/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			05-Jan-1993				      */
/*									      */
/*	Module Name:		DBDefines.h				      */
/*	Module Description:						      */
/*									      */
/*	Modification History:						      */
/*									      */
/*============================================================================*/
/*
	Include everything here.

	24-Oct-1995		if NO_GCC is defined then do not use the Codebase
					defines This because Codebase51 must be compiled
					with GCC Lotus123 functions cannot be.

*/
#ifndef	dbdefinesH
#define dbdefinesH

#ifndef	NO_GCC
#    ifdef WIN32
#	pragma pack (push, 1)
#    endif WIN32
#include "cb45to63.h"
#include "d4all.h"
#    ifdef WIN32
#	pragma pack (pop)
#    endif WIN32
#endif NO_GCC

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#ifdef WIN32
#    define MAXPATHLEN  512
#else
#    include <sys/param.h>
#endif WIN32
#include "lstLib.h"
#include "dbDefs.h"

#define	MAXFIELDNAME	(11)
#define	MAXTABLENAME	(MAXPATHLEN)
#define	DB_SKIP_ONE	(1)
#define	FLD_DELETEFLAG	"DELETEFLAG"
#define	DB_AFTER	100
#define	DB_EOF		101
#define	DB_OK		0
/*
	Structures for generic database data. These are used to shield the user from
	the database type via the use of pointers to these structures. If the database
	engine is changed the function calls and the pointers remain the same even though
	the underlying code is different.
*/

typedef	struct	dbrecord
	{
	int	record_number;			/* current record number. */
	int	record_size;			/* size of this record. */
	} DB_RECORD, *DB_RECORD_PTR;

typedef	struct	dbtable
	{
	NODE	next_table;			/* for linked list of tables */
	char	table_name[MAXTABLENAME];	/* table(file) name. Without .DBF */
	int	table_records;			/* number of records in table. */
	int	table_fields;			/* number of fields in each record. */
	LIST	fields;				/* list of mapped fields in this table */
	int	current_record;			/* record pointer from first seek */

#ifdef	NO_GCC
	void	*table;				/* see above comment */
	void	*tag
#else
	D4DATA	*table;				/* CODEBASE structure for table */
	T4TAG	*tag;				/* for default tag */
#endif
	} DB_TABLE, *DB_TABLE_PTR;

typedef	struct	dbfield
	{
	NODE	next_field;			/* next in list or 0 if end */
	int	field_number;			/* current field number */
	int	field_size;			/* size of field */
	int	field_type;			/* type of field */
	int	field_scale;			/* number of digits to right of decimal point */
	char	field_name[MAXFIELDNAME];	/* text name of field */
	struct dbtable	*owner;			/* table this field belongs to */

#ifdef NO_GCC
	void	*field;
#else
	F4FIELD	*field;				/* CODEBASE structure for this field */
#endif
	} DB_FIELD, *DB_FIELD_PTR;

typedef struct dbdatabase
	{
	LIST	tables;				/* list of tables for this database path */
	char	path[MAXPATHLEN];
	} DB_DATABASE,*DB_DATABASE_PTR;
/*
	Parameters local to the library
*/
extern	struct	dbdatabase	DB_Database;
extern	char	DB_DatabasePath[MAXPATHLEN];

#ifndef	NO_GCC
extern	C4CODE	DB_CodeBase;
#endif

/*
	prototypes as needed
*/
void	dbWriteLog(char *who,int line,D4DATA *where,char *how,DB_FIELD_PTR what,char *pvptr,char *value);
int	dbDeleted(D4DATA *table);
int	dbObtainRecord(D4DATA *table,char *name);
int	dbUnLock(void);
int	dbLockTest(int retries);

#endif	dbdefinesH
