
/*======================================================================================*/
/*											*/
/*											*/
/*	Tate Integrated Systems, LP							*/
/*											*/
/*											*/
/*	Author:			Greg Tomalesky						*/
/*	Date:			06-Jan-1993						*/
/*											*/
/*	Module Name:		DBProto.h						*/
/*	Module Description:	Database function prototypes.				*/
/*											*/
/*											*/
/*											*/
/*											*/
/*											*/
/*											*/
/*											*/
/*											*/
/*											*/
/*	Modification History:		First time 06-Jan-1993				*/
/*											*/
/*											*/
/*											*/
/*											*/
/*											*/
/*======================================================================================*/

#ifndef	dbprotoH
#define	dbprotoH

#include "DBCVerifyDefs.h"

DB_TABLE_PTR	DB_CreateTable(char *tabdesc,FIELD4INFO *FieldArray,TAG4INFO *TagArray);
int		DB_DeleteMulti(DB_TABLE_PTR tbl, char *key);
int		DB_DeleteRecord (DB_TABLE_PTR TableHandle, DB_RECORD_PTR rec);
void		DB_FlushAll (void);
void		DB_GetFieldValue (DB_RECORD_PTR RecordHandle, DB_FIELD_PTR FieldHandle, void *value, int *fieldType);
int		DB_GetVerifyInfo (DB_TABLE_PTR TableHandle, char *pvName, VERIFY_INFO_PTR verify_info, IMPORT_INFO_PTR import_info);
void		DB_InitDatabase (char *programName);
int		DB_IsDeleted (DB_TABLE_PTR TableHandle);
void		DB_MapDatabase (char *databaseDesc);
DB_FIELD_PTR	DB_MapField (DB_TABLE_PTR TableHandle, char *FieldName);
DB_TABLE_PTR	DB_MapTable (char *tableDesc);
DB_RECORD_PTR	DB_NewRecord (DB_TABLE_PTR TableHandle, char *name);
int		DB_Next (DB_TABLE_PTR TableHandle);
void		DB_PutFieldNF (DB_RECORD_PTR RecordHandle, DB_FIELD_PTR FieldHandle, void *value);
void		DB_PutFieldValue (DB_RECORD_PTR RecordHandle, DB_FIELD_PTR FieldHandle, void *value);
int		DB_PutVerifyInfo (DB_TABLE_PTR TableHandle, char *pvName, VERIFY_INFO_PTR verify_info, IMPORT_INFO_PTR import_info);
DB_RECORD_PTR	DB_Seek (DB_TABLE_PTR TableHandle, char *PrimaryKey);
DB_RECORD_PTR	DB_SeekNext (DB_TABLE_PTR TableHandle);
DB_RECORD_PTR	DB_SeekPrev (DB_TABLE_PTR TableHandle);
DB_RECORD_PTR	DB_SeekStatus (DB_TABLE_PTR TableHandle, char *PrimaryKey, int *stat);
DB_RECORD_PTR	DB_Top (DB_TABLE_PTR TableHandle);
void		DB_UnMapDatabase (int dopack);
void		DB_UnMapTable (DB_TABLE_PTR TableHandle, int dopack);
int		DB_UseKey (DB_TABLE_PTR TableHandle, char *NewKey);

int		dbLockTest (int retries);
DB_FIELD_PTR	dbSearchField (DB_TABLE_PTR TableHandle, char *fieldDesc);
DB_TABLE_PTR	dbSearchTable (char *tableDesc);
int		dbUnLock (void);
char **dbFindInArreduc (DB_TABLE_PTR arTable,char *pvName,int typeIndex,int *numStrings);


#endif	dbprotoH
