/**********
*
*	File:	airedfldidx.h
*	Author:	William H. Szostak
*	Date:	14-Feb-1993
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the analog input record.
*
*	NOTE: The order of the fields in this list must match the order of
*		the list in recAi.c.
*
*	Modification Log
*       ----------------
*	.01  03-12-93	ems	deleted ACK, adjusted indicies accordingly
*	.02  04-15-94	ems	added INI2, chg NUMFLDS to NUMAIFLDS
*	.03  10-12-94	ems	added TIME
*	.05  10-20-94	ems	chg TIME to LATM (last alarm time)
*	.06  01-13-95	ems	added MLST
*	.07  04-03-96	ems	added HHLL,HILO,RTCT,LARF,DVCT,SBCT
**********/

#define		STAT	0	/* current alarm status		*/
#define		SEVR	1	/* current alarm severity	*/
#define		VAL	2	/* current value		*/
#define		ROCI	3	/* rate of chg index		*/
#define		ROCC	4	/* rate of chg counter		*/
#define		LALM	5	/* last VAL alarmed		*/
#define		INI2	6	/* secondary init flag		*/
#define		LATM	7	/* last alarm time		*/
#define		MLST	8	/* last VAL monitored		*/
#define		HHLL	9	/* hihi/lolo alarm counter	*/
#define		HILO	10	/* high/low alarm counter	*/
#define		RTCT	11	/* return to normal counter	*/
#define		LARF	12	/* last alarm flag		*/
#define		DVCT	13	/* deviation alarm counter	*/
#define		SBCT	14	/* SBAD alarm counter		*/

#define		NUMAIFLDS    (SBCT + 1)
