/*caRing.h,v 1.1.1.1 1999/08/03 14:41:20 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		RING BUFFER HEADER (RBH) STRUCTURE		*/
/*								*/
/*	There are two types of data in the ring buffer. They	*/
/*	are events that come from monitors and changes in the	*/
/*	status for a resource. A short tells us what kind of	*/
/*	header structure follows. Event monitor headers are	*/
/*	followed by the field data for that event.		*/
/*								*/
/*	There is now a third kind of event. The new one is	*/
/*	unsolicited data for trend or alarm handlers.		*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#include <serverControl.h>
#include <tsDefs.h>


/******
	HEADER TYPE DEFINITIONS
******/

#define	EVENT_HDR	1
#define	RESRC_HDR	2
#define HNDLR_HDR	3


/******
	Event Monitor Header
******/

typedef struct
    {
    TS_STAMP	stamp;		/* Always a time stamp */
    struct dbCommon *precord;	/* Record we want to use */
    struct fldDes *pFldDes;	/* Field definition */
    caddr_t	pfield;		/* Field of interest */
    short	recType;	/* Record type */
    short	length;		/* The length of the value */
    short	mask;		/* Event mask */
    short	stat;		/* Point Status */
    short	sevr;		/* Point Severity */
    short	ack;		/* Alarm needs acknowledgement */
    } eventRBH;


/******
	Resource status change header
******/

typedef struct
    {
    short	newStat;	/* New status */
    char	resName[16];	/* Resource name */
    } resrcRBH;

/******
	Unsolicited data for trend and alarm handlers
******/

typedef struct
    {
    TS_STAMP		stamp;		/* Always a time stamp */
    struct fldDes	*pFldDes;	/* Field definition */
    struct dbCommon	*pRecord;	/* Record address */
    CCB			*client;	/* CCB pointer */
    short		recType;	/* Record type */
    short		mask;		/* Log, alarm, or both */
    short		stat;		/* Point status */
    short		sevr;		/* Severity */
    short		ack;		/* Alarm needs acknowledgement */
    } handlerRBH;

    /*
    This header is followed by the data. You can look inside the
    struct fldDes to figure out how long it is.
    */
