/* share/epicsH  @(#)cvnTypes.h   1.00 11/23/93 */
  
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************************
 *
 *  FILE    :   cvnTypes.h
 *  DATE    :   23 Nov 93
 *  AUTHOR  :   emsteel
 *  PURPOSE :   defines for conversion types
 *
 *  NOTES: these values must agree with values in the .ascii files listed
 *         below
 *
 ***************************** REVISION HISTORY *****************************
*
*  .01  mm-dd-yy        iii     Comment
*  .02	05-06-99	ems	added CVNSIGNED12BIT CVNUNSIGNED12BIT
*  .03	06-18-99	ems	added STY defines for ai's
*/



#ifndef INCcvnTypesH
#define INCcvnTypesH    1

/*  NOCONV & LINEAR values are also defined in
    .../share/ascii/cvtHeader.ascii
    .../share/ascii/choiceGbl.ascii
    .../share/ascii/choiceRec.ascii
*/

#define	NOCONV			0
#define	LINEAR			1

/* ASCFLT is defined in .../share/ascii/choiceRec.ascii and is used
   for Ao
*/

#define	ASCFLT			2

/* the break point tables, 4 so far, are defined in 
   .../share/ascii/cvtHeader.ascii
*/

#define	START_BRKPT		2
#define	TYPE_KDEGF		2
#define TYPE_KDEGC		3
#define	TYPE_JDEGF		4
#define	TYPE_JDEGC		5
#define	MAXBRKPTTBLS		9

/* other conversion types are also defined in 
   .../share/ascii/cvtHeader.ascii
*/

#define	CNVINTEGER		10
#define CNVDOUBLEINT		11
#define CNVFLOAT		12
#define	CNVDOUBLEFLT		13
#define CNVASCIIFLT		14
#define	CNVSQRROOT		15
#define	CNVMANONE		16
#define	CNVMVNONE		17
#define	CNVVNONE		18
#define	CNVMALINEAR		19
#define	CNVMVLINEAR		20
#define	CNVVLINEAR		21
#define CNVTJLINEAR		22
#define CNVTKLINEAR		23
#define CNVTELINEAR		24
#define	CNVTTLINEAR		25
#define	CNVTSLINEAR		26
#define	CNVTRLINEAR		27
#define	CNVTBLINEAR		28
#define	CNVRPT100LINEAR		29
#define	CNVRPT200LINEAR		30
#define	CNVRPT500LINEAR		31
#define	CNVRPT1000LINEAR	32
#define	CNVRN100LINEAR		33
#define	CNVRN200LINEAR		34
#define	CNVRN500LINEAR		35
#define	CNVRN1000LINEAR		36
#define	CNVSIGNED12BIT		37
#define	CNVUNSIGNED12BIT	38
#define MAXCONV			CNVUNSIGNED12BIT

/* defines for the signal types for ai's
 * these MUST agree with the indicies in
 * .../ascii/choiceRec.ascii
 */
#define	STPNA		0
#define	STPTCJ		1
#define	STPTCK		2
#define	STPTCE		3
#define	STPTCT		4
#define	STPTCS		5
#define	STPTCR		6
#define	STPTCB		7
#define	STPRTDPT100	8
#define	STPRTDPT200	9
#define	STPRTDPT500	10
#define	STPRTDPT1000	11
#define	STPRTDNI100	12
#define	STPRTDNI200	13
#define	STPRTDNI500	14
#define	STPRTDNI1000	15
#define	STPRTDR766ohm	16
#define	STPRTDR4000ohm	17
#define	STPVPM10	18
#define	STPV010		19
#define	STPVPM5		20
#define	STPV05		21
#define	STPV15		22
#define	STPCPM20	23
#define	STPC020		24
#define	STPC420		25
#define	STPSIGNED12BIT	26
#define	STPUNSIGNED12BIT 27
#define	MAXSTYP		STPUNSIGNED12BIT

#endif INCcvnTypesH
