/* dbPvd.h							*/
/* share/epicsH @(#)dbPvd.h	1.3     6/7/91 */

/*
 *      Author:          Bob Dalesio
 *      Date:            6-1-90
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the Regents of the University of California,
 *      and the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contracts:
 *      (W-7405-ENG-36) at the Los Alamos National Laboratory,
 *      and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *      Initial development by:
 *              The Controls and Automation Group (AT-8)
 *              Ground Test Accelerator
 *              Accelerator Technology Division
 *              Los Alamos National Laboratory
 *
 *      Co-developed with
 *              The Controls and Computing Group
 *              Accelerator Systems Division
 *              Advanced Photon Source
 *              Argonne National Laboratory
 *
 * Modification Log:
 * -----------------
 * .01  mm-dd-yy        iii     Comment
 */

#ifndef INCdbPvdh
#define INCdbPvdh 1
#ifndef INCdbDefsh
#include "dbDefs.h"
#endif
/* process variable directory equates */

/*NOTE: HASH_NO and MAX_PV must be <= 32767 */
#define	MC68000	1
#if CPU == MC68000
#define		HASH_NO	128
#else
#define 	HASH_NO	2048		/* number of hash table entries */
#endif

/*	HASH_NO was originally 512, changed by Tate */
#if CPU == MC68000
#define		MAX_PV	128
#else
#define		MAX_PV	8192		/* number of process variables */
#endif
/*	MAX_PV was originally 1000, changed by Tate */

#define		NO_ENTRY -1

/* process variable directory structure */
struct pvd_entry{
	char	name[PVNAME_SZ];	/* process variable name */
	long	record_addr;	/* record address */
	short	record_type;	/* record type of this process variable */
	short	record_no;	/* record number within this type */
	short	next;		/* pointer to the next record in the */
				/* collision chain */
};

/* process variable directory */
struct pvd {
	short		hash_entry[HASH_NO];	/* hash table		*/
	struct pvd_entry entry[MAX_PV];		/* process variables	*/
};
extern struct pvd *dbPvd;
int	pvd_create(void);
/************************************************************************
 * The memory layout is:
 *
 * dbPvd->pvd
 *          hash_entry[HASH_NO]
 *          pvd_entry[MAX_PV]
 *             name
 *             record_type
 *             record_no
 *             next
 ************************************************************************/
#endif
