/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/********************************************************************
*
*	File:	ddcredfldidx.h
*	Author:	emsteel
*	Date:	16 Apr 96
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the Digital Drum
*	Controller
*
*	Modification Log
*       ----------------
*	.01	04-16-96	ems	created
*	.02	05-17-96	ems	added PMID
*	.03	06-04-96	ems	added MODE
*
*********************************************************************/

#define		STAT	0	/* current alarm status		*/
#define		SEVR	1	/* current alarm severity	*/
#define		VAL	2	/* current value		*/
#define		LALM	3	/* last VAL alarmed		*/
#define		INI2	4	/* secondary init flag		*/
#define		LATM	5	/* last VAL alarm time		*/
#define		MLST	6	/* last VAL monitored		*/
#define		OUTX	7	/* output word index		*/
#define		PSIN	8	/* previous step input value	*/
#define		LTCK	9	/* last clock ticks		*/
#define		LOVL	10	/* last value written		*/
#define		LRST	11	/* last reset value		*/
#define		LDTM	12	/* last disable time flag	*/
#define		LMOD	13	/* last mode			*/
#define		MSTN	14	/* manual step number		*/
#define		MODE	15	/* auto/manual			*/

#define		NUMDDCFLDS	(MODE + 1)
