/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		PRIVILEDGES FOR IOC ACCESS			*/
/*								*/
/*	This program verifies that an operation is allowed	*/
/*	for a user.						*/
/*								*/
/*	Author: Grant Irani					*/
/*								*/
/****************************************************************/

#ifndef IOC_PRIV_H
#define IOC_PRIV_H

#define PRIV_FULL	2
#define PRIV_READ	1
#define	PRIV_NOACCESS	0
/****************************************************************
**  int GetGeneralPrivHost (char *userID, char *privPrefix)
** Return priviledges on a general identifier string constructed
** from the prefix, followed by the local hostname -
**
**  returns PRIV_FULL for full access
**  returns PRIV_READ for read only access
**  returns PRIV_NOACCESS for No priviledges
*****************************************************************/
int GetGeneralPrivHost (char *userID, char *privPrefix);

/****************************************************************
**  int GetGeneralPriv (char *userID, char *privID)
** Return priviledges on a general identifier string -
**
**  returns PRIV_FULL for full access
**  returns PRIV_READ for read only access
**  returns PRIV_NOACCESS for No priviledges
*****************************************************************/
int GetGeneralPriv (char *userID, char *privID);

/****************************************************************
**  int GetChannelPriv (char *userID, char *channel)
** Return priviledges on CA items -
**
**  returns PRIV_FULL for full access
**  returns PRIV_READ for read only access
**  returns PRIV_NOACCESS for No priviledges
*****************************************************************/
int GetChannelPriv (char *userID, char *channel);

/****************************************************************
**  void SecurityAlarm (char *userID, char *violationString)
** Set alarms for security breach.
*****************************************************************/
void SecurityAlarm (char *userID, char *violationString, char *auxString);

#endif IOC_PRIV_H
