/**********
*
*	File:	mbboredfldidx.h
*	Author:	William H. Szostak
*	Date:	14-Feb-1993
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the multi bit binary
*	output record.
*
*	Modification Log
*       ----------------
*	.01  03-12-93	ems	deleted ACK, adjusted indicies accordingly
*	.02  04-22-94	ems	added INI2, chg NUMFLDS to NUMMBBOFLDS
*	.03  10-13-94	ems	added TIME and LVAL
*	.04  10-20-94	ems	chg TIME to LATM (last alarm time)
*       .05  01-13-95	wep	add mlst to redundancy
*	.06  01-31-96	ems	added LOVL
*	.07  04-11-96	ems	added HHLL, RTCT
*
**********/

#define		STAT	0	/* current alarm status		*/
#define		SEVR	1	/* current alarm severity	*/
#define		VAL	2	/* current block value		*/
#define		LALM	3	/* last value alarmed		*/
#define		INI2	4	/* secondary init flag		*/
#define		LATM	5	/* last alarm time		*/
#define		LVAL	6	/* last value			*/
#define         MLST    7	/* last value monitored		*/
#define		LOVL	8	/* last output value		*/
#define		HHLL	9	/* STATE alarm counter		*/
#define		RTCT	10	/* return to normal counter	*/

#define		NUMMBBOFLDS    (RTCT + 1)
