/****************************************************************/
/*								*/
/*	WARNING! WARNING! DANGER! DANGER! WARNING! WARNING!	*/
/*								*/
/*	These definitions also have to match the header file	*/
/*	src/alarmvu/alarmString.h in addition to matching	*/
/*	whatever is in choiceGbl.ascii.				*/
/*								*/
/****************************************************************/

/* alarm.h Alarm definitions (Must Match choiceGbl.ascii) */
/* share/epicsH @(#)alarm.h	1.6     6/7/91 */

/*
 *      Original Author: Bob Dalesio
 *      Current Author:  Marty Kraimer
 *      Date:            11-7-90
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the Regents of the University of California,
 *      and the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contracts:
 *      (W-7405-ENG-36) at the Los Alamos National Laboratory,
 *      and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *      Initial development by:
 *              The Controls and Automation Group (AT-8)
 *              Ground Test Accelerator
 *              Accelerator Technology Division
 *              Los Alamos National Laboratory
 *
 *      Co-developed with
 *              The Controls and Computing Group
 *              Accelerator Systems Division
 *              Advanced Photon Source
 *              Argonne National Laboratory
 *
 * Modification Log:
 * -----------------
 * .01  mm-dd-yy        iii     Comment
 * .02  03-24-93	ems	added CMD_NOT_ALLOWED
 *                              added VOLUME_ALARM
 * .03  04-16-93        ems     added LEVEL_ALARM, TEMPERATURE_ALARM
 *                                    PRESSURE_ALARM, BSW_ALARM, TANK_VALVE_ALARM
 * .04  05-07-93	ems	added VALVE_OPEN_ALARM and VALVE_CLOSE_ALARM
 * .05  05-10-93	ems	added VALVE_LIMIT_TORQUE_LAG_ALARM
 * .06  06-04-93	ems	added VIBRATION_ALARM,PUMP_START_ALARM,PUMP_STOP_ALARM
 * .07	06-09-93	ems	added POT_DROP_READY_ALARM
 * .08  09-13-93	ems	added MANUAL_OVERRIDE
 * .09  10-04-93	ems	added SETPT ERROR and CASC MODE ERROR
 */

#ifndef INCalarmh
#define INCalarmh 1

/* Maximum number of values to be used in a ROC alarm */

#define	MAX_ROC_VALUES	60

/* scan enable */

#define	ON_SCAN		1
#define	OFF_SCAN	0

/* alarm enabled */

#define	ALARM_ENABLED	1
#define	ALARM_DISABLED	0

/* tagged point */

#define	TAGGED		2

/* define used by recBi.c */

#define	NORMAL		0
#define	USE_RAW_VALUE	2

/* defines for the choice fields */
/* ALARM SEVERITIES - NOTE: must match defs in choiceGbl.ascii GBL_ALARM_SEV */

#define NO_ALARM		0x0
#define INFORM			0x1
#define INFO_ALARM		INFORM
#define	ALM_EVENT		0x2
#define EVENT_ALARM		ALM_EVENT
#define	MINOR_ALARM		0x3
#define	MAJOR_ALARM		0x4
#define VALID_ALARM		0x5
#define ALARM_NSEV		VALID_ALARM+1

/* ALARM STATUS  -NOTE: must match defs in choiceGbl.ascii GBL_ALARM_STAT */
/* NO_ALARM = 0 as above */

#define	READ_ALARM		1
#define	WRITE_ALARM		2

/* ANALOG ALARMS */

#define	HIHI_ALARM		3
#define	HIGH_ALARM		4
#define	LOLO_ALARM		5
#define	LOW_ALARM		6
#define SBAD_ALARM		7
#define SIGNAL_ALARM		SBAD_ALARM
#define ROC_ALARM		8

/* BINARY ALARMS */

#define	STATE_ALARM		9
#define	COS_ALARM		10

/* other alarms */

#define COMM_ALARM		11
#define	TIMEOUT_ALARM		12
#define	HW_LIMIT_ALARM		13
#define LIMIT_ALARM		HW_LIMIT_ALARM
#define	CALC_ALARM		14
#define	SCAN_ALARM		15
#define	LINK_ALARM		16
#define	SOFT_ALARM		17
#define	BAD_SUB_ALARM		18
#define	UDF_ALARM		19
#define INHIBIT_ALARM		20
#define MANUAL_ALARM		21
#define TAGGED_ALARM		MANUAL_ALARM
#define CMD_NOT_ALLOWED		22
#define VOLUME	        	23
#define LEVEL                   24
#define TEMPERATURE	        25
#define PRESSURE		26
#define BSW	        	27
#define TANK_VALVE      	28
#define VALVE_OPEN_ALM  	29
#define VALVE_CLOSE_ALM  	30
#define VALVE_TORQUE_LAG	31
#define VALVE_FAULT_ALM         32
#define VALVE_POSITION	        33
#define AUTOMATIC		34
#define VIBRATION		35
#define PUMP_START	        36
#define PUMP_STOP		37
#define POT_DROP_READY	        38
#define TF_UNEXPECTED           39
#define TF_UNCOMMANDED          40
#define THRESHOLD_EXCEEDED	41
#define	PID_ALM_NOMV		42
#define	PID_ALM_NOOUT		43
#define PID_ALM_DEV		44
#define	PID_ALM_NOCMD		45
#define	PID_ALM_HIGH_STP_CLAMP	46
#define	PID_ALM_LOW_STP_CLAMP	47
#define	PID_ALM_HIGH_OUT_CLAMP	48
#define	PID_ALM_LOW_OUT_CLAMP	49
#define MANUAL_OVERRIDE		50
#define SETPT_ERROR             51
#define CASC_MODE_ERROR         52
#define ALARM_NSTATUS		(CASC_MODE_ERROR + 1)
#endif
