/**********
*
*	File:	ptoredfldidx.h
*	Author:	William H. Szostak
*	Date:	14-Sep-1993
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the Pulse Train output record.
*
*	Modification Log
*       ----------------
*	.01  03-12-93	ems	deleted ACK, adjusted indicies accordingly
*	.02  03-21-93	ems	deleted INIT
*	.03  05-17-94	ems	added INI2, chg NUMFLDS to NUMPTOFLDS
*	.04  10-13-94	ems	added TIME
*	.05  10-20-94	ems	chg TIME to LATM (last alarm time)
*       .06  01-13-95	wep	add mlst to redundancy
*	.07  05-15-95	ems	added RVAL
*	.08  04-10-96	ems	added HHLL,HILO,RTCT,LARF,HLOC
*
**********/

#define		STAT	0	/* current alarm status		*/
#define		SEVR	1	/* current alarm severity	*/
#define		VAL	2	/* current value		*/
#define		LALM	3	/* last value alarmed		*/
#define		INI2	4	/* secondary init flag		*/
#define		LATM	5	/* last time alarmed		*/
#define         MLST    6	/* last value monitored		*/
#define		RVAL	7	/* raw value			*/
#define		HHLL	8	/* hihi/lolo alarm counter	*/
#define		HILO	9	/* high/low alarm counter	*/
#define		RTCT	10	/* return to normal counter	*/
#define		LARF	11	/* last alarm flag		*/
#define		HLOC	12	/* hi/lo output clamp counter	*/

#define		NUMPTOFLDS    (HLOC + 1)
