/***********
*
*	File I/O Serial Driver 
*	File:	Serialfile.h
*	Edit:	JLD
*	Date:	7/10/98
*
*
*
*
*		SERIAL File I/O TASK
*
*	This is a task and a bunch of support routines to
*	communicate with a serial device
*
*
**********/

/* Line numbers greater than 100 are for serial file devices */
#define FILELINESTART	100
/****** Structure to maintain status ******/
#define TXBUFSIZE	260
typedef struct
    {
	short		inuse;				/* Established during attach		*/
	short		fd;				/* File Descriptor for tasks		*/
	SIO_CHAN 	*pchan;				/* Pointer to Serial Channel structure  */
	FUNCPTR		rxcallback;			/* User's rx processing routine		*/
	int		rxcallbackarg;			/* User's rx Id argument		*/
	FUNCPTR		txcallback;			/* User's tx processing routine		*/
	int		txcallbackarg;			/* User's tx Id argument		*/
	short		ticks;				/* Delay in Task			*/
	unsigned short	txcount;			/* Characters ready to be written	*/
	unsigned char	txbuf[TXBUFSIZE];		/* Data to be written			*/
	unsigned short	txdone;				/* Transmit finished flag		*/
    } LINESTATUS;

#define MAXLINES		32



int initSerialFile (short line, char *portName, char *mode,
		    FUNCPTR rxcallback, int rxcallbackarg,
		    FUNCPTR txcallback, int txcallbackarg,
		    short ticks);

 
int readfile_rx_char( unsigned short line, unsigned char *rxbyte,
		     unsigned short *rxstat, unsigned short *rxerrmask);
int	enablefiletx (short line);
int	disablefiletx (short line);
int 	writefile_tx_char( unsigned short line, unsigned char txbyte,
		     	   unsigned short *txstat, unsigned short *txerrmask);

