/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		SERIAL REDUNDANCY HANDSHAKE HEADER		*/
/*								*/
/*	This defines a bunch of support routines to		*/
/*	communicate with a redundant partner.			*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/
int
initSerialRedund (char *portName,	/* Device name */
		  int ticks);		/* Ticks between executions */


int
attachSerialRedund (int index,		/* Index into array, 0 <= index < MAX_SERIAL_TASKS */
		    int	timeOut);	/* Both for this task strobing and response from partner */

int
pulseSerialRedund (int index,		/* Index into array, same as attachSerialRedund */
		   int localState);	/* 'M' = master, 'S' = slave, 'W' = slavewant */

int
setStrobeSerialRedund (int index);

int
clearStrobeSerialRedund (int index);

int
remoteSerialRedund (int index);

int
localSerialRedund (int index);

int
localStrobeSerialRedund (int index);

int
eraseSerialRedund (int index);

