
/****************************************************************************
 *
 *  FILE    :   sigcharredfldidx.h
 *  DATE    :   19 Nov 93
 *  AUTHOR  :   emsteel
 *  PURPOSE :   This file contains the field descriptor indicies used by the
 *              redundant update memory que for the sigchar record
 *
****************************************************************************/

/****************************************************************************
 *
 * Programmer's Notes:
 *
 * NOTE: The order of the fields in this list MUST match the order and the
 *       spelling in the namelist[] in recSigchar.c. Spelling must also
 *       match that in sigcharRecord.ascii
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 May 94
 *  REVISION:  added INI2
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 Oct 94
 *  REVISION:  added TIME
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 20 Oct 94
 *  REVISION:	chg TIME to LATM (last larm time)
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 Jan 95
 *  REVISION:	added MLST
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 3 Apr 96
 *  REVISION:	added HHLL,HILO,RTCT,LARF,DVCT,SBHL
 *
****************************************************************************/


#define		STAT	0       /* alarm status			*/
#define		SEVR	1       /* alarm severity		*/
#define		VAL	2       /* current output value		*/
#define		ROCI	3       /* rate of change index		*/
#define		ROCC	4       /* rate of change count		*/
#define		LALM	5       /* last val alarmed		*/
#define         INI2    6       /* secondary init flag		*/
#define		LATM	7	/* last VAL alarm time		*/
#define		MLST	8	/* last VAL monitored		*/
#define		HHLL	9	/* hihi/lolo alarm counter	*/
#define		HILO	10	/* high/low alarm counter	*/
#define		RTCT	11	/* return to normal counter	*/
#define		LARF	12	/* last alarm flag		*/
#define		DVCT	13	/* deviation alarm counter	*/
#define		SBHL	14	/* SBAD hi/lo alarm counter	*/

#define		NUMSIGCHARFLDS	(SBHL + 1)
