/**********
*
*	File:	sifldidx.h
*	Author:	Gordon Uchenick
*	Date:	28-MAY-1993
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the stringin record.
*
*	NOTE: The order of the fields in this list must match the order of
*		the list in recStringin.c.
*
*	Modification Log
*       ----------------
*  .01	03-21-94	ems	deleted INIT
*  .02	05-16-94	ems	added INI2, chg NUMFLDS to NUMSIFLDS
*  .03	10-13-94	ems	added LALM and TIME
*  .04	10-20-94	ems	chg TIME to LATM (last alarm time)
*  .05	12-19-94	ems	removed LALM, not needed
*  .06	07-11-96	ems	added OVAL and LVAL
**********/

#define		STAT	0	/* current alarm status		*/
#define		SEVR	1	/* current alarm severity	*/
#define		VAL	2	/* current value		*/
#define		INI2	3	/* secondary init flag		*/
#define		LATM	4	/* last alarm time		*/
#define		OVAL	5	/* last posted VAL		*/
#define		LVAL	6	/* last VAL alarmed		*/

#define		NUMSIFLDS	(LVAL + 1)
