/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*                                                              */
/*      Author:   Joe Crivello                                  */

/*	Definitions for the State Notation Language Macros	*/

/*	Substitution Macros are defined below	*/

#define	TRUE		1
#define	ON		1
#define	FALSE		0
#define	OFF		0


/*	Function Macros are defined below	*/
	
/*	pv represents process variable name	*/

#define increase(pv,value)	pv+=value; pvPut(pv)
#define increment(pv)		pv+=1; pvPut(pv)
#define decrease(pv,value)	pv-=value; pvPut(pv)
#define decrement(pv)		pv-=1; pvPut(pv)
#define set(pv)			pv=1; pvPut(pv)
#define clear(pv)		pv=0; pvPut(pv)
#define WAIT(value)		when(delay(value))
#define pvSetValue(pv,value)		pv=value; pvPut(pv)
#define pvSetStringValue(pv,value)	strcpy(pv,value); pvPut(pv)

/*	Macro Substitution Function Macros are defined below	*/

#define	MacGet(string_name,string_variable)	strcpy(string_variable, macValueGet(string_name))
#define	MacTest(string_name,string)		(strcmp(macValueGet(string_name),string) == 0)

#define MacFloat(value_name,value)	 value=atof(macValueGet(value_name))
#define MacDouble(value_name,value)	value=atof(macValueGet(value_name)) 
#define MacInt(value_name,value)	value=atoi(macValueGet(value_name))
#define MacLong(value_name,value)	value=atol(macValueGet(value_name))
#define MacShort(value_name,value)	value=atol(macValueGet(value_name))

/* this is defined so that part of alarm.h that snl cannot handle
   is ignored
*/
#define	INCalarm_limitsh	1
