/****************************************************************************
 *
 *  FILE    :   tdredf.h
 *  DATE    :   29 Oct 93
 *  AUTHOR  :   emsteel
 *  PURPOSE :   This file contains the field descriptor indicies used by the
 *              redundant update memory que for the td record
 *
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 16 May 94
 *  REVISION:  added INI2
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 16 May 94
 *  REVISION:  added NEXT, TVAL, CTCK, NVAL and CBMD
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 14 Oct 94
 *  REVISION:  added TIME and LVAL
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 20 Oct 94
 *  REVISION:	chg TIME to LATM (last larm time)
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 Jan 95
 *  REVISION:	added MLST
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 Feb 96
 *  REVISION:   added TMRM and LCBM, put CBMD,LCBM and at end of list
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 11 Apr 96
 *  REVISION:   added HHLL, RTCT
 *
****************************************************************************/

/****************************************************************************
 *
 * Programmer's Notes:
 *
 * NOTE: The order of the fields in this list MUST match the order and the
 *       spelling in the namelist[] in recTd.c. Spelling must also match
 *       that in tdRecord.<ascii,h>
 *
 *
****************************************************************************/


#define	STAT	0	/* alarm status			*/
#define	SEVR	1	/* alarm severity		*/
#define	VAL	2	/* current input value		*/
#define	LALM	3	/* last value alarmed		*/
#define	PVAL	4	/* previous input value		*/
#define	IVAL	5	/* current input value		*/
#define	INI2	6	/* secondary init flag		*/
#define TVAL	7	/* next output value		*/
#define CTCK	8	/* current clock ticks		*/
#define NVAL	9	/* numeric version of VAL	*/
#define	LVAL	10	/* last value			*/
#define	LATM	11	/* last alarm time		*/
#define	MLST	12	/* last VAL monitored		*/
#define	TMRM	13	/* time remaining		*/
#define	NEXT	14	/* flag for cycle timer		*/
#define	LCBM	15	/* last redund CBMD		*/
#define	CBMD	16	/* callback mode flag		*/
#define	HHLL	17	/* STATE alarm counter		*/
#define	RTCT	18	/* return to normal counter	*/

#define	NUMTDFLDS  (RTCT + 1)

