/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		ALARM STRUCTURE FOR THE TIS 4000		*/
/*								*/
/*	This is the structure that an alarm handler gets from	*/
/*	Channel Access.						*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/
#ifndef TISALARM_H
#define TISALARM_H

#include <tsDefs.h>

typedef struct
    {
#ifdef AXP
    struct alTimeStruct
	{
	int	secPastEpoch;
	int	nsec;
	} alarmTime;			/* EPICS time stamp 
						(can't use TS_STAMP on AXP) */
#else
    TS_STAMP	alarmTime;
#endif AXP
    int		alarmSerial;		/* Used for end to end receipt */
    int		stateLess;		/* Handle for receipt */
    short	alarmStat;		/* Status: see alarm.h */
    short	alarmSevr;		/* Severity: see alarm.h */
    short	alarmAck;		/* 0 = ack'd, else unacked */
    short	alarmEnabled;		/* 0 = Disabled, else enabled */
    short	alarmOnscan;		/* 0 = Off scan, else on scan */
    char	pvName[PVNAME_SZ];	/* Null terminated */
    char	pvDesc[DESCRIPTOR_SZ];	/* Null terminated */
    char	pvEgu[8];		/* Null terminated */
    char	alarmValue[80];		/* Null terminated */
    } tisAlarm;

#endif TISALARM_H
