/*drvBrooks.c,v 1.1.1.1 1999/08/03 14:41:57 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
/*  File: drvBrooks.c
/*  Edit: 6/30/93 12:33 JLD
/*        1/18/94       WEP: name changes only
/*	  3/30/94	ems:startbrk(), remove test ln >= 0 since
/*			                it is unsigned
/*			    msgxfer(), remove cast (char *)
/*			    rename atof() brkatof, it is defined in
/*			    stdlib.h, which is included in taskLib.h which
/*			    is included in task_params.h
/*      :05/05/94       WEP: moved while(TRUE) taskDelay logic to while(master) loop.
/*                         : added taskDelay to while(pstate=slavewant)
/*      :06/14/94       WEP: modified register_resource to print pointname causing error.
/*      :06/22/94       WEP: corrected performance and use of the cmd_force_offline flag.
/*
  
*/
/* #define TEST	1 */
#ifdef TEST
#include<bioscomm.h>
#include<dummyos.h>
#include <lmpbus.h>
#include<brkproto.h>
#define logMsg		printf
#endif
#ifndef TEST
#include <ctype.h>
/* #include <malloc.h> */
#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>
#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvBrooks.h>
#include <drvBrooks_proto.h>
#include <restable.h>
#endif

static long	init();
static double	brkatof();

struct {
	long		number;
	DRVSUPFUN	report;
	DRVSUPFUN	init;
} drvBrooks={
	2,
	NULL,
	init};


/*
/*      Storage for Brooks Meter Structures
/*
*/
static unsigned short	parammasks[MAXPARAMS];
static unsigned short	haveparammasks = FALSE;

static BRKDEV		*plcs[BRKLINES] = {FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
					   FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
					   FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
					   FALSE,FALSE};

static unsigned char	resnames [BRKLINES][RESNAMELEN];
static RES_TABLE	*prestable[BRKLINES];
static unsigned short	resresponse[BRKLINES];
static unsigned short	line_activity[BRKLINES];
unsigned short		brkdatalock[BRKLINES];
static unsigned short	drvtrace[BRKLINES];
static unsigned short	drvrestrace[BRKLINES];
static OUTPUTQUE	*oq[BRKLINES];		/* array of output queues and their control structures */
static SEM_ID		semids[BRKLINES][2];
static short		backup_mode[BRKLINES];
static short		channel_select[BRKLINES];
static short		linetimers[BRKLINES];
static SEM_ID		linesems[BRKLINES];
/*
/*      Storage for BRK Line Structures
/*
*/

static RXLINE          *rxlinetab[BRKLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically allocated comm controls/buffers */

static TXLINE          *txlinetab[BRKLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically allocated comm controls/buffers */

static char    *bools[] = {
	"TRUE ",
	"FALSE"
    };
static int		taskId [BRKLINES];

static char *tasknames[] = {"BRK Ch0","BRK Ch1","BRK Ch2","BRK Ch3","BRK Ch4",
			    "BRK Ch5","BRK Ch6","BRK Ch7","BRK Ch8","BRK Ch9",
			    "BRK Ch10","BRK Ch11","BRK Ch12","BRK Ch13",
			    "BRK Ch14","BRK Ch15","BRK Ch16","BRK Ch17",
			    "BRK Ch18","BRK Ch19"};

static int mpnos[] = {509,519,529,539,549,559,565,805,808,935,936,937,938, -1 };
static int mlens[] = {  6,  6,  6,  6,  6,  6,  6,  5,  6,  9,  9,  9,  9, 1 };
static unsigned short bits[] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};


/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init () {
	return (0);
}
/********
/*
/*	This routine enables logging of comm trace messages
/*
********/
void brktraceon(unsigned short line)
    {
	drvtrace[line] = TRUE;
    }

/********
/*
/*	This routine disables logging of comm trace messages
/*
********/
void brktraceoff(unsigned short line)
    {
	drvtrace[line] = FALSE;
    }

/********
/*
/*	This routine enables logging of resource trace messages
/*
********/
void brkrestraceon(unsigned short line)
    {
	drvrestrace[line] = TRUE;
    }

/********
/*
/*	This routine disables logging of resource trace messages
/*
********/
void brkrestraceoff(unsigned short line)
    {
	drvrestrace[line] = FALSE;
    }


#ifndef TEST
int stopbrkdrv (short ln)
{
	if (comm_disconnect (ln) != -1) {
	    taskDelete (taskId [ln]);
	    return (1);
	} else {
	    return (-1);
	}
}

int startbrk(unsigned short ln, char *mode, unsigned short linepriv)
{

	if ( ln <= BRKLINES )
	{
	    taskId [ln] = taskSpawn(tasknames[ln],BRK_PRIORITY,
				    BRK_TASK_OPTIONS,BRK_STACK,brk_driver,
				    ln, mode, linepriv);

	    logMsg("Started the Brooks Meter driver on line %d\n",ln);

	    return (1);
	} else {

	    logMsg ("Invalid line number %d\n", ln);
	    return (-1);
	}
}
#endif




/*
/*      brk_driver
/*
/*      The purpose of this task is to scan the Brooks Meter device
/*      lines. It will maintain a configuration list supporting online additions
/*      and repplacement of modules, and  maintain a table of most recently
/*      scanned values.
/*
*/
void brk_driver (unsigned short line, unsigned char *mode,
		 unsigned short linepriv)


    {

	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	BRKDEV          *pmod;
	unsigned short  activity, pstate, lstate, execute, command,i;
	long		this_time, last_time;	

	RXLINE                  *rxp;


	/* Initialize the data structures */
	brkdatalock[line] = FALSE;
	resresponse[line] = FALSE;
	resnames[line][0] = 0;
	prestable[line] = NULL;
	drvtrace[line] = FALSE;
	drvrestrace[line] = FALSE;
	plcs[line] = (BRKDEV *)calloc(1,(sizeof(BRKDEV)*NUMBRKDEVS));
	if (!plcs[line]) {
	    logMsg ("Not enough memory for BRK line %d \n",line);
	    return;
	}
        /* output queue initialization */
	oq[line] = (OUTPUTQUE *)calloc(1,(sizeof(OUTPUTQUE)));
	if (!oq[line]) {
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}

        /* communication initialization */
	rxlinetab[line] = (RXLINE *)calloc(1,(sizeof(RXLINE)));
	if (!rxlinetab[line]) {
	    logMsg ("Not enough memory for PLC line %d (rx)\n",line);
	    return;
	}
	txlinetab[line] = (TXLINE *)calloc(1,(sizeof(TXLINE)));
	if (!txlinetab[line]) {
	    logMsg ("Not enough memory for PLC line %d (tx)\n",line);
	    return;
	}

	comm_init(line, mode, &tx_int_proc, &rx_int_proc);

	init_line_tabs (line);

	clear_rts(line);
	onlinefreq = 1;

	/* enable the reciever interrupt after set to ignore */
	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints(line);

	/* Wait for resource to be defined */
	while ( (resnames[line][0] == 0) || (prestable[line] == NULL) ) {
	    taskDelay(120);
	}
	if (!linepriv) {
	    resClearCaAnswer(prestable[line]);		/* Start Quiet */
	    resPutLocalState(prestable[line],RES_SLV);	/* As Slave */
	    if (drvrestrace[line]) logMsg ("1] Became RES_SLV \n");
	    taskDelay(300);
	    resGetStates(prestable[line],&lstate,&pstate);
	    activity = check_line_activity(line);
	}

	/* if the partner is not there be master */
	if ( (linepriv) || ((pstate != RES_MSTR) &&
			   (pstate != RES_SLVWANT) &&
			   (!activity)) ) {
	    resSetCaAnswer(prestable[line]);
	    resPutLocalState(prestable[line],RES_MSTR);
	    lstate = RES_MSTR;
	    if (drvrestrace[line]) logMsg ("2] Became RES_MSTR \n");
	}


	/* Task will process all modules sending outputs and getting inputs */
	/* It will then try to configure requested non responding modules   */

	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet(); /* Initialize the time  */


	while (TRUE) {

	    while (lstate == RES_SLV) {

		if (pstate != RES_SLVWANT) {
		    clear_rts(line); /* Make sure line is left for master */
		}
		resresponse[line] = FALSE; /* Make Sure driver is not responding */

		resPutCommand(prestable[line],0); /* clear out commands */

		activity = check_line_activity(line);
		resGetStates(prestable[line],&lstate,&pstate);

		/* If partner is there and must give it up take it */
		if (pstate == RES_SLVWANTCA) {
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (drvrestrace[line]) logMsg ("3] Became RES_MSTR \n");
		    break;
		}

		/* If partner is there and wants to give it up try to take it */
		if (pstate == RES_SLVWANT) {
		    execute = FALSE;
		    set_rts(line);
		    taskDelay(2); /* Time for switch to occure */

		    /* See if any one will answer to me */
		    for ( mod=1; (mod<NUMBRKDEVS); mod++) {
			pmod = plcs[line]+mod;
                        if ((pmod->was_requested) &&    /* data points have been requested      */
                            (!pmod->cmd_force_offline)) /* user has NOT forced plc offline      */
			{
			    on_line(line,mod);
                            /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
			    {
				execute = TRUE;
				break;
			    }
			}
		    }

		    /* If someone answered then become master and make sure partner gave it up */
		    if (execute) {
			resPutLocalState(prestable[line],RES_MSTR);
			lstate = RES_MSTR;
			if (drvrestrace[line]) logMsg ("4] Became RES_MSTR \n");
			execute = FALSE;
			for (i=0;(i<60);i++) {
			    activity = check_line_activity(line);
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ( (pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) ) {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute) {   /* Partner did not give it up go back to slave */
			    resPutLocalState(prestable[line],RES_SLV);
			    lstate = RES_SLV;
			    if (drvrestrace[line]) logMsg ("5] Became RES_SLV \n");
			}
			else { /* Assume control by taking the CA responsibilities */ 
			    resSetCaAnswer(prestable[line]);
			    prepresponses(line);
			    break;
			}
		    }
		}

		/* if the partner is not talking be master */
		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity)) {
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (drvrestrace[line]) logMsg ("6] Became RES_MSTR \n");
		    prepresponses(line);
		}

	    }
	
	    while (lstate == RES_SLVWANTCA) {

	        taskDelay(2);                   /* Give OS a chance...                  */
		clear_rts(line); /* Make sure line is left for master */
		resresponse[line] = FALSE; /* Make Sure driver is not responding */

		resGetStates(prestable[line],&lstate,&pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT)){
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLV);
		    lstate = RES_SLV;
		    if (drvrestrace[line]) logMsg ("7] Became RES_SLV \n");
		    break;
		}
		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0); /* clear out commands */
		if (command == RES_CANCELREL) {
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (drvrestrace[line]) logMsg ("8] Became RES_MSTR \n");
		    prepresponses(line);
		}

	    }
	    last_time = tickGet ();		/* initialize gap */
	    while ((lstate == RES_MSTR) || (lstate == RES_SLVWANT)) {

		set_rts(line);	/* Grab Switch */
		resresponse[line] = TRUE; /* Make Sure driver is responding */

		if (!linepriv) {
		    resGetCommand(prestable[line],&command);
		    resPutCommand(prestable[line],0); /* clear out commands */
		    if (command == RES_RELINQUISH) {
			resClearCaAnswer(prestable[line]);
			resPutLocalState(prestable[line],RES_SLVWANTCA);
			lstate = RES_SLVWANTCA;
			if (drvrestrace[line]) logMsg ("9] Became RES_SLVWANTCA \n");
			break;
		    }
		}

		modspolled = 0;

		for ( mod=0; (mod < NUMBRKDEVS); mod++ ) {

		    pmod = plcs[line]+mod;  /* shorthand pointer */

		    if (pmod->cmd_force_offline) {
			pmod->is_responding = FALSE;
		    }

		    if ((pmod->is_responding) && (!pmod->cmd_force_offline)) {
			modspolled++;
			scan_plc(pmod,line,mod);
			if (!pmod->is_responding) mark_not_valid(pmod);
		    } /* end of module */

		    if (!linepriv) {
			resGetCommand(prestable[line],&command);
			if (command == RES_RELINQUISH) break;
		    }

		} /* end of scan loop */

		cnt = 0;  /* count the number to bring on in one pass */

		/* do we try to bring any on this pass */
		if (--onlinefreq == 0) { 
		    onlinefreq = BRINGBACKCNT;

		    for ( mod=0; (mod<NUMBRKDEVS); mod++) {
			cfgchk++;
		 	if (cfgchk==NUMBRKDEVS) cfgchk=0;
			pmod = plcs[line]+cfgchk;
			if ((!pmod->is_responding) &&
			    (pmod->was_requested) &&
			    (!pmod->cmd_force_offline)) {

			    on_line(line,cfgchk);
			    modspolled++;
			    cnt++;
			    if (cnt == MAXCFGCK) break;
			}
		    }
		}

		/* Check for no one responding */

		if ( (!linepriv) && (!any_responding(line)) ) {
		    /* See if it is time to let partner try */
		    this_time = tickGet();
		    if ((this_time - last_time) > (3*SLWWINDOW)) {

			/* Switch States to let partner Know its his time to try */
			resPutLocalState(prestable[line],RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (drvrestrace[line]) logMsg ("10] Became RES_SLVWANT \n");

			/* Give Him Access to the Hardware */
			clear_rts(line);

			/* Let Partner try 1/10 of the time seconds */

			last_time = tickGet(); /* Remember the time of this try */

			for (i=0; (i<SLWWINDOW); i+=10) {

			    taskDelay(10);

			    /* If he picked up let him have control */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT)) {
				resClearCaAnswer(prestable[line]);
				resPutLocalState(prestable[line],RES_SLV);
				lstate = RES_SLV;
				if (drvrestrace[line]) logMsg ("11] Became RES_SLV \n");
				break;
			    }
			}
			/* Go Back to Master and take control of hardware */
			if (lstate != RES_SLV) {
			    resPutLocalState(prestable[line],RES_MSTR);
			    lstate = RES_MSTR;
			    if (drvrestrace[line]) logMsg ("12] Became RES_MSTR \n");
			    set_rts(line);
			}
			
		    }
		}
		/* Free all of the hold flags if the slave did not take over */	
		for ( mod=0; (mod < NUMBRKDEVS); mod++ ) {

		    pmod = plcs[line]+mod;  /* shorthand pointer */
		    pmod->holdflag = FALSE;
		}
                if (modspolled==0)  taskDelay(60);
                    else taskDelay(10);
	    }
	} /* end task loop */

     }


/*
/* Try to bring a unit on line
/*
*/
static void    on_line(unsigned short line,unsigned short mod)

    {
	BRKDEV  *pmod;
	unsigned short i,j;

	pmod = plcs[line] + mod;

	if (!getparam(ONERETRY+line,mod,pmod,STATPARAM)) return;

	mark_not_valid(pmod);

	pmod->is_responding = TRUE;

    }



/*
/* Mark all of the scaned data as no longer valid
/*
*/
static void    mark_not_valid(BRKDEV  *pmod)

    {
	
	unsigned short i,j;

/*
/*      PARAMS ARE INITIALIZED AS
/*              - READ BACK NOT VALID
*/

	for (i=0; (i<MAXPARAMS); i++) {
	    if (pmod->params[i]) {
		pmod->params[i]->data_valid = FALSE;
	    }
	}

    }


/*
/* Scan a Brooks Meter Device - call appropriate scan routine based on lmode
/*
*/

static	void    scan_plc(BRKDEV *pmod, unsigned short line,unsigned short mod)

    {
	unsigned short i;
	checkoutputs(line);

	/* The Scanning is goverened by the mode of the device */
	/* When a parameter has its bit set for this scan mode */
	/* get it */
	for (i=0; (i<MAXPARAMS); i++) {
	    if (pmod->params[i]) {
		if (((parammasks[i] & (bits[pmod->scanmode]))!=0) ||
		    (pmod->params[i]->force_fetch) )  {
		    pmod->params[i]->force_fetch = FALSE;
		    if (!getparam(line,mod,pmod,i)) return;
		    checkoutputs(line);
		}
	    }
	}

    }




/*
/* checkoutputs
/*      checks output que and returns if empty.
/*      if there is something on the que it attempts to process all
/*      pending outputs doing imediate retries. If attempts fail the request is dropped
/*
*/
static	void checkoutputs(unsigned short line)

    {
	OUTQENT 	*optr;
	int		aoval;
	unsigned char	*poval;
        double 		dblaovalue;
	unsigned short  addr,link,adapter,len,card,conv,prec;
	unsigned long	mask,bvalue;
	BRKDEV  	*pmod;

	while ((optr=(ogetnextp(line))) != NULLP) {

	  switch (optr->otype) {

	    case (BOUTTYPE):
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;
		pmod = plcs[link]+adapter;
		addr = optr->out.bonode.bosignal;
		card = optr->out.bonode.card;
		poval = optr->out.bonode.bovalue;
		mask = optr->out.bonode.bomask;
		bvalue = optr->out.bonode.bobvalue;

		if ((!pmod->cmd_force_offline) && (resresponse[link])) {
		    if (!(sendbout (link,adapter,card,pmod,addr,bvalue))) {
			pmod->badoutcnt++;
		    }
		}
	        break;

	    case (AOUTTYPE):
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;
		card = optr->out.aonode.card;
		pmod = plcs[link]+adapter;
		addr = optr->out.aonode.aosignal;
		aoval = optr->out.aonode.aovalue;
		dblaovalue = optr->out.aonode.dblaovalue;
		prec = optr->out.aonode.prec;
		conv = optr->out.aonode.conversion;

		if ((!pmod->cmd_force_offline) && (resresponse[link])) {
		    if (!(sendaout (link,adapter,card,pmod,addr,aoval,dblaovalue,conv,prec))) {
			pmod->badoutcnt++;
		    }
		}
		break;

	    case (SOUTTYPE):
		link = optr->out.sonode.link;
		adapter = optr->out.sonode.adapter;
		card = optr->out.sonode.card;
		pmod = plcs[link]+adapter;
		addr = optr->out.sonode.sosignal;
		poval = optr->out.sonode.sovalue;
		len = optr->out.sonode.solen;

		if ((!pmod->cmd_force_offline) && (resresponse[link])) {
		    if (!(sendsout (link,adapter,card,pmod,addr,poval,len))) {
			pmod->badoutcnt++;
		    }
		}
		break;
	  }

	  oreleasefull(line);     /* release the output que entry */

	}

    }



/*
/*      aidriver
/*
/*      This routines main purpose is to return a pointer to 
/*      the analog input value for the specified module. For a module value
/*      a (-1) will be returned if there is no valid data ready.
/*	a (-2) will be returned if the module is in hold state
*/
int brk_aidriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, char *pvalue, unsigned short conversion,
		unsigned short ascnumlen, unsigned char *resname)

    {
	BRKDEV  *pmod;
	unsigned short  len,i,vtype;
	unsigned char	*pdata;
	float		tfloat;
	short		tshort;


	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= BRKLINES) {
	    return (-1);
	}

	if (adapter >= NUMBRKDEVS) {
	    return (-1);
	}

	pmod = plcs [link]+adapter;

	/* Select the Size and Type of Response based on Conversion */
	switch (conversion) {
	    
	    case(AICNVINTEGER):
		vtype = 3;		/* Send Back a Short */
		len = 2;
		break;
	    case(AICNVDOUBLEINT):
		vtype = 0;		/* Send Back a Long */
		len = 4;
		break;
	    case(AICNVFLOAT):
		vtype = 4;		/* Send Back a Float */
		len = 4;
		break;
	    case(AICNVDOUBLEFLT):
		vtype = 1;		/* Send Back a Double */
		len = 8;
		break;
	    case(AICNVASCIIFLT):
		vtype = 2;		/* Send Back a String */
		if (ascnumlen != 0) {
		    len = ascnumlen;
		} else {
		    len = 20;
		}
		break;
	    case(AICNVTIME):
		len = 20;
		return (-1); /* Not Allowed */
		break;
	    case(AICNVASCII_2):
		vtype = 2;		/* Send Back a String */
		len = 2;
		break;
	    case(AICNVASCII_4):
		vtype = 2;		/* Send Back a String */
		len = 2;
		break;
	    case(AICNVASCII_12):
		vtype = 2;		/* Send Back a String */
		len = 12;
		break;
	    case(AICNVASCII_20):
		vtype = 2;		/* Send Back a String */
		len = 20;
		break;
	    default:
		vtype = 3;		/* Send Back a Short */
		len = 2;
		break;

 	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO) {

	    switch (signal) {

	    case 0: /* Were the PLC values requested */
		*((short *)pvalue) = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*((short *)pvalue) = pmod->is_responding;
		break;

	    case 2: /* The program Load request */
		*((short *)pvalue) = pmod->prog_load_stat;
		break;

	    case 3: /* PLC Program Load Block Number */
		*((short *)pvalue) = pmod->prog_load_page;
		break;

	    case 4: /* Set the program number to Load */
		 *((short *)pvalue) = pmod->prog_load_number;
		break;

	    case 5: /* Output Messages */
		*((short *)pvalue) = pmod->no_dataout_msgs;
		break;

	    case 6: /* Input Messages */
		*((short *)pvalue) = pmod->no_datain_msgs;
		break;

	    case 7: /* No Receiver Responses */
		*((short *)pvalue) = pmod->no_rxnoresp;
		break;

	    case 8: /* No Transmitter Response */
		*((short *)pvalue) = pmod->no_txnoresp;;
		break;

	    case 9: /* Data Echo Errors */
		*((short *)pvalue) = pmod->no_dataerr;
		break;

	    case 10: /* Message Retries */
		*((short *)pvalue) = pmod->no_retries;
		break;

	    case 11: /* RX Hardware errors */
		*((short *)pvalue) = pmod->no_rxhwerrs;
		break;

	    case 12: /* TX Hardware errors */
		*((short *)pvalue) = pmod->no_txhwerrs;
		break;

	    case 13: /* CRC errors */
		*((short *)pvalue) = pmod->no_crcerrs;
		break;

	    case 14: /* Offline transitions */
		*((short *)pvalue) = pmod->no_offlines;
		break;

	    case 15: /* reset statistics */
		*((short *)pvalue) = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*((short *)pvalue) = pmod->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*((short *)pvalue) = pmod->badoutcnt;
		break;

	    case 18: /* What is the scan mode for the unit*/
		*((short *)pvalue) = pmod->scanmode;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if (card < MAXPARAMS) {
	    if (!pmod->params[card])
	        if (!allocparam(pmod,card)) return (-1);
	    pmod->params[card]->was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->params[card]->data_valid) {
		return (-1);
	    }
	    switch (vtype) {
		case(0):
                    pdata = (unsigned char*)&pmod->params[card]->intdata;
                    break;
		case(1):
		    pdata = (unsigned char*)&pmod->params[card]->fdata;
		    break;
		case(2):
		    pdata = &(unsigned char)pmod->params[card]->sdatabuf[0];
		    break;
		case(3):
		    tshort = pmod->params[card]->intdata;
                    pdata = (unsigned char*)&tshort;
		    break;
		case(4):
		    tfloat = pmod->params[card]->fdata;
		    pdata = (unsigned char*)&tfloat;
		    break;
	    }
	} else {
	    return (-1);
        }

	lockdata(link);
	for (i=0; (i<len); i++) {
		pvalue[i] = pdata[i];
	}
	unlockdata(link);
	return(0);
    }



/*
/*      brk_aodriver
/*
/*      The main purpose of this routine is to set the request analog output
/*      value(s) on the requested card. This routine will return a (-1) if the
/*      requested module is the wrong type or not configured yet.
/*
*/
int brk_aodriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		  unsigned short signal,double dvalue, int value,
		  unsigned short prec, unsigned short conversion,
		  unsigned char *resname)


    {
	BRKDEV  *pmod;
	OUTQENT *oqp;
	unsigned short  blkix,i;

	if (!plcs [link]) {
	    return (-1);
	}
	if (link >= BRKLINES) {
	    return (-1);
	}

	if (adapter >= NUMBRKDEVS) {
	    return (-1);
	}

	pmod = plcs [link]+adapter;

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	pmod->was_requested = TRUE;


	if ((card >= FORCEFETCH) &&
	    (card < (FORCEFETCH+MAXPARAMS)) ) {

	    if (!pmod->params[card-FORCEFETCH])
		if (!allocparam(pmod,card)) return (-1);

	    pmod->params[card-FORCEFETCH]->was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);

	    pmod->params[card-FORCEFETCH]->force_fetch = TRUE;
            return(0);

	} else {

	    if (card >= (FORCEFETCH+MAXPARAMS) ) return (-1);
	    if ((card >= MAXPARAMS) && (card < TASKS)) return (-1);
	    if ((card >= MAXTASKS) && (card < FORCEFETCH)) return (-1);
 	}

	if (!resresponse[link]) return (-1);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline)) {
	    return (-1);
	}

	oqp = ogetemptyp (link);

	if (oqp == NULLP) {
	    return (-1);		/* output que is full */
	}

	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;
	oqp->out.aonode.aovalue = value;
	oqp->out.aonode.dblaovalue = dvalue;
	oqp->out.aonode.prec = prec;
	oqp->out.aonode.conversion = conversion;

	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
    }



/*
/*      brk_aoread
/*
/*      This routines main purpose is to return the value last read back
/*      from the analog output hardware. This is used to initialize analog
/*      outputs. This will return a (-1) if the module is the wrong type or
/*      the data is not yet valid
*/
int brk_aoread (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned int *pvalue,
		double *dval, unsigned short conv, unsigned char *resname)

    {
	BRKDEV  *pmod;
	unsigned short  blkix;
	unsigned long	tvalue;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= BRKLINES) {
	    return (-1);
	}

	if (adapter >= NUMBRKDEVS) {
	    return (-1);
	}

	pmod = plcs [link]+adapter;

  	if ((card >= FORCEFETCH) &&
	    (card < (FORCEFETCH+MAXPARAMS)) ) {

	    if (!pmod->params[card-FORCEFETCH]) 
		if (!allocparam(pmod,card)) return (-1);

	    pmod->params[card-FORCEFETCH]->was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);

	    /* Allow Initialization of values that cannot be read */
	    *pvalue = 0;
	    return(0);

	}

        if ((card >= TASKS) && (card < MAXTASKS)) {
	    /* Allow Initialization of values that cannot be read */
	    *pvalue = 0;
	    return(0);

	}

	if (card < MAXPARAMS) {
	    if (!pmod->params[card])
		if (!allocparam(pmod,card)) return (-1);

	    pmod->params[card]->was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->params[card]->data_valid) return (-1);
	    if (conv != ASCFLT) *pvalue = pmod->params[card]->intdata;
	    else *dval = pmod->params[card]->fdata;
	    return(0);
	}
	return (-1);
    }



/*
/*      brk_bidriver
/*
/*      The main purpose of this routine is to return the request digital input
/*      value(s) from the requested card. This routine will return a (-1) if the
/*      requested module is the wrong type or the data is not yet valid.
/*
*/

int brk_bidriver(char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask,unsigned long *pvalue,
		unsigned char *resname)

    {
	BRKDEV  *pmod;
	unsigned short i;
	unsigned long tvalue;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= BRKLINES) {
	    return (-1);
	}

	if (adapter >= NUMBRKDEVS) {
	    return (-1);
	}


	pmod = plcs [link]+adapter;



	pmod->was_requested = TRUE;

	if (card == PSEUDO) {

	    switch (signal) {

	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 18: /* What is the  mode for the device*/
		*pvalue = (pmod->scanmode << 18);
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if (card < MAXPARAMS) {

	    if (!pmod->params[card])
		if (!allocparam(pmod,card)) return (-1);

	    pmod->params[card]->was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->params[card]->data_valid) return (-1);

	    for (i = 0;(mpnos[i] != -1);i++) {
                if (mpnos[i] == card) {
 		    /* Try to make a mask out of the data */
		    *pvalue = pmod->params[card]->maskdata & mask;
		    return(0);
	        }
	    }
	    *pvalue = pmod->params[card]->intdata & mask;
	    return (0);
	}
	return (-1);
    }


/*
/*      brk_bodriver
/*
/*      The main purpose of this routine is to set the request digital output
/*      value(s) on the requested card. This routine will return a (-1) if the
/*      requested module is the wrong type or not configured yet.
/*
*/
int brk_bodriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		  unsigned short signal, unsigned char *value, unsigned long bvalue,
		  unsigned long mask, unsigned char *resname)


    {
	BRKDEV  *pmod;
	OUTQENT *oqp;
	unsigned short  blkix,i;

	if (!plcs [link]) {
	    return (-1);
	}
	if (link >= BRKLINES) {
	    return (-1);
	}

	if (adapter >= NUMBRKDEVS) {
	    return (-1);
	}


	pmod = plcs [link]+adapter;

	pmod->was_requested = TRUE;


	if (card == PSEUDO) {

	    switch (signal & 0x1f) {

	    case 15: /* Reset the accumulated statistics */
		if (bvalue != 0) initstats(pmod);
		break;

	    case 16: /* Force the PLC offline */
		pmod->cmd_force_offline = (bvalue != 0);
                if (bvalue != 0 )
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		break;

	    case 18: /* What is the mode for the device */
		pmod->scanmode = ((bvalue & mask) >> 18);
		break;


	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if ((card >= FORCEFETCH) &&
	    (card < (FORCEFETCH+MAXPARAMS)) ) {

	    if (!pmod->params[card-FORCEFETCH])
		if (!allocparam(pmod,card)) return (-1);

	    pmod->params[card-FORCEFETCH]->was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);

	    pmod->params[card-FORCEFETCH]->force_fetch = TRUE;
            return(0);

	} else {

	    if (card >= (FORCEFETCH+MAXPARAMS) ) return (-1);
	    if ((card >= MAXPARAMS) && (card < TASKS)) return (-1);
	    if ((card >= MAXTASKS) && (card < FORCEFETCH)) return (-1);
 	}


	if (!resresponse[link]) return (-1);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline)) {
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP) {
	    return (-1);		/* output que is full */
	}

	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bobvalue = bvalue;

	/* Move in the output string (should be a strncpy) */

	for (i=0;(i<STRMSGLEN);i++) {
	    oqp->out.bonode.bovalue[i] = value[i];
	}
	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
    }



/*
/*      brk_boread
/*
/*      This routines main purpose is to return the value last read back
/*      from the digital output hardware. This is used to initialize digital
/*      outputs. This will return a (-1) if the module is the wrong type or
/*      the data is not yet valid
*/
int brk_boread (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)

    {
	BRKDEV  *pmod;
	unsigned short  blkix;
	unsigned long	tvalue;

	if (!plcs [link]) {
	    return (-1);
	}
	if (link >= BRKLINES) {
	    return (-1);
	}

	if (adapter >= NUMBRKDEVS) {
	    return (-1);
	}

	pmod = plcs [link]+adapter;

  	if ((card >= FORCEFETCH) &&
	    (card < (FORCEFETCH+MAXPARAMS)) ) {

	    if (!pmod->params[card-FORCEFETCH])
		if (!allocparam(pmod,card)) return (-1);

	    pmod->params[card-FORCEFETCH]->was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);

	    /* Allow Initialization of values that cannot be read */
	    *pvalue = 0;
	    return(0);

	}

	if ( ((card >= TASKS) && (card < MAXTASKS)) ||
	     (card == PSEUDO) ) {
 	    /* Allow Initialization of values that cannot be read */
	    *pvalue = 0;
	    return(0);

	}

	if (card < MAXPARAMS) {
	    if (!pmod->params[card])
		if (!allocparam(pmod,card)) return (-1);

	    pmod->params[card]->was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->params[card]->data_valid) return (-1);
	    *pvalue = pmod->params[card]->intdata & mask;
	    return(0);
	}
	return (-1);
    }



/*
/*      brk_sidriver
/*
/*      The main purpose of this routine is to get the requested string
/*      from the data buffered from  the Brooks Meter device.
/*	 This routine will return a (-1) if the
/*      requested module is the wrong type or not configured yet.
/*
*/
int brk_sidriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned char *value, unsigned short len,
		unsigned char *resname)


    {
	BRKDEV  *pmod;
	OUTQENT *oqp;
	unsigned char	*pdata;
	unsigned short  i,maxlen,mlen;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= BRKLINES) {
	    return (-1);
	}

	if (adapter >= NUMBRKDEVS) {
	    return (-1);
	}

	pmod = plcs [link]+adapter;

	if (card > MAXPARAMS) return (-1);


	if (resname != 0) {
	    register_resource(link,pmod,resname,pname);
	}

	pmod->was_requested = TRUE;


	if (!pmod->params[card])
		if (!allocparam(pmod,card)) return (-1);

	pmod->params[card]->was_requested = TRUE;
	if (!resresponse[link]) return (-1);
	if (pmod->holdflag) return (-2);
	if (!pmod->is_responding) return (-1);
	if (!pmod->params[card]->data_valid) return (-1);
	pdata = &pmod->params[card]->sdatabuf[0];

	lockdata(link);
	mlen = len;
	if (len == 0) mlen = BRKPARAMASCLEN;
	for (i=0; (i<mlen); i++) {
		value[i] = pdata[i];
		if ((value[i] < 0x20) || (value[i] > 0x7e)) {
		    value[i] = 0;
		    break;
		}
	}
	value[i]=0;	/* put in final Null */
	unlockdata(link);
	return(0);
    }



/*
/*      brk_sodriver
/*
/*      The main purpose of this routine is to send the requested string
/*      to the Brooks Meter device. This routine will return a (-1) if the
/*      requested module is the wrong type or not configured yet.
/*
*/
int brk_sodriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned char *value, unsigned short len,
		unsigned char *resname)


    {
	BRKDEV  *pmod;
	OUTQENT *oqp;
	unsigned short  blkix,i;


	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= BRKLINES) {
	    return (-1);
	}

	if (adapter >= NUMBRKDEVS) {
	    return (-1);
	}

	pmod = plcs [link]+adapter;

	if (card >= MAXPARAMS) {
	    if (!((card >= TASKS) && (card < MAXTASKS)))
	        return (-1);
	}


	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	pmod->was_requested = TRUE;

	if (!resresponse[link]) return (-1);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline)) {
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP) {
	    return (-1);		/* output que is full */
	}
	oqp->otype = SOUTTYPE;
	oqp->out.sonode.link = link;
	oqp->out.sonode.adapter = adapter;
	oqp->out.sonode.card = card;
	oqp->out.sonode.sosignal = signal;
	oqp->out.sonode.solen = len;

	/* Move in the output string (should be a strncpy) */

	for (i=0;(i<STRMSGLEN);i++) {
	    oqp->out.sonode.sovalue[i] = value[i];
	}

	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
    }


/*
/* lockdata
/*
/*	The purpose of this routine is to provide locking on the 
/*	data elements with in the BRK line. Since the scan tasks read
/*	this data and the driver writes it we must protect against
/*	a partially updated data element being read by the scan task
*/
static void	lockdata(unsigned short line)

    {
	while (TRUE) {
	    if (brkdatalock[line]) taskDelay(1);
	    else {
		brkdatalock[line] = TRUE;
		break;
	    }
	}
    }

static void	unlockdata(unsigned short line)

    {
	brkdatalock[line] = FALSE;
    }
		

/*
/* register_resource                                                              	
/*                                                                                	
/*	This routine is used to initialize the resource pointers                  	
/*  If this is the first time the resource for this line is being                  	
/*  referenced the pointer to the resource table entry will be set                  	
/*  and the resource name will be saved. If the resource name has                       
/*  already been set, this routine will verify that all other points                 	
/*  for this driver are using the same resource name.                                	
/*                                                                                   	
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
			    BOREAD, SIDRIVER, and SODRIVER.                             
*/                               	

static void  register_resource (unsigned short link, BRKDEV *pmod,
                                unsigned char *resname, char *pointname)
    {
	if (resnames[link][0] == 0) /* This is the first reference */
	{
	    if (resGetByName( resname, &prestable[link]) != RES_OK)
	    {
		logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
				resname );
	    }
	    else strcpy(resnames[link], resname);
	}
	else
	{
	    if (strcmp(resnames[link], resname) != 0)
	    {
		logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
				resnames[link],
                                pointname,
				resname );
	    }
	}
    }



/*
/*      Initialize the Queue
*/
static	void outqueinit (unsigned short line)

    {
	oq[line]->ooutix = oq[line]->oinix = 0;

    }



/*
/*  ogetempty - get the next available slot on the output list
*/
static	OUTQENT *ogetemptyp (unsigned short line)

    {

	if (((oq[line]->oinix + 1) % OUTQSIZE) != oq[line]->ooutix) {
	    return (&oq[line]->outque[oq[line]->oinix]);
	}
	else return (NULLP);

    }



/*
/* omarkfull
/*      mark the next block as full 
*/
static	void omarkfull(unsigned short line)
	{
	    oq[line]->oinix = ((oq[line]->oinix + 1) % OUTQSIZE);
	}


/*
/*  ogetfullp - get the next full slot on the output list
*/
static	OUTQENT *ogetnextp (unsigned short line)

    {

	if (oq[line]->ooutix != oq[line]->oinix) {
	    return (&oq[line]->outque[oq[line]->ooutix]);
	}
	else return (NULLP);

    }


/*
/* oreleasefull - release the current full output block
*/
static	void oreleasefull(unsigned short line)

    {

	if (oq[line]->ooutix == oq[line]->oinix) return;
	oq[line]->ooutix = ((oq[line]->ooutix + 1) % OUTQSIZE);

    }




/*
/*      link_status
/*
/*      The purpose of this routine is to print out the state of each of the
/*      analog devices lines and the statistics gathered about them.
/*
*/
static	void link_status(unsigned short line)

    {
    if (line > BRKLINES-1) return;
    }



/*
/*      startrx
/*
/*      The purpose of this routine is to initialize a line table 
/*      for receive and to enable the receiver.
/*
*/
static	void start_rx( unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

    {

	RXLINE                  *rxp;

/*	disable_rx_ints(line); */
	rxp=rxlinetab[line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	rxp->rxstate = RXSOHST;
/*	enable_rx_ints(line); */
    }


/*
/*      stoprx
/*
/*      The purpose of this routine is to initialize a line table
/*      for receive and to disable the receiver.
/*
*/
static	void stop_rx( unsigned short line )

    {
	RXLINE                  *rxp;

	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
    }


/*
/*      rx_int_proc
/*
/*      The purpose of this routine is to process a receive character interrupt
/*      for a given line.
/*
*/
static	void rx_int_proc( unsigned short line )

    {
	unsigned char   rxchar;
	unsigned short  rxstat;
	unsigned short  rx_err_mask;
	RXLINE          *rxp;

	read_rx_hw(line,&rxchar,&rxstat,&rx_err_mask);
	rxp=rxlinetab[line];

	/* Something is sending in data */
	line_activity[line] = TRUE;

	if (rxp->rxstate==RXIGNORE) return;

	if ((rxstat & rx_err_mask) != 0) {
	    if (rxp->rxix == 0) return;
	    *(rxp->status) = RXBAD;
	    rxp->rxstate=RXIGNORE;
	    rxp->rxbuf[100]=rxstat;
	    rxp->rxbuf[101]=rxchar;
	    return;
	}
	rxp->rxbuf[rxp->rxix++] = rxchar;
/*	restart_timer ( linetimers[line], RXTIMEOUT); */
	if (rxp->rxix >= (MAXRXMSG-1)) {
	    rxp->rxstate=RXIGNORE;
	    return;
	}

	switch (rxp->rxstate) {
	    case RXSOHST:
		if (rxchar != BRKSOH) {
		    rxp->rxix = 0;
		}
		else {
		    rxp->rxstate = BRKADDRST;
		}
		return;
	    case BRKADDRST:
		if (rxchar == BRKSTX) {
		    rxp->rxstate = BRKDATAST;
		}
		return;
	    case BRKDATAST:
		if (rxchar == BRKETX) {
		    rxp->rxstate = BRKBCC1ST;
		}
		return;
	    case BRKBCC1ST:
		rxp->rxstate = BRKBCC2ST;
		return;
	    case BRKBCC2ST:
	        *(rxp->status) = RXGOOD;
		rxp->rxstate=RXIGNORE;
		semGive(rxp->semid);
		return;
	    default:
		rxp->rxstate=RXIGNORE;
		return;

	}
	return;
    }



/*
/*      check_line_activity
/*
/*      The purpose of this routine is to process a receive character interrupt
/*      for a given line.
/*
*/
static	int check_line_activity( unsigned short line )

    {
	RXLINE          *rxp;

	line_activity[line] = FALSE;
	rxp = rxlinetab[line];
	rxp->rxstate = RXIGNORE;
/*	enable_rx_ints(line);  */
	taskDelay(30);		/* .5 seconds */
	return (line_activity[line]);
    }



/*
/*      starttx
/*
/*      The purpose of this routine is to initialize a line table
/*      for send and to enable the transmitter.
/*
*/
static	void start_tx( unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

    {

	TXLINE                  *txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;
	/* Might have to output the first character here */


	enable_tx_ints(line);

    }


/*
/*      stoptx
/*
/*      The purpose of this routine is to initialize a line table
/*      for receive and to disable the receiver.
/*
*/
static	void stop_tx( unsigned short line )

    {
	TXLINE			*txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txdisable=TRUE;
    }


/*
/*      tx_int_proc
/*
/*      The purpose of this routine is to process a receive character interrupt
/*      for a given line.
/*
*/
static	void tx_int_proc( unsigned short line )

    {

	char                    txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

	txp=txlinetab[line];
	if (txp->txdisable) return;
	if (txp->txix == txp->txmsglen) {
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive(txp->semid);
	    return;
	} else {
	    txchar = txp->txbuf[txp->txix++];
	    write_tx_hw ( line,txchar,&txstat,&tx_err_mask );
	    if ( (txstat & tx_err_mask) != 0 ) {
	 	txp->txdisable=TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive(txp->semid);
	        return;
	    }

	}

	if (txp->txix >= MAXTXMSG) {
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive(txp->semid);
	    return;
	}

    }


/*
/*      msgxfer
/*
/*      The purpose of this routine is to transmit a buffer to the
/*      devices and to await a response. The transmit and receive
/*      buffers are in their respective line tables. This routine will retry
/*      the message up to a maximum number of times or until a response
/*      is received witha proper checksum.
/*              returns         XFERGOOD if response received
/*                              XFERBAD  if no good repsonse is received
/*
*/

static	unsigned short  msgxfer( unsigned short fline,unsigned short resplen,
				 BRKDEV *pmod, short rxlength)

    {

	unsigned short  retry,txstatus,rxstatus,rxlen,line,ix;
	RXLINE          *rxp;
	TXLINE          *txp;
	unsigned char   csums[2];

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

	rxp = rxlinetab[line];

	for (retry=((fline == line)?0:MAXRETRYS-1); (retry<MAXRETRYS); retry++ ) {
	    stop_timer(linetimers[line]);
	    txstatus = IO_TIMEOUT;
	    rxp->fixedlen = resplen;
	    rxp->rxmsglen = rxlength;
	    rxstatus = IO_TIMEOUT;
	    semTake(semids[line][TXSEM], NO_WAIT);
	    semTake(semids[line][RXSEM], NO_WAIT);

	    start_rx(line, semids[line][RXSEM], &rxstatus);
	    start_tx(line, semids[line][TXSEM], &txstatus);

/*!	    start_timer (linetimers[line],TXTIMEOUT,semids[line], &txstatus); */
	    if ((semTake(semids[line][TXSEM], TXTIMEOUT)) == ERROR)
		txstatus = IO_TIMEOUT;
/*!	    stop_timer(linetimers[line]); */
	    stop_tx(line);

	    if (txstatus == TXGOOD) {

		if (rxlength == -1) return (XFERGOOD);

/*!		start_timer (linetimers[line],(RXTIMEOUT * 2),semids[line], &rxstatus);  */

		if ((semTake(semids[line][RXSEM], (int)(RXTIMEOUT * 2))) == ERROR)
		    rxstatus = IO_TIMEOUT;
/*!		stop_timer(linetimers[line]);  */

		stop_rx(line);

		rxlen = rxp->rxix;
		if (rxstatus == RXGOOD) {
		    if (rxlen < 10) {
		        if (drvtrace[line]) logMsg("Invlalid rxlen... %d\n", rxlen);
		    } else {
		        makecrc(&rxp->rxbuf [0], rxlen-2, csums);
			if ( (csums[0]==rxp->rxbuf[rxp->rxix-2]) &&
			     (csums[1]==rxp->rxbuf[rxp->rxix-1]) ) {

			     return (XFERGOOD);
			} else {
			    pmod->no_crcerrs++;
			    if (drvtrace[line]) logMsg ("CRC Message Length = %d\n", rxlen);
			    if (drvtrace[line]) logMsg ("%x%x%x%x Bad CRC\n",
						rxp->rxbuf[rxp->rxix-2],
						rxp->rxbuf[rxp->rxix-1],
						csums [0], csums [1] );
			    for (ix = 0; ix < rxlen; ix++) {
			        if (drvtrace[line]) logMsg("%x\n", rxp->rxbuf[ix]);
			    }
			}
                    }
		} else if (rxstatus == IO_TIMEOUT) {
		    if (drvtrace[line]) logMsg ("Receive Timeout... Length: %d\n", rxlen);
		    pmod->no_rxnoresp++;
		} else {
		    if (drvtrace[line]) logMsg ("Receive Error\n");

		    if (drvtrace[line]) logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
			 rxp->rxbuf[100],
			 rxp->rxbuf[101],
			 rxp->rxix);
			 pmod->no_rxhwerrs++;
		}
	    } else if (txstatus == IO_TIMEOUT) {
		if (drvtrace[line]) logMsg ("Transmit Timeout\n");
		pmod->no_txnoresp++;
	    } else {
		if (drvtrace[line]) logMsg ("Transmit Error\n");
		pmod->no_txhwerrs++;
	    }
	if (retry != MAXRETRYS) pmod->no_retries++;
	}
	if (drvtrace[line]) logMsg ("Xfer Bad\n");
	return (XFERBAD);

    }


/*
/*      init_line_tabs
/*
/*      The purpose of this routine is to initialize the line tables for the
/*      BRK devices
/*
*/
static	void init_line_tabs(unsigned short line)

    {

	unsigned short  mod,i;
	BRKDEV  *pmod;

	for (mod=0; (mod<NUMBRKDEVS); mod++) {

	    pmod = plcs[line]+mod;

	    pmod->is_responding = FALSE;
	    pmod->holdflag = FALSE;
	    pmod->was_requested = FALSE;
	    pmod->cmd_force_offline = FALSE;
	    pmod->scanmode = 0;

	    initplc(pmod);
	    initstats(pmod);

	}
	linetimers[line] = gettimer();
	if (linetimers[line] == -1) {
		/*  put an error message in here */
	}

	/* Initialize this tasks semaphore*/
	semids[line][0]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
	semids[line][1]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);

	if (!haveparammasks) getparamdesc();

    }

/*
/* getparamdesc
/*
/*	read the parameter descriptor file
/*
*/
static void    getparamdesc(unsigned short line,BRKDEV *pmod)

    {

	char	buf[80];
	FILE		*fp;
	unsigned char	aline[2];
	int		status,i,j;
	unsigned short	number[3];

        unsigned short  pbits[8] = {1,2,4,8,16,32,64,128};
	strcpy(buf,"brkparam.dsc");

	/* default all parameters for mode 0 */
	for (i=0;(i<MAXPARAMS);i++) {
	    parammasks[i] = 1;
	}



	if ((fp = fopen(buf,"r"))== NULL) {
	    logMsg("Could not open parameter descriptor file %s\n",
			buf);
	    return;
	}

	haveparammasks = TRUE;

	status = ~EOF;
	while (status != EOF) {

	    status = getopen(fp);
	    if (status == EOF) break;

	    /* Try to get a list of numbers up to 9 */
	    /* (Parameter,Mode1,...,ModeN) */
	    for (i=0;(i<9);i++) {
		if ((status = getnumber(fp,&number[i])) == EOF) break; 
		if (status == '(' ) break;
	    }

	    if (number[0]<MAXPARAMS) {
		parammasks[number[0]] = 0;

                for (j=1;j<i;j++) {
                    if (number[j]<9) {
			parammasks[number[0]] |= pbits[number[j]];
		    } else {
		        logMsg ( "Invalid parameter description param = %d mode = %d  cnt = %d\n",
				number[0],
				number[j],
				i );
                    }
		}
	    }


	}
    }

		

/*
/* getopen
/*
/*	reads until "(" or EOF
/*
*/
static  int getopen(FILE *fp)

    {
	int	status,done;


	done = FALSE;
	while (!done) {
	    status = getc(fp);
	    if (status == EOF) break;
	    if (status == '(') break;
	}
	return(status);
    }

/*
/* getnumber
/*
/*	reads until "(" or EOF or a digit
/*	if EOF returns EOF
/*	if "(" returns "("
/*	if digit
/*		 reads until non digit converting to decimal
/*		 when non digit it puts it back and returns
*/
static int getnumber(FILE *fp, unsigned short *number)

    {
	int	status,done;


	done = FALSE;
	while (!done) {
	    status = getc(fp);
	    if (status == EOF) return(status);
	    if (status == '(') {
		ungetc(status,fp);
		return(status);
	    }
	    if (isdigit(status)) break;
	}
	*number = (status & 0x0f);

	while (isdigit(status = getc(fp))) {
	    *number = (*number * 10) + (status & 0x0f);
	}

	ungetc(status,fp);
	return(~EOF);
    }


/*
/*  allocparam
/*
/* 	Routine to allocate storage for a parameter structure
/*	space is allocated when the database references the parameter
/*	the parameter will not be scanned unless space has beed allocated
*/

static  allocparam(BRKDEV *pmod,unsigned short card)

    {
	pmod->params[card] = (BRKSPARAMETER *)calloc(1,sizeof(BRKSPARAMETER));
	if (!pmod->params[card]) {
	    logMsg ("Not enough memory for BRK Parameter %d \n",card);
	    return(-1);
	}

	pmod->params[card]->data_valid = FALSE;
	pmod->params[card]->was_requested = FALSE;
	pmod->params[card]->force_fetch = TRUE;
	pmod->params[card]->sdatabuf[0] = NULL;
	pmod->params[card]->intdata = NULL;
	pmod->params[card]->fdata = NULL;

	

	return(0);
    }

/*
/* Cold Init a PLC
/*
*/
static void    initplc (BRKDEV  *pmod)

    {

	unsigned short i;



/*
/*      PARAMETER POINTERS ARE INITIALIZED AS NULl
*/

	for (i=0; (i<MAXPARAMS); i++) {
	    pmod->params[i] = NULLP;
	}

    }


/*
/*
/* initialize the statistics for a Brooks Meter
/*
*/

static	void initstats(BRKDEV *pmod)

    {
	pmod->no_dataout_msgs = 0;      /* 5  Count Output Msgs */
	pmod->no_datain_msgs = 0;       /* 6  Count Data Requests */
	pmod->no_rxnoresp = 0;          /* 7  Count No Responses */
	pmod->no_txnoresp = 0;          /* 8  Count No Responses */
	pmod->no_dataerr = 0;           /* 9  Count Message Echo Errors */
	pmod->no_retries = 0;           /* 10 Count Retries */
	pmod->no_rxhwerrs = 0;          /* 11 Count Comm Hardware Errors */
	pmod->no_txhwerrs = 0;          /* 12 Count Comm Hardware Errors */
	pmod->no_crcerrs = 0;           /* 13 Count CRC Errors */
	pmod->no_offlines = 0;          /* 14 Count Off Line Transitions */
	pmod->badoutcnt = 0;		/* 17 Count failed output commands */

    }



/*
/*     prepresponses
/*
/*      The purpose of this routine is to mark the PLCs as on hold and the 
/*	data as not valid until read again from the PLC
/*
*/
static	void prepresponses(unsigned short line)

    {

	unsigned short  mod;
	BRKDEV  *pmod;

	for (mod=0; (mod<NUMBRKDEVS); mod++) {

	    pmod = plcs[line]+mod;
	    pmod->holdflag = TRUE;
 	    mark_not_valid(pmod);
	}
    }


/*
/*      any_responding
/*
/*      The purpose of this routine is to see if any units are 
/*	responding on this line
/*
*/
static	int any_responding(unsigned short line)

    {
	unsigned short  mod;
	BRKDEV  *pmod;

	for (mod=0; (mod<NUMBRKDEVS); mod++)
        {
	    pmod = plcs[line]+mod;
            /* check cmd_force_offline flag because it is set in an asynchronous task */
            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
               return(TRUE);
	}
	return(FALSE);
    }

/* 
/* getparam
*/
static	unsigned short getparam(unsigned short line, unsigned short mod,
			 BRKDEV *pmod, unsigned short parmno)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
		rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] =  BRKSOH;
	txp->txbuf[1] =  (mod/100)+'0';
	txp->txbuf[2] =  ((mod%100)/10)+'0';
	txp->txbuf[3] =  (mod%10)+'0';
	txp->txbuf[4] =  BRSMSTRADDR1;
	txp->txbuf[5] =  BRSMSTRADDR2;		/* Source Address is Fixed at 001 */
	txp->txbuf[6] =  BRSMSTRADDR3;
	txp->txbuf[7] =  BRKSTX;
	txp->txbuf[8] =  BRKREAD;	/* Code to read a parameter */
	txp->txbuf[9] =  (parmno/100)+'0';
	txp->txbuf[10] =  ((parmno%100)/10)+'0';
	txp->txbuf[11] =  (parmno%10)+'0';
	txp->txbuf[12] =  BRKETX;

	makecrc(&(txp->txbuf[0]),13,&(txp->txbuf[13]));

	txp->txmsglen = 15;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != BRKSOH) ||
	    (rxp->rxbuf[1] != txp->txbuf[4]) ||
	    (rxp->rxbuf[2] != txp->txbuf[5]) ||
	    (rxp->rxbuf[3] != txp->txbuf[6]) ||
	    (rxp->rxbuf[4] != txp->txbuf[1]) ||
	    (rxp->rxbuf[5] != txp->txbuf[2]) ||
	    (rxp->rxbuf[6] != txp->txbuf[3]) ||
	    (rxp->rxbuf[7] != BRKSTX) ||
	    (rxp->rxbuf[8] != txp->txbuf[9]) ||
	    (rxp->rxbuf[9] != txp->txbuf[10]) ||
	    (rxp->rxbuf[10] != txp->txbuf[11]) ||
	    (rxp->rxbuf[11] != '=') ) {

	    pmod->no_dataerr++;
	    return(FALSE);

	}


	/* verify message is not too long */
	len = rxp->rxix;


	/* Store the returned data as a string   */

	for ( i=12; (i<len); i++ ) {
	    pmod->params[parmno]->sdatabuf[i-12] = rxp->rxbuf[i];
	    if ((i-12)>BRKPARAMASCLEN) break;
	}

	/* Put in a null */
	pmod->params[parmno]->sdatabuf[i-12] = 0;

	/* Try to make a float out of the data */
	pmod->params[parmno]->fdata = brkatof(&pmod->params[parmno]->sdatabuf[0]);

	/* Try to make an integer out of the data */
	pmod->params[parmno]->intdata = brkatoi(&pmod->params[parmno]->sdatabuf[0]);

	for (i = 0;(mpnos[i] != -1);i++) {
            if (mpnos[i] == parmno) {
 		/* Try to make a mask out of the data */
		pmod->params[parmno]->maskdata = atom(&pmod->params[parmno]->sdatabuf[0]);
		break;
	    }
	}

	pmod->params[parmno]->data_valid = TRUE;
	return(TRUE);

    }

/* 
/* sendsout
*/
static	unsigned short sendsout(unsigned short line, unsigned short mod,
			 unsigned short card, BRKDEV *pmod, unsigned short signal,
			 unsigned char *buf, unsigned short olen)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,parmno,odata,obix;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;



	/* Format the output message */

	txp->txbuf[0] =  BRKSOH;
	txp->txbuf[1] =  (mod/100)+'0';
	txp->txbuf[2] =  ((mod%100)/10)+'0';
	txp->txbuf[3] =  (mod%10)+'0';
	txp->txbuf[4] =  BRSMSTRADDR1;
	txp->txbuf[5] =  BRSMSTRADDR2;		/* Source Address is Fixed at 001 */
	txp->txbuf[6] =  BRSMSTRADDR3;
	txp->txbuf[7] =  BRKSTX;

	if (card < MAXPARAMS) {
            parmno = card;
	    txp->txbuf[8] =  BRKWRITEACK;	/* Code to write a parameter */
	} else {
            parmno = (card-TASKS);
	    txp->txbuf[8] =  BRKEXECUTE;        /* Code to execute a task */
	}

	txp->txbuf[9] =  (parmno/100)+'0';
	txp->txbuf[10] =  ((parmno%100)/10)+'0';
	txp->txbuf[11] =  (parmno%10)+'0';

	if (card < MAXPARAMS) {
            parmno = card;
	    txp->txbuf[12] =  '=';
            odata = TRUE;
	    obix = 13;
	} else {
	    if (card == BRKDISPTASK) {
		odata = TRUE;
		obix = 12;
	    } else {
		odata = FALSE;
                obix = 12;
	    }
        }

	/* Move in the data and compute the length */

	/* Store the transmit data                      */

	i=0;
	if (odata) {
	    tlen = olen;
	    while  (i<STRMSGLEN) {
	        if ((olen != 0) && (i==tlen)) break;
	        txp->txbuf[obix+i] = buf[i];
		if (buf[i]=='~') txp->txbuf[obix+i]=0x1b;    /* get an escape char in msg */
	        if (olen == 0) {
		    if ((buf[i] == CR) || (buf[i] == 0)) {
                    /* Overwrite terminator with ETX */
			break;
		    }
	        }
	        i++;
	    }
        }

	txp->txbuf[obix+i] =  BRKETX;

	makecrc(&(txp->txbuf[0]),(obix+i+1),&(txp->txbuf[(obix+i+1)]));

	txp->txmsglen = obix+i+3;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

        /* Verify the header */
	if ((rxp->rxbuf[0] != BRKSOH) ||
	    (rxp->rxbuf[1] != txp->txbuf[4]) ||
	    (rxp->rxbuf[2] != txp->txbuf[5]) ||
	    (rxp->rxbuf[3] != txp->txbuf[6]) ||
	    (rxp->rxbuf[4] != txp->txbuf[1]) ||
	    (rxp->rxbuf[5] != txp->txbuf[2]) ||
	    (rxp->rxbuf[6] != txp->txbuf[3]) ||
	    (rxp->rxbuf[7] != BRKSTX) ) {

	    pmod->no_dataerr++;
	    return(FALSE);

	}
	if (card < MAXPARAMS) {
	    /* Verify the Ack */
	    if ((rxp->rxbuf[8] != BRKACK) ||
		(rxp->rxbuf[9] != BRKETX) ) {

	        pmod->no_dataerr++;
	        return(FALSE);
	    } else {
		return (TRUE);
            }
	} else { /* This must be an Execute Command */
	    if ( (rxp->rxbuf[8] != BRKEXECUTE) ||
	         (rxp->rxbuf[9] != txp->txbuf[9]) ||
	         (rxp->rxbuf[10] != txp->txbuf[10]) ||
	         (rxp->rxbuf[11] != txp->txbuf[11]) ||
	    	 (rxp->rxbuf[12] != '=') ||
	    	 (rxp->rxbuf[13] != 'Y') ||
	    	 (rxp->rxbuf[14] != BRKETX) ) {

		pmod->no_dataerr++;
	        return(FALSE);
	    } else {
		return (TRUE);
	    }
        }

    }




/*
/* sendbout binary output
*/
static	unsigned short sendbout (unsigned short line, unsigned short mod,
			 unsigned short card, BRKDEV *pmod, unsigned short signal,
			 unsigned long bval)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,mlen,parmno,temp,odata,obix,maskdata;
	unsigned char command;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;



	/* Format the output message */

	txp->txbuf[0] =  BRKSOH;
	txp->txbuf[1] =  (mod/100)+'0';
	txp->txbuf[2] =  ((mod%100)/10)+'0';
	txp->txbuf[3] =  (mod%10)+'0';
	txp->txbuf[4] =  BRSMSTRADDR1;
	txp->txbuf[5] =  BRSMSTRADDR2;		/* Source Address is Fixed at 001 */
	txp->txbuf[6] =  BRSMSTRADDR3;
	txp->txbuf[7] =  BRKSTX;

	if (card < MAXPARAMS) {
            parmno = card;
	    txp->txbuf[8] =  BRKWRITEACK;	/* Code to write a parameter */
	} else {
            parmno = (card-TASKS);
	    txp->txbuf[8] =  BRKEXECUTE;        /* Code to execute a task */
	}

	txp->txbuf[9] =  (parmno/100)+'0';
	txp->txbuf[10] =  ((parmno%100)/10)+'0';
	txp->txbuf[11] =  (parmno%10)+'0';

	if (card < MAXPARAMS) {
            parmno = card;
	    txp->txbuf[12] =  '=';
            odata = TRUE;
	    obix = 13;
            maskdata = FALSE;
	    for (i = 0;(mpnos[i] != -1);i++) {
		if (mpnos[i] == parmno) {
		    maskdata = TRUE;
                    mlen = mlens[i];
		    break;
	        }
	    }
	} else {
            obix = 12;
	    odata = FALSE;
	}

	/* Move in the data and compute the length */

	/* Store the transmit data                      */

	i=0;
	if (odata) {
	    if (maskdata) {
		obix += masktoascii(bval,&txp->txbuf[obix],mlen);
	    } else {
		obix += inttoascii(bval,&txp->txbuf[obix]);
            }

	}

	txp->txbuf[obix++] =  BRKETX;

	makecrc(&(txp->txbuf[0]),(obix),&(txp->txbuf[(obix)]));

	txp->txmsglen = obix+3;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

        /* Verify the header */
	if ((rxp->rxbuf[0] != BRKSOH) ||
	    (rxp->rxbuf[1] != txp->txbuf[4]) ||
	    (rxp->rxbuf[2] != txp->txbuf[5]) ||
	    (rxp->rxbuf[3] != txp->txbuf[6]) ||
	    (rxp->rxbuf[4] != txp->txbuf[1]) ||
	    (rxp->rxbuf[5] != txp->txbuf[2]) ||
	    (rxp->rxbuf[6] != txp->txbuf[3]) ||
	    (rxp->rxbuf[7] != BRKSTX) ) {

	    pmod->no_dataerr++;
	    return(FALSE);

	}
	if (card < MAXPARAMS) {
	    /* Verify the Ack */
	    if ((rxp->rxbuf[8] != BRKACK) ||
		(rxp->rxbuf[9] != BRKETX) ) {

	        pmod->no_dataerr++;
	        return(FALSE);
	    } else {
		return (TRUE);
            }
	} else { /* This must be an Execute Command */
	    if ( (rxp->rxbuf[8] != BRKEXECUTE) ||
	         (rxp->rxbuf[9] != txp->txbuf[9]) ||
	         (rxp->rxbuf[10] != txp->txbuf[10]) ||
	         (rxp->rxbuf[11] != txp->txbuf[11]) ||
	    	 (rxp->rxbuf[12] != '=') ||
	    	 (rxp->rxbuf[13] != 'Y') ||
	    	 (rxp->rxbuf[14] != BRKETX) ) {

		pmod->no_dataerr++;
	        return(FALSE);
	    } else {
		return (TRUE);
	    }
        }

    }



/*
/* 
/* sendaout analog output
*/
static	unsigned short sendaout (unsigned short line, unsigned short mod,
			 unsigned short card, BRKDEV *pmod, unsigned short signal,
			 int oval, double dbloval,unsigned short conv,
			 unsigned short prec)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	long		power;
	unsigned short  i,len,tlen,saveseqno,temp,olen, parmno,odata,obix;
	unsigned char command;


	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;



	/* Format the output message */

	txp->txbuf[0] =  BRKSOH;
	txp->txbuf[1] =  (mod/100)+'0';
	txp->txbuf[2] =  ((mod%100)/10)+'0';
	txp->txbuf[3] =  (mod%10)+'0';
	txp->txbuf[4] =  BRSMSTRADDR1;
	txp->txbuf[5] =  BRSMSTRADDR2;		/* Source Address is Fixed at 001 */
	txp->txbuf[6] =  BRSMSTRADDR3;
	txp->txbuf[7] =  BRKSTX;

	if (card < MAXPARAMS) {
            parmno = card;
	    txp->txbuf[8] =  BRKWRITEACK;	/* Code to write a parameter */
	} else {
            parmno = (card-TASKS);
	    txp->txbuf[8] =  BRKEXECUTE;        /* Code to execute a task */
	}

	txp->txbuf[9] =  (parmno/100)+'0';
	txp->txbuf[10] =  ((parmno%100)/10)+'0';
	txp->txbuf[11] =  (parmno%10)+'0';

	if (card < MAXPARAMS) {
            parmno = card;
	    txp->txbuf[12] =  '=';
            odata = TRUE;
	    obix = 13;
	} else {
            obix = 12;
	    odata = FALSE;
	}

	/* Move in the data and compute the length */

	/* Store the transmit data                      */

	if (odata) {
	    if (conv == ASCFLT) {
		obix += flttoascii(dbloval,&txp->txbuf[obix],prec);
	    } else {
		obix += inttoascii(oval,&txp->txbuf[obix]);
            }
	}


	txp->txbuf[obix++] =  BRKETX;

	makecrc(&(txp->txbuf[0]),(obix),&(txp->txbuf[(obix)]));

	txp->txmsglen = obix+3;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

        /* Verify the header */
	if ((rxp->rxbuf[0] != BRKSOH) ||
	    (rxp->rxbuf[1] != txp->txbuf[4]) ||
	    (rxp->rxbuf[2] != txp->txbuf[5]) ||
	    (rxp->rxbuf[3] != txp->txbuf[6]) ||
	    (rxp->rxbuf[4] != txp->txbuf[1]) ||
	    (rxp->rxbuf[5] != txp->txbuf[2]) ||
	    (rxp->rxbuf[6] != txp->txbuf[3]) ||
	    (rxp->rxbuf[7] != BRKSTX) ) {

	    pmod->no_dataerr++;
	    return(FALSE);

	}
	if (card < MAXPARAMS) {
	    /* Verify the Ack */
	    if ((rxp->rxbuf[8] != BRKACK) ||
		(rxp->rxbuf[9] != BRKETX) ) {

	        pmod->no_dataerr++;
	        return(FALSE);
	    } else {
		return (TRUE);
            }
	} else { /* This must be an Execute Command */
	    if ( (rxp->rxbuf[8] != BRKEXECUTE) ||
	         (rxp->rxbuf[9] != txp->txbuf[9]) ||
	         (rxp->rxbuf[10] != txp->txbuf[10]) ||
	         (rxp->rxbuf[11] != txp->txbuf[11]) ||
	    	 (rxp->rxbuf[12] != '=') ||
	    	 (rxp->rxbuf[13] != 'Y') ||
	    	 (rxp->rxbuf[14] != BRKETX) ) {

		pmod->no_dataerr++;
	        return(FALSE);
	    } else {
		return (TRUE);
	    }
        }

    }


static int masktoascii(long value,unsigned char *buf, unsigned short len)

    {
	unsigned short i,mask;

	mask = (1 << (len - 1));
	for (i = 0; (i<len);i++) {
	    if ((value & mask) != 0) buf[i] = '1';
	    else buf[i] = '0';
	}
	return (i);
    }




static int inttoascii(int value,unsigned char *buf)

    {
	long_to_str(value, buf);
	return (strlen(buf));

    }



static int flttoascii(double value ,unsigned char *buf,unsigned short prec)

    {
        f_to_str(value, buf, prec);
	return (strlen(buf));
    }

/*
/* makenum
/*
*/
static int makenum(char *buf,unsigned short len, long *value)

    {
	unsigned short i,sign,offset;

	offset = 0;
	sign = FALSE;
	if (buf[i] == '-') {
	    sign = TRUE;
	    offset = 1;
	}
	*value = 0;
	for (i=offset;(i<len);i++) {
	    if ((buf[i]<'0')||(buf[i]>'9')) return (FALSE);
	    *value = (*value*10)+(buf[i]-'0');
	}
	if (sign) *value = -*value;

	return (TRUE);

    }



/* makecrc
/*
*/
static	void makecrc( unsigned char *chkbuf, int len,char unsigned *retbuf)

    {
	unsigned short checksum;
	unsigned int   j;

	checksum = 0;
	for (j = 0; j < len; j++) {
	    checksum += chkbuf[j];
	}

	hexascii((checksum & 0xff),retbuf);
	return;
}



/*
/*      hexascii
/*
/*      The purpose of this routine is to convert the hex byte to 2 ascii
/*      characters and to place them into the buffer.
/*
*/
static	void hexascii(unsigned short val,char *buf)

    {
	char    hi,lo;

	hi = ((val & 0x0f0) >> 4);
	lo = (val & 0x0f);

	if (hi<=9)  hi+='0'; else hi+=('A'-10);
	if (lo<=9)  lo+='0'; else lo+=('A'-10);

	buf[0] = hi;
	buf[1] = lo;

    }


/*
/*      asciihex
/*
/*      The purpose of this routine is to convert the next 2 ascii
/*      characters in the buffer to hex and return them in val. It
/*      will return TRUE if good converdion of FALSE if bad.
*/
static	short asciihex(unsigned short *val,char *buf)

    {

	if ((buf[0] < '0') || (buf[0] > 'F')) return (FALSE);
	if ( buf[0] <= '9') *val = ((buf[0] & 0x0f) << 4);
	else {
	    if (buf[0] < 'A') return (FALSE);
	    else *val = ((buf[0] - 'A' + 10) << 4);
	}
	if ((buf[1] < '0') || (buf[1] > 'F')) return (FALSE);
	if ( buf[1] <= '9') *val += (buf[1] & 0x0f);
	else {
	    if (buf[1] < 'A') return (FALSE);
	    else *val += (buf[1] - 'A' + 10);
	}
	return (TRUE);
    }


static double brkatof(s)
char	*s;
{
	double	val;
	double	power;
	int	i;
	int	sign;

	for (i = 0; s[i] == ' ' || s[i] == '\n' || s[i] == '\t'; i++)
		;	/* skip white space */
	sign = 1;
	if (s[i] == '+' || s[i] == '-')		/* sign */
		sign = (s[i++] == '+') ? 1 : -1;
	for (val = 0; s[i] >= '0' && s[i] <= '9'; i++)
		val = 10 * val + s[i] - '0';
	if (s[i] == '.')
		i++;
	for (power = 1; s[i] >= '0' && s[i] <= '9'; i++) {
		val = 10 * val + s[i] - '0';
		power *= 10;
	}
	return (sign * val / power);
}


static long brkatoi(s)
char	*s;
{
	long	val;
	int	i;
	int	sign;

	for (i = 0; s[i] == ' ' || s[i] == '\n' || s[i] == '\t'; i++)
		;	/* skip white space */
	sign = 1;
	if (s[i] == '+' || s[i] == '-')		/* sign */
		sign = (s[i++] == '+') ? 1 : -1;
	for (val = 0; s[i] >= '0' && s[i] <= '9'; i++)
		val = 10 * val + s[i] - '0';

	return (sign * val);
}


static long atom(s)
char	*s;
{
	long	val;
	int	i;

	for (i = 0; s[i] == ' ' || s[i] == '\n' || s[i] == '\t'; i++)
		;	/* skip white space */
	for (val = 0; s[i] >= '0' && s[i] <= '1'; i++)
		val = 2 * val + s[i] - '0';

	return (val);
}

/*
/*      dump_brk_table
/*
/*      The purpose of this routine is to dump the module description
/*      portion of the analog devices driver tables for the selected line.
/*      It will print out two lines for each module which is responding.
/*      The first line will give the general module header, the second line
/*      will give module type specific info.
*/
static	void dump_brk_table(unsigned short line)

    {
	BRKDEV  *pmod;
	short           ix;



	if (!plcs[line]) return;

	if (line != line) return;  /* No Warnings */
	for (ix=0; ix<NUMBRKDEVS; ix++) {
	    pmod = plcs[line]+ix;
	    if (pmod->is_responding) {


	    }
	}
    }
