/*drvCompumotor.c,v 1.1.1.1 1999/08/03 14:42:09 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*                                                                            
/*  File: drvCompumotor.c                                                     
**  Edit:  3/31/99  wep : modified position command to handle negative values 
**  Edit:  4/02/99  wep : removed unused commented out code.                  
*/

#define VERSIONNUM   03    /* NOTE: change here */

#define	MAIN		cmpmtr_driver		/* NOTE: change here */
#define	AIDRIVER	cmpmtr_aidriver		/* NOTE: change here */
#define	AODRIVER	cmpmtr_aodriver		/* NOTE: change here */
#define	AOREAD		cmpmtr_aoread		/* NOTE: change here */
#define	BIDRIVER	cmpmtr_bidriver		/* NOTE: change here */
#define	BODRIVER	cmpmtr_bodriver		/* NOTE: change here */
#define	BOREAD		cmpmtr_boread		/* NOTE: change here */
#define	SIDRIVER	cmpmtr_sidriver		/* NOTE: change here */
#define	SODRIVER	cmpmtr_sodriver		/* NOTE: change here */

#define	TRAFFICON	cmpmtrtrafficon		/* NOTE: change here */
#define	TRAFFICOFF	cmpmtrtrafficoff	/* NOTE: change here */
#define	TRAFFIC		cmpmtrtraffic		/* NOTE: change here */
#define	TRACEON		cmpmtrtraceon		/* NOTE: change here */
#define	TRACEOFF	cmpmtrtraceoff		/* NOTE: change here */
#define	RTRACE		cmpmtrrestrlv		/* NOTE: change here */
#define	RTRACEON	cmpmtrrestraceon	/* NOTE: change here */
#define	RTRACEOFF	cmpmtrrestraceoff	/* NOTE: change here */
#define	TRACELEVEL	cmpmtrtrlv		/* NOTE: change here */
#define	CONTRACEON	cmpmtrcontraceon	/* NOTE: change here */
#define	CONTRACEOFF	cmpmtrcontraceoff	/* NOTE: change here */
#define	RUNTRACEON	cmpmtrruntraceon	/* NOTE: change here */
#define	RUNTRACEOFF	cmpmtrruntraceoff	/* NOTE: change here */
#define	REJECTTRACEON	cmpmtrrejecttraceon	/* NOTE: change here */
#define	REJECTTRACEOFF	cmpmtrrejecttraceoff	/* NOTE: change here */
#define	NACKTRACEON	cmpmtrnacktraceon	/* NOTE: change here */
#define	NACKTRACEOFF	cmpmtrnacktraceoff	/* NOTE: change here */
#define	DEFAULTTRACE	cmpmtrdefaulttrace	/* NOTE: change here */

#define	HELP		cmpmtrhelp		/* NOTE: change here */
#define	SIMON		cmpmtrsimon		/* NOTE: change here */
#define	SIMOFF		cmpmtrsimoff		/* NOTE: change here */

#define	STOPDRIVER	stopcmpmtr		/* NOTE: change here */
#define	STARTDRIVER1	startcmpmtr		/* NOTE: change here */
#define	SETCOMM		cmpmtrcomm		/* NOTE: change here */

#define	DUMPMSGCNTS	cmpmtrdumpmsgcnts	/* NOTE: change here */
#define	CLEARMSGCNTS	cmpmtrclearmsgcnts	/* NOTE: change here */
#define	DUMPPLCSTATS	cmpmtrdumpplcstats	/* NOTE: change here */
#define	CLEARPLCSTATS	cmpmtrclearplcstats	/* NOTE: change here */

#define	TABLEINFO	dump_cmpmtr_table	/* NOTE: change here */
#define	LINEINFO	showlineinfo		/* NOTE: change here */


#include	<ctype.h>

#include	<vxWorks.h>
#include	<sysLib.h>
#include	<semLib.h>
#include	<wdLib.h>
#include	<rngLib.h>
#include	<task_params.h>
#include	<stdioLib.h>

#include	"dbDefs.h"
#include	"drvSup.h"
#include	"module_types.h"
#include	"tsDefs.h"
#include	"drvCompumotor.h"		/* NOTE: change here */
#include	"drvCompumotor_proto.h"		/* NOTE: change here */
#include	"restable.h"

/* current time stamp, defined in .../share/src/time/ts_drive.c */

extern TS_STAMP	time_stamp;


/* static long	init (); */

struct
{
	long		number;
	DRVSUPFUN	report;
	DRVSUPFUN	init;
} drvCompumotor =
{
	2,
	NULL,
	init
};

/*
**      External Line Level Data Structures (declared in drvcommon.c)
**
*/

/* array of resource name strings.		*/

extern	unsigned char	resnames [CMPMTRLINES] [RESNAMELEN];

/* array of pointers to resource tables 	*/

extern	RES_TABLE	*prestable [CMPMTRLINES];

/* array of resource response flags. 		*/
/* False=not active resource (slave),		*/
/* True= active resource (master) 		*/

extern	unsigned short	resresponse [CMPMTRLINES];

/* true/false line active flag. calculated	*/
/* using activity_time below. 			*/

extern	unsigned short	line_activity [CMPMTRLINES];

/* assigned value of line_activity prior to	*/
/* it's recalculation.   			*/

extern	unsigned short	lastactivity [CMPMTRLINES];

/* controls output of communication error log	*/
/* messages (true/false) 			*/

extern	unsigned short	modtrace [CMPMTRLINES];

/* controls output of certain resource related	*/
/* log messages (level) 			*/

extern	unsigned short	mltrace [CMPMTRLINES];

/* controls output of MASTER/SLAVE arbitration	*/
/* log messages (binary) 			*/

extern	unsigned short	modrestrace [CMPMTRLINES];

/* 'new' semaphore logic. the old SEMAPHORE is	*/
/* still used. 					*/

extern	SEM_ID		semids [CMPMTRLINES] [2];

/* holds value passed in task spawn. used for	*/
/* each msgxfer attempt 			*/

extern	unsigned short	intermsgdelay [CMPMTRLINES];

/* holds post RTS delay before TX. 		*/

extern	unsigned short	pretxdelay [CMPMTRLINES];

/* holds post TX delay before dropping RTS. 	*/

extern	unsigned short	posttxdelay [CMPMTRLINES];

/* holds timetick of last activity. used to	*/
/* set line_activity flag  			*/

extern	long		activity_time [CMPMTRLINES];

/* store half/full duplex line status           */

extern  unsigned short  halfduplex [CMPMTRLINES];

/* holds max time in seconds that driver will   */
/* wait to obtain partner state on first        */
/* attempting to decide if it should be master. */

extern	unsigned short	pstatewait [CMPMTRLINES];


/*
**      Storage for Compumotor Comm Line Structures
**
*/
/* array of pointers to dynamically           */
/* allocated comm controls/buffers            */

static RXLINE          *rxlinetab [CMPMTRLINES] = 
{
	NULL, NULL, NULL, NULL
}; 

/* array of pointers to dynamically           */
/* allocated comm controls/buffers            */

static TXLINE          *txlinetab [CMPMTRLINES] = 
{
	NULL, NULL, NULL, NULL
};

/*
**      Storage for Compumotor Structures
**
*/

static	unsigned int	tick [CMPMTRLINES][5];

/* holds timestamp of beginning of major loop.  */

static	unsigned int	lastscan [CMPMTRLINES];

/* holds actual time taken to scan plcs.        */

static	unsigned int	scantime [CMPMTRLINES];

static	unsigned int	loopoutmsgs [CMPMTRLINES];

static	unsigned int	loopmsgs [CMPMTRLINES];

/* array of line level statistics.              */

static	LINESTATS	linestats [CMPMTRLINES];

/* two dimensional array of pointers to the	*/
/* fixed length dynamically allocated PLC	*/
/* control and data structures. extra pointer	*/
/* is for Query structure used independently	*/
/* of the others. it also allows for the array	*/
/* index to match the mod value.		*/

static	CMPMTR		*plcs [CMPMTRLINES] [NUMCMPMTRS + 1];

/* controls output of system error messages:	*/
/* bit mapped controls                          */

static	unsigned short	trace [CMPMTRLINES];

static	unsigned char	traceadr [CMPMTRLINES];

static	unsigned char	tracetype [CMPMTRLINES];

/* array of ptrs to the line output queues and  */
/* their control structures                     */

static	OUTPUTQUE	*oq [CMPMTRLINES];

static	unsigned long	nextouttime [CMPMTRLINES];

static	unsigned long	outagain [CMPMTRLINES];

/* holds id and password of the user that	*/
/* spawned the driver task required by host to	*/
/* check file read privileges on PLC load files	*/

static	char		user [40],
			password [40];

/* store half/full duplex line status	*/

static 	unsigned short	options [CMPMTRLINES];

static	char		*bools [] =
{
	"TRUE ",
	"FALSE"
};

static	int		taskId [CMPMTRLINES];

static	short		watchdogId [CMPMTRLINES];


static	char		*tasknames [CMPMTRLINES] =
{
	"CMPMTR Ch0","CMPMTR Ch1","CMPMTR Ch2","CMPMTR Ch3"
};

/**********
**
**	This routine is required by iocinit in the EPICS system.
**
**********/
static long init ()
{
	return (0);
}

/********
**
**	This routine outputs information to help with debugging.
**
********/
void HELP (void)
{
    printf (" Compumotor Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" cmpmtrtraceon(N)         Enable the following debug messages for line N:             \n");
    printf ("                         1) Major Scan loop Info:                                  \n");
    printf ("                           scan time, total output messages, and total messages.   \n"); 
    printf ("                         2) Output Queue Overflow.                                 \n");
    printf ("                         3) All communication errors encountered in msgxfer.       \n");
    printf ("*cmpmtrtraceoff(N)        Disable all of the modtraceon debug messages for line N.    \n");
    printf ("\n");
    printf (" cmpmtrrestrace(N,X)      Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*cmpmtrrestraceon(N)      Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" cmpmtrrestraceoff(N)     Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");
    printf ("  (v%d)                                                                 \n", VERSIONNUM);
    printf ("\n");
    printf ("\n");

    taskDelay (1 * 60); /* Time for operator to see it and pause the output */

    printf (" cmpmtrcontraceon(N)      Enable display of configuration errors in driver calls.     \n");
    printf ("*cmpmtrcontraceoff(N)     Disable display of configuration errors in driver calls.    \n");
    printf (" cmpmtrruntraceon(N)      Enable display of runtime errors (queue overflow).          \n");
    printf ("*cmpmtrruntraceoff(N)     Disable display of runtime errors (queue overflow).         \n");
    printf (" cmpmtrrejecttraceon(N)   Enable display of driver call rejections in driver calls.   \n");
    printf ("*cmpmtrrejecttraceoff(N)  Disable display of driver call rejections in driver calls.  \n");
    printf (" cmpmtrnacktraceon(N)     Enable display of point deselection on MODBUS command NACK. \n");
    printf ("*cmpmtrnacktraceoff(N)    Disable display of point deselection on MODBUS command NACK.\n");
    printf ("\n");

    taskDelay (1 * 60); /* Time for operator to see it and pause the output */

    printf (" cmpmtrtrlv(N,X)          Enable the following message for line N:                  \n");
    printf ("                         X=0,  display none of the messages below.               \n");
    printf ("                         X=1,  beginning of plc scan loop, bringing plcs online. \n");
    printf ("                         X=2,  beginning of plc scan.                            \n");
    printf ("                         X=3,  AO queue actions (normal: AODRIVER & checkoutputs)\n");
    printf ("                         X=4,  BO queue actions (normal: BODRIVER & checkoutputs)\n");
    printf ("                         X=5,  SO queue actions (normal: SODRIVER & checkoutputs)\n");
    printf ("                         X=6,  calls to checkoutputs.                            \n");
    printf ("                         X=7,  checkoutputs: trace each queue entry read.        \n");
    printf ("                         X=8,  AIDRIVER, AOREAD: normal call return.             \n");
    printf ("                         X=9,  BIDRIVER, BOREAD: normal call return.             \n");
    printf ("                         X=10, SIDRIVER: normal call return.                     \n");
    printf ("                         X=11 to 14,  reserved.                                  \n");
    printf ("                         X=15, 'Microsol Busy', waiting in checkoutputs.         \n");
    printf ("                         X=16 to 254,  reserved.                                 \n");
    printf ("\n");

    taskDelay (1 * 60); /* Time for operator to see it and pause the output */

    printf (" cmpmtrtrafficon(N)       Enable traffic tracing for all plc addresses                \n");
    printf ("                         and all modbus functions on line N.                       \n");
    printf ("*cmpmtrtrafficoff(N)      Disable all traffic tracing on line N.                      \n");
    printf (" cmpmtrtraffic(N,X,Y)     Modifies line N traffic tracing as follows:                 \n");
    printf ("                         X=0   disables tracing of all addresses.                  \n");
    printf ("                         X=255 enables tracing of all addresses.                   \n");
    printf ("                         0 < X < 255 enables tracing of address X traffic.         \n");
    printf ("                         Y=0   disables tracing of all modbus functions.           \n");
    printf ("                         Y=255 enables tracing of all modbus functions.            \n");
    printf ("                         0 < Y < 255 enables tracing of function Y traffic.        \n");
    printf ("\n");
    printf (" cmpmtrdefaulttrace(N)    Restores default setting for all traces.                    \n");
    printf ("\n");

    taskDelay (1 * 60); /* Time for operator to see it and pause the output */

    printf (" cmpmtrsimon(N,D,L,H,T)   Enables the simulation of responding plcs.                  \n");
    printf ("                        D: simulation interval (in seconds). if D<1 or D>60, D=60. \n");
    printf ("                        L: low value of analog simulation range.                   \n");
    printf ("                        H: high value of analog simulation range.                  \n");
    printf ("                        T: 0 = digital inputs are zero. 1 = digitial inputs toggle.\n");
    printf ("*cmpmtrsimoff(N)          Disables simulation, thus enabling normal driver function.  \n");
    printf ("\n");

    taskDelay (1 * 60); /* Time for operator to see it and pause the output */

    printf (" cmpmtrcomm(N,t1,f,t2,t3) Set communication timing parameters for line N as follows:  \n");
    printf ("                         t1: intermessage delay (in ticks).                        \n");
    printf ("                          f: 0 = full duplex, 1 = half duplex.                     \n");
    printf ("                         t2: post RTS assert, pre TX delay (in ticks).             \n");
    printf ("                         t3: post TX, pre RTS drop delay (in ticks).               \n");
    printf ("\n");
    printf (" cmpmtrdumpmsgcnts(N)     Display line N communication statistics.                    \n");
    printf (" cmpmtrclearmsgcnts(N)    Display and clear line N communication statistics.          \n");
    printf (" cmpmtrdumpplcstats(N,X)  Display line N, plc X, communication statistics.            \n");
    printf (" cmpmtrclearplcstats(N,X) Display and clear line N, plc X, xfers, status & errors.    \n");
    printf (" dump_cmpmtr_table(N,X)   Display line N, plc X, xfers, status, errors and input data.\n");
}


/********
**
**	This routine enables logging of comm trace messages
**
********/
void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/********
**
**	This routine disables logging of comm trace messages
**
********/
void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFIC (unsigned short line, unsigned char add, unsigned type)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = add;
        tracetype [line] = type;
        return;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFICON (unsigned short line)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = 255;  /* every address */
        tracetype [line] = 255; /* every message type */
}

/********
**
**	This routine disables detailed display of normal communications traffic
**
********/
void TRAFFICOFF (unsigned short line)
{
	trace [line] = trace [line] & ~ALLTRAFFICTRACE;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACE (unsigned short line, unsigned short level)
{
	modrestrace [line] = level;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACEON (unsigned short line)
{
	modrestrace [line] = 1;
}

/********
**
**	This routine disables logging of resource trace messages
**
********/
void RTRACEOFF (unsigned short line)
{
	modrestrace [line] = 0;
}

/********
**
**	This routine controls logging of trace messages
**
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}

/********
**
**	These routines enable and disable tracing of database
**	configuration errors in driver calls
*
********/
void CONTRACEON (unsigned short line)
{
	trace [line] = trace [line] | CONFIGURATIONTRACE;
}

void CONTRACEOFF (unsigned short line)
{
	trace [line] = trace [line] & ~CONFIGURATIONTRACE;
}

/********
**
**	These routines enable and disable tracing of runtime errors in driver calls
**
********/
void RUNTRACEON (unsigned short line)
{
	trace [line] = trace [line] | RUNTIMEERRORTRACE;
}

void RUNTRACEOFF (unsigned short line)
{
	trace [line] = trace [line] & ~RUNTIMEERRORTRACE;
}

/********
**
**	These routines enable and disable tracing of call rejection errors
**	in driver calls
**
********/
void REJECTTRACEON (unsigned short line)
{
	trace [line] = trace [line] | CALLREJECTTRACE;
}

void REJECTTRACEOFF (unsigned short line)
{
	trace [line] = trace [line] & ~CALLREJECTTRACE;
}

/********
**
**	These routines enable and disable tracing of call rejection errors
**	in driver calls
**
********/
void NACKTRACEON (unsigned short line)
{
	trace[line] = trace[line] | MODBUSNACKTRACE;
}

void NACKTRACEOFF (unsigned short line)
{
	trace[line] = trace[line] & ~MODBUSNACKTRACE;
}

/********
**
**	This routine restores default setting for all traces.
**
********/
void DEFAULTTRACE (unsigned short line)
{
        /* debug structures */

	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = 1;
        trace [line] = 0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
}

/********
**
**	This routine turns on all error tracing.
**
********/
void moderrortrace (unsigned short line)
{
        /* debug structures */
	modtrace [line] = TRUE;
	modrestrace [line] = 2;
	trace[line] = MODBUSNACKTRACE ||
                      CONFIGURATIONTRACE ||
                      RUNTIMEERRORTRACE ||
                      CALLREJECTTRACE ||
                      0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
}

int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
            /* if watchdog timer has been attached, detach it before deleting the task */
            if (taskId [ln])
            {
                tisWatchDogDetach (taskId [ln]);
            }
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER1 (unsigned short line,		/* the line number of this driver.                      */
                  char *mode,			/* UART initializations string (comma delimited ascii). */
                  unsigned short delay,		/* intermessage delay value, expressed in ticks.        */
                  unsigned short hdflag,	/* half duplex flag. 1=half duplex mode, 1!=full duplex */
                  unsigned short delay1,	/* half duplex post RTS assert, pre TX delay.           */
                  unsigned short delay2,	/* half duplex post TX, pre RTS drop delay.             */
                  unsigned short private,	/* private flag. if 0, normal. if !0, no partner driver.*/
		  unsigned short PosMode)	/* 0 = Absolute, 1 = Incremental */

{
	if (line < CMPMTRLINES)
	{
	    taskId [line] = taskSpawn (tasknames [line],
                                     CMPMTR_PRIORITY,
                                     CMPMTR_TASK_OPTIONS,
                                     CMPMTR_STACK,
                                     MAIN,
                                     line,
                                     mode,
                                     delay,
                                     hdflag,
                                     delay1,
                                     delay2,
                                     private,
				     PosMode);

	    logMsg ("Started the CMPMTR driver on line %d\n",line);

	    remCurIdGet (user,password);
	    return (1);
	}
	else
	{
	    logMsg ("Invalid line number %d\n", line);
	    return (-1);
	}
}
/********
**
** Set communication logic time delays to handle half/full duplex, radio delays, etc 
**
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
	halfduplex [line]    = hdflag;
	pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}


/*
**      CMPMTR_driver
**
**      The purpose of this task is to scan the modbus plc
**      lines. It will maintain a configuration list supporting online additions
**      and replacement of modules, and maintain a table of most recently
**      scanned values.
**
*/                                                                                     	
/* not called from within this driver 	*/

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2,
           unsigned short private,
	   unsigned short PosMode)
{
	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command, i;
	long	        this_time, last_time;
	CMPMTR          *pmod;
	RXLINE          *rxp;
	unsigned int    temptick, tempdiff;
	int             temp;
	short  *ptable_id;

	/* Initialize the data structures */

	intermsgdelay [line] = delay;

	halfduplex [line]  = hdflag;
	pretxdelay [line]  = delay1;
	posttxdelay [line] = delay2;

	resresponse [line] = FALSE;
	resnames [line] [0] = 0;
	prestable [line] = NULL;

	activity_time [line] = tickGet ();
	lastactivity [line] = line_activity [line] = FALSE;
	nextouttime [line] = 0;
	outagain [line] = 0;

	/* will wait up to one minute for partner to become valid */

	pstatewait[line] = 60;

	/* debug structures */
	moddefaulttrace (line);

	tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].msgxfercount = 0;
	linestats [line].startingtick = tickGet ();

	/* output queue initialization */

	oq [line] = (OUTPUTQUE *) calloc (1, (sizeof (OUTPUTQUE)));
	if (!oq [line])
	{
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}
	outqueinit (line);

	/* communication initialization */

	rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
	if (!rxlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
	    return;
	}
	txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
	if (!txlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
	    return;
	}
	/* make terminal display easier to read		*/
	/*avoids interleaving of other task data	*/

	taskLock ();
	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
	taskUnlock ();

	/* causes on_line calls to begin on first pass if master */

	onlinefreq = 1;

	/* Initialize the Rx ints to receive once for activity check	*/
	/* enable the receiver interrupt after set to ignore		*/

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);

	/* Wait for resource to be defined via an initial call to	*/
	/*'register_resource' via driver call.				*/

	while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
	{
	    if (modrestrace [line] > 1)
	    {
	    	logMsg ( "No Resource Defined for line - %d \n", line);
	    }
	    taskDelay (600);
	}

	/* attach this driver task to the watchdog timer monitoring function. */

	ptable_id = &watchdogId [line];

	if (tisWatchDogAttach (taskId [line], WATCHDOGTIMEOUT, ptable_id) != OK)
	{
	    logMsg("Attempt at watchdog attachment failed.\n");
	    tisWatchDogDetach (taskId [line]);
	    return;
	}
	if (tisWatchDogPulse (watchdogId [line]) != OK)
	{
	    logMsg ("First attempt at watchdog pulsing failed.\n");
	    tisWatchDogDetach (taskId [line]);
	    return;
	}

	if (private)
	{
	    /*****************************/
	    /* Immediately become master */
	    /*****************************/

	    resSetCaAnswer (prestable [line]);
	    resPutLocalState (prestable [line], RES_MSTR);

	    lastscan [line] = tickGet ();
	    scantime [line] = 0;

	    lstate = RES_MSTR;
	    if (modrestrace [line])
	    {
	    	logMsg ("0] Private: Initialize as RES_MSTR\n");
	    }
	}
	else			/* this is the 'normal' path */
	{
            /* Start out as slave */

	    /******************************/
	    tisWatchDogPulse (watchdogId [line]);
	    /******************************/

	    resClearCaAnswer (prestable [line]);	/* start quiet */
	    resPutLocalState (prestable [line], RES_SLV);

	    if (modrestrace [line])
	    {
		logMsg ("1] Initialized as RES_SLV\n");
	    }

	    /* wait finite time for pstate to be resolved */

	    logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
	    for (i = 0; i <= pstatewait [line]; i++)
	    {
		resGetStates (prestable [line], &lstate, &pstate);
		if (pstate != 0)
		{
		    break;
		}
		taskDelay (60);

		/******************************/
		tisWatchDogPulse (watchdogId [line]);
		/******************************/
	    }
	    if (pstate == 0)
	    {
		logMsg ("Timeout of pstate wait.\n");
	    }
	    else
	    {
		logMsg ("Completion of pstate wait.\n");
	    }

	    for (i = 0; i < ACTIVITYTIME / 10; i++) ;  /* ten seconds */
	    {
		taskDelay (10);

		/******************************/
		tisWatchDogPulse (watchdogId [line]);
		/******************************/
	    }

	    activity = check_line_activity (line, 0);
	    resGetStates (prestable [line], &lstate, &pstate);

	    /******************************************/
	    /* if the partner is not there, be master */

	    if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
	    {
		resSetCaAnswer (prestable [line]);
		resPutLocalState (prestable [line], RES_MSTR);
		lastscan [line] = tickGet ();
		scantime [line] = 0;

		lstate = RES_MSTR;
		if (modrestrace [line])
		{
		    logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
		}
	    }
	}

	cfgchk = 0;		/* Init the new config pointer */
	last_time = tickGet (); /* Initialize the time  */

	while (TRUE)
	{
	    /******************************/
	    tisWatchDogPulse (watchdogId [line]);
	    /******************************/

	    activity_time [line] = tickGet ();
	    lastactivity [line] = line_activity [line] = FALSE;

            /********************************************************************/
	    /*	we arrive here because we are a slave.				*/
	    /*			PLCs, we become master.				*/
	    /*			the partner is not master and there is no 	*/
	    /*			activity on the line.				*/
	    /********************************************************************/

	    while (lstate == RES_SLV)
	    {
		/******************************/
		tisWatchDogPulse (watchdogId [line]);
		/******************************/

		if (pstate != RES_SLVWANT)
		{
		    /* make sure line is left for master */

		    clear_rts (line); 
		}

 		/* make sure driver is not responding 	*/

		resresponse [line] = FALSE;

 		/* clear out commands 			*/

		resPutCommand (prestable [line], 0);

		/* wait 10 seconds before checking 	*/

		activity = check_line_activity (line, 10); 
		resGetStates (prestable [line], &lstate, &pstate);

		/* see if needed by partner to be master.	*/
		/* if yes, do it and break out of slave state.	*/
		if (pstate == RES_SLVWANTCA)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

		    lastscan [line] = tickGet ();
		    scantime [line] = 0;

		    if (modrestrace [line])
		    {
			logMsg ("3] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
		    }
		    break;
		}
		/***************************************************************/
		/* If partner is there and wants to give it up, try to take it */

		if (pstate == RES_SLVWANT)
		{
		    /******************************/
		    tisWatchDogPulse (watchdogId [line]);
		    /******************************/

		    execute = FALSE;
		    taskDelay (2);		/* Time for switch to occur */

		    /* See if anyone is out there and able to respond	*/
		    /* to a loopback command				*/

		    for (mod = 1; (mod <= NUMCMPMTRS); mod++)
		    {
			pmod = plcs [line] [mod];

			/* verify pointer validity prior to use */
			/* data points have been requested      */
			/* user has NOT forced plc offline      */

			if ((pmod) &&
			    (pmod->was_requested) &&
			    (!pmod->cmd_force_offline))
			{
			    /******************************/
			    tisWatchDogPulse (watchdogId [line]);
			    /******************************/

			    on_line (line, mod, PosMode);

			    /* check cmd_force_offline flag before AND	*/
			    /* after due to asynchronous tasks		*/

			    if ((pmod->is_responding) && (!pmod->cmd_force_offline))
			    {
				execute = TRUE;
				break;
			    }
			}
		    }
		    /* If someone answered, become master and make sure	*/
		    /* partner really gave it up			*/

		    if (execute)
		    {
			resPutLocalState (prestable [line], RES_MSTR);
			lstate = RES_MSTR;

			lastscan [line] = tickGet ();
			scantime [line] = 0;

			if (modrestrace [line])
			{
				logMsg ("4] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
			}
			execute = FALSE;
			activity_time [line] = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < 60); i++)
			{
			    /******************************/
			    tisWatchDogPulse (watchdogId [line]);
			    /******************************/

			    /* pause before testing */

			    activity = check_line_activity (line, 2);
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT)
				&& (!activity) )
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */
			    resPutLocalState (prestable [line], RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace [line])
			    {
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n", pstate, activity);
			    }
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 

			    resSetCaAnswer (prestable [line]);
			    prepresponses (line);
			    break;
			}
		    }
		}

		/********************************************/
		/* if the partner is not talking, be master */

		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

		    lastscan [line] = tickGet ();
		    scantime [line] = 0;

		    if (modrestrace [line])
		    {
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n", pstate, activity);
		    }
		    prepresponses (line);
		}
	    }

	    /********************************************************************/
	    /* to arrive here, we used to be master, and had been told to	*/
	    /* relinquish master status. stay in this loop until the partner	*/
	    /* takes over, or the command is canceled				*/

	    while (lstate == RES_SLVWANTCA)
	    {
		/******************************/
		tisWatchDogPulse (watchdogId [line]);
		/******************************/

	        taskDelay (2);		/* Give OS a chance...  */
		clear_rts (line);	/* Make sure line is left for master    */

		/* Make Sure driver is not responding   */

		resresponse [line] = FALSE;

		resGetStates (prestable [line], &lstate, &pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace [line])
		    {
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n", pstate, activity);
		    }
		    break;
		}
		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
		    {
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
		    }
		    prepresponses (line);
		}
	    }

            /********************************************************************/
	    /* in normal operation this code should never execute. it has,	*/
	    /* however, been seen to execute when the database has been		*/
	    /* inadvertently configured with the same resource assigned to	*/
	    /* two different drivers in the same IOC. The state does funny	*/
	    /* things.								*/
            /********************************************************************/

	    while (lstate == RES_SLVWANT)
	    {
		if ((modrestrace [line]) || (trace [line] & CONFIGURATIONTRACE))
		{
		    /* condition should NEVER occur.		*/
		    /* print error message every 5 seconds.	*/

		    logMsg ("Illegal Local Resource State.\n");
		    if (trace [line] & CONFIGURATIONTRACE)
		    {
			logMsg ("  Possible Resource Configuration Error:\n");
			logMsg ("   Check for multiple drivers sharing single Resource.\n");
		    }
		    taskDelay (600);
		}
		taskDelay (2);
	    }
	    /********************************************************************/
	    /* we come here because we have gone to, or are looping in, the	*/
	    /* master state.							*/
	    /* we stay in this loop until:					*/
	    /*		we have been told to give master state to the partner.	*/
	    /*		we break out to RES_SLVWANTCA.				*/
	    /*		we have successfully handed master state to partner.	*/
	    /* While master, this task will process all modules sending outputs	*/
	    /* and getting inputs.						*/
	    /* It will then try to configure requested non-responding modules.	*/
	    /********************************************************************/

	    last_time = tickGet ();		/* initialize gap */
	    while (lstate == RES_MSTR)
	    {
		if (mltrace [line] == 1)
		{
			logMsg ( "Top of Master Loop... \n");
	        }
		/******************************/
		tisWatchDogPulse (watchdogId [line]);
		/******************************/

		/* initial stuff				*/
		/* Make sure driver is responding. driver won't	*/
		/* issue commands if not set.			*/

		resresponse [line] = TRUE; 

		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0);	/* clear out commands */

		/****************************************************************/
		/* if relinquish command sent, change state and break out to	*/
		/* outer loop							*/

		if (command == RES_RELINQUISH)
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace [line])
		    {
			logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n", pstate, activity);
		    }
		    break;
		}

		/* measure time between scans of the entire set of plcs.	*/
		/* display if requested.					*/ 

		temptick = tickGet ();
		tempdiff = temptick - lastscan [line];

		if (modtrace [line])
		{
		    logMsg ("ScanTime: =%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                            scantime[line], loopoutmsgs[line], loopmsgs[line]);
		}

		loopoutmsgs [line] = 0;
		loopmsgs [line] = 0;
		lastscan [line] = temptick;

		/* scan plcs for data i/o, if allowed */

		modspolled = 0;

		/* call 'scan_plc' for each PLC device, unless user has */
		/* taken it off line or it is not responding.           */

		for (mod = 1; (mod <= NUMCMPMTRS); mod++)
		{
		    pmod = plcs [line] [mod];	/* shorthand pointer	*/

		    if (pmod)		/* verify pointer validity prior to use */
		    {
			if (pmod->cmd_force_offline)
			{ 
			    /* if user has turned this plc offline via		*/
			    /* pseudo commands, mark it as not responding.	*/

 			    pmod->is_responding = FALSE;
	    		}
			else if (pmod->is_responding)
			{
			    /* local/partner lockstep recovery */

			    resGetStates (prestable [line], &lstate, &pstate);
                            if (pstate == RES_MSTR)
			    {
				resClearCaAnswer (prestable [line]);
				resPutLocalState (prestable [line], RES_SLV);
				lstate = RES_SLV;

 				/* Make sure line is left for master */

				clear_rts (line);
				if (modrestrace [line])
				{
				    logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
				}

				/* random 5 to 12 second delay */

				temp = ((tickGet () % 8) + 5);
				for ( i = 0; i < temp; i++)
				{
				    /******************************/
				    tisWatchDogPulse (watchdogId [line]);
				    /******************************/
				    taskDelay(60);
				}
				break;
			    }
			    modspolled++;

			    scan_plc (pmod, line, mod);	/* I/O done here!	*/
			    if (!pmod->is_responding)
			    {
				mark_not_valid (pmod);
			    }
			}
		    }
		    /* end of single module action				*/

		    /* if told to relinquish our master state, stop plc		*/
		    /* scanning immediately. don't trash the command, so that	*/
		    /* we can still read it on the next loop			*/
                    /* through this while statement.				*/

		    resGetCommand (prestable [line], &command);
		    if (command == RES_RELINQUISH)
		    {
			break;
		    }
		} /* end of scan loop */

		/* test for lockstep detection. */

		if (lstate != RES_MSTR)
		{
		    break;
		}
		/******************************/
		tisWatchDogPulse(watchdogId[line]);
		/******************************/

		/* measure how long the scan took. to be displayed	*/
		/* at beginning of next loop.				*/

		temptick = tickGet ();
		scantime [line] = temptick - lastscan [line];

		/* try and bring all nonresponding plcs on line, but */
		/* don't bring in more than a specified number.      */

		cnt = 0;

 		/* do we try to bring any in on this pass? */

		if (--onlinefreq == 0)
		{ 
		    onlinefreq = BRINGBACKCNT;
		    for (mod = 1; (mod <= NUMCMPMTRS); mod++)
		    {
			cfgchk++;		/* manage plc index */
			if (cfgchk == NUMCMPMTRS + 1)
			{
			    cfgchk = 1;	/* wrap plc index */
			}
			pmod = plcs [line] [cfgchk];

			if ((pmod) &&	/* verify pointer validity prior to use*/
			    (!pmod->is_responding) &&
			    (pmod->was_requested) &&
			    (!pmod->cmd_force_offline))
		    	{
			    /******************************/
			    tisWatchDogPulse (watchdogId [line]);
			    /******************************/

			    /* loopback testing done here! 	*/

			    on_line (line, cfgchk, PosMode);

			    modspolled++;
			    cnt++;
			    if (cnt == MAXCFGCK)
			    {
				break;
			    }
			}
		    }
		}

		/* see if anyone on the line has been responding. */
		/* if not, try to get partner to become slave.    */
		/* Check for no one responding */

		if (!any_responding (line))
		{
		    /******************************/
		    tisWatchDogPulse (watchdogId [line]);
		    /******************************/

		    /* See if it is time to let partner try */

		    this_time = tickGet ();
		    if ((this_time - last_time) > (3 * SLWWINDOW))
		    {   /* #ticks for slave to try */

			resPutLocalState (prestable [line], RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace [line])
			{
			    logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n", pstate, activity);
			}
			/* Give partner access to the hardware */
			clear_rts (line);

			/* Remember the time of this try */
			last_time = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < SLWWINDOW); i += 10)
			{ /* SLWINDOW is the # of ticks for slave to try */

			    /******************************/
			    tisWatchDogPulse (watchdogId [line]);
			    /******************************/
			    taskDelay (10);

		    	    /* If partner picked up let it have control */
			    /* check immediately */

			    activity = check_line_activity (line, 0);
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT)
				|| (activity))
			    {
				resClearCaAnswer (prestable [line]);
				resPutLocalState (prestable [line], RES_SLV);
				lstate = RES_SLV;
				if (modrestrace [line])
				{
				    logMsg ("11] Became RES_SLV  P= %x A= %d \n", pstate, activity);
				}
				/******************************/
				tisWatchDogPulse (watchdogId [line]);
				/******************************/
				taskDelay (60);
				/******************************/
				tisWatchDogPulse (watchdogId [line]);
				/******************************/
				taskDelay (60);
				/******************************/
				tisWatchDogPulse (watchdogId [line]);
				/******************************/
				taskDelay (60);
				break;
			    }
			}
			/* Go Back to being the Master and take control	*/
			/* of the hardware				*/

			if (lstate != RES_SLV)
			{
			    resSetCaAnswer (prestable [line]);
			    resPutLocalState (prestable [line], RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace [line])
			    {
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
			    }
			}
		    }
		}

		/* take plcs off hold status. the plc's data are not to	*/
		/* be held off since now master.			*/

		for (mod = 1; (mod <= NUMCMPMTRS); mod++ )
		{
		    pmod = plcs [line] [mod];
		    if (pmod)		/* verify pointer validity prior to use */
		    {        
			pmod->holdflag = FALSE;
		    }
		}
		if (modspolled == 0)
		{
		   taskDelay (6);
		}
		else
		{
		    taskDelay (2);
		}
	    }
	} /* end infinite task loop */
}

/*
** Try to bring a PLC on line
**
*/

/* this routine only called from MAIN */

static void on_line (unsigned short line, unsigned short mod,
			unsigned short PosMode)
{
	CMPMTR		*pmod;
	unsigned	short i, j;

	pmod = plcs [line] [mod];	
	if (pmod)		/* verify pointer prior to use */
	{
	    if (mltrace [line] == 1)
	    {
		logMsg ( "Bring Online PLC %d\n", mod );
	    }
	    /* Use the loop back function to see if the unit	*/
	    /* is there and responding				*/

	    if (!modloopback (ONERETRY + line, mod, pmod))
	    {
		return; /* if no response, get out */
	    }

	    /* a PLC that has just been brought online must have    */
	    /* it's data marked as being not valid.                 */

	    mark_not_valid (pmod);

	    pmod->is_responding = TRUE;
        }
}

/*							
** Mark all plc data elements as not valid     		
**                                             		
*/                                             	
/* called from on_line and prepresponses      		*/    	

static void mark_not_valid (CMPMTR  *pmod)
{
	unsigned short		i, j;

/*
**      DIGITALS ARE INITIALIZED AS NOT VALID		
*/
	for (i = 0; (i < NUMCMPMTRDIS); i++)
	{
	    pmod->dis [i].data_valid = FALSE;
	}

/*
**      DIGITALS ARE INITIALIZED AS NOT VALID		
*/
	for (i = 0; (i < NUMCMPMTRDOS); i++)
	{
	    pmod->dos [i].data_valid = FALSE;
	}

/*
**      ANALOG INS ARE INITIALIZED AS NOT VALID	
*/
	for (i = 0; (i < NUMCMPMTRAIS); i++)
	{
	    pmod->ais [i].data_valid = FALSE;
	}

/*
**      REGISTERS ARE INITIALIZED AS READ WRITE VALUES		
**      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS 	
**              - READ BACK NOT VALID      	               	
*/
	for (i = 0; (i < NUMCMPMTRAOS); i++)
	{
	    pmod->aos [i].data_valid = FALSE;
	}
}

/*                                                           	
** Scan a Compumotor controller -  get inputs and set outputs as required	
**                                                            	
*/

static	void scan_plc (CMPMTR *pmod, unsigned short line, unsigned short mod)
{

	pmod->tscanpass++;

	if (mltrace [line] == 2)
	{
	    logMsg ( "Scanning Compumotor - %d.\n", mod );
	}

	checkoutputs (line);

	if (readDFS (pmod, line, mod) != CMDDONE)
	{
	    return;
	}

	checkoutputs (line);

	if (readDFX (pmod, line, mod) != CMDDONE)
	{
	    return;
	}

	checkoutputs (line);

	if (readDPA1 (pmod, line, mod) != CMDDONE)
	{
	    return;
	}

	checkoutputs (line);

	if (readDPE1 (pmod, line, mod) != CMDDONE)
	{
	    return;
	}

	checkoutputs (line);

	if (readDVA1 (pmod, line, mod) != CMDDONE)
	{
	    return;
	}

	checkoutputs (line);

	if (readDVS1 (pmod, line, mod) != CMDDONE)
	{
	    return;
	}

	checkoutputs (line);

	if (readR (pmod, line, mod) != CMDDONE)
	{
	    return;
	}

	checkoutputs (line);

	if (pmod->dis [5].last_read < 2)
	{
	    if (readPR (pmod, line, mod) != CMDDONE)
	    {
		return;
	    }
	}

	checkoutputs (line);
}

/*
** checkoutputs
**      checks output que and returns if empty.
**      if there is something on the queue it attempts to process all
**      pending outputs, doing immediate retries. If attempts fail the
**	request is dropped.      
**
*/                                                                                              
/* this routine only called from scan_plc */

static	void checkoutputs (unsigned short line)
{
	OUTQENT		*optr;
	unsigned short	regaddr, regval, link, adapter, coiladdr, conv;
	unsigned long	coilmask, coilval;
	CMPMTR		*pmod;
	double		dblaovalue;
	unsigned short	stringaddr, stringlen;
	unsigned char	*pstringval;
	unsigned short	write_status;

	if (mltrace [line] == 6)
	{
	    logMsg ("Checking Output Queue ...\n"); 
	}
	while ((optr = ogetnextp (line)) != NULLP)
	{
	    if ((optr->otype) == AOUTTYPE)
	    {
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;
		pmod = plcs [link] [adapter];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, adapter))
		    {
			/* if not allocated, try. if can't allocate, get out. */
			return;
		    }
		    pmod = plcs [link] [adapter];
		}
		regaddr = optr->out.aonode.aosignal;
		regval = optr->out.aonode.aovalue;
		dblaovalue = optr->out.aonode.dblaovalue;
		conv = optr->out.aonode.conversion;
		if (mltrace [link] == 7)
		{
		    logMsg("AO IN QUEUE: L=%d, A=%d,       S=%d, Value=%d\n",
			link, adapter, regaddr, regval);
		} 
		if ((!pmod->cmd_force_offline) &&
			(resresponse [link]) &&
			(pmod->is_responding))
		{
		    loopoutmsgs [line]++;
		    write_status = setreg (link, adapter, pmod, regaddr,
					regval, dblaovalue, conv);
		    if (write_status != CMDDONE)
		    {
		        pmod->badoutcnt++;		    
			if (mltrace [link] == 3)
			{
			    logMsg("AO DEQUEUE: Output failed: L=%d, A=%d,       S=%d, Value=%d\n",
				link, adapter, regaddr, regval);
			} 
		    }
		    else
		    {
			if (mltrace [link] == 3)
			{
			    logMsg ("AO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d, Value=%d\n",
				link, adapter, regaddr, regval);
			} 
		    }
		}
	    }
	    else if ((optr->otype) == BOUTTYPE)
	    {
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;
		pmod = plcs [link] [adapter];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, adapter))
		    {
			/* if not allocated, try. if can't allocate, get out. */
			return;
		    }
		    pmod = plcs [link] [adapter];
		}
		coiladdr = optr->out.bonode.bosignal;
		coilval = optr->out.bonode.bovalue;
		coilmask = optr->out.bonode.bomask;
		if (mltrace [link] == 7)
		{
		    logMsg("BO IN QUEUE: L=%d, A=%d,       S=%d, Value=%d\n",
			link, adapter, coiladdr, coilval);
		}

		if ((!pmod->cmd_force_offline) &&
			(resresponse [link]) &&
			(pmod->is_responding))
		{
		    loopoutmsgs [line]++;
		    write_status = setcoil (link, adapter, pmod, coiladdr,
					coilmask, coilval);
		    if (write_status != CMDDONE)
		    {
			pmod->badoutcnt++;
			if (mltrace [link] == 4)
			{
			    logMsg("BO DEQUEUE: Output failed: L=%d, A=%d,       S=%d, Value=%d\n",
				link, adapter, coiladdr, coilval);
			}
		    }
		    else
		    {
			if (mltrace [link] == 4)
			{
			    logMsg("BO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d, Value=%d\n",
				link, adapter, coiladdr, coilval);
			}
		    }
		}
	    }
	    else if ((optr->otype) == SOUTTYPE)
	    {
		link = optr->out.sonode.link;
		adapter = optr->out.sonode.adapter;
		pmod = plcs [link] [adapter];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, adapter))
		    {
			/* if not allocated, try. if can't allocate, get out. */
			return;
		    }
		    pmod = plcs [link] [adapter];
		}
		stringaddr = optr->out.sonode.sosignal;
		stringlen  = optr->out.sonode.solen;
		pstringval = optr->out.sonode.sovalue;
		if (mltrace [line] == 7)
		{
		    logMsg("SO IN QUEUE: L=%d, A=%d,       S=%d\n",
			link, adapter, stringaddr);
		}

		if ((!pmod->cmd_force_offline) &&
			(resresponse [link]) &&
			(pmod->is_responding))
		{
		    loopoutmsgs [line]++;
		    if ((setstring (link, adapter, pmod, stringaddr,
				pstringval, stringlen)) != CMDDONE)
		    {
			pmod->badoutcnt++;
			if (mltrace [link] == 5)
			{
			    logMsg ("SO DEQUEUE: Output failed: L=%d, A=%d,       S=%d\n",
				link,adapter,stringaddr);
			}
		    }
		    else
		    {
			if (mltrace [link] == 5)
			{
			    logMsg ("SO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d\n",
				link, adapter, stringaddr);
			}
		    }
		}
	    }
	    oreleasefull (line);     /* release the output que entry */
	}
}

/*
**      AIDRIVER
**
**      This routines main purpose is to return the analog input value for the
**      specified module. For a module value
**      a (-1) will be returned if there is no valid data ready.
**
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, short *pvalue,
		unsigned short conversion, unsigned char *resname)
{
	CMPMTR		*pmod;
	typedef struct
	{
	    short	pval0;
	    short	pval1;
	    short	pval2;
	    short	pval3;
	} DPVAL;

	union
	{
	    double	pval;
	    DPVAL	dpval;
	} dblval;
		    
	if (link > CMPMTRLINES)
	{
	    if (trace[link] & CONFIGURATIONTRACE)
	    {
		logMsg ("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if (adapter > NUMCMPMTRS)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if ((card != CMPMTRAIS) && (card != PSEUDO))
	{
	    if (trace[link] & CONFIGURATIONTRACE)
	    {
		logMsg ("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		/* if not allocated, try. if can't allocate, get out. */
		return (-1);
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 5: /* Output Messages */
		*pvalue = pmod->no_dataout_msgs & 0x7fff;
		break;

	    case 6: /* Input Messages */
		*pvalue = pmod->no_datain_msgs & 0x7fff;
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = pmod->no_rxnoresp & 0x7fff;
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = pmod->no_txnoresp & 0x7fff;
		break;

	    case 10: /* Message Retries */
		*pvalue = pmod->no_retries & 0x7fff;
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = pmod->no_rxhwerrs & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = pmod->no_txhwerrs & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*pvalue = pmod->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = pmod->badoutcnt & 0x7fff;
		break;

	    default:
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg ("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    return (0);
	}

	if (card == CMPMTRAIS)
	{
	    if (signal > MAXAINO)
	    {
		if (trace[link] & CONFIGURATIONTRACE)
		{
		    logMsg ("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d, min=%d\n",
			pointname, link, adapter, card, signal, MAXAINO, MINAINO);
		}
		return (-1);
	    }

	    if (resname != 0)
	    { 
		register_resource (link, pmod, resname, pointname);
	    }

	    pmod->was_requested = TRUE;

	    pmod->ais [signal].was_requested = TRUE;

	    if (!resresponse [link])
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg("AIDRIVER: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (pmod->holdflag)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("AIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
		}
		return (-2);
	    }
	    if (!pmod->is_responding)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("AIDRIVER: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (!pmod->ais [signal].data_valid)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg("AIDRIVER: Data Not Valid(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
		}
		return (-1);
	    }

	    dblval.pval = pmod->ais [signal].aivals;

	    taskLock ();
	    pvalue [0] = dblval.dpval.pval0;
	    pvalue [1] = dblval.dpval.pval1;
	    pvalue [2] = dblval.dpval.pval2;
	    pvalue [3] = dblval.dpval.pval3;
	    taskUnlock ();

	    if (mltrace [link] == 8)
	    {
		logMsg ("AIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
			pointname, link, adapter, card, signal,
			pvalue [0], pvalue [1]);
	    }
	    return (0);
	}
	return (-1);
}

/*
**	AODRIVER
**
**	This routines main purpose is to set requested analog outputs to the
**	specified module.
*/                                                                            	
/* this routine not called from within this driver */


int AODRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, double dvalue,
		unsigned short value, unsigned short conversion,
		unsigned char *resname)

{
	CMPMTR		*pmod;
	OUTQENT		*oqp;

	if (link > CMPMTRLINES)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}
	if (adapter > NUMCMPMTRS)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("AODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}
	if ((card != CMPMTRAOS) && (card != PSEUDO))
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		/* if not allocated, try. if can't allocate, get out. */
		return (-1);
	    }
	    pmod = plcs [link] [adapter];
	}
	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats (pmod);
		}
		break;

	    case 16: /* Force the PLC online/offline */
		pmod->cmd_force_offline = (value != 0);
		if (value != 0)
		{
		    /* only required when asserting cmd_force_offline */
		    pmod->is_responding = FALSE;
		}
		break;

	    default:
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
		}
		return (-1);
	    }
	    return (0);
	}

	if (signal > MAXAONO)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg("AODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}
	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}

	pmod->was_requested = TRUE;

	pmod->aos [signal].was_requested = TRUE;

	if (!resresponse [link])
	{
	    if (trace [link] & CALLREJECTTRACE)
	    {
		logMsg ("AODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    if (trace [link] & CALLREJECTTRACE)
	    {
		logMsg ("AODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
	    if (trace [link] & RUNTIMEERRORTRACE)
	    {
		logMsg ("AODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    pmod->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;
	oqp->out.aonode.aovalue = value;
	oqp->out.aonode.dblaovalue = dvalue;
	oqp->out.aonode.conversion = conversion;

	omarkfull (link);		/* Mark this entry as ready for output */

	if (mltrace [link] == 3)
	{
	    logMsg ("AODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	}
	return (0);
}

/*
**	AOREAD
**
**	This routines main purpose is to return the value last read back
**      from the analog output hardware. This is used to initialize analog   	
**	outputs.
*/
/* this routine not called from within this driver */

int AOREAD (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal,
		unsigned short *pvalue, unsigned short conversion,
		unsigned char *resname)
{
	CMPMTR		*pmod;
	
	if (link > CMPMTRLINES)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if (adapter > NUMCMPMTRS)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("AOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if ((card != CMPMTRAOS) && (card != PSEUDO))
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		/* if not allocated, try. if can't allocate, get out. */
		return (-1);
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 15: /* read statistics command value */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Read the current PLC offline command status */
		*pvalue = pmod->cmd_force_offline;
		break;

	    default:
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    return (0);
	}

	if (card == CMPMTRAOS)
	{
	    if (signal > MAXAONO)
	    {
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg ("AOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
		}
		return (-1);
	    }

	    if (resname != 0)
	    { 
		register_resource (link, pmod, resname, pointname);
	    }

	    pmod->was_requested = TRUE;

	    /* as soon as the address is confirmed as valid, set requested bits. */

	    pmod->aos [signal].was_requested = TRUE;
	    if (!resresponse [link])
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg("AOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (pmod->holdflag)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("AOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-2);
	    }
	    if (!pmod->is_responding)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    *pvalue = pmod->aos [signal].ioregs;

	    if (mltrace [link] == 8)
	    {
		logMsg ("AOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
			pointname, link, adapter, card, signal,
			pvalue [0], pvalue [1]);
	    }
	    return (0);
	}
	return(-1);
}

/*
**	BIDRIVER
**
**	The main purpose of this routine is to return the request digital input
**	value(s) from the requested card. This routine will return a (-1) if the
**	requested module is the wrong type or the data is not yet valid.
**
*/
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, unsigned long mask,
		unsigned long *pvalue, unsigned char *resname)
{
	CMPMTR 		*pmod;
	unsigned short	blkix;
	unsigned long	tvalue;

	if (link > CMPMTRLINES)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if (adapter > NUMCMPMTRS)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if ((card != CMPMTRDIS) && (card != CMPMTRDOS) && (card != PSEUDO))
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		/* if not allocated, try. if can't allocate, get out. */
		return (-1);
	    }
	    pmod = plcs [link] [adapter];
	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    default:
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg ("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    return (0);
	}

	tvalue = 0;

	if (card == CMPMTRDIS)
	{
	    if (signal > MAXDINO)
	    {
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg ("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (resname != 0)
	    { 
		register_resource (link, pmod, resname, pointname);
	    }

	    pmod->was_requested = TRUE;

	    blkix = signal / BITBLOCK;

	    pmod->dis [blkix].was_requested = TRUE;
	    if (!resresponse [link])
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (pmod->holdflag)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-2);
	    }
	    if (!pmod->is_responding)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (!pmod->dis [blkix].data_valid)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    tvalue = pmod->dis [blkix].last_read & mask;

	    *pvalue = tvalue & mask;

	    if (mltrace [link] == 8)
	    {
		logMsg ("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
			pointname, link, adapter, card, signal, pvalue);
	    }
	    return (0);
	}

	tvalue = 0;
	if (card == CMPMTRDOS)
	{
	    if (signal > MAXDONO)
	    {
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg ("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (resname != 0)
	    { 
		register_resource (link, pmod, resname, pointname);
	    }

	    pmod->was_requested = TRUE;

	    blkix = signal / BITBLOCK;

	    pmod->dos [blkix].was_requested = TRUE;
	    if (!resresponse [link])
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (pmod->holdflag)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
				 pointname, link, adapter, card, signal);
		}
		return (-2);
	    }
	    if (!pmod->is_responding)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (!pmod->dos [blkix].data_valid)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    tvalue = pmod->dos [blkix].last_read & mask;
	    *pvalue = tvalue & mask;
	    if (mltrace [link] == 9)
	    {
		logMsg ("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
			pointname, link, adapter, card, signal, pvalue);
	    }
	    return (0);
	}
	return (-1);
}

/*
**	BODRIVER
**
**	The main purpose of this routine is to set the request digital output
**	value(s) on the requested card. This routine will return a (-1) if the
**      requested module is the wrong type or not configured yet.
**
*/
/* this routine not called from within this driver */

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, unsigned long value,
		unsigned long mask, unsigned char *resname)
{
	CMPMTR		*pmod;
	OUTQENT		*oqp;
	unsigned short	blkix;

	if (link > CMPMTRLINES)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}
	if (adapter > NUMCMPMTRS)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}
	if ((card != CMPMTRDOS) && (card != PSEUDO))
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		/* if not allocated, try. if can't allocate, get out. */
		return (-1);
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == PSEUDO)
	{
	    switch (signal & 0x1f)
	    {
	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats (pmod);
		}
		break;

	    case 16: /* Force the PLC offline */
		pmod->cmd_force_offline = (value != 0);
		if (value != 0)
		{
		    /* only required when asserting cmd_force_offline */
		    pmod->is_responding = FALSE;
		}
		break;

	    default:
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg ("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
				pointname, link, adapter, card, signal, value);
		}
		return (-1);
	    }
	    return (0);
	}

	if (signal > MAXDONO)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}

	pmod->was_requested = TRUE;

	blkix = signal / BITBLOCK;

	pmod->dos [blkix].was_requested = TRUE;

	if (!resresponse[link])
	{
	    if (trace [link] & CALLREJECTTRACE)
	    {
		logMsg ("BODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    if (trace [link] & CALLREJECTTRACE)
	    {
		logMsg ("BODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
	    if (trace [link] & RUNTIMEERRORTRACE)
	    {
                logMsg ("BODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	    }
	    pmod->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bovalue = value;

	omarkfull (link);		/* Mark this entry as ready for output */

	if (mltrace [link] == 4)
	{
	    logMsg ("BODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
			pointname, link, adapter, card, signal, value);
	}
	return (0);
}

/*
**	BOREAD
**
**	This routines main purpose is to return the value last read back      	
**	from the digital output hardware. This is used to initialize digital
**	outputs. This will return a (-1) if the module is the wrong type or
**	the data is not yet valid
*/
/* this routine not called from within this driver */


int BOREAD (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, unsigned long *pvalue,
		unsigned long mask, unsigned char *resname)

{
	CMPMTR		*pmod;
	unsigned short	blkix;
	unsigned long	tvalue;

	if (link > CMPMTRLINES)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if (adapter > NUMCMPMTRS)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if ((card != CMPMTRDOS) && (card != PSEUDO))
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		/* if not allocated, try. if can't allocate, get out. */
		return (-1);
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    default:
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg ("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    return (0);
	}

	if (signal > MAXDONO)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
			pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}

	if (resname != 0)
	{
	     register_resource (link, pmod, resname, pointname);
	}

	pmod->was_requested = TRUE;

	blkix = signal / BITBLOCK;
	tvalue = 0;

	pmod->dos [blkix].was_requested = TRUE;
	if (!resresponse [link])
	{
	    if (trace [link] & CALLREJECTTRACE)
	    {
		logMsg ("BOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if (pmod->holdflag)
	{
	    if (trace [link] & CALLREJECTTRACE)
	    {
		logMsg ("BOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-2);
	}
	if (!pmod->is_responding)
	{
	    if (trace [link] & CALLREJECTTRACE)
	    {
		logMsg ("BOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	tvalue = pmod->dos [blkix].last_read & mask;
	*pvalue = tvalue & mask;
	if (mltrace [link] == 9)
	{
	    logMsg ("BOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
			pointname, link, adapter, card, signal, pvalue);
	}
	return (0);
}

/*   
**	SIDRIVER    
**
**	This routines main purpose is to return the analog input value for the
**	specified module. For a module value   	
**	a (-1) will be returned if there is no valid data ready.  	
**   	
*/

int SIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, unsigned char *pvalue,
		unsigned short len, unsigned char *resname)
{
	CMPMTR		*pmod;
	int		i;

	if (link > CMPMTRLINES)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("SIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if (adapter > NUMCMPMTRS)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("SIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if ((card != CMPMTRSIN) && (card != CMPMTRSOT))
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg("SIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		/* if not allocated, try. if can't allocate, get out. */
		return (-1);
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == CMPMTRSIN)
	{
	    /* ensure string contained entirely within the address	*/
	    /* space of the allocated region				*/

	    if (signal >= MAXSINO)
	    {
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg ("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (resname != 0)
	    { 
		register_resource (link, pmod, resname, pointname);
	    }

	    pmod->was_requested = TRUE;

	    pmod->sin [signal].was_requested = TRUE;

	    if (!resresponse [link])
            {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("SIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (pmod->holdflag)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("SIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
					pointname, link, adapter, card, signal);
		}
		return (-2);
            }
	    if (!pmod->is_responding)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("SIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (!pmod->sin [signal].data_valid)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
					pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (strncmp (pvalue, pmod->sin [signal].last_response, STRINGMSGLEN - 1))
	    {
		for (i = 0; i < STRINGMSGLEN; i++)
		{
		    pvalue [i] = 0;
		}
		strncpy (pvalue, pmod->sin [signal].last_response, STRINGMSGLEN - 1);
	    }
	    return (0);
	}
	if (card == CMPMTRSOT)
	{
	    /* ensure string contained entirely within the address	*/
	    /* space of the allocated region				*/

	    if (signal > MAXSONO)
	    {
		if (trace [link] & CONFIGURATIONTRACE)
		{
		    logMsg ("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (resname != 0)
	    { 
		register_resource (link, pmod, resname, pointname);
	    }

	    pmod->was_requested = TRUE;

	    if (!resresponse [link])
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("SIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
					pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (pmod->holdflag)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("SIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
					pointname, link, adapter, card, signal);
		}
		return (-2);
	    }
	    if (!pmod->is_responding)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg ("SIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (!pmod->aos [signal].data_valid)
	    {
		if (trace [link] & CALLREJECTTRACE)
		{
		    logMsg("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
		}
		return (-1);
	    }
	    if (strncmp (pvalue, pmod->sot [signal].last_command, STRINGMSGLEN - 1))
	    {
		for (i = 0; i < STRINGMSGLEN; i++)
		{
		    pvalue [i] = 0;
		}
		strncpy (pvalue, pmod->sot [signal].last_command, STRINGMSGLEN - 1);
	    }
	    return (0);
	}
	return (-1);
}

/*
**	SODRIVER
**
**	This routines main purpose is to set requested string outputs to the
**	specified module via the output buffer.
*/

int SODRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, unsigned char *value,
		unsigned short len, unsigned char *resname)
{
	CMPMTR		*pmod;
	OUTQENT		*oqp;
	unsigned int	i;

	if (link > CMPMTRLINES)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("SODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if (adapter > NUMCMPMTRS)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("SODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}
	if (card != CMPMTRSOT)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("SODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		/* if not allocated, try. if can't allocate, get out. */
		return (-1);
	    }
	    pmod = plcs [link] [adapter];
	}

	if (signal > MAXSONO)
	{
	    if (trace [link] & CONFIGURATIONTRACE)
	    {
		logMsg ("SODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}

	pmod->was_requested = TRUE;

	pmod->sot [signal].was_requested = TRUE; /* notice we only set one here */

	if (!resresponse [link])
	{
	    if (trace [link] & CALLREJECTTRACE)
	    {
		logMsg ("SODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    if (trace [link] & CALLREJECTTRACE)
	    {
		logMsg ("SODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
	    if (trace [link] & RUNTIMEERRORTRACE)
	    {
		logMsg ("SODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d\n",
				pointname, link, adapter, card, signal);
	    }
	    pmod->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = SOUTTYPE;
	oqp->out.sonode.link = link;
	oqp->out.sonode.adapter = adapter;
	oqp->out.sonode.card = card;
	oqp->out.sonode.sosignal = signal;
	oqp->out.sonode.solen = len;

	/* Move in the output string (strcpy not used because */
	/*  string content could contain terminators)         */

	for (i = 0 ;(i < STRINGMSGLEN) ; i++)
	{
	    oqp->out.sonode.sovalue [i] = value [i];
	}

	omarkfull (link);		/* Mark this entry as ready for output */

	if (mltrace [link] == 5)
	{
	    logMsg ("SODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%s\n",
			pointname, link, adapter, card, signal, value);
	}
	return (0);
}

/*
** register_resource
**
**	This routine is used to initialize the resource pointers
**	If this is the first time the resource for this line is being
**	referenced the pointer to the resource table entry will be set
**	and the resource name will be saved. If the resource name has
**	already been set, this routine will verify that all other points
**	for this driver are using the same resource name.
**
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,
			    BOREAD, SIDRIVER, and SODRIVER.
*/                               	

static void  register_resource (unsigned short link, CMPMTR *pmod,
                                unsigned char *resname, char *pointname)
{
	if (resnames [link] [0] == 0) /* This is the first reference */
	{
	    if (resGetByName (resname, &prestable [link]) != RES_OK)
	    {
		logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
				pointname,
				resname );
	    }
	    else
	    {
		strcpy (resnames [link], resname);
	    }
	}
	else
	{
	    if (strcmp (resnames [link], resname) != 0)
	    {
		logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
				resnames[link],
				pointname,
				resname );
	    }
	}
}

/*
**	Initialize the Queue                                        		
*/
/* not called from within this driver */

static	void outqueinit (unsigned short line)
{
	oq [line]->ooutix = oq [line]->oinix = 0;
}


/*                                                                     		
**	ogetempty - get the next available slot on the output list
*/
/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
{
	if (((oq [line]->oinix + 1) % OUTQSIZE) != oq [line]->ooutix)
	{
	    return (&oq [line]->outque[oq [line]->oinix]);
	}
	if (mltrace [line] == 11)
	{
	    logMsg ( "Output Queue Full\n");
	}
	return (NULLP);
}


/*                                                                    		
** omarkfull                                                          		
**      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
{
	oq [line]->oinix = ((oq [line]->oinix + 1) % OUTQSIZE);
}


/*                                                                      	
**  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
{
	if (oq [line]->ooutix != oq [line]->oinix)
	{
	    return (&oq [line]->outque[oq [line]->ooutix]);
	}
	else
	{
	    return (NULLP);
	}
}


/*                                                       	               	
** oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
{
	if (oq [line]->ooutix == oq [line]->oinix)
	{
	    return;
	}
	oq [line]->ooutix = ((oq [line]->ooutix + 1) % OUTQSIZE);
}

/*                                                          			
**      link_status                                                           	
**                                                                            	
**      The purpose of this routine is to print out the state of each of the  	
**      analog devices lines and the statistics gathered about them.         	
**                                                                           	
*/
/* not called from within this driver */

static	void link_status (unsigned short line)
{
	if (line > CMPMTRLINES - 1)
	{
	    return;
	}
}

/*                                                                             	
**                                                                              
**	allocate_plc                                                            
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	plc data structure. If not successful, a console error message is  	
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_plc (unsigned short line, unsigned short plc )
{
	plcs [line] [plc] = (CMPMTR *) calloc (1, (sizeof (CMPMTR)));
	if (!plcs [line] [plc])
	{
	    logMsg ("Unable to allocate memory");
	    printf (" for CMPMTR data structure on line %d, plc %d\n",line ,plc);
	    return(FALSE);
	}
	else
	{
	    logMsg ("Allocated memory for CMPMTR data structure on line %d, plc %d\n",line ,plc);
	    init_plc_tab (line, plc);	     /*	initialize the data structures. */
	}

	return (TRUE);
}


/*                                                                   		
**      start_rx                                                        	
**                                                                     	 	
**      The purpose of this routine is to initialize a line table        	
**      for receive and to enable the receiver.                           	
**                                                                        	
*/
/* only called from msgxfer */


static	void start_rx (unsigned short line, SEMAPHORE *semid,
			unsigned short *pstatus )

{
	RXLINE		*rxp;

	rxp = rxlinetab [line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	rxp->rxstate = RXADRST;
	rxp->rxmsglen = rxp->rxmsglenexpected;
}

/*
**	stop_rx                                                              	
**
**	The purpose of this routine is to initialize a line table
**	for receive and to disable the receiver.
**
*/
/* only called from msgxfer */


static	void stop_rx (unsigned short line )

{
	RXLINE		*rxp;

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
}

/*                                                                        	
**      rx_int_proc                                                        	
**                                                                         	
**      The purpose of this routine is to process a receive character interrupt	
**      for a given line.                                                     	
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static	void rx_int_proc (unsigned short line )

{
	unsigned char	rxchar;
	unsigned short	rxstat;
	unsigned short	rx_err_mask;
	RXLINE		*rxp;

	read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);

	linestats [line].RXintcount++;

	rxp = rxlinetab [line];

	/* Something is sending in data. */

	line_activity [line] = TRUE;

	if (rxp->rxstate == RXIGNORE)
	{
	    return;
	}

        /* no matter what the state, errors cause a logical reset	*/
	/* of the message processing					*/

	if ((rxstat & rx_err_mask) != 0)
	{
	    /* if comm goes bad, assume it was garbage,	*/
	    /* and go wait for the good stuff.		*/

	    rxp->rxstate = RXADRST; 
	    rxp->rxix = 0;           /* reset the buffer index/counter            */
	    rxp->rxmsglen = rxp->rxmsglenexpected; /* reload decrementing counter.*/
	    return;
	}

	/* store the character in the buffer and bump the index.*/

	rxp->rxbuf [rxp->rxix++] = rxchar;

	if ((rxchar == '>') || (rxchar == LF))
	{
	    rxp->rxbuf [rxp->rxix] = 0;
	    rxp->rxstate = RXIGNORE;
	    *(rxp->status) = RXGOOD;
	    semGive (rxp->semid);
	}
	return;
}

/*                                                                             
**      check_line_activity                                                     
**                                                                             	
*/
/* only called from MAIN  */


static	int check_line_activity (unsigned short line, unsigned short predelay)

{
	RXLINE		*rxp;
	long		thistime;
	short		status;

	if (predelay != 0)
	{
	    taskDelay (predelay);
	}
	thistime = tickGet ();
	if ((thistime - activity_time [line]) < ACTIVITYTIME)
	{
	    return (lastactivity [line] || (line_activity [line]));
	}
	lastactivity [line] = status = line_activity [line];
	line_activity [line] = FALSE;
	activity_time [line] = thistime;
	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;

	return (status);
}

/*                                                                         	
**      start_tx                                                            	
**                                                                          	
**      The purpose of this routine is to initialize a line table           	
**      for send and to enable the transmitter.                              	
**                                                                            	
*/
/* only called from msgxfer  */


static	void start_tx (unsigned short line, SEMAPHORE *semid,
			unsigned short *pstatus )
{

	TXLINE		*txp;

	disable_tx_ints (line);
	txp = txlinetab [line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */

	enable_tx_ints (line);
}

/*
**      stop_tx                                                                	
**                                                                             	
**      The purpose of this routine is to initialize a line table              	
**      for receive and to disable the receiver.                               	
**                                                                             	
*/
/* only called from msgxfer  */


static	void stop_tx (unsigned short line )

{
	TXLINE		*txp;

	disable_tx_ints (line);
	txp = txlinetab [line];
	txp->txdisable = TRUE;
}

/*                                                                           	
**      tx_int_proc                                                           	
**                                                                            	
**      The purpose of this routine is to process a transmit character interrupt
**      for a given line.                                                  	
**                                                                         	
*/
/* only called from MAIN  */


static	void tx_int_proc (unsigned short line )

{
	char		txchar;
	unsigned short	txstat;
	unsigned short	tx_err_mask;
	TXLINE		*txp;

	linestats [line].TXintcount++;

	txp = txlinetab [line];
	if (txp->txdisable)
	{
	    return;
	}
	if (txp->txix == txp->txmsglen)
	{
	    txp->txdisable = TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive (txp->semid);
	    return;
	}
	else
	{
	    txchar = txp->txbuf [txp->txix++];
	    write_tx_hw (line, txchar, &txstat, &tx_err_mask);
	    if ((txstat & tx_err_mask) != 0 )
	    {
	 	txp->txdisable = TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive (txp->semid);
	        return;
	    }
	}

	if (txp->txix >= MAXTXMSG)
	{
	    txp->txdisable = TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive (txp->semid);
	    return;
	}
}


/*                                                                         	
**      msgxfer                                                              	
**                                                                           	
**      The purpose of this routine is to transmit a buffer to the         	
**      analog devices I/O and to await a response. The transmit and receive	
**      buffers are in their respective line tables. This routine will retry 	
**      the message up to a maximum number of times or until a response      	
**      is received with a proper checksum.                                  	
**              returns         XFERGOOD if response received                	
**                              XFERBAD  if no good response is received     	
**                                                                           	
*/

static	unsigned short  msgxfer (unsigned short fline, unsigned short resplen,
					CMPMTR *pmod, int opt_timeout)
{
	unsigned short	retry, txstatus, rxstatus, txlen, rxlen, line, ix, i;
	RXLINE		*rxp;
	TXLINE		*txp;
	unsigned char	csums [2];
	unsigned short	oldrxix;
	unsigned int	tick1, tick2, tick3, tick4;
	unsigned int	delta40, delta01, delta12, delta23, delta34;
	unsigned long	msgstart;

	msgstart = tickGet ();

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

	delta40 = delta01 = delta12 = delta23 = delta34 = 0;

	rxp = rxlinetab [line];
	txp = txlinetab [line];

	for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++)
	{
	    linestats [line].msgxfercount++;
	    loopmsgs [line]++;

	    /* time since end of last msgxfer */

	    tick [line] [0] = tickGet ();
	    delta40 = (tick [line] [0] - tick [line] [4]);

	    if (intermsgdelay [line] != 0)
	    {
		taskDelay (intermsgdelay [line]);
	    }
	    set_rts (line);

	    if (pretxdelay [line] != 0)
	    {
		taskDelay (pretxdelay [line]);
	    }

	    txstatus = IO_TIMEOUT;
	    rxstatus = IO_TIMEOUT;

	    semTake (semids [line] [TXSEM], NO_WAIT);
	    if (resplen != NORESP)
	    {
		semTake (semids [line] [RXSEM], NO_WAIT);
	    }

	    txlen = txp->txmsglen;

	    /******************************/
	    tisWatchDogPulse (watchdogId [line]);
	    /******************************/

	    if ((trace [line] & ALLTRAFFICTRACE))
	    {
		printf ("TX:");
		printf (" %s", txp->txbuf);
		printf ("\n");
	    }

            /* time from entering msgxfer to starting transmission.	*/
	    /* (including delays & diags)				*/ 

	    tick [line] [1] = tickGet ();
	    delta01 = (tick [line] [1] - tick [line] [0]);

	    if (resplen != NORESP)
	    {
		start_rx (line, semids [line] [RXSEM], &rxstatus);
	    }

	    /* this fires off the transmission. */

	    start_tx (line, semids [line] [TXSEM], &txstatus);

	    if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
	    {
		txstatus = IO_TIMEOUT;
	    }

	    /******************************/
	    tisWatchDogPulse (watchdogId [line]);
	    /******************************/

	    /* time to transmit message. */

	    tick [line] [2] = tickGet ();
	    delta12 = (tick [line] [2] - tick [line] [1]);

	    stop_tx (line);

	    if (posttxdelay [line] != 0)
	    {
		taskDelay (posttxdelay [line]);
	    }

	    if (halfduplex [line] == TRUE)
	    {
	       clear_rts (line);
	    }
	    /* intermessage wait time. */

	    tick [line] [3] = tickGet ();
	    delta23 = (tick [line] [3] - tick [line] [2]);

	    if (txstatus == TXGOOD)
	    {
		/******************************/
		tisWatchDogPulse (watchdogId [line]);
		/******************************/

		if (resplen == NORESP)
		{
		    if ((trace [line] & ALLTRAFFICTRACE))
		    {
			printf ("RX: NONE EXPECTED\n");
		    }
		    return (XFERGOOD);
		}

		/* make it pass through timeout loop at least once */

		oldrxix = -1;
		while ((semTake (semids [line] [RXSEM], (opt_timeout ? opt_timeout : (int) (RXTIMEOUT)))) == ERROR)
		{
		    /******************************/
		    tisWatchDogPulse (watchdogId [line]);
		    /******************************/

		    if (oldrxix == rxp->rxix)
		    {
			if (modtrace [line])
			{
			    logMsg ("RX timeout\n");
			}
			rxstatus = IO_TIMEOUT;
			break;
		    }
		    else
		    {
			if ((modtrace [line]) || (mltrace [line] == 12))
			{
			     logMsg ("waiting...");
			}
		    }
		    oldrxix = rxp->rxix;
		}
		stop_rx (line);

		/* time to receive message. */

		tick [line] [4] = tickGet();
		delta34 = (tick [line] [4] - tick [line] [3]);

		rxlen = rxp->rxix;
		if (rxstatus == RXGOOD)
		{
		    /******************************/
		    tisWatchDogPulse (watchdogId [line]);
		    /******************************/

		    if ((trace [line] & ALLTRAFFICTRACE))
		    {
			printf ("RX: %s\n", rxp->rxbuf);
		    }
		    pmod->msgs++;
		    pmod->responsetime += (tickGet () - msgstart);
		    return (XFERGOOD);
		}
		else if (rxstatus == IO_TIMEOUT)
		{
		    /******************************/
		    tisWatchDogPulse (watchdogId [line]);
		    /******************************/

		    if (modtrace [line])
		    {
			logMsg ("Receive Timeout... Length: %d\n", rxlen);
		    }
		    if ((trace [line] & ALLTRAFFICTRACE) &&
			((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
			((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
		    {
			printf ("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
		    }
		    pmod->no_rxnoresp++;
		}
		else
		{
		    /******************************/
		    tisWatchDogPulse (watchdogId [line]);
		    /******************************/

		    if (modtrace [line])
		    {
			logMsg ("Receive Error\n");
		    }
		    if (modtrace [line])
		    {
			logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
				 rxp->rxbuf[100],
				 rxp->rxbuf[101],
				 rxp->rxix);
		    }
		    pmod->no_rxhwerrs++;
		}
	    }
	    else if (txstatus == IO_TIMEOUT)
	    {
		/******************************/
		tisWatchDogPulse (watchdogId [line]);
		/******************************/

		if (modtrace [line])
 		{
		    logMsg ("Transmit Timeout\n");
		}
		if ((trace [line] & ALLTRAFFICTRACE) &&
			((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
			((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
		{
		    printf ("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
		}
		pmod->no_txnoresp++;
	    }
	    else
	    {
		if (modtrace [line])
		{
		    logMsg ("Transmit Error\n");
		}
		pmod->no_txhwerrs++;
	    }
	    if (retry != MAXRETRYS)
	    {
		pmod->no_retries++;
	    }
	}
	if (modtrace [line])
	{
	    logMsg ("Xfer Bad\n");
	}
	return (XFERBAD);
}

/*
**      init_plc_tab
**
**      The purpose of this routine is to initialize the line tables for the
**      analog devices I/O
**
*/
/* only called from allocate_plc  */


static	void init_plc_tab (unsigned short line, unsigned short mod)

{
	CMPMTR		*pmod;

	pmod = plcs [line] [mod];
	if (!pmod)
	{
		return;
	}
	pmod->is_responding = FALSE;
	pmod->holdflag = FALSE;
	pmod->was_requested = FALSE;
	pmod->cmd_force_offline = FALSE;

	initplc (pmod);
	initstats (pmod);

	/* Initialize this tasks semaphore*/

	semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
	semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
}
/*
** Cold Init a PLC
**
*/
/* only called from init_line_tabs  */


static void initplc (CMPMTR  *pmod)

{

	unsigned short	i,j;

                                                                	
/*                                                              	
**      COILS ARE INITIALIZED AS READ WRITE VALUES              	
**      WRITES ARE TREATED BY INDIVIDUAL BITS NOT GROUPS       		
**              - NOT REQUESTED                                		
**              - READ BACK NOT VALID                             	
**              - NO NEW VALUES TO GO                                	
*/

	for (i = 0; (i < NUMCMPMTRDOS); i++)
	{
	    pmod->dos [i].was_requested = FALSE;
	    pmod->dos [i].data_valid = FALSE;
	    pmod->dos [i].last_read = 0;
	}

/*                                                                 	
**      DIGITALS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID		
*/
	for (i = 0; (i < NUMCMPMTRDIS); i++)
	{
	    pmod->dis [i].was_requested = FALSE;
	    pmod->dis [i].data_valid = FALSE;
	}

/*                                                                 	
**      ANALOG INS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID    	
*/
	for (i = 0; (i < NUMCMPMTRAIS); i++)
	{
	    pmod->ais [i].was_requested = FALSE;
	    pmod->ais [i].data_valid = FALSE;
	}

/*                                                             		
**      REGISTERS ARE INITIALIZED AS READ WRITE VALUES             	
**      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS      	
**              - NOT REQUESTED                                    	
**              - READ BACK NOT VALID                              	
**              - NO NEW VALUES TO GO                               	
*/                                                                  	
	for (i = 0; (i < NUMCMPMTRAOS); i++)
	{
	    pmod->aos [i].was_requested = FALSE;
	    pmod->aos [i].data_valid = FALSE;
	}
/*                                                                 	
**      STRING INS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID    	
*/
	for (i = 0; (i < NUMCMPMTRSIN); i++)
	{
	    pmod->sin [i].was_requested = FALSE;
	    pmod->sin [i].data_valid = FALSE;
	}
/*                                                                 	
**      STRING OUTS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID    	
*/
	for (i = 0; (i < NUMCMPMTRSOT); i++)
	{
	    pmod->sot [i].was_requested = FALSE;
	    pmod->sot [i].data_valid = FALSE;
	}
}


/*                                                            		
**                                                              	
** initialize the statistics for a Compumotor Controller          	
**                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_line_tabs  */


static	void initstats (CMPMTR *pmod)

{
	pmod->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
	pmod->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
	pmod->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
	pmod->no_txnoresp = 0;      /* 8  Count No Responses 		*/
	pmod->no_retries = 0;       /* 10 Count Retries 		*/          	
	pmod->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
	pmod->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
	pmod->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
	pmod->badoutcnt = 0;	    /* 17 Count failed output commands 	*/

	pmod->tscanpass = 0;        /* plc scan pass counter            */
	pmod->msgs = 0;             /* good response message counts     */
	pmod->responsetime = 0;     /* total wait time for good messages*/
}

/*                                                                       
**	modloopback                                                      
**                                                                       
*/                                                                          	
static	unsigned short modloopback (unsigned short line, unsigned short mod,
			 CMPMTR *pmod)
{
	TXLINE 		*txp;
	RXLINE		*rxp;
	long		buildreg;
	unsigned short  i = 0;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Send the Kill Command */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'K';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	pmod->no_datain_msgs++;

	/* Send out the message */

	rxp->rxprompt = TRUE;

	msgxfer (line, NORESP, pmod, 15);

	taskDelay (200);

	i = 0;

	/* Disable interactive mode */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = 'I';
	txp->txbuf [i++] = '1';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	pmod->no_datain_msgs++;

	/* Send out the message */

	msgxfer (line, NORESP, pmod, 15);

	/* Enable communications interface */

	taskDelay (60);

	i = 0;

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'E';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	pmod->no_datain_msgs++;

	/* Send out the message */

	msgxfer (line, NORESP, pmod, 15);

	taskDelay (60);

	i = 0;

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'R';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	pmod->no_datain_msgs++;

	/* Send out the message */

	if (msgxfer ((ONERETRY | line), FIXEDRESP, pmod, 15) == XFERBAD)
	{
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (FALSE);
	    }
	}

	switch (rxp->rxbuf [4])
	{
	case 'R':
	case 'S':
	case 'B':
	case 'C':
	case 'Z':
	    break;

	default:
	    return (FALSE);
	}
	/* The unit is responding correctly, so we have to initialize it */

	/* RS-232C Echo must be enabled for daisey chain configuration */

	taskDelay (60);

	i = 0;

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = 'A';
	txp->txbuf [i++] = '0';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	pmod->no_datain_msgs++;

	/* Send out the message */

	msgxfer (line, NORESP, pmod, 15);

	/* Disable message mode */

	taskDelay (60);

	i = 0;

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = 'N';
	txp->txbuf [i++] = '0';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	pmod->no_datain_msgs++;

	/* Send out the message */

	msgxfer (line, NORESP, pmod, 15);

	/* Set Indexer to Encoder Step Mode */

	taskDelay (60);

	i = 0;

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'F';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = 'B';
	txp->txbuf [i++] = '1';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	pmod->no_datain_msgs++;

	/* Send out the message */

	msgxfer (line, NORESP, pmod, 15);

	/* Enable Position Maintenance */

	taskDelay (60);

	i = 0;

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'F';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = 'C';
	txp->txbuf [i++] = '0';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	pmod->no_datain_msgs++;

	/* Send out the message */

	msgxfer (line, NORESP, pmod, 15);

	/* Disable following mode */

	taskDelay (60);

	i = 0;

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'F';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = 'I';
	txp->txbuf [i++] = '0';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	pmod->no_datain_msgs++;

	/* Send out the message */

	msgxfer (line, NORESP, pmod, 15);

	/* Set Mode Normal */

	taskDelay (60);

	i = 0;

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'M';
	txp->txbuf [i++] = 'N';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	pmod->no_datain_msgs++;

	/* Send out the message */

	msgxfer (line, NORESP, pmod, 15);

	return (TRUE);
}

/*                                                                           	
**     prepresponses
**                                                                             	
**      The purpose of this routine is to mark the PLCs as on hold and the    	
**	data as not valid until read again from the PLC                       	
**                                                                           	
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)

{
	unsigned short	mod;
	CMPMTR		*pmod;

	for (mod = 1; (mod <= NUMCMPMTRS); mod++)
	{
            pmod = plcs [line] [mod];
	    if (pmod)		/* verify pointer validity prior to use */
	    {
	    	pmod->holdflag = TRUE;
		mark_not_valid (pmod);
            }
	}
}

/*                                                                  	
**      any_responding                                               	
**                                                                   	
**      The purpose of this routine is to see if any units are       	
**	responding on this line                                      	
**                                                                   	
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)

{
	unsigned short	mod;
	CMPMTR		*pmod;

	for (mod = 1; (mod <= NUMCMPMTRS); mod++)
	{
	    pmod = plcs [line] [mod];
	    if (pmod)		/* verify pointer validity prior to use */
	    {
                /* check cmd_force_offline flag because it is set	*/
		/* in an asynchronous task				*/

		if ((pmod->is_responding) && (!pmod->cmd_force_offline))
		{
		    return (TRUE);
		}
	    }
	}
	return (FALSE);
}

/*                                                             	
** readDFS - Display Flags for Servo Parameters
**                                                              	
*/
static	unsigned short readDFS (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned long	newval = 0;
	unsigned short  i = 0;
	unsigned short  j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'D';
	txp->txbuf [i++] = 'F';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}

	/* Store the returned data */

	for (i = 0, j = 6; i < 32; i++, j++)
	{
	    if (rxp->rxbuf [j] == '_')
	    {
		j++;
	    }
	    if (rxp->rxbuf [j] == '1')
	    {
		newval += (1 << (31 - i));
	    }
	}

	pmod->dis [0].last_read = newval;
	pmod->dis [0].data_valid = TRUE;

	return (CMDDONE);
}

/*                                                             	
** readDFX - Display Flags for Indexer Status
**                                                              	
*/
static	unsigned short readDFX (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned long	newval = 0;
	unsigned short  i = 0;
	unsigned short  j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'D';
	txp->txbuf [i++] = 'F';
	txp->txbuf [i++] = 'X';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}

	/* Store the returned data */

	for (i = 0, j = 6; i < 32; i++, j++)
	{
	    if (rxp->rxbuf [j] == '_')
	    {
		j++;
	    }
	    if (rxp->rxbuf [j] == '1')
	    {
		newval += (1 << (31 - i));
	    }
	}

	pmod->dis [1].last_read = newval;
	pmod->dis [1].data_valid = TRUE;

	return (CMDDONE);
}

/*                                                             	
** readDPA1 - Display Actual Position (once)
**                                                              	
*/
static	unsigned short readDPA1 (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i = 0;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'D';
	txp->txbuf [i++] = 'P';
	txp->txbuf [i++] = 'A';
	txp->txbuf [i++] = '1';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	return (CMDDONE);
}

/*                                                             	
** readDPE1 - Display Position Error (once)
**                                                              	
*/
static	unsigned short readDPE1 (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i = 0;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'D';
	txp->txbuf [i++] = 'P';
	txp->txbuf [i++] = 'E';
	txp->txbuf [i++] = '1';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	return (CMDDONE);
}

/*                                                             	
** readDVA1 - Display Actual Velocity (once)
**
*/
static	unsigned short readDVA1 (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i = 0;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'D';
	txp->txbuf [i++] = 'V';
	txp->txbuf [i++] = 'A';
	txp->txbuf [i++] = '1';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	return (CMDDONE);
}

/*                                                             	
** readDVS1 - Display Velocity Setpoint (once)
**                                                              	
*/
static	unsigned short readDVS1 (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i = 0;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'D';
	txp->txbuf [i++] = 'V';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = '1';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	return (CMDDONE);
}

/*                                                             	
** readFS - Encoder Function Report
**                                                              	
*/
static	unsigned short readFS (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned long	newval = 0;
	unsigned short  i = 0;
	unsigned short  j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'F';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	/* Send out the message */

	rxp->rxprompt = FALSE;

	if (msgxfer (line, FIXEDRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}

	/* Store the returned data */

	for (i = 16, j = 5; i < 32; i++, j++)
	{
	    if (rxp->rxbuf [j] == '_')
	    {
		j++;
	    }
	    if (rxp->rxbuf [j] == '1')
	    {
		newval += (1 << (31 - i));
	    }
	}

	pmod->dis [2].last_read = newval;
	pmod->dis [2].data_valid = TRUE;

	return (CMDDONE);
}

/*                                                             	
/* readIS - Input Status Report
**                                                              	
*/
static	unsigned short readIS (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned long	newval = 0;
	unsigned short  i = 0;
	unsigned short  j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'I';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}

	/* Store the returned data */

	for (i = 20, j = 5; i < 32; i++, j++)
	{
	    if (rxp->rxbuf [j] == '_')
	    {
		j++;
	    }
	    if (rxp->rxbuf [j] == '1')
	    {
		newval += (1 << (31 - i));
	    }
	}

	pmod->dis [3].last_read = newval;
	pmod->dis [3].data_valid = TRUE;

	return (CMDDONE);
}

/*                                                             	
** readPR - Absolute Position Report
**                                                              	
*/
static	unsigned short readPR (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i= 0;
	double		newval;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'P';
	txp->txbuf [i++] = 'R';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}
	/* Store the returned data */

	rxp->rxbuf [16] = '.';
	rxp->rxbuf [17] = '0';
	rxp->rxbuf [18] = 0;

	if (sscanf (&rxp->rxbuf [5], "%lf", &newval) == 1)
	{
	    pmod->ais [4].aivals = newval;
	    pmod->ais [4].data_valid = TRUE;
	}
	else
	{
	    pmod->ais [4].data_valid = FALSE;
	}

	return (CMDDONE);
}

/*                                                             	
** readPX - Report Encoder Position
**                                                              	
*/
static	unsigned short readPX (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i = 0;
	double		newval;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'P';
	txp->txbuf [i++] = 'X';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}

	/* Store the returned data */

	rxp->rxbuf [16] = '.';
	rxp->rxbuf [16] = '0';
	rxp->rxbuf [16] = 0;

	if (sscanf (&rxp->rxbuf [5], "%lf", &newval) == 1)
	{
	    pmod->ais [5].aivals = newval;
	    pmod->ais [5].data_valid = TRUE;
	}
	else
	{
	    pmod->ais [5].data_valid = FALSE;
	}

	return (CMDDONE);
}

/*                                                             	
** readR - Report SX Status
**
*/
static	unsigned short readR (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned long	newval = 0;
	unsigned short  i = 0;
	unsigned short  j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'R';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}

	/* Store the returned data */

	switch (rxp->rxbuf [4])
	{
	case 'R':
	    pmod->dis [5].last_read = 0;
	    pmod->dis [5].data_valid = TRUE;
	    break;

	case 'S':
	    pmod->dis [5].last_read = 1;
	    pmod->dis [5].data_valid = TRUE;
	    break;

	case 'B':
	    pmod->dis [5].last_read = 2;
	    pmod->dis [5].data_valid = TRUE;
	    break;

	case 'C':
	    pmod->dis [5].last_read = 3;
	    pmod->dis [5].data_valid = TRUE;
	    break;

	case 'Z':
	    pmod->dis [5].last_read = 4;
	    pmod->dis [5].data_valid = TRUE;
	    break;

	default:
	    pmod->dis [5].data_valid = FALSE;
	    break;
	}
	return (CMDDONE);
}

/*                                                             	
** readRA - Limit Switch Status Report
**
*/
static	unsigned short readRA (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned long	newval = 0;
	unsigned short  i = 0;
	unsigned short  j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'R';
	txp->txbuf [i++] = 'A';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}

	/* Store the returned data */

	if ((rxp->rxbuf [5] >= '@') && (rxp->rxbuf [5] <= 'O'))
	{
	    pmod->dis [6].last_read = (rxp->rxbuf [6] - '@');
	    pmod->dis [6].data_valid = TRUE;
	}
	else
	{
	    pmod->dis [6].data_valid = FALSE;
	}
	return (CMDDONE);
}

/*                                                             	
** readRB - Loop, Pause, Shutdown, Trigger Status Report
**
*/
static	unsigned short readRB (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned long	newval = 0;
	unsigned short  i = 0;
	unsigned short  j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'R';
	txp->txbuf [i++] = 'B';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}

	/* Store the returned data */

	if ((rxp->rxbuf [5] >= '@') && (rxp->rxbuf [5] <= 'O'))
	{
	    pmod->dis [7].last_read = (rxp->rxbuf [6] - '@');
	    pmod->dis [7].data_valid = TRUE;
	}
	else
	{
	    pmod->dis [7].data_valid = FALSE;
	}
	return (CMDDONE);
}

/*                                                             	
** readSS - Function Set-Up Report
**
*/
static	unsigned short readSS (CMPMTR *pmod, unsigned short line,
				unsigned short mod)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned long	newval = 0;
	unsigned short  i = 0;
	unsigned short  j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	if (mod > 9)
	{
	    txp->txbuf [i++] = ((mod / 10) + 0x30);
	}
	txp->txbuf [i++] = ((mod % 10) + 0x30);
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = 'S';
	txp->txbuf [i++] = CR;
	txp->txbuf [i] = 0;

	txp->txmsglen = i;

	rxp->fixedlen = FALSE;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}

	/* Store the returned data */

	for (i = 12, j = 5; i < 32; i++, j++)
	{
	    if (rxp->rxbuf [j] == '_')
	    {
		j++;
	    }
	    if (rxp->rxbuf [j] == '1')
	    {
		newval += (1 << (31 - i));
	    }
	}

	pmod->dis [4].last_read = newval;
	pmod->dis [4].data_valid = TRUE;

	return (CMDDONE);
}

/*
**	Setcoil
**
*/
static	unsigned short setcoil (unsigned short line, unsigned short mod,
			 CMPMTR *pmod, unsigned short bitaddr,
			 unsigned long mask, unsigned long val)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short	i, ix, lsignal;
	unsigned long	lmask, lval, tmask ,tval;

	if (mask == 0)
	{
	    return (CMDREJECT);
	}
	tmask = lmask = mask;
	tval = lval = val;
	lsignal = bitaddr;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	/* Format the output message */

	txp->txbuf [0] = mod + 0x30;

	switch (lsignal)
	{
	case 0:
	    if (val & mask)
	    {
		txp->txbuf [1] = 'G';
		txp->txbuf [2] =  CR;
		txp->txbuf [3] = 0;

		txp->txmsglen = 3;

		pmod->dos [0].last_read = 1;

		/* Send out the message */

		if (msgxfer (line, NORESP, pmod, 15) == XFERBAD)
		{
		    pmod->no_offlines++;
		    pmod->holdflag = TRUE;
		    pmod->is_responding = FALSE;
		    return (CMDFAIL);
		}
		taskDelay (6);
		if (readR (pmod, line, mod) != CMDDONE)
		{
		    return (CMDFAIL);
		}
		return (CMDDONE);
	    }
	    else
	    {
		pmod->dos [0].last_read = 0;
		return (CMDDONE);
	    }
	    break;

	case 1:
	    if (val & mask)
	    {
		txp->txbuf [1] = 'K';
		pmod->dos [0].last_read = 0;
	    }
	    else
	    {
		return (CMDDONE);
	    }
	    break;


	case 2:
	    if (val & mask)
	    {
		txp->txbuf [1] = 'H';
		pmod->dos [0].last_read = 0;
	    }
	    else
	    {
		return (CMDDONE);
	    }
	    break;


	case 3:
	    if (val & mask)
	    {
		txp->txbuf [1] = 'S';
		pmod->dos [0].last_read = 0;
	    }
	    else
	    {
		return (CMDDONE);
	    }
	    break;

	default:
	    return (CMDREJECT);
	}

	txp->txbuf [2] =  CR;
	txp->txbuf [3] = 0;

	txp->txmsglen = 3;

	/* Send out the message */

	if (msgxfer (line, NORESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}
	return (CMDDONE);
}

/*
**	Setreg
**
*/
static	unsigned short setreg (unsigned short line, unsigned short mod,
			 CMPMTR *pmod, unsigned short regaddr,
			 unsigned short val, double dblval, unsigned short conv)
{
	TXLINE 		*txp;
	RXLINE 		*rxp;
	unsigned short	i;
	union		u_value
		{
		short		ivalue;
		long		lvalue;
		float		fvalue;
		double		dvalue;
		char		afvalue [100];
		}  uval;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	/* Format the output message */

	txp->txbuf [0] =  mod + 0x30;

	switch (regaddr)
	{
	case 0:
	    txp->txbuf [1] = 'D';
	    if (dblval < 0)
	    {
		txp->txbuf [2] = '-';
	    }
	    else
	    {
		txp->txbuf [2] = '+';
	    }
	    sprintf (&txp->txbuf [3], "%10.0f", dblval);

	    for (i = 0; i < 10; i++)
	    {
                /* trip leading zero spaces and negative sign. */ 
		if ((txp->txbuf [i + 3] == '-') ||
		    (txp->txbuf [i + 3] == ' '))
		{
		    txp->txbuf [i + 3] = '0';
		}
	    }
	    strcat (txp->txbuf, "\r");

	    txp->txmsglen = strlen (txp->txbuf);
	    break;

	case 1:
	    txp->txbuf [1] = 'V';

	    sprintf (&txp->txbuf [2], "%4.2f", dblval);

	    for (i = 0; i < 4; i++)
	    {
		if (txp->txbuf [i + 3] == ' ')
		{
		    txp->txbuf [i + 3] = '0';
		}
	    }

	    strcat (txp->txbuf, "\r");

	    txp->txmsglen = strlen (txp->txbuf);
	    break;

	case 2:
	    txp->txbuf [1] = 'A';

	    sprintf (&txp->txbuf [2], "%4.2f", dblval);

	    for (i = 0; i < 4; i++)
	    {
		if (txp->txbuf [i + 3] == ' ')
		{
		    txp->txbuf [i + 3] = '0';
		}
	    }

	    strcat (txp->txbuf, "\r");

	    txp->txmsglen = strlen (txp->txbuf);
	    break;

	case 3:
	    txp->txbuf [1] = 'A';
	    txp->txbuf [2] = 'D';

	    sprintf (&txp->txbuf [3], "%4.2f", dblval);

	    for (i = 0; i < 4; i++)
	    {
		if (txp->txbuf [i + 3] == ' ')
		{
		    txp->txbuf [i + 3] = '0';
		}
	    }

	    strcat (txp->txbuf, "\r");

	    txp->txmsglen = strlen (txp->txbuf);
	    break;

	case 4:
	    txp->txbuf [1] = 'D';
	    txp->txbuf [2] = 'P';

	    sprintf (&txp->txbuf [3], "%d", val);

	    strcat (txp->txbuf, "\r");

	    txp->txmsglen = strlen (txp->txbuf);
	    break;
	}

	/* Send out the message */

	rxp->rxprompt = FALSE;

	if (msgxfer (line, NORESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}
	return (CMDDONE);
}

/*
**	Setstring
**
*/
static	unsigned short setstring (unsigned short line, unsigned short mod,
			          CMPMTR *pmod, unsigned short signal,
			          unsigned char *buf, unsigned short olen)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	int		i;

	union		u_value
		{
		short		ivalue;
		long		lvalue;
		float		fvalue;
		double		dvalue;
		char		afvalue [100];
		}  uval;

	/* Don't allow passthru commands if the motor is busy */

	if (pmod->dis [5].last_read >= 2)
	{
	    return (CMDDONE);
	}

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	/* Format the output message */

	strcpy (txp->txbuf, buf);

	txp->txbuf [strlen (buf)] =  CR;
	txp->txbuf [strlen (buf) + 1] =  0;

	txp->txmsglen = strlen (txp->txbuf);

	/* Clear the receive buffer */

	for (i = 0; i < MAXRXMSG; i++)
	{
	    rxp->rxbuf [i] = 0;
	}

	/* Send out the message */

	msgxfer ((ONERETRY + line), FIXEDRESP, pmod, 15);

	/* Verify the response - the message is repeated back*/
/*
	for (i = 0; i < strlen (txp->txbuf); i++)
	{
	    if (txp->txbuf [i] != rxp->rxbuf [i])
	    {
		return (CMDFAIL);
	    }
	}
*/
	/* Update the string input point so application can see response */

	taskLock ();
	for (i = 0; i < STRINGMSGLEN; i++)
	{
	    pmod->sin [0].last_response [i] = 0;
	}
	strncpy (pmod->sin [0].last_response, rxp->rxbuf, STRINGMSGLEN - 1);
	taskUnlock ();
	pmod->sin [0].data_valid = TRUE;

	return (CMDDONE);
}

/*
**	DUMPMSGCNTS
**
**	The purpose of this routine is to dump the line level
**	statistics for this driver.
**
*/

void DUMPMSGCNTS (unsigned short line)

{
	unsigned long	temp, t, x, y, z;

	temp = tickGet ();
	t = (temp - linestats [line].startingtick);

	x = linestats [line].TXintcount;
	y = linestats [line].RXintcount;
	z = linestats [line].msgxfercount;

	if (z == 0)
	{
	    printf (" ******  No Messages Transferred ****** \n");
	    return;
	}

	printf ("\n");
	printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
	printf ("\n");
	printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
	printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
	printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
	printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
	printf ("\n");
	printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
	printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
	printf ("\n");
	printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
	printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
	printf ("\n");
	return;
}

/*
**	CLEARMSGCNTS
**
**	The purpose of this routine is to dump and clear the line level statistics
**	for this driver.
**
*/

void CLEARMSGCNTS (unsigned short line)

{
	DUMPMSGCNTS (line);

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].msgxfercount = 0;

	linestats [line].startingtick = tickGet ();
	printf (" ******  All Counts Cleared  ****** \n",
		linestats [line].msgxfercount);
	printf ("\n");
	return;
}

/*
**	DUMPPLCSTATS
**
**	The purpose of this routine is to dump the plc level
**	statistics for this driver.
**
*/

void DUMPPLCSTATS (unsigned short line, unsigned short maddr)

{
	CMPMTR		*pmod;
	unsigned long	microsecs;

	pmod = plcs [line] [maddr];
	if (!pmod)
	{
	    logMsg ("Line/CMPMTR Address Not Defined \n");
	    return;
	}

	printf (" Was requested = %d \n", pmod->was_requested);
	printf (" Is responding = %d \n", pmod->is_responding);
	printf (" # Output messages = %d \n", pmod->no_dataout_msgs & 0x7fff);
	printf (" # Data in messages = %d \n", pmod->no_datain_msgs & 0x7fff);
	printf (" #No Rx Response = %d \n", pmod->no_rxnoresp & 0x7fff);
	printf (" #No Tx Responses = %d \n", pmod->no_txnoresp & 0x7fff);
	printf (" #Retries = %d \n", pmod->no_retries & 0x7fff);
	printf (" #Rx Hw Errors = %d \n", pmod->no_rxhwerrs & 0x7fff);
	printf (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs & 0x7fff);
	printf (" #Off Lines = %d \n", pmod->no_offlines & 0x7fff);
	printf (" Reset Statistics = %d \n", pmod->cmd_reset_stat);
	printf (" Force Offline = %d \n", pmod->cmd_force_offline);
	printf (" #Failed Outputs = %d \n", pmod->badoutcnt & 0x7fff);
	printf ("\n");


	printf ("\n");
	printf (" # of Messages %d \n", pmod->msgs);
	printf (" # Total response time (ticks) = %lu \n", pmod->responsetime);
	if (pmod->msgs)
	{
	    printf ("   Average response time (ticks) = %d \n",
			(pmod->responsetime / pmod->msgs));
	    microsecs = (16667 * pmod->responsetime) / pmod->msgs;
	    printf ("   Average response time (msec) = %d.%1d \n",
			microsecs / 1000, (microsecs % 1000) / 100);
	}
	printf (" # of scan passes = %d \n", pmod->tscanpass);
	printf ("\n");

	printf (" Resource Responding = %d \n", resresponse [line]);
	printf (" Hold flag  = %d \n", pmod->holdflag );
	return;
}

/*
**	CLEARPLCSTATS
**
**	The purpose of this routine is to clear the plc level
**	statistics for this driver. 
**
*/

void CLEARPLCSTATS (unsigned short line, unsigned short maddr)
{
	CMPMTR		*pmod;

	pmod = plcs [line] [maddr];
	if (!pmod)
	{
	    logMsg ("Line/CMPMTR Address Not Defined \n");
	    return;
	}

	initstats (pmod); /* use existing procedure */
	return;
}

/*
**dump_mod_table                                                       	
**
**	The purpose of this routine is twofold:                                 
**	1) dump the plc level statistics for the modbus driver.
**	2) dump the data for the specified modbus plc.
**
*/

void TABLEINFO (unsigned short line, unsigned short maddr)

{
	CMPMTR		*pmod;
	short		ix;
	unsigned	short	i, n, j; 

	CMPMTRDO	*doptr;
	CMPMTRDI	*diptr;
	CMPMTRAO	*aoptr;
	CMPMTRAI	*aiptr;
	unsigned short	req, val, value, addr, firstaiinblk, firstreginblk, linecnt;
	unsigned long	bigvalue;
	unsigned char	buffer [200];


	pmod = plcs [line] [maddr];
	if (!pmod)
	{
	    logMsg("Line/CMPMTR Address Not Defined \n");
	    return;
	}

	/* previously integral code moved to seperate procedure	*/
	/* for debugging convenience				*/

	DUMPPLCSTATS (line, maddr);

	linecnt = 1;
	printcoilhdr (buffer, linecnt);
	addr = 1;
	for (i = 0; i < (MAXDONO / 8); i += 4)
	{
	    printf("  %4d    ", addr);
	    for (n = 0; n < 4; n++)
	    {		
		doptr = &pmod->dos[i+n];
		printf("%1x,  %1x,         %lx,\t",
			doptr->was_requested,
			doptr->data_valid,
			doptr->last_read);
	    }
	    printf ("\n");
	    linecnt += 1;
	    if ( (linecnt >= 17) && ((i + 4)  < (MAXDONO /8)) )
	    {
		linecnt = 1;
		printcoilhdr (buffer, linecnt);
	    }
	    addr += 32;		
	}

	linecnt = 1;
	printdihdr (buffer, linecnt);
	addr = 1;
	for (i = 0; i < (MAXDINO / 8); i += 4)
	{
	    printf ("  %4d    ", addr);
	    for (n = 0; n < 4; n++)
	    {		
 		diptr = &pmod->dis[i+n];
		printf("%1x,  %1x,         %lx,\t",
			diptr->was_requested,
			diptr->data_valid,
			diptr->last_read);
	    }
	    printf ("\n");
	    linecnt += 1;
	    if ((linecnt >= 17) && ((i + 4)  < (MAXDINO / 8)) )
	    {
		linecnt = 1;
		printdihdr (buffer, linecnt);
	    }
	    addr += 32;		
	}


	linecnt = 1;
	printaihdr(buffer, linecnt);
	addr = 1;
	for (i = 0; i < MAXAINO; i += 8)
	{
	    printf ("  %4d \t", addr);
				   
	    for (n = 0; n < 2; n++ )
	    {		
		aiptr = &pmod->ais [(i / 4) + n];
		printf ("\t%1x,%1x  \t", aiptr->was_requested, aiptr->data_valid);
		printf("%5d,   ", aiptr->aivals);
	    }
	    printf("\n");
	    linecnt += 1;
	    if ((linecnt >= 17) && ((i + 8)  < MAXAINO) )
	    {
		linecnt = 1;
		printaihdr (buffer, linecnt);
	    }
	    addr += 8;		
	}

	linecnt = 1;
	printreghdr (buffer, linecnt);
	addr = 1;
	for (i = 0; i < MAXAONO; i += 8)
	{
	    printf("  %4d \t", addr);

	    for (n = 0; n < 2; n++)
	    {		
		aoptr = &pmod->aos [(i / 4) + n];
		printf("\t%1x, %1x,\t", aoptr->was_requested, aoptr->data_valid);
		printf("%6d,\t",aoptr->ioregs);
	    }
	    printf ("\n");
	    linecnt += 1;
	    if ((linecnt >= 17) && ((i + 8)  < MAXAONO) )
	    {
		linecnt = 1;
		printreghdr (buffer, linecnt);
	    }
	    addr += 8;		
	}
}


/*
**
**	dump_ai_table                                                       	
**                                                                           	
**	The purpose of this routine is twofold:                                 
**	1) dump the plc level statistics for the modbus driver.              
**	2) dump the data for the specified modbus plc.                       
**                                                                              
*/

void dump_ai_table (unsigned short line, unsigned short maddr)
{
	CMPMTR		*pmod;
	short		ix;
	unsigned	short	i, n, j; 

	CMPMTRAI	*aiptr;

	unsigned short	req, val, value, addr, firstaiinblk, firstreginblk, linecnt;
	unsigned long	bigvalue;
	unsigned char	buffer [200];


	pmod = plcs [line] [maddr];
	if (!pmod)
	{
	    logMsg("Line/CMPMTR Address Not Defined \n");
	    return;
	}

	/* previously integral code moved to seperate	*/
	/* procedure for debugging convenience		*/

	DUMPPLCSTATS (line, maddr);

	linecnt = 1;
	printaihdr (buffer, linecnt);
	addr = 1;
	for (i = 0; i < MAXAINO; i += 8)
	{
	    printf ("  %4d \t", addr);
	    for (n = 0; n < 2; n++ )
	    {		

		aiptr = &pmod->ais [(i / 4) + n];
		printf ("\t%1x,%1x  \t", aiptr->was_requested, aiptr->data_valid);
		printf("%5d,   ", aiptr->aivals);
	    }
	    printf("\n");
	    linecnt += 1;
	    if ((linecnt >= 17) && ((i + 8)  < MAXAINO) )
	    {
		linecnt = 1;
		printaihdr (buffer, linecnt);
	    }
	    addr += 8;		
	}
}

/*
**	only called from dump_mod_table 
*/

static void printcoilhdr (unsigned char *buffer, unsigned short cnt)
{	
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                                    PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
        sprintf (buffer,"                                                   MODBUS COILS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
	sprintf (buffer,
               "          R   V      Value\tR   V      Value\tR   V      Value\tR   V      Value");
 	printf ( "%s\n", buffer);
 	cnt += 1;
}
/*
**	only called from dump_mod_table
*/

static void printdihdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                                    PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
	sprintf (buffer,"                                              MODBUS DIGITAL INPUTS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
	sprintf (buffer,
                "          R   V      Value\tR   V      Value\tR   V      Value\tR   V      Value");
	printf ( "%s\n", buffer);
	cnt += 1;
}
/*
**	only called from dump_mod_table
*/

static void printaihdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                               PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
	sprintf (buffer,"                                            MODBUS ANALOG INPUTS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
	sprintf (buffer," \t \tR  V\tValue  \tValue  \tValue  \tValue  \t \tR  V\tValue  \tValue  \tValue  \tValue");
	printf ( "%s\n", buffer);
	cnt += 1;
}

/*
** only called from dump_mod_table
*/

static void printreghdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                               PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
	sprintf (buffer,"                                             MODBUS REGISTERS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
	sprintf (buffer,"\t\tR  V\tValue\tValue\tValue\tValue\t\tR  V\tValue\tValue\tValue\tValue");
	printf ( "%s\n", buffer);
 	cnt += 1;
}

/*
**
**	The purpose of this routine is to display the contents
**	of the static variables contained within this driver.
**
*/

LINEINFO ()
{
	short		i;
	char		buffer [132];
	char		*resrsp;
	char		*lineact;


	printf ("                                 CMPMTR Line Information Table          \n");
	printf ("\n");
	printf (" Line        Pointer to        Resource      Resource");
	printf ("       Line        Delay Times:       Activity\n");
	printf ("Number      MODPLC Table         Name        Response");
	printf ("     Activity      IM  .TX  TX.         Time\n");
	printf ("\n");

	for (i = 0; i < CMPMTRLINES; i++)
	{
	    if (plcs [i] == NULL)
	    {
		continue;
	    }
	    if (resresponse [i] == 0)
	    {
		resrsp = "FALSE";
	    }
	    else
	    {
		resrsp = "TRUE";
	    }
	    if (line_activity [i] == 0)
	    {
		lineact = "FALSE";
	    }
	    else
	    {
		lineact = "TRUE";
	    }
	    sprintf (buffer,
                       "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
			i, plcs[i], &resnames[i],
			&resrsp[0],
			&lineact[0],
			intermsgdelay[i],
			pretxdelay[i],
			posttxdelay[i],
			activity_time[i]);
	    printf ( "%s\n", buffer);
	}
	return 0;
}

/*
** only called from dump_mod_table 
*/

static void printbdhdr (unsigned char *buffer, unsigned short *cnt,
			unsigned short percent)
{	
    taskDelay(2);
    printf("\n");
    sprintf(buffer,"                      Microsol %d Percent Debounce Event Queue         ", percent);
    printf( "%s\n\n", buffer);
    (*cnt)++;
    (*cnt)++;
    sprintf(buffer,
        " index:  Date/Time                  Reg,Addr    OldValue      NewValue      NextValue    Pct");
    printf( "%s\n", buffer);
    (*cnt)++;
}

/*	End of File:	drvCompumotor.c */
