/*drvEnraf.c,v 1.1.1.1 1999/08/03 14:42:55 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
/*  File: drvEnraf.c													
/*  Edit:  01/11/94      WEP: created based on drvmodbus.c
	03/30/94	ems: STARTDRIVER1, STARTDRIVER2, remove test
			     ln >= 0, it is unsgined
			     msgxfer(), remove cast (char*) not needed
*/
/* #define TEST 	1 */


#define  MAIN        enraf_driver           /* NOTE: change here */
#define  AIDRIVER    enraf_aidriver         /* NOTE: change here */
#define  AODRIVER    enraf_aodriver         /* NOTE: change here */
#define  AOREAD      enraf_aoread           /* NOTE: change here */
#define  BIDRIVER    enraf_bidriver         /* NOTE: change here */
#define  BODRIVER    enraf_bodriver         /* NOTE: change here */
#define  BOREAD      enraf_boread           /* NOTE: change here */

#define  TRACEON     enraftraceon           /* NOTE: change here */
#define  TRACEOFF    enraftraceoff          /* NOTE: change here */
#define  RTRACEON    enrafrestraceon        /* NOTE: change here */
#define  RTRACEOFF   enrafrestraceoff       /* NOTE: change here */
#define  TRACELEVEL  enraftrlv              /* NOTE: change here */

#define  STOPDRIVER  stopenraf              /* NOTE: change here */
#define  STARTDRIVER1 startenraf            /* NOTE: change here */
#define  STARTDRIVER2 startenraf1           /* NOTE: change here */
#define  SETDELAYS   enraf_setdelays        /* NOTE: change here */
#define  TABLEINFO   enraf_dmt              /* NOTE: change here */
#define  LINEINFO    enraf_sli              /* NOTE: change here */


#ifdef TEST
#include<bioscomm.h>
#include<dummyos.h>
#include <modbus.h>
#include<modproto.h>
#define logMsg printf
#endif

#ifndef TEST
#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvEnraf.h>		          /* NOTE: change here */
#include <drvEnraf_proto.h> 		  /* NOTE: change here */
#include <restable.h>
#endif


/* static long	init(); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvEnraf={ 2,	NULL, init};


/*
/*      Storage for MODBUS PLC Structures
/*
*/
static LOADINFO		linfo[MODLINES];		/* array of control structures for loading PLC headers 			*/

static MODPLC		*plcs[MODLINES][NUMMODPLCS+1];	/* two dimensional array of pointers to the fixed length   		*/
							/* dynamically allocated PLC control and data structures.  		*/
							/* extra pointer is for Query structure used independently 		*/
							/* of the others. it also allows for the array index to    		*/
							/* match the mod value.                                    		*/

static unsigned char	resnames[MODLINES][RESNAMELEN];	/* array of resource name strings. 					*/

static RES_TABLE	*prestable[MODLINES];		/* array of pointers to resource tables 				*/

static unsigned short	resresponse[MODLINES];		/* array of resource response flags. 					*/
							/* False=not active resource(slave), True= active resource(master) 	*/

static unsigned short	line_activity[MODLINES];	/* true/false line active flag. calculated using activity_time below. 	*/
static unsigned short	lastactivity[MODLINES];		/* assigned value of line_activity prior to it's recalculation.   	*/

static unsigned short	modtrace[MODLINES];		/* controls output of communication error log messages (true/false) 	*/
static unsigned short	mltrace[MODLINES];		/* controls output of certain resource related log messages (level) 	*/
static unsigned short	modrestrace[MODLINES];		/* controls output of MASTER/SLAVE arbitration log messages (binary) 	*/

static OUTPUTQUE	*oq[MODLINES];			/* array of ptrs to the line output queues and their control structures */

static SEM_ID		semids[MODLINES][2];		/* 'new' semaphore logic. the old SEMAPHORE is still used. 		*/

static short		linetimers[MODLINES];		/* except on init (init_line_tabs), all references commented out 	*/

static SEM_ID		linesems[MODLINES];		/* not used. no references in the code at all 				*/
                                                	
static unsigned short	intermsgdelay[MODLINES];	/* holds value passed in task spawn. used  for each msgxfer attempt 	*/
static unsigned short	pretxdelay[MODLINES];		/* holds post RTS delay before TX. 					*/
static unsigned short	posttxdelay[MODLINES];		/* holds post TX delay before dropping RTS. 				*/

static long		activity_time[MODLINES];	/* holds timetick of last activity. used to set line_activity flag  	*/
static unsigned short	microsolflag[MODLINES];		/* flag used in AIDRIVER and AIDRIVER to differentiate          	*/
							/*  between the microsol & modicon plc devices 				*/

static char		user[40],password[40];		/* holds id and password of the user that spawned the driver task	*/
							/* required by host to check file read privileges on PLC load files 	*/


static SEM_ID		linemux[MODLINES];	/* 1/03/94: mutual-exclusion semaphore for shared resource of the data link 	*/
						/* controls access to common path shared by data and diagnostic channels. 	*/
						/* originally designed for use with MDS remote radio diagnostics. 		*/

/*
/*      Storage for MODBUS Comm Line Structures
/*
*/

static RXLINE          *rxlinetab[MODLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically allocated comm controls/buffers 	*/

static TXLINE          *txlinetab[MODLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically allocated comm controls/buffers */

static char    *bools[] = {
	"TRUE ",
	"FALSE"
    };
static int		taskId [MODLINES];

static char *tasknames[] = {"MODBUS Ch0","MODBUS Ch1","MODBUS Ch2","MODBUS Ch3","MODBUS Ch4","MODBUS Ch5",
			    "MODBUS Ch6","MODBUS Ch7","MODBUS Ch8","MODBUS Ch9","MODBUS Ch10","MODBUS Ch11",
			    "MODBUS Ch12","MODBUS Ch13","MODBUS Ch14","MODBUS Ch15","MODBUS Ch16","MODBUS Ch17",
			    "MODBUS Ch18","MODBUS Ch19","MODBUS Ch20"
			    };

static char *tasknames2[]= {"MICROSOL Ch0","MICROSOL Ch1","MICROSOL Ch2","MICROSOL Ch3","MICROSOL Ch4","MICROSOL Ch5",
			    "MICROSOL Ch6","MICROSOL Ch7","MICROSOL Ch8","MICROSOL Ch9","MICROSOL Ch10","MICROSOL Ch11",
			    "MICROSOL Ch12","MICROSOL Ch13","MICROSOL Ch14","MICROSOL Ch15","MICROSOL Ch16","MICROSOL Ch17",
			    "MICROSOL Ch18","MICROSOL Ch19","MICROSOL Ch20"
			    };
/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
    {
	return (0);
    }
/********
/*
/*	This routine enables logging of comm trace messages
/*
********/
void TRACEON (unsigned short line)
    {
	modtrace[line] = TRUE;
    }

/********
/*
/*	This routine disables logging of comm trace messages
/*
********/
void TRACEOFF (unsigned short line)
    {
	modtrace[line] = FALSE;
    }

/********
/*
/*	This routine enables logging of resource trace messages
/*
********/
void RTRACEON (unsigned short line)
    {
	modrestrace[line] = TRUE;
    }

/********
/*
/*	This routine disables logging of resource trace messages
/*
********/
void RTRACEOFF (unsigned short line)
    {
	modrestrace[line] = FALSE;
    }

/********
/*
/*	This routine controls logging of trace messages
/*
********/
void TRACELEVEL (unsigned short line, unsigned short level)
    {
	mltrace[line] = level;
    }

#ifndef TEST
int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER1 (unsigned short ln, char *mode,unsigned short delay)
{
	if ( ln < MODLINES )
	{
	    microsolflag[ln] = FALSE;
	    taskId [ln] = taskSpawn (tasknames[ln],MOD_PRIORITY,MOD_TASK_OPTIONS,MOD_STACK,MAIN,ln, mode, delay);

	    logMsg ("Started the MODBUS driver on line %d\n",ln);

	    remCurIdGet (user,password);
	    return (1);
	}
	else
	{

	    logMsg ("Invalid line number %d\n", ln);
	    return (-1);
	}
}

int STARTDRIVER2 (unsigned short ln, char *mode,unsigned short delay)
{
	if ( ln < MODLINES )
	{
	    microsolflag[ln] = TRUE;
	    taskId [ln] = taskSpawn (tasknames2[ln],MOD_PRIORITY,MOD_TASK_OPTIONS,MOD_STACK,MAIN,ln, mode, delay);

	    logMsg ("Started the MICROSOL driver on line %d\n",ln);

	    remCurIdGet (user,password);
	    return (1);
	}
	else
	{
	    logMsg ("Invalid line number %d\n", ln);
	    return (-1);
	}
}
#endif




/********
/*
/* Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETDELAYS (unsigned short line,
		unsigned short tickcount1,
		unsigned short tickcount2,
		unsigned short tickcount3)
    {
	intermsgdelay[line] = tickcount1;  /* at beginning new message/response sequence.			*/
	pretxdelay[line]    = tickcount2;  /* after asserting RTS but before beginning transmission.            */
	posttxdelay[line]   = tickcount3;  /* after sending last character of transmission before dropping RTS  */
    }


/*											
/*      MOD_driver                                                                      
/*                                                                                     	
/*      The purpose of this task is to scan the modbus plc                             	
/*      lines. It will maintain a configuration list supporting online additions       	
/*      and replacement of modules, and maintain a table of most recently              	
/*      scanned values.                                                                	
/*                                                                                     	
*/                                                                                     	
/* not called from within this driver 						      */

void MAIN (unsigned short line, unsigned char *mode, unsigned short delay)
    {
	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command,i;
	long	        this_time, last_time;
	MODPLC          *pmod;
	RXLINE          *rxp;

/* Initialize the data structures */

	intermsgdelay[line] = delay;
	pretxdelay[line] = 3;		/* wep: initialize to 50 msec */
	posttxdelay[line] = 3;		/* wep: initialize to 50 msec */
	linfo[line].loading = FALSE;

	resresponse[line] = FALSE;
	resnames[line][0] = 0;
	prestable[line] = NULL;

	modtrace[line] = FALSE;
	mltrace[line] = 0;
	modrestrace[line] = TRUE;

	activity_time[line] = tickGet ();
	lastactivity[line] = line_activity[line] = FALSE;

/* wep: output queue initialization */
	oq[line] = (OUTPUTQUE *)calloc(1,(sizeof(OUTPUTQUE)));
	if (!oq[line])
	{
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}

/* wep: communication initialization */
	rxlinetab[line] = (RXLINE *)calloc(1,(sizeof(RXLINE)));
	if (!rxlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
	    return;
	}
	txlinetab[line] = (TXLINE *)calloc(1,(sizeof(TXLINE)));
	if (!txlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
	    return;
	}

	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
	onlinefreq = 1;		/* causes on_line calls to begin on first pass if master */

	/* Initialize the Rx interrupts to receive once for activity check */
	/* enable the receiver interrupt after set to ignore */
	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);

/*														
/* 1/03/94: 	initialize mutual-exclusion semaphore logic for diagnostic driver path sharing. The Take/Put	
/*		logic implemented below is designed to insure, under heavy diagnostic demand, that scan_plc	
/*		and the on_line while routine are executed once for every two diagnostic Take/Put sequences.    
/*		Furthermore, diagnostic activities are suspended during master/slave arbitration by Taking  	
/*		the semaphore while the local state is not the master state.                                	
/*
*/   

	linemux[line]=semMCreate (SEM_Q_PRIORITY); 	/* default: semaphore inits as 'full', ready to be Taken */
	if (!linemux[line])
	{
	    logMsg  ("Not enough memory for line %d data structure (mutual-exclusion semaphore)\n",line);
	    return;
        }
	

#ifdef  TEST
	scansome ();
#endif
	/* Wait for resource to be defined via an initial call to our own 'register_resource' from someone higher up */
	while ( (resnames[line][0] == 0) || (prestable[line] == NULL) )
	{
	    if (mltrace[line] == 1)
	    	logMsg ( "No Resource Defined for line - %d \n", line);
	    taskDelay (120);
	}




	/* Start out as slave */
	resClearCaAnswer(prestable[line]);		/* start quiet */
	resPutLocalState(prestable[line],RES_SLV);
	if (modrestrace[line])
		logMsg ("1] Became RES_SLV \n");
	taskDelay(300);
	resGetStates(prestable[line],&lstate,&pstate);
	activity = check_line_activity(line,ACTIVITYTIME);


	/* if the partner is not there, be master */
	if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
	{
	    resSetCaAnswer(prestable[line]);
	    resPutLocalState(prestable[line],RES_MSTR);
	    lstate = RES_MSTR;
	    if (modrestrace[line])
	    	logMsg ("2] Became RES_MSTR \n");
	}


	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet(); /* Initialize the time  */

	while (TRUE)
	{
	    activity_time[line] = tickGet();
	    lastactivity[line] = line_activity[line] = FALSE;

	    /* we arrive here because we are a slave. 									  */
	    /* we stay here until:    asked to be master by partner. if we can reach PLCs, we breakout to 'master' state. */
	    /*                        the partner is not master and there is no activity on the line. 			  */

	    while (lstate == RES_SLV)
	    {
		if (pstate != RES_SLVWANT)
		{
		    clear_rts(line); 				/* make sure line is left for master 	*/
		}


		resresponse[line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand(prestable[line],0); 		/* clear out commands 			*/
		activity = check_line_activity(line,10); 	/* wait 10 seconds before checking 	*/
		resGetStates(prestable[line],&lstate,&pstate);


		/* see if needed by partner to be master. if yes, do it and break out of this slave state */
		if (pstate == RES_SLVWANTCA)
		{
		    semGive(linemux[line]);	/* 1/4/94: give back the semaphore so diagnostics can function */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line]) logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    break;
		}
		/* If partner is there and wants to give it up, try to take it */
		if (pstate == RES_SLVWANT)
		{
		    execute = FALSE;

		    taskDelay(2); /* Time for switch to occur */

		    /* See if anyone is out there and able to respond to a loopback command */
		    for ( mod=1; (mod <= NUMMODPLCS); mod++)
		    {
			pmod = plcs[line][mod];
			if ((pmod) &&			/* verify pointer validity prior to use */
			    (pmod->was_requested))
			{
			    on_line(line,mod);	
			    if (pmod->is_responding)
			    {
				execute = TRUE;
				break;
			    }
			}
		    }
		    /* If someone answered, become master and make sure partner really gave it up */
		    if (execute)
		    {
			resPutLocalState(prestable[line],RES_MSTR);
			lstate = RES_MSTR;
			if (modrestrace[line])
				logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			execute = FALSE;
			activity_time[line] = tickGet();
			lastactivity[line] = line_activity[line] = FALSE;
			for (i=0;(i<60);i++)
			{
			    activity = check_line_activity(line,2);    /* wait two seconds before testing */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ( (pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */
			    resPutLocalState(prestable[line],RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace[line])
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 
			    semGive(linemux[line]);	/* 1/4/94: give back the semaphore so diagnostics can function */
			    resSetCaAnswer(prestable[line]);
			    prepresponses(line);
			    break;
			}
		    }
		}

		/* if the partner is not talking, be master */
		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
		    semGive(linemux[line]);		/* 1/4/94: give back the semaphore so diagnostics can function */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line])
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
		    prepresponses(line);
		}
	    }

            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is canceled */
	    while (lstate == RES_SLVWANTCA)
	    {
		clear_rts(line); 		/* Make sure line is left for master */
		resresponse[line] = FALSE; 	/* Make Sure driver is not responding */

		resGetStates(prestable[line],&lstate,&pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace[line])
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    break;
		}
		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    semGive(linemux[line]);		/* 1/4/94: give back the semaphore so diagnostics can function */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line])
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    prepresponses(line);
		}
	    }

            /* we come here because we have gone to, or are looping in, the master state.          */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
	    /* It will then try to configure requested non-responding modules.                      */

	    /* it doesn't appear that we ever come here in a RES_SLVWANT lstate mode. it happens    */
	    /*  within this loop, but is never seen by the while loop conditional evaluation.       */

	    last_time = tickGet ();		/* initialize gap */
	    while ((lstate == RES_MSTR) || (lstate == RES_SLVWANT))
	    {
		/* initial stuff */
		resresponse[line] = TRUE; /* Make sure driver is responding. driver won't issue commands if not set. */

/* this is for testing only, and will be removed in the released version */
		if (lstate == RES_SLVWANT)
			logMsg (" Diagnostic WEP.0001. Ignore this message. \n");

		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0);        /* clear out commands */


		/* if relinquish command sent, change state and break out to outer loop */
		if (command == RES_RELINQUISH)
		{
		    while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)  	/* make sure diagnostics are quiescent */
                    {
			logMsg ("101] Waiting for Radio Diagnostics: Mutual-Exclusion Semaphore Timeout on Line %d\n",line);
		    }
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace[line]) logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
		    break;
		}


		/* wep: scan plcs for data i/o, if allowed */
		modspolled = 0;
		/* call 'scan_plc' for each PLC device, unless user has taken it off line or it is not responding */
		for ( mod=1; (mod <= NUMMODPLCS); mod++ )
		{
		    pmod = plcs[line][mod];			/* shorthand pointer 			*/
		    if (pmod)					/* verify pointer validity prior to use */
		    {
			if (pmod->cmd_force_offline)
			{ 
				/* if user has turned this plc offline via pseudo commands, mark it as not responding */
 				pmod->is_responding = FALSE;
	    		}
			else if (pmod->is_responding)
			{
				modspolled++;
				while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)  	/* get access to the radio */
                                {
				logMsg ("98] Waiting for Radio Diagnostics: Mutual-Exclusion Semaphore Timeout on Line %d\n",line);
				}
				scan_plc(pmod,line,mod);      	/* I/O done here! 			*/
				semGive(linemux[line]);
				if (!pmod->is_responding)
				{
					mark_not_valid(pmod);
                               	}
			}
		    }
		    /* end of single module action */

		    /* if told to relinquish our master state, stop plc scanning immediately. */
		    /* don't trash the command, so that we can still read it on the next loop through this while statement. */
		    resGetCommand(prestable[line],&command);
		    if (command == RES_RELINQUISH) break;
		} /* end of scan loop */


		/* try and bring all nonresponding plcs on line, but don't bring in more than a specified number. */
		cnt = 0;
		if (--onlinefreq == 0) 		/* do we try to bring any in on this pass? */
		{ 
		    onlinefreq = BRINGBACKCNT;
		    for ( mod=1; (mod <= NUMMODPLCS); mod++)
		    {
			cfgchk++;		/* manage plc index */
			if (cfgchk==NUMMODPLCS+1)
			{
				cfgchk=1;	/* wrap plc index */
                        }
			pmod = plcs[line][cfgchk];
			if ((pmod) &&		/* verify pointer validity prior to use*/
			    (!pmod->is_responding) &&
			    (pmod->was_requested) &&
			    (!pmod->cmd_force_offline))
		    	{
				while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)  	/* get access to the radio */
                                {
					logMsg ("99] Waiting for Radio Diagnostics: Mutual-Exclusion Semaphore Timeout on Line %d\n",line);
				}
				on_line(line,cfgchk);	/* loopback testing done here! 			*/
				semGive(linemux[line]);

				modspolled++;
				cnt++;
                                if (cnt == MAXCFGCK) break;
			}
		    }
		}

		/* see if anyone on the line has been responding. if not, try to get partner to become slave. */
		/* Check for no one responding */
		if (!any_responding(line))
		{
		    /* See if it is time to let partner try */
		    this_time = tickGet();
		    if ((this_time - last_time) > (3*SLWWINDOW))
		    {   /* #ticks for slave to try */

			/* Switch States to let partner know it's its time to try */

/* 1/4/94: make semGet(linemux[line]) call before the switch to make sure diagnostic task is quiescent while partner  */
/*         is checking the line with the loopback command. if local not master, then diagnostic won't try anyway, for */
/*         either master or remote radios, but it might have begun a 12 second test sequence just before we got here. */
			while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)  	/* make sure diagnostics are quiescent */
			{
				logMsg ("100] Waiting for Radio Diagnostics: Mutual-Exclusion Semaphore Timeout on Line %d\n",line);
			}
/*	   we must semPut the semaphore back if and when we go to being the master */


			resPutLocalState(prestable[line],RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace[line])
				logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate,activity);

			/* Give partner access to the hardware */
			clear_rts(line);

			/* Remember the time of this try */
			last_time = tickGet();
			lastactivity[line] = line_activity[line] = FALSE;
			for (i=0; (i<SLWWINDOW); i+=10)
			{       		/* SLWINDOW is the # of ticks for slave to try */
			    taskDelay(10);
		    				/* If partner picked up let it have control */
			    activity = check_line_activity(line,0);  /* check immediately */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
			    {
				resClearCaAnswer(prestable[line]);
				resPutLocalState(prestable[line],RES_SLV);
				lstate = RES_SLV;
				if (modrestrace[line])
					logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);
				taskDelay(240);
				break;
			    }
			}
			/* Go Back to being the Master and take control of the hardware */
			if (lstate != RES_SLV)
			{
			    semGive(linemux[line]);	/* 1/4/94: give back the semaphore so diagnostics can function */
			    resPutLocalState(prestable[line],RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace[line])
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			}
		    }
		}

		/* take plcs off of hold status. the plc's data is not to be held off since we are now master. */
		for ( mod=1; (mod <= NUMMODPLCS); mod++ )
		{
		    pmod = plcs[line][mod];
		    if (pmod)			/* verify pointer validity prior to use */
		    {        
			pmod->holdflag = FALSE;
                    }
		}
	    }
#ifndef TEST
	    if (modspolled==0)
	    	taskDelay(60);
	    else taskDelay(10);
#endif
#ifdef  TEST
	    scansome();
#endif
	} /* end infinite task loop */
     }

/*
/* Try to bring a PLC on line
/*
*/

/* this routine only called from MAIN */


static void on_line (unsigned short line,unsigned short mod)
    {
	MODPLC  *pmod;
	unsigned short i,j;

	pmod = plcs[line][mod];	
	if (pmod)			/* verify pointer prior to use */
	{
		if (mltrace[line] == 1)
		{
			logMsg ( "Bring Online line - %d  mod - %d \n",
				line, mod );
	        }
		/* Use the loop back function to see if the unit is there and responding */

		if (!modloopback(ONERETRY+line,mod,pmod))
			return; /* if no response, get out */

		mark_not_valid(pmod);	/* a PLC that has just been brought online must have it's data marked not valid */

		pmod->is_responding = TRUE;
        }
    }



/*							
/* Mark all plc data elements as not valid     		
/*                                             		
*/                                             	
/* called from on_line and prepresponses      		*/    	


static void mark_not_valid (MODPLC  *pmod)
    {
	unsigned short i,j;

/*							
/*      COILS ARE INITIALIZED AS READ WRITE VALUES      
/*              - READ BACK NOT VALID 			
*/

	for (i=0; (i<NUMMODCOILS); i++)
	{
	    pmod->coils[i].data_valid = FALSE;
	}

/*							
/*      DIGITALS ARE INITIALIZED AS NOT VALID		
*/
	for (i=0; (i<NUMMODDIS); i++)
	{
	    pmod->dis[i].data_valid = FALSE;
	}

/*							
/*      ANALOG INS ARE INITIALIZED AS NOT VALID		
*/
	for (i=0; (i<NUMMODAIS); i++)
	{
	    pmod->ais[i].data_valid = FALSE;
	}

/*                                                  		
/*      REGISTERS ARE INITIALIZED AS READ WRITE VALUES		
/*      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS 	
/*              - READ BACK NOT VALID      	               	
*/
	for (i=0; (i<NUMREGISTERS); i++)
	{
	    pmod->regs[i].data_valid = FALSE;
	}
    }
/*                                                           	
/* Scan a MODBUS PLC -  get inputs and set outputs as required	
/*                                                            	
*/
/* this routine only called from MAIN 		*/


static	void scan_plc (MODPLC *pmod, unsigned short line,unsigned short mod)
    {
	unsigned short i, j, val, bitaddr, regaddr, readlen;
	unsigned long   bitmask;
	LOADINFO	sslinfo;

	checkoutputs(line);

	if (mltrace[line] == 1)
		logMsg ( "Scan  line - %d  mod - %d \n",
				line,mod );

	/* Test to see if load requested or in progress */
	if (pmod->prog_load_stat == PLC_LOAD_REQUESTED)
	{
	    loadinit(line,pmod,mod);
	    return;
	}
	if (pmod->prog_load_stat == PLC_LOAD_IN_PROGRESS)
	{
	    loadnextblock(line);
	    return;
	}
	/* Test to see if a start or stop is requested */
	if (pmod->plc_stop)
	{
		sslinfo.line = line;
		sslinfo.mod = mod;
		sslinfo.pmod = pmod;
		if(plc_login(&sslinfo))
		{
		    plc_stop(&sslinfo);
		}
		plc_logout(&sslinfo);
		pmod->plc_stop = FALSE;
	}
	if (pmod->plc_start)
	{
		sslinfo.line = line;
		sslinfo.mod = mod;
		sslinfo.pmod = pmod;
		if(plc_login(&sslinfo))
		{
		    plc_start(&sslinfo);
		}
		plc_logout(&sslinfo);
		pmod->plc_start = FALSE;
	}
	/* read the coil values to be scanned */
	for (i=0; (i<NUMMODCOILS); i++)
	{
	    if (pmod->coils[i].was_requested)
	    {
		for (j=1; ((j<MAXDIGBLKSIZE) && ( (i+j)<NUMMODCOILS )); j++)
		{
		    if (!pmod->coils[i+j].was_requested)
		    	break;
		}
		bitaddr = (i*8);
		readlen = j*8;
		if (!readcoils (line,mod,pmod,bitaddr,readlen))
			return;
		checkoutputs(line);
		i=(i+j)-1;
	    }
	}
	/* read the di values to be scanned */
	for (i=0; (i<NUMMODDIS); i++)
	{
	    if (pmod->dis[i].was_requested)
	    {
		for (j=1; ((j<MAXDIGBLKSIZE) && ( (i+j)<NUMMODDIS )); j++)
		{
		    if (!pmod->dis[i+j].was_requested)
		    	break;
		}
		bitaddr = (i*8);
		readlen = j*8;
		if (!readdis (line,mod,pmod,bitaddr,readlen))
			return;
		checkoutputs(line);
		i=(i+j)-1;
	    }
	}
	/* read the ai values to be scanned */
	for (i=0; (i<NUMMODAIS); i++)
	{
	    if (pmod->ais[i].was_requested)
	    {
		for (j=1; ((j<MAXREGBLKSIZE) && ( (i+j)<NUMMODAIS )); j++)
		{
		    if (!pmod->ais[i+j].was_requested)
		    	break;
		}
		regaddr = i*REGBLOCK;
		readlen = j*REGBLOCK;
		if (!readais (line,mod,pmod,regaddr,readlen))
			return;
		checkoutputs(line);
		i=(i+j)-1;
	    }
	}
	/* read the reg values to be scanned */
	for (i=0; (i<NUMREGISTERS); i++)
	{
	    if (pmod->regs[i].was_requested)
	    {
		for (j=1; ((j<MAXREGBLKSIZE) && ( (i+j)<NUMREGISTERS )); j++)
		{
		    if (!pmod->regs[i+j].was_requested)
		    	break;
		}
		regaddr = i*REGBLOCK;
		readlen = j*REGBLOCK;
		if (!readregs (line,mod,pmod,regaddr,readlen))
			return;
		checkoutputs(line);
		i=(i+j)-1;
	    }
	}
    }
/*												
/* checkoutputs											
/*      checks output que and returns if empty.							
/*      if there is something on the queue it attempts to process all                           
/*      pending outputs, doing immediate retries. If attempts fail the request is dropped.      
/*                                                                                              
*/                                                                                              
/* this routine only called from scan_plc */

static	void checkoutputs (unsigned short line)
    {
	OUTQENT *optr;
	unsigned short  regaddr,regval,link,adapter,coiladdr,conv;
	unsigned long   coilmask,coilval;
	MODPLC  *pmod;
	double 		dblaovalue;

	while ((optr=ogetnextp(line)) != NULLP)
	{
	    if ((optr->otype)==AOUTTYPE)
	    {
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;

		pmod = plcs[link][adapter];
		if (pmod == NULL)
		{
			if (!allocate_plc(link, adapter))
				return; /* if not allocated, try. if can't allocate, get out. */
		}

		regaddr = optr->out.aonode.aosignal;
		regval = optr->out.aonode.aovalue;
		dblaovalue = optr->out.aonode.dblaovalue;
		conv = optr->out.aonode.conversion;

		if (mltrace[line] == 2) 
			logMsg ( "Analog Output to line %d, address %d, signal  - %d\n",
				link, adapter, regaddr );

		if ((!pmod->cmd_force_offline) && (resresponse[link]))
		{
		    if (!(setreg(link,adapter,pmod,regaddr,regval,dblaovalue,conv )))
		    {
		        pmod->badoutcnt++;		    
		    }
		}
	    }
	    else if ((optr->otype)==BOUTTYPE)
	    {
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;

		pmod = plcs[link][adapter];
		if (pmod == NULL)
		{
			if (!allocate_plc(link, adapter))
				return; /* if not allocated, try. if can't allocate, get out. */
		}

		coiladdr = optr->out.bonode.bosignal;
		coilval = optr->out.bonode.bovalue;
		coilmask = optr->out.bonode.bomask;

		if (mltrace[line] == 2) 
			logMsg ( "Binary Output to line %d, address %d, signal  - %d\n",
				link, adapter, coiladdr );

		if ((!pmod->cmd_force_offline) && (resresponse[link]))
		{
		    if (!(setcoil (link,adapter,pmod,coiladdr,coilmask,coilval)))
		    {
			pmod->badoutcnt++;
		    }
		}
	    }
	    oreleasefull(line);     /* release the output que entry */
	}
    }
/*                                                                                    	
/*      AIDRIVER
/*                                                                              	
/*      This routines main purpose is to return the analog input value for the         	
/*      specified module. For a module value                                           	
/*      a (-1) will be returned if there is no valid data ready.                       	
/*                                                                                     	
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname)
    {
	MODPLC  *pmod;
	unsigned short  blkix;
	unsigned short	*pdata;

	if (link > MODLINES)
		return (-1);
	if (adapter > NUMMODPLCS)
		return (-1);
	if ((card != MAINS) && (card != MREGS) && (card != MPSEUDO))
		return (-1);
	if (conversion != conversion)
		return (-1); /* No warnings */

	signal--; /* Signals are defined as 1 relative */

	if ((card == MAINS) && (signal > MAXAINO))
		return (-1);
	if ((card == MREGS) && (signal > MAXREGNO))
		return (-1);

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return; /* if not allocated, try. if can't allocate, get out. */
	}

	pmod->was_requested = TRUE;


	if (card == MPSEUDO)
	{
	    signal++;
	    if (!resresponse[link])
	    	return (-2);
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 2: /* The program Load request */
		*pvalue = pmod->prog_load_stat;
		break;

	    case 3: /* PLC Program Load Block Number */
		*pvalue = pmod->prog_load_page;
		break;

	    case 4: /* Set the program number to Load */
		*pvalue = pmod->prog_load_number;
		break;

	    case 5: /* Output Messages */
		*pvalue = pmod->no_dataout_msgs;
		break;

	    case 6: /* Input Messages */
		*pvalue = pmod->no_datain_msgs;
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = pmod->no_rxnoresp;
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = pmod->no_txnoresp;;
		break;

	    case 9: /* Data Echo Errors */
		*pvalue = pmod->no_dataerr;
		break;

	    case 10: /* Message Retries */
		*pvalue = pmod->no_retries;
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = pmod->no_rxhwerrs;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = pmod->no_txhwerrs;
		break;

	    case 13: /* CRC errors */
		*pvalue = pmod->no_crcerrs;
		break;

	    case 14: /* Offline transitions */
		*pvalue = pmod->no_offlines;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = pmod->badoutcnt;
		break;


	    case 20: /* What is the program load comp code for the plc? */
		*pvalue = pmod->prog_load_code;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname);
	}

	if (card == MAINS)
	{
	    if (signal > MAXAINO)
	    {
		return (-1);
	    }
	    blkix = (signal / REGBLOCK);
	    pmod->ais [blkix].was_requested = TRUE;
	    if (!resresponse[link])
	    	return (-2);
	    if (pmod->holdflag)
	    	return (-2);
	    if (!pmod->is_responding)
	    	return (-1);
	    if (!pmod->ais [blkix].data_valid)
	    {
		return (-1);
	    }
	    if (!microsolflag[link])
	    {
		pdata = ((unsigned short*) &(pmod->ais [blkix].aivals [signal % REGBLOCK]));
	    } else
	    {
		*pvalue = (pmod->ais[blkix].aivals[signal%REGBLOCK]>>4) & 0xFFF;
		return(0);
	    }
	}
	if (card == MREGS)
	{
	    if (signal > MAXREGNO)
	    { 
		return (-1);
	    }
	    blkix = (signal / REGBLOCK);
	    pmod->regs [blkix].was_requested = TRUE;
	    if (!resresponse[link])
	    	return (-2);
	    if (pmod->holdflag)
	    	return (-2);
	    if (!pmod->is_responding)
	    	return (-1);
	    if (!pmod->regs [blkix].data_valid)
	    {
		return (-1);
	    }
	    if (!microsolflag[link])
	    {
		pdata = &(pmod->regs [blkix].ioregs [signal % REGBLOCK]);
	    } else
	    {
		*pvalue = (pmod->regs[blkix].ioregs[signal%REGBLOCK] >> 4) & 0xFFF;
		return(0);
	    }
	}

	/* NOTE !! MULTIPLE PRECISION VALUES MUST RESIDE IN A SINGLE BLOCK */

	/* Select the Size and Type of Response based on Conversion */
	switch (conversion)
	{
	    case(AICNVDOUBLEINT):
		pvalue[0] = pdata[1];
		pvalue[1] = pdata[0];
		break;
	    case(AICNVFLOAT):
		pvalue[0] = pdata[1];
		pvalue[1] = pdata[0];
		break;
	    case(AICNVDOUBLEFLT):
		pvalue[0] = pdata[3];
		pvalue[1] = pdata[2];
		pvalue[2] = pdata[1];
		pvalue[3] = pdata[0];
		break;
	    case(AICNVINTEGER):
	    default:
		*pvalue = *pdata;
		break;

 	}
	return(0);

    }

/*  										
/*      AODRIVER
/*                                                                            	
/*      This routines main purpose is to set requested analog outputs to the  	
/*      specified module.                                                     	
*/                                                                            	
/* this routine not called from within this driver */


int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	    unsigned short signal,double dvalue, unsigned short value,
	    unsigned short conversion, unsigned char *resname)

    {
	MODPLC  *pmod;
	unsigned short  blkix;
	OUTQENT *oqp;

	signal--; /* Signals are defined as 1 relative */

	if (link > MODLINES)
		return (-1);
	if (adapter > NUMMODPLCS)
		return (-1);
	if ((card != MREGS) && (card != MPSEUDO))
		return -1;

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return; /* if not allocated, try. if can't allocate, get out. */
	}


	if (card == MPSEUDO)
	{
	    signal++;
	    if (!resresponse[link])
	    	return (-2);
	    switch (signal)
	    {

	    case 2: /* Set the program Load request */
		if (value != 0)
		    pmod->prog_load_stat = PLC_LOAD_REQUESTED;
		break;

	    case 4: /* Set the program number to Load */
		pmod->prog_load_number = value;
		break;

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
			initstats(pmod);
		break;

	    case 16: /* Force the PLC online/offline */
		pmod->cmd_force_offline = (value != 0);
		pmod->is_responding = (value != 0);
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname);
	}

	if (signal > MAXREGNO)
	{
	    return (-1);
	}
	pmod->was_requested = TRUE;

	blkix = (signal / REGBLOCK);
	pmod->regs [blkix].was_requested = TRUE;

	if (!resresponse[link])
		return (-2);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}
	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
	    return (-1);		/* output que is full */
	}
	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;

	if (!microsolflag[link])
	{
	    oqp->out.aonode.aovalue = value;
	} else
	{
	    oqp->out.aonode.aovalue = (value << 4);
	}
	oqp->out.aonode.dblaovalue = dvalue;
	oqp->out.aonode.conversion = conversion;

	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
    }
/*
/*      AOREAD
/*                                                                          	
/*      This routines main purpose is to return the value last read back     	
/*      from the analog output hardware. This is used to initialize analog   	
/*      outputs.                                                             	
*/
/* this routine not called from within this driver */


int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	  unsigned short signal, unsigned short *pvalue,
	  unsigned short conv, unsigned char *resname)

    {
	MODPLC  *pmod;
	unsigned short  blkix, *pdata;
	
	signal--; /* Signals are defined as 1 relative */

	if (link > MODLINES)
		return (-1);
	if (adapter > NUMMODPLCS)
		return (-1);
	if ((card != MREGS) && (card != MPSEUDO))
		return -1;

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter)) return; /* if not allocated, try. if can't allocate, get out. */
	}

	if (card == MPSEUDO)
	{
	    signal++;
	    if (!resresponse[link])
	    	return (-2);
	    switch (signal)
	    {
	    case 2: /* read the most recent program Load request */
		*pvalue = pmod->prog_load_stat;
		break;

	    case 4: /* read the most recent program number to Load */
		*pvalue = pmod->prog_load_number;
		break;

	    case 15: /* read statistics command value */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Read the current PLC offline command status */
		*pvalue = pmod->cmd_force_offline;
		break;


	    default:
		return(-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname);
	}

	if (signal > MAXREGNO)
	{
	    return (-1);
	}
	pmod->was_requested = TRUE;

	blkix = (signal / REGBLOCK);
	pmod->regs [blkix].was_requested = TRUE;

	if (!resresponse[link])
		return (-2);

	if (pmod->holdflag)
		return (-2);

	if (!pmod->is_responding)
	{
	    return (-1);
	}

	if (!pmod->regs [blkix].data_valid)
	{
	    return (-1);
	}

	pdata = &(pmod->regs [blkix].ioregs [(signal % REGBLOCK)]);

	/* NOTE !! MULTIPLE PRECISION VALUES MUST RESIDE IN A SINGLE BLOCK */

	/* Select the Size and Type of Response based on Conversion */
	switch (conv)
	{
	    case(ASCFLT):
		pvalue[0] = pdata[1];
		pvalue[1] = pdata[0];
		break;
	    default:
		*pvalue = *pdata;
		break;
 	}
	return (0);
    }
/*
/*      BIDRIVER
/*                                                                               	
/*      The main purpose of this routine is to return the request digital input  	
/*      value(s) from the requested card. This routine will return a (-1) if the  	
/*      requested module is the wrong type or the data is not yet valid.          	
/*                                                                                	
*/
/* this routine not called from within this driver */



int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask,unsigned long *pvalue,
		unsigned char *resname)

    {
	MODPLC  *pmod;
	unsigned short blkix;
	unsigned long tvalue;

	signal--; /* Signals are defined as 1 relative */

	if (link > MODLINES)
		return (-1);
	if (adapter > NUMMODPLCS)
		return (-1);

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return; /* if not allocated, try. if can't allocate, get out. */
	}

	pmod->was_requested = TRUE;

	if (card == MPSEUDO)
	{
	    signal++;
	    if (!resresponse[link])
	    	return (-2);
	    switch (signal)
	    {
		    case 0: /* Were the PLC values requested */
			*pvalue = pmod->was_requested;
			break;

		    case 1: /* Is the PLC responding */
			*pvalue = pmod->is_responding;
			break;

		    case 15: /* reset statistics */
			*pvalue = pmod->cmd_reset_stat;
			break;

		    case 16: /* Force the PLC offline */
			*pvalue = pmod->cmd_force_offline;
			break;


		    case 20: /* What is the selected channel for the line */
			*pvalue = pmod->prog_load_code;
			break;

		    default:
			return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname);
	}

	blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */
						/* mask aligned to 32 bits  */
	tvalue = 0;
	if (card == MDINS)
	{
	    if (signal > MAXDINO)
	    {
		return (-1);
	    }
	    if ( (mask & 0x000000FF) != 0)
	    {
	        pmod->dis [blkix].was_requested = TRUE;
		if (!resresponse[link])
			return (-2);
		if (pmod->holdflag)
			return (-2);
		if (!pmod->is_responding)
			return (-1);
		if (!pmod->dis [blkix].data_valid)
		{
		    return (-1);
		}
	        tvalue = pmod->dis [blkix].last_read & mask;
	    }
	    if ( (mask & 0x0000FF00) != 0)
	    {
	        pmod->dis [blkix+1].was_requested = TRUE;
		if (!resresponse[link])
			return (-2);
		if (pmod->holdflag)
			return (-2);
		if (!pmod->is_responding)
			return (-1);
		if (!pmod->dis [blkix+1].data_valid)
		{
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->dis [blkix+1].last_read) << 8;
	    }
	    if ( (mask & 0x00FF0000) != 0)
	    {
	        pmod->dis [blkix+2].was_requested = TRUE;
		if (!resresponse[link])
			return (-2);
		if (pmod->holdflag)
			return (-2);
		if (!pmod->is_responding)
			return (-1);
		if (!pmod->dis [blkix+2].data_valid)
		{
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->dis [blkix+2].last_read) << 16;
	    }
	    if ( (mask & 0xFF000000) != 0)
	    {
	        pmod->dis [blkix+3].was_requested = TRUE;
		if (!resresponse[link])
			return (-2);
		if (pmod->holdflag)
			return (-2);
		if (!pmod->is_responding)
			return (-1);
		if (!pmod->dis [blkix+3].data_valid)
		{
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->dis [blkix+3].last_read) << 24;
	    }
	    *pvalue = tvalue & mask;
	    return (0);
	}

	tvalue = 0;
	if (card == MCOILS)
	{
	    if ((signal) > MAXCOILNO)
	    {
		return (-1);
	    }
	    if ( (mask & 0x000000FF) != 0)
	    {
	        pmod->coils [blkix].was_requested = TRUE;
		if (!resresponse[link])
			return (-2);
		if (pmod->holdflag)
			return (-2);
		if (!pmod->is_responding)
			return (-1);
		if (!pmod->coils [blkix].data_valid)
		{
		    return (-1);
		}
	        tvalue = pmod->coils [blkix].last_read & mask;
	    }
	    if ( (mask & 0x0000FF00) != 0)
	    {
	        pmod->coils [blkix+1].was_requested = TRUE;
		if (!resresponse[link])
			return (-2);
		if (pmod->holdflag)
			return (-2);
		if (!pmod->is_responding)
			return (-1);
		if (!pmod->coils [blkix+1].data_valid)
		{
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->coils [blkix+1].last_read) << 8;
	    }
	    if ( (mask & 0x00FF0000) != 0)
	    {
	        pmod->coils [blkix+2].was_requested = TRUE;
		if (!resresponse[link])
			return (-2);
		if (pmod->holdflag)
			return (-2);
		if (!pmod->is_responding)
			return (-1);
		if (!pmod->coils [blkix+2].data_valid)
		{
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->coils [blkix+2].last_read) << 16;
	    }
	    if ( (mask & 0xFF000000) != 0)
	    {
	        pmod->coils [blkix+3].was_requested = TRUE;
		if (!resresponse[link])
			return (-2);
		if (pmod->holdflag)
			return (-2);
		if (!pmod->is_responding)
			return (-1);
		if (!pmod->coils [blkix+3].data_valid)
		{
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->coils [blkix+3].last_read) << 24;
	    }
	    *pvalue = tvalue & mask;
	    return (0);
	}
	return (-1);
    }
/*                                                                                	
/*      BODRIVER
/*                                                                                 	
/*      The main purpose of this routine is to set the request digital output      	
/*      value(s) on the requested card. This routine will return a (-1) if the     	
/*      requested module is the wrong type or not configured yet.                  	
/*                                                                                 	
*/
/* this routine not called from within this driver */


int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long value, unsigned long mask,
		unsigned char *resname)


    {
	MODPLC  *pmod;
	OUTQENT *oqp;
	unsigned short  blkix;

	signal--; /* Signals are defined as 1 relative */

	if (link > MODLINES)
		return (-1);
	if (adapter > NUMMODPLCS)
		return (-1);
	if ((card != MCOILS) && (card != MPSEUDO))
		return (-1);

	blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */
						/* masks aligned on 32 bits */

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return; /* if not allocated, try. if can't allocate, get out. */
	}

	pmod->was_requested = TRUE;

	if (card == MPSEUDO)
	{
	    signal++;
	    if (!resresponse[link])
	    	return (-2);
	    switch (signal & 0x1f)
	    {

	    case 2: /* Set the program Load request */
		if (value != 0)
		    pmod->prog_load_stat = PLC_LOAD_REQUESTED;
		break;

	    case 15: /* Reset the accumulated statistics */
		if (value != 0) initstats(pmod);
		break;

	    case 16: /* Force the PLC offline */
		pmod->cmd_force_offline = (value != 0);
		pmod->is_responding = (value != 0);
		break;


	    case 21: /* Start the PLC */
		pmod -> plc_start = (value != 0);
		break;

	    case 22: /* What is the selected channel for the line */
		pmod-> plc_stop = (value != 0);
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname);
	}

	if (signal > MAXCOILNO)
	{
	    return (-1);
	}
	if ((mask & 0x000000FF) != 0)
	{
	    pmod->coils [blkix].was_requested = TRUE;
	}
	if ((mask & 0x0000FF00) != 0)
	{
	    pmod->coils [blkix+1].was_requested = TRUE;
	}
	if ((mask & 0x00FF0000) != 0)
	{
	    pmod->coils [blkix+2].was_requested = TRUE;
	}
	if ((mask & 0xFF000000) != 0)
	{
	    pmod->coils [blkix+3].was_requested = TRUE;
	}

	if (!resresponse[link])
		return (-2);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}
	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
	    return (-1);		/* output que is full */
	}
	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bovalue = value;

	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
    }
/*
/*      BOREAD
/*                                                                           	
/*      This routines main purpose is to return the value last read back      	
/*      from the digital output hardware. This is used to initialize digital  	
/*      outputs. This will return a (-1) if the module is the wrong type or    	
/*      the data is not yet valid                                              	
*/
/* this routine not called from within this driver */


int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)

    {
	MODPLC  *pmod;
	unsigned short  blkix;
	unsigned long	tvalue;

	signal--; /* Signals are defined as 1 relative */

	if (link > MODLINES)
		return (-1);
	if (adapter > NUMMODPLCS)
		return (-1);
	if ((card != MCOILS) && (card != MPSEUDO))
		return (-1);

	blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */
						/* masks aligned on 32 bits */

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return; /* if not allocated, try. if can't allocate, get out. */
	}


	pmod->was_requested = TRUE;

	if (card == MPSEUDO)
	{
	    signal++;
	    if (!resresponse[link])
	    	return (-2);
	    switch (signal)
	    {
	    case 2: /* Set the program Load request */
		*pvalue = 0;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;


	    case 21: /* Start the PLC */
		*pvalue = pmod -> plc_start;
		break;

	    case 22: /* What is the selected channel for the line */
		*pvalue = pmod-> plc_stop;
		break;


	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{
	    register_resource(link,pmod,resname);  /* under what condition(s) could this ever test false? */
	}

	if ((signal) > MAXCOILNO)
	{
	    return (-1);
	}
	tvalue = 0;
	if ((mask & 0x000000FF) != 0)
	{
	    pmod->coils [blkix].was_requested = TRUE;
	    if (!resresponse[link])
	    	return (-2);
	    if (pmod->holdflag)
	    	return (-2);
	    if (!pmod->is_responding)
	    	return (-1);
	    if (!pmod->coils [blkix].data_valid)
	    {
		return (-1);
	    }
	    tvalue = pmod->coils [blkix].last_read & mask;
	}
	if ( (mask & 0x0000FF00) != 0)
	{
	    pmod->coils [blkix+1].was_requested = TRUE;
	    if (!resresponse[link])
	    	return (-2);
	    if (pmod->holdflag)
	    	return (-2);
	    if (!pmod->is_responding)
	    	return (-1);
	    if (!pmod->coils [blkix+1].data_valid)
	    {
		return (-1);
	    }
	    tvalue += (unsigned long) (pmod->coils [blkix+1].last_read) << 8;
	}
	if ( (mask & 0x00FF0000) != 0)
	{
	    pmod->coils [blkix+2].was_requested = TRUE;
	    if (!resresponse[link])
	    	return (-2);
	    if (pmod->holdflag)
	    	return (-2);
	    if (!pmod->is_responding)
	    	return (-1);
	    if (!pmod->coils [blkix+2].data_valid)
	    {
		return (-1);
	    }
	    tvalue += (unsigned long) (pmod->coils [blkix+2].last_read) << 16;
	}
	if ( (mask & 0xFF000000) != 0)
	{
	    pmod->coils [blkix+3].was_requested = TRUE;
	    if (!resresponse[link])
	    	return (-2);
	    if (pmod->holdflag)
	    	return (-2);
	    if (!pmod->is_responding)
	    	return (-1);
	    if (!pmod->coils [blkix+3].data_valid)
	    {
		return (-1);
	    }
	    tvalue += (unsigned long) (pmod->coils [blkix+3].last_read) << 24;
	}
	*pvalue = tvalue & mask;

	return (0);
    }

/*
/* register_resource                                                              	
/*                                                                                	
/*	This routine is used to initialize the resource pointers                  	
/*  If this is the first time the resource for this line is being                  	
/*  referenced the pointer to the resource table entry will be set                  	
/*  and the resource name will be saved. If the resouce name has                    	
/*  already been set, this routine will verify that all other points                 	
/*  for this driver are using the same resource name.                                	
/*                                                                                   	
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BOREAD,				
			    BIDRIVER, and BODRIVER */                               	

static void  register_resource(unsigned short link,MODPLC *pmod,unsigned char *resname)
    {
	if (resnames[link][0] == 0) /* This is the first reference */
	{
	    if (resGetByName( resname,&prestable[link]) != RES_OK)
	    {
		logMsg ( "Resource not found in table - %s \n",
				resname );
	    }
	    else strcpy(resnames[link],resname);
	}
	else
	{
	    if (strcmp(resnames[link],resname) != 0)
	    {
		logMsg ("Resource name conflict - %s,  %s \n",
				resnames[link],
				resname );
	    }
	}
    }
/*                                                                  		
/*      Initialize the Queue                                        		
*/                                                                        	
/* not called from within this driver */

static	void outqueinit (unsigned short line)
    {
	oq[line]->ooutix = oq[line]->oinix = 0;
    }


/*                                                                     		
/*  ogetempty - get the next available slot on the output list         		
*/
/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
    {
	if (((oq[line]->oinix + 1) % OUTQSIZE) != oq[line]->ooutix)
	{
	    return (&oq[line]->outque[oq[line]->oinix]);
	}
	if (mltrace[line] == 1) 
		logMsg ( "Output Que Full line - %d\n",line);
	return (NULLP);
    }


/*                                                                    		
/* omarkfull                                                          		
/*      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
	{
	    oq[line]->oinix = ((oq[line]->oinix + 1) % OUTQSIZE);
	}


/*                                                                      	
/*  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
    {
	if (oq[line]->ooutix != oq[line]->oinix)
	{
	    return (&oq[line]->outque[oq[line]->ooutix]);
	}
	else return (NULLP);
    }


/*                                                       	               	
/* oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
    {
	if (oq[line]->ooutix == oq[line]->oinix)
		return;
	oq[line]->ooutix = ((oq[line]->ooutix + 1) % OUTQSIZE);
    }
/*                                                          			
/*      link_status                                                           	
/*                                                                            	
/*      The purpose of this routine is to print out the state of each of the  	
/*      analog devices lines and the statistics gathered about them.         	
/*                                                                           	
*/
/* not called from within this driver */

static	void link_status (unsigned short line)
    {
    if (line > MODLINES-1) return;
    }





/*                                                                             	
/*                                                                              
/*	allocate_plc                                                            
/*                                                                              
/*	The purpose of this routine is to allocate the memory for a single      
/*	plc data structure. If not successful, a console error message is  	
/*	printed and an error flag is returned to the caller.                    
/*	If successful, the newly allocated data structures are initialized.     
/*                                                                             	
*/

static int allocate_plc (unsigned short line, unsigned short plc )
   {
	plcs[line][plc] = (MODPLC *)calloc(1,(sizeof(MODPLC)));
	if (!plcs[line][plc])
	{
		logMsg ("Unable to allocate memory for MODPLC data structure on line %d, plc %d\n",line ,plc);
		 return(FALSE);
	}
	else
	{
		logMsg ("Allocated memory for MODPLC data structure on line %d, plc %d\n",line ,plc);
		init_plc_tab(line, plc);	     /*	initialize the data structures. */
	}

	return(TRUE);
   }













/*                                                                   		
/*      start_rx                                                        	
/*                                                                     	 	
/*      The purpose of this routine is to initialize a line table        	
/*      for receive and to enable the receiver.                           	
/*                                                                        	
*/
/* only called from msgxfer */


static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

    {
	RXLINE                  *rxp;

	rxp=rxlinetab[line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	rxp->rxstate = RXADRST;

    }







/*                                                                           	
/*      stop_rx                                                              	
/*                                                                           	
/*      The purpose of this routine is to initialize a line table            	
/*      for receive and to disable the receiver.                             	
/*                                                                           	
*/
/* only called from msgxfer */


static	void stop_rx (unsigned short line )

    {
	RXLINE                  *rxp;

	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
    }
/*                                                                        	
/*      rx_int_proc                                                        	
/*                                                                         	
/*      The purpose of this routine is to process a receive character interrupt	
/*      for a given line.                                                     	
*/
/* referenced in system call in MAIN */

static	void rx_int_proc (unsigned short line )
    {
	unsigned char   rxchar;
	unsigned short  rxstat;
	unsigned short  rx_err_mask;
	RXLINE          *rxp;

	read_rx_hw(line,&rxchar,&rxstat,&rx_err_mask);

	rxp=rxlinetab[line];

	/* Something is sending in data */
	line_activity[line] = TRUE;

	if (rxp->rxstate==RXIGNORE)
		return;

	if ((rxstat & rx_err_mask) != 0)
	{
	    if (rxp->rxix == 0)
	    	return;
	    *(rxp->status) = RXBAD;
	    rxp->rxstate=RXIGNORE;
	    rxp->rxbuf[100]=rxstat;
	    rxp->rxbuf[101]=rxchar;
	    return;
	}
	rxp->rxbuf[rxp->rxix++] = rxchar;

	if (rxp->fixedlen)
	{
	    rxp->rxmsglen--;
	    if (rxp->rxix == 2)
	    {
		if ((rxchar & FNCERRBIT) != 0)
		{
		    rxp->fixedlen = FIXEDRESP;
		    rxp->rxmsglen = NAKMSGLEN;
		}
	    }
	    if (rxp->rxmsglen == 0)
	    {
		*(rxp->status) = RXGOOD;
		rxp->rxstate=RXIGNORE;
		semGive(rxp->semid);
	    }
	    return;
	}
	switch (rxp->rxstate)
	{
	    case RXADRST:
		rxp->rxstate = RXFNCST;
		return;
	    case RXFNCST:
		rxp->rxstate = RXLENST;
		if ((rxchar & FNCERRBIT) != 0)
		{
		    rxp->fixedlen = FIXEDRESP;
		    rxp->rxmsglen = NAKMSGLEN;
		}
		return;
	    case RXLENST:
		rxp->fixedlen = FIXEDRESP;
		rxp->rxmsglen = rxchar+2;       /* Add 2 for crc */
		rxp->rxstate = RXDATAST;
		return;
	    default:  /* Data State */
		rxp->rxmsglen--;
		if (rxp->rxmsglen == 0)
		{
		    *(rxp->status) = RXGOOD;
		    rxp->rxstate=RXIGNORE;
		    semGive(rxp->semid);
		    return;
		}
	}
	return;
    }
/*                                                                           	
/*      check_line_activity
/*                                                                             	
/*      The purpose of this routine is to process a receive character interrupt	
/*      for a given line.                                                      	
/*                                                                             	
*/
/* only called from MAIN  */


static	int check_line_activity (unsigned short line, unsigned short predelay )

    {
	RXLINE          *rxp;
	long		thistime;
	short		status;

	if (predelay != 0)
		taskDelay(predelay);
	thistime = tickGet();
	if ((thistime-activity_time[line]) < ACTIVITYTIME)
		return (lastactivity[line] || (line_activity[line]));
	lastactivity[line] = status = line_activity[line];
	line_activity[line] = FALSE;
	activity_time[line] = thistime;
	rxp = rxlinetab[line];
	rxp->rxstate = RXIGNORE;

	return (status);
    }
/*                                                                         	
/*      start_tx                                                            	
/*                                                                          	
/*      The purpose of this routine is to initialize a line table           	
/*      for send and to enable the transmitter.                              	
/*                                                                            	
*/
/* only called from msgxfer  */


static	void start_tx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

    {

	TXLINE                  *txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */


	enable_tx_ints(line);

    }


/*
/*      stop_tx                                                                	
/*                                                                             	
/*      The purpose of this routine is to initialize a line table              	
/*      for receive and to disable the receiver.                               	
/*                                                                             	
*/
/* only called from msgxfer  */


static	void stop_tx (unsigned short line )

    {
	TXLINE			*txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txdisable=TRUE;
    }
/*                                                                           	
/*      tx_int_proc                                                           	
/*                                                                            	
/*      The purpose of this routine is to process a transmit character interrupt
/*      for a given line.                                                  	
/*                                                                         	
*/
/* only called from MAIN  */


static	void tx_int_proc (unsigned short line )

    {
	char                    txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

	txp=txlinetab[line];
	if (txp->txdisable)
		return;
	if (txp->txix == txp->txmsglen)
	{
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive(txp->semid);
	    return;
	}
	else
	{
	    txchar = txp->txbuf[txp->txix++];
	    write_tx_hw ( line,txchar,&txstat,&tx_err_mask );
	    if ( (txstat & tx_err_mask) != 0 )
	    {
	 	txp->txdisable=TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive(txp->semid);
	        return;
	    }

	}

	if (txp->txix >= MAXTXMSG)
	{
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive(txp->semid);
	    return;
	}

    }

/*                                                                         	
/*      msgxfer                                                              	
/*                                                                           	
/*      The purpose of this routine is to transmit a buffer to the         	
/*      analog devices I/O and to await a response. The transmit and receive	
/*      buffers are in their respective line tables. This routine will retry 	
/*      the message up to a maximum number of times or until a response      	
/*      is received with a proper checksum.                                  	
/*              returns         XFERGOOD if response received                	
/*                              XFERBAD  if no good response is received     	
/*                                                                           	
*/
/* called from modloopback, readcoils, readdis, readais, readregs, setcoil, setreg, plc_start, plc_stop, 	*/
/*             pollfordone, plc_init, plc_getdim, plc_setdim, readmem, writemem, writelogic, and writeascii 	*/


static	unsigned short  msgxfer (unsigned short fline,unsigned short resplen, MODPLC *pmod, unsigned short rxlength)
    {
	unsigned short  retry,txstatus,rxstatus,rxlen,line,ix;
	RXLINE          *rxp;
	TXLINE          *txp;
	unsigned char   csums[2];

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

	rxp = rxlinetab[line];

	for (retry=((fline == line)?0:MAXRETRYS-1); (retry<MAXRETRYS); retry++ )
	{
	    if (intermsgdelay[line] != 0)
	    {
		taskDelay (intermsgdelay[line]);
	    }

/* this looks like a good place to 'set_rts', as long as the MAIN task is */
/*  called with a delay > rts/cts delay on the radio transmitter, if not, do our own. */
	    set_rts(line);

	    if (pretxdelay[line] != 0)
	    {
		taskDelay (pretxdelay[line]);
	    }

	    txstatus = IO_TIMEOUT;
	    rxp->fixedlen = resplen;
	    rxp->rxmsglen = rxlength;
	    rxstatus = IO_TIMEOUT;
	    semTake(semids[line][TXSEM], NO_WAIT);
	    semTake(semids[line][RXSEM], NO_WAIT);

	    start_rx(line, semids[line][RXSEM], &rxstatus);
	    start_tx(line, semids[line][TXSEM], &txstatus); /* this actually fires off the transmission. */

	    if ((semTake(semids[line][TXSEM], TXTIMEOUT)) == ERROR)
		txstatus = IO_TIMEOUT;

	    stop_tx(line);

	    if (posttxdelay[line] != 0)
	    {
		taskDelay (posttxdelay[line]);
	    }


/* this looks like a good place to 'clear_rts'. BUT, may need to delay to make sure last character is all the way out. */
	    clear_rts(line);


	    if (txstatus == TXGOOD)
	    {
		if ((semTake(semids[line][RXSEM], (int)(RXTIMEOUT * 2))) == ERROR)
		    rxstatus = IO_TIMEOUT;

		stop_rx(line);

		rxlen = rxp->rxix;
		if (rxstatus == RXGOOD)
		{
		    if (rxlen < 3)
		    {
			if (modtrace[line])
				logMsg("Invlalid rxlen... %d\n", rxlen);
		    }
		    else
		    {
		        makecrc(&rxp->rxbuf [0], rxlen-2, csums);
		    }
		    if ( (csums[0]==rxp->rxbuf[rxp->rxix-2]) &&
			 (csums[1]==rxp->rxbuf[rxp->rxix-1]) )
		    {
			if ((modtrace[line]) && ((rxp->rxbuf[1] & FNCERRBIT) != 0))
			{
			    switch (rxp->rxbuf[2])
			    {
				case (1):
				    logMsg("Modbus Error Illegal Function \n");
				    break;
				case (2):
				    logMsg("Modbus Error Illegal Data Address \n");
				    break;
				case (3):
				    logMsg("Modbus Error Illegal Data Value \n");
				    break;
				case (4):
				    logMsg("Modbus Error Device Failure \n");
				    break;
				case (5):
				    logMsg("Modbus Error Acknowledgement \n");
				    break;
				case (6):
				    logMsg("Modbus Error Busy/Rejected Message \n");
				    break;
				case (7):
				    logMsg("Modbus Error Negative Ack \n");
				    break;
			    }
			}

			 return (XFERGOOD);
		    }
		    else
		    {
			pmod->no_crcerrs++;
			if (modtrace[line])
				logMsg ("CRC Message Length = %d\n", rxlen);
			if (modtrace[line])
				logMsg ("%x%x%x%x Bad CRC\n",
					rxp->rxbuf[rxp->rxix-2],rxp->rxbuf[rxp->rxix-1],
					csums [0], csums [1]
					);
			for (ix = 0; ix < rxlen; ix++)
			{
			    if (modtrace[line])
			    	logMsg("%x\n", rxp->rxbuf[ix]);
			}
		    }
		}
		else if
		(rxstatus == IO_TIMEOUT)
		{
		    if (modtrace[line])
		    	logMsg ("Receive Timeout... Length: %d\n", rxlen);
		    pmod->no_rxnoresp++;
		}
		else
		{
		    if (modtrace[line])
		    	logMsg ("Receive Error\n");

		    if (modtrace[line])
		    	logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
				 rxp->rxbuf[100],
				 rxp->rxbuf[101],
				 rxp->rxix);
			 pmod->no_rxhwerrs++;
		}
	    }
	    else if
	    (txstatus == IO_TIMEOUT)
	    {
		if (modtrace[line])
			logMsg ("Transmit Timeout\n");
		pmod->no_txnoresp++;
	    }
	    else
	    {
		if (modtrace[line])
			logMsg ("Transmit Error\n");
		pmod->no_txhwerrs++;
	    }
	if (retry != MAXRETRYS)
		pmod->no_retries++;
	}
	if (modtrace[line])
		logMsg ("Xfer Bad\n");
	return (XFERBAD);

    }
/*
/*      init_plc_tab
/*
/*      The purpose of this routine is to initialize the line tables for the
/*      analog devices I/O
/*
*/
/* only called from allocate_plc  */


static	void init_plc_tab (unsigned short line, unsigned short mod)

    {
	MODPLC  *pmod;

	pmod = plcs[line][mod];
	if (!pmod)
		return;

	pmod->is_responding = FALSE;
	pmod->holdflag = FALSE;
	pmod->was_requested = FALSE;
	pmod->cmd_force_offline = FALSE;
	pmod->prog_load_stat = PLC_NOT_LOADING;
	pmod->prog_load_number = 0;
	pmod->prog_load_page = 0;
	pmod->plc_start = FALSE;
	pmod->plc_stop = FALSE;

	initplc(pmod);
	initstats(pmod);

	linetimers[line] = gettimer();
	if (linetimers[line] == -1)
	{

		/*  put an error message in here */

	}

	/* Initialize this tasks semaphore*/
	semids[line][0]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
	semids[line][1]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
    }





/*
/* Cold Init a PLC
/*
*/
/* only called from init_line_tabs  */


static void initplc (MODPLC  *pmod)

    {

	unsigned short i,j;

                                                                	
/*                                                              	
/*      COILS ARE INITIALIZED AS READ WRITE VALUES              	
/*      WRITES ARE TREATED BY INDIVIDUAL BITS NOT GROUPS       		
/*              - NOT REQUESTED                                		
/*              - READ BACK NOT VALID                             	
/*              - NO NEW VALUES TO GO                                	
*/

	for (i=0; (i<NUMMODCOILS); i++)
	{
	    pmod->coils[i].was_requested = FALSE;
	    pmod->coils[i].data_valid = FALSE;
	    pmod->coils[i].last_read = 0;
	}

/*                                                                 	
/*      DIGITALS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID		
*/
	for (i=0; (i<NUMMODDIS); i++)
	{
	    pmod->dis[i].was_requested = FALSE;
	    pmod->dis[i].data_valid = FALSE;
	}

/*                                                                 	
/*      ANALOG INS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID    	
*/
	for (i=0; (i<NUMMODAIS); i++)
	{
	    pmod->ais[i].was_requested = FALSE;
	    pmod->ais[i].data_valid = FALSE;
	}

/*                                                             		
/*      REGISTERS ARE INITIALIZED AS READ WRITE VALUES             	
/*      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS      	
/*              - NOT REQUESTED                                    	
/*              - READ BACK NOT VALID                              	
/*              - NO NEW VALUES TO GO                               	
*/                                                                  	
	for (i=0; (i<NUMREGISTERS); i++)
	{
	    pmod->regs[i].was_requested = FALSE;
	    pmod->regs[i].data_valid = FALSE;
	}

    }

/*                                                            		
/*                                                              	
/* initialize the statistics for a modicon PLC                  	
/*                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_line_tabs  */


static	void initstats (MODPLC *pmod)

    {
	pmod->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
	pmod->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
	pmod->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
	pmod->no_txnoresp = 0;      /* 8  Count No Responses 		*/
	pmod->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
	pmod->no_retries = 0;       /* 10 Count Retries 		*/          	
	pmod->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
	pmod->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
	pmod->no_crcerrs = 0;       /* 13 Count CRC Errors 		*/
	pmod->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
	pmod->badoutcnt = 0;	    /* 17 Count failed output commands 	*/
    }
/*                                                                       
/* modloopback                                                            
/*                                                                        
*/                                                                          	
/* only called from on_line */


static	unsigned short modloopback (unsigned short line, unsigned short mod,
			 MODPLC *pmod)

    {
	TXLINE  *txp;
	RXLINE  *rxp;
	long    buildreg;
	unsigned short  i;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[1] =  MODLOOPBACK;
	txp->txbuf[2] =  0;
	txp->txbuf[3] =  0;
	txp->txbuf[4] =  0xA5;
	txp->txbuf[5] =  0x37;

	makecrc(&(txp->txbuf[0]),MODLOOPBACKLEN,&(txp->txbuf[MODLOOPBACKLEN]));

	txp->txmsglen = MODLOOPBACKLEN+MODCRCLEN;

	/* Send out the message */

	if (msgxfer(line,FIXEDRESP,pmod,MODLOOPBACKRESPLEN) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = FALSE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	return(TRUE);
    }
/*                                                                           	
/*     prepresponses                                                            
/*                                                                             	
/*      The purpose of this routine is to mark the PLCs as on hold and the    	
/*	data as not valid until read again from the PLC                       	
/*                                                                           	
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)

    {
	unsigned short  mod;
	MODPLC  *pmod;

	for (mod = 1; (mod <= NUMMODPLCS); mod++)
	{
            pmod = plcs[line][mod];
	    if (pmod)				/* verify pointer validity prior to use */
	    {
	    	pmod->holdflag = TRUE;
		mark_not_valid(pmod);
            }
	}
    }



/*                                                                  	
/*      any_responding                                               	
/*                                                                   	
/*      The purpose of this routine is to see if any units are       	
/*	responding on this line                                      	
/*                                                                   	
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)

    {
	unsigned short  mod;
	MODPLC  *pmod;

	for (mod = 1; (mod <= NUMMODPLCS); mod++)
	{
	    pmod = plcs[line][mod];
	    if (pmod)			/* verify pointer validity prior to use */
	    {
		if (pmod->is_responding)
			 return(TRUE);
	    }
	}
	return(FALSE);
    }


/*                                                                	
/* Readcoils                                                       	
/*                                                                  	
*/
static	unsigned short readcoils (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned short readlen)

/* only called from scan_plc */

    {
	TXLINE  *txp;
	RXLINE  *rxp;

	unsigned short  i;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[1] =  MODCOILREAD;
	txp->txbuf[2] =  (bitaddr >> 8);
	txp->txbuf[3] =  (bitaddr & 0xFF);
	txp->txbuf[4] =  (readlen >> 8);
	txp->txbuf[5] =  (readlen & 0xFF);

	makecrc(&(txp->txbuf[0]),MODREADMSGLEN,&(txp->txbuf[MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN+MODCRCLEN;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = FALSE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != mod) ||
	    (rxp->rxbuf[1] != MODCOILREAD) ||
	    (rxp->rxbuf[2] != ((readlen+7)/8)) )
	{
	    pmod->no_dataerr++;
	    return(FALSE);

	}

	/* Store the returned data                      */
	/*  data is aligned by 8 pseudo register        */
	/*  and a multiple of 8 bits long               */

	for ( i=0; (i<rxp->rxbuf[2]); i++ )
	{
	    pmod->coils[(bitaddr/8)+i].last_read = rxp->rxbuf[3+i];
	    pmod->coils[(bitaddr/8)+i].data_valid = TRUE;
	}

	return(TRUE);

    }
/*                                                             	
/* Readdis                                                      	
/*                                                              	
*/
static	unsigned short readdis (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned short readlen)

/* only called from scan_plc */

    {
	TXLINE  *txp;
	RXLINE  *rxp;

	unsigned short  i;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[1] =  MODDIREAD;
	txp->txbuf[2] =  (bitaddr >> 8);
	txp->txbuf[3] =  (bitaddr & 0xFF);
	txp->txbuf[4] =  (readlen >> 8);
	txp->txbuf[5] =  (readlen & 0xFF);

	makecrc(&(txp->txbuf[0]),MODREADMSGLEN,&(txp->txbuf[MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN+MODCRCLEN;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = FALSE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != mod) ||
	    (rxp->rxbuf[1] != MODDIREAD) ||
	    (rxp->rxbuf[2] != ((readlen+7)/8)))
	{
	    pmod->no_dataerr++;
	    return(FALSE);
	}

	/* Store the returned data                      */
	/*  data is aligned by 8 pseudo register        */
	/*  and a multiple of 8 bits long               */

	for ( i=0; (i<rxp->rxbuf[2]); i++ )
	{
	    pmod->dis[(bitaddr/8)+i].last_read = rxp->rxbuf[3+i];
	    pmod->dis[(bitaddr/8)+i].data_valid = TRUE;
	}

	return(TRUE);

    }
/*                                                               	
/* Readais                                                        	
/*                                                                	
*/
static	unsigned short readais (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short reglen)

/* only called from scan_plc */

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  buildreg;
	unsigned short  i,j;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[1] =  MODAIREAD;
	txp->txbuf[2] =  (regaddr >> 8);
	txp->txbuf[3] =  (regaddr & 0xFF);
	txp->txbuf[4] =  (reglen >> 8);
	txp->txbuf[5] =  (reglen & 0xFF);

	makecrc(&(txp->txbuf[0]),MODREADMSGLEN,&(txp->txbuf[MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN+MODCRCLEN;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = FALSE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != mod) ||
	    (rxp->rxbuf[1] != MODAIREAD) ||
	    (rxp->rxbuf[2] != (reglen*2)) )
	{
	    pmod->no_dataerr++;
	    return(FALSE);
	}

	/* Store the returned data                      */
	/*  data is aligned by 4 register sets          */
	/*  and a multiple of 4 registers long          */

	for ( i=0; (i<rxp->rxbuf[2]); i+=8 )
	{
	    for (j=0; (j<4); j++)
	    {
		buildreg = rxp->rxbuf[3+i+(j*2)];
		buildreg = (buildreg << 8) + rxp->rxbuf[3+i+(j*2)+1];
		pmod->ais[(regaddr/4)+(i/8)].aivals[j] = buildreg;
	    }
	    pmod->ais[(regaddr/4)+(i/8)].data_valid = TRUE;
	}

	return(TRUE);

    }
/*                                                                      	
/* Readregs                                                                	
/*                                                                            	
*/
static	unsigned short readregs (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short reglen)

/* only called from scan_plc */

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  buildreg;
	unsigned short  i,j;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[1] =  MODREGREAD;
	txp->txbuf[2] =  (regaddr >> 8);
	txp->txbuf[3] =  (regaddr & 0xFF);
	txp->txbuf[4] =  (reglen >> 8);
	txp->txbuf[5] =  (reglen & 0xFF);

	makecrc(&(txp->txbuf[0]),MODREADMSGLEN,&(txp->txbuf[MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN+MODCRCLEN;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = FALSE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != mod) ||
	    (rxp->rxbuf[1] != MODREGREAD) ||
	    (rxp->rxbuf[2] != (reglen*2)) )
	{
	    pmod->no_dataerr++;
	    return(FALSE);
	}

	/* Store the returned data                      */
	/*  data is aligned by 4 register sets          */
	/*  and a multiple of 4 registers long          */

	for ( i=0; (i<rxp->rxbuf[2]); i+=8 )
	{
	    for (j=0; (j<4); j++)
	    {
		buildreg = rxp->rxbuf[3+i+(j*2)];
		buildreg = (buildreg << 8) + rxp->rxbuf[3+i+(j*2)+1];
		pmod->regs[(regaddr/4)+(i/8)].ioregs[j] = buildreg;
	    }
	    pmod->regs[(regaddr/4)+(i/8)].data_valid = TRUE;
	}

	return(TRUE);

    }
/*                                                           		
/* Setcoil                                                        	
/*                                                                 	
*/
static	unsigned short setcoil (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned long mask, unsigned long val)

/* only called from checkoutputs */

    {
	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i, ix, lsignal;
	unsigned long lmask, lval, tmask ,tval;


	if (mask == 0)
		return(TRUE);
	tmask = lmask = mask;
	tval = lval = val;
	lsignal = bitaddr;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	 /* adjust the bits to the low order bit */

	while ((tmask & 1) == 0)
	{
	    tval = tval >> 1;          /* adjust the value */
	    tmask = tmask >> 1;         /* adjust the mask */
	}

	/* Is it a single coil output */

	if ((tmask & 2) == 0)
	{
	    /* Format the output message */

	    txp->txbuf[0] =  mod;
	    txp->txbuf[1] =  MODCOILWRITE;
	    txp->txbuf[2] =  (lsignal >> 8);
	    txp->txbuf[3] =  (lsignal & 0xFF);
	    txp->txbuf[4] =  (lval==0)?0:0xFF;  /* 0 => off  0xFF => on */
	    txp->txbuf[5] =  0;

	    makecrc(&(txp->txbuf[0]),MODSETCOILLEN,&(txp->txbuf[MODSETCOILLEN]));

	    txp->txmsglen = MODSETCOILLEN+MODCRCLEN;


	    /* Send out the message */

	    if (msgxfer(line,FIXEDRESP,pmod,MODWRITERESPLEN) == XFERBAD)
	    {
		pmod->no_offlines++;
	        pmod->holdflag = FALSE;
		pmod->is_responding = FALSE;
		return(FALSE);
	    }

	    /* Verify the response - the message is repeated back*/
	    for ( i=0; (i<MODSETCOILLEN); i++)
	    {
		if (txp->txbuf[i] != rxp->rxbuf[i])
		{
		    pmod->no_dataerr++;
		    return (FALSE);
		}
	    }
	    return(TRUE);
	}


	/* Must be a multiple coil output */

	else
	{
	    lmask = tmask;
	    lval = tval;

	    /* count the number of coils to output */
	    for ( i=0,tmask=1; ((tmask & lmask)!=0); i++)
	    	tmask = tmask << 1;

	    /* Format the output message */

	    txp->txbuf[0] =  mod;
	    txp->txbuf[1] =  MODMCOILWRITE;
	    txp->txbuf[2] =  (lsignal >> 8);
	    txp->txbuf[3] =  (lsignal & 0xFF);
	    txp->txbuf[4] =  (i >> 8);          /* number of coils */
	    txp->txbuf[5] =  (i & 0xFF );
	    txp->txbuf[6] =  (((i+7)/8) & 0xFF); /* number of data bytes */
	    txp->txbuf[7] =  (lval & 0xFF );
	    ix = 8;
	    if (i>8)
	    {
		txp->txbuf[ix++] =  ((lval >> 8) & 0xFF );
		if (i>16)
		{
		    txp->txbuf[ix++] =  ((lval >> 16) & 0xFF );
		    if (i>24)
		    {
			txp->txbuf[ix++] =  ((lval >> 24) & 0xFF );
		    }
		}
	    }

	    makecrc(&(txp->txbuf[0]),ix,&(txp->txbuf[ix]));

	    txp->txmsglen = ix+MODCRCLEN;


	    /* Send out the message */

	    if (msgxfer(line,FIXEDRESP,pmod,MODWRITERESPLEN) == XFERBAD)
	    {
		pmod->no_offlines++;
	        pmod->holdflag = FALSE;
		pmod->is_responding = FALSE;
		return(FALSE);
	    }

	    /* Verify the response - first part of the message is repeated back*/
	    for ( i=0; (i<MODMSETCOILRESPLEN); i++)
	    {
		if (txp->txbuf[i] != rxp->rxbuf[i])
		{
		    pmod->no_dataerr++;
		    return (FALSE);
		}
	    }
	    return(TRUE);
	}
    }
/*                                                                	
/* Setreg                                                       	
/*                                                                  	
*/
static	unsigned short setreg (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short val,double dblval, unsigned short conv)

/* only called from checkoutputs */

    {
	TXLINE 		 *txp;
	RXLINE 		 *rxp;
	unsigned short  i;
   	union 	u_value {
		    short		ivalue;
		    long		lvalue;
		    float		fvalue;
		    double		dvalue;
		    char		afvalue[100];
		}  uval;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	uval.fvalue = dblval;

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[2] =  (regaddr >> 8);
	txp->txbuf[3] =  (regaddr & 0xFF);

	if (conv != ASCFLT)
	{
	    txp->txbuf[1] =  MODREGWRITE;
	    txp->txbuf[4] =  (val >> 8);
	    txp->txbuf[5] =  (val & 0xFF);

	    makecrc(&(txp->txbuf[0]),MODSETREGLEN,&(txp->txbuf[MODSETREGLEN]));

	    txp->txmsglen = MODSETREGLEN+MODCRCLEN;

	    /* Send out the message */

	    if (msgxfer(line,FIXEDRESP,pmod, MODWRITERESPLEN) == XFERBAD)
	    {
	        pmod->no_offlines++;
	        pmod->holdflag = FALSE;
	        pmod->is_responding = FALSE;
	        return(FALSE);
	    }

	    /* Verify the response - the message is repeated back*/
	    for ( i=0; (i<MODSETREGLEN); i++)
	    {
		if (txp->txbuf[i] != rxp->rxbuf[i])
		{
		    pmod->no_dataerr++;
		    return (FALSE);
	        }
	    }

	    return(TRUE);
	}
	else
	{ /* Send out float as multiple register write */

	    txp->txbuf[1] =  MODMREGWRITE;
	    txp->txbuf[4] = 0x00;
	    txp->txbuf[5] = 0x02;	/* Number of registers */
	    txp->txbuf[6] = 0x04;	/* Number of bytes */

	    txp->txbuf[7] = (uval.lvalue >> 8) & 0xFF;
	    txp->txbuf[8] =  uval.lvalue & 0xFF;
	    txp->txbuf[9] = (uval.lvalue >> 24) & 0xFF;
	    txp->txbuf[10] = (uval.lvalue >> 16) & 0xFF;


	    makecrc(&(txp->txbuf[0]),MODSET2REGLEN,&(txp->txbuf[MODSET2REGLEN]));

	    txp->txmsglen = MODSET2REGLEN+MODCRCLEN;

	    /* Send out the message */

	    if (msgxfer(line,FIXEDRESP,pmod, MODWRITERESPLEN) == XFERBAD)
	    {
	        pmod->no_offlines++;
	        pmod->holdflag = FALSE;
	        pmod->is_responding = FALSE;
	        return(FALSE);
	    }

	    /* Verify the response - the message is repeated back*/
	    for ( i=0; (i<MODSETMREGRESPLEN); i++)
	    {
		if (txp->txbuf[i] != rxp->rxbuf[i])
		{
		    pmod->no_dataerr++;
		    return (FALSE);
	        }
	    }
	    return(TRUE);
	}
	return(FALSE);
    }

/*                                                                	
/*	Read Area Descriptors                                		
*/                                                                 	
/* only called from scan_plc */

static int loadinit (unsigned short line,MODPLC *pmod,unsigned short mod)
    {

	LOADINFO	*plinfo;
	char		filename[30];
	char		addr[8];
        int 		status;
	long		pos;
	unsigned short	prognum;

	plinfo = &linfo[line];	/* establish the pointer */
	/* If already one being loaded wait else claim it */
	if (plinfo->loading)
		return(0);
	plinfo->line = line;	/* easy way to find it */
	plinfo->loading = TRUE;
	plinfo->pmod = pmod;
	plinfo->mod = mod;
	prognum = pmod->prog_load_number;

	/* Make File Name	*/
	strcpy(plinfo->filename,"P");
	addr[0] = 'L';			/* Line Number */
	addr[1] = '0'+(line/10);
	addr[2] = '0' + (line % 10);
	addr[3] = 'A';			/* Address */
	addr[4] = '0'+(mod/10);
	addr[5] = '0' + (mod % 10);
	addr[6]	= '0' + (prognum % 10);
	addr[7] = 0;
	strcat(plinfo->filename,addr);
	strcat(plinfo->filename,".prg");

	/* Open File	*/
	iam(user,password);
	if ((plinfo->loadfile = fopen(&plinfo->filename[0],"r")) == NULL)
	{
	    terminateload(plinfo,line,FALSE,CANNOTOPENFILE);
	    return(-1);
	}

	/* Seek to First Area */
	plinfo->fileaddr = (PAGE0*WORDLEN);
	if (pos = fseek(plinfo->loadfile,plinfo->fileaddr,0) !=
		OK)
	{
	    terminateload(plinfo,line,FALSE,CANNOTSEEKTO);
	    return(-1);
	}

	/* Read First Dump Block */
	if (fread(&plinfo->dadesc[0],1,DUMPAREASIZE,plinfo->loadfile) !=
		DUMPAREASIZE)
	{
	    terminateload(plinfo,line,FALSE,CANNOTREAD);
	    return(-1);
	}

	/* Seek to Next Area */
	plinfo->fileaddr = (PAGEF*WORDLEN);
	if (pos = fseek(plinfo->loadfile,plinfo->fileaddr,0) !=
		OK)
	{
	    terminateload(plinfo,line,FALSE,CANNOTSEEKTO);
	    return(-1);
	}

	/* Read Next Dump Block */
	if (fread(&plinfo->dadesc[1],1,DUMPAREASIZE,plinfo->loadfile) !=
		DUMPAREASIZE)
	{
	    terminateload(plinfo,line,FALSE,CANNOTREAD);
	    return(-1);
	}

	/* Seek to Next Area */
	plinfo->fileaddr = (ASCII*WORDLEN);
	if (pos = fseek(plinfo->loadfile,plinfo->fileaddr,0) !=
		OK)
	{
	    terminateload(plinfo,line,FALSE,CANNOTSEEKTO);
	    return(-1);
	}

	/* Read Next Dump Block */
	if (fread(&plinfo->dadesc[2],1,DUMPAREASIZE,plinfo->loadfile) !=
		DUMPAREASIZE)
	{
	    terminateload(plinfo,line,FALSE,CANNOTREAD);
	    return(-1);
	}

	/* Seek to Last Area */
	plinfo->fileaddr = (FUTURE*WORDLEN);
	if (pos = fseek(plinfo->loadfile,plinfo->fileaddr,0) !=
		OK)
	{
	    terminateload(plinfo,line,FALSE,CANNOTSEEKTO);
	    return(-1);
	}

	/* Read Last Dump Block */
	if (fread(&plinfo->dadesc[3],1,DUMPAREASIZE,plinfo->loadfile) !=
		DUMPAREASIZE)
	{
	    terminateload(plinfo,line,FALSE,CANNOTREAD);
	    return(-1);
	}

	/* Seek to The First Area in the File */
	plinfo->fileaddr = ((plinfo->dadesc[0].areas[0].strtaddr)*WORDLEN);
	if (pos = fseek(plinfo->loadfile,plinfo->fileaddr,0) !=
		OK)
	{
	    terminateload(plinfo,line,FALSE,CANNOTSEEKTO);
	    return(-1);
	}

	/* LogOut on PLC	*/
	if (!plc_logout(plinfo))
	{
	    terminateload(plinfo,line,FALSE,CANNOTLOGOUT);
	    return(-1);
	}

	/* LogIn on PLC	*/
	if (!plc_login(plinfo))
	{
	    terminateload(plinfo,line,FALSE,CANNOTLOGIN);
	    return(-1);
	}

	/* Read The Machine State	*/
	if (!get_plc_state(plinfo, &plinfo->machstate))
	{
	    terminateload(plinfo,line,FALSE,CANNOTREAD);
	    return(-1);
	}

	/* If Memory Protect Abort */
	if ((plinfo->machstate & MEMPROTECT) == 0)
	{
	    terminateload(plinfo,line,FALSE,MEMORYPROTECT);
	    return(-1);
	}

	/* If Running Stop The Controller */
	if ((plinfo->machstate & RUNNINGSTATE) == 0)
	{
	    if(!plc_stop(plinfo))
	    {
		terminateload(plinfo,line,FALSE,PLCWONTSTOP);
		return(-1);
	    }
	}

	/* Check for dim Awareness */
	status = plc_getdim(plinfo);
	if (status < 0)
	{
	    terminateload(plinfo,line,FALSE,PLCWONTGETDIM);
	    return(-1);
	}

	/* If not in dim awareness */
	if (status == 0)
	{
	    /* Send to dim awareness */
	    if (!plc_setdim(plinfo))
	    {
		terminateload(plinfo,line,FALSE,PLCWONTSETDIM);
		return(-1);
	    }
	    /* Verify dim awareness */
	    status = plc_getdim(plinfo);
	    if (status != 1)
	    {
		terminateload(plinfo,line,FALSE,PLCWONTBEDIM);
		return(-1);
	    }
	}

	/* Initialize the Load Pointer to the first area */
	plinfo->ldblock = 0;
	plinfo->ldarea = 0;

	/* Set The Load State Variables */
	plinfo->pmod->prog_load_stat = PLC_LOAD_IN_PROGRESS;
	plinfo->pmod->prog_load_page = 0;

	return(0);
    }

/*                                                              	
/*	Load The Next Dump Block                               		
*/
/* only called from scan_plc */

static int loadnextblock (unsigned short line)
    {
	LOADINFO	*plinfo;
	unsigned short	type_mask,currarea;
	int		status;

	plinfo = &linfo[line];	/* establish the pointer */

	type_mask = ((plinfo->dadesc[plinfo->ldblock].areaspec << plinfo->ldarea) & AREATYPEMASK);
	switch (type_mask)
	{
	    case LOGICAREATYPE:
		status = loadlogic(plinfo);
		break;
	    case ASCIIAREATYPE:
		status = loadmemory(plinfo,ASCIIAREATYPE);
		break;
	    case MEMORYAREATYPE:
	    default:
		status = loadmemory(plinfo,MEMORYAREATYPE);
		break;
	}

	if (status != 0)
		return(-1);
	currarea = ((plinfo->ldblock*AREASPERBLK)+plinfo->ldarea);
	if (  currarea == CONFIGAREA)
	{
	    /* Exit Dim Arareness with a start command*/
	    if (!plc_start(plinfo))
	    {
		terminateload(plinfo,line,FALSE,PLCWONTSTART);
		return(-1);
	    }

	    /* !!Three messages were issued here: 	*/
	    /*	 sf=0x31				*/
	    /*	 sf=0x34				*/
	    /*	confirm dim awareness			*/

	    /* Init PLC (Special Message Issued Here) initialize msg*/
	    status = plc_init(plinfo);
	    if (!status)
	    {
		terminateload(plinfo,line,FALSE,PLCWONTINIT);
		return(-1);
	    }

	    /* Read and Save the Run Load Switch from the PLC */
	    if (!getrunmode(plinfo, &plinfo->rlmode))
	    {
		terminateload(plinfo,line,FALSE,CANTGETMODE);
		return(-1);
	    }

	    /* Set the Run Load Switch to Load */
	    if (!setrunmode(plinfo, LOADSWITCH))
	    {
		terminateload(plinfo,line,FALSE,CANTSETLOADMODE);
		return(-1);
	    }

	}

	/* Advance the block and area pointers for the next load operation */
	plinfo->ldarea = ((plinfo->ldarea+1) % AREASPERBLK);
	if (plinfo->ldarea == 0)
		plinfo->ldblock++;

	plinfo->pmod->prog_load_page = currarea+1;

	/* When we reach the end clean up and enable the next load */
	if (plinfo->ldblock >= NUMDUMPAREAS)
	{
	    terminateload(plinfo,line,TRUE,LOADOK);
	}

	return(0);

    }
/*                                                                      	
/*	Load a Logic Area                                                	
*/                                                                        	
/* only called from loadnextblock */

static int loadlogic (LOADINFO *plinfo)
    {
	long  pos;
	short length,page,startaddr,startnode,endnode,dbix, status;
	short dowrite,endwritten,thisnodecount;
	unsigned char	databuf[MAXTXMSG];

	page = plinfo->dadesc[plinfo->ldblock].page;
	startaddr = plinfo->dadesc[plinfo->ldblock].areas[plinfo->ldarea].strtaddr;
	length = plinfo->dadesc[plinfo->ldblock].areas[plinfo->ldarea].length * NODELEN;
	startnode = FALSE;
	endnode = FALSE;
	endwritten = FALSE;
	dowrite = FALSE;
	dbix = 0;
	thisnodecount = 0;

	while(length)
	{
	    /* While there are nodes to read */
	    /* Read a node (3 Bytes) if error abort */
	    status = fread(&databuf[dbix],1,NODELEN,plinfo->loadfile);
	    if (status == 0)
	    {
		terminateload(plinfo,plinfo->line,FALSE,UNEXPECTDEOF);
		return(-1);
	    }
	    thisnodecount++;
	    length -= NODELEN;

	    /* If 5X0 set Endnode found */
	    if ((databuf[dbix] == EOLNODE) && (databuf[dbix+2] == 0))
		endnode = TRUE;

	    /* If (<5)XX (this is a start) and I already have one */
	    /*   backup and write what We have so far and resume */
	    if ( (databuf[dbix] <= BOCNODE) && (startnode) )
	    {
		/* Back up over start node from current position */
		pos = fseek(plinfo->loadfile,(long) -NODELEN,1);
		thisnodecount--;
		length += NODELEN;
		dowrite = TRUE;
		dbix -= NODELEN;
	    }

	    /* If this is the first start node set the flag */
	    if ( (databuf[dbix] < BOCNODE) && (!startnode) )
	    {
	        startnode = TRUE;
	    }

	    dbix += NODELEN;

	    if ( (length == 0) ||
		 (dowrite) || 
		 ( (!startnode) && (thisnodecount > 4) ) ||
		 (thisnodecount >= MAXMSGNODES) )
	    {
		if (!endwritten)
		{   /* Continue to read but don't write */
		    /* Write logic load message out */
		    status = writelogic(
		    plinfo,
		    page,
		    startaddr
		    ,dbix,
		    (char*)databuf);  /* databuf); ###*/
                                      /* cast because the local array is unsigned char */

		    /* Abort on error */
		    if (!status)
		    {
			terminateload(plinfo,plinfo->line,FALSE,LOGICWRITEERROR);
			return(-1);
		    }
		}
		dowrite = FALSE;
		startaddr += thisnodecount; /* Set Start for next block */
		thisnodecount = 0;
		startnode = FALSE;
		endwritten = endnode; 
		dbix = 0;		   /* Set index for next block */
 	    }
	}
	return(0);
    }
/*                                                       		
/*	Load A Memory or ASCII Area                                  	
*/
/* only called from loadnextblock */

static int loadmemory (LOADINFO *plinfo, unsigned short type)

    {
	short length,page,startaddr,dbix, status, thislength;
	char	databuf[MAXTXMSG];

	page = plinfo->dadesc[plinfo->ldblock].page;
	startaddr = plinfo->dadesc[plinfo->ldblock].areas[plinfo->ldarea].strtaddr;
	length = plinfo->dadesc[plinfo->ldblock].areas[plinfo->ldarea].length * WORDLEN;

	while(length)
	{
	    /* While there are nodes to read */
	    /* Read a block of data if error abort */
	    thislength = (length > MAXWORDMSGLEN) ? MAXWORDMSGLEN:length;
	    status = fread(databuf,1,thislength,plinfo->loadfile);
	    if (status == 0)
	    {
		terminateload(plinfo,plinfo->line,FALSE,UNEXPECTDEOF);
		return(-1);
	    }
	    length -= thislength;
	    if (type == MEMORYAREATYPE)
	    {
		status = writemem(plinfo,page,startaddr,thislength,databuf);
	    }
	    else
	    {
		status = writeascii(plinfo,page,startaddr,thislength,databuf);
	    }
	    /* Abort on error */
	    if (!status)
	    {
		terminateload(plinfo,plinfo->line,FALSE,MEMORYWRITEERROR);
		return(-1);
	    }
	    startaddr+=thislength/2;
	}
	return(0);
    }

/*                                                             	
/*	End The Load Sequence                                      	
*/
/* called from loadinit, loadnextblock, loadlogic, loadmemory */

static terminateload (LOADINFO *plinfo,unsigned short line,
	       unsigned short success,unsigned short code)
    {
	/* Close The File		*/
	fclose(plinfo->loadfile);

	/* Release for another PLC */
	plinfo->loading = FALSE;

	if (!success)
	{
	    plinfo->pmod->prog_load_stat = PLC_LOAD_FAILED;
	    plinfo->pmod->prog_load_code = code;
	    return;
	}

	/* Switch The Controller from Load to Run */
	if (!setrunmode(plinfo, RUNSWITCH))
	{
	    terminateload(plinfo,line,FALSE,CANTSETRUNMODE);
	    return(-1);
	}

	/* Set The Controller to the mode stored in the file */
	/* Which was read back from the controller after config area loaded */
	if (!setrunmode(plinfo, plinfo->rlmode))
	{
	    terminateload(plinfo,line,FALSE,CANTSETLOADEDMODE);
	    return(-1);
	}

	/* !!Two messages were issued here: 		*/
	/*	 sf=0x31				*/
	/*	 sf=0x34				*/

	if (!plc_logout(plinfo))
	{
	    terminateload(plinfo,line,FALSE,CANNOTLOGOUT);
	    return(-1);
	}

	/* Set Pmod status back to no loading */
	plinfo->pmod->prog_load_stat = PLC_NOT_LOADING;
	plinfo->pmod->prog_load_code = code;
	return;
    }

/*                                                            		
/*	PLC Logout                                                	
*/

/* called from scan_plc, loadinit, and terminateload  */


static int plc_logout (LOADINFO *plinfo)

    {
	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;	/* Address		*/
	txp->txbuf[1] =  MODLOAD;	/* Function Code	*/
	txp->txbuf[2] =  1;		/* Length		*/
	txp->txbuf[3] =  MODSFLOGOUT;	/* Subfunction Code 	*/

	makecrc(&(txp->txbuf[0]),4,&(txp->txbuf[4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    (rxp->rxbuf[1] != MODLOAD) ||
	    (rxp->rxbuf[2] != 2 ) ||
	    (rxp->rxbuf[3] != MODSFLOGOUT) ||
	    (rxp->rxbuf[4] != MODCMDDONE) )
	{
	    plinfo->pmod->no_dataerr++;
	    return(FALSE);
	}
	return(TRUE);
    }
/*                                                               	
/*	PLC Login                                                 	
*/

/* called from scan_plc and loadinit  */


static int plc_login (LOADINFO *plinfo)
    {
	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;	/* Address	*/
	txp->txbuf[1] =  MODLOAD;	/* Fuction Code	*/
	txp->txbuf[2] =  1;		/* Length	*/
	txp->txbuf[3] =  MODSFLOGIN;	/* Subfunction Code */

	makecrc(&(txp->txbuf[0]),4,&(txp->txbuf[4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    (rxp->rxbuf[1] != MODLOAD) ||
	    (rxp->rxbuf[2] != 2 ) ||
	    (rxp->rxbuf[3] != MODSFLOGIN) ||
	    ((rxp->rxbuf[4] & 0x80) != 0) )
	{
	    plinfo->pmod->no_dataerr++;
	    return(FALSE);
	}

	return(TRUE);
    }
/*                                                          		
/*	PLC Start                                                 	
*/
/* called from scan_plc and loadnextblock  */


static int plc_start (LOADINFO *plinfo)
    {
  	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;	/* Address	*/
	txp->txbuf[1] =  MODLOAD;	/* Fuction Code	*/
	txp->txbuf[2] =  1;		/* Length	*/
	txp->txbuf[3] =  MODSFSTART;	/* Subfunction Code */

	makecrc(&(txp->txbuf[0]),4,&(txp->txbuf[4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    ((rxp->rxbuf[1] & 0x7F) != MODLOAD) )
	{
	    plinfo->pmod->no_dataerr++;
	    return(FALSE);
	}

	/* Is it a command done */
	if ((rxp->rxbuf[1] == MODLOAD) &&
	    (rxp->rxbuf[3] == MODSFSTART) &&
	    (rxp->rxbuf[4] == MODCMDDONE) )
	{
	    return(TRUE);
	}

	/* Is it an ACK done */
	if ((rxp->rxbuf[1] == (0x80 + MODLOAD) )&&
	    (rxp->rxbuf[2] == MODCMDSTARTED) )
	{
	    return(pollfordone(plinfo, MODSFSTART, FALSE));
	}
	return(FALSE);
    }

/*                                                                	
/*	PLC Stop                                         		
*/

/* called from loadinit and scan_plc */


static int plc_stop (LOADINFO *plinfo)
    {
	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;	/* Address	*/
	txp->txbuf[1] =  MODLOAD;	/* Fuction Code	*/
	txp->txbuf[2] =  1;		/* Length	*/
	txp->txbuf[3] =  MODSFSTOP;	/* Subfunction Code */

	makecrc(&(txp->txbuf[0]),4,&(txp->txbuf[4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    ((rxp->rxbuf[1] & 0x7F) != MODLOAD) )
	{
	    plinfo->pmod->no_dataerr++;
	    return(FALSE);
	}

	/* Is it a command done */
	if ((rxp->rxbuf[1] == MODLOAD) &&
	    (rxp->rxbuf[3] == MODSFSTOP) &&
	    (rxp->rxbuf[4] == MODCMDDONE) )
	{
	    return(TRUE);
	}

	/* Is it an ACK done */
	if ( (rxp->rxbuf[1] == (0x80 + MODLOAD)) /*&&
	     (rxp->rxbuf[2] == MODCMDSTARTED) */ )
	{
	    return(pollfordone(plinfo, MODSFSTOP, FALSE));
	}
	return(FALSE);
    }
/*    									
/* pollfordone                                                     	
/*	subfunction                                                 	
/*                                                                  	
*/
/* called from plc_start, plc_stop, and writelogic  */


static int pollfordone (LOADINFO *plinfo, int subfunction, unsigned short geterrcode)
    {
	unsigned short i;
	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	for (i=0;i<MAXPOLLSFORDONE;i++)
	{

	    /* Format the output message */

	    txp->txbuf[0] =  plinfo->mod;	/* Address	*/
	    txp->txbuf[1] =  MODPOLL;		/* Fuction Code	*/

	    makecrc(&(txp->txbuf[0]),2,&(txp->txbuf[2]));

	    txp->txmsglen = 4;

	    /* Send out the message */

	    if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	    {
		plinfo->pmod->no_offlines++;
	    	plinfo->pmod->holdflag = FALSE;
		plinfo->pmod->is_responding = FALSE;
		return(FALSE);
	    }

	    /* May be used to fetch error code only */
	    if (geterrcode)
	    	return (TRUE);

	    /* Verify the response */

	    if ((rxp->rxbuf[0] == plinfo->mod) &&
		(rxp->rxbuf[1] == MODPOLL) &&
		(rxp->rxbuf[2] == 2 ) &&
		(rxp->rxbuf[3] == subfunction) &&
		(rxp->rxbuf[4] == MODCMDDONE) )
	    {
		return(TRUE);
	    }
	}
	return(FALSE);
    }
/* 										
/*	PLC Init                                                     		
*/                                                                      	
/* only called from loadnextblock  */

static int plc_init (LOADINFO *plinfo)
    {
	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;		/* Address		*/
	txp->txbuf[1] =  MODLOAD;		/* Fuction Code		*/
	txp->txbuf[2] =  1;			/* Length		*/
	txp->txbuf[3] =  MODSFINITIALIZE;	/* Subfunction Code 	*/

	makecrc(&(txp->txbuf[0]),4,&(txp->txbuf[4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    (rxp->rxbuf[1] != MODLOAD) ||
	    (rxp->rxbuf[2] != 2 ) ||
	    (rxp->rxbuf[3] != MODSFINITIALIZE) ||
	    (rxp->rxbuf[4] != MODCMDDONE) )
	{
	    plinfo->pmod->no_dataerr++;
	    return(FALSE);
	}
	return(TRUE);
    }
/*                    								
/*	Get Dim Awareness                                                   	
/*		-1 => error    0 => not dim   1=> dim                       	
*/
/* only called from loadinit  */

static int plc_getdim (LOADINFO *plinfo)
    {
	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;	/* Address	*/
	txp->txbuf[1] =  MODLOAD;	/* Fuction Code	*/
	txp->txbuf[2] =  1;		/* Length	*/
	txp->txbuf[3] =  MODSFCHKDIM;	/* Subfunction Code */

	makecrc(&(txp->txbuf[0]),4,&(txp->txbuf[4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(-1);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    (rxp->rxbuf[1] != MODLOAD) ||
	    (rxp->rxbuf[3] != MODSFCHKDIM) )
	{
	    plinfo->pmod->no_dataerr++;
	    return(-1);
	}

	if  (rxp->rxbuf[4] == 0)
		return(0); /* Not in Dim Awareness */

	return(1); /* Am in Dim Awareness */
    }

/*          									
/*	Set Dim Awareness                                                   	
*/
/* only called from loadinit  */

static int plc_setdim (LOADINFO *plinfo)
    {
	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;	/* Address	*/
	txp->txbuf[1] =  MODLOAD;	/* Fuction Code	*/
	txp->txbuf[2] =  1;		/* Length	*/
	txp->txbuf[3] =  MODSFENTERDIM;	/* Subfunction Code */

	makecrc(&(txp->txbuf[0]),4,&(txp->txbuf[4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    (rxp->rxbuf[1] != MODLOAD) ||
	    (rxp->rxbuf[3] != MODSFENTERDIM) ||
	    (rxp->rxbuf[4] != MODCMDDONE) )
	{
	    plinfo->pmod->no_dataerr++;
	    return(FALSE);
	}
	return (TRUE);
    }
/*                                                			
/*	Set Run Mode                                                	
*/
/* called from loadnextblock and terminateload  */

static int setrunmode (LOADINFO *plinfo, short value)
    {
	return (writemem(
		plinfo,
		0,
	 	RUNLOADSWITCHADDR,
	 	2,
		(char*)&value));  /* &value)); ### */
			   /* (wep: cast required when prototyping was performed. */
    }

/*                                            				
/*	Get Run Mode                                               	
*/
/* only called from loadnextblock  */

static int getrunmode (LOADINFO *plinfo, short *pvalue)
    {
	return (readmem(
		plinfo,
		0,
		RUNLOADSWITCHADDR,
		2,
		(char*)pvalue)); /* pvalue)); ###*/
    }

/*                                                                 	
/*	Get Machine State                                          	
*/
/* only called from loadinit  */

static int get_plc_state (LOADINFO *plinfo, short *pvalue)
    {
	return (readmem(
		plinfo,
		0,
		MACHINESTATEADDR,
		2,
		(char*)pvalue));  /* pvalue)); ###*/
    }

/*                                                                	
/*	Read Memory (Page,Address,datalength,buffer)               	
*/
/* called from getrunmode and get_plc_state */

static int readmem (LOADINFO *plinfo, unsigned short page, unsigned short address,
	     unsigned short datalen, char *databuf)
    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short	i;
	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;		/* Address		*/
	txp->txbuf[1] =  MODLOAD;		/* Fuction Code		*/
	txp->txbuf[2] =  5;			/* Length		*/
	txp->txbuf[3] =  MODSFREADMEM;		/* Subfunction Code 	*/
	txp->txbuf[4] =  (datalen/2);		/* Count of elements 	*/
	txp->txbuf[5] =  page;			/* Memory Page 		*/
	txp->txbuf[6] =  (address >> 8);	/* Address High 	*/
	txp->txbuf[7] =  (address & 0xFF);	/* Address Low 		*/

	makecrc(&(txp->txbuf[0]),8,&(txp->txbuf[8]));

	txp->txmsglen = 10;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    (rxp->rxbuf[1] != MODLOAD) ||
	    (rxp->rxbuf[2] != datalen+5) ||
	    (rxp->rxbuf[3] != MODSFREADMEM) ||
	    (rxp->rxbuf[4] != (datalen/2)) ||
	    (rxp->rxbuf[5] != page) ||
	    (rxp->rxbuf[6] != (unsigned char)(address >> 8)) ||
	    (rxp->rxbuf[7] != (unsigned char)(address &0xFF))  )
	{
	    plinfo->pmod->no_dataerr++;
	    return(FALSE);
	}
	/* move in the data */
	for (i=0;(i<datalen);i++)
	{
	    databuf[i] = rxp->rxbuf[8+i];
	}
	return (TRUE);
    }
/*                                                            		
/*	Write Memory (Page,Address,datalength,buffer)              	
*/
/* called from loadmemory and setrunmode */

static int writemem (LOADINFO *plinfo, unsigned short page, unsigned short address,
	     unsigned short datalen, char *databuf)
    {
	unsigned short i;
	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;	/* Address	*/
	txp->txbuf[1] =  MODLOAD;	/* Fuction Code	*/
	txp->txbuf[2] =  5+datalen;	/* Length	*/
	txp->txbuf[3] =  MODSFWRITEMEM;	/* Subfunction Code */
	txp->txbuf[4] =  (datalen/2);	/* Count of elements */
	txp->txbuf[5] =  page;		/* Memory Page */
	txp->txbuf[6] =  (address >> 8);	/* Address High */
	txp->txbuf[7] =  (address & 0xFF);	/* Address Low */

	/* move in the data */
	for (i=0;(i<datalen);i++)
	{
	    txp->txbuf[8+i] = databuf[i];
	}
	makecrc(&(txp->txbuf[0]),8+datalen,&(txp->txbuf[8+datalen]));

	txp->txmsglen = 10+datalen;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response is command done*/

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    (rxp->rxbuf[1] != MODLOAD) ||
	    (rxp->rxbuf[2] != 2) ||
	    (rxp->rxbuf[3] != MODSFWRITEMEM) ||
	    (rxp->rxbuf[4] != MODCMDDONE)  )
	{
	    plinfo->pmod->no_dataerr++;
	    return(FALSE);
	}
	return (TRUE);
    }
/*                                                                	
/*	Write Logic (Page,Address,datalength,buffer)               	
*/
/* only called from loadlogic */

static int writelogic (LOADINFO *plinfo, unsigned short page, unsigned short address,
	     unsigned short datalen, char *databuf)
    {
	unsigned short i;
	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;		/* Address		*/
	txp->txbuf[1] =  MODLOAD;		/* Fuction Code		*/
	txp->txbuf[2] =  5+datalen;		/* Length		*/
	txp->txbuf[3] =  MODSFWRITENODE;	/* Subfunction Code 	*/
	txp->txbuf[4] =  (datalen/3);		/* Count of elements 	*/
	txp->txbuf[5] =  page;			/* Memory Page 		*/
	txp->txbuf[6] =  (address >> 8);	/* Address High 	*/
	txp->txbuf[7] =  (address & 0xFF);	/* Address Low 		*/

	/* move in the data */
	for (i=0;(i<datalen);i++)
	{
	    txp->txbuf[8+i] = databuf[i];
	}
	makecrc(&(txp->txbuf[0]),8+datalen,&(txp->txbuf[8+datalen]));

	txp->txmsglen = 10+datalen;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}


	/* Verify the response is command done*/

	if ((rxp->rxbuf[0] == plinfo->mod) &&
	    (rxp->rxbuf[1] == MODLOAD) &&
	    (rxp->rxbuf[2] == 2) &&
	    (rxp->rxbuf[3] == MODSFWRITENODE) &&
	    (rxp->rxbuf[4] == MODCMDDONE)  )
	{
	    return(TRUE);
	}

	/* Is it an ACK done */
	if ((rxp->rxbuf[1] == (0x80 + MODLOAD) )&&
	    (rxp->rxbuf[2] == MODCMDSTARTED) )
	{
	    return(pollfordone(plinfo, MODSFWRITENODE, FALSE));
	}
	pollfordone(plinfo, MODSFWRITENODE, TRUE);
	return(FALSE);
    }
/*                                                            		
/*	Write Ascii (Page,Address,datalength,buffer)              	
*/
/* only called from loadmemory */

static int writeascii (LOADINFO *plinfo, unsigned short page, unsigned short address,
	     unsigned short datalen, char *databuf)
    {
	unsigned short i;
	TXLINE  *txp;
	RXLINE  *rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;		/* Address		*/
	txp->txbuf[1] =  MODLOAD;		/* Fuction Code		*/
	txp->txbuf[2] =  5+datalen;		/* Length		*/
	txp->txbuf[3] =  MODSFWRITEASCII;	/* Subfunction Code 	*/
	txp->txbuf[4] =  (datalen/2);		/* Count of elements 	*/
	txp->txbuf[5] =  page;			/* Memory Page 		*/
	txp->txbuf[6] =  (address >> 8);	/* Address High 	*/
	txp->txbuf[7] =  (address & 0xFF);	/* Address Low 		*/

	/* move in the data */
	for (i=0;(i<datalen);i++)
	{
	    txp->txbuf[8+i] = databuf[i];
	}
	makecrc(&(txp->txbuf[0]),8+datalen,&(txp->txbuf[8+datalen]));

	txp->txmsglen = 10+datalen;

	/* Send out the message */

	if (msgxfer(plinfo->line,VARRESP,plinfo->pmod,0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = FALSE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response is command done*/

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    (rxp->rxbuf[1] != MODLOAD) ||
	    (rxp->rxbuf[2] != 2) ||
	    (rxp->rxbuf[3] != MODSFWRITEASCII) ||
	    (rxp->rxbuf[4] != MODCMDDONE)  )
	{
	    plinfo->pmod->no_dataerr++;
	    return(FALSE);
	}
	return (TRUE);
    }
/*                                                                           	
/* makecrc 									
/*                                                                        	
*/
/* called from msgxfer, modloopback, readcoils, readdis, readais, readregs, setcoil, setreg,  */
/*             plc_logout, plc_login, plc_start, plc_stop, pollfordone, plc_init, plc_getdim, */
/*             plc_setdim, readmem, writemem, writelogic, and writeascii */

static	void makecrc (unsigned char *chkbuf, int len,char unsigned *retbuf)

    {
	unsigned short checksum;
	unsigned int     i, j;
	unsigned short   flag;
	unsigned char   tempch;

	checksum = 0x0ffff;
	for (j = 0; j < len; j++)
	{
	    tempch = chkbuf [j];
	    checksum ^= tempch;
	    for (i = 0; i < 8; i++)
	    {
		flag = checksum & 1;
		checksum >>= 1;
		if (flag)
		{
		    checksum ^= (unsigned short) 0x0a001;
		}
	    }
	}
	retbuf[1] = ((checksum >> 8) & 0xff);
	retbuf[0] = (checksum & 0xff);
}/*                                                                        	
/*      hexascii                                                            	
/*                                                                          	
/*      The purpose of this routine is to convert the hex byte to 2 ascii   	
/*      characters and to place them into the buffer.                       	
/*                                                                          	
*/
/* not called from within this driver */


static	void hexascii (unsigned short val,char *buf)

    {
	char    hi,lo;

	hi = ((val & 0x0f0) >> 4);
	lo = (val & 0x0f);

	if (hi<=9)
		hi+='0';
	else
		hi+=('A'-10);
	if (lo<=9)
		lo+='0';
	else
		lo+=('A'-10);

	buf[0] = hi;
	buf[1] = lo;

    }









/*                                                                         	
/*      asciihex                                                    	   	
/*                                                                         	
/*      The purpose of this routine is to convert the next 2 ascii         	
/*      characters in the buffer to hex and return them in val. It         	
/*      will return TRUE if good conversion of FALSE if bad.               	
*/                                                                         	
/* not called from within this driver */


static	short asciihex (unsigned short *val,char *buf)

    {
	if ((buf[0] < '0') || (buf[0] > 'F')) return (FALSE);
	if ( buf[0] <= '9') *val = ((buf[0] & 0x0f) << 4);
	else
	{
	    if (buf[0] < 'A') return (FALSE);
	    else *val = ((buf[0] - 'A' + 10) << 4);
	}
	if ((buf[1] < '0') || (buf[1] > 'F')) return (FALSE);
	if ( buf[1] <= '9') *val += (buf[1] & 0x0f);
	else
	{
	    if (buf[1] < 'A') return (FALSE);
	    else *val += (buf[1] - 'A' + 10);
	}
	return (TRUE);
    }

/*                                                                          	
/*      dump_mod_table                                                       	
/*                                                                           	
/*      The purpose of this routine is to dump the module description        	
/*      portion of the analog devices driver tables for the selected line.   	
/*      It will print out two lines for each module which is responding.     	
/*      The first line will give the general module header, the second line 	
/*      will give module type specific info.                                	
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)

    {
	MODPLC  *pmod;
	short           ix;
	unsigned	short	i, n, j; 

	MODCOILS	*coilptr;
	MODDIS		*diptr;
	REGISTERS	*regptr;
	MODAIS		*aiptr;
	unsigned	short req, val, value, addr, firstaiinblk, firstreginblk, linecnt;
	unsigned	long	bigvalue;
	unsigned	char	buffer[200];


	pmod = plcs[line][maddr];
	if (!pmod)
	{
	    logMsg("Line/ModbusAddress Not Defined \n");
	    return;
	}

	printf (" Was requested = %d \n", pmod->was_requested);
	printf (" Is responding = %d \n", pmod->is_responding);
	printf (" Prog Load State = %d \n", pmod->prog_load_stat);
	printf (" Prog Load Page = %d \n",  pmod->prog_load_page);
	printf (" Prog Number = %d \n", pmod->prog_load_number);
	printf (" # Output messages = %d \n", pmod->no_dataout_msgs);
	printf (" # Data in messages = %d \n", pmod->no_datain_msgs);
	printf (" #No Rx Response = %d \n", pmod->no_rxnoresp);
	printf (" #No Tx Responses = %d \n", pmod->no_txnoresp);
	printf (" #Data Errors = %d \n", pmod->no_dataerr);
	printf (" #Retries = %d \n", pmod->no_retries);
	printf (" #Rx Hw Errors = %d \n", pmod->no_rxhwerrs);
	printf (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs);
	printf (" #Crc Errors = %d \n", pmod->no_crcerrs);
	printf (" #Off Lines = %d \n", pmod->no_offlines);
	printf (" Reset Statistics = %d \n", pmod->cmd_reset_stat);
	printf (" Force Offline = %d \n", pmod->cmd_force_offline);
	printf (" #Failed Outputs = %d \n", pmod->badoutcnt);


	printf (" Resource Responding = %d \n", resresponse[line]);
	printf (" Module Is Responding = %d \n", pmod->is_responding );
	printf (" Hold flag  = %d \n", pmod->holdflag );


	linecnt = 1;
	printcoilhdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < (MAXCOILNO / 8); i += 4)
	{
		printf("  %4d    ", addr);
		for (n = 0; n < 4; n++)
		{		
		        coilptr = &pmod->coils[i+n];
			printf("%1x,  %1x,         %lx,\t", coilptr->was_requested, coilptr->data_valid, coilptr->last_read);
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + 4)  < (MAXCOILNO /8)) )
		{
			linecnt = 1;
			printcoilhdr(buffer, linecnt);
		}
		addr += 32;		
	}

	linecnt = 1;
	printdihdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < (MAXDINO / 8); i += 4)
	{
		printf("  %4d    ", addr);
		for (n = 0; n < 4; n++)
		{		
 			diptr = &pmod->dis[i+n];
			printf("%1x,  %1x,         %lx,\t", diptr->was_requested, diptr->data_valid, diptr->last_read);
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + 4)  < (MAXDINO /8)) )
		{
			linecnt = 1;
			printdihdr(buffer, linecnt);
		}
		addr += 32;		
	}


	linecnt = 1;
	printaihdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < MAXAINO; i += 8)
	{

		printf("  %4d\t", addr);
				   
		for (n = 0; n < 2; n++ )
		{		
		    aiptr = &pmod->ais[(i/4)+n];
		    printf("\t%1x, %1x,\t", aiptr->was_requested, aiptr->data_valid);
		    for (j = 0; j < 4; j++)
		    {
			printf("%6d,\t",  aiptr->aivals[j]);
		    }
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + 8)  < NUMMODAIS) )
		{
			linecnt = 1;
			printaihdr(buffer, linecnt);
		}
		addr += 8;		
	}

	linecnt = 1;
	printreghdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < MAXREGNO; i += 8)
	{
		printf("  %4d\t", addr);

		for (n = 0; n < 2; n++)
		{		
		    regptr = &pmod->regs[(i/4)+n];
		    printf("\t%1x, %1x,\t", regptr->was_requested, regptr->data_valid);
		    for (j = 0; j < 4; j++)
		    {
			printf("%6d,\t",regptr->ioregs[j]);
		    }
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + 8)  < NUMREGISTERS) )
		{
			linecnt = 1;
			printreghdr(buffer, linecnt);
		}
		addr += 8;		
	}
    }

/*
/* only called from dump_mod_table 
*/


static void printcoilhdr (unsigned char *buffer, unsigned short cnt)
{	
	taskDelay(180);
	printf("\n");
	sprintf(buffer,"                                                    PLC REPORT         ");
	printf( "%s\n", buffer);
	cnt += 1;
	printf("\n");
	cnt += 1;
        sprintf(buffer,"                                                   MODBUS COILS        ");
	printf( "%s\n", buffer);
	cnt += 1;
        sprintf(buffer,"          R   V      Value\tR   V      Value\tR   V      Value\tR   V      Value");
 	printf( "%s\n", buffer);
 	cnt += 1;
      /*     01234567891         01234567893         01234567895         0123456789 
			 01234567892         01234567894         01234567896	     01234456789
	*/
	printf ("\n");
	cnt += 1;
}
/*
/* only called from dump_mod_table
*/


static void printdihdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay(180);
	printf("\n");
	sprintf(buffer,"                                                    PLC REPORT         ");
	printf( "%s\n", buffer);
	cnt += 1;
	printf("\n");
	cnt += 1;
        sprintf(buffer,"                                              MODBUS DIGITAL INPUTS        ");
	printf( "%s\n", buffer);
	cnt += 1;
        sprintf(buffer,"          R   V      Value\tR   V      Value\tR   V      Value\tR   V      Value");
	printf( "%s\n", buffer);
 	cnt += 1;
      /*     01234567891         01234567893         01234567895         0123456789 
			 01234567892         01234567894         01234567896	     01234456789
	*/
	printf ("\n");
	cnt += 1;
}
/*
/* only called from dump_mod_table
*/


static void printaihdr(unsigned char *buffer, unsigned short cnt)
{
	taskDelay(180);
	printf("\n");
	sprintf(buffer,"                                               PLC REPORT         ");
	printf( "%s\n", buffer);
	cnt += 1;
	printf("\n");
	cnt += 1;
       sprintf(buffer,"                                            MODBUS ANALOG INPUTS        ");
	printf( "%s\n", buffer);
	cnt += 1;
       sprintf(buffer,"\t\tR  V\tValue\tValue\tValue\tValue\t\tR  V\tValue\tValue\tValue\tValue");
 	printf( "%s\n", buffer);
 	cnt += 1;
      /*     01234567891         01234567893         01234567895         0123456789 
			 01234567892         01234567894         01234567896	     01234456789
	*/
	printf ("\n");
	cnt += 1;
}

/*
/* only called from dump_mod_table
*/


static void printreghdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay(180);
	printf("\n");
	sprintf(buffer,"                                               PLC REPORT         ");
	printf( "%s\n", buffer);
	cnt += 1;
	printf("\n");
	cnt += 1;
       sprintf(buffer,"                                             MODBUS REGISTERS        ");
	printf( "%s\n", buffer);
	cnt += 1;
       sprintf(buffer,"\t\tR  V\tValue\tValue\tValue\tValue\t\tR  V\tValue\tValue\tValue\tValue");
 	printf( "%s\n", buffer);
 	cnt += 1;
      /*     01234567891         01234567893         01234567895         0123456789 
			 01234567892         01234567894         01234567896	     01234456789
	*/
	printf ("\n");
	cnt += 1;

}
/*                                                               		
**                                                                	 	
**	The purpose of this routine is to display the contents            	
**	of the static variables contained within this driver.             	
**                                                                        	
*/

/* this routine not called from within this driver */


LINEINFO ()
{
	short	i;
	char	buffer[132];
	char	*resrsp;
	char	*lineact;


	printf("                                 Modbus Line Information Table         \n");
	printf("\n");
       printf(" Line        Pointer to        Resource      Resource       Line        Delay Times:       Activity\n");
       printf("Number      MODPLC Table         Name        Response     Activity      IM  .TX  TX.         Time\n");
        /*     01234567891         01234567893         01234567895         0123456789 
			 01234567892         01234567894         01234567896
	*/
	printf("\n");

	for (i=0; i < MODLINES; i++)
	{
		if(plcs[i] == NULL)
		{
			continue;
		}
		if (resresponse[i] == 0)
		{
			resrsp = "FALSE";
		}
		else
		{
			resrsp = "TRUE";
		}
		if (line_activity[i] == 0)
		{
			lineact = "FALSE";
		}
		else
		{
			lineact = "TRUE";
		}
		sprintf(buffer, "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
			i,plcs[i],&resnames[i],
			&resrsp[0],
			&lineact[0],
			intermsgdelay[i],
			pretxdelay[i],
			posttxdelay[i],
			activity_time[i]);
		printf( "%s\n", buffer);
	}
	return 0;
}

/*	End of File:	drvEnraf.c */
