/*drvInf7.h,v 1.1.1.1 1999/08/03 14:43:06 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
/*  File:     drvInf7.h
/*  Author:   Walter E. Palmer
/*  Created:  07/21/97
/*  Modified: 07/21/97    WEP:
/*        
/*  This file contains the data structures used by the Newport Infinity 7 I/O driver.
/*                                                                                  
*/

#define TRUE	1
#define FALSE	0
#define NULLP	0
#define CR	0x0d

/*	number of lines of Infinity 7 	*/

#define         INF7LINES	32

/*	number of Infinity 7 units per line */

#define         NUMUNITS       200

/* define Card types for the Infinity 7 */

#define	INF7AI		1
#define	INF7AO		2
#define	INF7BI		3
#define	INF7BO		4
#define INF7PSEUDO	33              /* Card number for pseudo i/o         */

/* Define the signal numbers */

#define	AITOTALSCALE	0
#define AITOTALOFFSET	1
#define	AITOTALDP	2
#define	AIBATCHSCALE	3
#define	AIBATCHLOAD	4
#define	AIBATCHDP	5
#define	AIAVGCONFIG	6
#define	AISETPOINT5	7
#define	AISETPOINT4	8
#define	AISETPOINT3	9
#define	AISETPOINT2	10
#define	AISETPOINT1	11
#define	AIOUTOFFSET	12
#define	AIOUTSCALE	13
#define	AISERIALDELAY	14
#define	AIRECOGCHAR	15
#define	AIINPUTOFFSET	16
#define	AIINPUTSCALE	17
#define	AISCALEOPERATOR	18
#define	AIPULSEDALARMNO	19
#define	AISERIALTIME	20
#define	AISERIALADDR	21
#define	AIPULSEDALARMTM	22
#define	AIGATETIME	23
#define	AINUMBERBATCHES	24
#define	AIBATCHVALUE	25
#define	AITOTAL		26
#define AITIMEHOUR	27
#define	AITIMEMIN	28
#define	AITIMESEC	29
#define MAXINF7AI	29

#define	BICINFIG4	0
#define	BICINFIG3	1
#define	BICINFIG2	2
#define	BICINFIG1	3
#define	BILOCKOUT3	4
#define	BILOCKOUT2	5
#define	BILOCKOUT1	6
#define	BIBUSFORMAT	7
#define	BIDATAFORMAT	8
#define	BISERIALCONFIG	9
#define	BIBAUDRATE	10
#define	BIUNITMEASURE2	11
#define	BIUNITMEASURE1	12
#define MAXINF7BI	(13 * 32)

/* Number of items */

#define MAXINF7AO	29
#define	MAXINF7BO	(13 * 32)

/* Define the masks for the binary values */

#define	DISPMODEMASK	0x07
#define	RUNMODEMASK	0x80

#define	CSUM_REQUIRED	0x01

/*
/*	Conversion types for analog inputs	*/
/*
*/
#define		AICNVINTEGER	10
#define		AICNVDOUBLEINT	11
#define		AICNVFLOAT	12
#define		AICNVDOUBLEFLT	13
#define		AICNVASCIIFLT	14
#define		AICNVSTATUS	15
#define		AICNVTIME	16
#define		AICNVASCII_2	17
#define		AICNVASCII_4	18
#define		AICNVASCII_12	19
#define		AICNVASCII_20	20
#define		MAXCONV		20

/* The following must match the definition in recChoice.ascii */

#define NOCONV 0
#define LINEAR 1
#define ASCFLT 2

/*
/*	Communications I/O Structures
/*
*/

#define		RXSEM		0
#define		TXSEM		1
#define		MAXRXMSG	256
#define		MAXTXMSG	256


typedef	struct {
	unsigned short		rxstate;
	unsigned short		fixedlen;
	unsigned short		rxmsglenexpected;
        unsigned short          rxmsglen;
       	unsigned short		rxix;
	SEMAPHORE		*semid;
	unsigned short		*status;
        unsigned char           txaddress;
        unsigned char           txfunction;
       	unsigned char		rxbuf [MAXRXMSG];
		} 	RXLINE;


typedef	struct {
	unsigned short		protocol;
	unsigned short		txdisable;
	unsigned short		txtocnt;
	unsigned short		txhwerrcnt;
	unsigned short		txmsglen;
	unsigned short		txix;
	SEMAPHORE		*semid;
	unsigned short		*status;
	unsigned char		txbuf [MAXTXMSG];
		} 	TXLINE;
/*
/*	Communications I/O Constants
/*
*/
#define		RXGOOD			1
#define		RXBAD			2
#define		RXTIMEOUT		60	/* 16 ms ticks 				*/
#define		ACTIVITYTIME		300	/* must see activity in 5 seconds 	*/

/*
#define		VARRESP			FALSE
#define		FIXEDRESP		TRUE
*/
#define		ONERETRY		0x8000	/* OR'ed into line number for xfermsg 	*/
#define		RXIGNORE		0
#define		RXBYTE1			1
#define		RXBYTE2			2

#define		TXGOOD			1
#define		TXBAD			2
#define		IO_TIMEOUT		3	/* Code returned by timer 		*/


#define		TXTIMEOUT		60	/* 16 ms ticks: one second              */

#define		MAXRETRYS		3	/* retransmission trys 			*/

#define		MAXCFGCK		8	/* Try to Bring online each cycle 	*/
#define		BRINGBACKCNT		4	/* Poll loops per cycle 		*/

#define		XFERGOOD		1
#define		XFERBAD			2

#define		RESNAMELEN		16	/* length of a resource name 		*/
#define		SLWWINDOW		900	/* # of ticks to allow slave to try 	*/


/* msgxfer testing data types */

#define         LOOPBACK                0





/*
/*	Internal IOC Structure for Tankway Unit
/*
*/
typedef	struct
{
	unsigned short	was_requested;
	unsigned short	data_valid;
	float		last_read;
} AIVAL;

typedef	struct
{
	unsigned short	was_requested;
	unsigned short	data_valid;
	unsigned short	output_ready;
	float		output_val;
	float		last_read;
} AOVAL;

typedef	struct
{
	unsigned short	was_requested;
	unsigned short	data_valid;
	unsigned long	last_read;
} BIVAL;

typedef	struct
{
	unsigned short	was_requested;
	unsigned short	data_valid;
	unsigned short	output_ready;
	unsigned long	output_val;
	unsigned long	output_mask;
	unsigned long	last_read;
} BOVAL;

typedef	struct
{
	unsigned short	was_requested;		/* 0  The scan task has accessed this RTU */
	unsigned short	is_responding;		/* 1  The RTU is responding		*/
	unsigned short  holdflag;		/*    The RTU data is in hold 		*/
	unsigned short  no_dataout_msgs;	/* 5  Count Output Msgs 		*/
	unsigned short  no_datain_msgs;		/* 6  Count Data Requests 		*/
	unsigned short  no_rxnoresp;		/* 7  Count No Responses 		*/
	unsigned short  no_txnoresp;		/* 8  Count No Responses 		*/
	unsigned short  no_dataerr;		/* 9  Count Message Echo Errors 	*/
	unsigned short  no_retries;		/* 10 Count Retries 			*/
	unsigned short  no_rxhwerrs;		/* 11 Count Comm Hardware Errors 	*/
	unsigned short  no_txhwerrs;		/* 12 Count Comm Hardware Errors 	*/
	unsigned short  no_crcerrs;		/* 13 Count CRC Errors 			*/
	unsigned short  no_offlines;		/* 14 Count Off Line Transitions	*/
	unsigned short  cmd_reset_stat;		/* 15 Comand to reset stats		*/
	unsigned short  cmd_force_offline;	/* 16 Command to Force Offline 		*/
	unsigned short  badoutcnt;		/* 17 Count Failed output commands 	*/
						/* 18 Back up Mode 1 = Auto 0 = Man	*/
						/* 19 Active Channel 1= Primary 0 = Backup */

        unsigned short  tscanpass;		/* Total number of scanpasses. incremented at */
                                                /*  the start of each unit scan.              */
        unsigned short  msgs;			/* Count of messages which got good responses. */
                                                /*  incremented on each exit from 'good' msgxfer */
        unsigned long   responsetime;		/* Total time(ticks) waiting for good responses. */
                                                /* accumu (exit-entry) time for 'good' msgxfers  */

	unsigned char	mode;			/* Instrument operating mode */
	unsigned char	disp_mode;		/* Instrument display mode */
	unsigned char	run_mode;		/* Instrument run mode */
	unsigned char	recog_char;		/* Serial recognition char */
	unsigned char	ser_addr;		/* Serial address */
	unsigned char	outputs_to_go;		/* Outputs have been requested */
	AIVAL		aival [MAXINF7AI + 1];
	AOVAL		aoval [MAXINF7AO + 1];
	BIVAL		bival [MAXINF7BI + 1];
	BOVAL		boval [MAXINF7BO + 1];
} INF7;

/*	Define the instrument operating modes	*/

#define	BATCH_MODE	0
#define	RATE_MODE	1
#define	SQRT_MODE	2

/*	Define the instrument display modes	*/

#define	DISPMODEFAULT	0
#define	DISP_RATE	1
#define	DISP_AVGRT	2
#define	DISP_BATCH	1
#define	DISP_NO_BATCHES	2
#define	DISP_TOTAL	3
#define	DISP_TIME	4

/*	Define the Instrument run mode	*/

#define	RUN_MODE	0
#define	STOP_MODE	1

/* task definitions */

#define INF7_STACK		8000   /* Stack size              */
#define	INF7_PRIORITY		152    /* default priority        */
#define	INF7_TASK_OPTIONS	8      /* Floating point          */



typedef struct
{
        unsigned long   TXintcount;
        unsigned long   RXintcount;
        unsigned long   RXbadcount;
        unsigned long   msgxfercount;
        unsigned long   startingtick;
} LINESTATS;


/* Trace Bit Definitions */

#define ALLTRAFFICTRACE      0x0001
#define MODBUSNACKTRACE      0x0002        /* MODBUS NACK errors.                               */
#define CONFIGURATIONTRACE   0x0010        /* trace configuration errors in driver calls.       */
#define RUNTIMEERRORTRACE    0x0020        /* trace run time errors in driver calls.            */
#define CALLREJECTTRACE      0x0040        /* trace non-error based driver call rejections.     */


/*	End of File:	drvInf7.h */
