/*drvMapbd.c,v 1.1.1.1 1999/08/03 14:43:18 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File: drvMapbd.c                                                                      
**  Edit:  04/20/94      WEP: created based on drvmodbus.c                                
**      :  06/06/94      WEP: modified msgxfer RX timing logic to handle long responses   
**      :  06/14/94      WEP: modified register_resource to print pointname causing error.
**      :  06/22/94      WEP: corrected performance and use of the cmd_force_offline flag.
**      :  07/13/94      WEP: modified AIDRIVER and BODRIVER to increment the 'badoutcnt' 
**                          : pseudo point counter when the output request is rejected    
**                          : due to the output queue being full.                         
**      :  07/14/94      WEP: modified master state logic in MAIN to detect and recover   
**                          : from the local and partner drivers being in lockstep.       
**      :  07/15/94         : added test of is_responding flag in checkoutputs and, if    
**                          : FALSE, discard the output queue entry.                      
**      :  11/11/94      WEP: modified allocated_map to wait to write pointer to the      
**                          : allocated pointer structure until the allocated memory has  
**                          : been completely initialized.                                
**      :  12/05/94      WEP: modified TABLEINFO to mask out MSBit of stat counts.        
**      :  01/17/95      WEP: implemented calls to watchdog timer logic in platform.      
**                          : add detailed driver call error tracing.                     
**      :  05/22/95      WEP: modified master loop logic to exit when local state is not  
**                          : master. This causes lockstep logic to function correctly.   
**                          : test for and conditionally display an illegal lstate message.
**      :  08/22/95      WEP: fixed bug in 'allocate_mapbd'                               
**      :  08/24/95      WEP: original mapboard specification wrong. valid response to    
**                          : a command is not echo of command. test for '77403 <cr><lf>' 
**      :  08/30/95      WEP: ignore error replies by ignoring 3rd character in reply.    
**                          : modify setalllamps to use the global(7777) address for all. 
*/

/*#define CALLS           1       ** enables driver call monitoring             */
/*#define TESTNOBOARD     1       ** enable code to fakeout mapboard in msgxfer */


#define  MAIN        mapbd_driver           /* NOTE: change here */
#define  AIDRIVER    mapbd_aidriver         /* NOTE: change here */
#define  AODRIVER    mapbd_aodriver         /* NOTE: change here */
#define  AOREAD      mapbd_aoread           /* NOTE: change here */
#define  BIDRIVER    mapbd_bidriver         /* NOTE: change here */
#define  BODRIVER    mapbd_bodriver         /* NOTE: change here */
#define  BOREAD      mapbd_boread           /* NOTE: change here */

#define  TRAFFICON   mapbdtrafficon         /* NOTE: change here */
#define  TRAFFICOFF  mapbdtrafficoff        /* NOTE: change here */
#define  TRACEON     mapbdtraceon           /* NOTE: change here */
#define  TRACEOFF    mapbdtraceoff          /* NOTE: change here */
#define  RTRACEON    mapbdrestraceon        /* NOTE: change here */
#define  RTRACEOFF   mapbdrestraceoff       /* NOTE: change here */
#define  TRACELEVEL  mapbdtrlv              /* NOTE: change here */

#define  STOPDRIVER  stopmapbd              /* NOTE: change here */
#define  STARTDRIVER startmapbd             /* NOTE: change here */
#define  SETDELAYS   mapbd_setdelays        /* NOTE: change here */
#define  TABLEINFO   mapbd_dmt              /* NOTE: change here */


#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>
#include <logLib.h>

#include <dbDefs.h>
#include <drvSup.h>
/*#include <module_types.h>*/
#include <drvMapbd.h>		          /* NOTE: change here */
#include <drvMapbd_proto.h> 		  /* NOTE: change here */
#include <restable.h>

/* static long	init(); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvMapbd={ 2,	NULL, init};

/*
**      External Line Level Data Structures (declared in drvcommon.c)
**
*/
extern	unsigned char	resnames[MAPLINES][RESNAMELEN];	/* array of resource name strings.		*/

extern	RES_TABLE	*prestable[MAPLINES];		/* array of pointers to resource tables 	*/

extern	unsigned short	resresponse[MAPLINES];		/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

extern	unsigned short	line_activity[MAPLINES];	/* true/false line active flag. calculated	*/
							/* using activity_time below. 			*/
extern	unsigned short	lastactivity[MAPLINES];		/* assigned value of line_activity prior to	*/
							/* it's recalculation.   			*/

extern	unsigned short	modtrace[MAPLINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/
extern	unsigned short	mltrace[MAPLINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/
extern	unsigned short	modrestrace[MAPLINES];		/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/

extern	SEM_ID		semids[MAPLINES][2];		/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

extern	short		linetimers[MAPLINES];		/* except on init (init_line_tabs), all		*/
							/* references are commented out		 	*/

extern	unsigned short	intermsgdelay[MAPLINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/
extern	unsigned short	pretxdelay[MAPLINES];		/* holds post RTS delay before TX. 		*/
extern	unsigned short	posttxdelay[MAPLINES];		/* holds post TX delay before dropping RTS. 	*/

extern	long		activity_time[MAPLINES];	/* holds timetick of last activity. used to	*/
							/* set line_activity flag  			*/

extern  SEM_ID		linemux[MAPLINES];		/* 1/03/94: mutual-exclusion semaphore for	*/
							/* shared resource of the data line 		*/
							/* controls access to common path shared by	*/
							/* data and diagnostic channels. 		*/
							/* originally designed for use with MDS remote	*/
							/* radio diagnostics. 				*/

extern  unsigned short  halfduplex[MAPLINES];           /* store half/full duplex line status           */

extern  unsigned short  pstatewait[MAPLINES];           /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */

/*
**      Storage for Mapbd Comm Line Structures
**
*/

static RXLINE          *rxlinetab[MAPLINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically           */
                                                          /* allocated comm controls/buffers            */

static TXLINE          *txlinetab[MAPLINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically           */
                                                          /* allocated comm controls/buffers            */



/*
**      Storage for Mapbd Data Image Structures
**
*/

static MAPBOARD		*map[MAPLINES];	                /* array of pointers to the fixed length        */
                                                        /* dynamically allocated map board control      */
                                                        /* and data structures.                         */

static OUTPUTQUE	*oq[MAPLINES];			/* array of ptrs to the line output queues and  */
                                                        /* their control structures                     */

static int		taskId [MAPLINES];
static short        watchdogId [MAPLINES];
static short   watchdogTimeout [MAPLINES];

static unsigned long	idle_time[MAPLINES];            /* holds tick value needed for next time to     */
							/* create activity on the comm line to show     */
                                                        /* redundant partner we are alive and well.     */


static char *tasknames[] = {"MAPBD Ch0","MAPBD Ch1","MAPBD Ch2","MAPBD Ch3",
                            "MAPBD Ch4","MAPBD Ch5","MAPBD Ch6","MAPBD Ch7",
                            "MAPBD Ch8","MAPBD Ch9","MAPBD Ch10","MAPBD Ch11",
                            "MAPBD Ch12","MAPBD Ch13","MAPBD Ch14",
                            "MAPBD Ch15","MAPBD Ch16","MAPBD Ch17",
                            "MAPBD Ch18","MAPBD Ch19","MAPBD Ch20"
			    };


static unsigned short trace[MAPLINES];
static unsigned short mapsim[MAPLINES];

static unsigned char mapboardok[8];




/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
    {
	return (0);
    }
/********
**
**	This routine enables simulation of mapboard
**
********/
void mapsimon (unsigned short line)
    {
	mapsim[line] = TRUE;
    }

/********
**
**	This routine disables simulation of mapboard
**
********/
void mapsimoff (unsigned short line)
    {
	mapsim[line] = FALSE;
    }

/********
**
**	This routine enables logging of comm trace messages
**
********/
void TRACEON (unsigned short line)
    {
	modtrace[line] = TRUE;
    }

/********
**
**	This routine disables logging of comm trace messages
**
********/
void TRACEOFF (unsigned short line)
    {
	modtrace[line] = FALSE;
    }

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFICON (unsigned short line)
    {
	trace[line] = trace[line] | ALLTRAFFICTRACE;
    }

/********
**
**	This routine disables detailed display of normal communications traffic
**
********/
void TRAFFICOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~ALLTRAFFICTRACE;
    }

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACEON (unsigned short line)
    {
	modrestrace[line] = TRUE;
    }

/********
**
**	This routine disables logging of resource trace messages
**
********/
void RTRACEOFF (unsigned short line)
    {
	modrestrace[line] = FALSE;
    }

/********
**
**	This routine controls logging of trace messages
**
********/
void TRACELEVEL (unsigned short line, unsigned short level)
    {
	mltrace[line] = level;
    }

/********
**
**	These routines enable and disable tracing of database configuration errors in driver calls
**
********/
void mapbdcontraceon (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }
void mapbdcontraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }

/********
**
**	These routines enable and disable tracing of runtime errors in driver calls
**
********/
void mapbdruntraceon (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }
void mapbdruntraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/********
**
**	These routines enable and disable tracing of call rejection errors in driver calls
**
********/
void mapbdrejecttraceon (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }
void mapbdrejecttraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }


int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
            /* if watchdog timer has been attached, detach it before deleting the task */
            if (taskId[ln])
            {
                tisWatchDogDetach(taskId[ln]);
            }
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER (unsigned short line,      /* the line number of this driver.                      */
                 char *mode,               /* UART initializations string (comma delimited ascii). */
                 unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                 unsigned short hdflag,    /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                 unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                 unsigned short delay2)    /* half duplex post TX, pre RTS drop delay.             */
{
	if (line < MAPLINES)
	{
	    taskId [line] = taskSpawn (tasknames[line],
                                     MAPBD_PRIORITY,
                                     MAPBD_TASK_OPTIONS,
                                     MAPBD_STACK,
                                     MAIN,
                                     line,
                                     mode,
                                     delay,
                                     hdflag,
                                     delay1,
                                     delay2,0,0,0,0);

	    logMsg ("Started the MAPBD driver on line %d\n",line,0,0,0,0,0);

/*	    remCurIdGet (user, password); */
	    return (1);
	}
	else
	{

	    logMsg ("Invalid line number %d\n", line,0,0,0,0,0);
	    return (-1);
	}
}


/********
**
** Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
**
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
    {
	intermsgdelay[line] = tickcount1;  /* at beginning new message/response sequence.               */
	halfduplex[line]    = hdflag;
	pretxdelay[line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay[line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
    }
/*											
**      MOD_driver                                                                      
**                                                                                     	
**      The purpose of this task is to scan the MAPBD plc                               
**      lines. It will maintain a configuration list supporting online additions       	
**      and replacement of modules, and maintain a table of most recently              	
**      scanned values.                                                                	
**                                                                                     	
*/                                                                                     	
/* not called from within this driver 						      */

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2)
    {
	unsigned short  cfgchk, cnt, modspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command,i;
	long	        this_time, last_time;
	MAPBOARD        *pmap;
	RXLINE          *rxp;
        int             temp;

        short  *ptable_id;

        mapboardok[0] = 0x37;
        mapboardok[1] = 0x37;
        mapboardok[2] = 0x34;
        mapboardok[3] = 0x30;
        mapboardok[4] = 0x33;
        mapboardok[5] = 0x20;
        mapboardok[6] = 0x0d;
        mapboardok[7] = 0x0a;

 /* Initialize the data structures */

	intermsgdelay[line] = delay;

	halfduplex[line]  = hdflag;
	pretxdelay[line]  = delay1;
	posttxdelay[line] = delay2;

	resresponse[line] = FALSE;
	resnames[line][0] = 0;
	prestable[line] = NULL;

/*	modtrace[line] = TRUE;
	mltrace[line] = 2;
	modrestrace[line] = TRUE;
*/
	modtrace[line] = FALSE;
	mltrace[line] = 0;            
	modrestrace[line] = TRUE; 
        trace[line] = 0;
	mapsim[line] = FALSE;

	activity_time[line] = tickGet ();
	lastactivity[line] = line_activity[line] = FALSE;

        idle_time[line] = tickGet();   /* used to manage periodic 'loopback' line activity.       */

        pstatewait[line] = 60;         /* will wait up to one minute for partner to become valid. */

/* wep: mapboard control & image initialization */
	pmap = map[line];
	if (pmap == NULL)
	{
		if (!allocate_mapbd(line))
			return;                /* if not allocated, try. if can't allocate, get out. */
	        pmap = map[line];
	}

/* wep: output queue initialization */
	oq[line] = (OUTPUTQUE *)calloc(1,(sizeof(OUTPUTQUE)));
	if (!oq[line])
	{
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}
        outqueinit (line);

/* wep: communication initialization */
	rxlinetab[line] = (RXLINE *)calloc(1,(sizeof(RXLINE)));
	if (!rxlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
	    return;
	}
	txlinetab[line] = (TXLINE *)calloc(1,(sizeof(TXLINE)));
	if (!txlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
	    return;
	}

        taskLock();  /* make terminal display easier to read - avoids interleaving of other task data */
	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
        taskUnlock();

	/* Initialize the Rx interrupts to receive once for activity check */
	/* enable the receiver interrupt after set to ignore */
	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);

/*                                                                                                      
**         initialize mutual-exclusion semaphore logic for diagnostic driver path sharing. The Take/Put
**         logic implemented below is designed to insure, under heavy diagnostic demand, that scan_plc	
**         and the on_line while routine are executed once for every two diagnostic Take/Put sequences. 
**         Furthermore, diagnostic activities are suspended during master/slave arbitration by Taking  	
**         the semaphore while the local state is not the master state.                                	
**
*/   
/*	taskDelay(300); */
/*	printf("\n###########\nModicon: CREATE MUTUAL-EXCLUSION SEMAPHORE \n#############\n"); */
/*	taskDelay(60); */

        taskLock();
	linemux[line]=semMCreate (SEM_Q_PRIORITY); /* default: semaphore initializes as 'full',       */
                                                   /* ready to be Taken.                              */
	if (!linemux[line])
	{
	    logMsg  ("Not enough memory for line %d data structure (mutual-exclusion semaphore)\n",line);
            taskUnlock();
	    return;
        }
/*	logMsg ("Mapbd: semShow to follow...\n"); */
/*        semShow(linemux[line],1); */
        if ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)
        {
	      logMsg ("Mutual-Exclusion Semaphore Timeout on Line\n",line);
              taskDelay(300);
	}
/*	logMsg ("Mapbd: semShow to follow...\n"); */
/*        semShow(linemux[line],1); */
        taskUnlock();
	taskDelay(120);/* short delay for diagnostic readability */


	/* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
	while ( (resnames[line][0] == 0) || (prestable[line] == NULL) )
	{
	    if (mltrace[line] == 1)
	    	logMsg ( "No Resource Defined for line - %d \n", line);
	    taskDelay (600);
	}

        /* attach this driver task to the watchdog timer monitoring function. */
        ptable_id = &watchdogId[line];
        if (tisWatchDogAttach(taskId[line], WATCHDOGTIMEOUT, ptable_id) != OK)
        {
            logMsg("Attempt at watchdog attachment failed.\n");
            tisWatchDogDetach(taskId[line]);
            return;
        }
        if (tisWatchDogPulse(watchdogId[line]) != OK)
        {
            logMsg("First attempt at watchdog pulsing failed.\n");
            tisWatchDogDetach(taskId[line]);
            return;
        }

	/* Start out as slave */

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

	resClearCaAnswer(prestable[line]);		/* start quiet */
	resPutLocalState(prestable[line], RES_SLV);
	if (modrestrace [line])
	{
		logMsg ("1] Initialized as RES_SLV");
	}
        /* wait finite time for pstate to be resolved */

        logMsg ("Begin wait for pstate to become valid.\n");
        for (i = 0; i <= pstatewait [line]; i++)
        {
            resGetStates (prestable [line], &lstate, &pstate);
	    if ((pstate != 0) && (pstate != RES_ISOLATED) && (pstate != RES_CHANGED))
	    {
		break;
	    }
            taskDelay (60);
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/
        }
        if (pstate == 0)
	{
            logMsg ("Timeout of pstate wait.\n");
        }
	else
	{
            logMsg ("Completion of pstate wait.\n");
	}
/*	activity = check_line_activity(line, ACTIVITYTIME);  ** ten seconds */
        for (i = 0; i < ACTIVITYTIME/10; i++)
        {
            taskDelay(10);
           /******************************/
           tisWatchDogPulse(watchdogId[line]);
           /******************************/
        }
	activity = check_line_activity(line, 0);
	resGetStates (prestable [line], &lstate, &pstate);

        /******************************************/
	/* if the partner is not there, be master */

	if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
	{
	    resSetCaAnswer(prestable[line]);
	    resPutLocalState(prestable[line], RES_MSTR);
	    lstate = RES_MSTR;
	    if (modrestrace[line])
	    	logMsg (" Became RES_MSTR \n");
	    semGive(linemux[line]);	/* give back semaphore so diagnostics can run   */
	}


	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet(); /* Initialize the time  */

	while (TRUE)
	{
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

	    activity_time[line] = tickGet();
	    lastactivity[line] = line_activity[line] = FALSE;

	    /* we arrive here because we are a slave.                                                   */
	    /* we stay until:   asked to be master by partner. if we can reach Mapbd, we become master. */
            /*                  the partner is not master and there is no activity on the line.         */

	    while (lstate == RES_SLV)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

		if (pstate != RES_SLVWANT)
		{
		    clear_rts(line); 				/* make sure line is left for master 	*/
		}
		resresponse[line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand(prestable[line],0); 		/* clear out commands 			*/
		activity = check_line_activity(line,10); 	/* wait 10 seconds before checking 	*/
		resGetStates(prestable[line],&lstate,&pstate);


		/* see if needed by partner to be master. if yes, do it and break out of slave state.   */
		if (pstate == RES_SLVWANTCA)
		{
		    semGive(linemux[line]);	/* give back semaphore so diagnostics can function      */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line]) logMsg ("Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    break;
		}
		/* If partner is there and wants to give it up, try to take it */
		if (pstate == RES_SLVWANT)
		{
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

		    execute = FALSE;

		    taskDelay(2); /* Time for switch to occur */

		    /* See if map board is out there and able to respond to a loopback command */
                    pmap = map[line];
                    if ((pmap) &&			/* verify pointer validity prior to use */
			    (pmap->was_requested) &&    /* data points have been requested      */
                            (!pmap->cmd_force_offline)) /* user has NOT forced mapbd offline    */
		    {
                        on_line(line);
                        /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                        if ((pmap->is_responding) && (!pmap->cmd_force_offline))
                        {
                                execute = TRUE;
                                break;
                        }
                    }

		    /* If mapboard answered, become master and make sure partner really gave it up */
		    if (execute)
		    {
			resPutLocalState(prestable[line],RES_MSTR);
			lstate = RES_MSTR;
			if (modrestrace[line])
				logMsg ("5] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			execute = FALSE;
			activity_time[line] = tickGet();
			lastactivity[line] = line_activity[line] = FALSE;
			for (i=0;(i<60);i++)
			{
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/

			    activity = check_line_activity(line,2); /* pause before testing */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ( (pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */
			    resPutLocalState(prestable[line],RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace[line])
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 
			    semGive(linemux[line]);	/* give back semaphore so diagnostics can run   */
			    resSetCaAnswer(prestable[line]);
			    prepresponses(line);
			    break;
			}
		    }
		}

                /********************************************/
		/* if the partner is not talking, be master */
		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
		    semGive(linemux[line]);		/* give back semaphore so diagnostics can run.  */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line])
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
		    prepresponses(line);
		}
	    }
            /****************************************************************************************/
            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is cancelled */
	    while (lstate == RES_SLVWANTCA)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

	        taskDelay(2);                   /* Give OS a chance...                  */
		clear_rts(line); 		/* Make sure line is left for master    */
		resresponse[line] = FALSE; 	/* Make Sure driver is not responding   */

		resGetStates(prestable[line],&lstate,&pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace[line])
                    {
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                    }
		    break;
		}
		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    semGive(linemux[line]);		/* give back semaphore so diagnostics can run.  */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line])
                    {
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                    }
		    prepresponses(line);
		}
	    }

            /****************************************************************************************/
	    /* in normal operation this code should never execute. it has, however, been seen to    */
            /* execute when the database has been inadvertently configured with the same resource   */
	    /* assigned to two different drivers in the same IOC. The state does funny things.      */
            /****************************************************************************************/
	    while (lstate == RES_SLVWANT)
	    {
                if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))

		{
                    /* condition should NEVER occur. print error message every 5 seconds. */
                    logMsg ("Illegal Local Resource State.\n");
                    if (trace[line] & CONFIGURATIONTRACE)
                    {
                        logMsg ("  Possible Resource Configuration Error:\n");
                        logMsg ("   Check for multiple drivers sharing single Resource.\n");
                    }
                    taskDelay (600);
                }
                taskDelay (2);
            }
            /****************************************************************************************/
            /* we come here because we have gone to, or are looping in, the master state.          */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
	    /* It will then try to configure requested non-responding modules.                      */
            /****************************************************************************************/

	    last_time = tickGet ();		/* initialize gap */
	    while (lstate == RES_MSTR)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                /* initial stuff */
                resresponse[line] = TRUE; /* Make sure driver is responding. driver won't           */
                                          /* issue commands if not set.                             */

                taskDelay(6);  /* don't waste CPU cycles while waiting for things to happen */

                /************************************************************************/
                /* if relinquish command sent, change state and break out to outer loop */
                if (command == RES_RELINQUISH)
                {
                    /* make sure diagnostics are quiescent */

                        getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                    resClearCaAnswer(prestable[line]);
                    resPutLocalState(prestable[line],RES_SLVWANTCA);
                    lstate = RES_SLVWANTCA;
                    if (modrestrace[line])
                       logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
                    break;
                }

                /* wep: process map board outputs, if any.                              */
                pmap = map[line];		/* shorthand pointer 			*/
                if (pmap->cmd_force_offline)
                { 
                        /* if user has put the mapboard offline via pseudo commands,     */
                        /* mark it as not responding.                                   */
                        pmap->is_responding = FALSE;
                }
                /* scan & output logic */
                else if (pmap->is_responding)
                {
                         /* local/partner lockstep recovery */
                         resGetStates(prestable[line], &lstate, &pstate);
                         if (pstate == RES_MSTR)
                         {
                             resClearCaAnswer(prestable[line]);
                             resPutLocalState(prestable[line], RES_SLV);
                             lstate = RES_SLV;
                             clear_rts(line); 		/* Make sure line is left for master */
                             pmap->is_responding = FALSE;
                             if (modrestrace[line])
                             {
                                logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                             }
                             temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                             for ( i = 0; i < temp; i++)
                             {
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                             }
                             break;
                         }
                        /* get access to the radio, if any in the data path */

                        getsemaphore(line);       /* make sure radio diagnostics are quiescent */
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        idletask(line); /* replaces call to scan_plc(pmap, line)          */
                        checkoutputs(line);
                        semGive(linemux[line]);
                }
                /* end of single module action */
                /* if told to relinquish our master state, stop outputting to the map board  */
                /* immediately. don't trash the command, so that we can still read it on the */
                /* next loop through this while statement.                                   */

                /* test for lockstep detection. */
                if (lstate != RES_MSTR) break;

		/* try and bring the non-responding map board online.            */
                if ((pmap) &&		/* verify pointer validity prior to use. */
                   (!pmap->is_responding) &&
                   (pmap->was_requested) &&
                   (!pmap->cmd_force_offline))
                {
                /* get access to the radio, if there is one involved */

                   getsemaphore(line);       /* make sure radio diagnostics are quiescent */

		   on_line(line);	/* loopback testing done here! 	*/
		   semGive(linemux[line]);
		}

                /* fail-over logic. */
		/* see if map board is currently responding. */
                /* if not, try to get partner to become slave.    */
		if (!any_responding(line))
		{
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

		    /* See if it is time to let partner try */
		    this_time = tickGet();
		    if ((this_time - last_time) > (3*SLWWINDOW))
		    {   /* #ticks for slave to try */

			/* Switch States to let partner know it's its time to try */

                        /* make semGet(linemux[line]) call before the switch to make sure diagnostic    */
                        /* task is quiescent while partner is checking the line with the loopback       */
                        /* command. if local not master, then diagnostic won't try anyway, for either   */
                        /* master or remote radios, but it might have begun a 12 second test sequence   */
                        /* just before we got here. */

                        getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                        /* we must semGive the semaphore back if and when we go to being the master */

			resPutLocalState(prestable[line],RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace[line])
				logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate,activity);

			/* Give partner access to the hardware */
			clear_rts(line);

			/* Remember the time of this try */
			last_time = tickGet();
			lastactivity[line] = line_activity[line] = FALSE;
			for (i=0; (i<SLWWINDOW); i+=10)
			{       		/* SLWINDOW is the # of ticks for slave to try */
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
			    taskDelay(10);
		    				/* If partner picked up let it have control */
			    activity = check_line_activity(line,0);  /* check immediately */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
			    {
				resClearCaAnswer(prestable[line]);
				resPutLocalState(prestable[line],RES_SLV);
				lstate = RES_SLV;
				if (modrestrace[line])
					logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
				break;
			    }
			}
			/* Go Back to being the Master and take control of the hardware */
			if (lstate != RES_SLV)
			{
			    semGive(linemux[line]);	/* give back semaphore so diagnostics can run. */
                            resSetCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace[line])
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			}
		    }
		}

		/* take map board off hold status. the data are not to be held off since now master. */
		pmap = map[line];
		if (pmap)			/* verify pointer validity prior to use */
		{        
			pmap->holdflag = FALSE;
                }
	    
                /* give the other tasks a chance to execute! */
                taskDelay(6); /* check every 100 msec */
            }
	} /* end infinite task loop */
     }

static void getsemaphore(unsigned short line)
{
    int i;     

    while ((semTake(linemux[line], 10)) == ERROR)
    {
        i =+ 10;
        if (i >= MUXTIMEOUT)
        {
            i = 0;
            logMsg (" Waiting for Radio Diagnostics:");
            printf (" Mutual-Exclusion Semaphore Timeout on Line %d\n", line);
        }
        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/
    }
    return;
}


/*
** Try to bring the map board on line
**
*/

/* this routine only called from MAIN */


static void idletask (unsigned short line)
    {
	MAPBOARD  *pmap;
	unsigned long thistime;

	pmap = map[line];
	thistime = tickGet();

        if (mapsim[line] == TRUE)
        {
            if ((thistime-idle_time[line]) < (30*60)) /* hardwired 30 seconds */
                return;
        }
        else
        {
            if ((thistime-idle_time[line]) < IDLETASKINTERVAL)
                return;
        }

	idle_time[line] = thistime;

        if (modtrace[line] || (trace[line] && ALLTRAFFICTRACE))
        {
            logMsg ("System Idle: Generate Comm Activity.\n");
        }
/*        restorelamp (line, pmap, LOOPBACKLAMPNUMBER); */
        mapbd_idleloop(line, pmap);
        return;
/*        mapbd_idleloop(line, pmap); */
    }

/*
** Try to bring the map board on line
**
*/

/* this routine only called from MAIN */

static void on_line (unsigned short line)
    {
	MAPBOARD  *pmap;
	unsigned short i,j;

	pmap = map[line];
	if (pmap)			/* verify pointer prior to use */
	{
		if (mltrace[line] == 1)
		{
			logMsg ( "Bring Map Board Online:  line - %d\n", line);
	        }
		/* Use the loop back function to see if the unit is there and responding */

		if (!mapbdloopback(ONERETRY+line, pmap))
			return; /* if no response, get out */
		pmap->is_responding = TRUE;
        }
    }

/*
** checkoutputs											
**      checks output que and returns if empty.							
**      if there is something on the queue it attempts to process all                           
**      pending outputs, doing immediate retries. If attempts fail the request is dropped.      
**                                                                                              
*/                                                                                              
/* this routine only called from MAIN */

static	void checkoutputs (unsigned short line)
    {
	OUTQENT         *optr;
	unsigned short  regaddr, regval, queueline, adapter, coiladdr, conv, signal;
	unsigned long   coilmask, coilval;
	MAPBOARD          *pmap;

        unsigned int    commandclass, cmd, lampnumber;
        char            command;

	while ((optr=ogetnextp(line)) != NULLP)
	{
	    if ((optr->otype)==AOUTTYPE)
            {
		queueline = optr->out.aonode.line;

		pmap = map[queueline];
		if (pmap == NULL)
		{
			if (!allocate_mapbd(queueline))
				return; /* if not allocated, try. if can't allocate, get out. */
        	        pmap = map[queueline];
		}
		commandclass = optr->out.bonode.card;

                if (commandclass == ONETEST)
                {                
                    cmd = optr->out.aonode.aosignal;
                    lampnumber = (optr->out.aonode.aovalue-1)/2; /* perform address translation */

                    switch(cmd)
                    {
                        case 5: /* turn lamp off */
                          command = '0';
                          break;
                        case 6: /* turn lamp on */
                          command = '1';
                          break;
                        case 7: /* set lamp to slow blink */
                          command = '2';
                          break;
                        case 9: /* restore lamp to state prior to diagnostics */
                          if ((!pmap->cmd_force_offline) &&
                              (resresponse[queueline]) &&
                              (pmap->is_responding))
		          {
		              if (!(restorelamp(queueline, pmap, lampnumber)))
		              {
		                 pmap->badoutcnt++;
		              }
		          }
                          idle_time[queueline] = tickGet(); /* reset idle timeout value       */
                          oreleasefull(line);               /* release the output que entry   */
                          return;
                          break;
                        case 8: /* set lamp to fast blink */
                        default:
                          command = '3';
                          break;
                     }
		    if (mltrace[line] == 2)
			logMsg ( "Analog Output to line %d\n", queueline);

                    if ((!pmap->cmd_force_offline) &&
                        (resresponse[queueline]) &&
                        (pmap->is_responding))
		    {
		        if (!(setlamp(queueline, command, pmap, lampnumber)))
		        {
		                pmap->badoutcnt++;
		        }
		    }
                    idle_time[queueline] = tickGet();    /* reset idle timeout value: action just performed*/
                }
            }
	    else if ((optr->otype)==BOUTTYPE)
	    {
		queueline = optr->out.bonode.line;
		pmap = map[queueline];
		if (pmap == NULL)
		{
			if (!allocate_mapbd(queueline))
				return; /* if not allocated, try. if can't allocate, get out. */
        	        pmap = map[queueline];
		}
		commandclass = optr->out.bonode.card;
                /* ordinary lamp command */
                if (commandclass == LAMPS)
                {                
                   signal = optr->out.bonode.bosignal;
                   lampnumber = ((signal-1)/2);
                   cmd = (optr->out.bonode.bovalue >> (lampnumber % 16)*2);
		   if (mltrace[line] == 2)
                      logMsg ( "Adjusted lampnumber & command value: lampnumber %d, cmd = %d\n",
                               lampnumber, cmd );
                   switch(cmd)
                   {
                        case 0: /* turn lamp off */
                          command = '0';
                          break;
                        case 1: /* turn lamp on */
                          command = '1';
                          break;
                        case 2: /* set lamp to slow blink */
                          command = '2';
                          break;
                        case 3: /* set lamp to fast blink */
                        default:
                          command = '3';
                          break;
                   }
		   if (mltrace[line] == 2)
			logMsg ( "Output Command to Map Board: lamp number = %d, command = %d\n",
				lampnumber, command );

		   if ((!pmap->cmd_force_offline) &&
                       (resresponse[queueline]) &&
                       (pmap->is_responding))
		   {
                      if (!(setlamp(queueline, command, pmap, lampnumber)))
		      {
		          pmap->badoutcnt++;
		      }
                      else
                      {
                          setimage(queueline, command, pmap, lampnumber);
                      }
                   idle_time[queueline] = tickGet();    /* reset idle timeout value: action just performed*/
		   }
                }
                /* all lamps command */
                if (commandclass == ALLTEST)
                {                
                   cmd = optr->out.bonode.bosignal;
                   switch(cmd)
                   {
                      case 0: /* turn lamp off */
                          command = '0';
                          break;
                      case 1: /* turn lamp on */
                          command = '1';
                          break;
                      case 2: /* set lamp to slow blink */
                          command = '2';
                          break;
                      case 4: /* restore lamp to state prior to diagnostics */
                          if (mltrace[line] == 2)
			      logMsg ( "Restore Pre-Diagnostic state to all lamps.\n");
                          if ((!pmap->cmd_force_offline) &&
                              (resresponse[queueline]) &&
                              (pmap->is_responding))
		          {
		              if (!(restorealllamps(queueline, pmap)))
		              {
		                 pmap->badoutcnt++;
		              }
		          }
                          idle_time[queueline] = tickGet(); /* reset idle timeout value       */
                          oreleasefull(line);               /* release the output que entry   */
                          return;
                          break;
                      case 3: /* set lamp to fast blink */
                      default:
                          command = '3';
                          break;
                   }
		   if (mltrace[line] == 2)
			logMsg ( "Output Test Command to Map Board: All Lamps, command = %d\n",
                               command );

		   if ((!pmap->cmd_force_offline) &&
                       (resresponse[queueline]) &&
                       (pmap->is_responding))
		   {
                       if (!(setalllamps(queueline, command, pmap)))
		       {
		           pmap->badoutcnt++;
		       }
                   }
                   idle_time[queueline] = tickGet();/* reset idle timeout value: action performed */
		}
	    }
	    oreleasefull(line);     /* release the output que entry */
	}
    }
/*                                                                                     
**      AIDRIVER                                                                        
**                                                                              	
**      This routines main purpose is to return the analog input value for the         	
**      specified module. For a module value                                           	
**      a (-1) will be returned if there is no valid data ready.                       	
**                                                                                     	
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short line, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname)
    {
	MAPBOARD  *pmap;
	unsigned short  blkix;
	unsigned short	*pdata;

	if (line > MAPLINES)
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, line, adapter, card, signal);
            return (-1);
        }
	if (card != PSEUDO)
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, line, adapter, card, signal);
            return (-1);
        }

	pmap = map[line];
	if (pmap == NULL)
	{
		if (!allocate_mapbd(line))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmap = map[line];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmap->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmap->is_responding;
		break;

	    case 5: /* Output Messages */
		*pvalue = pmap->no_dataout_msgs & 0x7fff;
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = pmap->no_rxnoresp & 0x7fff;
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = pmap->no_txnoresp & 0x7fff;
		break;

	    case 9: /* Data Echo Errors */
		*pvalue = pmap->no_dataerr & 0x7fff;
		break;

	    case 10: /* Message Retries */
		*pvalue = pmap->no_retries & 0x7fff;
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = pmap->no_rxhwerrs & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = pmap->no_txhwerrs & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*pvalue = pmap->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmap->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmap->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = pmap->badoutcnt & 0x7fff;
		break;

	    default:
                if (trace[line] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, line, adapter, card, signal);
                return (-1);
	    }
            if (mltrace[line] == 6)
                logMsg("AIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                        pointname, line, adapter, card, signal+1, pvalue[0], pvalue[1]);
	    return (0);
	}
	return(-1);
    }

/*  										
**      AODRIVER                                                                
**                                                                            	
**      This routines main purpose is to set requested analog outputs to the  	
**      specified module.                                                     	
*/                                                                            	
/* this routine not called from within this driver */


int AODRIVER (char *pointname, unsigned short line, unsigned short adapter, unsigned short card,
	    unsigned short signal,double dvalue, unsigned short value,
	    unsigned short conversion, unsigned char *resname)

    {
	MAPBOARD  *pmap;
	unsigned short  blkix;
	OUTQENT *oqp;

	if (line > MAPLINES)
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, line, adapter, card, signal, value);
            return (-1);
        }
	if ((card != ONETEST) && (card != PSEUDO))
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, line, adapter, card, signal, value);
            return (-1);
        }

	pmap = map[line];
	if (pmap == NULL)
	{
		if (!allocate_mapbd(line))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmap = map[line];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
			initstats(pmap);
		break;

	    case 16: /* Force the PLC online/offline */
		pmap->cmd_force_offline = (value != 0);
		if (value != 0)
                   pmap->is_responding = FALSE;
		break;

	    default:
                if (trace[line] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, line, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}
        /* validate signal range */
        if (card == ONETEST)
        {
        	if ((signal < MINONETESTNUM) || (signal > MAXONETESTNUM))
                {
                    if (trace[line] & CONFIGURATIONTRACE)
                        logMsg("AODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, line, adapter, card, signal, value);
                    return (-1);
                }
        	if ((value % 2) == 0) /* all must start on odd address boundaries: 1,3,5... */
                {
                    if (trace[line] & CALLREJECTTRACE)
                        logMsg("AODRIVER: Illegal value (even):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, line, adapter, card, signal, value);
                    return (-1);
                }
                if ((value < MINLAMPNUM) || (value > MAXLAMPNUM))
                {
                    if (trace[line] & CALLREJECTTRACE)
                        logMsg("AODRIVER: Illegal value (outrange):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, line, adapter, card, signal, value);
                    return (-1);
                }
        }

	if (resname != 0)
	{ 
	    register_resource(line, pmap, resname, pointname);
	}

	pmap->was_requested = TRUE;

        /* verify IOC is ready, willing, and able to send the data */
	if (!resresponse[line])
        {
            if (trace[line] & CALLREJECTTRACE)
                logMsg("AODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, line, adapter, card, signal+1, value);
            return (-1);
        }

	if ((!pmap->is_responding) || (pmap->cmd_force_offline))
	{
            if (trace[line] & CALLREJECTTRACE)
                logMsg("AODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, line, adapter, card, signal+1, value);
	    return (-1);
	}

        /* Queue up the output request */
	oqp = ogetemptyp (line);
	if (oqp == NULLP)
	{
            logMsg("AODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, line, adapter, card, signal+1, value);
	    pmap->badoutcnt++;
	    return (-1);		/* output que is full */
	}
	oqp->otype = AOUTTYPE;
	oqp->out.aonode.line = line;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;
	oqp->out.aonode.aovalue = value;
	oqp->out.aonode.conversion = conversion;

	omarkfull (line);		/* Mark this entry as ready for output */

        if (mltrace[line] == 4)
            logMsg("AODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, line, adapter, card, signal+1, value);
	return (0);
    }
/*                                                                             
**      AOREAD                                                                  
**                                                                          	
**      This routines main purpose is to return the value last read back     	
**      from the analog output hardware. This is used to initialize analog   	
**      outputs.                                                             	
*/
/* this routine not called from within this driver */


int AOREAD (char *pointname, unsigned short line, unsigned short adapter, unsigned short card,
	  unsigned short signal, unsigned short *pvalue,
	  unsigned short conversion, unsigned char *resname)

    {
	MAPBOARD  *pmap;
	unsigned short  blkix, *pdata;
	
	if (line > MAPLINES)
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, line, adapter, card, signal);
            return (-1);
        }
	if ((card != ONETEST) && (card != PSEUDO))
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, line, adapter, card, signal);
            return (-1);
        }

	pmap = map[line];
	if (pmap == NULL)
	{
		if (!allocate_mapbd(line))
                        return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmap = map[line];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 15: /* read statistics command value */
		*pvalue = pmap->cmd_reset_stat;
		break;

	    case 16: /* Read the current PLC offline command status */
		*pvalue = pmap->cmd_force_offline;
		break;

	    default:
		return(-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource(line, pmap, resname, pointname);
	}

        /* validate signal range */
        if (card == ONETEST)
        {
            if ((signal < MINONETESTNUM) || (signal > MAXONETESTNUM))
	    {
                if (trace[line] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, line, adapter, card, signal);
		return (-1);
	    }
            /* verify IOC is ready, willing, and able to send the data */
            if  (!resresponse[line])
                {
                    if (trace[line] & CALLREJECTTRACE)
                        logMsg("AOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, line, adapter, card, signal+1);
                    return (-1);
                }
                if (!pmap->is_responding)
                {
                    if (trace[line] & CALLREJECTTRACE)
                        logMsg("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, line, adapter, card, signal+1);
                    return (-1);
                }
/*                logMsg("AOREAD(5): no problem:  returning 0"); */
		*pvalue = 0;
                if (mltrace[line] == 6)
                    logMsg("AOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                            pointname, line, adapter, card, signal+1, pvalue[0], pvalue[1]);
                return (0);
	}
	return(-1);
    }
/*                                                                                     
**      BIDRIVER                                                                        
**                                                                               	
**      The main purpose of this routine is to return the request digital input  	
**      value(s) from the requested card. This routine will return a (-1) if the  	
**      requested module is the wrong type or the data is not yet valid.          	
**                                                                                	
*/
/* this routine not called from within this driver */



int BIDRIVER (char *pointname, unsigned short line, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask,unsigned long *pvalue,
		unsigned char *resname)

    {
	MAPBOARD  *pmap;
	unsigned short blkix;
	unsigned long tvalue;

	if (line > MAPLINES)
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, line, adapter, card, signal);
            return (-1);
        }
	if (card != PSEUDO)
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, line, adapter, card, signal);
            return (-1);
        }

	pmap = map[line];
	if (pmap == NULL)
	{
		if (!allocate_mapbd(line))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmap = map[line];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
		    case 0: /* Were the PLC values requested */
			*pvalue = pmap->was_requested;
			break;

		    case 1: /* Is the PLC responding */
			*pvalue = pmap->is_responding;
			break;

		    case 15: /* reset statistics */
			*pvalue = pmap->cmd_reset_stat;
			break;

		    case 16: /* Force the PLC offline */
			*pvalue = pmap->cmd_force_offline;
			break;

		    default:
                        if (trace[line] & CONFIGURATIONTRACE)
                            logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, line, adapter, card, signal);
			return (-1);
	    }
            if (mltrace[line] == 8)
                logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                        pointname, line, adapter, card, signal+1, pvalue);
	    return (0);
	}
	return (-1);
    }
/*                                                                                	
**      BODRIVER
**                                                                                 	
**      The main purpose of this routine is to set the request digital output      	
**      value(s) on the requested card. This routine will return a (-1) if the     	
**      requested module is the wrong type or not configured yet.                  	
**                                                                                 	
*/
/* this routine not called from within this driver */


int BODRIVER (char *pointname, unsigned short line, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long value, unsigned long mask,
		unsigned char *resname)
    {
	MAPBOARD  *pmap;
	OUTQENT *oqp;

	if (line > MAPLINES)
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, line, adapter, card, signal, value);
            return (-1);
        }
	if ((card != LAMPS) && (card != ALLTEST) && (card != PSEUDO))
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, line, adapter, card, signal, value);
            return (-1);
        }

	pmap = map[line];
	if (pmap == NULL)
	{
		if (!allocate_mapbd(line))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmap = map[line];
	}

	if (card == PSEUDO)
	{
	    switch (signal & 0x1f)
	    {
	    case 15: /* Reset the accumulated statistics */
		if (value != 0) initstats(pmap);
		break;

	    case 16: /* Force the PLC offline */
		pmap->cmd_force_offline = (value != 0);
		if (value != 0)
                   pmap->is_responding = FALSE;
		break;

	    default:
                if (trace[line] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, line, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}

	pmap->was_requested = TRUE;

	if (resname != 0)
	{ 
	    register_resource(line, pmap, resname, pointname);
	}

        /* validate signal range & value */
        if (card == LAMPS)
        {
        	if ((signal < MINLAMPNUM) || (signal > MAXLAMPNUM))
                {
                    if (trace[line] & CONFIGURATIONTRACE)
                        logMsg("BODRIVER: Illegal signal(range):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                pointname, line, adapter, card, signal, value);
                    return (-1);
                }
        	if ((signal % 2) == 0) /* all must start on odd address boundaries */
                {
                    if (trace[line] & CONFIGURATIONTRACE)
                        logMsg("BODRIVER: Illegal signal(even):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                pointname, line, adapter, card, signal, value);
                    return (-1);
                }
	}
        if (card == ALLTEST)
        {
        /*      if ((signal < MINALLTESTNUM) || (signal > MAXALLTESTNUM))               */
        /* commented out to eliminate warning on testing for < 0 on an unsigned value   */
        	if (signal > MAXALLTESTNUM)
                {
                    if (trace[line] & CONFIGURATIONTRACE)
                        logMsg("BODRIVER: Illegal signal(range):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                pointname, line, adapter, card, signal, value);
                    return (-1);
                }
	}

        /* verify that the IOC is ready, willing, and able to send the data */
	if  (!resresponse[line])
        {
            if (trace[line] & CALLREJECTTRACE)
                logMsg("BODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, line, adapter, card, signal+1, value);
            return (-1);
        }

	if ((!pmap->is_responding) || (pmap->cmd_force_offline))
	{
            if (trace[line] & CALLREJECTTRACE)
                logMsg("BODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, line, adapter, card, signal+1, value);
	    return (-1);
	}

        /* Queue up the output request */
	oqp = ogetemptyp (line);
	if (oqp == NULLP)
	{
	    pmap->badoutcnt++;
	    return (-1);		/* output que is full */
	}
	oqp->otype = BOUTTYPE;
	oqp->out.bonode.line = line;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bovalue = value;

	omarkfull (line);		/* Mark this entry as ready for output */

        if (mltrace[line] == 5)
            logMsg("BODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, line, adapter, card, signal+1, value);
	return (0);
    }
/*
**      BOREAD                                                                  
**                                                                           	
**      This routines main purpose is to return a zero in response to a read
**      of a value previously output to the map board (as there is no memory    
**      in the map board.  This is normally only done to initialize digital     
**      outputs. This will return a (-1) if the module is the wrong type or    	
**      the data address range is invalid                                       
*/
/* this routine not called from within this driver */

int BOREAD (char *pointname, unsigned short line, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)
    {
	MAPBOARD  *pmap;
	unsigned short  blkix;
	unsigned long	tvalue;

	if (line > MAPLINES)
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, line, adapter, card, signal);
            return (-1);
        }
	if ((card != LAMPS) && (card != ALLTEST) && (card != PSEUDO))
        {
            if (trace[line] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, line, adapter, card, signal);
            return (-1);
        }

	pmap = map[line];
	if (pmap == NULL)
	{
		if (!allocate_mapbd(line))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmap = map[line];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 15: /* reset statistics */
		*pvalue = pmap->cmd_reset_stat;
		break;
	    case 16: /* Force the PLC offline */
		*pvalue = pmap->cmd_force_offline;
		break;

	    default:
                if (trace[line] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, line, adapter, card, signal);
		return (-1);
	    }
	    return (0);
	}

	pmap->was_requested = TRUE;

	if (resname != 0)
             register_resource(line, pmap, resname, pointname);

        /* validate signal range */
        if (card == LAMPS)
        {
        	if (signal >= NUMLAMPS)
                {
                    if (trace[line] & CONFIGURATIONTRACE)
                        logMsg("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, line, adapter, card, signal+1);
                    return (-1);
                }
	}
        if (card == ALLTEST)
        {
        	if (signal > MAXALLTESTNUM)
                {
                    if (trace[line] & CONFIGURATIONTRACE)
                        logMsg("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, line, adapter, card, signal+1);
                    return (-1);
                }
	}

        /* always return zero, as the map board cannot be read */
     	tvalue = 0;
	*pvalue = tvalue;
        if (mltrace[line] == 9)
            logMsg("BOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, line, adapter, card, signal+1, pvalue);
	return (0);
    }
/*
** register_resource                                                              	
**                                                                                	
**	This routine is used to initialize the resource pointers                  	
**  If this is the first time the resource for this line is being                  	
**  referenced the pointer to the resource table entry will be set                  	
**  and the resource name will be saved. If the resource name has                       
**  already been set, this routine will verify that all other points                 	
**  for this driver are using the same resource name.                                	
**                                                                                   	
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
			    BOREAD, SIDRIVER, and SODRIVER.                             
*/                               	

static void  register_resource (unsigned short line, MAPBOARD *pmap,
                                unsigned char *resname, char *pointname)
    {
	if (resnames[line][0] == 0) /* This is the first reference */
	{
	    if (resGetByName( resname, &prestable[line]) != RES_OK)
	    {
		logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
				resname );
	    }
	    else strcpy(resnames[line], resname);
	}
	else
	{
	    if (strcmp(resnames[line], resname) != 0)
	    {
		logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
				resnames[line],
                                pointname,
				resname );
	    }
	}
    }
/*
**      Initialize the Queue                                        		
*/                                                                        	
/* only called from MAIN */

static	void outqueinit (unsigned short line)
    {
	oq[line]->ooutix = oq[line]->oinix = 0;
    }


/*                                                                     		
**  ogetempty - get the next available slot on the output list         		
*/
/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
    {
	if (((oq[line]->oinix + 1) % OUTQSIZE) != oq[line]->ooutix)
	{
	    return (&oq[line]->outque[oq[line]->oinix]);
	}
        if (mltrace[line] == 1)
		logMsg ( "Output Que Full line - %d\n",line);
	return (NULLP);
    }


/*                                                                    		
** omarkfull                                                          		
**      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
	{
	    oq[line]->oinix = ((oq[line]->oinix + 1) % OUTQSIZE);
	}


/*                                                                      	
**  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
    {
	if (oq[line]->ooutix != oq[line]->oinix)
	{
	    return (&oq[line]->outque[oq[line]->ooutix]);
	}
	else return (NULLP);
    }


/*                                                       	               	
** oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
    {
	if (oq[line]->ooutix == oq[line]->oinix)
		return;
	oq[line]->ooutix = ((oq[line]->ooutix + 1) % OUTQSIZE);
    }

/*                                                                             	
**                                                                              
**	allocate_mapbd                                                          
**                                                                              
**	The purpose of this routine is to allocate the memory for the           
**      map board. If not successful, a console error message is  	        
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_mapbd (unsigned short line)
   {
        map[line] = (MAPBOARD *)calloc(1,(sizeof(MAPBOARD)));
	if (!map[line])
	{
		printf ("Unable to allocate memory");
                printf (" for Map Board data structure on line %d\n",line);
		 return(FALSE);
	}
	else
	{
		logMsg ("Allocated memory for Map Board data structure on line %d\n",line);
		init_mapboard(line);	     /*	initialize the data structures. */
	        return(TRUE);
	}
   }


/*                                                                   		
**      start_rx                                                        	
**                                                                     	 	
**      The purpose of this routine is to initialize a line table        	
**      for receive and to enable the receiver.                           	
**                                                                        	
*/
/* only called from msgxfer */


static	void start_rx (unsigned short line,SEMAPHORE *semid, unsigned short *pstatus )

    {
	RXLINE                  *rxp;

	rxp=rxlinetab[line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	rxp->rxstate = RXGETDATA;
    }



/*                                                                           	
**      stop_rx                                                              	
**                                                                           	
**      The purpose of this routine is to initialize a line table            	
**      for receive and to disable the receiver.                             	
**                                                                           	
*/
/* only called from msgxfer */


static	void stop_rx (unsigned short line )

    {
	RXLINE                  *rxp;

	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
    }


/*                                                                        	
**      rx_int_proc                                                        	
**                                                                         	
**      The purpose of this routine is to process a receive character interrupt	
**      for a given line.                                                     	
*/
/* referenced in system call in MAIN */

static	void rx_int_proc (unsigned short line )
    {
	unsigned char   rxchar;
	unsigned short  rxstat;
	unsigned short  rx_err_mask;
	RXLINE          *rxp;

	read_rx_hw(line, &rxchar, &rxstat, &rx_err_mask);

	rxp=rxlinetab[line];

	/* Something is sending in data */
	line_activity[line] = TRUE;

	if (rxp->rxstate==RXIGNORE)
		return;

	if ((rxstat & rx_err_mask) != 0)
	{
	    if (rxp->rxix == 0)
	    	return;
	    *(rxp->status) = RXBAD;
	    rxp->rxstate=RXIGNORE;
	    rxp->rxbuf[100]=rxstat;
	    rxp->rxbuf[101]=rxchar;
	    return;
	}
	rxp->rxbuf[rxp->rxix++] = rxchar;

        rxp->rxmsglen--;
	if (rxp->rxmsglen == 0)
        {
            *(rxp->status) = RXGOOD;
            rxp->rxstate=RXIGNORE;
            semGive(rxp->semid);
	    return;
	}
	return;
    }
/*                                                                           	
**      check_line_activity                                                     
**                                                                             	
**      The purpose of this routine is to process a receive character interrupt	
**      for a given line.                                                      	
**                                                                             	
*/
/* only called from MAIN  */


static	int check_line_activity (unsigned short line, unsigned short predelay )

    {
	RXLINE          *rxp;
	long		thistime;
	short		status;

	if (predelay != 0)
		taskDelay(predelay);
	thistime = tickGet();
	if ((thistime-activity_time[line]) < ACTIVITYTIME)
		return (lastactivity[line] || (line_activity[line]));
	lastactivity[line] = status = line_activity[line];
	line_activity[line] = FALSE;
	activity_time[line] = thistime;
	rxp = rxlinetab[line];
	rxp->rxstate = RXIGNORE;

	return (status);
    }
/*                                                                         	
**      start_tx                                                            	
**                                                                          	
**      The purpose of this routine is to initialize a line table           	
**      for send and to enable the transmitter.                              	
**                                                                            	
*/
/* only called from msgxfer  */


static	void start_tx (unsigned short line,SEMAPHORE *semid, unsigned short *pstatus)

    {
	TXLINE                  *txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */


	enable_tx_ints(line);

    }


/*
**      stop_tx                                                                	
**                                                                             	
**      The purpose of this routine is to initialize a line table              	
**      for receive and to disable the receiver.                               	
**                                                                             	
*/
/* only called from msgxfer  */


static	void stop_tx (unsigned short line)

    {
	TXLINE  *txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txdisable=TRUE;
    }
/*                                                                           	
**      tx_int_proc                                                           	
**                                                                            	
**      The purpose of this routine is to process a transmit character interrupt
**      for a given line.                                                  	
**                                                                         	
*/
/* only called from MAIN  */


static	void tx_int_proc (unsigned short line )

    {
	char                    txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

	txp=txlinetab[line];
	if (txp->txdisable)
		return;
	if (txp->txix == txp->txmsglen)
	{
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive(txp->semid);
	    return;
	}
	else
	{
	    txchar = txp->txbuf[txp->txix++];
	    write_tx_hw ( line,txchar,&txstat,&tx_err_mask );
	    if ( (txstat & tx_err_mask) != 0 )
	    {
	 	txp->txdisable=TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive(txp->semid);
	        return;
	    }

	}

	if (txp->txix >= MAXTXMSG)
	{
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive(txp->semid);
	    return;
	}

    }

/*                                                                         	
**      msgxfer                                                              	
**                                                                           	
**      The purpose of this routine is to transmit a buffer to the         	
**      analog devices I/O and to await a response. The transmit and receive	
**      buffers are in their respective line tables. This routine will retry 	
**      the message up to a maximum number of times or until a response      	
**      is received with a proper checksum.                                  	
**              returns         XFERGOOD if response received                	
**                              XFERBAD  if no good response is received     	
**                                                                           	
*/
/* called from mapbdloopback, mapbd_idleloop, and setlamp                         */

static	unsigned short  msgxfer (unsigned short fline,
                                 MAPBOARD *pmap,
                                 unsigned short rxlength)
    {
	unsigned short  retry, txstatus, rxstatus, txlen, rxlen, line, ix, i;
	RXLINE          *rxp;
	TXLINE          *txp;
	unsigned char   csums[2];
        unsigned short  oldrxix;
        unsigned int    tick1, tick2, tick3, tick4;
        unsigned int    delta12, delta23, delta34;

        tick1 = tick2 = tick3 = tick4 = 0;     /* pre-zero all time keep registers */
        delta12 = delta23 = delta34 = 0;

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

	rxp = rxlinetab[line];
	txp = txlinetab[line];

	for (retry=((fline == line)?0:MAXRETRYS-1); (retry<MAXRETRYS); retry++ )
	{
	    if (intermsgdelay[line] != 0)
	    {
		taskDelay (intermsgdelay[line]);
	    }
	    set_rts(line);

	    if (pretxdelay[line] != 0)
	    {
		taskDelay (pretxdelay[line]);
	    }

	    txstatus = IO_TIMEOUT;
	    rxp->rxmsglen = rxlength;
	    rxstatus = IO_TIMEOUT;

	    semTake(semids[line][TXSEM], NO_WAIT);
	    semTake(semids[line][RXSEM], NO_WAIT);

	    txlen = txp->txmsglen;

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            if (trace[line] && ALLTRAFFICTRACE)
            {
               printf("TX:");
               for (ix = 0; ix < 12 ; ix++) /* 12 is maximum TX message length */
               {
                    if (ix < txlen)
                       printf("_%2x", txp->txbuf[ix]);
                    else
                       printf("...");
               } 
               printf(" ");
            }

            tick1 = tickGet();
	    start_rx(line, semids[line][RXSEM], &rxstatus);
	    start_tx(line, semids[line][TXSEM], &txstatus); /* this fires off the transmission. */

            if (mapsim[line] == TRUE)
            {
                /* give the 8 character message extra output margin: for hardware line monitor. */
	        if ((semTake(semids[line][TXSEM], 10)) == ERROR)
                    txstatus = IO_TIMEOUT;
            }
            else
            {
                if ((semTake(semids[line][TXSEM], TXTIMEOUT)) == ERROR)
                    txstatus = IO_TIMEOUT;
            }

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            tick2 = tickGet();
            delta12 = (tick2-tick1)%10000;

	    stop_tx(line);

	    if (posttxdelay[line] != 0)
	    {
		taskDelay (posttxdelay[line]);
	    }

	    if (halfduplex[line] == TRUE)
	       clear_rts(line);

            tick3 = tickGet();
            delta23 = (tick3-tick2)%10000;


            if (mapsim[line] == TRUE)
            {
/*******************************************************************************************/
/* DEBUG code: Used to test in Map Board abstencia: Fake out the satisfactory transmission */
/*******************************************************************************************/
               txstatus = TXGOOD;
            }

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

	    if (txstatus == TXGOOD)
	    {
                oldrxix = -1;    /* make it pass through timeout loop at least once */

                if (mapsim[line] == FALSE)
                {
                    while ((semTake(semids[line][RXSEM], (int)(RXTIMEOUT))) == ERROR)
                    {
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/

                            if (oldrxix == rxp->rxix)
                            {
                                   if (modtrace[line])
                                       logMsg("RX timeout\n");
                                    rxstatus = IO_TIMEOUT;
                                    break;
                            }       
                            else
                            {
                                if (mltrace[line] == 4)
                                   logMsg("waiting...");
                            }
                            oldrxix = rxp->rxix;
                    }
                }                    

		stop_rx(line);

                tick4 = tickGet();
                delta34 = (tick4-tick3)%10000;

		rxlen = rxp->rxix;

/*******************************************************************************************/
/* DEBUG code: Used to test in Map Board abstencia: Fake out the 'message ok' response     */
/*******************************************************************************************/
                if (mapsim[line] == TRUE)
                {
                    for ( i=0; (i<MAPBOARDMSGLEN); i++)
                    {
                        (rxp->rxbuf[i] = mapboardok[i]);
                    }
                    rxstatus = RXGOOD;
                    rxlen = MAPBOARDMSGLEN;
                }

                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                if (rxstatus == RXGOOD)
                {
                    if (trace[line] && ALLTRAFFICTRACE)
                    {
                       printf("RX:");
                       for (ix = 0; ix < 16 ; ix++) /* 24 is maximum RX message length */
                       {
                            if (ix < rxlen)
                                printf("_%2x", rxp->rxbuf[ix]);
                            else
                                printf("...");
                       } 
	               printf(" ");
                       printf(" %3d %3d %3d\n", delta12, delta23, delta34);
                    }
                    return (XFERGOOD);
                }
		else if
		(rxstatus == IO_TIMEOUT)
		{
		    if (modtrace[line])
		    	logMsg ("Receive Timeout... Length: %d\n", rxlen);
		    pmap->no_rxnoresp++;
		}
		else
		{
		    if (modtrace[line])
                    {
		    	logMsg ("Receive Error\n");
                        logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
                           rxp->rxbuf[100],
                           rxp->rxbuf[101],
                           rxp->rxix);
			logMsg ("Bad Message Response. Length = %d\n", rxlen);
                    }
                    if (trace[line] && ALLTRAFFICTRACE)
                    {
			printf ("Message: ");
                        for (ix = 0; ix < rxlen; ix++)
                            {
                                printf("[%x]", rxp->rxbuf[ix]);
			    }
                        printf("   %3d %3d %3d\n", delta12, delta23, delta34);
                    }
                    pmap->no_rxhwerrs++;
		}
	    }
	    else if
	    (txstatus == IO_TIMEOUT)
	    {
		if (modtrace[line])
                {
		    logMsg ("Receive Timeout... Length: %d     ", rxlen);
                }
                if (trace[line] && ALLTRAFFICTRACE)
                {
                    printf("   %3d %3d %3d\n", delta12, delta23, delta34);
                }
		pmap->no_txnoresp++;
	    }
	    else
	    {
		if (modtrace[line])
                {
		    logMsg ("Transmit Error        ");
                }
                if (trace[line] && ALLTRAFFICTRACE)
                {
                    printf("   %3d %3d %3d\n", delta12, delta23, delta34);
                }
		pmap->no_txhwerrs++;
	    }
	if (retry != MAXRETRYS)
		pmap->no_retries++;
	}
	return (XFERBAD);
    }
/*                                                                             
**      init_mapboard
**                                                                              
**      The purpose of this routine is to initialize the command output         
**      tables and statistics for the map board.                                
**                                                                              
*/
/* only called from allocate_mapbd  */


static	void init_mapboard (unsigned short line)

    {
	MAPBOARD  *pmap;

	pmap = map[line];
	if (!pmap)
		return;

	pmap->is_responding = FALSE;
	pmap->holdflag = TRUE;
	pmap->was_requested = FALSE;
	pmap->cmd_force_offline = FALSE;

	initmap(pmap);
	initstats(pmap);

	linetimers[line] = gettimer();
	if (linetimers[line] == -1)
	{
		/*  put an error message in here */
                /* (under what conditions can this occur? */
	}

	/* Initialize this tasks semaphore*/
	semids[line][0]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
	semids[line][1]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
    }

/*                                                                              
** Cold Init a Map Moard Memory Image                                           
**                                                                              
**      The map board memory image will actually hold the output command        
**      to be sent to the referenced lamp.                                      
**                                                                              
*/
/* only called from init_mapboard  */


static void initmap (MAPBOARD  *pmap)

    {
	unsigned short i;

	for (i=0; (i<NUMLAMPS); i++)
	{
	    pmap->lamp[i] = '-';         /* initialize command byte to lamp off */
/*	    pmap->lamp[i] = '0';         ** initialize command byte to lamp off */
/*	    pmap->lamp[i] = (i % 7)+0x30;         ** initialize command byte to lamp off */
	}
    }

/*                                                            		
**                                                              	
** initialize the statistics for a Map Board                            
**                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_mapboard  */


static	void initstats (MAPBOARD *pmap)

    {
	pmap->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
	pmap->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
	pmap->no_txnoresp = 0;      /* 8  Count No Responses 		*/
	pmap->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
	pmap->no_retries = 0;       /* 10 Count Retries 		*/
	pmap->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
	pmap->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
	pmap->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
	pmap->badoutcnt = 0;	    /* 17 Count failed output commands 	*/
    }
/*
** mapbd_idleloop                                                         
**                                                                        
*/                                                                          	
/* only called from idletask */

static	unsigned short mapbd_idleloop (unsigned short line, MAPBOARD *pmap)
    {
        TXLINE  *txp;
        RXLINE  *rxp;
        unsigned short results, lampnumber, i;
        char command;

        lampnumber = LOOPBACKLAMPNUMBER;
        command = pmap->lamp[lampnumber];
        if ((command < '0') || (command > '3'))
        {
             command = '0'; /* if not known command, then issue clear lamp command */
        }

        /* Set up pointers for comm buffers */
        txp = txlinetab[line & (~ONERETRY)];
        rxp = rxlinetab[line & (~ONERETRY)];

        /* Count number of data request messages. */
        /* NOTE: idle loop write attempts are counted as INPUT messages */
        pmap->no_datain_msgs++;

        /* Format the output message */
        txp->txbuf[0] =  command;
        makeoctal(lampnumber,4,&(txp->txbuf[1])); /* 4 octal digits */
        txp->txbuf[5] = 0x20; /* space */
        txp->txbuf[6] = 0x0d; /* carriage return */ 
        txp->txbuf[7] = 0x0a; /* line feed */
        txp->txmsglen = 8;

        /* expect '77503 <cr><lf>' reply: bad command */
        mapboardok[2] = 0x35;

        /* Send out the message */
        if (msgxfer(line, pmap, MAPBOARDMSGLEN) == XFERBAD)
        {
             pmap->no_offlines++;
             pmap->holdflag = TRUE;
             pmap->is_responding = FALSE;
             return(FALSE);
        }

        /* Verify the response - standard message 'ok' response */
        for ( i=0; (i<MAPBOARDMSGLEN); i++)
        {
            if (rxp->rxbuf[i] != mapboardok[i])
            {
                 pmap->no_dataerr++;
                 return (FALSE);
            }
        }

        return(TRUE);
    }
/*
** mapbdloopback                                                            
**                                                                        
*/                                                                          	
/* only called from on_line */

static	unsigned short mapbdloopback (unsigned short line, MAPBOARD *pmap)
    {
        TXLINE  *txp;
        RXLINE  *rxp;
        unsigned short results, lampnumber, i;
        char command;

        lampnumber = LOOPBACKLAMPNUMBER;
        command = pmap->lamp[lampnumber];
        if ((command < '0') || (command > '3'))
        {
             command = '0'; /* if not known command, then issue clear lamp command */
        }

        /* Set up pointers for comm buffers */
        txp = txlinetab[line & (~ONERETRY)];
        rxp = rxlinetab[line & (~ONERETRY)];

        /* Count number of data request messages. */
        /* NOTE: loopback write attempts are counted as INPUT messages */
        pmap->no_datain_msgs++;

        /* Format the output message */
        txp->txbuf[0] =  command;
        makeoctal(lampnumber,4,&(txp->txbuf[1])); /* 4 octal digits */
        txp->txbuf[5] = 0x20; /* space */
        txp->txbuf[6] = 0x0d; /* carriage return */ 
        txp->txbuf[7] = 0x0a; /* line feed */
        txp->txmsglen = 8;

        /* expect '77503 <cr><lf>' reply: bad command */
        mapboardok[2] = 0x35;

        /* Send out the message */
        if (msgxfer(line, pmap, MAPBOARDMSGLEN) == XFERBAD)
        {
             pmap->is_responding = FALSE;
             return(FALSE);
        }

        /* Verify the response - standard message 'ok' response */
        for ( i=0; (i<MAPBOARDMSGLEN); i++)
        {
            if (rxp->rxbuf[i] != mapboardok[i])
            {
                 pmap->no_dataerr++;
                 return (FALSE);
            }
        }
        return(TRUE);
    }
/*
**     prepresponses                                                            
**                                                                             	
**      The purpose of this routine is to mark the Map Board as on hold.    	
**                                                                              
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)

    {
	MAPBOARD  *pmap;

        pmap = map[line];
	if (pmap)			/* verify pointer validity prior to use */
	{
	    	pmap->holdflag = TRUE;
        }
    }



/*                                                                  	
**      any_responding                                               	
**                                                                   	
**      The purpose of this routine is to see if any units are       	
**	responding on this line                                      	
**                                                                   	
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)

    {
	MAPBOARD  *pmap;

        pmap = map[line];
        if (pmap)			/* verify pointer validity prior to use */
	{
            /* check cmd_force_offline flag because it is set in an asynchronous task */
            if ((pmap->is_responding) && (!pmap->cmd_force_offline))
                return(TRUE);
        }
	return(FALSE);
    }
/*
** RestoreAllLamps                                                        	
**                                                                 	
*/
/* only called from checkoutputs */

static	unsigned short restorealllamps (unsigned short line,
			                MAPBOARD *pmap)
    {
	unsigned short  i;

        for (i = 0; i < NUMLAMPS; i++)
        {
            if (!(restorelamp(line, pmap, i)))
            {
                  return(FALSE); /* if hard failure, stop processing */
            }
        }
        return(TRUE);
    }
/*
** RestoreLamps                                                        	
**                                                                 	
*/
/* only called from checkoutputs */

static	unsigned short restorelamp (unsigned short line,
			             MAPBOARD *pmap,
                                     unsigned short lampnumber)
    {
        char command;

        command = pmap->lamp[lampnumber];
        if ((command < '0') || (command > '3'))
        {
             command = '0'; /* if not known command, then issue clear lamp command */
        }
        if (!(setlamp(line, command, pmap, lampnumber)== XFERGOOD))
        {
              pmap->badoutcnt++;
              return(FALSE); /* if hard failure, stop processing */
        }
	return(TRUE);
    }
/*
** SetImage                                                        	
**                                                                 	
*/
/* only called from checkoutputs */

static	unsigned short setimage (unsigned short line,
                                char command,
			        MAPBOARD *pmap,
                                unsigned short lampnumber)
    {
        pmap->lamp[lampnumber] = command;
	return(TRUE);
    }
/*
** SetLamp                                                        	
**                                                                 	
*/
/* only called from checkoutputs */

static	unsigned short setlamp (unsigned short line,
                                char command,
			        MAPBOARD *pmap,
                                unsigned short lampnumber)
    {
	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmap->no_dataout_msgs++;

        /* Format the output message */

        txp->txbuf[0] =  command;

	makeoctal(lampnumber,4,&(txp->txbuf[1])); /* 4 octal digits */

        txp->txbuf[5] = 0x20; /* space */
        txp->txbuf[6] = 0x0d; /* carriage return */ 
        txp->txbuf[7] = 0x0a; /* line feed */

        txp->txmsglen = 8;

        /* expect '77403 <cr><lf>' reply: good command */
        mapboardok[2] = 0x34;

        /* Send out the message */

        if (msgxfer(line, pmap, MAPBOARDMSGLEN) == XFERBAD)
	{
             pmap->no_offlines++;
             pmap->holdflag = TRUE;
             pmap->is_responding = FALSE;
             return(FALSE);
        }

        /* Verify the response - standard message 'ok' response */
        for ( i=0; (i<MAPBOARDMSGLEN); i++)
        {
            if (rxp->rxbuf[i] != mapboardok[i])
            {
                 pmap->no_dataerr++;
                 return (FALSE);
            }
        }
	    return(TRUE);
    }
/*
** SetAllLamps                                                        	
**                                                                 	
*/
/* only called from checkoutputs */

static	unsigned short setalllamps (unsigned short line,
                                char command,
			        MAPBOARD *pmap)
{
    TXLINE  *txp;
    RXLINE  *rxp;
    unsigned short  i;

    setlamp(line, command, pmap, 07777);
    return(TRUE);
}
/*
** makeoctal 									
**                                                                        	
*/
/* called from msgxfer, modloopback, setlamp, setalllamps                     */

static	void makeoctal (unsigned short lampnumber, int length, char unsigned *retbuf)
{
    hextoascii(((lampnumber >> 9) % 8), &retbuf[0]);
    hextoascii(((lampnumber >> 6) % 8), &retbuf[1]);
    hextoascii(((lampnumber >> 3) % 8), &retbuf[2]);
    hextoascii(( lampnumber       % 8), &retbuf[3]);
}



/*
**      hextoascii                                                            	
**                                                                          	
**      The purpose of this routine is to convert the hex nibble to one ascii   
**      character and to place it into the buffer.                       	
**                                                                          	
*/
/* only called from makeoctal */

static	void hextoascii (unsigned short val, char *buf)
    {
	char    lo;

	lo = (val & 0x0f);
	if (lo<=9)
                 lo+='0';
	else
                 lo+=('A'-10);
	buf[0] = lo;
    }

void mapbdstate (unsigned short line)
    {
    TABLEINFO(line);
    }



/*                                                                          	
**      TABLEINFO                                                       	
**                                                                           	
**      The purpose of this routine is to dump the map board image.             
**                                                                              
*/
** not called from within this driver */

void TABLEINFO (unsigned short line)
    {
	MAPBOARD  *pmap;
	unsigned	short i,n, addr, linecnt ;
	unsigned	char	buffer[200];

	pmap = map[line];
	if (!pmap)
	{
	    logMsg("Line/MAPBD Address Not Defined \n");
	    return;
	}

	printf (" Was requested = %d         ", pmap->was_requested);
	printf                              (" Module Is responding = %d \n", pmap->is_responding);
	printf (" Resource Responding = %d   ", resresponse[line]);
	printf                              (" Hold flag  = %d \n", pmap->holdflag );
	printf (" Force Offline = %d \n\n", pmap->cmd_force_offline);
	printf (" # DataOut messages = %d    ", pmap->no_dataout_msgs & 0x7fff);
	printf                              (" #No Rx Response = %d \n", pmap->no_rxnoresp & 0x7fff);
	printf (" #No Tx Responses = %d      ", pmap->no_txnoresp & 0x7fff);
	printf                              (" #Data Errors = %d \n", pmap->no_dataerr & 0x7fff);
	printf (" #Retries = %d              ", pmap->no_retries & 0x7fff);
	printf                              (" #Rx Hw Errors = %d \n", pmap->no_rxhwerrs & 0x7fff);
	printf (" #Tx Hw Errors = %d         ", pmap->no_txhwerrs & 0x7fff);
	printf                              (" #Off Lines = %d \n", pmap->no_offlines & 0x7fff);
	printf (" Reset Statistics = %d      ", pmap->cmd_reset_stat);
	printf                              (" #Failed Outputs = %d \n", pmap->badoutcnt & 0x7fff);


	linecnt = 1;
	printmaphdr(buffer, linecnt);
	addr = 0;
	for (i=0; (i < NUMLAMPS); i+=8)
	{
		printf("  %4d          ", addr);
		for (n = 0; n < 8; n++)
		{		
			printf("%2x        ", pmap->lamp[i+n]);
                        if ((i+n+1) >= NUMLAMPS)
                           break;
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + 8) < NUMLAMPS) )
		{
			linecnt = 1;
			printmaphdr(buffer, linecnt);
		}
		addr += 8;		
	}
    }

/*
** only called from dump_mod_table 
*/

static void printmaphdr (unsigned char *buffer, unsigned short cnt)
{	
	taskDelay(2);
	printf("\n");
	sprintf(buffer,"                                             Map Board Lamp Image         ");
	printf( "%s\n", buffer);
	cnt += 1;
        sprintf(buffer,
               " Lamp Number:  Value     Value     Value     Value     Value     Value     Value     Value");
 	printf( "%s\n", buffer);
 	cnt += 1;
}

/*	End of File:	drvMapbd.c */

