/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
/*  File: drvMds_proto.h							
/*  Edit:  03/07/94     WEP: original
*/  	

static  long init ();

        void mdstime (unsigned short line, unsigned short master, unsigned short remote);

        void TRACEINFO (unsigned short line);

        void TRACEMASK (unsigned short line, unsigned short mask);

        void TRACEADD (unsigned short line, unsigned short mask);

        void TRACESUB (unsigned short line, unsigned short mask);

        int STOPDRIVER (short ln);

        int STARTDRIVER (unsigned short primeline,
                         unsigned short line,
                         char *mode,
                         unsigned short delay,
                         unsigned short hdflag,
                         unsigned short delay1,
                         unsigned short delay2,
                         unsigned short timer1,
                         unsigned short timer2);

        void SETDELAYS (unsigned short line,
		        unsigned short tickcount1,
		        unsigned short tickcount2,
		        unsigned short tickcount3);

        void MAIN (unsigned short primeline, unsigned short line, unsigned char *mode,
                   unsigned short delay, unsigned short hdflag, unsigned short delay1, unsigned short delay2,
        	   unsigned short timer1, unsigned short timer2);

        void monitor_state(unsigned short line);

        void get_the_semaphore(unsigned short line);

        void give_the_semaphore(unsigned short line);

static  void check_demand_list(unsigned short line);

static  unsigned int check_master_radio(unsigned short line, unsigned short timer1);

static	unsigned short process_master_radio (unsigned short line);

static  void check_remote_radios(unsigned short line, unsigned short timer2);

static  void check_offline_radios(unsigned short line, unsigned short timer3);

static	void process_remote_radio (unsigned short line, unsigned short radionum);

static	unsigned short send_bo_commands (unsigned short line, unsigned short adapter,
					 unsigned short card, unsigned short signal,
					 unsigned short value);

static  unsigned short send_remotecontrolmaster(unsigned short line,
                                                unsigned short radionum,
                                                unsigned short card,
                                                unsigned short signal,
                                                unsigned char mdscmd);

static	unsigned short send_ao_commands (unsigned short line, unsigned short radionum,
			                 unsigned short card, unsigned short signal,
                                         unsigned char value);

static  unsigned short send_masterdiagnostics(unsigned short line, unsigned char mdscmd);

static  int            send_remoteactivate(unsigned short line,
                                           unsigned short radionum,
                                           MDSRADIO *radio);



static  int            send_remotecontrol(unsigned short line,
                                        unsigned short radionum,
                                        MDSRADIO *radio,
                                        unsigned short value,
                                        unsigned char mdscmd);

static  void makedtmf (unsigned short radionum, unsigned char *retbuf);

static	void makecrc (unsigned char *chkbuf, int len,char unsigned *retbuf);

static	void makechecksum (unsigned char *chkbuf, int len, char unsigned *retbuf);

static  void on_line (unsigned short line,unsigned short radionum);

static  void mark_not_valid (MDSRADIO  *radio);


        int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		     unsigned short signal, short *pvalue, unsigned short conversion,
	             unsigned char *resname);

        int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	             unsigned short signal,double dvalue, unsigned short value,
	             unsigned short conversion, unsigned char *resname);

        int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                     unsigned short signal, unsigned long mask,unsigned long *pvalue,
                     unsigned char *resname);

        int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                     unsigned short signal, unsigned long value, unsigned long mask,
                     unsigned char *resname);

        int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                   unsigned short signal, unsigned short *pvalue,
                   unsigned short conv, unsigned char *resname);

        int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname);

static  void  register_resource (unsigned short link,MDSRADIO *radio,
                                 unsigned char *resname, char *pointname);

static	void outqueinit (unsigned short line);

static	OUTQENT *ogetemptyp (unsigned short line);

static	void omarkfull (unsigned short line);

static	OUTQENT *ogetnextp (unsigned short line);

static	void oreleasefull (unsigned short line);

static	void link_status (unsigned short line);

static  int allocate_radio (unsigned short line, unsigned short radio );

static  int allocate_master (unsigned short line);

static	void start_rx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus);

static	void stop_rx (unsigned short line);

static	void rx_int_proc (unsigned short line);

static	int check_line_activity (unsigned short line, unsigned short predelay);

static	void start_tx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus);

static	void stop_tx (unsigned short line);

static	void tx_int_proc (unsigned short line);

static	unsigned short  mdsmsgout  (unsigned short fline,
				    MDSRADIO *radio,
                                    unsigned short rxlength,
                                    unsigned short checksumflag,
                                    unsigned long time,
                                    unsigned short type);

static	unsigned short  mdsmsgxfer (unsigned short fline,
				    MDSRADIO *radio,
                                    unsigned short rxlength,
                                    unsigned short checksumflag,
                                    unsigned long time,
                                    unsigned short type);

static	void set_release_time (unsigned short line, unsigned long time);

static	void init_line_tab (unsigned short line, MDSRADIO *radio);

static  void init_radio (MDSRADIO  *radio);

static	void init_stats (MDSRADIO *radio);

static	void prepresponses (unsigned short line);

static	int any_responding (unsigned short line);

static  int loadmapfile (unsigned short line);

static  void terminateload (LOADMAP *mapinfo,unsigned short line,
	       unsigned short success,unsigned short code);

static  void eatspaces(char *ch, FILE *handle);

static  void eatline(char *ch, FILE *handle);

        void TABLEINFO (unsigned short line, unsigned short radioaddress);

static  void printbihdr (unsigned char *buffer, unsigned short cnt);

static  void printaihdr (unsigned char *buffer, unsigned short cnt);

        void SHOWMAP (unsigned short line);

static  void printmaphdr (unsigned char *buffer, unsigned short cnt);

        void LINEINFO ();


/*	End of File: drvMds_proto.h */