/*drvMr350_proto.h,v 1.1.1.1 1999/08/03 14:43:23 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File: drvMr350_proto.h                                                        
**                                                                                
**  Edit: 09/17/96      WEP: created MR-350 Data Collection Terminal (DCT) Drive  
**        11/20/97      WEP: modified driver invocation to add a port parameter to
**                         : be used in the Partner Redundant Update function.     
**                         :
*/

static  long init ();

/*********************************************************************************************/
/*********************************************************************************************/
/***** User/Operator Routines ****************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/


        void HELP (void);

        void TRACEON (unsigned short line);

        void TRACEOFF (unsigned short line);

        void TRAFFIC (unsigned short line, unsigned char add, unsigned type);

        void TRAFFICON (unsigned short line);

        void TRAFFICOFF (unsigned short line);

        void RTRACE (unsigned short line, unsigned short level);

        void RTRACEON (unsigned short line);

        void RTRACEOFf (unsigned short line);

        void TRACELEVEL (unsigned short line, unsigned short level);

        void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable);

        void SIMOFF (unsigned short line);

        void CONTRACEON (unsigned short line);

        void CONTRACEOFF (unsigned short line);

        void RUNTRACEON (unsigned short line);

        void RUNTRACEOFF (unsigned short line);

        void REJECTTRACEON (unsigned short line);

        void REJECTTRACEOFF (unsigned short line);

        void NACKTRACEON (unsigned short line);

        void NACKTRACEOFF (unsigned short line);

        void DEFAULTTRACE (unsigned short line);

        void DEBUGTRACE (unsigned short line);

        int STOPDRIVER (short ln);

        int STARTDRIVER  (unsigned short line,      /* the line number of this driver.                      */
                          unsigned short port,      /* the port used by the redundant memory sharing logic. */
                          char *mode,               /* UART initializations string (comma delimited ascii). */
                          unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                          unsigned short hdflag,    /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                          unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                          unsigned short delay2,    /* half duplex post TX, pre RTS drop delay.             */
                          unsigned short private);  /* private flag. if 0, normal. if !0, no partner driver.*/

        void SETCOMM (unsigned short line,
                      unsigned short tickcount1,
                      unsigned short hdflag,
                      unsigned short tickcount2,
                      unsigned short tickcount3);

        void MAIN (unsigned short line,
                      unsigned short port,
                      unsigned char *mode,
                      unsigned short delay,
                      unsigned short hdflag,
                      unsigned short delay1,
                      unsigned short delay2,
                      unsigned short private);

         int checkgroup (unsigned short line, unsigned short *lstate, unsigned short tracenum);

static  void getsemaphore(unsigned short line);

static  void on_line (unsigned short line, unsigned short dct);

static  void mark_not_valid (MR350 *pdct);

static	void scan_dct (MR350 *pdct, unsigned short line, unsigned short dct);

static	void sim_dct (MR350 *pdct, unsigned short line, unsigned short dct);

static	void checkoutputs (unsigned short line);

static  int  write_aos (unsigned short line);

/**************************************************************************************/
/**************************************************************************************/
/***** Driver Routines ****************************************************************/
/**************************************************************************************/
/**************************************************************************************/

        int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                      unsigned short signal, short *pvalue, unsigned short conversion,
                      unsigned char *resname);

        int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                      unsigned short signal,double dvalue, unsigned short value,
                      unsigned short conversion, unsigned char *resname);

        int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                    unsigned short signal, unsigned short *pvalue,
                    unsigned short conversion, unsigned char *resname);

        int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                      unsigned short signal, unsigned long mask, unsigned long *pvalue,
                      unsigned char *resname);

        int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                      unsigned short signal, unsigned long value, unsigned long mask,
                      unsigned char *resname);

        int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                    unsigned short signal, unsigned long *pvalue, unsigned long mask,
                    unsigned char *resname);

        int SIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                      unsigned short signal, short *pvalue, unsigned short len,
                      unsigned char *resname);

        int SODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                      unsigned short signal, unsigned char *value, unsigned short len,
                      unsigned char *resname);

/*********************************************************************************************/
/*********************************************************************************************/
/***** User/Operator Routines ****************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

static  void  register_resource (unsigned short link, MR350 *pdct,
                                unsigned char *resname, char *pointname);


static	void outqueinit (unsigned short line);

static	OUTQENT *ogetemptyp (unsigned short line);

static	void omarkfull (unsigned short line);

static	OUTQENT *ogetnextp (unsigned short line);

static	void oreleasefull (unsigned short line);

/* remote site access task prototype definitions. */
static	void taskqueinit (unsigned short line);
static	TASKOUT *tgetemptyp (unsigned short line);
static	void tmarkfull (unsigned short line);
static	TASKOUT *tgetnextp (unsigned short line);
static	void treleasefull (unsigned short line);


static	void link_status (unsigned short line);

static  int allocate_dct (unsigned short line, unsigned short dct);

static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus);

static	void stop_rx (unsigned short line);

static	void rx_int_proc (unsigned short line);

static	int check_line_activity (unsigned short line, unsigned short predelay);

static	void start_tx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus);

static	void stop_tx (unsigned short line);

static	void tx_int_proc (unsigned short line);

static	unsigned short  msgxfer (unsigned short fline,
                                 unsigned short msgtype,
                                 MR350 *pdct);

static	void accessinit (unsigned short line);

static	void init_dct_tab (unsigned short line, unsigned short dct);

static  void initdct (MR350  *pdct);

static	void initstats (MR350 *pdct);

static	unsigned short dctloopback (unsigned short line, unsigned short dct, MR350 *pdct);

static	void prepresponses (unsigned short line);

static	int any_responding (unsigned short line);

static	unsigned short requestmsgs (unsigned short line, unsigned short dct, MR350 *pdct);

static	unsigned short requestdins (unsigned short line, unsigned short dct, MR350 *pdct);

static	unsigned short setdouts (unsigned short line, unsigned short dct, MR350 *pdct,
                                 unsigned short signal, unsigned short value);

static	unsigned short setledouts (unsigned short line, unsigned short dct, MR350 *pdct,
                                   unsigned short signal, unsigned short value);

static	unsigned short setlcdouts (unsigned short line, unsigned short dct, MR350 *pdct,
                                   unsigned short signal, unsigned char *value);

static	unsigned short setbuzzerouts (unsigned short line, unsigned short dct, MR350 *pdct,
                                      unsigned short signal, unsigned short value);

static	void makechksum (unsigned char *chkbuf, int len,
                         unsigned char addr, char unsigned *retbuf);

static	void hexascii (unsigned short val,char *buf);

static	short asciihex (unsigned short *val,char *buf);

        void DUMPMSGCNTS (unsigned short line);

        void CLEARMSGCNTS (unsigned short line);

        void DUMPDCTSTATS (unsigned short line, unsigned short maddr);

        void CLEARDCTSTATS (unsigned short line, unsigned short maddr);

        void TABLEINFO (unsigned short line, unsigned short maddr);

        void dump_ai_table (unsigned short line, unsigned short maddr);

        LINEINFO ();

/* gordon's code: 9/3/97 */
int     assignLockGroup (int group, char *resource);


/* more remote site access task prototype definitions. */
        void rsainfo(void);

static  int  verifyId (char *cardId, char *passWd, char *usrName);
        void tisEncrypt(char *password, int size);
static  char code(unsigned char *block, int blockLen, unsigned char *key, int keyLen);
static  void byteShift(unsigned char *block, int blockLen);
static  int  loadAccessList (void);
static  int  getSetCurrentState (unsigned short *state, int get);
        void sendalarmmsg1 (unsigned short line);
        void sendalarmmsg2 (unsigned short line);
        void sendalarmmsg3 (unsigned short line);
        void sendvalidkeymsg (unsigned short line, unsigned short unit, unsigned short type);
        void sendinvalidkeymsg (unsigned short line, unsigned short unit);
        void sendvalidcardmsg (unsigned short line, unsigned short unit, unsigned short type);
        void sendinvalidcardmsg (unsigned short line, unsigned short unit);
        void commandLED (unsigned short line, unsigned short unit,
                         unsigned short lednum, unsigned short ledstate);
        void commandLOG (unsigned short line, unsigned short unit,
                         unsigned short lognum, unsigned short logstate);
        void commandKLAXON (unsigned short line, unsigned short unit, unsigned short frequency,
                            unsigned short length, unsigned short numsecs);
        void klaxonon (unsigned short line, unsigned short unit);
        void klaxonoff (unsigned short line, unsigned short unit);
        void lightup (unsigned short line, unsigned short unit, unsigned short led);
        void getmr350stuff (unsigned short line, unsigned short unit);
        void getperimeterstate (unsigned short line);
        void transition (unsigned short line, unsigned short newstate);
        void managetimer(unsigned short line, unsigned short unit);

static	void master_updateredimage (unsigned short line);
static	void slave_updateredimage (unsigned short line, RSAREDUPD *redbuf, int size);

        void RSATASK (unsigned short line,
                      unsigned short delay1,
                      unsigned short delay2,
                      unsigned short delay3,
                      unsigned short port);











/*	End of File:	drvMr350_proto.h */
