/*drvNetpac.c,v 1.1.1.1 1999/08/03 14:43:25 tis4000 Exp */

/****************************************************************/
/*                                                              */
/*    This software is the proprietary property of Tate         */
/*    Integrated Systems, L.P.  Patents and copyrights are      */
/*    pending.                                                  */
/*                                                              */
/*    This software is furnished under a license and may        */
/*    be used and copied only in accordance with the terms      */
/*    of such license and with the inclusion of the above       */
/*    notice. This software or any other copies thereof         */
/*    may not be provided or otherwise made available to        */
/*    any other person. No title to and ownership of the        */
/*    software is hereby transferred.                           */
/*                                                              */
/*    The information in this software is subject to            */
/*    change without notice and should not be construed         */
/*    as a commitment by Tate Integrated Systems L.P. or        */
/*    its third party suppliers.                                */
/*                                                              */
/*    Tate Integrated Systems, L.P. (TIS) and its third         */
/*    party suppliers assume no responsibility for the          */
/*    use or inability to use any of its software. TIS          */
/*    software is provided "as is" without warranty of          */
/*    any kind and TIS expressly disclaims all implied          */
/*    warranties, including but not limited to the implied      */
/*    warranties of merchantability and fitness for a           */
/*    particular purpose.                                       */
/*                                                              */
/*    Notice: Notwithstanding any other lease or license        */
/*    that may pertain to or accompany the delivery of this     */
/*    computer software, the rights of the Government           */
/*    regarding its use, reproduction, and disclosure are       */
/*    as set forth in Section 52.227-19 of the FARS             */
/*    Computer Software-Restricted Rights clause.               */
/*                                                              */
/****************************************************************/
/*
/*  File: drvNetpac.c
/*  Edit:  7/25/95     wep : created                              
/*                         :
/*
*/                                                                                                                      

#define  MAIN           netpac_driver           /* NOTE: change here */
#define  AIDRIVER       netpac_aidriver         /* NOTE: change here */
#define  AODRIVER       netpac_aodriver         /* NOTE: change here */
#define  AOREAD         netpac_aoread           /* NOTE: change here */
#define  BIDRIVER       netpac_bidriver         /* NOTE: change here */
#define  BODRIVER       netpac_bodriver         /* NOTE: change here */
#define  BOREAD         netpac_boread           /* NOTE: change here */

#define  ASCIION        np_asciion              /* NOTE: change here */
#define  ASCIIOFF       np_asciioff             /* NOTE: change here */
#define  TRAFFICON      np_trafficon            /* NOTE: change here */
#define  TRAFFICOFF     np_trafficoff           /* NOTE: change here */
#define  TRAFFIC        np_traffic              /* NOTE: change here */
#define  TRACEON        np_traceon              /* NOTE: change here */
#define  TRACEOFF       np_traceoff             /* NOTE: change here */
#define  RTRACE         np_restrlv              /* NOTE: change here */
#define  RTRACEON       np_restraceon           /* NOTE: change here */
#define  RTRACEOFF      np_restraceoff          /* NOTE: change here */
#define  TRACELEVEL     np_trlv                 /* NOTE: change here */
#define  CONTRACEON     np_contraceon           /* NOTE: change here */
#define  CONTRACEOFF    np_contraceoff          /* NOTE: change here */
#define  RUNTRACEON     np_runtraceon           /* NOTE: change here */
#define  RUNTRACEOFF    np_runtraceoff          /* NOTE: change here */
#define  REJECTTRACEON  np_rejecttraceon        /* NOTE: change here */
#define  REJECTTRACEOFF np_rejecttraceoff       /* NOTE: change here */
#define  NACKTRACEON    np_nacktraceon          /* NOTE: change here */
#define  NACKTRACEOFF   np_nacktraceoff         /* NOTE: change here */
#define  DEFAULTTRACE   np_defaulttrace         /* NOTE: change here */
                                           
#define  HELP           np_help                 /* NOTE: change here */
#define  SIMON          np_simon                /* NOTE: change here */
#define  SIMOFF         np_simoff               /* NOTE: change here */

#define  STOPDRIVER     stopnetpac              /* NOTE: change here */
#define  STARTDRIVER    startnetpac             /* NOTE: change here */
#define  SETCOMM        np_comm                 /* NOTE: change here */

#define  DUMPMSGCNTS    np_dumpmsgcnts          /* NOTE: change here */
#define  CLEARMSGCNTS   np_clearmsgcnts         /* NOTE: change here */
#define  DUMPMODSTATS   np_dumpmodulestats      /* NOTE: change here */
#define  CLEARMODSTATS  np_clearmodulestats     /* NOTE: change here */
                                           
#define  TABLEINFO      np_tableinfo            /* NOTE: change here */
#define  MODULEINFO     np_modinfo              /* NOTE: change here */
#define  LINEINFO       np_lineinfo             /* NOTE: change here */

#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvNetpac.h>                          /* NOTE: change here */
#include <drvNetpac_proto.h>                    /* NOTE: change here */
#include <restable.h>


/* static long    init(); */
struct {
            long        number;
            DRVSUPFUN   report;
            DRVSUPFUN   init;
       }
        drvNetpac={ 2, NULL, init};

/*
/*      External Line Level Data Structures (declared in drvcommon.c)
/*
*/

extern  unsigned char   resnames [NETPACLINES] [RESNAMELEN]; /* array of resource name strings.       */

extern  RES_TABLE      *prestable [NETPACLINES];      /* array of pointers to resource tables         */

extern  unsigned short  resresponse [NETPACLINES];    /* array of resource response flags.            */
                                                      /* False = not active resource(slave),          */
                                                      /* True = active resource(master).              */

extern  unsigned short  line_activity [NETPACLINES];  /* true/false line active flag. calculated      */
                                                      /* using activity_time below.                   */
extern  unsigned short  lastactivity [NETPACLINES];   /* assigned value of line_activity prior to     */
                                                      /* it's recalculation.                          */

extern  unsigned short  modtrace [NETPACLINES];       /* controls output of communication error log   */
                                                      /* messages (true/false)                        */
extern  unsigned short  mltrace [NETPACLINES];        /* controls output of certain resource related  */
                                                      /* log messages (level)                         */
extern  unsigned short  modrestrace [NETPACLINES];    /* controls output of MASTER/SLAVE arbitration  */
                                                      /* log messages (binary)                        */

extern  SEM_ID          semids [NETPACLINES] [2];     /* 'new' semaphore logic. the old SEMAPHORE is  */
                                                      /* still used.                                  */

extern  unsigned short  intermsgdelay [NETPACLINES];  /* holds value passed in task spawn. used for   */
                                                      /* each msgxfer attempt                         */
extern	unsigned short	pretxdelay [NETPACLINES];     /* holds post RTS delay before TX.              */
extern	unsigned short	posttxdelay [NETPACLINES];    /* holds post TX delay before dropping RTS.     */


extern  long            activity_time [NETPACLINES];  /* holds timetick of last activity. used to     */
                                                      /* set line_activity flag                       */

extern  SEM_ID          linemux [NETPACLINES];        /* 1/03/94: mutual-exclusion semaphore for      */
                                                      /* shared resource of the data link             */
                                                      /* controls access to common path shared by     */
                                                      /* data and diagnostic channels.                */
                                                      /* originally designed for use with MDS remote  */
                                                      /* radio diagnostics.                           */

extern  unsigned short  pstatewait [NETPACLINES];     /* holds max time in seconds that driver will   */
                                                      /* wait to obtain partner state on first        */
                                                      /* attempting to decide if it should be master. */


/*
/*      Storage for Netpac Comm Line Structures
/*
*/

static RXLINE          *rxlinetab [NETPACLINES] =
                        {NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically         */
                                                          /* allocated comm controls/buffers          */

static TXLINE          *txlinetab [NETPACLINES] =
                        {NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically         */
                                                          /* allocated comm controls/buffers          */


/*
/*      Storage for Netpac Structures
/*
*/
static unsigned int     modsim [NETPACLINES];         /* 0 = normal operation, 1 = simulation.        */

static unsigned int     simdelay [NETPACLINES];

static          int     simlow [NETPACLINES];

static          int     simhigh [NETPACLINES];

static          int     simdigon [NETPACLINES];

static unsigned int     tick [NETPACLINES][5];

static unsigned int     lastscan [NETPACLINES];       /* holds timestamp of start of main loop.       */

static unsigned int     scantime [NETPACLINES];       /* holds actual time taken to scan modules.     */

static unsigned int     loopoutmsgs [NETPACLINES];

static unsigned int     loopmsgs [NETPACLINES];

static LINESTATS        linestats [NETPACLINES];      /* array of line level statistics.              */


static NETPAC           *modules [NETPACLINES] [NUMMODS]; /* two dimensional array of pointers to     */
                                                      /* fixed length dynamically allocated Netpac    */
                                                      /* control and data structures.                 */

static  unsigned short  trace [NETPACLINES];          /* controls output of system error messages:    */
                                                      /* bit mapped controls                          */
static  unsigned char   traceadr [NETPACLINES];
static  unsigned char   tracetype [NETPACLINES];

static           char   user [40], password [40];     /* holds id and password of the user that       */
                                                      /* spawned the driver task required by host to  */
                                                      /* check file read privileges on load files     */


static  unsigned short  options [NETPACLINES];        /* store half/full duplex line status           */

static           char  *bools [] = {"TRUE ","FALSE"};

static           int    taskId [NETPACLINES];
static           short  watchdogId [NETPACLINES];


static           char  *tasknames [] =
                           {"NETPAC Ch0", "NETPAC Ch1", "NETPAC Ch2", "NETPAC Ch3",
                            "NETPAC Ch4", "NETPAC Ch5", "NETPAC Ch6", "NETPAC Ch7",
                            "NETPAC Ch8", "NETPAC Ch9", "NETPAC Ch10","NETPAC Ch11",
                            "NETPAC Ch12","NETPAC Ch13","NETPAC Ch14",
                            "NETPAC Ch15","NETPAC Ch16","NETPAC Ch17",
                            "NETPAC Ch18","NETPAC Ch19","NETPAC Ch20"};


/**********
*
*    This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
{
    return (0);
}

np_set_rts(line)
{
    set_rts(line);
}

np_clear_rts(line)
{
    clear_rts(line);
}


/********
/*
/*    This routine outputs information to help with debugging.
/*
********/
void HELP (void)
{
    printf ("Starting and Stopping the Netpac Driver:\n");
    printf ("\n");
    printf (" startnetpac(N,C,T1,H,T2,T3,P)                                                     \n");
    printf ("                      N: line number                                              \n");
    printf ("                      C: communications parameter string (comma delimited ascii)  \n"); 
    printf ("                     T1: intermessage delay (in ticks).                           \n");
    printf ("                      H: 1 = half duplex.                                         \n");
    printf ("                     T2: post RTS assert, pre TX delay (in ticks).                \n");
    printf ("                     T3: post TX, pre RTS drop delay (in ticks).                  \n");
    printf ("                      P: Private/Redundant mode.  0 = redundant, !0 = private.    \n");
    printf ("                                                                                  \n");
    printf (" Example: startnetpac(2,\"19200,N,8,1\",4,1,0,0,0)                                \n");
    printf ("                                                                                  \n");
    printf (" stopnetpac(N)                                                                    \n");
    printf ("                     N = line number                                              \n");
    printf ("\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf ("Netpac Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" np_traceon(N)      Enable the following debug messages for line N:             \n");
    printf ("                         1) Major Scan loop Info:                               \n");
    printf ("                           scan time, total output messages, and total messages.\n"); 
    printf ("                         2) Output Queue Overflow.                              \n");
    printf ("                         3) All communication errors encountered in msgxfer.    \n");
    printf ("*np_traceoff(N)     Disable all of the modtraceon debug messages for line N.    \n");
    printf ("\n");
    printf (" np_restrace(N,X)   Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*np_restraceon(N)   Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" np_restraceoff(N)  Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" np_contraceon(N)     Enable display of configuration errors in driver calls.     \n");
    printf ("*np_contraceoff(N)    Disable display of configuration errors in driver calls.    \n");
    printf (" np_runtraceon(N)     Enable display of runtime errors (queue overflow).          \n");
    printf ("*np_runtraceoff(N)    Disable display of runtime errors (queue overflow).         \n");
    printf (" np_rejecttraceon(N)  Enable display of driver call rejections in driver calls.   \n");
    printf ("*np_rejecttraceoff(N) Disable display of driver call rejections in driver calls.  \n");
    printf (" np_nacktraceon(N)    Enable display of point deselection on NETPAC command NACK. \n");
    printf ("*np_nacktraceoff(N)   Disable display of point deselection on NETPAC command NACK.\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" np_trlv(N,X)       Enable the following message for line N:                    \n");
    printf ("                         X=0,  display none of the messages below.              \n");
    printf ("                         X=1,  beginning of scan loop, bringing modules online. \n");
    printf ("                         X=2,  beginning of scan.                               \n");
    printf ("                         X=3 to 7,   reserved                                   \n");
    printf ("                         X=8,  AIDRIVER: normal call return.                    \n");
    printf ("                         X=9,  BIDRIVER: normal call return.                    \n");
    printf ("                         X=10 to 254,  reserved.                                \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" np_trafficon(N)    Enable traffic tracing for all module addresses             \n");
    printf ("                         and all modbus functions on line N.                    \n");
    printf ("*np_trafficoff(N)   Disable all traffic tracing on line N.                      \n");
    printf (" np_traffic(N,X,Y)  Modifies line N traffic tracing as follows:                 \n");
    printf ("                         X=0   disables tracing of all addresses.               \n");
    printf ("                         X=255 enables tracing of all addresses.                \n");
    printf ("                         0 < X < 255 enables tracing of address X traffic.      \n");
    printf ("                         Y=0   disables tracing of all modbus functions.        \n");
    printf ("                         Y=255 enables tracing of all modbus functions.         \n");
    printf ("                         0 < Y < 255 enables tracing of function Y traffic.     \n");
    printf ("\n");
    printf (" np_defaulttrace(N) Restores default setting for all traces.                    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" np_simon(N,D,L,H,T) Enables the simulation of responding modules.                 \n");
    printf ("                        D: simulation interval (in seconds). if D<1 or D>60, D=60. \n");
    printf ("                        L: low value of analog simulation range.                   \n");
    printf ("                        H: high value of analog simulation range.                  \n");
    printf ("                        T: 0 = digital inputs are zero. 1 = digitial inputs toggle.\n");
    printf ("*np_simoff(N)        Disables simulation, thus enabling normal driver function.    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" np_comm(N,t1,h,t2,t3) Set communication timing parameters for line N as follows:   \n");
    printf ("                         t1: intermessage delay (in ticks).                         \n");
    printf ("                          h: 1 = half duplex.                                       \n");
    printf ("                         t2: post RTS assert, pre TX delay (in ticks).              \n");
    printf ("                         t3: post TX, pre RTS drop delay (in ticks).                \n");
    printf ("\n");
    printf (" np_dumpmsgcnts(N)     Display line N communication statistics.                    \n");
    printf (" np_clearmsgcnts(N)    Display and clear line N communication statistics.          \n");
    printf (" np_dumpmodulestats(N,X)  Display line N, module X, communication statistics.      \n");
    printf (" np_clearmodulestats(N,X) Display and clear line N, module X, xfers, status & errors.\n");
    printf (" np_tableinfo(N,X)     Display line N, mod X, xfers, status, errors and input data.\n");
    printf (" np_modinfo(N)         Display summary stats for all known modules on the line.    \n");
    printf (" np_lineinfo           Display simple status info for all netpac driver lines.     \n");
    printf (" np_help               Display this information.                                   \n");
}


/********
/*
/*    This routine enables logging of comm trace messages
/*
********/
void TRACEON (unsigned short line)
{
    modtrace [line] = TRUE;
}

/********
/*
/*    This routine disables logging of comm trace messages
/*
********/
void TRACEOFF (unsigned short line)
{
    modtrace [line] = FALSE;
}

/********
/*
/*    This routine enables detailed display of normal communications traffic
/*
********/
void TRAFFIC (unsigned short line, unsigned char add, unsigned type)
{
    trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = add;
        tracetype [line] = type;
        return;
}

/********
/*
/*    This routine enables detailed display of normal communications traffic
/*
********/
void TRAFFICON (unsigned short line)
{
    trace [line] = trace [line] | ASCIITRAFFICTRACE;
    trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = 255;  /* every address */
        tracetype [line] = 255; /* every message type */
}

/********
/*
/*    This routine disables detailed display of normal communications traffic
/*
********/
void TRAFFICOFF (unsigned short line)
{
    trace [line] = trace [line] & ~ALLTRAFFICTRACE;
    trace [line] = trace [line] & ~ASCIITRAFFICTRACE;
}

/********
/*
/*    This routine enables detailed display of normal communications traffic in ascii
/*
********/
void ASCIION (unsigned short line)
{
    trace [line] = trace [line] | ASCIITRAFFICTRACE;
}

/********
/*
/*    This routine returns detailed display of normal communications traffic in ascii-hex
/*
********/
void ASCIIOFF (unsigned short line)
{
    trace [line] = trace [line] & ~ASCIITRAFFICTRACE;
}

/********
/*
/*    This routine enables logging of resource trace messages
/*
********/
void RTRACE (unsigned short line, unsigned short level)
{
    modrestrace [line] = level;
}

/********
/*
/*    This routine enables logging of resource trace messages
/*
********/
void RTRACEON (unsigned short line)
{
    modrestrace [line] = 1;
}

/********
/*
/*    This routine disables logging of resource trace messages
/*
********/
void RTRACEOFF (unsigned short line)
{
    modrestrace [line] = 0;
}

/********
/*
/*    This routine controls logging of trace messages
/*
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
    mltrace [line] = level;
}

/********
/*
/*    This routine enables the simulation of responding modules, reading all input values as zero.
/*
********/
void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable)
{
    if ((delay < 1) || (delay > 60))
    {
        simdelay [line] = 60;
    }
    else
    {
        simdelay [line] = delay;
    }
    if (low > high)
    {
        simhigh [line] = low;
        simlow [line] = high;
    }
    else
    {
        simlow [line] = low;
        simhigh [line] = high;
    }
    modsim [line] = TRUE;
    simdigon [line] = digenable;
}

/********
/*
/*    This routine disables simulation, thus enabling normal driver function.
/*
********/
void SIMOFF (unsigned short line)
{
    modsim [line] = FALSE;
}

/********
/*
/*    These routines enable and disable tracing of database configuration errors in driver calls
/*
********/
void CONTRACEON (unsigned short line)
{
    trace[line] = trace[line] | CONFIGURATIONTRACE;
}

void CONTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~CONFIGURATIONTRACE;
}

/********
/*
/*    These routines enable and disable tracing of runtime errors in driver calls
/*
********/
void RUNTRACEON (unsigned short line)
{
    trace[line] = trace[line] | RUNTIMEERRORTRACE;
}

void RUNTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
}

/********
/*
/*    These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void REJECTTRACEON (unsigned short line)
{
    trace[line] = trace[line] | CALLREJECTTRACE;
}

void REJECTTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~CALLREJECTTRACE;
}


/********
/*
/*    These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void NACKTRACEON (unsigned short line)
{
    trace[line] = trace[line] | MODBUSNACKTRACE;
}

void NACKTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~MODBUSNACKTRACE;
}

/********
/*
/*    These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void npallstatuson (unsigned short line)
{
    trace[line] = trace[line] |
                  OKTRACE |
                  COMMTRACE |
                  PROGTRACE |
                  FATALTRACE |
                  CONFIGTRACE |
                  UNKNOWNTRACE |
                  0;
}

void npallstatusoff (unsigned short line)
{
    trace[line] = trace[line] &
                  ~OKTRACE &
                  ~COMMTRACE &
                  ~PROGTRACE &
                  ~FATALTRACE &
                  ~CONFIGTRACE &
                  ~UNKNOWNTRACE &
                  ~0;
}

/********
/*
/*    These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void npbadstatuson (unsigned short line)
{
    trace[line] = trace[line] |
                  COMMTRACE |
                  PROGTRACE |
                  FATALTRACE |
                  CONFIGTRACE |
                  UNKNOWNTRACE |
                  0;
}

void npbadstatusoff (unsigned short line)
{
    trace[line] = trace[line] &
                  ~COMMTRACE &
                  ~PROGTRACE &
                  ~FATALTRACE &
                  ~CONFIGTRACE &
                  ~UNKNOWNTRACE &
                  ~0;
}

/********
/*
/*    This routine restores default setting for all traces.
/*
********/
void DEFAULTTRACE (unsigned short line)
{
    /* debug structures */
    modtrace [line] = FALSE;
    mltrace [line] = 0;
    modrestrace [line] = 1;
    trace [line] = 0;
    traceadr [line] = 255;  /* every address      */
    tracetype [line] = 255; /* every message type */
}

int STOPDRIVER (short ln)
{
    if (comm_disconnect (ln) != -1)
    {
        /* if watchdog timer has been attached, detach it before deleting the task */
        if (taskId[ln])
        {
            tisWatchDogDetach(taskId[ln]);
        }
        taskDelete (taskId [ln]);
        return (1);
    }
    else
    {
        return (-1);
    }
}

int STARTDRIVER (unsigned short line,       /* the line number of this driver.                      */
                  char *mode,               /* UART initializations string (comma delimited ascii). */
                  unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                  unsigned short slug,      /* half duplex flag placeholder: ignored.               */
                  unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                  unsigned short delay2,    /* half duplex post TX, pre RTS drop delay.             */
                  unsigned short private)   /* private flag. if 0, normal. if !0, no partner driver.*/
{
    if (line < NETPACLINES)
    {
        taskId [line] = taskSpawn (tasknames [line],
                                   NETPAC_PRIORITY,
                                   NETPAC_TASK_OPTIONS,
                                   NETPAC_STACK,
                                   MAIN,
                                   line,
                                   mode,
                                   delay,
                                   delay1,
                                   delay2,
                                   private);

        logMsg ("Started the NETPAC driver on line %d\n",line);

        remCurIdGet (user,password);
        return (1);
    }
    else
    {
        logMsg ("Invalid line number %d\n", line);
        return (-1);
    }
}

/********
/*
/* Set communication logic time delays to handle radio delays and half duplex delays. */
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short slug,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
	pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}


/*                                                                              
/*    netpac_driver                                                             
/*                                                                              
/*      The purpose of this task is to scan the netpac module lines.            
/*      It will maintain a configuration list supporting online additions       
/*      and replacement of modules, and maintain a table of most recently       
/*      scanned values.                                                         
/*                                                                              
*/                                                                                         
/* not called from within this driver     */

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short delay1,
           unsigned short delay2,
           unsigned short private)
{
    unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
    unsigned short  activity, pstate, lstate, execute, command,i;
    long            this_time, last_time;
    NETPAC          *pmod;
    RXLINE          *rxp;
    unsigned int    temptick, tempdiff;
    int             temp;

    short  *ptable_id;

    /* Initialize the data structures */
    intermsgdelay [line] = delay;
    pretxdelay [line]    = delay1;
    posttxdelay [line]   = delay2;


    resresponse [line] = FALSE;
    resnames [line] [0] = 0;
    prestable [line] = NULL;

    activity_time [line] = tickGet ();
    lastactivity [line] = line_activity [line] = FALSE;

    pstatewait[line] = 60;      /* will wait up to one minute for partner to become valid */

    /* debug structures */
    /* moddebugtrace (line); */
    DEFAULTTRACE (line);

    tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

    linestats [line].TXintcount = 0;
    linestats [line].RXintcount = 0;
    linestats [line].msgxfercount = 0;
    linestats [line].startingtick = tickGet ();

    modsim [line] = FALSE;              /* start with normal operation. */

    /* communication initialization */
    rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
    if (!rxlinetab [line])
    {
        logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
        return;
    }
    txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
    if (!txlinetab [line])
    {
        logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
        return;
    }

    taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */
    comm_init (line, mode, &tx_int_proc, &rx_int_proc);
    clear_rts (line);
    taskUnlock ();

    onlinefreq = 1;   /* causes on_line calls to begin on first pass if master */

    /* Initialize the Rx interrupts to receive once for activity check         */
    /* enable the receiver interrupt after set to ignore                       */

    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
    enable_rx_ints (line);

/*                                                                                                  
/* 1/03/94:                                                                                         
/*  initialize mutual-exclusion semaphore logic for diagnostic driver path sharing. The Take/Put    
/*  logic implemented below is designed to insure, under heavy diagnostic demand, that scan_module  
/*  and the on_line while routine are executed once for every two diagnostic Take/Put sequences.    
/*  Furthermore, diagnostic activities are suspended during master/slave arbitration by Taking      
/*  the semaphore while the local state is not the master state.                                    
/*
*/   
    taskLock ();
    linemux [line] = semMCreate (SEM_Q_PRIORITY); /* default: semaphore initializes as 'full',    */
                                                  /* ready to be Taken.                           */
    if (!linemux [line])
    {
        logMsg  ("Not enough memory for line %d data structure (mutual-exclusion semaphore)\n",line);
        taskUnlock ();
        return;
    }
    if ((semTake (linemux [line], MUXTIMEOUT)) == ERROR)
    {
        logMsg ("Netpac: Mutual-Exclusion Semaphore Timeout on Line\n",line);
        taskDelay(300);
    }

    taskUnlock ();
    taskDelay (120);/* short delay for diagnostic readability */


    /* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
    while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
    {
        if (modrestrace [line] > 1)
        {
            logMsg ( "No Resource Defined for this line.\n");
        }
        taskDelay (600);
    }
    /* diagnostic message */
    logMsg ( "Resource has now been defined for this line.\n");
    taskDelay (60);

    /* attach this driver task to the watchdog timer monitoring function. */
    ptable_id = &watchdogId[line];

    if (tisWatchDogAttach(taskId[line],WATCHDOGTIMEOUT, ptable_id) != OK)
    {
        logMsg("Attempt at watchdog attachment failed.\n");
        tisWatchDogDetach(taskId[line]);
        return;
    }
    if (tisWatchDogPulse(watchdogId[line]) != OK)
    {
        logMsg("First attempt at watchdog pulsing failed.\n");
        tisWatchDogDetach(taskId[line]);
        return;
    }

    /* diagnostic message */
    logMsg ( "Watchdog timer is now attached.\n");
    taskDelay (60);

    if (private)
    {
        /*****************************/
        /* Immediately become master */
        /*****************************/

        resSetCaAnswer (prestable [line]);
        resPutLocalState (prestable [line], RES_MSTR);

        lastscan [line] = tickGet ();
        scantime [line] = 0;

        lstate = RES_MSTR;
        if (modrestrace [line])
        {
            logMsg ("0] Private: Initialize as RES_MSTR\n");
        }
        semGive (linemux [line]);    /* give back semaphore so diagnostics can run   */
    }
    else /* this is the 'normal' path */
    {
        /**********************/
        /* Start out as slave */

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        resClearCaAnswer (prestable [line]);        /* start quiet */
        resPutLocalState (prestable [line], RES_SLV);

        if (modrestrace [line])
        {
            logMsg ("1] Initialized as RES_SLV\n");
        }

        /* wait finite time for pstate to be resolved */
        logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
        for (i = 0; i <= pstatewait [line]; i++)
        {
            resGetStates (prestable [line], &lstate, &pstate);
            if (pstate != 0)
            {
                break;
            }
            taskDelay (60);
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/
        }

        if (pstate == 0)
        {
            logMsg ("Timeout of pstate wait.\n");
        }
        else
        {
            logMsg ("Completion of pstate wait.\n");
        }

        for (i = 0; i < ACTIVITYTIME/10; i++) ;  /* ten seconds */
        {
            taskDelay(10);
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/
        }

        activity = check_line_activity(line, 0);
        resGetStates (prestable [line], &lstate, &pstate);

        /******************************************/
        /* if the partner is not there, be master */

        if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
        {
            resSetCaAnswer (prestable [line]);
            resPutLocalState (prestable [line], RES_MSTR);
            lastscan [line] = tickGet ();
            scantime [line] = 0;
            lstate = RES_MSTR;
            if (modrestrace [line])
            {
                logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
            }
            semGive (linemux [line]);    /* give back semaphore so diagnostics can run   */
            prepresponses (line);
        }
    }

    cfgchk = 0;               /* Init the new config pointer.  */
    last_time = tickGet ();   /* Initialize the time.          */

    while (TRUE)
    {
        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        activity_time [line] = tickGet ();
        lastactivity [line] = line_activity [line] = FALSE;

        /*********************************************************************************************/
        /* we arrive here because we are a slave.                                                    */
        /* we stay until:   asked to be master by partner. if we can reach modules, we become master.*/
        /*                  the partner is not master and there is no activity on the line.          */
        /*********************************************************************************************/

        while (lstate == RES_SLV)
        {
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* check for module simulated mode. */
            if (modsim [line])
            {
                semGive (linemux [line]);    /* give back semaphore so diagnostics can function      */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                if (modrestrace [line])
                {
                    logMsg ("Simulation Mode] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                }
                break;
            }

            if (pstate != RES_SLVWANT)
            {
                clear_rts (line);                      /* make sure line is left for master    */
            }
            resresponse [line] = FALSE;                /* make sure driver is not responding   */
            resPutCommand (prestable [line], 0);       /* clear out commands                   */
            activity = check_line_activity (line, 10); /* wait 10 seconds before checking      */
            resGetStates (prestable [line], &lstate, &pstate);

            /****************************************************************************************/
            /* see if needed by partner to be master. if yes, do it and break out of slave state.   */
            if (pstate == RES_SLVWANTCA)
            {
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                if (modrestrace [line])
                {
                    logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                }
                taskDelay (60);
                prepresponses (line);
                semGive (linemux [line]);    /* give back semaphore so diagnostics can function     */
                resSetCaAnswer (prestable [line]);
                onlinefreq = 1;   /* causes on_line calls to begin on first pass as master */
                break;
            }
            /***************************************************************/
            /* If partner is there and wants to give it up, try to take it */

            if (pstate == RES_SLVWANT)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                execute = FALSE;
                taskDelay (2); /* Time for switch to occur */

                /* See if anyone is out there and able to respond to a loopback command */
                for (mod = 0; (mod < NUMMODS); mod++)
                {
                    pmod = modules [line] [mod];
                    if ((pmod) &&            /* verify pointer validity prior to use */
                        (pmod->was_requested) &&    /* data points have been requested      */
                        (!pmod->cmd_force_offline)) /* user has NOT forced module offline      */
                    {
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        on_line (line, mod);
                        /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                        if ((pmod->is_responding) && (!pmod->cmd_force_offline))
                        {
                            execute = TRUE;
                            break;
                        }
                    }
                }
                /* If someone answered, become master and make sure partner really gave it up */
                if (execute)
                {
                    resPutLocalState (prestable [line], RES_MSTR);
                    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

                    if (modrestrace [line])
                    {
                        logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                    }
                    execute = FALSE;
                    activity_time [line] = tickGet ();
                    lastactivity [line] = line_activity [line] = FALSE;
                    for (i = 0; (i < 60); i++)
                    {
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/

                        activity = check_line_activity (line, 2); /* pause before testing */
                        resGetStates (prestable [line], &lstate, &pstate);
                        if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
                        {
                            execute = TRUE; /* Partner Gave It Up so take CA */
                            break;
                        }
                    }
                    if (!execute)
                    {   /* Partner did not give it up go back to slave */
                        resPutLocalState (prestable [line], RES_SLV);
                        lstate = RES_SLV;
                        if (modrestrace [line])
                        {
                            logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                        }
                    }
                    else
                    { /* Assume control by taking the CA responsibilities */
                        semGive (linemux [line]);  /* give back semaphore so diagnostics can run. */
                        resSetCaAnswer (prestable [line]);
                        prepresponses (line);
                        break;
                    }
                }
            }

            /********************************************/
            /* if the partner is not talking, be master */

            if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
            {
                semGive (linemux [line]);          /* give back semaphore so diagnostics can run.  */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                if (modrestrace [line])
                {
                    logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
                }
                prepresponses (line);
                onlinefreq = 1;   /* causes on_line calls to begin on first pass as master */
            }
        }

        /****************************************************************************************/
        /* to arrive here, we used to be master, and had been told to relinquish master status. */
        /* stay in this loop until the partner takes over, or the command is canceled.          */
        /****************************************************************************************/
        while (lstate == RES_SLVWANTCA)
        {
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            taskDelay (2);                   /* Give OS a chance...  */
            clear_rts (line);                /* Make sure line is left for master    */
            resresponse [line] = FALSE;      /* Make Sure driver is not responding   */

            resGetStates (prestable [line], &lstate, &pstate);
            if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
            {
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                if (modrestrace [line])
                {
                    logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                }
                break;
            }
            resGetCommand (prestable [line], &command);
            resPutCommand (prestable [line], 0); /* clear out commands */
            if (command == RES_CANCELREL)
            {
                semGive (linemux [line]);        /* give back semaphore so diagnostics can run.  */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;
                if (modrestrace [line])
                {
                    logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                }
                prepresponses (line);
            }
        }

        /****************************************************************************************/
        /* in normal operation this code should never execute. it has, however, been seen to    */
        /* execute when the database has been inadvertently configured with the same resource   */
        /* assigned to two different drivers in the same IOC. The state does funny things.      */
        /****************************************************************************************/
        while (lstate == RES_SLVWANT)
        {
            if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))
            {
                /* condition should NEVER occur. print error message every 5 seconds. */
                logMsg ("Illegal Local Resource State.\n");
                if (trace[line] & CONFIGURATIONTRACE)
                {
                    logMsg ("  Possible Resource Configuration Error:\n");
                    logMsg ("   Check for multiple drivers sharing single Resource.\n");
                }
                taskDelay (600);
            }
            taskDelay (2);
        }

        /****************************************************************************************/
        /* we come here because we have gone to, or are looping in, the master state.           */
        /* we stay in this loop until:    we have been told to give master state to the partner.*/
        /*                                we break out to RES_SLVWANTCA.                        */
        /*                                we have successfully handed master state to partner.  */
        /* While master, this task will process all modules sending outputs and getting inputs. */
        /* It will then try to configure requested non-responding modules.                      */
        /****************************************************************************************/
        last_time = tickGet ();        /* initialize gap */
        while (lstate == RES_MSTR)
        {
            if (mltrace [line] == 1)
            {
                logMsg ( "Top of Master Loop... \n");
            }
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* check for module simulated mode. */
            while (modsim [line])
            {
                resresponse [line] = TRUE; /* Make sure driver is responding. driver won't      */
                for (mod = 0; (mod < NUMMODS); mod++)
                {
                    pmod = modules [line] [mod];    /* shorthand pointer                        */
                    if (pmod)                       /* verify pointer validity prior to use.    */
                    {
                        if (pmod->cmd_force_offline)
                        {
                            /* if user has turned this module offline via pseudo commands,      */
                            /* mark it as not responding.                                       */
                            pmod->is_responding = FALSE;
                        }
                        else
                        {
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/

                            sim_module (pmod, line, mod);      /* I/O done here!         */
                            taskDelay (simdelay [line]);
                        }
                    }
                }
            }
            /* initial stuff */
            resresponse [line] = TRUE; /* Make sure driver is responding. driver won't   */
                                       /* issue commands if not set.                     */

            resGetCommand (prestable [line], &command);
            resPutCommand (prestable [line], 0);        /* clear out commands */

            /************************************************************************/
            /* if relinquish command sent, change state and break out to outer loop */
            if (command == RES_RELINQUISH)
            {
                getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLVWANTCA);
                lstate = RES_SLVWANTCA;
                if (modrestrace [line])
                {
                    logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
                }
                break;
            }

            /* measure time between scans of the entire set of modules. display if requested. */
            temptick = tickGet ();
            tempdiff = temptick - lastscan [line];

            if (modtrace [line])
            {
                logMsg ("ScanTime: =%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                         scantime[line], loopoutmsgs[line], loopmsgs[line]);
            }

            loopoutmsgs [line] = 0;
            loopmsgs [line] = 0;
            lastscan [line] = temptick;

            /* scan modules for data i/o, if allowed */

            modspolled = 0;

            /* call 'scan_module' for each Netpac Module, unless the   */
            /* user has taken it off line or it is not responding.     */
            for (mod = 0; (mod < NUMMODS); mod++)
            {
                pmod = modules [line] [mod];  /* shorthand pointer                    */
                if (pmod)                     /* verify pointer validity prior to use */
                {
                    if (pmod->cmd_force_offline)
                    {
                        /* if user has turned this module offline via pseudo commands,   */
                        /* mark it as not responding.                                    */
                        pmod->is_responding = FALSE;
                        mark_not_valid (pmod);
                    }
                    else if (pmod->is_responding)
                    {
                        /* local/partner lockstep recovery */
                         resGetStates (prestable [line], &lstate, &pstate);
                        if (pstate == RES_MSTR)
                        {
                            resClearCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_SLV);
                            lstate = RES_SLV;
                            clear_rts (line);         /* Make sure line is left for master */
                            if (modrestrace [line])
                            {
                                logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                            }
                            temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                            for ( i = 0; i < temp; i++)
                            {
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                            }
                            break;
                        }
                        modspolled++;

                        getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                        scan_module (pmod, line, mod);          /* I/O done here!              */
                        semGive (linemux [line]);
                        if (!pmod->is_responding)
                        {
                            mark_not_valid (pmod);
                        }
                    }
                }
                /* end of single module action */

                /* if told to relinquish our master state, stop module scanning immediately. */
                /* immediately, don't trash the command, so that we can still read it on     */
                /* the next loop through this while statement.                               */
                resGetCommand (prestable [line], &command);
                if (command == RES_RELINQUISH)
                {
                    break;
                }
            } /* end of scan loop */

            /* test for lockstep detection. */
            if (lstate != RES_MSTR) break;

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* measure how long the scan took. to be displayed at beginning of next loop. */
            temptick = tickGet ();
            scantime [line] = temptick - lastscan [line];

            /* try and bring all nonresponding modules on line, but */
            /* don't bring in more than a specified number.         */

            cnt = 0;
            if (--onlinefreq == 0)         /* do we try to bring any in on this pass? */
            {
                onlinefreq = BRINGBACKCNT;
                for (mod = 0; (mod < NUMMODS); mod++)
                {
                    cfgchk++;           /* manage module index */
                    if (cfgchk == NUMMODS)
                    {
                        cfgchk=0;    /* wrap module index */
                    }
                    pmod = modules [line] [cfgchk];
                    if ((pmod) &&        /* verify pointer validity prior to use*/
                        (!pmod->is_responding) &&
                        (pmod->was_requested) &&
                        (!pmod->cmd_force_offline))
                    {
                        getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/

                        on_line (line, cfgchk);    /* loopback testing done here!     */
                        semGive (linemux [line]);

                        modspolled++;
                        cnt++;
                        if (cnt == MAXCFGCK)
                        {
                            break;
                        }
                    }
                }
            }

            /* see if anyone on the line has been responding. */
            /* if not, try to get partner to become slave.    */
            /* Check for no one responding.                   */

            if ((!any_responding (line)) && (!private))
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                /* See if it is time to let partner try */

                this_time = tickGet ();
                if ((this_time - last_time) > (3 * SLWWINDOW))
                {   /* #ticks for slave to try */

                    /* Switch States to let partner know it's its time to try */

                    /* make semGet(linemux[line]) call before the switch to make sure diagnostic */
                    /* task is quiescent while partner is checking the line with the loopback    */
                    /* command. if local not master, then diagnostic won't try anyway, for       */
                    /* either master or remote radios, but it might have begun a 12 second test  */
                    /* sequence just before we got here.                                         */
                    getsemaphore(line);

                    /* we must semGive the semaphore back if and when we go to being the master */


                    resPutLocalState (prestable [line], RES_SLVWANT);
                    lstate = RES_SLVWANT;
                    if (modrestrace [line])
                    {
                        logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate, activity);
                    }
                    /* Give partner access to the hardware */
                    clear_rts (line);

                    /* Remember the time of this try */
                    last_time = tickGet ();
                    lastactivity [line] = line_activity [line] = FALSE;
                    for (i = 0; (i < SLWWINDOW); i += 10)
                    {               /* SLWINDOW is the # of ticks for slave to try */
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        taskDelay (10);
                        /* If partner picked up let it have control */
                        activity = check_line_activity (line, 0);  /* check immediately */
                        resGetStates (prestable [line], &lstate, &pstate);
                        if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
                        {
                            resClearCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_SLV);
                            lstate = RES_SLV;
                            if (modrestrace [line])
                            {
                                logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                            }
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay(60);
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay(60);
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay(60);
                            break;
                        }
                    }
                    /* Go Back to being the Master and take control of the hardware */
                    if (lstate != RES_SLV)
                    {
                        semGive (linemux [line]);    /* give back semaphore so diagnostics can run. */
                        resSetCaAnswer (prestable [line]);
                        resPutLocalState (prestable [line], RES_MSTR);
                        lstate = RES_MSTR;
                        if (modrestrace [line])
                        {
                            logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                        }
                        prepresponses (line);
                    }
                }
            }

            /* take modules off hold status. the module's data are not to be held off since now master. */
            for (mod = 0; (mod < NUMMODS); mod++ )
            {
                pmod = modules [line] [mod];
                if (pmod)            /* verify pointer validity prior to use */
                {
                    pmod->holdflag = FALSE;
                }
            }
            if (modspolled == 0)
            {
                taskDelay(6);
            }
            else
            {
                taskDelay(2);
            }
        }
    } /* end infinite task loop */
}


static void getsemaphore(unsigned short line)
{
    int i;     

    while ((semTake(linemux[line], 10)) == ERROR)
    {
        i =+ 10;
        if (i >= MUXTIMEOUT)
        {
            i = 0;
            logMsg (" Waiting for Radio Diagnostics:");
            printf (" Mutual-Exclusion Semaphore Timeout on Line %d\n", line);
        }
        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/
    }
    return;
}

/*
/* Try to bring a Netpac module on line
/*
*/

/* this routine only called from MAIN */

static void on_line (unsigned short line, unsigned short mod)
{
    NETPAC          *pmod;
    unsigned short   i, j;

    pmod = modules [line] [mod];
    if (pmod)            /* verify pointer prior to use */
    {
        if (mltrace [line] == 1)
        {
            logMsg ( "Bring Online Netpac Module %d\n", mod );
        }


        /* Use the loop back function to see if the unit is there and responding */
        if (!modloopback (ONERETRY + line, mod, pmod))
            return; /* if no response, get out */
        if (!settalkmode (ONERETRY + line, mod, pmod))
            return; /* if no response, get out */
        if (!setfahrenheit (ONERETRY + line, mod, pmod))
            return; /* if no response, get out */
        if (!setdataformat (ONERETRY + line, mod, pmod))
            return; /* if no response, get out */
        /* we have initialized the Module and it is ready to read */

        mark_not_valid (pmod);    /* a module that has just been brought online must  */
                                  /* have it's data marked as being not valid.        */
        pmod->is_responding = TRUE;
    }
}


/*                                                          
/* Mark all module data elements as not valid               
/*                                                          
*/                                                 
/* called from on_line and prepresponses              */        

static void mark_not_valid (NETPAC  *pmod)
{
    unsigned    short i, j;

/*                                                              
/*      Analog Inputs are initalized in the driver as not       
/*       valid and the engineering units not initialized        
*/
    for (i = 0; (i < NUMCHANNELS); i++)
    {
        pmod->inputs [i].data_valid = FALSE;
        pmod->inputs [i].initialized = 0;
        pmod->inputs [i].device_type = 0; /* will cause type to be resent to Netpac */
    }
}



/*                                                                  
/* Scan a NETPAC Module -  get inputs and set outputs as required   
/*                                                                  
*/
/* this routine only called from MAIN         */

static void scan_module (NETPAC *pmod, unsigned short line, unsigned short mod)
{
    unsigned short  i, j, k, val, bitaddr, regaddr, readlen;
    unsigned long   bitmask;
    unsigned short  temp, cmd;

    pmod->tscanpass++;

    if (mltrace [line] == 2)
    {
        logMsg ( "Scanning Module %d.\n", mod );
    }

    if (initinputs (line, mod, pmod))
    {
        readinputs (line, mod, pmod);
    }
    return;
}


static void sim_module (NETPAC *pmod, unsigned short line, unsigned short mod)
{
    unsigned short   i, j, k, val, bitaddr, regaddr, readlen;
    unsigned long    bitmask;
    unsigned short   temp, cmd;

    pmod->is_responding = pmod->was_requested;

    pmod->status = 0;
    pmod->statusclass = 0;
    pmod->status_valid = TRUE;
    pmod->modulestatus[0] = 0;
    pmod->modulestatus[1] = 0;
    /* read the ai values to be scanned */
    for (i = 0; (i < NUMCHANNELS); i++)
    {
        if ( pmod->inputs [i].was_requested )
        {
            pmod->inputs [i].data_valid = TRUE;
            pmod->inputs [i].initialized = 2;

            if ((pmod->inputs [i].last_read < (simlow [line] + (i*100))) ||
                (pmod->inputs [i].last_read >= (simhigh [line] + (i*100))))
            {
                pmod->inputs [i].last_read = simlow [line] + (i*100);
                /* every time the odd # channels wrap the sim counter, toggle between ok and opentc */
                if ((pmod->inputs [i].data_status == 0) && (i%2 == 1))
                {
                    pmod->inputs [i].data_status = OPENTHERMOCOUPLE;
                }
                else
                {
                    pmod->inputs [i].data_status = 0;
                }
            }
            else
            {
                pmod->inputs [i].last_read += 1;
            }
            /* make highest channel thermocouple open */
/*            if (i%3 == 0) pmod->inputs [i].data_status = 0;
            if (i%3 == 1) pmod->inputs [i].data_status = OPENTHERMOCOUPLE;
            if (i%3 == 2) pmod->inputs [i].data_status = PARITYERROR;
*/
            pmod->inputs [i].raw_read [0] = 'X';
            pmod->inputs [i].raw_read [1] = 'X';
            pmod->inputs [i].raw_read [2] = 'X';
            pmod->inputs [i].raw_read [3] = 'X';
            pmod->inputs [i].raw_read [4] = 'X';
            pmod->inputs [i].raw_read [5] = 'X';
            pmod->inputs [i].raw_read [6] = 'X';
            pmod->inputs [i].raw_read [7] = 'X';
        }
    }
}


/*                                                                                     
/*      AIDRIVER                                                                       
/*                                                                                     
/*      This routines main purpose is to return the analog input value for the         
/*      specified module. For a module value                                           
/*      a (-1) will be returned if there is no valid data ready.                       
/*
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
        unsigned short signal, float *pvalue, unsigned short conversion,
        unsigned char *resname)
{
    NETPAC          *pmod;
    unsigned short   blkix;
    float           *pdata;

    if (link > NETPACLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter >= NUMMODS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
         return (-1);
    }

    switch (card)
    {
        case 2:
        case 3:            
        case 4:
        case 5:            
        case 6:
        case 7:            
        case 8:
        case 9:            
        case 10:
        case 11:            
        case 12:
        case 13:            
        case 14:
        case 15:            
        case 16:
        case 20:            
        case 21:
        case 22:
        case 23:
        case 24:            
        case 35:
        case 36:
        case 37:            
        case 38:
        case 39:            
        case 40:
        case MPSEUDO:
            break;

        default:
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
            break;
    }

    pmod = modules [link] [adapter];
    if (pmod == NULL)
    {
        if (!allocate_module (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = modules [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the Module values requested */
                *pvalue = pmod->was_requested;
                break;

            case 1: /* Is the Module responding */
                *pvalue = pmod->is_responding;
                break;

            case 5: /* Output Messages */
                *pvalue = pmod->no_dataout_msgs & 0x7fff;
                break;

            case 6: /* Input Messages */
                *pvalue = pmod->no_datain_msgs & 0x7fff;
                break;

            case 7: /* No Receiver Responses */
                *pvalue = pmod->no_rxnoresp & 0x7fff;
                break;

            case 8: /* No Transmitter Response */
                *pvalue = pmod->no_txnoresp & 0x7fff;
                break;

            case 9: /* Message Reply Errors */
                *pvalue = pmod->no_dataerr & 0x7fff;
                break;

            case 10: /* Message Retries */
                *pvalue = pmod->no_retries & 0x7fff;
                break;

            case 11: /* RX Hardware errors */
                *pvalue = pmod->no_rxhwerrs & 0x7fff;
                break;

            case 12: /* TX Hardware errors */
                *pvalue = pmod->no_txhwerrs & 0x7fff;
                break;

            case 13: /* Netpac reported checksum errors */
                *pvalue = pmod->no_chksumerrs & 0x7fff;
                break;

            case 14: /* Offline transitions */
                *pvalue = pmod->no_offlines & 0x7fff;
                break;

            case 15: /* reset statistics */
                *pvalue = pmod->cmd_reset_stat;
                break;

            case 16: /* Force the Module offline */
                *pvalue = pmod->cmd_force_offline;
                break;

	    case 17: /* Failed output commands */
		*pvalue = pmod->badoutcnt & 0x7fff;
		break;

            case 18: /* Netpac reported framing errors */
                *pvalue = pmod->no_frameerrs & 0x7fff;
                break;

            case 20: /* Netpac No Error responses */
                *pvalue = pmod->noerror & 0x7fff;
                break;

            case 21: /* Netpac Programming Error responses */
                *pvalue = pmod->progerror & 0x7fff;
                break;

            case 22: /* Netpac Communications Error responses */
                *pvalue = pmod->commerror & 0x7fff;
                break;

            case 23: /* Netpac Fatal Error responses */
                *pvalue = pmod->fatalerror & 0x7fff;
                break;

            case 24: /* Netpac Configuration Error responses */
                *pvalue = pmod->configerror & 0x7fff;
                break;

            case 25: /* Netpac Unknown Error responses */
                *pvalue = pmod->unknownerror & 0x7fff;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        /* check for illegal conversion type */
        if (conversion != NOCONV)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal Pseudo Point Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        return (0);
    }

    /* check for illegal signal */
    if (signal > MAXAINO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d, min=%d\n",
                    pointname, link, adapter, card, signal, MAXAINO, MINAINO);
        return (-1);
    }

    if (resname != 0)
    { 
        register_resource (link, pmod, resname, pointname);
    }
    pmod->was_requested = TRUE;


    /* check for illegal conversion type */
    if ((conversion != NOCONV) && (conversion != LINEAR) && (conversion != AICNVSQRROOT))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /* if device type is zero, then this is the first time for this channel. */
    if (pmod->inputs [signal].device_type == 0)
    {
        pmod->inputs [signal].device_type = card;
        pmod->inputs [signal].initialized = 0;
    }

/*
    if ((link == 2) &&
        (adapter == 0) &&
        (card == 9) &&
        (signal == 1))
    {
        logMsg("AIDRIVER: [%s]: DevType=%d,  Initialized=%d,  Datavalid=%d,  Resresponse=%d,  Holdflag=%d,  Isresponding=%d\n",
                pointname,
                pmod->inputs [signal].device_type,
                pmod->inputs [signal].initialized,
                pmod->inputs [signal].data_valid,
                resresponse[link],
                pmod->holdflag,
                pmod->is_responding);
    }
*/
    /* as soon as the address is confirmed as valid, set was_requested flag. */
    pmod->inputs [signal].was_requested = TRUE;

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (pmod->holdflag)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }

    if (!pmod->is_responding)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /* if unit is responding, but not initialized yet, just indicate that its not ready yet. */
    if (pmod->inputs[signal].initialized != 2)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Data Not Ready. (Channel Not Initialized):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }

    if (!pmod->inputs[signal].data_valid)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (pmod->inputs[signal].data_status == OPENTHERMOCOUPLE)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Data Not Valid(2), Open Thermocouple:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-3); /* note: new return value specificly indicating open thermocouple. */
    }

    if (pmod->inputs[signal].data_status == OVERRANGE)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Data Not Valid(3), Overrange:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-4); /* note: new return value specificly indicating overrange. */
    }

    if (pmod->inputs[signal].data_status)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Data Not Valid(3), other:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    *pvalue = pmod->inputs [signal].last_read;

    if (mltrace[link] == 8)
        logMsg("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%12.6f\n",
                pointname, link, adapter, card, signal, *pvalue);

    return(0);
}

/*                                                                                
/*      AODRIVER                                                                  
/*                                                                                
/*      This routines main purpose is to set requested analog outputs to the      
/*      specified module.                                                         
*/
/* this routine not called from within this driver */


int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
              unsigned short signal, double dvalue, unsigned short value,
              unsigned short conversion, unsigned char *resname)
{
    NETPAC         *pmod;
    unsigned short  blkix;

    if (link > NETPACLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (adapter >= NUMMODS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    pmod = modules [link] [adapter];
    if (pmod == NULL)
    {
        if (!allocate_module (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = modules [link] [adapter];
    }
    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats(pmod);
                }
                break;

            case 16: /* Force the Module online/offline */
                pmod->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    pmod->is_responding = FALSE; /* only required when asserting cmd_force_offline */
                }
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
            return (-1);
        }
        return (0);
    }
    return (-1);
}


/*                                                                               
/*      AOREAD                                                                   
/*                                                                               
/*      This routines main purpose is to return the value last read back         
/*      from the analog output hardware. This is used to initialize analog       
/*      outputs.                                                                 
*/
/* this routine not called from within this driver */


int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
      unsigned short signal, unsigned short *pvalue,
      unsigned short conversion, unsigned char *resname)

{
    NETPAC         *pmod;
    unsigned short  blkix, *pdata;
    
    if (link > NETPACLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (adapter >= NUMMODS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pmod = modules [link] [adapter];
    if (pmod == NULL)
    {
        if (!allocate_module (link, adapter))
        {
                return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = modules [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 15: /* read statistics command value */
                *pvalue = pmod->cmd_reset_stat;
                break;

            case 16: /* Read the current Module offline command status */
                *pvalue = pmod->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return(-1);
        }
        return (0);
    }
    return(-1);
}


/*                                                                                    
/*      BIDRIVER                                                                      
/*                                                                                    
/*      The main purpose of this routine is to return the request digital input       
/*      value(s) from the requested card. This routine will return a (-1) if the      
/*      requested module is the wrong type or the data is not yet valid.              
/*                                                                                    
*/
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
        unsigned short signal, unsigned long mask, unsigned long *pvalue,
        unsigned char *resname)
{
    NETPAC          *pmod;

    if (link > NETPACLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (adapter >= NUMMODS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if ((card != MPSEUDO) && (card != MODULE))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pmod = modules [link] [adapter];
    if (pmod == NULL)
    {
        if (!allocate_module (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = modules [link] [adapter];
    }

    pmod->was_requested = TRUE;

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the Module values requested */
                *pvalue = pmod->was_requested;
                break;

            case 1: /* Is the Module responding */
                *pvalue = pmod->is_responding;
                break;

            case 15: /* reset statistics */
                *pvalue = pmod->cmd_reset_stat;
                break;

            case 16: /* Force the Module offline */
                *pvalue = pmod->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        if (mltrace[link] == 9)
            logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue);
        return (0);
    }

    /* to arrive here, the card must be MODULE */


    /* check for illegal signal */
    if ((signal > MAXDINO) || (signal < MINDINO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d, min=%d\n",
                    pointname, link, adapter, card, signal, MAXDINO, MINDINO);
        return (-1);
    }

    if (resname != 0)
    { 
        register_resource (link, pmod, resname, pointname);
    }
    pmod->was_requested = TRUE;

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (pmod->holdflag)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }

    if (!pmod->is_responding)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    *pvalue = (unsigned long) pmod->modulestatus & mask; /* there is only one BI at this point */

    if (mltrace[link] == 9)
        logMsg("BIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V= %12.6f\n",
                pointname, link, adapter, card, signal, *pvalue);
    return(0);
}

/*                                                                                     
/*      BODRIVER                                                                       
/*                                                                                     
/*      The main purpose of this routine is to set the request digital output          
/*      value(s) on the requested card. This routine will return a (-1) if the         
/*      requested module is the wrong type or not configured yet.                      
/*                                                                                     
*/
/* this routine not called from within this driver */

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
        unsigned short signal, unsigned long value, unsigned long mask,
        unsigned char *resname)
{
    NETPAC         *pmod;

    if (link > NETPACLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (adapter >= NUMMODS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
            return (-1);
    }

    pmod = modules [link] [adapter];
    if (pmod == NULL)
    {
        if (!allocate_module (link, adapter))
        {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = modules [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal & 0x1f)
        {
            case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats (pmod);
                }
                break;

            case 16: /* Force the Module offline */
                pmod->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
                }
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }
}

/*                                                                              
/*      BOREAD                                                                  
/*                                                                              
/*      This routines main purpose is to return the value last read back        
/*      from the digital output hardware. This is used to initialize digital    
/*      outputs. This will return a (-1) if the module is the wrong type or     
/*      the data is not yet valid                                               
*/
/* this routine not called from within this driver */


int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
        unsigned short signal, unsigned long *pvalue, unsigned long mask,
        unsigned char *resname)

{
    NETPAC          *pmod;

    if (link > NETPACLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter >= NUMMODS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
         return (-1);
    }

    pmod = modules [link] [adapter];
    if (pmod == NULL)
    {
        if (!allocate_module (link, adapter))
        {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = modules [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 15: /* reset statistics */
                *pvalue = pmod->cmd_reset_stat;
                break;

            case 16: /* Force the Module offline */
                *pvalue = pmod->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }
}
/*
/* register_resource
/*
/*    This routine is used to initialize the resource pointers
/*  If this is the first time the resource for this line is being
/*  referenced the pointer to the resource table entry will be set
/*  and the resource name will be saved. If the resource name has
/*  already been set, this routine will verify that all other points
/*  for this driver are using the same resource name.
/*
*/                                                                                        
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,        
                BOREAD, SIDRIVER, and SODRIVER.                             
*/                                   

static void  register_resource (unsigned short link, NETPAC *pmod,
                                unsigned char *resname, char *pointname)
{
    if (resnames [link] [0] == 0) /* This is the first reference */
    {
        if (resGetByName (resname, &prestable [link]) != RES_OK)
        {
        logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
                resname );
        }
        else
        {
        strcpy (resnames [link], resname);
        }
    }
    else
    {
        if (strcmp (resnames [link], resname) != 0)
        {
        logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
                resnames[link],
                                pointname,
                resname );
        }
    }
}


/*                                                                              
/*                                                                              
/*    allocate_module                                                           
/*                                                                              
/*    The purpose of this routine is to allocate the memory for a single        
/*    module data structure. If not successful, a console error message is      
/*    printed and an error flag is returned to the caller.                      
/*    If successful, the newly allocated data structures are initialized.       
/*                                                                              
*/

static int allocate_module (unsigned short line, unsigned short module )
{
    modules [line] [module] = (NETPAC *) calloc (1, (sizeof (NETPAC)));
    if (!modules [line] [module])
    {
        logMsg ("Unable to allocate memory");
            printf (" for NETPAC data structure on line %d, module %d\n",line ,module);
        return(FALSE);
    }
    else
    {
        logMsg ("Allocated memory for NETPAC data structure on line %d, module %d\n",line ,module);
        init_module_tab (line, module);         /*    initialize the data structures. */
    }

    return (TRUE);
}



/*                                                                          
/*      start_rx                                                            
/*                                                                          
/*      The purpose of this routine is to initialize a line table           
/*      for receive and to enable the receiver.                             
/*                                                                          
*/
/* only called from msgxfer */

static  void start_rx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus)
{
    RXLINE        *rxp;

    rxp = rxlinetab [line];
    rxp->rxix = 0;
    rxp->semid = semid;
    rxp->status = pstatus;
    rxp->rxstate = RXCOLON;
}

/*                                                                               
/*      stop_rx                                                                  
/*                                                                               
/*      The purpose of this routine is to initialize a line table                
/*      for receive and to disable the receiver.                                 
/*                                                                               
*/
/* only called from msgxfer */

static  void stop_rx (unsigned short line )

{
    RXLINE        *rxp;

    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
}


/*                                                                                 
/*      NEW rx_int_proc                                                            
/*                                                                                 
/*      The purpose of this routine is to process a receive character interrupt    
/*      for a given line.                                                          
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static  void rx_int_proc (unsigned short line )
{
    unsigned char   rxchar;
    unsigned short  rxstat;
    unsigned short  rx_err_mask;
    RXLINE         *rxp;

    read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);
    linestats [line].RXintcount++;
    rxp = rxlinetab [line];

    /* Something is sending in data. */
    line_activity [line] = TRUE;
    if (rxp->rxstate == RXIGNORE)
    {
        return;
    }
    /* no matter what the state, errors cause a logical reset of the message processing */
    if ((rxstat & rx_err_mask) != 0)
    {
        rxp->rxstate = RXCOLON;    /* if comm goes bad, assume it was garbage,  */
                                   /* and go wait for the good stuff.           */ 
        rxp->rxix = 0;             /* reset the buffer index/counter            */
        return;
    }

    rxp->rxbuf [rxp->rxix++] = rxchar; /* store the character in the buffer and bump the index. */
    switch (rxp->rxstate)
    {
        case RXCOLON:           /* Waiting for Colon character to begin response   */
            if (rxchar == ':')
            {
                rxp->rxstate = RXAT;
                return;
            }
            else
            {
                rxp->rxstate = RXCOLON;                /* presume it was a false input.  */
                                                       /* go wait for the real one.      */ 
                rxp->rxix = 0;                         /* reset the buffer index/counter.*/
                return;
            }

        case RXAT:              /* Waiting for @ character, signifying message for the host */
            if (rxchar == '@')
            {
                rxp->rxstate = RXRESPONSE;
                return;
            }
            else
            {
                rxp->rxstate = RXCOLON;                /* presume it was a false input.  */
                                                       /* go wait for the real one.      */ 
                rxp->rxix = 0;                         /* reset the buffer index/counter.*/
                return;
            }

        case RXRESPONSE:             /* Input response while waiting for Carriage Return */
            if (rxchar == 0x0d)
            {
                *(rxp->status) = RXGOOD;
                rxp->rxstate = RXIGNORE;
                semGive (rxp->semid);
                return;
            }
            if (rxp->rxix >= MAXRXMSG)                 /* don't overflow the buffer.     */
            {
                *(rxp->status) = RXBAD;
                rxp->rxstate = RXIGNORE;
                semGive (rxp->semid);
                return;
            }
    }
    return;
}


/*                                                                             
/*      check_line_activity                                                    
/*                                                                             
*/
/* only called from MAIN  */

static  int check_line_activity (unsigned short line, unsigned short predelay )
{
    RXLINE      *rxp;
    long         thistime;
    short        status;

    if (predelay != 0)
    {
        taskDelay (predelay);
    }
    thistime = tickGet ();
    if ((thistime - activity_time [line]) < ACTIVITYTIME)
    {
        return (lastactivity [line] || (line_activity [line]));
    }
    lastactivity [line] = status = line_activity [line];
    line_activity [line] = FALSE;
    activity_time [line] = thistime;
    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;

    return (status);
}


/*                                                                                 
/*      start_tx                                                                   
/*                                                                                 
/*      The purpose of this routine is to initialize a line table                  
/*      for send and to enable the transmitter.                                    
/*                                                                                 
*/
/* only called from msgxfer  */

static  void start_tx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus )
{
    TXLINE        *txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txix = 0;
    txp->semid = semid;
    txp->status = pstatus;
    txp->txdisable = FALSE;

    enable_tx_ints (line);
}


/*                                                                                 
/*      stop_tx                                                                    
/*                                                                                 
/*      The purpose of this routine is to initialize a line table                  
/*      for receive and to disable the receiver.                                   
/*                                                                                 
*/
/* only called from msgxfer  */

static  void stop_tx (unsigned short line )
{
    TXLINE        *txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txdisable = TRUE;

    /* the 485 interface uses RTS to control direction of line transmission. */
    clear_rts (line);
}


/*                                                                                
/*      tx_int_proc                                                               
/*                                                                                
/*      The purpose of this routine is to process a transmit character interrupt  
/*      for a given line.                                                         
/*                                                                                
*/
/* only called from MAIN  */

static  void tx_int_proc (unsigned short line )
{
    char            txchar;
    unsigned short  txstat;
    unsigned short  tx_err_mask;
    TXLINE         *txp;

    linestats [line].TXintcount++;

    txp = txlinetab [line];

    if (txp->txdisable)
    {
        return;
    }

    if (txp->txix < txp->txmsglen)
    {
        txchar = txp->txbuf [txp->txix++];
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD;
            semGive (txp->semid);
            return;
        }
        if (txp->txix >= MAXTXMSG)
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD;
            semGive (txp->semid);
            return;
        }
        return;
    }

    if (txp->txix == txp->txmsglen)
    {
        /* the 485 interface uses RTS to control direction of line transmission.        */
        /* we transmit an extra character (NULL) in order to provide time for the last  */
        /* 'real' character to be transmitted before completing tranmission interrupt   */
        /* servicing and reversing the RTS line in order to receive the reply.          */

        txchar = 0;
        txp->txix++;
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD;
            semGive (txp->semid);
        }
        return;
    }

    if (txp->txix > txp->txmsglen)
    {
        txp->txdisable = TRUE;
        disable_tx_ints (line);
        *(txp->status) = TXGOOD;
        semGive (txp->semid);
        return;
    }
}


/*                                                                               
/*      msgxfer                                                                  
/*                                                                               
/*      The purpose of this routine is to transmit a buffer to the               
/*      Netpac Module and to await a response. The transmit and receive buffers  
/*      are in their respective line tables. This routine will retry the         
/*      message up to a maximum number of times or until a response is received  
/*      with a proper checksum.                                                  
/*              returns         XFERGOOD if response received                    
/*                              XFERBAD  if no good response is received         
/*                                                                               
*/

static  unsigned short  msgxfer (unsigned short fline, NETPAC *pmod, unsigned short responselen)
{
    unsigned short  retry, txstatus, rxstatus, txlen, rxlen, line, ix, i;
    RXLINE         *rxp;
    TXLINE         *txp;
    unsigned char   csums [2];
    unsigned short  oldrxix;
    unsigned int    tick1, tick2, tick3, tick4;
    unsigned int    delta40, delta01, delta12, delta23, delta34;
    unsigned long   msgstart;
    unsigned short  status, statusclass;
    unsigned char   tempbuf[2];

    msgstart = tickGet();
    line = (fline & (~ONERETRY));          /* strip off the no retry flag*/
    delta40 = delta01 = delta12 = delta23 = delta34 = 0;

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++)
    {
        linestats [line].msgxfercount++;
        loopmsgs [line]++;

        /* time since end of last msgxfer */
        tick [line] [0] = tickGet ();
        delta40 = (tick [line] [0] - tick [line] [4]);

        if (intermsgdelay [line] != 0)
        {
            taskDelay (intermsgdelay [line]);
        }

        txstatus = IO_TIMEOUT;
        rxstatus = IO_TIMEOUT;

        semTake (semids [line] [TXSEM], NO_WAIT);
        semTake (semids [line] [RXSEM], NO_WAIT);

        txlen = txp->txmsglen;

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        if ((trace [line] & ALLTRAFFICTRACE) &&
            ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
            ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
        {
            printf ("TX:____");
            if (trace [line] & ASCIITRAFFICTRACE)
            {
                for (ix = 0; ix < txlen ; ix++) /* just print what is there to print */
                {
                    if (!((txp->txbuf [ix]) < 0x20))
                    {
                        printf("%c", txp->txbuf [ix]);
                    }
                    else
                    {
                        printf ("<%x>", txp->txbuf [ix]);
                    }
                }
                printf ("\n");
            }
            else
            {
                for (ix = 0; ix < 12 ; ix++) /* 12 is maximum TX message length */
                {
                    if (ix < txlen)
                    {
                        printf("_%2x", txp->txbuf [ix]);
                    }
                    else
                    {
                        printf ("...");
                    }
                }
                printf ("\n");
            }
        }

        /* the 485 interface uses RTS to control direction of line transmission.        */
        /* we assert RTS immediately prior to beginning transmission.                   */
        set_rts (line);

        if (pretxdelay [line] != 0)
        {
            taskDelay (pretxdelay [line]);
        }

        /* time from entering msgxfer to starting transmission. (including delays & diags) */
        tick [line] [1] = tickGet ();
        delta01 = (tick [line] [1] - tick [line] [0]);

        start_rx (line, semids [line] [RXSEM], &rxstatus);
        start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */

        if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
        {
            txstatus = IO_TIMEOUT;
        }

        /* the 485 interface uses RTS to control direction of line transmission.        */
        /* we clear the RTS line immediately after transmitting the full message.       */
        stop_tx (line);

        if (posttxdelay [line] != 0)
        {
            taskDelay (posttxdelay [line]);
        }

        clear_rts (line);

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        /* time to transmit message. */
        tick [line] [2] = tickGet ();
        delta12 = (tick [line] [2] - tick [line] [1]);


        /* intermessage wait time. */
        tick [line] [3] = tickGet ();
        delta23 = (tick [line] [3] - tick [line] [2]);

        if (txstatus == TXGOOD)
        {
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            oldrxix = -1;    /* make it pass through timeout loop at least once */
            while ((semTake (semids [line] [RXSEM], (int) (RXTIMEOUT))) == ERROR)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                if (oldrxix == rxp->rxix)
                {
                    if (modtrace [line])
                    {
                        logMsg("RX timeout\n");
                    }
                    rxstatus = IO_TIMEOUT;
                    break;
                }
                else
                {
                    if ((modtrace [line]) || (mltrace[line] == 12))
                    {
                         logMsg("waiting...");
                    }
                }
                oldrxix = rxp->rxix;
            }
            stop_rx (line);

            /* time to receive message. */
            tick [line] [4] = tickGet();
            delta34 = (tick [line] [4] - tick [line] [3]);

            rxlen = rxp->rxix; /* index is just past last received character. length EQUALS index */
            if (rxstatus == RXGOOD)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                    ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                {
                    printf ("RX:____");
                    if (trace [line] & ASCIITRAFFICTRACE)
                    {
                        for (ix = 0; ix < rxlen ; ix++) /* just print what is there to print */
                        {
                            if (((ix-2)%40 == 0) && (ix != 2))
                            {
                                printf ("\n         "); /* avoid line wrap */
                            }
                            else if ( ((ix-2)%8 == 0) && (ix != 2))
                            {
                                 printf ("_"); /* seperate hex values */
                            }
                            if (!((rxp->rxbuf [ix]) < 0x20))
                            {
                                printf("%c", rxp->rxbuf [ix]);
                            }
                            else
                            {
                                printf ("<%x>", rxp->rxbuf [ix]);
                            }
                        }
                        /* printf ("\n");*/
                    }
                    else
                    {
                        for (ix = 0; ix < 20 ; ix++) /* 20 is maximum RX message length */
                        {
                            if (ix < rxlen)
                            {
                                printf("_%2x", rxp->rxbuf [ix]);
                            }
                            else
                            {
                                printf ("...");
                            }
                        }
                        /* printf ("\n"); */
                    }
                    printf(" ............. DELTA: %3d %3d %3d %3d %3d\n",
                            delta40, delta01, delta12, delta23, delta34);
                }
                /**********************************************/
                /**********************************************/

                makechksum (&(rxp->rxbuf [0]), rxlen-3, &tempbuf[0]);

                if ((rxp->rxbuf [rxlen-3] == tempbuf[0]) &&
                    (rxp->rxbuf [rxlen-2] == tempbuf[1]))
                {
                    /* test for valid message header & message for host */
                    /* (since the interrupt routine parses for ':', this test is redundant) */
                    if ((rxp->rxbuf[0] == ':') &&
                        (rxp->rxbuf[1] == '@'))
                    {
                        /* test for status message vs. data message */
                        if (rxp->rxbuf[2] == '*')
                        {
                            if (asciidec (&status, &(rxp->rxbuf[3])))
                            {
                                /* number was valid ascii decimal. it has been stored in status. */
                                pmod->status = status;
                                pmod->modulestatus[0] = status;
                                pmod->modulestatus[1] = 0;
                                if ((status >= CHECKSUMERROR00) && (status <= CHECKSUMERROR15))
                                {
                                    pmod->modulestatus[0] = CHECKSUMERROR;
                                    pmod->modulestatus[1] = status;
                                }
                                pmod->status_valid = TRUE;
                                statusstats (line, pmod, status); /* bump status statistics and set statusclass */
                                statustrace (line, pmod);
                    
                                /* check for Netpac reported communication errors */
                                if ((pmod->status != CHECKSUMERROR) && (pmod->status != FRAMINGERROR))
                                {
                                    /* all other status values, good or bad, pass back to the calling routine.  */
                                    /* if the status is good, then that is all that is needed.                  */
                                    /* if the status is bad, the other error types are not helped by retrying.  */
                                    pmod->msgs++;
                                    pmod->responsetime += (tickGet() - msgstart);
                                    return (XFERGOOD);
                                }
                                /* bump appropriate statistics counter */
                                if (pmod->status == CHECKSUMERROR)
                                {
                                    pmod->no_chksumerrs++;  /* reported communication error: try it again */
                                }
                                else
                                {
                                    pmod->no_frameerrs++;   /* reported communication error: try it again */
                                }
                            }
                            else /* if not valid ascii decimal number, bump error and try again. */
                            { 
                                pmod->no_dataerr++;
                            }
                        }
                        else /* response is not a Module status message */
                        {
                            /* if we get the 'D' data, we must presume the status is GOOD */
                            pmod->status = 0;
                            pmod->modulestatus[0] = 0;
                            pmod->modulestatus[1] = 0;
                            pmod->status_valid = TRUE;
                            /* driver only supports one command that returns anything other than status: 'D'*/
                            if (rxlen == responselen+CHKSUMLEN+1) /* count checksum and CR */
                            {    
                                pmod->msgs++;
                                pmod->responsetime += (tickGet() - msgstart);
                                return (XFERGOOD);
                            }
                            else /* response length is wrong. */
                            {
                                if (modtrace [line])
                                {
                                    logMsg ("Receive Length Error: Expected = %d, Actual = %d\n",
                                             responselen+CHKSUMLEN+1, rxlen);
                                }
                                pmod->no_dataerr++;  /* communication error: try it again */
                            }
                        }/* end of 'good' message handling if-else code */
                    }
                    else /* ':@...' one or both of first two response characters are wrong */
                    {
                        pmod->no_dataerr++;  /* communication error: try it again */
                    }
                } /* end of good checksum code */

                else /* bad checksum */
                {
                    if (trace [line] & ASCIITRAFFICTRACE)
                    {
                        printf ("Bad Checksum: Received= %c%c     Excpected=%c%c\n",
                                 rxp->rxbuf [rxlen-3], rxp->rxbuf [rxlen-2], tempbuf[0], tempbuf[1]);
                    }
                    pmod->no_chksumerrs++; /* reported communication error: try it again */
/*                    pmod->no_dataerr++;    /* communication error: try it again */
                }
            } /* bottom of rxstatus == RXGOOD */
            else
            {
                if (rxstatus == IO_TIMEOUT)
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/
                    
                    if (modtrace [line])
                    {
                        logMsg ("Receive Timeout... Length: %d\n", rxlen);
                    }
                    if ((trace [line] & ALLTRAFFICTRACE) &&
                        ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                        ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                    {
                        printf ("DELTA: %3d %3d %3d %3d %3d\n",
                                delta40, delta01, delta12, delta23, delta34);
                    }
                    pmod->no_rxnoresp++;
                }
                else
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/
                
                    if (modtrace [line])
                    {
                        logMsg ("Receive Error:   RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
                         rxp->rxbuf[100],
                         rxp->rxbuf[101],
                         rxp->rxix);
                    }
                    pmod->no_rxhwerrs++;
                }
            }
        }
        else
        {
            if (txstatus == IO_TIMEOUT)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                if (modtrace [line])
                {
                    logMsg ("Transmit Timeout\n");
                }
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                    ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d\n",
                            delta40, delta01, delta12, delta23, delta34);
                }
                pmod->no_txnoresp++;
            }
            else
            {
                if (modtrace [line])
                {
                    logMsg ("Transmit Error\n");
                }
                pmod->no_txhwerrs++;
            }
        }
        /* bottom of retry loop */
        if (retry != MAXRETRYS)
            pmod->no_retries++;
    }
    if (modtrace [line])
    {
        logMsg ("Xfer Bad\n");
    }
    return (XFERBAD);
}


/*
/*                                                                      
/*      asciidec                                                        
/*                                                                      
/*      The purpose of this routine is to convert the next 2 ascii      
/*      characters in the buffer to decimal and return them in val.     
/*      It will return TRUE if good conversion or FALSE if bad.         
*/                                                                         	

static	short asciidec (unsigned short *val, char *buf)
{
    if ((buf [0] < '0') || (buf [0] > '9'))
    {
        return (FALSE);
    }
    *val = ((buf [0] & 0x0f) * 10);

    if ((buf [1] < '0') || (buf [1] > '9'))
    {
        return (FALSE);
    }
    *val += (buf [1] & 0x0f);

    return (TRUE);
}

/*
/*                                                                      
/*      asciihex                                                    	
/*                                                                      
/*      The purpose of this routine is to convert the next 2 ascii      
/*      characters in the buffer to hex and return them in val. It      
/*      will return TRUE if good conversion or FALSE if bad.            
*/                                                                         	

static short asciihex (unsigned short *val, char *buf)
{
    if ((buf [0] < '0') || (buf [0] > 'F'))
    {
        return (FALSE);
    }
    if (buf [0] <= '9')
    {
        *val = ((buf [0] & 0x0f) << 4);
    }
    else
    {
        if (buf [0] < 'A')
        {
            return (FALSE);
        }
        else
        {
            *val = ((buf [0] - 'A' + 10) << 4);
        }
    }
    if ((buf [1] < '0') || (buf [1] > 'F'))
    {
        return (FALSE);
    }
    if ( buf [1] <= '9')
    {
        *val += (buf [1] & 0x0f);
    }
    else
    {
        if (buf [1] < 'A')
        {
            return (FALSE);
        }
        else
        {
            *val += (buf [1] - 'A' + 10);
        }
    }
    return (TRUE);
}


/*                                                                                  
/*      statusstats                                                                 
/*                                                                                  
/*      The purpose of this routine is to increment the module statistics counters  
/*                                                                                  
/*
*/
/* called from msgxfer  */

static void statusstats (unsigned short line, NETPAC *pmod, unsigned short status)
{
    if ((status >= CHECKSUMERROR00) && (status <= CHECKSUMERROR15))        /* serial framing error */
    {
        pmod->statusclass = COMMERROR;
        pmod->commerror++;
        pmod->error50++;
        return;
    }

    switch (status)
    {
        /* no error, no command */
        case (NOERRORS):
            pmod->statusclass = NOERROR;
            pmod->noerror++;
            pmod->error00++;
            break;

        /* no error, command ok */
        case (COMMANDOK):
            pmod->statusclass = NOERROR;
            pmod->noerror++;
            pmod->error01++;
            break;

        /* programming error */
        case (PROGRAMMINGERROR):
            pmod->statusclass = PROGERROR;
            pmod->progerror++;
            pmod->error02++;
            break;

        /* power-up flag not set */
        case (POWEUPFLAGERROR):
            pmod->statusclass = FATALERROR;
            pmod->fatalerror++;
            pmod->error03++;
            break;

        /* serial framing error */
        case (FRAMINGERROR):
            pmod->statusclass = COMMERROR;
            pmod->commerror++;
            pmod->error04++;
            break;

        /* PROM check error */
        case (PROMERROR):
            pmod->statusclass = FATALERROR;
            pmod->fatalerror++;
            pmod->error10++;
            break;

        /* RAM check error */
        case (RAMERROR):
            pmod->statusclass = FATALERROR;
            pmod->fatalerror++;
            pmod->error11++;
            break;

        /* VCO check error */
        case (VCOERROR):
            pmod->statusclass = FATALERROR;
            pmod->fatalerror++;
            pmod->error12++;
            break;

        /* chennel range error  */
        case (CHANNELRANGEERROR):
            pmod->statusclass = CONFIGERROR;
            pmod->fatalerror++;
            pmod->error40++;
            break;

        /* card number not installed  */
        case (CARDNUMBERERROR):
            pmod->statusclass = CONFIGERROR;
            pmod->fatalerror++;
            pmod->error41++;
            break;

        /* EU is not 40 for <V> value */
        case (EUERROR):
            pmod->statusclass = FATALERROR;
            pmod->fatalerror++;
            pmod->error42++;
            break;

        /* value out of range */
        case (VALUERANGEERROR):
            pmod->statusclass = FATALERROR;
            pmod->fatalerror++;
            pmod->error43++;
            break;

        /* overrange */
        case (OVERRANGEERROR):
            pmod->statusclass = FATALERROR;
            pmod->fatalerror++;
            pmod->error44++;
            break;

        /* power failure */
        case (POWERFAILURE):
            pmod->statusclass = FATALERROR;
            pmod->fatalerror++;
            pmod->error45++;
            break;

        /* unknown reply code */
        default:
            pmod->statusclass = UNKNOWNERROR;
            pmod->unknownerror++;
            break;
    }
}

/*
/*      statustrace
/*                                                                              
/*      The purpose of this routine is to display, under trace control, the     
/*      replies to Bailey CIU commands.                                         
/*                                                                              
/*
*/
/* called from msgxfer  */

static void statustrace (unsigned short line, NETPAC *pmod)
{
    unsigned short   status;
    unsigned short   statusclass;

    /* initialize all current values */
    status = pmod->status;
    statusclass = pmod->statusclass;

    if ((trace[line] & OKTRACE) && (pmod->statusclass == NOERROR))
    {
        switch (status)
        {
            /* no error, no command */
            case (NOERRORS):
                logMsg("Status:(%d) No error. no command.\n", status);
                taskDelay (4); /* just enough to keep diagnostic msgs from overlapping */
                break;

            /* no error, command ok */
            case (COMMANDOK):
                logMsg("Status:(%d) No error. command ok.\n", status);
                taskDelay (4);
                break;
        }
    }

    if ((trace[line] & PROGTRACE) && (pmod->statusclass == PROGERROR))
    {
        switch (status)
        {
            /* programming error */
            case (PROGRAMMINGERROR):
                logMsg("Status:(%d) No error. command ok.\n, status");
                taskDelay (4);
                break;
        }
    }

    if ((trace[line] & FATALTRACE) && (pmod->statusclass == FATALERROR))
    {
        switch (status)
        {
            /* power-up flag not set */
            case (POWEUPFLAGERROR):
                logMsg("Status:(%d) Power-up flag not set.\n", status);
                taskDelay (4);
                break;

            /* PROM check error */
            case (PROMERROR):
                logMsg("Status:(%d) PROM check error.\n", status);
                taskDelay (4);
                break;

            /* RAM check error */
            case (RAMERROR):
                logMsg("Status:(%d) RAM check error.\n", status);
                taskDelay (4);
                break;

            /* VCO check error */
            case (VCOERROR):
                logMsg("Status:(%d) VCO check error.\n", status);
                taskDelay (4);
                break;

            /* EU is not 40 for <V> value */
            case (EUERROR):
                logMsg("Status:(%d) EU is not 40 for <V> value.\n", status);
                taskDelay (4);
                break;

            /* value out of range */
            case (VALUERANGEERROR):
                logMsg("Status:(%d) Value out of range.\n", status);
                taskDelay (4);
                break;

            /* overrange */
            case (OVERRANGEERROR):
                logMsg("Status:(%d) Overrange.\n", status);
                taskDelay (4);
                break;

            /* power failure */
            case (POWERFAILURE):
                logMsg("Status:(%d) Power failure.\n", status);
                taskDelay (4);
                break;
        }
    }

    if ((trace[line] & UNKNOWNTRACE) && (pmod->statusclass == UNKNOWNERROR))
    {
        switch (status)
        {
            /* unknown reply code */
            default:
                logMsg("Status:(%d) Unknown error.\n", status);
                taskDelay (4);
                break;
        }
    }

    if ((trace[line] & COMMTRACE) && (pmod->statusclass == COMMERROR))
    {
        switch (status)
        {
            /* serial framing error */
            case (FRAMINGERROR):
                logMsg("Status:(%d) Serial framing error.\n", status);
                taskDelay (4);
                break;

            /* checksum errors */
            default:
                logMsg("Status:(%d) Checksum error.\n", status);
                taskDelay (4);
                break;
        }
    }

    if ((trace[line] & CONFIGTRACE) && (pmod->statusclass == CONFIGERROR))
    {
        switch (status)
        {
            /* chennel range error  */
            case (CHANNELRANGEERROR):
                logMsg("Status:(%d) Channel number out of range.\n", status);
                taskDelay (4);
                break;

            /* card number not installed  */
            case (CARDNUMBERERROR):
                logMsg("Status:(%d) Card number not installed.\n", status);
                taskDelay (4);
                break;
        }
    }

    if ((trace[line] & UNKNOWNTRACE) && (pmod->statusclass == UNKNOWNERROR))
    {
        logMsg("Status:(%d) Unknown.\n", status);
        taskDelay (4);
        return;
    }
    return;
}


/*
/*      init_module_tab
/*
/*      The purpose of this routine is to initialize the line tables for the
/*      analog devices I/O
/*
*/
/* only called from allocate_module  */


static  void init_module_tab (unsigned short line, unsigned short mod)
{
    NETPAC  *pmod;

    pmod = modules [line] [mod];
    if (!pmod)
    {
        return;
    }
    pmod->is_responding = FALSE;
    pmod->holdflag = FALSE;
    pmod->was_requested = FALSE;
    pmod->cmd_force_offline = FALSE;
    pmod->status_valid = FALSE;
    pmod->status = 0;
    pmod->statusclass = 0;
    pmod->modulestatus[0] = 0;
    pmod->modulestatus[1] = 0;

    initmodule (pmod);
    initstats (pmod);

    /* Initialize this tasks semaphore*/

    semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
    semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
}

/*
/* Cold Init a Module
/*
*/
/* only called from init_line_tabs  */


static void initmodule (NETPAC  *pmod)
{
    unsigned short    i,j;
                                                                    
/*                                                                       
/*      Analog Inputs are initialized as not requested & data not valid. 
/*                                                                       
*/
    for (i = 0; (i < NUMCHANNELS); i++)
    {
        pmod->inputs [i].was_requested = FALSE;
        pmod->inputs [i].device_type = 0;
        pmod->inputs [i].initialized = 0;
        pmod->inputs [i].data_valid = FALSE;
        pmod->inputs [i].raw_read[0] = 'U';
        pmod->inputs [i].raw_read[1] = 'U';
        pmod->inputs [i].raw_read[2] = 'U';
        pmod->inputs [i].raw_read[3] = 'U';
        pmod->inputs [i].raw_read[4] = 'U';
        pmod->inputs [i].raw_read[5] = 'U';
        pmod->inputs [i].raw_read[6] = 'U';
        pmod->inputs [i].raw_read[7] = 'U';
        pmod->inputs [i].last_read = 0;
        pmod->inputs [i].data_status = 0;
    }
}


/*                                                                    
/*                                                                    
/* initialize the statistics for a Netpac Module                      
/*                                                                    
*/                                                                   
/* called from AODRIVER, BODRIVER, and init_line_tabs  */

static  void initstats (NETPAC *pmod)
{
    pmod->no_dataout_msgs = 0;  /* 5  Count Output Msgs               */
    pmod->no_datain_msgs = 0;   /* 6  Count Data Requests             */
    pmod->no_rxnoresp = 0;      /* 7  Count No Responses              */
    pmod->no_txnoresp = 0;      /* 8  Count No Responses              */
    pmod->no_dataerr = 0;       /* 9  Count Message Reply Errors      */
    pmod->no_retries = 0;       /* 10 Count Retries                   */              
    pmod->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors      */
    pmod->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors      */
    pmod->no_chksumerrs = 0;    /* 13 Count Checksum Errors           */
    pmod->no_offlines = 0;      /* 14 Count Off Line Transitions      */
    pmod->no_frameerrs = 0;     /*    Count Framing Errors            */

    pmod->tscanpass = 0;        /* module scan pass counter           */
    pmod->msgs = 0;             /* good response message counts       */
    pmod->responsetime = 0;     /* total wait time for good messages  */

    pmod->noerror = 0;
    pmod->progerror = 0;
    pmod->commerror = 0;
    pmod->fatalerror = 0;
    pmod->configerror = 0;
    pmod->unknownerror = 0;

    pmod->error00 = 0;
    pmod->error01 = 0;
    pmod->error02 = 0;
    pmod->error03 = 0;
    pmod->error04 = 0;
    pmod->error10 = 0;
    pmod->error11 = 0;
    pmod->error12 = 0;
    pmod->error40 = 0;
    pmod->error41 = 0;
    pmod->error42 = 0;
    pmod->error43 = 0;
    pmod->error44 = 0;
    pmod->error45 = 0;
    pmod->error50 = 0;
}

/*                                                              
/* modloopback                                                  
/*                                                              
*/                                                                              
/* only called from on_line */


static  unsigned short modloopback (unsigned short line, unsigned short mod, NETPAC *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = ':';
    txp->txbuf [1] = '0' + (mod/10);
    txp->txbuf [2] = '0' + (mod%10);
    txp->txbuf [3] = LOOPBACK;
    makechksum (&(txp->txbuf [0]), LOOPBACKLEN, &(txp->txbuf [LOOPBACKLEN]));
    txp->txbuf [LOOPBACKLEN+CHKSUMLEN] = 0x0d;
    txp->txmsglen = LOOPBACKLEN+CHKSUMLEN+1;
    pmod->no_datain_msgs++;

    /* Send out the message */
    if (msgxfer (line, pmod, STATUSREPLYLEN) == XFERBAD)
    {
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting a status response. if anything else, its a mistake */
    if (rxp->rxbuf [2] != '*')
    {
        pmod->no_dataerr++;
        return (FALSE);
    }
    /* expecting a good response. if anything else, its an error. */
    if (pmod->statusclass != NOERROR)
    {
        return (FALSE);
    }

    return (TRUE);
}


/*                                                              
/* readstatus                                                   
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short readstatus (unsigned short line, unsigned short mod, NETPAC *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = ':';
    txp->txbuf [1] = '0' + (mod/10);
    txp->txbuf [2] = '0' + (mod%10);
    txp->txbuf [3] = READSTATUS;
    makechksum (&(txp->txbuf [0]), READSTATUSLEN, &(txp->txbuf [READSTATUSLEN]));
    txp->txbuf [READSTATUSLEN+CHKSUMLEN] = 0x0d;
    txp->txmsglen = READSTATUSLEN+CHKSUMLEN+1;
    pmod->no_datain_msgs++;

    /* Send out the message */
    if (msgxfer (line, pmod, STATUSREPLYLEN) == XFERBAD)
    {
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting a status response. if anything else, its a mistake */
    if (rxp->rxbuf [2] != '*')
    {
        pmod->no_dataerr++;
        return (FALSE);
    }
    /* expecting a good response. if anything else, its an error. */
    if (pmod->statusclass != NOERROR)
    {
        return (FALSE);
    }

    return (TRUE);
}

/*                                                              
/* settalkmode                                                  
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short settalkmode (unsigned short line, unsigned short mod, NETPAC *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = ':';
    txp->txbuf [1] = '0' + (mod/10);
    txp->txbuf [2] = '0' + (mod%10);
    txp->txbuf [3] = TALKMODE;
    makechksum (&(txp->txbuf [0]), TALKMODELEN, &(txp->txbuf [TALKMODELEN]));
    txp->txbuf [TALKMODELEN+CHKSUMLEN] = 0x0d;
    txp->txmsglen = TALKMODELEN+CHKSUMLEN+1;
    pmod->no_dataout_msgs++;

    /* Send out the message */
    if (msgxfer (line, pmod, STATUSREPLYLEN) == XFERBAD)
    {
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting a status response. if anything else, its a mistake */
    if (rxp->rxbuf [2] != '*')
    {
        pmod->no_dataerr++;
        return (FALSE);
    }
    /* expecting a good response. if anything else, its an error. */
    if (pmod->statusclass != NOERROR)
    {
        return (FALSE);
    }

    return (TRUE);
}

/*                                                              
/* setfahrenheit                                                
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short setfahrenheit (unsigned short line, unsigned short mod, NETPAC *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = ':';
    txp->txbuf [1] = '0' + (mod/10);
    txp->txbuf [2] = '0' + (mod%10);
    txp->txbuf [3] = TEMPERATUREUNIT;
    txp->txbuf [4] = '1';  /* fahrenheit */
    makechksum (&(txp->txbuf [0]), TEMPERATUREUNITLEN, &(txp->txbuf [TEMPERATUREUNITLEN]));
    txp->txbuf [TEMPERATUREUNITLEN+CHKSUMLEN] = 0x0d;
    txp->txmsglen = TEMPERATUREUNITLEN+CHKSUMLEN+1;
    pmod->no_dataout_msgs++;

    /* Send out the message */
    if (msgxfer (line, pmod, STATUSREPLYLEN) == XFERBAD)
    {
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting a status response. if anything else, its a mistake */
    if (rxp->rxbuf [2] != '*')
    {
        pmod->no_dataerr++;
        return (FALSE);
    }
    /* expecting a good response. if anything else, its an error. */
    if (pmod->statusclass != NOERROR)
    {
        return (FALSE);
    }

    return (TRUE);
}

/*                                                              
/* setdataformat                                                
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short setdataformat (unsigned short line, unsigned short mod, NETPAC *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = ':';
    txp->txbuf [1] = '0' + (mod/10);
    txp->txbuf [2] = '0' + (mod%10);
    txp->txbuf [3] = DATAFORMAT;
    txp->txbuf [4] = '1';  /* floating point (ascii hex) */
    makechksum (&(txp->txbuf [0]), DATAFORMATLEN, &(txp->txbuf [DATAFORMATLEN]));
    txp->txbuf [DATAFORMATLEN+CHKSUMLEN] = 0x0d;
    txp->txmsglen = DATAFORMATLEN+CHKSUMLEN+1;
    pmod->no_dataout_msgs++;

    /* Send out the message */
    if (msgxfer (line, pmod, STATUSREPLYLEN) == XFERBAD)
    {
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting a status response. if anything else, its a mistake */
    if (rxp->rxbuf [2] != '*')
    {
        pmod->no_dataerr++;
        return (FALSE);
    }
    /* expecting a good response. if anything else, its an error. */
    if (pmod->statusclass != NOERROR)
    {
        return (FALSE);
    }

    return (TRUE);
}


/*                                                                              
/*     prepresponses                                                            
/*                                                                              
/*      The purpose of this routine is to mark the Modules as on hold and the   
/*    data as not valid until read again from the Module                        
/*                                                                              
*/
/* only called from MAIN */

static  void prepresponses (unsigned short line)
{
    unsigned short   mod;
    NETPAC          *pmod;

    for (mod = 0; (mod < NUMMODS); mod++)
    {
        pmod = modules [line] [mod];
        if (pmod)                /* verify pointer validity prior to use */
        {
            pmod->holdflag = TRUE;
            mark_not_valid (pmod);
        }
    }
}


/*                                                                       
/*      any_responding                                                   
/*                                                                       
/*      The purpose of this routine is to see if any units are           
/*    responding on this line                                            
/*                                                                       
*/
/* only called from MAIN */

static  int any_responding (unsigned short line)
{
    unsigned short  mod;
    NETPAC        *pmod;

    for (mod = 0; (mod < NUMMODS); mod++)
    {
        pmod = modules [line] [mod];
        if (pmod)            /* verify pointer validity prior to use */
        {
            /* check cmd_force_offline flag because it is set in an asynchronous task */
            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
            {
                return (TRUE);
            }
        }
    }
    return (FALSE);
}

/*
/* initinputs                                                   
/*                                                              
*/                                                                              
/* only called from scan_module */

static  unsigned short initinputs (unsigned short line, unsigned short mod, NETPAC *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i, j, k;

    unsigned char   rawnum [4];
    unsigned char  *pchar;
    float          *pfloat;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = ':';
    txp->txbuf [1] = '0' + (mod/10);
    txp->txbuf [2] = '0' + (mod%10);
    txp->txbuf [3] = ENGINEERINGUNIT;

    for (i = 0; i < NUMCHANNELS; i++)
    {
        /* if we need to send the engineering units, do it */
        if ((pmod->inputs[i].device_type) && (!(pmod->inputs[i].initialized)))
        {
            txp->txbuf [4] = '0' + (i/10);
            txp->txbuf [5] = '0' + (i%10);
            txp->txbuf [6] = '0' + ((pmod->inputs[i].device_type)/10);
            txp->txbuf [7] = '0' + ((pmod->inputs[i].device_type)%10);
            makechksum (&(txp->txbuf [0]), ENGINEERINGUNITLEN, &(txp->txbuf [ENGINEERINGUNITLEN]));
            txp->txbuf [ENGINEERINGUNITLEN+CHKSUMLEN] = 0x0d;
            txp->txmsglen = ENGINEERINGUNITLEN+CHKSUMLEN+1;
            pmod->no_dataout_msgs++;

            /* Send out the message */
            if (msgxfer (line, pmod, STATUSREPLYLEN) == XFERBAD)
            {
                pmod->no_offlines++;
                pmod->holdflag = TRUE;
                pmod->is_responding = FALSE;
                return (FALSE);
            }
            /* Verify the response */
            /* expecting a status response. if anything else, its a mistake */
            if (rxp->rxbuf [2] != '*')
            {
                pmod->no_dataerr++;
                return (FALSE);
            }
            /* expecting a good response. if anything else, its an error. */
            if (pmod->statusclass != NOERROR)
            {
                return (FALSE);
            }
            pmod->inputs[i].initialized = 1;
        }
    }
    return (TRUE);
}

/********************************************************************************/
/********************************************************************************/
/*

/*
/* readinputs                                                   
/*                                                              
*/                                                                              
/* only called from scan_module */

static  unsigned short readinputs (unsigned short line, unsigned short mod, NETPAC *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i, j, k;
    unsigned short hexvalue;

    unsigned char   rawnum [4];
    unsigned char  *pchar;
    float          *pfloat;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = ':';
    txp->txbuf [1] = '0' + (mod/10);
    txp->txbuf [2] = '0' + (mod%10);
    txp->txbuf [3] = READANALOGDATA;
    makechksum (&(txp->txbuf [0]), READANALOGDATALEN, &(txp->txbuf [READANALOGDATALEN]));
    txp->txbuf [READANALOGDATALEN+CHKSUMLEN] = 0x0d;
    txp->txmsglen = READANALOGDATALEN+CHKSUMLEN+1;
    pmod->no_datain_msgs++;

    /* Send out the message */
    if (msgxfer (line, pmod, DATAREPLYLEN) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return (FALSE);
    }

    /* Verify the response */
    if (rxp->rxbuf [2] == '*') /* if we got module status instead of data, something is wrong */
    {
        pmod->no_dataerr++;
        return (FALSE);
    }

    /* parse and store the returned data, assuming it is good. If not, store the channel status */
    k = 2;

    for (i = 0; i < NUMCHANNELS; i++)
    {
        /* eat any spaces, though none expected */
        while ((rxp->rxbuf[k] == ' ') && (k < MAXRXMSG))
        {
            k++;
        }

        if (k >= MAXRXMSG)
        {
            pmod->no_offlines++;
            pmod->holdflag = TRUE;
            pmod->is_responding = FALSE;
            return (FALSE);
        }

        for (j = 0; j < 8; j++)
        {
            pmod->inputs[i].raw_read[j] = rxp->rxbuf [k++];
        }

        /* only process channel data if engineering units have been established for the channel */
        if (pmod->inputs[i].initialized != 0)
        {
            /* setting flag to 2 takes individual 'hold' logic off of the point in AIDRIVER */
            pmod->inputs[i].initialized = 2;

            /* convert 2nd byte of floating point value (MSB of mantissa) from ascii to numeric value. */
            if (!(asciihex( &hexvalue, &pmod->inputs[i].raw_read[2])))
            {
                pmod->no_offlines++;
                pmod->holdflag = TRUE;
                pmod->is_responding = FALSE;
                return (FALSE);
            }
            /* test for channel error: MSB of mantissa not set. */
            if ((hexvalue == 0) || (hexvalue & 0x80))   /* if no error, convert value */
            {
                pchar = &(pmod->inputs[i].raw_read[0]);
                pfloat = &(pmod->inputs[i].last_read);
                if (!(netpac_to_float (pchar, pfloat)))
                {
                    pmod->no_offlines++;
                    pmod->holdflag = TRUE;
                    pmod->is_responding = FALSE;
                    return (FALSE);
                }
                pmod->inputs[i].data_valid = TRUE;
                pmod->inputs[i].data_status = 0;
            }
            else
            {
                pmod->inputs[i].data_valid = TRUE;
                pmod->inputs[i].data_status = hexvalue;
            }
        }
    }
    return (TRUE);
}

/********************************************************************************/
/********************************************************************************/
/*

floating point data format discussion:

IEEE-754 floating point format uses sign-magnitude representation and stores the
8 bit exponent in biased notation or 'excess - 127' notation. The mantissa is
stored in a 23 bit normalized form, with a hidden 24th bit located immediately to
the left of the the decimal point for all values except floating-point 0.
 
the 'internal' format (the memory stored format) is as follows:

|    byte 0     |    byte 1     |    byte 2     |    byte 3     |
-----------------------------------------------------------------
| sign | exponent |  mantissa                                   |
-----------------------------------------------------------------
 1 bit   8 bits     23 bits  


The Netpac floating point format uses a four character long sign magnitude
format and stores the 7 bit exponent in unbiased two's complement notation. The
mantissa is stored in a 24 bit normalized form. 


the 'internal' format (the memory stored format) is as follows:

|    byte 0     |    byte 1     |    byte 2     |    byte 3     |
-----------------------------------------------------------------
| sign |exponent|    mantissa                                   |
-----------------------------------------------------------------
 1 bit   7 bits     24 bits 

*/


/*                                                                                      
/* netpac_to_float:                                                                     
/*                                                                                      
/*    convert Netpac floating point format to native IEEE-754 floating point format     
/*                                                                                      
/*         input:   points to an 8 character array holding the ascii representation     
/*                  of the 32 bits of the input Netpac floating point value             
/*         output:  points to a float value (IEEE-754 format, 32 bits),                 
/*                  in which the value is returned                                      
*/
static unsigned short  netpac_to_float (unsigned char *input, float *output)
{

    unsigned char  sign;
    char           exponenta;
    short          exponentb, exponent;
    unsigned long  mantissa;
    unsigned short hexvalue;
    unsigned char  temp[4];

    union f_value {
                   float          fvalue;
                   unsigned long  lvalue;
                   unsigned short svalue;
                   unsigned char  cvalue;
                   unsigned char  array[4];
                   }  outputval;

    if (!(asciihex( &hexvalue, &input[0])))
       return (FALSE);
    (unsigned char) temp[0] = hexvalue;

    if (!(asciihex( &hexvalue, &input[2])))
       return (FALSE);
    (unsigned char) temp[1] = hexvalue;

    if (!(asciihex( &hexvalue, &input[4])))
       return (FALSE);
    (unsigned char) temp[2] = hexvalue;

    if (!(asciihex( &hexvalue, &input[6])))
       return (FALSE);
    (unsigned char) temp[3] = hexvalue;

    if ((temp[0] == 0) && (temp[1] == 0) && (temp[2] == 0) && (temp[3] == 0))
    {
        *output = 0;
        return (TRUE);
    }

    sign     =   ((temp[0] & 0x80)?1:0);
    exponenta =  (((char)(temp[0] << 1) >> 1));
    exponentb =  ((short)(exponenta)) + (127 - 1);
    exponent =   ((short)(((char)(temp[0] << 1) >> 1))) +
                  (127 - 1);
    mantissa = ( ( ( ( (temp[1]<<8) | temp[2])<<8) | temp[3]) & 0x7fffff);

    outputval.lvalue = mantissa;
    outputval.svalue = (outputval.svalue | (exponent << 7));
    outputval.cvalue = (outputval.cvalue | (sign?0x80:0));

    *output = outputval.fvalue;

    return (TRUE);

    if (trace [1] & ASCIITRAFFICTRACE)
    {
        printf ("Floating Point Conversion\n");
        printf ("                 Netpac:   %x%x,%x%x,%x%x,%x%x   expa=%x, expb=%x\n",
                 temp[0]/16,
                 temp[0]%16,
                 temp[1]/16,
                 temp[1]%16,
                 temp[2]/16,
                 temp[2]%16,
                 temp[3]/16,
                 temp[3]%16,
                 exponenta,
                 exponentb);

        printf ("                 IEEE:     %x%x,%x%x,%x%x,%x%x    sgn=%x,  exp=%x,  mantissa=%x\n",
                 outputval.array[0]/16,
                 outputval.array[0]%16,
                 outputval.array[1]/16,
                 outputval.array[1]%16,
                 outputval.array[2]/16,
                 outputval.array[2]%16,
                 outputval.array[3]/16,
                 outputval.array[3]%16,
                 sign,
                 exponent,
                 mantissa);
    }

    return (TRUE);
}

/*             
/* makechksum  
/*             
*/

static  void makechksum (unsigned char *chkbuf, int len, char unsigned *retbuf)
{
    unsigned short  checksum;
    unsigned int    i, j;
    unsigned short  temp0, temp1;

    checksum = 0;
    for (j = 0; j < len; j++)
    {
        checksum += chkbuf [j];
    }
    checksum = checksum % 256;    
    temp0 = (checksum / 16) + '0';
    temp1 = (checksum % 16) + '0';
    if (temp0 > '9') temp0 += 7;
    if (temp1 > '9') temp1 += 7;
    retbuf [0] = temp0;
    retbuf [1] = temp1;
}


/*
/*      DUMPMSGCNTS
/*
/*      The purpose of this routine is to dump the line level statistics for this driver. 
/*
*/
/* called from TABLEINFO */

void DUMPMSGCNTS (unsigned short line)
{
    unsigned long    temp, t, x, y, z;

    temp = tickGet ();
    t = (temp - linestats [line].startingtick);

    x = linestats [line].TXintcount;
    y = linestats [line].RXintcount;
    z = linestats [line].msgxfercount;

    if (z == 0)
    {
        printf (" ******  No Messages Transferred ****** \n");
        return;
    }

    printf ("\n");
    printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
    printf ("\n");
    printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
    printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
    printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
    printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
    printf ("\n");
    printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
    printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
    printf ("\n");
    printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
    printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
    printf ("\n");
    return;
}

/*
/*      CLEARMSGCNTS
/*
/*      The purpose of this routine is to dump and clear the line level statistics
/*      for this driver.
/*
*/
/* called from TABLEINFO */

void CLEARMSGCNTS (unsigned short line)
{
    DUMPMSGCNTS (line);

    linestats [line].TXintcount = 0;
    linestats [line].RXintcount = 0;
    linestats [line].msgxfercount = 0;

    linestats [line].startingtick = tickGet ();
    printf (" ******  All Counts Cleared  ****** \n", linestats [line].msgxfercount);
    printf ("\n");
    return;
}



/*                                                                                           
/*      DUMPMODSTATS                                                                         
/*                                                                                           
/*      The purpose of this routine is to dump the module level statistics for this driver.  
/*                                                                                           
*/                                                                                           
/* called from TABLEINFO */

void DUMPMODSTATS (unsigned short line, unsigned short maddr)
{
    NETPAC         *pmod;
    unsigned long   microsecs;

    pmod = modules [line] [maddr];
    if (!pmod)
    {
        logMsg ("Line/Module Address Not Defined \n");
        return;
    }

    printf (" Was requested        = %5d         ", pmod->was_requested);
    printf (" Is responding        = %5d       \n", pmod->is_responding);
    printf (" # Data out messages  = %5d         ", pmod->no_dataout_msgs & 0x7fff);
    printf (" # Data in messages   = %5d       \n", pmod->no_datain_msgs & 0x7fff);
    printf (" #No Rx Response      = %5d         ", pmod->no_rxnoresp & 0x7fff);
    printf (" #No Tx Responses     = %5d       \n", pmod->no_txnoresp & 0x7fff);
    printf (" #Data Errors         = %5d         ", pmod->no_dataerr & 0x7fff);
    printf (" #Retries             = %5d       \n", pmod->no_retries & 0x7fff);
    printf (" #Rx Hw Errors        = %5d         ", pmod->no_rxhwerrs & 0x7fff);
    printf (" #Tx Hw Errors        = %5d       \n", pmod->no_txhwerrs & 0x7fff);
    printf (" #Checksum Errors     = %5d         ", pmod->no_chksumerrs & 0x7fff);
    printf (" #Framing Errors      = %5d       \n", pmod->no_frameerrs & 0x7fff);
    printf (" #Off Lines           = %5d         ", pmod->no_offlines & 0x7fff);
    printf (" Reset Statistics     = %5d       \n", pmod->cmd_reset_stat);
    printf (" Force Offline        = %5d       \n", pmod->cmd_force_offline);


    printf ("Error Class Counts\n\n");

    printf (" # No Errors          = %5d         ", pmod->noerror & 0x7fff);
    printf (" # Programming        = %5d       \n", pmod->progerror & 0x7fff);
    printf (" # Communication      = %5d         ", pmod->commerror & 0x7fff);
    printf (" # Fatal              = %5d       \n", pmod->fatalerror & 0x7fff);
    printf (" # Configuration      = %5d         ", pmod->configerror & 0x7fff);
    printf (" # Unknown            = %5d       \n", pmod->unknownerror & 0x7fff);

    printf ("Netpac Status Counts\n\n");

    printf (" # No Err (00)        = %5d         ", pmod->error00 & 0x7fff);
    printf (" # Command OK (01)    = %5d       \n", pmod->error01 & 0x7fff);
    printf (" # Prog Err (02)      = %5d         ", pmod->error02 & 0x7fff);
    printf (" # Power-up Err (03)  = %5d       \n", pmod->error03 & 0x7fff);
    printf (" # Framing Err (04)   = %5d         ", pmod->error04 & 0x7fff);
    printf (" # PROM Err (10)      = %5d       \n", pmod->error10 & 0x7fff);
    printf (" # RAM Err (11)       = %5d         ", pmod->error11 & 0x7fff);
    printf (" # VCO Err (12)       = %5d       \n", pmod->error12 & 0x7fff);
    printf (" # Chan Num Err (40)  = %5d         ", pmod->error40 & 0x7fff);
    printf (" # Card Num Err (41)  = %5d       \n", pmod->error41 & 0x7fff);
    printf (" # EV Err (42)        = %5d         ", pmod->error42 & 0x7fff);
    printf (" # Val Range Err (43) = %5d       \n", pmod->error43 & 0x7fff);
    printf (" # Overrange Err (44) = %5d         ", pmod->error44 & 0x7fff);
    printf (" # PowerFailure (45)  = %5d       \n", pmod->error45 & 0x7fff);
    printf (" # All Checksum (50)  = %5d       \n", pmod->error50 & 0x7fff);




    printf ("\n");
    printf (" # of Messages %d \n", pmod->msgs);
    printf (" # Total response time (ticks) = %lu \n", pmod->responsetime);
    if (pmod->msgs)
    {
        printf ("   Average response time (ticks) = %d \n", (pmod->responsetime/pmod->msgs));
        microsecs = (16667*pmod->responsetime)/pmod->msgs;
        printf ("   Average response time (msec) = %d.%1d \n", microsecs/1000, (microsecs%1000)/100);
    }

    printf (" # of scan passes = %d \n", pmod->tscanpass);
    printf ("\n");

    printf (" Resource Responding = %d \n", resresponse[line]);
    printf (" Hold flag  = %d \n", pmod->holdflag );
        return;
}

/*
/*      CLEARMODSTATS
/*
/*      The purpose of this routine is to clear the module level statistics for this driver.
/*
*/
/* called from TABLEINFO */

void CLEARNMODSTATS (unsigned short line, unsigned short maddr)
{
    NETPAC        *pmod;

    pmod = modules [line] [maddr];
    if (!pmod)
    {
        logMsg ("Line/Module Address Not Defined \n");
        return;
    }
    initstats (pmod); /* use existing procedure */
    return;
}



/*
/*      dump_mod_table                                                  
/*                                                                      
/*      The purpose of this routine is twofold:                         
/*         1) dump the module level statistics for the modbus driver.   
/*         2) dump the data for the specified Netpac module.            
/*                                                                      
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)
{
    NETPAC          *pmod;
    unsigned short   i, n;

    unsigned short   addr, linecnt;
    unsigned char    buffer [200];

    pmod = modules [line] [maddr];
    if (!pmod)
    {
        logMsg("Line/Module Address Not Defined \n");
        return;
    }

    /* previously integral code moved to seperate procedure for debugging convenience */
    DUMPMODSTATS (line, maddr);

    linecnt = 1;
    printhdr (buffer, linecnt);
    for (i = 0; i < (NUMCHANNELS); i += 2)
    {
        for (n = 0; n < 2; n++)
        {        
            printf(" %2d:   %2d   %2d   %2d     %2d    %2d   %c%c,%c%c,%c%c,%c%c  %10.4f    ",
                   (i+n),
                   pmod->inputs[i+n].was_requested,
                   pmod->inputs[i+n].device_type,
                   pmod->inputs[i+n].initialized,
                   pmod->inputs[i+n].data_valid,
                   pmod->inputs[i+n].data_status,
                   pmod->inputs[i+n].raw_read[0],
                   pmod->inputs[i+n].raw_read[1],
                   pmod->inputs[i+n].raw_read[2],
                   pmod->inputs[i+n].raw_read[3],
                   pmod->inputs[i+n].raw_read[4],
                   pmod->inputs[i+n].raw_read[5],
                   pmod->inputs[i+n].raw_read[6],
                   pmod->inputs[i+n].raw_read[7],
                   pmod->inputs[i+n].last_read);
        }
        printf ("\n");
        linecnt += 2;
        if ((linecnt >= 24) && ((i + 2)  < NUMCHANNELS))
        {
            linecnt = 1;
            printhdr(buffer, linecnt);
        }
    }
}
/*
/* only called from dump_mod_table 
*/
static void printhdr (unsigned char *buffer, unsigned short cnt)
{    
    taskDelay (120);
    printf ("\n");
    sprintf (buffer,"                            NETPAC MODULE DATA     ");
    printf ( "%s\n", buffer);
    cnt += 1;
    sprintf (buffer,
      " CH#  WasR DevT Init   DVal DStat  RAWREAD          LASTREAD   CH#  WasR DevT Init   DVal DStat  RAWREAD          LASTREAD");
    printf ( "%s\n", buffer);
    cnt += 1;
}

/*
/*      mod info                                                        
/*                                                                      
/*      The purpose of this routine is to list summary information      
/*        for all modules allocated and referenced on this line.        
/*
*/
/* not called from within this driver */

void MODULEINFO (unsigned short line)
{
    NETPAC          *pmod;
    unsigned short   i, n;

    unsigned short   addr, linecnt;
    unsigned char    buffer [200];

    printmodhdr (buffer, linecnt);
    for (i = 0; i < NUMMODS; i++)
    {
        pmod = modules [line] [i];
        if (pmod)
        {
            linecnt = 1;
            printf(" %2d:   %1d   %1d   %1d   %5d %5d %5d %5d %5d %5d %5d %5d %5d  %1d",
                    i,
                    pmod->was_requested,
                    pmod->is_responding,
                    pmod->cmd_force_offline,
                    pmod->no_dataout_msgs & 0x7fff,
                    pmod->no_datain_msgs & 0x7fff,
                    pmod->no_rxnoresp & 0x7fff,
                    pmod->no_txnoresp & 0x7fff,
                    pmod->no_dataerr & 0x7fff,
                    pmod->no_retries & 0x7fff,
                    pmod->no_chksumerrs & 0x7fff,
                    pmod->no_frameerrs & 0x7fff,
                    pmod->no_offlines & 0x7fff);
            linecnt += 1;
            if ((linecnt >= 20) && ((i + 1)  < NUMMODS))
            {
                linecnt = 1;
                printmodhdr(buffer, linecnt);
            }
        }
    }
}
/*
/* only called from dump_mod_table 
*/
static void printmodhdr (unsigned char *buffer, unsigned short cnt)
{    
    taskDelay (30);
    printf ("\n");
    sprintf (buffer,"                        NETPAC MODULE CONFIGURATION INFO");
    printf ( "%s\n", buffer);
/*    cnt += 1; */
    sprintf (buffer,
      " MOD   --- Status ---  # Messages   ------- Comm Error Counts by Type ------- ");
    printf ( "%s\n", buffer);
    sprintf (buffer,
      " NUM   Req  Res  FOL   In    Out    NoTx  NoRx  DatEr Retry Chksm Frame Offln ");
    printf ( "%s\n", buffer);
/*    cnt += 1; */
}

/*
**                                                                
**    The purpose of this routine is to display the contents      
**    of the static variables contained within this driver.       
**                                                                
*/

/* this routine not called from within this driver */

LINEINFO ()
{
    short    i;
    char    buffer [132];
    char    *resrsp;
    char    *lineact;


    printf ("                                 Netpac Line Information Table          \n");
    printf ("\n");
    printf (" Line        Pointer to        Resource      Resource");
    printf ("       Line      Intermessage   Activity\n");
    printf ("Number      NETPAC Table         Name        Response");
    printf ("     Activity      IM  .TX  TX.         Time\n");
    printf ("\n");

    for (i = 0; i < NETPACLINES; i++)
    {
        if(modules [i] == NULL)
        {
        continue;
        }
        if (resresponse [i] == 0)
        {
        resrsp = "FALSE";
        }
        else
        {
        resrsp = "TRUE";
        }
        if (line_activity [i] == 0)
        {
        lineact = "FALSE";
        }
        else
        {
        lineact = "TRUE";
        }
        sprintf (buffer,
                       "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
            i,
            modules[i],
            &resnames[i],
            &resrsp[0],
            &lineact[0],
            intermsgdelay[i],
            pretxdelay[i],
            posttxdelay[i],
            activity_time[i]);
        printf ( "%s\n", buffer);
    }
    return 0;
}

/*    End of File:    drvNetpac.c */
