/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/*  File: drvQ984_proto.h
/*  Edit: 09/04/97      wep: added Resource Group Lock function
/*                         :
*/
void v984_driver (unsigned short line,unsigned short address, unsigned short redundant,
		  unsigned short delay, unsigned short loadinhibit);

         int checkgroup (unsigned short line, unsigned short *lstate, unsigned short tracenum);

static	void    on_line(unsigned short line);

static	void    scan_plc(MODPLC *pmod, unsigned short line,unsigned short mod);

static	void checkoutputs(unsigned short line);

int v984_aidriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname);

int v984_aodriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned short value, unsigned char *resname);

int v984_aoread (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned short *pvalue, unsigned char *resname);

int v984_bidriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask, unsigned long *pvalue,
		unsigned char *resname);

int v984_bodriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long value, unsigned long mask,
		unsigned char *resname);

int v984_boread (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname);

static void  register_resource (unsigned short link, MODPLC *pmod,
                                unsigned char *resname, char *pointname);

static	void outqueinit (unsigned short line);

static	OUTQENT *ogetemptyp (unsigned short line);

static	void omarkfull(unsigned short line);

static	OUTQENT *ogetnextp (unsigned short line);

static	void oreleasefull(unsigned short line);

static	void link_status(unsigned short line);

static	void start_rx( unsigned short line,SEMAPHORE *semid,unsigned short *pstatus );

static	void stop_rx( unsigned short line );

static	void rx_int_proc( unsigned short line );

static	void start_tx( unsigned short line,SEMAPHORE *semid,unsigned short *pstatus );

static	void stop_tx( unsigned short line );

static	void tx_int_proc( unsigned short line );

static	unsigned short  msgxfer(unsigned short fline,unsigned short resplen, MODPLC *pmod, unsigned short rxlength);

static	void init_line_tabs(unsigned short line, unsigned short loadinhibit);

static	void initstats(MODPLC *pmod);

static	unsigned short modloopback(unsigned short line, unsigned short mod,
			   MODPLC *pmod);

static	unsigned short readcoils(unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned short readlen);

static	unsigned short readdis(unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned short readlen);

static unsigned short readais(unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short reglen);

static unsigned short readregs(unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short reglen);

static unsigned short setcoil(unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned long mask, unsigned long val);

static unsigned short setreg(unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short val);

static	void makecrc( unsigned char *chkbuf, int len,unsigned char *retbuf);
static	void hexascii(unsigned short val,char *buf);
static	short asciihex(unsigned short *val,char *buf);
static	void dump_mod_table(unsigned short line);
static	void scannsome (int flag);
void v984_int_proc( unsigned short line );

/* Resource Group Lock code: 9/10/97 */
int     assignLockGroup (int group, char *resource);

