/*drvQei.c,v 1.1.1.1 1999/08/03 14:44:15 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
/*  File: drvQei.c                                                                      
/*  Edit:  05/08/94      JLD: created based on drvmodbus.c                              
/*      :  12/05/94      WEP: modified AIDRIVER to mask out MSBit of statistics counts. 
/*      :  01/23/95      WEP: initialize pstatewait to 60 seconds.                      
/*      :  01/23/95      WEP: implemented calls to watchdog timer logic in platform.    
/*      :  01/23/95      WEP: on_line test made conditional on cmd_force_offline=FALSE. 
/*      :  01/23/95      WEP: delay added to wait loop when partner forced to master.   
/*      :  01/31/95      WEP: corrected msgxfer handling in msgtortu and qeiaocmd.      
/*      :  05/12/95      WEP: simplified line activity data structures and detection    
/*                          : logic in MAIN, check_line_activity, and rx_int_proc.      
/*                          : combined 'waiting for valid pstate' and 'checking for     
/*                          : line activity' delay loops in MAIN.                       
/*      :  05/22/95      WEP: modified master loop logic to exit when local state is not
/*                          : master. This causes lockstep logic to function correctly. 
/*                          : test for and conditionally display an illegal lstate msg. 
/*      :  10/05/95      WEP: modified 'pollfordata' and 'msgtortu' to increment the    
/*                          : retry counter when CIU has responded with a zero length   
/*                          : reply. This has been seen to occur when the CIU is unable 
/*                          : to communicate with an rtu in the system, and is retrying 
/*                          : communications to the rtu. Once it has retried five times,
/*                          : it no longer returns a zero length message, but instead   
/*                          : simply fails to respond to the driver commands.           
/*      :  05/24/96      WEP: added pollforall call after successful on_line action.    
/*      :  06/12/96      WEP: added traffic tracing, private flag, half duplex runtime  
/*                          : control, full prototyping, comm performance statistics,   
/*                          : help menu, and zero padded last of 5 parameter calls to   
/*                          : the 'qeiresponse' routine to match prototype, and modified
/*                          : 'qeierr' to eliminate 'errno' var.                        
/*      :  06/13/96      WEP: modified traffic trace to selectively trace on address,   
/*                          : TTC code, and/or opcode. added trace level to show        
/*                          : commands sent to qei rtu.                                 
/*      :  06/14/96      WEP: modified traffic trace to also parse and display the TX   
/*                          : and RX message addresses, TTC codes, opcodes, and point   
/*                          : values. TTC codes and opcodes are also displayed in       
/*                          : english.                                                  
/*      :  06/21/96      WEP: modified traffic trace display routine to recognize and   
/*                          : print message for the CIU's Zero Response Byte.           
/*      :  06/24/96      WEP: added 'checkdata' to print debug error messages for reply 
/*                          : syntax and data errors, and to print details of data sent.
/*                          : modifed 'savedata' to bump dataerr ans crcerrs counters.  
/*                          : fixed pollforall interval > 18 minute error. enhanced     
/*                          : the 'on_line' debug msgs to indicate success or failure   
/*      :  06/25/96      WEP: made data output in traffic tracing conditional.          
/*      :  07/27/96      WEP: changed order and response in response error testing to   
/*                          : cause checksum to be tested first, and the crcerror       
/*                          : counter to be incremented.                                
/*      :  07/02/96      WEP: modified scan_plc to keep from polling for upsets         
/*                          : immediately after polling for all.                        
/*      :  07/10/96      WEP: modified msgxfer to retry on zero length responses.       
/*                          : release hold flag for each rtu immediately after access,  
/*                          : rather than waiting till the end of the master loop.      
/*                          : remove extra pollforall added on 5/34/96.                 
/*
*/


#define  MAIN        qei_driver           /* NOTE: change here */
#define  AIDRIVER    qei_aidriver         /* NOTE: change here */
#define  AODRIVER    qei_aodriver         /* NOTE: change here */
#define  AOREAD      qei_aoread           /* NOTE: change here */
#define  BIDRIVER    qei_bidriver         /* NOTE: change here */
#define  BODRIVER    qei_bodriver         /* NOTE: change here */
#define  BOREAD      qei_boread           /* NOTE: change here */
#define  SIDRIVER    qei_sidriver         /* NOTE: change here */

#define  TRAFFICON   qeitrafficon         /* NOTE: change here */
#define  TRAFFICOFF  qeitrafficoff        /* NOTE: change here */
#define  TRAFFIC     qeitraffic           /* NOTE: change here */
#define  DATAON      qeidataon            /* NOTE: change here */
#define  DATAOFF     qeidataoff           /* NOTE: change here */

#define  TRACEON     qeitraceon           /* NOTE: change here */
#define  TRACEOFF    qeitraceoff          /* NOTE: change here */
#define  RTRACEON    qeirestraceon        /* NOTE: change here */
#define  RTRACEOFF   qeirestraceoff       /* NOTE: change here */
#define  TRACELEVEL  qeitrlv              /* NOTE: change here */

#define  CONTRACEON     qeicontraceon     /* NOTE: change here */
#define  CONTRACEOFF    qeicontraceoff    /* NOTE: change here */
#define  RUNTRACEON     qeiruntraceon     /* NOTE: change here */
#define  RUNTRACEOFF    qeiruntraceoff    /* NOTE: change here */
#define  REJECTTRACEON  qeirejecttraceon  /* NOTE: change here */
#define  REJECTTRACEOFF qeirejecttraceoff /* NOTE: change here */
#define  NACKTRACEON    qeinacktraceon    /* NOTE: change here */
#define  NACKTRACEOFF   qeinacktraceoff   /* NOTE: change here */
#define  DEFAULTTRACE   qeidefaulttrace   /* NOTE: change here */

#define  HELP        qeihelp              /* NOTE: change here */
#define  SIMLEVEL    qsim                 /* NOTE: change here */
#define  STOPDRIVER  stopqei              /* NOTE: change here */
#define  STARTDRIVER startqei             /* NOTE: change here */

#define  SETCOMM     qeicomm              /* NOTE: change here */
#define  SETDELAYS   qei_setdelays        /* NOTE: change here */

#define  DUMPMSGCNTS   qeidumpmsgcnts     /* NOTE: change here */
#define  CLEARMSGCNTS  qeiclearmsgcnts    /* NOTE: change here */
#define  DUMPPLCSTATS  qeidumpplcstats    /* NOTE: change here */
#define  CLEARPLCSTATS qeiclearplcstats   /* NOTE: change here */

#define  TABLEINFO   qei_dmt              /* NOTE: change here */
#define  LINEINFO    qei_sli              /* NOTE: change here */


#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvQei.h>		          /* NOTE: change here */
#include <drvQei_proto.h> 		  /* NOTE: change here */
#include <restable.h>


/* static long	init](); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvQei={ 2,	NULL, init};


/*
/*      External Line Level Data Structures (declared in drvcommon.c)
/*
*/
extern  unsigned short  pstatewait[QEILINES];           /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */
/*
/*      Storage for QEIRTU RTU Structures
/*
*/
static unsigned short bcastaccreset[QEILINES];		/* broadcast accreset                           */
static unsigned short bcastaccfreeze[QEILINES];		/* broadcast accfreze                           */
static unsigned short bcastxferreset[QEILINES];		/* broadcast accxferreset                       */

static POLLCNTRL	pollcntrl[QEILINES];		/* structures for controlling polling           */
static int		qeisim[QEILINES];
static QEISIM		simrtu;


static unsigned int     tick [QEILINES][5];

static unsigned int     lastscan [QEILINES];            /* holds timestamp of beginning of major loop.  */

static unsigned int     scantime [QEILINES];            /* holds actual time taken to scan plcs.        */

static unsigned int     loopoutmsgs [QEILINES];

static unsigned int     loopmsgs [QEILINES];

static LINESTATS	linestats [QEILINES];		/* array of line level statistics.              */


static QEIRTU		*plcs[QEILINES][NUMQEIRTUS+1];	/* two dimensional array of pointers to the     */
                                                        /* fixed length dynamically allocated RTU       */
                                                        /* control and data structures. extra pointer   */
                                                        /* is for Query structure used independently    */
							/* of the others. it also allows for the array  */
                                                        /* index to match the mod value.                */

static unsigned char	resnames[QEILINES][RESNAMELEN];	/* array of resource name strings. 		*/

static RES_TABLE	*prestable[QEILINES];		/* array of pointers to resource tables 	*/

static unsigned short	resresponse[QEILINES];		/* array of resource response flags. 		*/
							/* False= not active resource(slave),           */
                                                        /* True = active resource(master)               */

static unsigned short	modtrace[QEILINES];		/* communication error messages (true/false)    */
static unsigned short	mltrace[QEILINES];		/* resource related messages (level)            */
static unsigned short	modrestrace[QEILINES];		/* MASTER/SLAVE arbitration messages (binary)   */

static	unsigned short	trace [QEILINES];               /* controls output of system error messages:	*/
                                                        /* bit mapped controls                          */
static  unsigned char   traceadr [QEILINES];
static  unsigned char   tracecmd [QEILINES];
static  unsigned char   tracetype [QEILINES];

static OUTPUTQUE	*oq[QEILINES];			/* array of ptrs to the line output queues and  */
                                                        /* their control structures                     */

static SEM_ID		semids[QEILINES][2];		/* 'new' semaphore logic. the old SEMAPHORE is  */
                                                        /* still used.                                  */

static short		linetimers[QEILINES];		/* except on init (init_line_tabs), all         */
                                                        /* references are commented out.                */

static SEM_ID		linesems[QEILINES];		/* not used. no references in the code at all   */
                                                	
static unsigned short	intermsgdelay[QEILINES];	/* holds value passed in task spawn. used for   */
                                                        /* each msgxfer attempt.                        */
static unsigned short	pretxdelay[QEILINES];		/* holds post RTS delay before TX. 		*/
static unsigned short	posttxdelay[QEILINES];		/* holds post TX delay before dropping RTS. 	*/
static unsigned short   halfduplex [QEILINES];          /* store half/full duplex line status           */


static char		user[40],password[40];		/* holds id and password of the user that       */
                                                        /* spawned the driver task required by host to  */
                                                        /* check file read privileges on RTU load files.*/

static unsigned long    activity_tick[QEILINES];        /* holds timetick of RX interrupt. used to set  */
                                                        /* recent_activity flag.                        */
static unsigned long    recent_activity[QEILINES];      /* flag indicating recent RX comm activity.     */


static unsigned short bits[] = {
	0x0001,0x0002,0x0004,0x0008,0x0010,0x0020,0x0040,0x0080,
	0x0100,0x0200,0x0400,0x0800,0x1000,0x2000,0x4000,0x8000 };

/*
/*      Storage for QEI Comm Line Structures
/*
*/

static RXLINE          *rxlinetab[QEILINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically allocated */
                                                          /* comm controls/buffers                      */

static TXLINE          *txlinetab[QEILINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically allocated */
                                                          /* comm controls/buffers                      */

static char    *bools[] = {
	"TRUE ",
	"FALSE"
    };
static int		taskId [QEILINES];
static short        watchdogId [QEILINES];

static char *tasknames[] = {"QEIRTU Ch0","QEIRTU Ch1","QEIRTU Ch2","QEIRTU Ch3",
                            "QEIRTU Ch4","QEIRTU Ch5","QEIRTU Ch6","QEIRTU Ch7",
                            "QEIRTU Ch8","QEIRTU Ch9","QEIRTU Ch10","QEIRTU Ch11",
                            "QEIRTU Ch12","QEIRTU Ch13","QEIRTU Ch14","QEIRTU Ch15",
                            "QEIRTU Ch16","QEIRTU Ch17","QEIRTU Ch18","QEIRTU Ch19",
                            "QEIRTU Ch20"
			    };

static int rxtimeout = RXTIMEOUT;



static char *ttcnames[] = {
                           "M2RPREMORE ", "M2RPREMORE ", "R2MPREMORE ", "R2MPREMORE ",
                           "M2RDATAMORE", "M2RDATAMORE", "R2MDATAMORE", "R2MDATAMORE",
                           "M2RPRESING ", "M2RPRESING ", "R2MPRESING ", "R2MPRESING ",
                           "M2RDATALAST", "M2RDATALAST", "R2MDATALAST", "R2MDATALAST",
                           "UNKNOWN TTC", "UNKNOWN TTC", "UNKNOWN TTC", "UNKNOWN TTC",
                           "UNKNOWN TTC", "UNKNOWN TTC", "UNKNOWN TTC", "UNKNOWN TTC",
                           "UNKNOWN TTC", "UNKNOWN TTC", "UNKNOWN TTC", "UNKNOWN TTC",
                           "UNKNOWN TTC", "UNKNOWN TTC", "UNKNOWN TTC", "UNKNOWN TTC"
                          };
static char *opcodenames[] = {
                              "RESTART       ", "POLLRESET     ", "POLLNORESET   ", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "POLLALL       ", "SELECT_DO     ", "EXECON        ",
                              "EXECOFF       ", "POLLACC       ", "RESETACC      ", "FREEZEACC     ",
                              "SELECT_AO     ", "EXEC_AO       ", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "XFERRESETACC  ", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE",
                              "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE", "UNKNOWN OPCODE"
                             };

/********
/*
/*	This routine sets the receiver timeout 
/*
********/
void qeirxtimeout (unsigned short secs)
    {
	rxtimeout = secs;
    }



/**********
*
*	This routine is required by iocinit
*
**********/
static long init ()
    {
	return (0);
    }
/********
/*
/*	This routine outputs information to help with debugging.
/*
********/
void HELP (void)
{
    printf ("Starting and Stopping the Qei Driver:\n");
    printf ("\n");
    printf (" startqei(N,C,T1,H,T2,T3,P)                                                     \n");
    printf ("                      N: line number                                              \n");
    printf ("                      C: communications parameter string (comma delimited ascii)  \n"); 
    printf ("                     T1: intermessage delay (in ticks).                           \n");
    printf ("                      H: 0 = full duplex, 1 = half duplex.                        \n");
    printf ("                     T2: post RTS assert, pre TX delay (in ticks).                \n");
    printf ("                     T3: post TX, pre RTS drop delay (in ticks).                  \n");
    printf ("                      P: Private/Redundant mode.  0 = redundant, !0 = private.    \n");
    printf ("                                                                                  \n");
    printf (" Example: startqei(2,\"9600,N,8,1\",1,0,0,0,0)                                    \n");
    printf ("                                                                                  \n");
    printf (" stopqei(N)                                                                       \n");
    printf ("                     N = line number                                              \n");
    printf ("\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" Qei Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" qeitraceon(N)         Enable the following debug messages for line N:             \n");
    printf ("                         1) Major Scan loop Info:                                  \n");
    printf ("                           scan time, total output messages, and total messages.   \n"); 
    printf ("                         2) Output Queue Overflow.                                 \n");
    printf ("                         3) All communication errors encountered in msgxfer.       \n");
    printf ("*qeitraceoff(N)        Disable all of the qeitraceon debug messages for line N.    \n");
    printf ("\n");
    printf (" qeirestrace(N,X)      Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*qeirestraceon(N)      Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" qeirestraceoff(N)     Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

/*
    printf (" qeicontraceon(N)      Enable display of configuration errors in driver calls.     \n");
    printf ("*qeicontraceoff(N)     Disable display of configuration errors in driver calls.    \n");
    printf (" qeiruntraceon(N)      Enable display of runtime errors (queue overflow).          \n");
    printf ("*qeiruntraceoff(N)     Disable display of runtime errors (queue overflow).         \n");
    printf (" qeirejecttraceon(N)   Enable display of driver call rejections in driver calls.   \n");
    printf ("*qeirejecttraceoff(N)  Disable display of driver call rejections in driver calls.  \n");
    printf (" qeinacktraceon(N)     Enable display of point deselection on command NACK.        \n");
    printf ("*qeinacktraceoff(N)    Disable display of point deselection on command NACK.       \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" qeitrlv(N,X)          Enable the following message for line N:                  \n");
    printf ("                         X=0,  display none of the messages below.               \n");
    printf ("                         X=1,  beginning of plc scan loop, bringing plcs online, \n");
    printf ("                               and output queue full.                            \n");
    printf ("                         X=2,  beginning of each plc scan.                       \n");
    printf ("                         X=3,  AO & BO actions (normal): checkoutputs)           \n");
    printf ("                         X>1,  (simulation mode only) poll_for_all_data trace.   \n");
    printf ("                         X>2,  (simulation mode only) poll_for_upsets trace.     \n");
    printf ("\n");

/*
    printf ("                         X=4,  BO queue actions (normal: BODRIVER & checkoutputs)\n");
    printf ("                         X=5,  reserved.                                         \n");
    printf ("                         X=6,  calls to checkoutputs.                            \n");
    printf ("                         X=7,  checkoutputs: trace each queue entry read.        \n");
    printf ("                         X=8,  AIDRIVER, AOREAD: normal call return.             \n");
    printf ("                         X=9,  BIDRIVER, BOREAD: normal call return.             \n");
    printf ("                         X=10, SIDRIVER: normal call return.                     \n");
    printf ("                         X=11 to 254,  reserved.                                 \n");
*/

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" qeitrafficon(N)       Enable traffic tracing for all plc addresses                \n");
    printf ("                         and all qeibus functions on line N.                       \n");
    printf ("*qeitrafficoff(N)      Disable all traffic tracing on line N.                      \n");
    printf (" qeitraffic(N,X,Y,Z)   Modifies line N traffic tracing as follows:                 \n");
    printf ("                         X=254 disables tracing of all rtu addresses.              \n");
    printf ("                         X=255 enables tracing of all rtu addresses.               \n");
    printf ("                         0 <= X < 254 enables tracing of rtu address X traffic.    \n");
    printf ("                         Y=254 disables tracing of all qei ttc codes.              \n");
    printf ("                         Y=255 enables tracing of all qei ttc codes.               \n");
    printf ("                         0 <= Y < 254 enables tracing of ttc code Y traffic.       \n");
    printf ("                         Z=254 disables tracing of all qei opcodes.                \n");
    printf ("                         Z=255 enables tracing of all qei opcodes.                 \n");
    printf ("                         0 <= Z < 254 enables tracing ofopcode Z traffic.          \n");
    printf ("\n");
    printf (" qeidefaulttrace(N)    Restores default setting for all traces.                    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" qsim(N,L)             Enables(L=1) or disables(L=0) the simulation mode.         \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" qeicomm(N,T1,H,T2,T3) Set communication timing parameters for line N as follows: \n");
    printf ("                      N: line number                                              \n");
    printf ("                     T1: intermessage delay (in ticks).                           \n");
    printf ("                      H: 0 = full duplex, 1 = half duplex.                        \n");
    printf ("                     T2: post RTS assert, pre TX delay (in ticks).                \n");
    printf ("                     T3: post TX, pre RTS drop delay (in ticks).                  \n");
    printf (" qei_setdelays(N,T1,T2,T3) Set communication timing parameters for line N as follows: \n");
    printf ("                      N: line number                                              \n");
    printf ("                     T1: intermessage delay (in ticks).                           \n");
    printf ("                     T2: post RTS assert, pre TX delay (in ticks).                \n");
    printf ("                     T3: post TX, pre RTS drop delay (in ticks).                  \n");
    printf ("\n");
    printf (" qeidumpmsgcnts(N)     Display line N communication statistics.                    \n");
    printf (" qeiclearmsgcnts(N)    Display and clear line N communication statistics.          \n");
    printf (" qeidumpplcstats(N,X)  Display line N, plc X, communication statistics.            \n");
    printf (" qeiclearplcstats(N,X) Display and clear line N, plc X, xfers, status & errors.    \n");
    printf (" qei_dmt(N,X)          Display line N, plc X, xfers, status, errors and input data.\n");
}

/********
/*
/*	This routine enables logging of comm trace messages
/*
********/
void TRACEON (unsigned short line)
    {
	modtrace[line] = TRUE;
    }

/********
/*
/*	This routine disables logging of comm trace messages
/*
********/
void TRACEOFF (unsigned short line)
    {
	modtrace[line] = FALSE;
    }

/********
/*
/*	This routine enables logging of resource trace messages
/*
********/
void RTRACEON (unsigned short line)
    {
	modrestrace[line] = TRUE;
    }

/********
/*
/*	This routine disables logging of resource trace messages
/*
********/
void RTRACEOFF (unsigned short line)
    {
	modrestrace[line] = FALSE;
    }

/********
/*
/*	This routine controls logging of trace messages
/*
********/
void TRACELEVEL (unsigned short line, unsigned short level)
    {
	mltrace[line] = level;
    }
/********
/*
/*	This routine enables detailed display of normal communications traffic
/*
********/
void TRAFFIC (unsigned short line, unsigned char addr, unsigned char ttccode, unsigned char opcode)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = addr;
        tracecmd [line] = ttccode;
        tracetype [line] = opcode;
        return;
}

/********
/*
/*	This routine enables detailed display of normal communications traffic
/*
********/
void TRAFFICON (unsigned short line)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = 255;  /* every address  */
        tracecmd [line] = 255;  /* every ttc code */
        tracetype [line] = 255; /* every opcode   */
}

/********
/*
/*	This routine disables detailed display of normal communications traffic
/*
********/
void TRAFFICOFF (unsigned short line)
{
	trace [line] = trace [line] & ~ALLTRAFFICTRACE;
}


/********
/*
/*	These routines enable and disable displaying parsed data during traffic tracing
/*
********/
void DATAON (unsigned short line)
{
	trace [line] = trace [line] | DATATRAFFICTRACE;
}
void DATAOFF (unsigned short line)
{
	trace [line] = trace [line] & ~DATATRAFFICTRACE;
}


/********
/*
/*	These routines enable and disable tracing of database configuration errors in driver calls
/*
********/
void CONTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }
void CONTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }

/********
/*
/*	These routines enable and disable tracing of runtime errors in driver calls
/*
********/
void RUNTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }
void RUNTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/********
/*
/*	These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void REJECTTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }
void REJECTTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }


/********
/*
/*	These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void NACKTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | MODBUSNACKTRACE;
    }
void NACKTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~MODBUSNACKTRACE;
    }

/********
/*
/*	This routine restores default setting for all traces.
/*
********/
void DEFAULTTRACE (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = 1;
        trace [line] = 0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
    }
/********
/*
/*	This routine controls simulation of rtu messages
/*
********/
void SIMLEVEL (unsigned short line, unsigned short level)
    {
	qeisim[line] = level;
    }

int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
            /* if watchdog timer has been attached, detach it before deleting the task */
            if (taskId[ln])
            {
                tisWatchDogDetach(taskId[ln]);
            }
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER (unsigned short line,      /* the line number of this driver.                      */
                 char *mode,               /* UART initializations string (comma delimited ascii). */
                 unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                 unsigned short hdflag,    /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                 unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                 unsigned short delay2,    /* half duplex post TX, pre RTS drop delay.             */
                 unsigned short private)   /* private flag. if 0, normal. if !0, no partner driver.*/
{
	if (line < QEILINES)
	{
	    taskId [line] = taskSpawn (tasknames [line],
                                     QEI_PRIORITY,
                                     QEI_TASK_OPTIONS,
                                     QEI_STACK,
                                     MAIN,
                                     line,
                                     mode,
                                     delay,
                                     hdflag,
                                     delay1,
                                     delay2,
                                     private);


	    logMsg ("Started the QEIRTU driver on line %d\n",line);

	    remCurIdGet (user,password);
	    return (1);
	}
	else
	{

	    logMsg ("Invalid line number %d\n", line);
	    return (-1);
	}
}

/********
/*
/* Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
    intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
    halfduplex [line]    = hdflag;
    pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
    posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}

/********
/*
/* Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETDELAYS (unsigned short line,
		unsigned short tickcount1,
		unsigned short tickcount2,
		unsigned short tickcount3)
    {
	intermsgdelay[line] = tickcount1;  /* at beginning new message/response sequence.               */
	pretxdelay[line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay[line]   = tickcount3;  /* after sending last character of transmission but          */
                                           /* before dropping RTS.                                      */
    }



/*											
/*      QEI_driver                                                                      
/*                                                                                     	
/*      The purpose of this task is to scan the QEI lines. It will                      
/*      maintain a configuration list supporting online additions and                   
/*      replacement of modules, and maintain a table of most recently                   
/*      scanned values.                                                                 
/*                                                                                     	
*/                                                                                     	
/* not called from within this driver 						      */

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2,
           unsigned short private)
    {
	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command,i;
	int		thismod;
	int		lastpolled = 1;
	long	        this_time, last_time;
	QEIRTU          *pmod;
	RXLINE          *rxp;
        unsigned int    temptick, tempdiff;
        int             temp;

        short  *ptable_id;

/* Initialize the data structures */

	for ( mod=0; (mod <= NUMQEIRTUS); mod++ )
	{
	    plcs[line][mod] = NULLP;
	}		

	intermsgdelay[line] = delay;

	halfduplex [line]  = hdflag;
	pretxdelay[line] = 0;		/* wep: initialize to 50 msec */
	posttxdelay[line] = 0;		/* wep: initialize to 50 msec */

	qeisim[line] = FALSE;
	resresponse[line] = FALSE;
	resnames[line][0] = 0;
	prestable[line] = NULL;

	modtrace[line] = FALSE;
	mltrace[line] = 0;
	modrestrace[line] = TRUE;

	/* Initialize the broadcast commands */
 	bcastaccreset[line] = FALSE;
	bcastaccfreeze[line] = FALSE;
	bcastxferreset[line] = FALSE;

        pstatewait[line] = 60;

        /* debug structures */
        qeidefaulttrace (line);

        tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].msgxfercount = 0;
        linestats [line].startingtick = tickGet ();


/******/
        activity_tick[line] = 0; /* forces 'recent_activity' test result to FALSE until first RX int. */
        recent_activity[line] = FALSE;
/******/

/* wep: output queue initialization */
	oq[line] = (OUTPUTQUE *)calloc(1,(sizeof(OUTPUTQUE)));
	if (!oq[line])
	{
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}

/* wep: communication initialization */
	rxlinetab[line] = (RXLINE *)calloc(1,(sizeof(RXLINE)));
	if (!rxlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
	    return;
	}
	txlinetab[line] = (TXLINE *)calloc(1,(sizeof(TXLINE)));
	if (!txlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
	    return;
	}

	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
	onlinefreq = 1;		/* causes on_line calls to begin on first pass if master */

	/* Initialize the Rx interrupts to receive once for activity check */
	/* enable the receiver interrupt after set to ignore */
	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);


	/* Initialize the poll control for this line */
	pollcntrl[line].scan_number = 0;
 	pollcntrl[line].nosincenormal = 0;
 	pollcntrl[line].nosincefast = 0;
 	pollcntrl[line].nosinceoffline = 0;
 	pollcntrl[line].noperoffline = DEFAULTPOLLSPEROFFLINE;
 	pollcntrl[line].noperfast = DEFAULTPOLLSPERFAST;
 	pollcntrl[line].minsperacc = 0;
 	pollcntrl[line].minsperall = 0;
 	pollcntrl[line].minstillacc = 0;
 	pollcntrl[line].minstillall = 0;
	pollcntrl[line].lastalltime = 0;
	pollcntrl[line].lastacctime = 0;
	pollcntrl[line].lastsetfreq = 0;
	pollcntrl[line].lastforced = 0;	
	pollcntrl[line].lastfast = 0;	
	pollcntrl[line].lastoffline = 0;
	pollcntrl[line].lastnormal = 0;	

	this_time = tickGet(); /* Initialize the time  */
 	pollcntrl[line].lastalltime = this_time;
 	pollcntrl[line].lastacctime = this_time;

	for (i=0;(i<10);i++) {
	    pollcntrl[line].lastscanned[i] = 0;
	    pollcntrl[line].lastscannedstat[i] = 0;
	    pollcntrl[line].pollreason[i] = 0;
	    pollcntrl[line].id[i].station[0] = 0;
	}

/*	while (mltrace[line] == 0)
/*	{
/*	    logMsg ( "Waiting for Trace Level on line - %d \n", line); 
/*
/*	    taskDelay (120);
/*	}
*/

	/* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
	while ( (resnames[line][0] == 0) || (prestable[line] == NULL) )
	{
	    if (mltrace[line] == 1)
	    	logMsg ( "No Resource Defined for line - %d \n", line);
	    taskDelay (120);
	}


        /* attach this driver task to the watchdog timer monitoring function. */
        ptable_id = &watchdogId[line];

        if (tisWatchDogAttach(taskId[line],WATCHDOGTIMEOUT, ptable_id) != OK)
        {
            logMsg("Attempt at watchdog attachment failed.\n");
            tisWatchDogDetach(taskId[line]);
            return;
        }
        if (tisWatchDogPulse(watchdogId[line]) != OK)
        {
            logMsg("First attempt at watchdog pulsing failed.\n");
            tisWatchDogDetach(taskId[line]);
            return;
        }

        if (private)
        {
            /*****************************/
	    /* Immediately become master */
            /*****************************/

	    resSetCaAnswer (prestable [line]);
	    resPutLocalState (prestable [line], RES_MSTR);

            lastscan [line] = tickGet ();
            scantime [line] = 0;

	    lstate = RES_MSTR;
	    if (modrestrace [line])
	    {
	    	logMsg ("0] Private: Initialize as RES_MSTR\n");
	    }
        }
        else /* this is the 'normal' path */
        {
            /**********************/
            /* Start out as slave */

            /*********************************/
            tisWatchDogPulse(watchdogId[line]);
            /*********************************/

            resClearCaAnswer(prestable[line]);		/* start quiet */
            resPutLocalState(prestable[line], RES_SLV);
            if (modrestrace[line])
                logMsg ("1] Initialized as RES_SLV \n");
            taskDelay(60);

            /******/
            /* wait finite time for pstate to be resolved */
            logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
            for (i = 0; i <= pstatewait [line]; i++)
            {
                resGetStates (prestable [line], &lstate, &pstate);
                if ((pstate == RES_MSTR) ||
                    (pstate == RES_SLV) ||
                    (pstate == RES_SLVWANT) ||
                    (pstate == RES_SLVWANTCA))
                {
                    /* wait for the minimum activity time before exiting from loop, even if pstate is valid. */
                    if (i > ACTIVITYTIME/60)
                    {
                        break;
                    }
                }
                taskDelay (60);
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/
            }
            if (i >= pstatewait[line])
            {
                logMsg ("Timeout of pstate wait.\n");
            }
            else
            {
                logMsg ("Completion of pstate[%d] wait.\n", i);
            }
            /******/
            activity = check_line_activity(line, 0);
            resGetStates(prestable[line],&lstate,&pstate);
            /******************************************/
            /* if the partner is not there, be master */
            if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
            {
                resSetCaAnswer(prestable[line]);
        	resPutLocalState(prestable[line],RES_MSTR);
                lastscan [line] = tickGet ();
                scantime [line] = 0;

        	lstate = RES_MSTR;
        	if (modrestrace[line])
        	    logMsg ("2] Became RES_MSTR \n");
            }
        }

	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet(); /* Initialize the time  */

	while (TRUE)
	{
            /*********************************/
            tisWatchDogPulse(watchdogId[line]);
            /*********************************/

            activity_tick[line] = 0; /* forces 'recent_activity' results FALSE until first RX int. */
            recent_activity[line] = FALSE;

	    /* we arrive here because we are a slave.                                                   */
	    /* we stay until:  1) asked to be master by partner. if we can reach PLCs, we become master.*/
            /*                 2) the partner is not master and there is no activity on the line.       */

	    while (lstate == RES_SLV)
	    {
                /*********************************/
                tisWatchDogPulse(watchdogId[line]);
                /*********************************/

		if (pstate != RES_SLVWANT)
		{
		    clear_rts(line); 				/* make sure line is left for master 	*/
		}
		resresponse[line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand(prestable[line],0); 		/* clear out commands 			*/
		activity = check_line_activity(line,10); 	/* wait 10 seconds before checking 	*/
		resGetStates(prestable[line],&lstate,&pstate);


		/* see if needed by partner to be master. if yes, do it and break out of slave state.   */
		if (pstate == RES_SLVWANTCA)
		{
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace[line]) logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    break;
		}
		/* If partner is there and wants to give it up, try to take it */
		if (pstate == RES_SLVWANT)
		{
                   /*********************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /*********************************/

		    execute = FALSE;

		    taskDelay(2); /* Time for switch to occur */

		    /* See if anyone is out there and able to respond to a loopback command */
		    if (lastpolled >= NUMQEIRTUS)
		    {
			lastpolled = 1;
		    }
		    for ( mod=lastpolled; (mod <= NUMQEIRTUS); mod++, lastpolled++)
		    {
		        resGetStates(prestable[line],&lstate,&pstate);
		        if (pstate != RES_SLVWANT)
			    break;
 			pmod = plcs[line][mod];
			if ((pmod) &&			/* verify pointer validity prior to use */
			    (pmod->was_requested) &&    /* data points have been requested      */
                            (!pmod->cmd_force_offline)) /* user has NOT forced plc offline      */
			{
                            /*********************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /*********************************/

			    on_line(line,mod);
                            /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
			    {
				execute = TRUE;
                                /* take this rtu off of hold status. */
                                pmod->holdflag = FALSE;
				break;
			    }
			}

		    }
		    /* If someone answered, become master and make sure partner really gave it up */
		    if (execute)
		    {
			resPutLocalState(prestable[line],RES_MSTR);
			lstate = RES_MSTR;

                        lastscan [line] = tickGet ();
                        scantime [line] = 0;

			if (modrestrace[line])
				logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			execute = FALSE;

                        activity_tick[line] = 0; /* 'recent_activity' = FALSE until next RX int. */
                        recent_activity[line] = FALSE;

			for (i=0;(i<60);i++)
			{
                            /*********************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /*********************************/

			    activity = check_line_activity(line,2);  /* wait two seconds before testing */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ( (pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */
			    resPutLocalState(prestable[line],RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace[line])
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 
			    resSetCaAnswer(prestable[line]);
			    prepresponses(line);
			    break;
			}
		    }
		}

		/* if the partner is not talking, be master */
		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace[line])
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
		    prepresponses(line);
		}
	    }

            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is canceled */
	    while (lstate == RES_SLVWANTCA)
	    {
                /*********************************/
                tisWatchDogPulse(watchdogId[line]);
                /*********************************/

	        taskDelay(2);                   /* Give OS a chance...                  */
		clear_rts(line); 		/* Make sure line is left for master */
		resresponse[line] = FALSE; 	/* Make Sure driver is not responding */

		resGetStates(prestable[line],&lstate,&pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace[line])
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    break;
		}
		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;

		    if (modrestrace[line])
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    prepresponses(line);
		}
	    }

            /****************************************************************************************/
	    /* in normal operation this code should never execute. it has, however, been seen to    */
            /* execute when the database has been inadvertently configured with the same resource   */
	    /* assigned to two different drivers in the same IOC. The state does funny things.      */
            /****************************************************************************************/
	    while (lstate == RES_SLVWANT)
	    {
                if (modrestrace [line])
		{
                    /* condition should NEVER occur. print error message every 5 seconds. */
                    logMsg ("Illegal Local Resource State.\n");
                    taskDelay (600);
                }
                taskDelay (2);
            }

            /* we come here because we have gone to, or are looping in, the master state.           */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
	    /* It will then try to configure requested non-responding modules.                      */

	    /* it doesn't appear that we ever come here in a RES_SLVWANT lstate mode. it happens    */
	    /*  within this loop, but is never seen by the while loop conditional evaluation.       */

	    last_time = tickGet ();		/* initialize gap */
	    while ((lstate == RES_MSTR) || (lstate == RES_SLVWANT))
	    {
                /*********************************/
                tisWatchDogPulse(watchdogId[line]);
                /*********************************/

		resresponse[line] = TRUE; /* Make sure driver is responding. driver won't           */
                                          /* issue commands if not set.                             */

		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0);        /* clear out commands */


		/* if relinquish command sent, change state and break out to outer loop */
		if (command == RES_RELINQUISH)
		{
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace[line])
                        logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
		    break;
		}

                /* measure time between scans of the entire set of plcs. display if requested. */
                temptick = tickGet ();
                tempdiff = temptick - lastscan [line];

                if (modtrace [line])
		{
                    logMsg ("ScanTime: =%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                            scantime[line], loopoutmsgs[line], loopmsgs[line]);
		}

                loopoutmsgs [line] = 0;
                loopmsgs [line] = 0;
                lastscan [line] = temptick;


		/* scan plcs for data i/o, if allowed */
		modspolled = 0;
		/* call 'scan_plc' for each RTU device, unless user */
                /* has taken it off line or it is not responding.   */
		for ( mod=1; (mod <= NUMQEIRTUS); mod++ )
		{
		    thismod = Next_to_Poll(line);
		    if (thismod == -1)
			break;
		    pmod = plcs[line][thismod];		/* shorthand pointer 			*/
		    if (pmod)				/* verify pointer validity prior to use */
		    {
			if (pmod->cmd_force_offline)
			{ 
				/* if user has turned this plc offline via pseudo commands, */
                                /* mark it as not responding                                */
 				pmod->is_responding = FALSE;
	    		}
			else 
			{
                            /* local/partner lockstep recovery */
                            resGetStates(prestable[line], &lstate, &pstate);
                            if (pstate == RES_MSTR)
                            {
                                resClearCaAnswer(prestable[line]);
                                resPutLocalState(prestable[line], RES_SLV);
                                lstate = RES_SLV;
                                clear_rts(line); 		/* Make sure line is left for master */
                                if (modrestrace[line])
                                    logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                                temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                                for ( i = 0; i < temp; i++)
                                {
                                   /*********************************/
                                   tisWatchDogPulse(watchdogId[line]);
                                   /*********************************/
                                   taskDelay(60);
                                }
                                break;
                            }
			    modspolled++;
			    if (pmod->is_responding)
                            {	
				scan_plc(pmod,line,thismod);      	/* I/O done here! 	*/
				if (!pmod->is_responding)
				{
					mark_not_valid(pmod);
                               	} else {
				    pmod->holdflag = FALSE;
				}
			    }
                            else
                            {
                                /*********************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /*********************************/

				on_line(line,thismod);	/* loopback testing done here! 		*/
			    }
			}
		    }
                    /* take this rtu off of hold status. the rtu's data is not to be held off   */
                    /* since we are now master and have tried, successful or not, to reach it.  */
                    pmod->holdflag = FALSE;


		    /* end of single module action */

		    /* if told to relinquish our master state, stop plc scanning immediately.   */
		    /* don't trash the command, so that we can still read it on the next loop   */
                    /* through this while statement.                                            */
		    resGetCommand(prestable[line],&command);
		    if (command == RES_RELINQUISH) break;
		} /* end of scan loop */

                /* test for lockstep detection. */
                if (lstate != RES_MSTR) break;

                /*********************************/
                tisWatchDogPulse(watchdogId[line]);
                /*********************************/

                /* measure how long the scan took. to be displayed at beginning of next loop. */
                temptick = tickGet ();
                scantime [line] = temptick - lastscan [line];

		/* see if anyone on the line has been responding.       */
                /* if not, try to get partner to become slave.          */
		/* Check for no one responding */
		if ((!any_responding (line)) && (!private))
		{
                    /*********************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /*********************************/

		    /* See if it is time to let partner try */
		    this_time = tickGet();
		    if ((this_time - last_time) > (3*SLWWINDOW))
		    {   /* #ticks for slave to try */

			/* Switch States to let partner know it's time to try */

			resPutLocalState(prestable[line],RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace[line])
				logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate,activity);

			/* Give partner access to the hardware */
			clear_rts(line);

			/* Remember the time of this try */
			last_time = tickGet();

                        activity_tick[line] = 0; /* activity = FALSE until next RX int. */
                        recent_activity[line] = FALSE;

			for (i=0; (i<SLWWINDOW); i+=10)
			{       		/* SLWINDOW is the # of ticks for slave to try */
                            /*********************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /*********************************/
			    taskDelay(10);
		    				/* If partner picked up let it have control */
			    activity = check_line_activity(line,0);  /* check immediately */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
			    {
				resClearCaAnswer(prestable[line]);
				resPutLocalState(prestable[line],RES_SLV);
				lstate = RES_SLV;
				if (modrestrace[line])
					logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                                /*********************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /*********************************/
                                taskDelay(60);
                                /*********************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /*********************************/
                                taskDelay(60);
                                /*********************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /*********************************/
                                taskDelay(60);
				break;
			    }
			}
			/* Go Back to being the Master and take control of the hardware */
			if (lstate != RES_SLV)
			{
                            resSetCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace[line])
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			}
		    }
		}

		/* take plcs off of hold status.                                 */
                /* the plc's data is not to be held off since we are now master. */
		for ( mod=1; (mod <= NUMQEIRTUS); mod++ )
		{
		    pmod = plcs[line][mod];
		    if (pmod)			/* verify pointer validity prior to use */
		    {        
			pmod->holdflag = FALSE;
                    }
		}
	    }
	    if (modspolled==0)
	    	taskDelay(60);
	    else taskDelay(10);
	} /* end infinite task loop */
     }

/*
/* Try to bring a RTU on line
/*
*/

/* this routine only called from MAIN */


static void on_line (unsigned short line, unsigned short mod)
{
    QEIRTU  *pmod;
    unsigned short i, j;
    unsigned long  this_time;

    pmod = plcs[line][mod];	
    if (pmod)			/* verify pointer prior to use */
    {
        if (mltrace[line] == 1)
        {
            logMsg ( "Attempt to Bring Online:  RTU: [%d]\n", mod );
        }
        /* Use the loop back function to see if the unit is there and responding */

        mark_not_valid(pmod);	/* an RTU that has just been brought online      */
                                /*  must have it's data marked not valid.        */

        if (!modloopback(ONERETRY+line, mod, pmod))
        {
            if (mltrace[line] == 1)
            {
                logMsg ( "Online Attempt Failed:    RTU: [%d]\n\n", mod );
            }
            return; /* if no response, get out */
        }

        if (mltrace[line] == 1)
        {
            logMsg ( "Online Attempt Succeeded: RTU: [%d]\n\n", mod );
        }

        pmod->is_responding = TRUE;

/*
        if (!(pollforall(line, mod, pmod)))
        {
            pmod->holdflag = TRUE;
            pmod->is_responding = FALSE;
            return;
        }
        /* After Sucessful Poll For All, set last pollall time and clear poll_all_due flag.  */
/*
        this_time = tickGet();
 	pollcntrl[line].lastalltime = this_time;
        pmod->poll_all_due = FALSE;
*/
        return;
    }
}

/*
/* Next_to_Poll
/*
/*	This routine scans through the poll list and determines who is
/*	the next unit to talk to
*/
static int Next_to_Poll(unsigned short line)
    {

	unsigned short i,modno,reason;
	QEIRTU  *pmod;
	POLLCNTRL	*pc;
	int		 next2poll;

	next2poll = -1;
	pc = &pollcntrl[line];

	/* Check for a forced scan on any RTU */
	for (i=0,modno=((pc->lastforced)%NUMQEIRTUS)+1;
	     (i<NUMQEIRTUS);
	     i++,modno=((modno)%NUMQEIRTUS)+1 ) {

	    pmod = plcs[line][modno];
	    if ((pmod) &&			/* verify pointer validity prior to use */
		(pmod->was_requested) &&
		(pmod->forcescan) ) {

		pmod->forcescan = FALSE;
		next2poll = modno;
		reason = FORCEDSCAN;

		pc->lastforced = modno;
		break;
	    }
	}

	/* Check for set frequency scan mode */
	for (i=0,modno=((pc->lastsetfreq)%NUMQEIRTUS)+1;
	     (i<NUMQEIRTUS);
	     i++,modno=((modno)%NUMQEIRTUS)+1 ) {

	    pmod = plcs[line][modno];
	    if ((pmod) &&			/* verify pointer validity prior to use */
		(pmod->was_requested) &&
		(pmod->is_responding) &&
		(pmod->scan_freq != 0) ) {

		if ((pc->scan_number - pmod->last_scan_no) > pmod->scan_freq)
		    pmod->poll_due = TRUE;

		if ((pmod->poll_due) && (next2poll == -1)) {
		    pmod->forcescan = FALSE;
		    next2poll = modno;
		    reason = SETFREQSCAN;
		    pc->lastsetfreq = modno;
		}

	    }
	}

	/* Check the fast poll scan list if it is time for a fast poll */
	if (pc->noperfast != 0) {    /* process fast scan */
	    if ((pc->nosincefast < pc->noperfast) ||
		(next2poll != -1) )  {
	        pc->nosincefast++;
	    } else {
	        /* It is time to look for a unit on the fast poll list */
	        pc->nosincefast = pc->nosincefast-pc->noperfast;

	        for (i=0,modno=((pc->lastfast)%NUMQEIRTUS)+1;
	             (i<NUMQEIRTUS);
	             i++,modno=((modno)%NUMQEIRTUS)+1 ) {

	            pmod = plcs[line][modno];
	            if ((pmod) &&			/* verify pointer validity prior to use */
		        (pmod->was_requested) &&
		        (pmod->is_responding) &&
		        (pmod->fast_poll)    ) {

		        pmod->forcescan = FALSE;
		        next2poll = modno;
		        reason = FASTSCAN;
		        pc->lastfast = modno;
			break;
	            }

	        }
	    }
	}

	/* Check the offline poll scan list if it is time for a online poll */
	if (pc->noperoffline != 0) {    /* process offline scan */
	    if ((pc->nosinceoffline < pc->noperoffline) ||
		(next2poll != -1) )  {
	        pc->nosinceoffline++;
	    } else {
	        /* It is time to look for a unit on the offline poll list */
	        pc->nosinceoffline = pc->nosinceoffline-pc->noperoffline;

	        for (i=0,modno=((pc->lastoffline)%NUMQEIRTUS)+1;
	             (i<NUMQEIRTUS);
	             i++,modno=((modno)%NUMQEIRTUS)+1 ) {

	            pmod = plcs[line][modno];
	            if ((pmod) &&			/* verify pointer validity prior to use */
		        (pmod->was_requested) &&
		        (!(pmod->is_responding))  ){

		        pmod->forcescan = FALSE;
		        next2poll = modno;
		        reason = OFFLINESCAN;
		        pc->lastoffline = modno;
			break;
	            }

	        }
	    }
	}

	/* Check the normal poll scan list */
	if (next2poll == -1)  {
	    for (i=0,modno=((pc->lastnormal)%NUMQEIRTUS)+1;
	         (i<NUMQEIRTUS);
	         i++,modno=((modno)%NUMQEIRTUS)+1 ) {

	        pmod = plcs[line][modno];
	        if ((pmod) &&			/* verify pointer validity prior to use */
		    (pmod->was_requested) &&
		    (pmod->is_responding) &&
		     (!pmod->fast_poll) &&
		     (pmod->scan_freq == 0) ) {

		    pmod->forcescan = FALSE;
		    next2poll = modno;
		    reason = NORMAL;
		    pc->lastnormal = modno;
		    break;
	        }
	    }
	}

	if (next2poll != -1) {
	    pmod = plcs[line][next2poll];
	    for (i=9;(i>0);i--) {
		pc->lastscanned[i] = pc->lastscanned[i-1];
		pc->lastscannedstat[i] = pc->lastscannedstat[i-1];
		pc->pollreason[i] = pc->pollreason[i-1];
		strcpy(pc->id[i].station,pc->id[i-1].station);
	    }
	    strcpy(pc->id[0].station,pmod->stationname);
	    pc->lastscanned[0] = next2poll;
	    pc->lastscannedstat[0] = pmod->is_responding;
	    pc->pollreason[0] = reason;
	    pmod->last_scan_no = pc->scan_number;
	    pmod->poll_due = FALSE;
	}
	pc->scan_number++;
	return(next2poll);
    }


/*							
/* Mark all plc data elements as not valid     		
/*                                             		
*/                                             	
/* called from on_line and prepresponses      		*/    	


static void mark_not_valid (QEIRTU  *pmod)
    {
	unsigned short i,j;

/*							
/*      Initialize the AIs as not valid
/*      
*/

	for (i=0; (i<MAXAI); i++)
	{
	    pmod->ais[i].data_valid = FALSE;
	}

/*							
/*      Initialize the DIs as not valid
/*      
*/

	for (i=0; (i<MAXDIBLK); i++)
	{
	    pmod->dis[i].data_valid = FALSE;
	}

/*							
/*      Initialize the ACCs as not valid
/*      
*/

	for (i=0; (i<MAXACC); i++)
	{
	    pmod->accs[i].data_valid = FALSE;
	}
    }

/*                                                           	
/* Scan a QEIRTU RTU -  get inputs and set outputs as required	
/*                                                            	
*/
/* this routine only called from MAIN 		*/


static	void scan_plc (QEIRTU *pmod, unsigned short line, unsigned short mod)
    {
	unsigned long	thistime, timesince;
	QEIRTU 		*tpmod;
	unsigned short	i;

	thistime = tickGet();

	pmod->tscanpass++;

	if (mltrace [line] == 2)
	{
	    logMsg ( "Scanning RTU - %d.\n", mod );
	}
	checkoutputs (line);

	/* Check the timed functions */
	if (pollcntrl[line].minsperacc != 0) {
	    timesince = thistime-pollcntrl[line].lastacctime;
	    pollcntrl[line].minstillacc = pollcntrl[line].minsperacc-(timesince/3600);
	    if (thistime >= pollcntrl[line].lastacctime + (((unsigned long)(pollcntrl[line].minsperacc))*3600)) {
		pollcntrl[line].lastacctime = thistime;
		for (i=1;(i<NUMQEIRTUS);(i++)) {
		    tpmod = plcs[line][i];
		    if (tpmod != NULL) {
	    		tpmod->poll_acc_due = TRUE;
		    }
		}
	    }
	}
	if (pollcntrl[line].minsperall != 0) {
	    timesince = thistime-pollcntrl[line].lastalltime;
	    pollcntrl[line].minstillall = pollcntrl[line].minsperall-(timesince/3600);
	    if (thistime >= pollcntrl[line].lastalltime + (((unsigned long)(pollcntrl[line].minsperall))*3600)){
		pollcntrl[line].lastalltime = thistime;
		for (i=1;(i<NUMQEIRTUS);(i++)) {
		    tpmod = plcs[line][i];
		    if (tpmod != NULL) {
	    		tpmod->poll_all_due = TRUE;
		    }
		}
	    }
	}


	/* See if any of the broadcast commands are required */
 	if (bcastaccreset[line]) {
	    resetacc(line, 0, pmod);
	    bcastaccreset[line] = FALSE;
	}
	if (bcastaccfreeze[line]) {
	    freezeacc(line, 0, pmod);
	    bcastaccfreeze[line] = FALSE;
	}
	if (bcastxferreset[line]) {
	    transferresetacc(line, 0, pmod);
	    bcastxferreset[line] = FALSE;
	}

	/* See if it is time for a poll for all data */
	if (pmod->poll_all_due) {
	    pollforall(line,mod,pmod);
            /* After Poll For All, set last pollall time and clear poll_all_due flag.  */
            thistime = tickGet();
 	    pollcntrl[line].lastalltime = thistime;
	    pmod->poll_all_due = FALSE;
            return;
	}

	/* See if it is time for a poll for accumulators */
	if (pmod->poll_acc_due) {
	    pollforacc(line,mod,pmod);
	    pmod->poll_acc_due = FALSE;
	}

	/* Poll for Upsets */
	pollfordata(line,mod,pmod);

    }
/*												
/* checkoutputs											
/*      checks output que and returns if empty.							
/*      if there is something on the queue it attempts to process all                           
/*      pending outputs, doing immediate retries. If attempts fail the request is dropped.      
/*                                                                                              
*/                                                                                              
/* this routine only called from scan_plc */

static	void checkoutputs (unsigned short line)
    {
	OUTQENT *optr;
	unsigned short  regaddr,regval,link,adapter,card,coiladdr,conv,stat;
	unsigned long   coilmask,coilval;
	QEIRTU  *pmod;
	double 		dblaovalue;

	while ((optr=ogetnextp(line)) != NULLP)
	{
	    if ((optr->otype)==AOUTTYPE)
	    {
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;

		pmod = plcs[link][adapter];
		if (pmod == NULL)
		{
			if (!allocate_plc(link, adapter))
				return; /* if not allocated, try. if can't allocate, get out. */
			pmod = plcs[link][adapter];
		}

		card = optr->out.aonode.card;
		regaddr = optr->out.aonode.aosignal;
		regval = optr->out.aonode.aovalue;
		dblaovalue = optr->out.aonode.dblaovalue;
		conv = optr->out.aonode.conversion;

		if (mltrace[line] == 3) 
			logMsg ( "Analog Output to line %d, address %d, card %d,  signal  - %d\n",
				link, adapter, card, regaddr );

		if ((!pmod->cmd_force_offline) && (resresponse[link]))
		{
                    loopoutmsgs [line]++;
		    if (!(qeiaocmd(link,adapter,card, pmod,regaddr,regval,dblaovalue,conv )))
		    {
		        pmod->badoutcnt++;		    
		    }
		}
	    }
	    else if ((optr->otype)==BOUTTYPE)
	    {
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;

		pmod = plcs[link][adapter];
		if (pmod == NULL)
		{
			if (!allocate_plc(link, adapter))
				return; /* if not allocated, try. if can't allocate, get out. */
			pmod = plcs[link][adapter];
		}

		card = optr->out.bonode.card;
		coiladdr = optr->out.bonode.bosignal;
		coilval = optr->out.bonode.bovalue;
		coilmask = optr->out.bonode.bomask;

		if (mltrace[line] == 3) 
			logMsg ( "Binary Output to line %d, address %d, card %d, signal  - %d\n",
				link, adapter,card, coiladdr );

		if ((!pmod->cmd_force_offline) && (resresponse[link]))
		{
                    loopoutmsgs [line]++;
		    if (card == POLLCONTROL) {
			switch (coiladdr) {
			    case 30: /* Accumulator Reset */
				stat = resetacc(link, adapter, pmod);
				pmod->accreset = FALSE;
				break;
			    case 31: /* Accumulator Freeze */
				stat = freezeacc(link, adapter, pmod);
				pmod->accfreeze = FALSE;
				break;
			    case 32: /* Accumulator Transfer and Freeze */
				stat = transferresetacc(link, adapter, pmod);
				pmod->xferreset = FALSE;
				break;
			}
			if (!stat)
			    pmod->badoutcnt++;
		    } else {
		        if (!(qeibocmd (link,adapter,card,pmod,coiladdr,coilmask,coilval)))
		        {
			    pmod->badoutcnt++;
		        }
		    }
		}
	    }
	    oreleasefull(line);     /* release the output que entry */
	}
    }
/*                                                                                    	
/*      AIDRIVER                                                                        
/*                                                                              	
/*      This routines main purpose is to return the analog input value for the         	
/*      specified module. For a module value                                           	
/*      a (-1) will be returned if there is no valid data ready.                       	
/*                                                                                     	
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname)
    {
	QEIRTU  *pmod;
	unsigned short  blkix;
	unsigned short	*pdata;

	if (link > QEILINES)
		return (-1);
	if (adapter > NUMQEIRTUS)
		return (-1);
	if ((card != QEIAIS) && (card != QEIACCS) && 
	    (card != PSEUDO) && (card != POLLCONTROL) )
		return (-1);
	if (conversion != conversion)
		return (-1); /* No warnings */

	if ((card == QEIAIS) && (signal > MAXAI))
		return (-1);
	if ((card == QEIACCS) && (signal > MAXACC))
		return (-1);

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
		pmod = plcs[link][adapter];
	}

	pmod->was_requested = TRUE;


	if (card == PSEUDO)
	{

	    switch (signal)
	    {
	    case 0: /* Were the RTU values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the RTU responding */
		*pvalue = pmod->is_responding;
		break;

	    case 5: /* Output Messages */
		*pvalue = pmod->no_dataout_msgs & 0x7fff;
		break;

	    case 6: /* Input Messages */
		*pvalue = pmod->no_datain_msgs & 0x7fff;
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = pmod->no_rxnoresp & 0x7fff;
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = pmod->no_txnoresp & 0x7fff;
		break;

	    case 9: /* Data Echo Errors */
		*pvalue = pmod->no_dataerr & 0x7fff;
		break;

	    case 10: /* Message Retries */
		*pvalue = pmod->no_retries & 0x7fff;
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = pmod->no_rxhwerrs & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = pmod->no_txhwerrs & 0x7fff;
		break;

	    case 13: /* CRC errors */
		*pvalue = pmod->no_crcerrs & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*pvalue = pmod->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the RTU offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = pmod->badoutcnt & 0x7fff;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (card == POLLCONTROL) {

	    if (signal < 10) {
		*pvalue = pollcntrl[link].lastscanned[signal];
		return(0);
	    }
	    if (signal < 20) {
		*pvalue = pollcntrl[link].lastscannedstat[signal-10];
		return(0);
	    }
	    if (signal < 30) {
		*pvalue = pollcntrl[link].pollreason[signal-20];
		return(0);
	    }

	    switch (signal)
	    {

	    case 60: /* Number of polls since last normal poll */
		*pvalue = pollcntrl[link].nosincenormal & 0x7fff;
		break;

	    case 61: /* Number of polls since last fast poll */
		*pvalue = pollcntrl[link].nosincefast & 0x7fff;
		break;

	    case 62: /* Number of polls since last offline poll */
		*pvalue = pollcntrl[link].nosinceoffline & 0x7fff;
		break;

	    case 63: /* Number of polls between offline poll */
		*pvalue = pollcntrl[link].noperoffline;
		break;

	    case 64: /* Number of polls between fast poll */
		*pvalue = pollcntrl[link].noperfast;
		break;

	    case 67: /* Number of polls between polling this unit */
		*pvalue = pmod->scan_freq & 0x7fff;
		break;

	    case 69: /* Number of polls since polling this unit */
		*pvalue = (pollcntrl[link].scan_number - pmod->last_scan_no) & 0x7fff;
		break;

	    case 70: /* Number of minutes between acc poll */
		*pvalue = pollcntrl[link].minsperacc;
		break;

	    case 71: /* Number of minutes between poll for all data*/
		*pvalue = pollcntrl[link].minsperall;
		break;

	    case 72: /* Number of minutes till acc scan */
		*pvalue = pollcntrl[link].minstillacc;
		break;

	    case 73: /* Number of minutes till poll for all data */
		*pvalue = pollcntrl[link].minstillall;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname,pointname);
	}

	if (card == QEIAIS)
	{
	    pmod->ais [signal].was_requested = TRUE;
	    if (!resresponse[link])
	    	return (-1);
	    if (pmod->holdflag)
	    	return (-2);
	    if (!pmod->is_responding)
	    	return (-1);
	    if (!pmod->ais [signal].data_valid)
	    {
		return (-1);
	    }
	    pdata = ((unsigned short*) &(pmod->ais [signal].last_read) );
	}

	if (card == QEIACCS)
	{
	    pmod->accs [signal].was_requested = TRUE;
	    if (!resresponse[link])
	    	return (-1);
	    if (pmod->holdflag)
	    	return (-2);
	    if (!pmod->is_responding)
	    	return (-1);
	    if (!pmod->accs [signal].data_valid)
	    {
		return (-1);
	    }
	    pdata = ((unsigned short*) &(pmod->accs [signal].last_read) );
	}

	/* NOTE !! MULTIPLE PRECISION VALUES MUST RESIDE IN A SINGLE BLOCK */

	/* Select the Size and Type of Response based on Conversion */
	switch (conversion)
	{
	    case(AICNVDOUBLEINT):
		pvalue[0] = pdata[1];
		pvalue[1] = pdata[0];
		break;
	    case(AICNVFLOAT):
		pvalue[0] = pdata[1];
		pvalue[1] = pdata[0];
		break;
	    case(AICNVDOUBLEFLT):
		pvalue[0] = pdata[3];
		pvalue[1] = pdata[2];
		pvalue[2] = pdata[1];
		pvalue[3] = pdata[0];
		break;
	    case(AICNVINTEGER):
	    default:
		*pvalue = *pdata;
		break;

 	}
	return(0);

    }

/*  										
/*      AODRIVER                                                                
/*                                                                            	
/*      This routines main purpose is to set requested analog outputs to the  	
/*      specified module.                                                     	
*/                                                                            	
/* this routine not called from within this driver */


int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	    unsigned short signal,double dvalue, unsigned short value,
	    unsigned short conversion, unsigned char *resname)

    {
	QEIRTU  *pmod;
	OUTQENT *oqp;

	if (link > QEILINES)
		return (-1);
	if (adapter > NUMQEIRTUS)
		return (-1);
	if ((card != QEIAOS) && (card != PSEUDO) &&
	    (card != POLLCONTROL) )
		return -1;

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
		pmod = plcs[link][adapter];
	}


	if (card == POLLCONTROL) {

	    switch (signal)
	    {

	    case 63: /* Number of polls between offline poll */
		pollcntrl[link].noperoffline = value;
		break;

	    case 64: /* Number of polls between fast poll */
		pollcntrl[link].noperfast = value;
		break;

	    case 67: /* Number of polls between polling this unit */
		pmod->scan_freq = value;
		break;

	    case 70: /* Number of minutes between acc poll */
		pollcntrl[link].minsperacc = value;
		break;

	    case 71: /* Number of minutes between poll for all data*/
		pollcntrl[link].minsperall = value;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (card == PSEUDO)
	{
	    if (!resresponse[link])
	    	return (-1);
	    switch (signal)
	    {

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
			initstats(pmod);
		break;

	    case 16: /* Force the RTU online/offline */
		pmod->cmd_force_offline = (value != 0);
		pmod->is_responding = (value != 0);
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname,pointname);
	}

	if (signal > MAXAO)
	{
	    return (-1);
	}
	pmod->was_requested = TRUE;

	pmod->setpoints[signal] = value;

	if (!resresponse[link])
		return (-1);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}
	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
	    return (-1);		/* output que is full */
	}
	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;

	oqp->out.aonode.aovalue = value;
	oqp->out.aonode.dblaovalue = dvalue;
	oqp->out.aonode.conversion = conversion;

	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
    }
/*                                                                             
/*      AOREAD                                                                  
/*                                                                          	
/*      This routines main purpose is to return the value last read back     	
/*      from the analog output hardware. This is used to initialize analog   	
/*      outputs.                                                             	
*/
/* this routine not called from within this driver */


int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	  unsigned short signal, unsigned short *pvalue,
	  unsigned short conv, unsigned char *resname)

    {
	QEIRTU  *pmod;
	unsigned short  *pdata;
	
	if (link > QEILINES)
		return (-1);
	if (adapter > NUMQEIRTUS)
		return (-1);
	if ((card != QEIAOS) && (card != PSEUDO) &&
	    (card != POLLCONTROL) )
		return -1;

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter)) return(-1); /* if not allocated, try.      */
                                                          /* if can't allocate, get out. */
		pmod = plcs[link][adapter];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 15: /* read statistics command value */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Read the current RTU offline command status */
		*pvalue = pmod->cmd_force_offline;
		break;


	    default:
		return(-1);
	    }
	    return (0);
	}

	if (card == POLLCONTROL) {

	    switch (signal)
	    {

	    case 63: /* Number of polls between offline poll */
		*pvalue = pollcntrl[link].noperoffline;
		break;

	    case 64: /* Number of polls between fast poll */
		*pvalue = pollcntrl[link].noperfast;
		break;

	    case 67: /* Number of polls between polling this unit */
		*pvalue = pmod->scan_freq;
		break;

	    case 70: /* Number of minutes between acc poll */
		*pvalue = pollcntrl[link].minsperacc;
		break;

	    case 71: /* Number of minutes between poll for all data*/
		*pvalue = pollcntrl[link].minsperall;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname,pointname);
	}

	if (signal > MAXAO)
	{
	    return (-1);
	}
	pmod->was_requested = TRUE;


	if (!resresponse[link])
		return (-1);

	if (pmod->holdflag)
		return (-2);

	if (!pmod->is_responding)
	{
	    return (-1);
	}

	pdata = &(pmod->setpoints[signal]);

	/* NOTE !! MULTIPLE PRECISION VALUES MUST RESIDE IN A SINGLE BLOCK */

	/* Select the Size and Type of Response based on Conversion */
	switch (conv)
	{
	    case(ASCFLT):
		pvalue[0] = pdata[1];
		pvalue[1] = pdata[0];
		break;
	    default:
		*pvalue = *pdata;
		break;
 	}
	return (0);
    }
/*                                                                                     
/*      BIDRIVER                                                                        
/*                                                                               	
/*      The main purpose of this routine is to return the request digital input  	
/*      value(s) from the requested card. This routine will return a (-1) if the  	
/*      requested module is the wrong type or the data is not yet valid.          	
/*                                                                                	
*/
/* this routine not called from within this driver */



int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask,unsigned long *pvalue,
		unsigned char *resname)

    {
	QEIRTU  *pmod;
	unsigned long tvalue,tmask,set;
	unsigned short blkix;

	if (link > QEILINES)
		return (-1);
	if (adapter > NUMQEIRTUS)
		return (-1);

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
		pmod = plcs[link][adapter];
	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
		    case 0: /* Were the RTU values requested */
			*pvalue = pmod->was_requested;
			break;

		    case 1: /* Is the RTU responding */
			*pvalue = pmod->is_responding;
			break;

		    case 15: /* reset statistics */
			*pvalue = pmod->cmd_reset_stat;
			break;

		    case 16: /* Force the RTU offline */
			*pvalue = pmod->cmd_force_offline;
			break;

		    default:
			return (-1);
	    }
	    return (0);
	}

	if (card == POLLCONTROL) {


	    if ( (signal >=10) && (signal < 20) ) {
		*pvalue = pollcntrl[link].lastscannedstat[signal-10] << (signal % 32);
		return(0);
	    }

	    if ((signal >= 20) && (signal < 30)) {
		*pvalue = (pollcntrl[link].pollreason[signal-20] << (signal % 32));
		return(0);
	    }

	    switch (signal) {

	        case 66: /* This RTU is n fast poll */
		    *pvalue = pmod->fast_poll;
		    break;

	        case 68:     /* This RTU is due for a frequency scan */
		    *pvalue = pmod->poll_due;
		    break;

	        default:
		    return (-1);
	    }
	    return (0);
	}


	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname,pointname);
	}

	blkix = ((signal / 16) & (0xfffe));	/* 16 bits per digital BLOCK */
						/* mask aligned to 32 bits  */
	tvalue = 0;
	if (card == QEIDIS)
	{
	    if (signal > MAXDI)
	    {
		return (-1);
	    }
	    if ( (mask & 0x0000FFFF) != 0)
	    {
	        pmod->dis [blkix].was_requested = TRUE;
		if (!resresponse[link])
			return (-1);
		if (pmod->holdflag)
			return (-2);
		if (!pmod->is_responding)
			return (-1);
		if (!pmod->dis [blkix].data_valid)
		{
		    return (-1);
		}
	        tvalue = pmod->dis [blkix].last_read & mask;
	    }
	    if ( (mask & 0xFFFF0000) != 0)
	    {
	        pmod->dis [blkix+1].was_requested = TRUE;
		if (!resresponse[link])
			return (-1);
		if (pmod->holdflag)
			return (-2);
		if (!pmod->is_responding)
			return (-1);
		if (!pmod->dis [blkix+1].data_valid)
		{
		    return (-1);
		}
	        tvalue += ((unsigned long)(pmod->dis [blkix+1].last_read)) << 16;
	    }
	    *pvalue = tvalue & mask;
	    return (0);
	}
	return (-1);
    }
/*                                                                                	
/*      BODRIVER                                                                        
/*                                                                                 	
/*      The main purpose of this routine is to set the request digital output      	
/*      value(s) on the requested card. This routine will return a (-1) if the     	
/*      requested module is the wrong type or not configured yet.                  	
/*                                                                                 	
*/
/* this routine not called from within this driver */


int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long value, unsigned long mask,
		unsigned char *resname)


    {
	QEIRTU  *pmod;
	OUTQENT *oqp;
	unsigned long tmask;
	unsigned short special;

	if (link > QEILINES)
		return (-1);
	if (adapter > NUMQEIRTUS)
		return (-1);
	if ((card != QEIDOS) && (card != PSEUDO) &&
	    (card != POLLCONTROL) )
		return (-1);

	/* grab and process broadcast pseudo controls */
	if ((card == POLLCONTROL) && (adapter == 0)) {
	    switch (signal) {

		case 30: /* Accumulator Reset */
		    bcastaccreset[link] = (value != 0);
		    break;

		case 31: /* Accumulator Freeze */
		    bcastaccfreeze[link] = (value != 0);
		    break;

		case 32: /* Accumulator Transfer and Freeze */
		    bcastxferreset[link] = (value != 0);
		    break;
	    }
	    return(0);
	}

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
		pmod = plcs[link][adapter];
	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{
	    if (!resresponse[link])
	    	return (-1);
	    switch (signal & 0x1f) {

		case 15: /* Reset the accumulated statistics */
		    if (value != 0) initstats(pmod);
		    break;

		case 16: /* Force the RTU offline */
		    pmod->cmd_force_offline = (value != 0);
		    pmod->is_responding = (value != 0);
		    break;

		default:
		    return (-1);
	    }
	    return (0);
	}

	if (card == POLLCONTROL) {
	
	    special = FALSE;

	    switch (signal) {

		case 30: /* Accumulator Reset */
		    special = TRUE;
		    pmod->accreset = (value != 0);
		    break;

		case 31: /* Accumulator Freeze */
		    special = TRUE;
		    pmod->accfreeze = (value != 0);
		    break;

		case 32: /* Accumulator Transfer and Freeze */
		    special = TRUE;
		    pmod->xferreset = (value != 0);
		    break;

		case 65: /*Poll  This RTU now */
		    pmod->forcescan = (value != 0);
		    pmod->poll_all_due = TRUE;
		    break;

	    	case 66: /* put This RTU o n fast poll */
		    pmod->fast_poll = (value != 0);
		    break;

		default:
		    return (-1);
	    }
	    if (!special)
		return (0);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname,pointname);
	}

	if (!special) {
	    if (signal > MAXDO)
	    {
	        return (-1);
	    }
	    if (!resresponse[link])
		return (-1);

	}

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
	    return (-1);		/* output que is full */
	}
	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bovalue = value;

	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
    }
/*                                                                             
/*      BOREAD                                                                  
/*                                                                           	
/*      This routines main purpose is to return the value last read back      	
/*      from the digital output hardware. This is used to initialize digital  	
/*      outputs. This will return a (-1) if the module is the wrong type or    	
/*      the data is not yet valid                                              	
*/
/* this routine not called from within this driver */


int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)

    {
	QEIRTU  *pmod;
	unsigned long	tvalue;

	if (link > QEILINES)
		return (-1);
	if (adapter > NUMQEIRTUS)
		return (-1);
	if ((card != QEIDOS) && (card != PSEUDO) &&
	    (card != POLLCONTROL) )
		return (-1);

	/* grab and process broadcasts */
	if ((card == POLLCONTROL) && (adapter == 0)) {
	    *pvalue = 0;
	    return(0);
	}

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
		pmod = plcs[link][adapter];
	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{
	    switch (signal) {

		case 15: /* reset statistics */
		    *pvalue = pmod->cmd_reset_stat;
		    break;

		case 16: /* Force the RTU offline */
		    *pvalue = pmod->cmd_force_offline;
		    break;

		default:
		    return (-1);
	    }
	    return (0);
	}

	if (card == POLLCONTROL) {
	    switch (signal) {

		case 65: /*Poll  This RTU now */
		    *pvalue = pmod->forcescan;
		    break;

	    	case 66: /* This RTU on fast poll */
		    *pvalue = pmod->fast_poll;
		    break;

		default:
		    return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{
	    register_resource(link,pmod,resname,pointname);
	}

	if ((signal) > MAXDO)
	{
	    return (-1);
	}

	if (!resresponse[link])
	    return (-1);
	if (pmod->holdflag)
	    return (-2);
	if (!pmod->is_responding)
	    return (-1);
	*pvalue = pmod->dos[signal];

	return (0);
    }
/*                                                                              
/*      SIDRIVER                                                                
/*                                                                              
/*      The main purpose of this routine is to get the requested string         
/*      from the data buffered from  the qei station name.                      
/*	 This routine will return a (-1) if the                                 
/*      requested module is the wrong type or not configured yet.               
/*                                                                              
*/
int SIDRIVER (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned char *value, unsigned short len,
		unsigned char *resname)


    {
	QEIRTU  *pmod;

	if (link > QEILINES)
		return (-1);
	if (card != POLLCONTROL)
		return (-1);
	if (adapter != 0)
	    return(-1);
	if (signal > 10)
	    return(-1);

	strcpy(value,pollcntrl[link].id[signal].station);

	return(0);
    }



/*
/* register_resource                                                              	
/*                                                                                	
/*	This routine is used to initialize the resource pointers                  	
/*  If this is the first time the resource for this line is being                  	
/*  referenced the pointer to the resource table entry will be set                  	
/*  and the resource name will be saved. If the resouce name has                    	
/*  already been set, this routine will verify that all other points                 	
/*  for this driver are using the same resource name.                                	
/*                                                                                   	
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BOREAD,				
			    BIDRIVER, and BODRIVER */                               	

static void  register_resource(unsigned short link,QEIRTU *pmod,unsigned char *resname, char *pointname)
    {

	unsigned short	i,j,gotfirst;

	if (resnames[link][0] == 0) /* This is the first reference */
	{
	    if (resGetByName( resname,&prestable[link]) != RES_OK)
	    {
		logMsg ( "Resource not found in table - %s \n",
				resname );
	    }
	    else strcpy(resnames[link],resname);
	}
	else
	{
	    if (strcmp(resnames[link],resname) != 0)
	    {
		logMsg ("Resource name conflict - %s,  %s point = %s\n",
				resnames[link],
				resname,
				pointname );
	    }
	}
	if (pmod->stationname[0] == 0) {
	    /* copy in station name from point name (from underscore to underscore) */
	    i = j = 0;
	    gotfirst = FALSE;
	    while ((pointname[i] != 0) && (i<28) && (j<7)) {
		if (pointname[i] == '_') {
		    if (gotfirst) {
			pmod->stationname[j] = 0;
			return;
		    } else {
			gotfirst = TRUE;
			i++;
		    }
		} else {
		    if (gotfirst) {
			pmod->stationname[j++] = pointname[i++];
		    } else {
			i++;
		    }
		}
	    }
	    pmod->stationname[j] = 0;
	}

		
    }
/*                                                                  		
/*      Initialize the Queue                                        		
*/                                                                        	
/* not called from within this driver */

static	void outqueinit (unsigned short line)
    {
	oq[line]->ooutix = oq[line]->oinix = 0;
    }


/*                                                                     		
/*  ogetempty - get the next available slot on the output list         		
*/
/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
    {
	if (((oq[line]->oinix + 1) % OUTQSIZE) != oq[line]->ooutix)
	{
	    return (&oq[line]->outque[oq[line]->oinix]);
	}
	if (mltrace[line] == 1) 
		logMsg ( "Output Que Full line - %d\n",line);
	return (NULLP);
    }


/*                                                                    		
/* omarkfull                                                          		
/*      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
	{
	    oq[line]->oinix = ((oq[line]->oinix + 1) % OUTQSIZE);
	}


/*                                                                      	
/*  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
    {
	if (oq[line]->ooutix != oq[line]->oinix)
	{
	    return (&oq[line]->outque[oq[line]->ooutix]);
	}
	else return (NULLP);
    }


/*                                                       	               	
/* oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
    {
	if (oq[line]->ooutix == oq[line]->oinix)
		return;
	oq[line]->ooutix = ((oq[line]->ooutix + 1) % OUTQSIZE);
    }

/*                                                                             	
/*                                                                              
/*	allocate_plc                                                            
/*                                                                              
/*	The purpose of this routine is to allocate the memory for a single      
/*	plc data structure. If not successful, a console error message is  	
/*	printed and an error flag is returned to the caller.                    
/*	If successful, the newly allocated data structures are initialized.     
/*                                                                             	
*/

static int allocate_plc (unsigned short line, unsigned short plc )
   {
	QEIRTU  *pmod;


	pmod = (QEIRTU *)calloc(1,(sizeof(QEIRTU)));
	if (!pmod)
	{
		logMsg ("Unable to allocate memory for QEIRTU data structure for plc %d\n" ,plc);
		 return(FALSE);
	}
	else
	{
		logMsg ("Allocated memory for QEIRTU data structure for plc %d\n" ,plc);
		init_plc_tab(line, pmod);	     /*	initialize the data structures. */
	}
	plcs[line][plc] = pmod;
	return(TRUE);
   }
/*                                                                   		
/*      start_rx                                                        	
/*                                                                     	 	
/*      The purpose of this routine is to initialize a line table        	
/*      for receive and to enable the receiver.                           	
/*                                                                        	
*/
/* only called from msgxfer */


static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

    {
	RXLINE                  *rxp;

	rxp=rxlinetab[line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	rxp->rxstate = RXBLKCNT;

    }



/*                                                                           	
/*      stop_rx                                                              	
/*                                                                           	
/*      The purpose of this routine is to initialize a line table            	
/*      for receive and to disable the receiver.                             	
/*                                                                           	
*/
/* only called from msgxfer */


static	void stop_rx (unsigned short line )

    {
	RXLINE                  *rxp;

	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
    }

/*                                                                        	
/*      rx_int_proc                                                        	
/*                                                                         	
/*      The purpose of this routine is to process a receive character interrupt	
/*      for a given line.                                                     	
*/
/* referenced in system call in MAIN */

static	void rx_int_proc (unsigned short line )
    {
	unsigned char   rxchar;
	unsigned short  rxstat;
	unsigned short  rx_err_mask;
	RXLINE          *rxp;

	read_rx_hw(line,&rxchar,&rxstat,&rx_err_mask);

        linestats [line].RXintcount++;

	rxp=rxlinetab[line];

	/* Something is sending in data */
        activity_tick[line] = tickGet();
        recent_activity[line] = TRUE;

	if (rxp->rxstate==RXIGNORE)
		return;

	if ((rxstat & rx_err_mask) != 0)
	{
	    if (rxp->rxix == 0)
	    	return;
	    *(rxp->status) = RXBAD;
	    rxp->rxstate=RXIGNORE;
	    rxp->rxbuf[100]=rxstat;
	    rxp->rxbuf[101]=rxchar;
	    return;
	}

	rxp->rxbuf[rxp->rxix++] = rxchar;


	switch (rxp->rxstate)
	{
	    case RXBLKCNT:
		if ((rxchar & 0x7f) == 0)
		{
		    *(rxp->status) = RXGOOD;
		    rxp->rxstate=RXIGNORE;
		    semGive(rxp->semid);
		    return;
		}
		rxp->rxstate = RXDATA;
		rxp->rxmsglen = ((rxchar & 0x7f) * 4);
		return;

	    case RXDATA:
	    default:  /* Data State */
		rxp->rxmsglen--;
		if (rxp->rxmsglen == 0)
		{
		    *(rxp->status) = RXGOOD;
		    rxp->rxstate=RXIGNORE;
		    semGive(rxp->semid);
		    return;
		}
	}
	return;
    }


/*                                                                           	
/*      check_line_activity                                                     
/*                                                                             	
/*      The purpose of this routine is to process a receive character interrupt	
/*      for a given line.                                                      	
/*                                                                             	
*/
/* only called from MAIN  */


static	int check_line_activity (unsigned short line, unsigned short predelay )
{
    unsigned long  thistime;
    short          status;


    if (predelay != 0)
	taskDelay(predelay);

    thistime = tickGet();
    if ((thistime - activity_tick[line]) < ACTIVITYTIME)
    {
        recent_activity[line] = TRUE;
        return (TRUE);
    }
    return (FALSE);
}
/*                                                                             
/*      start_tx                                                            	
/*                                                                          	
/*      The purpose of this routine is to initialize a line table           	
/*      for send and to enable the transmitter.                              	
/*                                                                            	
*/
/* only called from msgxfer  */


static	void start_tx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

    {

	TXLINE                  *txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */


	enable_tx_ints(line);

    }


/*                                                                              
/*      stop_tx                                                                	
/*                                                                             	
/*      The purpose of this routine is to initialize a line table              	
/*      for receive and to disable the receiver.                               	
/*                                                                             	
*/
/* only called from msgxfer  */


static	void stop_tx (unsigned short line )

    {
	TXLINE			*txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txdisable=TRUE;
    }

/*                                                                           	
/*      tx_int_proc                                                           	
/*                                                                            	
/*      The purpose of this routine is to process a transmit character interrupt
/*      for a given line.                                                  	
/*                                                                         	
*/
/* only called from MAIN  */


static	void tx_int_proc (unsigned short line )

    {
	char                    txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

        linestats [line].TXintcount++;

	txp=txlinetab[line];
	if (txp->txdisable)
		return;
	if (txp->txix == txp->txmsglen)
	{
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive(txp->semid);
	    return;
	}
	else
	{
	    txchar = txp->txbuf[txp->txix++];
	    write_tx_hw ( line,txchar,&txstat,&tx_err_mask );
	    if ( (txstat & tx_err_mask) != 0 )
	    {
	 	txp->txdisable=TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive(txp->semid);
	        return;
	    }

	}

	if (txp->txix >= MAXTXMSG)
	{
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive(txp->semid);
	    return;
	}

    }

/*                                                                         	
/*      msgxfer                                                              	
/*                                                                           	
/*      The purpose of this routine is to transmit a buffer to the         	
/*      analog devices I/O and to await a response. The transmit and receive	
/*      buffers are in their respective line tables. This routine will retry 	
/*      the message up to a maximum number of times or until a response      	
/*      is received with a proper checksum.                                  	
/*              returns         XFERGOOD if response received                	
/*                              XFERBAD  if no good response is received     	
/*                                                                           	
*/


static	unsigned short  msgxfer (unsigned short fline, unsigned short resplen,
                                 QEIRTU *pmod, unsigned short rxlength)
{
    unsigned short  retry, txstatus, rxstatus, txlen, rxlen, line, ix, i, charsin;
    unsigned short  rtuadr, ttccode, opcode, point;
    unsigned short  resrtuadr, resttccode, resopcode, respoint;
    unsigned long   msgword, responseword;

    RXLINE          *rxp;
    TXLINE          *txp;
    unsigned char   csums[2];

    unsigned int    tick1, tick2, tick3, tick4;
    unsigned int    delta40, delta01, delta12, delta23, delta34;
    unsigned long   msgstart;


    msgstart = tickGet();

    line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

    delta40 = delta01 = delta12 = delta23 = delta34 = 0;

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    msgword =  (unsigned long) txp->txbuf[0] +
              ((unsigned long) txp->txbuf[1] << 8) +
              ((unsigned long) txp->txbuf[2] << 16) +
              ((unsigned long) txp->txbuf[3] << 24);
    ttccode = msgword & 0x0f;
    rtuadr  = ((msgword >> 4) & 0x7f) + ((msgword >> (24-7)) & 0x80);
    opcode  = (msgword >> 11) & 0x3f;
    point   = (msgword >> 17) & 0x7f;

    for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++)
    {
        linestats [line].msgxfercount++;
        loopmsgs [line]++;

        /* time since end of last msgxfer */
        tick [line] [0] = tickGet ();
        delta40 = (tick [line] [0] - tick [line] [4]);

	if (intermsgdelay[line] != 0) {
	    taskDelay (intermsgdelay[line]);
	}

	set_rts(line);

	if (pretxdelay[line] != 0) {
	    taskDelay (pretxdelay[line]);
	}

	txstatus = IO_TIMEOUT;
	rxp->fixedlen = resplen;
	rxp->rxmsglen = rxlength;
	rxstatus = IO_TIMEOUT;
	semTake(semids[line][TXSEM], NO_WAIT);
	semTake(semids[line][RXSEM], NO_WAIT);

        txlen = txp->txmsglen;

        /*********************************/
        tisWatchDogPulse(watchdogId[line]);
        /*********************************/

        if ((trace [line] & ALLTRAFFICTRACE) &&
            ((traceadr [line] == rtuadr) || (traceadr [line] == 255)) &&
            ((tracecmd [line] == ttccode) || (tracecmd [line] == 255)) &&
            ((tracetype [line] == opcode) || (tracetype [line] == 255)))
        {
           printf ("TX>>  ADR:[%2d],   TTC:[%2d] %s,   OPCODE:[%2d] %s,   POINT:[%2d] \n",
                   rtuadr, ttccode, ttcnames[ttccode], opcode, opcodenames[opcode], point);

           printf ("TX:");


           for (ix = 0; ix < 20 ; ix++) /* 20 is maximum TX message length */
           {
                if (ix < txlen)
                {
                   printf("_%2x", txp->txbuf [ix]);
                }
                else
                {
                   printf ("...");
                }
           } 
           printf ("\n");
        }

        /* time from entering msgxfer to starting transmission. (including delays & diags) */
        tick [line] [1] = tickGet ();
        delta01 = (tick [line] [1] - tick [line] [0]);

	start_rx(line, semids[line][RXSEM], &rxstatus);
	start_tx(line, semids[line][TXSEM], &txstatus); /* this fires off the transmission. */

	if ((semTake(semids[line][TXSEM], TXTIMEOUT)) == ERROR)
	    txstatus = IO_TIMEOUT;

        /*********************************/
        tisWatchDogPulse(watchdogId[line]);
        /*********************************/

        /* time to transmit message. */
        tick [line] [2] = tickGet ();
        delta12 = (tick [line] [2] - tick [line] [1]);

	stop_tx(line);

	if (posttxdelay[line] != 0) {
	    taskDelay (posttxdelay[line]);
	}

        if (halfduplex [line] == TRUE)
        {
            clear_rts (line);
        }

        /* intermessage wait time. */
        tick [line] [3] = tickGet ();
        delta23 = (tick [line] [3] - tick [line] [2]);

	if (txstatus == TXGOOD) {

	    if (qeisim[line]) {
		taskDelay(60);
                /*********************************/
                tisWatchDogPulse(watchdogId[line]);
                /*********************************/

		return (msgsim (fline,resplen, pmod, rxlength));
	    }

	    charsin = 0;
	    while (TRUE) {
		if ((semTake(semids[line][RXSEM], rxtimeout)) == ERROR) {
		    rxstatus = IO_TIMEOUT;
		    if (rxp->rxix == charsin) {
			break;
		    } else {
			charsin = rxp->rxix;
		    }
		} else {
		    break;
		}
	    }

            /*********************************/
            tisWatchDogPulse(watchdogId[line]);
            /*********************************/

	    stop_rx(line);

            /* time to receive message. */
            tick [line] [4] = tickGet();
            delta34 = (tick [line] [4] - tick [line] [3]);

	    rxlen = rxp->rxix;

	    if ((rxp->rxbuf [0] == 0) && (rxlen == 1))
	    {
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == rtuadr) || (traceadr [line] == 255)) &&
                    ((tracecmd [line] == ttccode) || (tracecmd [line] == 255)) &&
                    ((tracetype [line] == opcode) || (tracetype [line] == 255)))
                {

                    printf ("RX>> Zero Byte Reply Received From CIU. Nothing to report for this RTU.\n");

                    printf("RX:");
                    for (ix = 0; ix < 26; ix++) /* 26 is maximum RX message length */
                    {
                        if (ix < rxlen)
                        {
                            printf("_%2x", rxp->rxbuf [ix]);
                        }
                        else
                        {
                            printf("...");
                        }
                    } 
                    printf("\n");
                    printf("DELTA: %3d %3d %3d %3d %3d\n\n", delta40, delta01, delta12, delta23, delta34);
                }
		if (modtrace[line])
		    logMsg ("Zero Length Response\n");
	    	pmod->no_zeroresponses++;
                continue;
/*		return (XFERGOODCIU); */
	    }
	    if (rxstatus == RXGOOD)
            {
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == rtuadr) || (traceadr [line] == 255)) &&
                    ((tracecmd [line] == ttccode) || (tracecmd [line] == 255)) &&
                    ((tracetype [line] == opcode) || (tracetype [line] == 255)))
                {
                    responseword =  (unsigned long) rxp->rxbuf[1] +
                                   ((unsigned long) rxp->rxbuf[2] << 8) +
                                   ((unsigned long) rxp->rxbuf[3] << 16) +
                                   ((unsigned long) rxp->rxbuf[4] << 24);
                    resttccode =   responseword & 0x0f;
                    resrtuadr  = ((responseword >> 4) & 0x7f) + ((responseword >> (24-7)) & 0x80);
                    resopcode  =  (responseword >> 11) & 0x3f;
                    respoint   =  (responseword >> 17) & 0x7f;

                    /******************************************************************/
                    /******************************************************************/
                    /******************************************************************/

                    checkdata(line, pmod, rtuadr, opcode, point, rxp);

                    /******************************************************************/
                    /******************************************************************/
                    /******************************************************************/

                    printf("RX:");
                    for (ix = 0; ix < 26; ix++) /* 26 is maximum RX message length */
                    {
                        if (ix < rxlen)
                        {
                            printf("_%2x", rxp->rxbuf [ix]);
                        }
                        else
                        {
                            printf("...");
                        }
                    } 
                    printf("\n");
                    printf("DELTA: %3d %3d %3d %3d %3d\n\n", delta40, delta01, delta12, delta23, delta34);
                }


		if (rxlen != ((rxp->rxbuf[0] * 4) + 1) ) {
		    if (modtrace[line])
			logMsg("Invlalid rxlen... %d\n", rxlen);
		} else {
                    pmod->msgs++;
                    pmod->responsetime += (tickGet() - msgstart);
                    return (XFERGOOD);
		}
	    } else { 
		if (rxstatus == IO_TIMEOUT) {
		    if (modtrace[line])
			logMsg ("Receive Timeout... Length: %d\n", rxlen);
		    pmod->no_rxnoresp++;

                    if ((trace [line] & ALLTRAFFICTRACE) &&
                        ((traceadr [line] == rtuadr) || (traceadr [line] == 255)) &&
                        ((tracecmd [line] == ttccode) || (tracecmd [line] == 255)) &&
                        ((tracetype [line] == opcode) || (tracetype [line] == 255)))
                    {
                        printf("DELTA: %3d %3d %3d %3d %3d\n\n", delta40, delta01, delta12, delta23, delta34);
                    }

	        } else {
		    if (modtrace[line])
		        logMsg ("Receive Error\n");

		    if (modtrace[line])
		        logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
					rxp->rxbuf[100],
					rxp->rxbuf[101],
					rxp->rxix);
		    pmod->no_rxhwerrs++;
		}
	    }
	} else {
	    if (txstatus == IO_TIMEOUT) {
		if (modtrace[line])
		    logMsg ("Transmit Timeout\n");

                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == rtuadr) || (traceadr [line] == 255)) &&
                    ((tracecmd [line] == ttccode) || (tracecmd [line] == 255)) &&
                    ((tracetype [line] == opcode) || (tracetype [line] == 255)))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d\n\n", delta40, delta01, delta12, delta23, delta34);
                }
	    	pmod->no_txnoresp++;
	    } else {
	        if (modtrace[line])
		    logMsg ("Transmit Error\n");
	        pmod->no_txhwerrs++;
	    }
	}
    }
    if (modtrace[line])
	logMsg ("Xfer Bad\n");
    return (XFERBAD);

}

/*                                                                           
/*      init_plc_tab                                                          
/*                                                                            
/*      The purpose of this routine is to initialize the line tables for the  
/*      analog devices I/O                                                    
/*                                                                            
*/
/* only called from allocate_plc  */


static	void init_plc_tab (unsigned short line, QEIRTU  *pmod)

    {
	if (!pmod)
		return;

	pmod->was_requested = FALSE;
	pmod->is_responding = FALSE;
	pmod->holdflag = FALSE;
	pmod->cmd_force_offline = FALSE;

	/* Accumulator Controls */
	pmod->accreset = FALSE;
	pmod->accfreeze = FALSE;
	pmod->xferreset = FALSE;

	/* Poll Control Flags */
	pmod->forcescan = FALSE;
	pmod->fast_poll = FALSE;
	pmod->scan_freq = 0;
	pmod->last_scan_no = 0;
	pmod->poll_due = FALSE;
	pmod->poll_all_due = FALSE;
	pmod->poll_acc_due = FALSE;
	pmod->stationname[0] = 0;

	initplc(pmod);
	initstats(pmod);

	linetimers[line] = gettimer();
	if (linetimers[line] == -1)
	{

		/*  put an error message in here */

	}

	/* Initialize this tasks semaphore*/
	semids[line][0]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
	semids[line][1]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
    }



/*
/* Cold Init a RTU
/*
*/
/* only called from init_line_tabs  */


static void initplc (QEIRTU  *pmod)

    {

	unsigned short i,j;

	/* Initialize the Dis */
	for (i=0;(i<MAXDIBLK);i++) {
	    pmod->dis[i].was_requested = FALSE;
	    pmod->dis[i].data_valid = FALSE;
	    pmod->dis[i].last_read = 0;
	}
	/* Initialize the Ais */
	for (i=0;(i<MAXAI);i++) {
	    pmod->ais[i].was_requested = FALSE;
	    pmod->ais[i].data_valid = FALSE;
	    pmod->ais[i].last_read = 0;
	}
	/* Initialize the Accs */
	for (i=0;(i<MAXACC);i++) {
	    pmod->accs[i].was_requested = FALSE;
	    pmod->accs[i].data_valid = FALSE;
	    pmod->accs[i].last_read = 0;
	}
    }

/*                                                             
/*                                                              
/* initialize the statistics for a modicon RTU                  
/*                                                              
*/
/* called from AODRIVER, BODRIVER, and init_line_tabs  */


static	void initstats (QEIRTU *pmod)

    {
	pmod->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
	pmod->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
	pmod->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
	pmod->no_txnoresp = 0;      /* 8  Count No Responses 		*/
	pmod->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
	pmod->no_retries = 0;       /* 10 Count Retries 		*/
	pmod->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
	pmod->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
	pmod->no_crcerrs = 0;       /* 13 Count CRC Errors 		*/
	pmod->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
	pmod->badoutcnt = 0;	    /* 17 Count failed output commands 	*/
	pmod->no_zeroresponses = 0; /*    Count Zero Byte Message Responses */

        pmod->tscanpass = 0;        /* plc scan pass counter            */
        pmod->msgs = 0;             /* good response message counts     */
        pmod->responsetime = 0;     /* total wait time for good messages*/
}
/*                                                                       
/* modloopback
/*                                                                        
*/                                                                          	
/* only called from on_line */


static	unsigned short modloopback (unsigned short line, unsigned short mod, QEIRTU *pmod)
    {
        unsigned long  this_time;

	if (!(pollforall(line, mod, pmod)))
        {
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    pmod->no_rxnoresp++;
	    return(FALSE);
	}
        /* After Sucessful Poll For All, set last pollall time and clear poll_all_due flag.  */
        this_time = tickGet();
 	pollcntrl[line & (~ONERETRY)].lastalltime = this_time;
        pmod->poll_all_due = FALSE;


        return(TRUE);
    }
/*                                                                           	
/*     prepresponses                                                            
/*                                                                             	
/*      The purpose of this routine is to mark the RTUs as on hold and the      
/*	data as not valid until read again from the RTU                       	
/*                                                                           	
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)

    {
	unsigned short  mod;
	QEIRTU  *pmod;

	for (mod = 1; (mod <= NUMQEIRTUS); mod++)
	{
            pmod = plcs[line][mod];
	    if (pmod)				/* verify pointer validity prior to use */
	    {
	    	pmod->holdflag = TRUE;
		mark_not_valid(pmod);
            }
	}
    }



/*                                                                  	
/*      any_responding                                               	
/*                                                                   	
/*      The purpose of this routine is to see if any units are       	
/*	responding on this line                                      	
/*                                                                   	
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)

    {
	unsigned short  mod;
	QEIRTU  *pmod;

	for (mod = 1; (mod <= NUMQEIRTUS); mod++)
	{
	    pmod = plcs[line][mod];
	    if (pmod)			/* verify pointer validity prior to use */
	    {
		if (pmod->is_responding)
			 return(TRUE);
	    }
	}
	return(FALSE);
    }



/*                                                                      
/* pollforall                                                           
/*      poll RTU for all values and save them                           
/*	this is used to bring the RTU online and to periodically        
/*	request a full update from the RTU                              
*/
static int pollforall(unsigned short line, unsigned short mod, QEIRTU *pmod)
    {
	return(msgtortu(line, mod, pmod, POLLALL, 0, TRUE, TRUE));
    }

                                                                        
/*                                                                      
/* pollforacc                                                           
/*      poll RTU for all accumulator values and save them               
/*	this is used to periodically                                    
/*	request a full set of accumulators from the RTU                 
*/
static int pollforacc(unsigned short line,unsigned short mod,QEIRTU *pmod)

    {
	return(msgtortu(line, mod, pmod, POLLACC, 0, TRUE, TRUE));
    }


/*                                                                      
/* resetacc                                                             
/*      reset all accumulator values                                    
/*	this is used to broadcast or to send a command to an individual 
/*	RTU                                                             
*/
static int resetacc(unsigned short line,unsigned short mod,QEIRTU *pmod)
    {
	return(msgtortu(line, mod, pmod, RESETACC, 0, FALSE, FALSE));
    }

/*                                                                      
/* freezeacc                                                            
/*      freeze all accumulator values                                   
/*	this is used to broadcast or to send a command to an individual 
/*	RTU                                                             
*/
static int freezeacc(unsigned short line,unsigned short mod,QEIRTU *pmod)
    {
	return(msgtortu(line, mod, pmod, FREEZEACC, 0, FALSE, FALSE));
    }
/*                                                                      
/* transferresetacc                                                     
/*      transfer and reset all accumulator values                       
/*	this is used to broadcast or to send a command to an individual 
/*	RTU                                                             
*/
static int transferresetacc(unsigned short line,unsigned short mod,QEIRTU *pmod)
    {
	return(msgtortu(line, mod, pmod, XFERRESETACC, 0, FALSE, FALSE));
    }

/*                                                                      
/* msgtortu                                                             
/* 	this routine is used to send a command to the RTU and           
/* 	get and verify the response                                     
*/
static int msgtortu(unsigned short line,unsigned short mod,
		      QEIRTU *pmod, unsigned short opcode,
		      unsigned short point,unsigned short inmsg,
		      unsigned short dataexpected)
    {
	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,j, xferstat;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	if (inmsg)
	{
	    /* Count number of data request messages */

	    pmod->no_datain_msgs++;
	}
	else
	{
	    pmod->no_dataout_msgs++;
	}

	/* Format the output message */

	txp->txbuf [0] = (M2RPRESING + ((mod & 0x0f) << 4));
	txp->txbuf [1] = (((opcode & 0x1f) <<  3) + ((mod >> 4) & 0x07));
	txp->txbuf [2] = (((opcode >> 5) & 0x01) + /* High bit of opcode */
			  ((point & 0x7f) << 1)); /* Point Number */

	/* !@! This may be where addresses greater than 128 are set */

	txp->txbuf [3] = ((mod >> 7) & 0x01); /* Point Number or Address?? */
	txp->txbuf [3] = txp->txbuf [3] + (makebch (txp->txbuf) | STOPBIT);
	txp->txmsglen = SINGLELEN;

	/* Send out the message */

	if ((xferstat = msgxfer ((line + ONERETRY), VARRESP, pmod, 0)) == XFERGOOD)
	{
	    if (savedata (mod, pmod, opcode, point, rxp, dataexpected))
	    {
		return (TRUE);
	    }
	}
	else
        {
            if ((xferstat == XFERGOODCIU) && (pmod->is_responding))
            {
                /* communication was good, but CIU had its own retry problems */
                pmod->no_retries++;
	        return (TRUE);
            }
        }
	/* Communications Failed */
	if (pmod->is_responding)
	{
	    pmod->no_rxnoresp++;
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	}
	return (FALSE);
    }


/*                                                                      
/* pollfordata                                                          
/*      poll RTU for changed values and save them                       
*/
static	unsigned short pollfordata (unsigned short line,
				    unsigned short mod,
			 	    QEIRTU *pmod)

{

	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  opcode;
	unsigned short  i, j, point, xferstat;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	opcode = POLLRESET;
	point = 0;
	txp->txbuf [0] =  (M2RPRESING + ((mod & 0x0f) << 4));
	txp->txbuf [1] =  (((opcode & 0x1f) <<  3) + ((mod >> 4) & 0x07));
	txp->txbuf [2] = (((opcode >> 5) & 0x01) + /* High bit of opcode */
				((point & 0x7f) << 1)); /* Point Number */

	/* !@! This may be where addresses greater than 128 are set */

	txp->txbuf [3] = ((mod >> 7) & 0x01); /* Point Number or Address?? */
	txp->txbuf [3] = txp->txbuf [3] + (makebch (txp->txbuf) | STOPBIT);
	txp->txmsglen = SINGLELEN;

	/* Send out the message */

	for (i = 1; (i < MAXRETRYS); i++)
	{
	    /* This is the loop which requests exception data */

	    if ((xferstat = msgxfer ((line + ONERETRY), VARRESP, pmod, 0)) == XFERGOOD)
	    {
		if (savedata (mod, pmod, opcode, point, rxp, TRUE))
		{
		    return (TRUE);
		}
	    }		
	    else
            {
                if ((xferstat == XFERGOODCIU) && (pmod->is_responding))
                {
                    /* communication was good, but CIU had its own retry problems */
                    pmod->no_retries++;
                    return (TRUE);
                }
            }

	    pmod->no_retries++;
	    opcode = POLLNORESET;
	    txp->txbuf [0] = (M2RPRESING + ((mod & 0x0f) << 4));
	    txp->txbuf [1] = (((opcode & 0x1f) <<  3) + ((mod >> 4) & 0x07));
	    txp->txbuf[2] = (((opcode >> 5) & 0x01) + /* High bit of opcode */
				((point & 0x7f) << 1)); /* Point Number */

	    /* !@! This may be where addresses greater than 128 are set */

	    txp->txbuf [3] = ((mod >> 7) & 0x01); /* Point Number or Address? */
	    txp->txbuf [3] = txp->txbuf[3] + (makebch(txp->txbuf) | STOPBIT);
	    txp->txmsglen = SINGLELEN;
	}

	/* Communications Failed */
        if (pmod->is_responding == TRUE)
        {
	    pmod->no_rxnoresp++;
            pmod->no_offlines++;
            pmod->holdflag = TRUE;
            pmod->is_responding = FALSE;
        }
	return (FALSE);
}

/*                                                                       
/*    savedata(mod,pmod,opcode,point,rxp,dataexpected)                   
/*                                                                       
/*	Verify the response and save the data returned from the RTU      
/*	Process the response from either a Poll for upsets (with or      
/*	without reset, Poll for all data or Poll for Accumulators        
/*                                                                       
*/
unsigned short savedata(unsigned short mod,QEIRTU *pmod,
			unsigned short opcode, unsigned short point, RXLINE  *rxp,
			unsigned short dataexpected)
{
    unsigned short len,msgix,bch,digblk,digval,pointno,value,taddr;
    unsigned long  msgword;


    len = rxp->rxbuf[0];	/* number of words */

    /* check the first message word as an echo of the command */
    msgword = (unsigned long) rxp->rxbuf[1] +
             ((unsigned long) rxp->rxbuf[2] << 8) +
             ((unsigned long) rxp->rxbuf[3] << 16) +
             ((unsigned long) rxp->rxbuf[4] << 24);


    /* Verify bch: do this prior to testing individual field validity */
    bch = makebch(&rxp->rxbuf[1]);
    if (((msgword >> 24) & 0x7e) != bch)
    {
        pmod->no_crcerrs++;
        return (FALSE);
    }

    /* Stop Bit */
    if ((msgword & 0x80000000) == 0)
    {
        pmod->no_dataerr++;
        return (FALSE);
    }

    /* Strt Bit */
    if ((msgword & 1) != 0)
    {
        pmod->no_dataerr++;
        return (FALSE);
    }
    /* Check Transmission Code */
    if ( (((msgword & 0x0e)) != R2MPRESING) &&
         (((msgword & 0x0e)) != R2MPREMORE) )
    {
        pmod->no_dataerr++;
        return (FALSE);
    }
    /* Check Address */
    taddr = ((msgword >> 4) & 0x7f);
    if ((msgword & 0x1000000) != 0)
	taddr += 128;
	if ( taddr != mod)
        {
	    pmod->no_dataerr++;
	    return (FALSE);
        }
	/* Check Opcode */
	if (((msgword >> 11) & 0x3f) != opcode)
        {
	    pmod->no_dataerr++;
	    return (FALSE);
        }
	/* Check point number = 0 */
	if (((msgword >> 17) & 0x7f) != point)
        {
	    pmod->no_dataerr++;
	    return (FALSE);
        }

	/* verify the data portion of the message */

	if (((msgword & 0x0e)) == R2MPRESING) {
	    /* There are no data elements in this message */
	    if (len == 1)
		return (TRUE);
	    else
            {
	        pmod->no_dataerr++;
	        return (FALSE);
            }
	}

	/* if no dtat was expected drop the rest of the message */
	if (!dataexpected)
	    return (TRUE);

	msgix = 5;
	len--;

	while (len) {
	    msgword = rxp->rxbuf[msgix] +
		      ((unsigned long) rxp->rxbuf[msgix+1] << 8) +
		      ((unsigned long) rxp->rxbuf[msgix+2] << 16) +
		      ((unsigned long) rxp->rxbuf[msgix+3] << 24);

	    msgix+=4;

            /* Verify bch: do this prior to testing individual field validity */
	    bch = makebch(&rxp->rxbuf[msgix-4]);
	    if (((msgword >> 24) & 0x7e) != bch)
            {
	        pmod->no_crcerrs++;
	        return (FALSE);
            }

	    /* Stop Bit */
	    if ((msgword & 0x80000000) == 0)
            {
                pmod->no_dataerr++;
                return (FALSE);
            }

	    /* Strt Bit */
	    if ((msgword & 1) != 0)
            {
                pmod->no_dataerr++;
                return (FALSE);
            }
	    /* Check Transmission Code */
	    if ( (((msgword & 0x0e)) != R2MDATAMORE) &&
	         (((msgword & 0x0e)) != R2MDATALAST) )
            {
                pmod->no_dataerr++;
                return (FALSE);
            }

	    /* Extract the point type */
	    if ((msgword & DIGDATAFLAG) == 0) {
		digblk = ((msgword >> 5) & 0x0f);
		digval = ((msgword >> 9) & 0xffff); 
		pmod->dis[digblk].last_read = digval;
		pmod->dis[digblk].data_valid = TRUE;
	    } else {
		if ((msgword & ACCFLAG) == 0) {
		    /* Is an analog input */ 
		    pointno = ((msgword >> 5) & 0x7f);
		    value = ((msgword >> 12) & 0xfff);
		    if ((value & 0x800) != 0) {
			/* sign extend */
			value = value + 0xf000;
		    }
		    pmod->ais[pointno].last_read = value;
		    pmod->ais[pointno].data_valid = TRUE;
		} else {
		    /* Is an accumulator */
		    pointno = ((msgword >> 5) & 0x7);
		    value = ((msgword >> 8) & 0x7fff);
		    pmod->accs[pointno].last_read = value;
		    pmod->accs[pointno].data_valid = TRUE;
		}
	    }
	    len --;
	}

	return (TRUE);

    }






/*                                                                      
/*    checkdata                                                         
/*                                                                      
/*	Check the validity of the response and print diagnostic results.
/*                                                                      
*/
static void checkdata(unsigned short line, QEIRTU *pmod, unsigned short mod,
                      unsigned short opcode, unsigned short point, RXLINE  *rxp)
{
	unsigned short len,msgix,bch,digblk,digval,pointno,value,taddr;
        unsigned short goodmsgflg;
        unsigned short resrtuadr, resttccode, resopcode, respoint;
        unsigned long  responseword;

        goodmsgflg = TRUE;
	len = rxp->rxbuf[0];	/* number of words */

	/* check the first message word as an echo of the command */
        responseword =  (unsigned long) rxp->rxbuf[1] +
                  ((unsigned long) rxp->rxbuf[2] << 8) +
                  ((unsigned long) rxp->rxbuf[3] << 16) +
                  ((unsigned long) rxp->rxbuf[4] << 24);
        resttccode =   responseword & 0x0f;
        resrtuadr  = ((responseword >> 4) & 0x7f) + ((responseword >> (24-7)) & 0x80);
        resopcode  =  (responseword >> 11) & 0x3f;
        respoint   =  (responseword >> 17) & 0x7f;

        /* Verify bch: do this prior to testing individual field validity */
	bch = makebch(&rxp->rxbuf[1]);
	if (((responseword >> 24) & 0x7e) != bch)
        {
            printf ("RX>>      Response Message Error: Bad Checksum Value\n");
            goodmsgflg = FALSE;
        }
        else
        {
            /* Stop Bit */
            if ((responseword & 0x80000000) == 0)
            {
                printf ("RX>>      Response Message Error: Bad Stop Bit\n");
                goodmsgflg = FALSE;
            }

	    /* Strt Bit */
	    if ((responseword & 1) != 0)
            {
                printf ("RX>>      Response Message Error: Bad Start Bit\n");
                goodmsgflg = FALSE;
            }
	    /* Check Transmission Code */
	    if ( (((responseword & 0x0e)) != R2MPRESING) &&
	         (((responseword & 0x0e)) != R2MPREMORE) )
            {
                printf ("RX>>      Response Message Error: Unexpected Transmission Code[%2d]\n", resttccode);
                goodmsgflg = FALSE;
            }
	    /* Check Address */
	    taddr = ((responseword >> 4) & 0x7f);
	    if ((responseword & 0x1000000) != 0)
	    	taddr += 128;
	    if ( taddr != mod)
            {
                printf ("RX>>      Response Message Error: Unexpected Address[%2d]\n", resrtuadr);
                goodmsgflg = FALSE;
            }
	    /* Check Opcode */
	    if (((responseword >> 11) & 0x3f) != opcode)
            {
                printf ("RX>>      Response Message Error: Unexpected Opcode[%2]\n", resopcode);
                goodmsgflg = FALSE;
            }
	    /* Check point number = 0 */
	    if (((responseword >> 17) & 0x7f) != point)
            {
                printf ("RX>>      Response Message Error: Point Number is Not Zero [%2d]\n", respoint);
                goodmsgflg = FALSE;
            }
        }


        if (goodmsgflg)
        {
            /* to arrive here indicates that the 1st response word is correct, and can be interpreted as below */
            printf ("RX>>  ADR:[%2d],   TTC:[%2d] %s,   OPCODE:[%2d] %s,   POINT:[%2d],   WC:[%2d]\n",
                     resrtuadr, resttccode, ttcnames[resttccode],
                     resopcode, opcodenames[resopcode], respoint, rxp->rxbuf[0]);
        }
        else
        {
            /* to arrive here indicates that the 1st response word is bad, but would have been interpreted as below */
            printf ("RX>>  The following is how the RX message would have been\n");
            printf ("RX>>    interpreted, if not for the errors detected above:\n");
            printf ("RX>>  ADR:[%2d],   TTC:[%2d] %s,   OPCODE:[%2d] %s,   POINT:[%2d],   WC:[%2d]\n",
                     resrtuadr, resttccode, ttcnames[resttccode],
                     resopcode, opcodenames[resopcode], respoint, rxp->rxbuf[0]);
            return;
        }


	/* verify the data portion of the message */

	if (((responseword & 0x0e)) == R2MPRESING) {
	    /* There are no data elements in this message */
	    if (len == 1)
		return;
	    else
            {
                printf ("RX>>      Response Message Error: R2MPRESING message has too many (more than one) words [%2d]\n", len);
                goodmsgflg = FALSE;
            }
	}


	msgix = 5;
	len--;

	while (len)
        {
            responseword = (unsigned long) rxp->rxbuf[msgix] +
                          ((unsigned long) rxp->rxbuf[msgix+1] << 8) +
                          ((unsigned long) rxp->rxbuf[msgix+2] << 16) +
                          ((unsigned long) rxp->rxbuf[msgix+3] << 24);

            resttccode =   responseword & 0x0f;
            resrtuadr  = ((responseword >> 4) & 0x7f) + ((responseword >> (24-7)) & 0x80);
            resrtuadr  =  (responseword >> 4) & 0x7f;
            resopcode  =  (responseword >> 11) & 0x3f;
            respoint   =  (responseword >> 17) & 0x7f;
	    msgix+=4;


            /* Verify bch: do this prior to testing individual field validity */
	    bch = makebch(&rxp->rxbuf[msgix-4]);
	    if (((responseword >> 24) & 0x7e) != bch)
            {
                printf ("RX>>      Response Message Error: Word %d; Bad Checksum Value\n", len);
                goodmsgflg = FALSE;
            }
            else
            {
	        /* Stop Bit */
	        if ((responseword & 0x80000000) == 0)
                {
                    printf ("RX>>      Response Message Error: Word %d; Bad Stop Bit\n", len);
                    goodmsgflg = FALSE;
                }
	        /* Strt Bit */
	        if ((responseword & 1) != 0)
                {
                    printf ("RX>>      Response Message Error: Word %d; Bad Start Bit\n", len);
                    goodmsgflg = FALSE;
                }
	        /* Check Transmission Code */
	        if ( (((responseword & 0x0e)) != R2MDATAMORE) &&
	             (((responseword & 0x0e)) != R2MDATALAST) )
                {
                    printf ("RX>>      Response Message Error: Word %d; Unexpected Transmission Code[%2d]\n",
                            len, resttccode);
                    goodmsgflg = FALSE;
                }
            }

            /* data is good, print it  */
            if ((goodmsgflg)  && (trace [line] & DATATRAFFICTRACE))

            {
                /* Extract the point type */
                if ((responseword & DIGDATAFLAG) == 0)
                {
                    digblk = ((responseword >> 5) & 0x0f);
                    digval = ((responseword >> 9) & 0xffff);
                    printf ("RX>>      Digital Data:      block[%d], value[%d]\n", digblk, digval);
                }
                else
                {
                    if ((responseword & ACCFLAG) == 0)
                    {
                        /* Is an analog input */ 
                        pointno = ((responseword >> 5) & 0x7f);
                        value = ((responseword >> 12) & 0xfff);
                        if ((value & 0x800) != 0)
                        {
                            /* sign extend */
                            value = value + 0xf000;
                        }
                        printf ("RX>>      Analog Data:       block[%d], value[%d]\n", pointno, value);
                    }
                    else
                    {
                        /* Is an accumulator */
                        pointno = ((responseword >> 5) & 0x7);
                        value = ((responseword >> 8) & 0x7fff);
                        printf ("RX>>      Accumulator Data:  block[%d], value[%d]\n", pointno, value);
                    }
                }
            }
            len --;
        }
        printf ("RX>>      -----------------------------------------------------------------------------------\n");
	return;
    }






/*                                                                      
/* qeibocmd                                                        	
/*	command an output to the rtu                                    
/*	select before operate                                           
*/
static	unsigned short qeibocmd (unsigned short line, unsigned short mod,
			 unsigned short card, QEIRTU *pmod,
			 unsigned short bitaddr,
			 unsigned long mask, unsigned long val)

/* only called from checkoutputs */

    {
	unsigned short opcode;

	if (!(msgtortu(line, mod, pmod, SELECT_DO, bitaddr, FALSE, FALSE)))
		return(FALSE);

	if (val == 0)
	    opcode = EXECOFF;
	else
	    opcode = EXECON;

	if (!(msgtortu(line, mod, pmod, opcode, bitaddr, FALSE, FALSE)))
		return(FALSE);

	return (TRUE);

    }
/*                                                                	
/* qeiaocmd                                                       	
/*                                                                  	
*/
static	unsigned short qeiaocmd (unsigned short line, unsigned short mod,
			 unsigned short card, QEIRTU *pmod,
			 unsigned short point,
			 unsigned short val,double dblval, unsigned short conv)
{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  opcode, xferstat;

	/* Count The output messages */

	pmod->no_dataout_msgs++;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	opcode = SELECT_AO;

	/* Format the output message */
	/* Command Word */

	txp->txbuf [0] = (M2RPREMORE + ((mod & 0x0f) << 4));
	txp->txbuf [1] = (((opcode & 0x1f) <<  3) + ((mod >> 4) & 0x07));
	txp->txbuf [2] = (((opcode >> 5) & 0x01) + /* High bit of opcode */
			  ((point & 0x7f) << 1)); /* Point Number */

	/* !@! This may be where addresses greater than 128 are set */

	txp->txbuf [3] = ((mod >> 7) & 0x01); /* Point Number or Address?? */
	txp->txbuf [3] = txp->txbuf [3] + ((makebch (txp->txbuf) | STOPBIT));

	/* Data Word */

	txp->txbuf [4] = (M2RDATALAST + ((val << 4) & 0xf0));
	txp->txbuf [5] = ((val >> 4 ) & 0xff);
	txp->txbuf [6] = 0;
	txp->txbuf [7] = ((makebch (txp->txbuf) | STOPBIT));

	txp->txmsglen = SETPOINTLEN;

	/* Send out the message */

	if ((xferstat = msgxfer (line, VARRESP, pmod, 0)) == XFERGOOD)
	{
	    if (!(savedata (mod, pmod, opcode, point, rxp, FALSE)))
	    {
                /* Communications Failed */
                if (pmod->is_responding == TRUE)
                {
		    pmod->no_rxnoresp++;
                    pmod->no_offlines++;
                    pmod->holdflag = TRUE;
                    pmod->is_responding = FALSE;
                }
                return (FALSE);
	    }
	}
	else
	{
            /* Communications Failed */
            if (pmod->is_responding == TRUE)
            {
		pmod->no_rxnoresp++;
                pmod->no_offlines++;
                pmod->holdflag = TRUE;
                pmod->is_responding = FALSE;
            }
            return (FALSE);
	}

	/* Format the execute message */

	opcode = EXEC_AO;

	/* Command Word */

	txp->txbuf [0] = (M2RPREMORE + ((mod << 4) & 0xf0));
	txp->txbuf [1] = (((opcode & 0x1f) <<  3) + ((mod >> 4) & 0x07));
	txp->txbuf [2] = (((opcode >> 5) & 0x01) + /* High bit of opcode */
			  ((point & 0x7f) << 1)); /* Point Number */

	/* !@! This may be where addresses greater than 128 are set */

	txp->txbuf [3] = ((mod >> 7) & 0x01); /* Point Number or Address?? */
	txp->txbuf [3] = txp->txbuf [3] + ((makebch (txp->txbuf) | STOPBIT));

	/* Data Word */

	txp->txbuf [4] = (M2RDATALAST + ((val << 4) & 0xf0));
	txp->txbuf [5] = ((val >> 4 ) & 0xff );
	txp->txbuf [6] = 0;
	txp->txbuf [7] = ((makebch (txp->txbuf) | STOPBIT));

	txp->txmsglen = SETPOINTLEN;

	/* Send out the message */

	if ((xferstat =msgxfer (line, VARRESP, pmod, 0)) == XFERGOOD)
	{
	    if (savedata (mod, pmod, opcode, point, rxp, FALSE))
	    {
		return (TRUE);
	    }
	}

        /* Communications Failed */
        if (pmod->is_responding == TRUE)
        {
	    pmod->no_rxnoresp++;
            pmod->no_offlines++;
            pmod->holdflag = TRUE;
            pmod->is_responding = FALSE;
        }
        return (FALSE);
}


/*                                                                     
/*	makebch(buf)                                                   
/*                                                                     
/*	    Routine Compute the BCH Code of the buffer                 
*/
unsigned short bchcodes[] =  { 0x0d,0x1a,0x34,0x13,0x26,0x37,0x15,0x2a,
			       0x2f,0x25,0x31,0x19,0x32,0x1f,0x3e,0x07,
			       0x0e,0x1c,0x38,0x0b,0x16,0x2c,0x23,0x3d };

unsigned short bchmask[] =   { 0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x01,
			       0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x01,
			       0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x01 };

unsigned short bchoffset[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,
			       0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x02,
			       0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x03 };


unsigned short makebch(unsigned char *buf)
    {
	unsigned short i,ix,sum;
	unsigned char mask,thischar;

	sum = 0;
	for (i=0;(i<24);i++) {
	    if ((buf[bchoffset[i]] & bchmask[i]) != 0)
		sum = (sum ^ bchcodes[i]);
	}
	return ( ( ((~sum) & 0x3f) << 1) );

    }


/*
/*      DUMPMSGCNTS
/*
/*      The purpose of this routine is to dump the line level statistics for this driver. 
/*
*/
/* called from TABLEINFO */

void DUMPMSGCNTS (unsigned short line)

    {
        unsigned long	temp, t, x, y, z;

        temp = tickGet ();
        t = (temp - linestats [line].startingtick);

 	x = linestats [line].TXintcount;
	y = linestats [line].RXintcount;
	z = linestats [line].msgxfercount;

        if (t == 0)
        {
            printf (" ******  No Time has Transpired ****** \n");
            return;
        }

        if (z == 0)
        {
            printf (" ******  No Messages Transferred ****** \n");
            return;
        }

 	printf ("\n");
	printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
 	printf ("\n");
 	printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
 	printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
 	printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
 	printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
 	printf ("\n");
 	printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
 	printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
 	printf ("\n");
	printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
	printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
 	printf ("\n");
        return;
}

/*
/*      CLEARMSGCNTS
/*
/*      The purpose of this routine is to dump and clear the line level statistics
/*      for this driver.
/*
*/
/* called from TABLEINFO */

void CLEARMSGCNTS (unsigned short line)

{
        DUMPMSGCNTS (line);

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].msgxfercount = 0;

        linestats [line].startingtick = tickGet ();
	printf (" ******  All Counts Cleared  ****** \n", linestats [line].msgxfercount);
 	printf ("\n");
        return;
}


/*                                                                      
/*      DUMPPLCSTATS                                                    
/*                                                                      
/*      The purpose of this routine is to dump the plc level            
/*        statistics for this driver.                                   
/*                                                                      
*/
/* called from TABLEINFO */

void DUMPPLCSTATS (unsigned short line, unsigned short maddr)

{
    QEIRTU         *pmod;
    unsigned long   microsecs;

    pmod = plcs [line] [maddr];
    if (!pmod)
    {
        logMsg ("Line/Address Not Defined \n");
        return;
    }

    printf (" Was requested = %d \n", pmod->was_requested);
    printf (" Is responding = %d \n", pmod->is_responding);
    printf (" # Output messages = %d \n", pmod->no_dataout_msgs & 0x7fff);
    printf (" # Data in messages = %d \n", pmod->no_datain_msgs & 0x7fff);
    printf (" #No Rx Response = %d \n", pmod->no_rxnoresp & 0x7fff);
    printf (" #No Tx Responses = %d \n", pmod->no_txnoresp & 0x7fff);
    printf (" #Data Errors = %d \n", pmod->no_dataerr & 0x7fff);
    printf (" #Retries = %d \n", pmod->no_retries & 0x7fff);
    printf (" #Rx Hw Errors = %d \n", pmod->no_rxhwerrs & 0x7fff);
    printf (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs & 0x7fff);
    printf (" #Crc Errors = %d \n", pmod->no_crcerrs & 0x7fff);
    printf (" #Off Lines = %d \n", pmod->no_offlines & 0x7fff);
    printf (" Reset Statistics = %d \n", pmod->cmd_reset_stat);
    printf (" Force Offline = %d \n", pmod->cmd_force_offline);
    printf (" #Failed Outputs = %d \n", pmod->badoutcnt & 0x7fff);

    printf ("\n");
    printf (" #Zero Length Responses = %d \n", pmod->no_zeroresponses & 0x7fff);
    printf ("\n");

    printf (" # of Completed Messages %d \n", pmod->msgs);
    printf (" Total Response Time (in ticks) = %lu \n", pmod->responsetime);
    printf ("   (includes retries prior to each completed message)\n");
    if (pmod->msgs)
    {
        printf ("   Average response time (ticks) = %d \n", (pmod->responsetime/pmod->msgs));
        microsecs = (16667*pmod->responsetime)/pmod->msgs;
        printf ("   Average response time (msec) = %d.%1d \n", microsecs/1000, (microsecs%1000)/100);
    }
    printf (" # of scan passes = %d \n", pmod->tscanpass);
    printf ("\n");

    printf (" Resource Responding = %d \n", resresponse[line]);
    printf (" Hold flag  = %d \n", pmod->holdflag );
    return;
}

/*                                                                       
/*      CLEARPLCSTATS                                                    
/*                                                                       
/*      The purpose of this routine is to clear the plc level            
/*        statistics for this driver.                                    
/*                                                                       
*/
/* called from TABLEINFO */

void CLEARPLCSTATS (unsigned short line, unsigned short maddr)
{
    QEIRTU	*pmod;

    pmod = plcs [line] [maddr];
    if (!pmod)
    {
        logMsg ("Line/Address Not Defined \n");
        return;
    }

    initstats (pmod); /* use existing procedure */
    return;
}


/*                                                                          	
/*      dump_mod_table                                                       	
/*                                                                           	
/*      The purpose of this routine is to dump the module description        	
/*      portion of the analog devices driver tables for the selected line.   	
/*      It will print out two lines for each module which is responding.     	
/*      The first line will give the general module header, the second line 	
/*      will give module type specific info.                                	
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)

    {
	QEIRTU  *pmod;
	short           ix;
	unsigned	short	i, n, j; 

	QEIACC		*accptr;
	QEIDI		*diptr;
	QEIAI		*aiptr;
	unsigned	short req, val, value, addr, firstaiinblk, firstreginblk, linecnt;
	unsigned	long	bigvalue;
	unsigned	char	buffer[200];


	pmod = plcs[line][maddr];
	if (!pmod)
	{
	    logMsg("Line/QEIAddress Not Defined \n");
	    return;
	}

	printf (" Was requested = %d \n", pmod->was_requested);
	printf (" Is responding = %d \n", pmod->is_responding);
	printf (" # Output messages = %d \n", pmod->no_dataout_msgs & 0x7fff);
	printf (" # Data in messages = %d \n", pmod->no_datain_msgs & 0x7fff);
	printf (" #No Rx Response = %d \n", pmod->no_rxnoresp & 0x7fff);
	printf (" #No Tx Responses = %d \n", pmod->no_txnoresp & 0x7fff);
	printf (" #Data Errors = %d \n", pmod->no_dataerr & 0x7fff);
	printf (" #Retries = %d \n", pmod->no_retries & 0x7fff);
	printf (" #Rx Hw Errors = %d \n", pmod->no_rxhwerrs & 0x7fff);
	printf (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs & 0x7fff);
	printf (" #Crc Errors = %d \n", pmod->no_crcerrs & 0x7fff);
	printf (" #Off Lines = %d \n", pmod->no_offlines & 0x7fff);
	printf (" Reset Statistics = %d \n", pmod->cmd_reset_stat);
	printf (" Force Offline = %d \n", pmod->cmd_force_offline);
	printf (" #Failed Outputs = %d \n", pmod->badoutcnt & 0x7fff);

        printf ("\n");
        printf (" #Zero Length Responses = %d \n", pmod->no_zeroresponses & 0x7fff);
        printf ("\n");

	printf (" Resource Responding = %d \n", resresponse[line]);
	printf (" Module Is Responding = %d \n", pmod->is_responding );
	printf (" Hold flag  = %d \n", pmod->holdflag );
        printf ("\n");


	/*Print the Polling Control */
	printf(" RTU is on forced scan = %d\n",pmod->forcescan);
	printf(" RTU fast poll flag  = %d\n",pmod->fast_poll);
	printf(" RTU scan frequency  = %d\n",pmod->scan_freq);
	printf(" RTUs last scan no   = %d\n",pmod->last_scan_no);
	printf(" RTU is due for poll = %d\n",pmod->poll_due);
	printf(" RTU is due for poll all = %d\n",pmod->poll_all_due);
	printf(" RTU is due for acc poll = %d\n",pmod->poll_acc_due);
        printf ("\n");

	/* Print the I/O */
	/* Print the DIs */
	printf( "Digital inputs line %d, Addr %d \n",line,maddr);
	for (i=0;(i<MAXDIBLK/4);i++) {
	    printf( "%d\t", (i*64));
	    for (j=0;(j<4);j++) {
		printf(" %d %d %x \t",
			pmod->dis[(i*4)+j].was_requested,
			pmod->dis[(i*4)+j].data_valid,
			pmod->dis[(i*4)+j].last_read );
	    }
	    printf("\n");
	}

	/* Print the AIs */
	printf( "Analog inputs line %d, Addr %d \n",line,maddr);
	for (i=0;(i<MAXAI/8);i++) {
	    printf( "%d\t", (i*8));
	    for (j=0;(j<8);j++) {
		printf(" %d %d %x \t",
			pmod->ais[(i*8)+j].was_requested,
			pmod->ais[(i*8)+j].data_valid,
			pmod->ais[(i*8)+j].last_read );
	    }
	    printf("\n");
	}

	/* Print the ACCs */
	printf( "Accumulator inputs line %d, Addr %d \n",line,maddr);
	for (i=0;(i<MAXACC/8);i++) {
	    printf( "%d\t", (i*8));
	    for (j=0;(j<8);j++) {
		printf(" %d %d %x \t",
			pmod->accs[(i*8)+j].was_requested,
			pmod->accs[(i*8)+j].data_valid,
			pmod->accs[(i*8)+j].last_read );
	    }
	    printf("\n");
	}

	/* Print the Aos */
	printf( "Analog outputs line %d, Addr %d \n",line,maddr);
	for (i=0;(i<MAXAO/8);i++) {
	    printf( "%d\t", (i*8));
	    for (j=0;(j<8);j++) {
		printf(" %d,\t",
			pmod->setpoints[(i*8)+j] );
	    }
	    printf("\n");
	}

	/* Print the Dos */
	printf( "Digital outputs line %d, Addr %d \n",line,maddr);
	for (i=0;(i<MAXDO/32);i++) {
	    printf( "%d\t", (i*32));
	    for (j=0;(j<32);j++) {
		printf("%d, ",
			pmod->dos[(i*32)+j] );
	    }
	    printf("\n");
	}
    }


/*                                                               		
**                                                                	 	
**	The purpose of this routine is to display the contents            	
**	of the static variables contained within this driver.             	
**                                                                        	
*/

/* this routine not called from within this driver */


LINEINFO ()
{
	short	i;
	char	buffer[132];
	char	*resrsp;
	char	*lineact;


	printf("                                 Qei Line Information Table         \n");
	printf("\n");
       printf(" Line        Pointer to        Resource      Resource       Line        Delay Times:       Activity\n");
       printf("Number      QEIRTU Table         Name        Response     Activity      IM  .TX  TX.         Time\n");
        /*     01234567891         01234567893         01234567895         0123456789 
			 01234567892         01234567894         01234567896
	*/
	printf("\n");

	for (i=0; i < QEILINES; i++)
	{
		if(plcs[i] == NULL)
		{
			continue;
		}
		if (resresponse[i] == 0)
		{
			resrsp = "FALSE";
		}
		else
		{
			resrsp = "TRUE";
		}
		if (recent_activity[i] == 0)
		{
			lineact = "FALSE";
		}
		else
		{
			lineact = "TRUE";
		}
		sprintf(buffer, "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
			i,plcs[i],&resnames[i],
			&resrsp[0],
			&lineact[0],
			intermsgdelay[i],
			pretxdelay[i],
			posttxdelay[i],
			activity_tick[i]);
		printf( "%s\n", buffer);
	}

	return 0;
}


/*                                                                         
**                                                                         
**	The purpose of this routine is to display the contents             
**	of the static poll control variables contained within this driver. 
**                                                                         
*/

/* this routine not called from within this driver */


POLLINFO (unsigned short line)
{
	short	i;

	/* Print the Polling Control Information */
	printf("Current Scan Number = %d \n",
			pollcntrl[line].scan_number);
	printf("Polls Since Normal Scan = %d \n",
				pollcntrl[line].nosincenormal & 0x7fff);
	printf("Polls Since Fast Scan = %d \n",
				pollcntrl[line].nosincefast & 0x7fff);
	printf("Polls Since Offline Scan = %d \n",
				pollcntrl[line].nosinceoffline & 0x7fff);
	printf("Polls Per Off-Line Scan = %d \n",
				pollcntrl[line].noperoffline);
	printf("Polls per Fast Scan = %d \n",
				pollcntrl[line].noperfast);
	printf("Minutes per Scan Accs = %d \n",
				pollcntrl[line].minsperacc);
	printf("Minutes per Scan All = %d \n",
				pollcntrl[line].minsperall);
	printf("Minutes Till Scan Acc = %d \n",
				pollcntrl[line].minstillacc);
	printf("Minutes Till Scan All = %d \n",
				pollcntrl[line].minstillall);
	printf("Last All Scan Time = %ld \n",
				pollcntrl[line].lastalltime);
	printf("Last Acc Scan Time = %ld \n",
				pollcntrl[line].lastacctime);
	printf("Last Set Freq Scan Number = %d \n",
				pollcntrl[line].lastsetfreq);
	printf("Last Forced Scan Number = %d \n",
				pollcntrl[line].lastforced);
	printf("Last Fast Scan Number = %d \n",
				pollcntrl[line].lastfast);
	printf("Last Off-Line Scan Number = %d \n",
				pollcntrl[line].lastoffline);
	printf("Last Normal Scan Number = %d \n",
				pollcntrl[line].lastnormal);

	for (i=0;(i<10);i++) {
	    printf("Unit [%d]  = %d , Status = %d, Reason = %d\n",
		    i,
		    pollcntrl[line].lastscanned[i],
		    pollcntrl[line].lastscannedstat[i],
		    pollcntrl[line].pollreason[i] );
	}
    }


/*
/* Qeierr
/*
*/
static void qeierr(unsigned short qerrno, unsigned short len,
		   unsigned long command1, unsigned long command2)
    {
	logMsg("QEI Simulator Recieve Error # %d, Len = %d, command1 = %lx, command2 = %lx\n",
			qerrno,
			len,
			command1,
			command2);
    }

/*
/*      msgsim
/*
/*		the purpose of this routine is to simulate responses from the qei RTU
/*		providing data from tables stored in memory one data table will
/*		reported for all RTUS.
/*              returns         XFERGOOD if response received
/*                              XFERBAD  if no good response is received
/*
*/

static	unsigned short  msgsim (unsigned short fline,unsigned short resplen,
                                QEIRTU *pmod, unsigned short rxlength)
    {
	unsigned short  retry,txstatus,rxstatus,rxlen,line,ix,i,func;
	RXLINE          *rxp;
	TXLINE          *txp;
	unsigned char   csums[2];
	unsigned long   command1,command2;
	unsigned short	opcode,station,point,value;

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

	rxp = rxlinetab[line];
	txp = txlinetab[line];

	command1 = (long)(  ((long) txp->txbuf[3] << 24) +
			    ((long) txp->txbuf[2] << 16) +
			    ((long) txp->txbuf[1] << 8) +
			            txp->txbuf[0] );
	command2 = (long)(  ((long) txp->txbuf[7] << 24) +
			    ((long) txp->txbuf[6] << 16) +
			    ((long) txp->txbuf[5] << 8) +
			            txp->txbuf[4] );

	/* look at the length and the TCC codes */
	if (txp->txmsglen == 4) {
	    if ( (command1 & 0x0f) != 0x08) {
		logMsg("Bad TCC Code on single word command\n");
		qeierr(0,4,command1,command2);
	    	return (XFERBAD);
	    }
	} else {
	    if ( (command1 & 0x0f) != 0x0) {
		logMsg("Bad First TCC Code on double word command \n");
		qeierr(1,8,command1,command2);
	    	return (XFERBAD);
	    }
	    if ( (command2 & 0x0f) != 0x0c) {
		logMsg("Bad Second TCC Code on double word command\n");
		qeierr(2,8,command1,command2);
	  	return (XFERBAD);
	    }
	}

	/* look at the opcode and the length */
	opcode = ((command1 & 0x1f800) >> 11);
	if ( (opcode == 0x10) || (opcode == 0x11) ) {
	    if ( (txp->txmsglen) != 8) {
		logMsg("Bad Length on double word opcode\n");
		qeierr(3,8,command1,command2);
	    	return (XFERBAD);
	    }
 	} else {
	    if ( (txp->txmsglen) != 4) {
		logMsg("Bad Length on single word opcode\n");
		qeierr(4,8,command1,command2);
	    	return (XFERBAD);
	    }
	}
	/* break out the station address and point address */
	station = ((command1 & 0x7f0) >> 4);
	point = ((command1 & 0x1fe0000) >> 17);
	value = ((command2 & 0x3ff0) >> 4);
	if (station > 20)
	    return (XFERBAD);
	rxp->rxix = 1; /* leave room for byte count */
	/* do case of the opcode */
	switch (opcode) {
	    case (0):
		/* restart remote 	      -> print message */
		/* 			      -> echo command
		*/
		qeiresponse(rxp,0,command1,0,0);
		logMsg("Restart remote command station = %d\n",station);
		logMsg("Function not supported \n");
		break;
	    case (1):
		/* poll for upsets with reset -> print message
		/*			      -> respond with all changed data
		/*			      -> copy changed to old changed
		/*			      -> clear changed flags
		*/
		if (mltrace[line] > 2)
		    logMsg("Poll for upsets & reset station = %d\n",station);
		qeiresponse(rxp,1,command1,0,0);
		for (i=0;(i<MAXDIBLK);i++) {
		    if (simrtu.cfdis[i]) {
			func = checkformore(0,(i+1));
			qeiresponse(rxp,func,i,simrtu.dis[i],0);
		    }
		    simrtu.ocfdis[i] = simrtu.cfdis[i];
		    simrtu.cfdis[i] = FALSE;
		}
		for (i=0;(i<MAXAI);i++) {
		    if (simrtu.cfais[i]) {
			func = checkformore(1,(i+1));
			qeiresponse(rxp,func,i,simrtu.ais[i],1);
		    }
		    simrtu.ocfais[i] = simrtu.cfais[i];
		    simrtu.cfais[i] = FALSE;
		}
		for (i=0;(i<MAXACC);i++) {
		    if (simrtu.cfaccs[i]) {
			func = checkformore(2,(i+1));
			qeiresponse(rxp,func,i,simrtu.accs[i],2);
		    }
		    simrtu.ocfaccs[i] = simrtu.cfaccs[i];
		    simrtu.cfaccs[i] = FALSE;
		}
		break;
	    case (2):
		/* poll for upsets wo reset   -> print message
		/*			      -> respond with all old changed data
		*/
		if (mltrace[line] > 2)
		    logMsg("Poll for upsets wo reset station = %d\n",station);
		qeiresponse(rxp,1,command1,0,0);
		for (i=0;(i<MAXDIBLK);i++) {
		    if (simrtu.cfdis[i]) {
			func = ocheckformore(0,(i+1));
			qeiresponse(rxp,func,i,simrtu.dis[i],0);
		    }
		}
		for (i=0;(i<MAXAI);i++) {
		    if (simrtu.cfais[i]) {
			func = ocheckformore(1,(i+1));
			qeiresponse(rxp,func,i,simrtu.ais[i],1);
		    }
		}
		for (i=0;(i<MAXACC);i++) {
		    if (simrtu.cfaccs[i]) {
			func = ocheckformore(2,(i+1));
			qeiresponse(rxp,func,i,simrtu.accs[i],2);
		    }
		    qeiresponse(rxp,func,i,simrtu.accs[i],2);
		}
		break;
	    case (9):
		/* poll for all data	      -> print message
		/*			      -> respond with all data
		*/
		qeiresponse(rxp,1,command1,0,0);
		if (mltrace[line] > 1)
		    logMsg("Poll for all data station = %d\n",station);
		for (i=0;(i<MAXDIBLK);i++) {
		    qeiresponse(rxp,2,i,simrtu.dis[i],0);
		}
		for (i=0;(i<MAXAI);i++) {
		    qeiresponse(rxp,2,i,simrtu.ais[i],1);
		}
		for (i=0;(i<(MAXACC-1));i++) {
		    qeiresponse(rxp,2,i,simrtu.accs[i],2);
		}
		/* put out the last one */
		qeiresponse(rxp,3,i,simrtu.accs[i],2);

		break;
	    case (10):
		/* select point		      -> print message
		/* 			      -> echo command
		/*			      -> remember digital point number
		*/
		logMsg("Select DO point station = %d, point = %d\n",station,point);
		simrtu.dosel = point;
		simrtu.outputstation = station;
		qeiresponse(rxp,0,command1,0,0);
		break;
	    case (11):
		/* execute on command	      -> print message
		/* 			      -> echo command
		/*			      -> set "selected digital point to 1
		*/
		logMsg("Execute On  DO point station = %d, point = %d\n",station,point);
		simrtu.dos[point/16] |= bits[point%16];
		qeiresponse(rxp,0,command1,0,0);
		break;
	    case (12):
		/* execute off command	      -> print message
		/* 			      -> echo command
		/*			      -> set "selected digital point to 0
		*/
		logMsg("Execute Off DI point station = %d, point = %d\n",station,point);
		if (station != simrtu.outputstation) {
		    logMsg("DO execute OFF with different station ss= %d ,es= %d\n",
				simrtu.outputstation,station);
		    break;
		}
		if (point != simrtu.dosel) {
		    logMsg("DO execute with different point sp= %d, ep = %d",
				simrtu.dosel,point);
		    break;
		}
		simrtu.dis[point/16] &= (~bits[point%16]);
		qeiresponse(rxp,0,command1,0,0);
		break;
	    case (13):
		/* poll for accumulators      -> print message
		/*			      -> respond with all accumulators
		*/
		qeiresponse(rxp,1,command1,0,0);
		logMsg("Poll for accumulators station = %d\n",station);
		for (i=0;(i<(MAXACC-1));i++) {
		    qeiresponse(rxp,2,i,simrtu.accs[i],2);
		}
		/* put out the last one */
		qeiresponse(rxp,3,i,simrtu.accs[i],2);
		break;
	    case (14):
		/* reset accumulators	      -> print message
		/* 			      -> echo command
		*/
		logMsg("Reset accumulators station = %d\n",station);
		qeiresponse(rxp,0,command1,0,0);
		for (i=0;(i<(MAXACC));i++) {
		    simrtu.accs[i]=0;
		}
		break;
	    case (15):
		/* freeze accumulators	      -> print message
		/* 			      -> echo command
		*/
		logMsg("Freeze accumulators station = %d\n",station);
		qeiresponse(rxp,0,command1,0,0);
		break;
	    case (16):
		/* select setpoint	      -> print message
		/* 			      -> echo command
		/*			      -> remember setpoint number
		*/
		logMsg("Select AO point station = %d, point = %d, value = %d\n",
				station,point,value);
		simrtu.aosel = point;
		simrtu.outputstation = station;
		if (txp->txmsglen > 4)
		    simrtu.aoval = value;
		qeiresponse(rxp,0,command1,0,0);
		break;
	    case (17):
		/* execute setpoint	      -> print message
		/* 			      -> echo command
		/* 			      -> save second part in selected set point
		*/
		logMsg("Execute AO point station = %d, point = %d, value = %d\n",
				station,point,value);
		if (station != simrtu.outputstation) {
		    logMsg("AO execute with different station ss= %d ,es= %d\n",
				simrtu.outputstation,station);
		    break;
		}
		if (point != simrtu.aosel) {
		    logMsg("AO execute with different point sp= %d, ep = %d",
				simrtu.aosel,point);
		    break;
		}
		if (txp->txmsglen > 4)
		    simrtu.aoval = value;
		simrtu.setpoints[point] = simrtu.aoval;
		qeiresponse(rxp,0,command1,0,0);
		break;

	    case (20):
		/* xfer/reset accumulators    -> print message
		/* 			      -> echo command
		*/
		logMsg("Xfer/Reset accumulators station = %d\n",station);
		qeiresponse(rxp,0,command1,0,0);
		break;
	    default:		
		break;

	}

	rxp->rxbuf[0] = (rxp->rxix-1)/4;
        return (XFERGOOD);

    }
/*
/*
/*	check for more
/*
*/
static int checkformore(unsigned short type,unsigned short point)
    {
	unsigned short i;

	i = point;
	switch (type) {
	    case (0):
		for (;(i<MAXDIBLK);i++) {
		    if (simrtu.cfdis[i])
				return(2);
		}
		i = 0;
	    case (1):
		for (;(i<MAXAI);i++) {
		    if (simrtu.cfais[i])
			return(2);
		}
		i = 0;
	    case (2):
		for (;(i<MAXACC);i++) {
		    if (simrtu.cfaccs[i])
			return(2);
		}
	}
	return(3);

    }

/*
/*
/*	check for more
/*
*/
static int ocheckformore(unsigned short type,unsigned short point)
    {
	unsigned short i;

	i = point;
	switch (type) {
	    case (0):
		for (;(i<MAXDIBLK);i++) {
		    if (simrtu.ocfdis[i])
				return(2);
		}
		i = 0;
	    case (1):
		for (;(i<MAXAI);i++) {
		    if (simrtu.ocfais[i])
			return(2);
		}
		i = 0;
	    case (2):
		for (;(i<MAXACC);i++) {
		    if (simrtu.ocfaccs[i])
			return(2);
		}
	}
	return(3);

    }

/*
/*	qeiresponse (rxp,function,data1,data2,type)
/*	    formats the response from a qei RTU simulation
/*	    functions
/*		0 - echo command with no data
/*		1 - echo command with data to follow
/*		2 - add data to buffer, more to follow
/*		3 - add data to buffer - last
/*
*/
static void qeiresponse( RXLINE *rxp,unsigned short function,
			 unsigned long data1, /* point number */
			 unsigned long data2, /* point value  */
			 unsigned short type )
    {

	unsigned short ix,savix,tcc;
	unsigned long responsedata;

	savix = ix = rxp->rxix;
	if (function == 0) {
		/* just echo the command with the new tcc & bch */
		rxp->rxbuf[ix++] = (data1 & 0x0f0) + 0x0a;
		rxp->rxbuf[ix++] = ((data1 & 0x0ff00) >> 8);
		rxp->rxbuf[ix++] = ((data1 & 0x0ff0000) >> 16);
		rxp->rxbuf[ix] = ((data1 & 0x001000000) >> 24);
		rxp->rxbuf[ix] |= ((makebch(&rxp->rxbuf[savix]) | STOPBIT) );
		rxp->rxix = ix+1;
		return;
	}

	if (function == 1) {
		/* echo the command with the more to follow tcc & bch */
		rxp->rxbuf[ix++] = (data1 & 0x0f0) + 0x02;
		rxp->rxbuf[ix++] = ((data1 & 0x0ff00) >> 8);
		rxp->rxbuf[ix++] = ((data1 & 0x0ff0000) >> 16);
		rxp->rxbuf[ix] = ((data1 & 0x001000000) >> 24);
		rxp->rxbuf[ix] |= ((makebch(&rxp->rxbuf[savix]) | STOPBIT) );
		rxp->rxix = ix+1;
		return;
	}

	if ((function != 2) && (function != 3)) {
	    return;
	}
	if (function == 2) 
	    responsedata = 6;
	else
	    responsedata = 14;

	switch (type) {

	    case (0):	/* status */
		responsedata += ((data1 & 0x0f) << 5);
		responsedata += (data2 << 9 );
		break;
	    case (1):   /* analog */
		responsedata += ((data1 & 0x07f) << 5) + 16; /* analog flag */
		responsedata += (data2 << 12 );
		break;
	    case (2):   /* accumulators */
		responsedata += ((data1 & 0x07) << 5) + 16; /* analog flag */
		responsedata += (data2 << 8 );
		responsedata += 0x01000000; /* accumulator flag */
		break;
	}

	rxp->rxbuf[ix++] = (responsedata & 0xff);
	rxp->rxbuf[ix++] = ((responsedata & 0x0ff00) >> 8);
	rxp->rxbuf[ix++] = ((responsedata & 0x0ff0000) >> 16);
	rxp->rxbuf[ix] = ((responsedata & 0x001000000) >> 24);
	rxp->rxbuf[ix] |= ((makebch(&rxp->rxbuf[savix]) | STOPBIT) );
	rxp->rxix = ix+1;
	return;
    }
/*
/* qeisimdump
/*
/*	Dumps the simulated rtus memory
/*
*/
qeisimdump()
    {

	unsigned short	i,j;

	/* Print the I/O */
	/* Print the DIs */
	printf( "Simulated Digital Inputs\n");
	for (i=0;(i<MAXDIBLK/4);i++) {
	    printf( "%d\t", (i*64));
	    for (j=0;(j<4);j++) {
		printf(" %d %d %x \t",
			simrtu.cfdis[(i*4)+j],
			simrtu.ocfdis[(i*4)+j],
			simrtu.dis[(i*4)+j] );
	    }
	    printf("\n");
	}

	/* Print the AIs */
	printf( "Simulated Analog Inputs\n");
	for (i=0;(i<MAXAI/8);i++) {
	    printf( "%d\t", (i*8));
	    for (j=0;(j<8);j++) {
		printf(" %d %d %x \t",
			simrtu.cfais[(i*8)+j],
			simrtu.ocfais[(i*8)+j],
			simrtu.ais[(i*8)+j] );
	    }
	    printf("\n");
	}

	/* Print the ACCs */
	printf( "Simulated Accumulator Inputs \n");
	for (i=0;(i<MAXACC/8);i++) {
	    printf( "%d\t", (i*8));
	    for (j=0;(j<8);j++) {
		printf(" %d %d %x \t",
			simrtu.cfaccs[(i*8)+j],
			simrtu.ocfaccs[(i*8)+j],
			simrtu.accs[(i*8)+j] );
	    }
	    printf("\n");
	}

	/* Print the Aos */
	printf( "Simulated Analog Outputs\n");
	for (i=0;(i<MAXAO/8);i++) {
	    printf( "%d\t", (i*8));
	    for (j=0;(j<8);j++) {
		printf(" %d,\t",
			simrtu.setpoints[(i*8)+j] );
	    }
	    printf("\n");
	}

	/* Print the Dos */
	printf( "Simulated Digital Outputs \n");
	for (i=0;(i<MAXDO/32);i++) {
	    printf( "%d\t", (i*32));
	    for (j=0;(j<32);j++) {
		printf("%d, ",
			simrtu.dos[(i*32)+j] );
	    }
	    printf("\n");
	}
    }


/*
/* qsacc(point,val)
/*
/*	Sets an accumulator value
/*
*/
qsacc (unsigned short point,unsigned short val) 
    {
	if (point >= MAXACC) {
	    printf("Point # too large\n");
	    return (-1);
	}
	simrtu.accs[point] = val;
	simrtu.cfaccs[point] = TRUE;
	return(0);
    }

/*
/* qsdi(point,val)
/*
/*	sets a di value
/*
*/
qsdi (unsigned short point,unsigned short val) 
    {
	if (point >= MAXDI) {
	    printf("Point # too large\n");
	    return (-1);
	}
	simrtu.cfdis[point/16] = TRUE;
	simrtu.dis[point/16] = val;
	return(0);
    }

/*
/* qsai(point,val)
/*
/*	sets an ai value
/*
*/
qsai (unsigned short point,unsigned short val) 
    {
	if (point >= MAXAI) {
	    printf("Point # too large\n");
	    return (-1);
	}
	simrtu.cfais[point] = TRUE;
	simrtu.ais[point] = val;
	return(0);
    }




/*  End of File:        drvQei.c */









