/****
*
*	File name :		mv90.h
*	Author :		Steve Johnson
*	Creation date :	December 22, 1998
*
*	Copyright (c) 1998,1999 Sigma Six Corporation
*
*	Include file for the Siemens MV90 Protocol
*
****/

/****
*
*	Definition of handles returned by open
*
****/

typedef void		*MV90_HANDLE;

/****
*
*	Possible MV90 error values
*
****/

typedef enum {
	MV90_NORMAL				= -1,
	MV90_BASE				= 3000,
	MV90_BAD_NAME			= MV90_BASE + 1,
	MV90_BAD_HANDLE			= MV90_BASE + 2,
	MV90_NO_MEMORY			= MV90_BASE + 3,
	MV90_ABORTED			= MV90_BASE + 4,
	MV90_PENDING			= MV90_BASE + 5,
	MV90_SHUTDOWN			= MV90_BASE + 6,
	MV90_OVERFLOW			= MV90_BASE + 7,
	MV90_TIMEOUT			= MV90_BASE + 8,
	MV90_NO_DATA			= MV90_BASE + 9,
	MV90_IO_ERROR			= MV90_BASE + 10,
	MV90_NOT_IMPLEMENTED	= MV90_BASE + 11,
	MV90_TABLE_EMPTY		= MV90_BASE + 12,
} MV90_STATUS;

#define MV90_MAX_TABLE_SIZE	140000

extern MV90_STATUS		mv90_init (void);
extern MV90_STATUS		mv90_publish (MV90_HANDLE *, char *);
extern MV90_STATUS		mv90_accept (MV90_HANDLE *, MV90_HANDLE);
extern MV90_STATUS		mv90_read (MV90_HANDLE, size_t, void *, size_t *);
extern MV90_STATUS		mv90_write (MV90_HANDLE, size_t, void *);
extern MV90_STATUS		mv90_poll (MV90_HANDLE *, size_t *);
extern MV90_STATUS		mv90_shutdown (MV90_HANDLE);
extern MV90_STATUS		mv90_exit (void);

