/*drvSabplc.c,v 1.1.1.1 1999/08/03 14:44:33 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File:	drvSabplc.c
**  Edit:	12/18/92 12:33 JLD
**        	01/18/94:	WEP	name changes only
**		03-30-94	ems	startabplc(), remove test ln >= 0
**					it is unsigned
**		04/13/94	WHS	upgrading driver to EPICS
**              12/02/94        WEP     modified AIDRIVER to mask out MSBit of statistics counts.
**              05/10/95        WEP     added 'abplc_clear' to clear statistics via 'initstats' call.
**              05/22/95        WEP     modified master loop logic to exit when local state is not
**                                      master. This causes lockstep logic to function correctly.   
**                                      test for and conditionally display an illegal lstate msg.
**              09/10/97        WEP     added Resource Group Lock function
**              02/03/98        WEP     added point name to diagnostic AO & BO function
**              02/04/98        WEP     added point value to diagnostic AO & BO function
**              06/24/98        WEP     bug fix: initialized rxp in abdiagstat for call to
**                                      getdataresp. also updated checkoutput messages.
**
*/

#define	MAIN		abplc_driver		/* NOTE: change here */
#define	AIDRIVER	abplc_aidriver		/* NOTE: change here */
#define	AODRIVER	abplc_aodriver		/* NOTE: change here */
#define	AOREAD		abplc_aoread		/* NOTE: change here */
#define	BIDRIVER	abplc_bidriver		/* NOTE: change here */
#define	BODRIVER	abplc_bodriver		/* NOTE: change here */
#define	BOREAD		abplc_boread		/* NOTE: change here */

#define	TRACEON		abplctraceon		/* NOTE: change here */
#define	TRACEOFF	abplctraceoff		/* NOTE: change here */
#define	RTRACEON	abplcrestraceon		/* NOTE: change here */
#define	RTRACEOFF	abplcrestraceoff	/* NOTE: change here */
#define	TRACELEVEL	abplctrlv		/* NOTE: change here */

#define	STOPDRIVER	stopabplc		/* NOTE: change here */
#define	STARTDRIVER1	startabplc		/* NOTE: change here */
#define	STARTDRIVER2	startabplc		/* NOTE: change here */
#define	SETDELAYS	abplcsetdelays		/* NOTE: change here */
#define	TABLEINFO	dump_abplc_table	/* NOTE: change here */
#define	LINEINFO	showlineinfo		/* NOTE: change here */

#define ASSIGNGROUP     abplcResGroup           /* NOTE: change here */


/*#define TEST*/

#ifdef TEST

/* #include "testmode.h" */

#include	"bioscomm.h"
#include	"dummyos.h"
#include 	"drvsabplc.h"
#include 	"link.h"
#include	"sabproto.h"
#define		logMsg printf

#endif

#ifndef TEST

#include	<ctype.h>
#include	<vxWorks.h>
#include	<sysLib.h>
#include	<semLib.h>
#include	<wdLib.h>
#include	<rngLib.h>
#include	<task_params.h>
#include	<stdioLib.h>
#include <logLib.h>
#include <remLib.h>
#include <tickLib.h>
#include <string.h>

#include	<dbDefs.h>
#include	<drvSup.h>
/*#include	<module_types.h>*/
#include	<drvSabplc.h>
#include	<drvSabplc_proto.h>
#include	<restable.h>
#endif

struct {
	long		number;
	DRVSUPFUN	report;
	DRVSUPFUN	init;
} drvSabplc = {2, NULL, init};

/**********
*
*      External Line Level Data Structures (declared in drvcommon.c)
*
**********/

extern	unsigned	char	resnames [ABLINES] [RESNAMELEN];	/* array of resource name strings.		*/

extern	RES_TABLE	*prestable [ABLINES];				/* array of pointers to resource tables 	*/

extern	unsigned	short	resresponse [ABLINES];			/* array of resource response flags. 		*/
									/* False=not active resource(slave),		*/
									/* True= active resource(master) 		*/

extern	unsigned	short	line_activity [ABLINES];		/* true/false line active flag. calculated	*/
									/* using activity_time below. 			*/
extern	unsigned	short	lastactivity [ABLINES];			/* assigned value of line_activity prior to	*/
									/* it's recalculation.   			*/

extern	unsigned	short	modtrace [ABLINES];			/* controls output of communication error log	*/
									/* messages (true/false) 			*/
extern	unsigned	short	mltrace [ABLINES];			/* controls output of certain resource related	*/
									/* log messages (level) 			*/
extern	unsigned	short	modrestrace [ABLINES];			/* controls output of MASTER/SLAVE arbitration	*/
									/* log messages (binary) 			*/

extern	SEM_ID			semids [ABLINES] [2];			/* 'new' semaphore logic. the old SEMAPHORE is	*/
									/* still used. 					*/

extern	short			linetimers [ABLINES];			/* except on init (init_line_tabs), all		*/
									/* references are commented out		 	*/
extern	unsigned	short	intermsgdelay [ABLINES];		/* holds value passed in task spawn. used for	*/
									/* each msgxfer attempt 			*/
extern	unsigned	short	pretxdelay [ABLINES];			/* holds post RTS delay before TX. 		*/
extern	unsigned	short	posttxdelay [ABLINES];			/* holds post TX delay before dropping RTS. 	*/

extern	long			activity_time [ABLINES];		/* holds timetick of last activity. used to	*/
									/* set line_activity flag  			*/
									/* shared resource of the data link 		*/
									/* controls access to common path shared by	*/
									/* data and diagnostic channels. 		*/
									/* originally designed for use with MDS remote	*/
									/* radio diagnostics. 				*/

extern  short                  resGroupLock [];                         /* holds line driver group lock flags.          */
extern  char                  *resGroupTripName [];                     /* holds line driver trip name.                 */


/**********
*
*      Storage for Allen Bradley Comm Line Structures
*
**********/

/* array of pointers to dynamically allocated comm controls/buffers */


static	RXLINE		*rxlinetab [ABLINES] =
 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL
			};

static TXLINE          *txlinetab [ABLINES] = 

			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL
			};

/**********
*
*      Storage for Allen Bradley PLC Structures
*
**********/

static	ABPLC		*plcs [ABLINES] [NUMABPLCS + 1];
static	OUTPUTQUE	*oq [ABLINES];

static	char		user [40],password [40];	/* holds id and password of the user that       */
                                                        	/* spawned the driver task required by host to  */
                                                        	/* check file read privileges on PLC load files */
static	short		backup_mode [ABLINES];
static	short		channel_select [ABLINES];
static	short		abadapteraddr [] =
			{0x3f, 0x3f, 0x3f, 0x3f, 0x3f,
			 0x3f, 0x3f, 0x3f, 0x3f, 0x3f,
			 0x3f, 0x3f, 0x3f, 0x3f, 0x3f,
			 0x3f, 0x3f, 0x3f, 0x3f, 0x3f,
			 0x3f, 0x3f, 0x3f, 0x3f, 0x3f,
			 0x3f, 0x3f, 0x3f, 0x3f, 0x3f,
			 0x3f, 0x3f
			};

static	LINEMODE	lnmode [ABLINES];

static	char    	*bools [] = {

				"TRUE ",
				"FALSE"};

static	int		taskId [ABLINES];

static	char		*tasknames [] =

			{"ABPLC Ch0", "ABPLC Ch1", "ABPLC Ch2", "ABPLC Ch3",
			 "ABPLC Ch4", "ABPLC Ch5", "ABPLC Ch6", "ABPLC Ch7",
			 "ABPLC Ch8", "ABPLC Ch9", "ABPLC Ch10", "ABPLC Ch11",
			 "ABPLC Ch12", "ABPLC Ch13", "ABPLC Ch14", "ABPLC Ch15",
			 "ABPLC CH16", "ABPLC Ch17", "ABPLC Ch18", "ABPLC Ch19",
			 "ABPLC CH20", "ABPLC Ch21", "ABPLC Ch22", "ABPLC Ch23",
			 "ABPLC CH24", "ABPLC Ch25", "ABPLC Ch26", "ABPLC Ch27",
			 "ABPLC CH28", "ABPLC Ch29", "ABPLC Ch30", "ABPLC Ch31"
			};

static unsigned short abplcResGroups [ABLINES] =
			{0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0} ; /* line driver group assignments   */

static	short		linemon [ABLINES];

/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/

static long init ()
{
	return (0);
}
/********
*
*	This routine enables logging of comm trace messages
*
********/

void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/********
*
*	This routine disables logging of comm trace messages
*
********/

void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}
/********
*
*	This routine enables logging of comm trace messages
*
********/

void ablnmonon (unsigned short line)
{
	linemon [line] = TRUE;
}

/********
*
*	This routine disables logging of comm trace messages
*
********/

void ablnmonoff (unsigned short line)
{
	linemon [line] = FALSE;
}

/********
*
*	This routine enables logging of resource trace messages
*
********/

void RTRACEON (unsigned short line)
{
	modrestrace [line] = TRUE;
}

/********
*
*	This routine disables logging of resource trace messages
*
********/

void RTRACEOFF (unsigned short line)
{
	modrestrace [line] = FALSE;
}

/********
*
*	This routine controls logging of trace messages
*
********/

void TRACELEVEL (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}

#ifndef TEST
int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER1 (unsigned short ln, char *mode, unsigned short delay,
			unsigned short adapter_addr, unsigned short sec_chan)
{
	if ( ln < ABLINES )
	{
	    abadapteraddr[ln] = adapter_addr;
	    lnmode [ln].dualchannel = sec_chan;
	    taskId [ln] = taskSpawn (tasknames [ln],
                                     AB_PRIORITY,
                                     AB_TASK_OPTIONS,
                                     AB_STACK, MAIN,
                                     ln,
                                     mode,
                                     delay,0,0,0,0,0,0,0);

	    logMsg ("Started the ABPLC driver on line %d\n", ln,0,0,0,0,0);

	    remCurIdGet (user, password);
	    return (1);
	}
	else
	{
	    logMsg ("Invalid line number %d\n", ln,0,0,0,0,0);
	    return (-1);
	}
}

/*
int STARTDRIVER2 (unsigned short ln, char *mode, unsigned short delay,
			unsigned short adapter_addr)
{
	if ( ln < ABLINES )
	{
	    abadapteraddr[ln] = adapter_addr;
	    taskId [ln] = taskSpawn (tasknames [ln],
                                     AB_PRIORITY,
                                     AB_TASK_OPTIONS,
                                     AB_STACK, MAIN,
                                     ln,
                                     mode,
                                     delay);

	    logMsg ("Started the ABPLC driver on line %d\n", ln);

	    remCurIdGet (user, password);
	    return (1);
	}
	else
	{
	    logMsg ("Invalid line number %d\n", ln);
	    return (-1);
	}
}
*/
#endif

/********
*
* Set communication logic time delays to handle half/full duplex,
* radio delays, etc 
*
********/

void SETDELAYS (unsigned short line,
		unsigned short tickcount1,
		unsigned short tickcount2,
		unsigned short tickcount3)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
	pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay [line]   = tickcount3;  /* after sending last character, but before dropping RTS     */
}


int ASSIGNGROUP (unsigned short line, unsigned short group)
{
    if (line < ABLINES)
    {
        if (group <= MAXGROUPNUM)
        {
            abplcResGroups [line] = group;
            logMsg ("Assigned Line %d to Group %d\n", line, group,0,0,0,0);
            return (1);
        }
        else
        {
            logMsg ("Invalid Group Assignment: line %d: group number must be less than %d.\n", line, MAXGROUPNUM+1,0,0,0,0);
            return (-1);
        }
    }
    else
    {
        logMsg ("Invalid Group Assignment: line %d: line number must be less than %d\n", line, ABLINES,0,0,0,0);
        return (-1);
    }
}

void abplcgrouptable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager:  Limitorque Driver Line to Group Map Table\n");
    printf (" -----------------------------------------------------------------------\n");
    printf ("  Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp \n");

    x = 8;
    y = ABLINES/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d  ",
                    index/10,
                    index%10,
                    abplcResGroups [index]/10,
                    abplcResGroups [index]%10);
        }
        printf ("\n");
    }
}

void abplclocktable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Grp:Flg   Grp:Flg   Grp:Flg   Grp:Flg\n");

    x = 4;
    y = MAXGROUPNUM/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d   ",
                    (index+1)/10,
                    (index+1)%10,
                    resGroupLock [index]/10,
                    resGroupLock [index]%10);
        }
        printf ("\n");
    }
}

void abplclockall (void)
{
    unsigned short i;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Group  Flag  Trip Name\n");
    for (i = 0; i < MAXGROUPNUM; i++)
    {
        printf ("   %d%d     %d%d",
                    (i+1)/10,
                    (i+1)%10,
                    resGroupLock [i]/10,
                    resGroupLock [i]%10);
        if (resGroupTripName[i])
        {
            printf ("   %s\n", *resGroupTripName[i]);
        }
        else
        {
            printf ("\n");
        }
    }
}

void abplcsetlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Setting Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 1;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1,0,0,0,0);
    }
}

void abplcclrlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Clearing Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 0;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1,0,0,0,0);
    }
}

void abplcgrouphelp (void)
{
    printf (" Serial Allen Bradley Driver Group Related Functions\n");
    printf ("\n");
    printf (" abplcResGroup(N, G)     Assign line N to group G (valid G range is 1 to 16)         \n");
    printf (" abplcgrouptable         Display the Limitorque's line to group assignment table.    \n");
    printf (" abplclocktable          Display the resource group lock Global Array.               \n");
    printf (" abplclockall            Display the resource group lock and trip name Global Array. \n");
    printf (" abplcsetlock (G)        Set the resource group lock for group G. (1 to 16)          \n");
    printf (" abplcclrlock (G)        Clear the resource group lock for group G. (1 to 16)        \n");
    printf (" abplcgrouphelp          Display this help message.                                  \n");
    printf ("\n");
}


/**********
*
*      abplc_driver
*
*      The purpose of this task is to scan the allen bradley plc
*      lines. It will maintain a configuration list supporting online additions
*      and repplacement of modules, and  maintain a table of most recently
*      scanned values.
*
**********/
void MAIN (unsigned short line, unsigned char *mode, unsigned short delay)
{
	unsigned	short 	mod, cfgchk, cnt, modspolled, onlinefreq;
	unsigned	short 	activity, pstate, lstate, execute, command,i;
	long	        	this_time, last_time;
	ABPLC          		*pmod;
	RXLINE          	*rxp;
        unsigned        short   group;

	/* Initialize the data structures */

	intermsgdelay [line] = delay;
	pretxdelay [line] = 0;
	posttxdelay [line] = 0;
/*?	linfo [line].loading = FALSE; */

	resresponse [line] = FALSE;
	resnames [line] [0] = 0;
	prestable [line] = NULL;

	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = TRUE;

	activity_time [line] = tickGet ();
	lastactivity [line] = line_activity [line] = FALSE;

/* wep: output queue initialization */

	oq [line] = (OUTPUTQUE *) calloc (1, (sizeof (OUTPUTQUE)));
	if (!oq [line])
	{
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n", line,0,0,0,0,0);
	    return;
	}

/* wep: communication initialization */

	rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
	if (!rxlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line,0,0,0,0,0);
	    return;
	}
	txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
	if (!txlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line,0,0,0,0,0);
	    return;
	}
	lnmode [line].role = ROLEPRIMARY;
	lnmode [line].stat = ACTIVE;	/* Always start on PRIMARY channel */
        taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */
	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
        taskUnlock ();
	if (lnmode [line].dualchannel)
	{	
	    if ((line + 1) < ABLINES)
	    {
		lnmode [line + 1].dualchannel = TRUE;
		lnmode [line + 1].role = ROLEBACKUP;
		lnmode [line + 1].stat = INACTIVE;
        	taskLock ();
		comm_init ((line + 1), mode, &tx_int_proc, &rx_int_proc);
		clear_rts ((line + 1));
        	taskUnlock ();
	    }
	    else
	    {
		logMsg ("Secondary channel exceeds available channels\n",0,0,0,0,0,0);
		return;
	    }
	}
	onlinefreq = 1;		/* causes on_line calls to begin on first pass if master */

	/* Initialize the Rx interrupts to receive once for activity check */
	/* enable the receiver interrupt after set to ignore */

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);

#ifdef  TEST
	scansome (0);
#endif
	/* Wait for resource to be defined via an initial call to 'register_resource'.*/
	while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
	{
	    if (mltrace [line] == 1)
	    {
	    	logMsg ( "No Resource Defined for line - %d \n", line,0,0,0,0,0);
	    }
	    taskDelay (120);
	}

	/* Start out as slave */

	resClearCaAnswer (prestable [line]);		/* start quiet */
	resPutLocalState (prestable [line], RES_SLV);
	if (modrestrace [line])
	{
	    logMsg ("1] Became RES_SLV\n",0,0,0,0,0,0);
	}
	taskDelay (300);
	resGetStates (prestable [line], &lstate, &pstate);
	activity = check_line_activity (line, ACTIVITYTIME);

	/* if the partner is not there, be master */

	if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
	{
	    resSetCaAnswer (prestable [line]);
	    resPutLocalState (prestable [line], RES_MSTR);
	    lstate = RES_MSTR;
	    if (modrestrace [line])
	    {
	    	logMsg ("2] Became RES_MSTR\n",0,0,0,0,0,0);
	    }
	}

	/* Task will process all modules sending outputs and getting inputs */
	/* It will then try to configure requested non responding modules   */

	cfgchk = 0;     	/* Init the new config pointer */
	last_time = tickGet (); /* Initialize the time  */

	while (TRUE)
	{
	    activity_time [line] = tickGet ();
	    lastactivity [line] = line_activity [line] = FALSE;

            /************************************/
            /* check for line group disablement */
            /************************************/
            group = abplcResGroups [line];
            if ((group) && (resGroupLock [group-1]))
            {
                if (modrestrace [line])
                {
                    logMsg ("13] Forced to RES_SLV.\n",0,0,0,0,0,0);
                }
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */
                if (modrestrace [line])
                {
                    logMsg ("14] Resource Group Locked     P= %x A= %d \n", pstate, activity,0,0,0,0);
                }
                while (resGroupLock [group-1])
                {
                    group = abplcResGroups [line];
                    if (group)
                    {
                        clear_rts (line); 		/* Make sure line is left for master    */
                        taskDelay (2);
                    }
                    else /* the line has been taken out of the group */
                    {
                        break;
                    }
                }
                if (modrestrace [line])
                {
                    logMsg ("15] Resource Group Unlocked   P= %x A= %d \n", pstate, activity,0,0,0,0);
                    logMsg ("16] Released to RES_SLV.\n",0,0,0,0,0,0);
                }
            }


	    /* we arrive here because we are a slave. 							*/
	    /* we stay here until:    asked to be master by partner. if we reach PLCs, become master.   */
	    /*                        the partner is not master and there is no activity on the line. 	*/

	    while (lstate == RES_SLV)
	    {
		if (pstate != RES_SLVWANT)
		{
		    clear_rts (line); 				/* make sure line is left for master 	*/
		    if (lnmode [line].dualchannel)
		    {
			clear_rts (line + 1);
		    }	
		}

		resresponse [line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand (prestable [line], 0); 		/* clear out commands 			*/
		activity = check_line_activity (line, 10); 	/* wait 10 seconds before checking 	*/
		resGetStates (prestable [line], &lstate, &pstate);

                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 17)) break;

		/* see if needed by partner to be master. if yes, do it and break out of slave state */
		if (pstate == RES_SLVWANTCA)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
		    {
			logMsg ("3] Became RES_MSTR  P= %x A= %d \n", pstate, activity,0,0,0,0);
		    }
		    break;
		}
		/* If partner is there and wants to give it up, try to take it */
		if (pstate == RES_SLVWANT)
		{
		    execute = FALSE;

		    taskDelay (2); /* Time for switch to occur */

		    /* See if anyone is out there and able to respond to a loopback command */
		    for (mod = 1; (mod <= NUMABPLCS); mod++)
		    {
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 18)) break;

			pmod = plcs [line] [mod];
			if (pmod)    /* verify pointer validity prior to use */
			{
			    if ((pmod->was_requested) && (!pmod->cmd_force_offline))
			    {
			        on_line (line, mod);	
			        if ((pmod->is_responding) && (!pmod->cmd_force_offline))
			        {   
				    execute = TRUE;
				    break;
			        }
			    }
			}
		    }
                    /************************************/
                    /* check for line group disablement */
                    if (checkgroup (line, &lstate, 19)) break;

		    /* If someone answered, become master and make sure partner really gave it up */
		    if (execute)
		    {
			resPutLocalState (prestable [line], RES_MSTR);
			lstate = RES_MSTR;
			if (modrestrace [line])
			{
			    logMsg ("4] Became RES_MSTR  P= %x A= %d \n",
					pstate, activity,0,0,0,0);
			}
			execute = FALSE;
			activity_time [line] = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < 60); i++)
			{
			    activity = check_line_activity (line, 2);    /* pause before testing */
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate != RES_MSTR) &&
				(pstate != RES_SLVWANT) && (!activity))
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */

			    resPutLocalState (prestable [line], RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace [line])
			    {
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",
					pstate, activity,0,0,0,0);
			    }
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 

			    resSetCaAnswer (prestable [line]);
			    prepresponses (line);
			    break;
			}
		    }
		}

		/* if the partner is not talking, be master */

		if ((pstate != RES_MSTR) &&
			(pstate != RES_SLVWANT) && (!activity))
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
		    {
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n", 
				pstate, activity,0,0,0,0);
		    }
		    prepresponses (line);
		}
	    }

            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is canceled */

	    while (lstate == RES_SLVWANTCA)
	    {
	        taskDelay(2);                   /* Give OS a chance...                  */

                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 20)) break;

		clear_rts (line); 		/* Make sure line is left for master */
		if (lnmode [line].dualchannel)
		{
		    clear_rts (line + 1);
		}	
		resresponse [line] = FALSE; 	/* Make Sure driver is not responding */
 		resGetStates (prestable [line], &lstate, &pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace [line])
		    {
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",
				pstate, activity,0,0,0,0);
		    }
		    break;
		}
		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
		    {
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",
				pstate, activity,0,0,0,0);
		    }
		    prepresponses (line);
		}
 	    }

            /****************************************************************************************/
	    /* in normal operation this code should never execute. it has, however, been seen to    */
            /* execute when the database has been inadvertently configured with the same resource   */
	    /* assigned to two different drivers in the same IOC. The state does funny things.      */
            /****************************************************************************************/
	    while (lstate == RES_SLVWANT)
	    {
                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 21)) break;

                if (modrestrace [line])
		{
                    /* condition should NEVER occur. print error message every 5 seconds. */
                    logMsg ("Illegal Local Resource State.\n",0,0,0,0,0,0);
                    logMsg ("  Possible Resource Configuration Error:\n");
                    logMsg ("   Check for multiple drivers sharing single Resource.\n");
                    taskDelay (600);
                }
                taskDelay (2);
            }

             /* we come here because we have gone to, or are looping in, the master state.           */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
	    /* It will then try to configure requested non-responding modules.                      */

	    /* it doesn't appear that we ever come here in a RES_SLVWANT lstate mode. it happens    */
	    /*  within this loop, but is never seen by the while loop conditional evaluation.       */

	    last_time = tickGet ();		/* initialize gap */
	    while ((lstate == RES_MSTR) || (lstate == RES_SLVWANT))
	    {
                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 22)) break;

		/* initial stuff */

		resresponse [line] = TRUE; /* Make sure driver is responding. */

		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0);    /* clear out commands */

		/* if relinquish command sent, change state and break out to outer loop */

		if (command == RES_RELINQUISH)
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace [line])
		    {
                       logMsg ("Became RES_SLVWANTCA  P= %x A= %d \n",
				pstate, activity,0,0,0,0);
		    }
		    break;
		}

		modspolled = 0;

		/* call 'scan_plc' for each PLC device, unless user has */
                /* taken it off line or it is not responding.           */

		for (mod = 1; (mod <= NUMABPLCS); mod++ )
		{
		    pmod = plcs [line] [mod];		/* shorthand pointer 			*/
		    if (pmod)				/* verify pointer validity prior to use */
		    {
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 23)) break;

			if (pmod->cmd_force_offline)
			{ 
			    /* if user has turned this plc offline via pseudo commands,     */
                            /* mark it as not responding.                                   */
 			    pmod->is_responding = FALSE;
	    		}
			else if (pmod->is_responding)
			{
			    modspolled++;


			     /* local/partner lockstep recovery */

			    resGetStates (prestable [line], &lstate, &pstate);
			    if (pstate == RES_MSTR)
			    {
				resClearCaAnswer (prestable [line]);
				resPutLocalState (prestable [line], RES_SLV);
				lstate = RES_SLV;
				clear_rts(line); 		/* Make sure line is left for master */
				if (lnmode [line].dualchannel)
				{
				    clear_rts (line + 1);
				}	
				for (mod = 1; (mod <= NUMABPLCS); mod++ )
				{
		    		    pmod = plcs [line] [mod];		/* shorthand pointer 	*/
		    		    if (pmod)				/* verify pointer validity prior to use */
		    		    {
		     			pmod->is_responding = FALSE;
	    			    }
				}
				if (modrestrace [line])
				{
				    logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity,0,0,0,0);
				}
				taskDelay (((tickGet () % 8) + 5) * 60); /* random 5 to 12 second delay */
				break;
			    }

			    scan_plc (pmod, line, mod);

			    if (!pmod->is_responding)
			    {
				mark_not_valid (pmod);
                            }
			}
		    }
		    /* end of single module action */

		    /* if told to relinquish our master state, stop plc scanning immediately. */
		    /* don't trash the command, so that we can still read it on the next loop */
                    /* through this while statement.                                          */
		    resGetCommand (prestable [line], &command);
		    if (command == RES_RELINQUISH)
		    {
			break;
		    }
		}					/* end of scan loop */

                /* test for lockstep detection or line group disablement. */
                if (lstate != RES_MSTR) break;

		/* try and bring all nonresponding plcs on line, but */
                /* don't bring in more than a specified number.      */

	        cnt = 0;  /* count the number to bring on in one pass */

	        if (--onlinefreq == 0)
		{
		    onlinefreq = BRINGBACKCNT;

		    for ( mod = 1; (mod < NUMABPLCS); mod++)
		    {
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 24)) break;

		       cfgchk++;
		        if (cfgchk == NUMABPLCS)
			{
			    cfgchk=1;
			}
		        pmod = plcs [line] [cfgchk];
			if (pmod)
			{
		            if ((!pmod->is_responding) &&
				(pmod->was_requested) &&
				(!pmod->cmd_force_offline))
			    {
				on_line (line, cfgchk);
				modspolled++;
				cnt++;
				if (cnt == MAXCFGCK)
				{
				    break;
				}
			    }
			}
		    }
	        }

                /************************************/
                /* test for line group disablement. */
                if (lstate != RES_MSTR) break;

		/* see if anyone on the line has been responding. */
                /* if not, try to get partner to become slave.    */
		/* Check for no one responding */

		if (!any_responding (line))
		{
		    if (lnmode [line].dualchannel)
		    {
			if (lnmode [line].stat == ACTIVE)
			{
			    lnmode [line].stat = INACTIVE;
			    lnmode [line + 1].stat = ACTIVE;
			}
			else
			{
			    lnmode [line].stat = ACTIVE;
			    lnmode [line + 1].stat = INACTIVE;
			}

			execute = FALSE;

			for (mod = 1; (mod <= NUMABPLCS); mod++)
			{
                            /************************************/
                            /* check for line group disablement */
                            if (checkgroup (line, &lstate, 25)) break;

			    pmod = plcs [line] [mod];
			    if (pmod)    /* verify pointer validity prior to use */
			    {
				if ((pmod->was_requested) && (!pmod->cmd_force_offline))
				{
			            on_line (line, mod);	

			            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
			            {   
					execute = TRUE;
					break;
			    	    }
				}
			    }
			}
                        /* test for line group disablement. */
                        if (lstate != RES_MSTR) break;

		        if (execute)
			{
			    break;
			}
		    }

		    /* See if it is time to let partner try */

		    this_time = tickGet ();
		    if ((this_time - last_time) > (3 * SLWWINDOW))
		    {   /* # ticks for slave to try */

			/* Switch States to let partner know it's its time to try */

			resPutLocalState (prestable [line], RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace [line])
			{
			    logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",
				pstate,activity,0,0,0,0);
			}

			/* Give partner access to the hardware */

			clear_rts (line);

			if (lnmode [line].dualchannel)
			{
			    clear_rts (line + 1);
			}	

			/* Remember the time of this try */

			last_time = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < SLWWINDOW); i += 10)
			{       		/* SLWINDOW is the # of ticks for slave to try */
                            /************************************/
                            /* check for line group disablement */
                            if (checkgroup (line, &lstate, 26)) break;

			    taskDelay (10);
		    				/* If partner picked up let it have control */
			    activity = check_line_activity (line, 0);  /* check immediately */
			    resGetStates (prestable [line], &lstate, &pstate);
 			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
			    {
				resClearCaAnswer (prestable [line]);
				resPutLocalState (prestable [line], RES_SLV);
				lstate = RES_SLV;
				if (modrestrace [line])
				{
				    logMsg ("11] Became RES_SLV  P= %x A= %d \n",
					 pstate, activity,0,0,0,0);
				}
				taskDelay (240);
				break;
			    }
			}

                        /************************************/
                        /* test for line group disablement. */
                        if (lstate == RES_LOCKED) break;

			/* Go Back to being the Master and take control of the hardware */
			if (lstate != RES_SLV)
			{
                            resSetCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace [line])
			    {
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n",
					pstate,activity,0,0,0,0);
			    }
			}
		    }
		}

		/* take plcs off hold status. the plc's data are not to be held off since now master. */

		for (mod = 1; (mod <= NUMABPLCS); mod++ )
		{
		    pmod = plcs [line] [mod];
		    if (pmod)			/* verify pointer validity prior to use */
		    {        
			pmod->holdflag = FALSE;
                    }
		}
	    }

#ifndef TEST
	    if (modspolled == 0)
	    {
		taskDelay (60);
	    }
	    else 
	    {
		taskDelay (10);
	    }
#endif
#ifdef  TEST
	    scansome();
#endif

	} /* end task loop */
     }


/************************************/
/* check for line group disablement */
/************************************/
int checkgroup (unsigned short line, unsigned short *lstate, unsigned short tracenum)
{
    unsigned short group;

    group = abplcResGroups [line];
    if ((group) && (resGroupLock [group-1]))
    {
        *lstate = RES_LOCKED;
        if (modrestrace [line])
        {
            logMsg ("%d] Resource Group Lock Detected.\n", tracenum,0,0,0,0,0);
        }
        return (TRUE);
    }
    return (FALSE);
}



/*********
*
* Try to bring a PLC on line
*
**********/

static	void    on_line (unsigned short line, unsigned short mod)
{
	ABPLC			*pmod;
	unsigned	short	 offlines;

	pmod = plcs [line] [mod];

/*
**      EVERY PLC MUST HAVE AT LEAST THE DEFAULT STATUS FILE DEFINED
**      & IF I CAN READ THEM THE PLC IS RESPONDING
**
*/

	if (pmod)
	{
	    pmod->nodatastrike = 0;
	    offlines = pmod->no_offlines;	/* avoid extra counts */
	    if (!abdiagstat (pmod, line, mod))
	    {
		pmod->no_offlines = offlines;
		return;
	    }
	    mark_not_valid (pmod);	/* PLC is online - Init data structures */

	    pmod->scanpass = 0;
	    pmod->is_responding = TRUE;
	}
}

/**********
*							
* Mark all plc data elements as not valid     		
*                                             		
**********/                                             	

/* called from on_line and prepresponses      		*/    	

static	void	mark_not_valid (ABPLC *pmod)
{
	unsigned	short	i;
/*
**      INITIALIZE ALL VALUES AS
**              - NOT REQUESTED
**              - DATA NOT VALID
**
*/

	for (i = 0; (i < NUMABOUTS); i++)
	{
	    pmod->abfouts [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINS); i++)
	{
	    pmod->abfins [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABSTATS); i++)
	{
	    pmod->abfstats [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABBITS); i++)
	{
	    pmod->abfbits [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABTMRS); i++)	
	{
	    pmod->abftimers [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABCNTRS); i++)
	{
	    pmod->abfcntrs [i].data_valid = FALSE;
	}
	for (i=0; (i < NUMABCNTRLS); i++)
	{
	    pmod->abfcntrls [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINTS); i++)
	{
	    pmod->abfints [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINTS); i++)
	{
	    pmod->abfexints1 [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINTS); i++)
	{
	    pmod->abfexints2 [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINTS); i++)
	{
	    pmod->abfexints3 [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINTS); i++)
	{
	    pmod->abfexints4 [i].data_valid = FALSE;
	}
}

/**********
*
* Scan an Allen Bradley PLC -  get inputs an set outputs as required
*
**********/

static	void    scan_plc (ABPLC *pmod, unsigned short line, unsigned short mod)
{
	unsigned	short	i, j, maxints, numgroups;

	pmod->scanpass++;
	pmod->tscanpass++;
	checkoutputs (line);

	/* read the Output Image values to be scanned */

	for (i = 0; (i < NUMABOUTS); i++)
	{
	    if (pmod->abfouts [i].was_requested)
	    {
		for (j = 1; ((j < MAXABOUTS) && ((i + j) < NUMABOUTS)); j++)
		{
		    if (!pmod->abfouts [i + j].was_requested)
		    {
			break;
		    }
		}
		numgroups = j;
		if (!readabouts (line, mod, pmod, i, numgroups))
		{
		    return;
		}
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* read the Input Image values to be scanned */

	for (i = 0; (i < NUMABINS); i++)
	{
	    if (pmod->abfins [i].was_requested)
	    {
		for (j = 1; ((j < MAXABINS) && ((i + j) < NUMABINS )); j++)
		{
		    if (!pmod->abfins [i + j].was_requested)
		    {
			break;
		    }
		}
		numgroups = j;
		if (!readabins (line, mod, pmod, i, numgroups))
		{
		    return;
		}
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* read the Status Image values to be scanned */

	for (i = 0; (i < NUMABSTATS); i++)
	{
	    if (pmod->abfstats [i].was_requested)
	    {
		for (j = 1; ((j < MAXABSTATS) && ((i + j) < NUMABSTATS)); j++)
		{
		    if (!pmod->abfstats [i + j].was_requested)
		    {
			break;
		    }
		}
		numgroups = j;
		if (!readabstats (line, mod, pmod, i, numgroups))
		{
		    return;
		}
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* read the Bit File values to be scanned */

	for (i = 0; (i < NUMABBITS); i++)
	{
	    if (pmod->abfbits [i].was_requested)
	    {
		for (j = 1; ((j < MAXABBITS) && ((i + j) < NUMABBITS )); j++)
		{
		    if (!pmod->abfbits [i + j].was_requested)
		    {
			break;
		    }
		}
		numgroups = j;
		if (!readabbits (line, mod, pmod, i, numgroups))
		{
		    return;
		}
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* Adjust the maximum number of integers based on scan pass */

	maxints = NUMFASTABINTS;

	if ((pmod->scanpass % SLOWPASS) == 0)
	{
	    pmod->scanpass = 0;
	    maxints =  NUMABINTS;
	}

	/* read the Default Integer File  values to be scanned */

	for (i = 0; (i < maxints); i++)
	{
	    if (pmod->abfints [i].was_requested)
	    {
		for (j = 1; ((j < MAXABINTS) && ( (i + j) < maxints )); j++)
		{
		    if (!pmod->abfints [i + j].was_requested)
		    {
			break;
		    }
		}
		numgroups = j;
		if (!readabints (line, mod, pmod, ABINTS, pmod->abfints,
				i, numgroups))
		{
		    return;
		}
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* read the First Extended Integer File  values to be scanned */

	if (pmod->extintfile1 < MAXFILE)
	{
	    for (i = 0; (i < maxints); i++)
	    {
		if (pmod->abfexints1 [i].was_requested)
		{
		    for (j = 1; ((j < MAXABINTS) && ((i + j) < maxints )); j++)
		    {
			if (!pmod->abfexints1 [i + j].was_requested)
			{
			    break;
			}
		    }
		    numgroups = j;
		    if (!readabints (line, mod, pmod, pmod->extintfile1,
				pmod->abfexints1 ,i, numgroups))
		    {
			return;
		    }
		    checkoutputs (line);
		    i = (i + j) - 1;
		}
	    }
	}

	/* read the Second Extended Integer File  values to be scanned */

	if (pmod->extintfile2 < MAXFILE)
	{
	    for (i = 0; (i < maxints); i++)
	    {
		if (pmod->abfexints2 [i].was_requested)
		{
		    for (j = 1; ((j < MAXABINTS) && ((i + j)<maxints)); j++)
		    {
			if (!pmod->abfexints2 [i + j].was_requested)
			{
			    break;
			}
		    }
		    numgroups = j;
		    if (!readabints (line, mod, pmod, pmod->extintfile2,
				pmod->abfexints2, i, numgroups))
		    {
			return;
		    }
		    checkoutputs (line);
		    i = (i + j) - 1;
		}
	    }
	}

	/* read the Third Extended Integer File  values to be scanned */

	if (pmod->extintfile3 < MAXFILE)
	{
	    for (i = 0; (i < maxints); i++)
	    {
		if (pmod->abfexints3 [i].was_requested)
		{
		    for (j = 1; ((j < MAXABINTS) && ((i + j) < maxints)); j++)
		    {
			if (!pmod->abfexints3 [i + j].was_requested)
			{
			    break;
			}
		    }
		    numgroups = j;
		    if (!readabints (line, mod, pmod, pmod->extintfile3,
				pmod->abfexints3, i, numgroups))
		    {
			return;
		    }
		    checkoutputs (line);
		    i = (i + j) - 1;
		}
	    }
	}

	/* read the Fourth Extended Integer File  values to be scanned */

	if (pmod->extintfile4 < MAXFILE)
	{
	    for (i = 0; (i < maxints); i++)
	    {
		if (pmod->abfexints4 [i].was_requested)
		{
		    for (j = 1; ((j < MAXABINTS) && ((i + j) < maxints)); j++)
		    {
			if (!pmod->abfexints4 [i + j].was_requested)
			{
			    break;
			}
		    }
		    numgroups = j;
		    if (!readabints (line, mod, pmod, pmod->extintfile4, pmod->abfexints4, i, numgroups))
		    {
			return;
		    }
		    checkoutputs (line);
		    i = (i + j) - 1;
		}
	    }
	}

	/* read the Timer File values to be scanned */

	for (i = 0; (i < NUMABTMRS); i++)
	{
	    if (pmod->abftimers [i].was_requested)
	    {
		for (j = 1; ((j < MAXABTMRS) && ((i + j) < NUMABTMRS)); j++)
		{
		    if (!pmod->abftimers [i + j].was_requested)
		    {
			break;
		    }
		}
		numgroups = j;
		if (!readabtimers (line, mod, pmod, i, numgroups))
		{
		    return;
		}
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* read the Counter File values to be scanned */

	for (i = 0; (i < NUMABCNTRS); i++)
	{
	    if (pmod->abfcntrs [i].was_requested)
	    {
		for (j = 1; ((j < MAXABCNTRS) && ((i + j) < NUMABCNTRS)); j++)
		{
		    if (!pmod->abfcntrs [i + j].was_requested)
		    {
			break;
		    }
		}
		numgroups = j;
		if (!readabcntrs (line, mod, pmod, i, numgroups))
		{
		    return;
		}
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* read the Controllers File values to be scanned */

	for (i = 0; (i < NUMABCNTRLS); i++)
	{
	    if (pmod->abfcntrls [i].was_requested)
	    {
		for (j = 1; ((j < MAXABCNTRLS) && ((i + j) < NUMABCNTRLS)); j++)
		{
		    if (!pmod->abfcntrls [i + j].was_requested)
		    {
			break;
		    }
		}
		numgroups = j;
		if (!readabcntrls (line, mod, pmod, i, numgroups))
		{
		    return;
		}
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}
}


/***********
*
*	checkoutputs
*
*	checks output que and returns if empty.
*	if there is something on the que it attempts to process all
*	pending outputs doing imediate retries. If attempts fail the
*	request is dropped
*
**********/

static	void	checkoutputs (unsigned short line)
{
	OUTQENT			*optr;
	unsigned	short	signal, value, link, adapter, card;
	unsigned	long	bomask, boval;
	ABPLC			*pmod;

	while ((optr = ogetnextp (line)) != NULLP)
	{
	    if ((optr->otype) == AOUTTYPE)
	    {
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;

		pmod = plcs [link] [adapter];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, adapter))
		    {
			return;			/* if not allocated, try. if can't allocate, get out. */
		    }
		    pmod = plcs [link] [adapter];
		}
		card = optr->out.aonode.card;
		signal = optr->out.aonode.aosignal;
		value = optr->out.aonode.aovalue;

		if (mltrace [line] == 2)
		{ 
		    logMsg ("Point[%s] Analog Output Dequeued: line %d, address %d, card %d signal %d, value %d\n",
				optr->out.aonode.pointname,
				link, adapter, card, signal, value);
		}

		if ((!pmod->cmd_force_offline)  && (resresponse [link]) && (pmod->is_responding))
		{
		    if (!setaouts (link, adapter, pmod, card, signal, value))
		    {
			pmod->badoutcnt++;
                        if (mltrace[link] == 2)
                            logMsg("Point[%s] AO DEQUEUE: Output failed: L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                    optr->out.aonode.pointname,
                                    link, adapter, card, signal, value);
			return;
		    }
                    else
                    {
                        if (mltrace[link] == 2)
                            logMsg("Point[%s] AO DEQUEUE: Output succeeded: L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                    optr->out.aonode.pointname,
                                    link, adapter, card, signal, value);
                    }
                }
                else
                {
                    if (mltrace[link] == 2)
                        logMsg("Point[%s] AO DEQUEUE: PLC not available: Output Discarded: L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                optr->out.aonode.pointname,
                                link, adapter, card, signal, value);
                }
	    }
	    else if ((optr->otype) == BOUTTYPE)
	    {
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;

		pmod = plcs [link] [adapter];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, adapter))
		    {
			return;			/* if not allocated, try. if can't allocate, get out. */
		    }
		    pmod = plcs [link] [adapter];
		}

		card = optr->out.bonode.card;
		signal = optr->out.bonode.bosignal;
		boval = optr->out.bonode.bovalue;
		bomask = optr->out.bonode.bomask;

		if (mltrace [line] == 3)
		{ 
		    logMsg ( "Point[%s] Binary Output Dequeued: line %d, address %d, card %d signal %d, value 0x%x, mask 0x%x\n",
				optr->out.bonode.pointname,
				link, adapter, card, signal, boval, bomask);
		}
		if ((!pmod->cmd_force_offline) && (resresponse [link]) && (pmod->is_responding))
		{
		    if (!setbouts (line, adapter, pmod, card, signal, bomask, boval))
		    {
			pmod->badoutcnt++;
                        if (mltrace[link] == 3)
                            logMsg("Point[%s] BO DEQUEUE: Output failed: L=%d, A=%d, C=%d, S=%d, V=0x%x, M=0x%x\n",
                                    optr->out.bonode.pointname,
                                    link, adapter, card, signal, boval, bomask);
			return;
		    }
                    else
                    {
                        if (mltrace[link] == 3)
                            logMsg("Point[%s] BO DEQUEUE: Output succeeded: L=%d, A=%d, C=%d, S=%d, V=0x%x, M=0x%x\n",
                                    optr->out.bonode.pointname,
                                    link, adapter, card, signal, boval, bomask);
                    }
                }
                else
                {
                    if (mltrace[link] == 3)
                        logMsg("Point[%s] BO DEQUEUE: PLC not available: Output Discarded: L=%d, A=%d, C=%d, S=%d, V=0x%x, M=0x%x\n",
                                optr->out.bonode.pointname,
                                link, adapter, card, signal, boval, bomask);
		}
	    }
	    oreleasefull (line);     /* release the output que entry */
	}
	return;
}

/**********
*
*      aidriver
*
*      This routines main purpose is to return the analog input value for the
*      specified module. For a module value
*      a (-1) will be returned if there is no valid data ready.
*
**********/

int	AIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal,
			unsigned short *pvalue, unsigned short conversion,
			unsigned char *resname)
{
	ABPLC 			*pmod;
	unsigned	short 	blkix, elemix, subelement;

	if (!rangeok (link, adapter, card, signal))
	{
	    return (-1);
	}
	if (conversion != conversion)
	{
	    return (-1);        /* No warnings */
	}
	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 2: /* The program Load request */
		*pvalue = pmod->prog_load_stat;
		break;

	    case 3: /* PLC Program Load Block Number */
		*pvalue = pmod->prog_load_page;
		break;

	    case 4: /* Set the program number to Load */
		*pvalue = pmod->prog_load_number;
		break;

	    case 5: /* Output Messages */
		*pvalue = pmod->no_dataout_msgs & 0x7fff;
		break;

	    case 6: /* Input Messages */
		*pvalue = pmod->no_datain_msgs & 0x7fff;
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = pmod->no_rxnoresp & 0x7fff;
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = pmod->no_txnoresp & 0x7fff;
		break;

	    case 9: /* Data Echo Errors */
		*pvalue = pmod->no_dataerr & 0x7fff;
		break;

	    case 10: /* Message Retries */
		*pvalue = pmod->no_retries & 0x7fff;
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = pmod->no_rxhwerrs & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = pmod->no_txhwerrs & 0x7fff;
		break;

	    case 13: /* CRC errors */
		*pvalue = pmod->no_crcerrs & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*pvalue = pmod->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = pmod->badoutcnt & 0x7fff;
		break;

	    case 18: /* What is the backup mode for the line*/
		*pvalue = backup_mode [link];
		break;

	    case 19: /* What is the selected channel for the line */
		*pvalue = channel_select [link];
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}

	if ((card == ABTIMERS) || (card == ABCOUNTERS) || (card == ABCNTRLS))
	{
	    blkix = (signal / 3) / ABNOGRPELEMS;
	    elemix = ((signal / 3) % ABNOGRPELEMS);
	    subelement = signal % 3;
	}
	else
	{
	    blkix = (signal / ABNOGRPELEMS);
	    elemix = (signal % ABNOGRPELEMS);
	}

	setrequested (pmod, card, blkix);

	if (!resresponse [link])
	{
	    return (-1);
	}
	if (pmod->holdflag)
	{
	    return (-2);
	}
	if (!pmod->is_responding)
	{
	    return (-1);
	}
	return (fetchvalue (pmod, card, blkix, elemix, subelement, pvalue));
}

/**********
*
*	abplc_aodriver
*
*	This routines main purpose is to set requested analog outputs to the
*	specified module.
*
**********/

int	AODRIVER (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal,
			double dval, unsigned short value,
			unsigned short conversion, unsigned char *resname)
{
	ABPLC 			*pmod;
	unsigned	short 	blkix;
	OUTQENT			*oqp;

	if (!rangeok (link, adapter, card, signal))
	{
	    return (-1);
	}
	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 2: /* Set the program Load request */
		if (value != 0)
		{
		    pmod->prog_load_stat = PLC_LOAD_REQUESTED;
		}
		break;

	    case 4: /* Set the program number to Load */
		pmod->prog_load_number = value;
		break;

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats (pmod);
		}
		break;

	    case 16: /* Force the PLC offline */
		pmod->cmd_force_offline = (value != 0);
		pmod->is_responding = (value != 0);
		break;

	    case 18: /* What is the backup mode for the line*/
		backup_mode [link] = (value != 0);
		break;

	    case 19: /* What is the selected channel for the line */
		channel_select [link] = (value != 0);
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	if ((card == ABTIMERS) || (card == ABCOUNTERS) ||(card == ABCNTRLS))
	{
	    blkix = (signal / 3) / ABNOGRPELEMS;
	}
	else
	{
	    blkix = (signal / ABNOGRPELEMS);
	}

	setrequested (pmod, card, blkix);

	if (!resresponse [link])
	{
	    return (-2);
	}
	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
	    return (-1); /* output que is full */
	}
	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;
	oqp->out.aonode.aovalue = value;
	strncpy (oqp->out.aonode.pointname, pointname, 38);

	omarkfull (link); /* Mark this entry as ready for output */

	if (mltrace [link] == 2)
	{ 
	    logMsg ("Point[%s] Analog Output Queued to line %d, address %d, card %d signal %d, value %d\n",
			pointname, link, adapter, card, signal, value);
	}
	return (0);
}

/**********
*
*      abplc_aoread
*
*      This routines main purpose is to return the value last read back
*      from the analog output hardware. This is used to initialize analog
*      outputs.
*
**********/

int	AOREAD (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal,
		unsigned short *pvalue, unsigned short conversion, 
		unsigned char *resname)
{
	ABPLC			*pmod;
	unsigned	short 	blkix, elemix, subelement;

	if (!rangeok (link, adapter, card, signal))
	{
	    return (-1);
	}
	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1);   /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 2: /* Set the program Load request */
		*pvalue = pmod->prog_load_stat;
		break;

	    case 4: /* Set the program number to Load */
		*pvalue = pmod->prog_load_number;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 18: /* What is the backup mode for the line*/
		*pvalue = backup_mode [link];
		break;

	    case 19: /* What is the selected channel for the line */
		*pvalue = channel_select [link];
		break;

	    default:
		return(-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}

	pmod->was_requested = TRUE;

	if ((card == ABTIMERS) || (card == ABCOUNTERS) || (card == ABCNTRLS))
	{

	    blkix = (signal / 3) / ABNOGRPELEMS;
	    elemix = ((signal / 3) % ABNOGRPELEMS);
	    subelement = signal % 3;
	}
	else
	{
	    blkix = (signal / ABNOGRPELEMS);
	    elemix = (signal % ABNOGRPELEMS);
	}

	setrequested (pmod, card, blkix);

	if (!resresponse [link])
	{
		return (-1);
	}
	if (pmod->holdflag)
	{
		return (-2);
	}
	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}

	return (fetchvalue (pmod, card, blkix, elemix, subelement, pvalue));
}

/***********
*
*      abplc_bidriver
*
*      The main purpose of this routine is to return the request digital input
*      value(s) from the requested card. This routine will return a (-1) if the
*      requested module is the wrong type or the data is not yet valid.
*
***********/

int	BIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal,
			unsigned long mask, unsigned long *pvalue,
			unsigned char *resname)
{
	ABPLC			*pmod;
	unsigned	short	blkix, elemix, subelement, tvallow, tvalhigh;
	unsigned	short	tsignal;
	long			retval;

	if (!plcs [link])
	{
	    return (-1);
	}
	blkix = (signal / 16) / ABNOGRPELEMS;
	elemix = ((signal / 16) % ABNOGRPELEMS);
	subelement = 0;

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 18: /* What is the backup mode for the line*/
		*pvalue = backup_mode [link];
		break;

	    case 19: /* What is the selected channel for the line */
		*pvalue = channel_select [link];
		break;

	    case 20: /* Was the driver started in dual channel mode */
		*pvalue = lnmode [link].dualchannel;
		break;

	    case 21: /* What is the role of this channel */
		*pvalue = lnmode [link].role;
		break;

	    case 22: /* What is the status of this channel */
		*pvalue = lnmode [link].stat;
		break;

	    default:
		return (-1);
	    }

	    return (0);
	}

	if ((card == ABTIMERS) || (card == ABCOUNTERS) || (card == ABCNTRLS))
	{
	    tsignal = (signal / 16) * 3; /* adjust for skip of data */
	}
	else
	{
	    tsignal = (signal / 16);
	}
	if (!rangeok (link, adapter, card, tsignal))
	{
	    return (-1);
	}
	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	setrequested (pmod, card, blkix);

	if (!resresponse [link])
	{
	    return (-1);
	}
	if (pmod->holdflag)
	{
	    return (-2);
	}

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}

	if ((fetchvalue (pmod, card, blkix, (elemix & 0xFFFE), subelement, &tvallow)) == -1)
	{
		return (-1);
	}
	if ((fetchvalue (pmod, card, blkix, (elemix | 1), subelement, &tvalhigh)) == -1)
	{
		return (-1);
	}
	retval = ((long) tvalhigh << 16);
	retval = retval + tvallow;
	*pvalue = (retval & mask);
	return (0);
}

/**********
*
*      abplc_bodriver
*
*      The main purpose of this routine is to set the request digital output
*      value(s) on the requested card. This routine will return a (-1) if the
*      requested module is the wrong type or not configured yet.
*
***********/

int	BODRIVER (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal,
			unsigned long value, unsigned long mask,
			unsigned char *resname)
{
	ABPLC			*pmod;
	OUTQENT			*oqp;
	unsigned	short	tsignal;
	unsigned	short	blkix;

	blkix = (signal / 16) / ABNOGRPELEMS;

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{
	    switch (signal & 0x1f)
	    {
	    case 2: /* Set the program Load request */
		if (value != 0)
		{
		    pmod->prog_load_stat = PLC_LOAD_REQUESTED;
		}
		break;

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats (pmod);
		}
		break;

	    case 16: /* Force the PLC offline */
		pmod->cmd_force_offline = (value != 0);
		pmod->is_responding = (value != 0);
		break;

	    case 18: /* What is the backup mode for the line*/
		backup_mode [link] = (value != 0);
		break;

	    case 19: /* What is the selected channel for the line */
		channel_select [link] = (value != 0);
		break;

	    case 22: /* What is the status of this channel */
		if (lnmode [link].dualchannel)
		{
		    if (lnmode [link].role == ROLEPRIMARY)
		    {
			lnmode [link].stat = (value != 0);
			lnmode [link + 1].stat = (value == 0);
		    }
		    else
		    {
			lnmode [link].stat = (value != 0);
			lnmode [link - 1].stat = (value == 0);
		    }
		}

	    default:
		return (-1);
	    }
	    return (0);
	}

	if ((card == ABTIMERS) || (card == ABCOUNTERS) || (card == ABCNTRLS))
	{
	    tsignal = (signal / 16) * 3; /* adjust for skip of data */
	}
	else
	{
	    tsignal = (signal / 16);
	}
	if (!rangeok (link, adapter, card, tsignal))
	{
	    return (-1);
	}
	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}

	setrequested (pmod, card, blkix);

	if (!resresponse [link])
	{
	    return (-1);
	}
	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}

	oqp = ogetemptyp (link);

	if (oqp == NULLP)
	{
	    return (-1); /* output que is full */
	}
	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bovalue = value;
	strncpy (oqp->out.bonode.pointname, pointname, 38);

	omarkfull (link); /* Mark this entry as ready for output */

	if (mltrace [link] == 3)
	{ 
	    logMsg ("Point[%s] Binary Output Queued to line %d, address %d, card %d signal %d, value 0x%x, 0x%x\n",
			pointname, link, adapter, card, signal, value, mask);
	}
	return (0);
}

/**********
*
*      abplc_boread
*
*      This routines main purpose is to return the value last read back
*      from the digital output hardware. This is used to initialize digital
*      outputs. This will return a (-1) if the module is the wrong type or
*      the data is not yet valid
*
**********/

int	BOREAD (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal,
		unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)
{
	ABPLC			*pmod;
	unsigned	short	blkix, elemix, subelement, tvallow, tvalhigh;
	unsigned	short	tsignal;
	long			retval;

	if (!plcs [link])
	{
	    return (-1);
	}
	blkix = (signal / 16) / ABNOGRPELEMS;
	elemix = ((signal / 16) % ABNOGRPELEMS);
	subelement = 0;

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}


	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 2: /* Set the program Load request */
		*pvalue = 0;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 18: /* What is the backup mode for the line*/
		*pvalue = backup_mode [link];
		break;

	    case 19: /* What is the selected channel for the line */
		*pvalue = channel_select [link];
		break;

	    case 22: /* What is the status of this channel */
		*pvalue = lnmode [link].stat;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if ((card == ABTIMERS) || (card == ABCOUNTERS) || (card == ABCNTRLS))
	{
	    tsignal = (signal / 16) * 3; /* adjust for skip of data */
	}
	else
	{
	    tsignal = (signal / 16);
	}

	if (!rangeok (link, adapter, card, tsignal))
	{
	    return (-1);
	}
	if (resname != 0)
	{
	    register_resource (link, pmod, resname, pointname); 
	}
	if (!resresponse [link])
	{
	    return (-1);
	}
	if (pmod->holdflag)
	{
	    return (-2);
	}
	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}
	setrequested (pmod, card, blkix);

	if ((fetchvalue (pmod, card, blkix, (elemix & 0xFFFE), subelement, &tvallow)) == -1)
	{
	    return (-1);
	}
	if ((fetchvalue (pmod, card, blkix, (elemix | 1), subelement, &tvalhigh)) == -1)
	{
	    return (-1);
	}

	retval = ((long) tvalhigh << 16);
	retval = retval + tvallow;
	*pvalue = (retval & mask);
	return (0);
}

/***********
*
*	register_resource
*
*	This routine is used to initialize the resource pointers
*	If this is the first time the resource for this line is being
*	referenced the pointer to the resource table entry will be set
*	and the resource name will be saved. If the resouce name has
*	already been set, this routine will verify that all other points
*	for this driver are using the same resource name.
*
**********/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BOREAD,				
			    BIDRIVER, and BODRIVER */                               	

static	void 	register_resource (unsigned short link, ABPLC *pmod,
				unsigned char *resname,
				unsigned char *pointname)
{
    int group;

    if (resnames [link] [0] == 0) /* This is the first reference */
    {
        if (resGetByName (resname, &prestable [link]) != RES_OK)
        {
            logMsg ("Resource not found in table - %s, %s\n",
                     pointname, resname ,0,0,0,0);
        }
        else
        {
            strcpy (resnames [link], resname);
            group = abplcResGroups [link];
            if (group)
            {
                if (assignLockGroup (group, resname) == ERROR)
                {
                    logMsg ("assignLockGroup error: Line = %d, Group = %d, Point Name = %s, Resource Name = %s\n",
                             link, group, pointname, resname,0,0);
                }
            }
        }
    }
    else
    {
        if (strcmp (resnames [link], resname) != 0)
        {
            logMsg ("Resource name conflict - %s,  %s, %s\n",
                     pointname, resnames [link], resname ,0,0,0);
        }
    }
}

/**********
*
*	rangeok
*
*	routine to check the boundaries for link adapter card and signal
*
**********/
static	int	rangeok (unsigned short link,unsigned short adapter,
		unsigned short card,unsigned short signal)
{
	ABPLC  *pmod;

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (FALSE);			/* if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (link >= ABLINES)
	{
	    return (FALSE);
	}
	if (adapter >= NUMABPLCS)
	{
	    return (FALSE);
	}
	if ((card > ABINTS) &&
	    (card != pmod->extintfile1) &&
	    (card != pmod->extintfile2) &&
	    (card != pmod->extintfile3) &&
	    (card != pmod->extintfile4) &&
	    (card != PSEUDO))
	    {

	    /* Look for an empty slot to define a new extended integer file */

	    if (pmod->extintfile1 == MAXFILE+1)
	    {
		pmod->extintfile1 = card;
		return (TRUE);
	    }
	    if (pmod->extintfile2 == MAXFILE+1)
	    {
		pmod->extintfile2 = card;
		return (TRUE);
	    }
	    if (pmod->extintfile3 == MAXFILE+1)
	    {
		pmod->extintfile3 = card;
		return (TRUE);
	    }
	    if (pmod->extintfile4 == MAXFILE+1)
	    {
		pmod->extintfile4 = card;
		return (TRUE);
	    }
	    return (FALSE);
	}
	if ((card == ABOUTIMG)   && (signal > MAXOUTIMG))
	{
	    return (FALSE);
	}
	if ((card == ABINIMG)    && (signal > MAXINIMG))
	{
	    return (FALSE);
	}
	if ((card == ABSTATUS)   && (signal > MAXSTATUS))
	{
	    return (FALSE);
	}
	if ((card == ABBITS)     && (signal > MAXBITS))
	{
	    return (FALSE);
	}
	if ((card == ABTIMERS)   && (signal > MAXTIMERS*3))
	{
	    return (FALSE);
	}
	if ((card == ABCOUNTERS) && (signal > MAXCOUNTERS*3))
	{
	    return (FALSE);
	}
	if ((card == ABCNTRLS)   && (signal > MAXCNTRLS*3))
	{
	    return (FALSE);
	}
	if ((card >= ABINTS)     && (signal > MAXINTS))
	{
	    return (FALSE);
	}
	return (TRUE);
}

/**********
*
*	setrequested
*	routine to set the requested flag for the selected block
*
**********/

static	void	setrequested (ABPLC *pmod, unsigned short card, unsigned short blkix)
{
	if (card == ABINTS)
	{
	    pmod->abfints[blkix].was_requested = TRUE;
	    return;
	}
	if (card == ABOUTIMG)
	{
	    pmod->abfouts[blkix].was_requested = TRUE;
	    return;
	}
	if (card == ABINIMG)
	{
	    pmod->abfins[blkix].was_requested = TRUE;
	    return;
	}
	if (card == ABSTATUS)
	{
	    pmod->abfstats[blkix].was_requested = TRUE;
	    return;
	}
	if (card == ABBITS)
	{
	    pmod->abfbits[blkix].was_requested = TRUE;
	    return;
	}
	if (card == ABTIMERS)
	{
	    pmod->abftimers[blkix].was_requested = TRUE;
	    return;
	}
	if (card == ABCOUNTERS)
	{
	    pmod->abfcntrs[blkix].was_requested = TRUE;
	    return;
	}
	if (card == ABCNTRLS)
	{
	    pmod->abfcntrls[blkix].was_requested = TRUE;
	    return;
	}
	if (card == pmod->extintfile1)
	{
	    pmod->abfexints1[blkix].was_requested = TRUE;
	    return;
	}
	if (card == pmod->extintfile2)
	{
	    pmod->abfexints2[blkix].was_requested = TRUE;
	    return;
	}
	if (card == pmod->extintfile3)
	{
	    pmod->abfexints3[blkix].was_requested = TRUE;
	    return;
	}
	if (card == pmod->extintfile4)
	{
	    pmod->abfexints4[blkix].was_requested = TRUE;
	    return;
	}
}

/**********
*
*	fetchvalue
*	routine to get a value from the Allen Bradley data structures
*
**********/
static	int  fetchvalue (ABPLC *pmod, unsigned short card,
		 unsigned short blkix, unsigned short elemix,
		 unsigned short subelement,unsigned short *pvalue)
{
	if (card == ABOUTIMG)
	{
	    if (!pmod->abfouts [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfouts [blkix].oimgdata [elemix];
	    return (0);
	}
	if (card == ABINIMG)
	{
	    if (!pmod->abfins [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfins [blkix].iimgdata [elemix];
	    return (0);
	}
	if (card == ABSTATUS)
	{
	    if (!pmod->abfstats [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfstats [blkix].statdata[ elemix];
	    return (0);
	}
	if (card == ABBITS)
	{
	    if (!pmod->abfbits [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfbits [blkix].bitdata [elemix];
	    return (0);
	}
	if (card == ABTIMERS)
	{
	    if (!pmod->abftimers [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue =     pmod->abftimers [blkix].timerdata [elemix].cdata [subelement];
	    return (0);
	}
	if (card == ABCOUNTERS)
	{
	    if (!pmod->abfcntrs [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfcntrs [blkix].cntrdata [elemix].cdata [subelement];
	    return (0);
	}
	if (card == ABCNTRLS)
	{
	    if (!pmod->abfcntrls [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfcntrls [blkix].cntrldata [elemix].cdata [subelement];
	    return (0);
	}
	if (card == ABINTS)
	{
	    if (!pmod->abfints [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfints [blkix].intdata [elemix];
	    return (0);
	}
	if (card == pmod->extintfile1)
	{
	    if (!pmod->abfexints1 [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfexints1 [blkix].intdata [elemix];
	    return (0);
	}
	if (card == pmod->extintfile2)
	{
	    if (!pmod->abfexints2 [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfexints2 [blkix].intdata [elemix];
	    return (0);
	}
	if (card == pmod->extintfile3)
	{
	    if (!pmod->abfexints3 [blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfexints3 [blkix].intdata [elemix];
	    return (0);
	}
	if (card == pmod->extintfile4)
	{
	    if (!pmod->abfexints4[blkix].data_valid)
	    {
		return (-1);
	    }
	    *pvalue = pmod->abfexints4 [blkix].intdata [elemix];
	    return (0);
	}
	return (-1);
}

/**********
*
*      Initialize the Queue
*
**********/

static	void	outqueinit (unsigned short line)
{
	oq [line]->ooutix = oq [line]->oinix = 0;
}

/**********
*
*  ogetempty - get the next available slot on the output list
*
**********/

static	OUTQENT	*ogetemptyp (unsigned short line)
{
	if (((oq [line]->oinix + 1) % OUTQSIZE) != oq [line]->ooutix)
	{
	    return (&oq [line]->outque [oq [line]->oinix]);
	}
	else
	{
	    return (NULLP);
	}
}

/**********
*
* omarkfull - mark the next block as full
*
**********/

static	void	omarkfull (unsigned short line)
{
	oq [line]->oinix = ((oq [line]->oinix + 1) % OUTQSIZE);
}


/**********
*
*  ogetfullp - get the next full slot on the output list
*
**********/

static	OUTQENT	*ogetnextp (unsigned short line)
{
	if (oq [line]->ooutix != oq [line]->oinix)
	{
	    return (&oq [line]->outque [oq [line]->ooutix]);
	}
	else
	{
	    return (NULLP);
	}
}

/**********
*
* oreleasefull - release the current full output block
*
**********/

static	void	oreleasefull (unsigned short line)
{
	if (oq [line]->ooutix == oq [line]->oinix)
	{
	    return;
	}
	oq [line]->ooutix = ((oq [line]->ooutix + 1) % OUTQSIZE);
}

/***********
*
*      link_status
*
*      The purpose of this routine is to print out the state of each of the
*      analog devices lines and the statistics gathered about them.
*
**********/

static	void	link_status (unsigned short line)
{
	if (line > ABLINES - 1)
	{
	    return;
	}
}

/**********
*                                                                              
*	allocate_plc                                                            
*                                                                              
*	The purpose of this routine is to allocate the memory for a single      
*	plc data structure. If not successful, a console error message is  	
*	printed and an error flag is returned to the caller.                    
*	If successful, the newly allocated data structures are initialized.     
*                                                                             	
**********/

static	int	allocate_plc (unsigned short line, unsigned short plc )
{
	plcs [line] [plc] = (ABPLC *) calloc (1, (sizeof (ABPLC)));
	if (!plcs [line] [plc])
	{
	    logMsg ("Unable to allocate memory",0,0,0,0,0,0);
            logMsg (" for ABPLC data structure on line %d, plc %d\n",line ,plc,0,0,0,0);
	    return (FALSE);
	}
	else
	{
	    logMsg ("Allocated memory for ABPLC data structure on line %d, plc %d\n",line ,plc,0,0,0,0);
	    init_plc_tab (line, plc);	     /*	initialize the data structures. */
	}
	return (TRUE);
}

/**********
*
*      startrx
*
*      The purpose of this routine is to initialize a line table
*      for receive and to enable the receiver.**
*
**********/

static	void	start_rx (unsigned short line, SEMAPHORE *semid,
			unsigned short *pstatus )
{

	RXLINE                  *rxp;

	if (lnmode [line].stat == INACTIVE)
	{
	    if (lnmode [line + 1].stat == ACTIVE)
	    {
		disable_rx_ints (line + 1);
	    }
	    else
	    {
		logMsg ("DUAL CHANNEL ERROR - Both lines are inactive...\n",0,0,0,0,0,0);
	    }
	}
	else
	{
	    disable_rx_ints (line);
	}
	rxp = rxlinetab [line];
	rxp->rxstate = RXINIT;
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	if (lnmode [line].stat == INACTIVE)
	{
	    if (lnmode [line + 1].stat == ACTIVE)
	    {
		enable_rx_ints (line + 1);
	    }
	    else
	    {
		logMsg ("DUAL CHANNEL ERROR - Both lines are inactive...\n",0,0,0,0,0,0);
	    }
	}
	else
	{
	    enable_rx_ints (line);
	}
}

/**********
*
*      stoprx
*
*      The purpose of this routine is to initialize a line table
*      for receive and to disable the receiver.
*
**********/

static	void	stop_rx (unsigned short line)
{
	RXLINE                  *rxp;

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
}

/**********
*
*      rx_int_proc
*
*      The purpose of this routine is to process a receive character interrupt
*      for a given line. (Protocol Specific)
*
**********/

#ifndef TEST

static	void	rx_int_proc (unsigned short line)

#endif

#ifdef TEST

	void	rx_int_proc (unsigned short line)

#endif

{
	unsigned	char	rxchar;
	unsigned 	short	rxstat;
	unsigned 	short	rx_err_mask;
	RXLINE          	*rxp;

	read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);

	if (lnmode [line].stat == INACTIVE)
	{
	    return;
	}
	if (lnmode [line].role == ROLEPRIMARY)
	{
	    rxp = rxlinetab [line];

	    /* Something is sending in data. */

	    line_activity [line] = TRUE;
	}
	else
	{
	    rxp = rxlinetab [line - 1];

	    /* Something is sending in data. */

	    line_activity [line - 1] = TRUE;
	}

	if (rxp->rxstate == RXIGNORE)
	{
	    return;
	}
	if ((rxstat & rx_err_mask) != 0)
	{
	    *(rxp->status) = RXBAD;
	    rxp->rxbuf [299] = rxstat;
	    rxp->rxbuf [300] = rxchar;
	    rxp->rxstate = RXIGNORE;
	    return;
	}

	switch (rxp->rxstate)
	{

	case RXINIT:
	    if (rxchar == DLE)
	    {
		rxp->rxstate = RX2NDCHAR;
	    }
	    return;

	case RX2NDCHAR:
	    if ((rxchar == ACK) || (rxchar == EOT))
	    {
		rxp->rxbuf [0] = rxchar;
		rxp->rxstate = RXIGNORE;
		*(rxp->status) = RXGOOD;
		semGive (rxp->semid);
		return;
	    }
	    if (rxchar == STX)
	    {
		rxp->rxbuf [0] = rxchar;
		rxp->rxix = 1;
		rxp->rxstate = RXGETDATA1;
		return;
	    }
	    rxp->rxstate = RXINIT;  /* Abort the message */
	    return;

	case RXGETDATA1:
	    if (rxchar != DLE)
	    {
		rxp->rxbuf [rxp->rxix++] = rxchar;
		if (rxp->rxix >= MAXRXMSG)
		{
		    rxp->rxstate = RXINIT;  /* Abort the message */
		}
		return;
	    }
	    rxp->rxstate = RXGOTESC;
	    return;

	case RXGOTESC:
	    if (rxchar == DLE)
	    {
		rxp->rxbuf [rxp->rxix++] = rxchar;
		if (rxp->rxix >= MAXRXMSG)
		{
		    rxp->rxstate = RXINIT;  /* Abort the message */
		    return;
		}
		rxp->rxstate = RXGETDATA1;
		return;
	    }
	    if (rxchar == ETX)
	    {
		rxp->rxbuf [rxp->rxix++] = rxchar;
		rxp->rxstate = RXGETCRC1;
		return;
	    }
	    rxp->rxstate = RXINIT;  /* Abort the message */
	    return;

	case RXGETCRC1:
	    rxp->rxbuf [rxp->rxix++] = rxchar;
	    rxp->rxstate = RXGETCRC2;
	    return;

	case RXGETCRC2:
	    rxp->rxbuf [rxp->rxix++] = rxchar;
	    rxp->rxstate = RXIGNORE;
	    *(rxp->status) = RXGOOD;
	    semGive (rxp->semid);
	    return;

	default:  /* Should Never Get Here */
	    rxp->rxstate = RXIGNORE;
	    return;
	}
}

/**********
*
*      check_line_activity
*                                                                             	
*      The purpose of this routine is to process a receive character interrupt	
*      for a given line.                                                      	
*                                                                             	
**********/

/* only called from MAIN  */

static	int	check_line_activity (unsigned short line, unsigned short predelay)
{
	RXLINE          *rxp;
	long		thistime;
	short		status;

	if (predelay != 0)
	{
	    taskDelay (predelay);
	}
	thistime = tickGet ();
	if ((thistime - activity_time [line]) < ACTIVITYTIME)
	{
	    return (lastactivity [line] || (line_activity [line]));
	}
	lastactivity [line] = status = line_activity [line];
	line_activity [line] = FALSE;
	activity_time [line] = thistime;
	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
	return (status);
}

/**********
*
*      starttx
*
*      The purpose of this routine is to initialize a line table
*      for send and to enable the transmitter.
*
**********/

static	void	start_tx (unsigned short line, SEMAPHORE *semid,
			unsigned short *pstatus )
{
	TXLINE                  *txp;

	if (lnmode [line].stat == INACTIVE)
	{
	    if (lnmode [line + 1].stat == ACTIVE)
	    {
		disable_tx_ints (line + 1);
	    }
	    else
	    {
		logMsg ("DUAL CHANNEL ERROR - Both lines are inactive...\n",0,0,0,0,0,0);
	    }
	}
	else
	{
	    disable_tx_ints (line);
	}
	txp = txlinetab [line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */

	if (lnmode [line].stat == INACTIVE)
	{
	    if (lnmode [line + 1].stat == ACTIVE)
	    {
		enable_tx_ints (line + 1);
	    }
	    else
	    {
		logMsg ("DUAL CHANNEL ERROR - Both lines are inactive...\n",0,0,0,0,0,0);
	    }
	}
	else
	{
	    enable_tx_ints (line);
	}
}

/**********
*
*      stoptx
*
*      The purpose of this routine is to initialize a line table
*      for receive and to disable the receiver.
*
**********/

static	void	stop_tx (unsigned short line)
{
	TXLINE	*txp;

	if (lnmode [line].stat == INACTIVE)
	{
	    if (lnmode [line + 1].stat == ACTIVE)
	    {
		disable_tx_ints (line + 1);
	    }
	    else
	    {
		logMsg ("DUAL CHANNEL ERROR - Both lines are inactive...\n",0,0,0,0,0,0);
	    }
	}
	else
	{
	    disable_tx_ints (line);
	}
	txp = txlinetab [line];
	txp->txdisable = TRUE;
}

/**********
*
*      tx_int_proc
*
*      The purpose of this routine is to process a receive character interrupt
*      for a given line.
*
**********/

#ifndef TEST

static	void	tx_int_proc (unsigned short line)

#endif

#ifdef TEST


	void	tx_int_proc (unsigned short line)
#endif
{
	unsigned char           txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

	if (lnmode [line].role == ROLEPRIMARY)
	{
	    txp = txlinetab [line];
	}
	else
	{
	    txp = txlinetab [line - 1];
	}
	if (txp->txdisable)
	{
	    return;
	}
	txchar = txp->txbuf [txp->txix++];
	write_tx_hw (line, txchar, &txstat, &tx_err_mask);

	if ((txstat & tx_err_mask) != 0)
	{
	    disable_tx_ints (line);
	    txp->txdisable = TRUE;
	    *(txp->status) = TXBAD;
	    semGive (txp->semid);
	    return;
	}

	if (txp->txix == txp->txmsglen)
	{
	    disable_tx_ints (line);
	    txp->txdisable = TRUE;
	    *(txp->status) = TXGOOD;
	    semGive (txp->semid);
	    return;
	}

	if (txp->txix >= MAXTXMSG)
	{
	    disable_tx_ints (line);
	    txp->txdisable = TRUE;
	    *(txp->status) = TXBAD;
	    semGive (txp->semid);
	    return;
	}
}

/**********
*
*      msgxfer
*
*      The purpose of this routine is to transmit a buffer to the
*      Allen Bradley PLCs and to await a response. The transmit and receive
*      buffers are in their respective line tables. This routine will retry
*      the message up to a maximum number of times or until a data response
*      is received with a proper checksum.
*              returns         XFERGOOD if response received
*                              XFERBAD  if no good repsonse is received
*
**********/

static	unsigned	short	msgxfer (unsigned short fline,
				unsigned short resptype, ABPLC *pmod)
{
	unsigned short  retry, txstatus, rxstatus, rxlen, no_char_tmout;
	unsigned short	line, wrongreply, wrflag, ix;
	RXLINE          *rxp;
	TXLINE          *txp;
	unsigned char   csums [2];
	unsigned char	txlnbuf [512];
	unsigned char	rxlnbuf [512];

	line = (fline & 0x1f);          /* strip off the no retry flag*/

	rxp = rxlinetab [line];
	txp = txlinetab [line];

	wrongreply = 0;
	no_char_tmout = 0;

	for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++ )
	{
	    if (intermsgdelay [line] != 0)
	    {
		taskDelay (intermsgdelay [line]);
	    }

/* this looks like a good place to 'set_rts', as long as the MAIN task is */
/*  called with a delay > rts/cts delay on the radio transmitter, if not, do our own. */
	    set_rts (line);

	    if (lnmode [line].dualchannel)
	    {
		set_rts (line + 1);
	    } 	

	    if (pretxdelay [line] != 0)
	    {
		taskDelay (pretxdelay [line]);
	    }
	    txstatus = IO_TIMEOUT;
	    rxstatus = IO_TIMEOUT;
	    wrflag = FALSE;
	    semTake (semids [line] [TXSEM], NO_WAIT);
	    semTake (semids [line] [RXSEM], NO_WAIT);
	    if (linemon [line])
	    {
		txlnbuf [0] = 0;
		for (ix = 0; ix < txp->txmsglen; ix++)
		{
		    sprintf (&txlnbuf [ix * 3], "%02x ", txp->txbuf [ix]);
		}
		txlnbuf [ix * 3] = 0;
		logMsg ("TX: %s\n", txlnbuf,0,0,0,0,0);
	    }

	    start_rx (line, semids [line] [RXSEM], &rxstatus);
	    start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */
	    semTake (semids [line] [TXSEM], TXTIMEOUT);

	    stop_tx (line);

	    if (posttxdelay [line] != 0)
	    {
		taskDelay (posttxdelay [line]);
	    }

/* this looks like a good place to 'set_rts', as long as the MAIN task is */
/*  called with a delay > rts/cts delay on the radio transmitter, if not, do our own. */

	    clear_rts (line);

	    if (lnmode [line].dualchannel)
	    {
		clear_rts (line + 1);
	    }	

	    if (txstatus == TXGOOD)
	    {
		if (resptype == NOREPLY)
		{
		    return (XFERGOOD);
		}
		semTake (semids [line] [RXSEM], (int) (RXTIMEOUT * 2));

		stop_rx (line);

		if (linemon [line])
		{
		    rxlnbuf [0] = 0;
		    for (ix = 0; ix < rxp->rxix; ix++)
		    {
			sprintf (&rxlnbuf [ix * 3], "%02x ", rxp->rxbuf [ix]);
		    }
		    rxlnbuf [ix * 3] = 0;
		    logMsg ("RX: %s\n", rxlnbuf,0,0,0,0,0);
		}

		rxlen = rxp->rxix;
		if (rxstatus == RXGOOD)
		{
		    if (rxp->rxbuf [0] == resptype)
		    {
			if (resptype == STX)
			{
			    makecrc (&rxp->rxbuf [1], rxlen - 3, csums);/* Adjust for STX & CRC*/
			    if ((csums [0] == rxp->rxbuf [rxp->rxix - 2]) &&
				(csums [1] == rxp->rxbuf [rxp->rxix - 1]) )
			    {
				return (XFERGOOD);
			    }
			    else
			    {
				pmod->no_crcerrs++;
				if (modtrace [line])
				{
				    logMsg ("%x%x%x%x Bad CRC\n",
					rxp->rxbuf [rxp->rxix - 2],
					rxp->rxbuf [rxp->rxix - 1],
					csums [0], csums [1],0,0);
				}
			    }
			}
			else 
			{
			    return (XFERGOOD);
			}
		    }
		    else
		    {
			wrflag = TRUE;
			wrongreply++;
		    }
		}
		else if (rxstatus == IO_TIMEOUT)
		{
		    if (modtrace [line])
		    {
		        logMsg ("Receive Timeout... Length: %d\n", rxlen,0,0,0,0,0);
		    }

		    pmod->no_rxnoresp++;

		    if (rxp->rxix == 0)
		    {
			if ((++no_char_tmout) == 3)
			{
			    return (XFERBAD);
			}
		    }
		}
		else
		{
		    if (modtrace [line])
		    {
		        logMsg ("Receive Error\n",0,0,0,0,0,0);
		        logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
			     rxp->rxbuf [299],
			     rxp->rxbuf [300],
			     rxp->rxix,0,0,0);
		    }
		    pmod->no_rxhwerrs++;
		}
	    }
	    else if (txstatus == IO_TIMEOUT)
	    {
		if (modtrace [line])
		{
		    logMsg ("Transmit Timeout\n",0,0,0,0,0,0);
		}
		pmod->no_txnoresp++;
	    }
	    else
	    {
		if (modtrace [line])
		{
		    logMsg ("Transmit Error\n",0,0,0,0,0,0);
		}
		pmod->no_txhwerrs++;
	    }
	    if ((retry != MAXRETRYS) && (!wrflag))
	    {
		pmod->no_retries++;
	    }
	}
	if ( wrongreply == MAXRETRYS)
	{
	    if (modtrace [line])
	    {
	        logMsg ("Wrong reply retries exhausted\n",0,0,0,0,0,0);
	    }
	}
	if (modtrace [line])
	{
	    logMsg ("Xfer Bad\n",0,0,0,0,0,0);
	}
	return (XFERBAD);
}

/**********
*
*      init_plc_tab
*
*      The purpose of this routine is to initialize the line tables for the
*      Allen Bradley I/O
*
**********/

/* only called from allocate_plc  */

static	void	init_plc_tab (unsigned short line, unsigned short mod)
{
	ABPLC  *pmod;

	pmod = plcs [line] [mod];
	if (!pmod)
	{
		return;
	}
	pmod->is_responding = FALSE;
	pmod->holdflag = FALSE;
	pmod->was_requested = FALSE;
	pmod->cmd_force_offline = FALSE;
	pmod->prog_load_stat = PLC_NOT_LOADED;
	pmod->prog_load_number = 0;
	pmod->prog_load_page = 0;
/*?	pmod->plc_start = FALSE; */
/*?	pmod->plc_stop = FALSE; */

	initplc (pmod);
	initstats (pmod);

	linetimers [line] = gettimer ();
	if (linetimers [line] == -1)
	{

		/*  put an error message in here */

	}

	/* Initialize this tasks semaphore*/

	semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
	semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
}

/**********
*
* Cold Init a PLC
*
**********/

/* only called from init_line_tabs  */

static	void	initplc (ABPLC *pmod)
{
	unsigned	short	i;

	for (i = 0; (i < NUMABOUTS); i++)
	{
	    pmod->abfouts [i].was_requested = FALSE;
	    pmod->abfouts [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINS); i++)
	{
	    pmod->abfins [i].was_requested = FALSE;
	    pmod->abfins [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABSTATS); i++)
	{
	    pmod->abfstats [i].was_requested = FALSE;
	    pmod->abfstats [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABBITS); i++)
	{
	    pmod->abfbits [i].was_requested = FALSE;
	    pmod->abfbits [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABTMRS); i++)
	{
	    pmod->abftimers [i].was_requested = FALSE;
	    pmod->abftimers [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABCNTRS); i++)
	{
	    pmod->abfcntrs [i].was_requested = FALSE;
	    pmod->abfcntrs [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABCNTRLS); i++)
	{
	    pmod->abfcntrls [i].was_requested = FALSE;
	    pmod->abfcntrls [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINTS); i++)
	{
	    pmod->abfints [i].was_requested = FALSE;
	    pmod->abfints [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINTS); i++)
	{
	    pmod->abfexints1 [i].was_requested = FALSE;
	    pmod->abfexints1 [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINTS); i++)
	{
	    pmod->abfexints2 [i].was_requested = FALSE;
	    pmod->abfexints2 [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINTS); i++)
	{
	    pmod->abfexints3 [i].was_requested = FALSE;
	    pmod->abfexints3 [i].data_valid = FALSE;
	}
	for (i = 0; (i < NUMABINTS); i++)
	{
	    pmod->abfexints4 [i].was_requested = FALSE;
	    pmod->abfexints4 [i].data_valid = FALSE;
	}
	pmod->extintfile1 = MAXFILE + 1;
	pmod->extintfile2 = MAXFILE + 1;
	pmod->extintfile3 = MAXFILE + 1;
	pmod->extintfile4 = MAXFILE + 1;
}

/**********
*
* initialize the statistics for an ALLEN BRADLEY PLC
*
**********/

static	void	initstats (ABPLC *pmod)
{
	pmod->no_dataout_msgs = 0;      /* 5  Count Output Msgs */
	pmod->no_datain_msgs = 0;       /* 6  Count Data Requests */
	pmod->no_rxnoresp = 0;          /* 7  Count No Responses */
	pmod->no_txnoresp = 0;          /* 8  Count No Responses */
	pmod->no_dataerr = 0;           /* 9  Count Message Echo Errors */
	pmod->no_retries = 0;           /* 10 Count Retries */
	pmod->no_rxhwerrs = 0;          /* 11 Count Comm Hardware Errors */
	pmod->no_txhwerrs = 0;          /* 12 Count Comm Hardware Errors */
	pmod->no_crcerrs = 0;           /* 13 Count CRC Errors */
	pmod->no_offlines = 0;          /* 14 Count Off Line Transitions */
	pmod->badoutcnt = 0;		/* 17 Count failed output commands */

        pmod->tscanpass = 0;            /* plc scan pass counter            */
        pmod->msgs = 0;                 /* good response message counts     */
        pmod->responsetime = 0;         /* total wait time for good messages*/

}

/**********
*	prepresponses                                                            
*                                                                             	
*       The purpose of this routine is to mark the PLCs as on hold and the    	
*	data as not valid until read again from the PLC                       	
*                                                                           	
**********/

/* only called from MAIN */

static	void	prepresponses (unsigned short line)
{
	unsigned	short 	mod;
	ABPLC			*pmod;

	for (mod = 1; (mod <= NUMABPLCS); mod++)
	{
            pmod = plcs [line] [mod];
	    if (pmod)			/* verify pointer validity prior to use */
	    {
	    	pmod->holdflag = TRUE;
		mark_not_valid (pmod);
            }
	}
}

/**********
*
*      any_responding                                               	
*                                                                   	
*      The purpose of this routine is to see if any units are       	
*	responding on this line                                      	
*                                                                   	
**********/

/* only called from MAIN */

static	int	any_responding (unsigned short line)
{
	unsigned short  mod;
	ABPLC  *pmod;

	for (mod = 1; (mod <= NUMABPLCS); mod++)
	{
	    pmod = plcs [line] [mod];
	    if (pmod)			/* verify pointer validity prior to use */
	    {
		if (pmod->is_responding)
		{
		    return (TRUE);
		}
	    }
	}
	return (FALSE);
}

/**********
*
*	Readabouts
*
*	Reads the Allen Bradley Output Image File
*
**********/

static	unsigned	short	readabouts (unsigned short line,
				unsigned short mod, ABPLC *pmod,
				unsigned short group, unsigned short numgroups)
{
	unsigned	short 	wval, elementno, numelements;
	unsigned	short	dataix, i, j, lastgroup;
	unsigned	char	data [MAXRXMSG];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Get the data */

	elementno = ABNOGRPELEMS * group;
	numelements = ABNOGRPELEMS * numgroups;

	if (!(abgetdata ( line, mod, pmod, ABOUTIMG,
			 elementno, numelements, data)))
	{
	    return (FALSE);
	}
	lastgroup = group + numgroups - 1;
	dataix = 0;
	for (i = group; i <= lastgroup; i++)
	{
	    for (j = 0; j < ABNOGRPELEMS; j++)
	    {
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abfouts [i].oimgdata [j] = wval;
	    }
	    pmod->abfouts [i].data_valid = TRUE;
	}
	return (TRUE);
}

/**********
*
*	Readabins
*	Reads the Allen Bradley Input Image File
*
**********/

static	unsigned	short	readabins (unsigned short line,
				unsigned short mod, ABPLC *pmod,
				unsigned short group, unsigned short numgroups)
{
	unsigned	short	wval, elementno, numelements;
	unsigned	short	dataix, i, j, lastgroup;
	unsigned	char	data [MAXRXMSG];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Get the data */

	elementno = ABNOGRPELEMS * group;
	numelements =  ABNOGRPELEMS * numgroups;

	if (!(abgetdata (line, mod, pmod, ABINIMG,
			 elementno, numelements, data)))
	{
	    return (FALSE);
	}
	lastgroup = group + numgroups - 1;
	dataix = 0;
	for (i = group; i <= lastgroup; i++)
	{
	    for (j = 0; j < ABNOGRPELEMS; j++)
	    {
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abfins [i].iimgdata [j] = wval;
	    }
	    pmod->abfins [i].data_valid = TRUE;
	}
	return (TRUE);
}

/**********
*
*	Readabstats
*	Reads the Allen Bradley Status File
*
**********/

static	unsigned	short	readabstats (unsigned short line,
				unsigned short mod, ABPLC *pmod,
				unsigned short group, unsigned short numgroups)
{
	unsigned	short	wval, elementno, numelements;
	unsigned	short	dataix, i, j, lastgroup;
	unsigned	char	data [MAXRXMSG];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Get the data */

	elementno = ABNOGRPELEMS * group;
	numelements =  ABNOGRPELEMS * numgroups;

	if (!(abgetdata ( line, mod, pmod, ABSTATUS,
			 elementno, numelements, data)))
	{
	    return (FALSE);
	}
	lastgroup = group + numgroups - 1;
	dataix = 0;
	for (i = group; i <= lastgroup; i++)
	{
	    for (j = 0; j < ABNOGRPELEMS; j++)
	    {
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abfstats [i].statdata [j] = wval;
	    }
	    pmod->abfstats [i].data_valid = TRUE;
	}
	return (TRUE);
}

/**********
*
*	Readabbits
*	Reads the Allen Bradley Bit File
*
**********/

static	unsigned	short	readabbits (unsigned short line,
				unsigned short mod, ABPLC *pmod,
				unsigned short group, unsigned short numgroups)
{
	unsigned	short	wval, elementno, numelements;
	unsigned	short	dataix, i, j, lastgroup;
	unsigned	char	data [MAXRXMSG];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Get the data */

	elementno = ABNOGRPELEMS * group;
	numelements =  ABNOGRPELEMS * numgroups;

	if (!(abgetdata ( line, mod, pmod, ABBITS,
			 elementno, numelements, data)))
	{
	    return (FALSE);
	}
	lastgroup = group + numgroups - 1;
	dataix = 0;
	for (i = group; i <= lastgroup; i++)
	{
	    for (j = 0; j < ABNOGRPELEMS; j++)
	    {
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abfbits [i].bitdata [j] = wval;
	    }
	    pmod->abfbits [i].data_valid = TRUE;
	}
	return (TRUE);
}

/**********
*
*	Readabintss
*	Reads an Allen Bradley Integer File
*
**********/
static	unsigned short readabints (unsigned short line, unsigned short mod,
			  ABPLC *pmod, unsigned short fileno ,ABINTSS abfints[],
			  unsigned short group,unsigned short numgroups)
{

	unsigned	short	wval, elementno, numelements;
	unsigned	short	dataix, i, j, lastgroup;
	unsigned	char	data [MAXRXMSG];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Get the data */

	elementno = ABNOGRPELEMS * group;
	numelements =  ABNOGRPELEMS * numgroups;

	if (!(abgetdata (line, mod, pmod, fileno,
			 elementno, numelements, data)))
	{
	    return (FALSE);
	}
	lastgroup = group + numgroups - 1;
	dataix = 0;
	for (i = group; i <= lastgroup; i++)
	{
	    for (j = 0; j < ABNOGRPELEMS; j++)
	    {
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		abfints [i].intdata [j] = wval;
	    }
	    abfints [i].data_valid = TRUE;
	}
	return (TRUE);
}

/**********
*
*	Readabtimers
*	Reads the Allen Bradley Timer File
*
**********/
static	unsigned short readabtimers (unsigned short line, unsigned short mod,
			  ABPLC *pmod,unsigned short group,
			  unsigned short numgroups)
{
	unsigned	short	wval, elementno, numelements;
	unsigned	short	dataix, i, j, lastgroup;
	unsigned	char	data [MAXRXMSG];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Get the data */

	elementno = ABNOGRPELEMS * group;
	numelements =  ABNOGRPELEMS * numgroups;

	if (!(abgetdata (line, mod, pmod, ABTIMERS,
			 elementno, numelements, data)))
	{
	    return (FALSE);
	}
	lastgroup = group + numgroups - 1;
	dataix = 0;
	for (i = group; i <= lastgroup; i++)
	{
	    for (j = 0; j < ABNOGRPELEMS; j++)
	    {
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abftimers [i].timerdata [j].cdata[0] = wval;
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abftimers [i].timerdata [j].cdata [1] = wval;
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abftimers [i].timerdata [j].cdata [2] = wval;
	    }
	    pmod->abftimers [i].data_valid = TRUE;
	}
	return (TRUE);
}

/**********
*
*	Readabcntrs
*	Reads the Allen Bradley Counter File
*
**********/
static	unsigned short readabcntrs (unsigned short line, unsigned short mod,
			  ABPLC *pmod,unsigned short group,
			  unsigned short numgroups)
{
	unsigned	short	wval, elementno, numelements;
	unsigned	short	dataix, i, j, lastgroup;
	unsigned	char	data [MAXRXMSG];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Get the data */

	elementno = ABNOGRPELEMS * group;
	numelements =  ABNOGRPELEMS * numgroups;

	if (!(abgetdata (line, mod, pmod, ABCOUNTERS,
			 elementno, numelements, data)))
	{
	    return (FALSE);
	}
	lastgroup = group + numgroups - 1;
	dataix = 0;
	for (i = group; i <= lastgroup; i++)
	{
	    for (j = 0; j < ABNOGRPELEMS; j++)
	    {
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abfcntrs [i].cntrdata [j].cdata [0] = wval;
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abfcntrs [i].cntrdata [j].cdata [1] = wval;
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abfcntrs [i].cntrdata [j].cdata [2] = wval;
	    }
	    pmod->abfcntrs [i].data_valid = TRUE;
	}
	return (TRUE);
}

/**********
*
*	Readabcntrls
*	Reads the Allen Bradley Controllers File
*
**********/
static	unsigned short readabcntrls (unsigned short line, unsigned short mod,
			  ABPLC *pmod,unsigned short group,
			  unsigned short numgroups)
{
	unsigned	short 	wval, elementno, numelements;
	unsigned	short	dataix, i, j, lastgroup;
	unsigned	char	data [MAXRXMSG];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Get the data */

	elementno = ABNOGRPELEMS * group;
	numelements =  ABNOGRPELEMS * numgroups;

	if (!(abgetdata (line, mod, pmod, ABCNTRLS,
			 elementno, numelements, data)))
			 {
	    return (FALSE);
	}
	lastgroup = group + numgroups - 1;
	dataix = 0;
	for (i = group; i <= lastgroup; i++)
	{
	    for (j = 0; j < ABNOGRPELEMS; j++)
	    {
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abfcntrls [i].cntrldata [j].cdata [0] = wval;
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abfcntrls [i].cntrldata [j].cdata [1] = wval;
		wval = data [dataix++];
		wval += ((unsigned short) data [dataix++] << 8);
		pmod->abfcntrls [i].cntrldata [j].cdata [2] = wval;
	    }
	    pmod->abfcntrls [i].data_valid = TRUE;
	}
	return (TRUE);
}

/**********
*
*	Setaouts
*	Set analog outputs in Allen Bradley PLC files.
*
**********/
static	unsigned short setaouts (unsigned short line, unsigned short mod,
			 ABPLC *pmod, unsigned short card,
			 unsigned short signal, unsigned short val)
{
	TXLINE  		*txp;
	unsigned	short	ix, element, subelement, checksum;
	unsigned	char	cval, retbuf [50];
	int			retcnt;
	unsigned long	msgstart;

	msgstart = tickGet();

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	/* Compute the element and subelement portions of the Logical Address */

	if ( (card == ABTIMERS) ||
	     (card == ABCNTRLS) ||
	     (card == ABCNTRLS) )
	{
	     element = (signal / 3);
	     subelement = (signal % 3);
	}
	else
	{
	     element = signal;
	     subelement = 0;
	}

	/* Format the output message */

	ix = 0;

	checksum = 0;

	abheader (&txp->txbuf [0], &ix, &checksum, pmod, line, mod, ABWWORDS,
		TRUE, 0 /* pkt */, 1 /* ttrans */);

	ablogaddr (pmod, &txp->txbuf [0], &ix, &checksum, card, element, subelement /*subelement*/);

	cval = ((val & 0xFF)); 	      	/* Value */
	if (cval == DLE)
	{
	    txp->txbuf [ix++] = DLE;
	}
	txp->txbuf [ix++]  = cval;
	updatesum (&checksum, cval);
	cval =  (val >> 8);	            	/* Value */
	if (cval == DLE)
	{
	    txp->txbuf [ix++] = DLE;
	}
	txp->txbuf [ix++]  = cval;
	updatesum (&checksum, cval);

	abcrc (&txp->txbuf [0], &ix, checksum);

	/* Bump TNS */

	pmod->txtsn++;

	/* Time to send the message and get an ACK */

	txp->txmsglen = ix;
	if (msgxfer ( line, ACK, pmod) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->badoutcnt++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Time to poll for data responses */

	retcnt = 40;  /* Maximum data to transfer */
	if ( !getdataresp (line, mod, pmod, retbuf, &retcnt))
	{
	    pmod->badoutcnt++;
	    return (FALSE);
	}

	pmod->msgs++;
	pmod->responsetime += (tickGet() - msgstart);

	return (TRUE);
}

/**********
*
*	Setbouts
*	Set binary outputs in Allen Bradley PLC files.
*
**********/
static	unsigned short setbouts (unsigned short line, unsigned short mod,
			 ABPLC *pmod, unsigned short card,
			 unsigned short signal,
			 long mask, long val)
{
	TXLINE			*txp;
	unsigned	short	ix, checksum, baseelement, element, subelement;
	unsigned	short	tmask, tvalue, andmask, ormask;
	unsigned	short	blkix, elemix, subelemix, tvallow, tvalhigh;
	unsigned	char 	cval, retbuf [50];
	int			retcnt;
	unsigned	char	addrset = FALSE;
	unsigned long	msgstart;

	msgstart = tickGet();


	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	subelement = 0;
	baseelement = ((signal / 16) & 0xFFFE);

	/* Format the output message */

	ix = 0;

	checksum = 0;

	abheader (&txp->txbuf [0], &ix, &checksum, pmod, line, mod, ABWBITSFNC,
	       FALSE, 0 /* pkt */, 1 /* ttrans */);

	if ((mask & 0xFFFF) != 0)
	{
	    element = baseelement;
	    tvalue = val & 0xFFFF;
	    tmask = mask & 0xFFFF;
	    andmask = (~tmask | tvalue);
	    ormask = (tmask & tvalue);
	    if (pmod->devtype)
	    {
		blkix = (signal / 16) / ABNOGRPELEMS;
		elemix = (signal / 16) % ABNOGRPELEMS;
		subelemix = 0;
		
		if ((fetchvalue (pmod, card, blkix, elemix, subelemix, &tvallow)) == -1)
		{
		    return (-1);
		}
		if (elemix == (ABNOGRPELEMS - 1))
		{
		    blkix++;
		    elemix = 0;
		}
		else
		{
		    elemix++;
		}
		if ((fetchvalue (pmod, card, blkix, elemix, subelemix, &tvalhigh)) == -1)
		{
		    return (-1);
		}
		tvallow &= ~tmask;
		tvallow |= tvalue;

		ablogaddr (pmod, &txp->txbuf [0], &ix, &checksum, card,
				element, 0 /*subelement*/);

		cval =  (tvallow & 0xFF);
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
		cval =  (tvallow >> 8);
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
		addrset = TRUE;
	    }
	    else
	    {
	        ablogaddr (pmod, &txp->txbuf [0], &ix, &checksum, card,
				element, 0 /*subelement*/);

		cval =  (andmask & 0xFF); 		      	/* And Mask low */
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
		cval =  (andmask >> 8);	            	/* And Mask High */
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
		cval =  (ormask & 0xFF); 		      	/* Or Mask low */
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
		cval =  (ormask >> 8);	            	/* Or Mask High */
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
	    }
	}
	if ((mask & 0xFFFF0000) != 0)
	{
	    element = baseelement + 1;
	    tvalue = val >> 16;
	    tmask = mask >> 16;
	    andmask = (~tmask | tvalue);
	    ormask = (tmask & tvalue);
	    if (pmod->devtype)
	    {
		if (addrset == FALSE)
		{
		    blkix = (signal / 16) / ABNOGRPELEMS;
		    elemix = (signal / 16) % ABNOGRPELEMS;
		    subelemix = 0;
		    if ((fetchvalue (pmod, card, blkix, elemix, subelemix, &tvalhigh)) == -1)
		    {
			return (-1);
		    }
		    ablogaddr (pmod, &txp->txbuf [0], &ix, &checksum, card,
				element, 0 /*subelement*/);
		}
		tvalhigh &= ~tmask;
		tvalhigh |= tvalue;

		cval =  (tvalhigh & 0xFF);
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
		cval =  (tvalhigh >> 8);
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
	    }
	    else
	    {

		ablogaddr (pmod, &txp->txbuf [0], &ix, &checksum, card,
				element, subelement /*subelement*/);

		cval =  (andmask & 0xFF); 		      	/* And Mask low */
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
		cval =  (andmask >> 8);	            	/* And Mask High */
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
		cval =  (ormask & 0xFF); 		      	/* Or Mask low */
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
		cval =  (ormask >> 8);	            	/* Or Mask High */
		if (cval == DLE)
		{
		    txp->txbuf [ix++] = DLE;
		}
		txp->txbuf [ix++]  = cval;
		updatesum (&checksum, cval);
	    }
	}

	abcrc (&txp->txbuf [0], &ix, checksum );

	/* Bump TNS */

	pmod->txtsn++;

	/* Time to send the message and get an ACK */

	txp->txmsglen = ix;
	if (msgxfer (line, ACK, pmod) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->badoutcnt++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Time to poll for data responses */

	retcnt = 40; /* Maxium data characters to receive */
	if (!getdataresp (line, mod, pmod, retbuf, &retcnt))
	{
	    pmod->badoutcnt++;
	    return (FALSE);
	}
	if (pmod->devtype)
	{
	    blkix = (signal / 16) / ABNOGRPELEMS;
	    elemix = (signal / 16) % ABNOGRPELEMS;
	    if (addrset == TRUE)
	    {
		pmod->abfexints1 [blkix].intdata [elemix] = tvallow;
		if (elemix == (ABNOGRPELEMS - 1))
		{
		    blkix++;
		    elemix = 0;
		}
		else
		{
		    elemix++;
		}
		pmod->abfexints1 [blkix].intdata [elemix] = tvalhigh;
	    }
	    else
	    {
		pmod->abfexints1 [blkix].intdata [elemix] = tvalhigh;
	    }
	
	}

	pmod->msgs++;
	pmod->responsetime += (tickGet() - msgstart);

	return (TRUE);
}

/**********
*
*	Routine to fetch data from an Allen Bradley PLC
*
**********/
static	int abgetdata ( unsigned short fline, unsigned short mod,
		ABPLC *pmod, unsigned short file,
		unsigned short element, unsigned short cnt,
		unsigned char *retbuf)
{
    int			bytecnt;
    unsigned	short	ix, outix, checksuies ,line;
    TXLINE		*txp;
    unsigned	char	cval;
    unsigned long	msgstart;

	msgstart = tickGet();


	if ((file ==  ABOUTIMG) || (file ==  ABINIMG) ||
	    (file ==  ABSTATUS) || (file ==  ABBITS) ||
	    (file ==  ABINTS) || (file ==  ABOUTIMG) ||
	    (file >= 9) )
	{
	    bytecnt = (cnt * 2);
	}
	else
	{
	    bytecnt = (cnt * 6);
	}
	line = fline & (~ONERETRY);

	txp = txlinetab [line];

	ix = 0;

	checksum = 0;

	abheader (&txp->txbuf [0], &ix, &checksum, pmod, line, mod, ABRWORDS,
	       TRUE, 0 /* pkt */, (bytecnt / 2) /* ttrans */);

	ablogaddr (pmod, &txp->txbuf [0], &ix, &checksum, file, element, 0 /*subelement*/);

	cval =  (bytecnt);       		/* Total Trans  Byte Count */
	if (cval == DLE)
	{
	    txp->txbuf [ix++] = DLE;
	}
	txp->txbuf [ix++]  = cval;
	updatesum (&checksum, cval);

	abcrc (&txp->txbuf [0], &ix, checksum );

	/* Bump TNS */

	pmod->txtsn++;

	/* Time to send the message and get an ACK */

	txp->txmsglen = ix;
	if (msgxfer (fline, ACK, pmod) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}
	/* Time to poll for data responses */

	outix = 0;
	while (bytecnt > 0)
	{
	    if (!getdataresp (line, mod, pmod, &retbuf [outix], &bytecnt))
	    {
		return (FALSE);
	    }
	}

	pmod->msgs++;
	pmod->responsetime += (tickGet() - msgstart);

	return (TRUE);
}


/*
** Routine to format an Allen Bradley transmission header
**
*/
static	void abheader( unsigned char *buf, unsigned short *ix, unsigned short *checksum,
	       ABPLC *pmod, unsigned short line, unsigned short mod, unsigned short fnc,
	       unsigned short pktnttans, unsigned short pkt,unsigned short ttrans)
{
	unsigned	char	cval;

	buf [(*ix)++] = DLE;			/* Start of Header */
	buf [(*ix)++] = SOH;
	cval = abadapteraddr [line];
	if (cval == DLE)
	{
	    buf [*ix++] = DLE; 	/* Station Number */
	}
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	buf [(*ix)++] = DLE;                	/* Start of Text */
	buf [(*ix)++] = STX;
	updatesum (checksum, STX);
	if (mod == DLE)
	{
	    buf [(*ix)++] = DLE;
	}
	buf [(*ix)++] = mod;
	updatesum (checksum, mod);
	buf [(*ix)++] = MASTERADDR;
	updatesum (checksum, MASTERADDR);      /* SRC */
	if (pmod->devtype)
	{
	    if (fnc == ABRWORDS)
	    {
		cval = ABUREAD;			/* CMD */
	    }
	    else
	    {
		cval = ABUWRITE;
	    }
	}
	else
	{
	    cval = AB5CMD;			/* CMD */
	}
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	cval = 0;                     		/* Status Byte Ok */
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	cval = (pmod->txtsn & 0xFF);           	/* TNS Low */
	if (cval == DLE)
	{
	    buf [(*ix)++] = DLE;
	}
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	cval = (pmod->txtsn >> 8);            	/* TNS High */
	if (cval == DLE)
	{
	    buf [(*ix)++] = DLE;
	}
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	if (pmod->devtype)
	{
	    return;
	}
	cval = fnc;                       	/* FNC */
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	if (!pktnttans)
	{
	    return;				/* Exit early if not required */
	}
	cval = (pkt & 0xFF);			/* Packet Offset Low */
	if (cval == DLE)
	{
	    buf [(*ix)++] = DLE;
	}
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	cval = (pkt >> 8);			/* Packet Offset High */
	if (cval == DLE)
	{
	    buf [(*ix)++] = DLE;
	}
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	cval = (ttrans & 0xFF);			/* Total Trans Low */
	if (cval == DLE)
	{
	    buf [(*ix)++] = DLE;
	}
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	cval = (ttrans >> 8);       		/* Total Trans High */
	if (cval == DLE)
	{
	    buf [(*ix)++] = DLE;
	}
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
    }

/*
** Routine to send diagnostic status messsage to AB device
**
*/
static	int abdiagstat (ABPLC *pmod, unsigned short line, unsigned short mod)
{
	unsigned	char	cval;
	unsigned	short	ix = 0;
	unsigned	short	checksum = 0;
	unsigned	short	outix;
	int			bytecnt = 1;
	TXLINE			*txp;
	RXLINE			*rxp;

        /* wep: 6/24/98 */
	rxp = rxlinetab [line];

	txp = txlinetab [line];
	txp->txbuf [ix++] = DLE;	/* Start of Header */
	txp->txbuf [ix++] = SOH;
	cval = abadapteraddr [line];
	if (cval == DLE)
	{
	    txp->txbuf [ix++] = DLE; 		/* Station Number */
	}
	txp->txbuf [ix++] = cval;
	updatesum (&checksum, cval);
	txp->txbuf [ix++] = DLE;		/* Start of Text */
	txp->txbuf [ix++] = STX;
	updatesum (&checksum, STX);
	if (mod == DLE)
	{
	    txp->txbuf [ix++] = DLE;
	}
	txp->txbuf [ix++] = mod;
	updatesum (&checksum, mod);
	txp->txbuf [ix++] = MASTERADDR;
	updatesum (&checksum, MASTERADDR);	/* SRC */
	cval = ABDIAGCMD;			/* CMD */
	txp->txbuf [ix++] = cval;
	updatesum (&checksum, cval);
	cval = 0;				/* Status Byte Ok */
	txp->txbuf [ix++] = cval;
	updatesum (&checksum, cval);
	cval = (pmod->txtsn & 0xFF);           	/* TNS Low */
	if (cval == DLE)
	{
	    txp->txbuf [ix++] = DLE;
	}
	txp->txbuf [ix++] = cval;
	updatesum (&checksum, cval);
	cval = (pmod->txtsn >> 8);            	/* TNS High */
	if (cval == DLE)
	{
	    txp->txbuf [ix++] = DLE;
	}
	txp->txbuf [ix++] = cval;
	updatesum (&checksum, cval);
	cval = ABDSTATFNC;                      /* FNC */
	txp->txbuf [ix++] = cval;
	updatesum (&checksum, cval);

	abcrc (&txp->txbuf [0], &ix, checksum );

	/* Bump TNS */

	pmod->txtsn++;

	/* Time to send the message and get an ACK */

	txp->txmsglen = ix;
	if (msgxfer (line, ACK, pmod) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}
	/* Time to poll for data responses */

	outix = 0;
	while (bytecnt > 0)
	{
	    if (!getdataresp (line, mod, pmod, &rxp->rxbuf [outix], &bytecnt))
	    {
		return (FALSE);
	    }
	}
	return (TRUE);
}

/*
** Routine to enter Allen Bradley logical address into buffer
**
*/
static	void	ablogaddr (ABPLC *pmod, unsigned char *buf, unsigned short *ix,
			unsigned short *checksum, unsigned short file,
			unsigned short element, unsigned short subelement)
{
	unsigned	char	cval;

	if (pmod->devtype == 0)
	{
	    cval = FULLADDR;	       		/* Full Address (4 parts) */
	    buf [(*ix)++] = cval;
	    updatesum (checksum, cval);
	    cval = DATATABLE;	       		/* Data Table */
	    buf [(*ix)++] = cval;
	    updatesum (checksum, cval);
	    cval = file;       			/* File Number */
	    if (cval == DLE)
	    {
		buf [(*ix)++] = DLE;
	    }
	    buf [(*ix)++] = cval;
	    updatesum (checksum, cval);
	    cval = FULLELEMFLAG;	     		/* Flag Full Element Addr */
	    buf [(*ix)++] = cval;
	    updatesum (checksum, cval);
	}
	cval = (element & 0xFF);       	/* Element Number Low */
	if (cval == DLE)
	{
	    buf [(*ix)++] = DLE;
	}
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	cval = (element >> 8);            	/* Element Number High */
	if (cval == DLE)
	{
	    buf [(*ix)++] = DLE;
	}
	buf [(*ix)++] = cval;
	updatesum (checksum, cval);
	if (pmod->devtype == 0)
	{
	    cval = subelement;	       		/* Sub Element Address */
	    if (cval == DLE)
	    {
		buf [(*ix)++] = DLE;
	    }
	    buf [(*ix)++] = cval;
	    updatesum (checksum, cval);
	}
}

/**********
*
* Routine to Place checksum in Allen Bradley transmission buffer
*
**********/
static	void	abcrc (unsigned char *buf, unsigned short *ix,
			unsigned short checksum )
{
	unsigned	char	cval;

	cval = DLE;		       		/* DLE */
	buf [(*ix)++] = cval;
	cval = ETX;		       		/* ETX  */
	buf [(*ix)++] = cval;
	updatesum (&checksum, cval);
	cval = (checksum & 0xff);      		/* CRC Low Byte  */
	buf [(*ix)++]  = cval;
	cval = ((checksum >> 8) & 0xff);  	/* CRC High Byte */
	buf [(*ix)++] = cval;
}

/**********
*
* getdataresponse
*	The purpose of this routine is to poll the PLC for data until
*	retries are exhausted or a data frame is received. This routine
*	is responsible for rejecting duplicate messages and updating the
*	rxcmd and rxtsn variables. It will also verify that the command
*	field returned contains the AB5CMDRESP and the status does not
*	indicate a command error. This routine will also send the ACKs to
*	the PLC for the data messages.
*
**********/
static	int	getdataresp (unsigned short line, unsigned short mod,
			ABPLC *pmod, unsigned char *retbuf, int *pcnt)
{
	TXLINE  		*txp;
	RXLINE  		*rxp;
	unsigned 	short   thistsn, polltry, ix, checksum, oix, errresptype;

	for (polltry = 0; (polltry < MAXPOLLTRY); polltry++)
	{
	    txp = txlinetab [line];
	    rxp = rxlinetab [line];
	    ix = 0;
	    checksum = 0;
	    txp->txbuf [ix++] = DLE;			/* Start of Header */
	    txp->txbuf [ix++] = ENQ;
	    if (mod == DLE)
	    {
		txp->txbuf [ix++] = DLE;		/* Station Number */
	    }
	    txp->txbuf [ix++]  = abadapteraddr [line];
	    checksum = (-abadapteraddr [line] & 0xff);  /* adapter uses BCC */
	    txp->txbuf [ix++]  = checksum;

	    txp->txmsglen = ix;

	    if (msgxfer (line, STX, pmod) == XFERBAD)
	    {
		pmod->nodatastrike++;
		if (pmod->nodatastrike == MAXDATASTRIKE)
		{
		    pmod->no_offlines++;
	    	    pmod->holdflag = TRUE;
		    pmod->is_responding = FALSE;
		}
		return (FALSE);
	    }
	    pmod->nodatastrike = 0;

	    /* Verify the Repsonse */

	    thistsn = rxp->rxbuf [WORDREADTNSLOFFSET];
	    thistsn += (unsigned short) rxp->rxbuf [WORDREADTNSHOFFSET] << 8;

	    /* Check for TSN & Correct Command Type */

	    if  (((rxp->rxbuf [WORDREADCMDOFFSET] ==  AB5CMDRESP) ||
		  (rxp->rxbuf [WORDREADCMDOFFSET] == ABDIAGRESP) ||
		  (rxp->rxbuf [WORDREADCMDOFFSET] == ABUREADRESP) ||
		  (rxp->rxbuf [WORDREADCMDOFFSET] == ABUWRITERESP)) &&
		  (thistsn == (unsigned short) (pmod->txtsn - 1)))
	    {

		 /* Update the TSN and CMD Fields */

		 pmod->rxtsn = thistsn;
		 pmod->rxcmd = rxp->rxbuf [WORDREADCMDOFFSET];

		 /* Return Based on Command Status */

		 if (((rxp->rxbuf [WORDREADCMDOFFSET] ==  AB5CMDRESP) ||
			(rxp->rxbuf [WORDREADCMDOFFSET] == ABUREADRESP) ||
			(rxp->rxbuf [WORDREADCMDOFFSET] == ABUWRITERESP)) &&
			(rxp->rxbuf [WORDREADSTSOFFSET] == 0))
		 {
		     /* Copy This Data into Return Buffer Skip STX and Header*/

		     for (ix = WORDREADDATAOFFSET, oix = 0; (ix < (rxp->rxix - 2)); ix++)
		     {
			 retbuf [oix++] = rxp->rxbuf [ix];
			 *pcnt = *pcnt - 1;
		     }
		     if (!sendack (line, pmod))
		     {
			return (FALSE);
		     }
		     return (TRUE);
		 }
		 else if (rxp->rxbuf [WORDREADCMDOFFSET] == ABDIAGRESP)
		 {
		     if (rxp->rxbuf [DIAGTYPEOFFSET] == ABSLC501)
		     {
			 pmod->devtype = 1;
			 logMsg ("Connected to Allen Bradley SLC Device, Line %d, Addr %d\n",
					line, mod,0,0,0,0);
		     }
		     else
		     {
			 pmod->devtype = 0;
			 logMsg ("Conneced to Allen Bradley PLC 5 Device, Line %d, Addr %d\n",
					line, mod,0,0,0,0);
		     }
		     *pcnt = 0;
		     return (TRUE);
		 }
		 else
		 {
		     pmod->no_dataerr++;
		     logMsg ("AB Read Status Error %X\n", rxp->rxbuf [WORDREADSTSOFFSET],0,0,0,0,0);
		     errresptype = rxp->rxbuf [WORDREADSTSOFFSET];
		     sendack (line, pmod);
		     if (errresptype == RNODEOFFLINE)
		     {
		    	pmod->no_offlines++;
		    	pmod->is_responding = FALSE;
		     }
		     return (FALSE);
		 }
	     }
	     else
	     {
		if (rxp->rxbuf [WORDREADCMDOFFSET] !=  AB5CMDRESP)
		{
		    logMsg ("Wrong Cmd Response Code %x \n",
				rxp->rxbuf [WORDREADCMDOFFSET],0,0,0,0,0);
		}
		if (thistsn != (unsigned short) (pmod->txtsn - 1))
		{
		    logMsg ("Wrong Sequence Number - Expected %d, Got %d \n",
			(unsigned short) pmod->txtsn - 1,
			thistsn ,0,0,0,0);
		}
	    }

	    /* Send an ack to the data anyway */

	    if (!sendack (line, pmod))
	    {
		return (FALSE);
	    }

	    /* Update the TSN and CMD Fields */

	    pmod->rxtsn = thistsn;
	    pmod->rxcmd = rxp->rxbuf [WORDREADCMDOFFSET];

	    pmod->no_dataerr++;
	}
	return (FALSE);
}

/**********
*
* Routine to send an ack to the responding slave
*
**********/
static	int sendack ( unsigned short line, ABPLC *pmod)
{

	TXLINE			*txp;
	unsigned	short   ix;

	/* Send an ACK to the Data */

	txp = txlinetab [line];
	ix = 0;
	txp->txbuf [ix++] = DLE;		/* Start of Header */
	txp->txbuf [ix++] = ACK;
	txp->txmsglen = ix;

	if (msgxfer (line, NOREPLY, pmod) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}
	return (TRUE);
}


/**********
*
*	makecrc
*
**********/
static	void makecrc ( unsigned char *chkbuf, int len, unsigned char *retbuf)
{
	unsigned	short	checksum;
	unsigned	short	 j;

	checksum = 0;
	for (j = 0; j < len; j++)
	{
	    updatesum (&checksum, chkbuf [j]);
	}
	retbuf [1] = ((checksum >> 8) & 0xff);
	retbuf [0] = (checksum & 0xff);
}

/**********
*
* updatesum
*	The purpose of this routine is to add the character
*	into the running CRC
*
**********/
static	void	updatesum (unsigned short *checksum, unsigned char cval)
{
	unsigned	short	i, flag;

	*checksum ^= cval;
	for (i = 0; i < 8; i++)
	{
	    flag = *checksum & 1;
	    *checksum >>= 1;
	    if (flag)
	    {
		*checksum ^= (unsigned short) 0x0a001;
	    }
	}
}

/**********
*
*      dump_mod_table
*
*      The purpose of this routine is to dump the module description
*      portion of the analog devices driver tables for the selected line.
*      It will print out two lines for each module which is responding.
*      The first line will give the general module header, the second line
*      will give module type specific info.
*
**********/
void	abplc_dump (unsigned short line,unsigned short addr)
{
	ABPLC		*pmod;

        unsigned long   microsecs;

	pmod = plcs [line] [addr];

	if (!pmod)
	{
	    logMsg ("Line/ModbusAddress Not Defined \n");
	    return;
	}

	printf (" Was requested = %d \n", pmod->was_requested);
	printf (" Is responding = %d \n", pmod->is_responding);
	printf (" Resource Responding = %d \n", resresponse[line]);
	printf (" Hold flag  = %d \n", pmod->holdflag );
	printf (" Force Offline = %d \n", pmod->cmd_force_offline);

	printf (" # Output messages = %d \n", pmod->no_dataout_msgs & 0x7fff);
	printf (" # Data in messages = %d \n", pmod->no_datain_msgs & 0x7fff);
	printf (" #No Rx Response = %d \n", pmod->no_rxnoresp & 0x7fff);
	printf (" #No Tx Responses = %d \n", pmod->no_txnoresp & 0x7fff);
	printf (" #Data Errors = %d \n", pmod->no_dataerr & 0x7fff);
	printf (" #Retries = %d \n", pmod->no_retries & 0x7fff);
	printf (" #Rx Hw Errors = %d \n", pmod->no_rxhwerrs & 0x7fff);
	printf (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs & 0x7fff);
	printf (" #Crc Errors = %d \n", pmod->no_crcerrs & 0x7fff);
	printf (" #Off Lines = %d \n", pmod->no_offlines & 0x7fff);
	printf (" #Failed Outputs = %d \n", pmod->badoutcnt & 0x7fff);

	printf ("\n");
	printf (" # of Messages %d \n", pmod->msgs);
	printf (" # Total response time (ticks) = %lu \n", pmod->responsetime);
	printf ("   Average response time (ticks) = %d \n", (pmod->responsetime/pmod->msgs));
        microsecs = (16667*pmod->responsetime)/pmod->msgs;
	printf ("   Average response time (msec) = %d.%1d \n", microsecs/1000, (microsecs%1000)/100);
	printf (" # of scan passes = %d \n", pmod->tscanpass);
    }

/**********
*
*      abplc_clear
*
*      The purpose of this routine is to clear the statistics for the
*      specified line and address.
*
**********/
void	abplc_clear (unsigned short line,unsigned short addr)
{
	ABPLC		*pmod;

	pmod = plcs [line] [addr];

	if (!pmod)
	{
	    logMsg ("Line/ModbusAddress Not Defined \n");
	    return;
	}

	initstats (pmod); /* use existing procedure */

        return;
    }

