/****************************************************************/
/*                                                              */
/*    This software is the proprietary property of Tate         */
/*    Integrated Systems, L.P.  Patents and copyrights are      */
/*    pending.                                                  */
/*                                                              */
/*    This software is furnished under a license and may        */
/*    be used and copied only in accordance with the terms      */
/*    of such license and with the inclusion of the above       */
/*    notice. This software or any other copies thereof         */
/*    may not be provided or otherwise made available to        */
/*    any other person. No title to and ownership of the        */
/*    software is hereby transferred.                           */
/*                                                              */
/*    The information in this software is subject to            */
/*    change without notice and should not be construed         */
/*    as a commitment by Tate Integrated Systems L.P. or        */
/*    its third party suppliers.                                */
/*                                                              */
/*    Tate Integrated Systems, L.P. (TIS) and its third         */
/*    party suppliers assume no responsibility for the          */
/*    use or inability to use any of its software. TIS          */
/*    software is provided "as is" without warranty of          */
/*    any kind and TIS expressly disclaims all implied          */
/*    warranties, including but not limited to the implied      */
/*    warranties of merchantability and fitness for a           */
/*    particular purpose.                                       */
/*                                                              */
/*    Notice: Notwithstanding any other lease or license        */
/*    that may pertain to or accompany the delivery of this     */
/*    computer software, the rights of the Government           */
/*    regarding its use, reproduction, and disclosure are       */
/*    as set forth in Section 52.227-19 of the FARS             */
/*    Computer Software-Restricted Rights clause.               */
/*                                                              */
/****************************************************************/
/*                                                                
**  File: drvSec.h                                                
**  Edit: 01/08/99  wep : created as sneaky way to test Sec Driver in t51
**         2/17/99  wep : added support for reading Status Group 3 (Output) 
**                      : parameters using the ST3 command.
**         3/24/99  wep : changed pseudo point card value from 9999 to 33
**
*/                                                                                                                      

#define TRUE    1
#define FALSE   0
#define NULLP   0
#define CR      0x0d

/*  number of lines of Sec              */
#define     SECLINES       32

/*  number of sec modules per line      */
#define     NUMMODS         1

/*  maximum number of channels per module  */
#define     NUMCHANNELS     1

/*  number of groups which can be defined in the PCU/LGU */
#define     MAXGROUPNUM    16

#define     RES_LOCKED      0

#define     MINSIGNAL       1
#define     MAXSIGNAL      79

#define       ILLEGALCOMMAND         0   /*  NUL :     "Illegal Command Zero"        */
#define       ALARMAWAITINGPOWER    12   /*  ST5 :     "Alarm Awaiting Power"        */
#define       ALARMBYPASSBAD         4   /*  ST5 :     "Alarm Bypass Bad"            */
#define       ALARMCHARGERFAILURE    7   /*  ST5 :     "Alarm Charger Failure"       */
#define       ALARMFANFAILURE        9   /*  ST5 :     "Alarm Fan Failure"           */
#define       ALARMFUSEFAILURE      10   /*  ST5 :     "Alarm Fuse Failure"          */
#define       ALARMGENERALFAULT     11   /*  ST5 :     "Alarm General Fault"         */
#define       ALARMINPUTBAD          1   /*  ST5 :     "Alarm Input Bad"             */
#define       ALARMOUTPUTBAD         2   /*  ST5 :     "Alarm Output Bad"            */
#define       ALARMOUTPUTOFF         5   /*  ST5 :     "Alarm Output Off"            */
#define       ALARMOVERLOAD          3   /*  ST5 :     "Alarm Overload"              */
#define       ALARMSHUTDNIMMINENT   14   /*  ST5 :     "Alarm Shutdown Imminent"     */
#define       ALARMSHUTDNPENDING    13   /*  ST5 :     "Alarm Shutdown Pending"      */
#define       ALARMSYSTEMOFF         8   /*  ST5 :     "Alarm System Off"            */
#define       ALARMTEMPERATURE       0   /*  ST5 :     "Alarm Temperature"           */
#define       ALARMUPSSHUTDOWN       6   /*  ST5 :     "Alarm UPS Shutdown"          */
#define       AUDIBLEALARM           7   /*  NOM :     "Audible Alarm"               */
#define       AUTORESTART            0   /*  ATR :     "Auto Restart"                */
#define       BATTERYCHARGE          2   /*  ST1 :     "Battery Charge"              */
#define       BATTERYCONDITION       0   /*  ST1 :     "Battery Condition"           */
#define       BATTERYCURRENT         7   /*  ST1 :     "Battery Current"             */
#define       BATTERYINSTALLDATE    10   /*  NOM :     "Battery Installed Date"      */
#define       BATTERYSTATUS          1   /*  ST1 :     "Battery Status"              */
#define       BATTERYTEMPERATURE     8   /*  ST1 :     "Battery Temperature"         */
#define       BATTERYVOLTAGE         6   /*  ST1 :     "Battery Voltage"             */
#define       BYPASSCURRENT1         3   /*  ST4 :     "Bypass Current 1"            */
#define       BYPASSCURRENT2         6   /*  ST4 :     "Bypass Current 2"            */
#define       BYPASSCURRENT3         9   /*  ST4 :     "Bypass Current 3"            */
#define       BYPASSFREQUENCY        0   /*  ST4 :     "Bypass Frequency"            */
#define       BYPASSNUMLINES         1   /*  ST4 :     "Bypass Num Lines"            */
#define       BYPASSPOWER1           4   /*  ST4 :     "Bypass Power 1"              */
#define       BYPASSPOWER2           7   /*  ST4 :     "Bypass Power 2"              */
#define       BYPASSPOWER3          10   /*  ST4 :     "Bypass Power 3"              */
#define       BYPASSVOLTAGE1         2   /*  ST4 :     "Bypass Voltage 1"            */
#define       BYPASSVOLTAGE2         5   /*  ST4 :     "Bypass Voltage 2"            */
#define       BYPASSVOLTAGE3         8   /*  ST4 :     "Bypass Voltage 3"            */
#define       ESTIMATEDCHARGE        5   /*  ST1 :     "Estimated Charge"            */
#define       ESTIMATEDMINUTES       4   /*  ST1 :     "Estimated Minutes"           */
#define       HIGHVOLTAGETRANSFER    9   /*  NOM :     "High Voltage Transfer Point" */
#define       IDENTIFICATION         0   /*  UID :     "Identification"              */
#define       INPUTCURRENT1          4   /*  ST2 :     "Input Current 1"             */
#define       INPUTCURRENT2          8   /*  ST2 :     "Input Current 2"             */
#define       INPUTCURRENT3         12   /*  ST2 :     "Input Current 3"             */
#define       INPUTFREQUENCY1        2   /*  ST2 :     "Input Frequency 1"           */
#define       INPUTFREQUENCY2        6   /*  ST2 :     "Input Frequency 2"           */
#define       INPUTFREQUENCY3       10   /*  ST2 :     "Input Frequency 3"           */
#define       INPUTLINEBADS          0   /*  ST2 :     "Input Line Bads"             */
#define       INPUTNUMLINES          1   /*  ST2 :     "Input Num Lines"             */
#define       INPUTPOWER1            5   /*  ST2 :     "Input Power 1"               */
#define       INPUTPOWER2            9   /*  ST2 :     "Input Power 2"               */
#define       INPUTPOWER3           13   /*  ST2 :     "Input Power 3"               */
#define       INPUTVOLTAGE1          3   /*  ST2 :     "Input Voltage 1"             */
#define       INPUTVOLTAGE2          7   /*  ST2 :     "Input Voltage 2"             */
#define       INPUTVOLTAGE3         11   /*  ST2 :     "Input Voltage 3"             */
#define       LOWVOLTAGETRANSFER     8   /*  NOM :     "Low Voltage Transfer Point"  */
#define       MANUFACTURER           0   /*  MAN :     "Manufacturer"                */
#define       MODEL                  0   /*  MOD :     "Model"                       */
#define       NOMBATTERYLIFE        11   /*  NOM :     "Nominal Battery Life"        */
#define       MONINPUTFREQUENCY      1   /*  NOM :     "Nominal Input Frequency"     */
#define       NOMINPUTVOLTAGE        0   /*  NOM :     "Nominal Input Voltage"       */
#define       NOMLOWBATTERYTIME      6   /*  NOM :     "Nominal Low Battery Time"    */
#define       NOMOUTPUTFREQUENCY     3   /*  NOM :     "Nominal Output Frequency"    */
#define       NOMOUTPUTPOWER         5   /*  NOM :     "Nominal Output Power"        */
#define       NOMOUTPUTVOLTAGE       2   /*  NOM :     "Nominal Output Voltage"      */
#define       NOMVOLTAMPRATING       4   /*  NOM :     "Nominal Volt-Amp Rating"     */
#define       OUTPUTCURRENT1         4   /*  ST3 :     "Output Current 1"            */
#define       OUTPUTCURRENT2         8   /*  ST3 :     "Output Current 2"            */
#define       OUTPUTCURRENT3        12   /*  ST3 :     "Output Current 3"            */
#define       OUTPUTFREQENCY         1   /*  ST3 :     "Output Frequency"            */
#define       OUTPUTLOAD1            6   /*  ST3 :     "Output Load 1"               */
#define       OUTPUTLOAD2           10   /*  ST3 :     "Output Load 2"               */
#define       OUTPUTLOAD3           14   /*  ST3 :     "Output Load 3"               */
#define       OUTPUTNUMLINES         2   /*  ST3 :     "Output Num Lines"            */
#define       OUTPUTPOWER1           5   /*  ST3 :     "Output Power 1"              */
#define       OUTPUTPOWER2           9   /*  ST3 :     "Output Power 2"              */
#define       OUTPUTPOWER3          13   /*  ST3 :     "Output Power 3"              */
#define       OUTPUTSOURCE           0   /*  ST3 :     "Output Source"               */
#define       OUTPUTVOLTAGE1         3   /*  ST3 :     "Output Voltage 1"            */
#define       OUTPUTVOLTAGE2         7   /*  ST3 :     "Output Voltage 2"            */
#define       OUTPUTVOLTAGE3        11   /*  ST3 :     "Output Voltage 3"            */
#define       REBOOTWITHDURATION     0   /*  RWD :     "Reboot With Duration"        */
#define       SECONDSONBATTERY       3   /*  ST1 :     "Seconds on Battery"          */
#define       SHUTDOWNTYPE           0   /*  SDA :     "Shutdown Type"               */
#define       SHUTDOWNAFTERDELAY     0   /*  PSD :     "Shutdown After Delay"        */
#define       SOFTWAREVERSION        0   /*  VER :     "Software Version"            */
#define       STARTUPAFTERDELAY      0   /*  STD :     "Startup After Delay"         */
#define       TESTRESULTSDETAIL      0   /*  STR :     "Test Results Detail"         */
#define       TESTRESULTSSUMMARY     1   /*  STR :     "Test Results Summary"        */
#define       TESTTYPE               0   /*  TST :     "Test Type"                   */
#define       UPSBAUDRATE            0   /*  UBR :     "UPS Baud Rate"               */

/*                                                                           		
** The IOC will assume that the data to be read from each Sec module will               
**   will come from a fixed number of channels, not exceeding 20 per module.            
**   It will read all of the channels in one module in one read request to              
**   minimize the amount of communications overhead.                                    
**                                                                                      
*/

#define MAINS           0               /* Card number for analog inputs              */
#define MODULE       1000               /* Card number for module status              */
#define MPSEUDO        33               /* Card number for pseudo i/o                 */



#define PARSEINVALIDDEFAULT   3         /* the number of sequential parse errors allowed for */
                                        /* each 'read status group N' command before marking */
                                        /* the data returned by that command as invalid.     */ 

#define PARSEOFFLINEDEFAULT   4         /* the number of sequential parse errors allowed for */
                                        /* all 'read status group N' commands before marking */
                                        /* the plc as offline.                               */



 

/*
**	Conversion types for analog inputs	
*/
#define		AICNVINTEGER    10
#define		AICNVDOUBLEINT  11
#define		AICNVFLOAT      12
#define		AICNVDOUBLEFLT  13
#define		AICNVASCIIFLT   14

#define		AICNVSQRROOT    15

#define		AICNVSTATUS     15
#define		AICNVTIME       16
#define		AICNVASCII_2    17
#define		AICNVASCII_4    18
#define		AICNVASCII_12   19
#define		AICNVASCII_20   20
#define		MAXCONV         20

/* The following must match the definition in recChoice.ascii */
#define NOCONV 0
#define LINEAR 1
#define ASCFLT 2


#define    WATCHDOGTIMEOUT       10*60 /* watchdog monitor timeout.  */


/*
**	Communications I/O Structures
**
*/

#define		RXSEM		0
#define		TXSEM		1
#define		MAXRXMSG	256
#define		MAXTXMSG	256


typedef	struct {
	unsigned short		rxstate;
	unsigned short		fixedlen;
	unsigned short		rxmsglenexpected;
        unsigned short          rxmsglen;
        unsigned short          datalength;
       	unsigned short		rxix;
	SEMAPHORE		*semid;
	unsigned short		*status;
        unsigned char           txaddress;
        unsigned char           txfunction;
       	unsigned char		rxbuf[MAXRXMSG];
		} 	RXLINE;

#define	   RXIGNORE                0
#define	   RXTOPHAT                1
#define	   RXMESSAGETYPE           2
#define	   RXDATALENGTH1           3
#define	   RXDATALENGTH2           4
#define	   RXDATALENGTH3           5
#define	   RXDATA                  6


typedef	struct {
	unsigned short		protocol;
	unsigned short		txdisable;
	unsigned short		txtocnt;
	unsigned short		txhwerrcnt;
	unsigned short		txmsglen;
	unsigned short		txix;
	SEMAPHORE		*semid;
	unsigned short		*status;
	unsigned char		txbuf[MAXTXMSG];
		} 	TXLINE;
/*
**	Communications I/O Constants
**
*/

#define		RXGOOD			1
#define		RXBAD			2
#define		RXTIMEOUT		60	/* 16 ms ticks 				*/
#define		ACTIVITYTIME		300	/* must see activity in 5 seconds 	*/

#define		VARRESP			FALSE
#define		FIXEDRESP		TRUE
#define		ONERETRY		0x8000	/* OR'ed into line number for xfermsg 	*/

#define		TXGOOD			1
#define		TXBAD			2
#define		IO_TIMEOUT		3	/* Code returned by timer 		*/


#define		TXTIMEOUT		30	/* 16 ms ticks: one second/2            */

#define		MAXRETRYS		3	/* retransmission trys 			*/

#define		MAXCFGCK		8	/* Try to Bring online each cycle 	*/
#define		BRINGBACKCNT		4	/* Poll loops per cycle 		*/

#define		XFERGOOD		1
#define		XFERBAD			2

#define		RESNAMELEN		16	/* length of a resource name 		*/
#define		SLWWINDOW		900	/* # of ticks to allow slave to try 	*/

/*
**	Internal IOC Structure for Sec Modules
**
*/

#define MAXDG1 9
#define MAXDG2 14
#define MAXDG3 15
#define MAXDG4 11
#define MAXDG5 15

typedef	struct {
    unsigned short  was_requested;
    unsigned short  data_valid;
    unsigned short  number [MAXDG1];
    unsigned short  status [MAXDG1];
    unsigned long   data   [MAXDG1];
    unsigned char   raw_read [MAXDG1][8];
               } DATAGROUP1;

typedef	struct {
    unsigned short  was_requested;
    unsigned short  data_valid;
    unsigned short  number [MAXDG2];
    unsigned short  status [MAXDG2];
    unsigned long   data   [MAXDG2];
    unsigned char   raw_read [MAXDG2][8];
               } DATAGROUP2;

typedef	struct {
    unsigned short  was_requested;
    unsigned short  data_valid;
    unsigned short  number [MAXDG3];
    unsigned short  status [MAXDG3];
    unsigned long   data   [MAXDG3];
    unsigned char   raw_read [MAXDG3][8];
               } DATAGROUP3;

typedef	struct {
    unsigned short  was_requested;
    unsigned short  data_valid;
    unsigned short  number [MAXDG5];
    unsigned short  status [MAXDG5];
    unsigned long   data   [MAXDG5];
    unsigned char   raw_read [MAXDG5][8];
               } DATAGROUP5;

typedef struct {
    unsigned short  was_requested;      /* 0  The scan task has accesses this RTU       */
    unsigned short  is_responding;      /* 1  The RTU is responding                     */
    unsigned short  holdflag;           /*    The RTU data is in hold                   */
    unsigned short  no_dataout_msgs;    /* 5  Count Output Msgs                         */
    unsigned short  no_datain_msgs;     /* 6  Count Data Requests                       */
    unsigned short  no_rxnoresp;        /* 7  Count No Responses                        */
    unsigned short  no_txnoresp;        /* 8  Count No Responses                        */
    unsigned short  no_dataerr;         /* 9  Count Message Echo Errors                 */
    unsigned short  no_retries;         /* 10 Count Retries                             */
    unsigned short  no_rxhwerrs;        /* 11 Count Comm Hardware Errors                */
    unsigned short  no_txhwerrs;        /* 12 Count Comm Hardware Errors                */
    unsigned short  no_chksumerrs;      /* 13 Count Checksum Errors                     */
    unsigned short  no_offlines;        /* 14 Count Off Line Transitions                */
    unsigned short  cmd_reset_stat;     /* 15 Comand to reset stats                     */
    unsigned short  cmd_force_offline;  /* 16 Command to Force Offline                  */
    unsigned short  badoutcnt;          /* 17 Count Failed output commands              */
    unsigned short  no_frameerrs;       /* 18 Count Framing Errors                      */
    unsigned short  tscanpass;          /* Total number of scanpasses. incremented at   */
                                        /*  the start of each plc scan.                 */
    unsigned short  msgs;               /* Count of messages which got good responses.  */
                                        /*  incremented on each exit from 'good' msgxfer*/
    unsigned long   responsetime;       /* Total time(ticks) waiting for good responses.*/
                                        /* accumu (exit-entry) time for 'good' msgxfers */
    DATAGROUP1  st1;
    DATAGROUP2  st2;
    DATAGROUP3  st3;
    DATAGROUP5  st5;
   } SEC;

/* Various message lengths used in message transmission validation                      */
#define MAXDATALENGTH    128  /* Maximum length of returned data from SEC UPS           */


/* task definitions */
#define SEC_STACK        8000  /* Stack size              */
#define	SEC_PRIORITY     152   /* default priority        */
#define	SEC_TASK_OPTIONS 8     /* Floating point          */


typedef struct {
        unsigned long   TXintcount;
        unsigned long   RXintcount;
        unsigned long   RXbadcount;
        unsigned long   msgxfercount;
        unsigned long   startingtick;
               }        LINESTATS;

/* Trace Bit Definitions */

#define ALLTRAFFICTRACE      0x0001
#define DETAILEDTRACE        0x0002        /* MODBUS NACK errors.                               */
#define CONFIGURATIONTRACE   0x0010        /* trace details of message buliding and parsing.    */
#define RUNTIMEERRORTRACE    0x0020        /* trace run time errors in driver calls.            */
#define CALLREJECTTRACE      0x0040        /* trace non-error based driver call rejections.     */

#define OKTRACE              0x0100
#define COMMTRACE            0x0200
#define PROGTRACE            0x0400
#define FATALTRACE           0x0800
#define CONFIGTRACE          0x1000
#define UNKNOWNTRACE         0x2000

#define ASCIITRAFFICTRACE    0x4000        /* when combined with ALLTRAFFICTRACE,               */
                                           /*  prints comm traffic in ascii.                    */
/*	End of File:	drvSec.h */
