/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/****************************************************************
*  File: drvSecurity.c
*  Edit:  7/20/95      WEP: original version.
*                         :
*
*****************************************************************/


#define  MAIN           security_driver      /* NOTE: change here */
#define  AIDRIVER       security_aidriver    /* NOTE: change here */
#define  BIDRIVER       security_bidriver    /* NOTE: change here */
#define  BODRIVER       security_bodriver    /* NOTE: change here */
#define  BOREAD         security_boread      /* NOTE: change here */
#define  SIDRIVER       security_sidriver    /* NOTE: change here */
#define  SODRIVER       security_sodriver    /* NOTE: change here */

#define  TRAFFICON      sectrafficon         /* NOTE: change here */
#define  TRAFFICOFF     sectrafficoff        /* NOTE: change here */
#define  TRACEON        sectraceon           /* NOTE: change here */
#define  TRACEOFF       sectraceoff          /* NOTE: change here */
#define  RTRACE         secrestrlv           /* NOTE: change here */
#define  RTRACEON       secrestraceon        /* NOTE: change here */
#define  RTRACEOFF      secrestraceoff       /* NOTE: change here */
#define  TRACELEVEL     sectrlv              /* NOTE: change here */
#define  CONTRACEON     seccontraceon        /* NOTE: change here */
#define  CONTRACEOFF    seccontraceoff       /* NOTE: change here */
#define  RUNTRACEON     secruntraceon        /* NOTE: change here */
#define  RUNTRACEOFF    secruntraceoff       /* NOTE: change here */
#define  REJECTTRACEON  secrejecttraceon     /* NOTE: change here */
#define  REJECTTRACEOFF secrejecttraceoff    /* NOTE: change here */
#define  NACKTRACEON    secnacktraceon       /* NOTE: change here */
#define  NACKTRACEOFF   secnacktraceoff      /* NOTE: change here */
#define  DEFAULTTRACE   secdefaulttrace      /* NOTE: change here */
#define  ERRORTRACE	secerrortrace        /* NOTE: change here */

#define  HELP           sechelp              /* NOTE: change here */

#define  STOPDRIVER     stopsecurity         /* NOTE: change here */
#define  STARTDRIVER    startsecurity        /* NOTE: change here */
#define  SETCOMM        seccomm              /* NOTE: change here */

#define  DUMPMSGCNTS    secdumpmsgcnts       /* NOTE: change here */
#define  CLEARMSGCNTS   secclearmsgcnts      /* NOTE: change here */
#define  DUMPSECSTATS   dumpsecstats         /* NOTE: change here */
#define  CLEARSECSTATS  clearsecstats        /* NOTE: change here */

#define  TABLEINFO      sectable             /* NOTE: change here */
#define  LINEINFO       secline              /* NOTE: change here */


#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>
#include <string.h>
#include <errno.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvSecurity.h>                     /* NOTE: change here */
#include <drvSecurity_proto.h>               /* NOTE: change here */
#include <restable.h>
#include <tsDefs.h>

extern TS_STAMP	time_stamp;	/* current time stamp, defined in .../share/src/time/ts_drive.c */

/* static long	init(); */

struct	{
	long		number;
	DRVSUPFUN	report;
	DRVSUPFUN	init;
	} drvSecurity = { 2, NULL, init};

/**********************************************************************
*
*      External Line Level Data Structures (declared in drvcommon.c)
*
***********************************************************************/

extern	unsigned char	resnames[SECLINES][RESNAMELEN]; /* array of resource name strings.		*/

extern	RES_TABLE      *prestable [SECLINES];		/* array of pointers to resource tables 	*/

extern	unsigned short	resresponse [SECLINES];		/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

extern	unsigned short	line_activity [SECLINES];	/* true/false line active flag. calculated	*/
							/* using activity_time below. 			*/

extern	unsigned short	lastactivity [SECLINES];	/* assigned value of line_activity prior to	*/
							/* it's recalculation.   			*/

extern	unsigned short	modtrace [SECLINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/

extern	unsigned short	mltrace [SECLINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/

extern	unsigned short	modrestrace [SECLINES];		/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/

extern	SEM_ID		semids [SECLINES] [2];		/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

extern	unsigned short	intermsgdelay [SECLINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/

extern	long		activity_time [SECLINES];	/* holds timetick of last activity. used to	*/
							/* set line_activity flag  			*/

extern  unsigned short  pstatewait [SECLINES];          /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */

/***************************************************
*
*      Storage for Security Comm Line Structures
*
****************************************************/

/*static RXLINE          *rxlinetab [SECLINES] = {
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 };				  /* array of pointers to dynamically           */
                                                          /* allocated comm controls/buffers            */

static TXLINE          *txlinetab [SECLINES] = { 
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 };				  /* array of pointers to dynamically           */
                                                          /* allocated comm controls/buffers            */
static RXRAWQUE         *rxrawq[SECLINES];                /* array of ptrs to the raw rx input queues   */
                                                          /* and their control structures               */
static  unsigned short   rxsave[SECLINES];                /* 0 = do not buffer rx input. 0 != buffer it.*/
  



/****************************************
*
*      Storage for Security Structures
*
*****************************************/

static void            *pointerpointer;

static unsigned int     tick [SECLINES][5];

static unsigned int     lastscan [SECLINES];             /* holds timestamp of beginning of major loop. */

static unsigned int     scantime [SECLINES];            /* holds actual time taken to scan terminal.    */

static unsigned int     loopoutmsgs [SECLINES];

static unsigned int     loopmsgs [SECLINES];

static LINESTATS	linestats [SECLINES];		/* array of line level statistics.              */

static SECURITY	       *security [SECLINES];            /* fixed length dynamically allocated Security  */
                                                        /* control and data structures.                 */

static	unsigned short	trace [SECLINES];		/* controls output of system error messages:	*/
							/* bit mapped controls                          */
static  unsigned char   traceadr [SECLINES];
static  unsigned char   tracetype [SECLINES];

static  OUTPUTQUE	*oq [SECLINES];			/* array of ptrs to the line output queues and  */
                                                        /* their control structures                     */

static char		user [40], password [40];	/* holds id and password of the user that       */
                                                        /* spawned the driver task required by host to  */
                                                        /* check file read privileges on TERMINAL       */
                                                        /* load files.                                  */
static  LOADUSER       *userlist [SECLINES];

static  unsigned short  options [SECLINES];             /* store half/full duplex line status           */

static char *bools [] = {
	"TRUE ",
	"FALSE"
	};

static int		taskId [SECLINES];
static short        watchdogId [SECLINES];


static char *tasknames [] = {
		"SECURE Ch0","SECURE Ch1","SECURE Ch2","SECURE Ch3",
		"SECURE Ch4","SECURE Ch5","SECURE Ch6","SECURE Ch7",
		"SECURE Ch8","SECURE Ch9","SECURE Ch10","SECURE Ch11",
		"SECURE Ch12","SECURE Ch13","SECURE Ch14","SECURE Ch15",
		"SECURE Ch16","SECURE Ch17","SECURE Ch18","SECURE Ch19",
		"SECURE Ch20"
		};

static int secwait[SECLINES];

secgo(unsigned short line)
{
    secwait[line] = TRUE;
}


/*******************************************************************
*
*	This routine is required by iocinit in the EPICS system.
*
*******************************************************************/

static long init ()
{
	return (0);
}

/*****************************************************************
*
*	This routine outputs information to help with debugging.
*
*****************************************************************/

void HELP (void)
{
    printf (" Security Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" sectraceon(N)         Enable the following debug messages for line N:             \n");
    printf ("                         1) Major Scan loop Info:                                  \n");
    printf ("                           scan time, total output messages, and total messages.   \n"); 
    printf ("                         2) Output Queue Overflow.                                 \n");
    printf ("                         3) All communication errors encountered in msgxfer.       \n");
    printf ("*sectraceoff(N)        Disable all of the sectraceon debug messages for line N.    \n");
    printf ("\n");
    printf (" secrestrace(N,X)      Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*secrestraceon(N)      Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" secrestraceoff(N)     Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");

    taskDelay (60);		/* Time for operator to see it and pause the output */

    printf (" seccontraceon(N)      Enable display of configuration errors in driver calls.     \n");
    printf ("*seccontraceoff(N)     Disable display of configuration errors in driver calls.    \n");
    printf (" secruntraceon(N)      Enable display of runtime errors (queue overflow).          \n");
    printf ("*secruntraceoff(N)     Disable display of runtime errors (queue overflow).         \n");
    printf (" secrejecttraceon(N)   Enable display of driver call rejections in driver calls.   \n");
    printf ("*secrejecttraceoff(N)  Disable display of driver call rejections in driver calls.  \n");
    printf (" secnacktraceon(N)     Enable display of point deselection on MODBUS command NACK. \n");
    printf ("*secnacktraceoff(N)    Disable display of point deselection on MODBUS command NACK.\n");
    printf ("\n");

    taskDelay (60);		/* Time for operator to see it and pause the output */

    printf (" sectrlv(N,X)          Enable the following message for line N:                  \n");
    printf ("                         X=0,  display none of the messages below.               \n");
    printf ("                         X=1,  beginning of scan loop.                           \n");
    printf ("                         X=2,  reserved.                                         \n");
    printf ("                         X=3,  AO queue actions (normal: AODRIVER & checkoutputs)\n");
    printf ("                         X=4,  BO queue actions (normal: BODRIVER & checkoutputs)\n");
    printf ("                         X=5,  SO queue actions (normal: SODRIVER & checkoutputs)\n");
    printf ("                         X=6,  calls to checkoutputs.                            \n");
    printf ("                         X=7,  checkoutputs: trace each queue entry read.        \n");
    printf ("                         X=8,  AIDRIVER, AOREAD: normal call return.             \n");
    printf ("                         X=9,  BIDRIVER, BOREAD: normal call return.             \n");
    printf ("                         X=10, SIDRIVER: normal call return.                     \n");
    printf ("                         X=11 to 254,  reserved.                                 \n");
    printf ("\n");

    taskDelay (60);		/* Time for operator to see it and pause the output */

    printf (" sectrafficon(N)       Enable traffic tracing on line N.                           \n");
    printf ("*sectrafficoff(N)      Disable all traffic tracing on line N.                      \n");
    printf ("\n");
    printf (" secdefaulttrace(N)    Restores default setting for all traces.                    \n");
    printf ("\n");

    taskDelay (60);		/* Time for operator to see it and pause the output */

    printf (" seccomm(N,t1,f,t2,t3) Set communication timing parameters for line N as follows:  \n");
    printf ("                         t1: intermessage delay (in ticks).                        \n");
    printf ("                          f: 0 = full duplex, 1 = half duplex.                     \n");
    printf ("                         t2: post RTS assert, pre TX delay (in ticks).             \n");
    printf ("                         t3: post TX, pre RTS drop delay (in ticks).               \n");
    printf ("\n");
    printf (" secdumpmsgcnts(N)     Display line N communication statistics.                    \n");
    printf (" secclearmsgcnts(N)    Display and clear line N communication statistics.          \n");
    printf (" dumpsecstats(N,X)     Display line N, plc X, communication statistics.            \n");
    printf (" clearsecstats(N,X)    Display and clear line N, plc X, xfers, status & errors.    \n");
    printf (" sectable(N)           Display line N user/password info.\n");
}


/*************************************************************
*
*	This routine enables logging of comm trace messages
*
*************************************************************/

void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/*************************************************************
*
*	This routine disables logging of comm trace messages
*
*************************************************************/

void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}

/********************************************************************************
*
*	This routine enables detailed display of normal communications traffic
*
********************************************************************************/

void TRAFFICON (unsigned short line)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = 255;  /* every address */
        tracetype [line] = 255; /* every message type */
}

/********************************************************************************
*
*	This routine disables detailed display of normal communications traffic
*
********************************************************************************/

void TRAFFICOFF (unsigned short line)
{
	trace [line] = trace [line] & ~ALLTRAFFICTRACE;
}

/*****************************************************************
*
*	This routine enables logging of resource trace messages
*
*****************************************************************/

void RTRACE (unsigned short line, unsigned short level)
{
	modrestrace [line] = level;
}

/*****************************************************************
*
*	This routine enables logging of resource trace messages
*
*****************************************************************/

void RTRACEON (unsigned short line)
{
	modrestrace [line] = 1;
}

/*****************************************************************
*
*	This routine disables logging of resource trace messages
*
*****************************************************************/

void RTRACEOFF (unsigned short line)
{
	modrestrace [line] = 0;
}

/*********************************************************
*
*	This routine controls logging of trace messages
*
*********************************************************/

void TRACELEVEL (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}

/**************************************************************************************
*
*	These routines enable and disable tracing of database configuration errors in 
*	driver calls
*
**************************************************************************************/

void CONTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }

void CONTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }

/************************************************************************************
*
*	These routines enable and disable tracing of runtime errors in driver calls
*
************************************************************************************/

void RUNTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }

void RUNTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/*******************************************************************************************
*
*	These routines enable and disable tracing of call rejection errors in driver calls
*
*******************************************************************************************/

void REJECTTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }

void REJECTTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }


/*******************************************************************************************
*
*	These routines enable and disable tracing of call rejection errors in driver calls
*
*******************************************************************************************/

void NACKTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | MODBUSNACKTRACE;
    }

void NACKTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~MODBUSNACKTRACE;
    }

/**************************************************************
*
*	This routine restores default setting for all traces.
*
**************************************************************/

void DEFAULTTRACE (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = 1;
        trace [line] = 0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
    }

/************************************************
*
*	This routine turns on all error tracing.
*
*************************************************/

void ERRORTRACE (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = TRUE;
	modrestrace [line] = 2;
	trace[line] = MODBUSNACKTRACE ||
                      CONFIGURATIONTRACE ||
                      RUNTIMEERRORTRACE ||
                      CALLREJECTTRACE ||
                      0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
    }

/*************************************
*
*	stop the security driver task
*
**************************************/

int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
            /* if watchdog timer has been attached, detach it before deleting the task */
            if (taskId[ln])
            {
                tisWatchDogDetach(taskId[ln]);
            }
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}
/***************************************
*
*	start the security driver task
*
****************************************/

int STARTDRIVER  (unsigned short line,      /* the line number of this driver.                      */
                  char *mode,               /* UART initializations string (comma delimited ascii). */
                  unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                  unsigned short private)   /* private flag. if 0, normal. if !0, no partner driver.*/

{
	if (line < SECLINES)
	{
	    taskId [line] = taskSpawn (tasknames [line],
                                     SEC_PRIORITY,
                                     SEC_TASK_OPTIONS,
                                     SEC_STACK,
                                     MAIN,
                                     line,
                                     mode,
                                     delay,
                                     private);

	    logMsg ("Started the Security driver on line %d\n",line);

	    /* vxWorks, get current user/passsword used for remote access */
	    remCurIdGet (user,password);
	    return (1);
	}
	else
	{

	    logMsg ("Invalid line number %d\n", line);
	    return (-1);
	}
}

/**************************************************************************************
*
* Set communication logic time delays to handle half/full duplex, radio delays, etc.
*
***************************************************************************************/

void SETCOMM (unsigned short line,
              unsigned short tickcount1)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
}


/*************************************************************************
*      Security_driver
*
*      The purpose of this task is to scan the terminal lines.
*      It will maintain a configuration list supporting online additions
*      and replacement of modules, and maintain a table of most recently
*      scanned values.
*
**************************************************************************/

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short private)
{
	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command,i;
	long	        this_time, last_time;
	SECURITY       *psec;
        unsigned int    temptick, tempdiff;
        int             temp;
	int		first_pass = 1;

        short          *ptable_id;

        RXRAWQUE       *qp;

	/* Initialize the data structures */

	intermsgdelay [line] = delay;

	resresponse [line] = FALSE;
	resnames [line] [0] = 0;
	prestable [line] = NULL;

	activity_time [line] = tickGet ();
	lastactivity [line] = line_activity [line] = FALSE;

        pstatewait[line] = 60;      /* will wait up to one minute for partner to become valid */

        /* initialize debug structures */

        secdefaulttrace (line);

        tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].msgxfercount = 0;
        linestats [line].startingtick = tickGet ();

        /* allocate user/password linklist structure */
        userlist[line] = (LOADUSER *)calloc(1,(sizeof(LOADUSER)));
        if (!userlist[line])
        {
            logMsg ("Not enough memory for data structure (userlist)\n");
            return;
        }
	userlist[line] -> firstuser = (USER *)0;

        /* wait here for manual enable of continuation. */
        /* this allows time for vxgdb to be attached to debug file parsing logic */
/*	secwait[line] = FALSE;
	while(!secwait[line])
	{
	    taskDelay(60);
/*            putStr (line, "Hello World!\n"); */
/*	} */
        /* open the address user file and build translation table */
        if (!loaduserfile(line))
        {
            logMsg("Security: Error on loading user/password file, Security task will teminate\n");
            return;
        }

        /* output queue initialization */
	oq [line] = (OUTPUTQUE *) calloc (1, (sizeof (OUTPUTQUE)));
	if (!oq [line])
	{
	    logMsg ("Not enough memory for line %d data output queue, Security task will termiante\n",
		     line);
	    return;
	}
        outqueinit (line);

        /* communication initialization: Raw RX Queue */
        rxrawq[line] = (RXRAWQUE *)calloc(1,(sizeof(RXRAWQUE)));
        if (!rxrawq[line])
        {
            logMsg ("Not enough memory for line %d comm: raw RX queue, Security task will terminate\n",
		     line);
            return;
        }

        qp = rxrawq[line];
        qp->rxinix = qp->rxoutix = 0;

        /* communication initialization */
	txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
	if (!txlinetab [line])
	{
	    logMsg ("Not enough memory for line %d comm: tx, Security task will termiante\n",line);
	    return;
	}

        /*******************************************/
        /* Initialize communications hardware.     */
        /*******************************************/

        taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */
	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
        taskUnlock ();

	onlinefreq = 1;	  /* causes on_line calls to begin on first pass if master */

        /*******************************************/
        /*  Initialize RX interrupts. (forever)    */
        /*******************************************/

	/* Initialize the Rx Input Buffer to receive data */
	start_rx(line);

	/* Initialize the Rx interrupts to receive once for activity check         */
	/* enable the receiver interrupt after set to ignore                       */
        enable_rx_ints (line);

        /****************************************/
        /********** TEST: allow input. **********/
/*        rxsave[line] = TRUE;
	secwait[line] = FALSE;
	while(!secwait[line])
	{
	    taskDelay(60);
            putStr (line, "Hello World!\n");
	}
        rxsave[line] = FALSE;
        qp->rxinix = qp->rxoutix = 0;
        /****************************************/
        /****************************************/

        /* initially discard all input. */
        rxsave[line] = FALSE;

	/* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
	while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
	{
            if (modrestrace [line] > 1)
	    {
	    	logMsg ( "No Resource Defined for line - %d \n", line);
	    }
	    taskDelay (300);
	}

        psec = security [line];		/* shorthand pointer 			*/


        /* attach this driver task to the watchdog timer monitoring function. */
        ptable_id = &watchdogId[line];

        if (tisWatchDogAttach(taskId[line],WATCHDOGTIMEOUT, ptable_id) != OK)
        {
            logMsg("Attempt at watchdog attachment failed, Security task will terminate\n");
            tisWatchDogDetach(taskId[line]);
            return;
        }
        if (tisWatchDogPulse(watchdogId[line]) != OK)
        {
            logMsg("First attempt at watchdog pulsing failed, Security task will terminate\n");
            tisWatchDogDetach(taskId[line]);
            return;
        }

        if (private)
        {
            /*****************************/
	    /* Immediately become master */
            /*****************************/

	    resSetCaAnswer (prestable [line]);
	    resPutLocalState (prestable [line], RES_MSTR);

            lastscan [line] = tickGet ();
            scantime [line] = 0;

	    lstate = RES_MSTR;
	    if (modrestrace [line])
	    {
	    	logMsg ("0] Private: Initialize as RES_MSTR\n");
	    }
            /* flush the input queue */
            disable_rx_ints(line);
            qp->rxinix = qp->rxoutix = 0;
            enable_rx_ints(line);
            /* start saving the input. */
            rxsave[line] = TRUE;
            /* when becoming master, bring terminal on_line */
            on_line (line);
        }
        else /* this is the 'normal' path */
        {
            /**********************/
            /* Start out as slave */

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            resClearCaAnswer (prestable [line]);		/* start quiet */
            resPutLocalState (prestable [line], RES_SLV);

            if (modrestrace [line])
            {
                logMsg ("1] Initialized as RES_SLV\n");
            }
            /* trash all input characters while in 'normal' slave mode. */
            rxsave[line] = FALSE;

            /* wait finite time for pstate to be resolved */
            logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
            for (i = 0; i <= pstatewait [line]; i++)
            {
                resGetStates (prestable [line], &lstate, &pstate);
                if (pstate != 0)
                {
	            break;
                }
                taskDelay (60);
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/
            }
            if (pstate == 0)
            {
                logMsg ("Timeout of pstate wait.\n");
            }
            else
            {
                logMsg ("Completion of pstate wait.\n");
            }

            for (i = 0; i < ACTIVITYTIME/10; i++) ;  /* ten seconds */
            {
                taskDelay(10);
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/
            }

            resGetStates (prestable [line], &lstate, &pstate);

            /******************************************/
            /* if the partner is not there, be master */
            if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT))
            {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lastscan [line] = tickGet ();
                scantime [line] = 0;
                lstate = RES_MSTR;
                if (modrestrace [line])
                {
                    logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
                }
                /* flush the input queue */
                disable_rx_ints(line);
                qp->rxinix = qp->rxoutix = 0;
                enable_rx_ints(line);
                /* start saving the input. */
                rxsave[line] = TRUE;
                /* when becoming master, bring terminal on_line */
                on_line (line);
            }
        }

	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet (); /* Initialize the time  */

	while (TRUE)
	{
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

	    activity_time [line] = tickGet ();
	    lastactivity [line] = line_activity [line] = FALSE;

            /********************************************************************************************/
	    /* we arrive here because we are a slave.                                                   */
	    /* we stay until:   asked to be master by partner. if we can reach TERMINAL, we become 	*/
	    /*			master.									*/
            /*                  the partner is not master and there is no activity on the line.         */
            /********************************************************************************************/

	    while (lstate == RES_SLV)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

		if (pstate != RES_SLVWANT)
		{
		    clear_rts (line); 				/* make sure line is left for master 	*/
		}
                /* trash all input characters while in 'normal' slave mode. */
                rxsave[line] = FALSE;
		resresponse [line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand (prestable [line], 0); 		/* clear out commands 			*/
		resGetStates (prestable [line], &lstate, &pstate);

                /****************************************************************************************/
		/* see if needed by partner to be master. if yes, do it and break out of slave state.   */
		if (pstate == RES_SLVWANTCA)
		{
                    rxsave[line] = TRUE;
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
			logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
		    break;
                    /* flush the input queue */
                    disable_rx_ints(line);
                    qp->rxinix = qp->rxoutix = 0;
                    enable_rx_ints(line);
                    /* start saving the input. */
                    rxsave[line] = TRUE;
                    /* when becoming master, bring terminal on_line */
                    on_line (line);
		}
                /***************************************************************/
		/* If partner is there and wants to give it up, try to take it */

		if (pstate == RES_SLVWANT)
		{
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

		    execute = FALSE;
		    taskDelay (2); /* Time for switch to occur */

		    /* See if you can output a CR without a communication error */
		    if ((psec) &&                       /* verify pointer validity prior to use         */
		        (psec->was_requested) &&        /* data points have been requested              */
                        (!psec->cmd_force_offline))     /* user has NOT forced security driver offline  */
		    {
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        /* allow input buffer to receive, (normally not allowed while in slave mode) */
                        rxsave[line] = TRUE;
                        on_line (line);
                        rxsave[line] = FALSE; /* discard all other input for now. (none should occur) */

                        /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                        if ((psec->is_responding) && (!psec->cmd_force_offline))
			{
			    execute = TRUE;
			    break;
                        }
		    }
                    /* If no comm error, become master make sure partner really gave it up. */
		    if (execute)
		    {
			resPutLocalState (prestable [line], RES_MSTR);
			lstate = RES_MSTR;

                        lastscan [line] = tickGet ();
                        scantime [line] = 0;

			if (modrestrace [line])
			{
				logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			}
                        /* flush the input queue */
                        disable_rx_ints(line);
                        qp->rxinix = qp->rxoutix = 0;
                        enable_rx_ints(line);
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        resGetStates (prestable [line], &lstate, &pstate);
                        if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) )
                        {
                            /* Assume control by taking the CA responsibilities. */
			    resSetCaAnswer (prestable [line]);
			    prepresponses (line);
			    break;
			}
		    }
		}
            } /* end while (lstate === RES_SLV) */
            /****************************************************************************************/
            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is canceled           */
	    while (lstate == RES_SLVWANTCA)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                rxsave[line] = FALSE;
	        taskDelay (2);                   /* Give OS a chance...  */
		clear_rts (line); 		/* Make sure line is left for master    */
		resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */

		resGetStates (prestable [line], &lstate, &pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace [line])
		    {
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    }
                    /* trash all input characters while in 'normal' slave mode. */
                    rxsave[line] = FALSE;
		    break;
		}
		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
		    {
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
                    /* flush the input queue */
                    disable_rx_ints(line);
                    qp->rxinix = qp->rxoutix = 0;
                    enable_rx_ints(line);
                    /* start saving the input. */
                    rxsave[line] = TRUE;
		    prepresponses (line);
                    /* when becoming master, bring terminal on_line */
                    on_line (line);
		}
	    }

            /****************************************************************************************/
	    /* in normal operation this code should never execute. it has, however, been seen to    */
            /* execute when the database has been inadvertently configured with the same resource   */
	    /* assigned to two different drivers in the same IOC. The state does funny things.      */
            /****************************************************************************************/
	    while (lstate == RES_SLVWANT)
	    {
                if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))

		{
                    /* condition should NEVER occur. print error message every 5 seconds. */
                    logMsg ("Illegal Local Resource State.\n");
                    if (trace[line] & CONFIGURATIONTRACE)
                    {
                        logMsg ("  Possible Resource Configuration Error:\n");
                        logMsg ("   Check for multiple drivers sharing single Resource.\n");
                    }
                    taskDelay (300);
                }
                taskDelay (2);
            }
            /****************************************************************************************/
            /* we come here because we have gone to, or are looping in, the master state.           */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
	    /* It will then try to configure requested non-responding modules.                      */
            /****************************************************************************************/

	    last_time = tickGet ();		/* initialize gap */
	    while (lstate == RES_MSTR)
	    {
		/* write the 1st ID prompt to the terminal */
		if (first_pass)
		{
		    putStr (line, SEC_ID_PROMPT);
		    first_pass = 0;
                    psec->logonstatus = SEC_LOGGED_OFF;
                    psec->data_valid = TRUE;
		}
		if (mltrace [line] == 1)
		{
			logMsg ( "Top of Master Loop... \n");
	        }
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

		/* initial stuff */
		resresponse [line] = TRUE; /* Make sure driver is responding. driver won't           */
                                           /* issue commands if not set.                             */

                rxsave[line] = TRUE;

		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0);        /* clear out commands */

                /************************************************************************/
		/* if relinquish command sent, change state and break out to outer loop */
		if (command == RES_RELINQUISH)
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace [line])
		    {
                       logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}

                /* measure time between scans of dumb terminal. display if requested. */
                temptick = tickGet ();
                tempdiff = temptick - lastscan [line];

                if (modtrace [line])
		{
                    logMsg ("ScanTime: =%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                            scantime[line], loopoutmsgs[line], loopmsgs[line]);
		}

                loopoutmsgs [line] = 0;
                loopmsgs [line] = 0;
                lastscan [line] = temptick;

		/* scan dumb terminal for data i/o, if allowed */
		if (psec)                       /* verify pointer validity prior to use */
		{
		    if (psec->cmd_force_offline)
		    { 
                        /* if user has turned this driver via pseudo commands,     */
                        /* mark it as not responding.                              */
                        psec->is_responding = FALSE;
                    }
                    else if (psec->is_responding)
                    {
                        /* local/partner lockstep recovery */
                        resGetStates (prestable [line], &lstate, &pstate);
                        if (pstate == RES_MSTR)
                        {
                            resClearCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_SLV);
                            lstate = RES_SLV;
                            clear_rts (line); 		/* Make sure line is left for master */
                            if (modrestrace [line])
	                    {
                                logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                            }
                            /* trash all input characters while in 'normal' slave mode. */
                            rxsave[line] = FALSE;

                            temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                            for ( i = 0; i < temp; i++)
                            {
                               /******************************/
                               tisWatchDogPulse(watchdogId[line]);
                               /******************************/
                               taskDelay(60);
                            }
                            break;
                        }

                        scan_terminal (line);      	/* I/O done here! 		*/

                    }
		    /* end of single module action */

		    /* if told to relinquish master state, stop terminal scanning immediately.*/
		    /* don't trash the command, so that we can still read it on the next loop */
                    /* through this while statement.                                          */
		    resGetCommand (prestable [line], &command);
		    if (command == RES_RELINQUISH)
		    {
			break;
		    }
		} /* end of scan loop */

                /* test for lockstep detection. */
                if (lstate != RES_MSTR) break;

                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                /* measure how long the scan took. to be displayed at beginning of next loop. */
                temptick = tickGet ();
                scantime [line] = temptick - lastscan [line];

		/* see if anyone on the line has been responding. */
                /* if not, try to get partner to become slave.    */
		/* Check for no one responding */


                if (!psec->is_responding)
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

                    /* See if it is time to let partner try */

                    this_time = tickGet ();
                    if ((this_time - last_time) > (3 * SLWWINDOW))
                    {   /* #ticks for slave to try */

                        /* Switch States to let partner know it's its time to try */
                        resPutLocalState (prestable [line], RES_SLVWANT);
                        lstate = RES_SLVWANT;
                        if (modrestrace [line])
                        {
                            logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n", pstate, activity);
                        }
                        /* Give partner access to the hardware */
                        clear_rts (line);

                        /* Remember the time of this try */
                        last_time = tickGet ();

                        for (i = 0; (i < SLWWINDOW); i += 10)
                        {       		/* SLWINDOW is the # of ticks for slave to try */
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay (10);

                            /* If partner picked up let it have control */
                            resGetStates (prestable [line], &lstate, &pstate);
                            if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
                            {
                                resClearCaAnswer (prestable [line]);
                                resPutLocalState (prestable [line], RES_SLV);
                                lstate = RES_SLV;
                                if (modrestrace [line])
                                {
                                    logMsg ("11] Became RES_SLV  P= %x A= %d \n",
                                             pstate, activity);
                                }
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                                break;
                            }
                        }
                        /* Go Back to being the Master and take control of the hardware */
                        if (lstate != RES_SLV)
                        {
                            resPutLocalState (prestable [line], RES_MSTR);
                            lstate = RES_MSTR;
                            if (modrestrace [line])
                            {
                                logMsg ("12] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
                            }
                            /* when becoming master, we reset the CIU and start building the data structures */
                            on_line (line);
                        }
                    }
                }

		/* take security logic off hold status. the security data is not */
                /*  to be held off since now master.                             */

                if (psec)			/* verify pointer validity prior to use */
                {        
                    psec->holdflag = FALSE;
                }
                taskDelay(6);
	    } /* end while (lstate == RES_MSTR) */

	} /* end infinite task loop */

} /* end MAIN */


/*************************************
*
* Try to bring a TERMINAL on line
* this routine only called from MAIN
*
*************************************/


static void on_line (unsigned short line)
{
    SECURITY       *psec;
    unsigned short  i, j;

    psec = security [line];
    if (psec)			/* verify pointer prior to use */
    {
        if (mltrace [line] == 1)
        {
            logMsg ( "Bring Terminal Online %d\n");
        }
        /* Use the loop back function to see if the unit is there and responding */

        init_security_tab (line);	     /*	initialize the data structures. */

        psec->is_responding = TRUE;
    }
}


/*************************************************************
*
* Scan a TERMINAL -  get inputs and set outputs as required	
* this routine only called from MAIN 
*
*************************************************************/

static void scan_terminal (unsigned short line)
{
    SECURITY		*psec;
    LOADUSER		*puserlist;
    char		tsStampText[128];
    char		*p;
    unsigned char	currChar;
    unsigned long	current_clk_ticks;
    unsigned long	delta_ticks;
    int			need_password = 0;

    psec = security[line];
    puserlist = userlist[line];

    psec->tscanpass++;
    if (mltrace[line] == 2)
    {
	logMsg ("Scanning Terminal\n");
    }

    if ((psec -> login_state == SEC_IDLE) || (psec -> logonstatus == SEC_LOGGED_ON))
    {
        checkoutputs (line);
    }

    tsStampToText (&time_stamp, TS_TEXT_MONDDYYYY, tsStampText);

    /* remove the nano-seconds from the timestamp */
    if ((p = strchr (tsStampText, '.')) != NULL)
	*p = NULL;
    current_clk_ticks = tickGet ();

    if (psec -> logonstatus == SEC_LOGGED_ON)
    {
	if (checkCh (line))
	{
	    currChar = getCh (line);
	    if ((currChar == 'Y') || (currChar == 'y'))
	    {
		strncpy (psec -> logstamp, tsStampText, 
					      sizeof (psec -> logstamp));
		psec -> logonstatus = SEC_LOGGED_OFF;
		putStr (line, SEC_ID_PROMPT);
		reset_new_login (line);
		return;
	    }
	}

	/* check for output messasges while someone is still logged on */
/*	checkoutmsgs (line, psec);*/

	psec -> logontime = current_clk_ticks - psec -> last_clk_ticks;
	if (psec -> logontime >= puserlist -> timeout)
	{
	    strncpy (psec -> logstamp, tsStampText, sizeof (psec -> logstamp));
	    psec -> logonstatus = SEC_TIMED_OUT;
	    putStr (line, SEC_ID_PROMPT);
	    reset_new_login (line);
	    return;
	}
    }
    else
    {
	switch (psec -> login_state)
	{
	    case SEC_IDLE:
		/* is there a character */
		if (!checkCh (line))
		{
                    /* check for output messages */
/*		    checkoutmsgs (line, psec); */
                    break;
                }
                psec -> login_state = SEC_LOGIN_ID;
                /* intentional fall through. */

	    case SEC_LOGIN_ID:
		/* is there a character */
		if (checkCh (line))
		{
		    currChar = getCh (line);
		    switch (currChar)
		    {
			case '\n':
			case '\r':
			    psec -> idx++;
			    psec -> newuserid[psec -> idx] = 0;
			    if ( (valid_id (line, &need_password)) == SEC_INVALID_ID)
			    {
				psec -> baduseridcnt++;
				reset_new_login (line);
				putStr (line, SEC_ILLEGAL_ID_MSG);
				putStr (line, SEC_ID_PROMPT);
				break;
			    }
			    if (need_password)
			    {
				putStr (line, SEC_PASSWD_PROMPT);
				psec -> login_state = SEC_PASSWD_ID;
                                psec -> idx = -1;
			    }
			    else
			    {
				psec -> newpasswd[0] = '*';
				psec -> newpasswd[1] = 0;
				psec -> login_state = SEC_LOGIN_FINISH;
			    }
			    break;
			default:
			    psec -> idx++;
			    if (psec -> idx >= MAXUSERLEN)
			    {
				reset_new_login (line);
				putStr (line, SEC_LOGNAME_TO_LONG_MSG);
				putStr (line, SEC_ID_PROMPT);
			    }
			    else
			    {
				/* echo the character back to the terminal */
				putCh (line, currChar);
				psec -> last_clk_ticks = current_clk_ticks;
				psec -> newuserid[psec -> idx] = currChar;
			    }
			    break;
		    }
		}
		/* someone is trying to log on */
		else
		{
		    if (psec -> idx >= 0)
		    {
			delta_ticks = current_clk_ticks - psec -> last_clk_ticks;
/*			if ( (psec -> last_clk_ticks + delta_ticks) > SEC_CHAR_TIMEOUT) */
			if (delta_ticks > SEC_CHAR_TIMEOUT)
			{
			    reset_new_login (line);
			    putStr (line, SEC_INPUT_TIMEOUT_MSG);
			    putStr (line, SEC_ID_PROMPT);
			}
		    }
		}
		break;

	    case SEC_PASSWD_ID:
		if (checkCh (line))
		{
		    currChar = getCh (line);
		    switch (currChar)
		    {
			case '\n':
			case '\r':
			    psec -> idx++;
			    psec -> newpasswd[psec -> idx] = 0;
			    psec -> login_state = SEC_LOGIN_FINISH;
			    break;
			default:
			    psec -> idx++;
			    if (psec -> idx >= MAXUSERLEN)
			    {
				reset_new_login (line);
				putStr (line, SEC_PASSWD_TO_LONG_MSG);
				putStr (line, SEC_ID_PROMPT);
			    }
			    else
			    {
				psec -> last_clk_ticks = current_clk_ticks;
				psec -> newpasswd[psec -> idx] = currChar;
			    }
			    break;
		    }
		}
		/* someone is trying to enter a password */
		else
		{
		    if (psec -> idx >= 0)
		    {
			delta_ticks = current_clk_ticks - psec -> last_clk_ticks;
/*			if ( (psec -> last_clk_ticks + delta_ticks) > SEC_CHAR_TIMEOUT) */
			if (delta_ticks > SEC_CHAR_TIMEOUT)
			{
			    reset_new_login (line);
			    putStr (line, SEC_INPUT_TIMEOUT_MSG);
			    putStr (line, SEC_ID_PROMPT);
			}
		    }
		}
		break;

	    case SEC_LOGIN_FINISH:
		if ( (valid_passwd (line) == SEC_VALID_LOGIN))
		{
		    psec -> last_clk_ticks = current_clk_ticks;
		    strncpy (psec -> logstamp, tsStampText, sizeof (psec -> logstamp));
		    strncpy (psec -> userid, psec -> newuserid, sizeof (psec -> userid));
		    psec -> logonstatus = SEC_LOGGED_ON;
		    putStr (line, SEC_LOGOFF_PROMPT);
		}
		else
		{
		    psec -> badpasswordcnt++;
		    putStr (line, SEC_INVALID_PASSWD_MSG);
		    putStr (line, SEC_ID_PROMPT);
		}
		reset_new_login (line);
		break;
	}
    }

    return;
}

/*********************************************************
*
*    reset state on line back to a start login condition
*
*********************************************************/

static void reset_new_login (unsigned short line)
{
    SECURITY	*psec;

    psec = security[line];

    bzero (psec -> newuserid, sizeof (psec -> newuserid));
    bzero (psec -> newpasswd, sizeof (psec -> newpasswd));
    psec -> logontime = 0;
    psec -> login_state = SEC_IDLE;
    psec -> idx = -1;
    return;
}

/************************************************************************
*
*    check if
*	a) the user is valid as listed in the userlist read in from the
*	   user file
*	b) also return if a password is needed to complete the logon
*
************************************************************************/

static int valid_id (unsigned short line, 
		     int *need_password)
{
    SECURITY	*psec;
    LOADUSER	*puserlist;
    USER	*puser;

    psec = security[line];
    puserlist = userlist[line];
    if (puserlist -> firstuser == NULL)
	return (SEC_INVALID_ID);
    puser = puserlist -> firstuser;
    while (puser)
    {
	if ((strncmp (puser -> userid, psec -> newuserid, sizeof (puser -> userid))) == NULL)
	{
	    if (puser -> password[0] == '*')
		*need_password = 0;
	    else
		*need_password = 1;
	    return (SEC_VALID_ID);
	}
	puser = puser -> nextuser;
    }
    return (SEC_INVALID_ID);
}

/******************************************************************
*
*    does the user have a valid password to complete the login
*    special case *, the user does not need a password but is set
*	in scan_termianl for use by the SEC_LOGIN_FINISH state
*
******************************************************************/

static int valid_passwd (unsigned short line)
{
    SECURITY	*psec;
    LOADUSER	*puserlist;
    USER	*puser;

    psec = security[line];
    puserlist = userlist[line];
    if (puserlist -> firstuser == NULL)
	return (SEC_INVALID_PASSWD);

    puser = puserlist -> firstuser;
    while (puser)
    {
	if ((strncmp (puser -> userid, psec -> newuserid, sizeof (puser -> userid))) == NULL)
	{
	    if ((strncmp (puser -> password, psec -> newpasswd, sizeof (puser -> password))) == NULL)
		return (SEC_VALID_LOGIN);
	    else
		return (SEC_INVALID_PASSWD);
	}
	puser = puser -> nextuser;
    }
    return (SEC_INVALID_PASSWD);
}

/********************************************************************************
*
*    called by scan_terminal to see if there is a character from the terminal
*    to process
*
********************************************************************************/

/*static int checkCh (unsigned short line)
{
    SECURITY	*psec;

    psec = security[line];

    return (0);
}

/****************************************************************
*
*    checkCh() has said there is a character from the terminal,
*    return that character
*
*****************************************************************/

/*static unsigned char getCh (unsigned short line)
{
    SECURITY		*psec;
    unsigned char	currChar;

    psec = security[line];

    return (currChar);
}

*/










/*                                                                              
/*  checkCh - check for presence of character in the input buffer.              
/*              TRUE: valid character,    FALSE: no valid character             
/*                                                                              
*/                                                                      	
static int checkCh (unsigned short line)
{
    RXRAWQUE    *qp;
    qp = rxrawq[line];
    if (qp->rxoutix != qp->rxinix)
    {
        return(TRUE);
    }
    return (FALSE);
}



/*                                                                              
/*  getCh - get the next character avaiable in the input buffer.                
/*              return the character, or NULL if buffer empty                   
/*                                                                              
*/                                                                      	
static unsigned char getCh (unsigned short line)
{
    RXRAWQUE    *qp;
    unsigned char rxchar, rxstatus;

    qp = rxrawq[line];
    if (qp->rxoutix != qp->rxinix)
    {
        rxchar = qp->rxque[qp->rxoutix].rxchar;
        rxstatus = qp->rxque[qp->rxoutix].rxstatus;
        /***************************************************************************/
        /***************************************************************************/
        /* Ed: note that although the interrupt service routine saves the          */
        /*     hardware error status, this routine ignores it. you could           */
        /*     redesign this stuff to:                                             */
        /*       1) have getCh ignore characters associated with hardware errors   */
        /*       2) have the ISR ignore characters associated with hardware errors */
        /*    If you modify the ISR to only save 'good' characters, the data       */
        /*    structure should be modified to eliminate the status field.          */
        /***************************************************************************/
        /***************************************************************************/
        qp->rxoutix = ((qp->rxoutix + 1) % RXRAWQSIZE);
        return (rxchar);
    }
    return (0);
}


/******************************************
*
*    echo a character back to the terminal
*
*******************************************/

static unsigned short putCh (unsigned short line, unsigned char ch)
{
    SECURITY	*psec;
    TXLINE      *txp;

    psec = security[line];

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];

    /* Format the output message */
    txp->txbuf [0] =  ch;
    txp->txmsglen = 1;

    psec->no_putch_msgs++;

    /* Send out the message */

    if (msgxfer (line) == XFERBAD)
    {
        psec->is_responding = FALSE;
        return (FALSE);
    }

    return (TRUE);
}



/**************************************************************
*
*    called from scan_terminal to put a string to the terminal
*
**************************************************************/

static unsigned short putStr (unsigned short line, 
		    unsigned char *str)
{
    SECURITY	*psec;
    TXLINE      *txp;

    psec = security[line];

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];

    /* Format the output message */
    strncpy (txp->txbuf, str, sizeof (txp->txbuf)-1);
    txp->txmsglen = strlen (str);

    psec->no_putstr_msgs++;

    /* Send out the message */

    if (msgxfer (line) == XFERBAD)
    {
        psec->is_responding = FALSE;
        return (FALSE);
    }

    return (TRUE);
}


/************************************************************
*
*    called from scan_terminal, see if there are any user
*    messages to output
*
***********************************************************/

static void checkoutmsgs (unsigned short line,
			  SECURITY *psec)
{
    int action = 0;

    if (psec -> outstr1[0] != 0)
    {
        putStr (line, "\r\n\r\n\07******************************\r\n");
	putStr (line, psec -> outstr1);
        putStr (line, "\r\n******************************\r\n\r\n\07");
        psec -> outstr1[0] = 0;
        action = 1;
    }

    if (psec -> outstr2[0] != 0)
    {
        putStr (line, "\r\n\r\n\07******************************\r\n");
	putStr (line, psec -> outstr2);
        putStr (line, "\r\n******************************\r\n\r\n\07");
        psec -> outstr2[0] = 0;
        action = 1;
    }

    if (!action)
    {
        return;
    }

    if (psec -> logonstatus == SEC_LOGGED_ON)
    {
	putStr (line, SEC_LOGOFF_PROMPT);
    }
    else
    {
	putStr (line, SEC_ID_PROMPT);
    }

    return;
}




/******************************************************************************************
*
* checkoutputs
*      checks output que and returns if empty.
*      if there is something on the queue it attempts to process all
*      pending outputs, doing immediate retries. If attempts fail the request is dropped.      
*      this routine only called from scan_terminal
*
******************************************************************************************/

static	void checkoutputs (unsigned short line)
{
	OUTQENT        *optr;
	unsigned short  regaddr, regval, link, adapter, coiladdr, conv;
	unsigned long   coilmask, coilval;
	SECURITY       *psec;
	double 		dblaovalue;
        unsigned short  stringaddr, stringlen;
	unsigned char  *pstringval;
	unsigned short	write_status;

        if (mltrace [line] == 6)
	{
            logMsg ("Checking Output Queue ...\n"); 
	}


	while ((optr = ogetnextp (line)) != NULLP)
	{
	    if ((optr->otype) == AOUTTYPE)
	    {
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;
		psec = security [link];
		if (psec == NULL)
		{
		    if (!allocate_security (link))
		    {
			return; /* if not allocated, try. if can't allocate, get out. */
		    }
        	    psec = security [link];
		}
		regaddr = optr->out.aonode.aosignal;
		regval = optr->out.aonode.aovalue;
		dblaovalue = optr->out.aonode.dblaovalue;
		conv = optr->out.aonode.conversion;
                if (mltrace [link] == 7)
                {
                    logMsg("AO IN QUEUE: L=%d, A=%d,       S=%d, Value=%d\n",
                           link, adapter, regaddr, regval);
                } 

		if ((!psec->cmd_force_offline) &&
                    (resresponse [link]) &&
                    (psec->is_responding))
		{
                    loopoutmsgs [line]++;
		    write_status = setanalog (link, regaddr, regval, dblaovalue, conv);
		    if (write_status != CMDDONE)
		    {
		        psec->badoutcnt++;
                        if (mltrace [link] == 3)
			{
                            logMsg("AO DEQUEUE: Output failed: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, regaddr, regval);
			} 
		    }
                    else
		    {
                        if (mltrace [link] == 3)
			{
                            logMsg ("AO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, regaddr, regval);
			} 
		    }

		}
	    }
	    else if ((optr->otype) == BOUTTYPE)
	    {
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;
		psec = security [link];
		if (psec == NULL)
		{
		    if (!allocate_security (link))
		    {
			return; /* if not allocated, try. if can't allocate, get out. */
		    }
        	    psec = security [link];
		}
		coiladdr = optr->out.bonode.bosignal;
		coilval = optr->out.bonode.bovalue;
		coilmask = optr->out.bonode.bomask;
                if (mltrace [link] == 7)
                {
                    logMsg("BO IN QUEUE: L=%d, A=%d,       S=%d, Value=%d\n",
                           link, adapter, coiladdr, coilval);
                }

		if ((!psec->cmd_force_offline) &&
                    (resresponse [link]) &&
                    (psec->is_responding))
		{
                    loopoutmsgs [line]++;
		    write_status = setbinary (link, coiladdr, coilmask, coilval);
		    if (write_status != CMDDONE)
		    {
			psec->badoutcnt++;
                        if (mltrace [link] == 4)
			{
                            logMsg("BO DEQUEUE: Output failed: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, coiladdr, coilval);
			}
		    }
                    else
		    {
                        if (mltrace [link] == 4)
			{
                            logMsg("BO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, coiladdr, coilval);
			}
		    }
		}
	    }
	    else if ((optr->otype) == SOUTTYPE)
	    {
		link = optr->out.sonode.link;
		adapter = optr->out.sonode.adapter;
/*		card = optr->out.sonode.card; */
		psec = security [link];
		if (psec == NULL)
		{
		    if (!allocate_security (link))
		    {
			return; /* if not allocated, try. if can't allocate, get out. */
		    }
        	    psec = security [link];
		}
		stringaddr = optr->out.sonode.sosignal;
		stringlen  = optr->out.sonode.solen;
		pstringval = optr->out.sonode.sovalue;
		if (mltrace [line] == 7)
		{
                    logMsg("SO IN QUEUE: L=%d, A=%d,       S=%d\n",
                           link, adapter, stringaddr);
		}

		if ((!psec->cmd_force_offline) &&
                    (resresponse [link]) &&
                    (psec->is_responding))
		{
                    loopoutmsgs [line]++;
		    if ((setstring (link, stringaddr, pstringval, stringlen)) != CMDDONE)
		    {
			psec->badoutcnt++;
                        if (mltrace [link] == 5)
			{
                            logMsg ("SO DEQUEUE: Output failed: L=%d, A=%d,       S=%d\n",
                                   link,adapter,stringaddr);
			}
		    }
                    else
		    {
                        if (mltrace [link] == 5)
			{
                            logMsg ("SO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d\n",
                                   link, adapter, stringaddr);
			}
		    }
		}
	    }
	    oreleasefull (line);     /* release the output que entry */
	}
}

/********************************************************************************
*
*      AIDRIVER                                                                       
*                                                                                     
*      This routines main purpose is to return the analog input value for the         
*      specified module. For a module value                                           
*      a (-1) will be returned if there is no valid data ready.                       
*      this routine not called from within this driver
*
*********************************************************************************/

int AIDRIVER (char *pointname, 
	      unsigned short  link, 
	      unsigned short  adapter, 
	      unsigned short  card,
	      unsigned short  signal, 
                       short *pvalue, 
	      unsigned short  conversion,
	      unsigned char  *resname)
{
    SECURITY       *psec;
    unsigned short  blkix;

    if (link > SECLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > MAXTERMINAL)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((card != MDATA) && (card != MPSEUDO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    psec = security [link];
    if (psec == NULL)
    {
        if (!allocate_security (link))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        psec = security [link];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the TERMINAL values requested */
                *pvalue = psec->was_requested;
                break;

            case 1: /* Is the TERMINAL responding */
                *pvalue = psec->is_responding;
                break;

            case 5: /* Output Messages */
                *pvalue = psec->no_dataout_msgs & 0x7fff;
                break;

            case 6: /* Input Messages */
                *pvalue = psec->no_datain_msgs & 0x7fff;
                break;

            case 7: /* No Receiver Responses */
                *pvalue = psec->no_rxnoresp & 0x7fff;
                break;

            case 8: /* No Transmitter Response */
                *pvalue = psec->no_txnoresp & 0x7fff;
                break;

            case 9: /* Data Echo Errors */
                *pvalue = psec->no_dataerr & 0x7fff;
                break;

            case 10: /* Message Retries */
                *pvalue = psec->no_retries & 0x7fff;
                break;

            case 11: /* RX Hardware errors */
                *pvalue = psec->no_rxhwerrs & 0x7fff;
                break;

            case 12: /* TX Hardware errors */
                *pvalue = psec->no_txhwerrs & 0x7fff;
                break;

            case 14: /* Offline transitions */
                *pvalue = psec->no_offlines & 0x7fff;
                break;

            case 15: /* reset statistics */
                *pvalue = psec->cmd_reset_stat;
                break;

            case 16: /* Force the TERMINAL offline */
                *pvalue = psec->cmd_force_offline;
                break;

            case 17: /* Failed output commands */
                *pvalue = psec->badoutcnt & 0x7fff;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        if (mltrace[link] == 8)
            logMsg("AIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                    pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
        return (0);
    }

    if (card == MDATA)
    {
        if ((signal > MAXAINO) || (signal < MINAINO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d, min=%d\n",
                        pointname, link, adapter, card, signal, MAXAINO, MINAINO);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link, resname, pointname);
        }

        psec->was_requested = TRUE;

        /* as soon as the address is confirmed as valid, set requested bits. */
        psec->was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (psec->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
             return (-2);
        }
        if (!psec->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (!psec->data_valid)
        {
           if (trace[link] & CALLREJECTTRACE)
               logMsg("AIDRIVER: Data Not Valid(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
           return (-1);
        }

        switch (signal)
        {
            case 1:
                *pvalue = (short)(psec->logontime / vxTicksPerSecond);
                break;
            case 2:
                *pvalue = psec->baduseridcnt;
                break;
            case 3:
                *pvalue = psec->badpasswordcnt;
                break;
        }

        if (mltrace[link] == 8)
            logMsg("AIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                    pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
        return(0);
    }
    return(-1);
}


/**********************************************************************************
*
*      BIDRIVER                                                                        
*                                                                               	
*      The main purpose of this routine is to return the request digital input  	
*      value(s) from the requested card. This routine will return a (-1) if the  	
*      requested module is the wrong type or the data is not yet valid.          	
*      this routine not called from within this driver
*                                                                                	
**********************************************************************************/

int BIDRIVER (char *pointname, 
	      unsigned short link, 
	      unsigned short adapter, 
	      unsigned short card,
	      unsigned short signal, 
	      unsigned long mask, 
	      unsigned long *pvalue,
	      unsigned char *resname)
{
    SECURITY       *psec;
    unsigned short	blkix;
    unsigned long	tvalue;

    if (link > SECLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > MAXTERMINAL)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((card != MDATA) && (card != MPSEUDO))
    {
         if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    psec = security [link];
    if (psec == NULL)
    {
        if (!allocate_security (link))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        psec = security [link];
    }

    psec->was_requested = TRUE;

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the TERMINAL values requested */
                *pvalue = psec->was_requested;
                 break;

            case 1: /* Is the TERMINAL responding */
                *pvalue = psec->is_responding;
                break;

            case 15: /* reset statistics */
                *pvalue = psec->cmd_reset_stat;
                break;

            case 16: /* Force the TERMINAL offline */
                *pvalue = psec->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }

    tvalue = 0;

    if (card == MDATA)
    {
        if ((signal > MAXBINO) || (signal < MINBINO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (mask > 0x00000003)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal maskl:[%s] L=%d, A=%d, C=%d, S=%d, M=0x%x\n",
                        pointname, link, adapter, card, signal, mask);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link, resname, pointname);
        }

        psec->was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (psec->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!psec->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (!psec->data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        /***************************/
        /* this is it, right here! */
        /***************************/
        tvalue = psec->logonstatus & mask;

        *pvalue = tvalue & mask;
        if (mltrace[link] == 9)
            logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal+1, pvalue);
        return (0);
    }
    return (-1);
}


/*******************************************************************************
*
*      BODRIVER                                                                        
*                                                                                 	
*      The main purpose of this routine is to set the request digital output      	
*      value(s) on the requested card. This routine will return a (-1) if the     	
*      requested module is the wrong type or not configured yet.                  	
*      this routine not called from within this driver 
*                                                                                 	
*******************************************************************************/

int BODRIVER (char *pointname, 
	      unsigned short link, 
	      unsigned short adapter, 
	      unsigned short card,
	      unsigned short signal, 
	      unsigned long value, 
	      unsigned long mask,
	      unsigned char *resname)
{
    SECURITY       *psec;
    OUTQENT        *oqp;
    unsigned short  blkix;

    if (link > SECLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if (adapter > MAXTERMINAL)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    psec = security [link];
    if (psec == NULL)
    {
        if (!allocate_security (link))
        {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        psec = security [link];
    }

    if (card == MPSEUDO)
    {
        switch (signal & 0x1f)
        {
            case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats (link);
                }
                break;

            case 16: /* Force the TERMINAL offline */
                psec->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    psec->is_responding = FALSE;/* only required when asserting cmd_force_offline */
                }
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
                return (-1);
	}
        return (0);
    }
    return (-1);
}


/*****************************************************************************
*
*      BOREAD                                                                  
*                                                                              
*      This routines main purpose is to return the value last read back      	
*      from the digital output hardware. This is used to initialize digital  	
*      outputs. This will return a (-1) if the module is the wrong type or    	
*      the data is not yet valid                                              	
*      this routine not called from within this driver
*
*****************************************************************************/


int BOREAD (char *pointname, 
	    unsigned short link, 
	    unsigned short adapter, 
	    unsigned short card,
	    unsigned short signal, 
	    unsigned long *pvalue, 
	    unsigned long mask,
	    unsigned char *resname)

{
    SECURITY       *psec;
    unsigned short  blkix;
    unsigned long   tvalue;

    if (link > SECLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > MAXTERMINAL)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    psec = security [link];
    if (psec == NULL)
    {
        if (!allocate_security (link))
        {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        psec = security [link];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {

            case 15: /* reset statistics */
                *pvalue = psec->cmd_reset_stat;
                break;

            case 16: /* Force the TERMINAL offline */
                *pvalue = psec->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }
    return (-1);
}


/**********************************************************************************
*
*      SIDRIVER                                                                        
*                                                                              	
*      This routines main purpose is to return the analog input value for the         	
*      specified module. For a module value                                           	
*      a (-1) will be returned if there is no valid data ready.                       	
*      this routine not called from within this driver
*                                                                                     	
***********************************************************************************/

int SIDRIVER (char *pointname, 
	      unsigned short link, 
	      unsigned short adapter, 
	      unsigned short card,
	      unsigned short signal, 
	      char          *pvalue,
	      unsigned short len,
	      unsigned char *resname)
{
    SECURITY       *psec;
    short           oldblkix, blkix, regix;
    unsigned short  reglen;
    int             i;

    if (link > SECLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > MAXTERMINAL)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (card != MDATA)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    psec = security[link];
    if (psec == NULL)
    {
        if (!allocate_security(link))
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        psec = security[link];
    }

/********************/
/* no pseudo points */
/*                  */
/********************/

    if (card == MDATA)
    {
        if ((signal > MAXSINO) || (signal < MINSINO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (resname != 0)
        { 
            register_resource(link, resname, pointname);
        }

        psec->was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("SIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
            return (-1);
        }
        if (psec->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("SIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
            return (-2);
        }
        if (!psec->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("SIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
            return (-1);
        }
        if (!psec->data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
            return (-1);
        }

        /***************************/
        /* this is it, right here. */
        /***************************/
        switch (signal)
        {
            case 1:
                strcpy (pvalue, psec->userid);
                break;
            case 2:
                strcpy (pvalue, psec->logstamp);
                break;
            default:
                return (-1);
                break;
        }
        return(0);
    }
    return(-1);
}


/******************************************************************************
*
*      SODRIVER                                                                
*                                                                            	
*      This routines main purpose is to set requested string outputs to the  	
*      specified module via the output buffer.                                 
*      this routine not called from within this driver
*
*******************************************************************************/

int SODRIVER (char *pointname, 
	      unsigned short link, 
	      unsigned short adapter, 
	      unsigned short card,
	      unsigned short signal, 
	      unsigned char *value, 
	      unsigned short len, 
	      unsigned char *resname)
{
    SECURITY       *psec;
    unsigned short  blkix;
    OUTQENT        *oqp;
    unsigned short  reglen;
    int             i;

    if (link > SECLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > MAXTERMINAL)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (card != MDATA)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    psec = security[link];
    if (psec == NULL)
    {
        if (!allocate_security(link))
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        psec = security[link];
    }

/********************/
/* no pseudo points */
/*                  */
/********************/

    /* ensure string contained entirely within the address space of the allocated region */
    if ((signal > MAXSONO) || (signal < MINSONO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
            pointname, link, adapter, card, signal);
        return (-1);
    }

/*    reglen = (len+1)/2;            /* round up odd length character count string lengths */
/*
/*    if ((signal+reglen) > MAXSINO)
/*    {
/*        if (trace[link] & CONFIGURATIONTRACE)
/*          logMsg(
/*          "SODRIVER: String extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
/*             pointname, link, adapter, card, signal);
/*        return (-1);
/*    }
*/
        if (resname != 0)
        { 
            register_resource(link, resname, pointname);
        }

    psec->was_requested = TRUE;

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("SODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal+1);
                    return (-1);
    }

    if ((!psec->is_responding) || (psec->cmd_force_offline))
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("SODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal+1);
        return (-1);
    }

    oqp = ogetemptyp (link);
    if (oqp == NULLP)
    {
        if (trace[link] & RUNTIMEERRORTRACE)
            logMsg("SODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal+1);
        psec->badoutcnt++;
        return (-1);		/* output queue is full */
    }

    oqp->otype = SOUTTYPE;
    oqp->out.sonode.link = link;
    oqp->out.sonode.adapter = adapter;
    oqp->out.sonode.card = card;
    oqp->out.sonode.sosignal = signal;
    oqp->out.sonode.solen = len;

    /* Move in the output string (strcpy not used because */
    /*  string content could contain terminators)         */
    for (i = 0 ;(i < STRINGMSGLEN) ; i++)
    {
        oqp->out.sonode.sovalue[i] = value[i];
    }

    omarkfull (link);		/* Mark this entry as ready for output */

    if (mltrace[link] == 5)
        logMsg("SODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%s\n",
                pointname, link, adapter, card, signal+1, value);
    return (0);
}


/***********************************************************************
*
* register_resource
*
*	This routine is used to initialize the resource pointers
*  If this is the first time the resource for this line is being
*  referenced the pointer to the resource table entry will be set
*  and the resource name will be saved. If the resource name has
*  already been set, this routine will verify that all other points
*  for this driver are using the same resource name.
*
* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
*			    BOREAD, SIDRIVER, and SODRIVER.                             
*
************************************************************************/

static void  register_resource (unsigned short link, 
				unsigned char *resname, 
				char *pointname)
{
    if (resnames [link] [0] == 0) /* This is the first reference */
    {
        if (resGetByName (resname, &prestable [link]) != RES_OK)
        {
            logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                     pointname, resname );
        }
        else
        {
            strcpy (resnames [link], resname);
        }
    }
    else
    {
        if (strcmp (resnames [link], resname) != 0)
        {
            logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
                     resnames[link], pointname,	resname );
        }
    }
}


/****************************************
*
*      Initialize the Queue                                        		
* not called from within this driver
*
****************************************/

static	void outqueinit (unsigned short line)
{
    oq [line]->ooutix = oq [line]->oinix = 0;
}


/****************************************************************
*
*  ogetempty - get the next available slot on the output list         		
*  called from AODRIVER and BODRIVER
*
****************************************************************/

static	OUTQENT *ogetemptyp (unsigned short line)
{
    if (((oq [line]->oinix + 1) % OUTQSIZE) != oq [line]->ooutix)
    {
        return (&oq [line]->outque[oq [line]->oinix]);
    }
    if (mltrace [line] == 11)
    {
        logMsg ( "Output Queue Full\n");
    }
    return (NULLP);
}


/*****************************************
*
* omarkfull                                                          		
*      mark the next block as full                                     	
*      called from AODRIVER and BODRIVER
*
*****************************************/

static	void omarkfull (unsigned short line)
{
    oq [line]->oinix = ((oq [line]->oinix + 1) % OUTQSIZE);
}


/*********************************************************
*
*  ogetnextp - get the next full slot on the output list               	
*  only called from checkoutputs 
*
**********************************************************/

static	OUTQENT *ogetnextp (unsigned short line)
{
    if (oq [line]->ooutix != oq [line]->oinix)
    {
        return (&oq [line]->outque[oq [line]->ooutix]);
    }
    else
    {
        return (NULLP);
    }
}


/*******************************************************
*
* oreleasefull - release the current full output block    	              	
* only called from checkoutputs
*
********************************************************/

static	void oreleasefull (unsigned short line)
{
    if (oq [line]->ooutix == oq [line]->oinix)
    {
        return;
    }
    oq [line]->ooutix = ((oq [line]->ooutix + 1) % OUTQSIZE);
}


/*****************************************************************************
*
*      link_status                                                           	
*                                                                            	
*      The purpose of this routine is to print out the state of each of the  	
*      analog devices lines and the statistics gathered about them.         	
*      not called from within this driver
*                                                                           	
******************************************************************************/

static	void link_status (unsigned short line)
{
    if (line > SECLINES-1)
    {
        return;
    }
}

/****************************************************************************
*
*                                                                              
*	allocate_security
*                                                                              
*	The purpose of this routine is to allocate the memory for a line's      
*	security structure. If not successful, a console error message is  	
*	printed and an error flag is returned to the caller.                    
*	If successful, the newly allocated data structures are initialized.     
*                                                                             	
****************************************************************************/

static int allocate_security (unsigned short line)
{
    security [line] = (SECURITY *) calloc (1, (sizeof (SECURITY)));
    if (!security [line])
    {
        logMsg ("Unable to allocate memory");
        printf (" for SECURITY data structure on line %d\n",line);
	return(FALSE);
    }
    else
    {
        logMsg ("Allocated memory for SECURITY data structure on line %d\n",line);
        init_security_tab (line);	     /*	initialize the data structures. */
    }

    return (TRUE);
}


/*******************************************************************
*
*      start_rx                                                        	
*                                                                     	 	
*      The purpose of this routine is to initialize a line table        	
*      for receive and to enable the receiver.                           	
*      only called from msgxfer
*                                                                        	
*******************************************************************/

static	void start_rx (unsigned short line)

{
        return;
}

/******************************************************************
*
*      stop_rx                                                              	
*                                                                           	
*      The purpose of this routine is to initialize a line table            	
*      for receive and to disable the receiver.                             	
*      only called from msgxfer
*                                                                           	
******************************************************************/

static	void stop_rx (unsigned short line )

{
/*	RXLINE		*rxp; */
/*
	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
*/
}


/*
/*      rx_int_proc                                                             
/*                                                                         	
/*      The purpose of this routine is to process a receive character interrupt	
/*      for a given line. the received character and status are put into a      
/*      circular queue for non-interrupt processing.                            
/*                                                                              
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static	void rx_int_proc (unsigned short line)
{
    unsigned char   rxchar;
    unsigned short  rxstat;
    unsigned short  rx_err_mask;

    RXRAW    *rxrawp;
    RXRAWQUE    *qp;

    read_rx_hw(line, &rxchar, &rxstat, &rx_err_mask);
        
    /* if not in master mode, or special slave mode, don't store the received characters. */
    if (rxsave[line] != TRUE)
        return;

    qp = rxrawq[line];
    /* if there are no more available entries in the queue, don't store the new character. */
    if (((qp->rxinix + 1) % RXRAWQSIZE) == qp->rxoutix)
    {
        /* if buffer overflow, forget it. there is nothing else to do in this case. */
        if (trace[line] & RUNTIMEERRORTRACE)
        {
	    logMsg ( "Raw RX Queue Full: Line %d\n", line);
            taskDelay(1);
        }
        return;
    }
    /* store data and status in this queue entry. */
    qp->rxque[qp->rxinix].rxchar = rxchar;
    qp->rxque[qp->rxinix].rxstatus = ((rxstat & rx_err_mask) != 0);
    /* complete this entry by pointing to the next entry in the queue. */
    qp->rxinix = ((qp->rxinix + 1) % RXRAWQSIZE);
    return;
}



/*******************************************************************
*
*      start_tx                                                            	
*                                                                          	
*      The purpose of this routine is to initialize a line table           	
*      for send and to enable the transmitter.                              	
*      only called from msgxfer
*                                                                            	
********************************************************************/

static	void start_tx (unsigned short line,
		       SEMAPHORE *semid,
		       unsigned short *pstatus )
{
	TXLINE		*txp;

	disable_tx_ints (line);
	txp = txlinetab [line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */

	enable_tx_ints (line);
}


/*******************************************************************
*
*      stop_tx                                                                	
*                                                                             	
*      The purpose of this routine is to initialize a line table              	
*      for receive and to disable the receiver.                               	
*      only called from msgxfer
*                                                                             	
*******************************************************************/

static	void stop_tx (unsigned short line )
    {
	TXLINE		*txp;

	disable_tx_ints (line);
	txp = txlinetab [line];
	txp->txdisable = TRUE;
    }


/*********************************************************************************
*
*      tx_int_proc                                                           	
*                                                                            	
*      The purpose of this routine is to process a transmit character interrupt
*      for a given line.                                                  	
*      only called from MAIN
*                                                                         	
*********************************************************************************/

static	void tx_int_proc (unsigned short line )
{
	char                    txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

        linestats [line].TXintcount++;

	txp = txlinetab [line];
	if (txp->txdisable)
	{
	    return;
	}
	if (txp->txix == txp->txmsglen)
	{
	    txp->txdisable = TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive (txp->semid);
	    return;
	}
	else
	{
	    txchar = txp->txbuf [txp->txix++];
	    write_tx_hw (line, txchar, &txstat, &tx_err_mask);
	    if ((txstat & tx_err_mask) != 0 )
	    {
	 	txp->txdisable = TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive (txp->semid);
	        return;
	    }
	}

	if (txp->txix >= MAXTXMSG)
	{
	    txp->txdisable = TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive (txp->semid);
	    return;
	}
}


/********************************************************************************
*
*      msgxfer                                                              	
*                                                                           	
*      The purpose of this routine is to transmit a buffer to the         	
*      analog devices I/O and to await a response. The transmit and receive	
*      buffers are in their respective line tables. This routine will retry 	
*      the message up to a maximum number of times or until a response      	
*      is received with a proper checksum.                                  	
*              returns         XFERGOOD if response received                	
*                              XFERBAD  if no good response is received     	
*      called from  setbinary, setanalog, setstring
*                                                                           	
********************************************************************************/

static	unsigned short msgxfer (unsigned short line)
{
	unsigned short  txstatus, txlen, ix, i;
	TXLINE          *txp;
	unsigned char   csums [2];
        unsigned int    tick1, tick2, tick3, tick4;
        unsigned int    delta40, delta01, delta12, delta23, delta34;
        unsigned long   msgstart;
        SECURITY       *psec;

        psec = security [line] ;

	msgstart = tickGet();

        delta40 = delta01 = delta12 = delta23 = delta34 = 0;

	txp = txlinetab [line];

            linestats [line].msgxfercount++;
            loopmsgs [line]++;

            tick [line] [0] = tickGet ();
            delta40 = (tick [line] [0] - tick [line] [4]);

	    if (intermsgdelay [line] != 0)
	    {
		taskDelay (intermsgdelay [line]);
	    }
	    set_rts (line);

	    txstatus = IO_TIMEOUT;
	    semTake (semids [line] [TXSEM], NO_WAIT);

	    txlen = txp->txmsglen;

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            if ((trace [line] & ALLTRAFFICTRACE) &&
                ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
            {
                printf ("TX:");
/*                if (trace [line] & ASCIITRAFFICTRACE) */
                if (trace [line] & ALLTRAFFICTRACE)
                {
                    for (ix = 0; ix < txlen ; ix++) /* just print what is there to print */
                    {
                        if (!((txp->txbuf [ix]) < 0x20)) /* non-printables are printed in ascii */
                        {
                            printf("%c", txp->txbuf [ix]);
                        }
                        else
                        {
                            printf ("<%x>", txp->txbuf [ix]);
                        }
                    }
                    printf ("\n");
                }
/*                else
                {
                    for (ix = 0; ix < 40 ; ix++) /* 40 is maximum TX message length */
/*                    {
                        if (ix < txlen)
                        {
                            printf("_%2x", txp->txbuf [ix]);
                        }
                        else
                        {
                            printf ("...");
                        }
                    }
                    printf ("\n");
                }
*/
            }

            /* time from entering msgxfer to starting transmission. (including delays & diags) */ 

            tick [line] [1] = tickGet ();
            delta01 = (tick [line] [1] - tick [line] [0]);

	    start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */

	    if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
	    {
		txstatus = IO_TIMEOUT;
	    }

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* time to transmit message. */

            tick [line] [2] = tickGet ();
            delta12 = (tick [line] [2] - tick [line] [1]);

	    stop_tx (line);

            /* intermessage wait time. */

            tick [line] [3] = tickGet ();
            delta23 = (tick [line] [3] - tick [line] [2]);

	    if (txstatus == TXGOOD)
	    {
                return (XFERGOOD);
            }
	    else if (txstatus == IO_TIMEOUT)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

		if (modtrace [line])
                {
                    taskDelay(1);
                    logMsg ("Transmit Timeout\n");
                }
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                    ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                }
		psec->no_txnoresp++;
	    }
	    else
	    {
		if (modtrace [line])
		{
                    taskDelay(1);
		    logMsg ("Transmit Error\n");
		}
		psec->no_txhwerrs++;
	    }
	return (XFERBAD);

}

/*****************************************************************************
*
*      init_security_tab
*
*      The purpose of this routine is to initialize the line tables for the
*      analog devices I/O
*      only called from allocate_security
*
*****************************************************************************/

static	void init_security_tab (unsigned short line)
{
    SECURITY       *psec;

    psec = security [line];
    if (!psec)
    {
	return;
    }
    psec->is_responding = FALSE;
    psec->holdflag = FALSE;
    psec->was_requested = FALSE;
    psec->cmd_force_offline = FALSE;

    initsecurity (line);
    initstats (line);

    /* Initialize this tasks semaphore*/

    semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
    semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
}

/**********************************************
*
* Cold Init a TERMINAL
* only called from init_line_tabs
*
**********************************************/

static void initsecurity (unsigned short line)
{
    SECURITY       *psec;

    psec = security [line];

    psec->data_valid = TRUE;
    psec->userid [0] = 0;         /* current operator id                          */
    psec->logstamp [0] = 0;       /* logon/off date/time stamp                    */
    psec->logontime = 0;          /* time since logon became active. (0 = logoff) */
    psec->baduseridcnt = 0;       /* count of invalid user ids entered.           */
    psec->badpasswordcnt = 0;     /* count of invalid passwords entered.          */
    reset_new_login (line);	  /* init new user/password/idx			  */
}



/*******************************************************
*                                                              	
* initialize the statistics for a TERMINAL                  	
* called from AODRIVER, BODRIVER, and init_line_tabs
*                                                              	
*******************************************************/

static	void initstats (unsigned short line)
{
    SECURITY       *psec;

    psec = security [line];

    psec->no_putch_msgs = 0;    /* ?  Count Output single chararacter Msgs	*/
    psec->no_putstr_msgs = 0;   /* ?  Count Output string Msgs 		        */
    psec->no_dataout_msgs = 0;  /* 5  Count Output Msgs                 */
    psec->no_datain_msgs = 0;   /* 6  Count Data Requests               */
    psec->no_rxnoresp = 0;      /* 7  Count No Responses                */
    psec->no_txnoresp = 0;      /* 8  Count No Responses                */
    psec->no_dataerr = 0;       /* 9  Count Message Echo Errors         */
    psec->no_retries = 0;       /* 10 Count Retries                     */
    psec->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors        */
    psec->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors        */
    psec->no_offlines = 0;      /* 14 Count Off Line Transitions        */
    psec->badoutcnt = 0;	/* 17 Count failed output commands      */

    psec->tscanpass = 0;        /* plc scan pass counter                */
    psec->msgs = 0;             /* good response message counts         */
    psec->responsetime = 0;     /* total wait time for good messages    */
}



/************************************************************************************
*
*     prepresponses                                                            
*                                                                             	
*      The purpose of this routine is to mark the TERMINAL as on hold and the    	
*      data as not valid until read again from the TERMINAL                       	
*      only called from MAIN 
*                                                                           	
************************************************************************************/

static	void prepresponses (unsigned short line)

{
    SECURITY       *psec;

    psec = security [line];
    if (psec)				/* verify pointer validity prior to use */
    {
        psec->holdflag = TRUE;
    }
}


/********************************
*
* Setbinary                                                        	
* only called from checkoutputs 
*                                                                 	
********************************/

static unsigned short setbinary (unsigned short line, 
			         unsigned short bitaddr,
			         unsigned long mask, 
			         unsigned long val)


{
    logMsg ("Security: setbinary, line %d, called\n",line);
    return (CMDFAIL);
}


/********************************
*
* Setanalog                                                       	
* only called from checkoutputs 
*                                                                  	
********************************/

static unsigned short setanalog (unsigned short line, 
			         unsigned short regaddr,
			         unsigned short val, 
			         double dblval, 
			         unsigned short conv)


{
    logMsg ("Security: setanalog, line %d, called\n", line);
    return (CMDFAIL);
}


/*********************************
*
* Setstring                                                       	
* only called from checkoutputs
*                                                                  	
**********************************/

static unsigned short setstring (unsigned short line, 
				 unsigned short signal,
				 unsigned char *buf, 
				 unsigned short olen)
{
    SECURITY	*psec;

    psec = security[line];

    if (signal == 1)
    {
	strncpy (psec -> outstr1, buf, sizeof (psec -> outstr1));
        checkoutmsgs (line, psec);
	return (CMDDONE);
    }
    if (signal == 2)
    {
	strncpy (psec -> outstr2, buf, sizeof (psec -> outstr1));
        checkoutmsgs (line, psec);
	return (CMDDONE);
    }

    return (CMDFAIL);
}




/************************************
*
*	Load User ID/Password file                              
*       only called from MAIN
*                                                              
************************************/

static int loaduserfile (unsigned short line)
{
    LOADUSER		*userinfo;
    USER		*currentuser;
/*    static void       *pointerpointer; */
    char		filename[30];
    char		userid[MAXUSERLEN+1];
    char		passwd[MAXUSERLEN+1];
    char		addr[8];
    char		next_char;
    unsigned short	entry_count;
    unsigned short	timeout = 0;

    userinfo = userlist [line];         /* establish the pointers.   */
    (USER **)pointerpointer = &userinfo -> firstuser;

    /* Make File Name	*/
    strcpy (filename, "Security");
    addr[0] = '0' + (line / 10);        /* append Line Number       */
    addr[1] = '0' + (line % 10);
    addr[2] = 0;
    strcat (filename, addr);
    strcat (filename, ".id");

    /* If already one being loaded, something is wrong.         */
    if (userinfo -> loading)
    {
	logMsg ("Security: file %s already loaded\n", filename);
	return(FALSE);
    }
    strcpy (userinfo -> filename, filename);
    userinfo -> line = line;              /* easy way to find it      */
    userinfo -> loading = TRUE;

    /* set remote user/password */
    iam (user, password); 

    /* Open File existing file for Read Only */
    if ( (userinfo -> userfile = fopen (&userinfo -> filename[0], "r") ) == NULL)
    {
        terminateload (userinfo, FALSE, CANNOTOPENFILE);
	logMsg ("Security: open err for %s\n", userinfo->filename);
        return(FALSE);
    }

    entry_count = 0;

    if ((get_timeout (userinfo, &timeout)) == FALSE)
    {
	terminateload (userinfo, FALSE, CANNOTGETTIMEOUT);
	logMsg ("Security: can not get timeout value from %s\n", userinfo->filename);
	return (FALSE);
    }
    /* store logon timeout value (in minutes)  as a tickcount */
    userinfo -> timeout = timeout * 60 * 60;

    /* now get the userids and passwords */
    while (TRUE)
    {
	bzero (userid, sizeof (userid));
	bzero (passwd, sizeof (passwd));
	next_char = getc (userinfo -> userfile);
	if (feof (userinfo -> userfile))
	{
	    if (entry_count > 0)
	    {
		terminateload (userinfo, TRUE, LOADOK);
		break;
	    }
	    else
	    {
		terminateload (userinfo, FALSE, NOUSERIDS);
		return (FALSE);
	    }
	}
	if (get_string (userinfo, &next_char, userid) == FALSE)
	{
	    return (FALSE);
	}
	if ( (userid[0] == 0) && (feof (userinfo -> userfile)))
	{
	    terminateload (userinfo, FALSE, BADUSERID);
	    return (FALSE);
	}
	next_char = getc (userinfo -> userfile);
	if (get_string (userinfo, &next_char, passwd) == FALSE)
	{
	    return (FALSE);
	}
	if (userid[0] == 0)
	{
	    terminateload (userinfo, FALSE, BADUSERID);
	    return (FALSE);
	}
	if (passwd[0] == 0)
	{
	    terminateload (userinfo, FALSE, BADPASSWORD);
	    return (FALSE);
	}
	entry_count++;
	if ( (currentuser = (USER *)calloc (1, sizeof (USER))) == NULL)
	{
	    logMsg ("Security: calloc fail for next user\n");
	    terminateload (userinfo, FALSE, NOMEMORY);
	    return (FALSE);
	}
	strncpy (currentuser -> userid, userid, MAXUSERLEN);
	strncpy (currentuser -> password, passwd, MAXUSERLEN);
	currentuser -> nextuser = (USER *)0;
        /* the thing pointed to by pointerpointer equals the thing pointed to by currentuser */
	*(USER **)pointerpointer = currentuser;
	(USER **)pointerpointer = &currentuser -> nextuser;
	userinfo -> entry_count = entry_count;
    }

    return (TRUE);

}
/* end of loaduserfile */


/**********************************************
*
*    get the timeout value from the userfile
*
**********************************************/

static int get_timeout (LOADUSER *userinfo, 
			unsigned short *timeout)
{
    char    next_char;

    while (TRUE)
    {
        next_char = getc (userinfo -> userfile);
	/* we are going to skip comment lines and blank lines */
	if (next_char == '#')
	{
	    eatline (userinfo -> userfile);
	    continue;
	}
	if (next_char == '\n')
	    continue;
	else
	    break;
    }
    eatspaces (&next_char, userinfo -> userfile);

    while (TRUE)
    {
	if (next_char == EOF)
	{
	    logMsg ("Security: EOF from get_timeout\n");
	    terminateload (userinfo, FALSE, NOTIMEOUTVALUE);
	    return (FALSE);
	}
	if (next_char == '\n')
	    break;
	if (!isdigit(next_char))
	{
	    logMsg ("Security: non digit in timeout %d\n", next_char);
	    terminateload (userinfo, FALSE, NOTIMEOUTVALUE);
	    return (FALSE);
	}
	*timeout = (*timeout * 10) + (next_char - '0');
	if ((*timeout) > 9999)
	{
	    logMsg ("Security: timeout range %d\n", *timeout);
	    terminateload (userinfo, FALSE, BADTIMEOUTVALUE);
	    return (FALSE);
	}
	next_char = getc (userinfo -> userfile);
    }

    return (TRUE);
}


/***************************************
*
*    get a string from the userfile
*
***************************************/

static int get_string (LOADUSER *userinfo,
		       char *pnext_char, 
		       unsigned char *buff)
{
    char	next_char = *pnext_char;
    int		idx = -1;

    while (TRUE)
    {
	/* we are going to skip comment lines and blank lines */
	if ((next_char != '#') && (next_char != '\n'))
	    break;
	if (next_char == '#')
	{
	    eatline (userinfo -> userfile);
	}
	next_char = getc (userinfo -> userfile);
    }
    eatspaces (&next_char, userinfo -> userfile);
    while (TRUE)
    {
	if (next_char == EOF)
	    break;
	if (next_char == '\n')
	    break;
	if (next_char == ',')
	    break;
	if (strchr (SEC_LEGAL_CHARS, next_char) == NULL)
	{
	    logMsg ("Security: illegal character %c\n",next_char);
	    return (FALSE);
	}
	idx++;
	if (idx >= MAXUSERLEN)
	{
	    logMsg ("Security: string to long %s\n",buff);
	    return (FALSE);
	}
	buff[idx] = next_char;
	next_char = getc(userinfo -> userfile);
    }
    
    return (TRUE);
}



/******************************************************************
*
*      terminateload                                                       
*	Abort the Address Translation Map Load and Report Errors            
*       called from loaduserfile
*                                                                          
*******************************************************************/

static void terminateload (LOADUSER *userinfo, 
			   unsigned short success, 
			   unsigned short code)
{
    /* Close The File		*/
    fclose(userinfo->userfile);
    userinfo->loading = FALSE;
    userinfo->user_load_status = success;
    userinfo->user_load_code = code;

    return;
}


/**************************************************************************
*
* eatspaces                                                                
*        entered with ch containing first character under consideration    
*        exit with ch pointing to next character to be considered.         
*        only called from readuserfile
*                                                                          
**************************************************************************/

static void eatspaces(char *ch, FILE *fd)
{
    while ((*ch == ' ') || (*ch == '\t'))
    {
        *ch = getc(fd);
    }
    return;  /* only leave when non-space character encountered */
}


/******************************************************************************
*
* eatline                                                                  
*	eatup entire line and return \n or EOF
*                                                                          
******************************************************************************/

static void eatline (FILE *fd)
{
    char    next_char;

    while (TRUE)
    {
	next_char = getc (fd);
	if ((next_char == '\n') || (next_char == EOF))
	    break;
    }
    return;
}


/******************************************************************************
*
*   SecShowUser
*      The purpose of this routine is to dump the user/password linked list.  	
*      not called from within this driver
*
******************************************************************************/

void SecShowUser (unsigned short line)
{
    LOADUSER        *userinfo;
    USER            *thisuser;
    unsigned short   i, n;
    unsigned short   address, linecnt;
    unsigned char    buffer[200];

    userinfo = userlist[line];	/* establish the pointer.   */

    if (!userinfo)
    {
        logMsg("User/Password List not allocated. Pointer not valid. \n");
        return;
    }
    if (userinfo -> firstuser == (USER *)0)
    {
        logMsg("No User/Password, list is empty. \n");
        return;
    }

    printf ("\nTimeout Value    = %d \n", userinfo->timeout);
    printf ("List Entry Count = %d \n\n", userinfo->entry_count);

    linecnt = 4;
    SecPrtHdr(&linecnt);

    thisuser = userinfo->firstuser;

    while (thisuser)
    {
	if (linecnt >= 17)
	{
	    linecnt = 0;
	    taskDelay (300);	/* wait 5 second for user to view */
	    SecPrtHdr (&linecnt);
	}
	printf("%-*.*s  %-*.*s\n", 
		MAXUSERLEN, MAXUSERLEN, thisuser->userid, 
		MAXUSERLEN, MAXUSERLEN, thisuser->password);
        linecnt += 1;
	thisuser = ((USER *) thisuser->nextuser);
    }
}

/*******************************
*
* only called from SecShowUser 
*
*******************************/

static void SecPrtHdr (unsigned short *cnt)
{
    char    buffer[200];

    sprintf(buffer, "\n--- Security Driver User/Password List ---\n\n");
    printf( "%s", buffer);
    *cnt += 3;
    sprintf(buffer, "USER ID               PASSWORD\n\n");
    *cnt += 2;
}


/******************************************************************************************
*
*      DUMPMSGCNTS
*
*      The purpose of this routine is to dump the line level statistics for this driver. 
*      called from TABLEINFO
*
******************************************************************************************/

void DUMPMSGCNTS (unsigned short line)

    {
        unsigned long	temp, t, x, y, z;

        temp = tickGet ();
        t = (temp - linestats [line].startingtick);

 	x = linestats [line].TXintcount;
	y = linestats [line].RXintcount;
	z = linestats [line].msgxfercount;

        if (z == 0)
        {
            printf (" ******  No Messages Transferred ****** \n");
            return;
        }

 	printf ("\n");
	printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", 
					t, t/vxTicksPerSecond, (t%vxTicksPerSecond)/6);
 	printf ("\n");
 	printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
 	printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
 	printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
 	printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
 	printf ("\n");
 	printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
 	printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
 	printf ("\n");
	printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
	printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
 	printf ("\n");
        return;
}

/************************************************************************************
*
*      CLEARMSGCNTS
*
*      The purpose of this routine is to dump and clear the line level statistics
*      for this driver.
*      called from TABLEINFO
*
************************************************************************************/

void CLEARMSGCNTS (unsigned short line)

{
        DUMPMSGCNTS (line);

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].msgxfercount = 0;

        linestats [line].startingtick = tickGet ();
	printf (" ******  All Counts Cleared  ****** \n", linestats [line].msgxfercount);
 	printf ("\n");
        return;
}


/*****************************************************************************************
*
*      DUMPSECSTATS
*
*      The purpose of this routine is to dump the security statistics for this driver.  
*      called from TABLEINFO 
*
*****************************************************************************************/

void DUMPSECSTATS (unsigned short line)

    {
	SECURITY       *psec;
        unsigned long   microsecs;

	psec = security [line];
	if (!psec)
	{
	    logMsg ("Line/Terminal Not Defined \n");
	    return;
	}

	printf (" Was requested = %d \n", psec->was_requested);
	printf (" Is responding = %d \n", psec->is_responding);
	printf (" # Output messages = %d \n", psec->no_dataout_msgs & 0x7fff);
	printf (" # Data in messages = %d \n", psec->no_datain_msgs & 0x7fff);
	printf (" #No Rx Response = %d \n", psec->no_rxnoresp & 0x7fff);
	printf (" #No Tx Responses = %d \n", psec->no_txnoresp & 0x7fff);
	printf (" #Data Errors = %d \n", psec->no_dataerr & 0x7fff);
	printf (" #Retries = %d \n", psec->no_retries & 0x7fff);
	printf (" #Rx Hw Errors = %d \n", psec->no_rxhwerrs & 0x7fff);
	printf (" #Tx Hw Errors = %d \n", psec->no_txhwerrs & 0x7fff);
	printf (" #Off Lines = %d \n", psec->no_offlines & 0x7fff);
	printf (" Reset Statistics = %d \n", psec->cmd_reset_stat);
	printf (" Force Offline = %d \n", psec->cmd_force_offline);
	printf (" #Failed Outputs = %d \n", psec->badoutcnt & 0x7fff);

	printf ("\n");
	printf (" # of Messages %d \n", psec->msgs);
	printf (" # Total response time (ticks) = %lu \n", psec->responsetime);
        if (psec->msgs)
        {
	    printf ("   Average response time (ticks) = %d \n", (psec->responsetime/psec->msgs));
            microsecs = (16667*psec->responsetime)/psec->msgs;
	    printf ("   Average response time (msec) = %d.%1d \n", microsecs/1000, (microsecs%1000)/100);
        }
	printf (" # of scan passes = %d \n", psec->tscanpass);
	printf ("\n");

	printf (" Resource Responding = %d \n", resresponse[line]);
	printf (" Hold flag  = %d \n", psec->holdflag );
        return;
}

/******************************************************************************************
*
*      CLEARSECSTATS
*
*      The purpose of this routine is to clear the plc level statistics for this driver. 
*      called from TABLEINFO 
*
******************************************************************************************/

void CLEARSECSTATS (unsigned short line)

    {
	SECURITY         *psec;

	psec = security [line];
	if (!psec)
	{
	    logMsg ("Line/Terminal Not Defined \n");
	    return;
	}

	initstats (line); /* use existing procedure */

        return;
    }


/*****************************************************************************************
*
*
*****************************************************************************************/

void TABLEINFO (unsigned short line)
{
    SECURITY        *psec;
    LOADUSER        *puserlist;
    USER            *puser;
    unsigned short   i;


    psec = security [line];
    if (!psec)
    {
        logMsg ("Line/Terminal Not Defined \n");
        return;
    }

    puserlist = userlist[line];
    if (!puserlist)
    {
        logMsg ("User List Data Structure Not Defined \n");
        return;
    }

    printf (" line             = %d \n", puserlist->line);
    printf (" loading          = %d \n", puserlist->loading);
    printf (" user_load_status = %d \n", puserlist->user_load_status);
    printf (" user_load_code   = %d \n", puserlist->user_load_code);
    printf (" entry_count      = %d \n", puserlist->entry_count);
    printf (" timeout          = %d \n", puserlist->timeout);
    printf (" filename         = %s \n", puserlist->filename);

    if (!(puserlist->firstuser))
    {
        logMsg ("No Users Defined in File.\n");
        return;
    }

    puser = puserlist -> firstuser;

    for (i=0; i < 20; i++)
    {
        printf (" %2d: %20s  %20s\n", i+1, puser->userid, puser->password);
        if (!(puser = puser -> nextuser)) break;
    }
    return;
}












/*	End of File:	drvSecurity.c */

