/*drvStcs.h,v 1.1.1.1 1999/08/03 14:44:49 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
/*	File:	tcs.h
/*	Auth:	John L. Dalesio
/*	Edit:	10/09/92	JLD
/*
/*	This file contains the data structures used by the Turnbull Controllers
/*	I/O driver.
/*
*/

#define	TRUE	1
#define FALSE	0
#define NULLP	0
#define CR	0x0d

/*	number of lines of TCS controllers */
#define		TCSLINES		6
#define		COMMLINES		TCSLINES	/* for bioscomm */
/*	number of TCS controllers per line */
#define		NUMTCSCNTRLS	       8

#define NUMTCSPARAM	128	/* Number of Parameters in each controller */
				/* !! NOTE Controllers with 256 parapeters */
				/* must be defined as 2 128 parameret units */
#define PSEUDO		256	/* Value for CARD to get to statistics */
/* MAXIMUM ELEMENTS TO ASK FOR IN A COMM REQUEST */

#define TCSMSGPARAMS	8	/* Number of TCS Parameters to Fetch */

/* POLLING USES ENQUIRY METHOD FOR EFFICIENCY */
/* PERIODICALLY IT MUST READ ALL REQUEST PARAMETERS */
#define FULLSCAN	5	/* Number of scan passes in a fullscan cycle */ 

/*
/*	Communications I/O Structures
/*
*/

#define		MAXRXMSG	300

/* TCS Receive Message tokens */
#define RCVNOMSG	0	/* EOT */
#define RCVACK		1	/* ACK */
#define RCVDATA		2	/* DATA MSG */
#define RCVBADDATA	3	/* CRC of Other Data Error */

typedef	struct {
	unsigned short		protocol;
	unsigned short		rxstate;
	unsigned short		rxtocnt;
	unsigned short		rxhwerrcnt;
	unsigned short		token;
	unsigned short		fixedlen;
	unsigned short		rxmsglen;
	unsigned short		rxix;
	SEMAPHORE		*semid;
	unsigned short		*status;
	unsigned char		rxbuf[MAXRXMSG+2];
		} 	RXLINE;


#define		MAXTXMSG	300

typedef	struct {
	unsigned short		protocol;
	unsigned short		txtocnt;
	unsigned short		txhwerrcnt;
	unsigned short		txmsglen;
	unsigned short		txix;
	SEMAPHORE		*semid;
	unsigned short		*status;
	unsigned char		txbuf[MAXTXMSG+2];
		} 	TXLINE;

/*
/*	Communications I/O Constants
/*
*/

#define		RXGOOD			1
#define		RXBAD			2
#define		RXTIMEOUT		6 	/* 16 ms ticks */

#ifdef TEST
#define		RX_ERR_MASK		(TIMEOUT | FRAMERR | PARITYERR | OVERRUN)
#define		TX_ERR_MASK		0	/* No Error Indication */
#endif

#define		VARRESP			FALSE
#define		FIXEDRESP		TRUE
#define		ONERETRY		0x8000	/* ored into line number for xfermsg */
#define		RXIGNORE		0
#define		RXINIT			1
#define		RXGETPARAMNO		2
#define		RXGETDATA1		3
#define		RXGETDATA2		4
#define		RXGETDATA3		5
#define		RXGETBCC		6



#define		TXGOOD			1
#define		TXBAD			2

#define		TXTIMEOUT		1255	/* 16 ms ticks */

#define		IO_TIMEOUT		3	/* Code returned by timer */

#define		MAXRETRYS		3	/* retransmission trys */

#define		MAXCFGCK		8	/* Try to Bring online each cycle */
#define		BRINGBACKCNT		4	/* Poll loops per cycle */

#define		XFERGOOD		1
#define		XFERBAD			2
#define		XFERBADRESP		3

/*
/*	PLC PROGRAM LOAD STATES
*/
#define		PLC_NOT_LOADED		0
#define		PLC_LOAD_REQUESTED	1
#define		PLC_LOAD_IN_PROGRESS	2
#define		PLC_LOAD_FAILED		3
#define		PLC_LOAD_SUCCESSFUL	4


/*
* Output Que Management Structures for Modbus Protocol
*/
#define         AOUTTYPE        1
#define         BOUTTYPE        2
#define         OUTQSIZE        128

typedef struct {
	unsigned short  link;
	unsigned short  adapter;
	unsigned short  card;
	unsigned short  aosignal;
	short           aovalue;
		} AOUT, *AOUTPTR;

typedef struct {
	unsigned short  link;
	unsigned short  adapter;
	unsigned short  card;
	unsigned short  bosignal;
	long            bomask;
	long            bovalue;
		} BOUT, *BOUTPTR;

typedef struct {
		unsigned short  otype;
		union   {
			AOUT    aonode;
			BOUT    bonode;
			}out;
	       } OUTQENT;

typedef struct {
		unsigned short	ooutix;
		unsigned short	oinix;
		OUTQENT         outque[OUTQSIZE];
		} OUTPUTQUE;




typedef	struct {
	unsigned short		was_requested;
	unsigned short		data_valid;
	unsigned short		format;
	unsigned short		value;
		}	TCSPARAM;

typedef	struct	{
	unsigned short	was_requested;		/* 0  The scan task has accesses this RTU */
	unsigned short	is_responding;		/* 1  The RTU is responding	*/
	unsigned short	prog_load_stat;		/* 2  Program load Status */
	unsigned short  prog_load_page;		/* 3  Program Load Block Number */
	unsigned short  prog_load_number;	/* 4  Program Number to Load */
	unsigned short  no_dataout_msgs;	/* 5  Count Output Msgs */
	unsigned short  no_datain_msgs;		/* 6  Count Data Requests */
	unsigned short  no_rxnoresp;		/* 7  Count No Responses */
	unsigned short  no_txnoresp;		/* 8  Count No Responses */
	unsigned short  no_dataerr;		/* 9  Count Message Echo Errors */
	unsigned short  no_retries;		/* 10 Count Retries */
	unsigned short  no_rxhwerrs;		/* 11 Count Comm Hardware Errors */
	unsigned short  no_txhwerrs;		/* 12 Count Comm Hardware Errors */
	unsigned short  no_crcerrs;		/* 13 Count CRC Errors */
	unsigned short  no_offlines;		/* 14 Count Off Line Transitions */
	unsigned short  cmd_reset_stat;		/* 15 Comand to reset stats*/
	unsigned short  cmd_force_offline;	/* 16 Command to Force Offline */
	unsigned short  badoutcnt;		/* 17 Count Failed output commands */
	unsigned short	txtsn;			/* Transmit Sequence Number */
	unsigned short	rxcmd;			/* Last Received Message Type */
	unsigned short	rxtsn;			/* Last Received Message Sequence Number */
	unsigned short	scanpass;               /* Scan Pass Counter */

	TCSPARAM	params[NUMTCSPARAM];	/* Structure of Parameters */

	}	TCSCNTRL;


/*
/* TCS Protocol function codes
*/
#define	SOH	0X01
#define	STX     0X02
#define	ETX     0X03
#define	EOT	0X04
#define	ENQ     0X05
#define	ACK     0X06
#define	DLE     0X10
#define	NAK	0X15
#define ETB	0X17
#define NOREPLY	0xFF


/* task definitions */

#define 	GEN_STACK		2000   /* Stack size              */
#define		GEN_PRIORITY		200    /* default proirity        */
#define		GEN_TASK_OPTIONS	8      /* Floating point	  */
