/*atca_event.c,v 1.1.1.1 1999/08/03 14:41:37 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/*
**	Tate Integrated Systems,LP
**
**	This is the event handler. It is entered asynchronously when an attached process
**	variable as changed. The argument is a pointer to an 'event_handler_args' structure
**	which contains the points value and the data type. In addition, the address of the 
**	ENTRY table for this point is also provided. This makes it easy to store the value
**	there for later processing by the '@function'.
**
**
**
*/
#include <stdio.h>
#include "atcamain.h"

void	atcaMonitor(arg)
struct event_handler_args	arg;
{
ENTRY	*node;

node = arg.usr;					/* address of the ENTRY node for this point */
node -> type = arg.type;		/* value type */
node -> valid = 1;				/* value is good from now on. Use old value if "calc" rate > report rate */
switch(arg.type)
	{
	case DBR_STS_DOUBLE:
		node -> value.float_value = ((struct dbr_sts_double *)arg.dbr)->value;
		break;
	case DBR_STS_FLOAT:
		node -> value.float_value =  ((struct dbr_sts_float *)arg.dbr)->value;
		break;
	case DBR_STS_CHAR:
		node -> value.byte_value = ((struct dbr_sts_char *)arg.dbr)->value;
		break;
	case DBR_STS_LONG:
		node -> value.long_value = ((struct dbr_sts_long *)arg.dbr)->value;
		break;
	case DBR_STS_SHORT:
	case DBR_STS_ENUM:
		node -> value.short_value = ((struct dbr_sts_short *)arg.dbr)->value;
		break;
	case DBR_CTRL_STRING:
	case DBR_STS_STRING:
		strcpy(node -> string, ((struct dbr_sts_string *)arg.dbr)->value);
		break;
	case DBR_CTRL_DOUBLE:
		node -> value.float_value = ((struct dbr_ctrl_double *)arg.dbr)->value;
		break;
	case DBR_CTRL_FLOAT:
		node -> value.float_value =  ((struct dbr_ctrl_float *)arg.dbr)->value;
		break;
	case DBR_CTRL_CHAR:
		node -> value.byte_value = ((struct dbr_ctrl_char *)arg.dbr)->value;
		break;
	case DBR_CTRL_LONG:
		node -> value.long_value = ((struct dbr_ctrl_long *)arg.dbr)->value;
		break;
	case DBR_CTRL_SHORT:
	case DBR_CTRL_ENUM:
		node -> value.short_value = ((struct dbr_ctrl_short *)arg.dbr)->value;
		break;
	}
}
/*
	Called after ca_build_read_and_monitor. same as above.
*/
void	atcaRead(arg)
struct	event_handler_args	arg;
{
atcaMonitor(arg);
}
/*
	Connection handler. Used to finish-up build_and_read...
*/
void	atcaConnect(arg)
struct	connection_handler_args	arg;
{
int		cnt;
ENTRY	*node;
node = (ENTRY *)arg.chid->paddr;
if(arg.op == CA_OP_CONN_UP)
	{
	ca_complete_bld_read_mon(arg.chid);
	if(!node->firstConnect)
	  {
	    node->firstConnect = 1;
/* 	    fprintf(stderr,"%s -- First connect node UP\n",node->var); */
	  }
	else
	  {
/* 	    fprintf(stderr,"%s -- Node UP\n",node->var); */
	    cnt = ca_element_count(arg.chid);
	    if (cnt == 0) cnt = 1;
	    ca_array_get_callback(dbf_type_to_DBR_STS(ca_field_type(arg.chid)),cnt, arg.chid, atcaMonitor,(void *)node);
	  }
	}
else
	{
	node->valid = 0;					/* point invalid util next connect and report */
/* 	fprintf(stderr,"%s -- Node DOWN\n",node->var); */
	}
}
