/*atca_process.c,v 1.1.1.1 1999/08/03 14:41:37 tis4000 Exp */

/*
**	Tate Integrated Systems,LP
**
**
**	Either store point in list or retrieve its value
**
*/
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#define	USE_REGISTER
#define	USE_CELL
#include "atcamain.h"
#include <stdio.h>
#include <syslog.h>
#define	NEED 1
extern	LIST	ATCA_Table;
ENTRY	*ATCA_ProcessPoint(point)
char	*point;
{
ENTRY	*ATCA_Entry;
chid	ATCA_Chid;
long	ATCA_Status;
evid	evID;						/* must have for NEW CA. GCT 30-Mar-1994 */
/*
	search table for occurance of 'point' string. If found then
	return data from table location to 123. Else make entry in table
	and attach channel to event handler.
*/

if((ATCA_Entry = ATCA_Search(point)) == 0)
	{
	if((ATCA_Entry = (ENTRY *)malloc(ENTRY_SIZE)) == 0)		/* get some memory */
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		fprintf(stderr,"Can't allocate memory for PV:%s\n",point);
		return(0);
		}
	if((ATCA_Status = ca_build_read_and_monitor(point,atcaConnect,ATCA_Entry,atcaRead,ATCA_Entry,atcaMonitor,ATCA_Entry,&ATCA_Chid,&evID)) != ECA_NORMAL)
		{
		free(ATCA_Entry);
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		fprintf(stderr,"Problem with ca_build_read_and_monitor...%s\n",ca_message(ATCA_Status));
		return(0);
		}
	lstAdd((LIST *)&ATCA_Table,(NODE *)ATCA_Entry);		/* add to list */
	sprintf(&ATCA_Entry->var[0],"%s\0",point);			/* copy the point name */
	ATCA_Entry->lastvalue.float_value = 0.0;			/* in case protected on startup */
	ATCA_Entry->laststring[0] = '\0';					/* zero length string too. */
	ATCA_Entry->type = ca_field_type(ATCA_Chid);		/* this is for both 'SET' functions */
	ATCA_Entry->channel_id = ATCA_Chid;					/* for output points */
	ATCA_Entry->valid = 0;								/* not valid until first report */
	ATCA_Entry->firstConnect = 0;						/* not connected yet */
	ATCA_Chid->paddr = (void *)ATCA_Entry;				/* save here for connection event */
	ca_pend_io(MIN_TIMEOUT);
	}
return(ATCA_Entry);
}
