/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* alarmDefs.h */

/* This file contains the sizes of all things in the alarming system. */
/* This includes internal (C,C++) and external (dBase) object sizes. */
/* Simple, widely used typedefs are also defined here. */

#ifndef _ALARMDEFS_H_
#define	_ALARMDEFS_H_

#define	VUPORT			8583
#define	MGRPORT			8584

/* Guarenteed 32 bit types */

typedef	int		int32;
typedef	unsigned int	uint32;

/* Alarming system file names */

#ifdef WIN32
#define	AL_DBASE_DIRECTORY_NAME	"\\tis4000db\\"
#define	AL_TREE_FILE_NAME	"\\tis4000db\\atree.dbf"
#define	AL_GROUP_FILE_NAME	"\\tis4000db\\agroups.dbf"
#define	AL_INFO_FILE_NAME	"\\tis4000db\\ainfo.dbf"
#define	AL_INFO_IX_FILE_NAME	"\\tis4000db\\ainfo.mdx"
#define	AL_PVMAP_FILE_NAME	"\\tis4000db\\pvmap.dbf"
#define	AL_PDBXREF_FILE_NAME	"\\tis4000db\\pdbxref.dbf"
#define	AL_IOCLIST_FILE_NAME	"\\tis4000db\\ioclist.dbf"
#define AL_RESLIST_FILE_NAME    "\\tis4000db\\reslist.dbf"
#define	AL_LOG_FILE_NAME	"\\tis4000db\\alarmlog.dbf"
#define	AL_LOG_IX_FILE_NAME	"\\tis4000db\\alarmlog.mdx"
#define	AL_LOG_MEMO_FILE_NAME	"\\tis4000db\\alarmlog.dbt"
#define	AL_POINT_STATE_NAME	"\\tis4000db\\alpstate.dbf"
#define	AL_PRINTER_FILE_NAME	"\\tis4000db\\printers.dbf"
#else
#define	AL_DBASE_DIRECTORY_NAME	"/tis4000db/"
#define	AL_TREE_FILE_NAME	"/tis4000db/atree.dbf"
#define	AL_GROUP_FILE_NAME	"/tis4000db/agroups.dbf"
#define	AL_INFO_FILE_NAME	"/tis4000db/ainfo.dbf"
#define	AL_INFO_IX_FILE_NAME	"/tis4000db/ainfo.mdx"
#define	AL_PVMAP_FILE_NAME	"/tis4000db/pvmap.dbf"
#define	AL_PDBXREF_FILE_NAME	"/tis4000db/pdbxref.dbf"
#define	AL_IOCLIST_FILE_NAME	"/tis4000db/ioclist.dbf"
#define AL_RESLIST_FILE_NAME    "/tis4000db/reslist.dbf"
#define	AL_LOG_FILE_NAME	"/tis4000db/alarmlog.dbf"
#define	AL_LOG_IX_FILE_NAME	"/tis4000db/alarmlog.mdx"
#define	AL_LOG_MEMO_FILE_NAME	"/tis4000db/alarmlog.dbt"
#define	AL_POINT_STATE_NAME	"/tis4000db/alpstate.dbf"
#define	AL_PRINTER_FILE_NAME	"/tis4000db/printers.dbf"
#endif WIN32
/* Simple data types */

#define	AL_PATHNAME_SIZE	80
typedef	char	PathName [AL_PATHNAME_SIZE+1];

#define	AL_SCRIPTNAME_SIZE	250
typedef	char	ScriptName [AL_SCRIPTNAME_SIZE+1];

#define	AL_POINTNAME_SIZE	28
typedef	char	PointName [AL_POINTNAME_SIZE+1];

#define	AL_POINTTYPE_SIZE	15
#define	AL_FIELDNAME_SIZE	6
#define	AL_MAXFILENAME_SIZE	132

#define	AL_GROUPNAME_SIZE	28
typedef	char	GroupName [AL_GROUPNAME_SIZE+1];

#define	AL_DESCRIPTOR_SIZE	40
typedef	char	Descriptor [AL_DESCRIPTOR_SIZE+1];

#define	AL_OPERATOR_SIZE	20
typedef	char	Operator [AL_OPERATOR_SIZE+1];

#define	AL_VALUE_SIZE	80
typedef	char	PvValue [AL_VALUE_SIZE+1];

/* these defines are used by mgr/print.c to format the alarm msg
   to the printer
*/
#define	PRINT_VALUE_SIZE	25
#define	PRINT_OP_SIZE		30

#define	AL_GUIDANCE_SIZE	240
typedef	char	Guidance [AL_GUIDANCE_SIZE+1];

#define	AL_STATUS_SIZE		12	/* HIHI, HI, LOLO, LO, etc */
typedef char	alStatus [AL_STATUS_SIZE+1];

#define	AL_RESOURCE_SIZE 	16	/* Resource name */
typedef	char	Resource [AL_RESOURCE_SIZE+1];

#define	AL_EGUTAG_SIZE		8	/* Engineering Units */
typedef	char	EguTag [AL_EGUTAG_SIZE+1];

#define	AL_COMMENT_SIZE		1000	/* Operator comment */
typedef	char	Comment [AL_COMMENT_SIZE+1];

#define	AL_HOSTNAME_SIZE	30	/* Host name */
typedef	char	HostName [AL_HOSTNAME_SIZE+1];

#define AL_IOCNAME_SIZE         16      /* IOC Name from resList */
typedef char    IOCName [AL_IOCNAME_SIZE+1];

#define	AL_HELPTOPIC_SIZE 	20	/* Help topic for help engine */
typedef	char	HelpTopic [AL_HELPTOPIC_SIZE+1];

#define	AL_RATE_SIZE		2	/* Alarm sound rate */
typedef	char	Rate [AL_RATE_SIZE+1];

#define	AL_MAX_MEMO_SIZE	160	/* Size of an alarm memo */
typedef	char	Memo [AL_MAX_MEMO_SIZE+1];

#define	AL_INFO_SIZE		40	/* Size of extra info field */

/* Various field sizes */

#define	AL_DATE_SIZE		8	/* mm/dd/yy */
#define	AL_TIME_SIZE		8	/* hh:mm:ss */
#define	AL_GMTSECS_SIZE		10	/* Seconds since 1 Jan 1970 */
#define	AL_GMTMSECS_SIZE 	3	/* Milliseconds */
#define	AL_SEVERITY_SIZE 	1	/* M, m, I, E, V */
#define	AL_NUM_SEVR	5

/* Maximum number of alarms that can be pending */

#define	MAX_ALARM_Q_ENTRIES	1000

/* Max number of channels in a channel list */

#define	AL_MAX_AUX_SELECT_CHANS	100

/* Table of alarmVu's currently connected */

#define	AL_RECV_BUFFER_SIZE	5000
#define	MAX_ALARMVUS	100	/* Allow for ackpoint/ackgroup connections */

typedef struct {
    int		fd;
    char	msgBuffer [AL_RECV_BUFFER_SIZE];
    int		numBytes;		/* Number of bytes in buffer */
    Operator	operatorName;
    int		usingShared;		/* Alarmvu using shared memory */
} VuConn;

/* Table of alarmMgr's currently connected */

#define	MAX_ALARMMGRS	10
#define	PING_TIMEOUT	16
typedef struct {
    int		fd;
    int		connectInProgress;
    long	lastPing;
    unsigned long	ipAddr;
    char	msgBuffer [AL_RECV_BUFFER_SIZE];
    int		numBytes;
    char	peerName [30];
} MgrConn;

/* Table of printers currently connected */

#define	MAX_PRINTERS	10
typedef struct {
    PathName	name;
    int		running;
} PrinterList;

typedef struct {
    unsigned long	inet;
    int			fd;
    int			nameIx;
    char		msgBuffer [AL_RECV_BUFFER_SIZE];
    int			numBytes;
} PrintConn;

#define AL_FILTERNAME_SIZE	40
typedef	char	FilterName [AL_FILTERNAME_SIZE+1];

/* Printer Group Sizes */

#define	MAX_PRINTER_GROUPS	100
#define	MAX_PRINTERS_PER_GROUP	10
#ifdef __cplusplus
struct PrinterGroupEntry {
#else
typedef struct {
#endif
    GroupName	name;
    PathName	printers [MAX_PRINTERS_PER_GROUP];
#ifdef __cplusplus
};
#else
} PrinterGroupEntry;
#endif

/* Maximum number of peers running alarmMgr */

#define	MAX_PEERS	64  /* GCT 19-Aug-1996 10 caused alarmMgr to tale a long walk off a short PEER */

/* Source from which a message was received */

#define	FROM_ALARMVU	0
#define	FROM_ALARMMGR	1

#ifdef MIPSEL
#define	LOG_OPTIONS	LOG_SALERT
#else
#define	LOG_OPTIONS	LOG_ALERT|LOG_LOCAL1
#endif

/* This macro assigns an imbedded timestamp from an alarm message into a TS_STAMP */

#define	assignTS(a,b)	a.secPastEpoch=b.secPastEpoch;a.nsec=b.nsec

#endif

