/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/*****************************************************************
*
*    atvMain.c
*
*    modifications
*    -------------
*  .01	10-21-96	ems	creation date
*
******************************************************************/


#include <atv.h>

/* define X stuff */

Widget	atvTopLevel;		/* top level fromXtVaAppInitialize */
Widget	atvEditDialog;		/* main conatiner dialog */
Widget	atvInfo = 0;		/* used for user decisions */
Widget	atvAreYouSure = 0;	/* used for user decisions */

String	fallbacks [] = {
	"ATV*background: grey",
	"ATV*foreground: black",
	"ATV*fontList: 8x13bold",
	"ATV*XmMessageBox.background: CadetBlue",	/* NOTE: foreground is default black */
	"ATV*ApplyButton.background: green4",
	"ATV*ApplyButton.foreground: white",
	"ATV*DismissButton.background: red",		/* NOTE: foreground is default black */
	NULL
	};

/* define codebase stuff */

CODE4	cb;				/* codebase */
DATA4	*alarmTalkDb;			/* return from d4open */

/* define some other stuff */

int	atvIsModified;			/* start as 0, (not modified ) */
int	dbIsOpened = 0;			/* set in itvInitDatabase () */
char	errmsgs[ERRMSG_SZ];


/************************************************************
*
*    main
*
************************************************************/

main (int argc, char *argv[])
{
    XtAppContext	atvApp;

#ifdef SOLARIS
    XtSetLanguageProc (NULL, NULL, NULL);
#endif
    atvTopLevel = XtVaAppInitialize (&atvApp, "ATV", NULL, 0, &argc, argv, fallbacks, NULL);
    if (atvInitDatabase ())
    {
	atvCreateInfo (errmsgs, "ATV");
	XtRemoveAllCallbacks (atvInfo, XmNokCallback);
	XtAddCallback (atvInfo, XmNokCallback, atvDoDismiss, (XtPointer)0);
    }
    else
    {
	atvCreateEdit (atvTopLevel);
    }
    XtRealizeWidget (atvTopLevel);
    XtAppMainLoop (atvApp);
}
