/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <stdio.h>
#include <signal.h>

	void	setupSignalHandlers ();
static	void	terminateMgr (int sig);
static	void	incrementDebugLevel ();
static	void	decrementDebugLevel ();
static	void	sidsHandler ();
extern	int	debugLevel;
extern	int	running;

/*----------*/
void setupSignalHandlers ()
{
#ifndef SOLARIS
#ifndef WIN32
  signal(SIGQUIT, terminateMgr);
  signal(SIGUSR1, incrementDebugLevel);
  signal(SIGUSR2, decrementDebugLevel);
  signal(SIGPIPE, SIG_IGN);
  signal(SIGCHLD, sidsHandler);
#endif WIN32
  signal(SIGTERM, terminateMgr);
  signal(SIGINT, terminateMgr);
#else
  sigset(SIGQUIT, terminateMgr);
  sigset(SIGTERM, terminateMgr);
  sigset(SIGINT, terminateMgr);
  sigset(SIGUSR1, incrementDebugLevel);
  sigset(SIGUSR2, decrementDebugLevel);
  sigset(SIGPIPE, SIG_IGN);
  sigset(SIGCHLD, sidsHandler);
#endif
}

/*----------*/
static void terminateMgr (sig)

    int 		sig;

    {

	if (debugLevel >= 1)
	    printf ("Terminate signal received\n");
	running = 0;

    }

#ifndef WIN32
/*----------*/
static void incrementDebugLevel (sig)

    int 		sig;

    {

	printf ("alarmMgr(%d): Debug level is now %d\n", getpid (), ++debugLevel);

    }

/*----------*/
static void decrementDebugLevel (sig)

    int 		sig;

    {

	if (debugLevel > 0)
	    debugLevel--;
	printf ("trendMgr(%d): Debug level is now %d\n", getpid (), debugLevel);

    }

/*----------*/
static void sidsHandler (sig)

    int		sig;

    {

	int	status;

	wait (&status);

    }

#endif WIN32
