#ifndef	ackmanydialogHXX
#define	ackmanydialogHXX

class AckManyOkButton;
class AckManyCancelButton;
#define	MAX_ACK_TO_DISPLAY  20

// *** ACKMANY DIALOG CLASS *********************************************

class AckManyDialog : public vdialog
{
    alvuApplication *app;
    vliststr	    *ackList;
    char	    *pv;
    TS_STAMP	    lastAlarm;
    void BuildAckList (void);

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(AckManyDialog);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(AckManyDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void OpenAckMany (alvuApplication *app, char *pvname, TS_STAMP *lastalarm);

    vlistview		*ackManyView;
    AckManyOkButton	*okButton;
    AckManyCancelButton	*cancelButton;

    int	okToAck;
};


// *** OK BUTTON CLASS **************************************************

class AckManyOkButton : public vbutton
{
    AckManyDialog	*ackManyDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(AckManyOkButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(AckManyOkButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreAckManyDialog (AckManyDialog *dlg)
	{ ackManyDialog = dlg; }
};


// *** CANCEL BUTTON CLASS **********************************************

class AckManyCancelButton : public vbutton
{
    AckManyDialog	*ackManyDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(AckManyCancelButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(AckManyCancelButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreAckManyDialog (AckManyDialog *dlg)
	{ ackManyDialog = dlg; }
};

#endif	ackmanydialogHXX

