#ifndef alvumaindialogHXX
#define	alvumaindialogHXX

// enum values used for the vcommandSelector::Issue
enum mainMenuItems
{
    SELECT_FILTER_MENUITEM = 0,
    NEW_FILTER_MENUITEM,
    EDIT_FILTER_MENUITEM,
    DELETE_FILTER_MENUITEM,
    PRINT_MENUITEM,
    EXIT_MENUITEM,
    GROUP_MENUITEM,
    ALARM_WINDOW_MENUITEM,
    ALARM_SUMMARY_MENUITEM,
    ALARM_HISTORY_MENUITEM,
    EVENT_HISTORY_MENUITEM,
    OPER_TRACK_MENUITEM,
    REPORTS_MENUITEM,
    SYSTEM_HISTORY_MENUITEM,
    DISABLE_PT_MENUITEM,
    ENABLE_PT_MENUITEM,
    DISABLE_GRP_MENUITEM,
    ENABLE_GRP_MENUITEM,
    USE_DEF_MENUITEM,
    SAVE_MENUITEM,
    PRINTER_MENUITEM,
    COLORS_MENUITEM,
    STARTUP_FILTER_MENUITEM,
    SETUP_ALARMWINDOW_MENUITEM,
    POPUP_MENUITEM,
    MENUITEM_COUNT
};


class mainDialogSilence;
class mainDialogSummary;
class mainDialogExit;
class mainDialogMajor;
class mainDialogMinor;
class mainDialogInfo;
class mainDialogTimer;

class alvuMainDialog : public vdialog
{
    vmenu	*helpMenu;
    char	**helpItems;
    TisAbout	*tisAbout;
    void	BuildHelpMenu (void);
    void	InitPrinter (void);
    int		loadiniterror;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(alvuMainDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(alvuMainDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void OpenMain (alvuApplication *app);

    // place to store internal names for main dialog menu items
    const vname		*commandNames[MENUITEM_COUNT];

    // function to return list of help items;
    char **GetHelpItems (void)
	{ return (helpItems); }

    // function to return mains loadiniterror
    int GetLoadInitError (void)
	{ return (loadiniterror); }

    // refresh main dialogs alarm buttons
    void	RefreshDisplay (void);

    // setup default button foreground colors
    void SetColors (void);

    // set filter menu item title
    void SetFilterMenuTitle (const vname *menuTitle, 
			     char *filterName);

    // ptr to appliaction class
    alvuApplication	*alvuApp;

    vmenuItem		*selFilterMenuItem;
    vmenuToggleItem	*setupAlWin;
    vmenuToggleItem	*setupPopAl;
    mainDialogSilence	*silenceButton;
    mainDialogSummary	*summaryButton;
    mainDialogExit	*exitButton;
    mainDialogMajor	*majorButton;
    mainDialogMinor	*minorButton;
    mainDialogInfo	*infoButton;

    mainDialogTimer	*mainTimer;

};


class  alvuMainCommand : public vcommandSelector
{
public:
    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(alvuMainCommand);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(alvuMainCommand, vcommandSelector);

    //override virtual issue function
    int Issue(vdict *);
};


class helpMenuItem : public vmenuItem
{
    alvuMainDialog	*mainDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(helpMenuItem);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(helpMenuItem, vmenuItem);

    // functions for mainDialog
    void StoreMainDialog (alvuMainDialog *dlg)
	{ mainDialog = dlg; }
    alvuMainDialog *GetMainDialog (void)
	{ return (mainDialog); }

};


class mainDialogSilence : public vbutton
{
    alvuMainDialog	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (mainDialogSilence);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (mainDialogSilence, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the main dialog
    void StoreMainDialog (alvuMainDialog *cd) 
	{ mainDialog = cd; }
};


class mainDialogSummary : public vbutton
{
    alvuMainDialog	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (mainDialogSummary);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (mainDialogSummary, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the main dialog
    void StoreMainDialog (alvuMainDialog *cd) 
	{ mainDialog = cd; }
};


class mainDialogExit : public vbutton
{
    alvuMainDialog	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (mainDialogExit);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (mainDialogExit, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the main dialog
    void StoreMainDialog (alvuMainDialog *cd) 
	{ mainDialog = cd; }
};


class mainDialogMajor : public vbutton
{
    alvuMainDialog	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (mainDialogMajor);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (mainDialogMajor, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the main dialog
    void StoreMainDialog (alvuMainDialog *cd) 
	{ mainDialog = cd; }
};


class mainDialogMinor : public vbutton
{
    alvuMainDialog	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (mainDialogMinor);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (mainDialogMinor, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the main dialog
    void StoreMainDialog (alvuMainDialog *cd) 
	{ mainDialog = cd; }
};


class mainDialogInfo : public vbutton
{
    alvuMainDialog	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (mainDialogInfo);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (mainDialogInfo, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the main dialog
    void StoreMainDialog (alvuMainDialog *cd) 
	{ mainDialog = cd; }
};


class mainDialogTimer : public vtimer
{
    alvuMainDialog	*mainDialog;

public:

    // virtual member function override
    void ObserveTimer (void);

    // handle the pointer to the main dialog
    void StoreMainDialog (alvuMainDialog *cd) 
	{ mainDialog = cd; }

    // start timer sequence
    void StartMainTimer (void);
};

#endif	alvumaindialogHXX

