/*bell.c,v 1.1.1.1 1999/08/03 14:41:46 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/******************************************************************************
 *                                                                            *
 *      path:  bell.c                                                         *
 *      date:  21-Oct-92                                                      *
 *                                                                            *
 ******************************************************************************/
#ifdef MIPSEL		/* DEK 3/9/94 - the MIPSEL C compiler doesn't support these */
#ifdef __cplusplus	/* DEK 3/9/94 - the C compiler doesn't support these */
#define	volatile
#define	signed
#endif __cplusplus
#endif MIPSEL

#include "shareMem.h"

#ifndef WIN32
extern long	lseek ();
#endif WIN32

#ifndef AXP
extern int	read ();
extern int	write ();
extern int	close ();
#endif AXP
#ifdef SUN
extern int	audio_cmp_hdr ();
extern int	audio_read_filehdr ();
extern int	audio_drain ();
extern int	audio__flush ();
extern int	audio__setgain ();
extern int	audio__setval ();
extern int	audio__setpause ();
extern int	audio__setplayhdr ();
#endif SUN
#ifdef AXP
#include <mme/mme_api.h>
#include "mmc_buffers.h"
#include "mmc_memory.h"
#include "mmc_wave_format.h"
#include "mmc_wave_file.h"
#include "mmc_wave.h"
#endif AXP

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>

#ifndef WIN32
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>
#endif WIN32

#if (!defined(MIPSEL) && !defined(WIN32))
#include <sys/fcntl.h>
#endif MIPSEL

#ifndef WIN32
#include <netinet/in.h>
#endif WIN32

#ifdef SUN
#include <libaudio.h>
#include <audio_device.h>
#endif SUN

#ifdef WIN32
#include <windows.h>
#include <mmsystem.h>
#endif WIN32


#include "bell.h"

#ifdef SOLARIS
#define bzero(b,n)	memset (b, 0, n)
#else
void		bzero ();
#endif SOLARIS

extern TreeNode	*treeRoot;

#if defined(SUN) || defined(AXP) || defined(WIN32)
int			audioType = -1;
void	OpenSoundFile ();

typedef	char	AlarmSoundPath [200];
static AlarmSoundPath alarmSounds [AL_NUM_SEVR];
int			audioDesc = -1;
static int alarmSoundFDs [AL_NUM_SEVR];
#endif SUN

#ifdef SUN
static char		*audioDevice = "/dev/audio";
static Audio_hdr	deviceHeader;
static unsigned char	soundBuffer[1024 * 64];
static Audio_hdr	alarmSoundHeaders[AL_NUM_SEVR];
#endif SUN

#ifdef AXP
static void cleanupSound ();
static void driverCallback (HANDLE hWaveOut,
			     UINT wMsg,
			     DWORD dwInstance,
			     LPARAM lParam1,
			     LPARAM lParam2);

/***** CONSTANTS *****/
#define BUFFER_PAD 4

/* Default parameters for headerless audio files */
#define DEFAULT_NCHANNELS      	1
#define DEFAULT_ENCODING	WAVE_FORMAT_MULAW
#define DEFAULT_SAMPLESIZE     	8
#define DEFAULT_SAMPLERATE	8000

/***** PSEUDO-FUNCTION MACROS *****/
#define DIV_ROUND_UP_(n,d) ((n + d - 1) / d)
#define ROUND_UP_(n,d) (DIV_ROUND_UP_(n,d) * d)

#define NBYTES_EXTRA 32
struct MyFormat_s
{
    WAVEFORMATEX wfx;
    char extra_data[NBYTES_EXTRA];
};

/* Global Storage */
static mmcWaveFileState_t WaveFileState = mmcWaveFileStateInitialValue;
static mmcBufferList_t BufferList = mmcBufferListInitialValue;
static HMMIO  hmmioIn = 0;     /* handle to open input WAVE file*/
struct MyFormat_s Format =
{
    {
	DEFAULT_ENCODING, DEFAULT_NCHANNELS, DEFAULT_SAMPLERATE, 0, 0, 0,
	DEFAULT_SAMPLESIZE, NBYTES_EXTRA
    }, {
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0
    }
};
enum State_e { STATE_START, STATE_PLAY, STATE_PAUSE, STATE_WAITING, STATE_CLOSE };
enum State_e State;
#endif AXP

Widget		BellWidget;
int		BellState;
char		*curSoundFileNamePtr;
int		freqCounter;
extern void	MainDialogRingBellGW (void);

/******************************************************************************
 *                                                                            *
 *                                                                            *
 *                                                                            *
 *     Bell ( widget )                                                        *
 *     TurnOn ( )                                                             *
 *     TurnOff ( )                                                            *
 *     Ring ( groupPtr )                                                      *
 *                                                                            *
 *                                                                            *
 *     Description                                                            *
 *                                                                            *
 *     console bell                                                           *
 *                                                                            *
 ******************************************************************************/

void Bell (widget)
    Widget widget;
{
#if defined(SUN) || defined(AXP)
	char		cp[90];
	char		*displayNamePtr;
	char		hostName[80];
	int		i;

	audioType = -1;		/* -1 = bell, 0 = no sound, >0 = sounds */
#endif SUN
	BellWidget = widget;
	BellState = OFF;
	curSoundFileNamePtr = NULL;

#if defined(SUN) || defined(AXP)
	if (gethostname (hostName, sizeof (hostName)) == -1 ||
	    !(displayNamePtr = getenv ("DISPLAY")))
	{
	    /* unable to determine client host or display host */
	    /* use bell for sound */
	    audioType = -1;
	    return;
	}

	/* isolate host part of display name */
	bzero( cp, sizeof cp );
	strcpy( cp, displayNamePtr );
	for (i=0; i < strlen(cp)-1; i++)
	{
	    if (cp[i] == ':')
	    {
		/* if display name was ':0.0', must be on local host */
		if (i == 0)
		    strcpy (cp, hostName); /* allows test to succeed */
		else /* just truncate at ':' */
		    cp[i] = 0;
		break;
	    }
	}
	if (strcmp (hostName, cp) != 0)
	{
	    /* display is not on client machine */
	    audioType = -1; /* use bell */
	    return;
	}
	audioType = 1;

	for (i=1; i < AL_NUM_SEVR; i++)
	{
	    if (treeRoot->groupParms.auxSelectPV && treeRoot->auxValue )
	    {
		if (treeRoot->groupParms.auxSounds[i-1])
		    OpenSoundFile (treeRoot->groupParms.auxSounds[i-1], i);
	    }
	    else
	    {
		if (treeRoot->groupParms.sounds[i-1])
		    OpenSoundFile (treeRoot->groupParms.sounds[i-1], i);
	    }
	}
#elif WIN32
	audioType = 1;
#endif SUN
}

void BellTurnOn ()
{
	BellState = ON;
}

void BellTurnOff ()
{
	BellState = OFF;
}

void BellRing (groupPtr)
    TreeNode	*groupPtr;
{       
#if defined(SUN) || defined(AXP) || defined(WIN32)
    int		*soundFileFDPtr;
    int		*soundRatePtr;
    int		newSound;
#endif SUN
#if defined(SUN) || defined(AXP)
    int		bytesRead;
#endif SUN
#ifdef SUN
    Audio_hdr	*soundHeaderPtr;
#endif SUN
#ifdef AXP
    HWAVEOUT	hWaveOut;
    MMRESULT	status;
    int		allDone;
    int		sizeBuffers;
    int		numBuffers = 4;
#endif AXP
    int		sevr = NO_ALARM;

    if (BellState == ON)
    {
	if (groupPtr)
	{
	    if (groupPtr->groupData.numUnackedBySeverity[MAJOR_ALARM])
		sevr = MAJOR_ALARM;
	    else if (groupPtr->groupData.numUnackedBySeverity[MINOR_ALARM])
		sevr = MINOR_ALARM;
	    else if (groupPtr->groupData.numUnackedBySeverity[EVENT_ALARM])
		sevr = EVENT_ALARM;
	    else if (groupPtr->groupData.numUnackedBySeverity[INFO_ALARM])
		sevr = INFO_ALARM;
	}

#if defined(SUN) || defined(AXP) || defined WIN32
	soundFileFDPtr = NULL;
	newSound = FALSE;
	if (audioType > 0 && groupPtr)
	{
	    if (groupPtr->groupParms.auxSelectPV && groupPtr->auxValue )
	    {
		if (*groupPtr->groupParms.auxSounds[sevr])
		{
		    OpenSoundFile (groupPtr->groupParms.auxSounds[sevr], sevr);
		    soundRatePtr = &groupPtr->groupParms.auxSoundRates[sevr];
#ifdef SUN
		    soundHeaderPtr = &alarmSoundHeaders[sevr];
#endif SUN
		    soundFileFDPtr = &alarmSoundFDs[sevr];
		}
		else
		{
		    if (*treeRoot->groupParms.auxSounds[sevr] == 0)
		    {
			return; /* can't do anything without a sound definition */
		    }
		    OpenSoundFile (treeRoot->groupParms.auxSounds[sevr], sevr);
		    soundRatePtr = &treeRoot->groupParms.auxSoundRates[sevr];
#ifdef SUN
		    soundHeaderPtr = &alarmSoundHeaders[sevr];
#endif SUN
		    soundFileFDPtr = &alarmSoundFDs[sevr];
		}
	    }
	    else
	    {
		if (*groupPtr->groupParms.sounds[sevr])
		{

		    OpenSoundFile (groupPtr->groupParms.sounds[sevr], sevr);
		    soundRatePtr = &groupPtr->groupParms.soundRates[sevr];
#ifdef SUN
		    soundHeaderPtr = &alarmSoundHeaders[sevr];
#endif SUN
		    soundFileFDPtr = &alarmSoundFDs[sevr];
		}
		else
		{
		    if (*treeRoot->groupParms.sounds[sevr] == 0)
		    {
			return; /* can't do anything without a sound definition */
		    }
		    OpenSoundFile (treeRoot->groupParms.sounds[sevr], sevr);
		    soundRatePtr = &treeRoot->groupParms.soundRates[sevr];
#ifdef SUN
		    soundHeaderPtr = &alarmSoundHeaders[sevr];
#endif SUN
		    soundFileFDPtr = &alarmSoundFDs[sevr];
		}
	    }
	}
	if (soundFileFDPtr && *soundFileFDPtr >= 0)
	{
	    if ( !curSoundFileNamePtr || strcmp (curSoundFileNamePtr, treeRoot->groupParms.sounds[sevr]) != 0)
	    {
		newSound = TRUE;
		curSoundFileNamePtr = treeRoot->groupParms.sounds[sevr];
		freqCounter = *soundRatePtr;
	    }
	    if (newSound || freqCounter == 1)
	    {
		if (audioDesc == -1)
		{
#ifdef SUN
		    if ((audioDesc = open (audioDevice, O_WRONLY | O_NDELAY)) < 0)
		    {
			/* device may be already allocated */
			printf ("~Cannot open audio device: %s\n", audioDevice);
			/* display is on client machine so disable sound completely */
			return;
		    }
		    else
		    {
			if (audio_get_play_config (audioDesc, &deviceHeader) != AUDIO_SUCCESS)
			{
			    printf ("~Cannot get audio config\n");
			    close (audioDesc);
			    audioDesc = -1; /* don't have access */
			    return;
			}
		    }
#endif SUN
#if defined(AXP) || defined(WIN32)
		    /* 
		     * Run the sound program
		     */
		    
		    audioDesc = 1;
#endif AXP
		}
		if (audioDesc == -1)
		{
#ifndef WIN32
		    /* couldn't get sound device, just soundoff and return */
		    MainDialogRingBellGW ();
#endif WIN32
		    return;
		}
		
#ifdef SUN
		if (audio_cmp_hdr (&deviceHeader, soundHeaderPtr) != 0)
		{
		    if (audio_drain (audioDesc, FALSE) != AUDIO_SUCCESS)
		    {
			printf ("~Alarm sound device drain error\n");
			close (*soundFileFDPtr);
			*soundFileFDPtr = -1;
		    }
		    if (*soundFileFDPtr >= 0)
		    {
			if (audio_set_play_config (audioDesc, soundHeaderPtr) != AUDIO_SUCCESS)
			{
			    printf ("~Alarm sound device configuration error\n");
			    close (*soundFileFDPtr);
			    *soundFileFDPtr = -1;
			}
		    }
		}
		if (*soundFileFDPtr >= 0)
		{
		    lseek (*soundFileFDPtr, sizeof (Audio_hdr), SEEK_SET);
		    while ((bytesRead = read (*soundFileFDPtr, soundBuffer, sizeof (soundBuffer))) >= 0)
		    {
			if (write (audioDesc, soundBuffer, bytesRead) != bytesRead)
			{
			    printf ("~Alarm sound device write error\n");
			    close (*soundFileFDPtr);
			    *soundFileFDPtr = -1;
			    break;
			}
			if (bytesRead == 0)
			{
			    break;
			}
		    }
		}
#endif SUN
#ifdef AXP
		axpPlaySound (curSoundFileNamePtr);
#endif AXP
#ifdef WIN32
		PlaySound (curSoundFileNamePtr, NULL, 
			   SND_ASYNC |
			   SND_FILENAME |
			   SND_NOWAIT |
			   SND_PURGE);
#endif WIN32
	    }

	    if ( !newSound && --freqCounter == 0)
	    {
		freqCounter = *soundRatePtr;
	    }
	    else if (freqCounter < 0)
	    {
		BellTurnOff ();
	    }
	}
	else if (audioType == -1)
	{
#endif SUN
	    curSoundFileNamePtr = NULL;
	    if (groupPtr)
	    {
		if (groupPtr->groupParms.auxSelectPV && groupPtr->auxValue )
		{
		    if ((*groupPtr->groupParms.auxSounds[sevr] != 0) && (*groupPtr->groupParms.auxSounds[sevr] != '*'))
		    {
#ifdef WIN32
			Beep (440, 250);
#else
			MainDialogRingBellGW ();
#endif WIN32
		    }
		    else if ((*treeRoot->groupParms.auxSounds[sevr] != 0)
		      && (*treeRoot->groupParms.auxSounds[sevr] != '*'))
		    {
#ifdef WIN32
			Beep (440, 250);
#else
			MainDialogRingBellGW ();
#endif WIN32
		    }
		}
		else
		{
		    if ((*groupPtr->groupParms.sounds[sevr] != 0) && (*groupPtr->groupParms.sounds[sevr] != '*'))
		    {
#ifdef WIN32
			Beep (440, 250);
#else
			MainDialogRingBellGW ();
#endif WIN32
		    }
		    else if ((*treeRoot->groupParms.sounds[sevr] != 0)
		      && (*treeRoot->groupParms.sounds[sevr] != '*'))
		    {
#ifdef WIN32
			Beep (440, 250);
#else
			MainDialogRingBellGW ();
#endif WIN32
		    }
		}
	    }
	    else
	    {
#ifdef WIN32
		Beep (440, 250);
#else
		MainDialogRingBellGW ();
#endif WIN32
    }
#if defined(SUN) || defined(AXP) || defined(WIN32)
	}
#endif SUN
    }
#if defined(SUN) || defined(AXP) || defined(WIN32)
    else
    {
	curSoundFileNamePtr = NULL;
	if (audioDesc != -1)
	{
#ifdef SUN
	    close (audioDesc); /* free up device */
#endif SUN
#ifdef AXP
	    mmcWaveOutClose (hWaveOut, &BufferList);
#endif AXP
#ifdef WIN32
	    PlaySound (NULL, NULL, SND_ASYNC | SND_FILENAME | SND_NOWAIT | SND_PURGE);
#endif WIN32
	    audioDesc = -1;
	}
    }
#endif SUN
}

/******************************************************************************
 *                                                                            *
 *                                                                            *
 *     OpenSoundFile ( soundName, sevr )                                      *
 *                                                                            *
 *                                                                            *
 *     Inputs                                                                 *
 *                                                                            *
 *     soundName     sound file path name                                     *
 *     sevr	     severity level                                           *
 *                                                                            *
 *     Return value                                                           *
 *                                                                            *
 *     none                                                                   *
 *                                                                            *
 *                                                                            *
 *     Description                                                            *
 *                                                                            *
 *     open a sound file                                                      *
 *                                                                            *
 *                                                                            *
 ******************************************************************************/

#if defined(SUN) || defined(AXP) || defined(WIN32)
void
OpenSoundFile ( soundName, sevr )
char *soundName;
int sevr;
{
#ifdef SUN
    int		tempFD;
#endif SUN
#ifdef AXP
    int		things_to_fix;
#endif AXP

    if ((*soundName == 0) || (*soundName == '*'))
    {
#ifndef WIN32
	if (alarmSoundFDs[sevr])
	    close (alarmSoundFDs[sevr]);
#endif WIN32
	alarmSoundFDs[sevr] = 0;
	strcpy (alarmSounds[sevr], soundName);
    }
    else if ( (strlen (alarmSounds[sevr]) == 0) || (strcmp (soundName, alarmSounds[sevr]) != 0))
    {
#ifdef SUN
	if ((tempFD = open (soundName, O_RDONLY, 0)) < 0)
        {
	    printf ("~Cannot open alarm sound file: %s\n", soundName);
	}
	else if (audio_read_filehdr (tempFD, &alarmSoundHeaders[sevr], (char *)NULL, 0)
	  != AUDIO_SUCCESS)
	{
	    printf ("~Not an alarm sound file: %s\n", soundName);
	    close (tempFD);
	}
	else
	{
	    if (alarmSoundFDs[sevr])
		close (alarmSoundFDs[sevr]);
	    alarmSoundFDs[sevr] = tempFD;
	    strcpy (alarmSounds[sevr], soundName);
	}
#endif SUN
#if defined(AXP) || defined(WIN32)
	/* nothing to do */
#endif AXP
    }
}
#endif SUN

