#ifndef	combodialogHXX
#define	combodialogHXX

enum ComboEnum {
    BROWSE_GROUP_LIST = 0,
    ENABLE_POINT_LIST,
    DISABLE_POINT_LIST,
    ENABLE_GROUP_LIST,
    DISABLE_GROUP_LIST,
    BASE_FILTER_LIST,
    EDIT_FILTER_LIST,
    DELETE_FILTER_LIST,
    STARTUP_FILTER_LIST,
    BROWSE_REPORTS_LIST
};
#define	COMBO_SELECTED_SIZE	64

class ComboBox;
class ComboOkButton;
class ComboCancelButton;

// *** COMBO DIALOG CLASS *********************************************

class ComboDialog : public vdialog
{
    alvuApplication	*app;
    int			listType;
    vstr		*title;
    vchar		selected [COMBO_SELECTED_SIZE + 1];
    void		SetDialogTitle (void);

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(ComboDialog);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(ComboDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void OpenCombo (alvuApplication *app, int listType,
		    char **selections, char *select);

    vchar *GetSelected (void)
	{ return (selected); }

    ComboBox		*comboBox;
    ComboOkButton	*okButton;
    ComboCancelButton	*cancelButton;

};


// *** COMBO BOX CLASS *************************************************

class ComboBox : public vcombobox
{
    ComboDialog	*comboDialog;

public:	

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(ComboBox);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(ComboBox, vcombobox);

    // override
    void ObserveComboBox (vevent *event, int message);

    // class extensions
    void BuildComboBoxList (char **selections);
    void StoreComboDialog (ComboDialog *dlg)
	{ comboDialog = dlg; }
    void SelectItem (char *selection);

};

// *** OK BUTTON CLASS **************************************************

class ComboOkButton : public vbutton
{
    ComboDialog	*comboDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(ComboOkButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(ComboOkButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreComboDialog (ComboDialog *dlg)
	{ comboDialog = dlg; }
};


// *** CANCEL BUTTON CLASS **********************************************

class ComboCancelButton : public vbutton
{
    ComboDialog	*comboDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(ComboCancelButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(ComboCancelButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreComboDialog (ComboDialog *dlg)
	{ comboDialog = dlg; }
};

#endif	combodialogHXX

