#ifndef	commentdialogHXX
#define	commentdialogHXX

class CommentCloseButton;
class CommentSaveButton;
class CommentDeleteButton;

// *** TEXT DIALOG CLASS *********************************************

class CommentDialog : public vdialog
{
    alvuApplication	*app;
    vstr		*title;
    AlarmLogRecord	*recPtr;
    void SetEntryAndComment (char *entry, char *comment);
    void SetDialogTitle (char *pv);

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(CommentDialog);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(CommentDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void OpenComment (alvuApplication *app, char *alarminfo, 
		      char *pvname, char *comment, 
		      AlarmLogRecord *recptr);

    vtextitem		*displayEntry;
    filteredTextitem	*commentView;
    CommentCloseButton	*closeButton;
    CommentSaveButton	*saveButton;
    CommentDeleteButton	*deleteButton;

    // handle recPtr
    AlarmLogRecord *GetAlarmLogRec (void)
	{ return (recPtr); }
};


// *** CLOSE BUTTON CLASS **********************************************

class CommentCloseButton : public vbutton
{
    CommentDialog	*commentDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(CommentCloseButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(CommentCloseButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreCommentDialog (CommentDialog *dlg)
	{ commentDialog = dlg; }
};


// *** SAVE BUTTON CLASS **********************************************

class CommentSaveButton : public vbutton
{
    CommentDialog	*commentDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(CommentSaveButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(CommentSaveButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreCommentDialog (CommentDialog *dlg)
	{ commentDialog = dlg; }
};


// *** DELETE BUTTON CLASS ********************************************

class CommentDeleteButton : public vbutton
{
    CommentDialog	*commentDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(CommentDeleteButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(CommentDeleteButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreCommentDialog (CommentDialog *dlg)
	{ commentDialog = dlg; }
};

#endif	commentdialogHXX
