#ifndef	popupdialogHXX
#define	popupdialogHXX

class AlarmGroupButton;
class ButtonContainer;
class PopupSilenceButton;
class PopupDisplayButton;
class PopupScriptButton;
class PopupCloseButton;
class PopupSummaryButton;
class PopupGuidanceButton;

// *** POPUP DIALOG CLASS *********************************************

class PopupDialog : public vdialog
{

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(PopupDialog);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(PopupDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void OpenPopup (alvuApplication *app, TreeNode *snode, Filter *origfilter);

    void RefreshDisplay (void);

    AlarmGroupButton	*alarmGroupButton;
    ButtonContainer	*buttonContainer;

    alvuApplication	*app;
    Filter		filter;
    TreeNode		*groupPtr;
    char		tempString[80];
 
};


// *** ALARMGROUP BUTTON CLASS **********************************************

class AlarmGroupButton : public vbutton
{
    PopupDialog	*popupDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(AlarmGroupButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(AlarmGroupButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StorePopupDialog (PopupDialog *dlg)
	{ popupDialog = dlg; }

};


// *** BUTTON CONTAINER CLASS **********************************************

class ButtonContainer : public vcontainer
{

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(ButtonContainer);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(ButtonContainer, vcontainer);

    // override
    void LoadInit (vresource resource);

    PopupSilenceButton   *silenceButton;
    PopupDisplayButton   *displayButton;
    PopupScriptButton    *scriptButton;
    PopupCloseButton	    *closeButton;
    PopupSummaryButton   *summaryButton;
    PopupGuidanceButton  *guidanceButton;

};


// *** SILENCE BUTTON CLASS **********************************************

class PopupSilenceButton : public vbutton
{
    PopupDialog	*popupDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(PopupSilenceButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(PopupSilenceButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StorePopupDialog (PopupDialog *dlg)
	{ popupDialog = dlg; }
};


// *** DISPLAY BUTTON CLASS **********************************************

class PopupDisplayButton : public vbutton
{
    PopupDialog	*popupDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(PopupDisplayButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(PopupDisplayButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StorePopupDialog (PopupDialog *dlg)
	{ popupDialog = dlg; }
};


// *** SCRIPT BUTTON CLASS **********************************************

class PopupScriptButton : public vbutton
{
    PopupDialog	*popupDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(PopupScriptButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(PopupScriptButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StorePopupDialog (PopupDialog *dlg)
	{ popupDialog = dlg; }
};


// *** CLOSE BUTTON CLASS **********************************************

class PopupCloseButton : public vbutton
{
    PopupDialog	*popupDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(PopupCloseButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(PopupCloseButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StorePopupDialog (PopupDialog *dlg)
	{ popupDialog = dlg; }
};


// *** SUMMARY BUTTON CLASS **********************************************

class PopupSummaryButton : public vbutton
{
    PopupDialog	*popupDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(PopupSummaryButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(PopupSummaryButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StorePopupDialog (PopupDialog *dlg)
	{ popupDialog = dlg; }
};


// *** GUIDANCE BUTTON CLASS **********************************************

class PopupGuidanceButton : public vbutton
{
    PopupDialog	*popupDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(PopupGuidanceButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(PopupGuidanceButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StorePopupDialog (PopupDialog *dlg)
	{ popupDialog = dlg; }
};

#endif	popupdialogHXX

