#ifndef	textdialogHXX
#define	textdialogHXX

enum textTypes
{
    EXPAND_TEXT = 0,
    GUIDANCE_TEXT
};

class TextCloseButton;

// *** TEXT DIALOG CLASS *********************************************

class TextDialog : public vdialog
{
    alvuApplication	*app;
    vstr		*title;
    int			textType;
    char		*miscStuff;
    void BuildText (char *txt);
    void SetDialogTitle (void);

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(TextDialog);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(TextDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void OpenText (alvuApplication *app, int textType, 
		   char *text, char *misc);

    vtextitem		*textView;
    TextCloseButton	*closeButton;
};


// *** CLOSE BUTTON CLASS **********************************************

class TextCloseButton : public vbutton
{
    TextDialog	*textDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(TextCloseButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(TextCloseButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreTextDialog (TextDialog *dlg)
	{ textDialog = dlg; }
};

#endif	textdialogHXX
