/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include "elfapi.h"
#include "apxfunc.h"
#include "apxdefs.h"
#include <sys/time.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>
#include <d4all.h>

#if defined(SOLARIS) || defined(AXP)
#define bzero(b,n)	memset (b, 0, n)
#define bcopy(s,d,n)	memcpy (d, s, n)
#endif

ENTRY   *atcaSearch(char *);
ENTRY	*atcaProcessPoint(char *point);
elfData	atcaSetNewValue(ENTRY *node);
void	atcaMonitor(struct event_handler_args arg);
void	atcaRead(struct	event_handler_args arg);
void	atcaConnect(struct connection_handler_args arg),atdbMonthDay(int, int, int *,int *);
void	atcaSignalHandler(int),atdbSplitDate(double,int *,int *,int *),atdbSplitTime(double,int *,int *,int *);
double	atdbMakeDate(int,int,int),atdbMakeTime(int,int,int);
int	atdbDayOfYear(int,int,int);
int	atdbGetRecord(D4DATA *,char *,char *,int,int,int,int,char *),longStatus(char *),thisYear;
char	*StrStatus(int,char *);
static int pointCount = 0;
char	msg[80];
LIST	atcaTable;
F4FIELD	*ratePtr,*offsetPtr,*doyPtr,*yearPtr,*hourPtr,*samplePtr;
D4DATA	*table;
float	tempvalue;
char	tempstatus[4];
static char daytab[2][13] =
	{
	{0,31,28,31,30,31,30,31,31,30,31,30,31},
	{0,31,29,31,30,31,30,31,31,30,31,30,31}
	};
static	char	key[MAXSTRING],sp[MAXSTRING];
char	*sev = "VMmIE";
unsigned long	sevbits [] =  {0x80000000, 0x40000000, 0x20000000, 0x10000000,0x08000000};
char	*qual = "*QCqF"; 							/* in precedence order*/
unsigned long	qualbits [] = {0x04000000, 0x02000000, 0x01000000,0x00800000, 0x00400000};
char	*alms = "FuBEKUXTIRGNcMCSrHhLlW ";
unsigned long	almbits []= {0x00200000, 0x00100000,
				 0x00080000, 0x00040000, 0x00020000, 0x00010000,
				 0x00008000, 0x00004000, 0x00002000, 0x00001000,
				 0x00000800, 0x00000400, 0x00000200, 0x00000100,
				 0x00000080, 0x00000040, 0x00000020, 0x00000010,
				 0x00000008, 0x00000004, 0x00000002, 0x00000001,
				 0};
#define	APX_ERR_SUCCESS		0
#define	APX_ERR_NORECORD	1
#define	APX_ERR_BADYEAR		2
#define	APX_ERR_SEEKERR		3
#define	APX_ERR_SKIPERR		4
#define	APX_ERR_NODATA		5
#define	APX_ERR_BLANK		6
char	*errorMsg[] =
	{
	"Success",
	"Record not found",
	"Incorrect year",
	"Error from seek",
	"Error from skip",
	"No data for PV",
	"Data was blank",
	"Error opening ar_snap.dbf"
	};
double	atdbRate;
int	atdbFieldIndex,atdbSampleCnt,tag_status;
int	atdbMinute,atdbSecond,atdbOffsetMinute,atdbFileHour,intDate;
time_t	current_time,retval,tempTime;
static char	*atdbDefaultPath;
static char	*atdbDefaultFile;
char	atdbStatusString[32];
int	atdbStatusValue,ts;
C4CODE	cb;

elfData AxDispatch(int funcId,elfData funcData)
{
elfData	rData = NULL;
ENTRY	*atcaEntry;
char	atcaProcessVar[PVNAME_SZ+FLDNAME_SZ+1],atdbRed1[RED_STR_SIZE],atdbRed2[RED_STR_SIZE],sawvaliddata;
double	atdbDate,atdbTime,atdbSpan,atdbResult,atdbLocalDateValue,atdbCurrentTime;
int	atdbMonth,atdbDay,atdbYear,atdbDOY;
int	atdbHour,atdbMinute,atdbSecond,i,atdbNSamples,loop_cnt;
int	atcaStatus = 0;
int	atdbStatus = 0;
char	atdbArSnapFile[MAXPATHLEN];
REDUCTION_TYPE	atdbFileReduction,atdbReqReduction;
struct	tm	*local_time,*reqTime;	/* for GMT conversions */
tempstatus[0] = 0;
tempstatus[1] = 0;
tempstatus[2] = 0;

switch(funcId)
	{
	case GET_VALUE:
		strcpy(atcaProcessVar,AxStrPtrFromDataPtr(funcData));
		if((atcaEntry = atcaProcessPoint(atcaProcessVar)) != 0)
			{
			ca_pend_io(0.0);
			if(atcaEntry->valid)
				rData = atcaSetNewValue(atcaEntry);		/* set the new return value */
			}
		else
			rData = AxMakeStrData(strlen(msg),msg);
		break;
	case PUT_VALUE:
		break;
	case GET_HTREND:
		AxDecomposeArray(funcData,"cdddcc",atcaProcessVar,PVNAME_SZ,
						&atdbDate,
						&atdbTime,
						&atdbSpan,
						atdbRed1,RED_STR_SIZE,
						atdbRed2,RED_STR_SIZE);
		atdbSplitDate(atdbDate,&atdbMonth,&atdbDay,&atdbYear);
		atdbSplitTime(atdbTime,&atdbHour,&atdbMinute,&atdbSecond);
		rData = NULL;
		if(table == 0)
		  {
		    AxError(2,errorMsg[7],"GETHTREND");
		    d4unlock_all(table);
		    return(rData);
		  }
/*
	06-Apr-1995 GCT.
	Set up for new GMT/DST conversion scheme.
*/
		tempTime		= time(0);
		reqTime			= localtime(&tempTime);
		reqTime->tm_year	= atdbYear - 1900;
		reqTime->tm_mon		= atdbMonth - 1;
		reqTime->tm_mday	= atdbDay;
		reqTime->tm_hour	= atdbHour;
		reqTime->tm_min		= atdbMinute;
		reqTime->tm_sec		= atdbSecond;
#if !defined(MIPSEL) && !defined(AXP)
#if !defined(SOLARIS)
		retval = timelocal (reqTime);
#else
		retval = mktime (reqTime);
#endif
#else
		retval = mktime (reqTime);
#endif
		local_time		= (struct tm *)gmtime(&retval);			/* get local time for this cell */
		atdbYear		= local_time->tm_year;
		atdbMonth		= local_time->tm_mon + 1;
		atdbDay			= local_time->tm_mday;
		atdbHour		= local_time->tm_hour;
		atdbMinute		= local_time->tm_min;
		atdbSecond		= local_time->tm_sec;
		atdbYear += 1900;
		atdbDate = atdbMakeDate(atdbMonth,atdbDay,atdbYear);
		atdbTime = atdbMakeTime(atdbHour,atdbMinute,atdbSecond);
		atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
		atdbDate += atdbTime;
/*
	Setup reduction method from file
*/
		for(i = 0;atdbRed1[i];i++) atdbRed1[i] = toupper(atdbRed1[i]);
		if(!strcmp(atdbRed1,"AVG"))
			atdbFileReduction = AVERAGE;
		else if(!strcmp(atdbRed1,"MIN"))
			atdbFileReduction = MINIMUM;
		else if(!strcmp(atdbRed1,"MAX"))
			atdbFileReduction = MAXIMUM;
		else
			atdbFileReduction = SAMPLE;
/*
	Setup requested reduction method.
*/
		for(i = 0;atdbRed2[i];i++) atdbRed2[i] = toupper(atdbRed2[i]);
		if(!strcmp(atdbRed2,"AVG"))
			{
			atdbResult = 1.0;
			atdbReqReduction = AVERAGE;
			}
		else if(!strcmp(atdbRed2,"MIN"))
			{
			atdbResult = 1.0e+20;
			atdbReqReduction = MINIMUM;
			}
		else if(!strcmp(atdbRed2,"MAX"))
			{
			atdbResult = 1.0e-20;
			atdbReqReduction = MAXIMUM;
			}
		else
			atdbReqReduction = SAMPLE;
/*
	Get First sample. If requested reduction is SAMPLE then we are done
*/
		rData = NULL;
		if(atdbReqReduction == SAMPLE)			/* no need to proceed any further */
			{
			if((atdbStatus = atdbGetRecord(table,atcaProcessVar,atdbRed1,atdbYear,atdbDOY,atdbHour,atdbMinute,"VALUE")) != 0)
				{
				AxError(2,errorMsg[atdbStatus],"GETHTREND");
				d4unlock_all(table);
				return(rData);
				}
			atdbResult = tempvalue;
			rData = AxMakeFloatData(atdbResult);
			d4unlock_all(table);
			return(rData);
			}
		atdbDate -= (atdbSpan * APPLIX_MINUTE);				/* atdbSpan is in minutes so convert to fractional days */
		intDate = atdbDate;
		atdbSplitDate(atdbDate,&atdbMonth,&atdbDay,&atdbYear);
		atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
		atdbTime = atdbDate - (double)intDate;
		atdbSplitTime(atdbTime,&atdbHour,&atdbMinute,&atdbSecond);
		rData = NULL;
		if((atdbStatus = atdbGetRecord(table,atcaProcessVar,atdbRed1,atdbYear,atdbDOY,atdbHour,atdbMinute,"VALUE")) != 0)
			{
			AxError(2,errorMsg[atdbStatus],"GETHTREND");
			d4unlock_all(table);
			return(rData);
			}
		atdbNSamples = 0;
		loop_cnt = atdbSpan / atdbRate;		/* span from cell arg #4 / rate from file */
		for(;loop_cnt != 0;loop_cnt--)		/* loop for this many data points */
			{
/*
	Get another point value here.
*/
			atdbDate += (atdbRate * APPLIX_MINUTE);
			atdbTime = atdbDate - (double)intDate;
			atdbLocalDateValue += (atdbRate * APPLIX_MINUTE);
			atdbSplitDate(atdbDate,&atdbMonth,&atdbDay,&atdbYear);
			atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
			atdbTime = atdbDate - (double)intDate;
			atdbSplitTime(atdbTime,&atdbHour,&atdbMinute,&atdbSecond);
/*
	GCT 12-Dec-1994 Must use current time to avoid reporting "future" data...Data that has not been written
	to the file yet. The sample count will always reflect a full record so we can't use it anymore.

			if(atdbLocalDateValue > atdbCurrentTime)
				continue;
*/
			if((atdbStatus = atdbGetRecord(table,atcaProcessVar,atdbRed1,atdbYear,atdbDOY,atdbHour,atdbMinute,"VALUE")) != 0)
				continue;
			atdbNSamples++;
			switch(atdbReqReduction)
				{
				case AVERAGE:
					atdbResult = (atdbResult * (atdbNSamples - 1) + tempvalue) / atdbNSamples;
					break;
				case MINIMUM:
					if((atdbNSamples == 1) ||  (tempvalue < atdbResult))
						atdbResult = tempvalue;
					break;
				case MAXIMUM:
					if((atdbNSamples == 1) ||  (tempvalue > atdbResult))
						atdbResult = tempvalue;
					break;
				}
			}
		rData = AxMakeFloatData(atdbResult);
		d4unlock_all(table);
		return(rData);
		break;
	case GET_HSTATUS:
		AxDecomposeArray(funcData,"cdddcc",atcaProcessVar,PVNAME_SZ,
						&atdbDate,
						&atdbTime,
						&atdbSpan,
						atdbRed1,RED_STR_SIZE,
						atdbRed2,RED_STR_SIZE);
		atdbSplitDate(atdbDate,&atdbMonth,&atdbDay,&atdbYear);
		atdbSplitTime(atdbTime,&atdbHour,&atdbMinute,&atdbSecond);
		rData = NULL;
		if(table == 0)
		  {
		    AxError(2,errorMsg[7],"GETHSTATUS");
		    d4unlock_all(table);
		    return(rData);
		  }
/*
	06-Apr-1995 GCT.
	Set up for new GMT/DST conversion scheme.
*/
		tempTime		= time(0);
		reqTime			= localtime(&tempTime);
		reqTime->tm_year	= atdbYear - 1900;
		reqTime->tm_mon		= atdbMonth - 1;
		reqTime->tm_mday	= atdbDay;
		reqTime->tm_hour	= atdbHour;
		reqTime->tm_min		= atdbMinute;
		reqTime->tm_sec		= atdbSecond;
#if !defined(MIPSEL) && !defined(AXP)
#if !defined(SOLARIS)
		retval = timelocal (reqTime);
#else
		retval = mktime (reqTime);
#endif
#else
		retval = mktime (reqTime);
#endif
		local_time		= (struct tm *)gmtime(&retval);			/* get local time for this cell */
		atdbYear		= local_time->tm_year;
		atdbMonth		= local_time->tm_mon + 1;
		atdbDay			= local_time->tm_mday;
		atdbHour		= local_time->tm_hour;
		atdbMinute		= local_time->tm_min;
		atdbSecond		= local_time->tm_sec;
		atdbYear += 1900;
		atdbDate = atdbMakeDate(atdbMonth,atdbDay,atdbYear);
		atdbTime = atdbMakeTime(atdbHour,atdbMinute,atdbSecond);
		atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
		atdbDate += atdbTime;
/*
	Setup reduction method from file
*/
		for(i = 0;atdbRed1[i];i++) atdbRed1[i] = toupper(atdbRed1[i]);
		if(!strcmp(atdbRed1,"AVG"))
			atdbFileReduction = AVERAGE;
		else if(!strcmp(atdbRed1,"MIN"))
			atdbFileReduction = MINIMUM;
		else if(!strcmp(atdbRed1,"MAX"))
			atdbFileReduction = MAXIMUM;
		else
			atdbFileReduction = SAMPLE;
/*
	Setup requested reduction method.
*/
		for(i = 0;atdbRed2[i];i++) atdbRed2[i] = toupper(atdbRed2[i]);
		if(!strcmp(atdbRed2,"AVG"))
			{
			atdbResult = 1.0;
			atdbReqReduction = AVERAGE;
			}
		else if(!strcmp(atdbRed2,"MIN"))
			{
			atdbResult = 1.0e+20;
			atdbReqReduction = MINIMUM;
			}
		else if(!strcmp(atdbRed2,"MAX"))
			{
			atdbResult = 1.0e-20;
			atdbReqReduction = MAXIMUM;
			}
		else
			atdbReqReduction = SAMPLE;
/*
	Get First sample. If requested reduction is SAMPLE then we are done
*/
		rData = NULL;
		atdbStatusValue = 0xffffffff;
		if(atdbReqReduction == SAMPLE)			/* no need to proceed any further */
			{
			if((atdbStatus = atdbGetRecord(table,atcaProcessVar,atdbRed1,atdbYear,atdbDOY,atdbHour,atdbMinute,"STATUS")) != 0)
				{
				AxError(2,errorMsg[atdbStatus],"GETHSTATUS");
				d4unlock_all(table);
				return(rData);
				}
			memcpy(atdbStatusString,tempstatus,3);					/* get status string(3 chars) */
			atdbStatusString[3] = 0;						/* NULL terminate */
			atdbStatusValue = longStatus(atdbStatusString);				/* decode bits in value */
			(void)StrStatus(atdbStatusValue,atdbStatusString);			/* encode bits back into string */
			rData = AxMakeStrData(strlen(atdbStatusString),atdbStatusString);			
			d4unlock_all(table);
			return(rData);
			}
		atdbDate -= (atdbSpan * APPLIX_MINUTE);				/* atdbSpan is in minutes so convert to fractional days */
		intDate = atdbDate;
		atdbSplitDate(atdbDate,&atdbMonth,&atdbDay,&atdbYear);
		atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
		atdbTime = atdbDate - (double)intDate;
		atdbSplitTime(atdbTime,&atdbHour,&atdbMinute,&atdbSecond);
		rData = NULL;
		if((atdbStatus = atdbGetRecord(table,atcaProcessVar,atdbRed1,atdbYear,atdbDOY,atdbHour,atdbMinute,"STATUS")) != 0)
			{
			AxError(2,errorMsg[atdbStatus],"GETHSTATUS");
			d4unlock_all(table);
			return(rData);
			}
		atdbNSamples = 0;
		atdbStatusValue = 0xffffffff;
		loop_cnt = atdbSpan / atdbRate;		/* span from cell arg #4 / rate from file */
		for(;loop_cnt != 0;loop_cnt--)		/* loop for this many data points */
			{
/*
	Get another point value here.
*/
			atdbDate += (atdbRate * APPLIX_MINUTE);
			atdbTime = atdbDate - (double)intDate;
			atdbLocalDateValue += (atdbRate * APPLIX_MINUTE);
			atdbSplitDate(atdbDate,&atdbMonth,&atdbDay,&atdbYear);
			atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
			atdbTime = atdbDate - (double)intDate;
			atdbSplitTime(atdbTime,&atdbHour,&atdbMinute,&atdbSecond);
/*
	GCT 12-Dec-1994 Must use current time to avoid reporting "future" data...Data that has not been written
	to the file yet. The sample count will always reflect a full record so we can't use it anymore.
*/
			if(atdbLocalDateValue > atdbCurrentTime)
				continue;
			if((atdbStatus = atdbGetRecord(table,atcaProcessVar,atdbRed1,atdbYear,atdbDOY,atdbHour,atdbMinute,"STATUS")) != 0)
				continue;
			atdbNSamples++;
			tempstatus[3] = 0;				/* NULL terminate */
			if (atdbStatusValue == 0xffffffff)
				{
				atdbStatusValue = longStatus(tempstatus);
				}
			else											/* rest of samples are subjected to precedence */
				{
				ts = longStatus(tempstatus);			/* if new quality is worse, update the quality */
				if ((ts & QUALMASK) > (atdbStatusValue & QUALMASK))
					atdbStatusValue = (atdbStatusValue & ~QUALMASK) | (ts & QUALMASK);
				if ((ts & CONNERRBIT) == 0)
					sawvaliddata = 1;
/*
	if new error is more severe or we haven't seen an alarm,
	take value from new sample.
*/
				if (((ts & SEVMASK) > (atdbStatusValue & SEVMASK)) || ((atdbStatusValue & ALMMASK) == 0))
					atdbStatusValue = (atdbStatusValue & QUALMASK) | (ts & (SEVMASK | ALMMASK));
				}
			}
/*
	 if quality level is Connect but we saw valid data, convert to Q status.
*/
		if ((atdbStatusValue != 0xffffffff) && (atdbStatusValue & CONNERRBIT) && (sawvaliddata == 1))
			atdbStatusValue = (atdbStatusValue & ~QUALMASK) | QERRBIT;
/*
	Convert the status integer to a text string for display in Lotus
*/
		(void)StrStatus(atdbStatusValue,atdbStatusString);
		rData = AxMakeStrData(strlen(atdbStatusString),atdbStatusString);			
		d4unlock_all(table);
		return(rData);
		break;
	case INIT_MACROS:
/*
	Init the Channel Sccess stuff first...
*/
		lstInit((LIST *)&atcaTable);
		atcaStatus = ca_task_initialize();
		rData = AxMakeIntData(atcaStatus);
/*
	Init database(dBase/Codebase) stuff next...
*/
		if((atdbDefaultPath = getenv("SNAP_PATH")) == 0)
			atdbDefaultPath = "/tis4000db";
		if((atdbDefaultFile = getenv("SNAP_FILE")) == 0)
			atdbDefaultFile = "ar_snap.dbf";
		sprintf(atdbArSnapFile,"%s/%s\0",atdbDefaultPath,atdbDefaultFile);
		d4init(&cb);
		cb.tag_name_error	= 0;
		cb.read_only		= 1;
		cb.open_error		= 0;
		if((table = d4open(&cb,atdbArSnapFile)) != 0)
		  {
		    d4tag_select(table,d4tag(table,"METHOD_REC"));
		    ratePtr = d4field(table,"RATE");		/* >= one. # of hours in record = sample_cnt/rate */
		    offsetPtr = d4field(table,"OFFSET_MIN");
		    doyPtr = d4field(table,"DAYOFYEAR");
		    yearPtr = d4field(table,"YEAR");
		    hourPtr = d4field(table,"HOUR");
		    samplePtr = d4field(table,"SAMPLE_CNT");	/* # of samples in record <= 60 */
		    tempTime	= time(0);
		    reqTime    	= localtime(&tempTime);
		    thisYear	= reqTime->tm_year+1900;
		  }
		else
		  {
		    AxError(2,errorMsg[7],"GETHTREND");
		  }
/*
	Establish signal handlers for command line exiting.
*/
		signal(SIGINT,atcaSignalHandler);
		signal(SIGHUP,atcaSignalHandler);
		break;
	}
return(rData);
}
ENTRY	*atcaProcessPoint(char *point)
{
ENTRY	*atcaEntry;
chid	atcaChid;
long	atcaStatus;
evid	evID;						/* must have for NEW CA. GCT 30-Mar-1994 */
char	msg[80];
/*
	search table for occurance of 'point' string. If found then
	return pointer to it . Else make entry in table
	and attach channel to event handler.
*/

if((atcaEntry = atcaSearch(point)) == 0)
	{
	if((atcaEntry = (ENTRY *)malloc(ENTRY_SIZE)) == 0)		/* get some memory */
		{
		sprintf(msg,"Can't allocate memory for PV:%s\n",point);
		return(0);
		}
	if((atcaStatus = ca_build_read_and_monitor(point,atcaConnect,atcaEntry,atcaRead,atcaEntry,atcaMonitor,atcaEntry,&atcaChid,&evID)) != ECA_NORMAL)
		{
		free(atcaEntry);
		sprintf(msg,"Problem with ca_build_read_and_monitor...%s\n",ca_message(atcaStatus));
		return(0);
		}
	lstAdd((LIST *)&atcaTable,(NODE *)atcaEntry);		/* add to list */
	sprintf(&atcaEntry->var[0],"%s\0",point);			/* copy the point name */
	atcaEntry->lastvalue.float_value = 0.0;			/* in case protected on startup */
	atcaEntry->laststring[0] = '\0';					/* zero length string too. */
	atcaEntry->type = ca_field_type(atcaChid);		/* this is for both 'SET' functions */
	atcaEntry->channel_id = atcaChid;					/* for output points */
	atcaEntry->valid = 0;								/* not valid until first report */
	atcaChid->paddr = (void *)atcaEntry;				/* save here for connection event */
	ca_pend_io(MIN_TIMEOUT);
	}
return(atcaEntry);
}
elfData	atcaSetNewValue(ENTRY *node)
{
elfData	retData;
switch(node->type)
	{
	case DBR_STS_FLOAT:
	case DBR_STS_DOUBLE:
	case DBR_CTRL_FLOAT:
	case DBR_CTRL_DOUBLE:
		retData = AxMakeFloatData(node -> value.float_value);
		break;
	case DBR_STS_CHAR:
	case DBR_CTRL_CHAR:
		retData = AxMakeIntData(node -> value.byte_value & 0xff);
		break;
	case DBR_STS_LONG:
	case DBR_CTRL_LONG:
		retData = AxMakeIntData(node -> value.long_value & 0xffffffff);
		break;
	case DBR_STS_SHORT:
	case DBR_STS_ENUM:
	case DBR_CTRL_SHORT:
	case DBR_CTRL_ENUM:
		retData = AxMakeIntData(node -> value.short_value & 0xffff);
		break;
	case DBR_STS_STRING:
	case DBR_CTRL_STRING:
		retData = AxMakeStrData(strlen(&node->string[0]),&node->string[0]);
		break;
	}
return(retData);
}
void	atcaMonitor(struct event_handler_args arg)
{
ENTRY	*node;

node = arg.usr;					/* address of the ENTRY node for this point */
node -> type = arg.type;			/* value type */
node -> valid = 1;				/* value is good from now on. Use old value if "calc" rate > report rate */
switch(arg.type)
	{
	case DBR_STS_DOUBLE:
		node -> value.float_value = ((struct dbr_sts_double *)arg.dbr)->value;
		break;
	case DBR_STS_FLOAT:
		node -> value.float_value =  ((struct dbr_sts_float *)arg.dbr)->value;
		break;
	case DBR_STS_CHAR:
		node -> value.byte_value = ((struct dbr_sts_char *)arg.dbr)->value;
		break;
	case DBR_STS_LONG:
		node -> value.long_value = ((struct dbr_sts_long *)arg.dbr)->value;
		break;
	case DBR_STS_SHORT:
	case DBR_STS_ENUM:
		node -> value.short_value = ((struct dbr_sts_short *)arg.dbr)->value;
		break;
	case DBR_CTRL_STRING:
	case DBR_STS_STRING:
		strcpy(node -> string, ((struct dbr_sts_string *)arg.dbr)->value);
		break;
	case DBR_CTRL_DOUBLE:
		node -> value.float_value = ((struct dbr_ctrl_double *)arg.dbr)->value;
		break;
	case DBR_CTRL_FLOAT:
		node -> value.float_value =  ((struct dbr_ctrl_float *)arg.dbr)->value;
		break;
	case DBR_CTRL_CHAR:
		node -> value.byte_value = ((struct dbr_ctrl_char *)arg.dbr)->value;
		break;
	case DBR_CTRL_LONG:
		node -> value.long_value = ((struct dbr_ctrl_long *)arg.dbr)->value;
		break;
	case DBR_CTRL_SHORT:
	case DBR_CTRL_ENUM:
		node -> value.short_value = ((struct dbr_ctrl_short *)arg.dbr)->value;
		break;
	}
}
/*
	Called after ca_build_read_and_monitor. same as above.
*/
void	atcaRead(struct	event_handler_args arg)
{
atcaMonitor(arg);
}
/*
	Connection handler. Used to finish-up build_and_read...
*/
void	atcaConnect(struct connection_handler_args arg)
{
int		cnt;
ENTRY	*node;
node = (ENTRY *)arg.chid->paddr;
if(arg.op == CA_OP_CONN_UP)
	ca_complete_bld_read_mon(arg.chid);
else
	node->valid = 0;					/* point invalid until next connect and report */
}
/*
	This is the search function. It is used to locate the process variable name
	in the ENTRY table. If the match succeeds then a poiner to the entry is
	returned else a NULL is returned;
*/
ENTRY	*atcaSearch(char *item)
{
ENTRY	*i;
i = (ENTRY *)lstFirst((LIST *)&atcaTable);
while(i)
	{
	if(!strcmp((char *)(&i->var[0]),item))
		break;
	i = (ENTRY *)lstNext((NODE *)i);
	}
return((ENTRY *)i);
}
void	atcaSignalHandler(int whichOne)
{
  switch(whichOne)
    {
    case SIGHUP:
    case SIGINT:
      ca_task_exit();
      if(table) d4close(table);
      printf("apxDispatch exiting due to ctrl-C\n");
      exit(1);
      break;
    }
}
void	atdbSplitDate(double dv,int *m,int *d,int *y)
{
int	dd,leap;
dd = dv;
for(*y = 1900;*y < thisYear;(*y)++)	/* total days since 1900 */
	{
	leap = *y%4 == 0 && *y%100 != 0 || *y%400 == 0;
	dd -= (365 + leap);
	}
atdbMonthDay(*y,dd,m,d);
}
void	atdbSplitTime(double tv,int *h,int *m,int *s)
{
double hh,tt,mm,ss;
tt = tv * SECS_PER_DAY;
tt += 1.0;
hh = tt / SECS_PER_HOUR;		/* get HOUR */
*h = hh;
mm = (hh - *h) * SECS_PER_MINUTE;	/* get MINUTES */
*m = mm;
ss = (mm - *m) * SECS_PER_MINUTE;	/* get SECONDS */
*s = ss;
}
double atdbMakeDate(int m,int d,int y)
{
int year,days,month,leap;
days = 0;
for(year = 1900;year < y;year++)	/* total days since 1900 */
	{
	leap = (year%4 == 0 && year%100 != 0 || year%400 == 0);
	days += (365 + leap);
	}
days += (atdbDayOfYear(y,m,d) + 2);
return((double)days);
}
double atdbMakeTime(int h,int m,int s)
{
return(((h * SECS_PER_HOUR) + (m * SECS_PER_MINUTE) + s)/SECS_PER_DAY);
}
int	atdbDayOfYear(int year,int month,int day)
{
int	i,leap;
leap = year%4 == 0 && year%100 != 0 || year%400 == 0;
for(i = 1;i < month;i++)
	day += daytab[leap][i];
return(day-1);
}
void	atdbMonthDay(int year,int doy,int *m,int *d)
{
int	i,leap;
leap = year%4 == 0 && year%100 != 0 || year%400 == 0;
for(*m = 1;doy > daytab[leap][*m];(*m)++)
	doy -= daytab[leap][*m];
*d = doy-1;
}
/*
	Get record with specified key. "fieldname" determines what to return value or status
*/
int	atdbGetRecord(D4DATA *table,char *name,char *method,int year,int doy,int hour,int minute,char *fieldname)
{
double		val,thour,tmin;
int		type,stat,slot_num,filedoy,fileyear,skip_ahead,rate,seek_stat;
int		start_time,target_time,i;
F4FIELD		*fptr;
char		slot_data[11],*statptr;

sprintf(key,"%-*.*s%3.3s%4d%3d%2d%2d\0",PVNAME_SZ,PVNAME_SZ,name,method,year,doy,hour,minute);	/* build key for new AR_SNAP files */
seek_stat = d4seek(table,key);
if(seek_stat < 0)
	{
	d4unlock_all(table);
	return(APX_ERR_SEEKERR);					/* seek error */
	}
if((seek_stat == r4after) || (seek_stat == r4eof))					/* not exactly found backup 1 record */
	{
	stat = d4skip(table,-1);
	if(stat != 0)
		{
		d4unlock_all(table);
		return(APX_ERR_SKIPERR);
		}
	seek_stat = stat;
	}
if(seek_stat == 0)						/* find record */
	{
	d4unlock_all(table);
	while(1)
		{
		atdbRate = f4double(ratePtr);
		atdbOffsetMinute = f4int(offsetPtr);
		filedoy = f4int(doyPtr);
		fileyear = f4int(yearPtr);
		atdbFileHour = f4int(hourPtr);
		atdbSampleCnt = f4int(samplePtr);
		if(atdbSampleCnt == 0)						/* no data in file */
			return(APX_ERR_NODATA);
		if(filedoy != doy)							/* requested record not in file */
			return(APX_ERR_NORECORD);
/*
	Check to make sure that the requested data is in the current record. If the requested time is earlier than
	the start time in the current record then I must skip back one record. If the requested time is
	later than the end time in the current record then I must skip ahead one record. Anything else is
	OK and I can proceed.
*/
		if(((atdbFileHour * 60 + atdbOffsetMinute) + (atdbRate * 60 + atdbOffsetMinute)) <= (hour * 60 + minute))
				{
				d4skip(table,1);		/* go ahead one record and re-read fields */
				continue;
				}
		break;								/* requested time is in the current record...get the value */
		}/*end while */
/*
		Get value from record
*/
		/* then error */
	if(year != fileyear)
		return(APX_ERR_BADYEAR);				/* must be same year too */
	start_time = atdbFileHour * 3600 + atdbOffsetMinute * 60;
	target_time = hour * 3600 + minute * 60 + atdbSecond;
	rate = atdbRate * 60;
	atdbFieldIndex = 0;
	for(i = start_time;i <= target_time;i += rate)
		atdbFieldIndex++;
	if ((atdbFieldIndex < 1) || (atdbFieldIndex > atdbSampleCnt))
		return(APX_ERR_NODATA);				/* no data to get */
	sprintf(slot_data,"%s%d\0",fieldname,atdbFieldIndex);	/* make field name */
	fptr = d4field(table,slot_data);
/*
	The following code is here to support the new format of the 'ar_snap.dbf' file. The
	values are now stored as 'real' floating point numbers using eight bytes instead
	of 18 as in the previous structure. This makes this file unreadable by dBase IV.

	GCT	15-Apr-1993
*/
	if(!strcmp(fieldname,"VALUE"))
		{
		statptr = f4ptr(fptr);
		if(*statptr != ' ')
			tempvalue = atof(statptr);
		else
			{
			d4unlock_all(table);
			return(APX_ERR_BLANK);
			}
		}
	else
		{
		statptr = f4ptr(fptr);
		bcopy(statptr,tempstatus,3);
		}
	d4unlock_all(table);
	return(APX_ERR_SUCCESS);
	}
else
	{
	d4unlock_all(table);
	return(APX_ERR_SEEKERR);
	}
}
char *StrStatus (int stat, char *str) 
{
    int i;

	str[0] = 0;
	if (stat != 0xffffffff)
	{
		str[0] = '-';
		for (i = 0; i < NUMQUAL; i++)
		{
			if (stat & qualbits[i])
			{
				str [0] = qual[i];
				break;
			}
		}
		str[1] = '-';
		for (i = 0; i < NUMSEV; i++)
		{
			if (stat & sevbits[i])
			{
				str [1] = sev[i];
				break;
			}
		}
		str[2] = '-';
		for (i = 0; i < NUMALM; i++)
		{
			if (stat & almbits[i])
			{
				str [2] = alms[i];
				break;
			}
		}
		str[3] = 0;
	}
    return str;
}
int longStatus (char *stat)
{
	unsigned int retstatus = 0;
	char *cp;

	if (stat[0] && (cp = strchr (qual, stat[0])))
	{
		retstatus = retstatus | qualbits [ cp-qual ];
	}
	if (stat[1] && (cp = strchr (sev, stat[1])))
	{
		retstatus = retstatus | sevbits [ cp-sev ];
	}
	if (stat[2] && (cp = strchr (alms, stat[2])))
	{
		retstatus = retstatus | almbits [ cp-alms ];
	}
	return retstatus;
}
