
#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>

typedef struct ElfOpaque *elfData;

typedef struct AxCallInfo_t {	/* C-Library dynamic linkage info */
	char *category;	/* func type ... "financial", "math" ... */
    elfData (*func)();	/* the C routine to call */
	char *alias;	/* name to use in Applixware (usually same as name) */
	char *argStr;	/* describes function args (per declaration) */
	int spreadsheetBuiltin;	/* if TRUE, visible in SS's Functions... Box */
} AxCallInfo_t;


#ifdef AX_USE_PROTOS
#define AXP_(body) body
#else
#define AXP_(body) ()
#endif

#define int32 int

#define ELFC_INIT 0		/* Automatically called once during server init */
#define ELFC_EXIT -1	/* Reserved convention for shutdown sequence */
#define ELFC_AXNET -2	/* Allows C servers to look like ELF<->ELF servers */
#define ELFC_PORT -3	/* Return port number from (e.g. from /etc/services) */
#define ELFC_HS1 -4		/* Private handshake support for axmain */
#define ELFC_HS2 -5		/* Private handshake support for axmain */
#define ELFC_HS3 -6		/* Private handshake support for axmain */
#define ELFC_GET_PID -7		/* For axmain to request pid of child process */

#define ELFSVR_OK        0
#define ELFSVR_ERROR    -1
#define ELFSVR_NOCHANNEL 1    /* obsolete */
#define ELFSVR_NOCLIENT  2

extern int AxArraySize  AXP_ ((elfData arg));
extern int AxBinarySize AXP_ ((elfData arg));
extern int AxIsArray    AXP_((elfData p));
extern int AxIsBinary   AXP_((elfData data));
extern int AxIsFloat    AXP_((elfData data));
extern int AxIsInt      AXP_((elfData data));
extern int AxIsNumber   AXP_((elfData data));
extern int AxIsString   AXP_((elfData data));

#if !eldataHinclude
extern elfData  AxAddArrayToArray AXP_((elfData ap,int dex,elfData p));
extern elfData  AxAddBoolToArray AXP_((elfData ap,int dex,int n));
extern elfData  AxAddDataToArray AXP_((elfData ap,int dex,elfData p));
extern elfData  AxAddFloatToArray AXP_((elfData ap,int dex,double n));
extern elfData  AxAddIntToArray AXP_((elfData ap,int dex,int n));
extern elfData  AxAddStrToArray AXP_((elfData ap,int dex,char *str));
extern elfData *AxArrayDataAddr AXP_((elfData data));
extern elfData  AxArrayElement AXP_((elfData ap,int dex));
extern elfData  AxArrayFromArray AXP_((elfData ap,int dex));
extern int      AxArraySize AXP_ ((elfData arg));
extern char    *AxBinaryBytesPtr AXP_((elfData data));
extern int      AxBinaryFromArray AXP_((elfData data, dex, char **binP));
extern int      AxBinaryFromDataPtr AXP_((elfData data, char **binP));
extern int      AxBoolFromArray AXP_((elfData data));
extern int      AxBoolFromDataPtr AXP_((elfData aP));
extern elfData  AxBuildArray();
extern elfData  AxCopyData AXP_((elfData data));
extern void     AxDecomposeArray();
extern elfData  AxDispatch();
extern void     AxError AXP_((int *code, char **str, char **obj));
extern double   AxFloatFromArray AXP_((elfData aP,int dex));
extern double   AxFloatFromDataPtr AXP_((elfData ap));
extern void     AxFree AXP_((int size));
extern void     AxFreeData AXP_((elfData p));
extern int      AxIntFromArray AXP_((elfData aP,int dex));
extern int      AxIntFromDataPtr AXP_((elfData aP));
extern int      AxIsArray AXP_((elfData p));
extern elfData  AxMakeArray AXP_((int elements));
extern elfData  AxMakeBinaryData AXP_((int elements));
extern elfData  AxMakeFloatData AXP_((double val));
extern elfData  AxMakeIntData AXP_((int num));
extern elfData  AxMakeStrData AXP_((int len, char *str));
extern char    *AxMalloc AXP_((int size));
extern void     AxMallocAborter AXP_((jmp_buf abortBuf));
extern char    *AxStrFromArray AXP_((elfData ap,int dex));
extern char    *AxStrFromDataPtr AXP_((elfData ap));
extern char    *AxStrPtrFromArray AXP_((elfData ap,int dex));
extern char    *AxStrPtrFromDataPtr AXP_((elfData aP));

/*
The following function is not used in standard ELF->C RPC programs
and shared libraries but may be required in certain C->ELF programs and
non-standard ELF->C RPC programs.
*/
extern int      AxMemWrite AXP_((elfData data,int makeRoom,char **buf));

/* The following function is not for customer use */
extern elfData  AxMemRead AXP_((char*buf));

#endif

/*
The following functions are not used in standard ELF->C RPC programs
and shared libraries but may be required in certain C->ELF programs and
non-standard ELF->C RPC programs.
*/
extern int      AxOpenServer AXP_((char *sockname,int forkIt));
extern int      AxSockTop AXP_((int fd));
extern elfData  AxRPCRead AXP_((char *bufP));

extern void     AxClientDisConnect AXP_((int channel));
extern elfData  AxNetElfChannelCall AXP_((int channel,char *funcname,
						elfData args,int *code,char **str,char **obj));
extern int      AxNetElfServiceConnect AXP_((char *host,char *service,
						int *code,char **str,char **obj));

/* Not for customer use */
extern elfData  AxGetResponseFromServer();
extern elfData  AxNetCall AXP_((char *host, char *service, elfData args));
extern elfData  AxNetServices AXP_((char *hostName));

