/*caPut.c,v 1.1.1.1 1999/08/03 14:41:59 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*			ARRAY PUT				*/
/*								*/
/*	Check that the data type confirms with the way that	*/
/*	the channel was opened and that the counts are valid.	*/
/*	Then, package up the data and send it on.		*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#ifdef vxWorks
#include <vxWorks.h>
#endif vxWorks
#ifdef WIN32
#include <winsock.h>
extern int sendCAQ(short, char *, int);
#else
#include <types.h>
#include <in.h>
#endif WIN32

#if defined(AXP) || defined(vxWorks)
#include <string.h>
#endif

#include "agentMsgs.h"
#include "agentErrs.h"
#include "dataTypes.h"
#include "dbDefs.h"
#include "db_access.h"		/* Original EPICS source file */
#include "cadef.h"
#include "tisByteOrder.h"

#ifdef vxWorks
#include "dbCommon.h"
#include "localChannel.h"
#endif vxWorks

int ca_array_put(type, count, pChid, pValue)
int	type;
int	count;
chid	pChid;
void	*pValue;
{
    short	msgType;
    struct
	{
	CH_DIRPUT	dirPut;
	char		dataBuff[1024];
	} msg;

    if (!pChid)
	return (AGNT_BADCHID);
    if (count == 0)
	count = 1;
    if (count > pChid -> nativeCount)
	return (AGNT_BADCOUNT);
    if (!dbf_type_is_valid(type))
	return (AGNT_BADTYPE);
    if (pChid -> buildType == AGNT_NOCONN)
	pChid -> buildType = type;

    /*
    If we are in an IOC and can do the put locally,
    do it. Otherwise, go through the sockets to write.
    */

#ifdef vxWorks
    if (localDbPut(pChid -> pDbAddr, type, count, pValue))
	return (AGNT_NORMAL);
#endif

    msgType = htons(CHAN_DIRPUT);
    msg.dirPut.chHandle = pChid -> handle;
    if (type == AGNT_STRING)
	{
	msg.dirPut.chDataSize = strlen(pValue) + 1;
	strcpy(msg.dataBuff, pValue);
	}
    else
	{
	msg.dirPut.chDataSize = count * dbr_size[type];

	/*
	Convert the data. Be careful about using the ++
	operator inside the conversion functions because
	they may be tricky macros.
	*/

	if (type == AGNT_INT || type == AGNT_ENUM)
	    {
	    short	*host = (short *) pValue;
	    short	*net = (short *) msg.dataBuff;

	    while (count--)
		{
		*net++ = htons(*host);
		host++;
		}
	    }

	else if (type == AGNT_LONG)
	    {
	    long	*host = (long *) pValue;
	    long	*net = (long *) msg.dataBuff;

	    while (count--)
		{
		*net++ = htonl(*host);
		host++;
		}
	    }

	else if (type == AGNT_FLOAT)
	    {
	    float	*host = (float *) pValue;
	    float	*net = (float *) msg.dataBuff;

	    while (count--)
		{
		htonf(host, net);
		net++;
		host++;
		}
	    }

	else if (type == AGNT_DOUBLE)
	    {
	    double	*host = (double *) pValue;
	    double	*net = (double *) msg.dataBuff;

	    while (count--)
		{
		htond (host, net);
		net++;
		host++;
		}
	    }
	}

    msg.dirPut.chDataSize = htons(msg.dirPut.chDataSize);
    msg.dirPut.chDataType = htons(dbrXlate[type]);
    sendCAQ(msgType, (char *) &msg, sizeof(CH_DIRPUT) + ntohs(msg.dirPut.chDataSize));
    return (AGNT_NORMAL);
}
