/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*								*/
/*	SEND NOTIFICATION OF DATABASE MOD TO NAMESERVER		*/
/*								*/
/*	This routine sends notification of a modification	*/
/*	of modifications to the online database from any	*/
/*	program to nameSrv. This is important for ioclist	*/
/*	and reslist because they are read only once and		*/
/*	then cached. Pvmap is included so that the name		*/
/*	server can close and reopen the file so that indices	*/
/*	won't change shape underneath him. This is a problem	*/
/*	that has been observed in the field.			*/
/*								*/
/****************************************************************/

#include <types.h>
#include <socket.h>
#include <in.h>
#include <netdb.h>
#include <tcp.h>

#include <agentPorts.h>
#include <agentMsgs.h>

void dbFileModNotify(pvMap, resList, iocList)
int	pvMap;
int	resList;
int	iocList;
{
    struct hostent	*hostent;
    char		*buffer;
    int			bytesSent;
    int			totalBytes;
    int			true = 1;
    int			sockFd;
    static char	caHostName[] = "localhost";
    struct sockaddr_in	portAddr;
    struct
	{
	short		msgType;
	NS_FILE_MOD	modMsg;
	} fileMod;

    /*
    Create a socket and connect it to nameSrv.
    */

    sockFd = socket(PF_INET, SOCK_STREAM);
    setsockopt(sockFd, IPPROTO_TCP, TCP_NODELAY, &true, sizeof(true));
    setsockopt(sockFd, SOL_SOCKET, SO_LINGER, &true, sizeof(true));
    hostent = gethostbyname(caHostName);
    portAddr.sin_family = AF_INET;
    portAddr.sin_addr.s_addr = **((long **)(hostent -> h_addr_list));
    portAddr.sin_port = ntohs(NAM_PORT);
    if (connect(sockFd, &portAddr, sizeof(portAddr)) == -1)
	{
	close(sockFd);
	return;
	}

    /*
    Format the message and ship it to him.
    */

    fileMod.msgType = htons(NAME_FILEMOD);
    fileMod.modMsg.nsFileResList = resList;
    fileMod.modMsg.nsFileIocList = iocList;
    fileMod.modMsg.nsFilePvMap = pvMap;
    buffer = (char *) &fileMod;
    totalBytes = sizeof(fileMod);
    while (totalBytes)
	{
	bytesSent = send(sockFd, buffer, totalBytes, 0);
	if (bytesSent <= 0)
	    {
	    close(sockFd);
	    return;
	    }
	buffer += bytesSent;
	totalBytes -= bytesSent;
	}

    /*
    Now clean up the socket.
    */

    close(sockFd);
}
