/*sendCaq.c,v 1.1.1.1 1999/08/03 14:42:04 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*	SEND A MESSAGE TO CHANNEL ACQUISITION AND CONTROL	*/
/*								*/
/*	This routine buffers up messages as long as there is	*/
/*	room in the transmit buffer. When the user calls	*/
/*	any of the routines that cause a flush, then the buffer	*/
/*	will get transmitted.					*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#define FALSE	0
#ifdef vms
#include <selectvms.h>
#endif vms

#ifdef vxWorks
#include <vxWorks.h>
#endif vxWorks

#include <bcopy.h>
#include <errno.h>

#include "cadef.h"
#include "caContext.h"

#ifndef WIN32
extern int	errno;
#else
extern int ca_flush_io(void);
#endif


int sendCAQ(msgType, buff, nbytes)
short	msgType;
char	*buff;
int	nbytes;
{
    CATX	*ctx;

    ctx = getContext();
#ifdef vxWorks
    if (ctx -> importedContext)
	ctx = ctx -> importedContext;
#endif

    if (!(ctx -> caSocketFd))
	return (0);
#ifdef vxWorks
    semTake(ctx -> sockMeSem, WAIT_FOREVER);
#endif vxWorks
    if ((ctx -> caOutputQueued + sizeof(msgType) + nbytes) > sizeof(ctx -> caOutputBuff))
	ca_flush_io();
    bcopy((char *) &msgType, ctx -> caOutputBuff + ctx -> caOutputQueued, sizeof(msgType));
    ctx -> caOutputQueued += sizeof(msgType);
    if (nbytes)
	{
	bcopy(buff, ctx -> caOutputBuff + ctx -> caOutputQueued, nbytes);
	ctx -> caOutputQueued += nbytes;
	}
#ifdef vxWorks
   semGive(ctx -> sockMeSem);
#endif
   return (0);
}
