#ifndef vuarreducdialogclassHXX
#define	vuarreducdialogclassHXX

class vuArReducMethodsClass;
class vuArReducRatesClass;
class vuArReducValuesListClass;
class vuArReducFieldsListClass;
class vuArReducApplyButtonClass;
class vuArReducDismissButtonClass;
class vuArReducClearButtonClass;


//*** AR_REDUC DIALOG CLASS *********************************************

class	vuArReducDialogClass : public vdialog
{
    int			dialogModified;
    vuMainDialogClass	*mainDialog;
    vstr		*dialogTitle;
    vchar		pointName[PVNAME_SZ + 1];
    vresource		methodsRes;
    vresource		methodsAbrRes;
    vresource		rateStrRes;
    vresource		rateAbrRes;
    vresource		rateValRes;
    vstr		**methodStrs;
    vstr		**methodAbrStrs;
    vstr		**rateStrs;
    vstr		**rateAbrStrs;
    vstr		**rateValStrs;
    size_t		numMethodStrs;
    size_t		numMethodAbrStrs;
    size_t		numRateStrs;
    size_t		numRateAbrStrs;
    size_t		numRateValStrs;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuArReducDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuArReducDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void vuArReducOpen (vuMainDialogClass *mainDialog, 
			char *pointName,
			int   pointType);	

    // function to locate pvname/method in ar_reduc
    DB_RECORD_PTR findRecord (char *pvname, char *method, char *field);

    // function to append to the valuesList
    void appendToValuesList (vchar *field, vchar *rate, vchar *method);

    // mics functions
    void updateTrendEnable (char *trendValue);

    // function to update an ar_reduc record
    void updateRecord (DB_RECORD_PTR rec, char *pvname, char *fldName, 
		       char *rate, char *method, char *archive);

    // function to update existing record in the valuesList
    void updateValuesList (vchar *field, vchar *rate, vchar *method);

    // functions to handle dialogModified
    int getDialogModify (void) { return (dialogModified); }
    void setDialogModify (int val) { dialogModified = val; }

    // function to handle mainDialog
    void storeMainDialog (vuMainDialogClass *cd)
	{ mainDialog = cd; }
    vuMainDialogClass *getMainDialog (void) 
	{ return (mainDialog); }

    // function to handle pointName
    vchar *getPointName (void)
	{ return (pointName); }

    // function to handle resources
    vresource getMethodsRes (void)	{ return (methodsRes); }
    vresource getMethodsAbrRes (void)	{ return (methodsAbrRes); }
    vresource getRateStrRes (void)	{ return (rateStrRes); }
    vresource getRateAbrRes (void)	{ return (rateAbrRes); }
    vresource getRateValRes (void)	{ return (rateValRes); }

    // functions to hand the resource strings
    vstr **getMethodStrs (void)		{ return (methodStrs); }
    vstr **getMethodAbrStrs (void)	{ return (methodAbrStrs); }
    vstr **getRateStrs (void)		{ return (rateStrs); }
    vstr **getRateAbrStrs (void)	{ return (rateAbrStrs); }
    vstr **getRateValStrs (void)	{ return (rateValStrs); }

    int getNumMethodStrs (void)		{ return (numMethodStrs); }
    int getNumMethodAbrStrs (void)	{ return (numMethodAbrStrs); }
    int getNumRateStrs (void)		{ return (numRateStrs); }
    int getNumRateAbrStrs (void)	{ return (numRateAbrStrs); }
    int getNumRateValStrs (void)	{ return (numRateValStrs); }

    // public so don't need funcs to get at

    vuArReducMethodsClass	*method;
    vuArReducRatesClass		*rate;
    checkBoxClass		*archive;
    vuArReducValuesListClass	*valuesList;
    vuArReducFieldsListClass	*fieldsList;
    vuArReducApplyButtonClass	*applyButton;
    vuArReducDismissButtonClass	*dismissButton;
    vuArReducClearButtonClass	*clearButton;

    // table map fields
    DB_FIELD_PTR	arRedChan;
    DB_FIELD_PTR	arRedRate;
    DB_FIELD_PTR	arRedMethod;
    DB_FIELD_PTR	arRedArchive;
    DB_FIELD_PTR	pvmapTrend;

};


//*** AR_REDUC METHODS CLASS *******************************************

class	vuArReducMethodsClass : public optionMenuClass
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuArReducMethodsClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuArReducMethodsClass, optionMenuClass);

    // function to build the values list
    void buildMenu (void);

};


//*** AR_REDUC RATES CLASS *******************************************

class	vuArReducRatesClass : public optionMenuClass
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuArReducRatesClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuArReducRatesClass, optionMenuClass);

    // function to build the values list
    void buildMenu (void);

};


//*** AR_REDUC VALUES LIST CLASS ***************************************

class	vuArReducValuesListClass : public vlistview
{

    vuArReducDialogClass	*arReducDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuArReducValuesListClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuArReducValuesListClass, vlistview);

    // virtual member function override
    void ObserveSelect (int state);

    // function to handle arReducDialog
    void storeArReducDialog (vuArReducDialogClass *cd)
	{ arReducDialog = cd; }

    // function to build the values list
    void buildValuesList (void);

};


//*** AR_REDUC FIELDS LIST CLASS ***************************************

class	vuArReducFieldsListClass : public vlistview
{

    vuArReducDialogClass	*arReducDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuArReducFieldsListClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuArReducFieldsListClass, vlistview);

    // function to handle arReducDialog
    void storeArReducDialog (vuArReducDialogClass *cd)
	{ arReducDialog = cd; }

    // function to build the fields list
    int buildFieldsList (int pttype);

};


//*** AR_REDUC APPLY BUTTON CLASS ***************************************

class	vuArReducApplyButtonClass : public vbutton
{

    vuArReducDialogClass	*arReducDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuArReducApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuArReducApplyButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeArReducDialog (vuArReducDialogClass *cd)
	{ arReducDialog = cd; }
};


//*** AR_REDUC DISMISS BUTTON CLASS ***************************************

class	vuArReducDismissButtonClass : public vbutton
{

    vuArReducDialogClass	*arReducDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuArReducDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuArReducDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeArReducDialog (vuArReducDialogClass *cd)
	{ arReducDialog = cd; }
};


//*** AR_REDUC CLEAR BUTTON CLASS ***************************************

class	vuArReducClearButtonClass : public vbutton
{

    vuArReducDialogClass	*arReducDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuArReducClearButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuArReducClearButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeArReducDialog (vuArReducDialogClass *cd)
	{ arReducDialog = cd; }
};


//*** TREND EDIT DIALOG CLASS *******************************************

class	vuTrendEditOkButtonClass;
class	vuTrendEditCancelButtonClass;

class vuTrendEditDialogClass : public vdialog
{
    vchar		pvName [PVNAME_SZ + 1];
    vuMainDialogClass	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuTrendEditDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuTrendEditDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    void vuTrendEditOpen (vuMainDialogClass *mainDialog);

    // public so dont need funcs to get at

    filteredTextitem		 *pointName;
    vuTrendEditOkButtonClass	 *okButton;
    vuTrendEditCancelButtonClass *cancelButton;

    // function to get pvName
    vchar *getPvName (void)
	{ return (pvName); }

    // function to get mainDialog
    vuMainDialogClass *getMainDialog (void)
	{ return (mainDialog); }
};


//*** TREND EDIT OK BUTTON CLASS ************************************

class	vuTrendEditOkButtonClass : public vbutton
{

    vuTrendEditDialogClass	*trendEditDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuTrendEditOkButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuTrendEditOkButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle trendEditDialog
    void storeTrendEditDialog (vuTrendEditDialogClass *cd)
	{ trendEditDialog = cd; }
};


//*** TREND EDIT CANCEL BUTTON CLASS *******************************

class	vuTrendEditCancelButtonClass : public vbutton
{

    vuTrendEditDialogClass	*trendEditDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuTrendEditCancelButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuTrendEditCancelButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle trendEditDialog
    void storeTrendEditDialog (vuTrendEditDialogClass *cd)
	{ trendEditDialog = cd; }
};

#endif	vuarreducdialogclassHXX
