#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vtextitemHEADER
#include vstartupHEADER
#include vcontainerHEADER
#include vcontrolHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vnumHEADER
#include vstringHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "choice.h"
#include "choiceGbl.h"
#include "dbFldTypes.h"
#include "dbDefs.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vunetwork.hxx"

#include "vuAccDialogClass.hxx"
#include "vuAiDialogClass.hxx"
#include "vuAoDialogClass.hxx"
#include "vuBiDialogClass.hxx"
#include "vuBoDialogClass.hxx"
#include "vuCalcDialogClass.hxx"
#include "vuDatamoveDialogClass.hxx"
#include "vuDdcDialogClass.hxx"
#include "vuDeadtimeDialogClass.hxx"
#include "vuFanoutDialogClass.hxx"
#include "vuLdfwDialogClass.hxx"
#include "vuLeadLagDialogClass.hxx"
#include "vuMbbiDialogClass.hxx"
#include "vuMbboDialogClass.hxx"
#include "vuPatDialogClass.hxx"
#include "vuPidDialogClass.hxx"
#include "vuPipeDialogClass.hxx"
#include "vuPotDialogClass.hxx"
#include "vuPtoDialogClass.hxx"
#include "vuPumpDialogClass.hxx"
#include "vuRampDialogClass.hxx"
#include "vuSelDialogClass.hxx"
#include "vuSigDialogClass.hxx"
#include "vuStateDialogClass.hxx"
#include "vuStringinDialogClass.hxx"
#include "vuStringoutDialogClass.hxx"
#include "vuTankDialogClass.hxx"
#include "vuTdDialogClass.hxx"
#include "vuUdbDialogClass.hxx"
#include "vuValveDialogClass.hxx"
#include "vuWaveformDialogClass.hxx"

#include "vuAlarmInfoDialogClass.hxx"
#include "vuArReducDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuCommonDialogClass, vdialog, "vuCommonDialogClass");

/*******************************************************************
*
*    vuCommonDialogClass override for constructors init ()
*	res is resource to vuCommonDialog
*
*******************************************************************/

void vuCommonDialogClass::LoadInit (vresource res)
{
    dialogModified = vFALSE;

    dbValue = NULL;
    dbValue = vmemAllocAndClear (VU_KEY_SIZE + 1);
    pvname = vuPvNameFilteredTextitem::RequestSubLoad (this, 
				vunames_NAME);

    vcontainer *desccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCommonDESCContainer);
    descriptor = filteredTextitem::RequestSubLoad (desccontainer,
				vunames_DESC);

    vcontainer *loccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCommonLOCContainer);
    location = filteredTextitem::RequestSubLoad (loccontainer,
				vunames_LOC);

    vcontainer *protcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCommonPRIVContainer);
    protectionGroup = filteredTextitem::RequestSubLoad (protcontainer,
				vunames_PRIV);

    vcontainer *phasecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCommonPHASContainer);
    phase = filteredTextitem::RequestSubLoad (phasecontainer,
				vunames_PHAS);

    vcontainer *eventcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCommonEVNTContainer);
    event = filteredTextitem::RequestSubLoad (eventcontainer,
				vunames_EVNT);

    vcontainer *rescontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCommonRESNContainer);
    resourceName = vuCommonResourceClass::RequestSubLoad (rescontainer,
				vunames_RESN);

    vcontainer *scancontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCommonSCANContainer);
    scanType = vuCommonScanTypeClass::RequestSubLoad (scancontainer,
				vunames_SCAN);

    vcontainer *linkcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCommonFLNKContainer);
    forwardLinkButton = vuPvNameButtonClass::RequestSubLoad (linkcontainer,
				vunames_vuCommonFLNKButton);
    forwardLink = vuFilteredTextitem::RequestSubLoad (linkcontainer,
				vunames_FLNK);

    vcontainer *scandiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCommonSDISContainer);
    scanDisableButton = vuPvNameButtonClass::RequestSubLoad (scandiscontainer,
				vunames_vuCommonSDISButton);
    scanDisable = vuFilteredTextitem::RequestSubLoad (scandiscontainer,
				vunames_SDIS);

    vcontainer *disvalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCommonDISVContainer);
    disableValue = filteredTextitem::RequestSubLoad (disvalcontainer,
				vunames_DISV);

    applyButton = vuCommonApplyButtonClass::RequestSubLoad (this,
				vunames_vuCommonApplyButton);

    dismissButton = vuCommonDismissButtonClass::RequestSubLoad (this,
				vunames_vuCommonDismissButton);

    deleteButton = vuCommonDeleteButtonClass::RequestSubLoad (this,
				vunames_vuCommonDeleteButton);

    gotoButton = vuCommonGoToButtonClass::RequestSubLoad (this,
				vunames_vuCommonGoToButton);

    nextButton = vuCommonNextButtonClass::RequestSubLoad (this,
				vunames_vuCommonNextButton);

    previousButton = vuCommonPreviousButtonClass::RequestSubLoad (this,
				vunames_vuCommonPrevButton);

    trendButton = vuCommonTrendButtonClass::RequestSubLoad (this,
				vunames_vuCommonTrendButton);

    alarmInfoButton = vuCommonAlarmInfoButtonClass::RequestSubLoad (this,
				vunames_vuCommonAlarmInfoButton);

    vdialog::LoadInit (res);

    forwardLinkButton -> storePvName (forwardLink);
    forwardLinkButton -> storeCommonDialog (this);
    forwardLink -> storeCommonDialog (this);
    scanDisableButton -> storePvName (scanDisable);
    scanDisableButton -> storeCommonDialog (this);
    scanDisable -> storeCommonDialog (this);

    pvname -> SetItemFilterFunc (pvnameFilter);
    pvname -> SetTextModifiedPtr (&this -> dialogModified);
    descriptor -> SetItemFilterFunc (descriptorFilter);
    descriptor -> SetTextModifiedPtr (&this -> dialogModified);
    location -> SetItemFilterFunc (locationFilter);
    location -> SetTextModifiedPtr (&this -> dialogModified);

    protectionGroup -> SetItemFilterFunc (vuProtectionGroupFilter);
    filteredText *pgText = (filteredText *)protectionGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pgText -> SetUserPtr ((void *)protectionGroup);
    protectionGroup -> SetTextModifiedPtr (&this -> dialogModified);

    phase -> SetItemFilterFunc (numericFilter);
    phase -> SetTextModifiedPtr (&this -> dialogModified);
    event -> SetItemFilterFunc (numericFilter);
    event -> SetTextModifiedPtr (&this -> dialogModified);

    forwardLink -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *fwText = (filteredText *)forwardLink -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    fwText -> SetUserPtr ((void *)forwardLink);
    forwardLink -> SetTextModifiedPtr (&this -> dialogModified);

    scanDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *sdText = (filteredText *)scanDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    sdText -> SetUserPtr ((void *)scanDisable);
    scanDisable -> SetTextModifiedPtr (&this -> dialogModified);

    disableValue -> SetItemFilterFunc (numericFilter);
    disableValue -> SetTextModifiedPtr (&this -> dialogModified);

    scanType -> storeCommonDialog (this);
    scanType -> buildScanTypeMenu ();
    resourceName -> storeCommonDialog (this);
    applyButton -> storeCommonDialog (this);
    dismissButton -> storeCommonDialog (this);
    deleteButton -> storeCommonDialog (this);
    gotoButton -> storeCommonDialog (this);
    nextButton -> storeCommonDialog (this);
    previousButton -> storeCommonDialog (this);
    trendButton -> storeCommonDialog (this);
    alarmInfoButton -> storeCommonDialog (this);
    //
    // handle readonly state or lack of privilege to create a new point
    // for the apply and delete buttons
    //
    if( (vuReadOnly == vTRUE) || 
	(vuUpdatePointPriv == vFALSE) || 
	(vuDeletePointPriv == vFALSE) )
    {
	applyButton -> Disable ();
	deleteButton -> Disable ();
    }

    Place (GetRoot (), vrectPLACE_CENTER, vrectPLACE_CENTER);
}


/*******************************************************************
*
*    vuCommonDialogClass Destroy function
*
*******************************************************************/

void vuCommonDialogClass::Destroy (void)
{
    if (dbValue != NULL)
	vmemFree (dbValue);
    vdialog::Destroy ();
}


/*******************************************************************
*
*    vuCommonDialogClass notify function
*	NOTE: I use evnt instead of event, because event is the
*		name of the event field in the common dialog, 
*		otherwise the compiler moans that event hides 
*		vuCommonDialogClass event
*
*******************************************************************/

void vuCommonDialogClass::ObserveWindow (vevent *evnt)
{
    if ( evnt -> GetType () == veventWINDOW_STATE && evnt -> IsClose ())
    {
	Close ();
    }
}


/*******************************************************************
*
*    vuCommonDialogClass to read the scan type string from
*	the option menu and convert it to database format
*
*******************************************************************/

void vuCommonDialogClass::vuGetScanType (DB_TABLE_PTR table, 
					 DB_RECORD_PTR rec,
					 const vchar *optionMenuValue,
					 char *dbvalue)
{
    DB_FIELD_PTR	rateField;
    double		rate;

    rateField = DB_MapField (table, FLD_SCANRATE);

    if ( (vcharCompare (optionMenuValue, "100 ms")) == 0)
    {
	rate = 0.1;
	DB_PutFieldValue (rec, rateField, (void *)(&rate));
	strcpy (dbvalue, "Periodic");
    }
    else if ( (vcharCompare (optionMenuValue, "200 ms")) == 0)
    {
	rate = 0.2;
	DB_PutFieldValue (rec, rateField, (void *)(&rate));
	strcpy (dbvalue, "Periodic");
    }
    else if ( (vcharCompare (optionMenuValue, "500 ms")) == 0)
    {
	rate = 0.5;
	DB_PutFieldValue (rec, rateField, (void *)(&rate));
	strcpy (dbvalue, "Periodic");
    }
    else if ( ( (vcharCompare (optionMenuValue, "1 second")) == 0) ||
	      ( (vcharCompare (optionMenuValue, "2 second")) == 0) ||
	      ( (vcharCompare (optionMenuValue, "5 second")) == 0) ||
	      ( (vcharCompare (optionMenuValue, "10 second")) == 0) ||
	      ( (vcharCompare (optionMenuValue, "15 second")) == 0) ||
	      ( (vcharCompare (optionMenuValue, "30 second")) == 0) ||
	      ( (vcharCompare (optionMenuValue, "60 second")) == 0) )
    {
	vcharExport (vcharScribeSystemExport (optionMenuValue), (void *)dbvalue);
	sscanf (dbvalue, "%lf", &rate);
	DB_PutFieldValue (rec, rateField, (void *)(&rate));
	strcpy (dbvalue, "Periodic");
    }
}


/**********************************************************************
*
*    vuCommonDialogClass, reset fields, 
*	traverse the dictionary and look for textitems, vcontrolToggle,
*	and vcontrolOptionMenus
*
**********************************************************************/

void vuCommonDialogClass::resetDialog (void)
{
    dataVuApplication	*app  = mainDialogClass -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vTRUE)
	{
	    dialogItem = vuFindDialogItem (this, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the disable value field
		if ( (vcharCompareBounded (epics, "DISV", FLDNAME_SZ)) == 0)
		{
		    vresource defRes = mainDialogClass -> getDefaultsResource ();
		    vstr *disv = vresourceGetString (defRes, 
						vunames_vuDISVdefault);
		    textItem -> SetText (disv);
		    vstrDestroy (disv);
		}
		// set the default value for the protection group field
		else if ( (vcharCompareBounded (epics, "PRIV", FLDNAME_SZ)) == 0)
		{
		    vresource defRes = mainDialogClass -> getDefaultsResource ();
		    vstr *disv = vresourceGetString (defRes, 
						vunames_vuPRIVdefault);
		    textItem -> SetText (disv);
		    vstrDestroy (disv);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	}  // end if in commondialog
    }
    iterator.Finish ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuCommonDialogClass load dialog fields function
*
*******************************************************************/

void vuCommonDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;

    char		pvName [PVNAME_SZ + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);
    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vTRUE)
	{
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
	    {
		sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
	    }
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindDialogItem (this, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    if ( (strncmp (xrefNode -> xrefEpicsName, "SCAN", FLDNAME_SZ)) == 0)
		    {
			vuSetScanType (xrefNode -> xrefTable, pntRecord, (char*)dbValue);
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		case DBF_OUTLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_FWDLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	}  // end if in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuCommonDialogClass to create the scan type string
*
*******************************************************************/

void vuCommonDialogClass::vuSetScanType (DB_TABLE_PTR table, 
					 DB_RECORD_PTR rec, 
					 char *dbvalue)
{
    DB_FIELD_PTR	rateField;
    double		rate;
    int			type;

    rateField = DB_MapField (table, FLD_SCANRATE);

    if ( (strcmp (dbvalue, "Periodic")) == 0)
    {
	DB_GetFieldValue (rec, rateField, &rate, &type);
	if (rate > 5.0)
	    sprintf (dbvalue, "%2.0f second\0", rate);
	else if (rate > 0.9)
	    sprintf (dbvalue, "%1.0f second\0", rate);
	else if (rate < 0.15)
	    strcpy (dbvalue, "100 ms");
	else if (rate < 0.25)
	    strcpy (dbvalue, "200 ms");
	else
	    strcpy (dbvalue, "500 ms");
    }
}


/*******************************************************************
*
*    vuCommonDialogClass save to database dialog fields function
*
*******************************************************************/

void vuCommonDialogClass::vuSaveDialog (vchar *pointName)
{
    dataVuApplication	*app  = mainDialogClass -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;
    const vchar		*optionMenuValue;

    char		pvName [PVNAME_SZ + 1];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			doSave;
    double		doubleValue;
    VERIFY_INFO		verifyInfo;	// def'd in DBCVerifyDefs.h
    IMPORT_INFO		importInfo;	// def'd in DBCVerifyDefs.h

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();

	// NAME field done in vuDatabaseClass::vuCreateNewRecords ()
	if ( (strncmp (xrefNode -> xrefEpicsName, FLD_NAME, FLDNAME_SZ)) == 0)
	    continue;

	if ( (xrefNode -> getInCommonDialog ()) == vTRUE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
	    {
		sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindDialogItem (this, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    if ( (strncmp (xrefNode -> xrefEpicsName, "RESN", FLDNAME_SZ)) == 0)
		    {
			optionMenu = (vcontrolOptionMenu *)dialogItem;
			optionMenuValue = vuGetOptionMenuValue (optionMenu);
			vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    }
		    else
		    {
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
			vcharExport (vcharScribeSystemExport (stringValue), dbValue);
			vstrDestroy (stringValue);
		    }
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    if ( (strncmp (xrefNode -> xrefEpicsName, "SCAN", FLDNAME_SZ)) == 0)
		    {
			vuGetScanType (xrefNode -> xrefTable, pntRecord, 
				       optionMenuValue, (char *)dbValue);
		    }
		    break;

		case DBF_INLINK:
		case DBF_OUTLINK:
		case DBF_FWDLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType 

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if in commondialog

    }  // end while iterator

    iterator.Finish ();

    memset ((char *)&verifyInfo, 0, VERIFY_INFO_SIZE);
    memset ((char *)&importInfo, 0, IMPORT_INFO_SIZE);
    verifyInfo.viTimeStamp = vuSynchTime ();
    DB_PutVerifyInfo (db -> vuPvmapTable, pvName, &verifyInfo, &importInfo);
    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuCommonDialogClass, reset the pvname field and set dialog
*	focus on this field
*
*******************************************************************/

void vuCommonDialogClass::vuClearPvNameField (void)
{
    pvname -> SetTextScribed (vcharScribeSystem (""));
    SetFocusItem (pvname);
}


vkindTYPED_FULL_DEFINITION(vuCommonScanTypeClass, vcontrolOptionMenu, 
			   "vuCommonScanTypeClass");
/*******************************************************************
*
*    ObserverDialogItem override function for vuCommonScanType class
*
*******************************************************************/
void vuCommonScanTypeClass::ObserveDialogItem (vevent *event)
{
    // get pointer to menu attached to the control
    vmenu *menu = this -> GetMenu ();

    // get current value of control
    int controlValue = this -> GetValue ();

    if ( (controlValue >= this -> GetMin ()) &&
	 (controlValue <= this -> GetMax ()) )
    {
	vuCommonDialogClass *vuCommonDialog = getCommonDialog ();
	vuCommonDialog -> setDialogModify (vTRUE);
    }
}


/*******************************************************************
*
*    buildScanTypeMenu ()
*	build a popup menu and attach it to a vcontrol object
*	NOTE: the menu attribute for scan class is destroyed when
*		it is changed, so vmenuDestroy is not needed
*
*******************************************************************/

void vuCommonScanTypeClass::buildScanTypeMenu (void)
{
    int			i;
    long		numRates;
    char		**scanChoices;
    vmenuItem		*menuItem;

    // get the scan rate choice list from the SDR
    // see ../epicsH/<choice.h, choiceGbl.h>

    numRates = choiceGbl -> papChoiceSet[GBL_SCAN] -> number;
    scanChoices = choiceGbl ->papChoiceSet[GBL_SCAN] -> papChoice;

    /* create a new menu to attach to the vcontrol item, we are 
       creating a popup menu within a dialog
    */
    vmenu *newMenu = new vmenu;

    for (i = 0; i < numRates; i++)
    {
	menuItem = new vmenuItem;
	menuItem -> SetTitleScribed (vcharScribeSystem ((void *)scanChoices[i]));
	newMenu -> AppendItem (menuItem);
    }

    // attach the menu to the control
    SetMenu (newMenu);
    // set min and max for the control
    SetMin (0);
    SetMax (numRates - 1);
    // set value so current menu item will be the 1st one
    SetValue (0);
}


vkindTYPED_FULL_DEFINITION(vuCommonResourceClass, vcontrolOptionMenu, 
			   "vuCommonResourceClass");
/*******************************************************************
*
*    ObserverDialogItem override function for vuCommonResourceClass 
*	class
*
*******************************************************************/
void vuCommonResourceClass::ObserveDialogItem (vevent *event)
{
    // get pointer to menu attached to the control
    vmenu *menu = this -> GetMenu ();

    // get current value of control
    int controlValue = this -> GetValue ();

    if ( (controlValue >= this -> GetMin ()) &&
	 (controlValue <= this -> GetMax ()) )
    {
	vuCommonDialogClass *vuCommonDialog = getCommonDialog ();
	vuCommonDialog -> setDialogModify (vTRUE);
    }
}


/*******************************************************************
*
*    buildResourceMenu ()
*	build a popup menu and attach it to a vcontrol object
*	NOTE: created after the mainDialog ptr is stored, since 
*	      it can be used to get at the vuDatabaseClass ptr
*	NOTE: the menu attribute for resource class is destroyed when
*		it is changed, so vmenuDestroy is not needed
*
*******************************************************************/

void vuCommonResourceClass::vuBuildResourceMenu (void)
{
    vuMainDialogClass	*mainDialog = commonDialog -> getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vresource		defRes = mainDialog -> getDefaultsResource ();
    vmenuItem		*menuItem;
    vliststr		*resList;
    int			resNames = 0;

    resList = vuGetResList (db, VU_NO_DPAS);
    
    vmenu *newMenu = new vmenu;

    // add the default resouce name to the head of the list
    vstr *defres = vresourceGetString (defRes, vunames_vuRESNdefault);
    menuItem = new vmenuItem;
    menuItem -> SetTitle (defres);
    newMenu ->AppendItem (menuItem);
    resNames++;
    vstrDestroy (defres);

    vlistIterator iterator;
    iterator.Start (resList);
    while (iterator.Next())
    {
	vchar *listValue = (vchar *)(iterator.GetValue());
	menuItem = new vmenuItem;
	menuItem -> SetTitle (listValue);
	newMenu -> AppendItem (menuItem);
	resNames++;
    }
    iterator.Finish ();
    resList -> Destroy ();
    // attach menu to option control
    SetMenu (newMenu);
    // set min and max
    SetMin (0);
    SetMax (resNames - 1);
    // set value so menu item 0 will show
    SetValue (0);
}


// *** SUBCLASSED filteredTextitem, override of its ObserveView to catch loss of focus *********

vkindTYPED_FULL_DEFINITION(vuPvNameFilteredTextitem, filteredTextitem, "vuPvNameFilteredTextitem");

void vuPvNameFilteredTextitem::ObserveView (vevent *event, int message)
{
    if (message == vtextviewACCEPT_NOTIFY)
    {
	vdialogItemList	*list = this -> GetItemListIn ();
	vobjectAttributed *obj = list -> GetFocusItem ();
	if ( ((vobjectAttributed *)this) != obj)
	{
	    vdialogItemList *list = GetItemListIn ();
	    if (list != NULL)
	    {
		vdialog *dialog = list -> DetermineDialog ();
		if (dialog != NULL)
		{
		    vchar pvname [PVNAME_SZ + 1];
		    GetText (pvname, PVNAME_SZ);
		    if (pvname[0] != 0)
		    {
			char *pv = (char *)vcharExportAlloc(vcharScribeSystemExport(pvname));
			vuCommonDialogClass *commonDialog = (vuCommonDialogClass *)dialog;
			vuMainDialogClass *mainDialog = commonDialog -> getMainDialog();
			dataVuApplication *app = mainDialog -> getApplication();
			vuDatabaseClass	*db = app -> getDatabaseClass();
			int pointTypeIndex = commonDialog -> getPointType();
			//if(db->vuVerifyDb(pv,pointTypeIndex) == 0)
			//{
			//    vcharExportFree((void *)pv);
			//    return;
			//}
			vcharExportFree((void *)pv);
			switch (pointTypeIndex)
			{
			    case VU_AI:
			    {
				vuAiDialogClass *aiDialog = (vuAiDialogClass *)dialog;
				aiDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_AO:
			    {
				vuAoDialogClass *aoDialog = (vuAoDialogClass *)dialog;
				aoDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_BI:
			    {
				vuBiDialogClass *biDialog = (vuBiDialogClass *)dialog;
				biDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_BO:
			    {
				vuBoDialogClass *boDialog = (vuBoDialogClass *)dialog;
				boDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_CALC:
			    {
				vuCalcDialogClass *calcDialog = 
							(vuCalcDialogClass *)dialog;
				calcDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_FANOUT:
			    {
				vuFanoutDialogClass *fanoutDialog = 
							(vuFanoutDialogClass *)dialog;
				fanoutDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_MBBI:
			    {
				vuMbbiDialogClass *mbbiDialog = 
							(vuMbbiDialogClass *)dialog;
				mbbiDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_MBBO:
			    {
				vuMbboDialogClass *mbboDialog = 
							(vuMbboDialogClass *)dialog;
				mbboDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_PID:
			    {
				vuPidDialogClass *pidDialog = 
							(vuPidDialogClass *)dialog;
				pidDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_SEL:
			    {
				vuSelDialogClass *selDialog = 
							(vuSelDialogClass *)dialog;
				selDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_STATE:
			    {
				vuStateDialogClass *stateDialog = 
							(vuStateDialogClass *)dialog;
				stateDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_STRINGIN:
			    {
				vuStringinDialogClass *stringinDialog = 
							(vuStringinDialogClass *)dialog;
				stringinDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_STRINGOUT:
			    {
				vuStringoutDialogClass *stringoutDialog = 
							(vuStringoutDialogClass *)dialog;
				stringoutDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_WAVEFORM:
			    {
				vuWaveformDialogClass *waveformDialog = 
							(vuWaveformDialogClass *)dialog;
				waveformDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_LEADLAG:
			    {
				vuLeadLagDialogClass *leadlagDialog = 
							(vuLeadLagDialogClass *)dialog;
				leadlagDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_RAMP:
			    {
				vuRampDialogClass *rampDialog = (vuRampDialogClass *)dialog;
				rampDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_PIPE:
			    {
				vuPipeDialogClass *pipeDialog = (vuPipeDialogClass *)dialog;
				pipeDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_TANK:
			    {
				vuTankDialogClass *tankDialog = (vuTankDialogClass *)dialog;
				tankDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_VALVE:
			    {
				vuValveDialogClass *valveDialog = 
							(vuValveDialogClass *)dialog;
				valveDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_PUMP:
			    {
				vuPumpDialogClass *pumpDialog = (vuPumpDialogClass *)dialog;
				pumpDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_POT:
			    {
				vuPotDialogClass *potDialog = (vuPotDialogClass *)dialog;
				potDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_ACCUM:
			    {
				vuAccDialogClass *accDialog = (vuAccDialogClass *)dialog;
				accDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_PTO:
			    {
				vuPtoDialogClass *ptoDialog = (vuPtoDialogClass *)dialog;
				ptoDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_DEADTIME:
			    {
				vuDeadtimeDialogClass *deadtimeDialog = 
							(vuDeadtimeDialogClass *)dialog;
				deadtimeDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_DATAMOVE:
			    {
				vuDatamoveDialogClass *datamoveDialog = 
							(vuDatamoveDialogClass *)dialog;
				datamoveDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_TD:
			    {
				vuTdDialogClass *tdDialog = (vuTdDialogClass *)dialog;
				tdDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_SIGCHAR:
			    {
				vuSigDialogClass *sigDialog = (vuSigDialogClass *)dialog;
				sigDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_UDB:
			    {
				vuUdbDialogClass *udbDialog = (vuUdbDialogClass *)dialog;
				int modified = udbDialog -> vuUdbGetLabelsFlag ();
				// if labels have been modifed reset for new point
				if (modified == vTRUE)
				{
				    udbDialog -> resetDialog ();
				}
				udbDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_PAT:
			    {
				vuPatDialogClass *patDialog = (vuPatDialogClass *)dialog;
				patDialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_LDFW1:
			    {
				vuLdfw1DialogClass *ldfw1Dialog = (vuLdfw1DialogClass *)dialog;
				ldfw1Dialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_LDFW2:
			    {
				vuLdfw2DialogClass *ldfw2Dialog = (vuLdfw2DialogClass *)dialog;
				ldfw2Dialog -> vuLoadDialog (pvname);
				break;
			    }

			    case VU_DDC:
			    {
				vuDdcDialogClass *ddcDialog = (vuDdcDialogClass *)dialog;
				ddcDialog -> vuLoadDialog (pvname);
				break;
			    }

			}
		    }
		}
	    }
	}
    }
}


// *** COMMON DIALOG BUTTON CLASS OVERIRDES ********************************************

vkindTYPED_FULL_DEFINITION(vuCommonApplyButtonClass, vbutton, "vuCommonApplyButtonClass");
vkindTYPED_FULL_DEFINITION(vuCommonDismissButtonClass, vbutton, "vuCommonDismissButtonClass");
vkindTYPED_FULL_DEFINITION(vuCommonDeleteButtonClass, vbutton, "vuCommonDeleteButtonClass");
vkindTYPED_FULL_DEFINITION(vuCommonGoToButtonClass, vbutton, "vuCommonGoToButtonClass");
vkindTYPED_FULL_DEFINITION(vuCommonNextButtonClass, vbutton, "vuCommonNextButtonClass");
vkindTYPED_FULL_DEFINITION(vuCommonPreviousButtonClass, vbutton, "vuCommonPreviousButtonClass");
vkindTYPED_FULL_DEFINITION(vuCommonTrendButtonClass, vbutton, "vuCommonTrendButtonClass");
vkindTYPED_FULL_DEFINITION(vuCommonAlarmInfoButtonClass, vbutton, "vuCommonAlarmInfoButtonClass");

void vuCommonApplyButtonClass::ObserveDialogItem (vevent *event)
{
    vuCommonDialogClass *commonDlg;
    vuMainDialogClass	*mainDialog;
    dataVuApplication	*app;
    vuDatabaseClass	*db;
    vuPvNameFilteredTextitem	*pvNameTextItem;
    vchar		pvname [PVNAME_SZ + 1];
    int			pointType;
    int			result;
    int			isNew = vFALSE;
    char		nameInFile [PVNAME_SZ + 1];
    char		pvName [PVNAME_SZ + 1];
    DB_RECORD_PTR	rec;

    vdialogItemList *list = GetItemListIn ();
    if (list != NULL)
    {
	vdialog *dialog = list -> DetermineDialog ();
	if (dialog != NULL)
	{
	    commonDlg = (vuCommonDialogClass *)dialog;
	    pvNameTextItem = commonDlg -> getPvNameField ();
	    pvNameTextItem -> GetText (pvname, PVNAME_SZ);
	    if (pvname[0] != 0)
	    {
		mainDialog = commonDlg -> getMainDialog ();
		app  = mainDialog -> getApplication ();
		db   = app -> getDatabaseClass ();
		pointType = commonDlg -> getPointType ();
		vcharExportBounded (vcharScribeSystemExport (pvname),
				    pvName,
				    PVNAME_SZ);
		sprintf (nameInFile, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		if ( (rec = DB_Seek (db -> vuPvmapTable, nameInFile)) == 0)
		{
		    if ( (result = db -> vuCreateNewRecords (pointType, pvname)) != VU_SUCCESS)
			return;
		    isNew = vTRUE;
		}
		else
		{
		    mainDialog -> vuMainMessageCenter (vunames_vuApplyPointChangesMsg, pvname);
		}
		switch (pointType)
		{
		    case VU_AI:
		    {
			vuAiDialogClass *aiDialog = (vuAiDialogClass *)dialog;
			aiDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_AO:
		    {
			vuAoDialogClass *aoDialog = (vuAoDialogClass *)dialog;
			aoDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_BI:
		    {
			vuBiDialogClass *biDialog = (vuBiDialogClass *)dialog;
			biDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_BO:
		    {
			vuBoDialogClass *boDialog = (vuBoDialogClass *)dialog;
			boDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_CALC:
		    {
			vuCalcDialogClass *calcDialog = (vuCalcDialogClass *)dialog;
			calcDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_FANOUT:
		    {
			vuFanoutDialogClass *fanoutDialog = 
						(vuFanoutDialogClass *)dialog;
			fanoutDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_MBBI:
		    {
			vuMbbiDialogClass *mbbiDialog = (vuMbbiDialogClass *)dialog;
			mbbiDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_MBBO:
		    {
			vuMbboDialogClass *mbboDialog = (vuMbboDialogClass *)dialog;
			mbboDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_PID:
		    {
			vuPidDialogClass *pidDialog = (vuPidDialogClass *)dialog;
			pidDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_SEL:
		    {
			vuSelDialogClass *selDialog = (vuSelDialogClass *)dialog;
			selDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_STATE:
		    {
			vuStateDialogClass *stateDialog = (vuStateDialogClass *)dialog;
			stateDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_STRINGIN:
		    {
			vuStringinDialogClass *stringinDialog = 
							(vuStringinDialogClass *)dialog;
			stringinDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_STRINGOUT:
		    {
			vuStringoutDialogClass *stringoutDialog = 
							(vuStringoutDialogClass *)dialog;
			stringoutDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_WAVEFORM:
		    {
			vuWaveformDialogClass *waveformDialog = 
							(vuWaveformDialogClass *)dialog;
			waveformDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_LEADLAG:
		    {
			vuLeadLagDialogClass *leadlagDialog = 
							(vuLeadLagDialogClass *)dialog;
			leadlagDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_RAMP:
		    {
			vuRampDialogClass *rampDialog = (vuRampDialogClass *)dialog;
			rampDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_PIPE:
		    {
			vuPipeDialogClass *pipeDialog = (vuPipeDialogClass *)dialog;
			pipeDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_TANK:
		    {
			vuTankDialogClass *tankDialog = (vuTankDialogClass *)dialog;
			tankDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_VALVE:
		    {
			vuValveDialogClass *valveDialog = (vuValveDialogClass *)dialog;
			valveDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_PUMP:
		    {
			vuPumpDialogClass *pumpDialog = (vuPumpDialogClass *)dialog;
			pumpDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_POT:
		    {
			vuPotDialogClass *potDialog = (vuPotDialogClass *)dialog;
			potDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_ACCUM:
		    {
			vuAccDialogClass *accDialog = (vuAccDialogClass *)dialog;
			accDialog -> vuSetNewRecord (isNew);
			accDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_PTO:
		    {
			vuPtoDialogClass *ptoDialog = (vuPtoDialogClass *)dialog;
			ptoDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_DEADTIME:
		    {
			vuDeadtimeDialogClass *deadtimeDialog = 
							(vuDeadtimeDialogClass *)dialog;
			deadtimeDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_DATAMOVE:
		    {
			vuDatamoveDialogClass *datamoveDialog = 
							(vuDatamoveDialogClass *)dialog;
			datamoveDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_TD:
		    {
			vuTdDialogClass *tdDialog = (vuTdDialogClass *)dialog;
			tdDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_SIGCHAR:
		    {
			vuSigDialogClass *sigDialog = (vuSigDialogClass *)dialog;
			sigDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_UDB:
		    {
			vuUdbDialogClass *udbDialog = (vuUdbDialogClass *)dialog;
			udbDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_PAT:
		    {
			vuPatDialogClass *patDialog = (vuPatDialogClass *)dialog;
			patDialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_LDFW1:
		    {
			vuLdfw1DialogClass *ldfw1Dialog = (vuLdfw1DialogClass *)dialog;
			ldfw1Dialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_LDFW2:
		    {
			vuLdfw2DialogClass *ldfw2Dialog = (vuLdfw2DialogClass *)dialog;
			ldfw2Dialog -> vuSaveDialog (pvname);
			break;
		    }

		    case VU_DDC:
		    {
			vuDdcDialogClass *ddcDialog = (vuDdcDialogClass *)dialog;
			ddcDialog -> vuSaveDialog (pvname);
			break;
		    }

		    default:
			break;

		}  // end switch pointType
		//
		// tell dbClient about this modification
		//
		app->dbClientNotify->sendNotify((char *)&pvname[0]);
	    }
	    else
	    {
		vuMessageDialogCenter (dialog, VU_NO_PTNAME_ENTERED_MSG);
		commonDlg -> SetFocusItem (pvNameTextItem);
	    }
	}  // end dialog != NULL
    }  // end list != NULL
}


void vuCommonDismissButtonClass::ObserveDialogItem (vevent *event)
{
    // if read only or do  not have update or delete privileges
    // who cares if they made changes
    if ( (vuReadOnly == vTRUE) ||
	 (vuUpdatePointPriv == vFALSE) || 
	 (vuDeletePointPriv == vFALSE) )
    {
	commonDialog -> Close ();
    }
    else if ( (commonDialog -> getDialogModify ()) == vTRUE)
    {
	int result = vuMessageDialogCenter (commonDialog, VU_MOD_DISMISS_MSG); 
	if (result == VU_TRUE)
	{
	    commonDialog -> Close ();
	}
    }
    else
    {
	commonDialog -> Close ();
    }
}


void vuCommonDeleteButtonClass::ObserveDialogItem (vevent *event)
{
    vuMainDialogClass *mainDialog = commonDialog -> getMainDialog ();
    vuPvNameFilteredTextitem *pvNameField = commonDialog -> getPvNameField ();

    vstr *pvName = pvNameField -> GetTextAsString ();
    if ( (vcharLength (pvName)) == 0)
    {
	vuMessageDialogCenter (commonDialog, VU_NO_PTNAME_ENTERED_MSG);
    }
    else
    {
	int result = vuMessageDialogCenter (commonDialog, VU_DELETE_REQ_MSG, pvName);
	if (result == VU_TRUE)
	{
	    result = vuDeletePoint (mainDialog, pvName);
	    if (result == vTRUE)
	    {
		mainDialog -> vuMainMessageCenter (vunames_vuDeleteMsg, pvName);
		// delete from navigators poitn list
		vuNavigatorDialogClass *navigator = mainDialog -> getNavigator ();
		if (navigator != NULL)
		{
		    navigator -> vuRemovePvName (pvName);
		}
	    }
	    commonDialog -> Close ();
	}
    }
    vstrDestroy (pvName);
}


void vuCommonGoToButtonClass::ObserveDialogItem (vevent *event)
{
    vuMainDialogClass *mainDialog = commonDialog -> getMainDialog ();
    vuGoTo (mainDialog);
}


void vuCommonNextButtonClass::ObserveDialogItem (vevent *event)
{
    char seekBuff[PVNAME_SZ+1];
    vuMainDialogClass *mainDialog = commonDialog -> getMainDialog ();

    dataVuApplication *vuApp = mainDialog -> getApplication ();
    vuDatabaseClass *db = vuApp -> getDatabaseClass ();
    vresource vuRes = vuApp -> getDataVuvresource ();
    vresource commonResource = vresourceGet (vuRes, vunames_vuCommonDialog);

    vuNavigatorDialogClass *navigator = mainDialog -> getNavigator ();
    if (navigator == NULL)
    {
	vuMessageDialogCenter (commonDialog, VU_NO_LIST_ERR);
	return;
    }
    vuNavContainerClass *navContainer = navigator -> getNavContainer ();
    vliststr *pointList = (vliststr *)(navContainer -> pointList -> GetList ());
    if (pointList == NULL)
    {
	vuMessageDialogCenter (commonDialog, VU_NO_LIST_ERR);
	return;
    }
    vlistSelection *selection = navContainer -> pointList -> GetSelection ();

    int row, column;
    pointList -> GetSelectedCell (selection, &row, &column);

    if (row != vlistNO_CELLS_SELECTED)
    {
	int numRows = pointList -> GetRowCount ();
	if ( (row + 1) < numRows)
	{
	    // unselect current, get next, chg to char * for DB stuff
	    pointList -> UnselectRow (selection, row);
	    row++;
	    pointList -> SelectRow (selection, row);
	    vchar *pvnameText = (vchar *)(pointList -> GetCellValue (row, 0));
	    char pvname [PVNAME_SZ + 1];
	    vcharExportBounded (vcharScribeSystemExport (pvnameText), (void *)pvname, PVNAME_SZ);
	    char pointTypeName [POINTTYPE_SZ];
	    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvname);
	    DB_RECORD_PTR pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
	    if (pntRecord != (DB_RECORD_PTR)0)
	    {
		int currPointTypeIndex = commonDialog -> getPointType ();
		DB_FIELD_PTR pType = DB_MapField(db -> vuPvmapTable, FLD_TYPE);
		int dbaseType;
		DB_GetFieldValue (pntRecord, pType, (void *)pointTypeName, &dbaseType);
		int newPointTypeIndex = vuGetPointTypeIndex (pointTypeName);

		if ( (commonDialog -> getDialogModify()) == vTRUE)
		{
		    int result = vuMessageDialogCenter (commonDialog, VU_MOD_DISMISS_MSG); 
		    if (result == VU_FALSE)
			return;
		}
		// same point type just load in new point
		if(db->vuVerifyDb(pvname,newPointTypeIndex) != 0)
		{
		    if (currPointTypeIndex == newPointTypeIndex)
		    {
			vuLoadAndGo ((vdialog *)commonDialog, pvnameText, newPointTypeIndex);
		    }
		    else
		    {
			commonDialog -> Close ();
			vuNewLoadAndGo (mainDialog, pvnameText, commonResource, newPointTypeIndex);
		    }
		}
	    }
	    else
	    {
		vuMessageDialogCenter (commonDialog, VU_PTNOTINPVMAPERR, pvnameText);
	    }
	}
	else
	{
	    vuMessageDialogCenter (commonDialog, VU_ENDOFLIST_MSG);
	}
    }
    else
    {
	vuMessageDialogCenter (commonDialog, VU_NO_PTNAMES_SELECTED_MSG);
    }
}


void vuCommonPreviousButtonClass::ObserveDialogItem (vevent *event)
{
    char seekBuff[PVNAME_SZ+1];
    vuMainDialogClass *mainDialog = commonDialog -> getMainDialog ();

    dataVuApplication *vuApp = mainDialog -> getApplication ();
    vuDatabaseClass *db = vuApp -> getDatabaseClass ();
    vresource vuRes = vuApp -> getDataVuvresource ();
    vresource commonResource = vresourceGet (vuRes, vunames_vuCommonDialog);

    vuNavigatorDialogClass *navigator = mainDialog -> getNavigator ();
    if (navigator == NULL)
    {
	vuMessageDialogCenter (commonDialog, VU_NO_LIST_ERR);
	return;
    }
    vuNavContainerClass *navContainer = navigator -> getNavContainer ();
    vliststr *pointList = (vliststr *)(navContainer -> pointList -> GetList ());
    if (pointList == NULL)
    {
	vuMessageDialogCenter (commonDialog, VU_NO_LIST_ERR);
	return;
    }
    vlistSelection *selection = navContainer -> pointList -> GetSelection ();

    int row, column;
    pointList -> GetSelectedCell (selection, &row, &column);

    if (row != vlistNO_CELLS_SELECTED)
    {
	if ( (row - 1) >= 0)
	{
	    // unselect current, get next, chg to char * for DB stuff
	    pointList -> UnselectRow (selection, row);
	    row--;
	    pointList -> SelectRow (selection, row);
	    vchar *pvnameText = (vchar *)(pointList -> GetCellValue (row, 0));
	    char pvname [PVNAME_SZ + 1];
	    vcharExportBounded (vcharScribeSystemExport (pvnameText), (void *)pvname, PVNAME_SZ);
	    char pointTypeName [POINTTYPE_SZ];
	    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvname);
	    DB_RECORD_PTR pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
	    if (pntRecord != (DB_RECORD_PTR)0)
	    {
		int currPointTypeIndex = commonDialog -> getPointType ();
		DB_FIELD_PTR pType = DB_MapField(db -> vuPvmapTable, FLD_TYPE);
		int dbaseType;
		DB_GetFieldValue (pntRecord, pType, (void *)pointTypeName, &dbaseType);
		int newPointTypeIndex = vuGetPointTypeIndex (pointTypeName);

		if ( (commonDialog -> getDialogModify()) == vTRUE)
		{
		    int result = vuMessageDialogCenter (commonDialog, VU_MOD_DISMISS_MSG); 
		    if (result == vFALSE)
			return;
		}
		// same point type just load in new point
		if(db->vuVerifyDb(pvname,newPointTypeIndex) != 0)
		{
		    if (currPointTypeIndex == newPointTypeIndex)
		    {
			vuLoadAndGo ((vdialog *)commonDialog, pvnameText, newPointTypeIndex);
		    }
		    else
		    {
			commonDialog -> Close ();
			vuNewLoadAndGo (mainDialog, pvnameText, commonResource, newPointTypeIndex);
		    }
		}

	    }
	    else
	    {
		vuMessageDialogCenter (commonDialog, VU_PTNOTINPVMAPERR, pvnameText );
	    }
	}
	else
	{
	    vuMessageDialogCenter (commonDialog, VU_STARTOFLIST_MSG);
	}
    }
    else
    {
	vuMessageDialogCenter (commonDialog, VU_NO_PTNAMES_SELECTED_MSG);
    }
}


void vuCommonTrendButtonClass::ObserveDialogItem (vevent *event)
{
    vuMainDialogClass *mainDialog = commonDialog -> getMainDialog ();
    dataVuApplication *vuApp = mainDialog -> getApplication ();
    vuDatabaseClass *db = vuApp -> getDatabaseClass ();
    vuPvNameFilteredTextitem *pvNameField = commonDialog -> getPvNameField ();

    vstr *pvName = pvNameField -> GetTextAsString ();
    if ( (vcharLength (pvName)) == 0)
    {
	vuMessageDialogCenter (commonDialog, VU_NO_PTNAME_ENTERED_MSG);
    }
    else
    {
	char pvname[PVNAME_SZ + 1];
	char seekBuff[PVNAME_SZ + 1];

	vcharExportBounded (vcharScribeSystemExport (pvName),
			    pvname,
			    PVNAME_SZ);
	pvname[PVNAME_SZ] = 0;
	sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvname);
	DB_RECORD_PTR rec = DB_Seek (db -> vuPvmapTable, seekBuff);
	if (rec == 0)
	{
	    vuMessageDialogCenter (commonDialog, VU_PTNOTINPVMAPERR, pvName);
	}
	else
	{
	    int  dbaseType;
	    char ptName[POINTTYPE_SZ + 1];
	    DB_FIELD_PTR pTypeField = DB_MapField (db -> vuPvmapTable, FLD_TYPE);
	    DB_GetFieldValue (rec, pTypeField, (void *)ptName, &dbaseType);

	    // convert point type string to an index value
	    int ptIndex = vuGetPointTypeIndex (ptName);

	    vresource vuRes = vuApp -> getDataVuvresource ();
	    vresource arReducRes = vresourceGet (vuRes, vunames_vuArReducDialog);
	    vuArReducDialogClass *arReduc = new vuArReducDialogClass (arReducRes);

	    arReduc -> vuArReducOpen (mainDialog, pvname, ptIndex);

	    delete arReduc;
	}
    }
    vstrDestroy (pvName);
}


void vuCommonAlarmInfoButtonClass::ObserveDialogItem (vevent *event)
{
    vuMainDialogClass *mainDialog = commonDialog -> getMainDialog ();
    dataVuApplication *vuApp = mainDialog -> getApplication ();
    vuPvNameFilteredTextitem *pvNameField = commonDialog -> getPvNameField ();

    vstr *pvName = pvNameField -> GetTextAsString ();
    if ( (vcharLength (pvName)) == 0)
    {
	vuMessageDialogCenter (commonDialog, VU_NO_PTNAME_ENTERED_MSG);
    }
    else
    {
	vresource vuRes = vuApp -> getDataVuvresource ();
	vresource aiRes = vresourceGet (vuRes, vunames_vuAlarmInfoDialog);
	vuAlarmInfoDialogClass *alarmInfo = new vuAlarmInfoDialogClass (aiRes);

	alarmInfo -> vuAlarmInfoOpen (mainDialog, pvName);

	delete alarmInfo;
    }
    vstrDestroy (pvName);
}

