#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vbuttonHEADER
#include vcontainerHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbDefs.h"
#include "dbRecType.h"
#include "dbRecDes.h"
#include "dbFldTypes.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "vucreateall.h"
int sdrLoad (char *path);
}
#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"
#include "vuDatabaseClass.hxx"


//** DEFINE EXTRA FIELDS THAT ARE NOT IN THE SDR, BUT ARE NEEDED *******

VU_EXTRAFIELDS	aiExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				 {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				 {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				 {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				 {0,0}};

VU_EXTRAFIELDS	aoExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				 {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				 {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				 {0,0}};

VU_EXTRAFIELDS	biExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				 {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				 {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				 {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				 {0,0}};

VU_EXTRAFIELDS	boExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				 {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				 {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				 {0,0}};

VU_EXTRAFIELDS	calcExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				   {"MXSA",DBF_GBLCHOICE},{"PRCA",DBF_GBLCHOICE},
				   {"MXSB",DBF_GBLCHOICE},{"PRCB",DBF_GBLCHOICE},
				   {"MXSC",DBF_GBLCHOICE},{"PRCC",DBF_GBLCHOICE},
				   {"MXSD",DBF_GBLCHOICE},{"PRCD",DBF_GBLCHOICE},
				   {"MXSE",DBF_GBLCHOICE},{"PRCE",DBF_GBLCHOICE},
				   {"MXSF",DBF_GBLCHOICE},{"PRCF",DBF_GBLCHOICE},
				   {"MXSG",DBF_GBLCHOICE},{"PRCG",DBF_GBLCHOICE},
				   {"MXSH",DBF_GBLCHOICE},{"PRCH",DBF_GBLCHOICE},
				   {"MXSI",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				   {"MXSJ",DBF_GBLCHOICE},{"PRCJ",DBF_GBLCHOICE},
				   {"MXSK",DBF_GBLCHOICE},{"PRCK",DBF_GBLCHOICE},
				   {"MXSL",DBF_GBLCHOICE},{"PRCL",DBF_GBLCHOICE},
				   {"CSTA",DBF_DOUBLE},{"CSTB",DBF_DOUBLE},
				   {"CSTC",DBF_DOUBLE},{"CSTD",DBF_DOUBLE},
				   {"CSTE",DBF_DOUBLE},{"CSTF",DBF_DOUBLE},
				   {"CSTG",DBF_DOUBLE},{"CSTH",DBF_DOUBLE},
				   {"CSTI",DBF_DOUBLE},{"CSTJ",DBF_DOUBLE},
				   {"CSTK",DBF_DOUBLE},{"CSTL",DBF_DOUBLE},
				   {0,0}};

VU_EXTRAFIELDS	fanoutExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},{0,0}};

VU_EXTRAFIELDS	mbbiExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				   {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				   {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				   {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				   {0,0}};

VU_EXTRAFIELDS	mbboExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				   {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				   {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				   {0,0}};

VU_EXTRAFIELDS	pidExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				  {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				  {"MXS2",DBF_GBLCHOICE},{"PRC2",DBF_GBLCHOICE},
				  {"MXS3",DBF_GBLCHOICE},{"PRC3",DBF_GBLCHOICE},
				  {0,0}};

VU_EXTRAFIELDS	selExtraFields[]={  {"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				    {"MXSA",DBF_GBLCHOICE},{"PRCA",DBF_GBLCHOICE},
				    {"MXSB",DBF_GBLCHOICE},{"PRCB",DBF_GBLCHOICE},
				    {"MXSC",DBF_GBLCHOICE},{"PRCC",DBF_GBLCHOICE},
				    {"MXSD",DBF_GBLCHOICE},{"PRCD",DBF_GBLCHOICE},
				    {"MXSE",DBF_GBLCHOICE},{"PRCE",DBF_GBLCHOICE},
				    {"MXSF",DBF_GBLCHOICE},{"PRCF",DBF_GBLCHOICE},
				    {"MXSG",DBF_GBLCHOICE},{"PRCG",DBF_GBLCHOICE},
				    {"MXSH",DBF_GBLCHOICE},{"PRCH",DBF_GBLCHOICE},
				    {"MXSI",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				    {"MXSJ",DBF_GBLCHOICE},{"PRCJ",DBF_GBLCHOICE},
				    {"MXSK",DBF_GBLCHOICE},{"PRCK",DBF_GBLCHOICE},
				    {"MXSL",DBF_GBLCHOICE},{"PRCL",DBF_GBLCHOICE},
				    {"CSTA",DBF_DOUBLE},{"CSTB",DBF_DOUBLE},
				    {"CSTC",DBF_DOUBLE},{"CSTD",DBF_DOUBLE},
				    {"CSTE",DBF_DOUBLE},{"CSTF",DBF_DOUBLE},
				    {"CSTG",DBF_DOUBLE},{"CSTH",DBF_DOUBLE},
				    {"CSTI",DBF_DOUBLE},{"CSTJ",DBF_DOUBLE},
				    {"CSTK",DBF_DOUBLE},{"CSTL",DBF_DOUBLE},
				    {"MAXS",DBF_GBLCHOICE},{"PRC1",DBF_GBLCHOICE},
				    {"CNST",DBF_DOUBLE},
				    {0,0}};

VU_EXTRAFIELDS	stateExtraFields[]={{"LOC",DBF_STRING},	{"PRIV",DBF_STRING},{0,0}};

VU_EXTRAFIELDS	stringinExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				       {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				       {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				       {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				       {"CNST",DBF_DOUBLE},
				       {0,0}};

VU_EXTRAFIELDS	stringoutExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
					{"LINE",DBF_LONG},{"ADDR",DBF_LONG},
					{"CARD",DBF_LONG},{"SIGN",DBF_LONG},
					{"CNST",DBF_DOUBLE},
					{0,0}};

VU_EXTRAFIELDS	waveformExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				       {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				       {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				       {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				       {"CNST",DBF_DOUBLE},
				       {0,0}};

VU_EXTRAFIELDS	leadlagExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				      {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				      {0,0}};

VU_EXTRAFIELDS	rampExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				   {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				   {0,0}};

VU_EXTRAFIELDS	pipeExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				   {"MXS1",DBF_GBLCHOICE},{"PRC1",DBF_GBLCHOICE},
				   {"MXS2",DBF_GBLCHOICE},{"PRC2",DBF_GBLCHOICE},
				   {0,0}};

VU_EXTRAFIELDS	tankExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				   {"MXS0",DBF_GBLCHOICE},{"PRC0",DBF_GBLCHOICE},
				   {"MXS1",DBF_GBLCHOICE},{"PRC1",DBF_GBLCHOICE},
				   {"MXS2",DBF_GBLCHOICE},{"PRC2",DBF_GBLCHOICE},
				   {"MXS3",DBF_GBLCHOICE},{"PRC3",DBF_GBLCHOICE},
				   {"MXS4",DBF_GBLCHOICE},{"PRC4",DBF_GBLCHOICE},
				   {"MXS5",DBF_GBLCHOICE},{"PRC5",DBF_GBLCHOICE},
				   {"MXS6",DBF_GBLCHOICE},{"PRC6",DBF_GBLCHOICE},
				   {"MXS7",DBF_GBLCHOICE},{"PRC7",DBF_GBLCHOICE},
				   {"MXS8",DBF_GBLCHOICE},{"PRC8",DBF_GBLCHOICE},
				   {"MXS9",DBF_GBLCHOICE},{"PRC9",DBF_GBLCHOICE},

				   {"MXSA",DBF_GBLCHOICE},{"PRCA",DBF_GBLCHOICE},
				   {"MXSB",DBF_GBLCHOICE},{"PRCB",DBF_GBLCHOICE},
				   {"MXSC",DBF_GBLCHOICE},{"PRCC",DBF_GBLCHOICE},
				   {"MXSD",DBF_GBLCHOICE},{"PRCD",DBF_GBLCHOICE},
				   {"MXSE",DBF_GBLCHOICE},{"PRCE",DBF_GBLCHOICE},
				   {"MXSF",DBF_GBLCHOICE},{"PRCF",DBF_GBLCHOICE},
				   {"MXSG",DBF_GBLCHOICE},{"PRCG",DBF_GBLCHOICE},
				   {"MXSH",DBF_GBLCHOICE},{"PRCH",DBF_GBLCHOICE},
				   {"MXSI",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				   {"MXSJ",DBF_GBLCHOICE},{"PRCJ",DBF_GBLCHOICE},
				   {0,0}};

VU_EXTRAFIELDS	valveExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				    {"MXS1",DBF_GBLCHOICE},{"PRC1",DBF_GBLCHOICE},
				    {"MXS2",DBF_GBLCHOICE},{"PRC2",DBF_GBLCHOICE},
				    {"MXS3",DBF_GBLCHOICE},{"PRC3",DBF_GBLCHOICE},
				    {"MXS4",DBF_GBLCHOICE},{"PRC4",DBF_GBLCHOICE},
				    {"MXS5",DBF_GBLCHOICE},{"PRC5",DBF_GBLCHOICE},
				    {"MXS6",DBF_GBLCHOICE},{"PRC6",DBF_GBLCHOICE},
				    {"MXS7",DBF_GBLCHOICE},{"PRC7",DBF_GBLCHOICE},
				    {"MXS8",DBF_GBLCHOICE},{"PRC8",DBF_GBLCHOICE},
				    {"MXS9",DBF_GBLCHOICE},{"PRC9",DBF_GBLCHOICE},
				    {"MXSA",DBF_GBLCHOICE},{"PRCA",DBF_GBLCHOICE},
				    {"MXSB",DBF_GBLCHOICE},{"PRCB",DBF_GBLCHOICE},
				    {0,0}};

VU_EXTRAFIELDS	pumpExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				   {"MXS1",DBF_GBLCHOICE},{"PRC1",DBF_GBLCHOICE},
				   {"MXS2",DBF_GBLCHOICE},{"PRC2",DBF_GBLCHOICE},
				   {"MXS3",DBF_GBLCHOICE},{"PRC3",DBF_GBLCHOICE},
				   {"MXS4",DBF_GBLCHOICE},{"PRC4",DBF_GBLCHOICE},
				   {"MXS5",DBF_GBLCHOICE},{"PRC5",DBF_GBLCHOICE},
				   {"MXS6",DBF_GBLCHOICE},{"PRC6",DBF_GBLCHOICE},
				   {"MXS7",DBF_GBLCHOICE},{"PRC7",DBF_GBLCHOICE},
				   {"MXS8",DBF_GBLCHOICE},{"PRC8",DBF_GBLCHOICE},
				   {0,0}};

VU_EXTRAFIELDS	potExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				  {"MXS1",DBF_GBLCHOICE},{"PRC1",DBF_GBLCHOICE},
				  {"MXS2",DBF_GBLCHOICE},{"PRC2",DBF_GBLCHOICE},
				  {"MXS3",DBF_GBLCHOICE},{"PRC3",DBF_GBLCHOICE},
				  {"MXS4",DBF_GBLCHOICE},{"PRC4",DBF_GBLCHOICE},
				  {"MXS5",DBF_GBLCHOICE},{"PRC5",DBF_GBLCHOICE},
				  {"MXS6",DBF_GBLCHOICE},{"PRC6",DBF_GBLCHOICE},
				  {"MXS7",DBF_GBLCHOICE},{"PRC7",DBF_GBLCHOICE},
				  {"MXS8",DBF_GBLCHOICE},{"PRC8",DBF_GBLCHOICE},
				  {"MXS9",DBF_GBLCHOICE},{"PRC9",DBF_GBLCHOICE},
				  {0,0}};

VU_EXTRAFIELDS	accumExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				    {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				    {"MXS2",DBF_GBLCHOICE},{"PRC2",DBF_GBLCHOICE},
				    {"MXS3",DBF_GBLCHOICE},{"PRC3",DBF_GBLCHOICE},
				    {0,0}};

VU_EXTRAFIELDS	ptoExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				  {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				  {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				  {"LIN2",DBF_LONG},{"ADR2",DBF_LONG},
				  {"CRD2",DBF_LONG},{"SIG2",DBF_LONG},
				  {0,0}};

VU_EXTRAFIELDS	deadtimeExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				       {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				       {"PRC2",DBF_GBLCHOICE},
				       {"CNST",DBF_DOUBLE},
				       {0,0}};

VU_EXTRAFIELDS	datamoveExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},{0,0}};

VU_EXTRAFIELDS	tdExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				 {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				 {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				 {"CNST",DBF_DOUBLE},
				 {0,0}};

VU_EXTRAFIELDS	sigcharExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				      {"MAXS",DBF_GBLCHOICE},{"PRCI",DBF_GBLCHOICE},
				      {0,0}};

VU_EXTRAFIELDS	udbExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				  {"MXS1",DBF_GBLCHOICE},{"PRC1",DBF_GBLCHOICE},
				  {"MXS2",DBF_GBLCHOICE},{"PRC2",DBF_GBLCHOICE},
				  {"MXS3",DBF_GBLCHOICE},{"PRC3",DBF_GBLCHOICE},
				  {"MXS4",DBF_GBLCHOICE},{"PRC4",DBF_GBLCHOICE},
				  {"MXS5",DBF_GBLCHOICE},{"PRC5",DBF_GBLCHOICE},
				  {"MXS6",DBF_GBLCHOICE},{"PRC6",DBF_GBLCHOICE},
				  {"MXS7",DBF_GBLCHOICE},{"PRC7",DBF_GBLCHOICE},
				  {"MXS8",DBF_GBLCHOICE},{"PRC8",DBF_GBLCHOICE},
				  {"PIN1",DBF_GBLCHOICE},{"PIN2",DBF_GBLCHOICE},
				  {"PIN3",DBF_GBLCHOICE},{"PIN4",DBF_GBLCHOICE},
				  {"PIN5",DBF_GBLCHOICE},{"PIN6",DBF_GBLCHOICE},
				  {"PIN7",DBF_GBLCHOICE},{"PIN8",DBF_GBLCHOICE},
				  {0,0}};

VU_EXTRAFIELDS	patExtraFields[]={{"LOC",DBF_STRING},{"PRIV",DBF_STRING},
				  {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				  {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				  {"LIN2",DBF_LONG},{"ADR2",DBF_LONG},
				  {"CRD2",DBF_LONG},{"SIG2",DBF_LONG},
				  {"LIN3",DBF_LONG},{"ADR3",DBF_LONG},
				  {"CRD3",DBF_LONG},{"SIG3",DBF_LONG},
				  {"LIN4",DBF_LONG},{"ADR4",DBF_LONG},
				  {"CRD4",DBF_LONG},{"SIG4",DBF_LONG},
				  {0,0}};

VU_EXTRAFIELDS	ldfw1ExtraFields[]={{"LOC",DBF_STRING},	{"PRIV",DBF_STRING},{0,0}};

VU_EXTRAFIELDS	ldfw2ExtraFields[]={{"LOC",DBF_STRING},	{"PRIV",DBF_STRING},
				    {"SCPR",DBF_GBLCHOICE},{"SCMS",DBF_GBLCHOICE},
				    {"LDPR",DBF_GBLCHOICE},{"LDMS",DBF_GBLCHOICE},
				    {0,0}};

VU_EXTRAFIELDS	ddcExtraFields[]={{"LOC",DBF_STRING},	{"PRIV",DBF_STRING},
				  {"LINE",DBF_LONG},{"ADDR",DBF_LONG},
				  {"CARD",DBF_LONG},{"SIGN",DBF_LONG},
				  {"PRCS",DBF_GBLCHOICE},{"SIMS",DBF_GBLCHOICE},
				  {"PRCR",DBF_GBLCHOICE},{"RSMS",DBF_GBLCHOICE},
				  {0,0}};

//
//	Tables for fields which must not be exported
//
//ai
char *aiOffScrFields[] =
{
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *aoOffScrFields[] =
{
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *biOffScrFields[] =
{
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *boOffScrFields[] =
{
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *calcOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *fanoutOffScrFields[] =
{
"DTYP",
"TENB",
"ADIS",
"TAGD",
"AENB",
"ALGP",
"ALDL",
"ITAG",
"TSTP",
0
};

char *mbbiOffScrFields[] =
{
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *mbboOffScrFields[] =
{
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *pidOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *selOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *stateOffScrFields[] =
{
"DTYP",
"TENB",
"ADIS",
"TAGD",
"ALDL",
"ITAG",
"TSTP",
0
};

char *stringinOffScrFields[] =
{
"TENB",
"TAGD",
"ALDL",
"ITAG",
"TSTP",
0
};

char *stringoutOffScrFields[] =
{
"TENB",
"ADIS",
"TAGD",
"AENB",
"ALGP",
"ALDL",
"ITAG",
"TSTP",
0
};

char *waveformOffScrFields[] =
{
"TENB",
"ADIS",
"TAGD",
"AENB",
"ALGP",
"ALDL",
"ITAG",
"TSTP",
0
};

char *leadlagOffScrFields[] =
{
"DTYP",
"TENB",
"ADIS",
"TAGD",
"AENB",
"ALGP",
"ALDL",
"ITAG",
"TSTP",
"INVT",
0
};

char *rampOffScrFields[] =
{
"DTYP",
"TENB",
"ADIS",
"TAGD",
"AENB",
"ALGP",
"ALDL",
"ITAG",
"TSTP",
0
};

char *pipeOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ALDL",
"ITAG",
"TSTP",
0
};

char *tankOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ALDL",
"ITAG",
"TSTP",
0
};

char *valveOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ALDL",
"ITAG",
"TSTP",
0
};

char *pumpOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ALDL",
"ITAG",
"TSTP",
"SVRT",
0
};

char *potOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ALDL",
"ITAG",
"TSTP",
0
};

char *accumOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ITAG",
"TSTP",
"FSMP",
"FTOT",
"FAVG",
"FMIN",
"FMAX",
"STOT",
"SSMP",
"SMIN",
"SMAX",
"SSTT",
"FSEC",
"ARSF",
"FSTA",
"FSEV",
"NFSA",
"NFSV",
"RSEC",
0
};

char *ptoOffScrFields[] =
{
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *deadtimeOffScrFields[] =
{
"DTYP",
"TENB",
"ADIS",
"TAGD",
"AENB",
"ALGP",
"ALDL",
"ITAG",
"TSTP",
0
};

char *datamoveOffScrFields[] =
{
"DTYP",
"TENB",
"ADIS",
"TAGD",
"AENB",
"ALGP",
"ALDL",
"ITAG",
"TSTP",
0
};

char *tdOffScrFields[] =
{
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *sigcharOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *udbOffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ITAG",
"TSTP",
"MODE",
"FUNC",
0
};

char *patOffScrFields[] =
{
"TENB",
"TAGD",
"ITAG",
"TSTP",
0
};

char *ldfw1OffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ALDL",
"ITAG",
"TSTP",
"LPST",
0
};

char *ldfw2OffScrFields[] =
{
"DTYP",
"TENB",
"TAGD",
"ALDL",
"ITAG",
"TSTP",
"LPST",
0
};

char *ddcOffScrFields[] =
{
"TENB",
"TAGD",
"ALDL",
"ITAG",
"TSTP",
0
};



//*** FIELD TAGS FOR VARIOUS DATABASE AUXILLIARY FILES *********************

//*** for pumpvars.dbf VARDESC field, defined in pdbxref.txt

char	*pumpIdString[] =
	{
	"Start PV",
	"Stop PV",
	"R/L PV",
	"Temp PV",
	"Vib PV",
	"Pres PV",
	"Perm PV",
	"RunCF PV",
	0
	};

char	*valveIdString[] = 
	{
	"Open PV",
	"Close PV",
	"Open Limit PV",
	"Close Limit PV",
	"Open Torque PV",
	"Close Torque PV",
	"R/L PV",
	"Position PV",
	"Drive Pos PV",
	"Fault MBBI PV",
	"Permissive PV",
	0
	};

char	*pipevars[] = 
	{
	"Pressure PV",
	"Temp PV",
	0
	};

char	*pipecmds[] =
	{
	"Run",
	"Stop",
	0
	};

char	*tankcmds[] =
	{
	"Issue",
	"Receive",
	"Run",
	"Stop",
	0
	};

char	*tankvars[] =
	{
	"Level PV",
	"Density PV",
	"BSW PV",
	"Avg Temp PV",
	"Volume PV",
	"Mass PV",
	"High Level PV",
	"Low Level PV",
	"High Pres PV",
	"Low Pres PV",
	0
	};

char	*potvars[] =
	{
	"Custody PV",
	"Temp PV",
	"Trans Permit PV",
	"Ground OK PV",
	"Enab Trans PV",
	"Press PV",
	"Meter PV",
	"Flow PV",
	"Corrected Vol PV",
	0
	};


/*******************************************************************
*
*    vuDatabaseClass constructor
*
*******************************************************************/

vuDatabaseClass::vuDatabaseClass (char *dbPath, vresource vures)
{
    int		result;
    int		i;

    initErrors = VU_SUCCESS;
    dataVuvresource = vures;

    // clear the xref dictionary array
    for (i = 0; i < VU_NUMPOINTS; i++)
		xrefDicts[i] = NULL;
	// initialize the extra fields array
    xrefExtraFields[VU_AI] = aiExtraFields;
    xrefExtraFields[VU_AO] = aoExtraFields;
    xrefExtraFields[VU_BI] = biExtraFields;
    xrefExtraFields[VU_BO] = boExtraFields;
    xrefExtraFields[VU_CALC] = calcExtraFields;
    xrefExtraFields[VU_FANOUT] = fanoutExtraFields;
    xrefExtraFields[VU_MBBI] = mbbiExtraFields;
    xrefExtraFields[VU_MBBO] = mbboExtraFields;
    xrefExtraFields[VU_PID] = pidExtraFields;
    xrefExtraFields[VU_SEL] = selExtraFields;
    xrefExtraFields[VU_STATE] = stateExtraFields;
    xrefExtraFields[VU_STRINGIN] = stringinExtraFields;
    xrefExtraFields[VU_STRINGOUT] = stringoutExtraFields;
    xrefExtraFields[VU_WAVEFORM] = waveformExtraFields;
    xrefExtraFields[VU_LEADLAG] = leadlagExtraFields;
    xrefExtraFields[VU_RAMP] = rampExtraFields;
    xrefExtraFields[VU_PIPE] = pipeExtraFields;
    xrefExtraFields[VU_TANK] = tankExtraFields;
    xrefExtraFields[VU_VALVE] = valveExtraFields;
    xrefExtraFields[VU_PUMP] = pumpExtraFields;
    xrefExtraFields[VU_POT] = potExtraFields;
    xrefExtraFields[VU_ACCUM] = accumExtraFields;
    xrefExtraFields[VU_PTO] = ptoExtraFields;
    xrefExtraFields[VU_DEADTIME] = deadtimeExtraFields;
    xrefExtraFields[VU_DATAMOVE] = datamoveExtraFields;
    xrefExtraFields[VU_TD] = tdExtraFields;
    xrefExtraFields[VU_SIGCHAR] = sigcharExtraFields;
    xrefExtraFields[VU_UDB] = udbExtraFields;
    xrefExtraFields[VU_PAT] = patExtraFields;
    xrefExtraFields[VU_LDFW1] = ldfw1ExtraFields;
    xrefExtraFields[VU_LDFW2] = ldfw2ExtraFields;
    xrefExtraFields[VU_DDC] = ddcExtraFields;

    // initialize the off-screen fields array
    offScreenFields[VU_AI] = aiOffScrFields;
    offScreenFields[VU_AO] = aoOffScrFields;
    offScreenFields[VU_BI] = biOffScrFields;
    offScreenFields[VU_BO] = boOffScrFields;
    offScreenFields[VU_CALC] = calcOffScrFields;
    offScreenFields[VU_FANOUT] = fanoutOffScrFields;
    offScreenFields[VU_MBBI] = mbbiOffScrFields;
    offScreenFields[VU_MBBO] = mbboOffScrFields;
    offScreenFields[VU_PID] = pidOffScrFields;
    offScreenFields[VU_SEL] = selOffScrFields;
    offScreenFields[VU_STATE] = stateOffScrFields;
    offScreenFields[VU_STRINGIN] = stringinOffScrFields;
    offScreenFields[VU_STRINGOUT] = stringoutOffScrFields;
    offScreenFields[VU_WAVEFORM] = waveformOffScrFields;
    offScreenFields[VU_LEADLAG] = leadlagOffScrFields;
    offScreenFields[VU_RAMP] = rampOffScrFields;
    offScreenFields[VU_PIPE] = pipeOffScrFields;
    offScreenFields[VU_TANK] = tankOffScrFields;
    offScreenFields[VU_VALVE] = valveOffScrFields;
    offScreenFields[VU_PUMP] = pumpOffScrFields;
    offScreenFields[VU_POT] = potOffScrFields;
    offScreenFields[VU_ACCUM] = accumOffScrFields;
    offScreenFields[VU_PTO] = ptoOffScrFields;
    offScreenFields[VU_DEADTIME] = deadtimeOffScrFields;
    offScreenFields[VU_DATAMOVE] = datamoveOffScrFields;
    offScreenFields[VU_TD] = tdOffScrFields;
    offScreenFields[VU_SIGCHAR] = sigcharOffScrFields;
    offScreenFields[VU_UDB] = udbOffScrFields;
    offScreenFields[VU_PAT] = patOffScrFields;
    offScreenFields[VU_LDFW1] = ldfw1OffScrFields;
    offScreenFields[VU_LDFW2] = ldfw2OffScrFields;
    offScreenFields[VU_DDC] = ddcOffScrFields;
    //
    // this is an array of an array of pointers to database table
    // structures. This is used to search for point names with a given
    // point type to determine database integrity
    //
    vuXREFTables = (VU_XREFHDR_PTR)vmemAllocAndClear(XREFHDRSIZE * VU_NUMPOINTS);
    if ( (result = vuDatabaseInit (dbPath)) != VU_SUCCESS)
	return;

    // store the default database path
    strncpy (dbasePath, dbPath, VU_MAX_PATH);
    dbasePath [VU_MAX_PATH - 1] = 0;
    ResListHasChanged(vTRUE);				// so lists are made first time
    IocListHasChanged(vTRUE);				// "    "    "   "     "    "
}



/*******************************************************************
*
*    vuDatabaseClass destructor
*
*******************************************************************/

vuDatabaseClass::~vuDatabaseClass (void)
{
    vdict		*dict;
    vdictIterator	iterator;
    xrefNodeClass	*xrefNode;
    int			i;

    // traverse the xref dictionaries and return all memory
    for (i = 0; i < VU_NUMPOINTS; i++)
    {
	dict = xrefDicts[i];
	if (dict == NULL)
	    continue;
	iterator.Start (dict);
	while (iterator.Next ())
	{
	    xrefNode = (xrefNodeClass *)(iterator.GetValue ());
	    delete xrefNode;
	}
	iterator.Finish ();
	delete dict;
    }
    vmemFree((void *)vuXREFTables);	// free xref tables here
}


/*******************************************************************
*
*    vuDatabaseClass function to init the database
*
*******************************************************************/

int vuDatabaseClass::vuDatabaseInit (char *dbPath)
{
    char	sdrPath [VU_MAX_PATH];

    // first load in the SDR file, see .../epicsH/choice.h
#ifndef WIN32
    sprintf (sdrPath, "%s/%s", dbPath, TIS_SDR_NAME);
#else
    sprintf (sdrPath, "%s\\%s", dbPath, TIS_SDR_NAME);
#endif
    sdrPath [VU_MAX_PATH - 1] = 0;
    if ( (sdrLoad (sdrPath)) != VU_SUCCESS)
    {
	vuMessageDialogCenter (NULL, VU_SDRERR);
	initErrors = VU_ERROR;
	return (VU_ERROR);
    }

    DB_MapDatabase (dbPath);	// map to current database path

    if((vuAccumTable = DB_MapTable(VU_ACCUMFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_ACCUM);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuAiTable = DB_MapTable(VU_AIFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_AI);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    // do not open alarm groups database, open and close as needed
    vuAlgrListTable = NULL;

    if((vuAlarmInfoTable = DB_MapTable(VU_ALARMINFOFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_ALARMINFOERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuAoTable = DB_MapTable(VU_AOFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_AO);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuApiTable = DB_MapTable(VU_APIFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_APIFILEERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuArReducTable = DB_MapTable(VU_ARREDUCFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_ARREDUCERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuBiTable = DB_MapTable(VU_BIFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_BI);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuBoTable = DB_MapTable(VU_BOFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_BO);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuCalcTable = DB_MapTable(VU_CALCFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_CALC);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuCalcOpsTable = DB_MapTable(VU_CALCOPFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_CALCOPERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuDatamoveTable = DB_MapTable(VU_DATAMOVEFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_DATAMOVE);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuDdcTable = DB_MapTable(VU_DDCFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_DDC);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuDeadtimeTable = DB_MapTable(VU_DEADTIMEFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_DEADTIME);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuFanLinkTable = DB_MapTable(VU_FANLINKFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_FANLINKERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuFanoutTable = DB_MapTable(VU_FANOUTFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_FANOUT);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuFldProtTable = DB_MapTable(VU_FIELDTABFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_FIELDTABERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuIOAddrTable = DB_MapTable(VU_IOADDRFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_IOADDRERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuIocListTable = DB_MapTable(VU_IOCLISTFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_IOCLISTERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuLaunchCfgTable = DB_MapTable(VU_LAUNCHCFGFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_LAUNCHCFGERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuLdfw1Table = DB_MapTable(VU_LDFW1FILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_LDFW1);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuLdfw2Table = DB_MapTable(VU_LDFW2FILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_LDFW2);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuLeadLagTable = DB_MapTable(VU_LEADLAGFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_LEADLAG);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuMbbiTable = DB_MapTable(VU_MBBIFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_MBBI);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuMbboTable = DB_MapTable(VU_MBBOFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_MBBO);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPatTable = DB_MapTable(VU_PATFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_PAT);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPidTable = DB_MapTable(VU_PIDFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_PID);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPipeTable = DB_MapTable(VU_PIPEFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_PIPE);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPipeCmdsTable = DB_MapTable(VU_PIPECMDSFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PIPECMDSERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPipeVarsTable = DB_MapTable(VU_PIPEVARSFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PIPEVARSERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPotTable = DB_MapTable(VU_POTFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_POT);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPotVarsTable = DB_MapTable(VU_POTVARSFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_POTVARSERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPtoTable = DB_MapTable(VU_PTOFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_PTO);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPrivTabTable = DB_MapTable(VU_PRIVTABFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PRIVTABERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPumpTable = DB_MapTable(VU_PUMPFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_PUMP);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPumpVarsTable = DB_MapTable(VU_PUMPVARSFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PUMPVARSERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuPvmapTable = DB_MapTable(VU_PVMAPFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PVMAPERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuRampTable = DB_MapTable(VU_RAMPFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_RAMP);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuResListTable = DB_MapTable(VU_RESLISTFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_RESLISTERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuScriptTable = DB_MapTable(VU_SCRIPTFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_SCRIPTFILEERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuSelTable = DB_MapTable(VU_SELFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_SEL);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuSelLinkTable = DB_MapTable(VU_SELLINKFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_SELLINKERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuSigCharTable = DB_MapTable(VU_SIGFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_SIGCHAR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuStateTable = DB_MapTable(VU_STATEFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_STATE);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuStringinTable = DB_MapTable(VU_STRINGINFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_STRINGIN);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuSysUsersTable = DB_MapTable(VU_SYSUSERSFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_SYSUSERSERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuStrapTable = DB_MapTable(VU_STRAPFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_STRAPFILEERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuStringoutTable = DB_MapTable(VU_STRINGOUTFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_STRINGOUT);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuTank1Table = DB_MapTable(VU_TANK1FILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_TANK);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuTank2Table = DB_MapTable(VU_TANK2FILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_TANK);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuTank3Table = DB_MapTable(VU_TANK3FILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_TANK);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuTank4Table = DB_MapTable(VU_TANK4FILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_TANK);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuTankCmdsTable = DB_MapTable(VU_TANKCMDSFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_TANKCMDSERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuTankPrbsTable = DB_MapTable(VU_TANKPRBSFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_TANKPRBSERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuTankVarsTable = DB_MapTable(VU_TANKVARSFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_TANKVARSERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuTankVlvsTable = DB_MapTable(VU_TANKVLVSFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_TANKVLVSERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuTdTable = DB_MapTable(VU_TDFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_TD);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuUdbTable = DB_MapTable(VU_UDBFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_UDB);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuUdbCfgTable = DB_MapTable(VU_UDBCONFIGFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_UDBCFGERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuValveTable = DB_MapTable(VU_VALVEFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_VALVE);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuValveVarsTable = DB_MapTable(VU_VALVEVARSFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_VALVEVARSERR);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    if((vuWaveformTable = DB_MapTable(VU_WAVEFORMFILE)) == 0)
    {
	vuMessageDialogCenter (NULL, VU_PTFILEERR, VU_WAVEFORM);
	initErrors = VU_ERROR;
	return(VU_ERROR);
    }
    DB_UseKey (vuCalcOpsTable,FLD_CALCOP_KEY);
    DB_UseKey (vuFanLinkTable,FLD_CALCOP_KEY);
    DB_UseKey (vuPipeCmdsTable,FLD_CALCOP_KEY);
    DB_UseKey (vuPipeVarsTable,FLD_CALCOP_KEY);
    DB_UseKey (vuPotVarsTable,FLD_CALCOP_KEY);
    DB_UseKey (vuPumpVarsTable,FLD_CALCOP_KEY);
    DB_UseKey (vuSelLinkTable,FLD_CALCOP_KEY);
    DB_UseKey (vuTankCmdsTable,FLD_CALCOP_KEY);
    DB_UseKey (vuTankPrbsTable,FLD_CALCOP_KEY);
    DB_UseKey (vuTankVarsTable,FLD_CALCOP_KEY);
    DB_UseKey (vuTankVlvsTable,FLD_CALCOP_KEY);
    DB_UseKey (vuValveVarsTable,FLD_CALCOP_KEY);

    ioaddrLine     = DB_MapField (vuIOAddrTable,FLD_LINE);
    ioaddrAddress  = DB_MapField (vuIOAddrTable,FLD_ADDRESS);
    ioaddrCard     = DB_MapField (vuIOAddrTable,FLD_CARD);
    ioaddrSignal   = DB_MapField (vuIOAddrTable,FLD_SIGNAL);
    pvmapTypeField = DB_MapField (vuPvmapTable,FLD_TYPE);

    iocNameField   = DB_MapField (vuIocListTable,FLD_IOCNAME);
    iocSyncField   = DB_MapField (vuIocListTable,FLD_NOSYNC);
    iocHostField   = DB_MapField (vuIocListTable,FLD_ISHOST);

    resNameField   = DB_MapField (vuResListTable,FLD_RESOURCE);
    resDPAField	   = DB_MapField (vuResListTable,FLD_DPA);

    // load up the xref dictionarys

    if ( (vuBuildXREFTable ()) != VU_SUCCESS)
    {
	vuMessageDialogCenter (NULL, VU_XREFERR);
	initErrors = VU_ERROR;
	return (VU_ERROR);
    }

    return (VU_SUCCESS);
}


/*******************************************************************
*
*    vuBuildXREFTable function to build internal xref dictionaries
*
*******************************************************************/

int vuDatabaseClass::vuBuildXREFTable (void)
{
    int			pointIndex;
    int			fieldIndex;
    int			errorCount;
    int			addStatus;
    char		xrefKey[40];	// key for xref table
    char		*typeString;	// ptr to point type string from SDR
    struct recTypDes	*vuRecTypDes;	// ptr to record type description from SDR
    struct fldDes	*vuFldDes;	// ptr to epics field description from SDR
    DB_RECORD_PTR	xrefRecord;	// ptr to record in xref file
    VU_EXTRAFIELDS	*localExtraFields; // ptr to extra fields not in SDR

    if ( (vuXrefTable = DB_MapTable (VU_XREFFILE)) == 0)
	return (VU_XREFERR);
    xrefNameField      = DB_MapField (vuXrefTable, FLD_FIELD_NAME);
    xrefTableField     = DB_MapField (vuXrefTable, FLD_TABLE);
    xrefTrueField      = DB_MapField (vuXrefTable, FLD_TRUE_STATE);
    xrefOpIdField      = DB_MapField (vuXrefTable, FLD_CALCOP);
    xrefReferenceField = DB_MapField (vuXrefTable, FLD_REFFIELD);
    xrefConstantField  = DB_MapField (vuXrefTable, FLD_CONSTFIELD);
    xrefHardwareField  = DB_MapField (vuXrefTable, FLD_HARDFIELD);
    xrefEpicsField     = DB_MapField (vuXrefTable, FLD_EPICS_FIELD_NAME);

    errorCount = 0;

    // for all point types, 
    // NOTE: point type enum in dataVu.hxx, starts from 0, since
    //       used for menus, but inreality, SDR starts at 1
    for (pointIndex = 0; pointIndex < VU_NUMPOINTS; pointIndex++)
    {
	pointHdr = (VU_XREFHDR_PTR)&vuXREFTables[pointIndex];
	/*
	    NOTE: IF YOU ADD TO THIS LIST, YOU HAD BETTER DO THE SAME
	    IN vuImport.c/free_data(). These following point types have
	    hardware and the ioaddr file is the first in the aray
	*/
	if( (pointIndex == VU_AI) ||
	    (pointIndex == VU_AO) ||
	    (pointIndex == VU_BI) ||
	    (pointIndex == VU_BO) ||
	    (pointIndex == VU_MBBI) ||
	    (pointIndex == VU_MBBO) ||
	    (pointIndex == VU_STRINGIN) ||
	    (pointIndex == VU_STRINGOUT) ||
	    (pointIndex == VU_WAVEFORM) ||
	    (pointIndex == VU_PTO) ||
	    (pointIndex == VU_TD) ||
	    (pointIndex == VU_PAT) ||
	    (pointIndex == VU_DDC) )
	  {
	    pointHdr->xrefHdrTables[0] = vuIOAddrTable;
	    strcpy(&pointHdr->xrefHdrNames[0][0],VU_IOADDRFILE);
	  }
	// get a new dictionary for the point type
	xrefDicts[pointIndex] = new vdict (vnameHash);

	// get pointer to the point type string
	typeString = dbRecType -> papName[pointIndex + 1];

	// get pointer to record description for this point type
	vuRecTypDes = GET_PRECTYPDES (pointIndex + 1);

	// while there are fields for this point type in the SDR
	fieldIndex = 0;
	while (vuFldDes = GET_PFLDDES (vuRecTypDes, fieldIndex))
	{
	    // position us in the xref table, if a prompted field or the NAME field
		if(vuCheckOnScreen(vuFldDes->fldname,pointIndex) == vFALSE)
		{
			fieldIndex++;
			continue;
		}
	    if((vuFldDes -> promptflag) || ((strcmp (vuFldDes -> fldname, "NAME")) == 0))
	    {
		// xref key based on point type name and EPICS field name
			sprintf (xrefKey, "%-15.15s%-4.4s\0", typeString, vuFldDes -> fldname);

			if ( (xrefRecord = DB_Seek (vuXrefTable, xrefKey)) != 0)
			{
				addStatus = vuAddToXrefDict (xrefDicts[pointIndex], 
						 xrefRecord, 
						 vuFldDes, 
						 vuFldDes -> field_type);

		    // skip non-existant point types
				if (addStatus == 0) break;

		    // skip to next field if no table
			    if (addStatus == -1)
			    {
					fieldIndex++;
					continue;
				}
			}
			else
			{
				if (pointIndex < VU_NUMPOINTS)
				{
				errorCount++;
				fprintf (stderr, "No pdbxref entry for %s\n", xrefKey);
				}
			}
	    }
	    fieldIndex++;
	} // end for all fields in this point type

	// Add aditional fields that are NOT in the SDR, but they are in 
	// PVMAP and PDBXREF tables

	fieldIndex = 0;
	localExtraFields = xrefExtraFields [pointIndex];

	while (localExtraFields[fieldIndex].xtraName)
	{
	    sprintf (xrefKey, "%-15.15s%-4.4s\0", 
			       typeString, localExtraFields[fieldIndex].xtraName);
	    if ( (xrefRecord = DB_Seek (vuXrefTable, xrefKey)) != 0)
	    {
		addStatus = vuAddToXrefDict (xrefDicts [pointIndex],
					     xrefRecord, 
					     vuFldDes,
					     localExtraFields[fieldIndex].xtraType);
		if (addStatus == VU_SUCCESS)
		    break;
	    }
	    fieldIndex++;
	}  // end for all extra fields for this point type

    } // end for all pointtypes

    // close the xref table
    DB_UnMapTable (vuXrefTable, 0);
    vuXrefTable = NULL;
    return (errorCount ? (int)VU_XREFERR : (int)VU_SUCCESS);
}


/*******************************************************************
*
*    vuAddToXrefDict
*	add to the point dictionary a field that belongs to this
*	point type
*
*******************************************************************/

int vuDatabaseClass::vuAddToXrefDict (vdict *dict, 
				      DB_RECORD_PTR xrefRec,
				      struct fldDes *FldDes,
				      int field_type)
{
    char	epicsname[FLDNAME_SZ];			// epics field name
    char	epicsName[FLDNAME_SZ+1];		// epics field name
    char	xrefFieldName[VU_CBASE_FIELD_SIZE];	// database field name
    char	xrefTableName[VU_TABLE_FIELD_SIZE];	// database table name
    char	trueField;				// true state field
    char	xrefOpIdName[VU_OPID_FIELD_SIZE];	// calc block operand
    char	hardwareField;				// harwdware flag
    char	xrefRefName[VU_REF_FIELD_SIZE];		// reference name
    char	xrefConstName[VU_CONST_FIELD_SIZE];	// constant name
    int		fieldType;
    int		i;

    DB_GetFieldValue (xrefRec, xrefNameField, xrefFieldName, &fieldType);
    DB_GetFieldValue (xrefRec, xrefEpicsField, epicsname, &fieldType);
    // we want to space pad any 3 letter fld name
    sprintf (epicsName, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, epicsname);
    DB_GetFieldValue (xrefRec, xrefTableField, xrefTableName, &fieldType);

    // skip non existant point types
    if ( (strlen (xrefFieldName)) == 0)
	return (VU_SUCCESS);

    // skip to next field if no table
    if ( (strlen (xrefTableName)) == 0)
	return (VU_ERROR);
    
    DB_GetFieldValue (xrefRec, xrefTrueField, &trueField, &fieldType);
    DB_GetFieldValue (xrefRec, xrefOpIdField, xrefOpIdName, &fieldType);
    DB_GetFieldValue (xrefRec, xrefHardwareField, &hardwareField, &fieldType);
    DB_GetFieldValue (xrefRec, xrefReferenceField, xrefRefName, &fieldType);
    DB_GetFieldValue (xrefRec, xrefConstantField, xrefConstName, &fieldType);

    // get a new xref node for the dictionary
    xrefNodeClass *newNode = new xrefNodeClass (FldDes, 
						field_type,
					        epicsName,
					        xrefFieldName,
					        xrefTableName,
					        trueField,
					        xrefOpIdName,
					        hardwareField,
					        xrefRefName,
					        xrefConstName);

    if ( (newNode -> getInitErrors ()) != VU_SUCCESS)
	return (VU_ERROR);
    if((i = xrefFindIndex(pointHdr,newNode->xrefTable)) >= 0)
      {
	pointHdr->xrefHdrTables[i] = newNode->xrefTable;
	strcpy(&pointHdr->xrefHdrNames[i][0],xrefTableName);
      }
    
    // add node to the dictionary, the key being the epics field name
    const vname *epics = vnameInternGlobalScribed (vcharScribeSystem(epicsName));
    dict -> SetElem ( (void *)epics, (void *)newNode);

    return (1);
}
int	vuDatabaseClass::xrefFindIndex(VU_XREFHDR_PTR xref,DB_TABLE_PTR tbl)	/* return 0-VU_MAX_TABLES or -1 on error */
{
    char	i;

    for(i = 0;i < VU_MAX_TABLES;i++)
      {
	if((xref->xrefHdrTables[i] == tbl) || (xref->xrefHdrTables[i] == 0))
	  return(i);
      }
    return(-1);
}


/*******************************************************************
*
*    vuCreateNewRecords
*	given a point type and point name create new records in
*	the appropriate databases
*
*******************************************************************/

int vuDatabaseClass::vuCreateNewRecords (int pointIndex, vchar *pvname)
{
    char		pvName [PVNAME_SZ + 1];
    char		trimmedPvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE];
    char		idString[3];
    char		id;
    int			i;
    int			enterInIoAddr;
    DB_FIELD_PTR	nameField, typeField, idField;
    DB_RECORD_PTR	rec, ioaddrRec;

    vuMainDialogClass *mainDialog = getMainDialog ();
    vcharExportBounded (vcharScribeSystemExport (pvname), pvName, PVNAME_SZ);

    // attempt to get a lock on the dbLock.lock file, if this fails
    // then do not create any new records
    if (!dbLockTest (VU_LOCK_TRIES))
    {
	vuMessageDialogCenter (NULL, VU_CREATE_NEWPT_ERR, pvname);
	return (VU_ERROR);
    }
    // message to dataVu main text screen
    mainDialog -> vuMainMessageCenter (vunames_vuCreateNewPointMsg, pvname);

    // enter into pvmap with the name field
    rec = DB_NewRecord (vuPvmapTable, pvName);
    nameField = DB_MapField (vuPvmapTable, FLD_NAME);
    DB_PutFieldValue (rec, nameField, pvName);
    // also enter the point type
    typeField = DB_MapField (vuPvmapTable, FLD_TYPE);
    DB_PutFieldValue (rec, typeField, dbRecType -> papName[pointIndex + 1]);

    enterInIoAddr = 0;
    switch (pointIndex)
    {
	case VU_AI:
	    // enter into ai.dbf
	    rec = DB_NewRecord (vuAiTable, pvName);
	    nameField = DB_MapField (vuAiTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	case VU_AO:
	    // enter into ao.dbf
	    rec = DB_NewRecord (vuAoTable, pvName);
	    nameField = DB_MapField (vuAoTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	case VU_BI:
	    // enter into di.dbf
	    rec = DB_NewRecord (vuBiTable, pvName);
	    nameField = DB_MapField (vuBiTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	case VU_BO:
	    // enter into do.dbf
	    rec = DB_NewRecord (vuBoTable, pvName);
	    nameField = DB_MapField (vuBoTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	case VU_CALC:
	    // enter into calc.dbf
	    rec = DB_NewRecord (vuCalcTable, pvName);
	    nameField = DB_MapField (vuCalcTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    // create new records in calcops.dbf for the new points
	    // inputs, A -> L
	    nameField = DB_MapField (vuCalcOpsTable, FLD_NAME);
	    idField   = DB_MapField (vuCalcOpsTable, FLD_CALCOP);
	    for (id = 'A'; id < 'M'; id++)
	    {
		rec = DB_NewRecord (vuCalcOpsTable, NULL);
		sprintf (idString, "%c\0", id);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, idString);
	    }
	    break;

	case VU_FANOUT:
	    // enter into fanout.dbf
	    rec = DB_NewRecord (vuFanoutTable, pvName);
	    nameField = DB_MapField (vuFanoutTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    // create new records in fanlink.dbf for the new points
	    // inputs, 1 -> 6
	    nameField = DB_MapField (vuFanLinkTable, FLD_NAME);
	    idField   = DB_MapField (vuFanLinkTable, FLD_LINKID);
	    for (id = '1'; id < '7'; id++)
	    {
		rec = DB_NewRecord (vuFanLinkTable, NULL);
		sprintf (idString, "%c\0", id);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, idString);
	    }
	    break;

	case VU_MBBI:
	    // enter into mbbi.dbf
	    rec = DB_NewRecord (vuMbbiTable, pvName);
	    nameField = DB_MapField (vuMbbiTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	case VU_MBBO:
	    // enter into mbbo.dbf
	    rec = DB_NewRecord (vuMbboTable, pvName);
	    nameField = DB_MapField (vuMbboTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	case VU_PID:
	    // enter into pid.dbf
	    rec = DB_NewRecord (vuPidTable, pvName);
	    nameField = DB_MapField (vuPidTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_SEL:
	    // enter into sel.dbf
	    rec = DB_NewRecord (vuSelTable, pvName);
	    nameField = DB_MapField (vuSelTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    // create new records in sellink.dbf for the new points
	    // inputs, A -> L
	    nameField = DB_MapField (vuSelLinkTable, FLD_NAME);
	    idField   = DB_MapField (vuSelLinkTable, FLD_SELECTORID);
	    for (id = 'A'; id < 'M'; id++)
	    {
		rec = DB_NewRecord (vuSelLinkTable, NULL);
		sprintf (idString, "%c\0", id);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, idString);
	    }
	    break;

	case VU_STATE:
	    // enter into state.dbf
	    rec = DB_NewRecord (vuStateTable, pvName);
	    nameField = DB_MapField (vuStateTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_STRINGIN:
	    // enter into strngin.dbf
	    rec = DB_NewRecord (vuStringinTable, pvName);
	    nameField = DB_MapField (vuStringinTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	case VU_STRINGOUT:
	    // enter into strngout.dbf
	    rec = DB_NewRecord (vuStringoutTable, pvName);
	    nameField = DB_MapField (vuStringoutTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	case VU_WAVEFORM:
	    // enter into waveform.dbf
	    rec = DB_NewRecord (vuWaveformTable, pvName);
	    nameField = DB_MapField (vuWaveformTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	case VU_LEADLAG:
	    // enter into leadlag.dbf
	    rec = DB_NewRecord (vuLeadLagTable, pvName);
	    nameField = DB_MapField (vuLeadLagTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_RAMP:
	    // enter into ramp.dbf
	    rec = DB_NewRecord (vuRampTable, pvName);
	    nameField = DB_MapField (vuRampTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_PIPE:
	    // enter into pipe.dbf
	    rec = DB_NewRecord (vuPipeTable, pvName);
	    nameField = DB_MapField (vuPipeTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);

	    // create records in pipevars.dbf
	    nameField = DB_MapField (vuPipeVarsTable, FLD_NAME);
	    idField   = DB_MapField (vuPipeVarsTable, FLD_VARDESC);
	    i = 0;
	    while (pipevars[i])
	    {
		rec = DB_NewRecord (vuPipeVarsTable, NULL);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, pipevars[i]);
		i++;
	    }

	    // create records in pipecmds.dbf
	    nameField = DB_MapField (vuPipeCmdsTable, FLD_NAME);
	    idField   = DB_MapField (vuPipeCmdsTable, FLD_COMMANDID);
	    i = 0;
	    while (pipecmds[i])
	    {
		rec = DB_NewRecord (vuPipeCmdsTable, NULL);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, pipecmds[i]);
		i++;
	    }
	    break;

	case VU_TANK:
	    // enter into tank<1,2,3,4>.dbf
	    rec = DB_NewRecord (vuTank1Table, pvName);
	    nameField = DB_MapField (vuTank1Table, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);

	    rec = DB_NewRecord (vuTank2Table, pvName);
	    nameField = DB_MapField (vuTank2Table, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);

	    rec = DB_NewRecord (vuTank3Table, pvName);
	    nameField = DB_MapField (vuTank3Table, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);

	    rec = DB_NewRecord (vuTank4Table, pvName);
	    nameField = DB_MapField (vuTank4Table, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);

	    // enter into tankvars.dbf
	    nameField = DB_MapField (vuTankVarsTable, FLD_NAME);
	    idField   = DB_MapField (vuTankVarsTable, FLD_VARDESC);
	    i = 0;
	    while (tankvars[i])
	    {
		rec = DB_NewRecord (vuTankVarsTable, NULL);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, tankvars[i]);
		i++;
	    }

	    // enter into tankvlvs.dbf
	    nameField = DB_MapField (vuTankVlvsTable, FLD_NAME);
	    idField   = DB_MapField (vuTankVlvsTable, FLD_VALVEID);
	    for (i = 1; i < 11; i++)
	    {
		rec = DB_NewRecord (vuTankVlvsTable, NULL);
		sprintf (idString, "%-d\0", i);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, idString);
	    }

	    // enter into tankcmds.dbf
	    nameField = DB_MapField (vuTankCmdsTable, FLD_NAME);
	    idField   = DB_MapField (vuTankCmdsTable, FLD_COMMANDID);
	    i = 0;
	    while (tankcmds[i])
	    {
		rec = DB_NewRecord (vuTankCmdsTable, NULL);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, tankcmds[i]);
		i++;
	    }

	    // enter into tankprbs.dbf
	    nameField = DB_MapField (vuTankPrbsTable, FLD_NAME);
	    idField   = DB_MapField (vuTankPrbsTable, FLD_PROBEID);
	    for (i = 1; i < 11; i++)
	    {
		rec = DB_NewRecord (vuTankPrbsTable, NULL);
		sprintf (idString, "%-d\0", i);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, idString);
	    }

	    break;

	case VU_VALVE:
	    // enter into valve.dbf
	    rec = DB_NewRecord (vuValveTable, pvName);
	    nameField = DB_MapField (vuValveTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);

	    // create records in vlvvars.dbf
	    nameField = DB_MapField (vuValveVarsTable, FLD_NAME);
	    idField   = DB_MapField (vuValveVarsTable, FLD_VARDESC);
	    i = 0;
	    while (valveIdString[i])
	    {
		rec = DB_NewRecord (vuValveVarsTable, NULL);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, valveIdString[i]);
		i++;
	    }
	    break;

	case VU_PUMP:
	    // enter into pump.dbf
	    rec = DB_NewRecord (vuPumpTable, pvName);
	    nameField = DB_MapField (vuPumpTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);

	    // create records in pumpvars.dbf
	    nameField = DB_MapField (vuPumpVarsTable, FLD_NAME);
	    idField   = DB_MapField (vuPumpVarsTable, FLD_VARDESC);
	    i = 0;
	    while (pumpIdString[i])
	    {
		rec = DB_NewRecord (vuPumpVarsTable, NULL);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, pumpIdString[i]);
		i++;
	    }
	    break;

	case VU_POT:
	    // enter into pot.dbf
	    rec = DB_NewRecord (vuPotTable, pvName);
	    nameField = DB_MapField (vuPotTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);

	    // create records in potvars.dbf
	    nameField = DB_MapField (vuPotVarsTable, FLD_NAME);
	    idField   = DB_MapField (vuPotVarsTable, FLD_VARDESC);
	    i = 0;
	    while (potvars[i])
	    {
		rec = DB_NewRecord (vuPotVarsTable, NULL);
		DB_PutFieldValue (rec, nameField, pvName);
		DB_PutFieldValue (rec, idField, potvars[i]);
		i++;
	    }
	    break;

	case VU_ACCUM:
	    // enter into accum.dbf
	    rec = DB_NewRecord (vuAccumTable, pvName);
	    nameField = DB_MapField (vuAccumTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_PTO:
	    // enter into pto.dbf
	    rec = DB_NewRecord (vuPtoTable, pvName);
	    nameField = DB_MapField (vuPtoTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    nameField = DB_MapField (vuIOAddrTable, FLD_NAME);
	    for (i = 0; pvName[i]; i++)
	    {
		if (pvName[i] == ' ')
		    break;
		trimmedPvName[i] = pvName[i];
	    }
	    trimmedPvName[i] = 0;
	    // usually there is only 1 IOAddr record per point
	    // but the PTO has 2, so to distinguish the 2 we append
	    // the numbers 1 - 2 to the point name
	    for (i = 1; i < 3; i++)
	    {
		sprintf (key, "%s%d\0", trimmedPvName, i);
		rec = DB_NewRecord (vuIOAddrTable, key);
		DB_PutFieldValue (rec, nameField, key);
	    }
	    break;

	case VU_DEADTIME:
	    // enter into deadtime.dbf
	    rec = DB_NewRecord (vuDeadtimeTable, pvName);
	    nameField = DB_MapField (vuDeadtimeTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_DATAMOVE:
	    // enter into datamove.dbf
	    rec = DB_NewRecord (vuDatamoveTable, pvName);
	    nameField = DB_MapField (vuDatamoveTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_TD:
	    // enter into do.dbf
	    rec = DB_NewRecord (vuTdTable, pvName);
	    nameField = DB_MapField (vuTdTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	case VU_SIGCHAR:
	    // enter into sigchar.dbf
	    rec = DB_NewRecord (vuSigCharTable, pvName);
	    nameField = DB_MapField (vuSigCharTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_UDB:
	    // enter into udb.dbf
	    rec = DB_NewRecord (vuUdbTable, pvName);
	    nameField = DB_MapField (vuUdbTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_PAT:
	    // enter into pat.dbf
	    rec = DB_NewRecord (vuPatTable, pvName);
	    nameField = DB_MapField (vuPatTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    nameField = DB_MapField (vuIOAddrTable, FLD_NAME);
	    for (i = 0; pvName[i]; i++)
	    {
		if (pvName[i] == ' ')
		    break;
		trimmedPvName[i] = pvName[i];
	    }
	    trimmedPvName[i] = 0;
	    // usually there is only 1 IOAddr record per point
	    // but the PAT has 4, so to distinguish the 4 we append
	    // the numbers 1 - 4 to the point name
	    for (i = 1; i < 5; i++)
	    {
		sprintf (key, "%s%d\0", trimmedPvName, i);
		rec = DB_NewRecord (vuIOAddrTable, key);
		DB_PutFieldValue (rec, nameField, key);
	    }
	    break;

	case VU_LDFW1:
	    // enter into ldfw1.dbf
	    rec = DB_NewRecord (vuLdfw1Table, pvName);
	    nameField = DB_MapField (vuLdfw1Table, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_LDFW2:
	    // enter into ldfw2.dbf
	    rec = DB_NewRecord (vuLdfw2Table, pvName);
	    nameField = DB_MapField (vuLdfw2Table, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    break;

	case VU_DDC:
	    // enter into ddc.dbf
	    rec = DB_NewRecord (vuDdcTable, pvName);
	    nameField = DB_MapField (vuDdcTable, FLD_NAME);
	    DB_PutFieldValue (rec, nameField, pvName);
	    enterInIoAddr = 1;
	    break;

	default:
	    break;

    }  // end switch pointIndex

    if (enterInIoAddr)
    {
	// enter into ioaddr
	ioaddrRec = DB_NewRecord (vuIOAddrTable, pvName);
	nameField = DB_MapField (vuIOAddrTable, FLD_NAME);
	DB_PutFieldValue (rec, nameField, pvName);
    }

    // release lock on dbLock.lock file
    dbUnLock ();

    return (VU_SUCCESS);
}

/*******************************************************************
*
*    vuCreateNewDatabase
*
* Create new (empty) database in specfied directory. Tell user if
* directory is /tis4000db and do not allow operation.
*
*******************************************************************/
int vuDatabaseClass::vuCreateNewDatabase(vstr *path)
{
    DB_TABLE_PTR	newTable;
    char		savePath[VU_MAX_PATH];
    int			i;

    /* save original path during the create function */
    strcpy(savePath,DB_Database.path);

    /* use path from selection box */
    strcpy(DB_Database.path,(const char *)path);
    vstrDestroy(path);

    /*
    Generate the new files here using the functions DB_CreateTable & DB_UnmapTable.
    */
    i = 0;
    // set open in exclusive mode, deny anyone else access
    DB_CodeBase.accessMode = OPEN4DENY_RW;
    while(info_array[i].file_name)
    {
	if((newTable = (DB_TABLE_PTR)DB_CreateTable((char *)info_array[i].file_name,
			(F4FIELD_INFO *)info_array[i].field_array,
			(T4TAG_INFO *)info_array[i].tag_array)) != 0)
	    DB_UnMapTable(newTable,0);
	else
	{
	    /* restore path */
	    strcpy(DB_Database.path,savePath);
	    DB_CodeBase.accessMode = OPEN4DENY_NONE;
	    /* if error then return index of problem file */
	    return(vFALSE);
	}
	i++;
    }
    /* restore path */
    strcpy(DB_Database.path,savePath);
    // restore open to anyone access
    DB_CodeBase.accessMode = OPEN4DENY_NONE;
    return(vTRUE);
}
//
// This function will check then supplied point name to make sure it exists
// in all the pertinent files. Returns 0 if not and 1 if OK
//
int vuDatabaseClass::vuVerifyDb(char *name,int type)
{
    char	padName[PVNAME_SZ+FLDNAME_SZ+1];
    char	key[PVNAME_SZ+FLDNAME_SZ+1];
    char	padKey[PVNAME_SZ+FLDNAME_SZ+1],i;
    char	*space;
    char	Name[PVNAME_SZ+FLDNAME_SZ+1];
    char	fileList[VU_MAX_PATH];
    int		stat = 1;	/* assume OK */

    strcpy(Name,name);
    if((space = (char *)strchr(Name,' ')) != 0)
    {
	*space = 0;
    }
    sprintf(padName,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,Name);
    /*
    Check in pvmap first to see if this point is deleted. If it
    is then return 0 and check no further
    */
    DB_Seek(vuPvmapTable,padName);
    if(DB_IsDeleted(vuPvmapTable))
    {
	return(0);
    }
    /*
    Not deleted then check other files.
    */
    fileList[0] = 0;
    for(i = 0;i < VU_MAX_TABLES;i++)
    {
	if(vuXREFTables[type].xrefHdrTables[i] == 0)
	{
	    continue;		/* no table...skip it */
	}
        if(vuXREFTables[type].xrefHdrTables[i] == vuPvmapTable)
	{
	    continue;		/* checked this one already */
	}
	if((vuXREFTables[type].xrefHdrTables[i] == vuIOAddrTable) &&
	   ((type == VU_PTO) || (type == VU_PAT)))
	{
	    sprintf(key,"%s1\0",Name);
    	    sprintf(padKey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,key);
	    if((DB_Seek(vuXREFTables[type].xrefHdrTables[i],padKey)) != (DB_RECORD_PTR)1)
	    {
		stat = 0;
		strcat(fileList,&vuXREFTables[type].xrefHdrNames[i][0]);
		strcat(fileList,".dbf, ");
	    }
	}
	else if((DB_Seek(vuXREFTables[type].xrefHdrTables[i],padName)) != (DB_RECORD_PTR)1)
	{
	    stat = 0;
	    strcat(fileList,&vuXREFTables[type].xrefHdrNames[i][0]);
	    strcat(fileList,".dbf, ");
	}
    }
    //
    // pop-up warning dialog if this test fails... make it modal
    //
    if(stat == 0)
    {
	fileList[strlen(fileList)-2] = 0;	//drop last comma
	vuMessageDialogCenter(NULL, VU_PARTIALPT_MSG,Name,fileList);
    }
    return(stat);
}
void vuDatabaseClass::ResListHasChanged(int state)
{
    resListState = state;
}
void vuDatabaseClass::IocListHasChanged(int state)
{
    iocListState = state;
}
int vuDatabaseClass::IocListChanged(void)
{
    return(iocListState);
}
int vuDatabaseClass::ResListChanged(void)
{
    return(resListState);
}

/*******************************************************************
*
*    class xrefNodeClass constructor
*
*******************************************************************/

xrefNodeClass::xrefNodeClass (struct fldDes *fldDes,
			      int	    fieldType,
			      char	    *epicsName,
			      char	    *cbaseName,
			      char	    *tableName,
			      char	    isTrue,
			      char	    *opIdName,
			      char	    hardware,
			      char	    *refName,
			      char	    *constName)
{
    initErrors = VU_SUCCESS;
    vuFldDes = fldDes;
    xrefEPICSFieldType = fieldType;
    strncpy (xrefEpicsName, epicsName, sizeof (xrefEpicsName));
    xrefEpicsName [sizeof (xrefEpicsName) - 1] = 0;
    strncpy (xrefCbaseName, cbaseName, sizeof (xrefCbaseName));
    xrefCbaseName[sizeof (xrefCbaseName) - 1] = 0;
    strncpy (xrefTableName, tableName, sizeof (xrefTableName));
    xrefTableName [sizeof (xrefTableName) - 1] = 0;
    xrefTrue = isTrue;
    strncpy (xrefOpId, opIdName, sizeof (xrefOpId));
    xrefOpId [sizeof (xrefOpId) - 1] = 0;
    xrefHardware = hardware;
    strncpy (xrefRefName, refName, sizeof (xrefRefName));
    xrefRefName [sizeof (xrefRefName) - 1] = 0;
    strncpy (xrefConstName, constName, sizeof (xrefConstName));
    xrefConstName [sizeof (xrefConstName) - 1] = 0;

    // now get some pointers to fields in the points database file

    if ( (xrefTable = DB_MapTable (xrefTableName)) == 0)
    {
	initErrors = VU_ERROR;
	return;
    }
    // get pointer to the field in the database
    xrefField      = DB_MapField (xrefTable, xrefCbaseName);
    // get pointers to these fields also, if they exist
    xrefRefField   = DB_MapField (xrefTable, xrefRefName);
    xrefConstField = DB_MapField (xrefTable, xrefConstName);

    // set flag to indicate that this field is in the commondialog
    if ( ((strncmp (epicsName, "NAME", FLDNAME_SZ)) == 0) ||
	 ((strncmp (epicsName, "DESC", FLDNAME_SZ)) == 0) ||
	 ((strncmp (epicsName, "LOC ", FLDNAME_SZ)) == 0) ||
	 ((strncmp (epicsName, "PRIV", FLDNAME_SZ)) == 0) ||
	 ((strncmp (epicsName, "PHAS", FLDNAME_SZ)) == 0) ||
	 ((strncmp (epicsName, "EVNT", FLDNAME_SZ)) == 0) ||
	 ((strncmp (epicsName, "RESN", FLDNAME_SZ)) == 0) ||
	 ((strncmp (epicsName, "SCAN", FLDNAME_SZ)) == 0) ||
	 ((strncmp (epicsName, "SDIS", FLDNAME_SZ)) == 0) ||
	 ((strncmp (epicsName, "DISV", FLDNAME_SZ)) == 0) ||
	 ((strncmp (epicsName, "FLNK", FLDNAME_SZ)) == 0) )
	inCommonDialog = vTRUE;
    else
	inCommonDialog = vFALSE;

    // set first time flag
    firstTime = vTRUE;

    // set inDialog flag
    inDialog = 0;
}
/*******************************************************************
*
*	check for fields that are not supposed to be on the display or
*   exported.
*
********************************************************************/
int vuDatabaseClass::vuCheckOnScreen(char *field,int type)
{
	int i;
	char **check;
	check = offScreenFields[type];
	i = 0;
	while(check[i])
	{
		if(!strncmp(check[i],field,FLDNAME_SZ))
			return(vFALSE);
		i++;
	}
	return(vTRUE);						// vTRUE means the field is on the screen
}


/*******************************************************************
*
*    class xrefNodeClass destructor
*
*******************************************************************/

xrefNodeClass::~xrefNodeClass (void)
{
}

