#ifndef	vudatabaseclassHXX
#define	vudatabaseclassHXX

//** SOME DEFINES *******************************************************************

// defines for the xrefNode
#define	VU_CBASE_FIELD_SIZE	20
#define	VU_TABLE_FIELD_SIZE	20
#define	VU_OPID_FIELD_SIZE	20
#define	VU_REF_FIELD_SIZE	10
#define	VU_CONST_FIELD_SIZE	10
#define	VU_KEY_SIZE		128
#define	VU_LOCK_TRIES		120
#define	VU_MAX_TABLES		10

// defines for some database files
#define	VU_ACCUMFILE	"accum"
#define	VU_AIFILE	"ai"
#define	VU_ALARMINFOFILE	"alarminf"
#define	VU_ALGRLISTFILE	"agroups"
#define	VU_AOFILE	"ao"
#define	VU_APIFILE	"apitbl"
#define	VU_ARREDUCFILE	"ar_reduc"
#define	VU_BIFILE	"di"
#define	VU_BOFILE	"do"
#define	VU_CALCFILE	"calc"
#define	VU_CALCOPFILE	"calcops"
#define	VU_DATAMOVEFILE	"datamove"
#define	VU_DDCFILE	"ddc"
#define	VU_DEADTIMEFILE	"deadtime"
#define	VU_FANLINKFILE	"fanlink"
#define	VU_FANOUTFILE	"fanout"
#define	VU_FIELDTABFILE	"fldprott"
#define	VU_IOADDRFILE	"ioaddr"
#define	VU_IOCLISTFILE	"ioclist"
#define	VU_LAUNCHCFGFILE	"grphicdb"
#define	VU_LDFW1FILE	"ldfw1"
#define	VU_LDFW2FILE	"ldfw2"
#define	VU_LEADLAGFILE	"leadlag"
#define	VU_MBBIFILE	"mbbi"
#define	VU_MBBOFILE	"mbbo"
#define	VU_PATFILE	"pat"
#define	VU_PIDFILE	"pid"
#define	VU_PIPEFILE	"pipe"
#define	VU_PIPECMDSFILE	"pipecmds"
#define	VU_PIPEVARSFILE	"pipevars"
#define	VU_POTFILE	"pot"
#define	VU_POTVARSFILE	"potvars"
#define	VU_PTOFILE	"pto"
#define	VU_PUMPFILE	"pump"
#define	VU_PUMPVARSFILE	"pumpvars"
#define	VU_PRIVTABFILE	"privtab"
#define	VU_PVMAPFILE	"pvmap"
#define	VU_RAMPFILE	"ramp"
#define	VU_RESLISTFILE	"reslist"
#define	VU_SCRIPTFILE	"scriptdb"
#define	VU_SELFILE	"sel"
#define	VU_SELLINKFILE	"sellink"
#define	VU_SIGFILE	"sigchar"
#define	VU_STATEFILE	"state"
#define	VU_STRAPFILE	"straptbl"
#define	VU_STRINGINFILE	"strngin"
#define	VU_STRINGOUTFILE	"strngout"
#define	VU_SYSUSERSFILE	"sysusers"
#define	VU_TANK1FILE	"tank1"
#define	VU_TANK2FILE	"tank2"
#define	VU_TANK3FILE	"tank3"
#define	VU_TANK4FILE	"tank4"
#define	VU_TANKCMDSFILE	"tankcmds"
#define	VU_TANKPRBSFILE	"tankprbs"
#define	VU_TANKVARSFILE	"tankvars"
#define	VU_TANKVLVSFILE	"tankvlvs"
#define	VU_TDFILE	"td"
#define	VU_UDBFILE	"udb"
#define	VU_UDBCONFIGFILE "udbcfg"
#define	VU_VALVEFILE	 "valve"
#define	VU_VALVEVARSFILE "vlvvars"
#define	VU_WAVEFORMFILE	"waveform"
#define	VU_XREFFILE	"pdbxref"

// define xref field names
#define	FLD_EPICS_FIELD_NAME	"FIELDNAME"
#define	FLD_FIELD_NAME	"FIELD_NAME"
#define	FLD_TABLE	"TABLE"
#define	FLD_TRUE_STATE	"TRUE_STATE"
#define	FLD_CALCOP	"OPERANDID"
#define	FLD_REFFIELD	"REFFIELD"
#define	FLD_CONSTFIELD	"CONSTFIELD"
#define	FLD_HARDFIELD	"HWFLAG"

// define a key used by several databases
#define	FLD_CALCOP_KEY	"NAMEID"

// defines for the fields in ioaddr.dbf
#define	FLD_ADDRESS	"ADDRESS"
#define	FLD_CARD	"CARD"
#define	FLD_LINE	"LINE"
#define	FLD_SIGNAL	"SIGNAL"

// defines for pvmap
#define	FLD_ALARMGROUP	"ALARMGROUP"
#define	FLD_DESC	"DESC"
#define	FLD_DEVTYPE	"DEVTYPE"
#define	FLD_LOCATION	"LOCATION"
#define	FLD_MERGE	"MERGE"
#define	FLD_NAME	"NAME"		// used by many other tables also
#define	FLD_TREND	"ONTREND"
#define	FLD_PROTECTION	"PRIVGROUP"
#define	FLD_RESOURCE	"RESRCNAME"
#define	FLD_SCANRATE	"SRATE"
#define	FLD_TYPE	"TYPE"

// defines for other fields
#define	FLD_ARCH_PTNAME_KEY		"POINTNAME"
#define	FLD_ARCH_PTNAME_METH_KEY	"POINTMETH"
#define	FLD_ARCH_CHAN	"POINTNAME"
#define	FLD_ARCH_TIME	"STARTTIME"
#define	FLD_ARCH_RATE	"RATE"	
#define	FLD_ARCH_METHOD	"METHOD"
#define	FLD_ARCH_ARCHIVE "ARCHIVE"
#define	FLD_COMMANDID	"COMMANDID"
#define	FLD_CONSTANT	"CONSTANT"
#define	FLD_DISPLAY	"DISPLAY"
#define	FLD_FRZSEVR	"FRZSEVR"
#define FLD_FRZRUNSEVR	"FRZRUNSEVR"
#define	FLD_FTAB_KEY	"TYPEFIELD"
#define	FLD_FTAB_TYPE	"POINTTYPE"
#define	FLD_FTAB_FIELD	"FIELDNAME"
#define	FLD_FTAB_LEVEL	"PRIVLEVEL"
#define	FLD_GROUPNAME	"GROUPNAME"
#define	FLD_GUIDANCE	"GUIDANCE"
#define	FLD_IOC1	"PRIMARYIOC"
#define	FLD_IOC2	"SECNDRYIOC"
#define	FLD_IOCNAME	"IOCNAME"
#define	FLD_ISHOST	"IS_HOST"
#define	FLD_LINKID	"LINKID"
#define	FLD_NOSYNC	"NO_SYNC"
#define	FLD_OPERID	"OPERATORID"
#define	FLD_OPERTYPE	"OPTYPE"
#define	FLD_PRIVKEY	"OPERGROUP"
#define	FLD_PROBEID	"PROBEID"
#define	FLD_PROT_GRP	"PROT_GROUP"
#define	FLD_PRIV_LVL	"PRIV_LEVEL"
#define	FLD_VARDESC	"VARDESC"
#define	FLD_REFERENCE	"REFERENCE"
#define	FLD_SELECTORID	"SELECTORID"
#define	FLD_UDBPGNAME	"UDBNAME"
#define	FLD_VALVEID	"VALVEID"
#define	FLD_PROCINPUT	"PROC_INPUT"
#define	FLD_MAXSEVERITY	"MAXSEVERTY"

// DPA field in resource table
#define FLD_DPA		"DPA"


//** SOME TYPEDEFS ******************************************************************

typedef struct
{
    char *xtraName;	// simulated EPICS field name
    int  xtraType;	// simulated EPICS field type
} VU_EXTRAFIELDS;


//**  CROSS REFERENCE TABLE CLASS ***************************************************

class xrefNodeClass
{

    // error indicator from constructor
    int		initErrors;

    // flag set if field is in common dialog
    int		inCommonDialog;

    // first time flag when this node is accessed
    int		firstTime;

    // flag used by some multi dialog point types
    int		inDialog;

public:

    // constructor
    xrefNodeClass (struct fldDes *vuFldDes,
		   int		 fieldType,
		   char		 *epicsName,
		   char		 *cbaseName,
		   char		 *tableName,
		   char		 isTrue,
		   char		 *opId,
		   char		 hardware,
		   char		 *refName,
		   char		 *constName);

    // destructor
    ~xrefNodeClass ();

    // get the initErrors flag
    int getInitErrors (void) { return (initErrors); }

    // handle inCommonDialog flag
    void setInCommonDialog (int flag) { inCommonDialog = flag; }
    int getInCommonDialog (void) { return (inCommonDialog); }

    // handle firstTime flag
    void setFirstTimeFlag (int flag) { firstTime = flag; }
    int getFirstTimeFlag (void) { return (firstTime); }

    // handle inDialog flag
    void setInDialogFlag (int flag) { inDialog = flag; }
    int getInDialogFlag (void) { return (inDialog); }

    struct fldDes	*vuFldDes;			// ptr to SDR field description
    DB_TABLE_PTR	xrefTable;			// used to access point specific table 
    DB_FIELD_PTR	xrefField;			// dbase field pointer 
    DB_FIELD_PTR	xrefRefField;		// for reference field in xxx.DBF
    DB_FIELD_PTR	xrefConstField;		// for constant field in xxx.DBF
    int			xrefEPICSFieldType;		// from vuFldDes of extra fields
    char	xrefEpicsName [FLDNAME_SZ + 1];
    char	xrefCbaseName [VU_CBASE_FIELD_SIZE + 1];
    char	xrefTableName [VU_TABLE_FIELD_SIZE + 1];
    char	xrefTrue;
    char	xrefOpId [VU_OPID_FIELD_SIZE + 1];
    char	xrefHardware;
    char	xrefRefName [VU_REF_FIELD_SIZE + 1];
    char	xrefConstName [VU_CONST_FIELD_SIZE + 1];
	char	xrefImportString[VU_KEY_SIZE];
	char	xrefImportValid;
	char	xrefNotOnScreen;			// true if in SDR but not on point type form(s)
};


//**  VU DATABASE CLASS ***************************************************

class vuDatabaseClass
{
    
    vresource	dataVuvresource;		// resource to dataVu
    vdict	*xrefDicts [VU_NUMPOINTS];	// one xref dict for each point type
    char	dbasePath [VU_MAX_PATH];	// place to store current 
							// database path
    int		initErrors;		// set to non-zero if errors from 
					// constructor
    int vuDatabaseInit (char *dbPath);	// function to load the database
    int vuBuildXREFTable (void);	// build internal tables
    int vuAddToXrefDict (vdict *dict, 
			 DB_RECORD_PTR xrefRec,
			 struct fldDes *vuFldDes,
			 int field_type);

    vuMainDialogClass	*mainDialogClass;
    typedef struct
    {
	// related table handles for this point type
	DB_TABLE_PTR	xrefHdrTables[VU_MAX_TABLES];
	// related table names for this point type 
	char		xrefHdrNames[VU_MAX_TABLES][VU_MAX_PATH];
    }VU_XREFHDR,*VU_XREFHDR_PTR;

#define	XREFHDRSIZE	sizeof(VU_XREFHDR)
    VU_XREFHDR_PTR	vuXREFTables;	// indexed by point type
    VU_XREFHDR_PTR	pointHdr;	// pointer to info for this point type 


public:

    // constructor
    vuDatabaseClass (char *dbPath, vresource dataVuvresource);

    // destructor
    ~vuDatabaseClass (void);
	// array of array of EPICS-like field name strings
	VU_EXTRAFIELDS	*xrefExtraFields[VU_NUMPOINTS];
 	char	**offScreenFields[VU_NUMPOINTS];
   // function to handle dbasePath
    char *getDbasePath (void)
	{ return (dbasePath); }

    // function to return initErrors
    int getInitErrors (void) 
	{ return (initErrors); }

    // function to return xref dictionaries
    vdict **getXrefDicts (void) 
	{ return (xrefDicts); }
    vdict *getXrefDict (int idx) 
	{ return ((idx >= VU_NUMPOINTS) ? NULL : xrefDicts[idx]); }

    // function to create records for a given point type
    int vuCreateNewRecords (int pointtype, vchar *pvname);

	// function to create new database files
    static int vuCreateNewDatabase(vstr *path);

	// function to check the Off-Screen field arrays
	vuCheckOnScreen(char *field,int type);

    // functions to handle the mainDialogClass
    void storeMainDialog (vuMainDialogClass *mainDialog) 
	{ mainDialogClass = mainDialog; }
    vuMainDialogClass *getMainDialog (void) 
	{ return (mainDialogClass); }
    //
    // This function will check then supplied point name to make sure it exists
    // in all the pertinent files. Returns 0 if not and 1 if OK
    //
    int vuVerifyDb(char *name,int type);

    // return 0-VU_MAX_TABLES or -1 on error
    int xrefFindIndex(VU_XREFHDR_PTR xref,DB_TABLE_PTR tbl);

    void ResListHasChanged(int state);
    void IocListHasChanged(int state);
    int IocListChanged(void);
    int ResListChanged(void);
private:
    int resListState;	    // vTRUE if list has been modified
    int iocListState;	    // vTRUE if list has been modified

public:
    // pointers into the cross reference table
    DB_TABLE_PTR	vuXrefTable;
    DB_FIELD_PTR	xrefNameField;
    DB_FIELD_PTR	xrefTableField;
    DB_FIELD_PTR	xrefTrueField;
    DB_FIELD_PTR	xrefOpIdField;
    DB_FIELD_PTR	xrefReferenceField;
    DB_FIELD_PTR	xrefConstantField;
    DB_FIELD_PTR	xrefHardwareField;
    DB_FIELD_PTR	xrefEpicsField;

    // pointers to various database tables (.dbf)
    DB_TABLE_PTR	vuAccumTable;
    DB_TABLE_PTR	vuAiTable;
    DB_TABLE_PTR	vuAlarmInfoTable;
    DB_TABLE_PTR	vuAlgrListTable;
    DB_TABLE_PTR	vuAoTable;
    DB_TABLE_PTR	vuApiTable;
    DB_TABLE_PTR	vuArReducTable;
    DB_TABLE_PTR	vuBiTable;
    DB_TABLE_PTR	vuBoTable;
    DB_TABLE_PTR	vuCalcTable;
    DB_TABLE_PTR	vuCalcOpsTable;
    DB_TABLE_PTR	vuDatamoveTable;
    DB_TABLE_PTR	vuDdcTable;
    DB_TABLE_PTR	vuDeadtimeTable;
    DB_TABLE_PTR	vuFanLinkTable;
    DB_TABLE_PTR	vuFanoutTable;
    DB_TABLE_PTR	vuFldProtTable; 
    DB_TABLE_PTR	vuIOAddrTable;
    DB_TABLE_PTR	vuIocListTable;
    DB_TABLE_PTR	vuLaunchCfgTable;
    DB_TABLE_PTR	vuLdfw1Table;
    DB_TABLE_PTR	vuLdfw2Table;
    DB_TABLE_PTR	vuLeadLagTable;
    DB_TABLE_PTR	vuMbbiTable;
    DB_TABLE_PTR	vuMbboTable;
    DB_TABLE_PTR	vuPatTable;
    DB_TABLE_PTR	vuPidTable;
    DB_TABLE_PTR	vuPipeTable;
    DB_TABLE_PTR	vuPipeCmdsTable;
    DB_TABLE_PTR	vuPipeVarsTable;
    DB_TABLE_PTR	vuPotTable;
    DB_TABLE_PTR	vuPotVarsTable;
    DB_TABLE_PTR	vuPtoTable;
    DB_TABLE_PTR	vuPumpTable;
    DB_TABLE_PTR	vuPumpVarsTable;
    DB_TABLE_PTR	vuPrivTabTable; 
    DB_TABLE_PTR	vuPvmapTable;
    DB_TABLE_PTR	vuRampTable;
    DB_TABLE_PTR	vuResListTable;
    DB_TABLE_PTR	vuScriptTable;
    DB_TABLE_PTR	vuSelTable;
    DB_TABLE_PTR	vuSelLinkTable;
    DB_TABLE_PTR	vuSigCharTable;
    DB_TABLE_PTR	vuStateTable;
    DB_TABLE_PTR	vuStrapTable;
    DB_TABLE_PTR	vuStringinTable;
    DB_TABLE_PTR	vuStringoutTable;
    DB_TABLE_PTR	vuSysUsersTable;
    DB_TABLE_PTR	vuTank1Table;
    DB_TABLE_PTR	vuTank2Table;
    DB_TABLE_PTR	vuTank3Table;
    DB_TABLE_PTR	vuTank4Table;
    DB_TABLE_PTR	vuTankCmdsTable;
    DB_TABLE_PTR	vuTankPrbsTable;
    DB_TABLE_PTR	vuTankVarsTable;
    DB_TABLE_PTR	vuTankVlvsTable;
    DB_TABLE_PTR	vuTdTable;
    DB_TABLE_PTR	vuUdbCfgTable;
    DB_TABLE_PTR	vuUdbTable;
    DB_TABLE_PTR	vuValveTable;
    DB_TABLE_PTR	vuValveVarsTable;
    DB_TABLE_PTR	vuWaveformTable;

    // pointers to some database fields
    DB_FIELD_PTR	ioaddrAddress;
    DB_FIELD_PTR	ioaddrCard;
    DB_FIELD_PTR	ioaddrLine;
    DB_FIELD_PTR	ioaddrSignal;

    DB_FIELD_PTR	pvmapTypeField;

    DB_FIELD_PTR	iocNameField;
    DB_FIELD_PTR	iocSyncField;
    DB_FIELD_PTR	iocHostField;

    DB_FIELD_PTR	resNameField;
    DB_FIELD_PTR	resDPAField;
};

#endif	vudatabaseclassHXX
