#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceDdc.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuDdcDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuDdcDialogClass, vuCommonDialogClass, "vuDdcDialogClass");

/*******************************************************************
*
*    vuDdcDialogClass override for constructors init ()
*
*******************************************************************/

void vuDdcDialogClass::LoadInit (vresource res)
{
    // load in the ddc specific fields
    ddcContainer = vuDdcContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    ddcContainer -> boardType -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> line -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> addr -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> card -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> signal -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> initAction -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> output -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> manual -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> closedLoop -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> useFirstReset -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> resetLink -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> procReset -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> msReset -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> resetValue -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> stepInput -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> procStepInput -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> msStepInput -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> primaryCascade -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> downstreamCascade -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> drumControlType -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> operatingMode -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> timingMode -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> activeEdge -> vuSetModifiedPtr (&this -> dialogModified);
    ddcContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);
    ddcContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    ddcContainer -> outputButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    ddcContainer -> resetLinkButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    ddcContainer -> stepInputButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    ddcContainer -> downstreamCascadeButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    ddcContainer -> primaryCascadeButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    ddcContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    ddcContainer -> output -> storeCommonDialog ((vuCommonDialogClass *)this);
    ddcContainer -> resetLink -> storeCommonDialog ((vuCommonDialogClass *)this);
    ddcContainer -> stepInput -> storeCommonDialog ((vuCommonDialogClass *)this);
    ddcContainer -> primaryCascade -> storeCommonDialog ((vuCommonDialogClass *)this);
    ddcContainer -> downstreamCascade -> storeCommonDialog ((vuCommonDialogClass *)this);
    ddcContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    ddcContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_DDC);

    // get the title from the resource file, ddcTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    ddcTitle = vresourceGetString (dialogTitles, 
				vunames_vuDdcDialogTitle);
    SetTitle (ddcTitle);

    // get resource for the output dialog, store it and set mod flags 
    // for its fields

    // load up the output dialog
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource outputDialogRes = vresourceGet (pointDictRes, vunames_vuDdcOutputDialog);
    outputDialog = new vuDdcOutputDialogClass (outputDialogRes);

    // store ptr to output values  dialog and ddc dialog in the values button
    ddcContainer -> outputValuesButton -> storeDdcDialog (this);
    ddcContainer -> outputValuesButton -> storeDdcOutputDialog (outputDialog);

    // store dialog modified flag for output dialog fields
    outputDialog -> time1 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value1 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time2 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value2 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time3 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value3 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time4 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value4 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time5 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value5 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time6 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value6 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time7 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value7 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time8 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value8 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time9 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value9 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time10 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value10 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time11 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value11 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time12 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value12 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time13 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value13 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time14 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value14 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time15 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value15 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time16 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value16 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time17 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value17 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time18 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value18 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time19 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value19 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time20 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value20 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time21 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value21 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time22 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value22 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time23 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value23 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time24 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value24 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time25 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value25 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time26 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value26 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time27 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value27 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time28 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value28 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time29 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value29 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time30 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value30 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time31 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value31 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> time32 -> SetTextModifiedPtr (&this -> dialogModified);
    outputDialog -> value32 -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> numOutputWords -> SetModifiedPtr (&this -> dialogModified);
    outputDialog -> numOutputBits -> SetModifiedPtr (&this -> dialogModified);
}


/*******************************************************************
*
*    vuDdcDialogClass Destroy function
*
*******************************************************************/

void vuDdcDialogClass::Destroy (void)
{
    vstrDestroy (ddcTitle);
    // delete the output dialog
    delete outputDialog;
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuDdcDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuDdcDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    int			firstTimeFlag;
    int			inDialogFlag;

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    firstTimeFlag = xrefNode -> getFirstTimeFlag ();
	    // only need to do this once
	    if (firstTimeFlag == vTRUE)
	    {
		xrefNode -> setFirstTimeFlag (vFALSE);
		// find which dialog this field is in
		dialogItem = vuFindContainerItem (ddcContainer, epics);
		if (dialogItem == NULL)
		{
		    dialogItem = vuFindDialogItem (outputDialog, epics);
		    if (dialogItem == NULL)
		    {
			xrefNode -> setInDialogFlag (VU_DDC_NOT_IN_DIALOG);
			continue;
		    }
		    else
		    {
			xrefNode -> setInDialogFlag (VU_DDC_OUTPUT_DIALOG);
		    }
		}
		else
		{
		    xrefNode -> setInDialogFlag (VU_DDC_IN_MAIN_DIALOG);
		}
	    }
	    else
	    {
		inDialogFlag = xrefNode -> getInDialogFlag ();
		dialogItem = NULL;
		switch (inDialogFlag)
		{
		    case VU_DDC_NOT_IN_DIALOG:
			break;

		    case VU_DDC_IN_MAIN_DIALOG:
			dialogItem = vuFindContainerItem (ddcContainer, epics);
			break;

		    case VU_DDC_OUTPUT_DIALOG:
			dialogItem = vuFindDialogItem (outputDialog, epics);
			break;

		    default:
			break;
		}
	    }
	
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the ddc's line field
		if ( ((vcharCompareBounded (epics, "LINE", FLDNAME_SZ)) == 0) ||
		     ((vcharCompareBounded (epics, "ADDR", FLDNAME_SZ)) == 0) ||
		     ((vcharCompareBounded (epics, "CARD", FLDNAME_SZ)) == 0) ||
		     ((vcharCompareBounded (epics, "SIGN", FLDNAME_SZ)) == 0) )
		{
		    vstr *zero = vresourceGetString (defRes, 
						vunames_vuZeroDefault);
		    textItem -> SetText (zero);
		    vstrDestroy (zero);
		}
		else if ( (vcharCompareBounded (epics, "RESV", FLDNAME_SZ)) == 0)
		{
		    vstr *one = vresourceGetString (defRes, 
						vunames_vuOneDefault);
		    textItem -> SetText (one);
		    vstrDestroy (one);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (spinner -> GetMin());
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuDdcDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;
    DTYP_TYPE		dType;		// device type indicator
    int			inDialogFlag;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);
    
    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT a DDC
	if (ptType != VU_DDC)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_DDC);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    // since the ddc can be a hardware point, find what we are for later use
    // by getting the DTYP (device type) dictionary entry
    referenceString = vstrCloneScribed (vcharScribeSystem ("REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("CONSTANT"));
    xrefNode = (xrefNodeClass *)(dict -> GetElem (
				vnameGetGlobalScribed (vcharScribeSystem ("DTYP"))));
    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
    if ( (vcharCompare ((const vchar *)dbValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare ((const vchar *)dbValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
	    {
		sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
	    }
	    lastTable = xrefNode -> xrefTable;
	    inDialogFlag = xrefNode -> getInDialogFlag ();
	    dialogItem = NULL;
	    switch (inDialogFlag)
	    {
		case VU_DDC_NOT_IN_DIALOG:
		    break;

		case VU_DDC_IN_MAIN_DIALOG:
		    dialogItem = vuFindContainerItem (ddcContainer, epics);
		    break;

		case VU_DDC_OUTPUT_DIALOG:
		    dialogItem = vuFindDialogItem (outputDialog, epics);
		    break;

		default:
		    break;
	    }
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    // to output CONSTANT field, device type must be CONSTANT
		    if ( (strncmp (xrefNode -> xrefEpicsName, "CNST", FLDNAME_SZ)) 
										== 0)
		    {
			if (dType != VU_CONSTANT)
			    continue;
		    }
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_OUTLINK:
		    // device type must be REFERENCE to output the reference
		    if (dType == VU_REFERENCE)
		    {
			DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
								dbValue, &dbaseType);
			finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    }
		    else
		    {
			finalValue = vstrCloneScribed (vcharScribeSystem (""));
		    }
		    break;

		case DBF_INLINK:
		    // works for all ddc inputs, see pdbxref
		    DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
								dbValue, &dbaseType);
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (vnum::ParseInt (finalValue, NULL));
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuDdcDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    char		vuCurrentBoard [VU_KEY_SIZE];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dType;		// device type
    double		doubleValue;
    int			doSave;
    int			inDialogFlag;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    // since the bo can be a hardware point, find what we are for later use
    // by getting the DTYP (BOARD) value from the dialog
    referenceString = vstrCloneScribed (vcharScribeSystem ("REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("CONSTANT"));
    vcharCopyScribedBounded (vcharScribeSystem ("DTYP"), epics, FLDNAME_SZ);
    epics[sizeof (epics) - 1] = 0;
    // find the BOARD (DTYP) field and get its value
    dialogItem = vuFindContainerItem (ddcContainer, epics);
    optionMenu = (vcontrolOptionMenu *)dialogItem;
    optionMenuValue = vuGetOptionMenuValue (optionMenu);
    vcharExport (vcharScribeSystemExport (optionMenuValue), (void *)vuCurrentBoard);
    if ( (vcharCompare (optionMenuValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare (optionMenuValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
	    {
		sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    inDialogFlag = xrefNode -> getInDialogFlag ();
	    dialogItem = NULL;
	    switch (inDialogFlag)
	    {
		case VU_DDC_NOT_IN_DIALOG:
		    break;

		case VU_DDC_IN_MAIN_DIALOG:
		    dialogItem = vuFindContainerItem (ddcContainer, epics);
		    break;

		case VU_DDC_OUTPUT_DIALOG:
		    dialogItem = vuFindDialogItem (outputDialog, epics);
		    break;

		default:
		    break;
	    }

	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
		    {
			spinner = (vspinner *)dialogItem;
			// fix, spinner not have proper value
			spinner -> Unfocus ();
			stringValue = spinner -> GetTextAsString ();
		    }
		    else
		    {
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
		    }
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    if ( (strncmp (xrefNode -> xrefEpicsName, "CNST", FLDNAME_SZ)) 
										== 0)
		    {
			if (dType != VU_CONSTANT)
			    doubleValue = 0;
		    }
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    if ( (strncmp (xrefNode -> xrefEpicsName, "DTYP", FLDNAME_SZ)) == 0)
		    {
			// write to DEVTYPE in pvmap
			DB_PutFieldValue (pntRecord, xrefNode -> xrefField, dbValue);
		    }
		    break;
		}

		case DBF_OUTLINK:
		    // there is only 1 output and that is OUT
		    // always write the boardtype from DTYP into the OUT field
		    DB_PutFieldValue (pntRecord, putField, vuCurrentBoard);
		    // if we are a reference then write OUT into the REFERENCE field
		    if (dType == VU_REFERENCE)
		    {
			putField = xrefNode -> xrefRefField;
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
			vcharExport (vcharScribeSystemExport (stringValue), dbValue);
			vstrDestroy (stringValue);
		    }
		    else
		    {
			// make sure to null out the field
			putField = xrefNode -> xrefRefField;
			vmemSet (dbValue, 0, VU_KEY_SIZE);
		    }
		    break;

		case DBF_INLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuDdcContainerClass, vcontainer, "vuDdcContainerClass");

/*******************************************************************
*
*    vuDdcContainerClass override for constructor
*
*******************************************************************/

void vuDdcContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuDdcContainer);

    vcontainer *btcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcDTYPContainer);
    boardType = vuBoardTypeMenuClass::RequestSubLoad (btcontainer,
				vunames_DTYP);

    vcontainer *linecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcLINEContainer);
    line = filteredTextitem::RequestSubLoad (linecontainer,
				vunames_LINE);

    vcontainer *addrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcADDRContainer);
    addr = filteredTextitem::RequestSubLoad (addrcontainer,
				vunames_ADDR);

    vcontainer *cardcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcCARDContainer);
    card = filteredTextitem::RequestSubLoad (cardcontainer,
				vunames_CARD);

    vcontainer *signalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcSIGNContainer);
    signal = filteredTextitem::RequestSubLoad (signalcontainer,
				vunames_SIGN);

    vcontainer *iactcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcIACTContainer);
    initAction = vuChoiceRecMenuClass::RequestSubLoad (iactcontainer,
				vunames_IACT);

    vcontainer *outcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOUTContainer);
    outputButton = vuPvNameButtonClass::RequestSubLoad (outcontainer,
				vunames_vuDdcOUTButton);
    output = vuFilteredTextitem::RequestSubLoad (outcontainer,
				vunames_OUT);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    manual = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MODE);

    closedLoop = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OMSL);

    useFirstReset = vuCheckBoxClass::RequestSubLoad (this,
				vunames_FRST);

    vcontainer *rslncontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcRSLNContainer);
    resetLinkButton = vuPvNameButtonClass::RequestSubLoad (rslncontainer,
				vunames_vuDdcRSLNButton);
    resetLink = vuFilteredTextitem::RequestSubLoad (rslncontainer,
				vunames_RSLN);
    procReset = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCR);
    msReset = vuCheckBoxClass::RequestSubLoad (this,
				vunames_RSMS);

    vcontainer *resvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcRESVContainer);
    resetValue = filteredTextitem::RequestSubLoad (resvcontainer,
				vunames_RESV);

    vcontainer *spincontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcSPINContainer);
    stepInputButton = vuPvNameButtonClass::RequestSubLoad (spincontainer,
				vunames_vuDdcSPINButton);
    stepInput = vuFilteredTextitem::RequestSubLoad (spincontainer,
				vunames_SPIN);
    procStepInput = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCS);
    msStepInput = vuCheckBoxClass::RequestSubLoad (this,
				vunames_SIMS);

    vcontainer *prcdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcPRCDContainer);
    primaryCascadeButton = vuPvNameButtonClass::RequestSubLoad (prcdcontainer,
				vunames_vuDdcPRCDButton);
    primaryCascade = vuFilteredTextitem::RequestSubLoad (prcdcontainer,
				vunames_PRCD);

    vcontainer *dscdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcDSCDContainer);
    downstreamCascadeButton = vuPvNameButtonClass::RequestSubLoad (dscdcontainer,
				vunames_vuDdcDSCDButton);
    downstreamCascade = vuFilteredTextitem::RequestSubLoad (dscdcontainer,
				vunames_DSCD);

    vcontainer *dctycontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcDCTYContainer);
    drumControlType = vuChoiceRecMenuClass::RequestSubLoad (dctycontainer,
				vunames_DCTY);

    vcontainer *omodcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOMODContainer);
    operatingMode = vuChoiceRecMenuClass::RequestSubLoad (omodcontainer,
				vunames_OMOD);

    vcontainer *tmodcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcTMODContainer);
    timingMode = vuChoiceRecMenuClass::RequestSubLoad (tmodcontainer,
				vunames_TMOD);

    vcontainer *ltedcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcLTEDContainer);
    activeEdge = vuChoiceRecMenuClass::RequestSubLoad (ltedcontainer,
				vunames_LTED);

    vcontainer *alarmdiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (alarmdiscontainer,
				vunames_vuDdcADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (alarmdiscontainer,
				vunames_ADIS);

    vcontainer *alrmgrpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (alrmgrpcontainer,
				vunames_ALGP);

    outputValuesButton = vuDdcOutputButtonClass::RequestSubLoad (this,
				vunames_vuDdcOutputValuesButton);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    outputButton -> storePvName (output);
    resetLinkButton -> storePvName (resetLink);
    stepInputButton -> storePvName (stepInput);
    primaryCascadeButton -> storePvName (primaryCascade);
    downstreamCascadeButton -> storePvName (downstreamCascade);
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters
    line -> SetItemFilterFunc (numericFilter);
    addr -> SetItemFilterFunc (numericFilter);
    card -> SetItemFilterFunc (numericFilter);
    signal -> SetItemFilterFunc (numericFilter);
    resetValue -> SetItemFilterFunc (numericFilter);

    output -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *outText = (filteredText *)output -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    outText -> SetUserPtr ((void *)output);

    resetLink -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *rslnText = (filteredText *)resetLink -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    rslnText -> SetUserPtr ((void *)resetLink);

    stepInput -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *spinText = (filteredText *)stepInput -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    spinText -> SetUserPtr ((void *)stepInput);

    primaryCascade -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *prcdText = (filteredText *)primaryCascade -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    prcdText -> SetUserPtr ((void *)primaryCascade);

    downstreamCascade -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *dscdText = (filteredText *)downstreamCascade -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    dscdText -> SetUserPtr ((void *)downstreamCascade);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *alrmDisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alrmDisText -> SetUserPtr ((void *)alarmDisable);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    // build popup menus
    boardType    -> vuBuildBoardTypeMenu (VU_DDC);
    initAction -> vuBuildOptionMenu (VU_DDC, REC_DDC_IACT);
    drumControlType -> vuBuildOptionMenu (VU_DDC, REC_DDC_DCTY);
    operatingMode  -> vuBuildOptionMenu (VU_DDC, REC_DDC_OPMODE);
    timingMode  -> vuBuildOptionMenu (VU_DDC, REC_DDC_TIMMODE);
    activeEdge  -> vuBuildOptionMenu (VU_DDC, REC_DDC_EDGE);

}

/*******************************************************************
*
*    vuDdcContainerClass override for destructor
*
*******************************************************************/

void vuDdcContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}


/*******************************************************************
*
*    vuDdcOutputButtonClass observer
*	open the values dialog and wait here until finished
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuDdcOutputButtonClass, vbutton, 
					"vuDdcOutputButtonClass");

void vuDdcOutputButtonClass::ObserveDialogItem (vevent *event)
{
    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    outputDialog -> Place (ddcDialog, vrectPLACE_CENTER, vrectPLACE_CENTER);
    outputDialog -> Open();
    MakeTopMostDialog (outputDialog, NULL);
    vevent::Process ();
}


/*******************************************************************
*
*    vuDdcOutputDialogClass
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuDdcOutputDialogClass, vdialog, 
					"vuDdcOutputDialogClass");

/*******************************************************************
*
*    vuDdcOutputDialogClass override for constructors init ()
*
*******************************************************************/

void vuDdcOutputDialogClass::LoadInit (vresource res)
{

    vcontainer *ts01container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS01Container);
    time1 = hhmmsstTimeClass::RequestSubLoad (ts01container,
				vunames_TS01);
    vcontainer *ow01container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW01Container);
    value1 = spinnerClass::RequestSubLoad (ow01container,
				vunames_OW01);

    vcontainer *ts02container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS02Container);
    time2 = hhmmsstTimeClass::RequestSubLoad (ts02container,
				vunames_TS02);
    vcontainer *ow02container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW02Container);
    value2 = spinnerClass::RequestSubLoad (ow02container,
				vunames_OW02);

    vcontainer *ts03container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS03Container);
    time3 = hhmmsstTimeClass::RequestSubLoad (ts03container,
				vunames_TS03);
    vcontainer *ow03container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW03Container);
    value3 = spinnerClass::RequestSubLoad (ow03container,
				vunames_OW03);

    vcontainer *ts04container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS04Container);
    time4 = hhmmsstTimeClass::RequestSubLoad (ts04container,
				vunames_TS04);
    vcontainer *ow04container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW04Container);
    value4 = spinnerClass::RequestSubLoad (ow04container,
				vunames_OW04);

    vcontainer *ts05container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS05Container);
    time5 = hhmmsstTimeClass::RequestSubLoad (ts05container,
				vunames_TS05);
    vcontainer *ow05container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW05Container);
    value5 = spinnerClass::RequestSubLoad (ow05container,
				vunames_OW05);

    vcontainer *ts06container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS06Container);
    time6 = hhmmsstTimeClass::RequestSubLoad (ts06container,
				vunames_TS06);
    vcontainer *ow06container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW06Container);
    value6 = spinnerClass::RequestSubLoad (ow06container,
				vunames_OW06);

    vcontainer *ts07container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS07Container);
    time7 = hhmmsstTimeClass::RequestSubLoad (ts07container,
				vunames_TS07);
    vcontainer *ow07container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW07Container);
    value7 = spinnerClass::RequestSubLoad (ow07container,
				vunames_OW07);

    vcontainer *ts08container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS08Container);
    time8 = hhmmsstTimeClass::RequestSubLoad (ts08container,
				vunames_TS08);
    vcontainer *ow08container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW08Container);
    value8 = spinnerClass::RequestSubLoad (ow08container,
				vunames_OW08);

    vcontainer *ts09container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS09Container);
    time9 = hhmmsstTimeClass::RequestSubLoad (ts09container,
				vunames_TS09);
    vcontainer *ow09container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW09Container);
    value9 = spinnerClass::RequestSubLoad (ow09container,
				vunames_OW09);

    vcontainer *ts10container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS10Container);
    time10 = hhmmsstTimeClass::RequestSubLoad (ts10container,
				vunames_TS10);
    vcontainer *ow10container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW10Container);
    value10 = spinnerClass::RequestSubLoad (ow10container,
				vunames_OW10);

    vcontainer *ts11container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS11Container);
    time11 = hhmmsstTimeClass::RequestSubLoad (ts11container,
				vunames_TS11);
    vcontainer *ow11container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW11Container);
    value11 = spinnerClass::RequestSubLoad (ow11container,
				vunames_OW11);

    vcontainer *ts12container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS12Container);
    time12 = hhmmsstTimeClass::RequestSubLoad (ts12container,
				vunames_TS12);
    vcontainer *ow12container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW12Container);
    value12 = spinnerClass::RequestSubLoad (ow12container,
				vunames_OW12);

    vcontainer *ts13container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS13Container);
    time13 = hhmmsstTimeClass::RequestSubLoad (ts13container,
				vunames_TS13);
    vcontainer *ow13container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW13Container);
    value13 = spinnerClass::RequestSubLoad (ow13container,
				vunames_OW13);

    vcontainer *ts14container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS14Container);
    time14 = hhmmsstTimeClass::RequestSubLoad (ts14container,
				vunames_TS14);
    vcontainer *ow14container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW14Container);
    value14 = spinnerClass::RequestSubLoad (ow14container,
				vunames_OW14);

    vcontainer *ts15container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS15Container);
    time15 = hhmmsstTimeClass::RequestSubLoad (ts15container,
				vunames_TS15);
    vcontainer *ow15container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW15Container);
    value15 = spinnerClass::RequestSubLoad (ow15container,
				vunames_OW15);

    vcontainer *ts16container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS16Container);
    time16 = hhmmsstTimeClass::RequestSubLoad (ts16container,
				vunames_TS16);
    vcontainer *ow16container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW16Container);
    value16 = spinnerClass::RequestSubLoad (ow16container,
				vunames_OW16);

    vcontainer *ts17container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS17Container);
    time17 = hhmmsstTimeClass::RequestSubLoad (ts17container,
				vunames_TS17);
    vcontainer *ow17container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW17Container);
    value17 = spinnerClass::RequestSubLoad (ow17container,
				vunames_OW17);

    vcontainer *ts18container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS18Container);
    time18 = hhmmsstTimeClass::RequestSubLoad (ts18container,
				vunames_TS18);
    vcontainer *ow18container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW18Container);
    value18 = spinnerClass::RequestSubLoad (ow18container,
				vunames_OW18);

    vcontainer *ts19container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS19Container);
    time19 = hhmmsstTimeClass::RequestSubLoad (ts19container,
				vunames_TS19);
    vcontainer *ow19container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW19Container);
    value19 = spinnerClass::RequestSubLoad (ow19container,
				vunames_OW19);

    vcontainer *ts20container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS20Container);
    time20 = hhmmsstTimeClass::RequestSubLoad (ts20container,
				vunames_TS20);
    vcontainer *ow20container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW20Container);
    value20 = spinnerClass::RequestSubLoad (ow20container,
				vunames_OW20);

    vcontainer *ts21container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS21Container);
    time21 = hhmmsstTimeClass::RequestSubLoad (ts21container,
				vunames_TS21);
    vcontainer *ow21container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW21Container);
    value21 = spinnerClass::RequestSubLoad (ow21container,
				vunames_OW21);

    vcontainer *ts22container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS22Container);
    time22 = hhmmsstTimeClass::RequestSubLoad (ts22container,
				vunames_TS22);
    vcontainer *ow22container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW22Container);
    value22 = spinnerClass::RequestSubLoad (ow22container,
				vunames_OW22);

    vcontainer *ts23container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS23Container);
    time23 = hhmmsstTimeClass::RequestSubLoad (ts23container,
				vunames_TS23);
    vcontainer *ow23container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW23Container);
    value23 = spinnerClass::RequestSubLoad (ow23container,
				vunames_OW23);

    vcontainer *ts24container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS24Container);
    time24 = hhmmsstTimeClass::RequestSubLoad (ts24container,
				vunames_TS24);
    vcontainer *ow24container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW24Container);
    value24 = spinnerClass::RequestSubLoad (ow24container,
				vunames_OW24);

    vcontainer *ts25container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS25Container);
    time25 = hhmmsstTimeClass::RequestSubLoad (ts25container,
				vunames_TS25);
    vcontainer *ow25container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW25Container);
    value25 = spinnerClass::RequestSubLoad (ow25container,
				vunames_OW25);

    vcontainer *ts26container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS26Container);
    time26 = hhmmsstTimeClass::RequestSubLoad (ts26container,
				vunames_TS26);
    vcontainer *ow26container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW26Container);
    value26 = spinnerClass::RequestSubLoad (ow26container,
				vunames_OW26);

    vcontainer *ts27container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS27Container);
    time27 = hhmmsstTimeClass::RequestSubLoad (ts27container,
				vunames_TS27);
    vcontainer *ow27container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW27Container);
    value27 = spinnerClass::RequestSubLoad (ow27container,
				vunames_OW27);

    vcontainer *ts28container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS28Container);
    time28 = hhmmsstTimeClass::RequestSubLoad (ts28container,
				vunames_TS28);
    vcontainer *ow28container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW28Container);
    value28 = spinnerClass::RequestSubLoad (ow28container,
				vunames_OW28);

    vcontainer *ts29container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS29Container);
    time29 = hhmmsstTimeClass::RequestSubLoad (ts29container,
				vunames_TS29);
    vcontainer *ow29container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW29Container);
    value29 = spinnerClass::RequestSubLoad (ow29container,
				vunames_OW29);

    vcontainer *ts30container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS30Container);
    time30 = hhmmsstTimeClass::RequestSubLoad (ts30container,
				vunames_TS30);
    vcontainer *ow30container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW30Container);
    value30 = spinnerClass::RequestSubLoad (ow30container,
				vunames_OW30);

    vcontainer *ts31container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS31Container);
    time31 = hhmmsstTimeClass::RequestSubLoad (ts31container,
				vunames_TS31);
    vcontainer *ow31container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW31Container);
    value31 = spinnerClass::RequestSubLoad (ow31container,
				vunames_OW31);

    vcontainer *ts32container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutTS32Container);
    time32 = hhmmsstTimeClass::RequestSubLoad (ts32container,
				vunames_TS32);
    vcontainer *ow32container = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutOW32Container);
    value32 = spinnerClass::RequestSubLoad (ow32container,
				vunames_OW32);

    vcontainer *numwcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutNUMWContainer);
    numOutputWords = spinnerClass::RequestSubLoad (numwcontainer,
				vunames_NUMW);

    vcontainer *numbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuDdcOutNUMBContainer);
    numOutputBits = spinnerClass::RequestSubLoad (numbcontainer,
				vunames_NUMB);

    dismissButton = vuDdcOutputDismissButtonClass::RequestSubLoad (this,
				vunames_vuDdcOutDismissButton);

    vdialog::LoadInit (res);


    // set filters
    time1 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t1text = (filteredText *)time1 -> GetTextData ();
    // remember ptr to textitem for later use
    t1text -> SetUserPtr ((void *)time1);

    time2 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t2text = (filteredText *)time2 -> GetTextData ();
    // remember ptr to textitem for later use
    t2text -> SetUserPtr ((void *)time2);

    time3 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t3text = (filteredText *)time3 -> GetTextData ();
    // remember ptr to textitem for later use
    t3text -> SetUserPtr ((void *)time3);

    time4 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t4text = (filteredText *)time4 -> GetTextData ();
    // remember ptr to textitem for later use
    t4text -> SetUserPtr ((void *)time4);

    time5 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t5text = (filteredText *)time5 -> GetTextData ();
    // remember ptr to textitem for later use
    t5text -> SetUserPtr ((void *)time5);

    time6 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t6text = (filteredText *)time6 -> GetTextData ();
    // remember ptr to textitem for later use
    t6text -> SetUserPtr ((void *)time6);

    time7 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t7text = (filteredText *)time7 -> GetTextData ();
    // remember ptr to textitem for later use
    t7text -> SetUserPtr ((void *)time7);

    time8 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t8text = (filteredText *)time8 -> GetTextData ();
    // remember ptr to textitem for later use
    t8text -> SetUserPtr ((void *)time8);

    time9 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t9text = (filteredText *)time9 -> GetTextData ();
    // remember ptr to textitem for later use
    t9text -> SetUserPtr ((void *)time9);

    time10 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t10text = (filteredText *)time10 -> GetTextData ();
    // remember ptr to textitem for later use
    t10text -> SetUserPtr ((void *)time10);

    time11 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t11text = (filteredText *)time11 -> GetTextData ();
    // remember ptr to textitem for later use
    t11text -> SetUserPtr ((void *)time11);

    time12 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t12text = (filteredText *)time12 -> GetTextData ();
    // remember ptr to textitem for later use
    t12text -> SetUserPtr ((void *)time12);

    time13 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t13text = (filteredText *)time13 -> GetTextData ();
    // remember ptr to textitem for later use
    t13text -> SetUserPtr ((void *)time13);

    time14 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t14text = (filteredText *)time14 -> GetTextData ();
    // remember ptr to textitem for later use
    t14text -> SetUserPtr ((void *)time14);

    time15 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t15text = (filteredText *)time15 -> GetTextData ();
    // remember ptr to textitem for later use
    t15text -> SetUserPtr ((void *)time15);

    time16 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t16text = (filteredText *)time16 -> GetTextData ();
    // remember ptr to textitem for later use
    t16text -> SetUserPtr ((void *)time16);

    time17 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t17text = (filteredText *)time17 -> GetTextData ();
    // remember ptr to textitem for later use
    t17text -> SetUserPtr ((void *)time17);

    time18 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t18text = (filteredText *)time18 -> GetTextData ();
    // remember ptr to textitem for later use
    t18text -> SetUserPtr ((void *)time18);

    time19 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t19text = (filteredText *)time19 -> GetTextData ();
    // remember ptr to textitem for later use
    t19text -> SetUserPtr ((void *)time19);

    time20 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t20text = (filteredText *)time20 -> GetTextData ();
    // remember ptr to textitem for later use
    t20text -> SetUserPtr ((void *)time20);

    time21 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t21text = (filteredText *)time21 -> GetTextData ();
    // remember ptr to textitem for later use
    t21text -> SetUserPtr ((void *)time21);

    time22 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t22text = (filteredText *)time22 -> GetTextData ();
    // remember ptr to textitem for later use
    t22text -> SetUserPtr ((void *)time22);

    time23 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t23text = (filteredText *)time23 -> GetTextData ();
    // remember ptr to textitem for later use
    t23text -> SetUserPtr ((void *)time23);

    time24 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t24text = (filteredText *)time24 -> GetTextData ();
    // remember ptr to textitem for later use
    t24text -> SetUserPtr ((void *)time24);

    time25 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t25text = (filteredText *)time25 -> GetTextData ();
    // remember ptr to textitem for later use
    t25text -> SetUserPtr ((void *)time25);

    time26 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t26text = (filteredText *)time26 -> GetTextData ();
    // remember ptr to textitem for later use
    t26text -> SetUserPtr ((void *)time26);

    time27 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t27text = (filteredText *)time27 -> GetTextData ();
    // remember ptr to textitem for later use
    t27text -> SetUserPtr ((void *)time27);

    time28 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t28text = (filteredText *)time28 -> GetTextData ();
    // remember ptr to textitem for later use
    t28text -> SetUserPtr ((void *)time28);

    time29 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t29text = (filteredText *)time29 -> GetTextData ();
    // remember ptr to textitem for later use
    t29text -> SetUserPtr ((void *)time29);

    time30 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t30text = (filteredText *)time30 -> GetTextData ();
    // remember ptr to textitem for later use
    t30text -> SetUserPtr ((void *)time30);

    time31 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t31text = (filteredText *)time31 -> GetTextData ();
    // remember ptr to textitem for later use
    t31text -> SetUserPtr ((void *)time31);

    time32 -> SetItemFilterFunc (hhmmsstTimeFilter);
    filteredText *t32text = (filteredText *)time32 -> GetTextData ();
    // remember ptr to textitem for later use
    t32text -> SetUserPtr ((void *)time32);


    // store dialog pointer in dismiss button

    dismissButton -> storeDdcOutputDialog (this);

}


/*******************************************************************
*
*    vuDdcOutputDialogClass notify function
*
*******************************************************************/

void vuDdcOutputDialogClass::ObserveWindow (vevent *event)
{
    if ( event -> GetType () == veventWINDOW_STATE && event -> IsClose ())
    {
	Close ();
	vevent::StopProcessing ();
    }
    else
    {
	MakeTopMostDialog (this, event);
    }
}


/*******************************************************************
*
*    vuDdcOutputDismissButtonClass notify function
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuDdcOutputDismissButtonClass, vbutton, 
					"vuDdcOutputDismissButtonClass");

void vuDdcOutputDismissButtonClass::ObserveDialogItem (vevent *event)
{
    outputDialog -> Close ();
    vevent::StopProcessing ();
}

