#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vlistviewHEADER
#include vliststrHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER
#include vregexpHEADER
#include vexHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbDefs.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"

#include "vuFindDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuFindDialogClass, vdialog, "vuFindDialogClass");

/*******************************************************************
*
*    vuFindDialogClass 
*	LoadInit, constructor
*
*******************************************************************/

void vuFindDialogClass::LoadInit(vresource res)
{
    // init found list to NULL
    foundList = NULL;

    // init number found
    numInList = 0;

    filterContainer = vcontainer::RequestSubLoad(this, 
					vunames_vuFindFilterContainer);
    ioContainer = vcontainer::RequestSubLoad(this, 
					vunames_vuFindIOContainer);

    // then lists...
    typeList = vlistview::RequestSubLoad(this, 
					vunames_vuFindTypeList);
    resourceList = vlistview::RequestSubLoad(this, 
					vunames_vuFindResourceList);
    iocList = vlistview::RequestSubLoad(ioContainer, 
					vunames_vuFindIOCList);

    // then text items...
    ioLine = filteredTextitem::RequestSubLoad(ioContainer,
					vunames_vuFindIOLine);
    ioAddress = filteredTextitem::RequestSubLoad(ioContainer,
					vunames_vuFindIOAddress);
    ioCard = filteredTextitem::RequestSubLoad(ioContainer,
					vunames_vuFindIOCard);
    ioSignal = filteredTextitem::RequestSubLoad(ioContainer,
					vunames_vuFindIOSignal);
    filterString = filteredTextitem::RequestSubLoad(filterContainer,
					vunames_vuFindFilterString);

    // then toggle buttons
    pvToggle = vcontrolToggle::RequestSubLoad(filterContainer,
					vunames_vuFindPVToggle);
    descToggle = vcontrolToggle::RequestSubLoad(filterContainer,
					vunames_vuFindDescToggle);
    alarmGroupToggle = vcontrolToggle::RequestSubLoad(filterContainer,
					vunames_vuFindAlarmGroupToggle);
    protGroupToggle = vcontrolToggle::RequestSubLoad(filterContainer,
					vunames_vuFindProtGroupToggle);
    locationToggle = vcontrolToggle::RequestSubLoad(filterContainer,
					vunames_vuFindLocationToggle);
    trendToggle = vcontrolToggle::RequestSubLoad(filterContainer,
					vunames_vuFindTrendToggle);
    resToggle = vcontrolToggle::RequestSubLoad(filterContainer,
					vunames_vuFindResourceToggle);
    typeToggle = vcontrolToggle::RequestSubLoad(filterContainer,
					vunames_vuFindPointTypeToggle);
    ioToggle = vcontrolToggle::RequestSubLoad(ioContainer,
					vunames_vuFindIOToggle);
    iocToggle = vcontrolToggle::RequestSubLoad(ioContainer,
					vunames_vuFindIOCToggle);

    // call base class loadInit to finish the job
    vdialog::LoadInit(res);

    // set filters for these fields

    ioLine -> SetItemFilterFunc (numericFilter);
    ioAddress -> SetItemFilterFunc (numericFilter);
    ioCard -> SetItemFilterFunc (numericFilter);
    ioSignal -> SetItemFilterFunc (numericFilter);

    // place window in center of screen
    Place(GetRoot(),vrectPLACE_CENTER,vrectPLACE_CENTER);
}


/*******************************************************************
*
*    vuFindDialogClass Destroy function
*
*******************************************************************/

void vuFindDialogClass::Destroy(void)
{
    vliststr *listdata;
    listdata = (vliststr *)resourceList -> GetList();
    if(listdata) 
	listdata->Destroy();

    listdata = (vliststr *)iocList -> GetList();
    if(listdata) 
	listdata->Destroy();

    listdata = (vliststr *)typeList -> GetList();
    if(listdata) 
	listdata->Destroy();

    if (foundList != NULL)
	foundList -> Destroy ();

    vdialog::Destroy();
}


/*******************************************************************
*
*    vuFindDialogClass Open function
*
*******************************************************************/

void vuFindDialogClass::vuFindOpen(vchar *label,vuMainDialogClass *mainDialg,int multiSelect)
{
    mainDialog = mainDialg;
    dataVuApplication *app = mainDialog->getApplication();
    db = app->getDatabaseClass();
    char		**resList = NULL;
    char		**ioclist = NULL;
    char		**ptlist = NULL;
    vliststr		*ptListData;
    vliststr		*resListData;
    vliststr		*iocListData;
    vlistSelection	*selection;
    int			i;

    // load the three lists here (typeList,  resourceList & iocList)...

    // RESOURCE LIST
	resListData = (vliststr *)(resourceList -> GetList());	
    if((db->ResListChanged() == vTRUE) || (resListData == NULL))
    {
	if(db->ResListChanged() == vTRUE)
	{
	    db->ResListHasChanged(vFALSE);
	}
	// destroy any existing listdata
	if(resListData != NULL)
	{
	    resListData -> Destroy();
	}
	// then create a new one
	//  resource list with no DPA's
	resListData = vuGetResList(db,VU_NO_DPAS);
	//  tell list view what to look at
	resourceList -> SetList(resListData);
    }

    // set so only one resource name can be selected
    selection = resourceList -> GetSelection ();
    resListData -> SetSelectMethod (selection, vlistONE_ONLY_SELECTION);
    // IOC LIST
    iocListData = (vliststr *)(iocList -> GetList());	
    if((db->IocListChanged() == vTRUE) || (iocListData == NULL))
    {
	if(db->IocListChanged() == vTRUE)
	{
	    db->IocListHasChanged(vFALSE);
	}
	// destroy any existing listdata
	if(iocListData != NULL)
	{
	    iocListData -> Destroy();
	}
	// then create a new one
	// ioc list here with no DPAs
	iocListData = vuGetIocList(db);
	//  tell list view what to look at
	iocList -> SetList(iocListData);
    }

	    // set so only one ioc name can be selected
	selection = iocList -> GetSelection ();
	iocListData -> SetSelectMethod (selection, vlistONE_ONLY_SELECTION);

    // POINT TYPE LIST

    ptListData = (vliststr *)(typeList -> GetList());	
    if(ptListData == NULL)
    {
    // then create a new one
    //  get the point type list from the SDR
	ptlist = vuGetPointTypeList();
	if (ptlist)
	{
	    ptListData = new vliststr();			
	    i = 0;
	    while(ptlist[i])
	    {
		ptListData -> SetCellValueScribed(i, 0, vcharScribeSystem(ptlist[i]));
		vmemFree((void *)(ptlist[i]));
		i++;
	    }
	    vmemFree((void *)ptlist);

	    //  tell list view what to look at
	    typeList -> SetList(ptListData);	

	    // set so only one point name can be selected
	    selection = typeList -> GetSelection ();
	    ptListData -> SetSelectMethod (selection, vlistONE_ONLY_SELECTION);
	}
    }

    // set the filter's default
    //vresource defaultRes  = mainDialog -> getDefaultsResource ();
    //vstr *filterDefault  = vresourceGetString (defaultRes, vunames_vuNavFilterdefault);
    //filterString -> SetTextScribed (vcharScribeSystem (filterDefault));
    //vstrDestroy (filterDefault);

    // set-up the database field pointers
    pType  = DB_MapField (db -> vuPvmapTable, FLD_TYPE);
    pName  = DB_MapField (db -> vuPvmapTable, FLD_NAME);
    pRes   = DB_MapField (db -> vuPvmapTable, FLD_RESOURCE);
    pDesc  = DB_MapField (db -> vuPvmapTable, FLD_DESC);
    pAlarm = DB_MapField (db -> vuPvmapTable, FLD_ALARMGROUP);
    pProt  = DB_MapField (db -> vuPvmapTable, FLD_PROTECTION);
    pLoc   = DB_MapField (db -> vuPvmapTable, FLD_LOCATION);
    pTrend = DB_MapField (db -> vuPvmapTable, FLD_TREND);
    pMerge = DB_MapField (db -> vuPvmapTable, FLD_MERGE);
    pDev   = DB_MapField (db -> vuPvmapTable, FLD_DEVTYPE);
    pIoc1  = DB_MapField (db -> vuResListTable, FLD_IOC1);
    pIoc2  = DB_MapField (db -> vuResListTable, FLD_IOC2);
    pDev   = DB_MapField (db -> vuPvmapTable, FLD_DEVTYPE);

}


/*******************************************************************
*
*    vuFindDialogClass 
*
*******************************************************************/

void vuFindDialogClass::vuFindList(void)
{
    DB_RECORD_PTR	pvmapRec, ioRec, resRec;
    VERIFY_INFO		local_info;
    vchar	lineIO [IOLINE_SZ + 1];
    vchar	addrIO [IOADDR_SZ + 1];
    vchar	cardIO [IOCARD_SZ + 1];
    vchar	signalIO [IOSIGNAL_SZ + 1];
    vchar	matchPattern[128];
    vchar	*cellValue;

    char	devName [DEVICETYPE_SZ + 1];
    char	iocNameSelected[IOCNAME_SZ + 1];
    char	iocName1[IOCNAME_SZ + 1];
    char	iocName2[IOCNAME_SZ + 1];
    char	ioName [PVNAME_SZ + 1];
    double	ioLineValue, ioAddressValue, ioCardValue, ioSignalValue;
    char	pointTypeSelected [POINTTYPE_SZ + 1];
    char	pointType [POINTTYPE_SZ + 1];
    char	pvName [PVNAME_SZ + 1];
    char	resourceSelected [RESOURCE_SZ + 1];
    char	resource [RESOURCE_SZ + 1];
    char	trendValue;	// T/F

    double	lVal, aVal, cVal, sVal;
    int		isFound, isChecked, andFound;
    int		type;
    int		row, column;
    int		newRow = 0;

    numInList = 0;
    // get the selected point type
    vlistSelection *ptSelection = typeList -> GetSelection ();
    vliststr *ptListData = (vliststr *)(typeList -> GetList ());
    ptListData -> GetSelectedCell (ptSelection, &row, &column);
    if (row != vlistNO_CELLS_SELECTED)
    {
	cellValue = (vchar *)(ptListData -> GetCellValue (row, 0));
	vcharExportBounded (vcharScribeSystemExport (cellValue),
			    pointTypeSelected,
			    POINTTYPE_SZ);
	pointTypeSelected[POINTTYPE_SZ] = 0;
    }
    else
	memset ( (void *)pointTypeSelected, 0, sizeof (pointTypeSelected));

    if ( (typeToggle -> GetValue ()) == vTRUE)
    {
	if (pointTypeSelected[0] == 0)
	{
	    vuMessageDialogCenter (this, VU_NO_POINTTYPE_SELECTED_MSG);
	    return;
	}
    }

    // get the selected resource name
    vlistSelection *resSelection = resourceList -> GetSelection ();
    vliststr *resListData = (vliststr *)(resourceList -> GetList ());
    resListData -> GetSelectedCell (resSelection, &row, &column);
    if (row != vlistNO_CELLS_SELECTED)
    {
	cellValue = (vchar *)(resListData ->GetCellValue (row, 0));
	vcharExportBounded (vcharScribeSystemExport (cellValue),
			    resourceSelected, 
			    RESOURCE_SZ);
	resourceSelected[RESOURCE_SZ] = 0;
    }
    else
	memset ( (void *)resourceSelected, 0, sizeof (resourceSelected));

    if ( (resToggle -> GetValue ()) == vTRUE)
    {
	if (resourceSelected[0] == 0)
	{
	    vuMessageDialogCenter (this, VU_NO_RESOURCE_SELECTED_MSG);
	    return;
	}
    }

    // get the selected ioc name
    vlistSelection *iocSelection = iocList -> GetSelection ();
    vliststr *iocListData = (vliststr *)(iocList -> GetList ());
    iocListData -> GetSelectedCell (iocSelection, &row, &column);
    if (row != vlistNO_CELLS_SELECTED)
    {
	cellValue = (vchar *)(iocListData -> GetCellValue (row, 0));
	vcharExportBounded (vcharScribeSystemExport (cellValue),
			    iocNameSelected, 
			    IOCNAME_SZ);
	iocNameSelected[IOCNAME_SZ] = 0;
    }
    else
	memset ( (void *)iocNameSelected, 0, sizeof (iocNameSelected));

    if ( (iocToggle -> GetValue ()) == vTRUE)
    {
	if (iocNameSelected[0] == 0)
	{
	    vuMessageDialogCenter (this, VU_NO_IOCNAME_SELECTED_MSG);
	    return;
	}
    }

    // change cursor to block/wait cursor
    Block ();

    filterString -> GetText (matchPattern, PVNAME_SZ);

    vregexp	*regExp = new vregexp;
    regExp->SetCaseSensitive(vTRUE);

    // capture the exception if the pattern to match is illegal,
    // vregexpBAD_REGULAR_EXPRESSION

vexWITH_HANDLING 
{
    regExp -> SetPatternScribed (vcharScribe (matchPattern));

    // get the IO toggel state
    ioLineValue = ioAddressValue = ioCardValue = ioSignalValue = 0;
    if ( (ioToggle -> GetValue ()) == vTRUE)
    {
	ioLine -> GetText (lineIO, IOLINE_SZ);
	if ((vcharLength (lineIO)) != 0)
	{
	    ioLineValue = ioLine -> GetTextAsFloat ();
	}
	ioAddress -> GetText (addrIO, IOADDR_SZ);
	if ((vcharLength (addrIO)) != 0)
	{
	    ioAddressValue = ioAddress -> GetTextAsFloat ();
	}
	ioCard -> GetText (cardIO, IOCARD_SZ);
	if ((vcharLength (cardIO)) != 0)
	{
	    ioCardValue = ioCard -> GetTextAsFloat ();
	}
	ioSignal ->GetText (signalIO, IOSIGNAL_SZ);
	if ((vcharLength (signalIO)) != 0)
	{
	    ioSignalValue = ioSignal -> GetTextAsFloat ();
	}
    }

    // now stomp through pvmap looking for records that satisfy
    // all the paramters selected in the Find

    pvmapRec = DB_Top (db -> vuPvmapTable);
    while (pvmapRec)
    {
	isFound = 0;
	andFound = 1;
	isChecked = 0;

	// is pvname selected
	if ( (pvToggle -> GetValue()) == vTRUE)
	{
	    isChecked = 1;
	    if (vcharLength(matchPattern) != 0)
		isFound |= vuMatchPattern (pvmapRec, pName, regExp);
	}
	// is descriptor selected
	if ( (descToggle -> GetValue()) == vTRUE)
	{
	    isChecked = 1;
	    if (vcharLength (matchPattern) != 0)
		isFound |= vuMatchPattern (pvmapRec, pDesc, regExp);
	}
	// is alarm group selected
	if ( (alarmGroupToggle -> GetValue ()) == vTRUE)
	{
	    isChecked = 1;
	    if (vcharLength (matchPattern) != 0)
		isFound |= vuMatchPattern (pvmapRec, pAlarm, regExp);
	}
	// is protection group selected
	if ( (protGroupToggle -> GetValue ()) == vTRUE)
	{
	    isChecked = 1;
	    if (vcharLength (matchPattern) != 0)
		isFound |= vuMatchPattern (pvmapRec, pProt, regExp);
	}
	// is location selected
	if ( (locationToggle -> GetValue ()) == vTRUE)
	{
	    isChecked = 1;
	    if (vcharLength (matchPattern) != 0)
		isFound |= vuMatchPattern (pvmapRec, pLoc, regExp);
	}
	// is trend selected
	if ( (trendToggle -> GetValue ()) == vTRUE)
	{
	    isChecked = 1;
	    DB_GetFieldValue (pvmapRec, pTrend, &trendValue, &type);
	    isFound |= (trendValue & 1);
	}
	// match io addresses
	if ( (ioToggle -> GetValue ()) == vTRUE)
	{
	    // read name from pvmap
	    DB_GetFieldValue (pvmapRec, pName, pvName, &type);
	    // also read the device type
	    DB_GetFieldValue (pvmapRec ,pDev, devName, &type);
	    sprintf (ioName, "%-*.*s", PVNAME_SZ, PVNAME_SZ, pvName);
	    // now try to find it in the ioaddr table
	    if ( (ioRec = DB_Seek (db -> vuIOAddrTable, ioName)) != 0)
	    {
		DB_GetFieldValue (ioRec, db -> ioaddrLine, &lVal, &type);
		DB_GetFieldValue (ioRec, db -> ioaddrAddress, &aVal, &type);
		DB_GetFieldValue (ioRec, db -> ioaddrCard, &cVal, &type);
		DB_GetFieldValue (ioRec, db -> ioaddrSignal, &sVal, &type);
		andFound &= ( (vcharLength (lineIO) ? (ioLineValue == lVal) : 1) &&
			      (vcharLength (addrIO) ? (ioAddressValue == aVal) : 1) &&
			      (vcharLength (cardIO) ? (ioCardValue == cVal) : 1) &&
			      (vcharLength (signalIO) ? (ioSignalValue == sVal) : 1) );

		// If the harware numbers match but the DEVTYPE field contains
		// either REFERENCE or CONSTANT then consider this as having
		// NOT matched.

		if( (strcmp(devName,FLD_REFERENCE) == 0) || 
		    (strcmp(devName,FLD_CONSTANT) == 0) )
			  andFound = 0;
	    }
	    else
		andFound = 0;
	}
	// match resource names
	if ( (resToggle -> GetValue ()) == vTRUE)
	{
	    DB_GetFieldValue (pvmapRec, pRes, resource, &type);
	    andFound &= (!strcmp (resourceSelected, resource) ? 1 : 0);
	}
	// match point types
	if ( (typeToggle -> GetValue ()) == vTRUE)
	{
	    DB_GetFieldValue (pvmapRec, pType, pointType, &type);
	    andFound &= (!strcmp (pointTypeSelected, pointType) ? 1 : 0);
	}
	// match ioc names
	if ( (iocToggle -> GetValue ()) == vTRUE)
	{
	    // get the resource name from pvmap
	    DB_GetFieldValue (pvmapRec, pRes, resource, &type);

	    // find resource name in table
	    if ( (resRec = DB_Seek (db -> vuResListTable, resource)) != 0)
	    {
		DB_GetFieldValue (resRec, pIoc1, iocName1, &type);
		DB_GetFieldValue (resRec, pIoc2, iocName2, &type);
		if (!strcmp (iocName1, iocNameSelected) )
		    andFound &= 1;
		else if (!strcmp (iocName2, iocNameSelected) )
		    andFound &= 1;
		else
		    andFound &= 0;
	    }
	    else
		andFound &= 0;
	}
	if ( (isFound && andFound) || ( (!isChecked) && andFound) )
	{
	    // read name from pvmap
	    DB_GetFieldValue (pvmapRec, pName, pvName, &type);

	    DB_GetVerifyInfo (db -> vuPvmapTable, pvName, &local_info, 0);
	    if (!VI_IS_DELETED (local_info.viPVStatus) )
	    {
		if (foundList == NULL)
		    foundList = new vliststr ();
		foundList -> SetCellValueScribed (newRow, 
						  0, 
						  vcharScribeSystem (pvName));
		newRow++;
	    }
	}

	pvmapRec = DB_SeekNext (db -> vuPvmapTable);

    } // end while pvmapRec to get in pvmap

    // get the number of names in the list 
    if (newRow > 0)
	numInList = foundList -> GetRowCount ();
    else
	numInList = 0;

}vexON_EXCEPTION
{
    numInList = 0;
    vuMessageDialogCenter (this, VU_FILTER_ERR, matchPattern);

}vexEND_HANDLING;

    delete regExp;

    // return window and cursor to normal
    Unblock ();
}


/*******************************************************************
*
*    vuFindDialogClass Remove function
*
*******************************************************************/

void vuFindDialogClass::vuRemovePvName(vchar *pvName)
{
}

