#ifndef vulaunchcfgdialogclassHXX
#define vulaunchcfgdialogclassHXX

#define	VU_LAUNCHCFG_KEY_SZ	6
#define	VU_LAUNCHCFG_FILE_SZ	30
#define	VU_LAUNCHCFG_PARAM_SZ	130
#define	VU_LAUNCHCFG_DESC_SZ	130

class	vuLaunchCfgApplyButtonClass;
class	vuLaunchCfgDismissButtonClass;
class	vuLaunchCfgDeleteButtonClass;
class	vuLaunchCfgNewButtonClass;
class	vuLaunchCfgGoToButtonClass;
class	vuLaunchCfgNextButtonClass;
class	vuLaunchCfgPrevButtonClass;
class	vuLaunchCfgKeyIdFilteredTextitem;
class	vuSelCfgDialogClass;

//*** LAUNCH CONFIG DIALOG CLASS ******************************

class  vuLaunchCfgDialogClass : public vdialog
{
    int			dialogModified;
    vuMainDialogClass	*mainDialog;
    vuSelCfgDialogClass	*selCfgDialog;

    public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuLaunchCfgDialogClass);

    // macros for standard constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuLaunchCfgDialogClass, vdialog);

    // override to load dialog
    void LoadInit(vresource res);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override 
    void Destroy ();

    void vuLaunchCfgOpen(vuMainDialogClass *mainDialog);	

    // functions to handle dialogModified
    int getDialogModify (void) { return (dialogModified); }
    void setDialogModify (int val) { dialogModified = val; }

    // function to handle mainDialog
    void storeMainDialog (vuMainDialogClass *cd)
	{ mainDialog = cd; }
    vuMainDialogClass *getMainDialog (void) 
	{ return (mainDialog); }

    // function to handle selCfgDialog
    vuSelCfgDialogClass *getSelCfgDialog (void)
	{ return (selCfgDialog); }
    void storeSelCfgDialog (vuSelCfgDialogClass *cd)
	{ selCfgDialog = cd; }

    // function to reset dialog
    void vuNewConfig (void);

    // function to load a script
    void vuLoadConfig (vchar *keyID);

    // function to map database fields
    void vuMapFields (void);

    // public so dont need funcs to access
    vuLaunchCfgKeyIdFilteredTextitem	*keyId;
    filteredTextitem	*nextKey;
    filteredTextitem	*prevKey;
    filteredTextitem	*file;
    filteredTextitem	*params;
    filteredTextitem	*description;

    vuLaunchCfgApplyButtonClass	*applyButton;
    vuLaunchCfgDismissButtonClass	*dismissButton;
    vuLaunchCfgDeleteButtonClass	*deleteButton;
    vuLaunchCfgNewButtonClass	*newButton;
    vuLaunchCfgGoToButtonClass	*gotoButton;
    vuLaunchCfgNextButtonClass	*nextButton;
    vuLaunchCfgPrevButtonClass	*prevButton;

    // database field ptrs
    DB_FIELD_PTR	keyField;
    DB_FIELD_PTR	nextKeyField;
    DB_FIELD_PTR	prevKeyField;
    DB_FIELD_PTR	fileField;
    DB_FIELD_PTR	paramsField;
    DB_FIELD_PTR	descField;

};


//*** LAUNCH CONFIG APPLY BUTTON CLASS **********************

class vuLaunchCfgApplyButtonClass : public vbutton
{
    vuLaunchCfgDialogClass	*launchCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLaunchCfgApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLaunchCfgApplyButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle launchCfgDialog
    void storeLaunchCfgDialog (vuLaunchCfgDialogClass *cd) 
	{ launchCfgDialog = cd; }
};


//*** LAUNCH CONFIG DISMISS BUTTON CLASS **********************

class vuLaunchCfgDismissButtonClass : public vbutton
{
    vuLaunchCfgDialogClass	*launchCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLaunchCfgDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLaunchCfgDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle launchCfgDialog
    void storeLaunchCfgDialog (vuLaunchCfgDialogClass *cd) 
	{ launchCfgDialog = cd; }
};


//*** LAUNCH CONFIG DELETE BUTTON CLASS ***********************

class vuLaunchCfgDeleteButtonClass : public vbutton
{
    vuLaunchCfgDialogClass	*launchCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLaunchCfgDeleteButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLaunchCfgDeleteButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle launchCfgDialog
    void storeLaunchCfgDialog (vuLaunchCfgDialogClass *cd) 
	{ launchCfgDialog = cd; }
};


//*** LAUNCH CONFIG NEW BUTTON CLASS ***************************

class vuLaunchCfgNewButtonClass : public vbutton
{
    vuLaunchCfgDialogClass	*launchCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLaunchCfgNewButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLaunchCfgNewButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle launchCfgDialog
    void storeLaunchCfgDialog (vuLaunchCfgDialogClass *cd) 
	{ launchCfgDialog = cd; }
};


//*** LAUNCH CONFIG GOTO BUTTON CLASS *************************

class vuLaunchCfgGoToButtonClass : public vbutton
{
    vuLaunchCfgDialogClass	*launchCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLaunchCfgGoToButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLaunchCfgGoToButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle launchCfgDialog
    void storeLaunchCfgDialog (vuLaunchCfgDialogClass *cd) 
	{ launchCfgDialog = cd; }
};


//*** LAUNCH CONFIG NEXT BUTTON CLASS ***************************

class vuLaunchCfgNextButtonClass : public vbutton
{
    vuLaunchCfgDialogClass	*launchCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLaunchCfgNextButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLaunchCfgNextButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle launchCfgDialog
    void storeLaunchCfgDialog (vuLaunchCfgDialogClass *cd) 
	{ launchCfgDialog = cd; }
};


//*** LAUNCH CONFIG PREV BUTTON CLASS ***************************

class vuLaunchCfgPrevButtonClass : public vbutton
{
    vuLaunchCfgDialogClass	*launchCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLaunchCfgPrevButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLaunchCfgPrevButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle launchCfgDialog
    void storeLaunchCfgDialog (vuLaunchCfgDialogClass *cd) 
	{ launchCfgDialog = cd; }
};


//*** SELECT CONFIG DIALOG CLASS **********************************

class	vuSelCfgListClass;
class	vuSelCfgApplyButtonClass;
class	vuSelCfgDismissButtonClass;

class	vuSelCfgDialogClass : public vdialog
{
    vuLaunchCfgDialogClass	*launchCfgDialog;
    vchar		keyId[VU_LAUNCHCFG_KEY_SZ + 1];

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSelCfgDialogClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuSelCfgDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // destroy override
    void Destroy (void);

    // open function
    void vuSelCfgOpen (vuLaunchCfgDialogClass *launchCfgDialog);

    // function for keyId
    vchar *vuGetKeyId (void) 
	{ return (keyId); }

    // public so dont need funcs to access
    vuSelCfgListClass		*selCfgList;
    vuSelCfgApplyButtonClass	*applyButton;
    vuSelCfgDismissButtonClass	*dismissButton;
};


// *** CONFIG SELECT LISTVIEW CLASS ********************************

class vuSelCfgListClass : public vlistview
{
    vuSelCfgDialogClass	*selCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSelCfgListClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSelCfgListClass, vlistview);

    // override
    void ObserveSelect (int state);

    // functions to handle selCfgDialog
    void storeSelCfgDialog (vuSelCfgDialogClass *cd)
	{ selCfgDialog = cd; }
};


//*** CONFIG SELECT APPLY BUTTON CLASS **********************

class vuSelCfgApplyButtonClass : public vbutton
{
    vuSelCfgDialogClass	*selCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSelCfgApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSelCfgApplyButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle selCfgDialog
    void storeSelCfgDialog (vuSelCfgDialogClass *cd) 
	{ selCfgDialog = cd; }
};


//*** CONFIG SELECT DISMISS BUTTON CLASS **********************

class vuSelCfgDismissButtonClass : public vbutton
{
    vuSelCfgDialogClass	*selCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSelCfgDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSelCfgDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle selCfgDialog
    void storeSelCfgDialog (vuSelCfgDialogClass *cd) 
	{ selCfgDialog = cd; }
};


// *** SUBCLASS OF filteredTextitem **************************************************

class vuLaunchCfgKeyIdFilteredTextitem : public filteredTextitem
{

    vuLaunchCfgDialogClass	*launchCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLaunchCfgKeyIdFilteredTextitem);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLaunchCfgKeyIdFilteredTextitem, filteredTextitem);

    // override observe
    void ObserveView (vevent *event, int message);

    // handle launchCfgDialog
    void storeLaunchCfgDialog (vuLaunchCfgDialogClass *cd) 
	{ launchCfgDialog = cd; }
    vuLaunchCfgDialogClass *getLaunchCfgDialog (void) 
	{ return (launchCfgDialog); }
};

#endif vulaunchcfgdialogclassHXX

