#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuMbbiDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuMbbiDialogClass, vuCommonDialogClass, "vuMbbiDialogClass");

/*******************************************************************
*
*    vuMbbiDialogClass override for constructors init ()
*
*******************************************************************/

void vuMbbiDialogClass::LoadInit (vresource res)
{
    // load in the mbbi specific fields
    mbbiContainer = vuMbbiContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    mbbiContainer -> boardType -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> line -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> addr -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> card -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> signal -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> processInput -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> maximizeSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> reference -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> constantValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> nobt -> SetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> manual -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);

    mbbiContainer -> zrvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> zrstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> zrsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> onvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> onstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> onsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> twvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> twstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> twsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> thvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> thstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> thsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> frvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> frstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> frsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> fvvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> fvstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> fvsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> sxvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> sxstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> sxsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> svvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> svstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> svsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> eivlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> eistValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> eisvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> nivlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> nistValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> nisvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> tevlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> testValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> tesvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> elvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> elstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> elsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> tvvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> tvstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> tvsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> ttvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> ttstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> ttsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> ftvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> ftstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> ftsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> ffvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> ffstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> ffsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);

    mbbiContainer -> cosSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> undefSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbbiContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> alarmDelay -> SetTextModifiedPtr (&this -> dialogModified);
    mbbiContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    mbbiContainer -> referenceButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    mbbiContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    mbbiContainer -> reference -> storeCommonDialog ((vuCommonDialogClass *)this);
    mbbiContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    mbbiContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_MBBI);

    // get the title from the resource file, aiTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    mbbiTitle = vresourceGetString (dialogTitles, 
				vunames_vuMbbiDialogTitle);
    SetTitle (mbbiTitle);
}


/*******************************************************************
*
*    vuMbbiDialogClass Destroy function
*
*******************************************************************/

void vuMbbiDialogClass::Destroy (void)
{
    vstrDestroy (mbbiTitle);
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuMbbiDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuMbbiDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    dialogItem = vuFindContainerItem (mbbiContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the Mbbi's line field
		if ( ((vcharCompareBounded (epics, "LINE", FLDNAME_SZ)) == 0) ||
		     ((vcharCompareBounded (epics, "ADDR", FLDNAME_SZ)) == 0) ||
		     ((vcharCompareBounded (epics, "CARD", FLDNAME_SZ)) == 0) ||
		     ((vcharCompareBounded (epics, "SIGN", FLDNAME_SZ)) == 0) )
		{
		    vstr *zero = vresourceGetString (defRes, 
						vunames_vuZeroDefault);
		    textItem -> SetText (zero);
		    vstrDestroy (zero);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (spinner -> GetMin());
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuMbbiDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;
    DTYP_TYPE		dType;		// device type indicator

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT an MBBI
	if (ptType != VU_MBBI)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_MBBI);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    // since the mbbi can be a hardware point, find what we are for later use
    // by getting the DTYP (device type) dictionary entry
    referenceString = vstrCloneScribed (vcharScribeSystem ("REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("CONSTANT"));
    xrefNode = (xrefNodeClass *)(dict -> GetElem (
			vnameGetGlobalScribed (vcharScribeSystem ("DTYP"))));
    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
    if ( (vcharCompare ((const vchar *)dbValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare ((const vchar *)dbValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
			pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindContainerItem (mbbiContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    // to output CONSTANT field, device type must be CONSTANT
		    if ( (strncmp (xrefNode -> xrefEpicsName, "CNST", FLDNAME_SZ)) == 0)
		    {
			if (dType != VU_CONSTANT)
			    continue;
		    }
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		    if ( (strncmp (xrefNode -> xrefEpicsName, "INP ", FLDNAME_SZ)) == 0)
		    {
			// device type must be REFERENCE to output the reference
			if (dType == VU_REFERENCE)
			{
			    DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
					      dbValue, &dbaseType);
			    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
			}
			else
			{
			    finalValue = vstrCloneScribed (vcharScribeSystem (""));
			}
		    }
		    else
			finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (vnum::ParseInt (finalValue, NULL));
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuMbbiDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    char		vuCurrentBoard [VU_KEY_SIZE];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dType;		// device type
    double		doubleValue;
    int			doSave;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    // since the ai can be a hardware point, find what we are for later use
    // by getting the DTYP (BOARD) value from the dialog
    referenceString = vstrCloneScribed (vcharScribeSystem ("REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("CONSTANT"));
    vcharCopyScribedBounded (vcharScribeSystem ("DTYP"), epics, FLDNAME_SZ);
    epics[sizeof (epics) - 1] = 0;
    // find the BOARD (DTYP) field and get its value
    dialogItem = vuFindContainerItem (mbbiContainer, epics);
    optionMenu = (vcontrolOptionMenu *)dialogItem;
    optionMenuValue = vuGetOptionMenuValue (optionMenu);
    vcharExport (vcharScribeSystemExport (optionMenuValue), (void *)vuCurrentBoard);
    if ( (vcharCompare (optionMenuValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare (optionMenuValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
			pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindContainerItem (mbbiContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
		    {
			spinner = (vspinner *)dialogItem;
			// buf fix, spinner mau not have proper value
			spinner -> Unfocus ();
			stringValue = spinner -> GetTextAsString ();
		    }
		    else
		    {
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
		    }
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    if ( (strncmp (xrefNode -> xrefEpicsName, "CNST", FLDNAME_SZ)) == 0)
		    {
			if (dType != VU_CONSTANT)
			    doubleValue = 0;
		    }
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    if ( (strncmp (xrefNode -> xrefEpicsName, "DTYP", FLDNAME_SZ)) == 0)
		    {
			// write to DEVTYPE in pvmap
			DB_PutFieldValue (pntRecord, xrefNode -> xrefField, dbValue);
		    }
		    break;
		}

		case DBF_INLINK:
			if ( (strncmp (xrefNode -> xrefEpicsName, "INP ", FLDNAME_SZ)) 
										== 0)
			{
			    // always write the boardtype from DTYP into the INP field
			    DB_PutFieldValue (pntRecord, putField, vuCurrentBoard);
			    // if we are a reference then write INP into the REFERENCE 
			    // field
			    if (dType == VU_REFERENCE)
			    {
				putField = xrefNode -> xrefRefField;
				textItem = (vtextitem *)dialogItem;
				stringValue = textItem -> GetTextAsString ();
				vcharExport (vcharScribeSystemExport (stringValue), 
									    dbValue);
				vstrDestroy (stringValue);
			    }
			    else
			    {
				// make sure to null out the field
				putField = xrefNode -> xrefRefField;
				vmemSet (dbValue, 0, VU_KEY_SIZE);
			    }
			}
			else
			{
			    textItem = (vtextitem *)dialogItem;
			    stringValue = textItem -> GetTextAsString ();
			    vcharExport (vcharScribeSystemExport (stringValue), 
									    dbValue);
			    vstrDestroy (stringValue);
			}
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuMbbiContainerClass, vcontainer, "vuMbbiContainerClass");

/*******************************************************************
*
*    vuMbbiContainerClass override for constructor
*
*******************************************************************/

void vuMbbiContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuMbbiContainer);

    vcontainer *btcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiDTYPContainer);
    boardType = vuBoardTypeMenuClass::RequestSubLoad (btcontainer,
				vunames_DTYP);

    vcontainer *linecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiLINEContainer);
    line = filteredTextitem::RequestSubLoad (linecontainer,
				vunames_LINE);

    vcontainer *addrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiADDRContainer);
    addr = filteredTextitem::RequestSubLoad (addrcontainer,
				vunames_ADDR);

    vcontainer *cardcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiCARDContainer);
    card = filteredTextitem::RequestSubLoad (cardcontainer,
				vunames_CARD);

    vcontainer *signalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiSIGNContainer);
    signal = filteredTextitem::RequestSubLoad (signalcontainer,
				vunames_SIGN);

    processInput = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCI);
    maximizeSeverity = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MAXS);

    vcontainer *refcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiINPContainer);
    referenceButton = vuPvNameButtonClass::RequestSubLoad (refcontainer,
				vunames_vuMbbiINPButton);
    reference = vuFilteredTextitem::RequestSubLoad (refcontainer,
				vunames_INP);

    vcontainer *cnstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiCNSTContainer);
    constantValue = filteredTextitem::RequestSubLoad (cnstcontainer,
				vunames_CNST);

    vcontainer *nobtcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiNOBTContainer);
    nobt = spinnerClass::RequestSubLoad (nobtcontainer,
				vunames_NOBT);

    manual = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MODE);
    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);
    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    vcontainer *zrvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiZRVLContainer);
    zrvlValue = filteredTextitem::RequestSubLoad (zrvlcontainer,
				vunames_ZRVL);
    vcontainer *zrstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiZRSTContainer);
    zrstValue = filteredTextitem::RequestSubLoad (zrstcontainer,
				vunames_ZRST);
    vcontainer *zrsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiZRSVContainer);
    zrsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (zrsvcontainer,
				vunames_ZRSV);

    vcontainer *onvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiONVLContainer);
    onvlValue = filteredTextitem::RequestSubLoad (onvlcontainer,
				vunames_ONVL);
    vcontainer *onstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiONSTContainer);
    onstValue = filteredTextitem::RequestSubLoad (onstcontainer,
				vunames_ONST);
    vcontainer *onsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiONSVContainer);
    onsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (onsvcontainer,
				vunames_ONSV);

    vcontainer *twvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTWVLContainer);
    twvlValue = filteredTextitem::RequestSubLoad (twvlcontainer,
				vunames_TWVL);
    vcontainer *twstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTWSTContainer);
    twstValue = filteredTextitem::RequestSubLoad (twstcontainer,
				vunames_TWST);
    vcontainer *twsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTWSVContainer);
    twsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (twsvcontainer,
				vunames_TWSV);

    vcontainer *thvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTHVLContainer);
    thvlValue = filteredTextitem::RequestSubLoad (thvlcontainer,
				vunames_THVL);
    vcontainer *thstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTHSTContainer);
    thstValue = filteredTextitem::RequestSubLoad (thstcontainer,
				vunames_THST);
    vcontainer *thsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTHSVContainer);
    thsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (thsvcontainer,
				vunames_THSV);

    vcontainer *frvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFRVLContainer);
    frvlValue = filteredTextitem::RequestSubLoad (frvlcontainer,
				vunames_FRVL);
    vcontainer *frstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFRSTContainer);
    frstValue = filteredTextitem::RequestSubLoad (frstcontainer,
				vunames_FRST);
    vcontainer *frsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFRSVContainer);
    frsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (frsvcontainer,
				vunames_FRSV);

    vcontainer *fvvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFVVLContainer);
    fvvlValue = filteredTextitem::RequestSubLoad (fvvlcontainer,
				vunames_FVVL);
    vcontainer *fvstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFVSTContainer);
    fvstValue = filteredTextitem::RequestSubLoad (fvstcontainer,
				vunames_FVST);
    vcontainer *fvsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFVSVContainer);
    fvsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (fvsvcontainer,
				vunames_FVSV);

    vcontainer *sxvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiSXVLContainer);
    sxvlValue = filteredTextitem::RequestSubLoad (sxvlcontainer,
				vunames_SXVL);
    vcontainer *sxstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiSXSTContainer);
    sxstValue = filteredTextitem::RequestSubLoad (sxstcontainer,
				vunames_SXST);
    vcontainer *sxsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiSXSVContainer);
    sxsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (sxsvcontainer,
				vunames_SXSV);

    vcontainer *svvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiSVVLContainer);
    svvlValue = filteredTextitem::RequestSubLoad (svvlcontainer,
				vunames_SVVL);
    vcontainer *svstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiSVSTContainer);
    svstValue = filteredTextitem::RequestSubLoad (svstcontainer,
				vunames_SVST);
    vcontainer *svsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiSVSVContainer);
    svsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (svsvcontainer,
				vunames_SVSV);

    vcontainer *eivlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiEIVLContainer);
    eivlValue = filteredTextitem::RequestSubLoad (eivlcontainer,
				vunames_EIVL);
    vcontainer *eistcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiEISTContainer);
    eistValue = filteredTextitem::RequestSubLoad (eistcontainer,
				vunames_EIST);
    vcontainer *eisvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiEISVContainer);
    eisvSeverity = vuChoiceGblMenuClass::RequestSubLoad (eisvcontainer,
				vunames_EISV);

    vcontainer *nivlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiNIVLContainer);
    nivlValue = filteredTextitem::RequestSubLoad (nivlcontainer,
				vunames_NIVL);
    vcontainer *nistcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiNISTContainer);
    nistValue = filteredTextitem::RequestSubLoad (nistcontainer,
				vunames_NIST);
    vcontainer *nisvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiNISVContainer);
    nisvSeverity = vuChoiceGblMenuClass::RequestSubLoad (nisvcontainer,
				vunames_NISV);

    vcontainer *tevlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTEVLContainer);
    tevlValue = filteredTextitem::RequestSubLoad (tevlcontainer,
				vunames_TEVL);
    vcontainer *testcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTESTContainer);
    testValue = filteredTextitem::RequestSubLoad (testcontainer,
				vunames_TEST);
    vcontainer *tesvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTESVContainer);
    tesvSeverity = vuChoiceGblMenuClass::RequestSubLoad (tesvcontainer,
				vunames_TESV);

    vcontainer *elvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiELVLContainer);
    elvlValue = filteredTextitem::RequestSubLoad (elvlcontainer,
				vunames_ELVL);
    vcontainer *elstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiELSTContainer);
    elstValue = filteredTextitem::RequestSubLoad (elstcontainer,
				vunames_ELST);
    vcontainer *elsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiELSVContainer);
    elsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (elsvcontainer,
				vunames_ELSV);

    vcontainer *tvvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTVVLContainer);
    tvvlValue = filteredTextitem::RequestSubLoad (tvvlcontainer,
				vunames_TVVL);
    vcontainer *tvstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTVSTContainer);
    tvstValue = filteredTextitem::RequestSubLoad (tvstcontainer,
				vunames_TVST);
    vcontainer *tvsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTVSVContainer);
    tvsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (tvsvcontainer,
				vunames_TVSV);

    vcontainer *ttvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTTVLContainer);
    ttvlValue = filteredTextitem::RequestSubLoad (ttvlcontainer,
				vunames_TTVL);
    vcontainer *ttstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTTSTContainer);
    ttstValue = filteredTextitem::RequestSubLoad (ttstcontainer,
				vunames_TTST);
    vcontainer *ttsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiTTSVContainer);
    ttsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (ttsvcontainer,
				vunames_TTSV);

    vcontainer *ftvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFTVLContainer);
    ftvlValue = filteredTextitem::RequestSubLoad (ftvlcontainer,
				vunames_FTVL);
    vcontainer *ftstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFTSTContainer);
    ftstValue = filteredTextitem::RequestSubLoad (ftstcontainer,
				vunames_FTST);
    vcontainer *ftsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFTSVContainer);
    ftsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (ftsvcontainer,
				vunames_FTSV);

    vcontainer *ffvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFFVLContainer);
    ffvlValue = filteredTextitem::RequestSubLoad (ffvlcontainer,
				vunames_FFVL);
    vcontainer *ffstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFFSTContainer);
    ffstValue = filteredTextitem::RequestSubLoad (ffstcontainer,
				vunames_FFST);
    vcontainer *ffsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiFFSVContainer);
    ffsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (ffsvcontainer,
				vunames_FFSV);

    vcontainer *cosvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiCOSVContainer);
    cosSeverity = vuChoiceGblMenuClass::RequestSubLoad (cosvcontainer,
				vunames_COSV);

    vcontainer *unsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiUNSVContainer);
    undefSeverity = vuChoiceGblMenuClass::RequestSubLoad (unsvcontainer,
				vunames_UNSV);

    vcontainer *alrmgrpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (alrmgrpcontainer,
				vunames_ALGP);

    vcontainer *alarmdiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (alarmdiscontainer,
				vunames_vuMbbiADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (alarmdiscontainer,
				vunames_ADIS);

    vcontainer *alarmdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbbiALDLContainer);
    alarmDelay = filteredTextitem::RequestSubLoad (alarmdelcontainer,
				vunames_ALDL);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    referenceButton -> storePvName (reference);
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters
    line -> SetItemFilterFunc (numericFilter);
    addr -> SetItemFilterFunc (numericFilter);
    card -> SetItemFilterFunc (numericFilter);
    signal -> SetItemFilterFunc (numericFilter);

    reference -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *refText = (filteredText *)reference -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    refText -> SetUserPtr ((void *)reference);

    constantValue -> SetItemFilterFunc (numericFilter);

    zrvlValue -> SetItemFilterFunc (numericFilter);
    zrstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    onvlValue -> SetItemFilterFunc (numericFilter);
    onstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    twvlValue -> SetItemFilterFunc (numericFilter);
    twstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    thvlValue -> SetItemFilterFunc (numericFilter);
    thstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    frvlValue -> SetItemFilterFunc (numericFilter);
    frstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    fvvlValue -> SetItemFilterFunc (numericFilter);
    fvstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    sxvlValue -> SetItemFilterFunc (numericFilter);
    sxstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    svvlValue -> SetItemFilterFunc (numericFilter);
    svstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    eivlValue -> SetItemFilterFunc (numericFilter);
    eistValue -> SetItemFilterFunc (multiDigitalStateFilter);
    nivlValue -> SetItemFilterFunc (numericFilter);
    nistValue -> SetItemFilterFunc (multiDigitalStateFilter);
    tevlValue -> SetItemFilterFunc (numericFilter);
    testValue -> SetItemFilterFunc (multiDigitalStateFilter);
    elvlValue -> SetItemFilterFunc (numericFilter);
    elstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    tvvlValue -> SetItemFilterFunc (numericFilter);
    tvstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    ttvlValue -> SetItemFilterFunc (numericFilter);
    ttstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    ftvlValue -> SetItemFilterFunc (numericFilter);
    ftstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    ffvlValue -> SetItemFilterFunc (numericFilter);
    ffstValue -> SetItemFilterFunc (multiDigitalStateFilter);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *alrmDisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alrmDisText -> SetUserPtr ((void *)alarmDisable);

    alarmDelay -> SetItemFilterFunc (numericFilter);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    // build popup menus
    boardType    -> vuBuildBoardTypeMenu (VU_MBBI);
    zrsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    onsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    twsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    thsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    frsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    fvsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    sxsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    svsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    eisvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    nisvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    tesvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    elsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    tvsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    ttsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    ftsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    ffsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    cosSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    undefSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);

}

/*******************************************************************
*
*    vuMbbiContainerClass override for destructor
*
*******************************************************************/

void vuMbbiContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}

