#ifndef vumkptsdialogclassHXX
#define vumkptsdialogclassHXX

#include "vuFindDialogClass.hxx"

class vuMkPtsMarkButtonClass;
class vuMkPtsUnmarkButtonClass;
class vuMkPtsDismissButtonClass;
class vuMkPtsFindButtonClass;
class vuMkPtsRulerClass;
class vuMkPtsDialogClass;

// *** MARK POINTS CONTAINER CLASS ***************************************************

class  vuMkPtsContainerClass : public vcontainer
{

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuMkPtsContainerClass);

    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuMkPtsContainerClass, vcontainer);	

    // override to load dialog
    void LoadInit(vresource res);		

    // override 
    void Destroy ();

    vlistview			*pointList;
    vdialogLabelItem		*pointsFoundLabel;
    vuMkPtsMarkButtonClass	*markButton;
    vuMkPtsUnmarkButtonClass	*unmarkButton;
    vuMkPtsRulerClass		*ruler;
};


// *** MARK POINTS RULER CLASS **********************************************

class vuMkPtsRulerClass : public vruler
{

    vuMkPtsDialogClass *mkptsDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuMkPtsRulerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuMkPtsRulerClass, vruler);

    // override
    void ObserveRuler (vevent *event, vrulerItem *item, int message);

    // functions to handle mkptsDialog
    void setMkPtsDialog (vuMkPtsDialogClass *dialog)
	{ mkptsDialog = dialog; }
};


// *** MARK POINTS MARK BUTTON CLASS *******************************************

class vuMkPtsMarkButtonClass : public vbutton
{
    vuMkPtsDialogClass	*mkptsDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuMkPtsMarkButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuMkPtsMarkButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle mkptsDialog
    void setMkPtsDialog (vuMkPtsDialogClass *dialog)
	{ mkptsDialog = dialog; }
};


// *** MARK POINTS UNMARK BUTTON CLASS ****************************************

class vuMkPtsUnmarkButtonClass : public vbutton
{
    vuMkPtsDialogClass	*mkptsDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuMkPtsUnmarkButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuMkPtsUnmarkButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle mkptsDialog
    void setMkPtsDialog (vuMkPtsDialogClass *dialog)
	{ mkptsDialog = dialog; }
};


// *** MARK POINTS DISMISS BUTTON CLASS **************************************

class vuMkPtsDismissButtonClass : public vbutton
{
    vuMkPtsDialogClass	*mkptsDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuMkPtsDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuMkPtsDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle mkptsDialog
    void setMkPtsDialog (vuMkPtsDialogClass *dialog) 
	{ mkptsDialog = dialog; }
};


// *** MARK POINTS FIND BUTTON CLASS *****************************************

class vuMkPtsFindButtonClass : public vbutton
{
    vuMkPtsDialogClass	*mkptsDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuMkPtsFindButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuMkPtsFindButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle mkptsDialog
    void setMkPtsDialog (vuMkPtsDialogClass *dialog) 
	{ mkptsDialog = dialog; }
};


// *** MARK POINTS DIALOG CLASS **********************************************

class vuMkPtsDialogClass : public vuFindDialogClass
{
    vuMkPtsContainerClass	*mkPtsContainer;
    vstr			*dialogTitle;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuMkPtsDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuMkPtsDialogClass, vuFindDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // override
    void ObserveWindow (vevent *event);

    // override
    void vuFindOpen (vchar *label, vuMainDialogClass *mainDialog,int multiSelect);

    // function to handle mkPtsContainer
    vuMkPtsContainerClass *getMkPtsContainer (void)
	{ return (mkPtsContainer); }

    vuMkPtsDismissButtonClass	*dismissButton;
    vuMkPtsFindButtonClass	*findButton;
};

#endif vumkptsdialogclassHXX
