#ifndef vunavigatordialogclassHXX
#define vunavigatordialogclassHXX

#include "vuFindDialogClass.hxx"

class vuNavPtListClass;
class vuNavOkButtonClass;
class vuNavDismissButtonClass;
class vuNavFindButtonClass;
class vuNavigatorDialogClass;

// *** NAVIGATOR CONTAINER CLASS ***************************************************

class  vuNavContainerClass : public vcontainer
{

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuNavContainerClass);

    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuNavContainerClass, vcontainer);	

    // override to load dialog
    void LoadInit(vresource res);		

    // override 
    void Destroy ();

    vuNavPtListClass		*pointList;
    vdialogLabelItem		*pointsFoundLabel;
    vuNavOkButtonClass		*okButton;
};


// *** NAVIGATOR POINT NAME LISTVIEW **********************************************

class vuNavPtListClass : public vlistview
{

    vuNavigatorDialogClass *navigatorDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuNavPtListClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuNavPtListClass, vlistview);

    // override
    void ObserveSelect (int state);

    // functions to handle navigatorDialog
    void setNavigatorDialog (vuNavigatorDialogClass *dialog)
	{ navigatorDialog = dialog; }
};


// *** NAVIGATOR OK BUTTON CLASS ***************************************************

class vuNavOkButtonClass : public vbutton
{
    vuNavigatorDialogClass	*navigatorDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuNavOkButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuNavOkButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle navigatorDialog
    void setNavigatorDialog (vuNavigatorDialogClass *dialog)
	{ navigatorDialog = dialog; }
};


// *** NAVIGATOR DISMISS BUTTON CLASS **********************************************

class vuNavDismissButtonClass : public vbutton
{
    vuNavigatorDialogClass	*navigatorDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuNavDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuNavDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle navigatorDialog
    void setNavigatorDialog (vuNavigatorDialogClass *dialog) 
	{ navigatorDialog = dialog; }
};


// *** NAVIGATOR FIND BUTTON CLASS **********************************************

class vuNavFindButtonClass : public vbutton
{
    vuNavigatorDialogClass	*navigatorDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuNavFindButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuNavFindButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle navigatorDialog
    void setNavigatorDialog (vuNavigatorDialogClass *dialog) 
	{ navigatorDialog = dialog; }
};


// *** NAVIGATOR DIALOG CLASS *****************************************************

class vuNavigatorDialogClass : public vuFindDialogClass
{
    vuNavContainerClass		*navContainer;
    char			**pvnameList;
    int				singleSelect;
    vstr			*dialogTitle;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuNavigatorDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuNavigatorDialogClass, vuFindDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // override
    void ObserveWindow (vevent *event);

    // override
    void vuFindOpen (vchar *label, vuMainDialogClass *mainDialog,int multiSelect);

    // override
    void vuRemovePvName (vchar *pvName);

    // functions to handle pvnameList
    char **getPvNameList (void)
	{ return (pvnameList); }
    void setPvNameList (char **list)
	{ pvnameList = list; }

    // function to handle singleSelect
    int getSingleSelect (void)
	{ return (singleSelect); }

    // function to handle navContainer
    vuNavContainerClass *getNavContainer (void)
	{ return (navContainer); }

    vuNavDismissButtonClass	*dismissButton;
    vuNavFindButtonClass	*findButton;
};

#endif vunavigatordialogclassHXX
