#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vlistviewHEADER
#include vliststrHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbDefs.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuOnlineAddDialogClass.hxx"
#include "vuUtils.hxx"


/*******************************************************************
*
*	ONLINE ADD DIALOG CLASS
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuOnlineAddDialogClass, vdialog, 
						"vuOnlineAddDialogClass");

/*******************************************************************
*
*    vuOnlineAddDialogClass 
*	LoadInit, constructor
*
*******************************************************************/

void vuOnlineAddDialogClass::LoadInit(vresource res)
{

    // call base class loadInit to finish the job
    vdialog::LoadInit(res);

    // set ptrs
    iocList -> setSelectOnlineAddDialog (this);
    downloadButton -> setSelectOnlineAddDialog (this);
    dismissButton -> setSelectOnlineAddDialog (this);

}


/*******************************************************************
*
*    vuOnlineAddDialogClass notify function
*
*******************************************************************/

void vuOnlineAddDialogClass::ObserveWindow(vevent *event)
{
    if ( event -> GetType() == veventWINDOW_STATE && event -> IsClose())
    {
	Close();
	vevent::StopProcessing ();
    }
}


/*******************************************************************
*
*    vuOnlineAddDialogClass Destroy function
*	if dialog is open, close it and stop its event loop
*
*******************************************************************/

void vuOnlineAddDialogClass::Destroy(void)
{
    if (IsOpen())
    {
	Close ();
	vevent::StopProcessing ();
    }

    // destroy list here

    vdialog::Destroy();
}


/*******************************************************************
*
*    vuOnlineAddDialogClas Open function
*
*******************************************************************/

void vuOnlineAddDialogClass::vuOnlineAddOpen(vuMainDialogClass *mainDialg)
{
    mainDialog = mainDialg;

    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    Place(GetRoot (), vrectPLACE_CENTER, vrectPLACE_CENTER);
    vdialog::Open();
    vevent::Process ();
}


/*******************************************************************
*
*    vuOnlineAddDownloadButtonClass 
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuOnlineAddDownloadButtonClass, vbutton, 
					"vuOnlineAddDownloadButtonClass");

/*******************************************************************
*
*    vuOnlineAddDownloadButtonClass Observer function
*
*******************************************************************/

void vuOnlineAddDownloadButtonClass::ObserveDialogItem (vevent *event)
{
    vevent::StopProcessing ();
}


/*******************************************************************
*
*    vuOnlineAddDismissButtonClass 
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuOnlineAddDismissButtonClass, vbutton, 
					"vuOnlineAddDismissButtonClass");

/*******************************************************************
*
*    vuOnlineAddDismissButtonClass Observer function
*
*******************************************************************/

void vuOnlineAddDismissButtonClass::ObserveDialogItem (vevent *event)
{
    onlineDialog -> Close ();
    vevent::StopProcessing ();
}


/*******************************************************************
*
*    vuOnlineAddListClass 
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuOnlineAddListClass, vlistview, 
					"vuOnlineAddListClass");

/*******************************************************************
*
*    vuOnlineAddListClass Observe function
*
*******************************************************************/

void vuOnlineAddListClass::ObserveSelect (int state)
{
    if (state == vlistviewSELECTION_HAS_CHANGED)
    {
	int clickCount = GetLastPointerClickCount ();
	if (clickCount == 2)
	{
	    onlineaddDialog -> Close ();
	    vevent::StopProcessing ();
	}
    }
}

