#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "choicePid.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuPidDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuPidDialogClass, vuCommonDialogClass, "vuPidDialogClass");

/*******************************************************************
*
*    vuPidDialogClass override for constructors init ()
*
*******************************************************************/

void vuPidDialogClass::LoadInit (vresource res)
{
    // load in the ai specific fields
    pidContainer = vuPidContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    pidContainer -> precision -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> eguTag -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> manual -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> initAction -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> mvChannel -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> mvProcess -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> mvMS -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> holdOnMvLoss -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> mvLossOutput -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> setptChannel -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> setptProcess -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> setptMS -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> initialSetpt -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> setptUpdate -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> reverseInit -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> cascadeOpen -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> cascadePercent -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> setptRamp -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> setptGap -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> setptCross -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> outputChannel -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> incremental -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> reverseOutput -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> cascadeChannel -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> cascadeProcess -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> cascadeMS -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> closeAction -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> propBand -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> reset -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> rate -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> errorSquared -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> deltaError -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> feedbackEnable -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> monitorDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> archiveDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> alarmDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> clampDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> eguLow -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> eguHigh -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> displayLow -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> displayHigh -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> setptClampLow -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> setptClampHigh -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> outputClampLow -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> outputClampHigh -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> deviationLimit -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> clampLowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> clampHighSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> deviationSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> noSetptSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> noMvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> noOutputSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> noCascadeCtrlSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> trackingModeSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pidContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);
    pidContainer -> alarmDelay -> SetTextModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    pidContainer -> mvChannelButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pidContainer -> setptChannelButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pidContainer -> outputChannelButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pidContainer -> cascadeChannelButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pidContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    pidContainer -> mvChannel -> storeCommonDialog ((vuCommonDialogClass *)this);
    pidContainer -> setptChannel -> storeCommonDialog ((vuCommonDialogClass *)this);
    pidContainer -> outputChannel -> storeCommonDialog ((vuCommonDialogClass *)this);
    pidContainer -> cascadeChannel -> storeCommonDialog ((vuCommonDialogClass *)this);
    pidContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    pidContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_PID);

    // get the title from the resource file, aiTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    pidTitle = vresourceGetString (dialogTitles, 
				vunames_vuPidDialogTitle);
    SetTitle (pidTitle);
}


/*******************************************************************
*
*    vuPidDialogClass Destroy function
*
*******************************************************************/

void vuPidDialogClass::Destroy (void)
{
    vstrDestroy (pidTitle);
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuPidDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuPidDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    dialogItem = vuFindContainerItem (pidContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the archive deadband field
		if ( (vcharCompareBounded (epics, "ADEL", FLDNAME_SZ)) == 0)
		{
		    vstr *adel = vresourceGetString (defRes, 
						vunames_vuADELdefault);
		    textItem -> SetText (adel);
		    vstrDestroy (adel);
		}
		else if ( (vcharCompareBounded (epics, "PREC", FLDNAME_SZ)) == 0)
		{
		    vstr *precision = vresourceGetString (defRes, 
						vunames_vuPRECdefault);
		    textItem -> SetText (precision);
		    vstrDestroy (precision);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuPidDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;

    char		pvName [PVNAME_SZ + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT an PID
	if (ptType != VU_PID)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_PID);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
			pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindContainerItem (pidContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuPidDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;

    char		pvName [PVNAME_SZ + 1];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
			pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindContainerItem (pidContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_INLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuPidContainerClass, vcontainer, "vuPidContainerClass");

/*******************************************************************
*
*    vuPidContainerClass override for constructor
*
*******************************************************************/

void vuPidContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuPidContainer);


    vcontainer *preccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidPRECContainer);
    precision = filteredTextitem::RequestSubLoad (preccontainer,
				vunames_PREC);

    vcontainer *egutagcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidEGUContainer);
    eguTag = filteredTextitem::RequestSubLoad (egutagcontainer,
				vunames_EGU);

    manual = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AM);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    vcontainer *iactcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidIACTContainer);
    initAction = vuChoiceRecMenuClass::RequestSubLoad (iactcontainer,
				vunames_IACT);

    vcontainer *mvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidMVLContainer);
    mvChannelButton = vuPvNameButtonClass::RequestSubLoad (mvlcontainer,
				vunames_vuPidMVLButton);
    mvChannel = vuFilteredTextitem::RequestSubLoad (mvlcontainer,
				vunames_MVL);

    mvProcess = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC2);

    mvMS = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS2);

    holdOnMvLoss = vuCheckBoxClass::RequestSubLoad (this,
				vunames_HOLD);

    vcontainer *mvlosscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidHVALContainer);
    mvLossOutput = filteredTextitem::RequestSubLoad (mvlosscontainer,
				vunames_HVAL);

    vcontainer *spcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidSTPLContainer);
    setptChannelButton = vuPvNameButtonClass::RequestSubLoad (spcontainer,
				vunames_vuPidSTPLButton);
    setptChannel = vuFilteredTextitem::RequestSubLoad (spcontainer,
				vunames_STPL);

    setptProcess = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCI);

    setptMS = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MAXS);

    vcontainer *istpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidISTPContainer);
    initialSetpt = filteredTextitem::RequestSubLoad (istpcontainer,
				vunames_ISTP);

    setptUpdate = vuCheckBoxClass::RequestSubLoad (this,
				vunames_USTP);

    reverseInit = vuCheckBoxClass::RequestSubLoad (this,
				vunames_RINI);

    cascadeOpen = vuCheckBoxClass::RequestSubLoad (this,
				vunames_USCS);

    cascadePercent = vuCheckBoxClass::RequestSubLoad (this,
				vunames_CPCT);

    vcontainer *srmpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidSRMPContainer);
    setptRamp = filteredTextitem::RequestSubLoad (srmpcontainer,
				vunames_SRMP);

    vcontainer *sptgcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidSPTGContainer);
    setptGap = filteredTextitem::RequestSubLoad (sptgcontainer,
				vunames_SPTG);

    setptCross = vuCheckBoxClass::RequestSubLoad (this,
				vunames_SPTC);

    vcontainer *routcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidROUTContainer);
    outputChannelButton = vuPvNameButtonClass::RequestSubLoad (routcontainer,
				vunames_vuPidROUTButton);
    outputChannel = vuFilteredTextitem::RequestSubLoad (routcontainer,
				vunames_ROUT);

    incremental = vuCheckBoxClass::RequestSubLoad (this,
				vunames_VELO);

    reverseOutput = vuCheckBoxClass::RequestSubLoad (this,
				vunames_RACT);

    vcontainer *dscscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidDSCSContainer);
    cascadeChannelButton = vuPvNameButtonClass::RequestSubLoad (dscscontainer,
				vunames_vuPidDSCSButton);
    cascadeChannel = vuFilteredTextitem::RequestSubLoad (dscscontainer,
				vunames_DSCS);

    cascadeProcess = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC3);

    cascadeMS = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS3);

    vcontainer *aclocontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidACLOContainer);
    closeAction = vuChoiceRecMenuClass::RequestSubLoad (aclocontainer,
				vunames_ACLO);

    vcontainer *kpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidKPContainer);
    propBand = filteredTextitem::RequestSubLoad (kpcontainer,
				vunames_KP);

    vcontainer *kicontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidKIContainer);
    reset = filteredTextitem::RequestSubLoad (kicontainer,
				vunames_KI);

    vcontainer *kdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidKDContainer);
    rate = filteredTextitem::RequestSubLoad (kdcontainer,
				vunames_KD);

    errorSquared = vuCheckBoxClass::RequestSubLoad (this,
				vunames_ESQR);

    deltaError = vuCheckBoxClass::RequestSubLoad (this,
				vunames_DMOD);

    feedbackEnable = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OPTR);

    vcontainer *dbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidDbContainer);

    vcontainer *mdelcontainer = vcontainer::RequestSubLoad (dbcontainer,
				vunames_vuPidMDELContainer);
    monitorDeadband = filteredTextitem::RequestSubLoad (mdelcontainer,
				vunames_MDEL);

    vcontainer *adelcontainer = vcontainer::RequestSubLoad (dbcontainer,
				vunames_vuPidADELContainer);
    archiveDeadband = filteredTextitem::RequestSubLoad (adelcontainer,
				vunames_ADEL);

    vcontainer *hystcontainer = vcontainer::RequestSubLoad (dbcontainer,
				vunames_vuPidHYSTContainer);
    alarmDeadband = filteredTextitem::RequestSubLoad (hystcontainer,
				vunames_HYST);

    vcontainer *cdelcontainer = vcontainer::RequestSubLoad (dbcontainer,
				vunames_vuPidCDELContainer);
    clampDeadband = filteredTextitem::RequestSubLoad (cdelcontainer,
				vunames_CDEL);

    vcontainer *valuescontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidValuesContainer);

    vcontainer *egulowcontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidEGULContainer);
    eguLow = filteredTextitem::RequestSubLoad (egulowcontainer,
				vunames_EGUL);

    vcontainer *eguhicontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidEGUFContainer);
    eguHigh = filteredTextitem::RequestSubLoad (eguhicontainer,
				vunames_EGUF);

    vcontainer *dsplowcontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidLOPRContainer);
    displayLow = filteredTextitem::RequestSubLoad (dsplowcontainer,
				vunames_LOPR);

    vcontainer *dsphicontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidHOPRContainer);
    displayHigh = filteredTextitem::RequestSubLoad (dsphicontainer,
				vunames_HOPR);

    vcontainer *stlccontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidSTLCContainer);
    setptClampLow = filteredTextitem::RequestSubLoad (stlccontainer,
				vunames_STLC);

    vcontainer *sthccontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidSTHCContainer);
    setptClampHigh = filteredTextitem::RequestSubLoad (sthccontainer,
				vunames_STHC);

    vcontainer *outlcontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidOUTLContainer);
    outputClampLow = filteredTextitem::RequestSubLoad (outlcontainer,
				vunames_OUTL);

    vcontainer *outhcontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidOUTHContainer);
    outputClampHigh = filteredTextitem::RequestSubLoad (outhcontainer,
				vunames_OUTH);

    vcontainer *devlcontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidDEVLContainer);
    deviationLimit = filteredTextitem::RequestSubLoad (devlcontainer,
				vunames_DEVL);

    vcontainer *clsvcontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidCLSVContainer);
    clampLowSeverity = vuChoiceGblMenuClass::RequestSubLoad (clsvcontainer,
				vunames_CLSV);

    vcontainer *chsvcontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidCHSVContainer);
    clampHighSeverity = vuChoiceGblMenuClass::RequestSubLoad (chsvcontainer,
				vunames_CHSV);

    vcontainer *dvsvcontainer = vcontainer::RequestSubLoad (valuescontainer,
				vunames_vuPidDVSVContainer);
    deviationSeverity = vuChoiceGblMenuClass::RequestSubLoad (dvsvcontainer,
				vunames_DVSV);

    vcontainer *alarmcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidAlarmContainer);

    vcontainer *nssvcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPidNSSVContainer);
    noSetptSeverity = vuChoiceGblMenuClass::RequestSubLoad (nssvcontainer,
				vunames_NSSV);

    vcontainer *ncsvcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPidNCSVContainer);
    noMvSeverity = vuChoiceGblMenuClass::RequestSubLoad (ncsvcontainer,
				vunames_NCSV);

    vcontainer *nosvcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPidNOSVContainer);
    noOutputSeverity = vuChoiceGblMenuClass::RequestSubLoad (nosvcontainer,
				vunames_NOSV);

    vcontainer *nccscontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPidNCCSContainer);
    noCascadeCtrlSeverity = vuChoiceGblMenuClass::RequestSubLoad (nccscontainer,
				vunames_NCCS);

    vcontainer *tmsvcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPidTMSVContainer);
    trackingModeSeverity = vuChoiceGblMenuClass::RequestSubLoad (tmsvcontainer,
				vunames_TMSV);

    vcontainer *algpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (algpcontainer,
				vunames_ALGP);

    vcontainer *adiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (adiscontainer,
				vunames_vuPidADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (adiscontainer,
				vunames_ADIS);

    vcontainer *aldlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPidALDLContainer);
    alarmDelay = filteredTextitem::RequestSubLoad (aldlcontainer,
				vunames_ALDL);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    mvChannelButton -> storePvName (mvChannel);
    setptChannelButton -> storePvName (setptChannel);
    outputChannelButton -> storePvName (outputChannel);
    cascadeChannelButton -> storePvName (cascadeChannel);
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters

    mvChannel -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *mvText = (filteredText *)mvChannel -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    mvText -> SetUserPtr ((void *)mvChannel);

    setptChannel -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *setptText = (filteredText *)setptChannel -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    setptText -> SetUserPtr ((void *)setptChannel);

    outputChannel -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *outputText = (filteredText *)outputChannel -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    outputText -> SetUserPtr ((void *)outputChannel);

    cascadeChannel -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *cascadeText = (filteredText *)cascadeChannel -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    cascadeText -> SetUserPtr ((void *)cascadeChannel);

    precision -> SetItemFilterFunc (numericFilter);
    eguTag -> SetItemFilterFunc (egutagFilter);
    mvLossOutput -> SetItemFilterFunc (floatFilter);
    initialSetpt -> SetItemFilterFunc (floatFilter);
    setptRamp -> SetItemFilterFunc (floatFilter);
    setptGap -> SetItemFilterFunc (floatFilter);
    propBand -> SetItemFilterFunc (floatFilter);
    reset -> SetItemFilterFunc (floatFilter);
    rate -> SetItemFilterFunc (floatFilter);
    monitorDeadband -> SetItemFilterFunc (floatFilter);
    archiveDeadband -> SetItemFilterFunc (floatFilter);
    alarmDeadband -> SetItemFilterFunc (floatFilter);
    clampDeadband -> SetItemFilterFunc (floatFilter);
    eguLow -> SetItemFilterFunc (floatFilter);
    eguHigh -> SetItemFilterFunc (floatFilter);
    displayLow -> SetItemFilterFunc (floatFilter);
    displayHigh -> SetItemFilterFunc (floatFilter);
    setptClampLow -> SetItemFilterFunc (floatFilter);
    setptClampHigh -> SetItemFilterFunc (floatFilter);
    outputClampLow -> SetItemFilterFunc (floatFilter);
    outputClampHigh -> SetItemFilterFunc (floatFilter);
    deviationLimit -> SetItemFilterFunc (floatFilter);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *adisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    adisText -> SetUserPtr ((void *)alarmDisable);

    alarmDelay -> SetItemFilterFunc (numericFilter);

    // build popup menus
    initAction   -> vuBuildOptionMenu (VU_PID, REC_PID_IACT );
    closeAction -> vuBuildOptionMenu (VU_PID, REC_PID_AUTOCLOSE);
    clampLowSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    clampHighSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    deviationSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    noSetptSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    noMvSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    noOutputSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    noCascadeCtrlSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    trackingModeSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);

}

/*******************************************************************
*
*    vuPidContainerClass override for destructor
*
*******************************************************************/

void vuPidContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}

