#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "choicePot.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuPotDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuPotDialogClass, vuCommonDialogClass, "vuPotDialogClass");

/*******************************************************************
*
*    vuPotDialogClass override for constructors init ()
*
*******************************************************************/

void vuPotDialogClass::LoadInit (vresource res)
{
    // load in the ai specific fields
    potContainer = vuPotContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    potContainer -> tempPV -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> processTemp -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> msTemp -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> custodyPV -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> processCustody -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> msCustody -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> flowPV -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> processFlow -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> msFlow -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> meterPV -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> processMeter -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> msMeter -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> pressPV -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> processPress -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> msPress -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> permitPV -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> processPermit -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> msPermit -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> okPV -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> processOk -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> msOk -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> transferPV -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> processTransfer -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> msTransfer -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> volPV -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> processVol -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> msVol -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> tempUnits -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> mode -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> custodyUnits -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> potType -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> flowUnits -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> meterFactor -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> productChg -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> movementSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> initEMS -> vuSetModifiedPtr (&this -> dialogModified);
    potContainer -> productDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> monitorDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> archiveDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> issueCommand -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> receiveCommand -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> stopCommand -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> issueStatus -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> receiveStatus -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> stopStatus -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> apiTable -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> apiSpGravity -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> product -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    potContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    potContainer -> tempPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> custodyPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> flowPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> meterPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> pressPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> permitPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> okPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> transferPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> volPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    potContainer -> tempPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> custodyPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> flowPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> meterPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> pressPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> permitPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> okPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> transferPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> volPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    potContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    potContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_POT);

    // get the title from the resource file, biTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    potTitle = vresourceGetString (dialogTitles, 
				vunames_vuPotDialogTitle);
    SetTitle (potTitle);
}


/*******************************************************************
*
*    vuPotDialogClass Destroy function
*
*******************************************************************/

void vuPotDialogClass::Destroy (void)
{
    vstrDestroy (potTitle);
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuPotDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuPotDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    dialogItem = vuFindContainerItem (potContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the archive deadband field
		if ( (vcharCompareBounded (epics, "ADEL", FLDNAME_SZ)) == 0)
		{
		    vstr *adel = vresourceGetString (defRes, 
						vunames_vuADELdefault);
		    textItem -> SetText (adel);
		    vstrDestroy (adel);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuPotDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT a POT
	if (ptType != VU_POT)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_POT);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed or new xrefOpId
	    if ( (lastTable != xrefNode -> xrefTable) ||
		 (strlen (xrefNode -> xrefOpId) ) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindContainerItem (potContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		case DBF_OUTLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuPotDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if  ( (lastTable != xrefNode -> xrefTable) ||
		  (strlen (xrefNode -> xrefOpId)) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindContainerItem (potContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_INLINK:
		case DBF_OUTLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuPotContainerClass, vcontainer, "vuPotContainerClass");

/*******************************************************************
*
*    vuPotContainerClass override for constructor
*
*******************************************************************/

void vuPotContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuPotContainer);

    vcontainer *tempcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotTEMPContainer);
    tempPVButton = vuPvNameButtonClass::RequestSubLoad (tempcontainer,
				vunames_vuPotTEMPButton);
    tempPV = vuFilteredTextitem::RequestSubLoad (tempcontainer,
				vunames_TEMP);
    processTemp = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC2);
    msTemp = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS2);

    vcontainer *cuspcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotCUSPContainer);
    custodyPVButton = vuPvNameButtonClass::RequestSubLoad (cuspcontainer,
				vunames_vuPotCUSPButton);
    custodyPV = vuFilteredTextitem::RequestSubLoad (cuspcontainer,
				vunames_CUSP);
    processCustody = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC1);
    msCustody = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS1);

    vcontainer *flwpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotFLWPContainer);
    flowPVButton = vuPvNameButtonClass::RequestSubLoad (flwpcontainer,
				vunames_vuPotFLWPButton);
    flowPV = vuFilteredTextitem::RequestSubLoad (flwpcontainer,
				vunames_FLWP);
    processFlow = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC8);
    msFlow = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS8);

    vcontainer *metpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotMETPContainer);
    meterPVButton = vuPvNameButtonClass::RequestSubLoad (metpcontainer,
				vunames_vuPotMETPButton);
    meterPV = vuFilteredTextitem::RequestSubLoad (metpcontainer,
				vunames_METP);
    processMeter = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC7);
    msMeter = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS7);

    vcontainer *prspcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotPRSPContainer);
    pressPVButton = vuPvNameButtonClass::RequestSubLoad (prspcontainer,
				vunames_vuPotPRSPButton);
    pressPV = vuFilteredTextitem::RequestSubLoad (prspcontainer,
				vunames_PRSP);
    processPress = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC6);
    msPress = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS6);

    vcontainer *rdypcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotRDYPContainer);
    permitPVButton = vuPvNameButtonClass::RequestSubLoad (rdypcontainer,
				vunames_vuPotRDYPButton);
    permitPV = vuFilteredTextitem::RequestSubLoad (rdypcontainer,
				vunames_RDYP);
    processPermit = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC3);
    msPermit = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS3);

    vcontainer *gokpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotGOKPContainer);
    okPVButton = vuPvNameButtonClass::RequestSubLoad (gokpcontainer,
				vunames_vuPotGOKPButton);
    okPV = vuFilteredTextitem::RequestSubLoad (gokpcontainer,
				vunames_GOKP);
    processOk = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC4);
    msOk = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS4);

    vcontainer *etnfcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotETNFContainer);
    transferPVButton = vuPvNameButtonClass::RequestSubLoad (etnfcontainer,
				vunames_vuPotETNFButton);
    transferPV = vuFilteredTextitem::RequestSubLoad (etnfcontainer,
				vunames_ETNF);
    processTransfer = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC5);
    msTransfer = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS5);

    vcontainer *cvlpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotCVLPContainer);
    volPVButton = vuPvNameButtonClass::RequestSubLoad (cvlpcontainer,
				vunames_vuPotCVLPButton);
    volPV = vuFilteredTextitem::RequestSubLoad (cvlpcontainer,
				vunames_CVLP);
    processVol = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC9);
    msVol = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS9);

    vcontainer *tpuncontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotTPUNContainer);
    tempUnits = vuChoiceGblMenuClass::RequestSubLoad (tpuncontainer,
				vunames_TPUN);

    vcontainer *modecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotMODEContainer);
    mode = vuChoiceGblMenuClass::RequestSubLoad (modecontainer,
				vunames_MODE);

    vcontainer *councontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotCOUNContainer);
    custodyUnits = vuChoiceGblMenuClass::RequestSubLoad (councontainer,
				vunames_COUN);

    vcontainer *pottcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotPOTTContainer);
    potType = vuChoiceRecMenuClass::RequestSubLoad (pottcontainer,
				vunames_POTT);

    vcontainer *fluncontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotFLUNContainer);
    flowUnits = vuChoiceGblMenuClass::RequestSubLoad (fluncontainer,
				vunames_FLUN);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    vcontainer *mfaccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotMFACContainer);
    meterFactor = filteredTextitem::RequestSubLoad (mfaccontainer,
				vunames_MFAC);

    vcontainer *voldcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotVOLDContainer);
    productChg = filteredTextitem::RequestSubLoad (voldcontainer,
				vunames_VOLD);

    vcontainer *movscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotMOVSContainer);
    movementSeverity = vuChoiceGblMenuClass::RequestSubLoad (movscontainer,
				vunames_MOVS);

    initEMS = vuCheckBoxClass::RequestSubLoad (this,
				vunames_ESTP);

    vcontainer *movdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotMOVDContainer);
    productDeadband = filteredTextitem::RequestSubLoad (movdcontainer,
				vunames_MOVD);

    vcontainer *mdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotMDELContainer);
    monitorDeadband = filteredTextitem::RequestSubLoad (mdelcontainer,
				vunames_MDEL);

    vcontainer *adelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotADELContainer);
    archiveDeadband = filteredTextitem::RequestSubLoad (adelcontainer,
				vunames_ADEL);

    vcontainer *sisscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotSISSContainer);
    issueCommand = filteredTextitem::RequestSubLoad (sisscontainer,
				vunames_SISS);

    vcontainer *sreccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotSRECContainer);
    receiveCommand = filteredTextitem::RequestSubLoad (sreccontainer,
				vunames_SREC);

    vcontainer *sstpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotSSTPContainer);
    stopCommand = filteredTextitem::RequestSubLoad (sstpcontainer,
				vunames_SSTP);

    vcontainer *issscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotISSSContainer);
    issueStatus = filteredTextitem::RequestSubLoad (issscontainer,
				vunames_ISSS);

    vcontainer *recscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotRECSContainer);
    receiveStatus = filteredTextitem::RequestSubLoad (recscontainer,
				vunames_RECS);

    vcontainer *stpscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotSTPSContainer);
    stopStatus = filteredTextitem::RequestSubLoad (stpscontainer,
				vunames_STPS);

    vcontainer *apitcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotAPITContainer);
    apiTable = filteredTextitem::RequestSubLoad (apitcontainer,
				vunames_APIT);

    vcontainer *sgrvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotSGRVContainer);
    apiSpGravity = filteredTextitem::RequestSubLoad (sgrvcontainer,
				vunames_SGRV);

    vcontainer *prodcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotPRODContainer);
    product = filteredTextitem::RequestSubLoad (prodcontainer,
				vunames_PROD);

    vcontainer *algpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (algpcontainer,
				vunames_ALGP);

    vcontainer *adiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPotADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (adiscontainer,
				vunames_vuPotADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (adiscontainer,
				vunames_ADIS);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    tempPVButton -> storePvName (tempPV);
    custodyPVButton -> storePvName (custodyPV);
    flowPVButton -> storePvName (flowPV);
    meterPVButton -> storePvName (meterPV);
    pressPVButton -> storePvName (pressPV);
    permitPVButton -> storePvName (permitPV);
    okPVButton -> storePvName (okPV);
    transferPVButton -> storePvName (transferPV);
    volPVButton -> storePvName (volPV);
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters
    meterFactor -> SetItemFilterFunc (floatFilter);
    productChg -> SetItemFilterFunc (floatFilter);
    productDeadband -> SetItemFilterFunc (floatFilter);
    monitorDeadband -> SetItemFilterFunc (floatFilter);
    archiveDeadband -> SetItemFilterFunc (floatFilter);
    issueCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    receiveCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    stopCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    issueStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    receiveStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    stopStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    apiTable -> SetItemFilterFunc (tankfarmCmdStsFilter);
    apiSpGravity -> SetItemFilterFunc (floatFilter);
    product -> SetItemFilterFunc (tankfarmCmdStsFilter);


    tempPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *tempText = (filteredText *)tempPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    tempText -> SetUserPtr ((void *)tempPV);

    custodyPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *custodyText = (filteredText *)custodyPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    custodyText -> SetUserPtr ((void *)custodyPV);

    flowPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *flowText = (filteredText *)flowPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    flowText -> SetUserPtr ((void *)flowPV);

    meterPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *meterText = (filteredText *)meterPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    meterText -> SetUserPtr ((void *)meterPV);

    pressPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pressText = (filteredText *)pressPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pressText -> SetUserPtr ((void *)pressPV);

    permitPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *permitText = (filteredText *)permitPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    permitText -> SetUserPtr ((void *)permitPV);

    okPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *okText = (filteredText *)okPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    okText -> SetUserPtr ((void *)okPV);

    transferPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *transferText = (filteredText *)transferPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    transferText -> SetUserPtr ((void *)transferPV);

    volPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *volText = (filteredText *)volPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    volText -> SetUserPtr ((void *)volPV);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *alrmDisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alrmDisText -> SetUserPtr ((void *)alarmDisable);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    // build popup menus
    tempUnits -> vuBuildOptionMenu (GBL_TF_TEMP);
    mode -> vuBuildOptionMenu (GBL_TF_AUTO_MAN_LOCK);
    custodyUnits -> vuBuildOptionMenu (GBL_TF_VOLUME);
    potType -> vuBuildOptionMenu (VU_POT, REC_POT_TYPE);
    flowUnits -> vuBuildOptionMenu (GBL_TF_FLOW);
    movementSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
}

/*******************************************************************
*
*    vuPotContainerClass override for destructor
*
*******************************************************************/

void vuPotContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}
