#ifndef vupumpdialogclassHXX
#define	vupumpdialogclassHXX

class	vuPumpContainerClass : public vcontainer
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuPumpContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuPumpContainerClass, vcontainer);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // pointers to fields in container, public so don't need funcs to
    // get at them from vuPumpDialogClass

    vuPvNameButtonClass	*startPVButton;
    vuFilteredTextitem	*startPV;
    vuCheckBoxClass	*processStart;
    vuCheckBoxClass	*msStart;
    vuPvNameButtonClass	*stopPVButton;
    vuFilteredTextitem	*stopPV;
    vuCheckBoxClass	*processStop;
    vuCheckBoxClass	*msStop;
    vuPvNameButtonClass	*remoteLocalPVButton;
    vuFilteredTextitem	*remoteLocalPV;
    vuCheckBoxClass	*processRemoteLocal;
    vuCheckBoxClass	*msRemoteLocal;
    vuPvNameButtonClass	*temperaturePVButton;
    vuFilteredTextitem	*temperaturePV;
    vuCheckBoxClass	*processTemperature;
    vuCheckBoxClass	*msTemperature;
    vuCheckBoxClass	*temperatureTrip;
    vuPvNameButtonClass	*vibrationPVButton;
    vuFilteredTextitem	*vibrationPV;
    vuCheckBoxClass	*processVibration;
    vuCheckBoxClass	*msVibration;
    vuCheckBoxClass	*vibrationTrip;
    vuPvNameButtonClass	*pressurePVButton;
    vuFilteredTextitem	*pressurePV;
    vuCheckBoxClass	*processPressure;
    vuCheckBoxClass	*msPressure;
    vuCheckBoxClass	*pressureTrip;
    vuPvNameButtonClass	*permissivePVButton;
    vuFilteredTextitem	*permissivePV;
    vuCheckBoxClass	*processPermissive;
    vuCheckBoxClass	*msPermissive;
    vuPvNameButtonClass	*runConfirmPVButton;
    vuFilteredTextitem	*runConfirmPV;
    vuCheckBoxClass	*processRunConfirm;
    vuCheckBoxClass	*msRunConfirm;
    vuCheckBoxClass	*runConfirmTrip;

    filteredTextitem	*startCommand;
    filteredTextitem	*stopCommand;
    filteredTextitem	*remoteStatus;
    filteredTextitem	*localStatus;
    filteredTextitem	*runningStatus;
    filteredTextitem	*startingStatus;
    filteredTextitem	*stoppedStatus;
    filteredTextitem	*stoppingStatus;
    filteredTextitem	*faultStatus;
    filteredTextitem	*minOffStatus;

    vuChoiceGblMenuClass	*mode;
    vuCheckBoxClass	*onScan;
    vuCheckBoxClass	*onAlarm;
    vuCheckBoxClass	*localTracking;
    vuCheckBoxClass	*learnMode;
    vuCheckBoxClass		*alarmOnAuto;
    vuChoiceGblMenuClass	*autoSeverity;
    vuCheckBoxClass		*alarmOnManual;
    vuChoiceGblMenuClass	*manualSeverity;
    filteredTextitem	*minOffTime;
    spinnerClass	*runTimePrecision;
    filteredTextitem		*startTime;
    filteredTextitem		*startTimeDeadband;
    vuChoiceGblMenuClass	*startTimeSeverity;
    filteredTextitem		*stopTime;
    filteredTextitem		*stopTimeDeadband;
    vuChoiceGblMenuClass	*stopTimeSeverity;

    vuPvNameButtonClass	*alarmDisableButton;
    vuFilteredTextitem	*alarmDisable;
    vuFilteredTextitem	*alarmGroup;
};


//*** PUMP DIALOG CLASS **********************************************

class	vuPumpDialogClass : public vuCommonDialogClass
{
    vuPumpContainerClass	*pumpContainer;
    vstr			*pumpTitle;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuPumpDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuPumpDialogClass, vuCommonDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // overide base vuCommonDialogClass
    void resetDialog (void);

    // override base class load and save functions
    void vuLoadDialog (vchar *pointName);
    void vuSaveDialog (vchar *pointName);
};

#endif	vupumpdialogclassHXX

