#ifndef vusigdialogclassHXX
#define	vusigdialogclassHXX

// define values for the xrefNode inDialog flag

enum {
    VU_SIG_NOT_IN_DIALOG = 1,
    VU_SIG_IN_MAIN_DIALOG,
    VU_SIG_VALUES_DIALOG
};

class	vuSigValuesDialogClass;
class	vuSigValuesButtonClass;
class	vuSigValuesDismissButtonClass;

//*** SIG CONTAINER CLASS ********************************************

class	vuSigContainerClass : public vcontainer
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSigContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSigContainerClass, vcontainer);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // pointers to fields in container, public so don't need funcs to
    // get at them from vuSigDialogClass

    vuPvNameButtonClass	*inputButton;
    vuFilteredTextitem	*input;
    vuCheckBoxClass	*processInput;
    vuCheckBoxClass	*maximizeSeverity;
    vuCheckBoxClass	*onScan;
    vuCheckBoxClass	*onAlarm;
    filteredTextitem	*precision;
    filteredTextitem	*eguTag;
    filteredTextitem	*rocSamples;
    vuCheckBoxClass	*manual;
    vuCheckBoxClass	*useFixed;
    filteredTextitem	*monitorDeadband;
    filteredTextitem	*archiveDeadband;
    filteredTextitem	*alarmDeadband;

    filteredTextitem	*x1;
    filteredTextitem	*y1;
    filteredTextitem	*x2;
    filteredTextitem	*y2;
    filteredTextitem	*x3;
    filteredTextitem	*y3;
    filteredTextitem	*x4;
    filteredTextitem	*y4;
    filteredTextitem	*x5;
    filteredTextitem	*y5;
    filteredTextitem	*x6;
    filteredTextitem	*y6;
    filteredTextitem	*x7;
    filteredTextitem	*y7;
    filteredTextitem	*x8;
    filteredTextitem	*y8;
    filteredTextitem	*x9;
    filteredTextitem	*y9;
    filteredTextitem	*x10;
    filteredTextitem	*y10;
    filteredTextitem	*x11;
    filteredTextitem	*y11;
    filteredTextitem	*x12;
    filteredTextitem	*y12;
    filteredTextitem	*x13;
    filteredTextitem	*y13;
    filteredTextitem	*x14;
    filteredTextitem	*y14;
    filteredTextitem	*x15;
    filteredTextitem	*y15;
    filteredTextitem	*x16;
    filteredTextitem	*y16;

    filteredTextitem	*displayLow;
    filteredTextitem	*displayHigh;
    filteredTextitem	*devSetpt;
    spinnerClass	*numberValues;

    vuPvNameButtonClass	*alarmDisableButton;
    vuFilteredTextitem	*alarmDisable;
    filteredTextitem	*alarmDelay;
    vuFilteredTextitem	*alarmGroup;

    filteredTextitem		*hihiLimit;
    vuChoiceGblMenuClass	*hihiSeverity;
    filteredTextitem		*highLimit;
    vuChoiceGblMenuClass	*highSeverity;
    filteredTextitem		*lowLimit;
    vuChoiceGblMenuClass	*lowSeverity;
    filteredTextitem		*loloLimit;
    vuChoiceGblMenuClass	*loloSeverity;
    filteredTextitem		*fixedLowLimit;
    vuChoiceGblMenuClass	*fixedLowSeverity;
    filteredTextitem		*fixedHighLimit;
    vuChoiceGblMenuClass	*fixedHighSeverity;
    filteredTextitem		*rocLimit;
    vuChoiceGblMenuClass	*rocSeverity;
    filteredTextitem		*devLimit;
    vuChoiceGblMenuClass	*devSeverity;

    vuSigValuesButtonClass	*valuesButton;
};


//*** SIGCHAR DIALOG CLASS **********************************************

class	vuSigDialogClass : public vuCommonDialogClass
{
    vuSigContainerClass		*sigContainer;
    vuSigValuesDialogClass	*valuesDialog;
    vstr			*sigTitle;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSigDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSigDialogClass, vuCommonDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // overide base vuCommonDialogClass
    void resetDialog (void);

    // override base class load and save functions
    void vuLoadDialog (vchar *pointName);
    void vuSaveDialog (vchar *pointName);
};


//*** SIGCHAR VALUES DIALOG CLASS ***************************************

class vuSigValuesDialogClass : public vdialog
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSigValuesDialogClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuSigValuesDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    filteredTextitem	*x17;
    filteredTextitem	*y17;
    filteredTextitem	*x18;
    filteredTextitem	*y18;
    filteredTextitem	*x19;
    filteredTextitem	*y19;
    filteredTextitem	*x20;
    filteredTextitem	*y20;
    filteredTextitem	*x21;
    filteredTextitem	*y21;
    filteredTextitem	*x22;
    filteredTextitem	*y22;
    filteredTextitem	*x23;
    filteredTextitem	*y23;
    filteredTextitem	*x24;
    filteredTextitem	*y24;
    filteredTextitem	*x25;
    filteredTextitem	*y25;
    filteredTextitem	*x26;
    filteredTextitem	*y26;
    filteredTextitem	*x27;
    filteredTextitem	*y27;
    filteredTextitem	*x28;
    filteredTextitem	*y28;
    filteredTextitem	*x29;
    filteredTextitem	*y29;
    filteredTextitem	*x30;
    filteredTextitem	*y30;
    filteredTextitem	*x31;
    filteredTextitem	*y31;
    filteredTextitem	*x32;
    filteredTextitem	*y32;
    vuSigValuesDismissButtonClass	*dismissButton;
};


//*** SIGCHAR VALUES BUTTON CLASS **************************************

class vuSigValuesButtonClass : public vbutton
{
    vuSigDialogClass		*sigDialog;
    vuSigValuesDialogClass	*sigValuesDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuSigValuesButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuSigValuesButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the sig dialog
    void storeSigDialog (vuSigDialogClass *cd) 
	{ sigDialog = cd; }

    // handle the pointer to the sig values dialog
    void storeSigValuesDialog (vuSigValuesDialogClass *cd) 
	{ sigValuesDialog = cd; }
};


//*** SIG VALUES DIALOG DISMISS BUTTON CLASS ***************************

class vuSigValuesDismissButtonClass : public vbutton
{
    vuSigValuesDialogClass	*sigValuesDialogClass;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuSigValuesDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuSigValuesDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the sig values dialog
    void storeSigValuesDialog (vuSigValuesDialogClass *cd) 
	{ sigValuesDialogClass = cd; }
    vuSigValuesDialogClass *getSigValuesDialog (void) 
	{ return (sigValuesDialogClass); }
};

#endif	vusigdialogclassHXX

