#ifndef vustrcfgdialogclassHXX
#define	vustrcfgdialogclassHXX

class vuStrCfgTablesListClass;
class vuStrCfgValuesListClass;
class vuStrCfgApplyButtonClass;
class vuStrCfgDismissButtonClass;
class vuStrCfgDeleteButtonClass;
class vuStrCfgCompileButtonClass;
class vuStrCfgAddButtonClass;
class vuStrCfgRemoveButtonClass;


//*** STR CFG DIALOG CLASS *********************************************

class	vuStrCfgDialogClass : public vdialog
{
    int			dialogModified;
    vuMainDialogClass	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuStrCfgDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuStrCfgDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void vuStrCfgOpen (vuMainDialogClass *mainDialog)

    // functions to handle dialogModified
    int getDialogModify (void) { return (dialogModified); }
    void setDialogModify (int val) { dialogModified = val; }

    // function to handle mainDialog
    void storeMainDialog (vuMainDialogClass *cd)
	{ mainDialog = cd; }
    vuMainDialogClass *getMainDialog (void) 
	{ return (mainDialog); }

    // public so don't need funcs to get at

    vuStrCfgTablesListClass	*tablesList;
    vuStrCfgValuesListClass	*valuesList;
    filteredTextitem		*tableName;
    filteredTextitem		*level;
    filteredTextitem		*volume;
    vuStrCfgApplyButtonClass	*applyButton;
    vuStrCfgDismissButtonClass	*dismissButton;
    vuStrCfgDeleteButtonClass	*deleteButton;
    vuStrCfgCompileButtonClass	*compileButton;
    vuStrCfgAddButtonClass	*addButton;
    vuStrCfgRemoveButtonClass	*removeButton;

};


//*** STR CFG TABLES LIST CLASS ***************************************

class	vuStrCfgTablesListClass : public vlistview
{

    vuStrCfgDialogClass	*strCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuStrCfgTablesListClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuStrCfgTablesListClass, vlistview);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuStrCfgDialogClass *cd)
	{ strCfgDialog = cd; }

    // function to build the fields list
    int buildTablesList (void);

};


//*** STR CFG VALUES LIST CLASS ***************************************

class	vuStrCfgValuesListClass : public vlistview
{

    vuStrCfgDialogClass	*strCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuStrCfgValuesListClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuStrCfgValuesListClass, vlistview);

    // virtual member function override
    void ObserveSelect (int state);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuStrCfgDialogClass *cd)
	{ strCfgDialog = cd; }

    // function to build the values list
    void buildValuesList (void);

};


//*** STR CFG APPLY BUTTON CLASS ***************************************

class	vuStrCfgApplyButtonClass : public vbutton
{

    vuStrCfgDialogClass	*strCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuStrCfgApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuStrCfgApplyButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuStrCfgDialogClass *cd)
	{ strCfgDialog = cd; }
};


//*** STR CFG DISMISS BUTTON CLASS ***************************************

class	vuStrCfgDismissButtonClass : public vbutton
{

    vuStrCfgDialogClass	*strCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuStrCfgDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuStrCfgDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuStrCfgDialogClass *cd)
	{ strCfgDialog = cd; }
};


//*** STR CFG DELETE BUTTON CLASS ***************************************

class	vuStrCfgDeleteButtonClass : public vbutton
{

    vuStrCfgDialogClass	*strCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuStrCfgDeleteButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuStrCfgDeleteButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuStrCfgDialogClass *cd)
	{ strCfgDialog = cd; }
};


//*** STR CFG COMPILE BUTTON CLASS ***************************************

class	vuStrCfgCompileButtonClass : public vbutton
{

    vuStrCfgDialogClass	*strCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuStrCfgCompileButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuStrCfgCompileButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuStrCfgDialogClass *cd)
	{ strCfgDialog = cd; }
};


//*** STR CFG ADD BUTTON CLASS ***************************************

class	vuStrCfgAddButtonClass : public vbutton
{

    vuStrCfgDialogClass	*strCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuStrCfgAddButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuStrCfgAddButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuStrCfgDialogClass *cd)
	{ strCfgDialog = cd; }
};


//*** STR CFG REMOVE BUTTON CLASS ***************************************

class	vuStrCfgRemoveButtonClass : public vbutton
{

    vuStrCfgDialogClass	*strCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuStrCfgRemoveButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuStrCfgRemoveButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuStrCfgDialogClass *cd)
	{ strCfgDialog = cd; }
};

#endif	vustrcfgdialogclassHXX

