#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "choiceTank.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuTankDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuTankDialogClass, vuCommonDialogClass, "vuTankDialogClass");

/*******************************************************************
*
*    vuTankDialogClass override for constructors init ()
*
*******************************************************************/

void vuTankDialogClass::LoadInit (vresource res)
{
    // load in the tank specific fields
    tankContainer = vuTankContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    //********  store dialog modified flag for tank container items ***************

    tankContainer -> tankShape -> vuSetModifiedPtr (&this -> dialogModified);
    tankContainer -> height -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> diameter -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> elevation -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> product -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> issueCmd -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> receiveCmd -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> runCmd -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> stopCmd -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> issueStatus -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> receiveStatus -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> runStatus -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> stopStatus -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> settleTime -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> mode -> vuSetModifiedPtr (&this -> dialogModified);
    tankContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    tankContainer -> strappingTable -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> apiTable -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> apiSpGravity -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> monitorDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> archiveDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> roofType -> vuSetModifiedPtr (&this -> dialogModified);
    tankContainer -> roofWgt -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> landedLevel -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> floatLevel -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> notInstalled -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> critical -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> landed -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> floating -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> productMeasMeth -> vuSetModifiedPtr (&this -> dialogModified);
    tankContainer -> bswMeasMeth -> vuSetModifiedPtr (&this -> dialogModified);
    tankContainer -> productSensorLevel -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> bswSensorLevel -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> hiLevelTrip -> SetTextModifiedPtr (&this -> dialogModified);
    tankContainer -> lowLevelTrip -> SetTextModifiedPtr (&this -> dialogModified);

    // set the point type
    setPointType (VU_TANK);

    // get the title from the resource file, tankTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    tankTitle = vresourceGetString (dialogTitles, 
				vunames_vuTankDialogTitle);
    SetTitle (tankTitle);

    //********* load up the the other TANK dialogs ************************************

    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);

    //************ load the alarm dialog **********************************************

    vresource alarmDialogRes = vresourceGet (pointDictRes, vunames_vuTankAlarmDialog);
    alarmDialog = new vuTankAlarmDialogClass (alarmDialogRes);

    // store dialog ptr in alarm button
    tankContainer -> alarmButton -> storeTankAlarmDialog (alarmDialog);

    // store dialog modified flag in alarm fields
    alarmDialog -> hihiLevel -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> hihiSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> hihiES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> highLevel -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> highSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> highES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> lowLevel -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> lowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> lowES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> loloLevel -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> loloSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> loloES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> volChg -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> volChgSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> volChgES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> hihiTemp -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> hihiTempSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> hihiTempES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> highTemp -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> highTempSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> highTempES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> lowTemp -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> lowTempSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> lowTempES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> loloTemp -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> loloTempSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> loloTempES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> highBsw -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> highBswSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> highBswES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> lowLevelTripSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> lowLevelTripES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> highLevelTripSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> highLevelTripES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> valveStateSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> valveStateES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> lowPressSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> lowPressES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> highPressSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> highPressES -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> levelDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> volumeDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> tempDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> bswDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);

    // store ptr to dialog for vuPvNameButtonClass for alarm dialog
    alarmDialog -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuPvNameFilter for alarm dialog
    alarmDialog -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuAlarmGroupFilter for alarm dialog
    alarmDialog -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    //*************** load the valve dialog ******************************************

    vresource valveDialogRes = vresourceGet (pointDictRes, vunames_vuTankValveDialog);
    valveDialog = new vuTankValveDialogClass (valveDialogRes);

    // store dialog ptr in valve button
    tankContainer -> valveButton -> storeTankValveDialog (valveDialog);

    // store dialog modified flag in valve fields
    valveDialog -> valve01 -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> stopped01 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> issuing01 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> receiving01 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> running01 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> valve02 -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> stopped02 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> issuing02 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> receiving02 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> running02 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> valve03 -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> stopped03 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> issuing03 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> receiving03 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> running03 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> valve04 -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> stopped04 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> issuing04 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> receiving04 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> running04 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> valve05 -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> stopped05 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> issuing05 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> receiving05 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> running05 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> valve06 -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> stopped06 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> issuing06 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> receiving06 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> running06 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> valve07 -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> stopped07 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> issuing07 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> receiving07 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> running07 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> valve08 -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> stopped08 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> issuing08 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> receiving08 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> running08 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> valve09 -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> stopped09 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> issuing09 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> receiving09 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> running09 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> valve10 -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> stopped10 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> issuing10 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> receiving10 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> running10 -> vuSetModifiedPtr (&this -> dialogModified);
    valveDialog -> stoppedTimeout -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> issuingTimeout -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> receivingTimeout -> SetTextModifiedPtr (&this -> dialogModified);
    valveDialog -> runningTimeout -> SetTextModifiedPtr (&this -> dialogModified);

    // store ptr to dialog for vuPvNameButtonClass for valve dialog
    valveDialog -> valve01Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve02Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve03Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve04Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve05Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve06Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve07Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve08Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve09Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve10Button -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuPvNameFilter for valve dialog
    valveDialog -> valve01 -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve02 -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve03 -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve04 -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve05 -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve06 -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve07 -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve08 -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve09 -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveDialog -> valve10 -> storeCommonDialog ((vuCommonDialogClass *)this);

    //******************* load the temp dialog ************************************

    vresource tempDialogRes = vresourceGet (pointDictRes, vunames_vuTankTempDialog);
    tempDialog = new vuTankTempDialogClass (tempDialogRes);

    // store dialog ptr in temp button
    tankContainer -> tempButton -> storeTankTempDialog (tempDialog);

    // store dialog modified flag in valve fields
    tempDialog -> probe01 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> level01 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> proc01 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> ms01 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> probe02 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> level02 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> proc02 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> ms02 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> probe03 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> level03 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> proc03 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> ms03 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> probe04 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> level04 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> proc04 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> ms04 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> probe05 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> level05 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> proc05 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> ms05 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> probe06 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> level06-> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> proc06 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> ms06 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> probe07 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> level07 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> proc07 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> ms07 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> probe08 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> level08 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> proc08 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> ms08 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> probe09 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> level09 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> proc09 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> ms09 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> probe10 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> level10 -> SetTextModifiedPtr (&this -> dialogModified);
    tempDialog -> proc10 -> vuSetModifiedPtr (&this -> dialogModified);
    tempDialog -> ms10 -> vuSetModifiedPtr (&this -> dialogModified);

    // store ptr to dialog for vuPvNameButtonClass for temp dialog
    tempDialog -> probe01Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe02Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe03Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe04Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe05Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe06Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe07Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe08Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe09Button -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe10Button -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuPvNameFilter for temp dialog
    tempDialog -> probe01 -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe02 -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe03 -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe04 -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe05 -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe06 -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe07 -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe08 -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe09 -> storeCommonDialog ((vuCommonDialogClass *)this);
    tempDialog -> probe10 -> storeCommonDialog ((vuCommonDialogClass *)this);

    //******************* load the PV dialog ************************************

    vresource pvDialogRes = vresourceGet (pointDictRes, vunames_vuTankPVDialog);
    pvDialog = new vuTankPvDialogClass (pvDialogRes);

    // store dialog ptr in pv button
    tankContainer -> pvButton -> storeTankPvDialog (pvDialog);

    // store dialog modified flag in valve fields
    pvDialog -> levelPv -> SetTextModifiedPtr (&this -> dialogModified);
    pvDialog -> procLevelPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> msLevelPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> densityPv -> SetTextModifiedPtr (&this -> dialogModified);
    pvDialog -> procDensityPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> msDensityPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> massPv -> SetTextModifiedPtr (&this -> dialogModified);
    pvDialog -> procMassPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> msMassPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> avgTempPv -> SetTextModifiedPtr (&this -> dialogModified);
    pvDialog -> procAvgTempPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> msAvgTempPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> volumePv -> SetTextModifiedPtr (&this -> dialogModified);
    pvDialog -> procVolumePv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> msVolumePv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> highLevelPv -> SetTextModifiedPtr (&this -> dialogModified);
    pvDialog -> procHighLevelPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> msHighLevelPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> lowLevelPv -> SetTextModifiedPtr (&this -> dialogModified);
    pvDialog -> procLowLevelPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> msLowLevelPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> highPressPv -> SetTextModifiedPtr (&this -> dialogModified);
    pvDialog -> procHighPressPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> msHighPressPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> lowPressPv -> SetTextModifiedPtr (&this -> dialogModified);
    pvDialog -> procLowPressPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> msLowPressPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> bswPv -> SetTextModifiedPtr (&this -> dialogModified);
    pvDialog -> procBswPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> msBswPv -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> levelUnits -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> densityUnits -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> massUnits -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> tempUnits -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> volumeUnits -> vuSetModifiedPtr (&this -> dialogModified);
    pvDialog -> flowRateUnits -> vuSetModifiedPtr (&this -> dialogModified);

    // store ptr to dialog for vuPvNameButtonClass for temp dialog
    pvDialog -> levelPvButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> densityPvButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> massPvButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> avgTempPvButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> volumePvButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> highLevelPvButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> lowLevelPvButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> highPressPvButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> lowPressPvButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> bswPvButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuPvNameFilter for temp dialog
    pvDialog -> levelPv -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> densityPv -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> massPv -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> avgTempPv -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> volumePv -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> highLevelPv -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> lowLevelPv -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> highPressPv -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> lowPressPv -> storeCommonDialog ((vuCommonDialogClass *)this);
    pvDialog -> bswPv -> storeCommonDialog ((vuCommonDialogClass *)this);

}


/*******************************************************************
*
*    vuTankDialogClass Destroy function
*
*******************************************************************/

void vuTankDialogClass::Destroy (void)
{
    vstrDestroy (tankTitle);
    // delete the other tank dialogs
    delete alarmDialog;
    delete valveDialog;
    delete tempDialog;
    delete pvDialog;
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuTankDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuTankDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    int			firstTimeFlag;
    int			inDialogFlag;

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    firstTimeFlag = xrefNode -> getFirstTimeFlag ();
	    // only need to do this once
	    if (firstTimeFlag == vTRUE)
	    {
		xrefNode -> setFirstTimeFlag (vFALSE);
		// find which dialog this field is in
		dialogItem = vuFindContainerItem (tankContainer, epics);
		if (dialogItem == NULL)
		{
		    dialogItem = vuFindDialogItem (alarmDialog, epics);
		    if (dialogItem == NULL)
		    {
			dialogItem = vuFindDialogItem (valveDialog, epics);
			if (dialogItem == NULL)
			{
			    dialogItem = vuFindDialogItem (tempDialog, epics);
			    if (dialogItem == NULL)
			    {
				dialogItem = vuFindDialogItem (pvDialog, epics);
				if (dialogItem == NULL)
				{
				    xrefNode -> setInDialogFlag (VU_TANK_NOT_IN_DIALOG);
    				    continue;
				}
				else
				{
				    xrefNode -> setInDialogFlag (VU_TANK_IN_PV_DIALOG);
				}
			    }
			    else
			    {
				xrefNode -> setInDialogFlag (VU_TANK_IN_TEMP_DIALOG);
			    }
			}
			else
			{
			    xrefNode -> setInDialogFlag (VU_TANK_IN_VALVE_DIALOG);
			}
		    }
		    else
		    {
			xrefNode -> setInDialogFlag (VU_TANK_IN_ALARM_DIALOG);
		    }
		}
		else
		{
		    xrefNode -> setInDialogFlag (VU_TANK_IN_MAIN_DIALOG);
		}
	    }
	    else
	    {
		inDialogFlag = xrefNode -> getInDialogFlag ();
		dialogItem = NULL;
		switch (inDialogFlag)
		{
		    case VU_TANK_NOT_IN_DIALOG:
			break;

		    case VU_TANK_IN_MAIN_DIALOG:
			dialogItem = vuFindContainerItem (tankContainer, epics);
			break;

		    case VU_TANK_IN_ALARM_DIALOG:
			dialogItem = vuFindDialogItem (alarmDialog, epics);
			break;

		    case VU_TANK_IN_VALVE_DIALOG:
			dialogItem = vuFindDialogItem (valveDialog, epics);
			break;

		    case VU_TANK_IN_TEMP_DIALOG:
			dialogItem = vuFindDialogItem (tempDialog, epics);
			break;

		    case VU_TANK_IN_PV_DIALOG:
			dialogItem = vuFindDialogItem (pvDialog, epics);
			break;

		    default:
			break;
		}
	    }
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function 
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuTankDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;
    int			inDialogFlag;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT a TANK
	if (ptType != VU_TANK)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_TANK);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed or new xrefOpId
	    if ( (lastTable != xrefNode -> xrefTable) ||
		 (strlen (xrefNode -> xrefOpId) ) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;

	    inDialogFlag = xrefNode -> getInDialogFlag ();
	    dialogItem = NULL;
	    switch (inDialogFlag)
	    {
		case VU_TANK_NOT_IN_DIALOG:
		    break;

		case VU_TANK_IN_MAIN_DIALOG:
		    dialogItem = vuFindContainerItem (tankContainer, epics);
		    break;

		case VU_TANK_IN_ALARM_DIALOG:
		    dialogItem = vuFindDialogItem (alarmDialog, epics);
		    break;

		case VU_TANK_IN_VALVE_DIALOG:
		    dialogItem = vuFindDialogItem (valveDialog, epics);
		    break;

		case VU_TANK_IN_TEMP_DIALOG:
		    dialogItem = vuFindDialogItem (tempDialog, epics);
		    break;

		case VU_TANK_IN_PV_DIALOG:
		    dialogItem = vuFindDialogItem (pvDialog, epics);
		    break;

		default:
		    break;
	    }
	
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		case DBF_OUTLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuTankDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;
    int			inDialogFlag;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if  ( (lastTable != xrefNode -> xrefTable) ||
		  (strlen (xrefNode -> xrefOpId)) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    inDialogFlag = xrefNode -> getInDialogFlag ();
	    dialogItem = NULL;
	    switch (inDialogFlag)
	    {
		case VU_TANK_NOT_IN_DIALOG:
		    break;

		case VU_TANK_IN_MAIN_DIALOG:
		    dialogItem = vuFindContainerItem (tankContainer, epics);
		    break;

		case VU_TANK_IN_ALARM_DIALOG:
		    dialogItem = vuFindDialogItem (alarmDialog, epics);
		    break;

		case VU_TANK_IN_VALVE_DIALOG:
		    dialogItem = vuFindDialogItem (valveDialog, epics);
		    break;

		case VU_TANK_IN_TEMP_DIALOG:
		    dialogItem = vuFindDialogItem (tempDialog, epics);
		    break;

		case VU_TANK_IN_PV_DIALOG:
		    dialogItem = vuFindDialogItem (pvDialog, epics);
		    break;

		default:
		    break;
	    }
	
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_INLINK:
		case DBF_OUTLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


/*******************************************************************
*
*	Tank container class
*
********************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankContainerClass, vcontainer, 
						"vuTankContainerClass");

/*******************************************************************
*
*    vuTankContainerClass override for constructor
*
*******************************************************************/

void vuTankContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuTankContainer);

    vcontainer *tankChar = vcontainer::RequestSubLoad (this,
				vunames_vuTankCharContainer);

    vcontainer *shapcontainer = vcontainer::RequestSubLoad (tankChar,
				vunames_vuTankSHAPContainer);
    tankShape = vuChoiceRecMenuClass::RequestSubLoad (shapcontainer,
				vunames_SHAP);

    vcontainer *htlncontainer = vcontainer::RequestSubLoad (tankChar,
				vunames_vuTankHTLNContainer);
    height = filteredTextitem::RequestSubLoad (htlncontainer,
				vunames_HTLN);

    vcontainer *diamcontainer = vcontainer::RequestSubLoad (tankChar,
				vunames_vuTankDIAMContainer);
    diameter = filteredTextitem::RequestSubLoad (diamcontainer,
				vunames_DIAM);

    vcontainer *elevcontainer = vcontainer::RequestSubLoad (tankChar,
				vunames_vuTankELEVContainer);
    elevation = filteredTextitem::RequestSubLoad (elevcontainer,
				vunames_ELEV);

    vcontainer *prodcontainer = vcontainer::RequestSubLoad (tankChar,
				vunames_vuTankPRODContainer);
    product = filteredTextitem::RequestSubLoad (prodcontainer,
				vunames_PROD);

    vcontainer *tankCmds = vcontainer::RequestSubLoad (this,
				vunames_vuTankCmdsContainer);

    vcontainer *issccontainer = vcontainer::RequestSubLoad (tankCmds,
				vunames_vuTankISSCContainer);
    issueCmd = filteredTextitem::RequestSubLoad (issccontainer,
				vunames_ISSC);

    vcontainer *recccontainer = vcontainer::RequestSubLoad (tankCmds,
				vunames_vuTankRECCContainer);
    receiveCmd = filteredTextitem::RequestSubLoad (recccontainer,
				vunames_RECC);

    vcontainer *runccontainer = vcontainer::RequestSubLoad (tankCmds,
				vunames_vuTankRUNCContainer);
    runCmd = filteredTextitem::RequestSubLoad (runccontainer,
				vunames_RUNC);

    vcontainer *stpccontainer = vcontainer::RequestSubLoad (tankCmds,
				vunames_vuTankSTPCContainer);
    stopCmd = filteredTextitem::RequestSubLoad (stpccontainer,
				vunames_STPC);

    vcontainer *issscontainer = vcontainer::RequestSubLoad (tankCmds,
				vunames_vuTankISSSContainer);
    issueStatus = filteredTextitem::RequestSubLoad (issscontainer,
				vunames_ISSS);

    vcontainer *recscontainer = vcontainer::RequestSubLoad (tankCmds,
				vunames_vuTankRECSContainer);
    receiveStatus = filteredTextitem::RequestSubLoad (recscontainer,
				vunames_RECS);

    vcontainer *runscontainer = vcontainer::RequestSubLoad (tankCmds,
				vunames_vuTankRUNSContainer);
    runStatus = filteredTextitem::RequestSubLoad (runscontainer,
				vunames_RUNS);

    vcontainer *stpscontainer = vcontainer::RequestSubLoad (tankCmds,
				vunames_vuTankSTPSContainer);
    stopStatus = filteredTextitem::RequestSubLoad (stpscontainer,
				vunames_STPS);

    vcontainer *tsetcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuTankTSETContainer);
    settleTime = filteredTextitem::RequestSubLoad (tsetcontainer,
				vunames_TSET);

    vcontainer *modecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuTankMODEContainer);
    mode = vuChoiceGblMenuClass::RequestSubLoad (modecontainer,
				vunames_MODE);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    vcontainer *sttncontainer = vcontainer::RequestSubLoad (this,
				vunames_vuTankSTTNContainer);
    strappingTable = filteredTextitem::RequestSubLoad (sttncontainer,
				vunames_STTN);

    vcontainer *apitcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuTankAPITContainer);
    apiTable = filteredTextitem::RequestSubLoad (apitcontainer,
				vunames_APIT);

    vcontainer *sgrvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuTankSGRVContainer);
    apiSpGravity = filteredTextitem::RequestSubLoad (sgrvcontainer,
				vunames_SGRV);

    vcontainer *mdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuTankMDELContainer);
    monitorDeadband = filteredTextitem::RequestSubLoad (mdelcontainer,
				vunames_MDEL);

    vcontainer *adelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuTankADELContainer);
    archiveDeadband = filteredTextitem::RequestSubLoad (adelcontainer,
				vunames_ADEL);

    vcontainer *roof = vcontainer::RequestSubLoad (this,
				vunames_vuTankRoofContainer);

    vcontainer *rtypcontainer = vcontainer::RequestSubLoad (roof,
				vunames_vuTankRTYPContainer);
    roofType = vuChoiceRecMenuClass::RequestSubLoad (rtypcontainer,
				vunames_RTYP);

    vcontainer *rwgtcontainer = vcontainer::RequestSubLoad (roof,
				vunames_vuTankRWGTContainer);
    roofWgt = filteredTextitem::RequestSubLoad (rwgtcontainer,
				vunames_RWGT);

    vcontainer *rllvcontainer = vcontainer::RequestSubLoad (roof,
				vunames_vuTankRLLVContainer);
    landedLevel = filteredTextitem::RequestSubLoad (rllvcontainer,
				vunames_RLLV);

    vcontainer *rflvcontainer = vcontainer::RequestSubLoad (roof,
				vunames_vuTankRFLVContainer);
    floatLevel = filteredTextitem::RequestSubLoad (rflvcontainer,
				vunames_RFLV);

    vcontainer *rniscontainer = vcontainer::RequestSubLoad (roof,
				vunames_vuTankRNISContainer);
    notInstalled = filteredTextitem::RequestSubLoad (rniscontainer,
				vunames_RNIS);

    vcontainer *rcrscontainer = vcontainer::RequestSubLoad (roof,
				vunames_vuTankRCRSContainer);
    critical = filteredTextitem::RequestSubLoad (rcrscontainer,
				vunames_RCRS);

    vcontainer *rllscontainer = vcontainer::RequestSubLoad (roof,
				vunames_vuTankRLLSContainer);
    landed = filteredTextitem::RequestSubLoad (rllscontainer,
				vunames_RLLS);

    vcontainer *rflscontainer = vcontainer::RequestSubLoad (roof,
				vunames_vuTankRFLSContainer);
    floating = filteredTextitem::RequestSubLoad (rflscontainer,
				vunames_RFLS);

    vcontainer *sensors = vcontainer::RequestSubLoad (this,
				vunames_vuTankSensorContainer);

    vcontainer *pmeacontainer = vcontainer::RequestSubLoad (sensors,
				vunames_vuTankPMEAContainer);
    productMeasMeth = vuChoiceRecMenuClass::RequestSubLoad (pmeacontainer,
				vunames_PMEA);

    vcontainer *bmeacontainer = vcontainer::RequestSubLoad (sensors,
				vunames_vuTankBMEAContainer);
    bswMeasMeth = vuChoiceRecMenuClass::RequestSubLoad (bmeacontainer,
				vunames_BMEA);

    vcontainer *plvacontainer = vcontainer::RequestSubLoad (sensors,
				vunames_vuTankPLVAContainer);
    productSensorLevel = filteredTextitem::RequestSubLoad (plvacontainer,
				vunames_PLVA);

    vcontainer *blvacontainer = vcontainer::RequestSubLoad (sensors,
				vunames_vuTankBLVAContainer);
    bswSensorLevel = filteredTextitem::RequestSubLoad (blvacontainer,
				vunames_BLVA);

    vcontainer *htrpcontainer = vcontainer::RequestSubLoad (sensors,
				vunames_vuTankHTRPContainer);
    hiLevelTrip = filteredTextitem::RequestSubLoad (htrpcontainer,
				vunames_HTRP);

    vcontainer *ltrpcontainer = vcontainer::RequestSubLoad (sensors,
				vunames_vuTankLTRPContainer);
    lowLevelTrip = filteredTextitem::RequestSubLoad (ltrpcontainer,
				vunames_LTRP);

    alarmButton = vuTankAlarmButtonClass::RequestSubLoad (this,
				vunames_vuTankAlarmButton);

    valveButton = vuTankValveButtonClass::RequestSubLoad (this,
				vunames_vuTankValveButton);

    tempButton = vuTankTempButtonClass::RequestSubLoad (this,
				vunames_vuTankTempButton);

    pvButton = vuTankPvButtonClass::RequestSubLoad (this,
				vunames_vuTankPvButton);

    vcontainer::LoadInit (realRes);

    // set filters
    height -> SetItemFilterFunc (floatFilter);
    diameter -> SetItemFilterFunc (floatFilter);
    elevation -> SetItemFilterFunc (floatFilter);
    height -> SetItemFilterFunc (floatFilter);
    product -> SetItemFilterFunc (tankfarmCmdStsFilter);
    issueCmd -> SetItemFilterFunc (tankfarmCmdStsFilter);
    receiveCmd -> SetItemFilterFunc (tankfarmCmdStsFilter);
    runCmd -> SetItemFilterFunc (tankfarmCmdStsFilter);
    stopCmd -> SetItemFilterFunc (tankfarmCmdStsFilter);
    issueStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    receiveStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    runStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    stopStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    settleTime -> SetItemFilterFunc (floatFilter);
    strappingTable -> SetItemFilterFunc (tankfarmCmdStsFilter);
    apiTable -> SetItemFilterFunc (tankfarmCmdStsFilter);
    apiSpGravity -> SetItemFilterFunc (floatFilter);
    monitorDeadband -> SetItemFilterFunc (floatFilter);
    archiveDeadband -> SetItemFilterFunc (floatFilter);
    roofWgt -> SetItemFilterFunc (floatFilter);
    landedLevel -> SetItemFilterFunc (floatFilter);
    floatLevel -> SetItemFilterFunc (floatFilter);
    notInstalled -> SetItemFilterFunc (tankfarmCmdStsFilter);
    critical -> SetItemFilterFunc (tankfarmCmdStsFilter);
    landed -> SetItemFilterFunc (tankfarmCmdStsFilter);
    floating -> SetItemFilterFunc (tankfarmCmdStsFilter);
    productSensorLevel -> SetItemFilterFunc (floatFilter);
    bswSensorLevel -> SetItemFilterFunc (floatFilter);
    hiLevelTrip -> SetItemFilterFunc (floatFilter);
    lowLevelTrip -> SetItemFilterFunc (floatFilter);

    // build popup menus
    tankShape -> vuBuildOptionMenu (VU_TANK, REC_TANK_SHAPE);
    mode -> vuBuildOptionMenu (GBL_TF_AUTO_MAN_LOCK);
    roofType -> vuBuildOptionMenu (VU_TANK, REC_TANK_ROOF);
    productMeasMeth -> vuBuildOptionMenu (VU_TANK, REC_TANK_MEAS);
    bswMeasMeth -> vuBuildOptionMenu (VU_TANK, REC_TANK_MEAS);

}


/*******************************************************************
*
*    vuTankContainerClass override for destructor
*
*******************************************************************/

void vuTankContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}



/******************************************************************
*
*    vuTankAlarmButtonClass observer
*	open the tank alarm dialog and wait here until finished
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuTankAlarmButtonClass, vbutton, 
					"vuTankAlarmButtonClass");

void vuTankAlarmButtonClass::ObserveDialogItem (vevent *event)
{
    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    alarmDialog -> Place (vwindow::GetRoot (), vrectPLACE_CENTER, vrectPLACE_CENTER);
    alarmDialog -> Open();
    MakeTopMostDialog (alarmDialog, NULL);
    vevent::Process ();
}


/******************************************************************
*
*    vuTankValveButtonClass observer
*	open the tank valve dialog and wait here until finished
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankValveButtonClass, vbutton, 
					"vuTankValveButtonClass");

void vuTankValveButtonClass::ObserveDialogItem (vevent *event)
{
    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    valveDialog -> Place (vwindow::GetRoot (), vrectPLACE_CENTER, vrectPLACE_CENTER);
    valveDialog -> Open();
    MakeTopMostDialog (valveDialog, NULL);
    vevent::Process ();
}


/******************************************************************
*
*    vuTankTempButtonClass observer
*	open the tank temp dialog and wait here until finished
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankTempButtonClass, vbutton, 
					"vuTankTempButtonClass");

void vuTankTempButtonClass::ObserveDialogItem (vevent *event)
{
    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    tempDialog -> Place (vwindow::GetRoot (), vrectPLACE_CENTER, vrectPLACE_CENTER);
    tempDialog -> Open();
    MakeTopMostDialog (tempDialog, NULL);
    vevent::Process ();
}


/******************************************************************
*
*    vuTankPvButtonClass observer
*	open the tank pv dialog and wait here until finished
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankPvButtonClass, vbutton, 
					"vuTankPvButtonClass");

void vuTankPvButtonClass::ObserveDialogItem (vevent *event)
{
    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    pvDialog -> Place (vwindow::GetRoot (), vrectPLACE_CENTER, vrectPLACE_CENTER);
    pvDialog -> Open();
    MakeTopMostDialog (pvDialog, NULL);
    vevent::Process ();
}


/******************************************************************
*
*    vuTankAlarmDialogClass
*
******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankAlarmDialogClass, vdialog,
					"vuTankAlarmDialogClass");

/*******************************************************************
*
*    vuTankAlarmDialogClass override for constructors init ()
*
*******************************************************************/

void vuTankAlarmDialogClass::LoadInit (vresource res)
{

    vcontainer *hhlvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHHLVContainer);
    hihiLevel = filteredTextitem::RequestSubLoad (hhlvcontainer,
					vunames_HHLV);
    vcontainer *hhlecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHHLEContainer);
    hihiSeverity = vuChoiceGblMenuClass::RequestSubLoad (hhlecontainer,
					vunames_HHLE);
    hihiES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_HHLX);

    vcontainer *hilvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHILVContainer);
    highLevel = filteredTextitem::RequestSubLoad (hilvcontainer,
					vunames_HILV);
    vcontainer *hilecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHILEContainer);
    highSeverity = vuChoiceGblMenuClass::RequestSubLoad (hilecontainer,
					vunames_HILE);
    highES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_HILX);

    vcontainer *lolvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLOLVContainer);
    lowLevel = filteredTextitem::RequestSubLoad (lolvcontainer,
					vunames_LOLV);
    vcontainer *lolecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLOLEContainer);
    lowSeverity = vuChoiceGblMenuClass::RequestSubLoad (lolecontainer,
					vunames_LOLE);
    lowES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_LOLX);

    vcontainer *lllvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLLLVContainer);
    loloLevel = filteredTextitem::RequestSubLoad (lllvcontainer,
					vunames_LLLV);
    vcontainer *lllecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLLLEContainer);
    loloSeverity = vuChoiceGblMenuClass::RequestSubLoad (lllecontainer,
					vunames_LLLE);
    loloES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_LLLX);

    vcontainer *voldcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmVOLDContainer);
    volChg = filteredTextitem::RequestSubLoad (voldcontainer,
					vunames_VOLD);
    vcontainer *alsvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmALSVContainer);
    volChgSeverity = vuChoiceGblMenuClass::RequestSubLoad (alsvcontainer,
					vunames_ALSV);
    volChgES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_IEMS);

    vcontainer *hhtvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHHTVContainer);
    hihiTemp = filteredTextitem::RequestSubLoad (hhtvcontainer,
					vunames_HHTV);
    vcontainer *hhtecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHHTEContainer);
    hihiTempSeverity = vuChoiceGblMenuClass::RequestSubLoad (hhtecontainer,
					vunames_HHTE);
    hihiTempES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_HHTX);

    vcontainer *hitvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHITVContainer);
    highTemp = filteredTextitem::RequestSubLoad (hitvcontainer,
					vunames_HITV);
    vcontainer *hitecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHITEContainer);
    highTempSeverity = vuChoiceGblMenuClass::RequestSubLoad (hitecontainer,
					vunames_HITE);
    highTempES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_HITX);

    vcontainer *lotvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLOTVContainer);
    lowTemp = filteredTextitem::RequestSubLoad (lotvcontainer,
					vunames_LOTV);
    vcontainer *lotecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLOTEContainer);
    lowTempSeverity = vuChoiceGblMenuClass::RequestSubLoad (lotecontainer,
					vunames_LOTE);
    lowTempES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_LOTX);

    vcontainer *lltvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLLTVContainer);
    loloTemp = filteredTextitem::RequestSubLoad (lltvcontainer,
					vunames_LLTV);
    vcontainer *lltecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLLTEContainer);
    loloTempSeverity = vuChoiceGblMenuClass::RequestSubLoad (lltecontainer,
					vunames_LLTE);
    loloTempES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_LLTX);

    vcontainer *hibvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHIBVContainer);
    highBsw = filteredTextitem::RequestSubLoad (hibvcontainer,
					vunames_HIBV);
    vcontainer *hibecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHIBEContainer);
    highBswSeverity = vuChoiceGblMenuClass::RequestSubLoad (hibecontainer,
					vunames_HIBE);
    highBswES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_HIBX);

    vcontainer *llsecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLLSEContainer);
    lowLevelTripSeverity = vuChoiceGblMenuClass::RequestSubLoad (llsecontainer,
					vunames_LLSE);
    lowLevelTripES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_LLSX);

    vcontainer *hlsecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHLSEContainer);
    highLevelTripSeverity = vuChoiceGblMenuClass::RequestSubLoad (hlsecontainer,
					vunames_HLSE);
    highLevelTripES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_HLSX);

    vcontainer *evsscontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmEVSSContainer);
    valveStateSeverity = vuChoiceGblMenuClass::RequestSubLoad (evsscontainer,
					vunames_EVSS);
    valveStateES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_EVES);

    vcontainer *lopecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLOPEContainer);
    lowPressSeverity = vuChoiceGblMenuClass::RequestSubLoad (lopecontainer,
					vunames_LOPE);
    lowPressES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_LOPX);

    vcontainer *hipecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHIPEContainer);
    highPressSeverity = vuChoiceGblMenuClass::RequestSubLoad (hipecontainer,
					vunames_HIPE);
    highPressES = vuCheckBoxClass::RequestSubLoad (this,
					vunames_HIPX);

    vcontainer *lhstcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmLHSTContainer);
    levelDeadband = filteredTextitem::RequestSubLoad (lhstcontainer,
					vunames_LHST);

    vcontainer *hystcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmHYSTContainer);
    volumeDeadband = filteredTextitem::RequestSubLoad (hystcontainer,
					vunames_HYST);

    vcontainer *thstcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmTHSTContainer);
    tempDeadband = filteredTextitem::RequestSubLoad (thstcontainer,
					vunames_THST);

    vcontainer *bhstcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmBHSTContainer);
    bswDeadband = filteredTextitem::RequestSubLoad (bhstcontainer,
					vunames_BHST);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
					vunames_AENB);

    vcontainer *algpcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (algpcontainer,
					vunames_ALGP);

    vcontainer *adiscontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankAlarmADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (adiscontainer,
					vunames_vuTankAlarmADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (adiscontainer,
					vunames_ADIS);

    dismissButton = vuTankAlarmDismissButtonClass::RequestSubLoad (this,
					vunames_vuTankAlarmDismissButton);

    vdialog::LoadInit (res);

    // store dialog pointer in dismiss button
    dismissButton -> storeTankAlarmDialog (this);

    // set filters
    hihiLevel -> SetItemFilterFunc (floatFilter);
    highLevel -> SetItemFilterFunc (floatFilter);
    lowLevel -> SetItemFilterFunc (floatFilter);
    loloLevel -> SetItemFilterFunc (floatFilter);
    volChg -> SetItemFilterFunc (floatFilter);
    hihiTemp -> SetItemFilterFunc (floatFilter);
    highTemp -> SetItemFilterFunc (floatFilter);
    lowTemp -> SetItemFilterFunc (floatFilter);
    loloTemp -> SetItemFilterFunc (floatFilter);
    highBsw -> SetItemFilterFunc (floatFilter);
    levelDeadband -> SetItemFilterFunc (floatFilter);
    volumeDeadband -> SetItemFilterFunc (floatFilter);
    tempDeadband -> SetItemFilterFunc (floatFilter);
    bswDeadband -> SetItemFilterFunc (floatFilter);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *alrmDisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alrmDisText -> SetUserPtr ((void *)alarmDisable);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    // store ptr to text field for vuPvNameButtonClass
    alarmDisableButton -> storePvName (alarmDisable);

    // build popup menus
    hihiSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    loloSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    volChgSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    hihiTempSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highTempSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowTempSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    loloTempSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highBswSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowLevelTripSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highLevelTripSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    valveStateSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowPressSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highPressSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
}


/*******************************************************************
*
*    vuTankAlarmDialogClass notify function
*
*******************************************************************/

void vuTankAlarmDialogClass::ObserveWindow (vevent *event)
{
    if ( event -> GetType () == veventWINDOW_STATE && event -> IsClose ())
    {
	Close ();
	vevent::StopProcessing ();
    }
    else
    {
	MakeTopMostDialog (this, event);
    }
}


/*******************************************************************
*
*    vuTankAlarmDismissButtonClass notify function
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankAlarmDismissButtonClass, vbutton, 
					"vuTankAlarmDismissButtonClass");

void vuTankAlarmDismissButtonClass::ObserveDialogItem (vevent *event)
{
    alarmDialog -> Close ();
    vevent::StopProcessing ();
}


/******************************************************************
*
*    vuTankValveDialogClass
*
******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankValveDialogClass, vdialog,
					"vuTankValveDialogClass");

/*******************************************************************
*
*    vuTankValveDialogClass override for constructors init ()
*
*******************************************************************/

void vuTankValveDialogClass::LoadInit (vresource res)
{

    vcontainer *v01pcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV01PContainer);
    valve01Button = vuPvNameButtonClass::RequestSubLoad (v01pcontainer,
					vunames_vuTankValveV01PButton);
    valve01 = vuFilteredTextitem::RequestSubLoad (v01pcontainer,
					vunames_V01P);
    vcontainer *v01scontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV01SContainer);
    stopped01 = vuChoiceRecMenuClass::RequestSubLoad (v01scontainer,
					vunames_V01S);
    vcontainer *v01icontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV01IContainer);
    issuing01 = vuChoiceRecMenuClass::RequestSubLoad (v01icontainer,
					vunames_V01I);
    vcontainer *v01rcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV01RContainer);
    receiving01 = vuChoiceRecMenuClass::RequestSubLoad (v01rcontainer,
					vunames_V01R);
    vcontainer *v01ncontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV01NContainer);
    running01 = vuChoiceRecMenuClass::RequestSubLoad (v01ncontainer,
					vunames_V01N);

    vcontainer *v02pcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV02PContainer);
    valve02Button = vuPvNameButtonClass::RequestSubLoad (v02pcontainer,
					vunames_vuTankValveV02PButton);
    valve02 = vuFilteredTextitem::RequestSubLoad (v02pcontainer,
					vunames_V02P);
    vcontainer *v02scontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV02SContainer);
    stopped02 = vuChoiceRecMenuClass::RequestSubLoad (v02scontainer,
					vunames_V02S);
    vcontainer *v02icontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV02IContainer);
    issuing02 = vuChoiceRecMenuClass::RequestSubLoad (v02icontainer,
					vunames_V02I);
    vcontainer *v02rcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV02RContainer);
    receiving02 = vuChoiceRecMenuClass::RequestSubLoad (v02rcontainer,
					vunames_V02R);
    vcontainer *v02ncontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV02NContainer);
    running02 = vuChoiceRecMenuClass::RequestSubLoad (v02ncontainer,
					vunames_V02N);

    vcontainer *v03pcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV03PContainer);
    valve03Button = vuPvNameButtonClass::RequestSubLoad (v03pcontainer,
					vunames_vuTankValveV03PButton);
    valve03 = vuFilteredTextitem::RequestSubLoad (v03pcontainer,
					vunames_V03P);
    vcontainer *v03scontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV03SContainer);
    stopped03 = vuChoiceRecMenuClass::RequestSubLoad (v03scontainer,
					vunames_V03S);
    vcontainer *v03icontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV03IContainer);
    issuing03 = vuChoiceRecMenuClass::RequestSubLoad (v03icontainer,
					vunames_V03I);
    vcontainer *v03rcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV03RContainer);
    receiving03 = vuChoiceRecMenuClass::RequestSubLoad (v03rcontainer,
					vunames_V03R);
    vcontainer *v03ncontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV03NContainer);
    running03 = vuChoiceRecMenuClass::RequestSubLoad (v03ncontainer,
					vunames_V03N);

    vcontainer *v04pcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV04PContainer);
    valve04Button = vuPvNameButtonClass::RequestSubLoad (v04pcontainer,
					vunames_vuTankValveV04PButton);
    valve04 = vuFilteredTextitem::RequestSubLoad (v04pcontainer,
					vunames_V04P);
    vcontainer *v04scontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV04SContainer);
    stopped04 = vuChoiceRecMenuClass::RequestSubLoad (v04scontainer,
					vunames_V04S);
    vcontainer *v04icontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV04IContainer);
    issuing04 = vuChoiceRecMenuClass::RequestSubLoad (v04icontainer,
					vunames_V04I);
    vcontainer *v04rcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV04RContainer);
    receiving04 = vuChoiceRecMenuClass::RequestSubLoad (v04rcontainer,
					vunames_V04R);
    vcontainer *v04ncontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV04NContainer);
    running04 = vuChoiceRecMenuClass::RequestSubLoad (v04ncontainer,
					vunames_V04N);

    vcontainer *v05pcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV05PContainer);
    valve05Button = vuPvNameButtonClass::RequestSubLoad (v05pcontainer,
					vunames_vuTankValveV05PButton);
    valve05 = vuFilteredTextitem::RequestSubLoad (v05pcontainer,
					vunames_V05P);
    vcontainer *v05scontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV05SContainer);
    stopped05 = vuChoiceRecMenuClass::RequestSubLoad (v05scontainer,
					vunames_V05S);
    vcontainer *v05icontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV05IContainer);
    issuing05 = vuChoiceRecMenuClass::RequestSubLoad (v05icontainer,
					vunames_V05I);
    vcontainer *v05rcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV05RContainer);
    receiving05 = vuChoiceRecMenuClass::RequestSubLoad (v05rcontainer,
					vunames_V05R);
    vcontainer *v05ncontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV05NContainer);
    running05 = vuChoiceRecMenuClass::RequestSubLoad (v05ncontainer,
					vunames_V05N);

    vcontainer *v06pcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV06PContainer);
    valve06Button = vuPvNameButtonClass::RequestSubLoad (v06pcontainer,
					vunames_vuTankValveV06PButton);
    valve06 = vuFilteredTextitem::RequestSubLoad (v06pcontainer,
					vunames_V06P);
    vcontainer *v06scontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV06SContainer);
    stopped06 = vuChoiceRecMenuClass::RequestSubLoad (v06scontainer,
					vunames_V06S);
    vcontainer *v06icontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV06IContainer);
    issuing06 = vuChoiceRecMenuClass::RequestSubLoad (v06icontainer,
					vunames_V06I);
    vcontainer *v06rcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV06RContainer);
    receiving06 = vuChoiceRecMenuClass::RequestSubLoad (v06rcontainer,
					vunames_V06R);
    vcontainer *v06ncontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV06NContainer);
    running06 = vuChoiceRecMenuClass::RequestSubLoad (v06ncontainer,
					vunames_V06N);

    vcontainer *v07pcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV07PContainer);
    valve07Button = vuPvNameButtonClass::RequestSubLoad (v07pcontainer,
					vunames_vuTankValveV07PButton);
    valve07 = vuFilteredTextitem::RequestSubLoad (v07pcontainer,
					vunames_V07P);
    vcontainer *v07scontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV07SContainer);
    stopped07 = vuChoiceRecMenuClass::RequestSubLoad (v07scontainer,
					vunames_V07S);
    vcontainer *v07icontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV07IContainer);
    issuing07 = vuChoiceRecMenuClass::RequestSubLoad (v07icontainer,
					vunames_V07I);
    vcontainer *v07rcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV07RContainer);
    receiving07 = vuChoiceRecMenuClass::RequestSubLoad (v07rcontainer,
					vunames_V07R);
    vcontainer *v07ncontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV07NContainer);
    running07 = vuChoiceRecMenuClass::RequestSubLoad (v07ncontainer,
					vunames_V07N);

    vcontainer *v08pcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV08PContainer);
    valve08Button = vuPvNameButtonClass::RequestSubLoad (v08pcontainer,
					vunames_vuTankValveV08PButton);
    valve08 = vuFilteredTextitem::RequestSubLoad (v08pcontainer,
					vunames_V08P);
    vcontainer *v08scontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV08SContainer);
    stopped08 = vuChoiceRecMenuClass::RequestSubLoad (v08scontainer,
					vunames_V08S);
    vcontainer *v08icontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV08IContainer);
    issuing08 = vuChoiceRecMenuClass::RequestSubLoad (v08icontainer,
					vunames_V08I);
    vcontainer *v08rcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV08RContainer);
    receiving08 = vuChoiceRecMenuClass::RequestSubLoad (v08rcontainer,
					vunames_V08R);
    vcontainer *v08ncontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV08NContainer);
    running08 = vuChoiceRecMenuClass::RequestSubLoad (v08ncontainer,
					vunames_V08N);

    vcontainer *v09pcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV09PContainer);
    valve09Button = vuPvNameButtonClass::RequestSubLoad (v09pcontainer,
					vunames_vuTankValveV09PButton);
    valve09 = vuFilteredTextitem::RequestSubLoad (v09pcontainer,
					vunames_V09P);
    vcontainer *v09scontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV09SContainer);
    stopped09 = vuChoiceRecMenuClass::RequestSubLoad (v09scontainer,
					vunames_V09S);
    vcontainer *v09icontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV09IContainer);
    issuing09 = vuChoiceRecMenuClass::RequestSubLoad (v09icontainer,
					vunames_V09I);
    vcontainer *v09rcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV09RContainer);
    receiving09 = vuChoiceRecMenuClass::RequestSubLoad (v09rcontainer,
					vunames_V09R);
    vcontainer *v09ncontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV09NContainer);
    running09 = vuChoiceRecMenuClass::RequestSubLoad (v09ncontainer,
					vunames_V09N);

    vcontainer *v10pcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV10PContainer);
    valve10Button = vuPvNameButtonClass::RequestSubLoad (v10pcontainer,
					vunames_vuTankValveV10PButton);
    valve10 = vuFilteredTextitem::RequestSubLoad (v10pcontainer,
					vunames_V10P);
    vcontainer *v10scontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV10SContainer);
    stopped10 = vuChoiceRecMenuClass::RequestSubLoad (v10scontainer,
					vunames_V10S);
    vcontainer *v10icontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV10IContainer);
    issuing10 = vuChoiceRecMenuClass::RequestSubLoad (v10icontainer,
					vunames_V10I);
    vcontainer *v10rcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV10RContainer);
    receiving10 = vuChoiceRecMenuClass::RequestSubLoad (v10rcontainer,
					vunames_V10R);
    vcontainer *v10ncontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveV10NContainer);
    running10 = vuChoiceRecMenuClass::RequestSubLoad (v10ncontainer,
					vunames_V10N);

    vcontainer *sttocontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveSTTOContainer);
    stoppedTimeout = filteredTextitem::RequestSubLoad (sttocontainer,
					vunames_STTO);

    vcontainer *istocontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveISTOContainer);
    issuingTimeout = filteredTextitem::RequestSubLoad (istocontainer,
					vunames_ISTO);

    vcontainer *retocontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveRETOContainer);
    receivingTimeout = filteredTextitem::RequestSubLoad (retocontainer,
					vunames_RETO);

    vcontainer *rutocontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankValveRUTOContainer);
    runningTimeout = filteredTextitem::RequestSubLoad (rutocontainer,
					vunames_RUTO);

    dismissButton = vuTankValveDismissButtonClass::RequestSubLoad (this,
					vunames_vuTankValveDismissButton);

    vdialog::LoadInit (res);

    // store dialog pointer in dismiss button
    dismissButton -> storeTankValveDialog (this);

    // set filters

    valve01 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *v01pText = (filteredText *)valve01 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    v01pText -> SetUserPtr ((void *)valve01);

    valve02 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *v02pText = (filteredText *)valve02 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    v02pText -> SetUserPtr ((void *)valve02);

    valve03 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *v03pText = (filteredText *)valve03 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    v03pText -> SetUserPtr ((void *)valve03);

    valve04 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *v04pText = (filteredText *)valve04 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    v04pText -> SetUserPtr ((void *)valve04);

    valve05 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *v05pText = (filteredText *)valve05 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    v05pText -> SetUserPtr ((void *)valve05);

    valve06 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *v06pText = (filteredText *)valve06 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    v06pText -> SetUserPtr ((void *)valve06);

    valve07 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *v07pText = (filteredText *)valve07 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    v07pText -> SetUserPtr ((void *)valve07);

    valve08 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *v08pText = (filteredText *)valve08 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    v08pText -> SetUserPtr ((void *)valve08);

    valve09 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *v09pText = (filteredText *)valve09 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    v09pText -> SetUserPtr ((void *)valve09);

    valve10 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *v10pText = (filteredText *)valve10 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    v10pText -> SetUserPtr ((void *)valve10);

    stoppedTimeout -> SetItemFilterFunc (floatFilter);
    issuingTimeout -> SetItemFilterFunc (floatFilter);
    receivingTimeout -> SetItemFilterFunc (floatFilter);
    runningTimeout -> SetItemFilterFunc (floatFilter);

    // store ptr to text field for vuPvNameButtonClass
    valve01Button -> storePvName (valve01);
    valve02Button -> storePvName (valve02);
    valve03Button -> storePvName (valve03);
    valve04Button -> storePvName (valve04);
    valve05Button -> storePvName (valve05);
    valve06Button -> storePvName (valve06);
    valve07Button -> storePvName (valve07);
    valve08Button -> storePvName (valve08);
    valve09Button -> storePvName (valve09);
    valve10Button -> storePvName (valve10);

    // build popup menus
    stopped01 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    issuing01 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    receiving01 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    running01 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);

    stopped02 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    issuing02 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    receiving02 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    running02 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);

    stopped03 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    issuing03 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    receiving03 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    running03 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);

    stopped04 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    issuing04 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    receiving04 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    running04 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);

    stopped05 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    issuing05 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    receiving05 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    running05 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);

    stopped06 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    issuing06 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    receiving06 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    running06 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);

    stopped07 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    issuing07 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    receiving07 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    running07 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);

    stopped08 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    issuing08 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    receiving08 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    running08 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);

    stopped09 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    issuing09 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    receiving09 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    running09 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);

    stopped10 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    issuing10 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    receiving10 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
    running10 -> vuBuildOptionMenu (VU_TANK, REC_TANK_VALVE);
}


/*******************************************************************
*
*    vuTankValveDialogClass notify function
*
*******************************************************************/

void vuTankValveDialogClass::ObserveWindow (vevent *event)
{
    if ( event -> GetType () == veventWINDOW_STATE && event -> IsClose ())
    {
	Close ();
	vevent::StopProcessing ();
    }
    else
    {
	MakeTopMostDialog (this, event);
    }
}


/*******************************************************************
*
*    vuTankValveDismissButtonClass notify function
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankValveDismissButtonClass, vbutton, 
					"vuTankValveDismissButtonClass");

void vuTankValveDismissButtonClass::ObserveDialogItem (vevent *event)
{
    valveDialog -> Close ();
    vevent::StopProcessing ();
}



/******************************************************************
*
*    vuTankTempDialogClass
*
******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankTempDialogClass, vdialog,
					"vuTankTempDialogClass");

/*******************************************************************
*
*    vuTankTempDialogClass override for constructors init ()
*
*******************************************************************/

void vuTankTempDialogClass::LoadInit (vresource res)
{

    vcontainer *t01vcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT01VContainer);
    probe01Button = vuPvNameButtonClass::RequestSubLoad (t01vcontainer,
					vunames_vuTankTempT01VButton);
    probe01 = vuFilteredTextitem::RequestSubLoad (t01vcontainer,
					vunames_T01V);
    vcontainer *t01lcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT01LContainer);
    level01 = filteredTextitem::RequestSubLoad (t01lcontainer,
					vunames_T01L);
    proc01 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRCA);
    ms01 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXSA);

    vcontainer *t02vcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT02VContainer);
    probe02Button = vuPvNameButtonClass::RequestSubLoad (t02vcontainer,
					vunames_vuTankTempT02VButton);
    probe02 = vuFilteredTextitem::RequestSubLoad (t02vcontainer,
					vunames_T02V);
    vcontainer *t02lcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT02LContainer);
    level02 = filteredTextitem::RequestSubLoad (t02lcontainer,
					vunames_T02L);
    proc02 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRCB);
    ms02 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXSB);

    vcontainer *t03vcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT03VContainer);
    probe03Button = vuPvNameButtonClass::RequestSubLoad (t03vcontainer,
					vunames_vuTankTempT03VButton);
    probe03 = vuFilteredTextitem::RequestSubLoad (t03vcontainer,
					vunames_T03V);
    vcontainer *t03lcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT03LContainer);
    level03 = filteredTextitem::RequestSubLoad (t03lcontainer,
					vunames_T03L);
    proc03 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRCC);
    ms03 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXSC);

    vcontainer *t04vcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT04VContainer);
    probe04Button = vuPvNameButtonClass::RequestSubLoad (t04vcontainer,
					vunames_vuTankTempT04VButton);
    probe04 = vuFilteredTextitem::RequestSubLoad (t04vcontainer,
					vunames_T04V);
    vcontainer *t04lcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT04LContainer);
    level04 = filteredTextitem::RequestSubLoad (t04lcontainer,
					vunames_T04L);
    proc04 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRCD);
    ms04 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXSD);

    vcontainer *t05vcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT05VContainer);
    probe05Button = vuPvNameButtonClass::RequestSubLoad (t05vcontainer,
					vunames_vuTankTempT05VButton);
    probe05 = vuFilteredTextitem::RequestSubLoad (t05vcontainer,
					vunames_T05V);
    vcontainer *t05lcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT05LContainer);
    level05 = filteredTextitem::RequestSubLoad (t05lcontainer,
					vunames_T05L);
    proc05 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRCE);
    ms05 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXSE);

    vcontainer *t06vcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT06VContainer);
    probe06Button = vuPvNameButtonClass::RequestSubLoad (t06vcontainer,
					vunames_vuTankTempT06VButton);
    probe06 = vuFilteredTextitem::RequestSubLoad (t06vcontainer,
					vunames_T06V);
    vcontainer *t06lcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT06LContainer);
    level06 = filteredTextitem::RequestSubLoad (t06lcontainer,
					vunames_T06L);
    proc06 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRCF);
    ms06 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXSF);

    vcontainer *t07vcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT07VContainer);
    probe07Button = vuPvNameButtonClass::RequestSubLoad (t07vcontainer,
					vunames_vuTankTempT07VButton);
    probe07 = vuFilteredTextitem::RequestSubLoad (t07vcontainer,
					vunames_T07V);
    vcontainer *t07lcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT07LContainer);
    level07 = filteredTextitem::RequestSubLoad (t07lcontainer,
					vunames_T07L);
    proc07 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRCG);
    ms07 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXSG);

    vcontainer *t08vcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT08VContainer);
    probe08Button = vuPvNameButtonClass::RequestSubLoad (t08vcontainer,
					vunames_vuTankTempT08VButton);
    probe08 = vuFilteredTextitem::RequestSubLoad (t08vcontainer,
					vunames_T08V);
    vcontainer *t08lcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT08LContainer);
    level08 = filteredTextitem::RequestSubLoad (t08lcontainer,
					vunames_T08L);
    proc08 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRCH);
    ms08 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXSH);

    vcontainer *t09vcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT09VContainer);
    probe09Button = vuPvNameButtonClass::RequestSubLoad (t09vcontainer,
					vunames_vuTankTempT09VButton);
    probe09 = vuFilteredTextitem::RequestSubLoad (t09vcontainer,
					vunames_T09V);
    vcontainer *t09lcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT09LContainer);
    level09 = filteredTextitem::RequestSubLoad (t09lcontainer,
					vunames_T09L);
    proc09 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRCI);
    ms09 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXSI);

    vcontainer *t10vcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT10VContainer);
    probe10Button = vuPvNameButtonClass::RequestSubLoad (t10vcontainer,
					vunames_vuTankTempT10VButton);
    probe10 = vuFilteredTextitem::RequestSubLoad (t10vcontainer,
					vunames_T10V);
    vcontainer *t10lcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankTempT10LContainer);
    level10 = filteredTextitem::RequestSubLoad (t10lcontainer,
					vunames_T10L);
    proc10 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRCJ);
    ms10 = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXSJ);

    dismissButton = vuTankTempDismissButtonClass::RequestSubLoad (this,
					vunames_vuTankTempDismissButton);

    vdialog::LoadInit (res);

    // store dialog pointer in dismiss button
    dismissButton -> storeTankTempDialog (this);

    // set filters
    level04 -> SetItemFilterFunc (floatFilter);
    level02 -> SetItemFilterFunc (floatFilter);
    level03 -> SetItemFilterFunc (floatFilter);
    level04 -> SetItemFilterFunc (floatFilter);
    level05 -> SetItemFilterFunc (floatFilter);
    level06 -> SetItemFilterFunc (floatFilter);
    level07 -> SetItemFilterFunc (floatFilter);
    level08 -> SetItemFilterFunc (floatFilter);
    level09 -> SetItemFilterFunc (floatFilter);
    level10 -> SetItemFilterFunc (floatFilter);

    probe01 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *t01vText = (filteredText *)probe01 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    t01vText -> SetUserPtr ((void *)probe01);

    probe02 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *t02vText = (filteredText *)probe02 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    t02vText -> SetUserPtr ((void *)probe02);

    probe03 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *t03vText = (filteredText *)probe03 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    t03vText -> SetUserPtr ((void *)probe03);

    probe04 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *t04vText = (filteredText *)probe04 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    t04vText -> SetUserPtr ((void *)probe04);

    probe05 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *t05vText = (filteredText *)probe05 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    t05vText -> SetUserPtr ((void *)probe05);

    probe06 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *t06vText = (filteredText *)probe06 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    t06vText -> SetUserPtr ((void *)probe06);

    probe07 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *t07vText = (filteredText *)probe07 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    t07vText -> SetUserPtr ((void *)probe07);

    probe08 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *t08vText = (filteredText *)probe08 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    t08vText -> SetUserPtr ((void *)probe08);

    probe09 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *t09vText = (filteredText *)probe09 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    t09vText -> SetUserPtr ((void *)probe09);

    probe10 -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *t10vText = (filteredText *)probe10 -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    t10vText -> SetUserPtr ((void *)probe10);

    // store ptr to text field for vuPvNameButtonClass
    probe01Button -> storePvName (probe01);
    probe02Button -> storePvName (probe02);
    probe03Button -> storePvName (probe03);
    probe04Button -> storePvName (probe04);
    probe05Button -> storePvName (probe05);
    probe06Button -> storePvName (probe06);
    probe07Button -> storePvName (probe07);
    probe08Button -> storePvName (probe08);
    probe09Button -> storePvName (probe09);
    probe10Button -> storePvName (probe10);
}


/*******************************************************************
*
*    vuTankTempDialogClass notify function
*
*******************************************************************/

void vuTankTempDialogClass::ObserveWindow (vevent *event)
{
    if ( event -> GetType () == veventWINDOW_STATE && event -> IsClose ())
    {
	Close ();
	vevent::StopProcessing ();
    }
    else
    {
	MakeTopMostDialog (this, event);
    }
}


/*******************************************************************
*
*    vuTankTempDismissButtonClass notify function
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankTempDismissButtonClass, vbutton, 
					"vuTankTempDismissButtonClass");

void vuTankTempDismissButtonClass::ObserveDialogItem (vevent *event)
{
    tempDialog -> Close ();
    vevent::StopProcessing ();
}



/******************************************************************
*
*    vuTankPvDialogClass
*
******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankPvDialogClass, vdialog,
					"vuTankPvDialogClass");

/*******************************************************************
*
*    vuTankPvDialogClass override for constructors init ()
*
*******************************************************************/

void vuTankPvDialogClass::LoadInit (vresource res)
{

    vcontainer *levpcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVLEVPContainer);
    levelPvButton = vuPvNameButtonClass::RequestSubLoad (levpcontainer,
					vunames_vuTankPVLEVPButton);
    levelPv = vuFilteredTextitem::RequestSubLoad (levpcontainer,
					vunames_LEVP);
    procLevelPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRC0);
    msLevelPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXS0);

    vcontainer *denpcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVDENPContainer);
    densityPvButton = vuPvNameButtonClass::RequestSubLoad (denpcontainer,
					vunames_vuTankPVDENPButton);
    densityPv = vuFilteredTextitem::RequestSubLoad (denpcontainer,
					vunames_DENP);
    procDensityPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRC1);
    msDensityPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXS1);

    vcontainer *maspcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVMASPContainer);
    massPvButton = vuPvNameButtonClass::RequestSubLoad (maspcontainer,
					vunames_vuTankPVMASPButton);
    massPv = vuFilteredTextitem::RequestSubLoad (maspcontainer,
					vunames_MASP);
    procMassPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRC4);
    msMassPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXS4);

    vcontainer *tmppcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVTMPPContainer);
    avgTempPvButton = vuPvNameButtonClass::RequestSubLoad (tmppcontainer,
					vunames_vuTankPVTMPPButton);
    avgTempPv = vuFilteredTextitem::RequestSubLoad (tmppcontainer,
					vunames_TMPP);
    procAvgTempPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRC2);
    msAvgTempPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXS2);

    vcontainer *volpcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVVOLPContainer);
    volumePvButton = vuPvNameButtonClass::RequestSubLoad (volpcontainer,
					vunames_vuTankPVVOLPButton);
    volumePv = vuFilteredTextitem::RequestSubLoad (volpcontainer,
					vunames_VOLP);
    procVolumePv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRC3);
    msVolumePv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXS3);

    vcontainer *hlpvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVHLPVContainer);
    highLevelPvButton = vuPvNameButtonClass::RequestSubLoad (hlpvcontainer,
					vunames_vuTankPVHLPVButton);
    highLevelPv = vuFilteredTextitem::RequestSubLoad (hlpvcontainer,
					vunames_HLPV);
    procHighLevelPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRC5);
    msHighLevelPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXS5);

    vcontainer *llpvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVLLPVContainer);
    lowLevelPvButton = vuPvNameButtonClass::RequestSubLoad (llpvcontainer,
					vunames_vuTankPVLLPVButton);
    lowLevelPv = vuFilteredTextitem::RequestSubLoad (llpvcontainer,
					vunames_LLPV);
    procLowLevelPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRC6);
    msLowLevelPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXS6);

    vcontainer *htpvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVHTPVContainer);
    highPressPvButton = vuPvNameButtonClass::RequestSubLoad (htpvcontainer,
					vunames_vuTankPVHTPVButton);
    highPressPv = vuFilteredTextitem::RequestSubLoad (htpvcontainer,
					vunames_HTPV);
    procHighPressPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRC7);
    msHighPressPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXS7);

    vcontainer *ltpvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVLTPVContainer);
    lowPressPvButton = vuPvNameButtonClass::RequestSubLoad (ltpvcontainer,
					vunames_vuTankPVLTPVButton);
    lowPressPv = vuFilteredTextitem::RequestSubLoad (ltpvcontainer,
					vunames_LTPV);
    procLowPressPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRC8);
    msLowPressPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXS8);

    vcontainer *bswpcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVBSWPContainer);
    bswPvButton = vuPvNameButtonClass::RequestSubLoad (bswpcontainer,
					vunames_vuTankPVBSWPButton);
    bswPv = vuFilteredTextitem::RequestSubLoad (bswpcontainer,
					vunames_BSWP);
    procBswPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_PRC9);
    msBswPv = vuCheckBoxClass::RequestSubLoad (this,
					vunames_MXS9);

    vcontainer *levucontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVLEVUContainer);
    levelUnits = vuChoiceRecMenuClass::RequestSubLoad (levucontainer,
					vunames_LEVU);

    vcontainer *denucontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVDENUContainer);
    densityUnits = vuChoiceRecMenuClass::RequestSubLoad (denucontainer,
					vunames_DENU);

    vcontainer *masucontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVMASUContainer);
    massUnits = vuChoiceRecMenuClass::RequestSubLoad (masucontainer,
					vunames_MASU);

    vcontainer *tmpucontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVTMPUContainer);
    tempUnits = vuChoiceGblMenuClass::RequestSubLoad (tmpucontainer,
					vunames_TMPU);

    vcontainer *volucontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVVOLUContainer);
    volumeUnits = vuChoiceGblMenuClass::RequestSubLoad (volucontainer,
					vunames_VOLU);

    vcontainer *flrucontainer = vcontainer::RequestSubLoad (this,
					vunames_vuTankPVFLRUContainer);
    flowRateUnits = vuChoiceGblMenuClass::RequestSubLoad (flrucontainer,
					vunames_FLRU);

    dismissButton = vuTankPvDismissButtonClass::RequestSubLoad (this,
					vunames_vuTankPVDismissButton);

    vdialog::LoadInit (res);

    // store dialog pointer in dismiss button
    dismissButton -> storeTankPvDialog (this);

    // set filters

    levelPv -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *levpText = (filteredText *)levelPv -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    levpText -> SetUserPtr ((void *)levelPv);

    densityPv -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *denpText = (filteredText *)densityPv -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    denpText -> SetUserPtr ((void *)densityPv);

    massPv -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *maspText = (filteredText *)massPv -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    maspText -> SetUserPtr ((void *)massPv);

    avgTempPv -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *tmppText = (filteredText *)avgTempPv -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    tmppText -> SetUserPtr ((void *)avgTempPv);

    volumePv -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *volpText = (filteredText *)volumePv -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    volpText -> SetUserPtr ((void *)volumePv);

    highLevelPv -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *hlpvText = (filteredText *)highLevelPv -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    hlpvText -> SetUserPtr ((void *)highLevelPv);

    lowLevelPv -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *llpvText = (filteredText *)lowLevelPv -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    llpvText -> SetUserPtr ((void *)lowLevelPv);

    highPressPv -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *htpvText = (filteredText *)highPressPv -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    htpvText -> SetUserPtr ((void *)highPressPv);

    lowPressPv -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *ltpvText = (filteredText *)lowPressPv -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    ltpvText -> SetUserPtr ((void *)lowPressPv);

    bswPv -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *bswpText = (filteredText *)bswPv -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    bswpText -> SetUserPtr ((void *)bswPv);

    // store ptr to text field for vuPvNameButtonClass

    levelPvButton -> storePvName (levelPv);
    densityPvButton -> storePvName (densityPv);
    massPvButton -> storePvName (massPv);
    avgTempPvButton -> storePvName (avgTempPv);
    volumePvButton -> storePvName (volumePv);
    highLevelPvButton -> storePvName (highLevelPv);
    lowLevelPvButton -> storePvName (lowLevelPv);
    highPressPvButton -> storePvName (highPressPv);
    lowPressPvButton -> storePvName (lowPressPv);
    bswPvButton -> storePvName (bswPv);

    // build popup menus
    levelUnits -> vuBuildOptionMenu (VU_TANK, REC_TANK_LEVEL);
    densityUnits -> vuBuildOptionMenu (VU_TANK, REC_TANK_DENSITY);
    massUnits -> vuBuildOptionMenu (VU_TANK, REC_TANK_MASS);
    tempUnits -> vuBuildOptionMenu (GBL_TF_TEMP);
    volumeUnits -> vuBuildOptionMenu (GBL_TF_VOLUME);
    flowRateUnits -> vuBuildOptionMenu (GBL_TF_FLOW);
}


/*******************************************************************
*
*    vuTankPvDialogClass notify function
*
*******************************************************************/

void vuTankPvDialogClass::ObserveWindow (vevent *event)
{
    if ( event -> GetType () == veventWINDOW_STATE && event -> IsClose ())
    {
	Close ();
	vevent::StopProcessing ();
    }
    else
    {
	MakeTopMostDialog (this, event);
    }
}


/*******************************************************************
*
*    vuTankPvDismissButtonClass notify function
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuTankPvDismissButtonClass, vbutton, 
					"vuTankPvDismissButtonClass");

void vuTankPvDismissButtonClass::ObserveDialogItem (vevent *event)
{
    pvDialog -> Close ();
    vevent::StopProcessing ();
}

