#ifndef vugrplistdialogclassHXX
#define vugrplistdialogclassHXX

class vuGrpListOkButtonClass;
class vuGrpListDismissButtonClass;
class vuGrpListListClass;

// *** GROUP LIST DIALOG CLASS ************************************************

class  vuGrpListDialogClass : public vdialog
{
    vuMainDialogClass	*mainDialog;
    vchar		groupName[PROTECTIONGRP_SZ + 1];

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuGrpListDialogClass);

    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuGrpListDialogClass, vdialog);	

    // override to load dialog
    void LoadInit(vresource res);		

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override 
    void Destroy ();

    // override to set OK button text
    void vuGrpListOpen(vuMainDialogClass *mainDialog);

    // handle mainDialog
    vuMainDialogClass *getMainDialog (void)
	{ return (mainDialog); }

    // handle groupName
    vchar *getGroupName (void)
	{ return (groupName); }

    vuGrpListListClass		*grpList;
    vuGrpListOkButtonClass	*okButton;
    vuGrpListDismissButtonClass	*dismissButton;
};


// *** GROUP LIST LIST CLASS ***************************************************

class vuGrpListListClass : public vlistview
{
    vuGrpListDialogClass	*grplistDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuGrpListListClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuGrpListListClass, vlistview);

    // override
    void ObserveSelect (int state);

    // functions to handle grplistDialog
    void setGrpListDialog (vuGrpListDialogClass *dialog)
	{ grplistDialog = dialog; }

    // function to build the list
    void buildList (void);
};


// *** GROUP LIST OK BUTTON CLASS *********************************************

class vuGrpListOkButtonClass : public vbutton
{
    vuGrpListDialogClass	*grplistDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuGrpListOkButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuGrpListOkButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle grplistDialog
    void setGrpListDialog (vuGrpListDialogClass *dialog)
	{ grplistDialog = dialog; }
};


// *** GROUP LIST DISMISS BUTTON CLASS ****************************************

class vuGrpListDismissButtonClass : public vbutton
{
    vuGrpListDialogClass	*grplistDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuGrpListDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuGrpListDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle grplistDialog
    void setGrpListDialog (vuGrpListDialogClass *dialog)
	{ grplistDialog = dialog; }
};

#endif vugrplistdialogclassHXX
