/*evtrigger.c,v 1.1.1.1 1999/08/03 14:42:34 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#include <vxWorks.h>
#include <fioLib.h>
#include <task_params.h>
#include <logLib.h>
#include <wdLib.h>

#include "dbAddr.h"
#include "callbacks.h"
#include "dbScan.h"

unsigned int			eventCount = 0;
unsigned int			usersRate = 0;

void eventTriggerService();

/****************************************************************/
/*								*/
/*			INITIALIZE				*/
/*								*/
/****************************************************************/

int evtrigger(extraRate)
int	extraRate;
{
	if (extraRate)
		{
		if (extraRate < 0 || extraRate > 255)
			{
			logMsg("User specified event rate must be from 1 to 255, inclusive.\n",
				0,0,0,0,0,0);
			logMsg("The user specified event rate has been discarded.\n",
				0,0,0,0,0,0);
			}
		else
			usersRate = extraRate;
		}
	if (taskSpawn("evntTrigger", EVENTSCAN_PRI, VX_FP_TASK, 2000, (FUNCPTR)eventTriggerService, 0,0,0,0,0,0,0,0,0,0) == ERROR)
		{
		logMsg("Can't spawn the event trigger task.\n",0,0,0,0,0,0);
		return(-1);
		}
	return (0);
}

/****************************************************************/
/*								*/
/*		WATCHDOG TIMER SERVICE ROUTINE			*/
/*								*/
/****************************************************************/

void eventTriggerService()
{
	for (;;)
		{
		taskDelay(60);
		eventCount++;
		if ((eventCount % 5) == 0)
			{
			post_event(5);
			if ((eventCount % 15) == 0)
				post_event(15);
			if ((eventCount % 10) == 0)
				{
				post_event(10);
				if ((eventCount % 30) == 0)
					{
					post_event(30);
					if ((eventCount % 60) == 0)
						post_event(60);
					}
				}
			}
		if ((eventCount % usersRate) == 0)
			post_event(usersRate);
		}
}
