/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

#include <vxWorks.h>
#include <socket.h>
#include <in.h>
#include <semLib.h>
#include <stdio.h>

#include <dbDefs.h>
#include <redmsgs.h>
#include <task_params.h>
#include <dbRecords.h>
#include <dbCommon.h>
#include <recSup.h>
#include <errno.h>
#include <restable.h>
#include <redflds.h>

void listUninit(maxRecs)
int	maxRecs;
{
    int			recsPrinted = 0;
    int			i;

	for (i = 0; i < dbRecords -> number; i++)
	{
	    struct recLoc	*recLoc;
	    struct recChain	*chain;
	    struct rset	*prset;
	    struct fldDes	**fldDes;

	    if (maxRecs == 0)
		maxRecs = 20;
	    if (!(recLoc = dbRecords -> papRecLoc[i]))
		continue;

	    prset = GET_PRSET(i);
	    fldDes = papRedFldList[i];

	    for (chain = (struct recChain *) (recLoc -> pFirst);
		 chain; chain = chain -> next)
	    {
		struct dbCommon	*recHdr;

		if (!(recHdr = (struct dbCommon *) (chain -> pRecord)))
		    continue;

		if (!(recHdr -> name[0]))
		    continue;

		if ((!(recHdr -> init)) || (!(recHdr -> ini2)))
		{
		    if (recsPrinted >= maxRecs)
			{
			printf("Additional records uninitialized!\n");
			return;
			}
		    printf("%s: resource = %s, init = %d, ini2 = %d\n", recHdr -> name, 
				recHdr -> resn, recHdr -> init, recHdr -> ini2);
		    recsPrinted++;
		}
	    } /* end all pts of type */

	} /* end for all pt types */
}
