/*DBDeleteMulti.c,v 1.1.1.1 1999/08/03 14:42:39 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			28-Feb-1994				      */
/*									      */
/*	Function Name:		DB_DeleteMulti				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:	DB_TABLE_PTR	tbl			      */
/*									      */
/*	Output Parameters:	none					      */
/*									      */
/*	Return Values or error codes:	none.				      */
/*									      */
/*	Modification History:	08-Apr-1993	First time		      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#include <DBDefines.h>

int	DB_DeleteMulti(tbl,key)
DB_TABLE_PTR	tbl;
char		*key;
{
char	padkey[PVNAME_SZ+1];
if(!strlen(key))
	return(0);
sprintf(padkey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,key);
/**/	dbWriteLog(__FILE__,__LINE__,tbl->table,"DELETE",0,key,0);
if(d4seek(tbl->table,padkey) == 0)
	{
	do								/* loop for all records with same key */
		{
		d4blank(tbl->table);		/* blank whole record */
		d4delete(tbl->table);		/* mark for delete also GCT 02-Sep-1994 */
		d4flush_all(tbl->table);	/* flush after every delete GCT 05-May-1994 */
		}
	while(d4seek(tbl->table,padkey) == 0);
	d4flush_all(tbl->table);		/* flush everything */
	d4unlock_all(tbl->table);		/* un-lock everything */
	return(1);						/* record deleted */
	}
else
	{
	d4unlock_all(tbl->table);		/* un-lock everything */
	return(0);				/* record not found */
	}
}
