/*DBGetFieldVal.c,v 1.1.1.1 1999/08/03 14:42:39 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			05-Jan-1993				      */
/*									      */
/*	Function Name:		DB_GetFieldValue.c			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:	RecordHandle - record handle from DB_Seek     */
/*				FieldHandle  - field handle from DB_MapField  */
/*									      */
/*	Output Parameters:	value	   - pointer to area to contain value.*/
/*					     Area better be big enough and of */
/*					     the appropriate type!	      */
/*									      */
/*	Return Values or error codes:	none.				      */
/*									      */
/*	Modification History:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#include <math.h>
#include <DBDefines.h>

void	DB_GetFieldValue(RecordHandle,FieldHandle,value,type)
DB_RECORD_PTR	RecordHandle;
DB_FIELD_PTR	FieldHandle;
void	*value;
int	*type;
{
char	*tstr;
int	tsize;
*type = FieldHandle -> field_type;
switch(FieldHandle -> field_type)
	{
	case 'N':
	case 'F':
		*((double *)value) = f4double(FieldHandle -> field);
		break;
	case 'D':
		*((int *)value) = f4long(FieldHandle -> field);
		break;
	case 'L':
		*((char *)value) = f4true(FieldHandle -> field);
		break;
	case 'C':
		tstr = f4str(FieldHandle -> field);
		for(tsize = strlen(tstr)-1;tsize >= 0;tsize--)
			if(isspace(tstr[tsize]))
				tstr[tsize] = '\0';
			else
				break;
		strcpy((char *)value,tstr);
		break;
	}
d4unlock_all(FieldHandle->owner->table);
}
