/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <DBDefines.h>
#include <DBCVerifyDefs.h>
#include <DBCDefines.h>
#include <dbRecType.h>
#ifndef WIN32
#include <syslog.h>
#endif WIN32
#include <ctype.h>

extern	DBC_XREFHDR_PTR	DBC_XREFTables;
#define	CHECK_ASCII
/*
	return a buffer containing the entire record for the given PV name. This record will
	be made up from all the component files as given in the DBC_XREFTables structure
	based on the type index.
*/
int	DB_GetFullRec(name,index,buff,size)
char	*name;
int		index;
char	**buff;			/* buff is the address of char pointer whose spece is allocated here */
int		*size;
{
int		i,totalSize,count;
char	*recptr,*buffptr,padkey[PVNAME_SZ+1],*newkey,*bptr;
F4FIELD	*fptr;
/*
	make one pass through the tables for the given type index to total up the
	record sizes. Use the vaue to allocate the return address space.
*/
totalSize = 0;
for(i =  0; i < DBC_MAX_TABLES;i++)
	{
	if(DBC_XREFTables[index].xrefHdrTables[i] == 0)
		continue;
	totalSize += (d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table) * DBC_XREFTables[index].xrefRecCount[i]);
	}
if((buffptr = (char *)malloc(totalSize)) == 0)		/* allocate the space */
	return(0);
*buff = buffptr;										/* save for return */
/*
	Seek to each record given in the xrefHdr table list. Copy each record into the buff area
	and increment buff by the sizeof each record.
*/
*size = totalSize;						/* for compare before return */
totalSize = 0;
for(i=0;i<PVNAME_SZ;i++)
	if(name[i] == ' ') break;
name[i] = 0;							/* drop trailing spaces */
for(i = 0; i < DBC_MAX_TABLES;i++)
  {
    if(DBC_XREFTables[index].xrefHdrTables[i] == 0)
      continue;
    fptr = d4field(DBC_XREFTables[index].xrefHdrTables[i]->table,"NAME");
    if(((index == VU_PTO)||(index == VU_PAT)) && (DBC_XREFTables[index].xrefHdrTables[i] == DBC_IOAddrTable))
      {
	sprintf(padkey,"%s1\0",name);		/* First record for PTO or PAT */
	sprintf(padkey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,padkey);
      }
    else
      sprintf(padkey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,name);
    if((d4seek(DBC_XREFTables[index].xrefHdrTables[i]->table,padkey)) == 0)
      {
	count = DBC_XREFTables[index].xrefRecCount[i];
	do
	  {
	    recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
	    memcpy(buffptr,recptr,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
	    buffptr += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
	    if((index == VU_PTO) && (DBC_XREFTables[index].xrefHdrTables[i] == DBC_IOAddrTable))
	      {
		sprintf(padkey,"%s2\0",name);
		sprintf(padkey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,padkey);
		if((d4seek(DBC_XREFTables[index].xrefHdrTables[i]->table,padkey)) == 0)
		  {
		    recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
		    memcpy(buffptr,recptr,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
		    buffptr += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
		  }
		break;
	      }
	    else if((index == VU_PAT) && (DBC_XREFTables[index].xrefHdrTables[i] == DBC_IOAddrTable))
	      {
		sprintf(padkey,"%s2\0",name);
		sprintf(padkey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,padkey);
		if((d4seek(DBC_XREFTables[index].xrefHdrTables[i]->table,padkey)) == 0)
		  {
		    recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
		    memcpy(buffptr,recptr,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
		    buffptr += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
		  }
		sprintf(padkey,"%s3\0",name);
		sprintf(padkey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,padkey);
		if((d4seek(DBC_XREFTables[index].xrefHdrTables[i]->table,padkey)) == 0)
		  {
		    recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
		    memcpy(buffptr,recptr,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
		    buffptr += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
		  }
		sprintf(padkey,"%s4\0",name);
		sprintf(padkey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,padkey);
		if((d4seek(DBC_XREFTables[index].xrefHdrTables[i]->table,padkey)) == 0)
		  {
		    recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
		    memcpy(buffptr,recptr,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
		    buffptr += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
		  }
		break;
	      }
	    else
	      {
		if((d4skip(DBC_XREFTables[index].xrefHdrTables[i]->table,1)) == 0)
		  newkey = f4str(fptr);
		else
		  break;
	      }
	  }
	while(--count);
	totalSize += (d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table) * DBC_XREFTables[index].xrefRecCount[i]);
      }
    d4unlock_all(DBC_XREFTables[index].xrefHdrTables[i]->table);
  }
/*
	Return error if the total size of the record is not equal to
	what it should be as determined above.
*/
if(*size == totalSize)										/* return total size of record */
  {
#ifdef	CHECK_ASCII
    int gotit = 0;
    int j;
    char msg[40];
    bptr = *buff;
    for (i = 0;i < totalSize;i++)
      {
	if(!isprint(bptr[i]))
	  gotit++;
      }
    if(gotit)
      {
#ifndef WIN32
	syslog(LOG_DAEMON | LOG_ALERT,"Detected %d unprintable chars in %s record",gotit,name);
#endif WIN32
	for(i = 0;i < totalSize;i+=8)
	  {
	    for(j=0;j < 8;j++)
	      sprintf(&msg[j*3],"%02X \0",bptr[i+j]);
#ifndef WIN32
	    syslog(LOG_DAEMON | LOG_ALERT,msg);
#endif WIN32
	  }
	return(0);
      }
#endif
    return(1);
  }
else
  return(0);
}
