/*DBPutFieldVal.c,v 1.1.1.1 1999/08/03 14:42:41 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			05-Jan-1993				      */
/*									      */
/*	Function Name:		DB_PutFieldValue.c			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:	RecordHandle - record handle from DB_Seek.    */
/*				FieldHandle  - field handle from DB_MapField. */
/*				ValuePointer - pointer to new data for this   */
/*					       field. This point had better   */
/*					       point to data consistant with  */
/*					       intended field.		      */
/*									      */
/*	Output Parameters:	none.					      */
/*									      */
/*	Return Values or error codes:	none.				      */
/*									      */
/*	Modification History:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#include <DBDefines.h>
/**/static char		old[200],comp[600];

void	DB_PutFieldValue(RecordHandle,FieldHandle,value)
DB_RECORD_PTR	RecordHandle;
DB_FIELD_PTR	FieldHandle;
void		*value;
{
DB_TABLE_PTR	tbl;
/**/int		size;
if(RecordHandle == (DB_RECORD_PTR)0)
  return;
tbl = FieldHandle -> owner;
/**/strncpy(old,f4ptr(FieldHandle->field),FieldHandle->field_size);
switch(FieldHandle -> field_type)
	{
	case 'N':
	case 'F':
		f4assign_double(FieldHandle -> field,*((double *)value));
		break;
	case 'D':
		f4assign_long(FieldHandle -> field,*((int *)value));
		break;
	case 'L':
		f4assign_char(FieldHandle -> field,(*((unsigned char *)value) == 1 ? 'T' : 'F'));
		break;
	case 'C':
		f4assign_n(FieldHandle -> field,(char *)value,strlen((char *)value));
		break;
	}
/**/if(strncmp(old,f4ptr(FieldHandle->field),FieldHandle->field_size))
/**/	{
/**/	size = FieldHandle->field_size;
/**/	sprintf(comp,"<%*.*s>,<%*.*s>\0",FieldHandle->field_size,FieldHandle->field_size,old,FieldHandle->field_size,FieldHandle->field_size,f4ptr(FieldHandle->field));
/**/	FieldHandle->field_size = strlen(comp);
/**/	dbWriteLog(__FILE__,__LINE__,tbl->table,"MODIFY",FieldHandle,d4record(tbl->table)+1,comp);
/**/	FieldHandle->field_size = size;
/**/	}
d4unlock_all(tbl->table);		/* make sure everything is unlocked */
d4flush_all(tbl->table);		/* write everything to disk */
}
