#include <DBDefines.h>
#include <DBCVerifyDefs.h>
#include <DBCDefines.h>
#include <dbRecType.h>
#include <ctype.h>
#ifndef WIN32
#include <syslog.h>
#endif WIN32
#define	CHECK_ASCII 1
extern	DBC_XREFHDR_PTR	DBC_XREFTables;
/*
	store a buffer containing the entire record for the given PV name. This buffer will
	be made up from all the component files as given in the DBC_XREFTables structure
	based on the type index.
*/
int	DB_PutFullRec(name,index,buff,rsize)
char	*name;
int	index;
char	*buff;			/* buff is the address full record buffer */
int	rsize;
{
F4FIELD	*fptr;
char	*recptr,padkey[PVNAME_SZ+1],*newkey,i;
#ifdef	CHECK_ASCII
	int gotit = 0;
	int j,k;
	char msg[40];
	char *bptr = buff;
#endif
int	count;
/*
	Seek to each record given in the xrefHdr table list. Copy each record from the buff area
	and increment buff by the sizeof each record.
*/
for(i=0;i<PVNAME_SZ;i++)
	if(name[i] == ' ') break;
name[i] = 0;							/* drop trailing spaces */
#ifdef	CHECK_ASCII
	for (k = 0;k < rsize;k++)
		{
		if(!isprint(bptr[k]))
			gotit++;
		}
	if(gotit)
		{
#ifndef WIN32
		  syslog(LOG_DAEMON | LOG_ALERT,"Received %d unprintable chars in %s record",gotit,name);
#endif WIN32
		for(k = 0;k < rsize;k+=8)
			{
			for(j=0;j < 8;j++)
				sprintf(&msg[j*3],"%02X \0",bptr[k+j]);
#ifndef WIN32
			syslog(LOG_DAEMON | LOG_ALERT,msg);
#endif WIN32
			}
		return(0);
		}
#endif
for(i = 0; i < DBC_MAX_TABLES;i++)
  {
    if(DBC_XREFTables[index].xrefHdrTables[i] == 0)
      continue;
    fptr = d4field(DBC_XREFTables[index].xrefHdrTables[i]->table,"NAME");
    if(((index == VU_PTO)||(index == VU_PAT)) && (DBC_XREFTables[index].xrefHdrTables[i] == DBC_IOAddrTable))
      {
	sprintf(padkey,"%s1\0",name);		/* First record for PTO & PAT */
	sprintf(padkey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,padkey);
      }
    else
      sprintf(padkey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,name);
    if((d4seek(DBC_XREFTables[index].xrefHdrTables[i]->table,padkey)) == 0)
      {
	count = DBC_XREFTables[index].xrefRecCount[i];
	do
	  {
	    dbWriteLog(__FILE__,__LINE__,DBC_XREFTables[index].xrefHdrTables[i]->table,"MODIFY",0,name,buff);
	    recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
	    memcpy(recptr,buff,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
	    buff += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
	    d4changed(DBC_XREFTables[index].xrefHdrTables[i]->table,1);
	    d4flush_all(DBC_XREFTables[index].xrefHdrTables[i]->table);
	    if((d4skip(DBC_XREFTables[index].xrefHdrTables[i]->table,1)) == 0)
	      newkey = f4str(fptr);
	    else
	      break;
#ifdef PATPTO
	    if((index == VU_PTO) && (DBC_XREFTables[index].xrefHdrTables[i] == DBC_IOAddrTable))
	      {
		recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
		memcpy(recptr,buff,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
		buff += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
		break;
	      }
	    if((index == VU_PAT) && (DBC_XREFTables[index].xrefHdrTables[i] == DBC_IOAddrTable))
	      {
		recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
		memcpy(recptr,buff,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
		buff += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
		recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
		memcpy(recptr,buff,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
		buff += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
		recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
		memcpy(recptr,buff,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
		buff += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
		break;
	      }
#endif
	  }
	while(--count);
	d4flush_all(DBC_XREFTables[index].xrefHdrTables[i]->table);
	d4unlock_all(DBC_XREFTables[index].xrefHdrTables[i]->table);
      }
    else
      {
	buff += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
      }
  }
return(1);
}
