/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include	<stdio.h>
#include	<string.h>
#ifdef WIN32
#include	<time.h>
#include	<sys/types.h>
#else
#include	<sys/time.h>
#include	<sys/param.h>
#include	<types.h>
#endif WIN32
#include	<sys/stat.h>
#include	<memory.h>
#include	<errno.h>
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32
#include	"dbDefs.h"
#include	"special.h"
#include	"descDataTable.h"
#include	"fieldAttributes.h"
#include	"msgMon.h"

extern typeDesc		**descTable;
extern SPECL_PASS	udbpass;
extern UDBPVS_PTR	udbpvs;

int main (void)
{
    int status;
    time_t elap;
    char	filepath[MAXPATHLEN];
#ifdef WIN32
    struct _stat statbuff;
#else
    struct stat	statbuff;
#endif WIN32

    tisOpenLog ("dbTree", 6, 2, NULL, NULL);
    elap = time(0);
    tisSysLog(0,0,"dbTree: Start time %s",ctime(&elap));

    sprintf (filepath, "%s%s", FA_DATABASEPATH, DBTREENAME);
    /* if the file does not exist then create it */
#ifdef WIN32
    status = _stat (filepath, &statbuff);
#else
    status = stat (filepath, &statbuff);
#endif WIN32
    if ( (status == -1) || (statbuff.st_size == 0) )
    {
	sprintf (filepath, "%sdefault.dctsdr", FA_DATABASEPATH);
	/* if the SDR is already loaded, dont do it again */
	if (dbRecType == NULL)
	{
	    if (sdrLoad (filepath))
	    {
		elap = time(0);
		tisSysLog(0,0,"dbTree: sdrLoad error, End time %s",ctime(&elap));
		return (1);
	    }
	}
	if ((descTable = bldDesDataTable ()) == NULL)
	{
	    elap = time(0);
	    tisSysLog(0,0,"dbTree: bldDesDataTable error, End time %s",ctime(&elap));
	    return (1);
	}
	if ((FA_InitDatabase ()) == 0)
	{
	    udbpass = PASS_1;
	    udbpvs = (UDBPVS_PTR)0;
	    sprintf (filepath, "%s%s", FA_DATABASEPATH, DBTREENAME);
	    if ((FA_InitAvlTree (descTable)) == 0)
	    {
		FA_WriteTree (filepath);
	    }
	    d4close_all (&FA_CodeBase);
	}
    }
    /* file exists, go no further */
    else
    {
	tisSysLog (0, 0, "dbTree: file %s already exists\n", filepath);
    }
    elap = time(0);
    tisSysLog(0,0,"dbTree: End time %s",ctime(&elap));
    return (0);
}

