/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <in.h>
#include "dpamain.h"
#include "msgMon.h"

extern char appName[];
void dpaOpen(char *name,void *handle)
{
  POINT_INFO  *pInfo,pointInfo;
  char  *app,*pv,*field,*elist,pvName[PVNAME_SZ+FLDNAME_SZ+1];
  short dType,mask,tempShort;
  int dSize;
  double tempDouble;
  void  *ptr;

  strcpy(pvName,name);
  app = (char *)strtok(name,":");
  if(strcmp(app,appName))
    return;
  pv = (char *)strtok(NULL,".");
  field	= (char *)strtok(NULL,"\0");
  if(!field)
    field = "VAL";
  if(strncmp(field,"VAL",3) != 0)	/* anything other then VAL is either internal or NOT supported */
    return;
  memset(&pointInfo.dpaPointValue,0,DPA_VAL_SIZE);
  dpaGetAttributes(handle,&dType,&mask,&tempDouble,&tempDouble,&tempDouble,&tempDouble,&tempShort,&elist);
  switch(dType & 0xff)
    {
    case AGNT_ENUM:
      dSize = sizeof(short);
      break;
    case AGNT_FLOAT:
      dSize = sizeof(float);
      break;
    case AGNT_DOUBLE:
      dSize = sizeof(double);
      break;
    case AGNT_STRING:
      dSize = DPA_VAL_SIZE;
      break;
    case AGNT_INT:
      dSize = sizeof(int);
      break;
    case AGNT_LONG:
      dSize = sizeof(long);
      break;
    }
  pointInfo.dpaHandle = (void *)dpaGetUserFieldPtr(handle,field);	/* get the user field pointer for search */
  if((pInfo = (POINT_INFO_PTR)avl_findsym(dpaPoints,&pointInfo)) == 0)
    {
      if(!(pInfo = avl_newnode(POINT_INFO_SIZE)))
	{
	  tisSysLog(0,0,"No memory for point tree insert...%s",pvName);
	  return;
	}
      *pInfo = pointInfo;						/* copy structure */
      pInfo->dpaAlarmHandle = handle;
      ptr = dpaSetUserField(handle,field,dSize,dType,1,0,0,0,&pInfo->dpaPointValue);
      strcpy(&pInfo->dpaPointName[0],pvName);
      avl_insert(dpaPoints,pInfo);
      pInfo->dpaPointStatus = NO_INIT_ALARM;
      pInfo->dpaPointSeverity = VALID_ALARM;
      if(dType == AGNT_STRING)
	memset(&pInfo->dpaLastValue[0],0,DPA_VAL_SIZE);
      else
	memset(&pInfo->dpaLastValue[0],0xff,DPA_VAL_SIZE);
      dpaGetAlarmAttr(handle,&pInfo->dpaHighHigh,
		      &pInfo->dpaHigh,
		      &pInfo->dpaLow,
		      &pInfo->dpaLowLow,
		      &pInfo->dpaHighHighSevr,
		      &pInfo->dpaHighSevr,
		      &pInfo->dpaLowSevr,
		      &pInfo->dpaLowLowSevr);
    }
}
void dpaRead(void *handle)
{
  dpaFieldResponse(handle);
}
