/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <stdio.h>
#include <sys/types.h>
#include <dataTypes.h>
#include <dbDefs.h>
#include <dbRecType.h>
#include <dbRecDes.h>
#include <dbRecords.h>
/* #include <dbFldTypes.h> */
#include <agentMsgs.h>
#include <signal.h>
#include <DBDefines.h>
#include <string.h>
#include <sys/time.h>
#include <syslog.h>
#include <avl.h>
#include <alarm.h>
#include <dpa.h>
#include <choice.h>
#include <choiceGbl.h>
#include <cadef.h>
#define DPA_VAL_SIZE  32
/*
structure for point data either import or export
*/
typedef struct
{
  char  dpaPointName[PVNAME_SZ+1];
  char  dpaPad[3];
  char  dpaPointValue[DPA_VAL_SIZE];
  char  dpaLastValue[DPA_VAL_SIZE];
  short dpaPointStatus;
  short dpaPointSeverity;
  char  dpaDoTrend;
  char  dpaDoAlarm;
  char  dpaDataType;
  void  *dpaHandle;
  void  *dpaAlarmHandle;
  double  dpaHighHigh;
  double  dpaHigh;
  double  dpaLow;
  double  dpaLowLow;
  short   dpaHighHighSevr;
  short   dpaHighSevr;
  short   dpaLowSevr;
  short   dpaLowLowSevr;
} POINT_INFO, *POINT_INFO_PTR;

extern AVL_TREE *dpaPoints;

/* function prototypes */
void dpaOpen(char *,void *);
void dpaWritePoint(void *,short, void *,short);
void dpaRead(void *);
void dpaSignalHandler(int);
int  dpaPointCompare(void *, void *);


/* defines */
#define  POINT_INFO_SIZE sizeof(POINT_INFO)
#define  CONTROL_INFO_SIZE sizeof(CONTROL_INFO)
#define  LOG_OPTIONS (LOG_ALERT|LOG_LOCAL1)
#define  ALWAYS_MASTER 1
#define  DB_PATH "/tis4000db"
#define  ERR_LOG_NAME "dpa"
#define  DPA_APP_NAME "dpa"
#define  DPA_SCAN_RATE 1.0


