/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	User function dispatch and support functions. This is the 
	dpaEvent() function with all its support functions.

	dpaEvent reads the sokect for incomming messages from the hsrvTask
	and when it gets a full message call the appropriate user supplied
	function to deal with the message.

	The socket I/O has been implememted the same way as in dbClient
	and sockMaint.

	GCT	17-Oct-1994
*/
#include	<stdio.h>
#include	<types.h>
#include	<socket.h>
#include	<in.h>
#include	<tcp.h>
#include	<sys/time.h>
#include	<errno.h>

#include	"dbDefs.h"
#include	"dataTypes.h"
#include	"paramStructs.h"
#include	"alarm.h"
#include	"dpa.h"

extern	DPA_INFO	dpaInfo;
extern	LIST	chanInfoTable;
static	int	readFd();
static	int	haveCompleteMsg();
static	int	readChars();
static 	void sendParamReply();
static  void addHandle(DPA_ADDR_PTR ,int,short,short);
static  DPA_HANDLES_PTR findHandle(int clientHandle);
static void readResponse(CH_DIRREAD *rMsg);
extern	char	*chanData;
/*
static char *msgNames[] =
{
"CHAN_IOCUP",
"CHAN_IOCDN",
"CHAN_RGST",
"CHAN_SESS_SET",
"CHAN_SESS_INQ",
"CHAN_SESS_REPLY",
"CHAN_BUILD",
"CHAN_TYPE",
"CHAN_NOTFOUND",
"CHAN_DIRREAD",
"CHAN_DIRPUT",
"CHAN_MONADD",
"CHAN_MONREM",
"CHAN_CLOSE",
"CHAN_BLDACK",
"CHAN_DRRDATA",
"CHAN_MONDATA",
"CHAN_RESMODE",
"CHAN_CONNEVNT",
"CHAN_DISCEVNT",
"CHAN_CLOSEACK",
"CHAN_MONREQ",
"CHAN_SINGMON",
"CHAN_RESINQ",
"CHAN_NEEDNMSRV",
"CHAN_GOTNMSRV",
"CHAN_BLDRDMON",
"CHAN_HANDLERS",
"CHAN_GETPARAMS",
"CHAN_PARMREPLY",
"CHAN_TRDATA",
"CHAN_ALARM",
"CHAN_ALARM_RECV",
"CHAN_ALARM_CTL",
"CHAN_ALARM_ACK",
"CHAN_ALQCONN"
}; */

int	dpaEvent(timeout)
float	timeout;			/* in seconds */
{
struct	timeval	maxWait,currTime,exitTime;
int		stat;
fd_set	readFds,saveset;
short	msgType;
CH_BUILD       	bMsg;
CH_BLDACK      	aMsg;
CH_DIRREAD     	rMsg;
CH_DIRPUT      	wMsg;
CH_BLDRDMON    	brmMsg;
CH_SINGMON     	smMsg;
CH_MONREQ      	mrMsg;
CH_CLOSE       	clMsg;
CH_GETPARAMS	gpMsg;
CH_HANDLERS    	hdMsg;
CH_ALARM_CTL	acMsg;
CH_ALARM_ACK	ackMsg;
CH_TYPE	       	tyMsg;
CH_ALARM	alarmData;
CH_MONADD	maMsg;

char		name[PVNAME_SZ+FLDNAME_SZ+50],field[FLDNAME_SZ+1],chan[PVNAME_SZ+1],buff[256];
CHANNEL_INFO_PTR	entry;
DPA_ADDR	*pAddr;				/* used to get old entry. */
DPA_HANDLES_PTR	hp,prev;

FD_ZERO(&saveset);
FD_SET(dpaInfo.appFd,&saveset);
bcopy(&saveset,&readFds,sizeof(fd_set));
maxWait.tv_sec = timeout;
maxWait.tv_usec = (timeout - (float)maxWait.tv_sec) * 1000000;
if((maxWait.tv_sec == 0) && (maxWait.tv_usec == 0))
	maxWait.tv_usec = 1;				/* default to one usec if user says 0.0 */
dpaInfo.appResp = CHAN_READ;				/* generate a CHAN_DRRDATA response for read request */
while((maxWait.tv_sec >= 0) && (maxWait.tv_usec >= 0))
  {
    gettimeofday(&currTime,0);
    stat = select(dpaInfo.appFd+1,&readFds,0,0,&maxWait);
    if(stat == 0)
      return(DPA_TIMEOUT);
    else if(stat < 0)
      return(DPA_SELECTERR);
    else
      {
	if((stat = readFd(&dpaInfo)) < 0)
	  return(stat);
	while(haveCompleteMsg(&dpaInfo))
	  {
	    readChars(&dpaInfo,&msgType,sizeof(msgType));
/* 	    printf("Received a %s message from hsrvTask\n",msgNames[msgType - CHANCNTRL_BASE]); */
	    switch(msgType)
	      {
	      case CHAN_BUILD:
		readChars(&dpaInfo,&bMsg,sizeof(CH_BUILD));	/* get the entry */
		readChars(&dpaInfo,name,bMsg.chNameLen);	/* get the channel name */
		dpaSplitName(name,chan,field);		       	/* get name parts */
		if((entry = (CHANNEL_INFO_PTR)dpaGetHandle(chan)) == 0)		/* 0 = not there */
		  {
		    /*
		      Add entry to table. handle is address of new entry.
		      */
		    entry = (CHANNEL_INFO_PTR)calloc(1,sizeof(CHANNEL_INFO));
		    lstAdd((LIST *)&chanInfoTable,(NODE *)entry);
		    strcpy(&entry->chanName[0],chan);
		  }
		pAddr = dpaNameToAddr(field,entry);	       	/* get pointer to field entry */
		entry->valid++;    					/* use this to validate handle */
		if(!pAddr->init)
		  {
		    pAddr->chHandle = (void *)bMsg.chHandle;
		    if(dpaInfo.appOpen)
		      (*dpaInfo.appOpen)(name,entry);		/* call user supplied function to overwrite initial data */
		  }
		addHandle(pAddr,bMsg.chHandle,pAddr->nativeType,pAddr->nativeCount); /* add handle to list for this point.field */
		/*
		  Send back info so hsrvTask can finish build operation.
		  */
		aMsg.chHandle  	= bMsg.chHandle;		/* from hsrvTask build really the pMCB*/
		aMsg.chIocHandle = (int)pAddr;			/* this will come back later */
		aMsg.chElementCount = pAddr->nativeCount;      	/* from dpaNameToAddr or user */
		aMsg.chDataType = pAddr->nativeType;		/* respond with nativeType...could change later */
		aMsg.currState  = dpaInfo.appResourceState;    	/* one resource master=1 or slave=0 */
		pAddr->init	= 1;			       	/* OK to write */
		/*
		  When hsrvTask gets this message, it will continue with the build process and respond
		  to CA.
		  */
		msgType = APP_BUILDACK;
		sendTcp(dpaInfo.appFd,&msgType,sizeof(msgType));
		sendTcp(dpaInfo.appFd,&aMsg,sizeof(CH_BLDACK));
		break;
	      case CHAN_DIRREAD:
		/*
		  get data from application. The application will respond via the
		  'dpaFieldResponse' function when the data is ready.
		  */
		readChars(&dpaInfo,&rMsg,sizeof(CH_DIRREAD));
		readResponse(&rMsg);
		break;
	      case CHAN_MONREQ:
		readChars(&dpaInfo,&mrMsg,sizeof(CH_MONREQ));
		entry = (CHANNEL_INFO_PTR)lstFirst((LIST *)&chanInfoTable);
		while(entry)						/* loop through ALL points */
		  {
		    pAddr = (DPA_ADDR_PTR)entry->chanFields;		/* loop through all fields */
		    while(pAddr)
		      {
			if(pAddr == (DPA_ADDR_PTR)mrMsg.chHandle)
			  {
			    smMsg.chHandle     	= (int)pAddr->chHandle;			/* restore chHandle from CHAN_BUILD */
			    smMsg.chCaHandle	= mrMsg.chCaHandle;
			    pAddr->chCaHandle	= (void *)mrMsg.chCaHandle;
			    smMsg.chDataType	= mrMsg.chType;
			    smMsg.chCount      	= mrMsg.chCount;
			    memset(chanData,0,DPA_CHAN_DATA_SIZE);
			    smMsg.chDataLen    	= dpaAgentField(chanData,smMsg.chDataType,smMsg.chCount,0,entry,pAddr);
			    smMsg.chMask       	= mrMsg.mask;
			    msgType	       	= CHAN_SINGMON;
			    stat = sendTcp(dpaInfo.appFd,&msgType,sizeof(msgType));
			    stat = sendTcp(dpaInfo.appFd,&smMsg,sizeof(CH_SINGMON));
			    stat = sendTcp(dpaInfo.appFd,chanData,smMsg.chDataLen);
			    break;
			  }
			pAddr = (DPA_ADDR_PTR)pAddr->nextField;
		      }
		    entry = (CHANNEL_INFO_PTR)lstNext((NODE *)entry);
		  }
		break;
	      case CHAN_DIRPUT:
		readChars(&dpaInfo,&wMsg,sizeof(CH_DIRPUT));
		readChars(&dpaInfo,chanData,wMsg.chDataSize);
		pAddr = (DPA_ADDR_PTR)wMsg.chCaHandle;
		entry = (CHANNEL_INFO_PTR)pAddr->precord;
		if(lstFind((LIST *)&chanInfoTable,(NODE *)entry) != -1)
		  entry->chanCaType = wMsg.chDataType;
		dpaPutField(pAddr,wMsg.chDataType,chanData,wMsg.chDataSize);
		if(dpaInfo.appWrite)
		  (*dpaInfo.appWrite)(pAddr,wMsg.chDataType,chanData,wMsg.chDataSize);
		break;
		/*
		  The following message will result in three messages being sent back to hsrvTask. The first
		  is a CHAN_BLDACK followed by a CHAN_DRRDATA and finally a CHAN_SINGMON.
		  */
	      case CHAN_BLDRDMON:
		readChars(&dpaInfo,&brmMsg,sizeof(CH_BLDRDMON));	/* get the entry */
		readChars(&dpaInfo,name,brmMsg.chNameLen);	/* get the channel name */
		dpaSplitName(name,chan,field);				/* get name parts */
		if((entry = (CHANNEL_INFO_PTR)dpaGetHandle(chan)) == 0)		/* 0 = not there */
		  {
		    /*
		      Add entry to table. handle is address of new entry.
		      */
		    entry = (CHANNEL_INFO_PTR)calloc(1,sizeof(CHANNEL_INFO));
		    lstAdd((LIST *)&chanInfoTable,(NODE *)entry);
		    strcpy(&entry->chanName[0],chan);
		  }
		pAddr = dpaNameToAddr(field,entry);
		if(!pAddr->init)
		  {
		    if(dpaInfo.appOpen)
		      (*dpaInfo.appOpen)(name,entry);			/* call user supplied function to overwrite initial data */
		  }
		/*
		  Send back info so hsrvTask can finish build operation.
		  */
		aMsg.chHandle		= brmMsg.chHandle;     	/* from hsrvTask build really the pMCB */
		aMsg.chIocHandle	= (int)pAddr;	       	/* this will come back later */
		aMsg.chElementCount	= pAddr->nativeCount;	/* one value per channel for static fields */
		aMsg.chDataType		= pAddr->nativeType;	/* respond with native type */
		aMsg.currState		= dpaInfo.appResourceState;    	/* one resource master=1 or slave=0 */
		addHandle(pAddr,aMsg.chHandle,pAddr->nativeType,pAddr->nativeCount);		       	/* add handle to list for this point.field */
		entry->valid++;				       	/* use this to validate handle */
		pAddr->init	       	= 1;		       	/* OK to write */
		msgType		       	= APP_BUILDACK;
/*
	When hsrvTask gets this message, it will continue with the build process and respond
	to CA. In previous versions, hsrvTask did not receive this message.
*/
		sendTcp(dpaInfo.appFd,&msgType,sizeof(msgType));
		sendTcp(dpaInfo.appFd,&aMsg,sizeof(CH_BLDACK));
		pAddr->chHandle		= (void *)brmMsg.chHandle;
		pAddr->chCaHandle	= (void *)brmMsg.chCaHandle;		/* preserve for return trip */
		pAddr->chAppHandle	= (void *)brmMsg.chAppHandle;
/*
	If the (one) resource is slave then go no further. CA will complete the 
	connection later if it becomes master.
*/
		if(!dpaInfo.appResourceState)
		  break;
/*
	perform second part of this message by as though a read request
	was made.
*/
		if(dpaInfo.appRead)
		  (*dpaInfo.appRead)(pAddr);
/*
	The final part of this message will generate a single monitor response
	to hsrvTask.
*/
		smMsg.chHandle		= brmMsg.chHandle;
		smMsg.chCaHandle	= brmMsg.chCaHandle;
		smMsg.chDataType = pAddr->nativeType;
  		if((smMsg.chDataType & 0xff) == AGNT_STRING)
  		  smMsg.chDataType |= (AGNT_STAT);
  		else
  		  smMsg.chDataType |= (AGNT_STAT /*| AGNT_GRAPH | AGNT_CNTRL*/);
		smMsg.chCount		= pAddr->nativeCount;
		memset(chanData,0,DPA_CHAN_DATA_SIZE);
		smMsg.chDataLen		= dpaAgentField(chanData,smMsg.chDataType,pAddr->nativeCount,0,entry,pAddr);
		smMsg.chMask		= entry->chanMask;
		msgType	       		= CHAN_SINGMON;
		stat = sendTcp(dpaInfo.appFd,&msgType,sizeof(msgType));
		stat = sendTcp(dpaInfo.appFd,&smMsg,sizeof(CH_SINGMON));
		stat = sendTcp(dpaInfo.appFd,chanData,smMsg.chDataLen);
		break;
	      case CHAN_GETPARAMS:
		readChars(&dpaInfo,&gpMsg,sizeof(CH_GETPARAMS));		/* get the entry */
		readChars(&dpaInfo,name,gpMsg.chNameLen);				/* get the channel name */
		dpaSplitName(name,chan,field);				/* get name parts */
		if((entry = (CHANNEL_INFO_PTR)dpaGetHandle(chan)) != 0)	/* 0 = not there */
		  {
		    sendParamReply(entry,&dpaInfo,&gpMsg,name);	/* send the parameter reply back to hsrvTask */
		  }
		break;
	      case CHAN_HANDLERS:
		readChars(&dpaInfo,&hdMsg,sizeof(CH_GETPARAMS));		/* get the entry */
/*
	send trend messages for all points that are on trend
*/
		entry = (CHANNEL_INFO_PTR)lstFirst((LIST *)&chanInfoTable);
		while(entry)
		  {
		    if(entry->chanMask & AGNT_LOG)
		      dpaTrend((void *)dpaNameToAddr("VAL ",entry));
		    entry = (CHANNEL_INFO_PTR)lstNext((NODE *)&chanInfoTable);
		  }
		break;
	      case CHAN_ALARM_CTL:
		readChars(&dpaInfo,&acMsg,sizeof(CH_ALARM_CTL));	       	/* get the entry */
		readChars(&dpaInfo,name,acMsg.alarmNameLen);		        /* get the channel name */
		dpaSplitName(name,chan,field);				       	/* get name parts */
		if((entry = (CHANNEL_INFO_PTR)dpaGetHandle(chan)) != 0)		/* 0 = not there */
		  {
		    struct timeval tv;
		    entry->chanAenb = acMsg.alarmCtlFunc;
		    entry->chanAck = 1;
		    if(strlen(field) == 0)
		      strcpy(field,"VAL");
		    pAddr = dpaNameToAddr(field,entry);
		    gettimeofday(&tv,0);
		    alarmData.alarmTime.secPastEpoch = tv.tv_sec - TS_EPOCH_SEC_PAST_1970;
		    alarmData.alarmTime.nsec	= 0;
		    alarmData.alarmSerial      	= 0;
		    alarmData.alarmStat	       	= entry->chanAenb ? entry->chanStat : INHIBIT_ALARM;
		    alarmData.alarmSevr	       	= entry->chanAenb ? entry->chanSevr : NO_ALARM;
		    entry->chanStat	       	= entry->chanAenb ? entry->chanStat : INHIBIT_ALARM;
		    entry->chanSevr	       	= entry->chanAenb ? entry->chanSevr : NO_ALARM;
		    alarmData.alarmAck	       	= 1;
		    alarmData.alarmOnscan      	= ON_SCAN;
		    alarmData.alarmEnabled     	= entry->chanAenb;
		    alarmData.alarmDataLen     	= dpaAlarmStream(entry,pAddr,&entry->last_value[0],buff);
		    msgType	       		= CHAN_ALARM;
		    sendTcp(dpaInfo.appFd,&msgType,sizeof(short));
		    sendTcp(dpaInfo.appFd,&alarmData,sizeof(CH_ALARM));
		    sendTcp(dpaInfo.appFd,buff,alarmData.alarmDataLen);
		  }
		break;
	      case CHAN_ALARM_ACK:
		readChars(&dpaInfo,&ackMsg,sizeof(CH_ALARM_ACK));	       	/* get the entry */
		readChars(&dpaInfo,name,ackMsg.alarmNameLen);	       		/* get the channel name */
		dpaSplitName(name,chan,field);	       				/* get name parts */
		if((entry = (CHANNEL_INFO_PTR)dpaGetHandle(chan)) != 0)		/* 0 = not there */
		  {
		    entry->chanAck = 0;					       	/* 0 means got the ack */
		    if (entry->alarm_time.secPastEpoch <= ackMsg.alarmTime.secPastEpoch)
		      {
			if(strlen(field) == 0)
			  strcpy(field,"VAL");
			pAddr = dpaNameToAddr(field,entry);
			alarmData.alarmTime.secPastEpoch = ackMsg.alarmTime.secPastEpoch;
			alarmData.alarmTime.nsec	= 0;
			alarmData.alarmSerial      	= 0;		       	/* filled in by hsrvTask */
			alarmData.alarmStat	       	= entry->chanStat;
			alarmData.alarmSevr	       	= entry->chanSevr;
			alarmData.alarmAck	       	= entry->chanAck;
			alarmData.alarmOnscan      	= ON_SCAN;
			alarmData.alarmEnabled     	= entry->chanAenb;
			alarmData.alarmDataLen     	= dpaAlarmStream(entry,pAddr,&entry->last_value[0],buff);
			msgType				= CHAN_ALARM;
			sendTcp(dpaInfo.appFd,&msgType,sizeof(short));
			sendTcp(dpaInfo.appFd,&alarmData,sizeof(CH_ALARM));
			sendTcp(dpaInfo.appFd,buff,alarmData.alarmDataLen);
		      }
		  }
		break;
	      case CHAN_MONADD:
		readChars(&dpaInfo,&maMsg,sizeof(CH_MONADD));
		if((hp = findHandle(maMsg.chHandle)) != 0)
		  {
		    hp->requestedType = maMsg.chType;	/* type and... */
		    hp->requestedCount = maMsg.chCount;	/* count */
		  }
		break;
	      case CHAN_TYPE:
		readChars(&dpaInfo,&tyMsg,sizeof(CH_TYPE));
		if((hp = findHandle(tyMsg.chHandle)) != 0)
		  {
		    hp->requestedType = tyMsg.chType;	/* type and... */
		    hp->requestedCount = tyMsg.chCount;	/* count */
		  }
		break;
	      case CHAN_CLOSE:
		readChars(&dpaInfo,&clMsg,sizeof(CH_CLOSE));
		msgType = htons(CHAN_CLOSE);
		sendTcp(dpaInfo.appFd,&msgType,sizeof(msgType));
		sendTcp(dpaInfo.appFd,&clMsg,sizeof(CH_CLOSE));
		entry = (CHANNEL_INFO_PTR)lstFirst((LIST *)&chanInfoTable);
		while(entry)						/* loop through ALL points */
		  {
		    pAddr = (DPA_ADDR_PTR)entry->chanFields;		/* loop through all fields */
		    while(pAddr)
		      {
			hp = (DPA_HANDLES_PTR)pAddr->sendHandles;	/* loop through ALL interested clients */
			prev = hp;
			while(hp)
			  {
			    if(hp->handle == clMsg.chHandle)		/* if handles match then modify requested... */
			      {
				if(--entry->valid < 0)
				  {
				    entry->valid = 0;	       			/* invalidate entry */
			/*
			  call user specified close function only after LAST close is received. This is done
			  in case we are redundant. We don't want the first close of possibly many to shutdown
			  the user task.
			  */
				    if(dpaInfo.appClose)
				      dpaInfo.appClose(pAddr);     		/* call user specified close function */
				  }
				if(prev == hp)
				  pAddr->sendHandles = hp->nextHandle;	/* was first in list */
				else
				  prev->nextHandle = hp->nextHandle;	/* un-chain it */
				free(hp);		       	/* free the memory */
				break;     			/* done */
			      }
			    prev = hp;
			    hp = (DPA_HANDLES_PTR)hp->nextHandle;
			  }
			pAddr = (DPA_ADDR_PTR)pAddr->nextField;
		      }
		    entry = (CHANNEL_INFO_PTR)lstNext((NODE *)entry);
		  }
		break;
	      }
	  }
	bcopy(&saveset,&readFds,sizeof(fd_set));	/* restore fd mask */
      }
/*
	adjust timer
*/
    gettimeofday(&exitTime,0);
    exitTime.tv_sec -= currTime.tv_sec;
    exitTime.tv_usec -= currTime.tv_usec;
    if(exitTime.tv_usec < 0)
      {
	exitTime.tv_usec += 1000000;
	exitTime.tv_sec--;
      }
    maxWait.tv_sec -= exitTime.tv_sec;
    maxWait.tv_usec -= exitTime.tv_usec;
    if(maxWait.tv_usec < 0)
      {
	maxWait.tv_usec += 1000000;
	maxWait.tv_sec--;
      }
  }
dpaInfo.appResp = CHAN_MONITOR;
return(DPA_NORMAL);
}

/*
	Read socket function. drain the fd!
*/
static int	readFd(DPA_INFO_PTR dpa)
{
  int  	stat,readSize;
  if(dpa->rxCount && dpa->rxNext)		/* slide existing bytes down */
    {
      bcopy(&dpa->rxBuff[dpa->rxNext],&dpa->rxBuff[0],dpa->rxCount);
      dpa->rxNext = 0;
    }
  readSize = DPA_MAX_CHARS - dpa->rxCount;
  if((stat = recv(dpa->appFd,&dpa->rxBuff[dpa->rxCount],readSize,0)) < 0)
    return(DPA_READERR);
  if(stat == 0)			/* zero length read then exit */
    {
      close(dpa->appFd);
      return(DPA_ZEROREAD);
    }
  dpa->rxCount += stat;
  dpa->rxNext = 0;
  return(stat);
}

static int	haveCompleteMsg(DPA_INFO_PTR dpa)
{
  short	mType,mSize;
  CH_BUILD      *bMsg;
  CH_DIRPUT    	*wMsg;
  CH_BLDRDMON   *brmMsg;
  CH_GETPARAMS	*gpMsg;
  CH_ALARM_CTL	*acMsg;
  CH_ALARM_ACK	*ackMsg;
  mSize = DPA_MAX_CHARS + 1;
  if(dpa->rxCount < sizeof(mType))
    return(0);
  bcopy(&dpa->rxBuff[dpa->rxNext],&mType,sizeof(mType));
  switch(mType)
    {
    case APP_OPEN:
      if(dpa->rxCount > sizeof(CH_BUILD) + sizeof(mType))
	{
	  bMsg = (CH_BUILD *)&dpa->rxBuff[dpa->rxNext + sizeof(mType)];
	  mSize = sizeof(CH_BUILD) + bMsg->chNameLen;
	}
      break;
    case CHAN_BLDRDMON:
      if(dpa->rxCount > sizeof(CH_BLDRDMON) + sizeof(mType))
	{
	  brmMsg = (CH_BLDRDMON *)&dpa->rxBuff[dpa->rxNext + sizeof(mType)];
	  mSize = sizeof(CH_BLDRDMON) + brmMsg->chNameLen;
	}
      break;
    case CHAN_CLOSE:
      mSize = sizeof(CH_CLOSE);
      break;
    case CHAN_DIRREAD:
      mSize = sizeof(CH_DIRREAD);
      break;
    case CHAN_MONREQ:
      mSize = sizeof(CH_MONREQ);
      break;
    case CHAN_TYPE:
      mSize = sizeof(CH_TYPE);
      break;
    case CHAN_MONADD:
      mSize = sizeof(CH_MONADD);
      break;
    case APP_DUMPTREND:
      mSize = sizeof(mType);
      break;
    case CHAN_GETPARAMS:
      if(dpa->rxCount > sizeof(CH_GETPARAMS) + sizeof(mType))
	{
	  gpMsg = (CH_GETPARAMS *)&dpa->rxBuff[dpa->rxNext + sizeof(mType)];
	  mSize = sizeof(CH_GETPARAMS) + gpMsg->chNameLen;
	}
      break;
    case CHAN_ALARM_CTL:
      if(dpa->rxCount > sizeof(CH_ALARM_CTL) + sizeof(mType))
	{
	  acMsg = (CH_ALARM_CTL *)&dpa->rxBuff[dpa->rxNext + sizeof(mType)];
	  mSize = sizeof(CH_ALARM_CTL) + acMsg->alarmNameLen;
	}
      break;
    case CHAN_ALARM_ACK:
      if(dpa->rxCount > sizeof(CH_ALARM_ACK) + sizeof(mType))
	{
	  ackMsg = (CH_ALARM_ACK *)&dpa->rxBuff[dpa->rxNext + sizeof(mType)];
	  mSize = sizeof(CH_ALARM_ACK) + ackMsg->alarmNameLen;
	}
      break;
    case CHAN_DIRPUT:
      if(dpa->rxCount > sizeof(CH_DIRPUT) + sizeof(mType))
	{
	  wMsg = (CH_DIRPUT *)&dpa->rxBuff[dpa->rxNext + sizeof(mType)];
	  mSize = sizeof(CH_DIRPUT) + wMsg->chDataSize;
	}
      break;
    default:
      dpa->rxCount = 0;
      dpa->rxNext = 0;
      return(0);
    }
  return(mSize > dpa->rxCount ? 0 : 1);
}

static int	readChars(DPA_INFO_PTR dpa,char *userBuff,int userSize)
{
  bcopy(&dpa->rxBuff[dpa->rxNext],userBuff,userSize);
  dpa->rxNext += userSize;
  dpa->rxCount -= userSize;
  return(userSize);
}
int	sendTcp(int fd,char *buff,int size)
{
return(send(fd,buff,size,0));
}
static	void	sendParamReply(CHANNEL_INFO_PTR info,DPA_INFO *dpainfo,CH_GETPARAMS *gpMsg,char *name)
{
  CH_PARMREPLY	prMsg;
  char 	reply[1024],*outPtr,*start;						/* reply buffer */
  short	mType = htons(CHAN_PARMREPLY);
  double hopr,lopr,drvh,drvl,tempDouble;
  short	dType,prec,mask,tempShort;
  float	tempFloat;
  int  	tempLong;
  char 	**list;

  outPtr = reply;
  start = reply;

  prMsg.chArgument	= gpMsg->chArgument;					/* just a copy of the request params */
  prMsg.chACB			= gpMsg->chACB;
  prMsg.chParmType	= gpMsg->chParmType;
/*
	get attributes as doubles we'll convert later
*/
  dpaGetAttributes(info,&dType,&mask,&hopr,&lopr,&drvh,&drvl,&prec,list);
/*
	populate the reply buffer based on data type;
*/
  switch(gpMsg->chParmType)
    {
    case DBR_SHORT_PARAM:
      tempShort = htons(((short) hopr));
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(((short) lopr));
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(((short) drvh));
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(((short) drvl));
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = dType;
      tempShort = htons(tempShort);
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(1);
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(((short) prec));
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      break;
    case DBR_ENUM_PARAM:
      {
	int	index;
	
	*(short *) outPtr = info->chanNumStrs;
	outPtr += sizeof(short);
	for (index = 0; index < info->chanNumStrs; index++)
	  {
	    strcpy(outPtr, info->chanEnumList[index]);
	    outPtr += (strlen(info->chanEnumList[index]) + 1);
	    /*
	      if((strlen(info->chanEnumList[index]) & 1) == 0)
	      outPtr++;
	      */
	  }
      }
      break;
    case DBR_FLOAT_PARAM:
      tempFloat = hopr;	/* Watch endian later */
      bcopy((char *) &tempFloat, outPtr, sizeof(float));
      outPtr += sizeof(float);
      tempFloat = lopr;	/* Watch endian later */
      bcopy((char *) &tempFloat, outPtr, sizeof(float));
      outPtr += sizeof(float);
      tempFloat = drvh;	/* Watch endian later */
      bcopy((char *) &tempFloat, outPtr, sizeof(float));
      outPtr += sizeof(float);
      tempFloat = drvl;	/* Watch endian later */
      bcopy((char *) &tempFloat, outPtr, sizeof(float));
      outPtr += sizeof(float);
      tempShort = dType;
      tempShort = htons(tempShort);
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(1);
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(((short) prec));
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      break;
    case DBR_LONG_PARAM:
      tempLong = htonl(((int) hopr));
      bcopy((char *) &tempLong, outPtr, sizeof(int));
      outPtr += sizeof(int);
      tempLong = htonl(((int) lopr));
      bcopy((char *) &tempLong, outPtr, sizeof(int));
      outPtr += sizeof(int);
      tempLong = htonl(((int) drvh));
      bcopy((char *) &tempLong, outPtr, sizeof(int));
      outPtr += sizeof(int);
      tempLong = htonl(((int) drvl));
      bcopy((char *) &tempLong, outPtr, sizeof(int));
      outPtr += sizeof(int);
      tempShort = dType;
      tempShort = htons(tempShort);
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(1);
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(((short) prec));
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      break;
    case DBR_DOUBLE_PARAM:
      tempDouble = hopr;	/* Watch endian later */
      bcopy ((char *) &tempDouble, outPtr, sizeof(double));
      outPtr += sizeof(double);
      tempDouble = lopr;	/* Watch endian later */
      bcopy((char *) &tempDouble, outPtr, sizeof(double));
      outPtr += sizeof(double);
      tempDouble = drvh;	/* Watch endian later */
      bcopy((char *) &tempDouble, outPtr, sizeof(double));
      outPtr += sizeof(double);
      tempDouble = drvl;	/* Watch endian later */
      bcopy((char *) &tempDouble, outPtr, sizeof(double));
      outPtr += sizeof(double);
      tempShort = dType;
      tempShort = htons(tempShort);
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(1);
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      tempShort = htons(((short) prec));
      bcopy((char *) &tempShort, outPtr, sizeof(short));
      outPtr += sizeof(short);
      break;
    }
  /*
    Data common to all types
    */
  strcpy(outPtr,name);						/* point name */
  outPtr += strlen(name) + 1;
  strcpy(outPtr,info->chanEgu);				/* EDU tag */
  outPtr += strlen(info->chanEgu) + 1;
  strcpy(outPtr,dpainfo->appName);			/* resource name */
  outPtr += strlen(dpainfo->appName) + 1;
  strcpy(outPtr,info->chanDesc);				/* descriptor */
  outPtr += strlen(info->chanDesc) + 1;
/*
	save length and send to hsrvTask
*/
  prMsg.chDataLen = (short)(outPtr - start);
  if(prMsg.chDataLen & 1) prMsg.chDataLen++;	/* make message length even */
  send(dpainfo->appFd,(char *)&mType,2,0);
  send(dpainfo->appFd,(char *)&prMsg,sizeof(CH_PARMREPLY),0);
  send(dpainfo->appFd,start,prMsg.chDataLen,0);
}
/*
  This function adds a CA handle to a list of CA handles that require
  a data feed. As of 13-Nov-1996,The requested data type and count will also be
  stored here. This is so that any time data is sent back to a data client,
  it will first be converted from the nativeType (never changes) to this
  type.

  Greg Tomalesky
*/
void	addHandle(DPA_ADDR_PTR paddr,int hand,short reqType,short reqCount)
{
  DPA_HANDLES_PTR	hp;
  hp = (DPA_HANDLES_PTR)calloc(1,sizeof(DPA_HANDLES));
  hp -> nextHandle = paddr->sendHandles;
  paddr->sendHandles = hp;
  hp->handle = hand;
  hp->requestedType = reqType;
  hp->requestedCount = reqCount;
}
/*
  This function gets my client handle when given one from hsrvTask
  */
DPA_HANDLES_PTR findHandle(int clientHandle)
{
  DPA_ADDR_PTR pAddr;
  CHANNEL_INFO_PTR entry;
  DPA_HANDLES_PTR hp;

  entry = (CHANNEL_INFO_PTR)lstFirst((LIST *)&chanInfoTable);
  while(entry)						/* loop through ALL points */
    {
      pAddr = (DPA_ADDR_PTR)entry->chanFields;		/* loop through all fields */
      while(pAddr)
	{
	  hp = (DPA_HANDLES_PTR)pAddr->sendHandles;	/* loop through ALL interested clients */
	  while(hp)
	    {
	      if(hp->handle == clientHandle)		/* if handles match then modify requested... */
		{
		  return(hp);  				/* done with this one */
		}
	      hp = (DPA_HANDLES_PTR)hp->nextHandle;
	    }
	  pAddr = (DPA_ADDR_PTR)pAddr->nextField;
	}
      entry = (CHANNEL_INFO_PTR)lstNext((NODE *)entry);
    }
return((DPA_HANDLES_PTR)0);
}
void readResponse(CH_DIRREAD *rMsg)
{
  CHANNEL_INFO_PTR	entry;
  DPA_ADDR		*pAddr;				/* used to get old entry. */
  DPA_HANDLES_PTR	hp;
  DPA_DRRDATA     	ddMsg;
  short			msgType;

  entry = (CHANNEL_INFO_PTR)lstFirst((LIST *)&chanInfoTable);
  while(entry)						/* loop through ALL points */
    {
      pAddr = (DPA_ADDR_PTR)entry->chanFields;		/* loop through all fields */
      while(pAddr)
	{
	  hp = (DPA_HANDLES_PTR)pAddr->sendHandles;	/* loop through ALL interested clients */
	  while(hp)
	    {
	      if(hp->handle == rMsg->chHandle)		/* if handles match then OK to send */
		{
		  msgType = htons(CHAN_DRRDATA);
 		  pAddr->chCaHandle	= (void *)rMsg->chCaHandle;
 		  pAddr->chAppHandle	= (void *)rMsg->chAppHandle;
		  ddMsg.drr.chHandle = rMsg->chHandle;	/* GCT 30-Sep-1997 */
		  ddMsg.appHandle = (void *)rMsg->chAppHandle;
		  ddMsg.drr.chCaHandle = rMsg->chCaHandle;
		  ddMsg.drr.chDataType = rMsg->chDataType;
		  if((ddMsg.drr.chDataType & 0xff) == AGNT_STRING)
		    ddMsg.drr.chDataType |= (AGNT_STAT);
		  else
		    ddMsg.drr.chDataType |= (AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL);
		  ddMsg.drr.chCount	= rMsg->chNumElem;	       	/* one element */
		  memset(chanData,0,DPA_CHAN_DATA_SIZE);
		  ddMsg.drr.chDataLen	= dpaAgentField(chanData,ddMsg.drr.chDataType,rMsg->chNumElem/*pAddr->nativeCount*/,0,entry,pAddr); /* get field data and size */
		  send(dpaInfo.appFd,(char *)&msgType,sizeof(msgType),0);		/* send the message type... */
		  send(dpaInfo.appFd,(char *)&ddMsg,sizeof(DPA_DRRDATA),0);       	/* followed by the message header... */
		  send(dpaInfo.appFd,chanData,ddMsg.drr.chDataLen,0);		/* followed by the data */
		  break;					/* done with this one */
		}
	      hp = (DPA_HANDLES_PTR)hp->nextHandle;
	    }
	  pAddr = (DPA_ADDR_PTR)pAddr->nextField;
	}
      entry = (CHANNEL_INFO_PTR)lstNext((NODE *)entry);
    }
}
