/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	This is a small test app. It uses the functions provided in dpaLibrary
	to communicate with CA.
*/
#include <math.h>
#include <signal.h>

#include "dbDefs.h"
#include "dataTypes.h"
#include "dbFldTypes.h"
#include "newalarm.h"
#include "dpa.h"
#include "cadef.h"

#define	TEST_CA	1

static	float	sqrtVal,testVal = 0.0;
static	short	testShort = 0;
static	char	*enumStrings[] = {"Long string","Greg Tomalesky","more strings","1234","dbClient","dataVu",0};
static	char	*methodStrings[] = {"SMP","MIN","MAX","AVG",0};
static	char	*pageStrings[] = {"< PREV","NEXT >",0};
static	char	*zoomStrings[] = {"ZOOM IN","ZOOM OUT",0};
static	char	appName[100];
void	updateToPartner(int handle,float val1,short val2);
int		updateFromPartner(int handle,float *val1,short *val2);
float	xArray[500],yArray[500];

void	*appHandle[6],*pvs[6],*handle1,*handle2,*handle3,*valuator,*indicator,*handle4,*handle5,*userHandle1,*userHandle2;
void	testOpen(),testRead(),testWrite(),sigHandler(),testClose(),*zoom,*page,*method;
int		signals[] = {SIGPIPE,SIGINT,SIGHUP,0};
void	caRead(struct	event_handler_args arg);
void	caMonitor(struct event_handler_args arg);
void	caConnect(struct connection_handler_args arg);
extern	DPA_INFO	dpaInfo;
char	*resMode[] =
	{
	"",
	"SLAVE!",
	"MASTER!",
	"MASTER-NO PARTNER",
	"UNKNOWN"
	};
typedef	enum
	{
	SLAVE=1,
	MASTER,
	MNOP,
	UNKNOWN
	}APP_RED_STATUS;

main(int argc,char *argv[])
{
double	dispHi,dispLo,drvHi,drvLo;
short	dType,prec,mask,num = 0;
char	**list,*slash;
short	newMask;
int		status,i,appRedHandle,appStatus;
APP_RED_STATUS	appRedStatus,ts;
double	HiHi,High,Low,LoLo;
short	hhSever,hSever,lSever,llSever,stat,sevr;
chid	Chid;
evid	evID;
float f = 0.0;
/*
	Init arrays
*/
for(i = 0;i < 500;i++)
	{
	xArray[i] = f;
	yArray[i] = 10*sqrt(f);
	f += 1.0;
	}
appRedStatus = UNKNOWN;
slash = (char *)strrchr(argv[0],'/');
if(slash)
	{
	slash++;
	strcpy(appName,slash);
	}
else
	strcpy(appName,argv[0]);
/* check for redundancy status on command line */
if(argc == 2)
	appRedStatus = atoi(argv[1]);
else
	appRedStatus = MASTER;

if((status = dpaInit(appName,testOpen,testRead,testWrite,0,sigHandler,signals)) < 0)
	exit();
num = dpaConfigure(appName);							/* read config file */
#ifdef USE_ARBITER
if((appStatus = appRegister(appName,&appRedHandle)))	/* use msArbiter to establish redundancy state */
	appGetStatus(appRedHandle,&appRedStatus);			/* get my redundancy status */
#else
appRedStatus = MASTER;
#endif
ts = appRedStatus;
printf("%s running as %s\n",appName,resMode[appRedStatus]);
dpaSetResMode(((appRedStatus == SLAVE) ? 0 : 1));		/* set it and (possibly ) send to hsrvTask */
#ifdef	TEST_CA
ca_task_initialize();									/* try CA at the same time */
if((status = ca_build_read_and_monitor("BillsCalc.VAL",caConnect,0,caRead,0,caMonitor,0,&Chid,&evID)) != ECA_NORMAL)
	printf("problem with cabram...%s\n",ca_message(status));
#endif
while(1)
	{
	handle1		= dpaGetHandle("testapp:test1");
	handle2		= dpaGetHandle("testapp:test1.VAL");
	handle3		= dpaGetHandle("testapp:test2.VAL");
	valuator	= dpaGetHandle("testapp:valuator.VAL");
	indicator	= dpaGetHandle("testapp:indicator.VAL");
	while(1)
		{
		status = dpaEvent(1.0);
		ca_pend_io(0.1);
#ifdef USE_ARBITER
		if(appStatus)
			{
			if((appStatus = appGetStatus(appRedHandle,(int *)&appRedStatus)) != 0)	/* get current status */
				{
				if(ts != appRedStatus)
					{
					ts = appRedStatus;
					printf("%s running as %s\n",appName,resMode[appRedStatus]);
					}
				dpaSetResMode(((appRedStatus == MASTER) ? 1 : 0));			/* set and send */
				}
			else
				{
				appStatus = appRegister(appName,&appRedHandle);
				continue;
				}
			}
		else
			{
			appStatus = appRegister(appName,&appRedHandle);
			continue;
			}
#endif
		if(appRedStatus == MASTER)
			{
#ifndef TEST_CA
			if((testVal += 0.5) > 100.00) testVal = 0.0;
			if((testShort += 1) > 3) testShort = 0;
#endif
			dpaGetAlarmAttr(handle1,&HiHi,&High,&Low,&LoLo,&hhSever,&hSever,&lSever,&llSever);
			if(testVal > HiHi)
				{
				stat = HIHI_ALARM;
				sevr = hhSever;
				}
			else if(testVal > High)
				{
				stat = HIGH_ALARM;
				sevr = hSever;
				}
			else if(testVal < LoLo)
				{
				stat = LOLO_ALARM;
				sevr = llSever;
				}
			else if(testVal < Low)
				{
				stat = LOW_ALARM;
				sevr = lSever;
				}
			else
				{
				stat = NO_ALARM;
				sevr = NO_ALARM;
				}
			dpaAlarm(handle2,(void *)&testVal,sizeof(float),stat,sevr,0);
			sqrtVal = sqrt(testVal);
		/*	dpaWrite(handle3,(short *)&testShort,sizeof(short),AGNT_VALUE,0,0);*/
#ifdef USE_ARBITER
			updateToPartner(appRedHandle,testVal,testShort);
			printf("%s sending %08X %04X\n",resMode[appRedStatus],*((unsigned int *)&testVal),(unsigned short)testShort);
#endif
			}
		else
			{
			updateFromPartner(appRedHandle,&testVal,&testShort);
			printf("%s receiving %08X %04X\n",resMode[appRedStatus],*((unsigned int *)&testVal),(unsigned short)testShort);
			}
		}
	}
}

void	testOpen(name,handle)
char	*name;
void	*handle;
{
if(!strcmp(name,"testapp:test4.VAL"))
	{
	printf("Overiding parameters for...%s\n",name);
	dpaSetAttributes(handle,AGNT_ENUM,AGNT_VALUE,50.0,0.0,50.0,0.0,3,enumStrings);
	}
if(!strcmp(name,"testapp:test1.X"))
	{
	userHandle1 = dpaSetUserField(handle,"X",sizeof(float),AGNT_FLOAT,500,0,0.0,100.0);
	dpaSetAttributes(handle,AGNT_FLOAT,AGNT_VALUE,500.0,0.0,500.0,0.0,3,0);
	dpaWrite(userHandle1,(float *)&xArray[0],sizeof(float),AGNT_VALUE,0,0);
	}
if(!strcmp(name,"testapp:test1.Y"))
	{
	userHandle2 = dpaSetUserField(handle,"Y",sizeof(float),AGNT_FLOAT,500,0,0.0,100.0);
	dpaSetAttributes(handle,AGNT_FLOAT,AGNT_VALUE,500.0,0.0,500.0,0.0,3,0);
	dpaWrite(userHandle2,(float *)&yArray[0],sizeof(float),AGNT_VALUE,0,0);
	}
if(!strcmp(name,"testapp:group.MTHD"))
	{
	method = dpaSetUserField(handle,"MTHD",sizeof(short),AGNT_ENUM,1,methodStrings,0,0);
	}
if(!strcmp(name,"testapp:group.ZOOM"))
	{
	zoom = dpaSetUserField(handle,"ZOOM",sizeof(short),AGNT_ENUM,1,zoomStrings,0,0);
	}
if(!strcmp(name,"testapp:group.PAGE"))
	{
	page = dpaSetUserField(handle,"PAGE",sizeof(short),AGNT_ENUM,1,pageStrings,0,0);
	}
}
/*
	This function supplies data to CA from the application
*/
void	testRead(handle)
void	*handle;
{
dpaFieldResponse(handle);
}
/*
	This function gets data from CA via DM and delivers it to the application
*/
void	testWrite(handle,dataType,value,size)
void	*handle;
short	dataType;
void	*value;
int		size;
{
double	dispHi,dispLo,drvHi,drvLo;
short	dType,prec,mask;
char	**list;

dpaGetFieldAttributes(handle,&dType,&mask,&dispHi,&dispLo,&drvHi,&drvLo,&prec,list);
if(handle == valuator)
	dpaWrite(indicator,value,size,AGNT_VALUE,0,0);
dpaWriteField(handle);
switch(dType)
	{
	case AGNT_FLOAT:
		printf("FLOAT Value from DM <%lf>\n",dpaConvertToFloat(handle,value,dataType));
		break;
	case AGNT_DOUBLE:
		printf("DOUBLE Value from DM <%f>\n",dpaConvertToDouble(handle,value,dataType));
		break;
	case AGNT_ENUM:
		printf("ENUM Value from DM <%s>\n",dpaConvertToEnumStr(handle,value,dataType));
		break;
	case AGNT_STRING:
		printf("STRING Value from DM <%s>\n",dpaConvertToString(handle,value,dataType));
		break;
	case AGNT_CHAR:
		printf("CHAR Value from DM <%d>\n",dpaConvertToChar(handle,value,dataType));
		break;
	case AGNT_SHORT:
		printf("SHORT INTEGER Value from DM <%d>\n",dpaConvertToInt(handle,value,dataType));
		break;
	case AGNT_LONG:
		printf("LONG INTEGER Value from DM <%d>\n",dpaConvertToLong(handle,value,dataType));
		break;
	default:
		printf("\n");
		break;
	}
}
void	sigHandler(int whichone)
{
switch(whichone)
	{
	case SIGPIPE:
		printf("\nPipes're broke, Hon\n");
		break;
	case SIGINT:
	case SIGHUP:
		printf("\nBye-bye...\n");
		break;
	default:
		printf("\nUnknown signal %d\n",whichone);
	}
kill(dpaInfo.hsrvTaskPID,SIGINT);
exit(1);
}
#ifdef	TEST_CA
void	caMonitor(struct event_handler_args arg)
{
float	fValue;
switch(arg.type)
	{
	case DBR_STS_DOUBLE:
		fValue = ((struct dbr_sts_double *)arg.dbr)->value;
		break;
	case DBR_STS_FLOAT:
		fValue =  ((struct dbr_sts_float *)arg.dbr)->value;
		break;
	case DBR_CTRL_DOUBLE:
		fValue = ((struct dbr_ctrl_double *)arg.dbr)->value;
		break;
	case DBR_CTRL_FLOAT:
		fValue =  ((struct dbr_ctrl_float *)arg.dbr)->value;
		break;
	default:
		break;
	}
testVal = fValue;
dpaWrite(handle2,(float *)&testVal,sizeof(float),AGNT_VALUE,0,0);
}
/*
	Called after ca_build_read_and_monitor. same as above.
*/
void	caRead(struct	event_handler_args arg)
{
caMonitor(arg);
}
/*
	Connection handler. Used to finish-up build_and_read...
*/
void	caConnect(struct connection_handler_args arg)
{
if(arg.op == CA_OP_CONN_UP)
	ca_complete_bld_read_mon(arg.chid);
}
#endif
/*
	Two functions to send/recv redundancy messages
*/
void	updateToPartner(int handle,float val1,short val2)
{
appSendData(handle,(char *)&val1,sizeof(float));
appSendData(handle,(char *)&val2,sizeof(short));
}

int	updateFromPartner(int handle,float *val1,short *val2)
{
int stat1,stat2;
stat1 = appRecvData(handle,(char *)val1,sizeof(float),10000);
stat2 = appRecvData(handle,(char *)val2,sizeof(short),10000);
if((stat1 != 0) && (stat2 != 0))
	return(1);
else
	return(0);
}
