/*	File:	index.h		/* Header for indexing package */
/*	Author:	Douglas P. Dotson
/*	Date:	25 Jan 91
/* 	Edit:	25 Jan 91	1329	DPD
*/

/* Constants */

#define	NUMBUFS		100
#define	MAXBUFSIZE	50000

/* Index File Descriptor and Header */

typedef	struct {
    int		KeySize;
    int		RecSize;
    FILE	*IndexFile;
    long	IndexSize;
    long	Inserts;
    long	ICollisions;
    long	LookUps;
    long	LCollisions;
    char	*Buffer;
    char	*Cache;
    long	CachePlace;
    long	CurrentRecord;
    char	*CacheBuffers [NUMBUFS];
    char	CacheModified [NUMBUFS];
    int		NumBufs;
    int		RecsPerBuf;
    long	LastRecInCache;
    long	NumRecs;
} INDEX;

/* Functions in this module */

extern	int 	IndexCreate ();
extern	int	IndexOpen ();
extern	void	IndexClose ();
extern	void	IndexDelete ();
extern	int	IndexInsert ();
extern	int	IndexLookUp ();
extern	void	IndexReadDirect ();
extern	void	IndexWriteDirect ();
extern	void	IndexRewind ();
extern	long	IndexReadNext ();
extern	void	IndexGetCollisions ();
extern	long	IndexSize ();
extern	long	IndexNumEntries ();
