
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
 /* 	FILE NAME   :	OperPriv.h
  *	PURPOSE	    :	Additional definitions for operator privilege checking 
  *			and operator tracking.
  *
  *	AUTHOR	    :	Donald E. Kyne, Jr.
  *	DATE	    :	21-Sep-1992
  *
  *					M O D I F I C A T I O N S
  *
  *	DATE		INITIALS	DETAILS
  *
  *	Copyright 1992, Tate Integrated Systems, L.P.  All rights reserved.
  */

#include "OperPrivErr.h"	/* return codes */

#ifdef PRIV_CLIENT
void	SetRemotePrivServer (void);
void	SetPrivServer (char *servername);
char	*GetPrivServer (char *servername, int namelen);
int	OperLogon (char *OperName, char *PassWord);
int	OperLogoff (void);
#endif PRIV_CLIENT
void	GetOperName (char *namebuff);
char	*getDisplayHost (void);
int	InitOperPriv (char *opername);
int	InitOperTracking (char *opername);
int	CheckOperPriv (char *channel);	
int	WriteOperTracking (char *channel, char *OldValue, char *NewValue);
int	OperPrivTrackErr (int code, char ***message);
int	CloseOperPriv (void);
int	CloseOperTracking (char *opername);
int	GetProtGrp (char *PtType, char *PtGrp);
int	GetOperLevel (void);
int	GetFieldLevel (char *PtType, char *FieldName, char *FieldPrvLevel);
int	CheckChannel (char *Channel);
int	OperPriv (C4CODE *cBase, char myGroup[]);
void	SetChannel (char *Channel);
