/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

#include	<stdio.h>
#include	<string.h>
#include	<memory.h>

#include	"msmain.h"

extern	char	applicationName [];
extern	int	appHostState;
extern	int	appMyHandle;

/*----------*/
int appSendData (appHandle, appBuffer, appBytes)

    int		appHandle;
    char	*appBuffer;
    int		appBytes;

    {

	AppDataMsg	msg;
	int		bytesLeft, bytesSent;
	char		*p;

	/* If we have no partner app, then no point in wasting bandwidth ans we will */
	/* call the send successful */

	if (appHostState == MASTER_NOPARTNER)
	    return 1;

	/* Build the message. This message is variable length so the calculation of message length */
	/* is a bit different. */

	msg.magic = htonl (MSG_MAGIC_NUMBER);
	msg.size = htonl (sizeof (msg) - MAX_MSG_LEN + appBytes);
	msg.type = htonl (APP_DATA);
	strcpy (msg.name, applicationName);
	memcpy (msg.data, appBuffer, appBytes);

	/* Send the message accounting for partial writes */

	bytesLeft = ntohl (msg.size);
	p = (char *)&msg;
	while (bytesLeft > 0) {
	    bytesSent = send (appHandle, p, bytesLeft, 0);
	    if (bytesSent == -1) {
		close (appHandle);
		appMyHandle = -1;
		return 0;
	    }
	    p += bytesSent;
	    bytesLeft -= bytesSent;
	}

	return 1;

    }
