/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/* These are the definitions for data stored in shared memory. */

#ifndef _SHAREMEM_H_
#define _SHAREMEM_H_

#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <sys/types.h>
#ifndef WIN32
#include <sys/time.h>
#include <sys/stat.h>
#include <syslog.h>
#include <error.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#endif WIN32

#define  TR_MEM_KEY     0x33333334    /* Shared memory key */
#define  TR_SEM_KEY     0x33333335    /* MX Semaphore key */

/* Each point that is set up for up-to-date data */

#define  POINTNAME_SIZE     28
#define  NUM_BUCKETS        60
typedef struct {
    char        pointName [POINTNAME_SIZE+1];
    int         interval;
    int         method;
    time_t      startTime;
    int         sampleCnt;
    double      value [NUM_BUCKETS];
    char        quality [NUM_BUCKETS];
    char        severity [NUM_BUCKETS];
    char        status [NUM_BUCKETS];
    double      lastValue;
    char        lastSeverity;
    char        lastStatus;
    int         useCount;   /* Number of clients using this entry */  
    int         valid;
  void          *p;    	/* will become a pointer to the point node for this pointName...see trendInsert */
} CurrentData;

/* This is the structure of the shared memory */

#define  NUM_TRENDS        100
typedef struct {
    int         numEntries;
    int         changed;
    CurrentData data [NUM_TRENDS];
} UpToDateInfo;

#define  TREND_MIN      0
#define  TREND_MAX      1
#define  TREND_AVG      2
#define  TREND_SMP      3

extern   int     trendInit (void);
extern   void    trendTerminate (void);
extern   int     trendInsert (char *, int);
extern   int     trendRemove (char *, int);
extern   int     trendGet (char *, int, CurrentData *);

#endif
