/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
   File:   trendupdate.h - trend update database formats

   Author: Grant Irani
   Date:   10/27/97
*/

/* journal name and location conventions - path is a subdirectory of tis4000db */
#ifdef WIN32
#define JOURNAL_PATH "\\tis4000db\\trend_updates\\"
#else
#define JOURNAL_PATH "/tis4000db/trend_updates/"
#endif WIN32
/*	name is TUmmddyy - i.e. 10/23/97 reports produce TU102397.dbf */
#define JOURNAL_NAME "TU%02.2d%02.2d%02.2d"

/* journal field and tag definitions */
FIELD4INFO	journalFields[] =	{

	/* Field name,		Type,	Width,		Decimals */
	{ "POINTNAME",		'C',	POINTNAME_SIZE,	        0},
	{ "TIME",		'N',	10,		        0},
	{ "EGUTAG",		'C',	EGUTAG_SIZE,	        0},
	{ "DISP_LOW",		'C',	LIMITS_SIZE, 	        0},
	{ "DISP_HIGH",		'C',	LIMITS_SIZE,	        0},
	{ "VALUE1",		'C',	VALUE_SIZE,		0},
	{ "STATUS1",		'C',	1,		0},
	{ "VALUE2",		'C',	VALUE_SIZE,		0},
	{ "STATUS2",		'C',	1,		0},
	{ "VALUE3",		'C',	VALUE_SIZE,		0},
	{ "STATUS3",		'C',	1,		0},
	{ "VALUE4",		'C',	VALUE_SIZE,		0},
	{ "STATUS4",		'C',	1,		0},
	{ "VALUE5",		'C',	VALUE_SIZE,		0},
	{ "STATUS5",		'C',	1,		0},
	{ "VALUE6",		'C',	VALUE_SIZE,		0},
	{ "STATUS6",		'C',	1,		0},
	{ "VALUE7",		'C',	VALUE_SIZE,		0},
	{ "STATUS7",		'C',	1,		0},
	{ "VALUE8",		'C',	VALUE_SIZE,		0},
	{ "STATUS8",		'C',	1,		0},
	{ "VALUE9",		'C',	VALUE_SIZE,		0},
	{ "STATUS9",		'C',	1,		0},
	{ "VALUE10",		'C',	VALUE_SIZE,		0},
	{ "STATUS10",		'C',	1,		0},
	{ "VALUE11",		'C',	VALUE_SIZE,		0},
	{ "STATUS11",		'C',	1,		0},
	{ "VALUE12",		'C',	VALUE_SIZE,		0},
	{ "STATUS12",		'C',	1,		0},
	{ "VALUE13",		'C',	VALUE_SIZE,		0},
	{ "STATUS13",		'C',	1,		0},
	{ "VALUE14",		'C',	VALUE_SIZE,		0},
	{ "STATUS14",		'C',	1,		0},
	{ "VALUE15",		'C',	VALUE_SIZE,		0},
	{ "STATUS15",		'C',	1,		0},
	{ "VALUE16",		'C',	VALUE_SIZE,		0},
	{ "STATUS16",		'C',	1,		0},
	{ "VALUE17",		'C',	VALUE_SIZE,		0},
	{ "STATUS17",		'C',	1,		0},
	{ "VALUE18",		'C',	VALUE_SIZE,		0},
	{ "STATUS18",		'C',	1,		0},
	{ "VALUE19",		'C',	VALUE_SIZE,		0},
	{ "STATUS19",		'C',	1,		0},
	{ "VALUE20",		'C',	VALUE_SIZE,		0},
	{ "STATUS20",		'C',	1,		0},
	{ "VALUE21",		'C',	VALUE_SIZE,		0},
	{ "STATUS21",		'C',	1,		0},
	{ "VALUE22",		'C',	VALUE_SIZE,		0},
	{ "STATUS22",		'C',	1,		0},
	{ "VALUE23",		'C',	VALUE_SIZE,		0},
	{ "STATUS23",		'C',	1,		0},
	{ "VALUE24",		'C',	VALUE_SIZE,		0},
	{ "STATUS24",		'C',	1,		0},
	{ "VALUE25",		'C',	VALUE_SIZE,		0},
	{ "STATUS25",		'C',	1,		0},
	{ "VALUE26",		'C',	VALUE_SIZE,		0},
	{ "STATUS26",		'C',	1,		0},
	{ "VALUE27",		'C',	VALUE_SIZE,		0},
	{ "STATUS27",		'C',	1,		0},
	{ "VALUE28",		'C',	VALUE_SIZE,		0},
	{ "STATUS28",		'C',	1,		0},
	{ "VALUE29",		'C',	VALUE_SIZE,		0},
	{ "STATUS29",		'C',	1,		0},
	{ "VALUE30",		'C',	VALUE_SIZE,		0},
	{ "STATUS30",		'C',	1,		0},
	{ "VALUE31",		'C',	VALUE_SIZE,		0},
	{ "STATUS31",		'C',	1,		0},
	{ "VALUE32",		'C',	VALUE_SIZE,		0},
	{ "STATUS32",		'C',	1,		0},
	{ "VALUE33",		'C',	VALUE_SIZE,		0},
	{ "STATUS33",		'C',	1,		0},
	{ "VALUE34",		'C',	VALUE_SIZE,		0},
	{ "STATUS34",		'C',	1,		0},
	{ "VALUE35",		'C',	VALUE_SIZE,		0},
	{ "STATUS35",		'C',	1,		0},
	{ "VALUE36",		'C',	VALUE_SIZE,		0},
	{ "STATUS36",		'C',	1,		0},
	{ "VALUE37",		'C',	VALUE_SIZE,		0},
	{ "STATUS37",		'C',	1,		0},
	{ "VALUE38",		'C',	VALUE_SIZE,		0},
	{ "STATUS38",		'C',	1,		0},
	{ "VALUE39",		'C',	VALUE_SIZE,		0},
	{ "STATUS39",		'C',	1,		0},
	{ "VALUE40",		'C',	VALUE_SIZE,		0},
	{ "STATUS40",		'C',	1,		0},
	{ "VALUE41",		'C',	VALUE_SIZE,		0},
	{ "STATUS41",		'C',	1,		0},
	{ "VALUE42",		'C',	VALUE_SIZE,		0},
	{ "STATUS42",		'C',	1,		0},
	{ "VALUE43",		'C',	VALUE_SIZE,		0},
	{ "STATUS43",		'C',	1,		0},
	{ "VALUE44",		'C',	VALUE_SIZE,		0},
	{ "STATUS44",		'C',	1,		0},
	{ "VALUE45",		'C',	VALUE_SIZE,		0},
	{ "STATUS45",		'C',	1,		0},
	{ "VALUE46",		'C',	VALUE_SIZE,		0},
	{ "STATUS46",		'C',	1,		0},
	{ "VALUE47",		'C',	VALUE_SIZE,		0},
	{ "STATUS47",		'C',	1,		0},
	{ "VALUE48",		'C',	VALUE_SIZE,		0},
	{ "STATUS48",		'C',	1,		0},
	{ "VALUE49",		'C',	VALUE_SIZE,		0},
	{ "STATUS49",		'C',	1,		0},
	{ "VALUE50",		'C',	VALUE_SIZE,		0},
	{ "STATUS50",		'C',	1,		0},
	{ "VALUE51",		'C',	VALUE_SIZE,		0},
	{ "STATUS51",		'C',	1,		0},
	{ "VALUE52",		'C',	VALUE_SIZE,		0},
	{ "STATUS52",		'C',	1,		0},
	{ "VALUE53",		'C',	VALUE_SIZE,		0},
	{ "STATUS53",		'C',	1,		0},
	{ "VALUE54",		'C',	VALUE_SIZE,		0},
	{ "STATUS54",		'C',	1,		0},
	{ "VALUE55",		'C',	VALUE_SIZE,		0},
	{ "STATUS55",		'C',	1,		0},
	{ "VALUE56",		'C',	VALUE_SIZE,		0},
	{ "STATUS56",		'C',	1,		0},
	{ "VALUE57",		'C',	VALUE_SIZE,		0},
	{ "STATUS57",		'C',	1,		0},
	{ "VALUE58",		'C',	VALUE_SIZE,		0},
	{ "STATUS58",		'C',	1,		0},
	{ "VALUE59",		'C',	VALUE_SIZE,		0},
	{ "STATUS59",		'C',	1,		0},
	{ "VALUE60",		'C',	VALUE_SIZE,      	0},
	{ "STATUS60",		'C',	1,		0},
	{0, 0, 0, 0}		/* NULL-record terminator */
};


TAG4INFO	journalTags [] =	{
	{ "POINT_TIME", "POINTNAME+STR(TIME,10,0)", 0, 0, 0},
	{0, 0, 0, 0, 0}		/* NULL-record terminator */
};


