/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

#ifdef SOLARIS
#include <sys/types.h>
#include <sys/statvfs.h>
#endif SOLARIS

#include "stdlib.h"

#include <time.h>

#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#include "cb45to63.h"
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#define C_EPOCHSTART	2440588L	/* dif from db4 date to 01/01/1970 */
#define C_SECSPERDAY 86400L	/* number of seconds per day */

#define	REDUC_MIN	0
#define	REDUC_MAX	1
#define	REDUC_AVG	2
#define	REDUC_SMP	3
#include "trendSizes.h"
#include "oracleSnap.h"
#include "avmDefs.h"
#include "xbaseSnapLib.h"
#include "DBDefines.h"
#include "catlib.h"
#include "resolveLinks.h"

static C4CODE	cb;
static int cbInit = 0;
#define MAX_OPEN_XBASE	10
static XBaseData openFile [MAX_OPEN_XBASE];
static XBaseDesc *openDesc [MAX_OPEN_XBASE * 2];

/* ar_snap field and tag definitions */
FIELD4INFO	snapFields[] =	{
	/* Field name,		Type,	Width,		Decimals */
	{ "POINTNAME",		'C',	POINTNAME_SIZE,	        0},
	{ "EGUTAG",		'C',	EGUTAG_SIZE,	        0},
	{ "DISP_LOW",		'C',	LIMITS_SIZE, 	        0},
	{ "DISP_HIGH",		'C',	LIMITS_SIZE,	        0},
	{ "YEAR",		'N',	YEAR_SIZE,	        0},
	{ "DAYOFYEAR",		'N',	DAY_SIZE,	        0},
	{ "HOUR",		'N',	HOUR_SIZE,  	        0},
	{ "OFFSET_MIN",		'N',	MIN_SIZE, 	        0},
	{ "SAMPLE_CNT",		'N',	SAMPLECNT_SIZE,         0},
	{ "RED_METHOD",		'C',	METHOD_SIZE,	        0},
	{ "RATE",		'C',	RATE_SIZE,              0},
	{ "VALUE1",		'C',	VALUE_SIZE,		0},
	{ "STATUS1",		'C',	STATUS_SIZE,		0},
	{ "VALUE2",		'C',	VALUE_SIZE,		0},
	{ "STATUS2",		'C',	STATUS_SIZE,		0},
	{ "VALUE3",		'C',	VALUE_SIZE,		0},
	{ "STATUS3",		'C',	STATUS_SIZE,		0},
	{ "VALUE4",		'C',	VALUE_SIZE,		0},
	{ "STATUS4",		'C',	STATUS_SIZE,		0},
	{ "VALUE5",		'C',	VALUE_SIZE,		0},
	{ "STATUS5",		'C',	STATUS_SIZE,		0},
	{ "VALUE6",		'C',	VALUE_SIZE,		0},
	{ "STATUS6",		'C',	STATUS_SIZE,		0},
	{ "VALUE7",		'C',	VALUE_SIZE,		0},
	{ "STATUS7",		'C',	STATUS_SIZE,		0},
	{ "VALUE8",		'C',	VALUE_SIZE,		0},
	{ "STATUS8",		'C',	STATUS_SIZE,		0},
	{ "VALUE9",		'C',	VALUE_SIZE,		0},
	{ "STATUS9",		'C',	STATUS_SIZE,		0},
	{ "VALUE10",		'C',	VALUE_SIZE,		0},
	{ "STATUS10",		'C',	STATUS_SIZE,		0},
	{ "VALUE11",		'C',	VALUE_SIZE,		0},
	{ "STATUS11",		'C',	STATUS_SIZE,		0},
	{ "VALUE12",		'C',	VALUE_SIZE,		0},
	{ "STATUS12",		'C',	STATUS_SIZE,		0},
	{ "VALUE13",		'C',	VALUE_SIZE,		0},
	{ "STATUS13",		'C',	STATUS_SIZE,		0},
	{ "VALUE14",		'C',	VALUE_SIZE,		0},
	{ "STATUS14",		'C',	STATUS_SIZE,		0},
	{ "VALUE15",		'C',	VALUE_SIZE,		0},
	{ "STATUS15",		'C',	STATUS_SIZE,		0},
	{ "VALUE16",		'C',	VALUE_SIZE,		0},
	{ "STATUS16",		'C',	STATUS_SIZE,		0},
	{ "VALUE17",		'C',	VALUE_SIZE,		0},
	{ "STATUS17",		'C',	STATUS_SIZE,		0},
	{ "VALUE18",		'C',	VALUE_SIZE,		0},
	{ "STATUS18",		'C',	STATUS_SIZE,		0},
	{ "VALUE19",		'C',	VALUE_SIZE,		0},
	{ "STATUS19",		'C',	STATUS_SIZE,		0},
	{ "VALUE20",		'C',	VALUE_SIZE,		0},
	{ "STATUS20",		'C',	STATUS_SIZE,		0},
	{ "VALUE21",		'C',	VALUE_SIZE,		0},
	{ "STATUS21",		'C',	STATUS_SIZE,		0},
	{ "VALUE22",		'C',	VALUE_SIZE,		0},
	{ "STATUS22",		'C',	STATUS_SIZE,		0},
	{ "VALUE23",		'C',	VALUE_SIZE,		0},
	{ "STATUS23",		'C',	STATUS_SIZE,		0},
	{ "VALUE24",		'C',	VALUE_SIZE,		0},
	{ "STATUS24",		'C',	STATUS_SIZE,		0},
	{ "VALUE25",		'C',	VALUE_SIZE,		0},
	{ "STATUS25",		'C',	STATUS_SIZE,		0},
	{ "VALUE26",		'C',	VALUE_SIZE,		0},
	{ "STATUS26",		'C',	STATUS_SIZE,		0},
	{ "VALUE27",		'C',	VALUE_SIZE,		0},
	{ "STATUS27",		'C',	STATUS_SIZE,		0},
	{ "VALUE28",		'C',	VALUE_SIZE,		0},
	{ "STATUS28",		'C',	STATUS_SIZE,		0},
	{ "VALUE29",		'C',	VALUE_SIZE,		0},
	{ "STATUS29",		'C',	STATUS_SIZE,		0},
	{ "VALUE30",		'C',	VALUE_SIZE,		0},
	{ "STATUS30",		'C',	STATUS_SIZE,		0},
	{ "VALUE31",		'C',	VALUE_SIZE,		0},
	{ "STATUS31",		'C',	STATUS_SIZE,		0},
	{ "VALUE32",		'C',	VALUE_SIZE,		0},
	{ "STATUS32",		'C',	STATUS_SIZE,		0},
	{ "VALUE33",		'C',	VALUE_SIZE,		0},
	{ "STATUS33",		'C',	STATUS_SIZE,		0},
	{ "VALUE34",		'C',	VALUE_SIZE,		0},
	{ "STATUS34",		'C',	STATUS_SIZE,		0},
	{ "VALUE35",		'C',	VALUE_SIZE,		0},
	{ "STATUS35",		'C',	STATUS_SIZE,		0},
	{ "VALUE36",		'C',	VALUE_SIZE,		0},
	{ "STATUS36",		'C',	STATUS_SIZE,		0},
	{ "VALUE37",		'C',	VALUE_SIZE,		0},
	{ "STATUS37",		'C',	STATUS_SIZE,		0},
	{ "VALUE38",		'C',	VALUE_SIZE,		0},
	{ "STATUS38",		'C',	STATUS_SIZE,		0},
	{ "VALUE39",		'C',	VALUE_SIZE,		0},
	{ "STATUS39",		'C',	STATUS_SIZE,		0},
	{ "VALUE40",		'C',	VALUE_SIZE,		0},
	{ "STATUS40",		'C',	STATUS_SIZE,		0},
	{ "VALUE41",		'C',	VALUE_SIZE,		0},
	{ "STATUS41",		'C',	STATUS_SIZE,		0},
	{ "VALUE42",		'C',	VALUE_SIZE,		0},
	{ "STATUS42",		'C',	STATUS_SIZE,		0},
	{ "VALUE43",		'C',	VALUE_SIZE,		0},
	{ "STATUS43",		'C',	STATUS_SIZE,		0},
	{ "VALUE44",		'C',	VALUE_SIZE,		0},
	{ "STATUS44",		'C',	STATUS_SIZE,		0},
	{ "VALUE45",		'C',	VALUE_SIZE,		0},
	{ "STATUS45",		'C',	STATUS_SIZE,		0},
	{ "VALUE46",		'C',	VALUE_SIZE,		0},
	{ "STATUS46",		'C',	STATUS_SIZE,		0},
	{ "VALUE47",		'C',	VALUE_SIZE,		0},
	{ "STATUS47",		'C',	STATUS_SIZE,		0},
	{ "VALUE48",		'C',	VALUE_SIZE,		0},
	{ "STATUS48",		'C',	STATUS_SIZE,		0},
	{ "VALUE49",		'C',	VALUE_SIZE,		0},
	{ "STATUS49",		'C',	STATUS_SIZE,		0},
	{ "VALUE50",		'C',	VALUE_SIZE,		0},
	{ "STATUS50",		'C',	STATUS_SIZE,		0},
	{ "VALUE51",		'C',	VALUE_SIZE,		0},
	{ "STATUS51",		'C',	STATUS_SIZE,		0},
	{ "VALUE52",		'C',	VALUE_SIZE,		0},
	{ "STATUS52",		'C',	STATUS_SIZE,		0},
	{ "VALUE53",		'C',	VALUE_SIZE,		0},
	{ "STATUS53",		'C',	STATUS_SIZE,		0},
	{ "VALUE54",		'C',	VALUE_SIZE,		0},
	{ "STATUS54",		'C',	STATUS_SIZE,		0},
	{ "VALUE55",		'C',	VALUE_SIZE,		0},
	{ "STATUS55",		'C',	STATUS_SIZE,		0},
	{ "VALUE56",		'C',	VALUE_SIZE,		0},
	{ "STATUS56",		'C',	STATUS_SIZE,		0},
	{ "VALUE57",		'C',	VALUE_SIZE,		0},
	{ "STATUS57",		'C',	STATUS_SIZE,		0},
	{ "VALUE58",		'C',	VALUE_SIZE,		0},
	{ "STATUS58",		'C',	STATUS_SIZE,		0},
	{ "VALUE59",		'C',	VALUE_SIZE,		0},
	{ "STATUS59",		'C',	STATUS_SIZE,		0},
	{ "VALUE60",		'C',	VALUE_SIZE,      	0},
	{ "STATUS60",		'C',	STATUS_SIZE,		0},
	{0, 0, 0, 0}		/* NULL-record terminator */
};

TAG4INFO	snapTags [] =	{
	{ "METH_RATE",	"STR(YEAR,4,0)+STR(DAYOFYEAR,3,0)+STR(HOUR,2,0)+STR(OFFSET_MIN,2,0)+POINTNAME+RED_METHOD+RATE+STR(RECNO(),8,0)", 0, 0, 0},
	{ "METHOD_REC",	"POINTNAME+RED_METHOD+STR(YEAR,4,0)+STR(DAYOFYEAR,3,0)+STR(HOUR,2,0)+STR(OFFSET_MIN,2,0)+STR(RECNO(),8,0)", 0, 0, 0},
	{0, 0, 0, 0, 0}		/* NULL-record terminator */
};


char ar_path [132] =
#ifdef WIN32
    {'\\','t','i','s','4','0','0','0','d','b','\\',0};
#else
    {'/','t','i','s','4','0','0','0','d','b','/',0};
#endif WIN32
char *defDirList[] = {ar_path, 0};

char ar_file[132] =
    {'a','r','_','s','n','a','p',0};
char *defFileList[] = {ar_file, 0};

XBaseDesc *trendDesc;
SnapRec	trendRec;
XBaseDesc *archDesc;
SnapRec	archRec;

/* Get default file strings */
void GetDefaultFile (char **path, char **file)
{
    *path = ar_path;
    *file = ar_file;
}

/* Force default file to something other than ar_snap */
void SetDefaultFile (char *path, char *file)
{
    strncpy (ar_path, path, sizeof(ar_path));
    strncpy (ar_file, file, sizeof(ar_file));
}

/* resolveLink - resolveLinks but returns the char pointer */
static char *resolveLink (char *filename)
{
    static char resolved [132];

    resolveLinks (filename, resolved);
    return resolved;
}

/* trimblanks - trim trailing blanks function */
static void trimblanks (char *text, int len)
{
    int last;

    if (len > (int)strlen(text)-1);
	len = strlen(text)-1;
    for (last = len; (last >= 0) && (text[last] == ' '); last--)
	    text [last] = 0;
}

/* padblanks - add trailing blanks function */
static void padblanks (string, len) 
char *string;
int len;
{
    int last;

	/* add trailing blanks */
	for (last = strlen(string); (last < len - 1); last++)
		string[last] = ' ';
	string[last] = 0;
}

/* LoadSnapRec - bring all values into the record */
/* support routine that loads the given variables from the current record */
static void LoadSnapRec (D4DATA *data, SnapRec *rec)
{
    int	ix;
    int field_ix;
    char	tempstring [100];

    f4ncpy (d4field (data, "POINTNAME"), rec->pointname, sizeof(rec->pointname));
    rec->pointname [sizeof(rec->pointname)-1] = 0;
    trimblanks (rec->pointname, sizeof(rec->pointname));

    strncpy (rec->red_method, f4str (d4field (data, "RED_METHOD")), METHOD_SIZE);
    rec->red_method[METHOD_SIZE] = 0;
    f4ncpy (d4field (data, "YEAR"), tempstring, 80);
    strcpy (&tempstring [4], "0101");
    rec->rec_time = a4long (tempstring);
    rec->rec_time += f4int (d4field (data, "DAYOFYEAR"));
    rec->rec_time = (rec->rec_time - C_EPOCHSTART) * C_SECSPERDAY;
    rec->rec_time += f4int (d4field (data, "HOUR")) * 3600L;
    rec->rec_time += f4int (d4field (data, "OFFSET_MIN")) * 60L;
    f4ncpy (d4field (data, "RATE"), tempstring, 10);
    if (!(f4len (d4field (data, "RATE")) != 2))
	rec->rate = (int)(atof (tempstring) * 60.);
    else
	rec->rate = (int)(atof (tempstring));
    rec->sample_cnt = f4int (d4field (data, "SAMPLE_CNT"));
    f4ncpy (d4field (data, "EGUTAG"), rec->egutag, sizeof(rec->egutag));
    rec->disp_low = f4double (d4field (data, "DISP_LOW"));
    rec->disp_high = f4double (d4field (data, "DISP_HIGH"));
    field_ix = d4fieldNumber (data, "VALUE1");
    for (ix = 0; ix < rec->sample_cnt; ix++)
    {
	f4ncpy (d4fieldJ (data, field_ix++), tempstring, 10);
	rec->value[ix] = atof (tempstring);

	strncpy (rec->status[ix], f4ptr (d4fieldJ (data, field_ix++)), sizeof(rec->status [ix]));
	rec->status[ix][3] = 0; /* terminate the status string */
    }
}

CreateParams defCreateParams  = { 10, 10, 1, defDirList };

/* Open xBase */
int OpenXBase ( void )
{
    if (cbInit)
	return (trendDesc->xbaseFile->data != NULL);

    /* open codebase */
    d4init (&cb);
    cb.errOpen = 0;
    cb.errGo = 0;
    cb.readLock = 0;
    cb.safety = 1;  /* will not create new database */

    cbInit = 1;

    /* open the archive data catalog */
    catOpen (YES_CREATE, "xBaseSnapLib");

    /* open trending dataBase */
    trendDesc = MakeSnapDesc (NULL, NULL);
    if (trendDesc)
    {
	return (trendDesc->xbaseFile != NULL);
    }
    cbInit = 0;
    return FALSE;
}

/* create a descriptor object to access data */
XBaseDesc *MakeSnapDesc ( char *pathname, char *filename )
{
    XBaseDesc *newdesc;
    char    openName[132];
    int i, j;
    XBaseData *newdata = NULL;
    char *openpathname;
    char *openfilename;

    if (pathname)
	openpathname = pathname;
    else
	openpathname = defDirList[0];
    if (filename)
	openfilename = filename;
    else
	openfilename = defFileList[0];

    for (i = 0; i < MAX_OPEN_XBASE * 2; i++)
	if (openDesc[i] == NULL)
	    break;
    if (i == MAX_OPEN_XBASE * 2)
	return NULL;

    /* search for opened file */
    for (j = 0; j < MAX_OPEN_XBASE; j++)
    {
	if ((openFile[j].ref == 0) && (newdata == NULL))
	{
	    newdata = &openFile[j];
	    strncpy (newdata->pathName, openpathname, AVM_MOUNTPNT_SIZE);
	    strncpy (newdata->fileName, openfilename, AVM_TABLENAME_SIZE);
	}
	else if ((strcmp (openFile[j].pathName, openpathname) == 0)
	  && (strcmp (openFile[j].fileName, openfilename) == 0))
	{
	    newdata = &openFile[j];
	    break;
	}
    }
    if ((j == MAX_OPEN_XBASE) && (newdata == NULL))
	return NULL;

    openDesc[i] = newdesc = calloc (1, sizeof(XBaseDesc));
    openDesc[i]->xbaseFile = newdata;
    if (newdata->data == NULL)
    {
	newdata->cb = &cb;
	strcpy (openName, newdata->pathName);
	strcat (openName, newdata->fileName);
	newdata->data = d4open (&cb, resolveLink (openName));
    }
    newdata->ref++;
    
    return newdesc;
}

int FreeSnapDesc (XBaseDesc *desc)
{
    int i;

    for (i = 0; i < MAX_OPEN_XBASE; i++)
	if (openDesc[i] == desc)
	    break;
    if (i == MAX_OPEN_XBASE)
	return FALSE;

    if (openDesc[i]->xbaseFile)
    {
	if (openDesc[i]->xbaseFile->ref == 1)
	{
	    if (openDesc[i]->xbaseFile->data)
		d4close (openDesc[i]->xbaseFile->data);
	    openDesc[i]->xbaseFile->data = NULL;
	    openDesc[i]->xbaseFile->ref = 0;
	}
	else
	    openDesc[i]->xbaseFile->ref--;
    }

    free (openDesc[i]);
    openDesc[i] = NULL;
    return TRUE;
}

int CloseXBase (void)
{
    int	i;

    if (cbInit == 0)
	return FALSE;

    /* close the archive data catalog */
    catClose ();

    /* close any open data access */
    for (i = 0; i < MAX_OPEN_XBASE; i++)
    {
	if (openDesc [i])
	{
	    if (openDesc[i]->xbaseFile->data)
		d4close (openDesc[i]->xbaseFile->data);
	    if (openDesc[i]->xbaseFile->notes)
		d4close (openDesc[i]->xbaseFile->notes);
	    free (openDesc[i]);
	    openDesc[i] = NULL;
	}
    }
    return (TRUE);
}

/* drop the standard archive synonym (causes new archive),
** Set diskLable to "Unlabeled" in catalog! */
int DropArchiveSynonym (void)
{
    time_t	lastTime;
    time_t archive_start;
    time_t archive_end;
    char table_name [AVM_TABLENAME_SIZE];
    char disk_name [AVM_DISKLABEL_SIZE];

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

    /* find archive with blank disk lable, update with "Unlabeled" */
    if ((lastTime = catGetLatestEndDate()) != 0)
    {
	if (catGetEntry (lastTime- 1,	/* time guaranteed to be in last entry */
	 	 &archive_start, &archive_end, table_name, disk_name, NULL, NULL))
	{
	    if (strlen (disk_name) == 0)
		strcpy (disk_name, "Unlabeled");
	    catUpdateEntry (archive_start, archive_end, table_name, disk_name, NULL, 1);
	    return TRUE;
	}
	else
	{
	    /* no entry exists. */
	    return FALSE;
	}
    }
    else
    {
	/* no entries in catalog */
	return FALSE;
    }
}

/* update the archive data catalog entry end time for the standard archive synonym */
int UpdateArchiveCatalog (void)
{
    time_t  lastTime;
    time_t  archive_start;
    time_t  archive_end;
    char    table_name [AVM_TABLENAME_SIZE];
    char    disk_name [AVM_DISKLABEL_SIZE];
    char    path_name [AVM_MOUNTPNT_SIZE];
    char    online;
    int	    curDay;
    int	    d4stat;

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

    /* find archive with blank disk lable, update with "Unlabeled" */
    if ((lastTime = catGetLatestEndDate()) != 0)
    {
	if (catGetEntry (lastTime - 1,	/* time guaranteed to be in last entry */
	 	 &archive_start, &archive_end, table_name, disk_name, path_name, &online))
	{
	    if (online && (strlen (disk_name) == 0))
	    {
		/* This is the archive entry. open the xbase file. */
		if ((archDesc == NULL)
		  || (strcmp (archDesc->xbaseFile->fileName, table_name)
		      || strcmp (archDesc->xbaseFile->pathName, path_name)))
		{
		    if (archDesc)
			FreeSnapDesc (archDesc); /* close current descriptor! */
		    archDesc = MakeSnapDesc (path_name, table_name);
		}
		if (archDesc->xbaseFile->data == 0)
		{
		    FreeSnapDesc (archDesc); /* close current descriptor! */
		    archDesc = NULL;
	   	    return FALSE;
		}
		    	
		/* determine maximum time value for this archive */
		d4bottom (archDesc->xbaseFile->data);
		LoadSnapRec (archDesc->xbaseFile->data, &archRec);
		archive_end = archRec.rec_time + (archRec.sample_cnt * archRec.rate);
		curDay = f4int (d4field (archDesc->xbaseFile->data, "DAYOFYEAR"));
		d4stat = d4skip (archDesc->xbaseFile->data, -1);
		while (d4stat && (curDay == f4int (d4field (archDesc->xbaseFile->data, "DAYOFYEAR"))))
		{
		    LoadSnapRec (archDesc->xbaseFile->data, &archRec);
		    if (archive_end < archRec.rec_time + (archRec.sample_cnt * archRec.rate))
			archive_end = archRec.rec_time + (archRec.sample_cnt * archRec.rate);
    		    d4stat = d4skip (archDesc->xbaseFile->data, -1);
		}
		/* and update catalog entry */
		catUpdateEntry (archive_start, archive_end, table_name, "UNLABELED", NULL, 1);
		return TRUE;
	    }
	    else
	    {
		/* no unnamed archive entry! */
		return FALSE;
	    }
	}
	else
	{
	    /* no entry for specified time */
	    return FALSE;
	}
    }
    else
    {
	/* no catalog entries */
	return FALSE;
    }
}

int OpenSnapTable (XBaseDesc *desc, CreateParams *createVals)
{
    time_t  archive_start;
    time_t  archive_end;
    char    online;
    time_t  lastTime;
    struct tm *tmblock;
    char    table_name [AVM_TABLENAME_SIZE];
    char    disk_name [AVM_DISKLABEL_SIZE];
    char    path_name [AVM_MOUNTPNT_SIZE];
    int	    dirIx;
    long    pct_avail;
#ifdef WIN32
    long    secpercl;
    long    bytpersec;
    long    clfree;
    long    cltotal;
#else
    int	    st;
#ifdef SOLARIS
    struct statvfs fsbuff;
#else
    struct statfs fsbuff;
#endif SOLARIS
#endif WIN32

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

    if (strcmp (desc->xbaseFile->pathName, "TISARCHIVE") == 0)
    {
	/* find archive with blank disk lable, this is the current archive */
	if ((lastTime = catGetLatestEndDate()) != 0)
	{
	    if (catGetEntry (lastTime - 1,	/* time guaranteed to be in last entry */
	 	     &archive_start, &archive_end, table_name, disk_name, path_name, &online))
	    {
		if (online && (strlen (disk_name) == 0))
		{
		    /* update descriptor to match current archive */
		    if (archDesc)
			FreeSnapDesc (archDesc);
		    archDesc = MakeSnapDesc (path_name, table_name);
		    if (archDesc == NULL)
		    {
			return FALSE;
		    }
		}
	    }
	}
	/* if archive not open yet, make a new one */
	if (desc->xbaseFile->data == 0)
	{
	    /* if not allowed to create, return */
	    if (createVals == 0)
		return FALSE;
	    /* no current archive, create new archive */
	    /* create name from start time (eldest value in trend_data, or end of catalog file data) */
	    archive_start = catGetLatestEndDate ();
	    if (archive_start == 0)
	    {
		if (GetSnapRecord (trendDesc, "!", "   ", 0, &trendRec))
		{
		    archive_start = trendRec.rec_time;
		}
	    }
	    tmblock = gmtime(&archive_start);
	    sprintf (table_name, "%3.3d%4.4d",
			     tmblock->tm_yday+1,
			     tmblock->tm_year+1900);
	    /* find directory with sufficient space */
	    for (dirIx = 0; dirIx < createVals->numDirectories; dirIx++)
	    {
#ifdef WIN32
		/* for windows, just take the first guy that's big enough */
		if (GetDiskFreeSpace (createVals->dirList[dirIx],
					&secpercl, &bytpersec, &clfree, &cltotal))
		{
		    pct_avail = (clfree - (((createVals->targetSize*1024*1024)/bytpersec)/secpercl))
				    / cltotal;
		}
		else
		{
		    /* can't find a place for the data */
		    exit (-1);
		}
#else
#ifdef SOLARIS
		st = statvfs (createVals->dirList[dirIx], &fsbuff);
#else
		st = statfs (createVals->dirList[dirIx], &fsbuff);
#endif SOLARIS
		if(st < 0)
		{
		    /* can't find a place for the data */
		    exit (-1);
		}
		/* If (available blocks - blocks used by new file) / total blocks */
		pct_avail = ((fsbuff.f_bavail - ((createVals->targetSize*1024*1024)
			    /fsbuff.f_frsize)) * 100)
			     / fsbuff.f_blocks;
		if (fsbuff.f_bavail <= ((createVals->targetSize*1024*1024)/fsbuff.f_frsize))
		    pct_avail = 0;
#endif WIN32
		if (pct_avail > createVals->diskSpace) /* compared to target */
		{
		    /* we have a big enough directory */
		    break;
		}
	    }
	    if (dirIx == createVals->numDirectories)
	    {
		/* Can't create, no space left */
		return FALSE;
	    }
	    desc = MakeSnapDesc (createVals->dirList[dirIx], table_name);
	    if (CreateArchTable (desc, createVals->targetSize, table_name))
	    {
		/* establish catalog entry  with no label*/
		catAddEntry (archive_start, archive_start, table_name, "", createVals->dirList[dirIx], 1);
		return TRUE;
	    }
	    else
		return FALSE;
	}
    }
    else
    {
	if (desc->xbaseFile->data != 0)
	    return  TRUE;
	if (createVals == 0)
	    return FALSE;
	return (CreateSnapTable (desc));
    }
}

int CreateArchTable (XBaseDesc *desc, int size, char *path)
{
    return CreateSnapTable (desc);
}

int CreateTablespace (XBaseDesc *desc, int size, char *path)
{
    return FALSE;
}

int CreateSnapTable (XBaseDesc *desc)
{
    char    openName[132];

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

    /* Create the xBase data file */
    strcpy (openName, desc->xbaseFile->pathName);
    strcat (openName, desc->xbaseFile->fileName);
    desc->xbaseFile->data = d4create (&cb, openName, snapFields, snapTags);
    if (desc->xbaseFile->data == NULL)
    {
	return FALSE;
    }
    return TRUE;
}

static char table_list [512];
static XBaseDesc *pointSetDesc;
static time_t archiveSetEnd;

static time_t lastCatCheck;
static time_t catStart;
static time_t catEnd;

/* open a cursor in the xBase db, and fetch first item.
** closes old cursor if open. */
int StartPointSet (char *pointname, char *dbred, time_t when, time_t end, SnapRec *rec)
{
    char    *seekpt;
    struct tm *tmblock;
    int	    d4stat;
    time_t  archive_start;
    char    table_name [AVM_TABLENAME_SIZE];
    char    path_name [AVM_MOUNTPNT_SIZE];
    char    online;
    int	    catStatus = FALSE;

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

    /* close old pointSet if open */
    if (pointSetDesc)
    {
	FreeSnapDesc (pointSetDesc);
	pointSetDesc = 0;
    }

    table_list[0] = 0;

    /* determine which db holds the starting time, or the earliest data */
    if (lastCatCheck == 0 || (lastCatCheck + 3600) < time(0))
    {
	lastCatCheck = time(0);
	catStart = catGetEarliestStartDate ();
	catEnd = catGetLatestEndDate ();
    }
    archive_start = catStart;
    if (archive_start > when)
	when = archive_start;
    while ((when < catEnd)
	&& (catStatus = catGetEntry (when, &archive_start, &archiveSetEnd,
					 table_name, NULL, path_name, &online))
	&& online == FALSE)
    {
	if (!online)
	{
	   /* if the db is not mounted, add table name to mount list */
	    if (strlen(table_list))
		strncat(table_list, "\n", sizeof(table_list));
	    strncat (table_list, table_name, sizeof (table_list));
	    /* move request forward and try again */
	    when = archiveSetEnd;
	    if (when > end)
		return FALSE;
	}
    }

    if ((catEnd <= when) || (catStatus == FALSE))
    {
	/* look in trend_data for values */
	pointSetDesc = MakeSnapDesc (NULL, NULL);
    }
    else
    {
	pointSetDesc = MakeSnapDesc (path_name, table_name);
    }
    /* remember query parameters */
    strncpy (pointSetDesc->rec_pointname, pointname, sizeof(pointSetDesc->rec_pointname));
    strncpy (pointSetDesc->rec_dbred, dbred, 4);
    pointSetDesc->rec_time = when;
    if (pointSetDesc->xbaseFile->data == 0)
    {
	FreeSnapDesc (pointSetDesc);
	pointSetDesc = NULL;
   	return FALSE;
    }

    d4tagSelect (pointSetDesc->xbaseFile->data, d4tag (pointSetDesc->xbaseFile->data, "METHOD_REC"));

    /* seek for point */
    seekpt = malloc (f4len (d4field (pointSetDesc->xbaseFile->data, "POINTNAME"))+3+4+3+2+2+1); 
    strncpy (seekpt, pointSetDesc->rec_pointname, sizeof(pointSetDesc->rec_pointname));
    padblanks (seekpt, f4len (d4field (pointSetDesc->xbaseFile->data, "POINTNAME"))+1);
    sprintf (&seekpt [strlen(seekpt)], "%3s", pointSetDesc->rec_dbred);
    if (when != 0)
    {
	tmblock = gmtime ((time_t *)&when);
	sprintf (&seekpt [strlen(seekpt)], "%4d%3d%2d%2d",
			 tmblock->tm_year+1900, tmblock->tm_yday, tmblock->tm_hour, tmblock->tm_min);
    }
    d4tagSelect (pointSetDesc->xbaseFile->data, d4tag (pointSetDesc->xbaseFile->data, "METHOD_REC"));
    d4stat = d4seek (pointSetDesc->xbaseFile->data, seekpt);

    /* check for our time in previous record */
    if (((d4stat == r4after) || (d4stat == r4eof)) && (when != 0))
    {
	int tempstat = d4skip (pointSetDesc->xbaseFile->data, -1L);
	if (tempstat == 0)
	{
	    LoadSnapRec (pointSetDesc->xbaseFile->data, rec);
	    d4stat = tempstat;
	    if (strcmp (rec->pointname, pointSetDesc->rec_pointname)
	      || (strcmp (rec->red_method, pointSetDesc->rec_dbred) || (rec->sample_cnt < 0)
	 	|| ((rec->rec_time + rec->rate * (rec->sample_cnt+1)) <= when)))
	    {
		/* nothing better in back of us, handle discontinuity in data */
		d4stat = d4skip (pointSetDesc->xbaseFile->data, 1L);
	    }
	    else if (pointSetDesc->lastpointtime <= rec->rec_time + rec->rate * rec->sample_cnt) /* remember last time recorded */
	    {
		pointSetDesc->lastpointtime = rec->rec_time + rec->rate * rec->sample_cnt;
	    }
	}
	else
	{
	    d4stat = d4seek (pointSetDesc->xbaseFile->data, seekpt);
	}
    }
    free (seekpt);

    /* Verify and unpack data for record */
    if ((d4stat == 0) || (d4stat == r4after))
    {
	LoadSnapRec (pointSetDesc->xbaseFile->data, rec);
	if (strcmp (rec->pointname, pointSetDesc->rec_pointname)
	  || strcmp(rec->red_method, pointSetDesc->rec_dbred)
	  || (rec->sample_cnt < 0))
	{
		d4unlock_all (pointSetDesc->xbaseFile->data);
		/* mark time for no valid data */
		rec->rec_time = 0x7fffffff;
        	return (FALSE);	/* No data in record! */
	}
	d4unlock_all (pointSetDesc->xbaseFile->data);
	/* if no records in this archive, look in next archive, or finally TREND_DATA */
	return NextPointSet (rec, end);
    }
    else
	return FALSE;
}

/* get the next record from the cursor */
int NextPointSet (SnapRec *rec, time_t end)
{
    char    *seekpt;
    int	    d4stat;
    time_t  archive_start;
    time_t  when;
    char    table_name [AVM_TABLENAME_SIZE];
    char    path_name [AVM_MOUNTPNT_SIZE];
    char    online;
    int	    catStatus;
    XBaseDesc *newDesc;

    /* if fetch for current cursor fails, determine db for next data set */
    if (NextSnapRecord (pointSetDesc, rec))
    {
	return TRUE;
    }
    else
    {
	return FALSE;
	while (strcmp (pointSetDesc->xbaseFile->fileName, "ar_snap") != 0)
	{
	    /* determine which db holds the starting time, or the earliest data */
	    when = archiveSetEnd;
	    while ((when < catEnd)
		&& (catStatus = catGetEntry (when, &archive_start, &archiveSetEnd,
				 table_name, NULL, path_name, &online))
		&& online == FALSE)
	    {
		if (!online)
		{
		   /* if the db is not mounted, add table name to mount list */
		    if (strlen(table_list))
			strncat(table_list, "\n", sizeof (table_list));
		    strncat (table_list, table_name, sizeof (table_list));
		    /* move request forward and try again */
		    if (archiveSetEnd > end)
			return FALSE;
		}
		when = archiveSetEnd;
	    }

	    if ((catEnd <= when) || (catStatus == FALSE))
	    {
		/* look in trend_data for values */
		newDesc = MakeSnapDesc (NULL, NULL);
	    }
	    else
	    {
		newDesc = MakeSnapDesc (path_name, table_name);
	    }
	    /* remember query parameters */
	    strncpy (newDesc->rec_pointname, pointSetDesc->rec_pointname, sizeof(newDesc->rec_pointname));
	    strncpy (newDesc->rec_dbred, pointSetDesc->rec_dbred, 4);
	    newDesc->rec_time = pointSetDesc->rec_time;
	    FreeSnapDesc (pointSetDesc);
	    pointSetDesc = newDesc;
	    if (pointSetDesc->xbaseFile->data == 0)
	    {
		FreeSnapDesc (pointSetDesc);
		pointSetDesc = NULL;
   		return FALSE;
	    }

	    d4tagSelect (pointSetDesc->xbaseFile->data, d4tag (pointSetDesc->xbaseFile->data, "METHOD_REC"));

	    /* blank fill */
	    seekpt = malloc (f4len (d4field (pointSetDesc->xbaseFile->data, "POINTNAME"))+3+1); 
	    strncpy (seekpt, pointSetDesc->rec_pointname, sizeof(pointSetDesc->rec_pointname));
	    padblanks (seekpt, f4len (d4field (pointSetDesc->xbaseFile->data, "POINTNAME"))+1);
	    sprintf (&seekpt [strlen(seekpt)], "%3s", pointSetDesc->rec_dbred);
	    d4tagSelect (pointSetDesc->xbaseFile->data, d4tag (pointSetDesc->xbaseFile->data, "METHOD_REC"));
	    d4stat = d4seek (pointSetDesc->xbaseFile->data, seekpt);
	    free (seekpt);

	    /* Verify and unpack data for record */
	    if ((d4stat == 0) || (d4stat == r4after))
	    {
		LoadSnapRec (pointSetDesc->xbaseFile->data, rec);;
		if (strcmp (rec->pointname, pointSetDesc->rec_pointname)
		  || strcmp (rec->red_method, pointSetDesc->rec_dbred)
		  || (rec->sample_cnt < 0))
		{
		    d4unlock_all (pointSetDesc->xbaseFile->data);
		    /* mark time for no valid data */
		    rec->rec_time = 0x7fffffff;
        	    continue;	/* No data in record! */
		}
		d4unlock_all (pointSetDesc->xbaseFile->data);
		/* if no records in this archive, look in next archive, or finally TREND_DATA */
		return NextPointSet (rec, end);
	    }
	    else
		continue;
	    /* fetch to acquire data, continue search if not found */
	    if (NextSnapRecord (pointSetDesc, rec))
		return TRUE;
	}
    }
    return FALSE;
}

/* close the cursor */
int EndPointSet ( )
{
    /* close the cursor */
    if (pointSetDesc)
	FreeSnapDesc (pointSetDesc);
    pointSetDesc = NULL;

    return TRUE;
}

char *GetOfflineTables ( )
{
    if (strlen (table_list))
	return table_list;
    else
	return NULL;
}

int GetSnapRecord (XBaseDesc *dataDesc, char *pointname, char *dbred, time_t when, SnapRec *rec)
{
    char    *seekpt;
    struct tm *tmblock;
    int	    d4stat;

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

    strncpy (dataDesc->rec_pointname, pointname, 30);
    strncpy (dataDesc->rec_dbred, dbred, 4);
    dataDesc->rec_time = when;

    d4tagSelect (dataDesc->xbaseFile->data, d4tag (dataDesc->xbaseFile->data, "METHOD_REC"));

    /* blank fill */
    seekpt = malloc (f4len (d4field (dataDesc->xbaseFile->data, "POINTNAME"))+3+4+3+2+2+1); 
    strncpy (seekpt, dataDesc->rec_pointname, sizeof(dataDesc->rec_pointname));
    padblanks (seekpt, f4len (d4field (dataDesc->xbaseFile->data, "POINTNAME"))+1);
    sprintf (&seekpt [strlen(seekpt)], "%3s", dataDesc->rec_dbred);
    if (when != 0)
    {
	tmblock = gmtime ((time_t *)&when);
	sprintf (&seekpt [strlen(seekpt)], "%4d%3d%2d%2d",
			 tmblock->tm_year+1900, tmblock->tm_yday, tmblock->tm_hour, tmblock->tm_min);
    }
    d4tagSelect (dataDesc->xbaseFile->data, d4tag (dataDesc->xbaseFile->data, "METHOD_REC"));
    d4stat = d4seek (dataDesc->xbaseFile->data, seekpt);

    /* check for our time in previous record */
    if (((d4stat == 0) || (d4stat == r4after) || (d4stat == r4eof)) && (when != 0))
    {
	int tempstat = d4skip (dataDesc->xbaseFile->data, -1L);
	if (tempstat == 0)
	{
	    LoadSnapRec (dataDesc->xbaseFile->data, rec);;
	    if ((d4stat == r4after) || (d4stat == r4eof)) /* remember last time recorded */
	    {
		dataDesc->lastpointtime = rec->rec_time + rec->rate * rec->sample_cnt;
	    }
	    if (strcmp (rec->pointname, dataDesc->rec_pointname)
	      || (strcmp (rec->red_method, pointSetDesc->rec_dbred) || (rec->sample_cnt < 0)
	 	|| ((rec->rec_time + rec->rate * (rec->sample_cnt+1)) <= when)))
	    {
		/* nothing better in back of us, handle discontinuity in data */
		d4stat = d4skip (dataDesc->xbaseFile->data, 1L);
	    }
	    d4stat = tempstat;
	}
	else
	{
		d4stat = d4seek (dataDesc->xbaseFile->data, seekpt);
	}
    }
    free (seekpt);

    /* Verify and unpack data for record */
    if ((d4stat == 0) || (d4stat == r4after))
    {
	LoadSnapRec (dataDesc->xbaseFile->data, rec);;
	if (strcmp (rec->pointname, dataDesc->rec_pointname)
	  || strcmp (rec->red_method, pointSetDesc->rec_dbred)
	  || (rec->sample_cnt < 0))
	{
		d4unlock_all (dataDesc->xbaseFile->data);
		/* mark time for no valid data */
		dataDesc->rec_time = 0x7fffffff;
        	return (FALSE);	/* No data in record! */
	}
	d4unlock_all (dataDesc->xbaseFile->data);
	/* if no records in this archive, look in next archive, or finally TREND_DATA */
	return NextSnapRecord (dataDesc, rec);
    }
    else
	return FALSE;
}

int NextSnapRecord (XBaseDesc *dataDesc, SnapRec *rec)
{
    int	    d4stat;

    /* if desc is marked for no data, return false */
    if (dataDesc->rec_time == 0x7fffffff)
	return FALSE;

    /* advance to next item */
    LoadSnapRec (dataDesc->xbaseFile->data, rec);
    d4stat = d4skip (dataDesc->xbaseFile->data, 1L);
    if (d4stat == r4eof)
    {
	/* next record doesn't match, set end of data */
	dataDesc->rec_time = 0x7fffffff;
    }
    else if (strcmp (dataDesc->rec_pointname, rec->pointname)
      || strcmp (dataDesc->rec_dbred, rec->red_method)
      || (rec->sample_cnt < 0))

    {
	/* next record doesn't match, set end of data */
	dataDesc->rec_time = 0x7fffffff;
    }

    return TRUE;
}

int EndSnapRecord ( XBaseDesc *dataDesc )
{
    return TRUE;
}

int GetSnapRecsByTime (XBaseDesc *dataDesc, time_t start, time_t end, SnapRec *rec)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;
    return TRUE;

}

int NextSnapRecByTime (XBaseDesc *dataDesc, SnapRec *rec)
{
    return 0;
}

int EndSnapRecByTime ( XBaseDesc *dataDesc )
{
    return 0;
}

int AddSnapRecord (XBaseDesc *dataDesc, SnapRec *rec)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

int UpdateSnapRecord (XBaseDesc *dataDesc, SnapRec *rec)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

int DeleteSnapRecord (XBaseDesc *dataDesc, SnapRec *rec)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

/* remove records before time from the ar_snap table */
int DeleteSnapRecsByTime (XBaseDesc *dataDesc, time_t start, time_t end)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

/* remove records for given point before time from the ar_snap table */
int DeleteSnapPointRecs (XBaseDesc *dataDesc, char *pointName, char *reduc, time_t when)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

/* transfer records from trend table to archive table */
int ArchiveSnapPoint (XBaseDesc *srcDesc, XBaseDesc *destDesc,
		      char *pointName, char *reduc, time_t end)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

/* Note file support */
/* Notes file structures */
static F4FIELD_INFO notes_field_info[] = /* define database field structure */
{
   /* field name,   type, width, decimals */
   { "POINTNAME",   'C',    28,    0 },
   { "YEAR",	    'N',    4,     0 },
   { "DAYOFYEAR",   'N',    3,     0 },
   { "HOUR",	    'N',    2,     0 },
   { "MINUTE",	    'N',    2,     0 },
   { "SECOND",	    'N',    2,     0 },
   { "NOTE",	    'M',    10,    0 },
   { 0, 0, 0, 0 },
} ;

static T4TAG_INFO notes_tag_info[] = /* define multiple tags */
{
   /* name,	    expression,	filter, unique,	     descending */
   { "MEMO_REC", "POINTNAME+STR(YEAR,4)+STR(DAYOFYEAR,3)+STR(HOUR,2)+STR(MINUTE,2)+STR(SECOND,2)",	"", 0, 0 },
   { 0,  0,  0, 0, 0 },
};

/* All notes references are based on time */

XBaseDesc *noteDesc;

int OpenSnapNotesTableByTime (time_t noteTime, int createIt)
{
    time_t  archive_start;
    time_t  archive_end;
    char    online;
    char    table_name [AVM_TABLENAME_SIZE];
    char    path_name [AVM_MOUNTPNT_SIZE];
    int	    catStatus;
    char    openName[132];

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

    /* Determine archive table, check if current noteDesc matches */
    if (lastCatCheck == 0 || (lastCatCheck + 3600) < time(0))
    {
	lastCatCheck = time(0);
	catStart = catGetEarliestStartDate ();
	catEnd = catGetLatestEndDate ();
    }
    if (noteTime > catEnd)
    {
	/* note belongs in ar_snapn */
	strcpy (path_name, defDirList[0]);
	strcpy (table_name, defFileList[0]);
    }
    else if (catStatus = catGetEntry (noteTime, &archive_start, &archive_end,
				 table_name, NULL, path_name, &online)
      && online)
    {
	/* note belongs in archive DB */
    }
    else
    {
	/* table is offline or not in this world, nothing can be done */
	return FALSE;
    }
    if ((noteDesc == NULL) || strcmp(noteDesc->xbaseFile->pathName, path_name)
	|| strcmp(noteDesc->xbaseFile->fileName, table_name))
    {
	/* may need to close descriptor */
	if (noteDesc)
	{
	    FreeSnapDesc (noteDesc);
	    noteDesc = NULL;
	}
	/* open a new one */
	noteDesc = MakeSnapDesc (path_name, table_name);
	if (noteDesc == NULL)
	    return FALSE;
    }

    /* open notes file */
    strcpy (openName, noteDesc->xbaseFile->pathName);
    strcat (openName, noteDesc->xbaseFile->fileName);
    strcat (openName, "n");
    if ((noteDesc->xbaseFile->notes == 0))
    {
	noteDesc->xbaseFile->notes = d4open (&cb, resolveLink (openName));
    }

    if ((noteDesc->xbaseFile->notes == 0))
    {
	if (createIt
	  && (noteDesc->xbaseFile->notes
		= d4create (&cb, resolveLink(openName), notes_field_info, notes_tag_info)))
	{
	    return TRUE;
	}
	else
	{
	    FreeSnapDesc (noteDesc);
	    noteDesc = NULL;
	    return FALSE;
	}
    }
    else
	return TRUE;
}

int CloseSnapNotesTable ()
{
    if (noteDesc)
    {
	FreeSnapDesc (noteDesc);
	noteDesc = NULL;
	return TRUE;
    }
    return FALSE;
}

/* static storage for current note pointname */

char currentnotepoint [30];
long currentnotetime;
char currentnote [1024];

int GetSnapNote (XBaseDesc *dataDesc, char *pointname, time_t *when, char **note)
{
    char *seekpt;
    char *sp;
    struct tm *tmblock;
    int  d4stat;
    char notepoint [30];

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;
    /* search for note for pointname and time. */
    if (dataDesc->xbaseFile->notes)
    {
        d4tag_select (dataDesc->xbaseFile->notes, d4tag (dataDesc->xbaseFile->notes, "MEMO_REC"));
        if (pointname[0] == '>')
            strncpy (notepoint, &pointname[1], 28);
        else
            strncpy (notepoint, pointname, 28);
        /* strip reduction type, and blank fill */
        if (sp = strchr (notepoint, '.'))
            *sp = 0;
	strncpy (dataDesc->rec_pointname, notepoint, sizeof (dataDesc->rec_pointname));
	dataDesc->rec_time = *when;
	seekpt = malloc (28+4+3+2+2+2); 
        strcpy (seekpt, notepoint);
        padblanks (seekpt, 29);
        tmblock = gmtime ((time_t *)&dataDesc->rec_time);
        sprintf (&seekpt [28], "%4d%3d%2d%2d%2d",
                                       tmblock->tm_year+1900, tmblock->tm_yday,
                                       tmblock->tm_hour, tmblock->tm_min, tmblock->tm_sec);
        d4stat = d4seek (dataDesc->xbaseFile->notes, seekpt);
        free (seekpt);

        /* if positioned after, but it is still the same pointname, return the note info */
        if ((d4stat == 0) || (d4stat == r4after))
        {
            return NextSnapNote (dataDesc, when, note);
        }
    }
    return FALSE;
}

/* get the next note from the cursor */
int NextSnapNote (XBaseDesc *dataDesc, time_t *when, char **note)
{
    char tempepn [30];
    char tempstring [30];
    time_t rettime;

    if (dataDesc)
    {
        f4ncpy (d4field (dataDesc->xbaseFile->notes, "POINTNAME"), tempepn, 28);
        tempepn [28] = 0;
        if (strncmp (dataDesc->rec_pointname, tempepn, strlen(tempepn)) == 0)
        {
            f4ncpy (d4field (dataDesc->xbaseFile->notes, "YEAR"), tempstring, 80);
            strcpy (&tempstring [4], "0101");
            rettime = a4long (tempstring);
            rettime += f4int (d4field (dataDesc->xbaseFile->notes, "DAYOFYEAR"));
            rettime = (rettime - C_EPOCHSTART) * C_SECSPERDAY;
            rettime += f4int (d4field (dataDesc->xbaseFile->notes, "HOUR")) * 3600L;
            rettime += f4int (d4field (dataDesc->xbaseFile->notes, "MINUTE")) * 60L;
            rettime += f4int (d4field (dataDesc->xbaseFile->notes, "SECOND"));
	    dataDesc->rec_time = rettime;
	    *note = m4ptr (d4field (dataDesc->xbaseFile->notes, "NOTE"));
	    d4skip (dataDesc->xbaseFile->notes, 1);
	    return TRUE;
	}
	else
	{
   	    dataDesc->rec_time = 0x7fffffff;
	    *note = NULL;
	    return FALSE;
	}
    }
    return FALSE;
}

int PrevSnapNote (XBaseDesc *dataDesc, char *pointname, time_t *when, char **note)
{
    return 0;
}

/* close the cursor */
int EndSnapNote (XBaseDesc *dataDesc)
{
    return 0;
}

int GetSnapNoteByTime (XBaseDesc *dataDesc, char **notepoint, time_t start,
		       time_t end, time_t *when, char **note)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

/* get the next note from the cursor */
int NextSnapNoteByTime (XBaseDesc *dataDesc, char **notepoint, time_t *when, char **note)
{
    return 0;
}

/* close the cursor */
int EndSnapNoteByTime (XBaseDesc *dataDesc)
{
    return 0;
}

/* add the ar_snap note from the provided data */
int AddSnapNote (XBaseDesc *dataDesc, char *pointname, time_t when, char *note)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

/* update the ar_snap note from the provided data */
int UpdateSnapNote (XBaseDesc *dataDesc, char *pointname, time_t when, char *note)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

/* remove the note from the ar_snap table */
int DeleteSnapNote (XBaseDesc *dataDesc, char *pointname, time_t when)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

/* remove records before time from the ar_snap table */
int DeleteSnapNoteByTime (XBaseDesc *dataDesc, time_t start, time_t end)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}
/*
 * may be used at later time
static XBaseDesc noteSetDesc;
static time_t noteSetEnd;
*/

int AddSetNote (char *pointname, time_t when, char *text)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

int DeleteSetNote (char *pointname, time_t when)
{

    if (cbInit == 0)
	if (!OpenXBase ())
	    return FALSE;

}

int PrevSetNote (char *pointname, time_t *when, char **note)
{
    return 0;
}

/* open a cursor in the xBase db, and fetch first item.
** closes old cursor if open. */
int StartNoteSet (char *pointname, time_t *when, char **note)
{
    time_t  archive_start;
    char    online;
    char    table_name [AVM_TABLENAME_SIZE];
    char    path_name [AVM_MOUNTPNT_SIZE];
    int	    catStatus;
    time_t  reqwhen = *when;

    CloseSnapNotesTable ();
    while (OpenSnapNotesTableByTime (reqwhen, FALSE)
      && !NextSnapNote (noteDesc, when, note))
    {
	/* stop after looking in ar_snap */
	if (strcmp(noteDesc->xbaseFile->fileName, defFileList[0]) == 0)
	{
	    CloseSnapNotesTable ();
	    *when = 0x7fffffff;
	    *note = NULL;
	    return FALSE;
	}
	/* determine which db holds the starting time, or the earliest data */
	archive_start = catStart;
	if (archive_start > reqwhen)
	    reqwhen = archive_start;
	while ((reqwhen < catEnd)
	    && (catStatus = catGetEntry (reqwhen, &archive_start, &archiveSetEnd,
					     table_name, NULL, path_name, &online))
	    && online == FALSE)
	{
	    /* move request forward and try again */
	    reqwhen = archiveSetEnd;
	}
	*when = reqwhen;
    }
    /* remember query parameters */
    if (noteDesc)
    {
	strncpy (noteDesc->rec_pointname, pointname, sizeof (noteDesc->rec_pointname));
	noteDesc->rec_time = *when;
	return TRUE;
    }
    else
	return FALSE;
}

/* get the next record from the cursor */
int NextNoteSet (time_t *when, char **note)
{
    time_t  archive_start;
    char    online;
    char    table_name [AVM_TABLENAME_SIZE];
    char    path_name [AVM_MOUNTPNT_SIZE];
    int	    catStatus;

    if (noteDesc)
    {
	/* remember time of query (snapnote squashes on failure) */
	time_t reqwhen = *when;
	if (!NextSnapNote (noteDesc, when, note))
	{
	    char reqpointname [30];
	    strncpy (reqpointname, noteDesc->rec_pointname, sizeof(reqpointname));

	    /* determine time in next catalog */
	    while ((reqwhen < catEnd)
		&& (catStatus = catGetEntry (reqwhen, &archive_start, &archiveSetEnd,
						 table_name, NULL, path_name, &online))
		&& online == FALSE)
	    {
		/* move request forward and try again */
		reqwhen = archiveSetEnd;
	    }
	    *when = reqwhen;
	    return StartNoteSet (reqpointname, when, note);
	}
	else
	    return TRUE;
    }
    return FALSE;
}

/* close the cursor */
int EndNoteSet ( )
{
    return CloseSnapNotesTable ();
}

