#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vmenuHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vmenubarHEADER
#include vbuttonHEADER
#include vtextitemHEADER
#include vstartupHEADER
#include vtimeHEADER
#include vmemHEADER
#include vcontrolHEADER
#include vtimerHEADER
extern "C"
{
#include "opNoteDb.h"
#include "OperPriv.h"
#include "msgMon.h"
}
#include "opno.h"
#include "opNoteUtils.hxx"
#include "opNote.hxx"


/*******************************************************************
*
*    Main ()
*
*******************************************************************/

int main (int argc, char **argv)
{
    tisOpenLog ("opNote", 6, 2, NULL, NULL);

    // Initialize Galaxy
    vstartup (argc, argv);

    opNoteApplication *opNoteApp = new opNoteApplication ();

    // if any errors during iniitalization
    if (opNoteApp -> hasInitErrors())
    {
	delete opNoteApp;
	exit (EXIT_FAILURE);
    }

    // load the main dialog
    vresource opNoteRes = opNoteApp -> getOpNoteResource ();
    vresource mainDialogResource = vresourceGet (opNoteRes, opno_mainDialog);
    opNoteMainDialog *mainDialog = new opNoteMainDialog (mainDialogResource);
    if ((mainDialog -> getLoadInitErrors ()) == OPNO_ERROR)
    {
	delete mainDialog;
	delete opNoteApp;
	exit (EXIT_SUCCESS);
    }
    mainDialog -> OpenMain (opNoteApp);

    /* Enter the event loop */
    veventProcess ();

    delete mainDialog;
    delete opNoteApp;

    exit (EXIT_SUCCESS);
    return EXIT_FAILURE;
}


/*******************************************************************
*
*    opNoteApplication constructor
*
*******************************************************************/

opNoteApplication::opNoteApplication (void)
{
    int		result = 0;

    initError = vFALSE;
    dbopened = vFALSE;
    initedTisGalaxy = vFALSE;

    opNoteVApplication = vapplication::GetCurrent ();
    opNoteResource = opNoteVApplication -> GetResources ();

    // intern tag names
    opnoInternNames ();

    messagesResource = vresourceGet (opNoteResource, opno_messagesDictionary);
    titlesResource = vresourceGet (opNoteResource, opno_titlesDictionary);

    // init the database and server if needed, 
    // see opNoteDbClient.c and opNoteDb.c
    if ( (result = openNotefile (OPNOTEDATABASE, vTRUE)) != DBOK)
    {
	if (result == DBSERVERERR)
	{
	    opnoMessageCenter (NULL, OPNO_INFO_NOTICE, opno_ServerOpenErr);
	}
	else
	{
	    vstr *opnoDb = vstrCloneScribed (vcharScribeSystem (OPNOTEDATABASE));
	    opnoMessageCenter (NULL, OPNO_INFO_NOTICE, opno_OpNoteDbOpenErr, opnoDb);
	    vstrDestroy (opnoDb);
	}
	initError = vTRUE;
	return;
    }
    // init tisGalaxy, see tisgalaxylib.<hxx,cxx>
    tisGalaxyResource = startTisGalaxy ();
    initedTisGalaxy = vTRUE;

    dbopened = vTRUE;
    // zero current selected record
    vmemSet ((void *)&currentSelectedRecord, 0, sizeof (OpNoteRecord));
    // zero the current filter
    vmemSet ((void *)&currentFilter, 0, sizeof (Filter));
    // get the user name from .../share/src/libtis/OperPrvTrk.c
    GetOperName (currentOperator);
    currentOperator[OP_SIZE] = 0;
    isSelectedRecord = vFALSE;
}


/*******************************************************************
*
*    opNoteApplication destructor
*
*******************************************************************/

opNoteApplication::~opNoteApplication (void)
{
    // close down tisgalaxy if used
    if (initedTisGalaxy == vTRUE)
    {
	stopTisGalaxy (tisGalaxyResource);
    }
    // close out the database
    if (dbopened == vTRUE)
    {
	RelNotes ();
	CloseNotes ();
	dbopened = vFALSE;
    }
}
