#ifndef opnotedbserver_h
#define opnotedbserver_h

#ifdef __cplusplus
extern "C"
{
#endif __cplusplus
#include "opNoteDb.h"
#ifdef __cplusplus
}
#endif __cplusplus

/* define message types */

enum
{
    OPNOTE_OPENDATABASE = 1,
    OPNOTE_GETNOTE,
    OPNOTE_NEXTNOTE,
    OPNOTE_SAVENOTE,
    OPNOTE_DELETENOTE,
    OPNOTE_GETKEYTYPES,
    OPNOTE_GETKEYVALUES,
    OPNOTE_WRITEKEY,
    OPNOTE_DELETEKEY,
    OPNOTE_DELETEKEYTYPE,
    OPNOTE_RELNOTES,
    OPNOTE_CLOSENOTES
};

/* define messages to server */

typedef struct
{
    short	msgType;
} NoteMsgHeader;

typedef struct
{
    short	msgType;
    short	create;
    char	dbfile[MAX_NOTEPATH + 1];
} OpenDatabaseMsg;

typedef struct
{
    short	msgType;
    short	pad;
    time_t	start;
    time_t	end;
    long	time;
    char	op [OP_SIZE + 1];
    char	keytype [KEY_SIZE + 1];
    char	keyvalue [KEY_SIZE + 1];
    char	search_text [MAX_NOTE + 1];
} FilterMsg;

typedef struct
{
    short	msgType;
    short	pad;
    time_t	time;
    char	op [OP_SIZE + 1];
    char	keytype [KEY_SIZE + 1];
    char	keyvalue [KEY_SIZE + 1];
    char	text [MAX_NOTE + 1];
} OpNoteRecordMsg;

typedef struct
{
    short	msgType;
    short	pad;
    time_t	time;
    char	op [OP_SIZE + 1];
    char	keytype [KEY_SIZE + 1];
    char	keyvalue [KEY_SIZE + 1];
    char	text [MAX_NOTE + 1];
    char	dbfile[MAX_NOTEPATH + 1];
} OpNoteSaveNoteMsg;

typedef struct
{
    short	msgType;
    short	start;
    char	keytype [KEY_SIZE + 1];
} KeyMsg;

typedef struct
{
    short	msgType;
    char	keyType[KEY_SIZE + 1];
    char	keyValue[KEY_SIZE + 1];
    char	errmsg[MAXERRMSG + 1];
} KeyIOMsg;


/* response messages from server */

typedef struct
{
    short	msgType;
    short	value;
} NoteMsgRsp;

typedef struct
{
    short	msgType;
    short	totKeys;
    short	blockKeys;
    char	errmsg[MAXERRMSG + 1];
    char	block[MAXBLOCK_SIZE + 1];
} KeyMsgRsp;

typedef struct
{
    short	msgType;
    short	value;
    char	errmsg[MAXERRMSG + 1];
} KeyIOMsgRsp;

/* unions of msgs */

typedef union
{
    NoteMsgHeader	msgHeader;
    OpenDatabaseMsg	openDatabaseMsg;
    FilterMsg		filterMsg;
    OpNoteRecordMsg	opNoteRecordMsg;
    OpNoteSaveNoteMsg	opNoteSaveNoteMsg;
    KeyMsg		keyMsg;
    KeyIOMsg		keyIOMsg;
} ReqMsgUnion;

typedef union
{
    NoteMsgHeader	msgHeader;
    NoteMsgRsp		noteMsgRsp;
    OpNoteRecordMsg	opNoteRecordMsg;
    KeyMsgRsp		keyMsgRsp;
    KeyIOMsgRsp		keyIOMsgRsp;	
} RespMsgUnion;

#endif opnotedbserver_h

