#ifndef opnoteutilsH
#define opnoteutilsH

#include vcomboboxHEADER

// define returns for date and time errors
// NOTE: these must agree with the opNote.vr file entry
//	arraysDictionary -> dateTimeErrorMsg
enum DateTimeErrors
{
    OPDATE_OK,
    OPYEAR_ERROR,
    OPMONTH_ERROR,
    OPDAY_ERROR,
    OPHOUR_ERROR,
    OPMIN_ERROR,
    OPSEC_ERROR,
    OPSTART_END_DATE_ERROR,
    OPDATE_TIME_ERROR,
    MAX_DATETIME_ERRORS
};

// define the strings for the default values for the key and value menus
#define	KEY_CLASS_DEFAULT	"no class"
#define	KEY_VALUE_DEFAULT	"no value"

// define for server error notice title
#define	SERVER_ERROR		"Server Error"

// define database error notice titles
#define	DATABASE_ERROR		"Database Error"

void	dateTimeErrorNotice (vdialog *dialog, DateTimeErrors msgType);
void	deleteComboBoxList (vcombobox *comboBox);
DateTimeErrors	extractDate (vchar *dateString, struct tm *tim);
DateTimeErrors	extractTime (vchar *timeString, struct tm *tim);
int	opnoMessageCenter (vdialog *dialog, int msgType, const vname *msgName, ...);


// *** opNote CONTROL subclass ********************************************************

class opNoteControl : public vcontrolOptionMenu
{
    vcontrol	*keyValue;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(opNoteControl);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(opNoteControl, vcontrolOptionMenu);

    // override the control notify
    void Notify (vevent *event);

    vcontrol *getKeyValue (void) { return (keyValue); }
    void setKeyValue (vcontrol *key) { keyValue = key; }

    // function to build keyValue menu
    void buildKeyClassMenu (int useDefault);

    // function to build a keyValue Menu
    void buildKeyValueMenu (vchar * pvChar);
};

#endif opnoteutilsH
