/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* Perform a TIS4000 operator logout */

#include <stdio.h>
#include <string.h>
#include <dirent.h>

#include "logutils.h"
#include "msgMon.h"

/*----------*/
main (int argc, char *argv [])

    {

	char	loginFilePath [100], opName [100];
	FILE	*f;
	DIR	*d;
	struct	dirent	*ent;

	tisOpenLog ("tisLogoutAll", 6, 2, NULL, NULL);

	/* Open the logins directory and go through all entries */

	d = opendir ("/tis4000/operators/logins");
	if (d == NULL) {
	    tisSysLog (0,0, "Unable to find /tis4000/operators/logins");
	    exit (-1);
	}

	while (ent = readdir (d)) {

	    /* Skip the non-files */

	    if ((strcmp (ent->d_name, ".") == 0) || (strcmp (ent->d_name, "..") ==0))
		continue;

	    /* Get the name in the log file so that we can log the logout */

	    sprintf (loginFilePath, "/tis4000/operators/logins/%s", ent->d_name);
	    f = fopen (loginFilePath, "r");
	    if (f == NULL)
		return -1;
	    fgets (opName, sizeof (opName), f);
	    opName [strlen (opName) - 1] = '\0';
	    fclose (f);

	    /* If already logged out then just return */

	    if (strcmp (opName, "nooperator") == 0)
		return;

	    /* Log the logout */

	    makeLogEntry (opName, ent->d_name, ALL_LOGOUT);

	    /* Create a new file with "nooperator" as the operator */

	    f = fopen (loginFilePath, "w");
	    fprintf (f, "nooperator\n");
	    fclose (f);

	}

    }
