/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <memory.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <syslog.h>
#include <sys/socket.h>
#include "logutils.h"
#include <avl.h>
#include "operDefs.h"
#include <slmDefs.h>
#include <signal.h>
#include <sys/termios.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/filio.h>
#include <errno.h>
#include <sys/stat.h>

#define STX 0x02
#define ETX 0x03
#define ACK 0x06
#define LF  0x0A
#define CR  0x0D
#define VT  0x0B
#define NAK 0x15
#define DC1 0x11
#define ESC 0x1B
#define EOT 0x04
#define LOG_OPTIONS LOG_ALERT|LOG_LOCAL1

/* data structures */
typedef struct
{
  char  ticName[SLM_NAME_SIZE+1];
  char  ticKeypadID[SLM_KEYPADID_SIZE*2+1];
  char  ticCardID[SLM_CARDID_SIZE+1];
  char  ticClearID[SLM_KEYPADID_SIZE+1];
  char  ticLogoutTime[SLM_TIME_SIZE];
  short ticIsOPI;			/* true means user may use this workstation */
  int   ticTimeout;
} NAME_ENTRY,*NAME_ENTRY_PTR;
#define NAME_ENTRY_SIZE sizeof(NAME_ENTRY)
typedef enum {KEYPAD,MAGCARD,TISLOGIN,IDNOT_YET,READ_ERROR,IOCTL_ERROR} LOGIN_TYPE;

/* function prototypes */
int  ticInit(void);
int  ticInitPort(int, char *);	       		/* open and init serial port (9600 baud,8,N,1) return FD */
void ticSignalHandler(int);			/* ctrl-C exit function */
LOGIN_TYPE  ticReadID(int, char *);          	/* read bytes until ETX or error...strip protocol bytes */
void ticPerformLogin(char *,NAME_ENTRY_PTR);   	/* do that login thing */
void ticLogin(char *,LOGIN_TYPE);      		/* login using name from database */
void ticLogout(NAME_ENTRY_PTR);			/* log this user out of the tis system */
int  ticNameCompare(void *,void *);
void ticCheckCard(void *,void *);		/* see if data entered at terminal was a card ID */
void ticCheckPassword(void *,void *);		/* see if data entered at terminal was a keypad ID(password) */
void ticBuildNameTree(void);			/* build name tree at startup and re-init */

/* external data */
extern AVL_TREE *ticNameTree;
