#include "opiStringDefs.h"
extern	char	*opiStringTab[];
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/***********************************************************************
**
**	EXECUTE_SCRIPTS.C
**	
**	Stolen from Deb Kerstiens related_displays.c of 12/90
**
**	Modification History:
**
*/
#include <X11/Xlib.h>      			/* the X library 		*/
#ifdef WIN32
#include <X11/XlibXtra.h>
#include <winsock.h>
#endif WIN32
#include <X11/Xutil.h>
#include <db_access.h>
#include <cadef.h>
#include <dldef.h>			/* display list defines 	*/
#include <dlinfo.h>			/* more display list defines 	*/
#include <dl_context.h>			/* defines dl context		*/
#include <gizmo.h>			/* defs for gizmos */
#include <op_gsdl_def.h>
#include <dynamic_def.h>		/* rti dynamic defines		*/

#ifdef AXP
#include <string.h>
#endif

extern void *tisMalloc();
extern void *tisCalloc();
extern void tisFree();


/************************************************************************************
*
*	setup_execute_scripts
*
*	DK 12/16/90
*
*	Setup_execute_scripts retrieves the appropriate info from the display list 
*	and sets up the menu gizmo to allow the operator to select script to execute. 
*	From this point on, the screen updates will be handled by the menu gizmo and 
*	the appropriate actions, i.e. new display callup, will be  when the handler 
*	specifed during menu gizmo creation is called(when a menu item is selected.)
*
*
*/
void setup_execute_scripts(pDm_llist_hdr, pDlc, pDm_llist_el, pDl_execute_script, nes, pdl_index)
struct dm_llist_hdr		*pDm_llist_hdr;
struct dl_context 		*pDlc;
struct dm_llist_el		*pDm_llist_el;
struct dl_execute_script 	*pDl_execute_script;
short 				nes;
#ifndef AXP
int				*pdl_index;
#else
unsigned long			*pdl_index;
#endif
	{
	/* set up table of string ptrs for menu gizmo */    
	int							i, j;
	void						execute_script();
	static unsigned short		nstrs			= 0; /* number of valid script paths */
	char						**pDl_str_table	= pDm_llist_el->pdl_strings;
	struct rti_exe_script		*pRti_exe_script;
	struct dl_execute_script	*pDl;
	
	if (nes <= 0)
		return;
	if ((pDm_llist_el->prti_exe_script = (struct rti_exe_script *)tisCalloc(__FILE__, __LINE__, nes, sizeof (struct rti_exe_script))) == NULL)
		return;

	/* add loop for num < nes here */
	/* set up table of string pointers for gizmo in user extension */
	for ( pRti_exe_script = pDm_llist_el->prti_exe_script, pDl = pDl_execute_script,i = 0; i < nes; i++, pRti_exe_script++)
		{
		/* may not need this one */
		pRti_exe_script->pDl_exe_script = pDl;
		pRti_exe_script->pDm_llist_el = pDm_llist_el;

		/* alloc for macro pair pointers */
		/* create string table for gizmo menu */
		for (j = 0, nstrs = 0; j < MAX_EXE_SCRIPTS;j++)
			{
			int	path_index	= (int)(pDl->script[j].path);
			int	args_index	= (int)(pDl->script[j].args);
			int	label_index	= (int)(pDl->script[j].label);
			
			/* use menu label if available, else use display name */
			if (strlen(pDl_str_table[path_index]) > 0)
				{
	    		((char **)pRti_exe_script->pScripts)[nstrs] = pDl_str_table[path_index];
	        	if (strlen(pDl_str_table[label_index]))
	    	   		((char **)pRti_exe_script->pMenustr)[nstrs] = pDl_str_table[label_index];
				else
					((char **)pRti_exe_script->pMenustr)[nstrs] = pDl_str_table[path_index];
				if (strlen(pDl_str_table[args_index]) > 0)
					{
					pRti_exe_script->ppMacros[nstrs] = (char **)tisCalloc(__FILE__, __LINE__, MAX_PAIR_STRS, sizeof(char *));
					pRti_exe_script->pArgList[nstrs] = pDl_str_table[args_index];
    				}
				else if(pDm_llist_el->ppMacro_pairs != NULL)
					{
					pRti_exe_script->ppMacros[nstrs] = pDm_llist_el->ppMacro_pairs;
					}
				else
					pRti_exe_script->ppMacros[nstrs] = NULL;
				nstrs++;
				}
			}

		/* null str to indicate end of string table */   
    	((char **)pRti_exe_script->pMenustr)[nstrs] = NULL;
		if (nstrs > 0)
			{
	    	pRti_exe_script->pgz = create_menu_gizmo(
										DefaultScreenOfDisplay(pDlc->d),
										pDlc->w,
										&(pDl->object), 
										ok_to_operate,
										execute_script,
										pRti_exe_script,
										pRti_exe_script->pMenustr,
										(unsigned)(sizeof(char *) * (nstrs+1))); /*num of strs + 1 for NULL*/
			if (pRti_exe_script->pgz != NULL)
				{
				XMapWindow(pRti_exe_script->pgz->pgg->d, pRti_exe_script->pgz->w);
				set_gizmo_color(pRti_exe_script->pgz, COLOR_LOOKUP(pdl_index, pDl->clr), COLOR_LOOKUP(pdl_index, pDl->bclr));
				}
			}
		pDl = (struct dl_execute_script *)((short *)pDl + ((struct dl_element_hdr *)pDl)->nwords);
		}
	} 

 
/************************************************************************************
*
*	execute_script
*
*
*	execute_script is the handler specifed during menu gizmo creation 
*	to be called when a menu selection from a script element is selected.
*	It executes the script with a system() call.
*
*
*	Input	: pRti_exe_script 	ptr to script struct
*		  pg			ptr to a gizmo
*		  index			index of the string in str table for display selected
*	Output	: Executes the given script by making a system call.
*	Returns	: nothing
*/
void execute_script(pRti_exe_script, pg, index)
struct rti_exe_script	*pRti_exe_script;
gizmo					*pg;
int 					index;
	{
	if (pRti_exe_script->pArgList[index])
		if (get_macro_pairs(pRti_exe_script->pArgList[index], pRti_exe_script->ppMacros[index], MAX_PAIR_STRS, DefaultScreenOfDisplay(pRti_exe_script->pDm_llist_el->dl_context.d)) == 0)
			return;

	runScript(pRti_exe_script->pScripts[index], pRti_exe_script->pDm_llist_el->display_path, pRti_exe_script->ppMacros[index]);
	}

runScript(script, path, args)
char	*script;
char	*path;
char	*args[];
	{
	char	cmd[200];

	/*
	 * build a command line of the form:
	 *	[(var=arg;export var;...][path/]script[)]
	 *	where the existance of the optional parts depend on the objects definition
	 */
	cmd[0] = 0;	/* start with an empty command string */
	if (args)
		{
		/*
		 * 'Macros' exit, setup variable,arg pairs and export them before calling the script
		 */
		int	i;

		strcpy(cmd, "(");
		for (i = 0; args[i]; i += 2)
			{
			char	assignment[50];
			char	**arg	= args;

			sprintf(assignment, opiStringTab[STR_HsCHsexport_Hs              ], arg[i], arg[i+1], arg[i]);
			strcat(cmd, assignment);
			}
		}
	if (script[0] != '/')
		{
		/*
		 * there is NO absolute path on the script so use the displays path (if it has one)
		 */
		if (strlen(path) > 0)
			{
			/*
			 * use the path from the display, i.e. scripts are stored with displays
			 */
			strcat(cmd, path);
			if (path[strlen(path)-1] != '/')
				strcat(cmd, "/");	/* add one */
			}
		/* else the display is pathless (can this happen?), do not add any */
		}
	strcat(cmd, script);
	if (args)
		strcat(cmd, ")");

	/* NOTES:
	 * I could check the script exists first and inform w/dialog if not.
	 * I could use popen and a dialog w/continue button which gives 'screens' of results and
	 * ok button which throws away the rest of the output.
	 */
	system(cmd);
	return 0;
	}

	    
/***********************************************************************
**
**	Delete_execute_scripts
**	
**
**	Purpose : This routine deletes the "gizmos" that have been created
**			for operator control.  Delete_controllers is called
**			when a display (dm_llist_el) is to be deleted to delete 
**			each gizmo that is currently active.  This must be
**			done so that when the parent (display) window is
**			deleted, the child window created for each gizmo will
**			already have been deleted.
**
**	Input :
**	    prti	: ptr to the run-time list for execute scripts
**	    nctrl	: count of execute script elements to display
**	Output :
**	    none
**	Returns
**	    none
**
**********************************************************************/

void delete_execute_scripts(prti, nes)
struct rti_exe_script 	*prti;
unsigned short			nes;
	{
	unsigned short	i, j;
 
	/* for each element on the display list */
	for (i = 0; i < nes; prti++, i++)
		{
		if (prti->pgz != NULL)
			free_gizmo(prti->pgz);
		for (j = 0; j < MAX_REL_DISPLAYS;j++)
			if (prti->pMenustr[j] && prti->ppMacros[j] && (prti->ppMacros[j] != prti->pDm_llist_el->ppMacro_pairs))
				tisFree(prti->ppMacros[j]);
		}
	}
