/*atodl_lex.c,v 1.1.1.1 1999/08/03 14:43:52 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
# include "stdio.h"
#ifdef AXP
#include	<string.h>
#endif

# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/**************************************************************************
			GTA PROJECT   AT division
	Copyright, 1990, The Regents of the University of California.
		         Los Alamos National Laboratory

	@(#)atodl_lex.l	1.2	2/25/92
	ENVIRONMENT: UNIX

 .01 joh 090691	Added `TK_' prefix to the token so they dont collide with
		other common C defines

***************************************************************************/
/* Lexical analyzer for ASCII-to-Display List Converter - atodl.
 *
 * This routine recognizes atodl tokens (Key words),
 * and passes these tokens to yacc().
 */

#include	"tokens.h"

/* #define		DEBUG */
#ifdef		DEBUG
#define	RETURN(param)	{ printf("%d: return(param)\n", line_num); return(param); }
#else
#define	RETURN(param)	return(param); 
#endif		DEBUG

#define	STR_BFR_SIZE	MAX_TOKEN_LTH

extern int		line_num; /* input line number */
char			*pLEXvalue; /* Ptr to token value (returned) */
char			str_bfr[STR_BFR_SIZE]; /* holding place string,
						 numbers, etc. */
char			*str_next; /* current ptr to str_bfr */
int			nc;

# define ATODL 2
# define COMMENT 4
# define STR 6
# define SUBS 8
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
	line_num++;
break;
case 2:
	BEGIN ATODL;
break;
case 3:
	;
break;
case 4:
{	/* \" within a string */
			/* *str_next++ = yytext[0]; */
			*str_next++ = yytext[1];
		}
break;
case 5:
	{
			*str_next++ = 0;
			pLEXvalue = str_bfr;
			BEGIN ATODL;
			RETURN(TK_STRING);
		}
break;
case 6:
		*str_next++ = yytext[0];
break;
case 7:
	{
			*str_next++ = '?';
			line_num++;
		}
break;
case 8:
	line_num++;
break;
case 9:
	BEGIN COMMENT;
break;
case 10:
{
			str_next = str_bfr;
			BEGIN STR;
		}
break;
case 11:
{	/* Any name */
			pLEXvalue = yytext;
			RETURN(TK_NAME);
		}
break;
case 12:
{
			nc = strlen(yytext) - 1;
			yytext[nc] = 0; /* Terminate after NUMBER */
			pLEXvalue = yytext+1;
			RETURN(TK_SUBSCRIPT);
		}
break;
case 13:
{	pLEXvalue = 0; RETURN(TK_EQUAL); }
break;
case 14:
{	pLEXvalue = 0; RETURN(TK_L_BRACKET); }
break;
case 15:
{	pLEXvalue = 0; RETURN(TK_R_BRACKET); }
break;
case 16:
{
			pLEXvalue = yytext;
			RETURN(TK_NUMBER);
		}
break;
case 17:
	;
break;
case 18:
{	pLEXvalue = 0; RETURN(TK_ERROR); }
break;
case 19:
	{	/* First character of input stream */
			line_num = 1;
			BEGIN ATODL;
			yyless(0); /* Re-start with same character */
		}
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
int yyvstop[] = {
0,

17,
0,

17,
0,

17,
0,

17,
0,

17,
0,

17,
0,

17,
0,

17,
0,

17,
0,

17,
0,

19,
0,

18,
19,
0,

17,
18,
19,
0,

8,
19,
0,

10,
18,
19,
0,

18,
19,
0,

18,
19,
0,

18,
19,
0,

16,
18,
19,
0,

18,
19,
0,

13,
18,
19,
0,

11,
18,
19,
0,

18,
19,
0,

14,
18,
19,
0,

15,
18,
19,
0,

3,
19,
0,

1,
19,
0,

3,
19,
0,

6,
19,
0,

7,
19,
0,

5,
6,
19,
0,

6,
19,
0,

17,
0,

16,
0,

16,
0,

9,
0,

16,
0,

11,
0,

2,
0,

4,
0,

12,
0,

11,
0,
0};
# define YYTYPE char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,11,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3,12,	0,0,	1,11,	1,11,	
0,0,	0,0,	13,33,	0,0,	
3,13,	3,14,	5,26,	0,0,	
0,0,	0,0,	0,0,	7,29,	
0,0,	0,0,	5,26,	5,27,	
0,0,	0,0,	0,0,	7,29,	
7,30,	0,0,	0,0,	4,15,	
8,31,	13,33,	32,44,	0,0,	
0,0,	3,15,	0,0,	6,28,	
18,36,	0,0,	4,16,	4,17,	
4,18,	1,11,	19,37,	28,43,	
3,16,	3,17,	3,18,	3,19,	
7,31,	34,37,	42,47,	5,28,	
0,0,	4,20,	4,21,	20,38,	
49,50,	5,26,	1,11,	3,20,	
3,21,	0,0,	7,29,	0,0,	
3,22,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	5,26,	0,0,	
0,0,	0,0,	0,0,	7,29,	
0,0,	0,0,	0,0,	0,0,	
4,23,	0,0,	8,32,	46,48,	
1,11,	0,0,	3,23,	0,0,	
0,0,	0,0,	3,12,	0,0,	
0,0,	42,48,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
5,26,	0,0,	7,32,	0,0,	
0,0,	7,29,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4,24,	0,0,	4,25,	0,0,	
0,0,	0,0,	3,24,	0,0,	
3,25,	16,34,	16,34,	16,34,	
16,34,	16,34,	16,34,	16,34,	
16,34,	16,34,	16,34,	17,35,	
17,35,	17,35,	17,35,	17,35,	
17,35,	17,35,	17,35,	17,35,	
17,35,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
0,0,	0,0,	0,0,	0,0,	
22,39,	0,0,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
22,39,	22,39,	22,39,	22,39,	
23,40,	23,41,	0,0,	23,42,	
23,42,	23,42,	23,42,	23,42,	
23,42,	23,42,	23,42,	23,42,	
23,42,	37,37,	37,37,	37,37,	
37,37,	37,37,	37,37,	37,37,	
37,37,	37,37,	37,37,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	38,45,	38,45,	38,45,	
38,45,	40,42,	40,42,	40,42,	
40,42,	40,42,	40,42,	40,42,	
40,42,	40,42,	40,42,	41,46,	
41,46,	41,46,	41,46,	41,46,	
41,46,	41,46,	41,46,	41,46,	
41,46,	45,45,	45,45,	45,45,	
45,45,	45,45,	45,45,	45,45,	
45,45,	45,45,	45,45,	0,0,	
0,0,	0,0,	0,0,	45,49,	
47,47,	47,47,	47,47,	47,47,	
47,47,	47,47,	47,47,	47,47,	
47,47,	47,47,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
45,45,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	47,48,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		yyvstop+1,
yycrank+0,	yysvec+1,	yyvstop+3,
yycrank+-7,	0,		yyvstop+5,
yycrank+-1,	yysvec+3,	yyvstop+7,
yycrank+-17,	0,		yyvstop+9,
yycrank+-1,	yysvec+5,	yyvstop+11,
yycrank+-22,	0,		yyvstop+13,
yycrank+-2,	yysvec+7,	yyvstop+15,
yycrank+0,	yysvec+1,	yyvstop+17,
yycrank+0,	yysvec+1,	yyvstop+19,
yycrank+0,	0,		yyvstop+21,
yycrank+0,	0,		yyvstop+23,
yycrank+5,	0,		yyvstop+26,
yycrank+0,	0,		yyvstop+30,
yycrank+0,	0,		yyvstop+33,
yycrank+85,	0,		yyvstop+37,
yycrank+95,	0,		yyvstop+40,
yycrank+2,	0,		yyvstop+43,
yycrank+4,	yysvec+16,	yyvstop+46,
yycrank+3,	0,		yyvstop+50,
yycrank+0,	0,		yyvstop+53,
yycrank+105,	0,		yyvstop+57,
yycrank+183,	0,		yyvstop+61,
yycrank+0,	0,		yyvstop+64,
yycrank+0,	0,		yyvstop+68,
yycrank+0,	0,		yyvstop+72,
yycrank+0,	0,		yyvstop+75,
yycrank+4,	0,		yyvstop+78,
yycrank+0,	0,		yyvstop+81,
yycrank+0,	0,		yyvstop+84,
yycrank+0,	0,		yyvstop+87,
yycrank+4,	0,		yyvstop+91,
yycrank+0,	yysvec+13,	yyvstop+94,
yycrank+11,	yysvec+16,	yyvstop+96,
yycrank+0,	yysvec+17,	yyvstop+98,
yycrank+0,	0,		yyvstop+100,
yycrank+193,	0,		yyvstop+102,
yycrank+186,	0,		0,	
yycrank+0,	yysvec+22,	yyvstop+104,
yycrank+261,	0,		0,	
yycrank+271,	0,		0,	
yycrank+12,	yysvec+40,	0,	
yycrank+0,	0,		yyvstop+106,
yycrank+0,	0,		yyvstop+108,
yycrank+281,	yysvec+38,	0,	
yycrank+2,	yysvec+41,	0,	
yycrank+296,	0,		0,	
yycrank+0,	0,		yyvstop+110,
yycrank+2,	0,		0,	
yycrank+0,	0,		yyvstop+112,
0,	0,	0};
struct yywork *yytop = yycrank+389;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,'_' ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
#ifndef AXP
			if ( (int)yyt > (int)yycrank){
#else
			if (yyt > yycrank){
#endif
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
#ifndef AXP
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
#else
			else if (yyt < yycrank){
#endif
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout,"action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
