#include "opiStringDefs.h"
extern	char	*opiStringTab[];
/*t_align_selections.c,v 1.1.1.1 1999/08/03 14:43:54 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 * 	A L I G N    S E L E C T I O N S . C
 *
 * 	Author: Jeffrey O. Hill
 *		hill@luke.lanl.gov
 *		505 665 1831
 * 
 * 	history
 *	.01 joh	120290	Aligned to max bounds instead of to average 
 *			as before
 *	.02 joh 062191	Added push_field_undo() calls for dl updates here
 */
#include <edd.h>
#include <edd_menus.h>
#include <dlinfo.h>


/*
 * ALIGN SELECTIONS
 * (see edd_menus.h)
 */
void align_selections(align_type, pdue)
enum align_type		align_type;
due			*pdue;
{
	eue_sel		*psel;
	XRectangle	maxrec;
	XRectangle	bounds;

	/*
	 * need at least two to align
	 */
	if(pdue->selections.count <= 1)
		return;

	selection_bounds(pdue, &maxrec, TRUE);

	for(	psel = (eue_sel *) pdue->selections.node.next;
		psel;
		psel = (eue_sel *) psel->node.next){

		int			offsetx, orgx, offsety, orgy;
		struct dl_object_hdr	*pobj	= &(psel->eue.elem.dl_anygo.object);

		push_field_undo(	
			pdue, 
			&psel->eue, 
			&dl_object_hdr_sinfo[x_index_dl_object_hdr], 
			pobj, 
			0);
		push_field_undo(	
			pdue, 
			&psel->eue, 
			&dl_object_hdr_sinfo[y_index_dl_object_hdr], 
			pobj, 
			0);
		if ( psel->eue.elem.dl_anygo.element.type == dl_line )
			push_line_endpoints(pdue, psel);

		compute_bounds(&psel->eue, &bounds);
		offsetx = (orgx = pobj->x) - bounds.x;
		offsety = (orgy = pobj->y) - bounds.y;

		switch(align_type){
		case align_left_edges:		pobj->x = maxrec.x + offsetx;
						break;
		case align_top_edges:		pobj->y = maxrec.y + offsety;
						break;
		case align_right_edges:		pobj->x = maxrec.x + offsetx + (int)maxrec.width       - (int)bounds.width;
						break;
		case align_bottom_edges:	pobj->y = maxrec.y + offsety + (int)maxrec.height      - (int)bounds.height;
						break;
		case align_horizontal_centers:	pobj->x = maxrec.x + offsetx + (int)(maxrec.width>>1)  - (int)(bounds.width>>1);
						break;
		case align_vertical_centers:	pobj->y = maxrec.y + offsety + (int)(maxrec.height>>1) - (int)(bounds.height>>1);
						break;
		case align_centers:		pobj->x = maxrec.x + offsetx + (int)(maxrec.width>>1)  - (int)(bounds.width>>1);
						pobj->y = maxrec.y + offsety + (int)(maxrec.height>>1) - (int)(bounds.height>>1);
						break;
		default:			assert(FALSE);
		}
		if(psel->eue.elem.dl_anygo.element.type == dl_line)
			adjust_line_endpoints(&(psel->eue.elem.dl_line), pobj->x - orgx, pobj->y - orgy);
	}
	selection_bounds(pdue, &maxrec, FALSE);
	redraw_dl(pdue, &maxrec);
}
