#include "opiStringDefs.h"
extern	char	*opiStringTab[];
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 *	D I A L O G . C
 *
 *	Author	Jeffrey O. Hill
 *		hill@luke.lanl.gov
 *		505 665 1831
 *
 *	Inform the operator and recv a response
 *
 *
 *	History
 *	-------
 *	.01 120291 joh	no longer includes vxWorks.h
 *
 */
#include <X11/Xlib.h>
#ifdef WIN32
#include <X11/XlibXtra.h>
#endif WIN32
#include <X11/Xutil.h>

#include <gizmo.h>

#define AnyEventMask (~(0L))
enum 	columns {dialog_col, last_col};

static void 	dialog_update();

struct dialog_ext{
	void	(*func)();
	void	*arg;
	int	done_flag;
	int	selection;
};


/*
 *	perform_dialog()
 */
perform_dialog(s, x, y, text_height, ppmessages, pchoices, border_width)
Screen		*s;
int		x;
int		y;
int		text_height;
char		**ppmessages; 		/* NULL termintaed */
char		**pchoices;		/* NULL terminated */
unsigned	border_width;
{
	gizmo			*ppopg, *pformg, *pmenug;
	struct dialog_ext	*pde;
	unsigned		i;
	XEvent			xevent;
	unsigned		nmessages;
	int			selection;
	int			status;

	ppopg = create_popup_gizmo(
				s, 
				RootWindowOfScreen(s),
				"Dialog",
				x, 
				y,
				border_width,
				dialog_update,
				NULL,
				pchoices,
				sizeof(struct dialog_ext));
	assert(ppopg != NULL);

	set_gizmo_color(	ppopg,
				WhitePixelOfScreen(s),
				ppopg->pgg->dialog_bg);

	pde = (struct dialog_ext *) ppopg->pae;
	pde->done_flag = FALSE;


	for(nmessages=0; ppmessages[nmessages]; nmessages++);

	pformg = create_form_gizmo(
				s, 
				ppopg->w,
				0, 
				0,
				last_col,
				nmessages,
				border_width,
				0);
	assert(pformg != NULL);

	for(i=0; i<nmessages; i++){
		form_gizmo_add_string(
				pformg, 
				dialog_col, 
				i, 
				text_height,
				ppmessages[i]);
	}

	resize_form_gizmo(pformg);
	popup_gizmo_add_gizmo(ppopg, pformg);
/* redundant with popup_gizmo_add_gizmo! agi
**	XMapWindow(ppopg->pgg->d, ppopg->w);
*/

	while(TRUE){
		XWindowEvent(	ppopg->pgg->d,
				ppopg->w, 
				StructureNotifyMask, 
				&xevent);
		/*
		 * lost events not allowed
 		 *
		 */
		status = filter_gizmo_events(&xevent);
		assert(status != 0);
		if(ppopg->mapped)
			break;
	}

	while(TRUE){
		XWindowEvent(	ppopg->pgg->d, 
				ppopg->w,
				ExposureMask, 
				&xevent);
		/*
		 * lost events not allowed
 		 *
		 */
		status = filter_gizmo_events(&xevent);
		assert(status != 0);
		if(xevent.xexpose.count == 0)
			break;
	}

	status = XGrabPointer(
			ppopg->pgg->d,
			ppopg->w,
			TRUE,
			ButtonPressMask|ButtonReleaseMask,	
			GrabModeAsync,
			GrabModeAsync,
			None,
			None,
			CurrentTime);
	if(status != GrabSuccess){
		printf(
			opiStringTab[STR_dialog_gizmo_Grab_failed_but], 
			status);
	}

	while(TRUE){
		XWindowEvent(	ppopg->pgg->d, 
				pformg->w, 
				StructureNotifyMask, 
				&xevent);
		/*
		 * lost events not allowed
 		 *
		 */
		status = filter_gizmo_events(&xevent);
		assert(status != 0);
		if(pformg->mapped)
			break;
	}
	while(TRUE){
		XWindowEvent(	ppopg->pgg->d, 
				pformg->w, 
				ExposureMask, 
				&xevent);
		/*
		 * lost events not allowed
 		 *
		 */
		status = filter_gizmo_events(&xevent);
		assert(status != 0);
		if(xevent.xexpose.count == 0)
			break;
	}
	XBell(ppopg->pgg->d, 50);

	pmenug = popup_gizmo_return_pmenugizmo(ppopg);
	while(TRUE){

		/*
		 * carefully extract only those events that can
		 * be delt with here
		 */
		XWindowEvent(
			ppopg->pgg->d, 
			pmenug->w, 
			AnyEventMask, 
			&xevent);

		/*
		 * lost events not allowed
 		 *
		 */
		status = filter_gizmo_events(&xevent);
		assert(status != 0);

		if(pde->done_flag)
			break;
	}

	XUngrabPointer(
		ppopg->pgg->d,
		CurrentTime);

	selection = pde->selection;

	free_gizmo(ppopg);

	return selection;
}




/*
 *
 *	dialog_update()
 *
 *
 */
static void 
dialog_update(pdummy, ppopg, value, pbe)
void		*pdummy;
gizmo		*ppopg;
int		value;
XButtonEvent	*pbe;
{
	struct dialog_ext	*pde;

	pde = (struct dialog_ext *) ppopg->pae;

	pde->done_flag = TRUE;
	pde->selection = value;
}

outOfRangeDialog(s, show_limits, low_limit, high_limit, pText)
Screen	*s;
int		show_limits;
double	low_limit;
double	high_limit;
char	*pText;
	{
	enum 	choices	{ ok, terminate, nchoices };
	char 	*pchoices[nchoices];
	char 	*pmessage[4];
	char	b0[100];
	char	b1[100];
	char	b2[100];
	int		i	= 0;

	pchoices[ok] = opiStringTab[STR_ok                          ];
	pchoices[terminate] = 0;
	sprintf(pmessage[i++] = &b0[0], opiStringTab[STR_Text_entry_Hs               ], pText ? pText : opiStringTab[STR_value_out_of_range          ]);
	if (show_limits)
		{
		sprintf(pmessage[i++] = &b1[0], opiStringTab[STR__low__limit_Hlf             ], low_limit);
		sprintf(pmessage[i++] = &b2[0], opiStringTab[STR__high_limit_Hlf             ], high_limit);
		}
	pmessage[i] = 0;
	perform_dialog(s, 400, 300, 21, pmessage, pchoices, 21);
	return FALSE;
	}
