#include "opiStringDefs.h"
extern	char	*opiStringTab[];
/*t_file_name.c,v 1.1.1.1 1999/08/03 14:43:57 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 *	F I L E _ N A M E . C
 *
 *	Author	Jeffrey O. Hill
 *		hill@luke.lanl.gov
 *		505 665 1831
 *
 *	edit a file name and path
 *
 *
 *	History
 *	-------
 * 	.01 120291 joh	No longer includes vxWorks.h
 *
 */
#include <X11/Xlib.h>
#ifdef WIN32
#include <X11/XlibXtra.h>
#endif WIN32
#include <X11/Xutil.h>

#ifdef AXP
#include <string.h>
#endif

#include <gizmo.h>

enum choices {execute_choice, cancel_choice};

static char  *pchoices[] =
{       
	"execute",
	"cancel",
	0
};

enum 	columns {description_col, gizmo_col, last_col};
enum 	rows {path_row, name_row, last_row};

static void 	add_row();
static void 	file_name_update();

struct file_name_ext{
	void	(*func)();
	void	*arg;
	char	*ppath;
	char	*pname;
};


/*
 *
 *	create_file_name_entry_gizmo()
 *
 *
 */
gizmo	
*create_file_name_entry_gizmo(s, w, pobj, ptitle, ppath, path_size, 
		pname, name_size, pfunction, arg, pad)
Screen		*s;
Window		w;
XRectangle	*pobj;
char		*ptitle;
char		*ppath;
unsigned	path_size;
char		*pname;
unsigned	name_size;
void		(*pfunction)();
void		*arg;
unsigned	pad;
{
	gizmo			*ppopg, *pformg;
	struct file_name_ext	*pfne;
	XRectangle		rowobj;

/*
	GCT 27-Nov-1994
	Added here to prevent compiler errors.
*/
	pchoices[0] = opiStringTab[STR_execute                     ];
	pchoices[1] = opiStringTab[STR_cancel                      ];
	pchoices[2] = 0;
	ppopg = create_popup_gizmo(
				s, 
				w,
				ptitle,
				pobj->x, 
				pobj->y,
				pad,
				file_name_update,
				NULL,
				pchoices,
				sizeof(struct file_name_ext));
	if(!ppopg)
		return NULL;

	pfne = (struct file_name_ext *) ppopg->pae;
	pfne->func = pfunction;
	pfne->arg = arg;
	pfne->ppath= ppath;
	pfne->pname = pname;

	pformg = create_form_gizmo(
				s, 
				ppopg->w,
				0, 
				0,
				last_col,
				last_row,
				pad,
				0);
	if(!pformg){
		free_gizmo(ppopg);
		return NULL;
	}

	/*
	 * position set later
	 */
	rowobj.x = 0;
	rowobj.y = 0;
	rowobj.width = pobj->width;
	rowobj.height = pobj->height>>1;

	add_row(	
		pformg, 
		path_row, 
		&rowobj, 
		opiStringTab[STR_Path                        ], 
		ppath, 
		path_size-1);
	add_row(
		pformg, 
		name_row, 
		&rowobj, 
		opiStringTab[STR_File                        ], 
		pname,
		name_size-1);

	resize_form_gizmo(pformg);
	popup_gizmo_add_gizmo(ppopg, pformg);
/* redundant with popup_gizmo_add_gizmo! agi
**	XMapWindow(ppopg->pgg->d, ppopg->w);
*/

	return ppopg;
}


/*
 *
 *	add_row()
 *
 *
 */
static void 
add_row(pformg, row, pobj, ptitle, pinit, maxstring)
gizmo		*pformg;
unsigned	row;
XRectangle	*pobj;
char		*ptitle;
char		*pinit;
unsigned	maxstring;
{
	gizmo		*pg;


	form_gizmo_add_string(
				pformg, 
				description_col, 
				row, 
				pobj->height,
				ptitle);

	pg = create_textedit_gizmo(
				pformg->pgg->s, 
				pformg->w, 
				pobj, 
				ok_to_operate,
				NULL,
				NULL,
				maxstring,
				0);
	assert(pg != NULL);

	set_textedit_gizmo(pg, pinit);

	form_gizmo_add_gizmo(
				pformg, 
				gizmo_col, 
				row, 
				pg);
}




/*
 *
 *	file_name_update()
 *
 *
 */
static void 
file_name_update(pdummy, ppopg, value, pbe)
void		*pdummy;
gizmo		*ppopg;
int		value;
XButtonEvent	*pbe;
{
	struct file_name_ext	*pfne;
	gizmo			*pformg;
	gizmo			*ppathg;
	gizmo			*pnameg;
	char			*ppath;
	char			*pname;

	pfne = (struct file_name_ext *) ppopg->pae;

	if(value == execute_choice){

		pformg = popup_gizmo_return_pgizmo(ppopg);
		ppathg = form_gizmo_return_pitem(pformg, gizmo_col, path_row);
		pnameg = form_gizmo_return_pitem(pformg, gizmo_col, name_row);
		ppath = textedit_gizmo_return_pbuf(ppathg);
		pname = textedit_gizmo_return_pbuf(pnameg);

		if(!pname[0]){
			set_textedit_gizmo(pnameg, opiStringTab[STR_Please_enter_a_file_name    ]);
			return;
		}

		strcpy(pfne->pname, pname);
		strcpy(pfne->ppath, ppath);

		(*pfne->func)(pfne->arg, TRUE, pbe);
	}
	else
		(*pfne->func)(pfne->arg, FALSE, pbe);
}
