/*edd_menus.h,v 1.1.1.1 1999/08/03 14:44:03 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#ifndef INCedd_menush

#ifndef INCeddh
#include <edd.h>
#endif

/*
 *
 *	so one function can handle several menu entries
 *
 *
 */
enum distribute_type{	dis_left_edges, 
			dis_right_edges, 
			dis_top_edges, 
			dis_bottom_edges,
			dis_horizontal_centers,
			dis_vertical_centers,
			dis_last};

enum align_type{	align_left_edges, 
			align_right_edges, 
			align_top_edges, 
			align_bottom_edges,
			align_horizontal_centers,
			align_vertical_centers,
			align_centers,
			align_last};

enum sel_request{	cut_request, 
			copy_request, 
			paste_request};

#ifdef EDD_MENUS_GLOBAL_SOURCE

#ifndef INCplain_menush
#include <plain_menus.h>
#endif

/*
 *
 *
 *	Set Up The Global Menu
 *
 *
 */

char				*colorrulemc[] =
{	COLOR_RULE_LISTEDIT_TAG, 
	0
};


struct jump_table		colorrulejt[] =
{
	{gm_modify_color_rules, (void *) COLOR_RULE_LISTEDIT_TAG},
	{0,0}
};


struct menu_configuration 	colorrule_mc =
{
	"color rule modify menu",
	colorrulemc,
	colorrulejt
};


char				*modifymc[] =
{	"attributes", 
	"color table", 
	"color rules", 
	0
};


struct jump_table		modifyjt[] =
{
	{modify_edd_defaults, (void *) 0},
	{gm_modify_color_map, (void *) 0},
	{SUBMENUNEEDED,       (void *) &colorrule_mc},
	{0,0}
};


struct menu_configuration 	modify_mc =
{
	"global modify menu",
	modifymc,
	modifyjt
};


/*
 * need print display and list displays
 *
 *
 */
char				*globalmc[] =
{	
	"load     display", 
	"modify   display",
	"save     display",
	"copy     display",
	"report   display",
	"activate display",
	"quit",
	0
};



struct jump_table		globaljt[] =
{
	{gm_load, 		(void *) 0},
	{SUBMENUNEEDED, 	(void *) &modify_mc},
	{gm_save, 		(void *) FALSE},
	{gm_save_to_new_file, 	(void *) 0},
	{gm_save_to_text_file, 	(void *) 0},
	{gm_activate, 		(void *) 0},
	{gm_quit, 		(void *) 0},
	{0,0}
};


struct menu_configuration 	global_mc =
{
	"global menu",
	globalmc,
	globaljt
};

/*
 *
 *
 *	Set Up The Edit Create Monitor Sub Menu
 *
 *
 */

char				*monitormc[] =
{	"indicator",
	"bar", 
	"text",
	"meter",
	0
};

struct jump_table		monitorjt[] =
{
	{em_create, (void *) dl_indicator},
	{em_create, (void *) dl_bar},
	{em_create, (void *) dl_text_update},
	{em_create, (void *) dl_meter},
	{0,0}
};


struct menu_configuration 	monitor_mc =
{
	"create monitor",
	monitormc,
	monitorjt
};


/*
 *
 *
 *	Set Up The Edit Create Controller Sub Menu
 *
 *
 */

char			*controlmc[] =
{	"valuator", 
	"text entry", 
	"choice button",
	"message button",
	"menu",
	"related display callup",
	"execute script",
	"kill display",
	0
};

struct jump_table		controljt[] =
{
	{em_create, (void *) dl_valuator},
	{em_create, (void *) dl_text_entry},
	{em_create, (void *) dl_choice_button},
	{em_create, (void *) dl_message_button},
	{em_create, (void *) dl_menu},
	{em_create, (void *) dl_related_display},
	{em_create, (void *) dl_execute_script},
	{em_create, (void *) dl_kill_display},
	{0,0}
};


struct menu_configuration 	control_mc =
{
	"create controller",
	controlmc,
	controljt
};


/*
 *
 *
 *	Set Up The Edit Create Plot Sub Menu
 *
 *
 */

char				*plotmc[] =
{	"cartesian plot", 
	"surface plot", 
	"strip chart",
	"smith overlay plot",
	0
};



struct jump_table		plotjt[] =
{
	{em_create, (void *) dl_plot},
	{em_create, (void *) dl_surface_plot},
	{em_create, (void *) dl_strip},
	{em_create, (void *) dl_smith_overlay},
	{0,0}
};


struct menu_configuration 	plot_mc =
{
	"create plot menu",
	plotmc,
	plotjt
};




/*
 *
 *
 *	Set Up The Edit Create Sub Menu
 *
 *
 */

char				*createmc[] =
{	"rectangle", 
	"line", 
	"oval",
	"arc",
	"text",
	"monitor",
	"controller",
	"plot",
	0
};



struct jump_table		createjt[] =
{
	{em_create,	(void *) dl_rec},
	{em_create,	(void *) dl_line},
	{em_create,	(void *) dl_oval},
	{em_create,	(void *) dl_arc},
	{em_create,	(void *) dl_text},
	{SUBMENUNEEDED,	(void *) &monitor_mc},
	{SUBMENUNEEDED,	(void *) &control_mc},
	{SUBMENUNEEDED,	(void *) &plot_mc},
	{0,0}
};


struct menu_configuration 	create_mc =
{
	"create menu",
	createmc,
	createjt
};

/*
 *
 *
 *	Set Up The Edit Menu
 *	(no item selected)
 *
 *
 */


char				*nseditmc[] =
{	"create", 
	"paste", 
	"undo",
	"select all",
	0
};


struct jump_table		nseditjt[] =
{
	{SUBMENUNEEDED,		(void *) &create_mc},
	{request_selections,	(void *) paste_request},
	{pop_undo_from_menu,	(void *) 0},
	{select_all,		(void *) 0},
	{0,0}
};


struct menu_configuration 	nsedit_mc =
{
	"edit menu",
	nseditmc,
	nseditjt
};


/*
 *
 *
 *	Set Up The Edit Menu - distribute submenu
 *	(item selected)
 *
 *
 */
char				*distributemc[] =
{	"left edges",
	"right edges", 
	"top edges", 
	"bottom edges",
	"horizontal centers",
	"vertical centers",
	0
};


struct jump_table		distributejt[] =
{
	{distribute_selections, (void *) dis_left_edges},
	{distribute_selections, (void *) dis_right_edges},
	{distribute_selections, (void *) dis_top_edges},
	{distribute_selections, (void *) dis_bottom_edges},
	{distribute_selections, (void *) dis_horizontal_centers},
	{distribute_selections, (void *) dis_vertical_centers},
	{0,0}
};



struct menu_configuration 	distribute_mc =
{
	"distribute",
	distributemc,
	distributejt
};



/*
 *
 *
 *	Set Up The Edit Menu - align submenu
 *	(item selected)
 *
 *
 */



char				*alignmc[] =
{	"left edges",
	"right edges", 
	"top edges", 
	"bottom edges",
	"horizontal centers",
	"vertical centers",
	"centers",
	0
};


struct jump_table		alignjt[] =
{
	{align_selections, (void *) align_left_edges},
	{align_selections, (void *) align_right_edges},
	{align_selections, (void *) align_top_edges},
	{align_selections, (void *) align_bottom_edges},
	{align_selections, (void *) align_horizontal_centers},
	{align_selections, (void *) align_vertical_centers},
	{align_selections, (void *) align_centers},
	{0,0}
};



struct menu_configuration 	align_mc =
{
	"align",
	alignmc,
	alignjt
};


/*
 *
 *
 *	Set Up The Edit Menu - more submenu
 *	(item selected)
 *
 *
 */

char				*moremc[] =
{	
	"group",
	"ungroup", 
	"front", 
	"back",
	"align",
	"distribute",
#ifdef UNFINISHED
	"open",
	"close",
#endif
	0
};


struct jump_table		morejt[] =
{
	{group_selections,	(void *) 0},
	{ungroup_selections,	(void *) 0},
	{float_selections,	(void *) 0},
	{sink_selections,	(void *) 0},
	{SUBMENUNEEDED,		(void *) &align_mc},
	{SUBMENUNEEDED,		(void *) &distribute_mc},
#ifdef UNFINISHED
	{0,			(void *) 0},
	{0,			(void *) 0},
#endif
	{0,0}
};



struct menu_configuration 	more_mc =
{
	"more",
	moremc,
	morejt
};



/*
 *
 *
 *	Set Up The Edit Menu
 *	(local item selected)
 *
 *
 */

char				*seditmc[] =
{	"modify",
	"modify channel names", 
	"cut", 
	"copy", 
	"move",
	"resize",
	"deselect",
	"more",
	0
};


struct jump_table		seditjt[] =
{
	{modify_selected_items,		(void *) 0},
	{modify_selected_channel_names,	(void *) 0},
	{request_selections,		(void *) cut_request},
	{request_selections,		(void *) copy_request},
	{move_selections,		(void *) 0},
	{resize_selections,		(void *) 0},
	{clear_x_selections,		(void *) FALSE},
	{SUBMENUNEEDED,			(void *) &more_mc},
	{0,0}
};



struct menu_configuration 	sedit_mc =
{
	"edit menu (selection)",
	seditmc,
	seditjt
};



/*
 *
 *
 *	Set Up The Edit Menu
 *	(another client's item selected)
 *
 *
 */
char			*rmtseditmc[] =
{	"cut", 
	"copy", 
	"deselect",
	0
};


struct jump_table		rmtseditjt[] =
{
	{request_selections, (void *) cut_request},
	{request_selections, (void *) copy_request},
	{clear_x_selections, (void *) FALSE},
	{0,0}
};



struct menu_configuration 	rmtsedit_mc =
{
	"edit menu (remote selection)",
	rmtseditmc,
	rmtseditjt
};



#endif

#endif
