/*op_gsdl_def.h,v 1.1.1.1 1999/08/03 14:44:04 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/*
**************************************************************
* File op_gsdl_def.h
* Purpose:  structure definitions for op_comm program.
*
* Modification History
* version   data        author        comments
*------------------------------------------------------------
* 1.0       07/10/90    Gale Slentz   Add pPut, pGet, put_req, get_req, nctrl,
*				      ncount fields to gsdl_com_record.  Add
*				      gsdl_put and gsdl_get structure types. 
* 1.1       07/19/90    Gale Slentz   Retract the modifications of 07/10/90.
* 1.2	    08/02/91	Deb Kerstiens Added event id and valid data fields to
*				      gsdl_com_record struct
*************************************************************
*/
/*
*------------------------------------------------------------
* Each window in a display consists of a set of dynamic graphic objects.
* These graphic objects respond to data changes from a set of connected channels
* Each window has a comm table created for its connected channels,
* consisting of a com record for each channel
*------------------------------------------------------------
*/
struct gsdl_com_record
	{
	chid pChan;  /* stores the chan access chan id */
	evid pevid;  /* event id for cleaing ca event on this chan */
	unsigned char valid_data; /* flags if data has been written for this chan */
	int count;  /* stores the graphic object's dl_hdr list connect count */
	int *pMod_bits; /* a bit for each graphics objects connection */
			/* set by arrival of event data */
	void *pData_struct; /* struct where channel's event data is stored */
	unsigned char connected; /* flags that channel is connected */
	};

/*
*------------------------------------------------------------
* A display screen consists of many windows.  These windows of a display
* are represented as a linked list.  Each list element points to that
* window's com table.
*------------------------------------------------------------
*/
struct gsdl_com_llist_element
	{
	struct gsdl_com_llist_element *pNext_element; /* ptr to next window's */
						/* com table */
	struct dl_hdr *pDl_hdr; /* ptr to hdr of dyn obj list for this window */
	struct gsdl_com_record *pCom_table; /* ptr to first record of the */
					/* window's com table */
	int ints_per_chan; /* number of ints used to represent the mod bits */
			/* for every channel in table */
	};

/*
*------------------------------------------------------------
* The Display Manager's screen will change as the operator opens and
* closes windows.  Each change is indicated by the new_llist_flag, along
* with a pointer the the first element of this new linked list.
*------------------------------------------------------------
*/
struct gsdl_com_llist_controller
	{
	char new_llist_flag; /* set by Disp Mgr indicating a new window list */
	struct gsdl_com_llist_element *pNew_llist; /*ptr to the first element */
					/* of this linked list */
	};


