/*plain_menus.h,v 1.1.1.1 1999/08/03 14:44:04 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#ifndef INCplain_menush
#define INCplain_menush


void	init_menu();
void 	*create_menu();
int	post_menu();
 
/*
 * "plain_menus" are posted after a button click in some X Window.
 * Certain event masks must be set on this window for plain menus 
 * to work correctly. Since this window can be an application window
 * the application program must set these masks on it for his menu
 * to operate properly.
 * I have provided "PLAIN_MENU_MIN_EVENT_MASK" for this purpose.
 * This mask must be or'd in with any other event masks needed when 
 * creating a window which will have a plain_menu popup menu.
 * 
 * ButtonPressMask and ButtonReleaseMask are needed to initiate a
 * passive grab. Button3MotionMask is needed for the menu panes
 * to highlight properly. A "plain_menus" menu will not operate
 * properly if posted from a window with OwnerGrabButtonMask set.
 *
 */
#define PLAIN_MENU_MIN_EVENT_MASK \
(ButtonPressMask|ButtonReleaseMask|Button3MotionMask)

struct jump_table{
	void			(*func)();
	void			*arg;
};

#define SUBMENUNEEDED		( (void (*)()) (-1) )

struct menu_configuration{
	char			*pname;
	char 			**pchoices;
	struct jump_table	*pactions;

	/* the following are filled in at runtime init */
	unsigned short		ht;
	unsigned short		wd;
	unsigned short		total_ht;	/* includes sub	menus 		*/
	unsigned short		total_wd;	/* includes sub menus 		*/
	short			inactive_wd; 	/* no unsgn so cmpr with -x wks */
	unsigned short		nchoices;	/* n panes			*/
	unsigned short		selection;
};


#endif
