/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/***
 *** Print Utilities (currently supporting only PostScript)
 ***
 *** MDA - 28 June 1990
 ***/

#include <memLeak.h>
#include <stdio.h>
#ifdef WIN32
#include <time.h>
#include <process.h>
#else
#include <sys/time.h>
#endif WIN32

#ifdef AXP
#include <stdlib.h>
#include <string.h>
#endif

#include <X11/Xlib.h>
#ifdef WIN32
#include <X11/XlibXtra.h>

FILE *xwdin;
FILE *xwdout;
FILE *xwderr;
#else
#define xwdin stdin
#define xwdout stdout
#define xwderr stderr
#endif WIN32
/*
 * routine through which all graphic print requests are channeled
 */


void utilPrint(display,window,fileName)
  Display *display;
  Window window;
  char *fileName;
{
  char *commandBuffer, *newFileName, *psFileName, *getenv();
  char labelString[28];
#ifndef WIN32
  struct timeval tp;
  struct timezone tzp;
#endif WIN32
  time_t seconds;
  FILE *fo;

#ifdef WIN32
  /* provide std handles to X-windows program */
  xwdin = fopen ("\\tis4000\\temp\\stdin", "wb");
  xwdout = fopen ("\\tis4000\\temp\\stdout", "wb");
  xwderr = fopen ("\\tis4000\\temp\\stderr", "wb");
#endif WIN32

  if (getenv("PSPRINTER")== NULL) {
     fprintf(xwderr, "\nseqlPrint: PSPRINTER environment variable not set, printing disallowed\n");
     return;
  }
  if (display == NULL || window == 0 || fileName == NULL) {
     return;
  }

#ifndef WIN32
  /* this is totally unecessary! (agi) */
  gettimeofday(&tp,&tzp);
#endif WIN32
  seconds = time(NULL);
  newFileName = (char *) calloc(1,256);
  sprintf(newFileName,"%s%d",fileName,seconds);

  sprintf(labelString,"%c%s%c",'\"',ctime(&(seconds)),'\"');

  commandBuffer = (char *) calloc(1,256);

  xwd(display, window, newFileName);

  newFileName = (char *) calloc(1,256);
  sprintf(newFileName,"%s%d",fileName,seconds);
  psFileName = (char *) calloc(1,256);
  sprintf(psFileName,"%s%s",newFileName,".ps");

{
  char *myArgv[5];
  int myArgc;

  myArgv[0] = "xwd2ps";
  myArgv[1] = "-d";
  myArgv[2] = "-t";
  myArgv[3] = "-x";	/* display the window title as the printout title */
  myArgv[4] = newFileName;
  myArgc = 5;

  fo = fopen(psFileName,"w+b");
  if (fo == NULL) {
      fprintf(xwderr,"\nutilPrint:  unable to open file: %s",psFileName);
    return;
  }
  xwd2ps(myArgc,myArgv,fo);
  fclose(fo);

}

#ifdef WIN32
  strcpy (commandBuffer, "/d:");
  strcat (commandBuffer, getenv("PSPRINTER"));
  _spawnl(_P_DETACH, "print", "print", commandBuffer, psFileName, NULL);
#else
  strcpy(commandBuffer,"lpr -P$PSPRINTER ");
  strcat(commandBuffer, psFileName);
  system(commandBuffer);
  strcpy(commandBuffer,"rm ");
  strcat(commandBuffer,newFileName);
  system(commandBuffer);
  strcpy(commandBuffer,"rm ");
  strcat(commandBuffer,psFileName);
  system(commandBuffer);
#endif WIN32
  free (commandBuffer);
  free (newFileName);
  free (psFileName);
}
