/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/***********************************************************************************************
    pagerdefs.h

    This header file contains the definitions for the digital pager interface dBase file creation.

    K.Grimes   February 1994 
***********************************************************************************************/
#include   <d4all.h>

#define    MAX_PHONE        11
#define    MAX_NAME         25
#define    MAX_SHIFT         6
#define    MAX_PIN           7

char  path[] = "/tis4000db";

/*  Point Grouping Table */

F4FIELD_INFO    pointgroup_flds[] = {
      /* Field name,            Type,      Width,     Decimals */
      { "TAG",                  'C',       1,         0 },
      { "POINTNAME",            'C',       28,        0 },
      { "AREANUM",              'N',       3,         0 },
      { "MESSAGE",              'C',       80,        0 },
      { 0, 0, 0, 0 }            /* NULL - record terminator */
};

/*  Tag for Point Grouping Table */

T4TAG_INFO    pointgroup_tag[] = {
     /* Tag name,      Key Expression,    Filter Expression,     Unique,     Descending */
     { "POINTNAME",    "POINTNAME",       0,                     0,          0 },
     { 0, 0, 0, 0, 0 } /* NULL - record terminator */
};

/*  Shift Table */

F4FIELD_INFO    shift_flds[] = {
     /* Field name,            Type,       Width,     Decimals */
     { "SHIFTNAME",            'C',        6,        0 },
     { "WEEKDAY",              'N',        1,         0 }, /* SUNDAY=1, SATURDAY=7 */
     { "STARTHOUR",            'N',        2,         0 }, /* assumes, HHMM, in military time */
     { "STARTMIN",             'N',        2,         0 }, 
     { 0, 0, 0, 0 }            /* NULL - record terminator */
};


/*  Tag for Shift Schedule Table */

T4TAG_INFO    shift_tag[] = {
     /* Tag name,      Key Expression,    Filter Expression,     Unique,     Descending */
     { "DAYTIME",    "STR(WEEKDAY,1)+STR(STARTHOUR,2)+STR(STARTMIN,2)",       0,                     0,          0 },
     { 0, 0, 0, 0, 0 } /* NULL - record terminator */
};


/*   Schedule Table */

F4FIELD_INFO    schedule_flds[] = {
     /* Field name,            Type,       Width,     Decimals */
     { "OPERATOR",             'C',        25,        0 },
     { "PIN",                  'C',         7,        0 },
     { "AREA",                 'N',         3,        0 },
     { "SHIFT",                'C',         6,        0 },
     { 0, 0, 0, 0 }            /* NULL - record terminator */
};


/*  Tag for Schedule Table */

T4TAG_INFO    schedule_tag[] = {
     /* Tag name,      Key Expression,    Filter Expression,     Unique,     Descending */
     { "AREA",       "STR(AREA, 3)",        0,                     0,          0 },
     { 0, 0, 0, 0, 0 } /* NULL - record terminator */
};
