/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*******************************************************************************
 * 	PROGRAM NAME:	translate_db_link.c
 *	PURPOSE	    :	The purpose of translate_db_link.c is to translate
 *                      the input filename of a database currently contained
 *                      in the /tis4000db to the absolute_filename.  The link
 *                      name is bypassed.
 *
 *	AUTHOR	    :	Adapted from CleanSnap.c 
 *	DATE	    :	8/94
 *
 ******************************************************************************/
#include <sys/stat.h>

void   translate_db_link(filename, absolute_filename)

char   filename[1000];
char   absolute_filename[1000];

{
	int		sc;
	struct stat	statInfo;
	char		pathData[1000];	/* Buffer for translating file link(s). */
	char		fileData[1000];	/* Buffer for translating file link(s). */
	char		fileToTranslate[1000];
	char		filePath[1000];

	/* Translate /tis4000db */

	memset( pathData, 0, sizeof( pathData ));
	memset( fileData, 0, sizeof( fileData ));
	memset( absolute_filename, 0, sizeof( absolute_filename ));
	memset(fileToTranslate, 0, sizeof( fileToTranslate ));

	sc = readlink( "/tis4000db", pathData, sizeof pathData );

        sprintf(fileToTranslate, "/tis4000db/%s", filename);

	sc = lstat( fileToTranslate, &statInfo );

#ifdef MIPSEL
	sc = (( statInfo.st_mode & S_IFLNK ) == S_IFLNK);	/* st_mode is bit-encoded */
#else
	sc = S_ISLNK( statInfo.st_mode );
#endif
	if(sc)  {

	    sc = readlink( fileToTranslate, fileData, sizeof fileData );

	    if( fileData[0] == '/' )  {
		/* File is a link to a different file system.  Don't concatenate. */
		strcpy( absolute_filename, fileData );
	    }
	    else  {
		sprintf( absolute_filename, "%s/%s",  pathData, fileData );
	    }
	}
	else  {
	    sprintf( absolute_filename, "%s/%s", pathData, filename );
	}
}
