/* d4all.h   (c)Copyright Sequiter Software Inc., 1991-1994. All rights reserved. */

#ifndef D4ALL_INC
#define D4ALL_INC

#define	S4UNIX

/**********************************************************************/
/**********            USER SWITCH SETTINGS AREA            ***********/

/* Index File compatibility options */
/* #define S4FOX     */
/* #define S4CLIPPER */
#define S4MDX
/* #define S4NDX     */

/* Specify Operating Environment or Screen Output Option - Default is DOS */
/* #define S4DLL          */
/* #define S4WINDOWS      */
/* #define S4WIN32        */  /* Windows NT */
/* #define S4CONSOLE      */  /* NT Console application */
/* #define S4OS2          */  /* OS/2 CONSOLE STATIC LIBRARY */
/* #define S4OS2DLL       */  /* OS/2 CONSOLE DLL LIBRARY */
/* #define S4OS2PM        */  /* OS/2 PM LIBRARY, NEED TO DEFINE S4OS2DLL */
/* #define S4SUN          */  /* requires Multi-Platform Version */
/* #define S4DEC          */
/* #define S4SOLARIS      */ /* requires Multi-Platform Version */
/* #define S4HPUX         */ /* requires Multi-Platform Version */
/* #define S4AIX          */ /* requires Multi-Platform Version */
/* #define S4SGI          */ /* requires Multi-Platform Version */
/* #define S4SCO          */ /* requires Multi-Platform Version */
/* #define S4COHERENT     */ /* requires Multi-Platform Version */
/* #define S4UNIXWARE     */ /* requires Multi-Platform Version */
/* #define S4INTERACTIVE  */ /* requires Multi-Platform Version */
/* #define S4MACINTOSH    */ /* requires Multi-Platform Version */
/* #define S4CODE_SCREENS */
/* #define S4CONTROLS     */ /* for use with CodeControls DLL */
/* #define S4VBX          */ /* for use with CodeControls VBX */
/* #define S4PASCAL_DOS   */ /* Borland Pascal for DOS DLL */
/* #define S4PASCAL_WIN   */ /* Borland Pascal for Windows DLL */

/* General Configuration Options */
/* #define S4DEBUG	*/
/* #define S4DEBUG_DEV    */
/* #define S4ERROR_HOOK   */
/* #define S4LOCK_CHECK   */
/* #define S4LOCK_HOOK    */
/* #define S4MAX          */
/* #define S4MEMO_OFF     */
/* #define S4OFF_ERROR    */
/* #define S4OFF_INDEX    */
/* #define S4OFF_MEMO     */
/* #define S4OFF_MULTI    */
/* #define S4OFF_OPTIMIZE */
#define S4OFF_REPORT
/* #define S4OFF_WRITE    */
/* #define S4OLD_CODE     */
/* #define S4OPTIMIZE_OFF */
/* #define S4SAFE         */
/* #define S4SINGLE */

/**********************************************************************/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#ifdef S4SUN
#define S4UNIX
#endif

#ifdef S4DEC
#define S4UNIX
#endif

#ifdef S4SOLARIS
#define S4UNIX
#endif

#ifdef S4HPUX
#define S4UNIX
#endif

#ifdef S4AIX
#define S4UNIX
#endif

#ifdef S4SGI
#define S4UNIX
#endif

#ifdef S4SCO
#define S4UNIX
#endif

#ifdef S4COHERENT
#define S4UNIX
#endif

#ifdef S4UNIXWARE
#define S4UNIX
#endif

#ifdef S4INTERACTIVE
#define S4UNIX
#endif

#ifdef S4MACINTOSH
#define S4UNIX
#endif

#ifdef S4UNIX
#include <p4port.h>
#else
#include <limits.h>
#include <io.h>
#include <stdarg.h>
#endif

#ifdef S4VB_DOS
#include <v4names.h>
#endif

#include <d4defs.h>
#include <d4data.h>
#include <d4declar.h>
#include <f4flag.h>
#include <e4expr.h>
#include <s4sort.h>
#include <e4error.h>

#include <o4opt.h>

#ifdef S4WINDOWS
#include <windows.h>
#else
#ifdef S4WIN32
#include <windows.h>
#endif
#endif

#include <r4relate.h>

#ifdef S4VBX
#ifndef S4CONTROLS
#define S4CONTROLS
#endif
#endif

#ifdef S4VB_DOS
#include <v4dos.h>
#endif

#ifndef S4OFF_REPORT
#include <r4report.h>
#endif

#ifdef S4CODE_SCREENS
#include <w4.h>
#endif

#define S4VERSION  5104

#endif

/* Migration from 4.5 to 5.1 macros */

#define	CB51

#define	C4CODE		CODE4
#define	D4DATA		DATA4
#define	F4FIELD		FIELD4
#define	T4TAG		TAG4
#define	F4FIELD_INFO	FIELD4INFO
#define I4INDEX		INDEX4
#define	T4TAG_INFO	TAG4INFO

#define	d4flush_record	d4flush_data
#define	m4assign	f4memo_assign
#define	m4str		f4memo_str
#define m4ncpy		f4memo_ncpy
#define m4ptr		f4memo_ptr
#define m4assign_n	f4memo_assign_n
#define a4long		date4long

/* These redefine a number of codebase functions so that the
  redundant versions are used instead of the normal ones. */

#define	d4append	red_d4append
#define	d4append_blank	red_d4append_blank
#define	d4append_start	red_d4append_start
#define	d4blank		red_d4blank
#define	d4bottom	red_d4bottom
#define	d4close		red_d4close
#define	d4close_all	red_d4close_all
#define	d4create	red_d4create
#define	d4delete	red_d4delete
#define	d4field		red_d4field
#define	d4flush_all	red_d4flush_all
#define	d4go		red_d4go
#define	d4init		red_d4init
#define	d4lock_file	red_d4lock_file
#define	d4open		red_d4open
#define	d4pack		red_d4pack
#define	d4seek		red_d4seek
#define	d4skip		red_d4skip
#define	d4tag_select	red_d4tag_select
#define	d4top		red_d4top
#define	d4unlock_all	red_d4unlock_all
#define	e4exit_test	red_e4exit_test
#define	f4assign	red_f4assign
#define	f4assign_double	red_f4assign_double
#define	f4assign_int	red_f4assign_int
#define	f4assign_long	red_f4assign_long
#define	f4assign_n	red_f4assign_n

extern	int	red_d4append ();
extern	int	red_d4append_blank ();
extern	int	red_d4append_start ();
extern	void	red_d4blank ();
extern	int	red_d4bottom ();
extern	int	red_d4close ();
extern	void	red_d4close_all ();
extern	D4DATA	*d4create ();
extern	void	red_d4delete ();
extern	F4FIELD	*red_d4field ();
extern	int	red_d4flush_all ();
extern	int	red_d4go ();
extern	void	red_d4init ();
extern	int	red_d4lock_file ();
extern	D4DATA	*red_d4open ();
extern	int	red_d4pack ();
extern	int	red_d4seek ();
extern	int	red_d4skip ();
extern	T4TAG	*red_d4tag ();
extern	void	red_d4tag_select ();
extern	int	red_d4top ();
extern	int	red_d4unlock_all ();
extern	int	red_d4update_header();
extern	void	red_e4exit_test ();
extern	void	red_f4assign ();
extern	void	red_f4assign_double ();
extern	void	red_f4assign_int ();
extern	void	red_f4assign_long();
extern	void	red_f4assign_n ();

