/*redflib.c,v 1.1.1.1 1999/08/03 14:44:28 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/****************************************************************/
/*								*/
/*	LIBRARY OF ROUTINES FOR MANAGING LISTS OF FIELDS	*/
/*		REQUIRING REDUNDANT UPDATES			*/
/*								*/
/*	This library is a collection of routines that are	*/
/*	used to manage the lists of fields that require		*/
/*	redundant updates.					*/
/*								*/
/****************************************************************/

/****** MOD LOG
01/30/93	GMU	410-581-0422	uchenick@tate.com
	Original entry
******/

/****************************************************************/
/*								*/
/*			INCLUDE FILES				*/
/*								*/
/****************************************************************/

#include <vxWorks.h>
#include <stdlib.h>

#include "dbDefs.h"
#include "dbRecType.h"
#include "redflds.h"
#include "pvd.h"


/****************************************************************/
/*								*/
/*		ALLOCATE A FIELD LIST FOR A TYPE		*/
/*								*/
/****************************************************************/

struct fldDes **redFldAlloc(type, nfields)
int	type;		/* point type */
int	nfields;	/* number of fields */
{
	if (!papRedFldList)
		return (0);	/* No global list allocated yet */
	if (!GET_PRECTYPE(type))
		return (0);	/* Illegal record type */

	papRedFldList[type] = (struct fldDes **)
			calloc(nfields + 1, sizeof(struct fldDes *));
	return (papRedFldList[type]);
}


/****************************************************************/
/*								*/
/*		ADD A FIELD TO THE FIELD LIST			*/
/*								*/
/****************************************************************/

int redFldAdd(type, index, field)
int	type;		/* point type */
int	index;		/* slot position */
char	*field;		/* <= 4 char field tag */
{
	if (!papRedFldList)
		return (0);	/* No global list allocated yet */
	if (!papRedFldList[type])
		return (0);	/* Record type not allocated yet */
	if (index < 0)
		return (0);	/* Illegal field number */
	papRedFldList[type][index] = pvdGetFld(type, field);
	if (!papRedFldList[type][index])
		return (-1);
	else
		return (0);
}
