/*clearca.c,v 1.1.1.1 1999/08/03 14:44:29 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*	@(#)clearca.c
 *   @(#)clearca.c	1.0 2/2/93
 *	Author:	Grant Irani
 *		irani@tate.com
 *		(410) 581-0422
 *	Date:	2/2/93
 *
 *
 * 	Modification Log:
 * 	-----------------
 */

#include <vxWorks.h>
#include <lstLib.h>
#include <types.h>
#include <socket.h>
#include <ioLib.h>
#include <in.h>
#include <tcp.h>
#include <errno.h>
#include <task_params.h>
#include <dbDefs.h>
#include <dbCommon.h>
#include <db_access.h>
#include <server.h>
#include <restable.h>

void
clearCA(rp)
	RES_TABLE *rp;
{
	FAST struct client *client;
	FAST struct channel_in_use *pchannel;
	FAST struct extmsg *mp;
	FAST int	client_msgs;
	FAST int	status;
        FAST struct event_ext *pevext;
        LIST            *peventq;

	struct sockaddr_in last_addr;

	if (CASDEBUG > 2)
		logMsg ("CAS: clearing channels for lost resource %s\n",
			rp->resourceName);

	/* scan all client structures */
	client = (struct client *) & clientQ;
	while (client = (struct client *) client->node.next) {
		client_msgs = 0;
                /* scan all channels in this client */
		pchannel = (struct channel_in_use *) & (client->addrq);
		while (pchannel = (struct channel_in_use *) pchannel->node.next) {

			/* if the channel is based on the argument resource */
			if (rp == ((struct dbCommon *)pchannel->addr.precord)->radr) {
				/* the following lines are handy for seeing the release process */
				if (CASDEBUG > 2) {
 					printErr ("releasing client %lx chan %s chid %lx\n",
					     client,
					     ((struct dbCommon *)pchannel->addr.precord)->name,
					     pchannel->chid);
				}
                                /* clear any event monitors */
                                while (pevext = (struct event_ext *) lstGet(&pchannel->eventq)) {
                                        status = db_cancel_event(pevext + 1);
                                        if (status == ERROR)
                                                taskSuspend(0);
  
                                        FASTLOCK(&rsrv_free_eventq_lck);
                                        lstAdd(&rsrv_free_eventq, pevext);
                                        FASTUNLOCK(&rsrv_free_eventq_lck);
                                }

				/* send a LOST_RESOURCE message to client */
		 		LOCK_CLIENT(client);
				mp = (struct extmsg *) ALLOC_MSG(client, 0);

				/* build msg header	 */
				mp->m_cmmd = htons(IOC_LOST_RESOURCE);
				mp->m_postsize = 0;
				mp->m_available = (long) pchannel->chid;
				mp->m_type = 0;
				mp->m_count = 0;
				mp->m_pciu = pchannel->chid;

                                /* set the marker for forwarding to client */
				END_MSG (client);
				UNLOCK_CLIENT (client);
				client_msgs++;
				lstDelete(&client->addrq, pchannel);
				FASTLOCK(&rsrv_free_addrq_lck);
				lstAdd(&rsrv_free_addrq, pchannel);
				FASTUNLOCK(&rsrv_free_addrq_lck);
				/* restart scan from beginning since we changed the list */
				pchannel = (struct channel_in_use *) & (client->addrq);
                       }
		}
		if (client_msgs) {
			cas_send_msg(client, TRUE);
		}
	}
}

