/*declareNameServer.c,v 1.1.1.1 1999/08/03 14:44:29 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		DECLARE INTERNET ADDRESS FOR NAME SERVER	*/
/*								*/
/*	In the IOC, a name server on a workstation is used.	*/
/*	This routine is called from startup.cmd to declare	*/
/*	the internet address for each name server. This		*/
/*	routine can be called up to ten times for each IOC.	*/
/*	It should be called PRIOR to iocInit(). The argument	*/
/*	is the Inet address of the node that contains the	*/
/*	name server in quotes. Example:				*/
/*		declareNameServer("192.246.18.1")		*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#include <vxWorks.h>
#include <inetLib.h>
#include <logLib.h>
#include <in.h>

extern struct in_addr	namAddrs[10];
extern int	numNames;

int declareNameServer(char *addr)
{
    int		inetAddr;

    if ((inetAddr = inet_addr(addr)) != ERROR)
	{
	namAddrs[numNames].s_addr = inetAddr;
	numNames++;
	}
    else
	logMsg ("Internet address %s is illegal -- ignored\n",
		(int)addr,0,0,0,0,0);

    return (0);
}
