/*mapTypes.c,v 1.1.1.1 1999/08/03 14:44:30 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		MAP BETWEEN THE NEW AND OLD DATA TYPES		*/
/*								*/
/*	The routines in dbAccess.c use the type definitions	*/
/*	in dbFldTypes.h. Channel access applications use the	*/
/*	definitions in db_access.h. Unfortunately, these	*/
/*	two header files define a different set of numbers	*/
/*	to declare the same attributes. Even more unfortunate,	*/
/*	they use the same names for these different values.	*/
/*	The perpetrator of this vile deed should be forced	*/
/*	to listen to endless repititions of Debby Boone singing	*/
/*	"You light up my life" while reading "How to Win	*/
/*	Friends and Influence People" by Andrew Dice Clay.	*/
/*	In any case, these two routines translate between	*/
/*	the old and new data types.				*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#include "dbFldTypes.h"		/* The "new" data types */
#include "dataTypes.h"		/* The "old" data types */
#include "mapTypes.h"


/******
	Tables for data mapping.
******/

int new2old[] =
    {

    /* The "old" type */	/* The "new" type */

    AGNT_STRING,		/* DBR_STRING */
    AGNT_CHAR,			/* DBR_CHAR   */
    AGNT_CHAR,			/* DBR_UCHAR  */
    AGNT_SHORT,			/* DBR_SHORT  */
    AGNT_SHORT,			/* DBR_USHORT */
    AGNT_LONG,			/* DBR_LONG   */
    AGNT_LONG,			/* DBR_ULONG  */
    AGNT_FLOAT,			/* DBR_FLOAT  */
    AGNT_DOUBLE,		/* DBR_DOUBLE */
    AGNT_ENUM,			/* DBR_ENUM   */
    };

int old2new[] =
    {

    /* The "new" type */	/* The "old" type */

    DBR_STRING,			/* AGNT_STRING */
    DBR_SHORT,			/* AGNT_SHORT  */
    DBR_FLOAT,			/* AGNT_FLOAT  */
    DBR_ENUM,			/* AGNT_ENUM   */
    DBR_CHAR,			/* AGNT_CHAR   */
    DBR_LONG,			/* AGNT_LONG   */
    DBR_DOUBLE,			/* AGNT_ENUM   */
    };


/******
	The mapping functions
******/

int mapNew2Old(short newVal)
{
    return (new2old[newVal]);
}

int mapOld2New(short oldVal)
{
    return (old2new[oldVal]);
}
