
#include <stdio.h>		/* definitions for std sys routines */
#include <conio.h>		/* definitions for console routines */
#include "client.h"		/* client library definitions */

#define	    MAXPUBLICITEMS	    1000

#include "demoMsgs.h"

CLIENT *client;			/* client control structure pointer */

/* local routines */
static int GetFileData ( char * );

/* Small client program -
**
**	Find a server, and display result
**	Request file from server
**	Get response
**	Print file
**	Wait for keystroke (allows pview to show server executing on host)
**	Exit
*/
#define srvNameSize 80

void main (int argc, char *argv[])
{
    char    serverName [srvNameSize];

    /* open demo data server */
    if (argc == 3)
	strncpy (serverName, argv[2], srvNameSize);
    else
	strncpy (serverName, "", srvNameSize);
    strncat (serverName, ":FileData", srvNameSize);
    client = OpenServer (serverName, 1);
    if (client == NULL)
    {
	printf ("Unable to find a server program.\n");
	exit (1);
    }
    else
    {
	printf ("Connected to %s\n", client->SrvID);
    }

    if (argc < 2)
    {
	printf ("Usage: client <filename> [<server_host>]\n");
	printf ("   Prints contents of filename on local machine\n");
	exit (1);
    }

    if (GetFileData (argv[1]) == FALSE)
    {
	printf ("Failed to get file information.\n");
	exit (1);
    }

    /* wait for a console keystroke */
    _getch ();

    /* close session to server */
    CloseSession (client);
    printf ("Client demo finished.\n");
    exit (0);
}


static int GetFileData ( char *file )
{
    FileMsg  filereq;		/* data request message */
    FileRsp  *filersp;		/* pointer to response data */
    int	    result;		/* DB result from server */
    char    *filetextbuffer;	/* place to keep result text */
    /*
    ** get first part of data
    */
    filereq.type = htons (GET_FILEDATA);
    filereq.req_filePosition = htons (0);
    strncpy (filereq.filename, file, 79);
    filersp = (FileRsp *)SendReq(client, &filereq, sizeof(filereq));
    if (filersp == NULL)
    {
	printf ("Server failed to respond.\n");
	return FALSE;
    }
    result = ntohs(filersp->result);
    if (result != TRUE)
    {
	free (filersp);
	return result;
    }
    /* fixup any host representation problems */
    filersp->fileTotalSize = ntohl(filersp->fileTotalSize);
    filersp->filePosition = ntohl(filersp->filePosition);
    filersp->fileDataSize = ntohs(filersp->fileDataSize);
    /*
    ** Allocate memory for the data
    */
    filetextbuffer = (char *) calloc (filersp->fileTotalSize+1, 1);
    /*
    ** copy data into area, and ask for more, if needed.
    */
    memcpy (filetextbuffer+filersp->filePosition, filersp->fileData, filersp->fileDataSize);
    /* Fetch additional segments of information */
    while ((filersp->filePosition + filersp->fileDataSize) < filersp->fileTotalSize)
    {
	filereq.req_filePosition = htonl (filersp->filePosition + filersp->fileDataSize);
	/* finished with preceding response, so free it */
	free (filersp);
	/* get next response */
	filersp = (FileRsp *)SendReq(client, &filereq, sizeof(filereq));
	if (filersp == NULL)
	{
	    printf ("Server failed to respond.\n");
	    return FALSE;
	}
	result = ntohs(filersp->result);
	if (result != TRUE)
	{
	    free (filersp);
	    return result;
	}
	filersp->filePosition = ntohl(filersp->filePosition);
	filersp->fileDataSize = ntohs(filersp->fileDataSize);
	memcpy (((char *)filetextbuffer)+filersp->filePosition, filersp->fileData, filersp->fileDataSize);
    }
    free (filersp);

    /* Print out collected data */
    printf (filetextbuffer);
    /* return result from last server response */
    return TRUE;

}

