/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* tisservice.h - service header file for tis client/server
**
*/

#ifndef TISSERVICE_H
#define TISSERVICE_H

#include "tisByteOrder.h"

#define TISSERVERPORT		8001	/* port used for service access */


#define SOFTWARE_LEVEL	0x0010	/* software level 1.0 */

/* message type IDs */
#define SVCREQ		0
#define SVCRESP		1
#define CONNREQ		2
#define	CONNRSP		3
#define	SRVREQ		4
#define	SRVRSP		5
#define	SRVMSG		6

/* UDP/TCP service request/signon message */
typedef struct {
    short int	type;		/* message type */
    short int	pad1;		/* allignment for dumb compilers */
    long	sftlvl;		/* client software level ID */
    char	service[40];	/* service name desired */
} SvcReq;
/* UDP service response sent from server */
typedef struct {
    short int	type;		/* message type (SVCRESP) */
    short int	pad1;		/* allignment for dumb compilers */
    long	sftlvl;		/* server software level ID */
} SvcResp;

/* server request format */
typedef struct {
    short int	type;		/* message type (SRVREQ) */
    short int	seq;		/* request sequence number or */
    				/* reply sequence number (from request) */
    short int	pad1;		/* allignment for dumb compilers */
    short int	userlength;	/* length of message data */
} ServHdr;

typedef struct {
    void	*next;
    ServHdr	hdr;
    char	*data;
} SVRMSG;

#endif TISSERVICE_H
