#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32
#include "stdio.h"
#include "time.h"
#include "ctype.h"
#include "fcntl.h"

#if !(defined(MIPSEL) || defined(AXP))
#include "memory.h"
#else
#include <sys/types.h>
#include <sys/stat.h>
extern int lstat ();
extern int readlink ();
#endif

#include "trend_defines.h"
#include "trendutils.h"
#include "client.h"
#include "trenddata.h"
#include "trclient.h"

CLIENT *client;		/* the client control structure */

char	*dbreducs [] = { "SMP", "AVG", "MIN", "MAX" };
char	* RedStrings [C_NEWRADIOBUTTONS] = { "SMP", "AVG", "MIN", "MAX", "BAR" };

char	*sev = "VMmIE";
#define NUMSEV 5
char	*qual = "*QCqF"; /* in precedence order*/
#define NUMQUAL 5
char	*alms = "FuBEKUXTIRGNcMCSrHhLlW ";
#define NUMALM 22

/* ar_snap data items */
int	pointstarttime; /* records first time for point */
int	lastpointtime;	/* records last time for point */
RecRsp	*recResponse;	/* last query result */
int	recItem;	/* current item index */

ReqUnion    rqmsg;

void snapinit ()
{
    /* open trend data server */
    client = OpenServer (":TrendData", 1, NULL);
}

int myOperPriv (group)
char *group;
{
    PrivRsp *answer;
    int	    result;

    PrivMsg *priv = (PrivMsg *)&rqmsg;
    priv->type = htons (GET_PRIV);
    strncpy (priv->opname, "Joe User", sizeof(priv->opname));
    strncpy (priv->pass, "joepass", sizeof(priv->pass));
    strncpy (priv->group, group, sizeof(priv->group));
    answer = (PrivRsp *)SendReq(client, priv, sizeof(*priv));
    if (answer == NULL)
    {
	return FALSE;
    }
    result = ntohs(answer->value);
    free (answer);
    return result;
}

int opentrendfile ()
{
    /* noop in client, automatic with server connect */
    return DBOK;
}

short trendPosition;
TrNamesRsp *trNameResponse;

char *FirstTrend ( )
{
    int	    result;
    TrNamesMsg *trend = (TrNamesMsg *)&rqmsg;

    if (trNameResponse)
	free (trNameResponse);

    trend->type = htons (GET_TRENDNAMES);
    trend->position = htons (0);
    trNameResponse = (TrNamesRsp *)SendReq(client, trend, sizeof(*trend));
    if (trNameResponse == NULL)
    {
	return NULL;
    }
    result = ntohs(trNameResponse->value);
    trNameResponse->position = ntohs(trNameResponse->position);
    trNameResponse->count = ntohs(trNameResponse->count);
    trendPosition = 0;
    return NextTrend ();
}

char *NextTrend ( )
{
    if (trNameResponse == NULL)
    {
	return NULL;
    }
    else if ((trendPosition - trNameResponse->position) >= trNameResponse->count)
    {
	int	    result;
	TrNamesMsg *trend = (TrNamesMsg *)&rqmsg;

	free (trNameResponse);

	trend->type = htons(GET_TRENDNAMES);
	trend->position = htons(trendPosition);
	trNameResponse = (TrNamesRsp *)SendReq(client, trend, sizeof(*trend));
	if (trNameResponse == NULL)
	{
	    return NULL;
	}
	result = ntohs(trNameResponse->value);
	trNameResponse->position = ntohs(trNameResponse->position);
	trNameResponse->count = ntohs(trNameResponse->count);
	if (trNameResponse->count == 0)
	{
	    free (trNameResponse);
	    return NULL;
	}
    }
    return (trNameResponse->trendDescriptors[(trendPosition++)
					    - trNameResponse->position]);
}

void RelTrends ( )
{
    /* noop on client */
}

int closetrends ()
{
    /* noop on client */
    return r4success;
}

int opennotefile (create)
int create;
{
    /* noop on client */
    return r4success;
}

/* static storage for current note pointname */
char notepoint [C_PTNMLEN];
NoteRsp *noteResponse;

long    GetNote ( pointname, time )
char *pointname;
long time;
{
    char    *sp;
    NoteMsg *note = (NoteMsg *)&rqmsg;

    if (noteResponse)
	free (noteResponse);

    if (ResolveName (notepoint, pointname, sizeof(notepoint)) == NULL)
	return 0x7fffffff;
    if (notepoint[0] == '>')
    {
        strncpy (notepoint, &notepoint[1], 28);
    }
    /* strip reduction type, and blank fill */
    if (sp = strchr (notepoint, '.'))
        *sp = 0;
    note->type = htons(GET_NOTE);
    strncpy (note->pointname, notepoint, sizeof(note->pointname));
    note->time = htonl(time);
    noteResponse = (NoteRsp *)SendReq(client, note, sizeof(*note));
    if (noteResponse == NULL)
    {
	return 0x7fffffff;
    }
    noteResponse->time = ntohl (noteResponse->time);
    return noteResponse->time;
}

long GetPrevNote ( pointname, time )
char *pointname;
long time;
{
    char    *sp;
    NoteMsg *note = (NoteMsg *)&rqmsg;

    if (noteResponse)
	free (noteResponse);

    if (ResolveName (notepoint, pointname, sizeof(notepoint)) == NULL)
	return 0x7fffffff;
    if (notepoint[0] == '>')
    {
        strncpy (notepoint, &notepoint[1], 28);
    }
    /* strip reduction type, and blank fill */
    if (sp = strchr (notepoint, '.'))
        *sp = 0;
    note->type = htons(GET_PREVNOTE);
    strncpy (note->pointname, notepoint, sizeof(note->pointname));
    note->time = htonl(time);
    noteResponse = (NoteRsp *)SendReq(client, note, sizeof(*note));
    if (noteResponse == NULL)
    {
	return 0x7fffffff;
    }
    noteResponse->time = ntohl (noteResponse->time);
    return noteResponse->time;
}

char *NotePoint ( )
{
    return notepoint;
}

char *ReadNote ( )
{
    if (noteResponse)
    {
        return noteResponse->note;
    }
    else
    {
        return ("~There is no notes file.");
    }
}

void SaveNote (pointname, time, text)
char *pointname;
long time;
char *text;
{
    char    *sp;
    NoteSaveMsg *note = (NoteSaveMsg *)&rqmsg;

    if (ResolveName (notepoint, pointname, sizeof(notepoint)) == NULL)
	return;
    if (notepoint[0] == '>')
    {
        strncpy (notepoint, &notepoint[1], 28);
    }
    /* strip reduction type, and blank fill */
    if (sp = strchr (notepoint, '.'))
        *sp = 0;
    note->type = htons(SAVE_NOTE);
    strncpy (note->pointname, notepoint, sizeof(note->pointname));
    note->time = htonl(time);
    strncpy (note->note, notepoint, sizeof(note->note));
    noteResponse = (NoteRsp *)SendReq(client, note, sizeof(*note));
    if (noteResponse)
    {
	noteResponse->time = ntohl (noteResponse->time);
    }
}

void    DeleteNote ( )
{
    if (noteResponse)
    {
	NoteSaveMsg *note = (NoteSaveMsg *)&rqmsg;

	note->type = htons(DEL_NOTE);
	strncpy (note->pointname, noteResponse->pointname, sizeof(note->pointname));
	note->time = htonl(noteResponse->time);
	free (noteResponse);
	noteResponse = (NoteRsp *)SendReq(client, note, sizeof(*note));
	if (noteResponse != NULL)
	{
	    free (noteResponse);
	}
	noteResponse = NULL;
    }
}

void RelNotes ( )
{
    /* noop on client */
}

int closenotes ()
{
    /* noop on client */
    return r4success;
}

int opensnap (dbfilename)
char *dbfilename;
{
    int	    result = DBSNAPERR;
    FileMsg *file = (FileMsg *)&rqmsg;
    FileRsp *fileRsp;

    file->type = htons(SELECT_FILE);
    strncpy (file->filename, dbfilename, sizeof(file->filename));
    fileRsp = (FileRsp *)SendReq(client, file, sizeof(*file));
    if (fileRsp)
    {
	result = ntohs(fileRsp->value);
	free (fileRsp);
    }
    return result;
}

int closesnap ()
{
    /* noop on client */
    return r4success;
}

long NextItem ()
{

    if (recResponse == NULL)
	return 0x7fffffff;

    /* get next record from data base */
    if (recItem == recResponse->samples)
    {
        if (!GetNextRec (recResponse->pointname, recResponse->dbreduc, 0))
           return 0x7fffffffL; /* somewhere in the far future */
	else
	    recItem = 0;
    }
    else
    {
	recItem++;
    }
    return (recResponse->time + (recItem * recResponse->rate));
}

int ItemRec ()
{
    return recResponse->rec;
}

int ItemField ()
{
    return recItem; /* corrects for preread value */
}

char *RecName ()
{
    return recResponse->pointname;
}

char *RecTag ()
{
    return recResponse->tag;
}

int RecReduc ()
{
    return recResponse->dbreduc;
}

double RecDispLo ()
{
    return recResponse->dl;
}

double RecDispHi ()
{
    return recResponse->dh;
}

long ItemTime ()
{
    if (recResponse)
	return (recResponse->time + (recItem * recResponse->rate));
    else
	return 0x7fffffff;
}

double ItemValue ()
{
    return recResponse->value[recItem];
}

char *ItemStatus ()
{
    return recResponse->status[recItem];
}

long RecRate ()
{
    return recResponse->rate;
}

long redPosition;
ReducRsp *redResponse;

char **GetReducs (cnt)
int *cnt;
{
    char    ** pvnames;
    char    *cp;
    int	    result;

    ReducMsg *reduc = (ReducMsg *)&rqmsg;

    *cnt = 0;

    reduc->type = htons(GET_REDUC);
    reduc->position = htons(0);
    redResponse = (ReducRsp *)SendReq(client, reduc, sizeof(*reduc));
    if (redResponse == NULL)
    {
	return NULL;
    }
    result = ntohs(redResponse->value);
    redResponse->position = ntohs (redResponse->position);
    redResponse->total = ntohs (redResponse->total);
    redResponse->count = ntohs (redResponse->count);

    pvnames = (char **)calloc (redResponse->total, sizeof(char *));
    for (*cnt = 0, cp = redResponse->names;
	 *cnt < redResponse->total;
	 *cnt = (*cnt) + 1)
    {
	pvnames[*cnt] = (char *)calloc (1, strlen (cp)+1);
	if (pvnames[*cnt])
	{
	    strcpy (pvnames [*cnt], cp);
	}
        cp = cp + strlen (cp)+1;
        if ((*cnt - redResponse->position) == (redResponse->count - 1))
	{
	    free (redResponse);
	    reduc->type = htons(GET_REDUC);
	    reduc->position = *cnt;
	    redResponse = (ReducRsp *)SendReq(client, reduc, sizeof(*reduc));
	    if (redResponse == NULL)
	    {
		return NULL;
	    }
	    result = ntohs(redResponse->value);
	    redResponse->position = ntohs (redResponse->position);
	    redResponse->total = ntohs (redResponse->total);
	    redResponse->count = ntohs (redResponse->count);
	    cp = redResponse->names;
	}
    }
    free (redResponse);
    return pvnames;
}

int CheckReduc (point, red)
char *point;
char *red;
{
    char ** pvnames;
    int	 cnt;
    char pointRed [40];

    if (point[0] == '>')
    {
	sprintf (pointRed, "%s|%s", &point[1], red);
    }
    else
    {
	sprintf (pointRed, "%s|%s", point, red);
    }
    
    pvnames = GetReducs(&cnt);

    for (; cnt; cnt--)
    {
	if (strcmp (pvnames[cnt-1], pointRed) == 0)
	{
	    for (; cnt; cnt--)
		free (pvnames[cnt-1]);
	    free (pvnames);
	    return 1;
	}
	free (pvnames[cnt-1]);
    }
    free (pvnames);
    return 0;
}

void RelPoints ()
{
    /* noop on client */
}

long GetTrendCount ()
{
    int	    result;
    long    trendCnt;

    TrNamesMsg *trend = (TrNamesMsg *)&rqmsg;

    if (trNameResponse)
	free (trNameResponse);

    trend->type = htons (GET_TRENDNAMES);
    trend->position = htons (0);
    trNameResponse = (TrNamesRsp *)SendReq(client, trend, sizeof(*trend));
    if (trNameResponse == NULL)
    {
	return 0;
    }
    result = ntohs(trNameResponse->value);
    trendCnt = ntohs(trNameResponse->count);
    free (trNameResponse);
    return trendCnt;
}

TrendRsp *trendResponse;

int GetTrendInfo ( descr, z, autoupdate, trspec )   /* load current trend set from database */
char *descr;
long *z;
long *autoupdate;
CHARSPEC trspec [];
{
    TrendMsg *trend = (TrendMsg *)&rqmsg;
    int	    i;

    trend->type = htons(GET_TREND);
    strncpy (trend->descr, descr, C_TRENDDESCLEN);
    trendResponse = (TrendRsp *)SendReq(client, trend, sizeof(*trend));
    if (trendResponse == NULL)
    {
	return FALSE;
    }
    if (ntohs(trendResponse->value))
    {
        *z = ntohl(trendResponse->zoom);
        *autoupdate = ntohl(trendResponse->autoupdate);
        for (i = 0; i < C_TRENDPTS; i++)
        {
	     strncpy (trspec[i], trendResponse->specs[i], sizeof (CHARSPEC));
        }
	free (trendResponse);
        return TRUE;
    }
    free (trendResponse);
    return FALSE;
}

int PutTrendInfo ( descr, z, autoupdate, trspec, flag )        /* save trend set in database */
char *descr;
long z;
long autoupdate;
CHARSPEC trspec [];
int flag;
{
    int	    i;
    TrendSaveMsg *trend = (TrendSaveMsg *)&rqmsg;

    trend->type = htons(SAVE_TREND);
    strncpy (trend->descr, descr, C_TRENDDESCLEN);
    trend->zoom = htonl(z);
    trend->autoupdate = htonl(autoupdate);
    for (i = 0; i < C_TRENDPTS; i++)
    {
	 strncpy (trend->specs[i], trspec[i], sizeof (CHARSPEC));
    }
    trend->flag = htons((short)flag);
    trendResponse = (TrendRsp *)SendReq(client, trend, sizeof(*trend));
    if (trendResponse == NULL)
    {
	return FALSE;
    }
    if (ntohs(trendResponse->value))
    {
	free (trendResponse);
        return TRUE;
    }
    free (trendResponse);
    return FALSE;
}

int DelTrendInfo ( descr )        /* delete trend set in database */
char *descr;
{
    TrendMsg *trend = (TrendMsg *)&rqmsg;

    trend->type = htons(DELETE_TREND);
    strncpy (trend->descr, descr, C_TRENDDESCLEN);
    trendResponse = (TrendRsp *)SendReq(client, trend, sizeof(*trend));
    if (trendResponse == NULL)
    {
	return FALSE;
    }
    if (ntohs(trendResponse->value))
    {
	free (trendResponse);
        return TRUE;
    }
    free (trendResponse);
    return FALSE;
}

int	GetRec ( pointname, dbred, when) 
char *pointname;
int dbred;
long when;
{
    int	    ix;
    RecMsg  *recreq = (RecMsg *)&rqmsg;

    if (recResponse)
    {
	/* if the point is in the current record, use it */
	if ((strcmp(pointname, recResponse->pointname) == 0)
	  && (recResponse->dbreduc == dbred)
	  && ((when >= recResponse->time)
	  && (when < recResponse->time + (recResponse->rate*recResponse->samples))))
	{
	    recItem = 0;
	    return recResponse->result;
	}
	free (recResponse);
	recResponse = NULL;
    }

    recreq->type = htons(RECORD);
    strncpy (recreq->pointname, pointname, C_TRENDDESCLEN);
    recreq->dbreduc = htons((short)dbred);
    recreq->time = htonl(when);
    recResponse = (RecRsp *)SendReq(client, recreq, sizeof(*recreq));
    if (recResponse == NULL)
    {
	return FALSE;
    }
    recResponse->result = ntohs(recResponse->result);
    if (recResponse->result == FALSE)
    {
	free (recResponse);
	recResponse = NULL;
	return FALSE;
    }
    recResponse->dbreduc = ntohs (recResponse->dbreduc);
    recResponse->rec = ntohl (recResponse->rec);
    recResponse->time = ntohl (recResponse->time);
    recResponse->rate = ntohl (recResponse->rate);
    recResponse->samples = ntohs (recResponse->samples);
    ntohd (recResponse->dl, recResponse->dl);
    ntohd (recResponse->dh, recResponse->dh);
    for (ix = 0; ix < recResponse->samples; ix++)
    {
	 ntohd (recResponse->value[ix], recResponse->value[ix]);
    }
    recItem = 0;
    return recResponse->result;
}

int	GetNextRec ( pointname, dbred, when) 
char *pointname;
int dbred;
long when;
{
    int	ix;
    RecMsg *recreq = (RecMsg *)&rqmsg;

    if (recResponse)
	free (recResponse);

    recreq->type = htons(RECORD);
    strncpy (recreq->pointname, pointname, C_TRENDDESCLEN);
    recreq->dbreduc = htons((short)dbred);
    recreq->time = htonl(when);
    recResponse = (RecRsp *)SendReq(client, recreq, sizeof(*recreq));
    if (recResponse == NULL)
    {
	return FALSE;
    }
    recResponse->result = ntohs(recResponse->result);
    if (recResponse->result == FALSE)
    {
	free (recResponse);
	recResponse = NULL;
	return FALSE;
    }
    recResponse->dbreduc = ntohs (recResponse->dbreduc);
    recResponse->rec = ntohl (recResponse->rec);
    recResponse->time = ntohl (recResponse->time);
    recResponse->rate = ntohl (recResponse->rate);
    recResponse->samples = ntohs (recResponse->samples);
    ntohd (recResponse->dl, recResponse->dl);
    ntohd (recResponse->dh, recResponse->dh);
    for (ix = 0; ix < recResponse->samples; ix++)
    {
	 ntohd (recResponse->value[ix], recResponse->value[ix]);
    }
    return recResponse->result;
}

int UpdateRec ( pointname, dbreduc, rec, fld, newval, newstat)
char *pointname;
int dbreduc;
int rec;
short int fld;
double newval;
char *newstat;
{
    int	    ix;
    UpdateMsg *update = (UpdateMsg *)&rqmsg;

    if (recResponse)
	free (recResponse);

    update->type = htons(RECORD);
    strncpy (update->pointname, pointname, C_TRENDDESCLEN);
    update->dbreduc = htons((short)dbreduc);
    update->rec = htonl(rec);
    update->ix = htons(fld);
    htond(newval, update->value);
    strncpy (update->status, newstat, sizeof(update->status));
    recResponse = (RecRsp *)SendReq(client, update, sizeof(*update));
    if (recResponse == NULL)
    {
	return FALSE;
    }
    recResponse->result = ntohs(recResponse->result);
    if (recResponse->result == FALSE)
    {
	free (recResponse);
	recResponse = NULL;
	return FALSE;
    }
    recResponse->dbreduc = ntohs (recResponse->dbreduc);
    recResponse->rec = ntohl (recResponse->rec);
    recResponse->time = ntohl (recResponse->time);
    recResponse->rate = ntohl (recResponse->rate);
    recResponse->samples = ntohs (recResponse->samples);
    ntohd (recResponse->dl, recResponse->dl);
    ntohd (recResponse->dh, recResponse->dh);
    for (ix = 0; ix < recResponse->samples; ix++)
    {
	 ntohd (recResponse->value[ix], recResponse->value[ix]);
    }
    return recResponse->result;
}

long dbsearch ( pointname, dbred, when, srch)
char *pointname;
int dbred;
long when;
SEARCH *srch;
{
    long    besttime;
    SearchMsg *search = (SearchMsg *)&rqmsg;
    SearchRsp *searchResponse;

    search->type = htons(SEARCH_DB);
    strncpy (search->pointname, pointname, C_TRENDDESCLEN);
    search->dbred = htons((short)dbred);
    search->time = htonl(when);
    search->srch = *srch;
    searchResponse = (SearchRsp *)SendReq(client, search, sizeof(*search));
    if (searchResponse == NULL)
    {
	return 0x7fffffff;
    }
    if (ntohs(searchResponse->value))
    {
        besttime = ntohl(searchResponse->time);
    }
    else
    {
	besttime = 0x7fffffff;
    }
    free (searchResponse);
    return (besttime);
}
