/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include "slm.h"

static Widget pgmList;
void slmCreateProgram(Widget parent)
{
  int n=0;
  Arg args[10];
  XmString title,listLabel,okLabel,cancelLabel,applyLabel;
#ifdef SOLARIS
  title = XmStringCreateLocalized("MT-80 Programmer");
  listLabel = XmStringCreateLocalized("User Name       Card ID      Keypad ID");
  okLabel = XmStringCreateLocalized("Program");
  applyLabel = XmStringCreateLocalized("Auto");
  cancelLabel = XmStringCreateLocalized("Dismiss");
#else
  title = XmStringCreateSimple("MT-80 Programmer");
  listLabel = XmStringCreateSimple("User Name       Card ID");
  okLabel = XmStringCreateSimple("Program");
  applyLabel = XmStringCreateSimple("Auto");
  cancelLabel = XmStringCreateSimple("Dismiss");
#endif
  /* set args */
  XtSetArg(args[n],XmNlistLabelString,listLabel);n++;
  XtSetArg(args[n],XmNokLabelString,okLabel);n++;
  XtSetArg(args[n],XmNapplyLabelString,applyLabel);n++;
  XtSetArg(args[n],XmNcancelLabelString,cancelLabel);n++;
  XtSetArg(args[n],XmNautoUnmanage,False);n++;
  /* create dialog */
  w_pgm = XmCreateSelectionDialog(parent,"PROGRAM",args,n);
  XtVaSetValues(w_pgm,
		XmNnoResize,True,
		XmNautoUnmanage,False,
		XmNdialogStyle,XmDIALOG_PRIMARY_APPLICATION_MODAL,
		XmNdialogTitle,title,NULL);
  XtUnmanageChild(XmSelectionBoxGetChild(w_pgm,XmDIALOG_HELP_BUTTON));
  XtUnmanageChild(XmSelectionBoxGetChild(w_pgm,XmDIALOG_TEXT));
  XtUnmanageChild(XmSelectionBoxGetChild(w_pgm,XmDIALOG_SELECTION_LABEL));
  XtAddCallback(XmSelectionBoxGetChild(w_pgm,XmDIALOG_CANCEL_BUTTON),XmNactivateCallback,slmPgmDismiss,(XtPointer)0);
  XtAddCallback(XmSelectionBoxGetChild(w_pgm,XmDIALOG_OK_BUTTON),XmNactivateCallback,slmPgmProgram,(XtPointer)0);
  XtAddCallback(XmSelectionBoxGetChild(w_pgm,XmDIALOG_APPLY_BUTTON),XmNactivateCallback,slmPgmAuto,(XtPointer)0);
  /* get children */
  pgmList = XmSelectionBoxGetChild(w_pgm,XmDIALOG_LIST);
  XtVaSetValues(pgmList,XmNselectionPolicy,XmEXTENDED_SELECT,NULL);
  /* free strings */
  XmStringFree(title);
  XmStringFree(listLabel);
  XmStringFree(okLabel);
  XmStringFree(applyLabel);
  XmStringFree(cancelLabel);
}
void slmPgmInit()
{
  XmListDeleteAllItems(pgmList);
  avl_traverse(slmNameTree,INORDER,slmPgmFillList,0);
}
void slmPgmFillList(void *p1,void *p2)
{
  char line[128];
  XmString item;
  ACCESS_ENTRY_PTR node = (ACCESS_ENTRY_PTR)p2;
  sprintf(line,"%-*.*s%-*.*s%-*.*s\0",
	  SLM_NAME_SIZE,SLM_NAME_SIZE,node->slmName,
	  SLM_CARDID_SIZE,SLM_CARDID_SIZE,node->slmCardID,
	  SLM_KEYPADID_SIZE,SLM_KEYPADID_SIZE,node->slmClearID);
#ifdef SOLARIS
  item = XmStringCreateLocalized(line);
#else
  item = XmStringCreateSimple(line);
#endif
  XmListAddItem(pgmList,item);
  XmStringFree(item);
}
void slmPgmDismiss(Widget w, XtPointer client_data, XtPointer call_data)	/* do nothing */
{
autoMode = 0;
XtUnmanageChild(w_pgm);
}
void slmPgmProgram(Widget w, XtPointer client_data, XtPointer call_data)	/* manual program...must click this for each card */
{
  int	numItems;
  XmStringTable	okSel;
  char *line,card[SLM_CARDID_SIZE+1];

  XtVaGetValues(pgmList,XmNselectedItemCount,&numItems,XmNselectedItems,&okSel,NULL);
  if(numItems)
    {
      XmStringGetLtoR(okSel[0],XmSTRING_DEFAULT_CHARSET,&line);
      strtok(line," ");
      strcpy(card,strtok(NULL," "));
      slmPgmSendProgram(card);
      XtFree(line);
    }
}
void slmPgmAuto(Widget w, XtPointer client_data, XtPointer call_data)		/* initiate auto-programming sequence */
{
  int	numItems;
  XmStringTable	okSel;
  char *line,card[SLM_CARDID_SIZE+1];

  XtVaGetValues(pgmList,XmNselectedItemCount,&numItems,XmNselectedItems,&okSel,NULL);
  if(numItems)
    {
      XmStringGetLtoR(okSel[0],XmSTRING_DEFAULT_CHARSET,&line);
      strtok(line," ");
      strcpy(card,strtok(NULL," "));
      slmPgmSendProgram(card);
      XtFree(line);
      autoMode = 1;
    }
}
void slmPgmNextCard(char *name)		       	/* slmPortBuff contains string echoed from MT-80 */
{
  int	numItems;
  XmStringTable	okSel;
  char *line,card[SLM_CARDID_SIZE+1];

  slmPgmClearItem(name);			/* deselect the last ID programed */
  XtVaGetValues(pgmList,XmNselectedItemCount,&numItems,XmNselectedItems,&okSel,NULL);
  if(numItems)
    {
      XmStringGetLtoR(okSel[0],XmSTRING_DEFAULT_CHARSET,&line);
      strtok(line," ");
      strcpy(card,strtok(NULL," "));
      slmPgmSendProgram(card);
      XtFree(line);
    }
  else
    autoMode = 0;
}
void slmPgmSendProgram(char *card)
{
  char pgm[SLM_CARDID_SIZE+5];

  sprintf(pgm,"%c;%s?%c",STX,card,ETX);
  if(slmFd != -1)
    write(slmFd,pgm,strlen(pgm));
}
void slmPgmDeselectItem(void *p1,void *p2)
{
  char line[64];
  XmString item;
  ACCESS_ENTRY_PTR node = (ACCESS_ENTRY_PTR)p2;
  char *card = (char *)p1;
  if(!strcmp(node->slmCardID,card))
    {
      sprintf(line,"%-*.*s%-*.*s\0",
	      SLM_NAME_SIZE,SLM_NAME_SIZE,node->slmName,
	      SLM_CARDID_SIZE,SLM_CARDID_SIZE,node->slmCardID);
#ifdef SOLARIS
      item = XmStringCreateLocalized(line);
#else
      item = XmStringCreateSimple(line);
#endif
      XmListDeselectItem(pgmList,item);
      XmStringFree(item);
    }
}
void slmPgmClearItem(char *name)
{
  char card[SLM_CARDID_SIZE+1];

  strcpy(card,(strchr(name,';')+1));	        /* drop leading part of message */
  card[strlen(card)-2] = 0;			/* NULL terminate on top of ETX */
  avl_traverse(slmNameTree,INORDER,slmPgmDeselectItem,(void *)card);
  sleep(1);					/* se we can tell the difference between the next card and an error */
}
