/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include "slm.h"

/* create and manage the RTU dialog box */
static Widget rtuList,rtuName,rtuSelect,rtuDismiss,rtuCard,rtuKeypad,rtuRTUList,rtuIsGlobal,rtuIsOPI;
static Widget sel;
void slmCreateRTU(Widget parent)
{
  Widget label;
  int n=0;
  Arg args[10];
  XmString title,listLabel,selLabel,okLabel,cancelLabel;

#ifdef SOLARIS
  title = XmStringCreateLocalized("RTU List");
#else
  title = XmStringCreateSimple("RTU List");
#endif
  w_rtu = XmCreateBulletinBoardDialog(parent,"PERSONNEL",args,n);
  XtVaSetValues(w_rtu,
		XmNnoResize,True,
		XmNautoUnmanage,False,
		XmNdialogStyle,XmDIALOG_PRIMARY_APPLICATION_MODAL,
		XmNdialogTitle,title,NULL);
  n=0;
#ifdef SOLARIS
  listLabel = XmStringCreateLocalized("Names:");
  selLabel = XmStringCreateLocalized("Name:");
  okLabel = XmStringCreateLocalized("Select");
  cancelLabel = XmStringCreateLocalized("Dismiss");
#else
  listLabel = XmStringCreateSimple("Names:");
  selLabel = XmStringCreateSimple("Name:");
  okLabel = XmStringCreateSimple("Select");
  cancelLabel = XmStringCreateSimple("Dismiss");
#endif
  /* set args */
  XtSetArg(args[n],XmNselectionLabelString,selLabel);n++;
  XtSetArg(args[n],XmNlistLabelString,listLabel);n++;
  XtSetArg(args[n],XmNokLabelString,okLabel);n++;
  XtSetArg(args[n],XmNcancelLabelString,cancelLabel);n++;
  XtSetArg(args[n],XmNmustMatch,False);n++;
  XtSetArg(args[n],XmNlistVisibleItemCount,12);n++;
  /* create dialog */
  sel = XmCreateSelectionBox(w_rtu,"RTUSEL",args,n);
  /* get children widgets */
  rtuList = XmSelectionBoxGetChild(sel,XmDIALOG_LIST);
  rtuName = XmSelectionBoxGetChild(sel,XmDIALOG_TEXT);
  XtVaSetValues(rtuName,XmNsensitive,False,NULL);
  rtuSelect = XmSelectionBoxGetChild(sel,XmDIALOG_OK_BUTTON);
  rtuDismiss = XmSelectionBoxGetChild(sel,XmDIALOG_CANCEL_BUTTON);
  XtVaSetValues(rtuName,XmNmaxLength,SLM_NAME_SIZE,NULL);
  /* add callbacks */
  XtAddCallback(sel,XmNcancelCallback,slmRTUDismiss,(XtPointer)0);
  XtAddCallback(sel,XmNokCallback,slmRTUSelect,(XtPointer)0);
  /* manage selection box and free strings */
  XtUnmanageChild(XmSelectionBoxGetChild(sel,XmDIALOG_HELP_BUTTON));
  XtManageChild(sel);
  XmStringFree(title);
  XmStringFree(listLabel);
  XmStringFree(selLabel);
  XmStringFree(okLabel);
  XmStringFree(cancelLabel);
  /* Add text widgets */
  /* Card ID */
  n=0;
  XtSetArg(args[n],XmNx,320);n++;
  XtSetArg(args[n],XmNy,35);n++;
  XtSetArg(args[n],XmNsensitive,False);n++;
  XtSetArg(args[n],XmNmaxLength,SLM_CARDID_SIZE);n++;
  rtuCard = XmCreateText(w_rtu,"CARD",args,n);
  XtManageChild(rtuCard);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,w_rtu,
				  XtVaTypedArg,XmNlabelString,XmRString,"Card ID:",9,
				  XmNx,252,
				  XmNy,41,
				  NULL);
 /* Keypad ID */
  n=0;
  XtSetArg(args[n],XmNx,320);n++;
  XtSetArg(args[n],XmNy,85);n++;
  XtSetArg(args[n],XmNsensitive,False);n++;
  XtSetArg(args[n],XmNmaxLength,SLM_KEYPADID_SIZE);n++;
  rtuKeypad = XmCreateText(w_rtu,"KEYPAD",args,n);
  XtManageChild(rtuKeypad);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,w_rtu,
				  XtVaTypedArg,XmNlabelString,XmRString,"Keypad ID:",11,
				  XmNx,237,
				  XmNy,91,
				  NULL);
  rtuIsGlobal = XtVaCreateManagedWidget("GLOBAL",xmToggleButtonWidgetClass,w_rtu,
					XtVaTypedArg,XmNlabelString,XmRString,"Enable Global RTU Access",25,
					XmNx,237,
					XmNy,135,
					XmNindicatorSize,15,
					XmNsensitive,False,
					NULL);

  rtuIsOPI = XtVaCreateManagedWidget("WORKSTATION",xmToggleButtonWidgetClass,w_rtu,
					XtVaTypedArg,XmNlabelString,XmRString,"Enable Workstation Access",26,
					XmNx,237,
					XmNy,160,
					XmNindicatorSize,15,
					XmNsensitive,False,
					NULL);
  n=0;
  XtSetArg(args[n],XmNx,237);n++;
  XtSetArg(args[n],XmNy,205);n++;
  XtSetArg(args[n],XmNwidth,237);n++;
  XtSetArg(args[n],XmNheight,143);n++;
  XtSetArg(args[n],XmNscrollBarDisplayPolicy,XmAS_NEEDED);n++;
  XtSetArg(args[n],XmNlistSizePolicy,XmCONSTANT);n++;
  rtuRTUList = (Widget)XmCreateScrolledList(w_rtu,"LIST",args,n);
  XtManageChild(rtuRTUList);
}
void slmRTUInit()
{
XmListDeleteAllItems(rtuList);
avl_traverse(slmNameTree,INORDER,slmRTULoadList,(XtPointer)rtuList);
}
void  slmRTULoadList(void *p1,void *p2)
{
  ACCESS_ENTRY_PTR node = (ACCESS_ENTRY_PTR)p2;
  XmString  item;
  Widget list = (Widget)p1;
#ifdef SOLARIS
  item = XmStringCreateLocalized(node->slmName);
#else
  item = XmStringCreateSimple(node->slmName);
#endif
  XmListAddItem(list,item);
  XmStringFree(item);
}
void slmRTUDismiss(Widget w, XtPointer client_data, XtPointer call_data)
{
XtUnmanageChild(w_rtu);
}
/* Select a name and show its RTUS */
void slmRTUSelect(Widget w, XtPointer client_data, XtPointer call_data)
{
  char *str;
  ACCESS_ENTRY  *pEntry,entry;
  RTU_ENTRY_PTR  rtu;
  XmString  item;

  str = XmTextGetString(rtuName);				/* get the selected name */
  if(strlen(str))
    {
      strcpy(entry.slmName,str);				/* copy to entry */
      if((pEntry = avl_findsym(slmNameTree,&entry)) != 0)
	{
	  XmTextSetString(rtuCard,pEntry->slmCardID);
 	  XmTextSetString(rtuKeypad,pEntry->slmClearID);
	  XmToggleButtonSetState(rtuIsGlobal,pEntry->slmIsGlobal,False);
	  XmToggleButtonSetState(rtuIsOPI,pEntry->slmIsOPI,False);
	  rtu = pEntry->slmRTUList;
	  XmListDeleteAllItems(rtuRTUList);
	  while(rtu)
	    {
#ifdef SOLARIS
	      item = XmStringCreateLocalized(rtu->slmRTUName);
#else
	      item = XmStringCreateSimple(rtu->slmRTUName);
#endif
	      XmListAddItem(rtuRTUList,item);
	      XmStringFree(item);
	      rtu = (RTU_ENTRY_PTR)rtu->next;
	    }
	}
    }
}
