/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include "slm.h"

char *lastChar(char *str,int target);
REDUNDANCY_STATE slmGetRedundancyState(char *iocname);
void slmAddToList( Widget list,char *name,char *val);

void slmExit(Widget w,XtPointer client_data, XtPointer call_data)
{
  slmCreateAreYouSure("Quit","SLM");
  XtRemoveAllCallbacks(slmAreYouSure,XmNokCallback);
  XtAddCallback(slmAreYouSure,XmNokCallback,slmOkToQuit,(XtPointer)0);
}


void slmRTU(Widget w,XtPointer client_data, XtPointer call_data)
{
  slmRTUInit();
  XtManageChild(w_rtu);
}

void slmPersonnel(Widget w,XtPointer client_data, XtPointer call_data)
{
  slmPerInit();
/*   XtManageChild(w_personnel); */
}

void slmDownload(Widget w,XtPointer client_data, XtPointer call_data)
{
  Widget list = XmSelectionBoxGetChild(w_download,XmDIALOG_LIST);
  XmListDeleteAllItems(list);		/* clear list ... */
  slmLoadDownloadRTUList(list);		/* then fill it */
  XtManageChild(w_download);
}

void slmOkToQuit(Widget w,XtPointer client_data, XtPointer call_data)
{
  avl_empty(slmNameTree,slmTreeDelete);
  slmEmptyList(slmRTUNameTree);
  close(slmFd);
  ca_task_exit();
  exit(1);
}
void  slmWriteRTUFiles()
{
  FILE_NODE  fn;
  RTU_ENTRY_PTR rtu;
  /* write out each RTU file from here */
  rtu = slmRTUNameTree;
  while(rtu)
    {
      fn.pRtu = rtu;
      fn.fp = 0;
      avl_traverse(slmNameTree,INORDER,slmCheckAndWrite,(void *)&fn);
      fclose(fn.fp);
      rtu = rtu->next;
    }
}
void  slmCheckAndWrite(void *p1,void *p2)
{
  FILE_NODE *fnode = (FILE_NODE *)p1;
  ACCESS_ENTRY_PTR pEntry = (ACCESS_ENTRY_PTR)p2;
  RTU_ENTRY_PTR  rtu;
  char  rtuName[80];
  time_t now;

  if((rtu = pEntry->slmRTUList) != 0)	       	/* get first member...if any */
    {
      while(rtu)
	{
	  if(!strcmp(rtu->slmRTUName,fnode->pRtu->slmRTUName))
	    {
	      if(fnode->fp == 0)			/* see if file not open yet */
		{
#ifdef	WIN32
		  sprintf(rtuName,"\\tis4000db\\%s.db\0",rtu->slmRTUName);
#else
		  sprintf(rtuName,"/tis4000db/%s.db\0",rtu->slmRTUName);
#endif	WIN32
		  fnode->fp = fopen(rtuName,"w");
		  now = time(0);
		  fprintf(fnode->fp,"%s",ctime(&now));
		}
	      fprintf(fnode->fp,"%s %s %s\n",pEntry->slmName,pEntry->slmCardID,pEntry->slmKeypadID);
	    }
	  rtu = rtu->next;
	}
    }
}
void  slmTreeDelete(void *p1)
{
  ACCESS_ENTRY_PTR  node = (ACCESS_ENTRY_PTR)p1;

  slmEmptyList(node->slmRTUList);
  avl_freenode(p1);
}
/* write the main database file. It's always in the same place and has
the name "secureList.txt"
*/
void slmWriteMain()
{
  FILE  *fp;
  char msg[80];
#ifdef	WIN32
  if((fp = fopen("\\tis4000\\operators\\secureList","w")) != 0)
#else
  if((fp = fopen("/tis4000/operators/secureList","w")) != 0)
#endif	WIN32
    {
      avl_traverse(slmNameTree,INORDER,slmWriteNameTree,(void *)fp);
      fclose(fp);
    }
  else
    {
      sprintf(msg,"Failed to open \"secureList\"\n%s",sys_errlist[errno]);
      slmCreateInfo(msg,"SLM");
    }
}
void slmWriteNameTree(void *fp, void *node)
{
  RTU_ENTRY_PTR rtu;

  fprintf((FILE*)fp,"%s %s %s %s %s %s %s ",
	  ((ACCESS_ENTRY *)node)->slmName,
	  ((ACCESS_ENTRY *)node)->slmKeypadID,
	  ((ACCESS_ENTRY *)node)->slmCardID,
	  ((ACCESS_ENTRY *)node)->slmClearID,
	  ((ACCESS_ENTRY *)node)->slmAutoLogoutTime,
	  (((ACCESS_ENTRY *)node)->slmIsGlobal ? "GLOBAL" : "NOGLOBAL"),
	  (((ACCESS_ENTRY *)node)->slmIsOPI ? "OPI" : "NOOPI"));
  /*
    If global flag is zero then use pointer stored in name entry
    otherwise use the global list of all the RTU names.
  */
  if(((ACCESS_ENTRY *)node)->slmIsGlobal == 0)
    rtu = (RTU_ENTRY_PTR)(((ACCESS_ENTRY *)node)->slmRTUList);
  else
    rtu = (RTU_ENTRY_PTR)slmRTUNameTree;
  while(rtu)
    {
      fprintf(fp,"%s ",rtu->slmRTUName);
      rtu = (RTU_ENTRY_PTR)rtu->next;
    }
  fprintf(fp,"\n");
  return;
}
void  slmEmptyList(RTU_ENTRY_PTR node)
{
if(node)
  {
    slmEmptyList(node->next);
    free(node);
  }
}
int slmReadMain()
{
  char  line[SLM_MAX_LINE_SIZE],*ptr;
  FILE  *fp;
  ACCESS_ENTRY  *pEntry;
  RTU_ENTRY_PTR newNode,found;

#ifdef	WIN32
  if((fp = fopen("\\tis4000\\operators\\secureList","r")) == 0)
#else
  if((fp = fopen("/tis4000/operators/secureList","r")) == 0)
#endif	WIN32
    {
#ifdef	WIN32
      if((fp = fopen("\\tis4000\\operators\\secureList","w")) == 0)
#else
      if((fp = fopen("/tis4000/operators/secureList","w")) == 0)
#endif	WIN32
	{
	  sprintf(line,"I/O error\n\"secureList\"\n%s",sys_errlist[errno]);
	  slmCreateInfo(line,"SLM");
	  XtRemoveAllCallbacks(slmInfo,XmNokCallback);
	  XtAddCallback(slmInfo,XmNokCallback,slmOkToQuit,(XtPointer)0);
	  return(0);
	}
    }
  while((fgets(line,SLM_MAX_LINE_SIZE-1,fp)) != 0)
    {
      line[strlen(line)-1] = 0;			/* drop \n and NULL terminate */
      pEntry = avl_newnode(ACCESS_ENTRY_SIZE);	/* create new node */
      strcpy(pEntry->slmName,strtok(line," "));	/* get name */
      strcpy(pEntry->slmKeypadID,strtok(NULL," "));	/* then keypad ID */
      strcpy(pEntry->slmCardID,strtok(NULL," "));	/* then card ID */
      strcpy(pEntry->slmClearID,strtok(NULL," "));	/* GCT 10-Apr-97 for SNWS get the un-encrypted password */
      strcpy(pEntry->slmAutoLogoutTime,strtok(NULL," "));	/* autologout time */
      pEntry->slmIsGlobal = (!strcmp(strtok(NULL," "),"NOGLOBAL") ? 0 : 1);
      pEntry->slmIsOPI = (!strcmp(strtok(NULL," "),"NOOPI") ? 0 : 1);
      pEntry->slmRTUList = 0;
      avl_insert(slmNameTree,pEntry);
      ptr = strtok(NULL," ");			/* get associated RTUs */
      while(ptr)
	{
	  newNode = (RTU_ENTRY_PTR)calloc(1,RTU_ENTRY_SIZE);
	  found = searchGlobalRTUList(ptr);
	  memcpy((char *)newNode,(char *)found,RTU_ENTRY_SIZE);
	  newNode->next = (RTU_ENTRY_PTR )pEntry->slmRTUList;
	  pEntry->slmRTUList = newNode;
	  ptr = strtok(NULL," ");			/* get next RTU if present */
	}
    }
  fclose(fp);
  return(1);
}
void	slmCreateAreYouSure(char *s,char *t)
{
  XmString	str,title,noString,yesString;
  if(!slmAreYouSure)
    {
      noString = XmStringCreateLtoR("Cancel",XmSTRING_DEFAULT_CHARSET);
      yesString = XmStringCreateLtoR("Yes",XmSTRING_DEFAULT_CHARSET);
      slmAreYouSure = (Widget)XmCreateQuestionDialog(w_toplevel,"QUESTION",NULL,0);
      XtUnmanageChild((Widget)XmMessageBoxGetChild(slmAreYouSure,XmDIALOG_HELP_BUTTON));	/* CANCEL or HELP in this one */
      XtVaSetValues(slmAreYouSure,
		    XmNcancelLabelString,noString,
		    XmNokLabelString,yesString,
		    XmNdialogStyle,XmDIALOG_FULL_APPLICATION_MODAL,
		    XmNmessageAlignment,XmALIGNMENT_CENTER,
		    XmNx,400,
		    XmNy,400,
		    NULL);
      XmStringFree(yesString);
      XmStringFree(noString);
    }
  str = XmStringCreateLtoR(s,XmSTRING_DEFAULT_CHARSET);
  title = XmStringCreate(t,XmSTRING_DEFAULT_CHARSET);
  XtVaSetValues(slmAreYouSure,
		XmNmessageString,str,
		XmNdialogTitle,title,
		NULL);
  XmStringFree(title);
  XmStringFree(str);
  XtManageChild(slmAreYouSure);
  return;
}
void	slmCreateInfo(char * s, char *t)
{
XmString	str,title;
if(slmInfo == 0)
	{
	slmInfo = (Widget)XmCreateInformationDialog(w_toplevel,"INFO",NULL,0);
	XtUnmanageChild((Widget)XmMessageBoxGetChild(slmInfo,XmDIALOG_HELP_BUTTON));	/* CANCEL or HELP in this one */
	XtUnmanageChild((Widget)XmMessageBoxGetChild(slmInfo,XmDIALOG_CANCEL_BUTTON));	/* CANCEL or HELP in this one */
	XtVaSetValues(slmInfo,
		XmNdialogStyle,XmDIALOG_FULL_APPLICATION_MODAL,
		XmNmessageAlignment,XmALIGNMENT_CENTER,
		XmNx,400,
		XmNy,400,
		NULL);
	}
str = XmStringCreateLtoR(s,XmSTRING_DEFAULT_CHARSET);
title = XmStringCreate(t,XmSTRING_DEFAULT_CHARSET);
XtVaSetValues(slmInfo,
	XmNmessageString,str,
	XmNdialogTitle,title,
	NULL);
XmStringFree(title);
XmStringFree(str);
XtManageChild(slmInfo);
return;
}
/*
  populate the RTU list from the IOCLIST.DBF file

  GCT 11-Apr-97 Add code to weed out redundant IOC/RTUs for SNWS
*/
void	slmBuildRTUTree()
{
  char	iocname[SLM_RTUNAME_SIZE+1],isHost;
  DB_RECORD_PTR	rec;
  int	type,status;
  DB_FIELD_PTR iocNameField,iocHostField;
  RTU_ENTRY *pEntry;
  evid	evID;						/* must have for NEW CA. GCT 30-Mar-1994 */

  /* Open IOCLIST file and build RTU tree */
  if((slmIocListTable = DB_MapTable("/tis4000db/ioclist")) == 0)
    {
      tisSysLog (0,0,"Can't open ioc list file");
      exit(2);
    }
  rec = DB_Top(slmIocListTable);
  iocNameField = DB_MapField(slmIocListTable,"IOCNAME");
  iocHostField = DB_MapField(slmIocListTable,"IS_HOST");
  while(rec)
    {
      DB_GetFieldValue(rec,iocHostField,&isHost,&type);
      if(!isHost)
	{
	  DB_GetFieldValue(rec,iocNameField,iocname,&type);
	  pEntry = (RTU_ENTRY_PTR)calloc(1,RTU_ENTRY_SIZE);
	  strcpy(pEntry->slmRTUName,iocname);
	  sprintf(pEntry->slmTSValueA,"%-24.24s\0","UNKNOWN");
	  sprintf(pEntry->slmTSValueB,"%-24.24s\0","UNKNOWN");
	  pEntry->slmIsRedundant = slmGetRedundancyState(iocname);
	  pEntry->next = slmRTUNameTree;
	  slmRTUNameTree = pEntry;
	}
      rec = DB_SeekNext(slmIocListTable);
    }
  DB_UnMapTable(slmIocListTable, 0);
  pEntry = slmRTUNameTree;
  while(pEntry)
    {
      sprintf(pEntry->slmRTUPntName,"%s_RSA.VAL\0",pEntry->slmRTUName);
      if((pEntry->slmIsRedundant == NON_REDUNDANT) || (pEntry->slmIsRedundant == REDUNDANT_A))
	{
	  if((status = ca_build_read_and_monitor(pEntry->slmRTUPntName,slmCAConnect,pEntry,slmCARead,pEntry,slmCAMonitor,pEntry,&pEntry->slmChannelA,&evID)) != ECA_NORMAL)
	    {
	      pEntry->slmChannelA = 0;
	      tisSysLog (0,0, "Error from ca_build_and_connect...%s",
						ca_message(status));
	    }
	}
      else if(pEntry->slmIsRedundant == REDUNDANT_B)
	{
	  if((status = ca_build_read_and_monitor(pEntry->slmRTUPntName,slmCAConnect,pEntry,slmCARead,pEntry,slmCAMonitor,pEntry,&pEntry->slmChannelB,&evID)) != ECA_NORMAL)
	    {
	      pEntry->slmChannelB = 0;
	      tisSysLog(0,0, "Error from ca_build_and_connect...%s",
						ca_message(status));
	    }
	}
      ca_pend_event(0);
      sprintf(pEntry->slmRTUTimeStamp,"%s_ADT.VAL\0",pEntry->slmRTUName);
      if((pEntry->slmIsRedundant == NON_REDUNDANT) || (pEntry->slmIsRedundant == REDUNDANT_A))
	{
	  if((status = ca_build_read_and_monitor(pEntry->slmRTUTimeStamp,slmCAConnect,pEntry,slmCARead,pEntry,slmCAMonitor,pEntry,&pEntry->slmTSchannelA,&evID)) != ECA_NORMAL)
	    {
	      pEntry->slmTSchannelA = 0;
	      tisSysLog(0,0, "Error from ca_build_and_connect...%s",
						ca_message(status));
	    }
	}
      else if(pEntry->slmIsRedundant == REDUNDANT_B)
	{
	  if((status = ca_build_read_and_monitor(pEntry->slmRTUTimeStamp,slmCAConnect,pEntry,slmCARead,pEntry,slmCAMonitor,pEntry,&pEntry->slmTSchannelB,&evID)) != ECA_NORMAL)
	    {
	      pEntry->slmTSchannelB = 0;
	      tisSysLog(0,0,"Error from ca_build_and_connect...%s",
						ca_message(status));
	    }
	}
      ca_pend_event(0);
      pEntry = pEntry->next;
    }
  return;
}
void	slmLoadRTUList(Widget list)
{
  RTU_ENTRY_PTR rtu;
  XmString item;
  char rtuName[SLM_RTUNAME_SIZE+1];

  rtu = slmRTUNameTree;
  while(rtu)
    {
      if(rtu->slmIsRedundant)
	{
	  strcpy(rtuName,rtu->slmRTUName);
	  rtuName[strlen(rtuName)-1] = 0;		/* drop a or b */
	}
      else
	strcpy(rtuName,rtu->slmRTUName);
#ifdef SOLARIS
      item = XmStringCreateLocalized(rtuName);
#else
      item = XmStringCreateSimple(rtuName);
#endif
      if(XmListItemExists(list,item) == False)
	XmListAddItem(list,item);
      XmStringFree(item);
      rtu = rtu->next;
    }
}
void	slmLoadDownloadRTUList(Widget list)
{
  RTU_ENTRY_PTR rtu;

  rtu = slmRTUNameTree;
  while(rtu)
    {
      if((rtu->slmIsRedundant == NON_REDUNDANT) || (rtu->slmIsRedundant == REDUNDANT_A))
	{
	  slmAddToList(list,rtu->slmRTUName,rtu->slmTSValueA);
	}
      else if(rtu->slmIsRedundant == REDUNDANT_B)
	{
	  slmAddToList(list,rtu->slmRTUName,rtu->slmTSValueB);
	}
      rtu = rtu->next;
    }
}
void slmAddToList( Widget list,char *name,char *val)
{
  XmString item;
  char  itemString[80],ts1[30],dbName[SLM_RTUNAME_SIZE+9];
  struct stat stBuff;
  int st,i;

  sprintf(dbName,"/tis4000db/%s.db",name);
  if(stat(dbName,&stBuff) != -1)
    strcpy(ts1,ctime(&stBuff.st_mtime));
  else
    strcpy(ts1,"UNKNOWN");
  st = ca_pend_io(0.01);
  for(i=0;i<100;i++)
    {
      if(st != ECA_TIMEOUT)
	st = ca_pend_io(0.01);
      else
	break;
    }
  sprintf(itemString,"%-*.*s %-24.24s %-24.24s\0",
			SLM_RTUNAME_SIZE,SLM_RTUNAME_SIZE,name,ts1,val);
#ifdef SOLARIS
  item = XmStringCreateLocalized(itemString);
#else
  item = XmStringCreateSimple(itemString);
#endif
  XmListAddItem(list,item);
  XmStringFree(item);
}
/* compare two names */
int  slmNameCompare(void *p1, void *p2)
{
return(strcmp(((ACCESS_ENTRY_PTR)p1)->slmName, ((ACCESS_ENTRY_PTR)p2)->slmName));
}
/* compare two names */
int  slmRTUCompare(RTU_ENTRY_PTR p1,RTU_ENTRY_PTR p2)
{
return(strcmp(p1->slmRTUName,p2->slmRTUName));
}
int slmInitPort(int count, char *portName)
{
  char realPort[32],msg[80];
  int newfd,i;
  struct termios	tinfo;

  if (count != 2)
    {
      return (-1);
    }
  if (strstr(portName, "ttya") != NULL)
    {
#ifdef SOLARIS
      strcpy(realPort,"/dev/cua/a");
#else
      strcpy(realPort,"/dev/cua0");
#endif
    }
  else if (strstr(portName, "ttyb") != NULL)
    {
#ifdef SOLARIS
      strcpy(realPort,"/dev/cua/b");
#else
      strcpy(realPort,"/dev/cua1");
#endif
    }
  else
    {
      return(-1);
    }
  if((newfd = open(realPort,O_RDWR | O_NDELAY)) < 0)
    {
      sprintf(msg,"Failed to open serial port %s\n(%s)",realPort,sys_errlist[errno]);
      slmCreateInfo(msg,"SLM");
      return (-1);
    }
  memset ((char *)&tinfo, 0, sizeof (struct termios));
  if (tcgetattr (newfd, &tinfo) < 0)
    {
      sprintf(msg,"Failed to get port settings (%s)",sys_errlist[errno]);
      slmCreateInfo(msg,"SLM");
      return (1);
    }
  /* save the original settings to restore later */
  savetty = tinfo;
  /* now that the tty is open set up its characteristics */
  /* set input modes */
  tinfo.c_iflag |= IGNBRK;	/* ignore breaks */
  tinfo.c_iflag |= IGNPAR;	/* ignore parity errors */
  tinfo.c_iflag |= ISTRIP;	/* strip the 8th bit */
  /* set output modes */
  tinfo.c_oflag = 0;
  /* set control modes */
  /* set output baud rate, this also sets the input baud rate
     since we are not specify an input baud rate diff from
     the output
     */
/*   if(cfsetospeed (&tinfo, B4800) < 0) */
/*     { */
/*       sprintf(msg,"Failed to set output baud rate (%s)",sys_errlist[errno]); */
/*       slmCreateInfo(msg,"SLM"); */
/*       return (-1); */
/*     } */
  tinfo.c_cflag &= ~CBAUD;		/* clear baud flags */
  tinfo.c_cflag |= B4800;		/* set baud to 4800 */
  tinfo.c_cflag &= ~CSIZE;     		/* clear character bits */
  tinfo.c_cflag |= CS7;			/* set to 7 bits */
  tinfo.c_cflag &= ~CSTOPB;		/* 1 stop bit */
  tinfo.c_cflag |= CREAD;		/* enable receiver */
  tinfo.c_cflag &= ~CLOCAL;		/* clear LOCAL bit */
  tinfo.c_cflag |= CLOCAL;		/* direct control, no modem control */
  tinfo.c_cflag &= ~PARENB;		/* clear parity checking */
  tinfo.c_cflag |= PARENB;		/* enable parity checking */
  tinfo.c_cflag &= ~PARODD;		/* clear parity */
  tinfo.c_cflag |= PARODD;		/* ODD parity */
  /* set line discipline modes */
  tinfo.c_lflag = 0;
  /* set controls:
     min chars requested or # chars available
     return w/o waiting for more chars
     */
  tinfo.c_cc[VMIN] = 0;
  tinfo.c_cc[VTIME] = 0;
  /* set new line attributes NOW */
  if (tcsetattr (newfd, TCSANOW, &tinfo) < 0)
    {
      sprintf(msg,"Failed to set tty characteristics (%s)",sys_errlist[errno]);
      slmCreateInfo(msg,"SLM");
      return (-1);
    }
  /* set exclusive use of this tty, the arg i is ignored for this call */
#ifdef SOLARIS
  if (ioctl (newfd, TIOCEXCL, &i) < 0)
    {
      sprintf(msg,"Failed to set exclusive tty use (%s)",sys_errlist[errno]);
      slmCreateInfo(msg,"SLM");
      return (-1);
    }
#endif
return(newfd);
}
READ_CODE slmReadFd(int fd,char *buff)
{
/* read bytes from card/keypad until terminator */
char inchar[SLM_CARDID_SIZE+1];
int  count,size;

if(ioctl(fd,FIONREAD,&size) != -1)			/* only read as maany as are in buffer */
  {
    if((count = read(fd,inchar,size)) < 0)
      {
	return(READ_ERROR);
      }
    inchar[size] = 0;					/* NULL terminate */
    if(strchr(inchar,ETX))	       			/* ETX...buff has full string now */
      {
	strcat(buff,inchar);				/* append whole message */
	return(PROGRAM_OK);
      }
    else
      {
/* 	if(isdigit(inchar[0])) */
	  strcat(buff,inchar);
	return(IDNOT_YET);
      }
  }
else
  {
    return(IOCTL_ERROR);
  }
}
void	slmCAMonitor(struct event_handler_args arg)
{
  RTU_ENTRY  *node;

  node = arg.usr;					/* address of the RTU_ENTRY node for this point */
  switch(arg.type)
    {
    case OLD_DBR_CTRL_STRING:
    case OLD_DBR_STS_STRING:
      if((node->slmIsRedundant == NON_REDUNDANT) || (node->slmIsRedundant == REDUNDANT_A))
	sprintf(node->slmTSValueA,"%-24.24s\0",((struct dbr_sts_string *)arg.dbr)->value);
      else if(node->slmIsRedundant == REDUNDANT_B)
	sprintf(node->slmTSValueB,"%-24.24s\0",((struct dbr_sts_string *)arg.dbr)->value);
      break;
    default:
      if((node->slmIsRedundant == NON_REDUNDANT) || (node->slmIsRedundant == REDUNDANT_A))
	sprintf(node->slmTSValueA,"%-24.24s\0","UNKNOWN");
      else if(node->slmIsRedundant == REDUNDANT_B)
	sprintf(node->slmTSValueB,"%-24.24s\0","UNKNOWN");
    }
}
void	slmCARead(struct event_handler_args arg)
{
  slmCAMonitor(arg);
}
/*
	Connection handler. Used to finish-up build_and_read...
*/
void	slmCAConnect(struct connection_handler_args arg)
{
  RTU_ENTRY	*node;
  node = (RTU_ENTRY *)arg.chid->paddr;
  if(arg.op == CA_OP_CONN_UP)
    ca_complete_bld_read_mon(arg.chid);
}
void slmReconnectCallback (void *arg, int fd, int cond)	/* Reconnect to CA */
{
  if(cond)
    {
      slmCaFd = fd;				/* save CA fd here */
      if(slmCaFd > maxFd) maxFd = slmCaFd;	/* add to group I'm interested in */
      FD_SET(slmCaFd,&useFds);
      memcpy((char *)&saveFds,(char *)&useFds,sizeof(fd_set));
    }
}
char *lastChar(char *str,int target)
{
int len;
len = strlen(str)-1;
if(str[len] == target)
  return(&str[len]);
else
  return(0);
}
REDUNDANCY_STATE slmGetRedundancyState(char *iocname)
{
  char checkName[SLM_RTUNAME_SIZE+1],*abptr,seekName[SLM_RTUNAME_SIZE+1];
  /*
    check for redundant IOCs/RTUs here, return 0 if non-redundant
  */
  strcpy(checkName,iocname);
  if((abptr = lastChar(checkName,'a')) == NULL)
    {
      if((abptr = lastChar(checkName,'b')) == NULL)
	{
	  return(NON_REDUNDANT);				/* NOT redundant */
	}
      else
	{
	  *abptr = 0;
	  sprintf(seekName,"%sa",checkName);	/* search for "a" side */
	  if(DB_Seek(slmIocListTable,seekName) == 0)
	    {
	      DB_Seek(slmIocListTable,iocname);
	      return(NON_REDUNDANT);
	    }
	  else
	    {
	      DB_Seek(slmIocListTable,iocname);
	      return(REDUNDANT_B);
	    }
	}
    }
  else
    {
      *abptr = 0;
      sprintf(seekName,"%sb",checkName);	/* search for "b" side */
      if(DB_Seek(slmIocListTable,seekName) == 0)
	{
	  DB_Seek(slmIocListTable,iocname);
	  return(NON_REDUNDANT);
	}
      else
	{
	  DB_Seek(slmIocListTable,iocname);
	  return(REDUNDANT_A);
	}
    }
}
