#ifndef	INCsnlvuappHXX
#define	INCsnlvuappHXX

#include vtimerHEADER

extern "C"
{
#include "dbDefs.h"
#include "msgMon.h"
#include "mon_defs.h"
}

#include "textFilters.hxx"
#include "tisgalaxylib.hxx"

// enum defs
enum {
    SNLVU_ERROR = -1,
    SNLVU_SUCCESS,
    SNLVU_INFO_NOTICE,
    SNLVU_CAUTION_NOTICE,
    SNLVU_NUMMISCENUMS
};

class MainDialog;
class TimerClass;


class snlvuApplication
{
    int			connected;
    int			initErrors;
    int			initedTisGalaxy;
    char		iocName [IOCNAME_SZ + 1];
    vapplication	*snlvuVApplication;
    vresource		snlvuResource;
    vresource		messagesResource;
    vresource		titlesResource;
    vresource		tisGalaxyResource;

    // remember dialog's
    MainDialog		*mainDialog;

    // timer class for program
    TimerClass		*snlvuTimer;

public:

    // class constructor
    snlvuApplication (char *iocname);
    // class destructor
    ~snlvuApplication (void);

    // public functions inline funcs

    void Connect (void)
	{ connected = snlMonConnect (iocName); }
    int IsConnected (void)
	{ return (connected); }
    char *GetIocName (void)
	{ return (iocName); }
    int GetInitErrors (void)
	{ return (initErrors); }
    vapplication *GetSnlvuApplication (void)
	{ return (snlvuVApplication); }
    vresource GetSnlvuResource(void)
	{ return (snlvuResource); }
    vresource GetMessagesResource (void)
	{ return (messagesResource); }
    vresource GetTitlesResource (void)
	{ return (titlesResource); }
    vresource GetGalaxyRes (void)
	{ return (tisGalaxyResource); }

    MainDialog *GetMainDialog (void)
	{ return (mainDialog); }
    void StoreMainDialog (MainDialog *dlg)
	{ mainDialog = dlg; }

    void StoreIocName (char *iocname)
	{ strncpy (iocName, iocname, IOCNAME_SZ);
	  iocName[IOCNAME_SZ] = 0; }
};


class TimerClass : public vtimer
{
    snlvuApplication	*snlvuApp;

public:
    // override
    void ObserveTimer (void);

    // start time
    void StartTimer (void);

    // handle app
    void StoreApp (snlvuApplication *app)
	{ snlvuApp = app; }
};

#endif	INCsnlvuappHXX
