class ModulesListView;
class LoadButton;
class UnloadButton;
class ExitButton;

class ModulesDialog : public vdialog
{
    // pointer to mainDialog
    MainDialog		*mainDialog;

    // pointers to items in the main dialog
    ModulesListView	*modulesListView;
    LoadButton		*loadButton;
    UnloadButton	*unloadButton;
    ExitButton		*exitButton;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(ModulesDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(ModulesDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // vwindow overide
    void ObserveWindow (vevent *event);

    // open 
    void OpenModules (MainDialog *dlg);

    // return the main dialog's resource
    MainDialog *GetMainDialog (void)
	{ return (mainDialog); }

   // return listview
   ModulesListView *GetListView (void)
	{ return (modulesListView); }
};


class  ModulesListView : public vlistview
{
    ModulesDialog	*modulesDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(ModulesListView);
    vloadableINLINE_CONSTRUCTORS(ModulesListView, vlistview);

    void Destroy ();

    void BuildList ();

    void StoreModulesDialog (ModulesDialog *dlg)
	{ modulesDialog = dlg; }
};


class  LoadButton : public vbutton
{
    ModulesDialog	*modulesDialog;

public:
    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(LoadButton);
    vloadableINLINE_CONSTRUCTORS(LoadButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreModulesDialog (ModulesDialog *dlg)
	{ modulesDialog = dlg; }
};


class  UnloadButton : public vbutton
{
    ModulesDialog	*modulesDialog;

public:
    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(UnloadButton);
    vloadableINLINE_CONSTRUCTORS(UnloadButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreModulesDialog (ModulesDialog *dlg)
	{ modulesDialog = dlg; }
};


class  ExitButton : public vbutton
{

public:
    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(ExitButton);
    vloadableINLINE_CONSTRUCTORS(ExitButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);
};

