#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vtimeHEADER
#include vmemHEADER
#include vnoticeHEADER

#include "snlvu.h"
#include "snlvuApp.hxx"
#include "snlvuUtils.hxx"


/*******************************************************************
*
*    snlvuMessageCenter ()
*	handle messages to user
*
*******************************************************************/

int snlvuMessageCenter (vdialog *dialog, int msgType, const vname *msgName, ...)
{
    int		result = vTRUE;
    va_list	argptr;

    va_start (argptr, msgName);

    vapplication *snlvuApp     = vapplication::GetCurrent ();
    vresource    snlvuRes      = snlvuApp -> GetResources ();
    vresource    titleRes      = vresourceGet (snlvuRes, snlvu_TitlesDictionary);
    vresource    msgRes        = vresourceGet (snlvuRes, snlvu_MessagesDictionary);
    vstr         *infoTitle    = vresourceGetString (titleRes, snlvu_InfoNotice);
    vstr         *cautionTitle = vresourceGetString (titleRes, snlvu_CautionNotice);

    vstr *format = vresourceGetString (msgRes, msgName);
    // NOTE: vstrScribe cleans up vstr *format
    vstr *msg = vstrCloneScribed (vcharScribeFormatScribedVarargs ( vstrScribe (format), argptr));

    va_end (argptr);

    if (msgType == SNLVU_INFO_NOTICE)
    {
	infoNotice (dialog, infoTitle, msg);
    }
    else
    {
	result = cautionNotice (dialog, cautionTitle, msg);
    }
    vstrDestroy (infoTitle);
    vstrDestroy (cautionTitle);
    vstrDestroy (msg);

    return (result);
}

