#ifndef	INCsnlvuvariablesdialogHXX
#define	INCsnlvuvariablesdialogHXX

class VariablesListView;
class VariablesModifyButton;
class VariablesExpandButton;
class VariablesExitButton;

class VariablesDialog : public vdialog
{
    MainDialog			*mainDialog;
    vruler			*variablesRuler;
    VariablesListView		*variablesListView;
    VariablesModifyButton	*modifyButton;
    VariablesExpandButton	*expandButton;
    VariablesExitButton		*exitButton;

    void		SetVariablesTitle (void);

    // remember the current variables displayed
    REPVARS_REPLY	*PrevVariables;
    char		programName [PROGRAM_NAME_SIZE + 1];
    long		TaskId;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(VariablesDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(VariablesDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override a dialog reconfigure event
    int HandleConfigure (vevent *event);

    // open 
    void OpenVariables (MainDialog *dlg, char *progName, long tid);

    void UpdateVariablesList (int ignorePrev);

    MainDialog *GetMainDialog (void)
	{ return (mainDialog); }

    REPVARS_REPLY *GetPrevVariables (void)
	{ return (PrevVariables); }

    char *GetProgramName (void)
	{ return (programName); }

    long GetTaskId (void)
	{ return (TaskId); }

    VariablesListView *GetVariablesListView (void)
	{ return (variablesListView); }

    vruler *GetVariablesRuler (void)
	{ return (variablesRuler); }

    int	InUse;
};


class  VariablesListView : public vlistview
{
    VariablesDialog	*variablesDialog;
    void		GetValue (REPVARS_REPLY *p, char *Var, char *Value);

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(VariablesListView);
    vloadableINLINE_CONSTRUCTORS(VariablesListView, vlistview);

    // override 
    void Destroy ();

    // override
    void ObserveSelect (int state);

    void BuildList (REPVARS_REPLY *variables, int numVariables);

    // set columns width based on current ruler item widths
    void SetColumnsWidths (void);

    void StoreVariablesDialog (VariablesDialog *dlg)
	{ variablesDialog = dlg; }
};


class  VariablesModifyButton : public vbutton
{
    VariablesDialog	*variablesDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(VariablesModifyButton);
    vloadableINLINE_CONSTRUCTORS(VariablesModifyButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreVariablesDialog (VariablesDialog *dlg)
	{ variablesDialog = dlg; }
};


class  VariablesExpandButton : public vbutton
{
    VariablesDialog	*variablesDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(VariablesExpandButton);
    vloadableINLINE_CONSTRUCTORS(VariablesExpandButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreVariablesDialog (VariablesDialog *dlg)
	{ variablesDialog = dlg; }
};


class  VariablesExitButton : public vbutton
{
    VariablesDialog	*variablesDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(VariablesExitButton);
    vloadableINLINE_CONSTRUCTORS(VariablesExitButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreVariablesDialog (VariablesDialog *dlg)
	{ variablesDialog = dlg; }
};

#endif	INCsnlvuvariablesdialogHXX

