/****
*
*	File name :		l1_8250x.c
*	Author :		Steve Johnson
*	Creation date :	December 1, 1985
*
*	Copyright (c) 1985,1999 Sigma Six Corporation
*
*	Provide the following entry points
*
*		pc8250_init
*		pc8250_connect
*		pc8250_publish
*		pc8250_accept
*		pc8250_write
*		pc8250_poll
*		pc8250_read
*		pc8250_clear
*		pc8250_shutdown
*		pc8250_exit
*
*	Entry point stub layer for DOS Intel 8250 type devices
*
****/

#include <sscommon.h>
#include <sstrace.h>
#include <sslevel1.h>
#include <ssl18250.h>

/****
*
****/

LEVEL1_STATUS pc8250_init (void)
{
	TRACE ("pc8250_init, stub");
	return LEVEL1_NORMAL;
}

/****
*
****/

LEVEL1_STATUS pc8250_connect (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE ("pc8250_connect, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS pc8250_publish (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE_S ("pc8250_publish, not supported (%s)", name);
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS pc8250_accept (LEVEL1_HANDLE	*client_handle
						   , LEVEL1_HANDLE	server_handle)
{
	ERROR_TRACE ("pc8250_accept, not supported");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS pc8250_write (LEVEL1_HANDLE	user_handle
						  , size_t			buffer_size
						  , void			*buffer)
{
	ERROR_TRACE ("pc8250_write, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS pc8250_poll (LEVEL1_HANDLE user_handle, size_t *bytes_ready)
{
	ERROR_TRACE ("pc8250_poll, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS pc8250_read (LEVEL1_HANDLE	user_handle
						 , size_t			buffer_size
						 , void				*buffer
						 , size_t			*return_length)
{
	ERROR_TRACE ("pc8250_read, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS pc8250_clear (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("pc8250_clear, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS pc8250_shutdown (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("pc8250_shutdown, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS pc8250_exit (void)
{
	TRACE ("pc8250_exit, stub");
	return LEVEL1_NORMAL;
}

