/****
*
*	File name :		l1_digix.c
*	Author :		Steve Johnson
*	Creation date :	September 16, 1998
*
*	Copyright (c) 1998,1999 Sigma Six Corporation
*
*	Provide the following entry points
*
*		digi_init
*		digi_connect
*		digi_publish
*		digi_accept
*		digi_write
*		digi_poll
*		digi_read
*		digi_clear
*		digi_close
*		digi_exit
*
*	Entry point stub layer for Digiboard Acceleport 8E
*
****/

#include <sscommon.h>
#include <sstrace.h>
#include <sslevel1.h>
#include <ssl1digi.h>

/****
*
****/

LEVEL1_STATUS digi_init (void)
{
	TRACE ("digi_init, stub");
	return LEVEL1_NORMAL;
}

/****
*
****/

LEVEL1_STATUS digi_connect (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE ("digi_connect, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS digi_publish (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE_S ("digi_publish, not supported (%s)", name);
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS digi_accept (LEVEL1_HANDLE	*client_handle
						 , LEVEL1_HANDLE	server_handle)
{
	ERROR_TRACE ("digi_accept, not supported");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS digi_write (LEVEL1_HANDLE		user_handle
					     , size_t			buffer_size
					     , void				*buffer)
{
	ERROR_TRACE ("digi_write, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS digi_poll (LEVEL1_HANDLE user_handle, size_t *bytes_ready)
{
	ERROR_TRACE ("digi_poll, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS digi_read (LEVEL1_HANDLE	user_handle
					   , size_t			buffer_size
					   , void			*buffer
					   , size_t			*return_length)
{
	ERROR_TRACE ("digi_read, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS digi_clear (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("digi_clear, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS digi_shutdown (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("digi_shutdown, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS digi_exit (void)
{
	TRACE ("digi_exit, stub");
	return LEVEL1_NORMAL;
}

