/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vmenuHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vmenubarHEADER
#include vbuttonHEADER
#include vtextitemHEADER
#include vstartupHEADER
#include vtimeHEADER
#include vmemHEADER
#include vcontrolHEADER
#include vcontainerHEADER
#include "tagvunames.h"
extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include <stdio.h>
#include "cadef.h"
#include "msgMon.h"
}
typedef char *caddr_t;
#include "textFilters.hxx"	/* ../share/src/tisgalaxylib */
#include "tagvu.h"
#include "tagvuEntryDialogClass.h"

static int reasonFilter (filteredText *text, vtextSelection *sel,
			  const vchar **s, long *len);
/*
	This is the source for the tag entry dialog class
*/
vkindTYPED_FULL_DEFINITION(tagvuEntryDialogClass, vdialog, "tagvuEntryDialogClass");
vkindTYPED_FULL_DEFINITION(tagvuEntryOKButton, vbutton, "tagvuEntryOKButton");
vkindTYPED_FULL_DEFINITION(tagvuEntryCancelButton, vbutton, "tagvuEntryCancelButton");

void tagvuEntryDialogClass::LoadInit(vresource res)
{
	okButton = tagvuEntryOKButton::RequestSubLoad(this,tagvunames_entryOK);
 	cancelButton = tagvuEntryCancelButton::RequestSubLoad(this,tagvunames_entryCancel);
	vcontainer *dummy = vcontainer::RequestSubLoad(this,tagvunames_nameContainer);
	entryName = filteredTextitem::RequestSubLoad(dummy,tagvunames_entryPointName);
	dummy = vcontainer::RequestSubLoad(this,tagvunames_reasonContainer);
	entryReason = filteredTextitem::RequestSubLoad(dummy,tagvunames_entryReason);
	entryTagType = vcontrolToggle::RequestSubLoad(this,tagvunames_entryInfo);
	vdialog::LoadInit(res);			// call base class loadInit to finish the job
	okButton->setParent(this);
	cancelButton->setParent(this);
	tagEntryData = NULL;
	entryName -> SetItemFilterFunc (pvnameFilter);
	entryReason -> SetItemFilterFunc (reasonFilter);
}
void tagvuEntryDialogClass::Destroy()
{
}
void tagvuEntryDialogClass::ObserveWindow(vevent *event)
{
    if(event -> GetType() == veventWINDOW_STATE && event -> IsClose())
    {
	Close();
	vevent::StopProcessing();
    }
}
void tagvuEntryDialogClass::Open()
{
	vdialog::Open();
    vevent::Process();
}
//
// button callbacks
//
void tagvuEntryOKButton::ObserveDialogItem(vevent *event)
{
	TagValueData *tagdata;
	vbutton::ObserveDialogItem(event);
	Close();
	vevent::StopProcessing();
	if((tagdata = (TagValueData *)vmemAllocAndClear(sizeof(TagValueData))))
	{
	//
	// get new TagInfoData stuff
	//
	// get point name
	    vstr *str1 = getParent()->entryName->GetTextAsString();
	    vcharExportBounded (vcharScribeSystemExport(str1),&tagdata->pointName,PVNAME_SZ);
	    vstrDestroy (str1);
	// get reason
	    str1 = getParent()->entryReason->GetTextAsString();
	    vcharExportBounded (vcharScribeSystemExport(str1),&tagdata->reason,REASON_SIZE);
	    vstrDestroy (str1);
	// set tag type
	    tagdata->tagType = (getParent()->entryTagType->GetValue() ? 'I' : 'O');
	// save tag data
	    tagdata->type = ADD_TAG;
	    getParent()->setTagData(tagdata);
	}
}
void tagvuEntryCancelButton::ObserveDialogItem(vevent *event)
{
	vbutton::ObserveDialogItem(event);
	Close();
	vevent::StopProcessing();
	getParent()->setTagData((TagValueData *)NULL);
}

/*******************************************************************
*
*    Filter function for the reasonEntry field
*
*******************************************************************/

static int reasonFilter (filteredText *text, vtextSelection *sel,
			  const vchar **s, long *len)
{
    return (NCharFilter (text, sel, s, len, 100));
}
