/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


extern "C"
{
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32
}
extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include <ctype.h>
#include "DBDefines.h"
#include "cadef.h"
#include "msgMon.h"
#include "server.h"
}
typedef char *caddr_t;
#include "tagvu.h"
#include "tagvuMsgs.h"
#include "tagvuServerApp.h"
void ConnectionHandlerProxy(connection_handler_args args);
void TagValueEventProxy(event_handler_args args);

tagvuServerApp::tagvuServerApp(SERVER *sv)
{
	server = sv;					// assign local copy of SERVER
	/*
	 * open database files
	 */
	d4init (&codeBaseDesc);
	codeBaseDesc.readLock = 0;
	codeBaseDesc.errCreate = 0;
	codeBaseDesc.errFieldName = 0;
	codeBaseDesc.errGo = 0;
	codeBaseDesc.errOpen = 0;
	codeBaseDesc.errSkip = 0;
	codeBaseDesc.errTagName = 0;
	codeBaseDesc.autoOpen = 1;		// 19-Aug-1998 force MDX file open now
	tagDesc = 0;
	pvmapDesc = 0;
	tagIndexDesc = 0;
	opTrackDesc = 0;
#ifndef WIN32
	if ( !(tagDesc = d4open (&codeBaseDesc, "/tis4000db/tagvu.dbf")))
#else
	if ( !(tagDesc = d4open (&codeBaseDesc, "\\tis4000db\\tagvu.dbf")))
#endif WIN32
	{
	    tisSysLog(0,3, "Can not open \"/tagvu.dbf\"\n");
	    closeFiles();
		errCode = TAGVU_ERROR_TAGDESC;
		return;
	}
	d4tag_select (tagDesc, NULL);		// use sequential access
	d4unlock_all (tagDesc);
#ifndef WIN32
	if ( !(pvmapDesc = d4open (&codeBaseDesc, "/tis4000db/pvmap.dbf")))
#else
	if ( !(pvmapDesc = d4open (&codeBaseDesc, "\\tis4000db\\pvmap.dbf")))
#endif WIN32
	{
	    tisSysLog (0,3, "Can not open  \"pvamp.dbf\"\n");
	    closeFiles();
		errCode = TAGVU_ERROR_PVMAP;
		return;
	}
#ifndef WIN32
	if ( !(opTrackDesc = d4open (&codeBaseDesc, "/tis4000db/op_trak.dbf")))
#else
	if ( !(opTrackDesc = d4open (&codeBaseDesc, "\\tis4000db\\op_trak.dbf")))
#endif
	{
	    tisSysLog (0,3, "Can not open operator tracking file \"op_trak.dbf\"\n");
	    closeFiles();
		errCode = TAGVU_ERROR_OPTRAK;
		return;
	}
	/*
	 * initialize channel access
	 */
	if(ca_task_initialize () != AGNT_NORMAL)
	{
	    tisSysLog(0,3, "error in channel access init\n");
	    closeFiles();
	    errCode = TAGVU_ERROR_CA;
	    return;
	}
	pendingRequest = (TagValueData *)calloc(1,sizeof(TagValueData));
	operatorName[0] = 0;
}
tagvuServerApp::~tagvuServerApp()
{
  closeFiles();
  free(pendingRequest);
}
int tagvuServerApp::Run()
{
  tisSysLog(0,3,"tagvuServer running\n");
  while(1)
    {
      if(ServerWait(server,2000))
	{
	  if(reqMsg = (REQ_MSG_UNION *)GetReq(server))
	    {
	      msgType = ntohs(((TAGVU_MSG_HEADER *)reqMsg)->msgType);
	      switch (msgType)
		{
		case ADDTAG_MSG_ID:
		  msgLen = addTagRecord();
		  break;
		case REMOVETAG_MSG_ID:
		  msgLen = removeTagRecord();
		  break;
		case FIRSTRECORD_MSG_ID:
		  msgLen = firstTagRecord();
		  break;
		case NEXTRECORD_MSG_ID:
		  msgLen = nextTagRecord();
		  break;
		default:
		  msgLen = -1;
		  break;
		}  /* end switch(msgType) */
	      if (msgLen > 0)
		{
		  SendRsp(server,(u_char *)&respMsg, msgLen);
		  free((void *)reqMsg);
		}
	    }
	  else
	    {
	      break;		// GetReq returned zero this break will exit the while and the program
	    }
	}
      ca_pend_io((float)0.0);
    }
  tisSysLog(0,3,"tagvuServer exiting\n");
  CloseSvcSession(server);
  return(1);
}
void tagvuServerApp::closeFiles()
{
  if(pvmapDesc)	d4close(pvmapDesc);
  if(opTrackDesc)	d4close(opTrackDesc);
  if(tagDesc)		d4close(tagDesc);
  tagDesc = 0;
  pvmapDesc = 0;
  tagIndexDesc = 0;
  opTrackDesc = 0;
}
//
int tagvuServerApp::addTagRecord()
{
  TagValueData tvd;
  char *fptr = NULL;
  FIELD4 *fp = NULL;
  memset((char *)&tvd,0,sizeof(TagValueData));
  TAGVU_MSG_ADDTAG *addTag = (TAGVU_MSG_ADDTAG *)reqMsg;
  strcpy(tvd.pointName,addTag->pointName);
  respMsg.addAck.msgType = ADDNACK_MSG_ID;		// assume NACK unless seek succeeds
  if((d4seek(this->pvmapDesc,&tvd.pointName[0])) == 0)
    {
      strcpy(tvd.reason,addTag->reason);
      strcpy(operatorName,addTag->operatorApplied);
      tvd.tagType = addTag->tagType;
      tvd.tagValue = 1;		// tag this record
      tvd.type = ADD_TAG;
      fp = d4field(this->pvmapDesc,"DESC");
      fptr = f4str(fp);
      strncpy(tvd.descriptor,fptr,DESCRIPTOR_SZ);
      tvd.descriptor[DESCRIPTOR_SZ] = 0;
      fp = d4field(this->pvmapDesc,"LOCATION");
      fptr = f4str(fp);
      strncpy(tvd.location,fptr,LOCATION_SZ);
      tvd.location[LOCATION_SZ] = 0;
      SendTagValue(&tvd);
      respMsg.addAck.msgType = ADDACK_MSG_ID;
    }
  respMsg.addAck.msgType = htons(respMsg.recResponse.msgType);
  return(sizeof(TAGVU_MSG_ADDACK));
}
//
int tagvuServerApp::removeTagRecord()
{
  TagValueData tvd;
  memset((char *)&tvd,0,sizeof(TagValueData));
  TAGVU_MSG_REMOVETAG *remTag = (TAGVU_MSG_REMOVETAG *)reqMsg;
  strcpy(tvd.reason,remTag->reason);
  strcpy(operatorName,remTag->operatorApplied);
  tvd.recordNum = ntohl(remTag->recordNum);
  tvd.type = REMOVE_TAG;
  FillFromTagDesc(&tvd);
  SendTagValue(&tvd);
  respMsg.remAck.msgType = REMACK_MSG_ID;
  respMsg.remAck.msgType = htons(respMsg.recResponse.msgType);
  return(sizeof(TAGVU_MSG_REMACK));
}
//
int tagvuServerApp::firstTagRecord()
{
  memset(&respMsg.recResponse.newTagRecord,0,sizeof(PntTagRecord));
  if(d4top(tagDesc) == r4success)	// go to top of file
    {
      filterIt(&((TAGVU_MSG_RECORD_REQ *)reqMsg)->newTagFilter,&respMsg.recResponse.newTagRecord);
    }
  respMsg.recResponse.msgType = FIRSTRECORD_MSG_ID;
  respMsg.recResponse.msgType = htons(respMsg.recResponse.msgType);
  return(sizeof(TAGVU_MSG_RECORD_RESP));
}
//
int tagvuServerApp::nextTagRecord()
{
  memset(&respMsg.recResponse.newTagRecord,0,sizeof(PntTagRecord));
  if(d4skip(tagDesc,1) == r4success)	// skip to next record
    {
      filterIt(&((TAGVU_MSG_RECORD_REQ *)reqMsg)->newTagFilter,&respMsg.recResponse.newTagRecord);
    }
  respMsg.recResponse.msgType = NEXTRECORD_MSG_ID;
  respMsg.recResponse.msgType = htons(respMsg.recResponse.msgType);
  return(sizeof(TAGVU_MSG_RECORD_RESP));
}
void tagvuServerApp::filterIt(FILTER_DATA_PTR filter,PntTagRecord *tagRecord)
{
  int foundit = 5;
  if(filter != NULL)
    {
      foundit = 0;
      if(strlen(filter->pointName) == 0) foundit++;
      else foundit += (!strncmp(filter->pointName,f4str(d4field(tagDesc,"POINTNAME")),strlen(filter->pointName)) ? 1 : 0);
      if(strlen(filter->location) == 0) foundit++;
      else foundit += (!strncmp(filter->location, f4str(d4field(tagDesc,"LOCATION")),strlen(filter->location)) ? 1 : 0);
      if(strlen(filter->operatorApplied) == 0) foundit++;
      else foundit += (!strncmp(filter->operatorApplied,f4str(d4field(tagDesc,"OPER_APL")),strlen(filter->operatorApplied)) ? 1 : 0);
      if(strlen(filter->dateApplied) == 0) foundit++;
      else
	{
	  filter->dateDirection = ntohl(filter->dateDirection);
	  if(filter->dateDirection == 1)
	    {
	      foundit += (strncmp(filter->dateApplied,f4str(d4field(tagDesc,"DATE_APL")),strlen(filter->dateApplied)) < 0 ? 1 : 0);
	    }
	  else
	    {
	      foundit += (strncmp(filter->dateApplied,f4str(d4field(tagDesc,"DATE_APL")),strlen(filter->dateApplied)) > 0 ? 1 : 0);
	    }
	}
      filter->tagState = ntohl(filter->tagState);
      if(filter->tagState == FILTER_SHOW_ALL) foundit++;
      else
	{
	  foundit += ((d4deleted(tagDesc) && filter->tagState == FILTER_SHOW_UNTAGGED) ? 1 : 0);
	  foundit += ((!d4deleted(tagDesc) && filter->tagState == FILTER_SHOW_TAGGED) ? 1 : 0);
	}
    }
  tagRecord->recNumber = -1;			// desired record not found
  if(foundit == 5)
    {
      strncpy (tagRecord->pointName, f4str (d4field (tagDesc, "POINTNAME")), PVNAME_SZ);
      strncpy (tagRecord->descriptor, f4str (d4field (tagDesc, "DESCRIPTOR")), DESCRIPTOR_SZ);
      strncpy (tagRecord->location, f4str (d4field (tagDesc, "LOCATION")), LOCATION_SZ);
      strncpy (tagRecord->dateApplied, inputToDate(d4field (tagDesc, "DATE_APL")),DATE_SIZE);
      strncpy (tagRecord->timeApplied, f4str (d4field (tagDesc, "TIME_APL")), TIME_SIZE);
      strncpy (tagRecord->operatorApplied, f4str (d4field (tagDesc, "OPER_APL")), OPERATOR_SZ);
      strncpy (tagRecord->reasonApplied, f4str (d4field (tagDesc, "REASON_APL")), REASON_SIZE);
      strncpy (tagRecord->dateRemoved, inputToDate(d4field (tagDesc, "DATE_RMV")),DATE_SIZE);
      strncpy (tagRecord->timeRemoved, f4str (d4field (tagDesc, "TIME_RMV")), TIME_SIZE);
      strncpy (tagRecord->operatorRemoved, f4str (d4field (tagDesc, "OPER_RMV")), OPERATOR_SZ);
      strncpy (tagRecord->reasonRemoved, f4str (d4field (tagDesc, "REASON_RMV")), REASON_SIZE);
      tagRecord->tagType = f4char (d4field (tagDesc, "TAGTYPE"));
      tagRecord->isDeleted = d4deleted(tagDesc);
      tagRecord->recNumber = htonl(d4recno(tagDesc));
    }
}
//
// Tell CA to modify tag field.
//
int tagvuServerApp::SendTagValue(TagValueData *tagValueDataPtr)
{
  char	pointName[PVNAME_SZ + FLDNAME_SZ + 2];
  char	txtBuf [100];

  strcpy(pointName, tagValueDataPtr -> pointName);
  stripWhiteSpace (pointName);
  if(tagValueDataPtr -> tagType == 'O')
    strcat(pointName, ".TAGD");
  else
    strcat(pointName, ".ITAG");
  tagValueDataPtr->timeout = TIMEOUT_VALUE;
  tagValueDataPtr->thisPointer = (void *)this;
  *pendingRequest = *tagValueDataPtr;	// copy contents
  ca_build_and_connect(pointName, TYPENOTCONN, 0, &(pendingRequest->chId), NULL,ConnectionHandlerProxy, (void *)pendingRequest);
  ca_pend_io((float)0.0);
  /* Display and activity window */
  sprintf(txtBuf, "Setting %s value for %s...", 
	  (tagValueDataPtr -> tagType == 'O') ? OUT_SERVICE_TAG : INFO_TAG,
	  stripWhiteSpace(tagValueDataPtr -> pointName));
  tisSysLog(0,3,txtBuf);
  return(1);
}
char *tagvuServerApp::stripWhiteSpace(char *string)
{
  int	i;
  for (i=strlen (string)-1; i >= 0 && isspace(string[i]); string[i--] = 0);
  for (i=0; string[i] && isspace(string[i]); i++);
  if (i) strcpy (string, &string[i]);
  return (string);
}
//
// FD registration and its proxy function. The proxy functions are needed
// to resolve the "this" pointer.
//
void ConnectionHandlerProxy(connection_handler_args args)
{
  void *classPointer;
  classPointer = ((TagValueData *)ca_puser(args.chanid))->thisPointer;
  ((tagvuServerApp *)classPointer)->ConnectionHandler(args);
}
void TagValueEventProxy(event_handler_args args)
{
  void *classPointer;
  classPointer = ((TagValueData *)ca_puser(args.chanid))->thisPointer;
  ((tagvuServerApp *)classPointer)->TagValueEvent(args);
}
//
// Actual callback functions
//
void tagvuServerApp::ConnectionHandler(connection_handler_args args)
{
  TagValueData	*tagValueDataPtr;	/* Get the pointer to the tag information */
  tagValueDataPtr = (TagValueData *)ca_puser(args.chanid);	/* Update the point's tag value */
  /* Get the value of the tag field using a callback */
  ca_put (OLD_DBR_SHORT, (void *)args.chanid, (void *)(&(tagValueDataPtr -> tagValue)));
  ca_array_get_callback(OLD_DBR_STRING, 1, args.chanid, TagValueEventProxy, (void *)tagValueDataPtr);
  ca_flush_io();
}
void tagvuServerApp::TagValueEvent(event_handler_args args)
{
  char	dateStr[EXT_DATE_SIZE+1];
  char	timeStr[TIME_SIZE+1];
  char	tagValue[BUFSIZ];
  time_t	curTime;
  struct tm	*curTimePtr;
  TagValueData	*tagValueDataPtr;
  char txtBuf[32];

  tagValueDataPtr = (TagValueData *)ca_puser(args.chanid);
  strcpy(tagValue,(char *)args.dbr);
  stripWhiteSpace(tagValue);
  if(((tagValueDataPtr -> tagType == 'O') &&
      (atoi(tagValue) == tagValueDataPtr -> tagValue)) ||
     ((tagValueDataPtr -> tagType == 'I') &&
      (((tagValueDataPtr -> tagValue == 0) &&
	(strcmp(tagValue, "NO") == 0) ) ||
       ((tagValueDataPtr -> tagValue == 1) &&
	(strcmp(tagValue, "YES") == 0)))))
    {
      curTime = time(0L);
      curTimePtr = localtime(&curTime);
      /*
	GCT 14-May-1998 Add in century for Y2K compliance
      */
      sprintf (dateStr, "%04d%02d%02d", curTimePtr -> tm_year+1900,curTimePtr -> tm_mon+1,curTimePtr -> tm_mday);
      sprintf (timeStr, "%02d:%02d:%02d", curTimePtr -> tm_hour,curTimePtr -> tm_min, curTimePtr -> tm_sec);
      ca_clear_channel(tagValueDataPtr -> chId);
      ca_flush_io();
      if(tagValueDataPtr->type == ADD_TAG)
	{
	  // add new record to tag file
	  d4append_blank (tagDesc);
	  f4assign(d4field(tagDesc, "POINTNAME"), tagValueDataPtr->pointName);
	  f4assign(d4field(tagDesc, "LOCATION"), tagValueDataPtr->location);
	  f4assign(d4field(tagDesc, "DESCRIPTOR"), tagValueDataPtr->descriptor);
	  f4assign(d4field(tagDesc, "OPER_APL"), operatorName);
	  f4assign(d4field(tagDesc, "REASON_APL"), tagValueDataPtr->reason);
	  f4assign(d4field(tagDesc, "DATE_APL"), dateStr);
	  f4assign(d4field(tagDesc, "TIME_APL"), timeStr);
	  f4assign_char(d4field(tagDesc, "TAGTYPE"), tagValueDataPtr->tagType);
	  d4append_blank (opTrackDesc);
	  f4assign(d4field(opTrackDesc, "OPERATOR"), operatorName);
	  f4assign(d4field(opTrackDesc, "TRK_DATE"), dateStr);
	  f4assign(d4field(opTrackDesc, "TRK_TIME"), timeStr);
	  f4assign(d4field(opTrackDesc, "POINTNAME"), tagValueDataPtr -> pointName);
	  f4assign(d4field(opTrackDesc, "DESCRIPTOR"), tagValueDataPtr -> descriptor);
	  f4assign(d4field(opTrackDesc, "OLD_VALUE"),(tagValueDataPtr -> tagType == 'O') ? OUT_SERVICE_TAG : INFO_TAG);
	}
      else if(tagValueDataPtr->type == REMOVE_TAG)
	{
	  d4go(tagDesc, tagValueDataPtr -> recordNum);
	  f4assign(d4field(tagDesc, "DATE_RMV"), dateStr);
	  f4assign(d4field(tagDesc, "TIME_RMV"), timeStr);
	  f4assign(d4field(tagDesc, "OPER_RMV"), operatorName);
	  f4assign(d4field(tagDesc, "REASON_RMV"), tagValueDataPtr -> reason);
	  d4delete(tagDesc);
	  d4append_blank(opTrackDesc);
	  f4assign(d4field(opTrackDesc, "OPERATOR"), operatorName);
	  f4assign(d4field(opTrackDesc, "TRK_DATE"), dateStr);
	  f4assign(d4field(opTrackDesc, "TRK_TIME"), timeStr);
	  f4assign(d4field(opTrackDesc, "POINTNAME"), tagValueDataPtr -> pointName);
	  f4assign(d4field(opTrackDesc, "DESCRIPTOR"), tagValueDataPtr -> descriptor);
	  sprintf(txtBuf, "untag %s",(tagValueDataPtr -> tagType == 'O') ? OUT_SERVICE_TAG : INFO_TAG);
	  f4assign(d4field(opTrackDesc, "OLD_VALUE"), txtBuf);
	}
      d4flush_all(tagDesc);
      d4unlock_all(tagDesc);
      d4flush_all(opTrackDesc);
      d4unlock_all(opTrackDesc);
      /*
	Tell client to update his lists.
      */
      respMsg.addAck.msgType = UPDATELIST_MSG_ID;
      respMsg.addAck.msgType = htons(respMsg.recResponse.msgType);
      SendMsg(server,(unsigned char *)&respMsg,sizeof(TAGVU_MSG_UPDATELIST));
    }
}
void tagvuServerApp::FillFromTagDesc(TagValueData *tagdata)
{
  d4go(tagDesc,tagdata->recordNum);
  strncpy(tagdata->pointName, f4str (d4field (tagDesc, "POINTNAME")),PVNAME_SZ);
  tagdata->pointName[PVNAME_SZ] = 0;
  strncpy(tagdata->descriptor, f4str(d4field (tagDesc, "DESCRIPTOR")),DESCRIPTOR_SZ);
  tagdata->descriptor[DESCRIPTOR_SZ] = 0;
  strncpy(tagdata->location, f4str(d4field (tagDesc, "LOCATION")),LOCATION_SZ);
  tagdata->location[LOCATION_SZ] = 0;
  tagdata->tagType = f4char(d4field (tagDesc, "TAGTYPE"));
  d4top(tagDesc);
  tagdata->tagValue = 0;
  if (tagdata->tagType == 'O')
    {
      do
	{
	  if((!d4deleted (tagDesc)) &&
	     (f4char(d4field (tagDesc, "TAGTYPE")) == 'O') &&
	     (strncmp(tagdata -> pointName,f4str(d4field(tagDesc, "POINTNAME")), PVNAME_SZ) == 0))
	    {
	      tagdata -> tagValue++;
	    }
	}
      while(d4skip (tagDesc, 1) == 0);
      d4unlock_all(tagDesc);
      if(tagdata -> tagValue)
	{
	  tagdata -> tagValue--;
	}
    }
  // info tag, can not be set to NO until ALL info tags for the
  //   point have been deleted
  else
    {
      do
	{
	  if((!d4deleted(tagDesc)) &&
	     (f4char(d4field(tagDesc, "TAGTYPE")) == 'I') &&
	     (strncmp(tagdata -> pointName,f4str(d4field(tagDesc, "POINTNAME")), PVNAME_SZ) == 0))
	    {
	      tagdata -> tagValue++;
	    }
	}
      while (d4skip (tagDesc, 1) == 0);
      d4unlock_all (tagDesc);
      
      // if any info tags are not deleted
      if(tagdata -> tagValue)
	{
	  tagdata -> tagValue--;
	  // if we still have some left, set value to 1,since only 0 and 1 are legal values
	  if(tagdata -> tagValue) tagdata -> tagValue = 1;
	}
    }
}
/*
  GCT 14-May-1998 new function to convert date from "MM/DD/YY" to
  "CCYYMMDD"
*/
char *tagvuServerApp::inputToDate(FIELD4 *field)
{
  char dstr[20];
  static char dbaseDateStr[20];
  int m,d,y;

  strncpy(dstr,f4str(field),DATE_SIZE);
  if(strchr(dstr,'/') != 0)
    {
      sscanf(dstr,"%d/%d/%d",&m,&d,&y);
      sprintf(dbaseDateStr,"%04d%02d%02d",y+1900,m,d);
      f4assign(field,dbaseDateStr);			// re-write date in proper format
      d4flush_all(tagDesc);
      d4unlock_all(tagDesc);      
    }
  else
    {
      strcpy(dbaseDateStr,dstr);
    }
  return(dbaseDateStr);
}
