/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#include "../../../share/src/tankfarm/CSLManager.h"
	/*
	 * This is the CSL Manager client library implementation.  These functions
	 * are called by the CSL interperter to make the requests.
	 */

typedef struct
	{
	NODE	node;
	char	*hostName;
	CLIENT	*client;
	} Server;
	
static LIST	serverList;	/* the list of servers */

#define foreachServer(x) for(x=(Server *)lstFirst(&serverList);x;x=(Server *)lstNext(x))

static Server *getManagerServer(hostName)
char	*hostName;
	{
	static int firstTime = 1;
	Server	*pServer;

	if (firstTime)
		{
		firstTime = 0;
		lstInit(&serverList);
		}
	/*
	 * search for the named server and return a pointer (or a NULL)
	 */
	foreachServer(pServer)
		if(strcmp(pServer->hostName, hostName) == 0)
			break;
	if (!pServer)
		{
		/*
		 * allocate space for the new server and it's name
		 */
		pServer = (Server *)calloc(1, sizeof (Server));
		if (!pServer)
			return NULL;
	
		pServer->hostName = (char *)calloc(strlen(hostName) + 1, sizeof (char));
		if (!pServer->hostName)
			return NULL;
	
		/*
		 * initialize the script and add it to the list
		 */
		strcpy(pServer->hostName, hostName);
		pServer->client = clnt_create(hostName, CSLMANAGERPROG, CSLMANAGERVERS, "tcp");
	/*clnt_pcreateerror("CSLManager");*/
		lstAdd(&serverList, &pServer->node);
		}

	return pServer;
	}

ScriptInfo *CSLManagerGetScriptInfo(hostName, dirname)
char	*hostName;
char	*dirname;
{
	static getInfoResult *result = NULL;
	static ScriptInfo scriptInfo;
	
	if (!result || !result->getInfoResult_u.list)	/* update the list */
		{
		Server *pServer = getManagerServer(hostName);

		if (!pServer || !pServer->client)
			return NULL;

		if (result)	/* get rid of the old (null) one */	
			xdr_free((xdrproc_t)xdr_getInfoResult, (char *)result);

		result = csl_manager_get_info_1(&dirname, pServer->client);
		if (!result || !result->getInfoResult_u.list)
			return NULL;
		}

	scriptInfo.scriptName = result->getInfoResult_u.list->scriptName;
	scriptInfo.modTime = result->getInfoResult_u.list->modTime;
	scriptInfo.buildTime = result->getInfoResult_u.list->buildTime;
	scriptInfo.size	= result->getInfoResult_u.list->size;
	scriptInfo.mode	= result->getInfoResult_u.list->mode;
	scriptInfo.more	= (result->getInfoResult_u.list->next != NULL);

	result->getInfoResult_u.list = result->getInfoResult_u.list->next;

	return &scriptInfo;
	}


/* Default timeout can be changed using clnt_control() */
static struct timeval TIMEOUT = { 25, 0 };

getInfoResult *
csl_manager_get_info_1(argp, clnt)
	nametype *argp;
	CLIENT *clnt;
{
	static getInfoResult clnt_res;

	memset((char *)&clnt_res, 0, sizeof (clnt_res));
	if (clnt_call(clnt, CSL_MANAGER_GET_INFO,
		(xdrproc_t) xdr_nametype, (caddr_t) argp,
		(xdrproc_t) xdr_getInfoResult, (caddr_t) &clnt_res,
		TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&clnt_res);
}
