/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

#include <stdio.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include <CSLScript.h>
#include <CSLManager.h>
#include <CSLMonitor.h>

char	*server	= "localhost";
char	environmentString[500]	= { 0 };	/* string to collect local environment variables in */

void	addEnvironmentVariable(variableName)
char	*variableName;
	{
	char	*getenv(), *s = getenv(variableName);
	char	buf[100];

	sprintf(buf, "%s=%s;export %s;", variableName, s ? s : "", variableName);
	if ((strlen(environmentString) + strlen(buf)) < sizeof environmentString)
		strcat(environmentString, buf);
	}

main(argc, argv)
int argc;
char *argv[];
	{
	if (argc == 1)
		{
		dir();
		active();
		}
	else
		{
		addEnvironmentVariable("USER");
		addEnvironmentVariable("HOME");
		addEnvironmentVariable("DISPLAY");
		for (argc--, argv++; argc-- > 0; argv++ )
			run(*argv, 0L);
		}
	}

dir()
	{
	char		*dir = (dir = getenv("CSL_SCRIPT_PATH")) ? dir : "";
	ScriptInfo	*scriptInfo;

	printf("Script Directory:\n");
	while (scriptInfo = CSLManagerGetScriptInfo(server, dir))
		{
		char		mod_time_str[20];
		struct tm	*mod_time = localtime((time_t *)&(scriptInfo->modTime));
		char		*status	 = (scriptInfo->buildTime > scriptInfo->modTime) ? "  valid" : "invalid";

		status = (scriptInfo->buildTime == 0 && scriptInfo->mode & S_IEXEC) ? " script" : status;
		strftime( mod_time_str, sizeof mod_time_str, "%b %d %H:%M", mod_time );
		printf("	%7d %s %s %s\n", scriptInfo->size, mod_time_str, status, scriptInfo->scriptName);
		if (!scriptInfo->more)
			break;
		}
	}

active()
	{
	ScriptEntry	*scriptEntry;

	printf("Active List:\n");
	printf("	%40s	Id	Status		Time	Return Code	Activity\n", "Name");
	while (scriptEntry = CSLMonitorGetScriptEntry(server))
		{
		extern char		*(scriptStatusText[]);
		ScriptStatus		scriptStatus;
		ExtendedScriptStatus	extendedScriptStatus;
		
		scriptStatus = CSLMonitorGetScriptStatus(server, scriptEntry->scriptId, &extendedScriptStatus);
		printf("	%40s	%d	%s	%d	%f	%s\n",
			scriptEntry->scriptName,
			scriptEntry->scriptId,
			scriptStatusText[scriptStatus],
			extendedScriptStatus.timeWithThisStatus,
			extendedScriptStatus.completionCode,
			extendedScriptStatus.messageText ? extendedScriptStatus.messageText : "no message"
			);
		if (!scriptEntry->more)
			break;
		}
	}

run(scriptName, scriptDelay)
char *scriptName;
long scriptDelay;
	{
	extern char	*(scriptStatusText[]);
	ScriptId	scriptId = CSLMonitorExecute(server, CSLscript, scriptName, scriptDelay, environmentString);
	ScriptStatus		scriptStatus;
	ExtendedScriptStatus	extendedScriptStatus;
	
	printf("got scriptId:%d for script %s\n", scriptId, scriptName);
	do
		{
		scriptStatus = CSLMonitorGetScriptStatus(server, scriptId, &extendedScriptStatus);
		printf("%s (for %d seconds)\n", scriptStatusText[scriptStatus], extendedScriptStatus.timeWithThisStatus);
		sleep(1);
		}
	while (scriptStatus != Unknown && scriptStatus != Exited && scriptStatus != Killed && scriptStatus != Aborted);
	printf("ret code:%f\n", extendedScriptStatus.completionCode);
	}
