/*
 *	CSLMonitor.x:	CSL Monitor task protocols
 */
#ifdef RPC_HDR
%/* NOTE: DO NOT EDIT THIS FILE. This file is created from CSLMonitor.x by rpcgen */
%#include <stdio.h>
%#include <string.h>
%#include <ctype.h>
%#include <sys/types.h>
%#include <rpc/rpc.h>
%#include <syslog.h>
%#include "lstLib.h"
%#include "TankFarm.h"
%#include "CSLScript.h"
%
%#define SCRIPTID_UNKNOWN	(FIRST_SERVER_SPECIFIC_ERROR-0)
%#define SCRIPT_NOT_RUNNING	(FIRST_SERVER_SPECIFIC_ERROR-1)
%#define KILL_FAILED		(FIRST_SERVER_SPECIFIC_ERROR-2)
%#define SCRIPT_IS_RUNNING	(FIRST_SERVER_SPECIFIC_ERROR-3)
%#define SCRIPT_STATUS_NOT_YET_TAKEN	(FIRST_SERVER_SPECIFIC_ERROR-4)
%
%#define SCRIPT_LINGER_TIME	(60L*60L)
%
%typedef int	ScriptId;
%typedef enum
%	{
%	Continue,
%	Linger
%	} WaitConstraint;
%typedef enum
%	{
%	CSLscript,
%	SHELLscript
%	} ScriptType;
%typedef enum
%	{
%	Unknown,
%	Scheduled,
%	Running,
%	Exited,
%	Aborted,
%	Killed,
%	} ScriptStatus;
#endif
#ifdef RPC_CLNT
%char *(scriptStatusText[]) =	/* should match the ScriptStatus enum above! */
%	{
%	"Unknown  ",
%	"Scheduled",
%	"Running  ",
%	"Exited   ",
%	"Aborted  ",
%	"Killed   ",
%	};
#endif
#ifdef RPC_HDR
%typedef struct scriptEntry
%	{
%	char	*scriptName;
%	int	scriptId;
%	int	more;
%	} ScriptEntry;
%
%typedef struct extendedScriptStatus
%	{
%	ScriptStatus	scriptStatus;
%	long		timeWithThisStatus;
%	double		completionCode;
%	char		*messageText;
%	} ExtendedScriptStatus;
%
%extern char *(scriptStatusText[]);
%	
%int	CSLMonitorAttach();	/* the interpreter calls this to get a connection to the monitor */
%int	CSLMonitorDetach();	/* the interpreter calls this before exiting to kill all connections */
%int	CSLMonitorSetMyStatus();/* the interpreter calls this to set the scripts status and exit code */
%int	CSLMonitorMessage();	/* the interpreter calls this to pass a text message to the monitor */
%ScriptId CSLMonitorExecute();	/* called by a client that wants to execute a script */
%int	CSLMonitorKill();	/* called by a client that wants to kill a script */
%ScriptStatus	CSLMonitorGetScriptStatus(); /* called by a client that wants to get the status of a script */
%ScriptEntry *CSLMonitorGetScriptEntry(); /* called by a client that wants to get a list of monitored scripts */
%int	CSLMonitorRelease();	/* called by a client that wants to release an exited scripts exit status info */
%	
#endif

#define	MAXMESSAGELEN		104
#define	MAXSCRIPTNAMELEN	104
#define	MAXENVIRONSTRINGLEN	200
#define	HOSTNAMELEN		24

typedef string 	MessageType<MAXMESSAGELEN>;
typedef string 	ScriptNameType<MAXSCRIPTNAMELEN>;
typedef string 	EnvironType<MAXENVIRONSTRINGLEN>;

struct attachArg {
    int		scriptId;
};

struct setStatusArg {
    int		scriptId;
    int		status;
    double	completionCode;
};

struct messageArg {
    int		scriptId;
    MessageType	message;
};

struct executeArg {
    int			scriptType;
    ScriptNameType	scriptName;
    long		preStartDelay;
    EnvironType		environmentString;
    int			scriptId;
};

struct killArg {
    int		scriptId;
};

struct getStatusArg {
    int		scriptId;
};

struct getStatusResult {
    int		scriptStatus;
    long	timeWithThisStatus;
    double	completionCode;
    MessageType	messageText;
};

typedef struct getEntryInfo *GetEntryResult;
struct getEntryInfo {
    GetEntryResult	next;
    ScriptNameType	scriptName;
    int			scriptId;
};

struct getEntryResult {
    GetEntryResult	list;
};

struct releaseArg {
    int		scriptId;
};

struct detachArg {
    int		scriptId;
};

program CSLMONITORPROG {
	version CSLMONITORVERS {
		int	CSL_MONITOR_ATTACH(attachArg) = 1;
		int	CSL_MONITOR_SET_MY_STATUS(setStatusArg)	= 2;
		int	CSL_MONITOR_MESSAGE(messageArg)	= 3;
		int	CSL_MONITOR_EXECUTE(executeArg)	= 4;
		int	CSL_MONITOR_KILL(killArg) = 5;
		getStatusResult	CSL_MONITOR_GET_STATUS(getStatusArg) = 6;
		getEntryResult	CSL_MONITOR_GET_ENTRY(void) = 7;
		int	CSL_MONITOR_RELEASE(releaseArg)	= 8;
		int	CSL_MONITOR_DETACH(detachArg) = 9;
	} = 1;
} = CSL_MONITOR_PROGRAM_NUMBER;

#ifdef RPC_CLNT
%/* NOTE: DO NOT EDIT THIS FILE. This file is created from CSLMonitor.x by rpcgen */
%
%	/*
%	 * This is the CSL Monitor client library implementation.  These functions
%	 * are called by the CSL interperter to make the requests.
%	 */
%
%typedef struct
%	{
%	NODE		node;
%	char		*hostName;
%	CLIENT		*client;
%	} Server;
%	
%static LIST serverList;	/* the list of servers */
%
%#define foreachServer(x) for(x = (Server *)lstFirst(&serverList); x; x = (Server *)lstNext(x))
%
%static Server *getMonitorServer(hostName)
%char *hostName;
%{
%	static int firstTime = 1;
%	Server *pServer;
%
%	if (firstTime) {
%	    firstTime = 0;
%	    lstInit(&serverList);
%	}
%	
%	/*
%	 * search for the named server and return a pointer (or a NULL)
%	 */
%	foreachServer(pServer)
%	    if(strcmp(pServer->hostName, hostName) == 0)
%		break;
%	if (!pServer) {
%
%	    /* allocate space for the new server and it's name */
%
%	    pServer = (Server *)calloc(1, sizeof (Server));
%	    if (!pServer)
%		return NULL;
%	
%	    pServer->hostName = (char *)calloc(strlen(hostName) + 1, sizeof (char));
%	    if (!pServer->hostName)
%		return NULL;
%	
%	    /* initialize the script and add it to the list */
%
%	    strcpy(pServer->hostName, hostName);
%	    pServer->client = clnt_create(hostName, CSLMONITORPROG, CSLMONITORVERS, "tcp");
%	    lstAdd(&serverList, &pServer->node);
%	}
%
%	return pServer;
%}
#endif

#ifdef RPC_SVC
%/* NOTE: DO NOT EDIT THIS FILE. This file is created from CSLMonitor.x by rpcgen */
%
%	/*
%	 * This is the CSL Monitor server implementation.  These functions handle the
%	 * requests that the CSL interperter makes while running CSL programs.
%	 */
%	
%#include <time.h>
%#include <string.h>
%#include "CSLMonitorDefs.h"
%	
%LIST 		scriptList;	/* the list of scripts */
%int		MyHandle;	/* Handle to arbiter */
%int		MyRole	;	/* My current role in life */
%int		Redundant;	/* Redundancy operational */
%int		Verbose;	/* Print various status messages */
%int		Debug;		/* Print debugging information */
%ScriptId	MasterScriptId	= 0;
%extern	int	MsgLengths [];
%	
%#define foreachScript(x) for(x = (Script *)lstFirst(&scriptList); x; x = (Script *)lstNext(x))
%
%static Script *getScript(scriptId)
%ScriptId scriptId;
%{
%	static int firstTime = 1;
%	Script *pScript;
%	static Script debugScript; /* used for scriptId == -10 for debugging the interpreter */
%
%	if (scriptId == -10)
%	    return &debugScript;
%
%	if (firstTime) {
%	    firstTime = 0;
%	    lstInit(&scriptList);
%	}
%
%	/* search for the given scriptId and return a pointer (or a NULL) */
%
%	foreachScript(pScript)
%	    if(pScript->scriptId == scriptId)
%		break;
%	return pScript;
%}
%
%char *makeMallocedString(text)
%char *text;
%{
%	return strcpy(malloc(strlen(text)+1), text);
%}
%
%#include <sys/types.h>
%#include <sys/wait.h>
%void terminateScriptIfPossible(pScript)
%Script	*pScript;
%{
%	DetachMsg	Msg;
%#ifdef SOLARIS
%	int		processStatus;
%#else
%	union wait	processStatus;
%#endif
%#ifdef SOLARIS
%	if (pScript->pid && (waitpid (pScript->pid, &processStatus, WNOHANG) == pScript->pid)) {
%#else
%	if (pScript->pid && (wait4(pScript->pid, &processStatus, WNOHANG, NULL) == pScript->pid)) {
%#endif
%	    pScript->pid = 0;
%	    pScript->statusChangeTime = time(0);
%	    pScript->scriptStatusTaken = No;
%	    if (pScript->scriptType == CSLscript) {
%		pScript->scriptStatus = WIFSIGNALED(processStatus) ? Killed : /*Exited*/ pScript->scriptStatus;
%		pScript->completionCode = WIFSIGNALED(processStatus) ? 1.0 : pScript->completionCode;
%	    } else {
%		pScript->scriptStatus = WIFSIGNALED(processStatus) ? Killed : Exited;
%		pScript->completionCode =
%			WIFEXITED(processStatus) ? WEXITSTATUS(processStatus) : 1.0;
%		pScript->Detached = Yes;
%		if (MyRole == ROLE_MASTER) {  /* Inform slave that script has detached */
%		    if (Debug)
%			syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: sending DETACH: id=%d\n",
%				 pScript->scriptId);
%		    Msg.msgType = htonl (DETACH);
%		    Msg.scriptId = htonl (pScript->scriptId);
%		    appSendData (MyHandle, (char *)&Msg, sizeof (Msg));
%		}
%	    }
%	    pScript->haveCompletionCode = Yes;
%	    if (Debug)
%		syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: Script %d terminated.\n", pScript->scriptId);
%	}
%}
%
%void releaseScriptIfPossible(pScript)
%Script	*pScript;
%{
%	if (pScript->scriptStatus != Scheduled && pScript->scriptStatus != Running &&
%	   			(time(0) - pScript->statusChangeTime) > SCRIPT_LINGER_TIME) {
%	    lstDelete(&scriptList, &pScript->node);
%	    free(pScript);
%	}
%}
#endif

#ifdef RPC_CLNT
%
%int CSLMonitorAttach(hostName, scriptId) /* interp calls this to get a 'process slot' */
%char *hostName;
%ScriptId scriptId;
%	{
%	Server *pServer = getMonitorServer(hostName);
%	int *result = NULL;
%	int firstTime = 1;
%
%	/* If the first time here, register with the arbiter and */
%	/* determine master/slave status. */
%
%	if (pServer && pServer->client)
%		{
%		attachArg arg;
%
%		arg.scriptId = scriptId;
%		result = csl_monitor_attach_1(&arg, pServer->client);
%		}
%
%	return (result) ? *result : TF_ERROR;
%	}
#endif
#ifdef RPC_SVC
%
%int *csl_monitor_attach_1(arg, rqstp)
%attachArg *arg;
%struct svc_req	*rqstp;
%	{
%	static int result;
%	Script *pScript = getScript(arg->scriptId);
%
%	if (Debug)
%	    syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: Attach, scriptId=%d\n",
%			 arg->scriptId);
%
%	result = (pScript) ? TF_OK : SCRIPTID_UNKNOWN;
%	return &result;
%	}
#endif

#ifdef RPC_CLNT
%
%int CSLMonitorDetach(hostName, scriptId) /* interp calls this before exiting to kill all connections */
%char *hostName;
%ScriptId scriptId;
%	{	
%	Server *pServer = getMonitorServer (hostName);
%	int	*result = NULL;
%
%
%	if (pServer && pServer->client) {
%	    detachArg	arg;
%
%	    arg.scriptId = scriptId;
%	    result = csl_monitor_detach_1(&arg, pServer->client);
%	}
%
%	/*
%	 * destroy the client connections to ALL of the servers
%	 * NOTE: the server is not notified. Any script records remain in the server
%	 *	 so that their status can be retrieved after they die.
%	 */
%	foreachServer(pServer)
%		if (pServer && pServer->client)
%			clnt_destroy(pServer->client);
%
%	lstFree(&serverList);
%
%	return (result) ? *result : TF_ERROR;
%	}
#endif
#ifdef RPC_SVC
%
%int *csl_monitor_detach_1(arg, rqstp)
%detachArg *arg;
%struct svc_req *rqstp;
%{
%	static	int	result;
%	Script	*pScript = getScript (arg->scriptId);
%	DetachMsg	Msg;
%
%	if (Debug)
%	    syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: DETACH, scriptId=%d\n",
%				 arg->scriptId);
%
%	if (!pScript)
%	    result = SCRIPTID_UNKNOWN;
%	else {
%	    pScript->Detached = Yes;
%	    result = TF_OK;
%	}
%
%	return &result;
%}
%
#endif

#ifdef RPC_CLNT
%
%int CSLMonitorSetMyStatus(hostName, scriptId, status, completionCode)
%char *hostName;
%ScriptId scriptId;
%ScriptStatus status;
%double completionCode;
%	{
%	Server *pServer = getMonitorServer(hostName);
%	int *result = NULL;
%	
%	if (pServer && pServer->client) {
%	    setStatusArg arg;
%	    arg.scriptId = scriptId;
%	    arg.status = status;
%	    arg.completionCode = completionCode;
%	    result = csl_monitor_set_my_status_1(&arg, pServer->client);
%	}
%	return (result) ? *result : TF_ERROR;
%}
#endif
#ifdef RPC_SVC
%
%int *csl_monitor_set_my_status_1(arg, rqstp)
%setStatusArg *arg;
%struct svc_req	*rqstp;
%{
%	static int result;
%	Script *pScript = getScript(arg->scriptId);
%	SetStatusMsg Msg;
%
%	if (Debug)	
%	    syslog (LOG_ALERT|LOG_LOCAL1,
%			"CSLMonitor_svc: SetMyStatus, scriptId=%d, Status=%.2lf, compCode=%.2lf\n",
%			arg->scriptId, arg->status, arg->completionCode);
%	if (pScript)
%		{
%		if (pScript->scriptStatus != arg->status)
%			pScript->statusChangeTime = time(0);
%		pScript->scriptStatus	= arg->status;
%		pScript->completionCode	= arg->completionCode;
%		}
%
%	result = (pScript) ? TF_OK : SCRIPTID_UNKNOWN;
%	return &result;
%}
%
#endif

#ifdef RPC_CLNT
%
%int CSLMonitorMessage(hostName, scriptId, message)
%char *hostName;
%ScriptId scriptId;
%char *message;
%{
%	Server *pServer = getMonitorServer(hostName);
%	int *result = NULL;
%	
%	if (pServer && pServer->client) {
%	    messageArg arg;
%	    arg.scriptId = scriptId;
%	    arg.message = message;
%	    result = csl_monitor_message_1(&arg, pServer->client);
%	}
%	return (result) ? *result : TF_ERROR;
%}
%
#endif
#ifdef RPC_SVC
%
%int *csl_monitor_message_1(arg, rqstp)
%messageArg *arg;
%struct svc_req	*rqstp;
%{
%	static int result;
%	Script *pScript = getScript(arg->scriptId);
%	MessageMsg Msg;
%
%	if (Debug)
%	    syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: Message, scriptId=%d, msg=%s\n",
%			arg->scriptId, arg->message);
%
%	if (pScript)
%		strncpy(&pScript->message[0], arg->message, MAXMESSAGELEN);
%
%	result = (pScript) ? TF_OK : SCRIPTID_UNKNOWN;
%
%	/* If this monitor is the master, send a MESSAGE message to */
%	/* the slave. */
%
%	if (MyRole == ROLE_MASTER) {
%	    if (Debug)
%		syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: sending MESSAGE, Id=%d, Msg=%s\n",
%			arg->scriptId, arg->message);
%
%	    Msg.msgType = htonl (MESSAGE);
%	    Msg.scriptId = htonl (arg->scriptId);
%	    strcpy (Msg.message, arg->message);
%	    appSendData (MyHandle, (char *)&Msg, sizeof (Msg));
%	}
%
%	return &result;
%}
#endif

#ifdef RPC_CLNT
%
%ScriptId CSLMonitorExecute(hostName, scriptType, scriptName, preStartDelay, environmentString)
%char *hostName;
%ScriptType scriptType;
%char *scriptName;
%long preStartDelay;
%char *environmentString;
%{
%	Server *pServer = getMonitorServer(hostName);
%	ScriptId *result = NULL;
%	char *s;
%	
%	for (s = strchr (scriptName, 0)-1; s > scriptName && isspace(*s); s--)	/* remove trailing blanks */
%		*s = 0;
%	for (s = strchr (environmentString, 0)-1; s > environmentString && isspace(*s); s--)	
%		*s = 0;
%	if (strlen(scriptName) < MAXSCRIPTNAMELEN && strlen(environmentString) < MAXENVIRONSTRINGLEN)
%	    if (pServer && pServer->client) {
%		executeArg arg;
%		arg.scriptType = scriptType;
%		arg.scriptName = scriptName;
%		arg.preStartDelay = preStartDelay;
%		arg.environmentString = environmentString;
%		arg.scriptId = -1;	/* Let server pick script id */
%		result = csl_monitor_execute_1(&arg, pServer->client);
%	    }
%	return (result) ? *result : (ScriptId)TF_ERROR;
%}
%
#endif
#ifdef RPC_SVC
%
%ScriptId *csl_monitor_execute_1(arg, rqstp)
%executeArg *arg;
%struct svc_req	*rqstp;
%{
%	char command[500], *args;
%	char job[500];
%	static ScriptId	result;
%	Script *pScript = getScript(0);	/* force auto-initialization, should return NULL */
%	ExecuteMsg Msg;
%	Script *p;
%
%	if (Debug)
%	    syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: EXECUTE, name=%s\n", arg->scriptName);
%
%	result = (ScriptId)TF_ERROR;	/* in case of error */
%
%	/*
%	 * run down the script list waiting for scripts that are terminating
%	 */
%	foreachScript(pScript) {
%	    terminateScriptIfPossible(pScript);
%	    releaseScriptIfPossible(pScript);
%	}
%
%	/*
%	 * allocate space for the new Script and initialize it
%	 */
%	pScript = (Script *)calloc(1, sizeof (Script));
%	if (!pScript)
%		return &result;
%	
%	pScript->scriptType = arg->scriptType;
%	strncpy(&pScript->scriptName[0], arg->scriptName, sizeof pScript->scriptName);
%	strncpy (pScript->scriptEnviron, arg->environmentString, sizeof (pScript->scriptName));
%	pScript->scriptId = (arg->scriptId == -1) ? ++MasterScriptId : arg->scriptId;
%	pScript->scriptStatus = arg->scriptType == CSLscript ? Scheduled : Running;
%	pScript->statusChangeTime = time(0);
%	pScript->scriptStatusTaken = 0;
%	pScript->completionCode = 0.0;
%	pScript->Detached = No;
%	strcpy(&pScript->message[0], "no message");
%
%
%	/* If this monitor is the master, send an EXECUTE message to */
%	/* the slave. */
%
%	if (MyRole == ROLE_MASTER) {
%
%	    if (Debug)
%		syslog (LOG_ALERT|LOG_LOCAL1,
%			"CSLMonitor_svc: sending EXECUTE, Id=%d, Type=%d, Name=%s, Delay=%ld, Env=%s\n",
%			pScript->scriptId,
%			arg->scriptType, arg->scriptName,
%			arg->preStartDelay, arg->environmentString);
%	
%	    Msg.msgType = htonl (EXECUTE);
%	    Msg.scriptType = htonl (arg->scriptType);
%	    Msg.preStartDelay = htonl (arg->preStartDelay);
%	    strcpy (Msg.scriptName, arg->scriptName);
%	    strcpy (Msg.environmentString, arg->environmentString);
%	    Msg.scriptId = htonl (pScript->scriptId);
%	    appSendData (MyHandle, (char *)&Msg, sizeof (Msg));
%	}
%
%	/*
%	 * exec a shell which sleeps for the preStartDelay and then executes
%	 * the script, don't wait for it the script is executed either by
%	 * CSLInterpreter or another shell
%	 */
%	args = strchr (arg->scriptName, ' ');
%	if (!args)
%		args = "";
%	else
%		*args++ = 0;
%	job[0] = 0;
%	if (arg->scriptType == CSLscript) {
%	    sprintf(job, "CSLInterpreter %d %s \"%s\"", pScript->scriptId,
%			arg->scriptName, args);	/* note arg escaping quotes */
%	} else {
%	    char *getenv(), *path = getenv(CSL_SCRIPT_PATH);
%
%	    if (*arg->scriptName != '/' && path)
%		sprintf(job, "%s/", path);
%
%	    /* If in slave mode, run a dummy script that always completes successfully */
%
%	    if (MyRole == ROLE_SLAVE)
%		sprintf(&job[strlen(job)], "slave.shell.script \"%s %s\"", arg->scriptName, args);
%	    else
%		sprintf(&job[strlen(job)], "%s %s", arg->scriptName, args);	/* note NO arg escaping quotes */
%	}
%	sprintf(command, "sleep %d;%sexec %s", abs(arg->preStartDelay), arg->environmentString, job);
%
%	switch (pScript->pid = fork()) {
%	    case 0:
%		execl("/bin/sh", "sh", "-c", command, 0);
%		exit(1);	/* the child becomes the script */
%	    default:
%		lstAdd(&scriptList, &pScript->node);
%		break;		/* the parent adds the script to the scriptList */
%	    case -1:
%		free(pScript);
%		return &result;	/* fork() error, clean up and return an error */
%	    }
%
%/*	if (Debug) {
%	    syslog (LOG_ALERT|LOG_LOCAL1, "Id Type Sts  Code T D Script-Name");
%	    foreachScript(p) {
%		syslog (LOG_ALERT|LOG_LOCAL1, "%3d %3d %3d %5.1lf %d %d %s",
%			p->scriptId, p->scriptType, p->scriptStatus,
%			p->completionCode,
%			p->scriptStatusTaken, p->Detached,
%			p->scriptName);
%	    }
%	}
%*/
%	result = pScript->scriptId;
%	return &result;
%}
#endif

#ifdef RPC_CLNT
%int CSLMonitorKill(hostName, scriptId)
%char *hostName;
%ScriptId scriptId;
%{
%	Server *pServer = getMonitorServer(hostName);
%	int *result = NULL;
%	
%	if (pServer && pServer->client) {
%	    killArg	arg;
%	    arg.scriptId = scriptId;
%	    result = csl_monitor_kill_1(&arg, pServer->client);
%	}
%	return (result) ? *result : TF_ERROR;
%}
#endif
#ifdef RPC_SVC
%#include <signal.h>
%
%int *csl_monitor_kill_1(arg, rqstp)
%killArg *arg;
%struct svc_req	*rqstp;
%{
%	static int result;
%	Script *pScript	= getScript(arg->scriptId);
%	KillMsg Msg;
%
%	if (Debug)
%	    syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: Kill, scriptId=%d\n", arg->scriptId);
%
%	if (!pScript)
%	    result = SCRIPTID_UNKNOWN;
%	else if (!pScript->pid || (pScript->scriptStatus != Scheduled && pScript->scriptStatus != Running))
%	    result = SCRIPT_NOT_RUNNING;
%	else if (kill(pScript->pid, SIGKILL) == -1)
%	    result = KILL_FAILED;
%	else {
%	    terminateScriptIfPossible(pScript);
%	    pScript->Detached = Yes;
%	    result = TF_OK;
%	}
%
%	/* If this monitor is the master, send a KILL message to */
%	/* the slave. */
%
%	if (MyRole == ROLE_MASTER) {
%	    if (Debug)
%		syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: sending KILL, scriptId=%d\n",
%				 arg->scriptId);
%	    Msg.msgType = htonl (KILL);
%	    Msg.scriptId = htonl (arg->scriptId);
%	    appSendData (MyHandle, (char *)&Msg, sizeof (Msg));
%	}
%
%	return &result;
%}
#endif

#ifdef RPC_CLNT
%
%ScriptStatus CSLMonitorGetScriptStatus(hostName, scriptId, pExtendedScriptStatus)
%char *hostName;
%ScriptId scriptId;
%ExtendedScriptStatus *pExtendedScriptStatus;	/* NULL if undesired */
%{
%	Server *pServer = getMonitorServer(hostName);
%	getStatusResult	*result = NULL;
%	
%	if (pServer && pServer->client) {
%	    getStatusArg arg;
%	    arg.scriptId = scriptId;
%	    result = csl_monitor_get_status_1(&arg, pServer->client);
%	    if (result && pExtendedScriptStatus) {
%		pExtendedScriptStatus->scriptStatus = result->scriptStatus;
%		pExtendedScriptStatus->completionCode = result->completionCode;
%		pExtendedScriptStatus->timeWithThisStatus = result->timeWithThisStatus;
%		pExtendedScriptStatus->messageText = result->messageText;
%	    }
%	}
%	return (result) ? result->scriptStatus : Unknown;
%}
#endif
#ifdef RPC_SVC
%
%getStatusResult *csl_monitor_get_status_1(arg, rqstp)
%getStatusArg	*arg;
%struct svc_req	*rqstp;
%{
%	static getStatusResult	result;
%	Script *pScript = getScript(arg->scriptId);
%	GetStatusMsg Msg;
%
%	if (Debug)
%	    syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: GetStatus, scriptId=%d\n",
%			 arg->scriptId);
%
%	xdr_free((xdrproc_t)xdr_getStatusResult, (char *)&result);
%
%	if (pScript) {
%
%	    /* generate the result */
%
%	    terminateScriptIfPossible(pScript);
%	    result.scriptStatus = pScript->scriptStatus;
%	    result.timeWithThisStatus = time(0) - pScript->statusChangeTime;
%	    result.completionCode = pScript->completionCode;
%	    result.messageText = makeMallocedString(&pScript->message[0]);
%	    pScript->scriptStatusTaken = (pScript->haveCompletionCode == 1);
%	} else {
%	    result.scriptStatus = Unknown;
%	    result.timeWithThisStatus = 0;
%	    result.messageText = makeMallocedString("");
%	}
%
%	return &result;
%}
#endif

#ifdef RPC_CLNT
%
%ScriptEntry *CSLMonitorGetScriptEntry(hostName)
%char *hostName;
%{
%	static getEntryResult *result = NULL;
%	static ScriptEntry scriptEntry;
%	
%	if (!result || !result->list) {
%	    Server *pServer = getMonitorServer(hostName);
%	    if (!pServer || !pServer->client)
%		return NULL;
%
%	    if (result)
%		xdr_free((xdrproc_t)xdr_getEntryResult, (char *)result);	/* get rid of the old (null) one */
%
%	    result = csl_monitor_get_entry_1(NULL, pServer->client);
%	    if (!result || !result->list)
%		return NULL;
%	}
%
%	scriptEntry.scriptName = result->list->scriptName;
%	scriptEntry.scriptId = result->list->scriptId;
%	scriptEntry.more = (result->list->next != NULL);
%
%	result->list = result->list->next;
%	return &scriptEntry;
%}
#endif
#ifdef RPC_SVC
%
%getEntryResult *csl_monitor_get_entry_1(dummyArg, rqstp)
%void *dummyArg;
%struct svc_req	*rqstp;
%{
%	static getEntryResult result;
%	Script *pScript	= getScript(0);	/* force auto-initialization, should return NULL */
%	GetEntryResult nl;
%	GetEntryResult *nlp;
%
%	xdr_free((xdrproc_t)xdr_getEntryResult, (char *)&result);
%
%	nlp = &result.list;
%	foreachScript(pScript) {
%	    nl = *nlp = (getEntryInfo *)malloc(sizeof (getEntryInfo));
%	    nl->scriptName = makeMallocedString(pScript->scriptName);
%	    nl->scriptId = pScript->scriptId;
%	    nlp = &nl->next;
%	}
%	*nlp = (GetEntryResult)NULL;	/* terminate the list and return */
%	return &result;
%}
#endif

#ifdef RPC_CLNT
%int CSLMonitorRelease(hostName, scriptId)
%char *hostName;
%ScriptId scriptId;
%{
%	Server *pServer = getMonitorServer(hostName);
%	int *result = NULL;
%	
%	if (pServer && pServer->client) {
%	    releaseArg arg;
%	    arg.scriptId = scriptId;
%	    result = csl_monitor_release_1(&arg, pServer->client);
%	}
%	return (result) ? *result : TF_ERROR;
%}
#endif
#ifdef RPC_SVC
%#include <signal.h>
%
%int *csl_monitor_release_1(arg, rqstp)
%releaseArg *arg;
%struct svc_req *rqstp;
%{
%	static int result;
%	Script *pScript = getScript(arg->scriptId);
%	ReleaseMsg Msg;
%
%	if (Debug)
%	    syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: Service request=RELEASE\n",
%			arg->scriptId);
%
%	if (!pScript)
%	    result = SCRIPTID_UNKNOWN;
%	else if (pScript->scriptStatus == Scheduled || pScript->scriptStatus == Running)
%	    result = SCRIPT_IS_RUNNING;
%	else if (!pScript->scriptStatusTaken)
%	    result = SCRIPT_STATUS_NOT_YET_TAKEN;
%	else {
%	    terminateScriptIfPossible(pScript);
%	    lstDelete(&scriptList, &pScript->node);
%	    free(pScript);
%	    result = TF_OK;
%	}
%
%	/* If this monitor is the master, send a RELEASE message to */
%	/* the slave. */
%
%	if (MyRole == ROLE_MASTER) {
%	    if (Debug)
%		syslog (LOG_ALERT|LOG_LOCAL1, "CSLMonitor_svc: sending RELEASE, scriptId=%d\n",
%				 arg->scriptId);
%
%	    Msg.msgType = htonl (RELEASE);
%	    Msg.scriptId = htonl (arg->scriptId);
%	    appSendData (MyHandle, (char *)&Msg, sizeof (Msg));
%	}
%
%	return &result;
%}
#endif

