/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/



#include <stdio.h>
#include <errno.h>
#include <rpc/rpc.h>
#ifdef SOLARIS
#include <rpc/svc_soc.h>
#endif
#include "EVOLManager.h"
#define	S4UNIX
#include "d4all.h"
#include <sys/signal.h>

int	Redundancy, Debug, Verbose, Trace;

extern	void	evolmanagerprog_1 ();
extern	void	svc_run ();
extern	C4CODE	codeBaseDesc;
extern	int	arbiterHandle;

#ifdef SOLARIS
int	_rpcpmstart;
#endif

void killHandler (sig)

    int		sig;

    {

	if (Verbose)
	    printf ("EVOLManager: TERM received -- terminating\n");

	d4close_all (&codeBaseDesc);
	red_Terminate ();
	sleep (5);
	exit (0);	

    }

main(argc, argv)

    int		argc;
    char	*argv[];

{
	register SVCXPRT *transp;
	int	Cmd;

	signal (SIGTERM, killHandler);

	Redundancy = 0;
	Verbose = 0;
	Debug = 0;
	Trace = 0;
	while((Cmd = getopt(argc,argv,"rvdt")) != -1) {
	    switch(Cmd) {
		case 'r':
			Redundancy = 1;
			break;
		case 'v':
			Verbose = 1;
			break;
		case 'd':
			Debug = 1;
			Verbose = 1;
			break;
		case 't':
			Trace = 1;
			break;
	    }
	}

	(void) pmap_unset(EVOLMANAGERPROG, EVOLMANAGERVERS);

	transp = svcudp_create(RPC_ANYSOCK);
	if (transp == NULL) {
		fprintf(stderr, "cannot create udp service.");
		exit(1);
	}
	if (!svc_register(transp, EVOLMANAGERPROG, EVOLMANAGERVERS, evolmanagerprog_1, IPPROTO_UDP)) {
		fprintf(stderr, "unable to register (EVOLMANAGERPROG, EVOLMANAGERVERS, udp).");
		exit(1);
	}

	transp = svctcp_create(RPC_ANYSOCK, 0, 0);
	if (transp == NULL) {
		fprintf(stderr, "cannot create tcp service.");
		exit(1);
	}
	if (!svc_register(transp, EVOLMANAGERPROG, EVOLMANAGERVERS, evolmanagerprog_1, IPPROTO_TCP)) {
		fprintf(stderr, "unable to register (EVOLMANAGERPROG, EVOLMANAGERVERS, tcp).");
		exit(1);
	}

	svc_run();
	fprintf(stderr, "svc_run returned");
	exit(1);
	/* NOTREACHED */
}

