/*TFPackDB.c,v 1.1.1.1 1999/08/03 14:44:57 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <stdio.h>
#include <d4all.h>

static	char	*DBFiles [] = {
	"/tankdb/evol.dbf",
	"/tankdb/evolseg.dbf",
	"/tankdb/segdests.dbf",
	"/tankdb/segsrcs.dbf",
	"/tankdb/measures.dbf",
	"/tankdb/xref.dbf",
	0
};

/*----------*/
main (argc, argv)

    int		argc;
    char	*argv [];

    {

	C4CODE	codeBase;
	D4DATA	*data;
	int	i, error, result;

	/* Initialize codebase */
	
	d4init(&codeBase);
	codeBase.read_lock = 0;
	codeBase.create_error = 0;
	codeBase.field_name_error = 0;
	codeBase.go_error = 0;
	codeBase.open_error = 0;
	codeBase.skip_error = 0;
	codeBase.tag_name_error = 0;

	/* Open each file and pack it */

	for (i=0 ; DBFiles [i] ; i++) {

	    if (!(data = d4open(&codeBase, DBFiles [i]))) {
		printf("Cannot open %s for packing.\n", DBFiles [i]);
		exit(-1);
	    }

	    result = d4pack (data);
	    switch (result) {
		case 0:
		    printf ("%s successfully packed.\n", DBFiles [i]);
		    error = 0;
		    break;
		case r4locked:
		    printf ("%s is locked by another user -- not packed!\n", DBFiles [i]);
		    error = 1;
		    break;
		case r4unique:
		    printf ("INdex file for %d could not be built due to a duplicate key.\n", DBFiles [i]);
		    printf ("This is not good! Contact TIS to report this incident! (410) 356-0422\n");
		    error = 1;
		    break;
		default:
		    printf ("Unknown error occurred while packing %s. Check integrity of file before continuing.\n",
				DBFiles [i]);
		    error = 1;
		    break;
	    }

	    d4close (data);

	}

	if (error) {
	    printf ("Errors occurred during packing process. Check integrity of database file.");
	    exit (-1);
	} else
	    exit (0);

    }


	
