/*TFdBASE.h,v 1.1.1.1 1999/08/03 14:44:57 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software was developed for DLA by Tate Integrated  */
/*	Systems, L.P. via a contract with Vitro Corporation.	*/
/*	It is designed to work with TIS4000 Release 4.2.	*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 * misc strings
 */
#define	BBLS_STRING		"BBLS"
#define	GALS_STRING		"GALS"
#define	PIER_ISSUE_STRING	"Pier Issue"
#define	TRUCK_ISSUE_STRING	"Trk Issue"
#define	PIER_RECEIVE_STRING	"Pier Rcv"
#define	TRUCK_RECEIVE_STRING	"Trk Rcv"
#define	TRANSFER_STRING		"Transfer"
#define	YES_STRING		"Yes"
#define	NO_STRING		"No"
#define	PENDING_STRING		"Pending"
#define	PRECISION		3	/* number of decimal points saved in 'F' type fields */
/*
 * dBASE file names
 */
char	*pointName		= "/tis4000db/pvmap.dbf";
char	*evolName		= "/tankdb/evol.dbf";
char	*evolSegsName		= "/tankdb/evolseg.dbf";
char	*lineupCmpntsName	= "/tankdb/lucmpnts.dbf";
char	*lineupDestsName	= "/tankdb/ludests.dbf";
char	*lineupMsrmntVolsName	= "/tankdb/lumvols.dbf";
char	*lineupName		= "/tankdb/lineup.dbf";
char	*lineupSrcsName		= "/tankdb/lusrcs.dbf";
char	*lineupSwingsName	= "/tankdb/lineupsw.dbf";
char	*lineupXrefVolsName	= "/tankdb/luxref.dbf";
char	*segDestsName		= "/tankdb/segdests.dbf";
char	*segSrcsName		= "/tankdb/segsrcs.dbf";
char	*msrsName		= "/tankdb/measures.dbf";
char	*xrefName		= "/tankdb/xref.dbf";
char	*tankName		= "/tankdb/tank1.dbf";
char	*potName		= "/tankdb/pot.dbf";

/*
 * data structure sizes
 */
#define	ACT_FLOW_RATE_ENTRY_SIZE	10
#define	ACT_FLOW_TIME_ENTRY_SIZE	10
#define	DOUBLE_VALUE_SIZE		10
#define	API_ENTRY_SIZE			10
#define	AUTO_SWING_ENTRY_SIZE		3
#define	AVGAPI_ENTRY_SIZE		10
#define	CHANNEL_NAME_ENTRY_SIZE		36
#define	CLIENT_ENTRY_SIZE		40
#define	CLIENT_ID_ENTRY_SIZE		20
#define	CSL_SCRIPT_ENTRY_SIZE		80
#define	DATE_STRING_ENTRY_SIZE		8
#define	DIC_CODE_ENTRY_SIZE		3
#define	ENVIRONMENTSTRING_ENTRY_SIZE	254
#define	EST_FLOW_RATE_ENTRY_SIZE	10
#define	EST_FLOW_TIME_ENTRY_SIZE	10
#define	EVOLMODE_ENTRY_SIZE		10
#define	EVOL_NUMBER_ENTRY_SIZE		5
#define	FLOW_RATE_ENTRY_SIZE		10
#define	FROM_LINEUP_SIZE		60
#define	LINEUP_NAME_ENTRY_SIZE		60
#define	METHOD_ENTRY_SIZE		20
#define	MOVE_TYPE_ENTRY_SIZE		10
#define	ORDER_NUMBER_ENTRY_SIZE		5
#define	PAUSE_ENTRY_SIZE		3
#define	PAUSE_ON_COMPL_ENTRY_SIZE	3
#define	PRODUCT_ENTRY_SIZE		16
#define	QUANTITY_ENTRY_SIZE		10
#define	REL_DSPLY_ENTRY_SIZE		80
#define	REQTYPE_ENTRY_SIZE		9
#define	SCRIPTID_ENTRY_SIZE		5
#define	SEG_NUMBER_ENTRY_SIZE		5
#define	STATE_ENTRY_SIZE		20
#define	STATUS_ENTRY_SIZE		10
#define	SWING_EVOL_NM_ENTRY_SIZE	10
#define	SWING_EVOL_SG_ENTRY_SIZE	10
#define	TIMESTAMP_ENTRY_SIZE		15
#define	TIME_STRING_ENTRY_SIZE		4
#define	TO_LINEUP_SIZE			60
#define	UNITS_ENTRY_SIZE		4
#define	VOL_SIZE			20
#define	VOL_XFERED_ENTRY_SIZE		10
#define	WEIGHTAVG_ENTRY_SIZE		10

/* dBASE file field definitions */

F4FIELD_INFO	lineupFields[] = {
	{ "LINEUPNAME",		'C',		LINEUP_NAME_ENTRY_SIZE,		0 },
	{ "METHOD",		'C',		METHOD_ENTRY_SIZE,		0 },
	{ "SETUPTIME",		'C',		TIME_STRING_ENTRY_SIZE,		0 },
	{ "SHTDWNTIME",		'C',		TIME_STRING_ENTRY_SIZE,		0 },
	{ "FLOWRATE",		'C',		FLOW_RATE_ENTRY_SIZE,		0 },
	{ "RELDSPLY",		'C',		REL_DSPLY_ENTRY_SIZE,		0 },
	{ "MANCSL",		'C',		CSL_SCRIPT_ENTRY_SIZE,		0 },
	{ "STARTSCRPT",		'C',		CSL_SCRIPT_ENTRY_SIZE,		0 },
	{ "STOPSCRPT",		'C',		CSL_SCRIPT_ENTRY_SIZE,		0 },
	{ "PAUSESCRPT",		'C',		CSL_SCRIPT_ENTRY_SIZE,		0 },
	{ "RESUMSCRPT",		'C',		CSL_SCRIPT_ENTRY_SIZE,		0 },
	{ "MONSCRPT",		'C',		CSL_SCRIPT_ENTRY_SIZE,		0 },
	{ 0, 0,	0, 0 }
};

T4TAG_INFO	lineupTagInfo[] = {
	{ "LINEUPTAG",	"LINEUPNAME",	".NOT. DELETED()",	0,	0 },
	{ 0, 0,	0, 0, 0 }
};

F4FIELD_INFO	lineupSwingsFields[] = {
	{ "FROMLINEUP",		'C',		FROM_LINEUP_SIZE,		0 },
	{ "TOLINEUP",		'C',		TO_LINEUP_SIZE,			0 },
	{ "SWINGTIME",		'C',		TIME_STRING_ENTRY_SIZE,		0 },
	{ "CSLSCRIPT",		'C',		CSL_SCRIPT_ENTRY_SIZE,		0 },
	{ 0, 0,	0, 0 }
};

T4TAG_INFO	lineupSwingsTagsInfo[] = {
	{ "LINEUPTAG",	"FROMLINEUP+SUBSTR(TOLINEUP,1,40)",	".NOT. DELETED()",	0,	0 },
	{ 0, 0, 0, 0, 0 }
};

F4FIELD_INFO	lineupCmpntsFields[] = {
	{ "LINEUPNAME",		'C',		LINEUP_NAME_ENTRY_SIZE,		0 },
	{ "CMPNTS",		'C',		CHANNEL_NAME_ENTRY_SIZE,	0 },
	{ "STATE",		'C',		STATE_ENTRY_SIZE,		0 },
	{ 0, 0, 0, 0 }
};

T4TAG_INFO	lineupCmpntsTagsInfo[] = {
	{ "LINEUPTAG",		"LINEUPNAME+CMPNTS",	".NOT. DELETED()",	0,	0 },
	{ 0, 0, 0, 0, 0 }
};

F4FIELD_INFO	lineupSrcsFields[] = {
	{ "LINEUPNAME",		'C',		LINEUP_NAME_ENTRY_SIZE,		0 },
	{ "SRCS",		'C',		CHANNEL_NAME_ENTRY_SIZE,	0 },
	{ 0, 0, 0, 0 }
};

F4FIELD_INFO	lineupDestsFields[] = {
	{ "LINEUPNAME",		'C',		LINEUP_NAME_ENTRY_SIZE,		0 },
	{ "DESTS",		'C',		CHANNEL_NAME_ENTRY_SIZE,	0 },
	{ 0, 0, 0, 0 }
};

F4FIELD_INFO	lineupMsrmntVolsFields[] = {
	{ "LINEUPNAME",		'C',		LINEUP_NAME_ENTRY_SIZE,		0 },
	{ "MSRMNTVOLS",		'C',		CHANNEL_NAME_ENTRY_SIZE,	0 },
	{ 0, 0, 0, 0 }
};
	
T4TAG_INFO	lineupMsrmntVolsTagInfo[] = {
	{ "LINEUPTAG",		"LINEUPNAME",	".NOT. DELETED()",	0,	0 },
	{ 0, 0,	0, 0, 0 }
};

F4FIELD_INFO	lineupXrefVolsFields[] = {
	{ "LINEUPNAME",		'C',		LINEUP_NAME_ENTRY_SIZE,		0 },
	{ "XREFVOLS",		'C',		CHANNEL_NAME_ENTRY_SIZE,	0 },
	{ 0, 0, 0, 0 }
};
	
T4TAG_INFO	lineupXrefVolsTagInfo[] = {
	{ "LINEUPTAG",	"LINEUPNAME",	".NOT. DELETED()",	0,	0 },
	{ 0, 0, 0, 0, 0 }
};

F4FIELD_INFO	evolFields[] = {
	{ "EVOLNUMBER",		'N',		EVOL_NUMBER_ENTRY_SIZE,		0 },
	{ "PRODUCT",		'C',		PRODUCT_ENTRY_SIZE,		0 },
	{ "QUANTITY",		'F',		QUANTITY_ENTRY_SIZE,		PRECISION },
	{ "UNITS",		'C',		UNITS_ENTRY_SIZE,		0 },
	{ "MOVETYPE",		'C',		MOVE_TYPE_ENTRY_SIZE,		0 },
	{ "AUTOSWNG",		'C',		AUTO_SWING_ENTRY_SIZE,		0 },
	{ "CLIENT",		'C',		CLIENT_ENTRY_SIZE,		0 },
	{ "CLIENTID",		'C',		CLIENT_ID_ENTRY_SIZE,		0 },
	{ "DICCODE",		'C',		DIC_CODE_ENTRY_SIZE,		0 },
	{ "DATE",		'C',		DATE_STRING_ENTRY_SIZE,		0 },
	{ "TIME",		'C',		TIME_STRING_ENTRY_SIZE,		0 },
	{ "TIMESTAMP",		'C',		TIMESTAMP_ENTRY_SIZE,		0 },
	{ "STATUS",		'C',		STATUS_ENTRY_SIZE,		0 },
	{ "EVOLMODE",		'C',		EVOLMODE_ENTRY_SIZE,		0 },
	{ "WEIGHTAVG",		'F',		WEIGHTAVG_ENTRY_SIZE,		PRECISION },
	{ 0, 0, 0, 0 }
};

T4TAG_INFO	evolTagInfo[] = {
	{ "EVOLTAG",	"STR(EVOLNUMBER,5)",		".NOT. DELETED()",	0,	0 },
	{ "TIMESTAMP",	"TIMESTAMP+STR(EVOLNUMBER,5)",	".NOT. DELETED()",	0,	0 },
	{ 0, 0,	0, 0, 0 }
};

F4FIELD_INFO	evolSegsFields[] = {
	{ "EVOLNUMBER",		'N',		EVOL_NUMBER_ENTRY_SIZE,			0 },
	{ "SEGNUMBER",		'N',		SEG_NUMBER_ENTRY_SIZE,			0 },
	{ "ORDERNUM",		'N',		ORDER_NUMBER_ENTRY_SIZE,		0 },
	{ "QUANTITY",		'F',		QUANTITY_ENTRY_SIZE,			PRECISION },
	{ "UNITS",		'C',		UNITS_ENTRY_SIZE,			0 },
	{ "LINEUPNAME",		'C',		LINEUP_NAME_ENTRY_SIZE,			0 },
	{ "PAUSE",		'C',		PAUSE_ENTRY_SIZE,			0 },
	{ "STATUS",		'C',		STATUS_ENTRY_SIZE,			0 },
	{ "VOLXFERED",		'F',		VOL_XFERED_ENTRY_SIZE,			PRECISION },
	{ "ACTFLWRT",		'F',		DOUBLE_VALUE_SIZE,			PRECISION },
	{ "ACTFLWTIME",		'F',		DOUBLE_VALUE_SIZE,			PRECISION },
	{ "LSTRAFTIME",		'F',		DOUBLE_VALUE_SIZE,			PRECISION },
	{ "LSTRTIME",		'C',		TIMESTAMP_ENTRY_SIZE,			0 },
	{ "SWNGEVOLNM",		'N',		SWING_EVOL_NM_ENTRY_SIZE,		0 },
	{ "SWNGEVOLSG",		'N',		SWING_EVOL_SG_ENTRY_SIZE,		0 },
	{ "SWNGTIME",		'C',		TIME_STRING_ENTRY_SIZE,			0 },
	{ "SCRIPTID",		'N',		SCRIPTID_ENTRY_SIZE,			0 },
	{ "REQTYPE",		'C',		REQTYPE_ENTRY_SIZE,			0 },
	{ "AVGAPI",		'F',		AVGAPI_ENTRY_SIZE,			PRECISION },
	{ "ENVSTRING",		'C',		ENVIRONMENTSTRING_ENTRY_SIZE,		0 },
	{ 0, 0, 0, 0 }
};

T4TAG_INFO	evolSegsTagInfo[] = {
	{ "EVOLNUMBER",		"STR(EVOLNUMBER,5)",                                    ".NOT. DELETED()",	0,	0 },
	{ "EVOLSEGTAG",		"STR(EVOLNUMBER,5)+STR(SEGNUMBER,5)",			".NOT. DELETED()",	0,	0 },
	{ "ORDERTAG",		"STR(EVOLNUMBER,5)+STR(ORDERNUM,5)+STR(SEGNUMBER,5)",	".NOT. DELETED()",	0,	0 },
	{ 0, 0, 0, 0, 0 }
};

F4FIELD_INFO	segSrcsFields[] = {
	{ "EVOLNUMBER",		'N',		EVOL_NUMBER_ENTRY_SIZE,		0 },
	{ "SEGNUMBER",		'N',		SEG_NUMBER_ENTRY_SIZE,		0 },
	{ "SOURCE",		'C',		CHANNEL_NAME_ENTRY_SIZE,	0 },
	{ "API",		'F',		API_ENTRY_SIZE,			PRECISION },
	{ 0, 0, 0, 0 }
};

T4TAG_INFO	segSrcsTagInfo[] = {
	{ "SEGSRCSTAG",		"STR(EVOLNUMBER,5)+STR(SEGNUMBER,5)+SOURCE",	".NOT. DELETED()",	0,	0 },
	{ 0, 0, 0, 0, 0 }
};

F4FIELD_INFO	segDestsFields[] = {
	{ "EVOLNUMBER",		'N',		EVOL_NUMBER_ENTRY_SIZE,		0 },
	{ "SEGNUMBER",		'N',		SEG_NUMBER_ENTRY_SIZE,		0 },
	{ "DEST",		'C',		CHANNEL_NAME_ENTRY_SIZE,	0 },
	{ 0, 0, 0, 0 }
};

T4TAG_INFO	segDestsTagInfo[] = {
	{ "SEGDESTSTAG",	"STR(EVOLNUMBER,5)+STR(SEGNUMBER,5)+DEST",	".NOT. DELETED()",		0,	0 },
	{ 0, 0, 0, 0, 0 }
};

F4FIELD_INFO	msrsFields[] = {
	{ "EVOLNUMBER",		'N',		EVOL_NUMBER_ENTRY_SIZE,		0 },
	{ "SEGNUMBER",		'N',		SEG_NUMBER_ENTRY_SIZE,		0 },
	{ "CHANNEL",		'C',		CHANNEL_NAME_ENTRY_SIZE,	0 },
	{ "STARTVOL",		'F',		VOL_SIZE,			PRECISION },
	{ "STARTTIME",		'C',		TIMESTAMP_ENTRY_SIZE,		0 },
	{ "STOPVOL",		'F',		VOL_SIZE,			PRECISION },
	{ "STOPTIME",		'C',		TIMESTAMP_ENTRY_SIZE,		0 },
	{ 0, 0, 0, 0 }
};

T4TAG_INFO	MsrsTagInfo[] = {
	{ "MSRSTAG",	"STR(EVOLNUMBER,5)+STR(SEGNUMBER,5)+CHANNEL+STARTTIME",		".NOT. DELETED()",	0,	0 },
	{ "REVMSRSTAG",	"STR(EVOLNUMBER,5)+STR(SEGNUMBER,5)+CHANNEL+STARTTIME",		".NOT. DELETED()",	0,	r4descending },
	{ 0, 0, 0, 0, 0 }
};

F4FIELD_INFO	xrefFields[] = {
	{ "EVOLNUMBER",		'N',		EVOL_NUMBER_ENTRY_SIZE,		0 },
	{ "SEGNUMBER",		'N',		SEG_NUMBER_ENTRY_SIZE,		0 },
	{ "CHANNEL",		'C',		CHANNEL_NAME_ENTRY_SIZE,	0 },
	{ "STARTVOL",		'F',		VOL_SIZE,			PRECISION },
	{ "STARTTIME",		'C',		TIMESTAMP_ENTRY_SIZE,		0 },
	{ "STOPVOL",		'F',		VOL_SIZE,			PRECISION },
	{ "STOPTIME",		'C',		TIMESTAMP_ENTRY_SIZE,		0 },
	{ 0, 0,	0, 0 }
};

T4TAG_INFO	XrefTagInfo[] = {
	{ "XREFTAG",	"STR(EVOLNUMBER,5)+STR(SEGNUMBER,5)+CHANNEL+STARTTIME",	".NOT. DELETED()",	0,	0 },
	{ "REVXREFTAG",	"STR(EVOLNUMBER,5)+STR(SEGNUMBER,5)+CHANNEL+STARTTIME",	".NOT. DELETED()",	0,	r4descending },
	{ 0, 0, 0, 0, 0 }
};

