#ifndef fieldpermsHXX
#define	fieldpermsHXX

class FldsListView; 
class PointTypes;
class FldPrivLevel;
class FldPermsApplyButton;
class FldPermsDismissButton;
class FldPermsClearButton;


class FldPermsDialog : public vdialog
{
    MainDialog	    *mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(FldPermsDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(FldPermsDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // override
    void ObserveWindow (vevent *event);

    void OpenFldPerms (MainDialog *mnDlg);

    // ptrs to some dialog stuff
    FldsListView	    *listView;
    vtextitem		    *comment;
    PointTypes		    *pointTypes;
    FldPrivLevel	    *privilegeLevel;
    FldPermsApplyButton	    *applyButton; 
    FldPermsDismissButton   *dismissButton;
    FldPermsClearButton	    *clearButton;
    
    // some public funcs
    MainDialog *GetMainDialog (void)
	{ return (mainDialog); }
};


class  FldsListView : public vlistview
{
    FldPermsDialog	*fldPermsDialog;
    int			calcColumnWidth;
    int			inUseFlag;
    vlist		**fieldsLists;	// from TisPermDatabase
    vliststr		*ptTypeList;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(FldsListView);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(FldsListView, vlistview);

    // overrides
    void Destroy ();
    void ObserveSelect (int state);

    // some public funcs
    void BuildFieldsList (int ptindex);
    void GetLists (void);
    void SetCalcColumnWidth (int val)
	{ calcColumnWidth = val; }
    void SetFldPermsDialog (FldPermsDialog *dlg)
	{ fldPermsDialog = dlg; }
    void SetInUseFlag (int flag)
	{ inUseFlag == flag; }
};


class  PointTypes : public vcontrolOptionMenu
{
    FldPermsDialog	    *fldPermsDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(PointTypes);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(PointTypes, vcontrolOptionMenu);

    //override virtual issue function
   void ObserveDialogItem(vevent *event);

    // some public funcs
   void BuildMenu (void);
   void SetFldPermsDialog (FldPermsDialog *dlg)
    { fldPermsDialog = dlg; }
};


class FldPrivLevel : public vcontainerExclusiveGroup
{
    FldPermsDialog  *fldPermsDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(FldPrivLevel);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(FldPrivLevel, vcontainerExclusiveGroup);

    // vloadable override
    void LoadInit (vresource resource);

    //override virtual issue function
    void ObserveDialogItem(vevent *event);

    // radio button toggles in the container
    vcontrolToggle	    *adminToggle;
    vcontrolToggle	    *engineerToggle;
    vcontrolToggle	    *supervisorToggle;
    vcontrolToggle	    *operatorToggle;
    vcontrolToggle	    *traineeToggle;
    vcontrolToggle	    *viewToggle;

    // some public funcs
    char *GetPrivStr (void);
    void SetFldPermsDialog (FldPermsDialog *dlg)
	{ fldPermsDialog = dlg; }
    void SetPrivilegeButton (DefaultPrivilegeLevels privLevel);

};


class  FldPermsApplyButton : public vbutton
{
    FldPermsDialog	    *fldPermsDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(FldPermsApplyButton);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(FldPermsApplyButton, vbutton);

    //override virtual issue function
   void ObserveDialogItem(vevent *event);

    // some public funcs
   void SetFldPermsDialog (FldPermsDialog *dlg)
    { fldPermsDialog = dlg; }
};


class  FldPermsDismissButton : public vbutton
{
    FldPermsDialog	    *fldPermsDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(FldPermsDismissButton);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(FldPermsDismissButton, vbutton);

    //override virtual issue function
   void ObserveDialogItem (vevent *event);

    // some public funcs
   void SetFldPermsDialog (FldPermsDialog *dlg)
    { fldPermsDialog = dlg; }
};


class  FldPermsClearButton : public vbutton
{
    FldPermsDialog	    *fldPermsDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(FldPermsClearButton);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(FldPermsClearButton, vbutton);

    //override virtual issue function
   void ObserveDialogItem (vevent *event);

    // some public funcs
   void SetFldPermsDialog (FldPermsDialog *dlg)
    { fldPermsDialog = dlg; }
};

#endif	fieldpermsHXX

