#ifndef tispermmaindialogHXX
#define	tispermmaindialogHXX

// enum values used for the vcommandSelector::Issue
enum mainMenuItems
{
    QUIT_MENUITEM = 0,
    NEWUSER_MENUITEM,
    MODUSER_MENUITEM,
    DELUSER_MENUITEM,
    NEWGRP_MENUITEM,
    MODGRP_MENUITEM,
    DELGRP_MENUITEM,
    GRPMAINT_MENUITEM,
    ASSIGNPERMS_MENUITEM,
    NEWPTGRP_MENUITEM,
    MODPTGRP_MENUITEM,
    DELPTGRP_MENUITEM,
    ASSIGNGRPS_MENUITEM,
    FLDPROTECT_MENUITEM,
    MENUITEM_COUNT
};

// enum values to tell listview what to do to list
enum ListViewFuncs
{
    AddToList = 0,
    ModTheList,
    DelFromList
};


class  GroupListView;
class  ProtGroupListView;
class  UserListView;

class MainDialog : public vdialog
{
    vmenu	*helpMenu;
    vresource	mainDialogResource;
    TisAbout	*tisAbout;
    void	BuildAboutMenu (void);
    // ptr to application class and galaxy app ptr
    TisPermApp		*tisPermApp;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(MainDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(MainDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // overrides 
    void ObserveWindow (vevent *event);
    int HandleConfigure (vevent *event);

    // override
    void Destroy ();

    void OpenMain (TisPermApp *app);

    // place to store internal names for main dialog menu items
    const vname		*commandNames[MENUITEM_COUNT];


    // ptrs to some dialog stuff
    vruler		*userRuler;
    vruler		*groupRuler;
    vruler		*prGrpRuler;
    UserListView	*userListView;
    GroupListView	*groupListView;
    ProtGroupListView	*prGrpListView;

    // some public funcs
    TisPermApp *GetPermApp ()
	{ return (tisPermApp); }

};


class  MainCommand : public vcommandSelector
{
public:
    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(MainCommand);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(MainCommand, vcommandSelector);

    //override virtual issue function
    int Issue(vdict *);
};


class  GroupListView : public vlistview
{
    vliststr	*list;
    MainDialog	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(GroupListView);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(GroupListView, vlistview);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // override
    void ObserveSelect (int state);

    // public functions
    void BuildList (void);

    // store MainDialog
    void StoreMainDialog (MainDialog *dlg)
	{ mainDialog = dlg; }
    // does group exist in the list
    int GroupExists (vchar *name);
    // modify the list
    void ModList (ListViewFuncs todo, vchar *name, vchar *desc);
};


class  ProtGroupListView : public vlistview
{
    vliststr	*list;
    MainDialog	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(ProtGroupListView);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(ProtGroupListView, vlistview);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // override
    void ObserveSelect (int state);

    // public functions
    void BuildList (void);

    // store MainDialog
    void StoreMainDialog (MainDialog *dlg)
	{ mainDialog = dlg; }
    // does group exist in the list
    int ProtGroupExists (vchar *name);
    // modify the list
    void ModList (ListViewFuncs todo, vchar *name, vchar *desc);
};


class  UserListView : public vlistview
{
    vlist	*list;
    MainDialog	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(UserListView);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(UserListView, vlistview);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // override
    void ObserveSelect (int state);

    // override
    void DrawCellContents (int row, int col, int selected, vrect *rect);

    // public functions
    void BuildList (void);

    // modify the list
    void ModList (ListViewFuncs todo, vchar *name, vchar *desc,
		  vchar *encrppasswd, int allowLogout, int logoutTime);
    // does group exist in the list
    int UserExists (vchar *name);
    void StoreMainDialog (MainDialog *dlg)
	{ mainDialog = dlg; }
};

#endif	tispermmaindialogHXX

