#ifndef	tisgalaxylibH
#define	tisgalaxylibH

#include veventHEADER
#include vdialogHEADER
#include vspinnerHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vmenuHEADER
#include vdomainitemHEADER
#include vtextitemHEADER
#include vnoticeHEADER

// some function prototypes

int cautionNotice (vdialog *dialog, vstr *title, vstr *msg);
void infoNotice (vdialog *dialog, vstr *title, vstr *msg);
void MakeTopMostDialog (vwindow *window, vevent *event);


// *** CHECK BOX CLASS  *********************************************

class checkBoxClass : public vcontrolToggle
{
    // ptr to the modify flag in the dialogs
    int *modified;

    // void ptr for whatever user needs
    void *userPtr;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(checkBoxClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(checkBoxClass, vcontrolToggle);

    // override 
    void LoadInit (vresource resource);

    // override the control notify
    void ObserveDialogItem (vevent *event);

    // handle user ptr
    void SetUserPtr (void *ptr) { userPtr = ptr; }
    void *GetUserPtr (void) { return (userPtr); }

    // handle the modified flag
    void SetModifiedPtr (int *mod) { modified = mod; }
    int *GetModifiedPtr (void) {return (modified); }
    void SetModifiedFlag (void) { *modified = vTRUE; }
};


// *** EXCLUSIVE CONTAINER CLASS ************************************

class exclusiveContainerClass : public vcontainerExclusiveGroup
{
    // ptr to the modify flag in the dialogs
    int *modified;

    // void ptr for whatever user needs
    void *userPtr;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(exclusiveContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(exclusiveContainerClass, vcontainerExclusiveGroup);

    // override 
    void LoadInit (vresource resource);

    // override the control notify
    void ObserveDialogItem (vevent *event);

    // handle user ptr
    void SetUserPtr (void *ptr) { userPtr = ptr; }
    void *GetUserPtr (void) { return (userPtr); }

    // handle the modified flag
    void SetModifiedPtr (int *mod) { modified = mod; }
    int *GetModifiedPtr (void) {return (modified); }
    void SetModifiedFlag (void) { *modified = vTRUE; }
};


// *** GROUP CONTAINER CLASS ****************************************

class groupContainerClass : public vcontainerGroup
{
    // ptr to the modify flag in the dialogs
    int *modified;

    // void ptr for whatever user needs
    void *userPtr;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(groupContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(groupContainerClass, vcontainerGroup);

    // override 
    void LoadInit (vresource resource);

    // override the control notify
    void ObserveDialogItem (vevent *event);

    // handle user ptr
    void SetUserPtr (void *ptr) { userPtr = ptr; }
    void *GetUserPtr (void) { return (userPtr); }

    // handle the modified flag
    void SetModifiedPtr (int *mod) { modified = mod; }
    int *GetModifiedPtr (void) {return (modified); }
    void SetModifiedFlag (void) { *modified = vTRUE; }
};


// *** MENU CLASS  **************************************************

class optionMenuClass : public vcontrolOptionMenu
{
    // ptr to the modify flag in the dialogs
    int *modified;

    // void ptr for what ever user needs
    void *userPtr;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(optionMenuClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(optionMenuClass, vcontrolOptionMenu);

    // override 
    void LoadInit (vresource resource);

    // override the control notify
    virtual void ObserveDialogItem (vevent *event);

    // handle the modified flag
    void SetModifiedPtr (int *mod) { modified = mod; }
    int *GetModifiedPtr (void) {return (modified); }
    void SetModifiedFlag (void) { *modified = vTRUE; }

    // handle user ptr
    void SetUserPtr (void *ptr) { userPtr = ptr; }
    void *GetUserPtr (void) { return (userPtr); }

    // function to build attached menu
    virtual void buildMenu (void);

    // function to get optionMenu value
    const vchar *GetOptionMenuValue (void);

    // function to set optionMenu value
    void SetOptionMenuValue (vstr *value);

};


// *** SPINNER CLASS  ***********************************************

class spinnerClass : public vspinner
{
    // ptr to the modify flag in the point dialogs
    int *modified;

    // void ptr for whatever user needs
    void *userPtr;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(spinnerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(spinnerClass, vspinner);

    // override 
    void LoadInit (vresource resource);

    // override the control notify
    void ObserveDialogItem (vevent *event);

    // override
    void SetValue (int val);

    // handle user ptr
    void SetUserPtr (void *ptr) { userPtr = ptr; }
    void *GetUserPtr (void) { return (userPtr); }

    // handle the modified flag
    void SetModifiedPtr (int *mod) { modified = mod; }
    int *GetModifiedPtr (void) {return (modified); }
    void SetModifiedFlag (void) { *modified = vTRUE; }
};


// *** NOTICE CLASS  ***********************************************

class noticeClass : public vnotice
{
public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(noticeClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(noticeClass, vnotice);

    // override the control notify
    void ObserveWindow (vevent *event);
};


// *** TISGALAXY CLASSES AND OTHER FUNCTIONS  ***********************

vresource startTisGalaxy (void);
void stopTisGalaxy (vresource res);

class AboutDialog;
class AboutMenuItem;
class OtherAboutMenuItem;
class AboutOkButton;

class AboutMenuItem : public vmenuItem
{
    AboutDialog	    *aboutDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(AboutMenuItem);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(AboutMenuItem, vmenuItem);

    // override
    void ObserveMenuItem (vevent *event);

    // handle aboutDialog
    void SetAboutDialog (AboutDialog *dlg)
	{ aboutDialog = dlg; }
};

class OtherAboutMenuItem : public vmenuItem
{
    AboutDialog	    *aboutDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(OtherAboutMenuItem);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(OtherAboutMenuItem, vmenuItem);

    // handle aboutDialog
    void SetAboutDialog (AboutDialog *dlg)
	{ aboutDialog = dlg; }
};


//*** TIS ABOUT WRAPPER CLASS for about menuitem ********************
class TisAbout
{
    vresource	    tisGalaxyRes;
    vresource	    aboutRes;
    vstr	    *versionText;
    AboutDialog	    *aboutDialog;
    AboutMenuItem   *aboutMenuItem;
    OtherAboutMenuItem   *otherAboutMenuItem;

public:

    // constructors/destructors
    TisAbout (vresource tisGalRes, vchar *verText);
    ~TisAbout ();

    AboutMenuItem *GetAboutMenuItem (void);
    // need another AvboutMenuItem definition for user
    OtherAboutMenuItem *GetOtherAboutMenuItem (void);
    vresource GetTisGalaxyRes (void)
	{ return (tisGalaxyRes); }
    void OpenAboutDialog (void);
    void SetAboutTitle (vchar *title);
    void SetAboutMenuObserver (vmenuItemNoteProc ObservationProc)
	{ aboutMenuItem -> SetObserveMenuItemProc (ObservationProc); }
    void SetResizable (void);
    void SetVersionLabel (vchar *label);
};


class AboutDialog : public vdialog
{
    vresource		aboutRes;
    AboutOkButton	*okButton;
    vtextitem		*versionLabel;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(AboutDialog);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(AboutDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    // inlines
    vtextitem *GetVersionLabel (void)
	{ return (versionLabel); }
};


class AboutOkButton : public vbutton
{
    AboutDialog	*aboutDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(AboutOkButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(AboutOkButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // handle aboutDialog
    void SetAboutDialog (AboutDialog *dlg)
	{ aboutDialog = dlg; }
};


//***** PROGRESS DIALOG CLASS ***************************************
class ProgressCancelButton;
class ProgressEvent;
class ProgressDomain;

class tisProgressDialog : public vdialog
{
    vbool   quitting;
public:

    // override vkindType
    vkindTYPED_FULL_DECLARATION(tisProgressDialog);
    // the standard versions of the necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(tisProgressDialog, vdialog);

    // virtual member function overrides
    void Close();
    void Destroy();
    void LoadInit(vresource);

    // virtuall function for user to write
    virtual vbool DoWork (double *percentCompleted);

    // non virtual functions
    vbool   IsQuitting (void)
	{ return (quitting); }
    void OpenProgress (void);
    void SetProgressTitle (vchar *progTitle)
	{ SetTitle (progTitle); }
    void SetQuitting (vbool val)
	{ quitting = val; }
    void UpdateDomain (double *percentCompleted);

    // dialog fields
    vtextitem		    *messageText;
    ProgressDomain	    *progressDomain;
    ProgressCancelButton    *cancelButton;
};


/*
 *  ProgressCancelButton
 */
class ProgressCancelButton : public vbutton
{
    tisProgressDialog  *progressDialog;
public:
    // override vkindType
    vkindTYPED_FULL_DECLARATION(ProgressCancelButton);
    // the standard versions of the necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(ProgressCancelButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void SetProgressDialog (tisProgressDialog *dlg)
	{ progressDialog = dlg; }
};


/*
 *  subclass vdomainitem to use as our progress report bar
 */
class ProgressDomain : public vdomainitem
{
public:

    // override vkindType
    vkindTYPED_FULL_DECLARATION(ProgressDomain);
    // the standard versions of the necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(ProgressDomain, vdomainitem);

    // overrides
    void DrawObject (vdomainObject *object);

    vcolor  *domainColor;
};



//***** WAIT DIALOG CLASS ***************************************

class tisWaitDialog : public vdialog
{
public:

    // override vkindType
    vkindTYPED_FULL_DECLARATION(tisWaitDialog);
    // the standard versions of the necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(tisWaitDialog, vdialog);

    // virtual member function overrides
    void Destroy();
    void LoadInit(vresource);
    void ObserveWindow (vevent *event);

    void OpenWaitDialog (void);

    // dialog fields
    vtextitem		    *waitTextitem;

    void SetMsgText (vchar *msgText)
    	{ waitTextitem -> SetText (msgText); }
};

#endif	tisgalaxylibH

