/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

#include <stdio.h>
#include "msgMon.h"

void main()
{
    unsigned char	buff[100];
    char		feature[100];
    char		key[6];
    char		keyCopy[6];
    int			len;
    int			i;
    int			year;
    int			month;
    int			day;
    int			idx;

    tisOpenLog ("tlmKey", 6, 2, NULL, NULL);

    printf("Workstation key?    ");
    gets(buff);
    if (strlen(buff) != 12)
	{
	printf("This key has an invalid length.\n");
	exit(0);
	}
    for (i = 0, idx = 0; buff[i]; i = i + 2, idx++)
	{
	if ((buff[i] >= '0') && (buff[i] <= '9'))
	    key[idx] = (buff[i] - '0') << 4;
	else if ((buff[i] >= 'A') && (buff[i] <= 'F'))
	    key[idx] = (buff[i] - 'A' + 10) << 4;
	else if ((buff[i] >= 'a') && (buff[i] <= 'f'))
	    key[idx] = (buff[i] - 'a' + 10) << 4;
	else
	    {
	    printf("This Workstation key has an invalid character.\n");
	    exit(0);
	    }
	
	if ((buff[i + 1] >= '0') && (buff[i + 1] <= '9'))
	    key[idx] += buff[i + 1] - '0';
	else if ((buff[i + 1] >= 'A') && (buff[i + 1] <= 'F'))
	    key[idx] += buff[i + 1] - 'A' + 10;
	else if ((buff[i + 1] >= 'a') && (buff[i + 1] <= 'f'))
	    key[idx] += buff[i + 1] - 'a' + 10;
	else
	    {
	    printf("This Workstation key has an invalid character.\n");
	    exit(0);
	    }
	}

    for (;;)
	{
	printf("Feature?   ");
	gets(feature);
	printf("Permanent Key? [N]   ");
	gets(buff);
	if ((buff[0] != 0) && (buff[0] != 'N') && (buff[0] != 'n'))
	    {
	    strcpy(buff, "!PAIDUP!");
	    }
	else
	    {
	    printf("Expiration Year (YYYY):   ");
	    gets(buff);
	    year = atoi(buff);
	    printf("Expiration Month (1 - 12):   ");
	    gets(buff);
	    month = atoi(buff);
	    month--;
	    printf("Expiration Day (1 - 31):   ");
	    gets(buff);
	    day = atoi(buff);
	    sprintf(buff, "%04d%02d%02d", year, month, day);
	    }


        strcat(buff, feature);
	memcpy(keyCopy, key, sizeof(keyCopy));
	len = strlen(buff);
	code(buff, len, keyCopy, sizeof(keyCopy));
	memcpy(keyCopy, key, sizeof(keyCopy));
	code(buff, len, keyCopy, sizeof(keyCopy));
	memcpy(keyCopy, key, sizeof(keyCopy));
	code(buff, len, keyCopy, sizeof(keyCopy));
	printf("Key is: ");
	for (i = 0; i < len; i++)
	    printf("%02x", buff[i]);
	printf("\n");
	}
}
