/* trendgraph.h,v 1.1.1.1 1999/08/03 14:45:10 tis4000 Exp
 *
 */

/*
 * TrendGraph - trend graph continer class
 */
class TrendFabric;
class IconFabric;

class TrendGraph : public vcontainer
{
    public:
	// the default versions of the necessary constructors/destructor
	vloadableINLINE_CONSTRUCTORS(TrendGraph, vcontainer);

	// overrides from vkindTyped
	vkindTYPED_FULL_DECLARATION(TrendGraph);

	// virtual member function overrides
	// vloadable
	virtual void LoadInit(vresource resource);

	// methods
	void SetTrendSet (TrendSet *set) {trendSet = set; Redisplay (); }
	void Redisplay () { DrawTimes (); SetTheCursor (cursor); }
	void SetPrefs (vcolorSpec fgColorSpec[C_TRENDPTS], vcolorSpec bgColorSpec);
	void SetTheCursor (int pos);
	int GetCursor () { return cursor; }
	virtual void NewCursor (int pos); // override with position callback!
	virtual void NewRange (int lpos, int rpos); // overide with expand event callback!
	TrendSet *GetTrendSet () { return trendSet; }
	vcolor *fgColors[C_TRENDPTS];
	vcolor *bgColor;
    private:
	void DrawTimes ();

	TrendSet    *trendSet;	    // the working document
	vdrawGState *drawGState;
	time_t startTime;
	int cursor;
	vtextitem *leftTime;
	vtextitem *rightTime;
	TrendFabric *mainDraw;
	IconFabric *iconDraw;
};
