/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* A channel list object. */
extern "C"
{
#include "cadef.h"
}

#define	MAX_CHANS	1000

typedef struct {
    char	chanName [29];	/* Name of the channel */
    chid	chanId;		/* Channel Id */
    evid	eventId;	/* Event Id for the callback */
    short	value;		/* Current value of the channel */
    short	connected;	/* Channel is connected */
    short	gotData;	/* Current value is valid */
} Channel;

typedef struct {
    Channel	chans [MAX_CHANS];
    int		numChannels;
} ChannelList;

extern	void	clInitialize (void);
extern	void	clTerminate (void);
extern	int	clAdd (char *chanName);
extern	void	clConnect (void);
extern	int	clGetValue (int chanIx);
extern	void	clPutValue (int chanIx, int value);
extern	int	clValid (int chanIx);


