/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/********************************************************************************
  ackpoint

  input :  the pointname of the channel to be acknowledged.
  output  :

  K.Grimes    9/94
********************************************************************************/   
#include <stdio.h>
#include <stdlib.h>  
#include <string.h>
#include <errno.h>
#include <time.h>
#if !(defined(AXP) || defined(WIN32))
#    include <sys/filio.h>
#endif
#ifndef	WIN32
#    include <sys/types.h>    /* Socket setup */
#    include <sys/socket.h>
#    include <netinet/in.h>
#    include <netdb.h>
#    include <sys/ioctl.h>
#    define SOCKET		int
#    define SOCKET_ERROR	-1
#    define INVALID_SOCKET	-1
#else
#    include <winsock.h>
#    include <fcntl.h>
#endif	!WIN32
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#include "dbDefs.h"
#include "alarmDefs.h"
#include "shareMem.h"    /* alarmMgr communication */
#include "alarmLib.h"
#include "ack.h"
#include "OperPriv.h"
#include "alarm.h"
#include "alarmString.h"
#include "messages.h"
#include "alarmvu.h"
#include "msgMon.h"

#include "SocketIO_alarmmgr.h"

/**********************************************************************************
  acknowledge the input pvname.
***********************************************************************************/
void main(int argc, char *argv[])
{
    SOCKET  alarmhndSocket;
    char    pointname[PVNAME_SZ+1];
    int	    operatorName[OPERATOR_SZ + 1];
    char    field[PVNAME_SZ+5];
    int	    debug = 0;

   /* set debug to one for print messages */
   if (argc > 2) debug = 1;

   memset(pointname, 0, sizeof pointname);

   /* if a parameter is passed in when ackgroup is invoked that is assumed to 
      be the point name,  If no parameters are present check for the point 
      environment variable */

   if (argc > 1)
      strncpy(pointname, argv[1], PVNAME_SZ+1);
   else if (getenv("point"))  
      strncpy(pointname,getenv("point"),PVNAME_SZ+1);
   else
      pointname[0] = 0;

   sprintf(field, "%s.ACK", pointname);

   if (pointname[0] != 0) {

      /* ack the point if the operator has privledges on it */

      if( (InitOperPriv((char *)(&operatorName[0])) == PRIVOK) &&
	  (CheckOperPriv(field) == PRIVOK) &&
	  (InitAlarmAccess()) && (init_ca(debug)) &&
          (create_and_connect_socket(&alarmhndSocket)) &&
	  (needs_acknowledgement(pointname)) ) 
	  
	   ack_point(alarmhndSocket, pointname, 0, 0, debug);
#ifdef	WIN32
      closesocket (alarmhndSocket);
#else
      close (alarmhndSocket);
#endif	WIN32
      close_ca();

      CloseOperTracking((char *)(&operatorName[0]));
  }
}
