/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <stdio.h>
#include <signal.h>
#include "msgMon.h"

	void	setupSignalHandlers ();
static	void	terminateMgr ();
static	void	incrementDebugLevel ();
static	void	decrementDebugLevel ();

extern	int	debugLevel;
extern	int	running;

/*----------*/
void setupSignalHandlers ()

    {

	signal (SIGQUIT, terminateMgr);
	signal (SIGTERM, terminateMgr);
	signal (SIGINT, terminateMgr);
	signal (SIGUSR1, incrementDebugLevel);
	signal (SIGUSR2, decrementDebugLevel);
	signal (SIGPIPE, SIG_IGN);

    }

/*----------*/
static void terminateMgr (sig, code, scp, addr)

    int 		sig, code;
    struct sigcontext	*scp;
    char 		*addr;

    {

	if (debugLevel >= 1)
	    tisSysLog (0,0,"Terminate signal received\n");
	running = 0;

    }

/*----------*/
static void incrementDebugLevel (sig, code, scp, addr)

    int 		sig, code;
    struct sigcontext	*scp;
    char 		*addr;

    {

	tisSysLog (0,0,"Debug level is now %d\n", ++debugLevel);

    }

/*----------*/
static void decrementDebugLevel (sig, code, scp, addr)

    int 		sig, code;
    struct sigcontext	*scp;
    char 		*addr;

    {

	if (debugLevel > 0)
	    debugLevel--;
	tisSysLog (0,0,"Debug level is now %d\n", debugLevel);

    }

